import { isVue3, defineComponent, getCurrentInstance, ref, computed, watch, onMounted, onUnmounted, h as h$1 } from "vue-demi";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a2, b2) => {
  for (var prop in b2 || (b2 = {}))
    if (__hasOwnProp.call(b2, prop))
      __defNormalProp(a2, prop, b2[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b2)) {
      if (__propIsEnum.call(b2, prop))
        __defNormalProp(a2, prop, b2[prop]);
    }
  return a2;
};
var __spreadProps = (a2, b2) => __defProps(a2, __getOwnPropDescs(b2));
function atToOn(eventName) {
  const keyArray = Array.from(eventName);
  keyArray[0] = keyArray[0].toUpperCase();
  keyArray.unshift("n");
  keyArray.unshift("o");
  return keyArray.join("");
}
function useGlobalConfig(globalConfig, localProps = []) {
  let globalProps2 = {}, globalAttrs2 = {}, globalListeners2 = {}, globalHooks2 = {};
  const localPropsArray = Array.isArray(localProps) ? localProps : Object.keys(localProps);
  for (let k2 in globalConfig) {
    if (k2.startsWith("@")) {
      const eventName = k2.substring(1);
      if (isVue3) {
        if (eventName.startsWith("vnode")) {
          globalHooks2[atToOn(eventName)] = globalConfig[k2];
        } else {
          globalListeners2[atToOn(eventName)] = globalConfig[k2];
        }
      } else {
        if (eventName.startsWith("hook:")) {
          globalHooks2[eventName] = globalConfig[k2];
        } else {
          globalListeners2[eventName] = globalConfig[k2];
        }
      }
    } else if (localPropsArray.includes(k2)) {
      globalProps2[k2] = globalConfig[k2];
    } else {
      globalAttrs2[k2] = globalConfig[k2];
    }
  }
  return {
    props: globalProps2,
    attrs: globalAttrs2,
    listeners: globalListeners2,
    hooks: globalHooks2
  };
}
var freeGlobal$2 = typeof global == "object" && global && global.Object === Object && global;
var freeGlobal$1$1 = freeGlobal$2;
var freeSelf$1 = typeof self == "object" && self && self.Object === Object && self;
var root$2 = freeGlobal$1$1 || freeSelf$1 || Function("return this")();
var root$1$1 = root$2;
var Symbol$1$1 = root$1$1.Symbol;
var Symbol$2$1 = Symbol$1$1;
var objectProto$f = Object.prototype;
var hasOwnProperty$c = objectProto$f.hasOwnProperty;
var nativeObjectToString$1$1 = objectProto$f.toString;
var symToStringTag$1$1 = Symbol$2$1 ? Symbol$2$1.toStringTag : void 0;
function getRawTag$1(value) {
  var isOwn = hasOwnProperty$c.call(value, symToStringTag$1$1), tag = value[symToStringTag$1$1];
  try {
    value[symToStringTag$1$1] = void 0;
    var unmasked = true;
  } catch (e22) {
  }
  var result = nativeObjectToString$1$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1$1] = tag;
    } else {
      delete value[symToStringTag$1$1];
    }
  }
  return result;
}
var objectProto$e = Object.prototype;
var nativeObjectToString$2 = objectProto$e.toString;
function objectToString$1(value) {
  return nativeObjectToString$2.call(value);
}
var nullTag$1 = "[object Null]", undefinedTag$1 = "[object Undefined]";
var symToStringTag$2 = Symbol$2$1 ? Symbol$2$1.toStringTag : void 0;
function baseGetTag$1(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag$1 : nullTag$1;
  }
  return symToStringTag$2 && symToStringTag$2 in Object(value) ? getRawTag$1(value) : objectToString$1(value);
}
function isObjectLike$1(value) {
  return value != null && typeof value == "object";
}
var symbolTag$3 = "[object Symbol]";
function isSymbol$1(value) {
  return typeof value == "symbol" || isObjectLike$1(value) && baseGetTag$1(value) == symbolTag$3;
}
function arrayMap(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length, result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}
var isArray$2 = Array.isArray;
var isArray$1$1 = isArray$2;
var INFINITY$1 = 1 / 0;
var symbolProto$2 = Symbol$2$1 ? Symbol$2$1.prototype : void 0, symbolToString = symbolProto$2 ? symbolProto$2.toString : void 0;
function baseToString(value) {
  if (typeof value == "string") {
    return value;
  }
  if (isArray$1$1(value)) {
    return arrayMap(value, baseToString) + "";
  }
  if (isSymbol$1(value)) {
    return symbolToString ? symbolToString.call(value) : "";
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY$1 ? "-0" : result;
}
function isObject$1(value) {
  var type = typeof value;
  return value != null && (type == "object" || type == "function");
}
function identity(value) {
  return value;
}
var asyncTag$1 = "[object AsyncFunction]", funcTag$2$1 = "[object Function]", genTag$1$1 = "[object GeneratorFunction]", proxyTag$1 = "[object Proxy]";
function isFunction$1(value) {
  if (!isObject$1(value)) {
    return false;
  }
  var tag = baseGetTag$1(value);
  return tag == funcTag$2$1 || tag == genTag$1$1 || tag == asyncTag$1 || tag == proxyTag$1;
}
var coreJsData$2 = root$1$1["__core-js_shared__"];
var coreJsData$1$1 = coreJsData$2;
var maskSrcKey$1 = function() {
  var uid = /[^.]+$/.exec(coreJsData$1$1 && coreJsData$1$1.keys && coreJsData$1$1.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
function isMasked$1(func) {
  return !!maskSrcKey$1 && maskSrcKey$1 in func;
}
var funcProto$2 = Function.prototype;
var funcToString$2 = funcProto$2.toString;
function toSource$1(func) {
  if (func != null) {
    try {
      return funcToString$2.call(func);
    } catch (e22) {
    }
    try {
      return func + "";
    } catch (e22) {
    }
  }
  return "";
}
var reRegExpChar$1 = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor$1 = /^\[object .+?Constructor\]$/;
var funcProto$1$1 = Function.prototype, objectProto$d = Object.prototype;
var funcToString$1$1 = funcProto$1$1.toString;
var hasOwnProperty$b = objectProto$d.hasOwnProperty;
var reIsNative$1 = RegExp("^" + funcToString$1$1.call(hasOwnProperty$b).replace(reRegExpChar$1, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
function baseIsNative$1(value) {
  if (!isObject$1(value) || isMasked$1(value)) {
    return false;
  }
  var pattern = isFunction$1(value) ? reIsNative$1 : reIsHostCtor$1;
  return pattern.test(toSource$1(value));
}
function getValue$1(object, key) {
  return object == null ? void 0 : object[key];
}
function getNative$1(object, key) {
  var value = getValue$1(object, key);
  return baseIsNative$1(value) ? value : void 0;
}
var WeakMap$3 = getNative$1(root$1$1, "WeakMap");
var WeakMap$1$1 = WeakMap$3;
var objectCreate$1 = Object.create;
var baseCreate$2 = function() {
  function object() {
  }
  return function(proto) {
    if (!isObject$1(proto)) {
      return {};
    }
    if (objectCreate$1) {
      return objectCreate$1(proto);
    }
    object.prototype = proto;
    var result = new object();
    object.prototype = void 0;
    return result;
  };
}();
var baseCreate$1$1 = baseCreate$2;
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0:
      return func.call(thisArg);
    case 1:
      return func.call(thisArg, args[0]);
    case 2:
      return func.call(thisArg, args[0], args[1]);
    case 3:
      return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}
function copyArray$1(source, array) {
  var index = -1, length = source.length;
  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}
var HOT_COUNT = 800, HOT_SPAN = 16;
var nativeNow = Date.now;
function shortOut(func) {
  var count = 0, lastCalled = 0;
  return function() {
    var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(void 0, arguments);
  };
}
function constant(value) {
  return function() {
    return value;
  };
}
var defineProperty$2 = function() {
  try {
    var func = getNative$1(Object, "defineProperty");
    func({}, "", {});
    return func;
  } catch (e22) {
  }
}();
var defineProperty$1$1 = defineProperty$2;
var baseSetToString = !defineProperty$1$1 ? identity : function(func, string) {
  return defineProperty$1$1(func, "toString", {
    "configurable": true,
    "enumerable": false,
    "value": constant(string),
    "writable": true
  });
};
var baseSetToString$1 = baseSetToString;
var setToString = shortOut(baseSetToString$1);
var setToString$1 = setToString;
function arrayEach$1(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}
var MAX_SAFE_INTEGER$1$1 = 9007199254740991;
var reIsUint$1 = /^(?:0|[1-9]\d*)$/;
function isIndex$1(value, length) {
  var type = typeof value;
  length = length == null ? MAX_SAFE_INTEGER$1$1 : length;
  return !!length && (type == "number" || type != "symbol" && reIsUint$1.test(value)) && (value > -1 && value % 1 == 0 && value < length);
}
function baseAssignValue$1(object, key, value) {
  if (key == "__proto__" && defineProperty$1$1) {
    defineProperty$1$1(object, key, {
      "configurable": true,
      "enumerable": true,
      "value": value,
      "writable": true
    });
  } else {
    object[key] = value;
  }
}
function eq$2(value, other) {
  return value === other || value !== value && other !== other;
}
var objectProto$c$1 = Object.prototype;
var hasOwnProperty$a$1 = objectProto$c$1.hasOwnProperty;
function assignValue$1(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty$a$1.call(object, key) && eq$2(objValue, value)) || value === void 0 && !(key in object)) {
    baseAssignValue$1(object, key, value);
  }
}
function copyObject$1(source, props, object, customizer) {
  var isNew = !object;
  object || (object = {});
  var index = -1, length = props.length;
  while (++index < length) {
    var key = props[index];
    var newValue = customizer ? customizer(object[key], source[key], key, object, source) : void 0;
    if (newValue === void 0) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue$1(object, key, newValue);
    } else {
      assignValue$1(object, key, newValue);
    }
  }
  return object;
}
var nativeMax$1 = Math.max;
function overRest(func, start, transform) {
  start = nativeMax$1(start === void 0 ? func.length - 1 : start, 0);
  return function() {
    var args = arguments, index = -1, length = nativeMax$1(args.length - start, 0), array = Array(length);
    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform(array);
    return apply(func, this, otherArgs);
  };
}
function baseRest(func, start) {
  return setToString$1(overRest(func, start, identity), func + "");
}
var MAX_SAFE_INTEGER$2 = 9007199254740991;
function isLength$1(value) {
  return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER$2;
}
function isArrayLike$1(value) {
  return value != null && isLength$1(value.length) && !isFunction$1(value);
}
function isIterateeCall(value, index, object) {
  if (!isObject$1(object)) {
    return false;
  }
  var type = typeof index;
  if (type == "number" ? isArrayLike$1(object) && isIndex$1(index, object.length) : type == "string" && index in object) {
    return eq$2(object[index], value);
  }
  return false;
}
function createAssigner(assigner) {
  return baseRest(function(object, sources) {
    var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : void 0, guard = length > 2 ? sources[2] : void 0;
    customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : void 0;
    if (guard && isIterateeCall(sources[0], sources[1], guard)) {
      customizer = length < 3 ? void 0 : customizer;
      length = 1;
    }
    object = Object(object);
    while (++index < length) {
      var source = sources[index];
      if (source) {
        assigner(object, source, index, customizer);
      }
    }
    return object;
  });
}
var objectProto$b$1 = Object.prototype;
function isPrototype$1(value) {
  var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto$b$1;
  return value === proto;
}
function baseTimes$1(n2, iteratee) {
  var index = -1, result = Array(n2);
  while (++index < n2) {
    result[index] = iteratee(index);
  }
  return result;
}
var argsTag$3 = "[object Arguments]";
function baseIsArguments$1(value) {
  return isObjectLike$1(value) && baseGetTag$1(value) == argsTag$3;
}
var objectProto$a$1 = Object.prototype;
var hasOwnProperty$9$1 = objectProto$a$1.hasOwnProperty;
var propertyIsEnumerable$1$1 = objectProto$a$1.propertyIsEnumerable;
var isArguments$2 = baseIsArguments$1(function() {
  return arguments;
}()) ? baseIsArguments$1 : function(value) {
  return isObjectLike$1(value) && hasOwnProperty$9$1.call(value, "callee") && !propertyIsEnumerable$1$1.call(value, "callee");
};
var isArguments$1$1 = isArguments$2;
function stubFalse$1() {
  return false;
}
var freeExports$2$1 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule$2$1 = freeExports$2$1 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports$2$1 = freeModule$2$1 && freeModule$2$1.exports === freeExports$2$1;
var Buffer$1$1 = moduleExports$2$1 ? root$1$1.Buffer : void 0;
var nativeIsBuffer$1 = Buffer$1$1 ? Buffer$1$1.isBuffer : void 0;
var isBuffer$2 = nativeIsBuffer$1 || stubFalse$1;
var isBuffer$1$1 = isBuffer$2;
var argsTag$2$1 = "[object Arguments]", arrayTag$2 = "[object Array]", boolTag$3 = "[object Boolean]", dateTag$3 = "[object Date]", errorTag$2 = "[object Error]", funcTag$1$1 = "[object Function]", mapTag$5 = "[object Map]", numberTag$3 = "[object Number]", objectTag$4 = "[object Object]", regexpTag$3 = "[object RegExp]", setTag$5 = "[object Set]", stringTag$3 = "[object String]", weakMapTag$2$1 = "[object WeakMap]";
var arrayBufferTag$3 = "[object ArrayBuffer]", dataViewTag$4 = "[object DataView]", float32Tag$2$1 = "[object Float32Array]", float64Tag$2$1 = "[object Float64Array]", int8Tag$2$1 = "[object Int8Array]", int16Tag$2$1 = "[object Int16Array]", int32Tag$2$1 = "[object Int32Array]", uint8Tag$2$1 = "[object Uint8Array]", uint8ClampedTag$2$1 = "[object Uint8ClampedArray]", uint16Tag$2$1 = "[object Uint16Array]", uint32Tag$2$1 = "[object Uint32Array]";
var typedArrayTags$1 = {};
typedArrayTags$1[float32Tag$2$1] = typedArrayTags$1[float64Tag$2$1] = typedArrayTags$1[int8Tag$2$1] = typedArrayTags$1[int16Tag$2$1] = typedArrayTags$1[int32Tag$2$1] = typedArrayTags$1[uint8Tag$2$1] = typedArrayTags$1[uint8ClampedTag$2$1] = typedArrayTags$1[uint16Tag$2$1] = typedArrayTags$1[uint32Tag$2$1] = true;
typedArrayTags$1[argsTag$2$1] = typedArrayTags$1[arrayTag$2] = typedArrayTags$1[arrayBufferTag$3] = typedArrayTags$1[boolTag$3] = typedArrayTags$1[dataViewTag$4] = typedArrayTags$1[dateTag$3] = typedArrayTags$1[errorTag$2] = typedArrayTags$1[funcTag$1$1] = typedArrayTags$1[mapTag$5] = typedArrayTags$1[numberTag$3] = typedArrayTags$1[objectTag$4] = typedArrayTags$1[regexpTag$3] = typedArrayTags$1[setTag$5] = typedArrayTags$1[stringTag$3] = typedArrayTags$1[weakMapTag$2$1] = false;
function baseIsTypedArray$1(value) {
  return isObjectLike$1(value) && isLength$1(value.length) && !!typedArrayTags$1[baseGetTag$1(value)];
}
function baseUnary$1(func) {
  return function(value) {
    return func(value);
  };
}
var freeExports$1$1 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule$1$1 = freeExports$1$1 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports$1$1 = freeModule$1$1 && freeModule$1$1.exports === freeExports$1$1;
var freeProcess$1 = moduleExports$1$1 && freeGlobal$1$1.process;
var nodeUtil$2 = function() {
  try {
    var types = freeModule$1$1 && freeModule$1$1.require && freeModule$1$1.require("util").types;
    if (types) {
      return types;
    }
    return freeProcess$1 && freeProcess$1.binding && freeProcess$1.binding("util");
  } catch (e22) {
  }
}();
var nodeUtil$1$1 = nodeUtil$2;
var nodeIsTypedArray$1 = nodeUtil$1$1 && nodeUtil$1$1.isTypedArray;
var isTypedArray$2 = nodeIsTypedArray$1 ? baseUnary$1(nodeIsTypedArray$1) : baseIsTypedArray$1;
var isTypedArray$1$1 = isTypedArray$2;
var objectProto$9$1 = Object.prototype;
var hasOwnProperty$8$1 = objectProto$9$1.hasOwnProperty;
function arrayLikeKeys$1(value, inherited) {
  var isArr = isArray$1$1(value), isArg = !isArr && isArguments$1$1(value), isBuff = !isArr && !isArg && isBuffer$1$1(value), isType = !isArr && !isArg && !isBuff && isTypedArray$1$1(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes$1(value.length, String) : [], length = result.length;
  for (var key in value) {
    if ((inherited || hasOwnProperty$8$1.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex$1(key, length)))) {
      result.push(key);
    }
  }
  return result;
}
function overArg$1(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}
var nativeKeys$2 = overArg$1(Object.keys, Object);
var nativeKeys$1$1 = nativeKeys$2;
var objectProto$8$1 = Object.prototype;
var hasOwnProperty$7$1 = objectProto$8$1.hasOwnProperty;
function baseKeys$1(object) {
  if (!isPrototype$1(object)) {
    return nativeKeys$1$1(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty$7$1.call(object, key) && key != "constructor") {
      result.push(key);
    }
  }
  return result;
}
function keys$1(object) {
  return isArrayLike$1(object) ? arrayLikeKeys$1(object) : baseKeys$1(object);
}
function nativeKeysIn$1(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}
var objectProto$7$1 = Object.prototype;
var hasOwnProperty$6$1 = objectProto$7$1.hasOwnProperty;
function baseKeysIn$1(object) {
  if (!isObject$1(object)) {
    return nativeKeysIn$1(object);
  }
  var isProto = isPrototype$1(object), result = [];
  for (var key in object) {
    if (!(key == "constructor" && (isProto || !hasOwnProperty$6$1.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}
function keysIn$1(object) {
  return isArrayLike$1(object) ? arrayLikeKeys$1(object, true) : baseKeysIn$1(object);
}
var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
  copyObject$1(source, keysIn$1(source), object, customizer);
});
var assignInWith$1 = assignInWith;
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/;
function isKey(value, object) {
  if (isArray$1$1(value)) {
    return false;
  }
  var type = typeof value;
  if (type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol$1(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
}
var nativeCreate$2 = getNative$1(Object, "create");
var nativeCreate$1$1 = nativeCreate$2;
function hashClear$1() {
  this.__data__ = nativeCreate$1$1 ? nativeCreate$1$1(null) : {};
  this.size = 0;
}
function hashDelete$1(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}
var HASH_UNDEFINED$2 = "__lodash_hash_undefined__";
var objectProto$6$1 = Object.prototype;
var hasOwnProperty$5$1 = objectProto$6$1.hasOwnProperty;
function hashGet$1(key) {
  var data = this.__data__;
  if (nativeCreate$1$1) {
    var result = data[key];
    return result === HASH_UNDEFINED$2 ? void 0 : result;
  }
  return hasOwnProperty$5$1.call(data, key) ? data[key] : void 0;
}
var objectProto$5$1 = Object.prototype;
var hasOwnProperty$4$1 = objectProto$5$1.hasOwnProperty;
function hashHas$1(key) {
  var data = this.__data__;
  return nativeCreate$1$1 ? data[key] !== void 0 : hasOwnProperty$4$1.call(data, key);
}
var HASH_UNDEFINED$1$1 = "__lodash_hash_undefined__";
function hashSet$1(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = nativeCreate$1$1 && value === void 0 ? HASH_UNDEFINED$1$1 : value;
  return this;
}
function Hash$1(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
Hash$1.prototype.clear = hashClear$1;
Hash$1.prototype["delete"] = hashDelete$1;
Hash$1.prototype.get = hashGet$1;
Hash$1.prototype.has = hashHas$1;
Hash$1.prototype.set = hashSet$1;
function listCacheClear$1() {
  this.__data__ = [];
  this.size = 0;
}
function assocIndexOf$1(array, key) {
  var length = array.length;
  while (length--) {
    if (eq$2(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}
var arrayProto$1 = Array.prototype;
var splice$1 = arrayProto$1.splice;
function listCacheDelete$1(key) {
  var data = this.__data__, index = assocIndexOf$1(data, key);
  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice$1.call(data, index, 1);
  }
  --this.size;
  return true;
}
function listCacheGet$1(key) {
  var data = this.__data__, index = assocIndexOf$1(data, key);
  return index < 0 ? void 0 : data[index][1];
}
function listCacheHas$1(key) {
  return assocIndexOf$1(this.__data__, key) > -1;
}
function listCacheSet$1(key, value) {
  var data = this.__data__, index = assocIndexOf$1(data, key);
  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}
function ListCache$1(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
ListCache$1.prototype.clear = listCacheClear$1;
ListCache$1.prototype["delete"] = listCacheDelete$1;
ListCache$1.prototype.get = listCacheGet$1;
ListCache$1.prototype.has = listCacheHas$1;
ListCache$1.prototype.set = listCacheSet$1;
var Map$3 = getNative$1(root$1$1, "Map");
var Map$1$1 = Map$3;
function mapCacheClear$1() {
  this.size = 0;
  this.__data__ = {
    "hash": new Hash$1(),
    "map": new (Map$1$1 || ListCache$1)(),
    "string": new Hash$1()
  };
}
function isKeyable$1(value) {
  var type = typeof value;
  return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
}
function getMapData$1(map, key) {
  var data = map.__data__;
  return isKeyable$1(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
}
function mapCacheDelete$1(key) {
  var result = getMapData$1(this, key)["delete"](key);
  this.size -= result ? 1 : 0;
  return result;
}
function mapCacheGet$1(key) {
  return getMapData$1(this, key).get(key);
}
function mapCacheHas$1(key) {
  return getMapData$1(this, key).has(key);
}
function mapCacheSet$1(key, value) {
  var data = getMapData$1(this, key), size = data.size;
  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}
function MapCache$1(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
MapCache$1.prototype.clear = mapCacheClear$1;
MapCache$1.prototype["delete"] = mapCacheDelete$1;
MapCache$1.prototype.get = mapCacheGet$1;
MapCache$1.prototype.has = mapCacheHas$1;
MapCache$1.prototype.set = mapCacheSet$1;
var FUNC_ERROR_TEXT$1 = "Expected a function";
function memoize(func, resolver) {
  if (typeof func != "function" || resolver != null && typeof resolver != "function") {
    throw new TypeError(FUNC_ERROR_TEXT$1);
  }
  var memoized = function() {
    var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache$1)();
  return memoized;
}
memoize.Cache = MapCache$1;
var MAX_MEMOIZE_SIZE = 500;
function memoizeCapped(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });
  var cache = result.cache;
  return result;
}
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
var reEscapeChar = /\\(\\)?/g;
var stringToPath = memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46) {
    result.push("");
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, "$1") : number || match);
  });
  return result;
});
var stringToPath$1 = stringToPath;
function toString(value) {
  return value == null ? "" : baseToString(value);
}
function castPath(value, object) {
  if (isArray$1$1(value)) {
    return value;
  }
  return isKey(value, object) ? [value] : stringToPath$1(toString(value));
}
var INFINITY = 1 / 0;
function toKey(value) {
  if (typeof value == "string" || isSymbol$1(value)) {
    return value;
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
function baseGet(object, path) {
  path = castPath(path, object);
  var index = 0, length = path.length;
  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return index && index == length ? object : void 0;
}
function get(object, path, defaultValue) {
  var result = object == null ? void 0 : baseGet(object, path);
  return result === void 0 ? defaultValue : result;
}
function arrayPush$1(array, values) {
  var index = -1, length = values.length, offset = array.length;
  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}
var getPrototype$2 = overArg$1(Object.getPrototypeOf, Object);
var getPrototype$1$1 = getPrototype$2;
var objectTag$3 = "[object Object]";
var funcProto$3 = Function.prototype, objectProto$4$1 = Object.prototype;
var funcToString$3 = funcProto$3.toString;
var hasOwnProperty$3$1 = objectProto$4$1.hasOwnProperty;
var objectCtorString = funcToString$3.call(Object);
function isPlainObject(value) {
  if (!isObjectLike$1(value) || baseGetTag$1(value) != objectTag$3) {
    return false;
  }
  var proto = getPrototype$1$1(value);
  if (proto === null) {
    return true;
  }
  var Ctor = hasOwnProperty$3$1.call(proto, "constructor") && proto.constructor;
  return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString$3.call(Ctor) == objectCtorString;
}
function stackClear$1() {
  this.__data__ = new ListCache$1();
  this.size = 0;
}
function stackDelete$1(key) {
  var data = this.__data__, result = data["delete"](key);
  this.size = data.size;
  return result;
}
function stackGet$1(key) {
  return this.__data__.get(key);
}
function stackHas$1(key) {
  return this.__data__.has(key);
}
var LARGE_ARRAY_SIZE$1 = 200;
function stackSet$1(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache$1) {
    var pairs = data.__data__;
    if (!Map$1$1 || pairs.length < LARGE_ARRAY_SIZE$1 - 1) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache$1(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}
function Stack$1(entries) {
  var data = this.__data__ = new ListCache$1(entries);
  this.size = data.size;
}
Stack$1.prototype.clear = stackClear$1;
Stack$1.prototype["delete"] = stackDelete$1;
Stack$1.prototype.get = stackGet$1;
Stack$1.prototype.has = stackHas$1;
Stack$1.prototype.set = stackSet$1;
function baseAssign$1(object, source) {
  return object && copyObject$1(source, keys$1(source), object);
}
function baseAssignIn$1(object, source) {
  return object && copyObject$1(source, keysIn$1(source), object);
}
var freeExports$3 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule$3 = freeExports$3 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports$3 = freeModule$3 && freeModule$3.exports === freeExports$3;
var Buffer2 = moduleExports$3 ? root$1$1.Buffer : void 0, allocUnsafe$1 = Buffer2 ? Buffer2.allocUnsafe : void 0;
function cloneBuffer$1(buffer, isDeep) {
  if (isDeep) {
    return buffer.slice();
  }
  var length = buffer.length, result = allocUnsafe$1 ? allocUnsafe$1(length) : new buffer.constructor(length);
  buffer.copy(result);
  return result;
}
function arrayFilter$1(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}
function stubArray$1() {
  return [];
}
var objectProto$3$1 = Object.prototype;
var propertyIsEnumerable$2 = objectProto$3$1.propertyIsEnumerable;
var nativeGetSymbols$1$1 = Object.getOwnPropertySymbols;
var getSymbols$2 = !nativeGetSymbols$1$1 ? stubArray$1 : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter$1(nativeGetSymbols$1$1(object), function(symbol) {
    return propertyIsEnumerable$2.call(object, symbol);
  });
};
var getSymbols$1$1 = getSymbols$2;
function copySymbols$1(source, object) {
  return copyObject$1(source, getSymbols$1$1(source), object);
}
var nativeGetSymbols$2 = Object.getOwnPropertySymbols;
var getSymbolsIn$2 = !nativeGetSymbols$2 ? stubArray$1 : function(object) {
  var result = [];
  while (object) {
    arrayPush$1(result, getSymbols$1$1(object));
    object = getPrototype$1$1(object);
  }
  return result;
};
var getSymbolsIn$1$1 = getSymbolsIn$2;
function copySymbolsIn$1(source, object) {
  return copyObject$1(source, getSymbolsIn$1$1(source), object);
}
function baseGetAllKeys$1(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray$1$1(object) ? result : arrayPush$1(result, symbolsFunc(object));
}
function getAllKeys$1(object) {
  return baseGetAllKeys$1(object, keys$1, getSymbols$1$1);
}
function getAllKeysIn$1(object) {
  return baseGetAllKeys$1(object, keysIn$1, getSymbolsIn$1$1);
}
var DataView$2 = getNative$1(root$1$1, "DataView");
var DataView$1$1 = DataView$2;
var Promise$1$1 = getNative$1(root$1$1, "Promise");
var Promise$2$1 = Promise$1$1;
var Set$3 = getNative$1(root$1$1, "Set");
var Set$1$1 = Set$3;
var mapTag$4$1 = "[object Map]", objectTag$2$1 = "[object Object]", promiseTag$1 = "[object Promise]", setTag$4$1 = "[object Set]", weakMapTag$1$1 = "[object WeakMap]";
var dataViewTag$3$1 = "[object DataView]";
var dataViewCtorString$1 = toSource$1(DataView$1$1), mapCtorString$1 = toSource$1(Map$1$1), promiseCtorString$1 = toSource$1(Promise$2$1), setCtorString$1 = toSource$1(Set$1$1), weakMapCtorString$1 = toSource$1(WeakMap$1$1);
var getTag$2 = baseGetTag$1;
if (DataView$1$1 && getTag$2(new DataView$1$1(new ArrayBuffer(1))) != dataViewTag$3$1 || Map$1$1 && getTag$2(new Map$1$1()) != mapTag$4$1 || Promise$2$1 && getTag$2(Promise$2$1.resolve()) != promiseTag$1 || Set$1$1 && getTag$2(new Set$1$1()) != setTag$4$1 || WeakMap$1$1 && getTag$2(new WeakMap$1$1()) != weakMapTag$1$1) {
  getTag$2 = function(value) {
    var result = baseGetTag$1(value), Ctor = result == objectTag$2$1 ? value.constructor : void 0, ctorString = Ctor ? toSource$1(Ctor) : "";
    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString$1:
          return dataViewTag$3$1;
        case mapCtorString$1:
          return mapTag$4$1;
        case promiseCtorString$1:
          return promiseTag$1;
        case setCtorString$1:
          return setTag$4$1;
        case weakMapCtorString$1:
          return weakMapTag$1$1;
      }
    }
    return result;
  };
}
var getTag$1$1 = getTag$2;
var objectProto$2$1 = Object.prototype;
var hasOwnProperty$2$1 = objectProto$2$1.hasOwnProperty;
function initCloneArray$1(array) {
  var length = array.length, result = new array.constructor(length);
  if (length && typeof array[0] == "string" && hasOwnProperty$2$1.call(array, "index")) {
    result.index = array.index;
    result.input = array.input;
  }
  return result;
}
var Uint8Array2 = root$1$1.Uint8Array;
var Uint8Array$1$1 = Uint8Array2;
function cloneArrayBuffer$1(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array$1$1(result).set(new Uint8Array$1$1(arrayBuffer));
  return result;
}
function cloneDataView$1(dataView, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer$1(dataView.buffer) : dataView.buffer;
  return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
}
var reFlags$1 = /\w*$/;
function cloneRegExp$1(regexp) {
  var result = new regexp.constructor(regexp.source, reFlags$1.exec(regexp));
  result.lastIndex = regexp.lastIndex;
  return result;
}
var symbolProto$1 = Symbol$2$1 ? Symbol$2$1.prototype : void 0, symbolValueOf$1 = symbolProto$1 ? symbolProto$1.valueOf : void 0;
function cloneSymbol$1(symbol) {
  return symbolValueOf$1 ? Object(symbolValueOf$1.call(symbol)) : {};
}
function cloneTypedArray$1(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer$1(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}
var boolTag$2$1 = "[object Boolean]", dateTag$2$1 = "[object Date]", mapTag$3$1 = "[object Map]", numberTag$2$1 = "[object Number]", regexpTag$2$1 = "[object RegExp]", setTag$3$1 = "[object Set]", stringTag$2$1 = "[object String]", symbolTag$2$1 = "[object Symbol]";
var arrayBufferTag$2$1 = "[object ArrayBuffer]", dataViewTag$2$1 = "[object DataView]", float32Tag$1$1 = "[object Float32Array]", float64Tag$1$1 = "[object Float64Array]", int8Tag$1$1 = "[object Int8Array]", int16Tag$1$1 = "[object Int16Array]", int32Tag$1$1 = "[object Int32Array]", uint8Tag$1$1 = "[object Uint8Array]", uint8ClampedTag$1$1 = "[object Uint8ClampedArray]", uint16Tag$1$1 = "[object Uint16Array]", uint32Tag$1$1 = "[object Uint32Array]";
function initCloneByTag$1(object, tag, isDeep) {
  var Ctor = object.constructor;
  switch (tag) {
    case arrayBufferTag$2$1:
      return cloneArrayBuffer$1(object);
    case boolTag$2$1:
    case dateTag$2$1:
      return new Ctor(+object);
    case dataViewTag$2$1:
      return cloneDataView$1(object, isDeep);
    case float32Tag$1$1:
    case float64Tag$1$1:
    case int8Tag$1$1:
    case int16Tag$1$1:
    case int32Tag$1$1:
    case uint8Tag$1$1:
    case uint8ClampedTag$1$1:
    case uint16Tag$1$1:
    case uint32Tag$1$1:
      return cloneTypedArray$1(object, isDeep);
    case mapTag$3$1:
      return new Ctor();
    case numberTag$2$1:
    case stringTag$2$1:
      return new Ctor(object);
    case regexpTag$2$1:
      return cloneRegExp$1(object);
    case setTag$3$1:
      return new Ctor();
    case symbolTag$2$1:
      return cloneSymbol$1(object);
  }
}
function initCloneObject$1(object) {
  return typeof object.constructor == "function" && !isPrototype$1(object) ? baseCreate$1$1(getPrototype$1$1(object)) : {};
}
var mapTag$2$1 = "[object Map]";
function baseIsMap$1(value) {
  return isObjectLike$1(value) && getTag$1$1(value) == mapTag$2$1;
}
var nodeIsMap$1 = nodeUtil$1$1 && nodeUtil$1$1.isMap;
var isMap$2 = nodeIsMap$1 ? baseUnary$1(nodeIsMap$1) : baseIsMap$1;
var isMap$1$1 = isMap$2;
var setTag$2$1 = "[object Set]";
function baseIsSet$1(value) {
  return isObjectLike$1(value) && getTag$1$1(value) == setTag$2$1;
}
var nodeIsSet$1 = nodeUtil$1$1 && nodeUtil$1$1.isSet;
var isSet$2 = nodeIsSet$1 ? baseUnary$1(nodeIsSet$1) : baseIsSet$1;
var isSet$1$1 = isSet$2;
var CLONE_DEEP_FLAG$1$1 = 1, CLONE_FLAT_FLAG$1 = 2, CLONE_SYMBOLS_FLAG$1$1 = 4;
var argsTag$1$1 = "[object Arguments]", arrayTag$1$1 = "[object Array]", boolTag$1$1 = "[object Boolean]", dateTag$1$1 = "[object Date]", errorTag$1$1 = "[object Error]", funcTag$3 = "[object Function]", genTag$2 = "[object GeneratorFunction]", mapTag$1$1 = "[object Map]", numberTag$1$1 = "[object Number]", objectTag$1$1 = "[object Object]", regexpTag$1$1 = "[object RegExp]", setTag$1$1 = "[object Set]", stringTag$1$1 = "[object String]", symbolTag$1$1 = "[object Symbol]", weakMapTag$3 = "[object WeakMap]";
var arrayBufferTag$1$1 = "[object ArrayBuffer]", dataViewTag$1$1 = "[object DataView]", float32Tag$3 = "[object Float32Array]", float64Tag$3 = "[object Float64Array]", int8Tag$3 = "[object Int8Array]", int16Tag$3 = "[object Int16Array]", int32Tag$3 = "[object Int32Array]", uint8Tag$3 = "[object Uint8Array]", uint8ClampedTag$3 = "[object Uint8ClampedArray]", uint16Tag$3 = "[object Uint16Array]", uint32Tag$3 = "[object Uint32Array]";
var cloneableTags$1 = {};
cloneableTags$1[argsTag$1$1] = cloneableTags$1[arrayTag$1$1] = cloneableTags$1[arrayBufferTag$1$1] = cloneableTags$1[dataViewTag$1$1] = cloneableTags$1[boolTag$1$1] = cloneableTags$1[dateTag$1$1] = cloneableTags$1[float32Tag$3] = cloneableTags$1[float64Tag$3] = cloneableTags$1[int8Tag$3] = cloneableTags$1[int16Tag$3] = cloneableTags$1[int32Tag$3] = cloneableTags$1[mapTag$1$1] = cloneableTags$1[numberTag$1$1] = cloneableTags$1[objectTag$1$1] = cloneableTags$1[regexpTag$1$1] = cloneableTags$1[setTag$1$1] = cloneableTags$1[stringTag$1$1] = cloneableTags$1[symbolTag$1$1] = cloneableTags$1[uint8Tag$3] = cloneableTags$1[uint8ClampedTag$3] = cloneableTags$1[uint16Tag$3] = cloneableTags$1[uint32Tag$3] = true;
cloneableTags$1[errorTag$1$1] = cloneableTags$1[funcTag$3] = cloneableTags$1[weakMapTag$3] = false;
function baseClone$1(value, bitmask, customizer, key, object, stack) {
  var result, isDeep = bitmask & CLONE_DEEP_FLAG$1$1, isFlat = bitmask & CLONE_FLAT_FLAG$1, isFull = bitmask & CLONE_SYMBOLS_FLAG$1$1;
  if (customizer) {
    result = object ? customizer(value, key, object, stack) : customizer(value);
  }
  if (result !== void 0) {
    return result;
  }
  if (!isObject$1(value)) {
    return value;
  }
  var isArr = isArray$1$1(value);
  if (isArr) {
    result = initCloneArray$1(value);
    if (!isDeep) {
      return copyArray$1(value, result);
    }
  } else {
    var tag = getTag$1$1(value), isFunc = tag == funcTag$3 || tag == genTag$2;
    if (isBuffer$1$1(value)) {
      return cloneBuffer$1(value, isDeep);
    }
    if (tag == objectTag$1$1 || tag == argsTag$1$1 || isFunc && !object) {
      result = isFlat || isFunc ? {} : initCloneObject$1(value);
      if (!isDeep) {
        return isFlat ? copySymbolsIn$1(value, baseAssignIn$1(result, value)) : copySymbols$1(value, baseAssign$1(result, value));
      }
    } else {
      if (!cloneableTags$1[tag]) {
        return object ? value : {};
      }
      result = initCloneByTag$1(value, tag, isDeep);
    }
  }
  stack || (stack = new Stack$1());
  var stacked = stack.get(value);
  if (stacked) {
    return stacked;
  }
  stack.set(value, result);
  if (isSet$1$1(value)) {
    value.forEach(function(subValue) {
      result.add(baseClone$1(subValue, bitmask, customizer, subValue, value, stack));
    });
  } else if (isMap$1$1(value)) {
    value.forEach(function(subValue, key2) {
      result.set(key2, baseClone$1(subValue, bitmask, customizer, key2, value, stack));
    });
  }
  var keysFunc = isFull ? isFlat ? getAllKeysIn$1 : getAllKeys$1 : isFlat ? keysIn$1 : keys$1;
  var props = isArr ? void 0 : keysFunc(value);
  arrayEach$1(props || value, function(subValue, key2) {
    if (props) {
      key2 = subValue;
      subValue = value[key2];
    }
    assignValue$1(result, key2, baseClone$1(subValue, bitmask, customizer, key2, value, stack));
  });
  return result;
}
var CLONE_DEEP_FLAG$2 = 1, CLONE_SYMBOLS_FLAG$2 = 4;
function cloneDeep$1(value) {
  return baseClone$1(value, CLONE_DEEP_FLAG$2 | CLONE_SYMBOLS_FLAG$2);
}
var HASH_UNDEFINED$3 = "__lodash_hash_undefined__";
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED$3);
  return this;
}
function setCacheHas(value) {
  return this.__data__.has(value);
}
function SetCache(values) {
  var index = -1, length = values == null ? 0 : values.length;
  this.__data__ = new MapCache$1();
  while (++index < length) {
    this.add(values[index]);
  }
}
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;
function arraySome(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}
function cacheHas(cache, key) {
  return cache.has(key);
}
var COMPARE_PARTIAL_FLAG$5 = 1, COMPARE_UNORDERED_FLAG$3 = 2;
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$5, arrLength = array.length, othLength = other.length;
  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG$3 ? new SetCache() : void 0;
  stack.set(array, other);
  stack.set(other, array);
  while (++index < arrLength) {
    var arrValue = array[index], othValue = other[index];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== void 0) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    if (seen) {
      if (!arraySome(other, function(othValue2, othIndex) {
        if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
          return seen.push(othIndex);
        }
      })) {
        result = false;
        break;
      }
    } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
      result = false;
      break;
    }
  }
  stack["delete"](array);
  stack["delete"](other);
  return result;
}
function mapToArray(map) {
  var index = -1, result = Array(map.size);
  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}
function setToArray(set) {
  var index = -1, result = Array(set.size);
  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}
var COMPARE_PARTIAL_FLAG$4 = 1, COMPARE_UNORDERED_FLAG$2 = 2;
var boolTag$4 = "[object Boolean]", dateTag$4 = "[object Date]", errorTag$3 = "[object Error]", mapTag$6 = "[object Map]", numberTag$4 = "[object Number]", regexpTag$4 = "[object RegExp]", setTag$6 = "[object Set]", stringTag$4 = "[object String]", symbolTag$4 = "[object Symbol]";
var arrayBufferTag$4 = "[object ArrayBuffer]", dataViewTag$5 = "[object DataView]";
var symbolProto$3 = Symbol$2$1 ? Symbol$2$1.prototype : void 0, symbolValueOf$2 = symbolProto$3 ? symbolProto$3.valueOf : void 0;
function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag$5:
      if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;
    case arrayBufferTag$4:
      if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array$1$1(object), new Uint8Array$1$1(other))) {
        return false;
      }
      return true;
    case boolTag$4:
    case dateTag$4:
    case numberTag$4:
      return eq$2(+object, +other);
    case errorTag$3:
      return object.name == other.name && object.message == other.message;
    case regexpTag$4:
    case stringTag$4:
      return object == other + "";
    case mapTag$6:
      var convert = mapToArray;
    case setTag$6:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG$4;
      convert || (convert = setToArray);
      if (object.size != other.size && !isPartial) {
        return false;
      }
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG$2;
      stack.set(object, other);
      var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack["delete"](object);
      return result;
    case symbolTag$4:
      if (symbolValueOf$2) {
        return symbolValueOf$2.call(object) == symbolValueOf$2.call(other);
      }
  }
  return false;
}
var COMPARE_PARTIAL_FLAG$3 = 1;
var objectProto$1$1 = Object.prototype;
var hasOwnProperty$1$1 = objectProto$1$1.hasOwnProperty;
function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3, objProps = getAllKeys$1(object), objLength = objProps.length, othProps = getAllKeys$1(other), othLength = othProps.length;
  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty$1$1.call(other, key))) {
      return false;
    }
  }
  var objStacked = stack.get(object);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);
  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key], othValue = other[key];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
    }
    if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == "constructor");
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor, othCtor = other.constructor;
    if (objCtor != othCtor && ("constructor" in object && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack["delete"](object);
  stack["delete"](other);
  return result;
}
var COMPARE_PARTIAL_FLAG$2 = 1;
var argsTag$4 = "[object Arguments]", arrayTag$3 = "[object Array]", objectTag$5 = "[object Object]";
var objectProto$g = Object.prototype;
var hasOwnProperty$d = objectProto$g.hasOwnProperty;
function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray$1$1(object), othIsArr = isArray$1$1(other), objTag = objIsArr ? arrayTag$3 : getTag$1$1(object), othTag = othIsArr ? arrayTag$3 : getTag$1$1(other);
  objTag = objTag == argsTag$4 ? objectTag$5 : objTag;
  othTag = othTag == argsTag$4 ? objectTag$5 : othTag;
  var objIsObj = objTag == objectTag$5, othIsObj = othTag == objectTag$5, isSameTag = objTag == othTag;
  if (isSameTag && isBuffer$1$1(object)) {
    if (!isBuffer$1$1(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack$1());
    return objIsArr || isTypedArray$1$1(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG$2)) {
    var objIsWrapped = objIsObj && hasOwnProperty$d.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty$d.call(other, "__wrapped__");
    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
      stack || (stack = new Stack$1());
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack$1());
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || !isObjectLike$1(value) && !isObjectLike$1(other)) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
}
var COMPARE_PARTIAL_FLAG$1 = 1, COMPARE_UNORDERED_FLAG$1 = 2;
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length, length = index, noCustomizer = !customizer;
  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object)) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0], objValue = object[key], srcValue = data[1];
    if (noCustomizer && data[2]) {
      if (objValue === void 0 && !(key in object)) {
        return false;
      }
    } else {
      var stack = new Stack$1();
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source, stack);
      }
      if (!(result === void 0 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG$1 | COMPARE_UNORDERED_FLAG$1, customizer, stack) : result)) {
        return false;
      }
    }
  }
  return true;
}
function isStrictComparable(value) {
  return value === value && !isObject$1(value);
}
function getMatchData(object) {
  var result = keys$1(object), length = result.length;
  while (length--) {
    var key = result[length], value = object[key];
    result[length] = [key, value, isStrictComparable(value)];
  }
  return result;
}
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue && (srcValue !== void 0 || key in Object(object));
  };
}
function baseMatches(source) {
  var matchData = getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || baseIsMatch(object, source, matchData);
  };
}
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}
function hasPath(object, path, hasFunc) {
  path = castPath(path, object);
  var index = -1, length = path.length, result = false;
  while (++index < length) {
    var key = toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isLength$1(length) && isIndex$1(key, length) && (isArray$1$1(object) || isArguments$1$1(object));
}
function hasIn(object, path) {
  return object != null && hasPath(object, path, baseHasIn);
}
var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
function baseMatchesProperty(path, srcValue) {
  if (isKey(path) && isStrictComparable(srcValue)) {
    return matchesStrictComparable(toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get(object, path);
    return objValue === void 0 && objValue === srcValue ? hasIn(object, path) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}
function baseProperty(key) {
  return function(object) {
    return object == null ? void 0 : object[key];
  };
}
function basePropertyDeep(path) {
  return function(object) {
    return baseGet(object, path);
  };
}
function property(path) {
  return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
}
function baseIteratee(value) {
  if (typeof value == "function") {
    return value;
  }
  if (value == null) {
    return identity;
  }
  if (typeof value == "object") {
    return isArray$1$1(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
  }
  return property(value);
}
function createBaseFor(fromRight) {
  return function(object, iteratee, keysFunc) {
    var index = -1, iterable = Object(object), props = keysFunc(object), length = props.length;
    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object;
  };
}
var baseFor = createBaseFor();
var baseFor$1 = baseFor;
function baseForOwn(object, iteratee) {
  return object && baseFor$1(object, iteratee, keys$1);
}
function assignMergeValue(object, key, value) {
  if (value !== void 0 && !eq$2(object[key], value) || value === void 0 && !(key in object)) {
    baseAssignValue$1(object, key, value);
  }
}
function isArrayLikeObject(value) {
  return isObjectLike$1(value) && isArrayLike$1(value);
}
function safeGet(object, key) {
  if (key === "constructor" && typeof object[key] === "function") {
    return;
  }
  if (key == "__proto__") {
    return;
  }
  return object[key];
}
function toPlainObject(value) {
  return copyObject$1(value, keysIn$1(value));
}
function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
  var objValue = safeGet(object, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
  if (stacked) {
    assignMergeValue(object, key, stacked);
    return;
  }
  var newValue = customizer ? customizer(objValue, srcValue, key + "", object, source, stack) : void 0;
  var isCommon = newValue === void 0;
  if (isCommon) {
    var isArr = isArray$1$1(srcValue), isBuff = !isArr && isBuffer$1$1(srcValue), isTyped = !isArr && !isBuff && isTypedArray$1$1(srcValue);
    newValue = srcValue;
    if (isArr || isBuff || isTyped) {
      if (isArray$1$1(objValue)) {
        newValue = objValue;
      } else if (isArrayLikeObject(objValue)) {
        newValue = copyArray$1(objValue);
      } else if (isBuff) {
        isCommon = false;
        newValue = cloneBuffer$1(srcValue, true);
      } else if (isTyped) {
        isCommon = false;
        newValue = cloneTypedArray$1(srcValue, true);
      } else {
        newValue = [];
      }
    } else if (isPlainObject(srcValue) || isArguments$1$1(srcValue)) {
      newValue = objValue;
      if (isArguments$1$1(objValue)) {
        newValue = toPlainObject(objValue);
      } else if (!isObject$1(objValue) || isFunction$1(objValue)) {
        newValue = initCloneObject$1(srcValue);
      }
    } else {
      isCommon = false;
    }
  }
  if (isCommon) {
    stack.set(srcValue, newValue);
    mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
    stack["delete"](srcValue);
  }
  assignMergeValue(object, key, newValue);
}
function baseMerge(object, source, srcIndex, customizer, stack) {
  if (object === source) {
    return;
  }
  baseFor$1(source, function(srcValue, key) {
    stack || (stack = new Stack$1());
    if (isObject$1(srcValue)) {
      baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
    } else {
      var newValue = customizer ? customizer(safeGet(object, key), srcValue, key + "", object, source, stack) : void 0;
      if (newValue === void 0) {
        newValue = srcValue;
      }
      assignMergeValue(object, key, newValue);
    }
  }, keysIn$1);
}
var mergeWith = createAssigner(function(object, source, srcIndex, customizer) {
  baseMerge(object, source, srcIndex, customizer);
});
var mergeWith$1 = mergeWith;
function mapKeys(object, iteratee) {
  var result = {};
  iteratee = baseIteratee(iteratee);
  baseForOwn(object, function(value, key, object2) {
    baseAssignValue$1(result, iteratee(value, key, object2), value);
  });
  return result;
}
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var __assign = function() {
  __assign = Object.assign || function __assign2(t2) {
    for (var s2, i2 = 1, n2 = arguments.length; i2 < n2; i2++) {
      s2 = arguments[i2];
      for (var p2 in s2)
        if (Object.prototype.hasOwnProperty.call(s2, p2))
          t2[p2] = s2[p2];
    }
    return t2;
  };
  return __assign.apply(this, arguments);
};
function lowerCase(str) {
  return str.toLowerCase();
}
var DEFAULT_SPLIT_REGEXP = [/([a-z0-9])([A-Z])/g, /([A-Z])([A-Z][a-z])/g];
var DEFAULT_STRIP_REGEXP = /[^A-Z0-9]+/gi;
function noCase(input, options) {
  if (options === void 0) {
    options = {};
  }
  var _a2 = options.splitRegexp, splitRegexp = _a2 === void 0 ? DEFAULT_SPLIT_REGEXP : _a2, _b2 = options.stripRegexp, stripRegexp = _b2 === void 0 ? DEFAULT_STRIP_REGEXP : _b2, _c2 = options.transform, transform = _c2 === void 0 ? lowerCase : _c2, _d2 = options.delimiter, delimiter = _d2 === void 0 ? " " : _d2;
  var result = replace(replace(input, splitRegexp, "$1\0$2"), stripRegexp, "\0");
  var start = 0;
  var end = result.length;
  while (result.charAt(start) === "\0")
    start++;
  while (result.charAt(end - 1) === "\0")
    end--;
  return result.slice(start, end).split("\0").map(transform).join(delimiter);
}
function replace(input, re2, value) {
  if (re2 instanceof RegExp)
    return input.replace(re2, value);
  return re2.reduce(function(input2, re22) {
    return input2.replace(re22, value);
  }, input);
}
function pascalCaseTransform(input, index) {
  var firstChar = input.charAt(0);
  var lowerChars = input.substr(1).toLowerCase();
  if (index > 0 && firstChar >= "0" && firstChar <= "9") {
    return "_" + firstChar + lowerChars;
  }
  return "" + firstChar.toUpperCase() + lowerChars;
}
function pascalCase(input, options) {
  if (options === void 0) {
    options = {};
  }
  return noCase(input, __assign({ delimiter: "", transform: pascalCaseTransform }, options));
}
function camelCaseTransform(input, index) {
  if (index === 0)
    return input.toLowerCase();
  return pascalCaseTransform(input, index);
}
function camelCase(input, options) {
  if (options === void 0) {
    options = {};
  }
  return pascalCase(input, __assign({ transform: camelCaseTransform }, options));
}
function typeOf(variate) {
  return {}.toString.call(variate).slice(8, -1).toLowerCase();
}
(function() {
  var array = [];
  for (var i2 = 0; i2 < 256; ++i2) {
    array.push("%" + ((i2 < 16 ? "0" : "") + i2.toString(16)).toUpperCase());
  }
  return array;
})();
function validateProp({
  type,
  name,
  prop,
  validator
}) {
  if (type) {
    if (typeOf(type) === "string") {
      type = [type];
    }
    const actualType = typeOf(prop);
    if (!type.includes(actualType)) {
      throw Error(`${name}\u9700\u4E3A${type.toString()}\u7C7B\u578B\uFF08\u5F97\u5230${actualType}\uFF09`);
    }
  }
  if (validator && !validator(prop)) {
    throw Error(`${name}\u4E0D\u5408\u6CD5`);
  }
}
function MergeObject(sources, {
  mergeObject,
  mergeFunction
}) {
  const customizer = mergeFunction ? (objValue, srcValue) => typeOf(objValue) === "function" && typeOf(srcValue) === "function" ? mergeFunction(srcValue, objValue) : void 0 : void 0;
  return mergeObject === "deep" ? mergeWith$1(...sources, customizer) : assignInWith$1(...sources, customizer);
}
function MergeFunction(sources, {
  mergeFunction
}) {
  return sources.reduce(mergeFunction, () => {
  });
}
function conclude(configSequence, config = {}) {
  let {
    name = "",
    type,
    default: defaultValue,
    defaultIsDynamic = false,
    required = false,
    validator,
    camelCase: camelCase$1 = true,
    mergeObject = "deep",
    mergeObjectApplyOnlyToDefault = false,
    mergeFunction = false,
    mergeFunctionApplyOnlyToDefault = true
  } = config;
  let configSequenceCopy;
  if (defaultIsDynamic) {
    if (typeOf(defaultValue) !== "function") {
      throw Error(`${name}\u52A8\u6001\u751F\u6210\u9ED8\u8BA4\u503C\u65F6\uFF0C\u9ED8\u8BA4\u503C\u9700\u4E3A\u51FD\u6570\u7C7B\u578B`);
    }
    configSequenceCopy = [...configSequence];
  } else {
    configSequenceCopy = [...configSequence, defaultValue];
  }
  let result, isPlainObjectArray = false, isFunctionArray = false;
  for (let i2 = 0; i2 < configSequenceCopy.length; i2++) {
    const v2 = configSequenceCopy[i2];
    if (v2 !== void 0) {
      validateProp({
        type,
        name,
        prop: v2,
        validator
      });
      const itemIsPlainObject = isPlainObject(v2);
      const itemIsFunction = typeOf(v2) === "function";
      isPlainObjectArray = itemIsPlainObject;
      isFunctionArray = itemIsFunction;
      if (!itemIsPlainObject && !itemIsFunction) {
        break;
      }
    }
  }
  if (isPlainObjectArray) {
    configSequenceCopy = cloneDeep$1(configSequenceCopy);
  } else {
    mergeObject = false;
    if (!isFunctionArray) {
      mergeFunction = false;
    }
  }
  for (let i2 = 0; i2 < configSequenceCopy.length; i2++) {
    const prop = configSequenceCopy[i2];
    if (prop !== void 0) {
      if (i2 === configSequenceCopy.length - 1) {
        result = prop;
      } else if (mergeObject) {
        result = MergeObject(mergeObjectApplyOnlyToDefault ? [defaultValue, prop] : [...configSequenceCopy].reverse(), {
          mergeObject,
          mergeFunction
        });
      } else if (mergeFunction) {
        result = MergeFunction(mergeFunctionApplyOnlyToDefault ? [prop, defaultValue] : configSequenceCopy, {
          mergeFunction
        });
      } else {
        result = prop;
      }
      break;
    }
  }
  if (required && result === void 0) {
    throw Error(`${name}\u53C2\u6570\u4E0D\u80FD\u4E3A\u7A7A`);
  }
  if (defaultIsDynamic) {
    return conclude(configSequence, __spreadProps(__spreadValues({}, config), {
      default: defaultValue(result),
      defaultIsDynamic: false
    }));
  } else {
    return camelCase$1 && isPlainObject(result) ? mapKeys(result, (v2, k2) => camelCase(k2, {
      stripRegexp: /-/g
    })) : result;
  }
}
var e, t, n, r, i, o, a, s, u, c, l, f, h, d, v, p, m, g, y, b, k, w, x, j, S, C, _, $, O, A, M, E, P, N, T, I, R, D, z, L, B, q, F, V, H, W, J, U, K, G, Q, Y, Z, X, ee, te, ne, re, ie, oe, ae, se, ue, ce, le, fe, he, de, ve, pe, me, ge, ye, be, ke, we, xe, je, Se, Ce, _e, $e, Oe, Ae, Me, Ee, Pe, Ne, Te, Ie, Re, De, ze, Le, Be, qe, Fe, Ve, He, We, Je, Ue, Ke, Ge, Qe, Ye, Ze, Xe, et, tt, nt, rt, it, ot, at, st, ut, ct, lt, ft, ht, dt, vt, pt, mt, gt, yt, bt, kt, wt, xt, jt, St, Ct, _t, $t, Ot, At, Mt, Et, Pt, Nt, Tt, It, Rt, Dt, zt, Lt, Bt, qt, Ft, Vt, Ht, Wt, Jt, Ut, Kt, Gt, Qt, Yt, Zt, Xt, en, tn, nn, rn, on, an, sn, un, cn, ln, fn, hn, dn, vn, pn, mn, gn, yn, bn, kn, wn, xn, jn, Sn, Cn, _n, $n, On, An, Mn, En, Pn, Nn, Tn, In, Rn, Dn, zn, Ln, Bn, qn, Fn, Vn, Hn, Wn, Jn, Un, Kn, Gn, Qn, Yn, Zn, Xn, er, tr, nr, rr, ir, or, ar, sr, ur, cr, lr, fr, hr, dr, vr, pr, mr, gr, yr, br, kr, wr, xr, jr, Sr, Cr, _r, $r, Or, Ar, Mr, Er, Pr, Nr, Tr, Ir, Rr, Dr, zr, Lr, Br, qr, Fr, Vr, Hr, Wr, Jr, Ur, Kr, Gr, Qr, Yr, Zr, Xr, ei, ti, ni, ri, ii, oi, ai, si, ui, ci, li, fi, hi;
function di(e22) {
  var t2 = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
  return (di = function(e23) {
    if (e23 === null || (n2 = e23, Function.toString.call(n2).indexOf("[native code]") === -1))
      return e23;
    var n2;
    if (typeof e23 != "function")
      throw new TypeError("Super expression must either be null or a function");
    if (t2 !== void 0) {
      if (t2.has(e23))
        return t2.get(e23);
      t2.set(e23, r2);
    }
    function r2() {
      return vi(e23, arguments, Ai(this).constructor);
    }
    return r2.prototype = Object.create(e23.prototype, { constructor: { value: r2, enumerable: false, writable: true, configurable: true } }), Si(r2, e23);
  })(e22);
}
function vi(e22, t2, n2) {
  return (vi = Oi() ? Reflect.construct.bind() : function(e23, t3, n3) {
    var r2 = [null];
    r2.push.apply(r2, t3);
    var i2 = new (Function.bind.apply(e23, r2))();
    return n3 && Si(i2, n3.prototype), i2;
  }).apply(null, arguments);
}
function pi(e22, t2) {
  return t2 || (t2 = e22.slice(0)), Object.freeze(Object.defineProperties(e22, { raw: { value: Object.freeze(t2) } }));
}
function mi() {
  /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */
  mi = function() {
    return e22;
  };
  var e22 = {}, t2 = Object.prototype, n2 = t2.hasOwnProperty, r2 = typeof Symbol == "function" ? Symbol : {}, i2 = r2.iterator || "@@iterator", o2 = r2.asyncIterator || "@@asyncIterator", a2 = r2.toStringTag || "@@toStringTag";
  function s2(e23, t3, n3) {
    return Object.defineProperty(e23, t3, { value: n3, enumerable: true, configurable: true, writable: true }), e23[t3];
  }
  try {
    s2({}, "");
  } catch (e23) {
    s2 = function(e24, t3, n3) {
      return e24[t3] = n3;
    };
  }
  function u2(e23, t3, n3, r3) {
    var i3 = t3 && t3.prototype instanceof f2 ? t3 : f2, o3 = Object.create(i3.prototype), a3 = new j2(r3 || []);
    return o3._invoke = function(e24, t4, n4) {
      var r4 = "suspendedStart";
      return function(i4, o4) {
        if (r4 === "executing")
          throw new Error("Generator is already running");
        if (r4 === "completed") {
          if (i4 === "throw")
            throw o4;
          return C2();
        }
        for (n4.method = i4, n4.arg = o4; ; ) {
          var a4 = n4.delegate;
          if (a4) {
            var s3 = k2(a4, n4);
            if (s3) {
              if (s3 === l2)
                continue;
              return s3;
            }
          }
          if (n4.method === "next")
            n4.sent = n4._sent = n4.arg;
          else if (n4.method === "throw") {
            if (r4 === "suspendedStart")
              throw r4 = "completed", n4.arg;
            n4.dispatchException(n4.arg);
          } else
            n4.method === "return" && n4.abrupt("return", n4.arg);
          r4 = "executing";
          var u3 = c2(e24, t4, n4);
          if (u3.type === "normal") {
            if (r4 = n4.done ? "completed" : "suspendedYield", u3.arg === l2)
              continue;
            return { value: u3.arg, done: n4.done };
          }
          u3.type === "throw" && (r4 = "completed", n4.method = "throw", n4.arg = u3.arg);
        }
      };
    }(e23, n3, a3), o3;
  }
  function c2(e23, t3, n3) {
    try {
      return { type: "normal", arg: e23.call(t3, n3) };
    } catch (e24) {
      return { type: "throw", arg: e24 };
    }
  }
  e22.wrap = u2;
  var l2 = {};
  function f2() {
  }
  function h2() {
  }
  function d2() {
  }
  var v2 = {};
  s2(v2, i2, function() {
    return this;
  });
  var p2 = Object.getPrototypeOf, m2 = p2 && p2(p2(S2([])));
  m2 && m2 !== t2 && n2.call(m2, i2) && (v2 = m2);
  var g2 = d2.prototype = f2.prototype = Object.create(v2);
  function y2(e23) {
    ["next", "throw", "return"].forEach(function(t3) {
      s2(e23, t3, function(e24) {
        return this._invoke(t3, e24);
      });
    });
  }
  function b2(e23, t3) {
    function r3(i4, o3, a3, s3) {
      var u3 = c2(e23[i4], e23, o3);
      if (u3.type !== "throw") {
        var l3 = u3.arg, f3 = l3.value;
        return f3 && Li(f3) == "object" && n2.call(f3, "__await") ? t3.resolve(f3.__await).then(function(e24) {
          r3("next", e24, a3, s3);
        }, function(e24) {
          r3("throw", e24, a3, s3);
        }) : t3.resolve(f3).then(function(e24) {
          l3.value = e24, a3(l3);
        }, function(e24) {
          return r3("throw", e24, a3, s3);
        });
      }
      s3(u3.arg);
    }
    var i3;
    this._invoke = function(e24, n3) {
      function o3() {
        return new t3(function(t4, i4) {
          r3(e24, n3, t4, i4);
        });
      }
      return i3 = i3 ? i3.then(o3, o3) : o3();
    };
  }
  function k2(e23, t3) {
    var n3 = e23.iterator[t3.method];
    if (n3 === void 0) {
      if (t3.delegate = null, t3.method === "throw") {
        if (e23.iterator.return && (t3.method = "return", t3.arg = void 0, k2(e23, t3), t3.method === "throw"))
          return l2;
        t3.method = "throw", t3.arg = new TypeError("The iterator does not provide a 'throw' method");
      }
      return l2;
    }
    var r3 = c2(n3, e23.iterator, t3.arg);
    if (r3.type === "throw")
      return t3.method = "throw", t3.arg = r3.arg, t3.delegate = null, l2;
    var i3 = r3.arg;
    return i3 ? i3.done ? (t3[e23.resultName] = i3.value, t3.next = e23.nextLoc, t3.method !== "return" && (t3.method = "next", t3.arg = void 0), t3.delegate = null, l2) : i3 : (t3.method = "throw", t3.arg = new TypeError("iterator result is not an object"), t3.delegate = null, l2);
  }
  function w2(e23) {
    var t3 = { tryLoc: e23[0] };
    1 in e23 && (t3.catchLoc = e23[1]), 2 in e23 && (t3.finallyLoc = e23[2], t3.afterLoc = e23[3]), this.tryEntries.push(t3);
  }
  function x2(e23) {
    var t3 = e23.completion || {};
    t3.type = "normal", delete t3.arg, e23.completion = t3;
  }
  function j2(e23) {
    this.tryEntries = [{ tryLoc: "root" }], e23.forEach(w2, this), this.reset(true);
  }
  function S2(e23) {
    if (e23) {
      var t3 = e23[i2];
      if (t3)
        return t3.call(e23);
      if (typeof e23.next == "function")
        return e23;
      if (!isNaN(e23.length)) {
        var r3 = -1, o3 = function t4() {
          for (; ++r3 < e23.length; )
            if (n2.call(e23, r3))
              return t4.value = e23[r3], t4.done = false, t4;
          return t4.value = void 0, t4.done = true, t4;
        };
        return o3.next = o3;
      }
    }
    return { next: C2 };
  }
  function C2() {
    return { value: void 0, done: true };
  }
  return h2.prototype = d2, s2(g2, "constructor", d2), s2(d2, "constructor", h2), h2.displayName = s2(d2, a2, "GeneratorFunction"), e22.isGeneratorFunction = function(e23) {
    var t3 = typeof e23 == "function" && e23.constructor;
    return !!t3 && (t3 === h2 || (t3.displayName || t3.name) === "GeneratorFunction");
  }, e22.mark = function(e23) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(e23, d2) : (e23.__proto__ = d2, s2(e23, a2, "GeneratorFunction")), e23.prototype = Object.create(g2), e23;
  }, e22.awrap = function(e23) {
    return { __await: e23 };
  }, y2(b2.prototype), s2(b2.prototype, o2, function() {
    return this;
  }), e22.AsyncIterator = b2, e22.async = function(t3, n3, r3, i3, o3) {
    o3 === void 0 && (o3 = Promise);
    var a3 = new b2(u2(t3, n3, r3, i3), o3);
    return e22.isGeneratorFunction(n3) ? a3 : a3.next().then(function(e23) {
      return e23.done ? e23.value : a3.next();
    });
  }, y2(g2), s2(g2, a2, "Generator"), s2(g2, i2, function() {
    return this;
  }), s2(g2, "toString", function() {
    return "[object Generator]";
  }), e22.keys = function(e23) {
    var t3 = [];
    for (var n3 in e23)
      t3.push(n3);
    return t3.reverse(), function n4() {
      for (; t3.length; ) {
        var r3 = t3.pop();
        if (r3 in e23)
          return n4.value = r3, n4.done = false, n4;
      }
      return n4.done = true, n4;
    };
  }, e22.values = S2, j2.prototype = { constructor: j2, reset: function(e23) {
    if (this.prev = 0, this.next = 0, this.sent = this._sent = void 0, this.done = false, this.delegate = null, this.method = "next", this.arg = void 0, this.tryEntries.forEach(x2), !e23)
      for (var t3 in this)
        t3.charAt(0) === "t" && n2.call(this, t3) && !isNaN(+t3.slice(1)) && (this[t3] = void 0);
  }, stop: function() {
    this.done = true;
    var e23 = this.tryEntries[0].completion;
    if (e23.type === "throw")
      throw e23.arg;
    return this.rval;
  }, dispatchException: function(e23) {
    if (this.done)
      throw e23;
    var t3 = this;
    function r3(n3, r4) {
      return a3.type = "throw", a3.arg = e23, t3.next = n3, r4 && (t3.method = "next", t3.arg = void 0), !!r4;
    }
    for (var i3 = this.tryEntries.length - 1; i3 >= 0; --i3) {
      var o3 = this.tryEntries[i3], a3 = o3.completion;
      if (o3.tryLoc === "root")
        return r3("end");
      if (o3.tryLoc <= this.prev) {
        var s3 = n2.call(o3, "catchLoc"), u3 = n2.call(o3, "finallyLoc");
        if (s3 && u3) {
          if (this.prev < o3.catchLoc)
            return r3(o3.catchLoc, true);
          if (this.prev < o3.finallyLoc)
            return r3(o3.finallyLoc);
        } else if (s3) {
          if (this.prev < o3.catchLoc)
            return r3(o3.catchLoc, true);
        } else {
          if (!u3)
            throw new Error("try statement without catch or finally");
          if (this.prev < o3.finallyLoc)
            return r3(o3.finallyLoc);
        }
      }
    }
  }, abrupt: function(e23, t3) {
    for (var r3 = this.tryEntries.length - 1; r3 >= 0; --r3) {
      var i3 = this.tryEntries[r3];
      if (i3.tryLoc <= this.prev && n2.call(i3, "finallyLoc") && this.prev < i3.finallyLoc) {
        var o3 = i3;
        break;
      }
    }
    o3 && (e23 === "break" || e23 === "continue") && o3.tryLoc <= t3 && t3 <= o3.finallyLoc && (o3 = null);
    var a3 = o3 ? o3.completion : {};
    return a3.type = e23, a3.arg = t3, o3 ? (this.method = "next", this.next = o3.finallyLoc, l2) : this.complete(a3);
  }, complete: function(e23, t3) {
    if (e23.type === "throw")
      throw e23.arg;
    return e23.type === "break" || e23.type === "continue" ? this.next = e23.arg : e23.type === "return" ? (this.rval = this.arg = e23.arg, this.method = "return", this.next = "end") : e23.type === "normal" && t3 && (this.next = t3), l2;
  }, finish: function(e23) {
    for (var t3 = this.tryEntries.length - 1; t3 >= 0; --t3) {
      var n3 = this.tryEntries[t3];
      if (n3.finallyLoc === e23)
        return this.complete(n3.completion, n3.afterLoc), x2(n3), l2;
    }
  }, catch: function(e23) {
    for (var t3 = this.tryEntries.length - 1; t3 >= 0; --t3) {
      var n3 = this.tryEntries[t3];
      if (n3.tryLoc === e23) {
        var r3 = n3.completion;
        if (r3.type === "throw") {
          var i3 = r3.arg;
          x2(n3);
        }
        return i3;
      }
    }
    throw new Error("illegal catch attempt");
  }, delegateYield: function(e23, t3, n3) {
    return this.delegate = { iterator: S2(e23), resultName: t3, nextLoc: n3 }, this.method === "next" && (this.arg = void 0), l2;
  } }, e22;
}
function gi(e22, t2, n2, r2, i2, o2, a2) {
  try {
    var s2 = e22[o2](a2), u2 = s2.value;
  } catch (e23) {
    return void n2(e23);
  }
  s2.done ? t2(u2) : Promise.resolve(u2).then(r2, i2);
}
function yi(e22) {
  return function() {
    var t2 = this, n2 = arguments;
    return new Promise(function(r2, i2) {
      var o2 = e22.apply(t2, n2);
      function a2(e23) {
        gi(o2, r2, i2, a2, s2, "next", e23);
      }
      function s2(e23) {
        gi(o2, r2, i2, a2, s2, "throw", e23);
      }
      a2(void 0);
    });
  };
}
function bi(e22, t2) {
  var n2 = typeof Symbol != "undefined" && e22[Symbol.iterator] || e22["@@iterator"];
  if (!n2) {
    if (Array.isArray(e22) || (n2 = Ti(e22)) || t2 && e22 && typeof e22.length == "number") {
      n2 && (e22 = n2);
      var r2 = 0, i2 = function() {
      };
      return { s: i2, n: function() {
        return r2 >= e22.length ? { done: true } : { done: false, value: e22[r2++] };
      }, e: function(e23) {
        throw e23;
      }, f: i2 };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var o2, a2 = true, s2 = false;
  return { s: function() {
    n2 = n2.call(e22);
  }, n: function() {
    var e23 = n2.next();
    return a2 = e23.done, e23;
  }, e: function(e23) {
    s2 = true, o2 = e23;
  }, f: function() {
    try {
      a2 || n2.return == null || n2.return();
    } finally {
      if (s2)
        throw o2;
    }
  } };
}
function ki() {
  return (ki = typeof Reflect != "undefined" && Reflect.get ? Reflect.get.bind() : function(e22, t2, n2) {
    var r2 = wi(e22, t2);
    if (r2) {
      var i2 = Object.getOwnPropertyDescriptor(r2, t2);
      return i2.get ? i2.get.call(arguments.length < 3 ? e22 : n2) : i2.value;
    }
  }).apply(this, arguments);
}
function wi(e22, t2) {
  for (; !Object.prototype.hasOwnProperty.call(e22, t2) && (e22 = Ai(e22)) !== null; )
    ;
  return e22;
}
function xi(e22, t2) {
  return function(e23) {
    if (Array.isArray(e23))
      return e23;
  }(e22) || function(e23, t3) {
    var n2 = e23 == null ? null : typeof Symbol != "undefined" && e23[Symbol.iterator] || e23["@@iterator"];
    if (n2 == null)
      return;
    var r2, i2, o2 = [], a2 = true, s2 = false;
    try {
      for (n2 = n2.call(e23); !(a2 = (r2 = n2.next()).done) && (o2.push(r2.value), !t3 || o2.length !== t3); a2 = true)
        ;
    } catch (e24) {
      s2 = true, i2 = e24;
    } finally {
      try {
        a2 || n2.return == null || n2.return();
      } finally {
        if (s2)
          throw i2;
      }
    }
    return o2;
  }(e22, t2) || Ti(e22, t2) || function() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }();
}
function ji(e22, t2) {
  if (typeof t2 != "function" && t2 !== null)
    throw new TypeError("Super expression must either be null or a function");
  e22.prototype = Object.create(t2 && t2.prototype, { constructor: { value: e22, writable: true, configurable: true } }), Object.defineProperty(e22, "prototype", { writable: false }), t2 && Si(e22, t2);
}
function Si(e22, t2) {
  return (Si = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(e23, t3) {
    return e23.__proto__ = t3, e23;
  })(e22, t2);
}
function Ci(e22) {
  var t2 = Oi();
  return function() {
    var n2, r2 = Ai(e22);
    if (t2) {
      var i2 = Ai(this).constructor;
      n2 = Reflect.construct(r2, arguments, i2);
    } else
      n2 = r2.apply(this, arguments);
    return _i(this, n2);
  };
}
function _i(e22, t2) {
  if (t2 && (Li(t2) === "object" || typeof t2 == "function"))
    return t2;
  if (t2 !== void 0)
    throw new TypeError("Derived constructors may only return object or undefined");
  return $i(e22);
}
function $i(e22) {
  if (e22 === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e22;
}
function Oi() {
  if (typeof Reflect == "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy == "function")
    return true;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), true;
  } catch (e22) {
    return false;
  }
}
function Ai(e22) {
  return (Ai = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function(e23) {
    return e23.__proto__ || Object.getPrototypeOf(e23);
  })(e22);
}
function Mi(e22, t2) {
  var n2 = Object.keys(e22);
  if (Object.getOwnPropertySymbols) {
    var r2 = Object.getOwnPropertySymbols(e22);
    t2 && (r2 = r2.filter(function(t3) {
      return Object.getOwnPropertyDescriptor(e22, t3).enumerable;
    })), n2.push.apply(n2, r2);
  }
  return n2;
}
function Ei(e22) {
  for (var t2 = 1; t2 < arguments.length; t2++) {
    var n2 = arguments[t2] != null ? arguments[t2] : {};
    t2 % 2 ? Mi(Object(n2), true).forEach(function(t3) {
      Pi(e22, t3, n2[t3]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e22, Object.getOwnPropertyDescriptors(n2)) : Mi(Object(n2)).forEach(function(t3) {
      Object.defineProperty(e22, t3, Object.getOwnPropertyDescriptor(n2, t3));
    });
  }
  return e22;
}
function Pi(e22, t2, n2) {
  return t2 in e22 ? Object.defineProperty(e22, t2, { value: n2, enumerable: true, configurable: true, writable: true }) : e22[t2] = n2, e22;
}
function Ni(e22) {
  return function(e23) {
    if (Array.isArray(e23))
      return Ii(e23);
  }(e22) || function(e23) {
    if (typeof Symbol != "undefined" && e23[Symbol.iterator] != null || e23["@@iterator"] != null)
      return Array.from(e23);
  }(e22) || Ti(e22) || function() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }();
}
function Ti(e22, t2) {
  if (e22) {
    if (typeof e22 == "string")
      return Ii(e22, t2);
    var n2 = Object.prototype.toString.call(e22).slice(8, -1);
    return n2 === "Object" && e22.constructor && (n2 = e22.constructor.name), n2 === "Map" || n2 === "Set" ? Array.from(e22) : n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2) ? Ii(e22, t2) : void 0;
  }
}
function Ii(e22, t2) {
  (t2 == null || t2 > e22.length) && (t2 = e22.length);
  for (var n2 = 0, r2 = new Array(t2); n2 < t2; n2++)
    r2[n2] = e22[n2];
  return r2;
}
function Ri(e22, t2) {
  if (!(e22 instanceof t2))
    throw new TypeError("Cannot call a class as a function");
}
function Di(e22, t2) {
  for (var n2 = 0; n2 < t2.length; n2++) {
    var r2 = t2[n2];
    r2.enumerable = r2.enumerable || false, r2.configurable = true, "value" in r2 && (r2.writable = true), Object.defineProperty(e22, r2.key, r2);
  }
}
function zi(e22, t2, n2) {
  return t2 && Di(e22.prototype, t2), n2 && Di(e22, n2), Object.defineProperty(e22, "prototype", { writable: false }), e22;
}
function Li(e22) {
  return (Li = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e23) {
    return typeof e23;
  } : function(e23) {
    return e23 && typeof Symbol == "function" && e23.constructor === Symbol && e23 !== Symbol.prototype ? "symbol" : typeof e23;
  })(e22);
}
function Bi() {
}
var qi = function(e22) {
  return e22;
};
function Fi(e22, t2) {
  for (var n2 in t2)
    e22[n2] = t2[n2];
  return e22;
}
function Vi(e22) {
  return e22();
}
function Hi() {
  return /* @__PURE__ */ Object.create(null);
}
function Wi(e22) {
  e22.forEach(Vi);
}
function Ji(e22) {
  return typeof e22 == "function";
}
function Ui(e22, t2) {
  return e22 != e22 ? t2 == t2 : e22 !== t2 || e22 && Li(e22) === "object" || typeof e22 == "function";
}
function Ki(e22, t2) {
  return e22 != e22 ? t2 == t2 : e22 !== t2;
}
function Gi(e22, t2, n2, r2) {
  if (e22) {
    var i2 = Qi(e22, t2, n2, r2);
    return e22[0](i2);
  }
}
function Qi(e22, t2, n2, r2) {
  return e22[1] && r2 ? Fi(n2.ctx.slice(), e22[1](r2(t2))) : n2.ctx;
}
function Yi(e22, t2, n2, r2) {
  if (e22[2] && r2) {
    var i2 = e22[2](r2(n2));
    if (t2.dirty === void 0)
      return i2;
    if (Li(i2) === "object") {
      for (var o2 = [], a2 = Math.max(t2.dirty.length, i2.length), s2 = 0; s2 < a2; s2 += 1)
        o2[s2] = t2.dirty[s2] | i2[s2];
      return o2;
    }
    return t2.dirty | i2;
  }
  return t2.dirty;
}
function Zi(e22, t2, n2, r2, i2, o2) {
  if (i2) {
    var a2 = Qi(t2, n2, r2, o2);
    e22.p(a2, i2);
  }
}
function Xi(e22) {
  if (e22.ctx.length > 32) {
    for (var t2 = [], n2 = e22.ctx.length / 32, r2 = 0; r2 < n2; r2++)
      t2[r2] = -1;
    return t2;
  }
  return -1;
}
function eo(e22) {
  return e22 == null ? "" : e22;
}
function to(e22) {
  return e22 && Ji(e22.destroy) ? e22.destroy : Bi;
}
var no, ro = typeof window != "undefined", io = ro ? function() {
  return window.performance.now();
} : function() {
  return Date.now();
}, oo = ro ? function(e22) {
  return requestAnimationFrame(e22);
} : Bi, ao = /* @__PURE__ */ new Set();
function so(e22) {
  ao.forEach(function(t2) {
    t2.c(e22) || (ao.delete(t2), t2.f());
  }), ao.size !== 0 && oo(so);
}
function uo(e22, t2) {
  e22.appendChild(t2);
}
function co(e22, t2, n2) {
  var r2 = lo(e22);
  if (!r2.getElementById(t2)) {
    var i2 = go("style");
    i2.id = t2, i2.textContent = n2, ho(r2, i2);
  }
}
function lo(e22) {
  if (!e22)
    return document;
  var t2 = e22.getRootNode ? e22.getRootNode() : e22.ownerDocument;
  return t2 && t2.host ? t2 : e22.ownerDocument;
}
function fo(e22) {
  var t2 = go("style");
  return ho(lo(e22), t2), t2.sheet;
}
function ho(e22, t2) {
  uo(e22.head || e22, t2);
}
function vo(e22, t2, n2) {
  e22.insertBefore(t2, n2 || null);
}
function po(e22) {
  e22.parentNode.removeChild(e22);
}
function mo(e22, t2) {
  for (var n2 = 0; n2 < e22.length; n2 += 1)
    e22[n2] && e22[n2].d(t2);
}
function go(e22) {
  return document.createElement(e22);
}
function yo(e22) {
  return document.createElementNS("http://www.w3.org/2000/svg", e22);
}
function bo(e22) {
  return document.createTextNode(e22);
}
function ko() {
  return bo(" ");
}
function wo() {
  return bo("");
}
function xo(e22, t2, n2, r2) {
  return e22.addEventListener(t2, n2, r2), function() {
    return e22.removeEventListener(t2, n2, r2);
  };
}
function jo(e22) {
  return function(t2) {
    return t2.stopPropagation(), e22.call(this, t2);
  };
}
function So(e22, t2, n2) {
  n2 == null ? e22.removeAttribute(t2) : e22.getAttribute(t2) !== n2 && e22.setAttribute(t2, n2);
}
function Co(e22, t2) {
  var n2 = Object.getOwnPropertyDescriptors(e22.__proto__);
  for (var r2 in t2)
    t2[r2] == null ? e22.removeAttribute(r2) : r2 === "style" ? e22.style.cssText = t2[r2] : r2 === "__value" ? e22.value = e22[r2] = t2[r2] : n2[r2] && n2[r2].set ? e22[r2] = t2[r2] : So(e22, r2, t2[r2]);
}
function _o(e22, t2) {
  for (var n2 in t2)
    So(e22, n2, t2[n2]);
}
function $o(e22, t2, n2) {
  t2 in e22 ? e22[t2] = typeof e22[t2] == "boolean" && n2 === "" || n2 : So(e22, t2, n2);
}
function Oo(e22) {
  return Array.from(e22.childNodes);
}
function Ao(e22, t2) {
  t2 = "" + t2, e22.wholeText !== t2 && (e22.data = t2);
}
function Mo(e22, t2) {
  e22.value = t2 == null ? "" : t2;
}
function Eo(e22, t2, n2, r2) {
  n2 === null ? e22.style.removeProperty(t2) : e22.style.setProperty(t2, n2, r2 ? "important" : "");
}
function Po(e22, t2) {
  for (var n2 = 0; n2 < e22.options.length; n2 += 1) {
    var r2 = e22.options[n2];
    if (r2.__value === t2)
      return void (r2.selected = true);
  }
  e22.selectedIndex = -1;
}
function No() {
  if (no === void 0) {
    no = false;
    try {
      typeof window != "undefined" && window.parent && window.parent.document;
    } catch (e22) {
      no = true;
    }
  }
  return no;
}
function To(e22, t2, n2) {
  e22.classList[n2 ? "add" : "remove"](t2);
}
function Io(e22, t2) {
  var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, r2 = n2.bubbles, i2 = r2 !== void 0 && r2, o2 = n2.cancelable, a2 = o2 !== void 0 && o2, s2 = document.createEvent("CustomEvent");
  return s2.initCustomEvent(e22, i2, a2, t2), s2;
}
var Ro, Do = function() {
  function e22() {
    var t2 = arguments.length > 0 && arguments[0] !== void 0 && arguments[0];
    Ri(this, e22), this.is_svg = false, this.is_svg = t2, this.e = this.n = null;
  }
  return zi(e22, [{ key: "c", value: function(e23) {
    this.h(e23);
  } }, { key: "m", value: function(e23, t2) {
    var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    this.e || (this.is_svg ? this.e = yo(t2.nodeName) : this.e = go(t2.nodeName), this.t = t2, this.c(e23)), this.i(n2);
  } }, { key: "h", value: function(e23) {
    this.e.innerHTML = e23, this.n = Array.from(this.e.childNodes);
  } }, { key: "i", value: function(e23) {
    for (var t2 = 0; t2 < this.n.length; t2 += 1)
      vo(this.t, this.n[t2], e23);
  } }, { key: "p", value: function(e23) {
    this.d(), this.h(e23), this.i(this.a);
  } }, { key: "d", value: function() {
    this.n.forEach(po);
  } }]), e22;
}(), zo = /* @__PURE__ */ new Map(), Lo = 0;
function Bo(e22) {
  for (var t2 = 5381, n2 = e22.length; n2--; )
    t2 = (t2 << 5) - t2 ^ e22.charCodeAt(n2);
  return t2 >>> 0;
}
function qo(e22, t2) {
  var n2 = { stylesheet: fo(t2), rules: {} };
  return zo.set(e22, n2), n2;
}
function Fo(e22, t2, n2, r2, i2, o2, a2) {
  for (var s2 = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : 0, u2 = 16.666 / r2, c2 = "{\n", l2 = 0; l2 <= 1; l2 += u2) {
    var f2 = t2 + (n2 - t2) * o2(l2);
    c2 += 100 * l2 + "%{".concat(a2(f2, 1 - f2), "}\n");
  }
  var h2 = c2 + "100% {".concat(a2(n2, 1 - n2), "}\n}"), d2 = "__svelte_".concat(Bo(h2), "_").concat(s2), v2 = lo(e22), p2 = zo.get(v2) || qo(v2, e22), m2 = p2.stylesheet, g2 = p2.rules;
  g2[d2] || (g2[d2] = true, m2.insertRule("@keyframes ".concat(d2, " ").concat(h2), m2.cssRules.length));
  var y2 = e22.style.animation || "";
  return e22.style.animation = "".concat(y2 ? "".concat(y2, ", ") : "").concat(d2, " ").concat(r2, "ms linear ").concat(i2, "ms 1 both"), Lo += 1, d2;
}
function Vo(e22, t2) {
  var n2 = (e22.style.animation || "").split(", "), r2 = n2.filter(t2 ? function(e23) {
    return e23.indexOf(t2) < 0;
  } : function(e23) {
    return e23.indexOf("__svelte") === -1;
  }), i2 = n2.length - r2.length;
  i2 && (e22.style.animation = r2.join(", "), (Lo -= i2) || oo(function() {
    Lo || (zo.forEach(function(e23) {
      for (var t3 = e23.stylesheet, n3 = t3.cssRules.length; n3--; )
        t3.deleteRule(n3);
      e23.rules = {};
    }), zo.clear());
  }));
}
function Ho(e22) {
  Ro = e22;
}
function Wo() {
  if (!Ro)
    throw new Error("Function called outside component initialization");
  return Ro;
}
function Jo(e22) {
  Wo().$$.before_update.push(e22);
}
function Uo(e22) {
  Wo().$$.on_mount.push(e22);
}
function Ko(e22) {
  Wo().$$.on_destroy.push(e22);
}
function Go() {
  var e22 = Wo();
  return function(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, i2 = r2.cancelable, o2 = i2 !== void 0 && i2, a2 = e22.$$.callbacks[t2];
    if (a2) {
      var s2 = Io(t2, n2, { cancelable: o2 });
      return a2.slice().forEach(function(t3) {
        t3.call(e22, s2);
      }), !s2.defaultPrevented;
    }
    return true;
  };
}
function Qo(e22, t2) {
  return Wo().$$.context.set(e22, t2), t2;
}
function Yo(e22) {
  return Wo().$$.context.get(e22);
}
var Zo = [], Xo = [], ea = [], ta = [], na = Promise.resolve(), ra = false;
function ia() {
  ra || (ra = true, na.then(fa));
}
function oa() {
  return ia(), na;
}
function aa(e22) {
  ea.push(e22);
}
function sa(e22) {
  ta.push(e22);
}
var ua, ca = /* @__PURE__ */ new Set(), la = 0;
function fa() {
  var e22 = Ro;
  do {
    for (; la < Zo.length; ) {
      var t2 = Zo[la];
      la++, Ho(t2), ha(t2.$$);
    }
    for (Ho(null), Zo.length = 0, la = 0; Xo.length; )
      Xo.pop()();
    for (var n2 = 0; n2 < ea.length; n2 += 1) {
      var r2 = ea[n2];
      ca.has(r2) || (ca.add(r2), r2());
    }
    ea.length = 0;
  } while (Zo.length);
  for (; ta.length; )
    ta.pop()();
  ra = false, ca.clear(), Ho(e22);
}
function ha(e22) {
  if (e22.fragment !== null) {
    e22.update(), Wi(e22.before_update);
    var t2 = e22.dirty;
    e22.dirty = [-1], e22.fragment && e22.fragment.p(e22.ctx, t2), e22.after_update.forEach(aa);
  }
}
function da(e22, t2, n2) {
  e22.dispatchEvent(Io("".concat(t2 ? "intro" : "outro").concat(n2)));
}
var va, pa = /* @__PURE__ */ new Set();
function ma() {
  va = { r: 0, c: [], p: va };
}
function ga() {
  va.r || Wi(va.c), va = va.p;
}
function ya(e22, t2) {
  e22 && e22.i && (pa.delete(e22), e22.i(t2));
}
function ba(e22, t2, n2, r2) {
  if (e22 && e22.o) {
    if (pa.has(e22))
      return;
    pa.add(e22), va.c.push(function() {
      pa.delete(e22), r2 && (n2 && e22.d(1), r2());
    }), e22.o(t2);
  }
}
var ka = { duration: 0 };
function wa(e22, t2, n2, r2) {
  var i2 = t2(e22, n2), o2 = r2 ? 0 : 1, a2 = null, s2 = null, u2 = null;
  function c2() {
    u2 && Vo(e22, u2);
  }
  function l2(e23, t3) {
    var n3 = e23.b - o2;
    return t3 *= Math.abs(n3), { a: o2, b: e23.b, d: n3, duration: t3, start: e23.start, end: e23.start + t3, group: e23.group };
  }
  function f2(t3) {
    var n3, r3 = i2 || ka, f3 = r3.delay, h2 = f3 === void 0 ? 0 : f3, d2 = r3.duration, v2 = d2 === void 0 ? 300 : d2, p2 = r3.easing, m2 = p2 === void 0 ? qi : p2, g2 = r3.tick, y2 = g2 === void 0 ? Bi : g2, b2 = r3.css, k2 = { start: io() + h2, b: t3 };
    t3 || (k2.group = va, va.r += 1), a2 || s2 ? s2 = k2 : (b2 && (c2(), u2 = Fo(e22, o2, t3, v2, h2, m2, b2)), t3 && y2(0, 1), a2 = l2(k2, v2), aa(function() {
      return da(e22, t3, "start");
    }), n3 = function(t4) {
      if (s2 && t4 > s2.start && (a2 = l2(s2, v2), s2 = null, da(e22, a2.b, "start"), b2 && (c2(), u2 = Fo(e22, o2, a2.b, a2.duration, 0, m2, i2.css))), a2) {
        if (t4 >= a2.end)
          y2(o2 = a2.b, 1 - o2), da(e22, a2.b, "end"), s2 || (a2.b ? c2() : --a2.group.r || Wi(a2.group.c)), a2 = null;
        else if (t4 >= a2.start) {
          var n4 = t4 - a2.start;
          o2 = a2.a + a2.d * m2(n4 / a2.duration), y2(o2, 1 - o2);
        }
      }
      return !(!a2 && !s2);
    }, ao.size === 0 && oo(so), new Promise(function(e23) {
      ao.add({ c: n3, f: e23 });
    }));
  }
  return { run: function(e23) {
    Ji(i2) ? (ua || (ua = Promise.resolve()).then(function() {
      ua = null;
    }), ua).then(function() {
      i2 = i2(), f2(e23);
    }) : f2(e23);
  }, end: function() {
    c2(), a2 = s2 = null;
  } };
}
var xa = typeof window != "undefined" ? window : typeof globalThis != "undefined" ? globalThis : global;
function ja(e22, t2) {
  e22.d(1), t2.delete(e22.key);
}
function Sa(e22, t2) {
  ba(e22, 1, 1, function() {
    t2.delete(e22.key);
  });
}
function Ca(e22, t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2) {
  for (var h2 = e22.length, d2 = o2.length, v2 = h2, p2 = {}; v2--; )
    p2[e22[v2].key] = v2;
  var m2 = [], g2 = /* @__PURE__ */ new Map(), y2 = /* @__PURE__ */ new Map();
  for (v2 = d2; v2--; ) {
    var b2 = f2(i2, o2, v2), k2 = n2(b2), w2 = a2.get(k2);
    w2 ? r2 && w2.p(b2, t2) : (w2 = c2(k2, b2)).c(), g2.set(k2, m2[v2] = w2), k2 in p2 && y2.set(k2, Math.abs(v2 - p2[k2]));
  }
  var x2 = /* @__PURE__ */ new Set(), j2 = /* @__PURE__ */ new Set();
  function S2(e23) {
    ya(e23, 1), e23.m(s2, l2), a2.set(e23.key, e23), l2 = e23.first, d2--;
  }
  for (; h2 && d2; ) {
    var C2 = m2[d2 - 1], _2 = e22[h2 - 1], $2 = C2.key, O2 = _2.key;
    C2 === _2 ? (l2 = C2.first, h2--, d2--) : g2.has(O2) ? !a2.has($2) || x2.has($2) ? S2(C2) : j2.has(O2) ? h2-- : y2.get($2) > y2.get(O2) ? (j2.add($2), S2(C2)) : (x2.add(O2), h2--) : (u2(_2, a2), h2--);
  }
  for (; h2--; ) {
    var A2 = e22[h2];
    g2.has(A2.key) || u2(A2, a2);
  }
  for (; d2; )
    S2(m2[d2 - 1]);
  return m2;
}
function _a(e22, t2) {
  for (var n2 = {}, r2 = {}, i2 = { $$scope: 1 }, o2 = e22.length; o2--; ) {
    var a2 = e22[o2], s2 = t2[o2];
    if (s2) {
      for (var u2 in a2)
        u2 in s2 || (r2[u2] = 1);
      for (var c2 in s2)
        i2[c2] || (n2[c2] = s2[c2], i2[c2] = 1);
      e22[o2] = s2;
    } else
      for (var l2 in a2)
        i2[l2] = 1;
  }
  for (var f2 in r2)
    f2 in n2 || (n2[f2] = void 0);
  return n2;
}
function $a(e22) {
  return Li(e22) === "object" && e22 !== null ? e22 : {};
}
function Oa(e22, t2, n2) {
  var r2 = e22.$$.props[t2];
  r2 !== void 0 && (e22.$$.bound[r2] = n2, n2(e22.$$.ctx[r2]));
}
function Aa(e22) {
  e22 && e22.c();
}
function Ma(e22, t2, n2, r2) {
  var i2 = e22.$$, o2 = i2.fragment, a2 = i2.on_mount, s2 = i2.on_destroy, u2 = i2.after_update;
  o2 && o2.m(t2, n2), r2 || aa(function() {
    var t3 = a2.map(Vi).filter(Ji);
    s2 ? s2.push.apply(s2, Ni(t3)) : Wi(t3), e22.$$.on_mount = [];
  }), u2.forEach(aa);
}
function Ea(e22, t2) {
  var n2 = e22.$$;
  n2.fragment !== null && (Wi(n2.on_destroy), n2.fragment && n2.fragment.d(t2), n2.on_destroy = n2.fragment = null, n2.ctx = []);
}
function Pa(e22, t2) {
  e22.$$.dirty[0] === -1 && (Zo.push(e22), ia(), e22.$$.dirty.fill(0)), e22.$$.dirty[t2 / 31 | 0] |= 1 << t2 % 31;
}
function Na(e22, t2, n2, r2, i2, o2, a2) {
  var s2 = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : [-1], u2 = Ro;
  Ho(e22);
  var c2 = e22.$$ = { fragment: null, ctx: null, props: o2, update: Bi, not_equal: i2, bound: Hi(), on_mount: [], on_destroy: [], on_disconnect: [], before_update: [], after_update: [], context: new Map(t2.context || (u2 ? u2.$$.context : [])), callbacks: Hi(), dirty: s2, skip_bound: false, root: t2.target || u2.$$.root };
  a2 && a2(c2.root);
  var l2 = false;
  if (c2.ctx = n2 ? n2(e22, t2.props || {}, function(t3, n3) {
    var r3 = !(arguments.length <= 2) && arguments.length - 2 ? arguments.length <= 2 ? void 0 : arguments[2] : n3;
    return c2.ctx && i2(c2.ctx[t3], c2.ctx[t3] = r3) && (!c2.skip_bound && c2.bound[t3] && c2.bound[t3](r3), l2 && Pa(e22, t3)), n3;
  }) : [], c2.update(), l2 = true, Wi(c2.before_update), c2.fragment = !!r2 && r2(c2.ctx), t2.target) {
    if (t2.hydrate) {
      var f2 = Oo(t2.target);
      c2.fragment && c2.fragment.l(f2), f2.forEach(po);
    } else
      c2.fragment && c2.fragment.c();
    t2.intro && ya(e22.$$.fragment), Ma(e22, t2.target, t2.anchor, t2.customElement), fa();
  }
  Ho(u2);
}
var Ta = function() {
  function e22() {
    Ri(this, e22);
  }
  return zi(e22, [{ key: "$destroy", value: function() {
    Ea(this, 1), this.$destroy = Bi;
  } }, { key: "$on", value: function(e23, t2) {
    var n2 = this.$$.callbacks[e23] || (this.$$.callbacks[e23] = []);
    return n2.push(t2), function() {
      var e24 = n2.indexOf(t2);
      e24 !== -1 && n2.splice(e24, 1);
    };
  } }, { key: "$set", value: function(e23) {
    var t2;
    this.$$set && (t2 = e23, Object.keys(t2).length !== 0) && (this.$$.skip_bound = true, this.$$set(e23), this.$$.skip_bound = false);
  } }]), e22;
}();
function Ia(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : !!Da("debug");
  if (t2) {
    var n2 = za(e22);
    return function() {
      for (var t3, r2 = arguments.length, i2 = new Array(r2), o2 = 0; o2 < r2; o2++)
        i2[o2] = arguments[o2];
      (t3 = console).log.apply(t3, ["%c".concat(e22), "color:".concat(n2)].concat(i2));
    };
  }
  return Ra;
}
function Ra() {
}
function Da(e22) {
  try {
    if (typeof window != "undefined" && window.localStorage !== void 0)
      return window.localStorage[e22];
  } catch (e23) {
  }
}
function za(e22) {
  for (var t2 = 0, n2 = 0; n2 < e22.length; n2++)
    t2 = (t2 << 5) - t2 + e22.charCodeAt(n2), t2 |= 0;
  return La[Math.abs(t2) % La.length];
}
var La = ["#0000CC", "#0099FF", "#009400", "#8dd200", "#CCCC00", "#CC9933", "#ae04e7", "#ff35d7", "#FF3333", "#FF6600", "#FF9933", "#FFCC33"];
function Ba(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n2 = t2.delay, r2 = n2 === void 0 ? 0 : n2, i2 = t2.duration, o2 = i2 === void 0 ? 400 : i2, a2 = t2.easing, s2 = a2 === void 0 ? qi : a2, u2 = +getComputedStyle(e22).opacity;
  return { delay: r2, duration: o2, easing: s2, css: function(e23) {
    return "opacity: ".concat(e23 * u2);
  } };
}
var qa = xa.window;
function Fa(e22) {
  co(e22, "svelte-g4wg3a", ".svelte-g4wg3a{box-sizing:border-box}.bg.svelte-g4wg3a{position:fixed;z-index:1000;top:0;left:0;display:flex;flex-direction:column;justify-content:center;width:100vw;height:100vh;background:rgba(0, 0, 0, 0.66)}.wrap.svelte-g4wg3a{position:relative;margin:2rem;max-height:100%}.window.svelte-g4wg3a{position:relative;width:40rem;max-width:100%;max-height:100%;margin:2rem auto;color:black;border-radius:0.5rem;background:white}.content.svelte-g4wg3a{position:relative;padding:1rem;max-height:calc(100vh - 4rem);overflow:auto}.close.svelte-g4wg3a{display:block;box-sizing:border-box;position:absolute;z-index:1000;top:1rem;right:1rem;margin:0;padding:0;width:1.5rem;height:1.5rem;border:0;color:black;border-radius:1.5rem;background:white;box-shadow:0 0 0 1px black;transition:transform 0.2s cubic-bezier(0.25, 0.1, 0.25, 1),\n      background 0.2s cubic-bezier(0.25, 0.1, 0.25, 1);-webkit-appearance:none}.close.svelte-g4wg3a:before,.close.svelte-g4wg3a:after{content:'';display:block;box-sizing:border-box;position:absolute;top:50%;width:1rem;height:1px;background:black;transform-origin:center;transition:height 0.2s cubic-bezier(0.25, 0.1, 0.25, 1),\n      background 0.2s cubic-bezier(0.25, 0.1, 0.25, 1)}.close.svelte-g4wg3a:before{-webkit-transform:translate(0, -50%) rotate(45deg);-moz-transform:translate(0, -50%) rotate(45deg);transform:translate(0, -50%) rotate(45deg);left:0.25rem}.close.svelte-g4wg3a:after{-webkit-transform:translate(0, -50%) rotate(-45deg);-moz-transform:translate(0, -50%) rotate(-45deg);transform:translate(0, -50%) rotate(-45deg);left:0.25rem}.close.svelte-g4wg3a:hover{background:black}.close.svelte-g4wg3a:hover:before,.close.svelte-g4wg3a:hover:after{height:2px;background:white}.close.svelte-g4wg3a:focus{border-color:#3399ff;box-shadow:0 0 0 2px #3399ff}.close.svelte-g4wg3a:active{transform:scale(0.9)}.close.svelte-g4wg3a:hover,.close.svelte-g4wg3a:focus,.close.svelte-g4wg3a:active{outline:none}");
}
function Va(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2 = e22[1].closeButton && Ha(e22), b2 = e22[2];
  return b2 && (a2 = new b2({})), { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = go("div"), y2 && y2.c(), i2 = ko(), o2 = go("div"), a2 && Aa(a2.$$.fragment), So(o2, "class", s2 = eo(e22[1].classContent) + " svelte-g4wg3a"), So(o2, "style", e22[9]), To(o2, "content", !e22[0]), So(r2, "class", u2 = eo(e22[1].classWindow) + " svelte-g4wg3a"), So(r2, "role", "dialog"), So(r2, "aria-modal", "true"), So(r2, "aria-label", c2 = e22[1].ariaLabelledBy ? null : e22[1].ariaLabel || null), So(r2, "aria-labelledby", l2 = e22[1].ariaLabelledBy || null), So(r2, "style", e22[8]), To(r2, "window", !e22[0]), So(n2, "class", h2 = eo(e22[1].classWindowWrap) + " svelte-g4wg3a"), So(n2, "style", e22[7]), To(n2, "wrap", !e22[0]), So(t2, "class", d2 = eo(e22[1].classBg) + " svelte-g4wg3a"), So(t2, "style", e22[6]), To(t2, "bg", !e22[0]);
  }, m: function(s3, u3) {
    vo(s3, t2, u3), uo(t2, n2), uo(n2, r2), y2 && y2.m(r2, null), uo(r2, i2), uo(r2, o2), a2 && Ma(a2, o2, null), e22[49](r2), e22[50](n2), e22[51](t2), p2 = true, m2 || (g2 = [xo(r2, "introstart", function() {
      Ji(e22[13]) && e22[13].apply(this, arguments);
    }), xo(r2, "outrostart", function() {
      Ji(e22[14]) && e22[14].apply(this, arguments);
    }), xo(r2, "introend", function() {
      Ji(e22[15]) && e22[15].apply(this, arguments);
    }), xo(r2, "outroend", function() {
      Ji(e22[16]) && e22[16].apply(this, arguments);
    }), xo(t2, "mousedown", e22[20]), xo(t2, "mouseup", e22[21])], m2 = true);
  }, p: function(f3, v3) {
    if ((e22 = f3)[1].closeButton ? y2 ? (y2.p(e22, v3), 2 & v3[0] && ya(y2, 1)) : ((y2 = Ha(e22)).c(), ya(y2, 1), y2.m(r2, i2)) : y2 && (ma(), ba(y2, 1, 1, function() {
      y2 = null;
    }), ga()), b2 !== (b2 = e22[2])) {
      if (a2) {
        ma();
        var m3 = a2;
        ba(m3.$$.fragment, 1, 0, function() {
          Ea(m3, 1);
        }), ga();
      }
      b2 ? (Aa((a2 = new b2({})).$$.fragment), ya(a2.$$.fragment, 1), Ma(a2, o2, null)) : a2 = null;
    }
    (!p2 || 2 & v3[0] && s2 !== (s2 = eo(e22[1].classContent) + " svelte-g4wg3a")) && So(o2, "class", s2), (!p2 || 512 & v3[0]) && So(o2, "style", e22[9]), 3 & v3[0] && To(o2, "content", !e22[0]), (!p2 || 2 & v3[0] && u2 !== (u2 = eo(e22[1].classWindow) + " svelte-g4wg3a")) && So(r2, "class", u2), (!p2 || 2 & v3[0] && c2 !== (c2 = e22[1].ariaLabelledBy ? null : e22[1].ariaLabel || null)) && So(r2, "aria-label", c2), (!p2 || 2 & v3[0] && l2 !== (l2 = e22[1].ariaLabelledBy || null)) && So(r2, "aria-labelledby", l2), (!p2 || 256 & v3[0]) && So(r2, "style", e22[8]), 3 & v3[0] && To(r2, "window", !e22[0]), (!p2 || 2 & v3[0] && h2 !== (h2 = eo(e22[1].classWindowWrap) + " svelte-g4wg3a")) && So(n2, "class", h2), (!p2 || 128 & v3[0]) && So(n2, "style", e22[7]), 3 & v3[0] && To(n2, "wrap", !e22[0]), (!p2 || 2 & v3[0] && d2 !== (d2 = eo(e22[1].classBg) + " svelte-g4wg3a")) && So(t2, "class", d2), (!p2 || 64 & v3[0]) && So(t2, "style", e22[6]), 3 & v3[0] && To(t2, "bg", !e22[0]);
  }, i: function(n3) {
    p2 || (ya(y2), a2 && ya(a2.$$.fragment, n3), aa(function() {
      f2 || (f2 = wa(r2, e22[12], e22[1].transitionWindowProps, true)), f2.run(1);
    }), aa(function() {
      v2 || (v2 = wa(t2, e22[11], e22[1].transitionBgProps, true)), v2.run(1);
    }), p2 = true);
  }, o: function(n3) {
    ba(y2), a2 && ba(a2.$$.fragment, n3), f2 || (f2 = wa(r2, e22[12], e22[1].transitionWindowProps, false)), f2.run(0), v2 || (v2 = wa(t2, e22[11], e22[1].transitionBgProps, false)), v2.run(0), p2 = false;
  }, d: function(n3) {
    n3 && po(t2), y2 && y2.d(), a2 && Ea(a2), e22[49](null), n3 && f2 && f2.end(), e22[50](null), e22[51](null), n3 && v2 && v2.end(), m2 = false, Wi(g2);
  } };
}
function Ha(e22) {
  var t2, n2, r2, i2, o2, a2 = [Ja, Wa], s2 = [];
  function u2(e23, n3) {
    return 2 & n3[0] && (t2 = null), t2 == null && (t2 = !!e23[17](e23[1].closeButton)), t2 ? 0 : 1;
  }
  return n2 = u2(e22, [-1, -1, -1]), r2 = s2[n2] = a2[n2](e22), { c: function() {
    r2.c(), i2 = wo();
  }, m: function(e23, t3) {
    s2[n2].m(e23, t3), vo(e23, i2, t3), o2 = true;
  }, p: function(e23, t3) {
    var o3 = n2;
    (n2 = u2(e23, t3)) === o3 ? s2[n2].p(e23, t3) : (ma(), ba(s2[o3], 1, 1, function() {
      s2[o3] = null;
    }), ga(), (r2 = s2[n2]) ? r2.p(e23, t3) : (r2 = s2[n2] = a2[n2](e23)).c(), ya(r2, 1), r2.m(i2.parentNode, i2));
  }, i: function(e23) {
    o2 || (ya(r2), o2 = true);
  }, o: function(e23) {
    ba(r2), o2 = false;
  }, d: function(e23) {
    s2[n2].d(e23), e23 && po(i2);
  } };
}
function Wa(e22) {
  var t2, n2, r2, i2;
  return { c: function() {
    So(t2 = go("button"), "class", n2 = eo(e22[1].classCloseButton) + " svelte-g4wg3a"), So(t2, "aria-label", "Close modal"), So(t2, "style", e22[10]), So(t2, "type", "button"), To(t2, "close", !e22[0]);
  }, m: function(n3, o2) {
    vo(n3, t2, o2), r2 || (i2 = xo(t2, "click", e22[18]), r2 = true);
  }, p: function(e23, r3) {
    2 & r3[0] && n2 !== (n2 = eo(e23[1].classCloseButton) + " svelte-g4wg3a") && So(t2, "class", n2), 1024 & r3[0] && So(t2, "style", e23[10]), 3 & r3[0] && To(t2, "close", !e23[0]);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2), r2 = false, i2();
  } };
}
function Ja(e22) {
  var t2, n2, r2, i2 = e22[1].closeButton;
  function o2(e23) {
    return { props: { onClose: e23[18] } };
  }
  return i2 && (t2 = new i2(o2(e22))), { c: function() {
    t2 && Aa(t2.$$.fragment), n2 = wo();
  }, m: function(e23, i3) {
    t2 && Ma(t2, e23, i3), vo(e23, n2, i3), r2 = true;
  }, p: function(e23, r3) {
    if (i2 !== (i2 = e23[1].closeButton)) {
      if (t2) {
        ma();
        var a2 = t2;
        ba(a2.$$.fragment, 1, 0, function() {
          Ea(a2, 1);
        }), ga();
      }
      i2 ? (Aa((t2 = new i2(o2(e23))).$$.fragment), ya(t2.$$.fragment, 1), Ma(t2, n2.parentNode, n2)) : t2 = null;
    }
  }, i: function(e23) {
    r2 || (t2 && ya(t2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    t2 && ba(t2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(n2), t2 && Ea(t2, e23);
  } };
}
function Ua(e22) {
  var t2, n2, r2, i2, o2 = e22[2] && Va(e22), a2 = e22[48].default, s2 = Gi(a2, e22, e22[47], null);
  return { c: function() {
    o2 && o2.c(), t2 = ko(), s2 && s2.c();
  }, m: function(a3, u2) {
    o2 && o2.m(a3, u2), vo(a3, t2, u2), s2 && s2.m(a3, u2), n2 = true, r2 || (i2 = xo(qa, "keydown", e22[19]), r2 = true);
  }, p: function(e23, r3) {
    e23[2] ? o2 ? (o2.p(e23, r3), 4 & r3[0] && ya(o2, 1)) : ((o2 = Va(e23)).c(), ya(o2, 1), o2.m(t2.parentNode, t2)) : o2 && (ma(), ba(o2, 1, 1, function() {
      o2 = null;
    }), ga()), s2 && s2.p && (!n2 || 65536 & r3[1]) && Zi(s2, a2, e23, e23[47], n2 ? Yi(a2, e23[47], r3, null) : Xi(e23[47]), null);
  }, i: function(e23) {
    n2 || (ya(o2), ya(s2, e23), n2 = true);
  }, o: function(e23) {
    ba(o2), ba(s2, e23), n2 = false;
  }, d: function(e23) {
    o2 && o2.d(e23), e23 && po(t2), s2 && s2.d(e23), r2 = false, i2();
  } };
}
function Ka(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  return function(n2) {
    return new e22(Ei(Ei({}, n2), {}, { props: Ei(Ei({}, t2), n2.props) }));
  };
}
function Ga(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2 = t2.$$slots, b2 = y2 === void 0 ? {} : y2, k2 = t2.$$scope, w2 = Go(), x2 = Qo, j2 = t2.isTabbable, S2 = j2 === void 0 ? function(e23) {
    return e23.tabIndex >= 0 && !e23.hidden && !e23.disabled && e23.style.display !== "none" && e23.type !== "hidden" && Boolean(e23.offsetWidth || e23.offsetHeight || e23.getClientRects().length);
  } : j2, C2 = t2.show, _2 = C2 === void 0 ? null : C2, $2 = t2.key, O2 = $2 === void 0 ? "simple-modal" : $2, A2 = t2.ariaLabel, M2 = A2 === void 0 ? null : A2, E2 = t2.ariaLabelledBy, P2 = E2 === void 0 ? null : E2, N2 = t2.closeButton, T2 = N2 === void 0 || N2, I2 = t2.closeOnEsc, R2 = I2 === void 0 || I2, D2 = t2.closeOnOuterClick, z2 = D2 === void 0 || D2, L2 = t2.styleBg, B2 = L2 === void 0 ? {} : L2, q2 = t2.styleWindowWrap, F2 = q2 === void 0 ? {} : q2, V2 = t2.styleWindow, H2 = V2 === void 0 ? {} : V2, W2 = t2.styleContent, J2 = W2 === void 0 ? {} : W2, U2 = t2.styleCloseButton, K2 = U2 === void 0 ? {} : U2, G2 = t2.classBg, Q2 = G2 === void 0 ? null : G2, Y2 = t2.classWindowWrap, Z2 = Y2 === void 0 ? null : Y2, X2 = t2.classWindow, ee2 = X2 === void 0 ? null : X2, te2 = t2.classContent, ne2 = te2 === void 0 ? null : te2, re2 = t2.classCloseButton, ie2 = re2 === void 0 ? null : re2, oe2 = t2.unstyled, ae2 = oe2 !== void 0 && oe2, se2 = t2.setContext, ue2 = se2 === void 0 ? x2 : se2, ce2 = t2.transitionBg, le2 = ce2 === void 0 ? Ba : ce2, fe2 = t2.transitionBgProps, he2 = fe2 === void 0 ? { duration: 250 } : fe2, de2 = t2.transitionWindow, ve2 = de2 === void 0 ? le2 : de2, pe2 = t2.transitionWindowProps, me2 = pe2 === void 0 ? he2 : pe2, ge2 = t2.disableFocusTrap, ye2 = ge2 !== void 0 && ge2, be2 = { ariaLabel: M2, ariaLabelledBy: P2, closeButton: T2, closeOnEsc: R2, closeOnOuterClick: z2, styleBg: B2, styleWindowWrap: F2, styleWindow: H2, styleContent: J2, styleCloseButton: K2, classBg: Q2, classWindowWrap: Z2, classWindow: ee2, classContent: ne2, classCloseButton: ie2, transitionBg: le2, transitionBgProps: he2, transitionWindow: ve2, transitionWindowProps: me2, disableFocusTrap: ye2, isTabbable: S2, unstyled: ae2 }, ke2 = Ei({}, be2), we2 = null, xe2 = function(e23) {
    return e23 ? Object.keys(e23).reduce(function(t3, n3) {
      return "".concat(t3, "; ").concat(function(e24) {
        return e24.replace(/([a-zA-Z])(?=[A-Z])/g, "$1-").toLowerCase();
      }(n3), ": ").concat(e23[n3]);
    }, "") : "";
  }, je2 = function(e23) {
    return !!(e23 && e23.constructor && e23.call && e23.apply);
  }, Se2 = function() {
    n2(6, s2 = xe2(Object.assign({}, { width: window.innerWidth, height: window.innerHeight }, ke2.styleBg))), n2(7, u2 = xe2(ke2.styleWindowWrap)), n2(8, c2 = xe2(ke2.styleWindow)), n2(9, l2 = xe2(ke2.styleContent)), n2(10, f2 = xe2(ke2.styleCloseButton)), n2(11, h2 = ke2.transitionBg), n2(12, d2 = ke2.transitionWindow);
  }, Ce2 = function() {
  }, _e2 = Ce2, $e2 = Ce2, Oe2 = Ce2, Ae2 = Ce2, Me2 = function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, i3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : {};
    n2(2, we2 = Ka(e23, t3)), n2(1, ke2 = Ei(Ei({}, be2), r3)), Se2(), Pe2(), n2(13, _e2 = function(e24) {
      i3.onOpen && i3.onOpen(e24), w2("open"), w2("opening");
    }), n2(14, $e2 = function(e24) {
      i3.onClose && i3.onClose(e24), w2("close"), w2("closing");
    }), n2(15, Oe2 = function(e24) {
      i3.onOpened && i3.onOpened(e24), w2("opened");
    }), n2(16, Ae2 = function(e24) {
      i3.onClosed && i3.onClosed(e24), w2("closed");
    });
  }, Ee2 = function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    we2 && (n2(14, $e2 = e23.onClose || $e2), n2(16, Ae2 = e23.onClosed || Ae2), n2(2, we2 = null), Ne2());
  }, Pe2 = function() {
    a2 = window.scrollY, v2 = document.body.style.position, p2 = document.body.style.overflow, m2 = document.body.style.width, document.body.style.position = "fixed", document.body.style.top = "-".concat(a2, "px"), document.body.style.overflow = "hidden", document.body.style.width = "100%";
  }, Ne2 = function() {
    document.body.style.position = v2 || "", document.body.style.top = "", document.body.style.overflow = p2 || "", document.body.style.width = m2 || "", window.scrollTo(0, a2);
  };
  ue2(O2, { open: Me2, close: Ee2 });
  var Te2 = false;
  return Ko(function() {
    Te2 && Ee2();
  }), Uo(function() {
    n2(46, Te2 = true);
  }), e22.$$set = function(e23) {
    "isTabbable" in e23 && n2(22, S2 = e23.isTabbable), "show" in e23 && n2(23, _2 = e23.show), "key" in e23 && n2(24, O2 = e23.key), "ariaLabel" in e23 && n2(25, M2 = e23.ariaLabel), "ariaLabelledBy" in e23 && n2(26, P2 = e23.ariaLabelledBy), "closeButton" in e23 && n2(27, T2 = e23.closeButton), "closeOnEsc" in e23 && n2(28, R2 = e23.closeOnEsc), "closeOnOuterClick" in e23 && n2(29, z2 = e23.closeOnOuterClick), "styleBg" in e23 && n2(30, B2 = e23.styleBg), "styleWindowWrap" in e23 && n2(31, F2 = e23.styleWindowWrap), "styleWindow" in e23 && n2(32, H2 = e23.styleWindow), "styleContent" in e23 && n2(33, J2 = e23.styleContent), "styleCloseButton" in e23 && n2(34, K2 = e23.styleCloseButton), "classBg" in e23 && n2(35, Q2 = e23.classBg), "classWindowWrap" in e23 && n2(36, Z2 = e23.classWindowWrap), "classWindow" in e23 && n2(37, ee2 = e23.classWindow), "classContent" in e23 && n2(38, ne2 = e23.classContent), "classCloseButton" in e23 && n2(39, ie2 = e23.classCloseButton), "unstyled" in e23 && n2(0, ae2 = e23.unstyled), "setContext" in e23 && n2(40, ue2 = e23.setContext), "transitionBg" in e23 && n2(41, le2 = e23.transitionBg), "transitionBgProps" in e23 && n2(42, he2 = e23.transitionBgProps), "transitionWindow" in e23 && n2(43, ve2 = e23.transitionWindow), "transitionWindowProps" in e23 && n2(44, me2 = e23.transitionWindowProps), "disableFocusTrap" in e23 && n2(45, ye2 = e23.disableFocusTrap), "$$scope" in e23 && n2(47, k2 = e23.$$scope);
  }, e22.$$.update = function() {
    8388608 & e22.$$.dirty[0] | 32768 & e22.$$.dirty[1] && Te2 && (je2(_2) ? Me2(_2) : Ee2());
  }, [ae2, ke2, we2, r2, i2, o2, s2, u2, c2, l2, f2, h2, d2, _e2, $e2, Oe2, Ae2, je2, Ee2, function(e23) {
    if (ke2.closeOnEsc && we2 && e23.key === "Escape" && (e23.preventDefault(), Ee2()), we2 && e23.key === "Tab" && !ke2.disableFocusTrap) {
      var t3 = o2.querySelectorAll("*"), n3 = Array.from(t3).filter(ke2.isTabbable).sort(function(e24, t4) {
        return e24.tabIndex - t4.tabIndex;
      }), r3 = n3.indexOf(document.activeElement);
      r3 === -1 && e23.shiftKey && (r3 = 0), r3 += n3.length + (e23.shiftKey ? -1 : 1), n3[r3 %= n3.length].focus(), e23.preventDefault();
    }
  }, function(e23) {
    !ke2.closeOnOuterClick || e23.target !== r2 && e23.target !== i2 || (g2 = e23.target);
  }, function(e23) {
    ke2.closeOnOuterClick && e23.target === g2 && (e23.preventDefault(), Ee2());
  }, S2, _2, O2, M2, P2, T2, R2, z2, B2, F2, H2, J2, K2, Q2, Z2, ee2, ne2, ie2, ue2, le2, he2, ve2, me2, ye2, Te2, k2, b2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(5, o2 = e23);
    });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(4, i2 = e23);
    });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(3, r2 = e23);
    });
  }];
}
var Qa = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, Ga, Ua, Ui, { isTabbable: 22, show: 23, key: 24, ariaLabel: 25, ariaLabelledBy: 26, closeButton: 27, closeOnEsc: 28, closeOnOuterClick: 29, styleBg: 30, styleWindowWrap: 31, styleWindow: 32, styleContent: 33, styleCloseButton: 34, classBg: 35, classWindowWrap: 36, classWindow: 37, classContent: 38, classCloseButton: 39, unstyled: 0, setContext: 40, transitionBg: 41, transitionBgProps: 42, transitionWindow: 43, transitionWindowProps: 44, disableFocusTrap: 45 }, Fa, [-1, -1, -1]), r2;
  }
  return zi(n2);
}(), Ya = [{ start: 0, end: 100 }], Za = { closeButton: false, classBg: "jse-modal-bg", classWindow: "jse-modal-window", classWindowWrap: "jse-modal-window-wrap", classContent: "jse-modal-content" }, Xa = Ei(Ei({}, Za), {}, { classWindow: "jse-modal-window jse-modal-window-sort" }), es = Ei(Ei({}, Za), {}, { classWindow: "jse-modal-window jse-modal-window-transform" }), ts = "Insert or paste contents, enter [ insert a new array, enter { to insert a new object, or start typing to insert a new value", ns = "Open context menu (Click here, right click on the selection, or use the context menu button or Ctrl+Q)", rs = "NO", is = "SELF", os = "NEXT_INSIDE", as = 0;
function ss() {
  return ++as;
}
function us(e22) {
  return e22 && e22.__esModule && Object.prototype.hasOwnProperty.call(e22, "default") ? e22.default : e22;
}
var cs = { exports: {} };
!function(e22) {
  function t2(e23) {
    return (t2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e24) {
      return typeof e24;
    } : function(e24) {
      return e24 && typeof Symbol == "function" && e24.constructor === Symbol && e24 !== Symbol.prototype ? "symbol" : typeof e24;
    })(e23);
  }
  function n2(e23, t3) {
    return JSON.stringify(e23) === JSON.stringify(t3);
  }
  function r2(e23, t3) {
    return e23 === t3;
  }
  function i2(e23) {
    return e23.slice(0, e23.length - 1);
  }
  function o2(e23) {
    return e23[e23.length - 1];
  }
  function a2(e23, t3) {
    var n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : r2;
    if (e23.length < t3.length)
      return false;
    for (var i3 = 0; i3 < t3.length; i3++)
      if (!n3(e23[i3], t3[i3]))
        return false;
    return true;
  }
  function s2(e23) {
    return t2(e23) === "object" && e23 !== null;
  }
  function u2(e23, t3) {
    var n3 = Object.keys(e23);
    if (Object.getOwnPropertySymbols) {
      var r3 = Object.getOwnPropertySymbols(e23);
      t3 && (r3 = r3.filter(function(t4) {
        return Object.getOwnPropertyDescriptor(e23, t4).enumerable;
      })), n3.push.apply(n3, r3);
    }
    return n3;
  }
  function c2(e23) {
    for (var t3 = 1; t3 < arguments.length; t3++) {
      var n3 = arguments[t3] != null ? arguments[t3] : {};
      t3 % 2 ? u2(Object(n3), true).forEach(function(t4) {
        l2(e23, t4, n3[t4]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e23, Object.getOwnPropertyDescriptors(n3)) : u2(Object(n3)).forEach(function(t4) {
        Object.defineProperty(e23, t4, Object.getOwnPropertyDescriptor(n3, t4));
      });
    }
    return e23;
  }
  function l2(e23, t3, n3) {
    return t3 in e23 ? Object.defineProperty(e23, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e23[t3] = n3, e23;
  }
  function f2(e23) {
    return (f2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e24) {
      return typeof e24;
    } : function(e24) {
      return e24 && typeof Symbol == "function" && e24.constructor === Symbol && e24 !== Symbol.prototype ? "symbol" : typeof e24;
    })(e23);
  }
  function h2(e23) {
    if (Array.isArray(e23)) {
      var t3 = e23.slice();
      return Object.getOwnPropertySymbols(e23).forEach(function(n4) {
        t3[n4] = e23[n4];
      }), t3;
    }
    if (f2(e23) === "object") {
      var n3 = c2({}, e23);
      return Object.getOwnPropertySymbols(e23).forEach(function(t4) {
        n3[t4] = e23[t4];
      }), n3;
    }
    return e23;
  }
  function d2(e23, t3, n3) {
    if (e23[t3] === n3)
      return e23;
    var r3 = h2(e23);
    return r3[t3] = n3, r3;
  }
  function v2(e23, t3) {
    for (var n3 = e23, r3 = 0; r3 < t3.length; )
      n3 = s2(n3) ? n3[t3[r3]] : void 0, r3++;
    return n3;
  }
  function p2(e23, t3, n3) {
    var r3 = arguments.length > 3 && arguments[3] !== void 0 && arguments[3];
    if (t3.length === 0)
      return n3;
    var i3 = t3[0], o3 = p2(e23 ? e23[i3] : void 0, t3.slice(1), n3, r3);
    if (!s2(e23)) {
      if (r3) {
        var a3 = typeof i3 == "number" ? [] : {};
        return a3[i3] = o3, a3;
      }
      throw new Error("Path does not exist");
    }
    return d2(e23, i3, o3);
  }
  function m2(e23, t3, n3) {
    if (t3.length === 0)
      return n3(e23);
    if (!s2(e23))
      throw new Error("Path doesn't exist");
    var r3 = t3[0];
    return d2(e23, r3, m2(e23[r3], t3.slice(1), n3));
  }
  function g2(e23, t3) {
    if (t3.length === 0)
      return e23;
    if (!s2(e23))
      throw new Error("Path does not exist");
    if (t3.length === 1) {
      var n3 = t3[0];
      if (n3 in e23) {
        var r3 = h2(e23);
        return Array.isArray(r3) ? r3.splice(n3, 1) : delete r3[n3], r3;
      }
      return e23;
    }
    var i3 = t3[0];
    return d2(e23, i3, g2(e23[i3], t3.slice(1)));
  }
  function y2(e23, t3, n3) {
    var r3 = t3.slice(0, t3.length - 1), i3 = t3[t3.length - 1];
    return m2(e23, r3, function(e24) {
      if (!Array.isArray(e24))
        throw new TypeError("Array expected at path " + JSON.stringify(r3));
      var t4 = h2(e24);
      return t4.splice(i3, 0, n3), t4;
    });
  }
  function b2(e23, t3) {
    return e23 !== void 0 && (t3.length === 0 || b2(e23[t3[0]], t3.slice(1)));
  }
  function k2(e23) {
    var t3 = e23.split("/");
    return t3.shift(), t3.map(function(e24) {
      return e24.replace(/~1/g, "/").replace(/~0/g, "~");
    });
  }
  function w2(e23) {
    return e23.map(x2).join("");
  }
  function x2(e23) {
    return "/" + String(e23).replace(/~/g, "~0").replace(/\//g, "~1");
  }
  function j2(e23, t3) {
    return e23 + x2(t3);
  }
  function S2(e23, t3) {
    return e23.startsWith(t3) && (e23.length === t3.length || e23[t3.length] === "/");
  }
  function C2(e23, t3, n3) {
    for (var r3 = e23, i3 = 0; i3 < t3.length; i3++) {
      T2(t3[i3]);
      var o3 = t3[i3];
      if (n3 && n3.before) {
        var a3 = n3.before(r3, o3);
        a3 !== void 0 && (a3.json !== void 0 && (r3 = a3.json), a3.operation !== void 0 && (o3 = a3.operation));
      }
      var s3 = r3, u3 = I2(r3, o3.path);
      if (o3.op === "add")
        r3 = O2(r3, u3, o3.value);
      else if (o3.op === "remove")
        r3 = $2(r3, u3);
      else if (o3.op === "replace")
        r3 = _2(r3, u3, o3.value);
      else if (o3.op === "copy")
        r3 = A2(r3, u3, R2(o3.from));
      else if (o3.op === "move")
        r3 = M2(r3, u3, R2(o3.from));
      else {
        if (o3.op !== "test")
          throw new Error("Unknown JSONPatch operation " + JSON.stringify(o3.op));
        E2(r3, u3, o3.value);
      }
      if (n3 && n3.after) {
        var c3 = n3.after(r3, o3, s3);
        c3 !== void 0 && (r3 = c3);
      }
    }
    return r3;
  }
  function _2(e23, t3, n3) {
    return p2(e23, t3, n3);
  }
  function $2(e23, t3) {
    return g2(e23, t3);
  }
  function O2(e23, t3, n3) {
    return P2(e23, t3) ? y2(e23, t3, n3) : p2(e23, t3, n3);
  }
  function A2(e23, t3, n3) {
    var r3 = v2(e23, n3);
    return P2(e23, t3) ? y2(e23, t3, r3) : p2(e23, t3, v2(e23, n3));
  }
  function M2(e23, t3, n3) {
    var r3 = v2(e23, n3), i3 = g2(e23, n3);
    return P2(i3, t3) ? y2(i3, t3, r3) : p2(i3, t3, r3);
  }
  function E2(e23, t3, r3) {
    if (r3 === void 0)
      throw new Error('Test failed: no value provided (path: "'.concat(w2(t3), '")'));
    if (!b2(e23, t3))
      throw new Error('Test failed: path not found (path: "'.concat(w2(t3), '")'));
    if (!n2(v2(e23, t3), r3))
      throw new Error('Test failed, value differs (path: "'.concat(w2(t3), '")'));
  }
  function P2(e23, t3) {
    if (t3.length === 0)
      return false;
    var n3 = v2(e23, i2(t3));
    return Array.isArray(n3);
  }
  function N2(e23, t3) {
    if (o2(t3) !== "-")
      return t3;
    var n3 = i2(t3), r3 = v2(e23, n3);
    return n3.concat(r3.length);
  }
  function T2(e23) {
    if (!["add", "remove", "replace", "copy", "move", "test"].includes(e23.op))
      throw new Error("Unknown JSONPatch op " + JSON.stringify(e23.op));
    if (typeof e23.path != "string")
      throw new Error('Required property "path" missing or not a string in operation ' + JSON.stringify(e23));
    if ((e23.op === "copy" || e23.op === "move") && typeof e23.from != "string")
      throw new Error('Required property "from" missing or not a string in operation ' + JSON.stringify(e23));
  }
  function I2(e23, t3) {
    return N2(e23, k2(t3));
  }
  function R2(e23) {
    return k2(e23);
  }
  function D2(e23, t3, n3) {
    var r3 = [];
    return C2(e23, t3, { before: function(e24, t4) {
      var i3, o3, a3 = I2(e24, t4.path);
      if (t4.op === "add")
        i3 = B2(e24, a3, t4.value);
      else if (t4.op === "remove")
        i3 = L2(e24, a3);
      else if (t4.op === "replace")
        i3 = z2(e24, a3);
      else if (t4.op === "copy")
        i3 = q2(e24, a3, t4.value);
      else if (t4.op === "move")
        i3 = F2(e24, a3, R2(t4.from));
      else {
        if (t4.op !== "test")
          throw new Error("Unknown JSONPatch operation " + JSON.stringify(t4.op));
        i3 = [];
      }
      if (n3 && n3.before) {
        var s3 = n3.before(e24, t4, i3);
        s3 && s3.revertOperations && (i3 = s3.revertOperations), s3 && s3.json && (o3 = s3.json);
      }
      if (r3 = i3.concat(r3), o3 !== void 0)
        return { json: o3 };
    } }), r3;
  }
  function z2(e23, t3) {
    return [{ op: "replace", path: w2(t3), value: v2(e23, t3) }];
  }
  function L2(e23, t3) {
    return [{ op: "add", path: w2(t3), value: v2(e23, t3) }];
  }
  function B2(e23, t3, n3) {
    return P2(e23, t3) || !b2(e23, t3) ? [{ op: "remove", path: w2(t3) }] : z2(e23, t3);
  }
  function q2(e23, t3, n3) {
    return B2(e23, t3);
  }
  function F2(e23, t3, n3) {
    if (t3.length < n3.length && a2(n3, t3))
      return [{ op: "replace", path: w2(t3), value: e23 }];
    var r3 = [{ op: "move", from: w2(t3), path: w2(n3) }];
    return !P2(e23, t3) && b2(e23, t3) && (r3 = r3.concat(L2(e23, t3))), r3;
  }
  function V2(e23) {
    return !!e23 && typeof e23.op == "string";
  }
  function H2(e23) {
    return !!e23 && e23.op === "add";
  }
  function W2(e23) {
    return !!e23 && e23.op === "remove";
  }
  function J2(e23) {
    return !!e23 && e23.op === "replace";
  }
  function U2(e23) {
    return !!e23 && e23.op === "copy";
  }
  function K2(e23) {
    return !!e23 && e23.op === "move";
  }
  function G2(e23) {
    return !!e23 && e23.op === "test";
  }
  e22.appendToJSONPointer = j2, e22.compileJSONPointer = w2, e22.compileJSONPointerProp = x2, e22.deleteIn = g2, e22.existsIn = b2, e22.getIn = v2, e22.immutableJSONPatch = C2, e22.insertAt = y2, e22.isJSONPatchAdd = H2, e22.isJSONPatchCopy = U2, e22.isJSONPatchMove = K2, e22.isJSONPatchOperation = V2, e22.isJSONPatchRemove = W2, e22.isJSONPatchReplace = J2, e22.isJSONPatchTest = G2, e22.parseFrom = R2, e22.parseJSONPointer = k2, e22.parsePath = I2, e22.revertJSONPatch = D2, e22.setIn = p2, e22.startsWithJSONPointer = S2, e22.updateIn = m2, Object.defineProperty(e22, "__esModule", { value: true });
}(cs.exports);
var ls = {}, fs = { b: "\b", f: "\f", n: "\n", r: "\r", t: "	", '"': '"', "/": "/", "\\": "\\" }, hs = "a".charCodeAt();
ls.parse = function(e22, t2, n2) {
  var r2 = {}, i2 = 0, o2 = 0, a2 = 0, s2 = n2 && n2.bigint && typeof BigInt != "undefined";
  return { data: u2("", true), pointers: r2 };
  function u2(t3, n3) {
    var r3;
    c2(), m2(t3, "value");
    var i3 = h2();
    switch (i3) {
      case "t":
        f2("rue"), r3 = true;
        break;
      case "f":
        f2("alse"), r3 = false;
        break;
      case "n":
        f2("ull"), r3 = null;
        break;
      case '"':
        r3 = l2();
        break;
      case "[":
        r3 = function(e23) {
          c2();
          var t4 = [], n4 = 0;
          if (h2() == "]")
            return t4;
          d2();
          for (; ; ) {
            var r4 = e23 + "/" + n4;
            t4.push(u2(r4)), c2();
            var i4 = h2();
            if (i4 == "]")
              break;
            i4 != "," && k2(), c2(), n4++;
          }
          return t4;
        }(t3);
        break;
      case "{":
        r3 = function(e23) {
          c2();
          var t4 = {};
          if (h2() == "}")
            return t4;
          d2();
          for (; ; ) {
            var n4 = y2();
            h2() != '"' && k2();
            var r4 = l2(), i4 = e23 + "/" + Ss(r4);
            g2(i4, "key", n4), m2(i4, "keyEnd"), c2(), h2() != ":" && k2(), c2(), t4[r4] = u2(i4), c2();
            var o3 = h2();
            if (o3 == "}")
              break;
            o3 != "," && k2(), c2();
          }
          return t4;
        }(t3);
        break;
      default:
        d2(), "-0123456789".indexOf(i3) >= 0 ? r3 = function() {
          var t4 = "", n4 = true;
          e22[a2] == "-" && (t4 += h2());
          t4 += e22[a2] == "0" ? h2() : p2(), e22[a2] == "." && (t4 += h2() + p2(), n4 = false);
          e22[a2] != "e" && e22[a2] != "E" || (t4 += h2(), e22[a2] != "+" && e22[a2] != "-" || (t4 += h2()), t4 += p2(), n4 = false);
          var r4 = +t4;
          return s2 && n4 && (r4 > Number.MAX_SAFE_INTEGER || r4 < Number.MIN_SAFE_INTEGER) ? BigInt(t4) : r4;
        }() : b2();
    }
    return m2(t3, "valueEnd"), c2(), n3 && a2 < e22.length && b2(), r3;
  }
  function c2() {
    e:
      for (; a2 < e22.length; ) {
        switch (e22[a2]) {
          case " ":
            o2++;
            break;
          case "	":
            o2 += 4;
            break;
          case "\r":
            o2 = 0;
            break;
          case "\n":
            o2 = 0, i2++;
            break;
          default:
            break e;
        }
        a2++;
      }
  }
  function l2() {
    for (var e23, t3 = ""; (e23 = h2()) != '"'; )
      e23 == "\\" ? (e23 = h2()) in fs ? t3 += fs[e23] : e23 == "u" ? t3 += v2() : k2() : t3 += e23;
    return t3;
  }
  function f2(e23) {
    for (var t3 = 0; t3 < e23.length; t3++)
      h2() !== e23[t3] && k2();
  }
  function h2() {
    w2();
    var t3 = e22[a2];
    return a2++, o2++, t3;
  }
  function d2() {
    a2--, o2--;
  }
  function v2() {
    for (var e23 = 4, t3 = 0; e23--; ) {
      t3 <<= 4;
      var n3 = h2().toLowerCase();
      n3 >= "a" && n3 <= "f" ? t3 += n3.charCodeAt() - hs + 10 : n3 >= "0" && n3 <= "9" ? t3 += +n3 : k2();
    }
    return String.fromCharCode(t3);
  }
  function p2() {
    for (var t3 = ""; e22[a2] >= "0" && e22[a2] <= "9"; )
      t3 += h2();
    if (t3.length)
      return t3;
    w2(), b2();
  }
  function m2(e23, t3) {
    g2(e23, t3, y2());
  }
  function g2(e23, t3, n3) {
    r2[e23] = r2[e23] || {}, r2[e23][t3] = n3;
  }
  function y2() {
    return { line: i2, column: o2, pos: a2 };
  }
  function b2() {
    throw new SyntaxError("Unexpected token " + e22[a2] + " in JSON at position " + a2);
  }
  function k2() {
    d2(), b2();
  }
  function w2() {
    if (a2 >= e22.length)
      throw new SyntaxError("Unexpected end of JSON input");
  }
}, ls.stringify = function(e22, t2, n2) {
  if (vs(e22)) {
    var r2, i2, o2 = 0, a2 = Li(n2) == "object" ? n2.space : n2;
    switch (Li(a2)) {
      case "number":
        var s2 = a2 > 10 ? 10 : a2 < 0 ? 0 : Math.floor(a2);
        a2 = s2 && y2(s2, " "), r2 = s2, i2 = s2;
        break;
      case "string":
        a2 = a2.slice(0, 10), r2 = 0, i2 = 0;
        for (var u2 = 0; u2 < a2.length; u2++) {
          switch (a2[u2]) {
            case " ":
              i2++;
              break;
            case "	":
              i2 += 4;
              break;
            case "\r":
              i2 = 0;
              break;
            case "\n":
              i2 = 0, o2++;
              break;
            default:
              throw new Error("whitespace characters not allowed in JSON");
          }
          r2++;
        }
        break;
      default:
        a2 = void 0;
    }
    var c2 = "", l2 = {}, f2 = 0, h2 = 0, d2 = 0, v2 = n2 && n2.es6 && typeof Map == "function";
    return function e23(t3, n3, r3) {
      switch (g2(r3, "value"), Li(t3)) {
        case "number":
        case "bigint":
        case "boolean":
          p2("" + t3);
          break;
        case "string":
          p2(ws(t3));
          break;
        case "object":
          t3 === null ? p2("null") : typeof t3.toJSON == "function" ? p2(ws(t3.toJSON())) : Array.isArray(t3) ? i3() : v2 ? t3.constructor.BYTES_PER_ELEMENT ? i3() : t3 instanceof Map ? s3() : t3 instanceof Set ? s3(true) : o3() : o3();
      }
      function i3() {
        if (t3.length) {
          p2("[");
          for (var i4 = n3 + 1, o4 = 0; o4 < t3.length; o4++) {
            o4 && p2(","), m2(i4);
            var a3 = vs(t3[o4]) ? t3[o4] : null;
            e23(a3, i4, r3 + "/" + o4);
          }
          m2(n3), p2("]");
        } else
          p2("[]");
      }
      function o3() {
        var i4 = Object.keys(t3);
        if (i4.length) {
          p2("{");
          for (var o4 = n3 + 1, s4 = 0; s4 < i4.length; s4++) {
            var u3 = i4[s4], c3 = t3[u3];
            if (vs(c3)) {
              s4 && p2(",");
              var l3 = r3 + "/" + Ss(u3);
              m2(o4), g2(l3, "key"), p2(ws(u3)), g2(l3, "keyEnd"), p2(":"), a2 && p2(" "), e23(c3, o4, l3);
            }
          }
          m2(n3), p2("}");
        } else
          p2("{}");
      }
      function s3(i4) {
        if (t3.size) {
          p2("{");
          for (var o4 = n3 + 1, s4 = true, u3 = t3.entries(), c3 = u3.next(); !c3.done; ) {
            var l3 = c3.value, f3 = l3[0], h3 = !!i4 || l3[1];
            if (vs(h3)) {
              s4 || p2(","), s4 = false;
              var d3 = r3 + "/" + Ss(f3);
              m2(o4), g2(d3, "key"), p2(ws(f3)), g2(d3, "keyEnd"), p2(":"), a2 && p2(" "), e23(h3, o4, d3);
            }
            c3 = u3.next();
          }
          m2(n3), p2("}");
        } else
          p2("{}");
      }
      g2(r3, "valueEnd");
    }(e22, 0, ""), { json: c2, pointers: l2 };
  }
  function p2(e23) {
    h2 += e23.length, d2 += e23.length, c2 += e23;
  }
  function m2(e23) {
    if (a2) {
      for (c2 += "\n" + y2(e23, a2), f2++, h2 = 0; e23--; )
        o2 ? (f2 += o2, h2 = i2) : h2 += i2, d2 += r2;
      d2 += 1;
    }
  }
  function g2(e23, t3) {
    l2[e23] = l2[e23] || {}, l2[e23][t3] = { line: f2, column: h2, pos: d2 };
  }
  function y2(e23, t3) {
    return Array(e23 + 1).join(t3);
  }
};
var ds = ["number", "bigint", "boolean", "string", "object"];
function vs(e22) {
  return ds.indexOf(Li(e22)) >= 0;
}
var ps = /"|\\/g, ms = /[\b]/g, gs = /\f/g, ys = /\n/g, bs = /\r/g, ks = /\t/g;
function ws(e22) {
  return '"' + (e22 = e22.replace(ps, "\\$&").replace(gs, "\\f").replace(ms, "\\b").replace(ys, "\\n").replace(bs, "\\r").replace(ks, "\\t")) + '"';
}
var xs = /~/g, js = /\//g;
function Ss(e22) {
  return e22.replace(xs, "~0").replace(js, "~1");
}
var _s = function() {
  function e22(t3, n3) {
    if (!(this instanceof e22))
      throw new SyntaxError("Constructor must be called with the new operator");
    this.message = t3 + " (char " + n3 + ")", this.char = n3, this.stack = new Error().stack;
  }
  (e22.prototype = new Error()).constructor = Error;
  var t2 = { "'": true, "\u2018": true, "\u2019": true, "`": true, "\xB4": true }, n2 = { '"': true, "\u201C": true, "\u201D": true };
  function r2(e23) {
    return i2.test(e23);
  }
  var i2 = /^[a-zA-Z_]$/, o2 = /^[0-9a-fA-F]$/;
  function a2(e23) {
    return s2.test(e23);
  }
  var s2 = /^[0-9]$/;
  function u2(e23) {
    return e23 === " " || e23 === "	" || e23 === "\n" || e23 === "\r";
  }
  function c2(e23) {
    return e23 === "\xA0" || "\u2000" <= e23 && e23 <= "\u200A" || e23 === "\u202F" || e23 === "\u205F" || e23 === "\u3000";
  }
  function l2(e23) {
    return t2[e23] === true;
  }
  function f2(e23) {
    return n2[e23] === true;
  }
  function h2(e23) {
    return t2[e23] === true ? "'" : n2[e23] === true ? '"' : e23;
  }
  function d2(e23, t3) {
    return (t3 = e23.lastIndexOf(t3)) !== -1 ? e23.substring(0, t3) + e23.substring(t3 + 1) : e23;
  }
  function v2(e23, t3) {
    var n3 = e23.length;
    if (!u2(e23[n3 - 1]))
      return e23 + t3;
    for (; u2(e23[n3 - 1]); )
      n3--;
    return e23.substring(0, n3) + t3 + e23.substring(n3);
  }
  var p2 = 0, m2 = 1, g2 = 2, y2 = 3, b2 = 4, k2 = 5, w2 = 6, x2 = { "": true, "{": true, "}": true, "[": true, "]": true, ":": true, ",": true, "(": true, ")": true, ";": true, "+": true }, j2 = { '"': '"', "\\": "\\", "/": "/", b: "\b", f: "\f", n: "\n", r: "\r", t: "	" }, S2 = { "\b": "\\b", "\f": "\\f", "\n": "\\n", "\r": "\\r", "	": "\\t" }, C2 = { null: "null", true: "true", false: "false" }, _2 = { None: "null", True: "true", False: "false" }, $2 = "", O2 = "", A2 = 0, M2 = "", E2 = "", P2 = w2;
  function N2() {
    A2++, M2 = $2.charAt(A2);
  }
  function T2() {
    N2(), M2 === "\\" && N2();
  }
  function I2() {
    return P2 === p2 && (E2 === "[" || E2 === "{") || P2 === g2 || P2 === m2 || P2 === y2;
  }
  function R2() {
    O2 += E2, P2 = w2, E2 = "", x2[M2] ? (P2 = p2, E2 = M2, N2()) : function() {
      if (a2(M2) || M2 === "-") {
        if (P2 = m2, M2 === "-") {
          if (E2 += M2, N2(), !a2(M2))
            throw new e22("Invalid number, digit expected", A2);
        } else
          M2 === "0" && (E2 += M2, N2());
        for (; a2(M2); )
          E2 += M2, N2();
        if (M2 === ".") {
          if (E2 += M2, N2(), !a2(M2))
            throw new e22("Invalid number, digit expected", A2);
          for (; a2(M2); )
            E2 += M2, N2();
        }
        if (M2 === "e" || M2 === "E") {
          if (E2 += M2, N2(), M2 !== "+" && M2 !== "-" || (E2 += M2, N2()), !a2(M2))
            throw new e22("Invalid number, digit expected", A2);
          for (; a2(M2); )
            E2 += M2, N2();
        }
      } else
        M2 === "\\" && $2.charAt(A2 + 1) === '"' ? (N2(), z2(T2)) : z2(N2);
    }(), P2 === b2 && (E2 = function(e23) {
      for (var t3 = "", n3 = 0; n3 < e23.length; n3++) {
        var r3 = e23[n3];
        t3 += c2(r3) ? " " : r3;
      }
      return t3;
    }(E2), R2()), P2 === k2 && (P2 = w2, E2 = "", R2());
  }
  function D2() {
    E2 === "," && (E2 = "", P2 = w2, R2());
  }
  function z2(i3) {
    if (t2[s3 = M2] === true || n2[s3] === true) {
      var s3 = h2(M2), d3 = l2(M2) ? l2 : f2;
      for (E2 += '"', P2 = g2, i3(); M2 !== "" && !d3(M2); )
        if (M2 === "\\")
          if (i3(), j2[M2] !== void 0)
            E2 += "\\" + M2, i3();
          else if (M2 === "u") {
            E2 += "\\u", i3();
            for (var v3 = 0; v3 < 4; v3++) {
              if (p3 = M2, !o2.test(p3))
                throw new e22("Invalid unicode character", A2 - E2.length);
              E2 += M2, i3();
            }
          } else {
            if (M2 !== "'")
              throw new e22('Invalid escape character "\\' + M2 + '"', A2);
            E2 += "'", i3();
          }
        else
          S2[M2] ? E2 += S2[M2] : E2 += M2 === '"' ? '\\"' : M2, i3();
      if (h2(M2) !== s3)
        throw new e22("End of string expected", A2 - E2.length);
      return E2 += '"', void i3();
    }
    var p3;
    !function() {
      if (r2(M2))
        for (P2 = y2; r2(M2) || a2(M2) || M2 === "$"; )
          E2 += M2, N2();
      else
        !function() {
          if (u2(M2) || c2(M2))
            for (P2 = b2; u2(M2) || c2(M2); )
              E2 += M2, N2();
          else
            !function() {
              if (M2 !== "/" || $2[A2 + 1] !== "*")
                if (M2 !== "/" || $2[A2 + 1] !== "/")
                  !function() {
                    for (P2 = w2; M2 !== ""; )
                      E2 += M2, N2();
                    throw new e22('Syntax error in part "' + E2 + '"', A2 - E2.length);
                  }();
                else
                  for (P2 = k2; M2 !== "" && M2 !== "\n"; )
                    E2 += M2, N2();
              else {
                for (P2 = k2; M2 !== "" && (M2 !== "*" || M2 === "*" && $2[A2 + 1] !== "/"); )
                  E2 += M2, N2();
                M2 === "*" && $2[A2 + 1] === "/" && (E2 += M2, N2(), E2 += M2, N2());
              }
            }();
        }();
    }();
  }
  function L2() {
    if (P2 !== p2 || E2 !== "{")
      !function() {
        if (P2 !== p2 || E2 !== "[")
          !function() {
            if (P2 !== g2)
              (P2 !== m2 ? function() {
                if (P2 !== y2)
                  !function() {
                    throw new e22(E2 === "" ? "Unexpected end of json string" : "Value expected", A2 - E2.length);
                  }();
                else if (C2[E2])
                  R2();
                else {
                  if (_2[E2])
                    return E2 = _2[E2], R2();
                  var t4 = E2, n3 = O2.length;
                  if (E2 = "", R2(), P2 === p2 && E2 === "(")
                    return E2 = "", R2(), L2(), P2 === p2 && E2 === ")" && (E2 = "", R2(), P2 === p2 && E2 === ";" && (E2 = "", R2()));
                  for (O2 = function(e23, t5, n4) {
                    return e23.substring(0, n4) + t5 + e23.substring(n4);
                  }(O2, '"'.concat(t4), n3); P2 === y2 || P2 === m2; )
                    R2();
                  O2 += '"';
                }
              } : R2)();
            else
              for (R2(); P2 === p2 && E2 === "+"; ) {
                var t3;
                E2 = "", R2(), P2 === g2 && (t3 = O2.lastIndexOf('"'), O2 = O2.substring(0, t3) + E2.substring(1), E2 = "", R2());
              }
          }();
        else if (R2(), P2 !== p2 || E2 !== "]") {
          for (; ; )
            if (L2(), P2 === p2 && E2 === ",") {
              if (R2(), P2 === p2 && E2 === "]") {
                O2 = d2(O2, ",");
                break;
              }
              if (E2 === "") {
                O2 = d2(O2, ",");
                break;
              }
            } else {
              if (!I2())
                break;
              O2 = v2(O2, ",");
            }
          P2 === p2 && E2 === "]" ? R2() : O2 = v2(O2, "]");
        } else
          R2();
      }();
    else if (R2(), P2 !== p2 || E2 !== "}") {
      for (; ; ) {
        if (P2 !== y2 && P2 !== m2 || (P2 = g2, E2 = '"'.concat(E2, '"')), P2 !== g2)
          throw new e22("Object key expected", A2 - E2.length);
        if (R2(), P2 === p2 && E2 === ":")
          R2();
        else {
          if (!I2())
            throw new e22("Colon expected", A2 - E2.length);
          O2 = v2(O2, ":");
        }
        if (L2(), P2 === p2 && E2 === ",") {
          if (R2(), P2 === p2 && E2 === "}") {
            O2 = d2(O2, ",");
            break;
          }
          if (E2 === "") {
            O2 = d2(O2, ",");
            break;
          }
        } else {
          if (P2 !== g2 && P2 !== m2 && P2 !== y2)
            break;
          O2 = v2(O2, ",");
        }
      }
      P2 === p2 && E2 === "}" ? R2() : O2 = v2(O2, "}");
    } else
      R2();
  }
  return function(t3) {
    O2 = "", A2 = 0, M2 = ($2 = t3).charAt(0), E2 = "", P2 = w2, R2();
    var n3 = P2;
    if (L2(), D2(), E2 === "")
      return O2;
    if (n3 === P2 && I2()) {
      for (var r3 = ""; n3 === P2 && I2(); )
        r3 += O2 = v2(O2, ","), O2 = "", L2(), D2();
      return "[\n".concat(r3).concat(O2, "\n]");
    }
    throw new e22("Unexpected characters", A2 - E2.length);
  };
}();
function $s(e22) {
  return Li(e22) === "object" && e22 !== null && !Array.isArray(e22);
}
function Os(e22) {
  return Li(e22) === "object" && e22 !== null;
}
function As(e22) {
  var t2 = window.document.createElement("div");
  return t2.style.color = e22, t2.style.color.split(/\s+/).join("").toLowerCase() || null;
}
function Ms(e22) {
  return e22 === null ? "null" : e22 === void 0 ? "undefined" : typeof e22 == "number" ? "number" : typeof e22 == "string" ? "string" : typeof e22 == "boolean" ? "boolean" : e22 instanceof RegExp ? "regexp" : Array.isArray(e22) ? "array" : "object";
}
var Es = /^https?:\/\/\S+$/;
function Ps(e22) {
  return typeof e22 == "string" && Es.test(e22);
}
function Ns(e22) {
  if (e22 === "")
    return "";
  if (e22 === "null")
    return null;
  if (e22 === "true")
    return true;
  if (e22 === "false")
    return false;
  var t2 = Number(e22);
  return isNaN(t2) || isNaN(parseFloat(e22)) ? e22 : t2;
}
var Ts = (typeof global == "undefined" ? "undefined" : Li(global)) == "object" && global && global.Object === Object && global, Is = (typeof self == "undefined" ? "undefined" : Li(self)) == "object" && self && self.Object === Object && self, Rs = Ts || Is || Function("return this")(), Ds = Rs.Symbol, zs = Object.prototype, Ls = zs.hasOwnProperty, Bs = zs.toString, qs = Ds ? Ds.toStringTag : void 0;
var Fs = Object.prototype.toString;
var Vs = Ds ? Ds.toStringTag : void 0;
function Hs(e22) {
  return e22 == null ? e22 === void 0 ? "[object Undefined]" : "[object Null]" : Vs && Vs in Object(e22) ? function(e23) {
    var t2 = Ls.call(e23, qs), n2 = e23[qs];
    try {
      e23[qs] = void 0;
      var r2 = true;
    } catch (e24) {
    }
    var i2 = Bs.call(e23);
    return r2 && (t2 ? e23[qs] = n2 : delete e23[qs]), i2;
  }(e22) : function(e23) {
    return Fs.call(e23);
  }(e22);
}
function Ws(e22) {
  return e22 != null && Li(e22) == "object";
}
function Js(e22) {
  return Li(e22) == "symbol" || Ws(e22) && Hs(e22) == "[object Symbol]";
}
function Us(e22) {
  return typeof e22 == "number" ? e22 : Js(e22) ? NaN : +e22;
}
function Ks(e22, t2) {
  for (var n2 = -1, r2 = e22 == null ? 0 : e22.length, i2 = Array(r2); ++n2 < r2; )
    i2[n2] = t2(e22[n2], n2, e22);
  return i2;
}
var Gs = Array.isArray, Qs = Ds ? Ds.prototype : void 0, Ys = Qs ? Qs.toString : void 0;
function Zs(e22) {
  if (typeof e22 == "string")
    return e22;
  if (Gs(e22))
    return Ks(e22, Zs) + "";
  if (Js(e22))
    return Ys ? Ys.call(e22) : "";
  var t2 = e22 + "";
  return t2 == "0" && 1 / e22 == -Infinity ? "-0" : t2;
}
function Xs(e22, t2) {
  return function(n2, r2) {
    var i2;
    if (n2 === void 0 && r2 === void 0)
      return t2;
    if (n2 !== void 0 && (i2 = n2), r2 !== void 0) {
      if (i2 === void 0)
        return r2;
      typeof n2 == "string" || typeof r2 == "string" ? (n2 = Zs(n2), r2 = Zs(r2)) : (n2 = Us(n2), r2 = Us(r2)), i2 = e22(n2, r2);
    }
    return i2;
  };
}
var eu = Xs(function(e22, t2) {
  return e22 + t2;
}, 0), tu = /\s/;
function nu(e22) {
  for (var t2 = e22.length; t2-- && tu.test(e22.charAt(t2)); )
    ;
  return t2;
}
var ru = /^\s+/;
function iu(e22) {
  return e22 ? e22.slice(0, nu(e22) + 1).replace(ru, "") : e22;
}
function ou(e22) {
  var t2 = Li(e22);
  return e22 != null && (t2 == "object" || t2 == "function");
}
var au = /^[-+]0x[0-9a-f]+$/i, su = /^0b[01]+$/i, uu = /^0o[0-7]+$/i, cu = parseInt;
function lu(e22) {
  if (typeof e22 == "number")
    return e22;
  if (Js(e22))
    return NaN;
  if (ou(e22)) {
    var t2 = typeof e22.valueOf == "function" ? e22.valueOf() : e22;
    e22 = ou(t2) ? t2 + "" : t2;
  }
  if (typeof e22 != "string")
    return e22 === 0 ? e22 : +e22;
  e22 = iu(e22);
  var n2 = su.test(e22);
  return n2 || uu.test(e22) ? cu(e22.slice(2), n2 ? 2 : 8) : au.test(e22) ? NaN : +e22;
}
function fu(e22) {
  return e22 ? (e22 = lu(e22)) === Infinity || e22 === -Infinity ? 17976931348623157e292 * (e22 < 0 ? -1 : 1) : e22 == e22 ? e22 : 0 : e22 === 0 ? e22 : 0;
}
function hu(e22) {
  var t2 = fu(e22), n2 = t2 % 1;
  return t2 == t2 ? n2 ? t2 - n2 : t2 : 0;
}
function du(e22, t2) {
  if (typeof t2 != "function")
    throw new TypeError("Expected a function");
  return e22 = hu(e22), function() {
    if (--e22 < 1)
      return t2.apply(this, arguments);
  };
}
function vu(e22) {
  return e22;
}
function pu(e22) {
  if (!ou(e22))
    return false;
  var t2 = Hs(e22);
  return t2 == "[object Function]" || t2 == "[object GeneratorFunction]" || t2 == "[object AsyncFunction]" || t2 == "[object Proxy]";
}
var mu, gu = Rs["__core-js_shared__"], yu = (mu = /[^.]+$/.exec(gu && gu.keys && gu.keys.IE_PROTO || "")) ? "Symbol(src)_1." + mu : "";
var bu = Function.prototype.toString;
function ku(e22) {
  if (e22 != null) {
    try {
      return bu.call(e22);
    } catch (e23) {
    }
    try {
      return e22 + "";
    } catch (e23) {
    }
  }
  return "";
}
var wu = /^\[object .+?Constructor\]$/, xu = Function.prototype, ju = Object.prototype, Su = xu.toString, Cu = ju.hasOwnProperty, _u = RegExp("^" + Su.call(Cu).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
function $u(e22) {
  return !(!ou(e22) || function(e23) {
    return !!yu && yu in e23;
  }(e22)) && (pu(e22) ? _u : wu).test(ku(e22));
}
function Ou(e22, t2) {
  var n2 = function(e23, t3) {
    return e23 == null ? void 0 : e23[t3];
  }(e22, t2);
  return $u(n2) ? n2 : void 0;
}
var Au = Ou(Rs, "WeakMap"), Mu = Au && new Au(), Eu = Mu ? function(e22, t2) {
  return Mu.set(e22, t2), e22;
} : vu, Pu = Object.create, Nu = function() {
  function e22() {
  }
  return function(t2) {
    if (!ou(t2))
      return {};
    if (Pu)
      return Pu(t2);
    e22.prototype = t2;
    var n2 = new e22();
    return e22.prototype = void 0, n2;
  };
}();
function Tu(e22) {
  return function() {
    var t2 = arguments;
    switch (t2.length) {
      case 0:
        return new e22();
      case 1:
        return new e22(t2[0]);
      case 2:
        return new e22(t2[0], t2[1]);
      case 3:
        return new e22(t2[0], t2[1], t2[2]);
      case 4:
        return new e22(t2[0], t2[1], t2[2], t2[3]);
      case 5:
        return new e22(t2[0], t2[1], t2[2], t2[3], t2[4]);
      case 6:
        return new e22(t2[0], t2[1], t2[2], t2[3], t2[4], t2[5]);
      case 7:
        return new e22(t2[0], t2[1], t2[2], t2[3], t2[4], t2[5], t2[6]);
    }
    var n2 = Nu(e22.prototype), r2 = e22.apply(n2, t2);
    return ou(r2) ? r2 : n2;
  };
}
function Iu(e22, t2, n2) {
  switch (n2.length) {
    case 0:
      return e22.call(t2);
    case 1:
      return e22.call(t2, n2[0]);
    case 2:
      return e22.call(t2, n2[0], n2[1]);
    case 3:
      return e22.call(t2, n2[0], n2[1], n2[2]);
  }
  return e22.apply(t2, n2);
}
var Ru = Math.max;
function Du(e22, t2, n2, r2) {
  for (var i2 = -1, o2 = e22.length, a2 = n2.length, s2 = -1, u2 = t2.length, c2 = Ru(o2 - a2, 0), l2 = Array(u2 + c2), f2 = !r2; ++s2 < u2; )
    l2[s2] = t2[s2];
  for (; ++i2 < a2; )
    (f2 || i2 < o2) && (l2[n2[i2]] = e22[i2]);
  for (; c2--; )
    l2[s2++] = e22[i2++];
  return l2;
}
var zu = Math.max;
function Lu(e22, t2, n2, r2) {
  for (var i2 = -1, o2 = e22.length, a2 = -1, s2 = n2.length, u2 = -1, c2 = t2.length, l2 = zu(o2 - s2, 0), f2 = Array(l2 + c2), h2 = !r2; ++i2 < l2; )
    f2[i2] = e22[i2];
  for (var d2 = i2; ++u2 < c2; )
    f2[d2 + u2] = t2[u2];
  for (; ++a2 < s2; )
    (h2 || i2 < o2) && (f2[d2 + n2[a2]] = e22[i2++]);
  return f2;
}
function Bu(e22, t2) {
  for (var n2 = e22.length, r2 = 0; n2--; )
    e22[n2] === t2 && ++r2;
  return r2;
}
function qu() {
}
function Fu(e22) {
  this.__wrapped__ = e22, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = 4294967295, this.__views__ = [];
}
function Vu() {
}
Fu.prototype = Nu(qu.prototype), Fu.prototype.constructor = Fu;
var Hu = Mu ? function(e22) {
  return Mu.get(e22);
} : Vu, Wu = {}, Ju = Object.prototype.hasOwnProperty;
function Uu(e22) {
  for (var t2 = e22.name + "", n2 = Wu[t2], r2 = Ju.call(Wu, t2) ? n2.length : 0; r2--; ) {
    var i2 = n2[r2], o2 = i2.func;
    if (o2 == null || o2 == e22)
      return i2.name;
  }
  return t2;
}
function Ku(e22, t2) {
  this.__wrapped__ = e22, this.__actions__ = [], this.__chain__ = !!t2, this.__index__ = 0, this.__values__ = void 0;
}
function Gu(e22, t2) {
  var n2 = -1, r2 = e22.length;
  for (t2 || (t2 = Array(r2)); ++n2 < r2; )
    t2[n2] = e22[n2];
  return t2;
}
function Qu(e22) {
  if (e22 instanceof Fu)
    return e22.clone();
  var t2 = new Ku(e22.__wrapped__, e22.__chain__);
  return t2.__actions__ = Gu(e22.__actions__), t2.__index__ = e22.__index__, t2.__values__ = e22.__values__, t2;
}
Ku.prototype = Nu(qu.prototype), Ku.prototype.constructor = Ku;
var Yu = Object.prototype.hasOwnProperty;
function Zu(e22) {
  if (Ws(e22) && !Gs(e22) && !(e22 instanceof Fu)) {
    if (e22 instanceof Ku)
      return e22;
    if (Yu.call(e22, "__wrapped__"))
      return Qu(e22);
  }
  return new Ku(e22);
}
function Xu(e22) {
  var t2 = Uu(e22), n2 = Zu[t2];
  if (typeof n2 != "function" || !(t2 in Fu.prototype))
    return false;
  if (e22 === n2)
    return true;
  var r2 = Hu(n2);
  return !!r2 && e22 === r2[0];
}
Zu.prototype = qu.prototype, Zu.prototype.constructor = Zu;
var ec = Date.now;
function tc(e22) {
  var t2 = 0, n2 = 0;
  return function() {
    var r2 = ec(), i2 = 16 - (r2 - n2);
    if (n2 = r2, i2 > 0) {
      if (++t2 >= 800)
        return arguments[0];
    } else
      t2 = 0;
    return e22.apply(void 0, arguments);
  };
}
var nc = tc(Eu), rc = /\{\n\/\* \[wrapped with (.+)\] \*/, ic = /,? & /;
var oc = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/;
function ac(e22) {
  return function() {
    return e22;
  };
}
var sc = function() {
  try {
    var e22 = Ou(Object, "defineProperty");
    return e22({}, "", {}), e22;
  } catch (e23) {
  }
}(), uc = tc(sc ? function(e22, t2) {
  return sc(e22, "toString", { configurable: true, enumerable: false, value: ac(t2), writable: true });
} : vu);
function cc(e22, t2) {
  for (var n2 = -1, r2 = e22 == null ? 0 : e22.length; ++n2 < r2 && t2(e22[n2], n2, e22) !== false; )
    ;
  return e22;
}
function lc(e22, t2, n2, r2) {
  for (var i2 = e22.length, o2 = n2 + (r2 ? 1 : -1); r2 ? o2-- : ++o2 < i2; )
    if (t2(e22[o2], o2, e22))
      return o2;
  return -1;
}
function fc(e22) {
  return e22 != e22;
}
function hc(e22, t2, n2) {
  return t2 == t2 ? function(e23, t3, n3) {
    for (var r2 = n3 - 1, i2 = e23.length; ++r2 < i2; )
      if (e23[r2] === t3)
        return r2;
    return -1;
  }(e22, t2, n2) : lc(e22, fc, n2);
}
function dc(e22, t2) {
  return !!(e22 == null ? 0 : e22.length) && hc(e22, t2, 0) > -1;
}
var vc = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]];
function pc(e22, t2, n2) {
  var r2 = t2 + "";
  return uc(e22, function(e23, t3) {
    var n3 = t3.length;
    if (!n3)
      return e23;
    var r3 = n3 - 1;
    return t3[r3] = (n3 > 1 ? "& " : "") + t3[r3], t3 = t3.join(n3 > 2 ? ", " : " "), e23.replace(oc, "{\n/* [wrapped with " + t3 + "] */\n");
  }(r2, function(e23, t3) {
    return cc(vc, function(n3) {
      var r3 = "_." + n3[0];
      t3 & n3[1] && !dc(e23, r3) && e23.push(r3);
    }), e23.sort();
  }(function(e23) {
    var t3 = e23.match(rc);
    return t3 ? t3[1].split(ic) : [];
  }(r2), n2)));
}
function mc(e22, t2, n2, r2, i2, o2, a2, s2, u2, c2) {
  var l2 = 8 & t2;
  t2 |= l2 ? 32 : 64, 4 & (t2 &= ~(l2 ? 64 : 32)) || (t2 &= -4);
  var f2 = [e22, t2, i2, l2 ? o2 : void 0, l2 ? a2 : void 0, l2 ? void 0 : o2, l2 ? void 0 : a2, s2, u2, c2], h2 = n2.apply(void 0, f2);
  return Xu(e22) && nc(h2, f2), h2.placeholder = r2, pc(h2, e22, t2);
}
function gc(e22) {
  return e22.placeholder;
}
var yc = /^(?:0|[1-9]\d*)$/;
function bc(e22, t2) {
  var n2 = Li(e22);
  return !!(t2 = t2 == null ? 9007199254740991 : t2) && (n2 == "number" || n2 != "symbol" && yc.test(e22)) && e22 > -1 && e22 % 1 == 0 && e22 < t2;
}
var kc = Math.min;
function wc(e22, t2) {
  for (var n2 = e22.length, r2 = kc(t2.length, n2), i2 = Gu(e22); r2--; ) {
    var o2 = t2[r2];
    e22[r2] = bc(o2, n2) ? i2[o2] : void 0;
  }
  return e22;
}
function xc(e22, t2) {
  for (var n2 = -1, r2 = e22.length, i2 = 0, o2 = []; ++n2 < r2; ) {
    var a2 = e22[n2];
    a2 !== t2 && a2 !== "__lodash_placeholder__" || (e22[n2] = "__lodash_placeholder__", o2[i2++] = n2);
  }
  return o2;
}
function jc(e22, t2, n2, r2, i2, o2, a2, s2, u2, c2) {
  var l2 = 128 & t2, f2 = 1 & t2, h2 = 2 & t2, d2 = 24 & t2, v2 = 512 & t2, p2 = h2 ? void 0 : Tu(e22);
  return function m2() {
    for (var g2 = arguments.length, y2 = Array(g2), b2 = g2; b2--; )
      y2[b2] = arguments[b2];
    if (d2)
      var k2 = gc(m2), w2 = Bu(y2, k2);
    if (r2 && (y2 = Du(y2, r2, i2, d2)), o2 && (y2 = Lu(y2, o2, a2, d2)), g2 -= w2, d2 && g2 < c2) {
      var x2 = xc(y2, k2);
      return mc(e22, t2, jc, m2.placeholder, n2, y2, x2, s2, u2, c2 - g2);
    }
    var j2 = f2 ? n2 : this, S2 = h2 ? j2[e22] : e22;
    return g2 = y2.length, s2 ? y2 = wc(y2, s2) : v2 && g2 > 1 && y2.reverse(), l2 && u2 < g2 && (y2.length = u2), this && this !== Rs && this instanceof m2 && (S2 = p2 || Tu(S2)), S2.apply(j2, y2);
  };
}
var Sc = Math.min;
var Cc = Math.max;
function _c(e22, t2, n2, r2, i2, o2, a2, s2) {
  var u2 = 2 & t2;
  if (!u2 && typeof e22 != "function")
    throw new TypeError("Expected a function");
  var c2 = r2 ? r2.length : 0;
  if (c2 || (t2 &= -97, r2 = i2 = void 0), a2 = a2 === void 0 ? a2 : Cc(hu(a2), 0), s2 = s2 === void 0 ? s2 : hu(s2), c2 -= i2 ? i2.length : 0, 64 & t2) {
    var l2 = r2, f2 = i2;
    r2 = i2 = void 0;
  }
  var h2 = u2 ? void 0 : Hu(e22), d2 = [e22, t2, n2, r2, i2, l2, f2, o2, a2, s2];
  if (h2 && function(e23, t3) {
    var n3 = e23[1], r3 = t3[1], i3 = n3 | r3, o3 = i3 < 131, a3 = r3 == 128 && n3 == 8 || r3 == 128 && n3 == 256 && e23[7].length <= t3[8] || r3 == 384 && t3[7].length <= t3[8] && n3 == 8;
    if (!o3 && !a3)
      return e23;
    1 & r3 && (e23[2] = t3[2], i3 |= 1 & n3 ? 0 : 4);
    var s3 = t3[3];
    if (s3) {
      var u3 = e23[3];
      e23[3] = u3 ? Du(u3, s3, t3[4]) : s3, e23[4] = u3 ? xc(e23[3], "__lodash_placeholder__") : t3[4];
    }
    (s3 = t3[5]) && (u3 = e23[5], e23[5] = u3 ? Lu(u3, s3, t3[6]) : s3, e23[6] = u3 ? xc(e23[5], "__lodash_placeholder__") : t3[6]), (s3 = t3[7]) && (e23[7] = s3), 128 & r3 && (e23[8] = e23[8] == null ? t3[8] : Sc(e23[8], t3[8])), e23[9] == null && (e23[9] = t3[9]), e23[0] = t3[0], e23[1] = i3;
  }(d2, h2), e22 = d2[0], t2 = d2[1], n2 = d2[2], r2 = d2[3], i2 = d2[4], !(s2 = d2[9] = d2[9] === void 0 ? u2 ? 0 : e22.length : Cc(d2[9] - c2, 0)) && 24 & t2 && (t2 &= -25), t2 && t2 != 1)
    v2 = t2 == 8 || t2 == 16 ? function(e23, t3, n3) {
      var r3 = Tu(e23);
      return function i3() {
        for (var o3 = arguments.length, a3 = Array(o3), s3 = o3, u3 = gc(i3); s3--; )
          a3[s3] = arguments[s3];
        var c3 = o3 < 3 && a3[0] !== u3 && a3[o3 - 1] !== u3 ? [] : xc(a3, u3);
        return (o3 -= c3.length) < n3 ? mc(e23, t3, jc, i3.placeholder, void 0, a3, c3, void 0, void 0, n3 - o3) : Iu(this && this !== Rs && this instanceof i3 ? r3 : e23, this, a3);
      };
    }(e22, t2, s2) : t2 != 32 && t2 != 33 || i2.length ? jc.apply(void 0, d2) : function(e23, t3, n3, r3) {
      var i3 = 1 & t3, o3 = Tu(e23);
      return function t4() {
        for (var a3 = -1, s3 = arguments.length, u3 = -1, c3 = r3.length, l3 = Array(c3 + s3), f3 = this && this !== Rs && this instanceof t4 ? o3 : e23; ++u3 < c3; )
          l3[u3] = r3[u3];
        for (; s3--; )
          l3[u3++] = arguments[++a3];
        return Iu(f3, i3 ? n3 : this, l3);
      };
    }(e22, t2, n2, r2);
  else
    var v2 = function(e23, t3, n3) {
      var r3 = 1 & t3, i3 = Tu(e23);
      return function t4() {
        return (this && this !== Rs && this instanceof t4 ? i3 : e23).apply(r3 ? n3 : this, arguments);
      };
    }(e22, t2, n2);
  return pc((h2 ? Eu : nc)(v2, d2), e22, t2);
}
function $c(e22, t2, n2) {
  return t2 = n2 ? void 0 : t2, _c(e22, 128, void 0, void 0, void 0, void 0, t2 = e22 && t2 == null ? e22.length : t2);
}
function Oc(e22, t2, n2) {
  t2 == "__proto__" && sc ? sc(e22, t2, { configurable: true, enumerable: true, value: n2, writable: true }) : e22[t2] = n2;
}
function Ac(e22, t2) {
  return e22 === t2 || e22 != e22 && t2 != t2;
}
var Mc = Object.prototype.hasOwnProperty;
function Ec(e22, t2, n2) {
  var r2 = e22[t2];
  Mc.call(e22, t2) && Ac(r2, n2) && (n2 !== void 0 || t2 in e22) || Oc(e22, t2, n2);
}
function Pc(e22, t2, n2, r2) {
  var i2 = !n2;
  n2 || (n2 = {});
  for (var o2 = -1, a2 = t2.length; ++o2 < a2; ) {
    var s2 = t2[o2], u2 = r2 ? r2(n2[s2], e22[s2], s2, n2, e22) : void 0;
    u2 === void 0 && (u2 = e22[s2]), i2 ? Oc(n2, s2, u2) : Ec(n2, s2, u2);
  }
  return n2;
}
var Nc = Math.max;
function Tc(e22, t2, n2) {
  return t2 = Nc(t2 === void 0 ? e22.length - 1 : t2, 0), function() {
    for (var r2 = arguments, i2 = -1, o2 = Nc(r2.length - t2, 0), a2 = Array(o2); ++i2 < o2; )
      a2[i2] = r2[t2 + i2];
    i2 = -1;
    for (var s2 = Array(t2 + 1); ++i2 < t2; )
      s2[i2] = r2[i2];
    return s2[t2] = n2(a2), Iu(e22, this, s2);
  };
}
function Ic(e22, t2) {
  return uc(Tc(e22, t2, vu), e22 + "");
}
function Rc(e22) {
  return typeof e22 == "number" && e22 > -1 && e22 % 1 == 0 && e22 <= 9007199254740991;
}
function Dc(e22) {
  return e22 != null && Rc(e22.length) && !pu(e22);
}
function zc(e22, t2, n2) {
  if (!ou(n2))
    return false;
  var r2 = Li(t2);
  return !!(r2 == "number" ? Dc(n2) && bc(t2, n2.length) : r2 == "string" && t2 in n2) && Ac(n2[t2], e22);
}
function Lc(e22) {
  return Ic(function(t2, n2) {
    var r2 = -1, i2 = n2.length, o2 = i2 > 1 ? n2[i2 - 1] : void 0, a2 = i2 > 2 ? n2[2] : void 0;
    for (o2 = e22.length > 3 && typeof o2 == "function" ? (i2--, o2) : void 0, a2 && zc(n2[0], n2[1], a2) && (o2 = i2 < 3 ? void 0 : o2, i2 = 1), t2 = Object(t2); ++r2 < i2; ) {
      var s2 = n2[r2];
      s2 && e22(t2, s2, r2, o2);
    }
    return t2;
  });
}
var Bc = Object.prototype;
function qc(e22) {
  var t2 = e22 && e22.constructor;
  return e22 === (typeof t2 == "function" && t2.prototype || Bc);
}
function Fc(e22, t2) {
  for (var n2 = -1, r2 = Array(e22); ++n2 < e22; )
    r2[n2] = t2(n2);
  return r2;
}
function Vc(e22) {
  return Ws(e22) && Hs(e22) == "[object Arguments]";
}
var Hc = Object.prototype, Wc = Hc.hasOwnProperty, Jc = Hc.propertyIsEnumerable, Uc = Vc(function() {
  return arguments;
}()) ? Vc : function(e22) {
  return Ws(e22) && Wc.call(e22, "callee") && !Jc.call(e22, "callee");
};
function Kc() {
  return false;
}
var Gc = (typeof exports == "undefined" ? "undefined" : Li(exports)) == "object" && exports && !exports.nodeType && exports, Qc = Gc && (typeof module == "undefined" ? "undefined" : Li(module)) == "object" && module && !module.nodeType && module, Yc = Qc && Qc.exports === Gc ? Rs.Buffer : void 0, Zc = (Yc ? Yc.isBuffer : void 0) || Kc, Xc = {};
function el(e22) {
  return function(t2) {
    return e22(t2);
  };
}
Xc["[object Float32Array]"] = Xc["[object Float64Array]"] = Xc["[object Int8Array]"] = Xc["[object Int16Array]"] = Xc["[object Int32Array]"] = Xc["[object Uint8Array]"] = Xc["[object Uint8ClampedArray]"] = Xc["[object Uint16Array]"] = Xc["[object Uint32Array]"] = true, Xc["[object Arguments]"] = Xc["[object Array]"] = Xc["[object ArrayBuffer]"] = Xc["[object Boolean]"] = Xc["[object DataView]"] = Xc["[object Date]"] = Xc["[object Error]"] = Xc["[object Function]"] = Xc["[object Map]"] = Xc["[object Number]"] = Xc["[object Object]"] = Xc["[object RegExp]"] = Xc["[object Set]"] = Xc["[object String]"] = Xc["[object WeakMap]"] = false;
var tl = (typeof exports == "undefined" ? "undefined" : Li(exports)) == "object" && exports && !exports.nodeType && exports, nl = tl && (typeof module == "undefined" ? "undefined" : Li(module)) == "object" && module && !module.nodeType && module, rl = nl && nl.exports === tl && Ts.process, il = function() {
  try {
    var e22 = nl && nl.require && nl.require("util").types;
    return e22 || rl && rl.binding && rl.binding("util");
  } catch (e23) {
  }
}(), ol = il && il.isTypedArray, al = ol ? el(ol) : function(e22) {
  return Ws(e22) && Rc(e22.length) && !!Xc[Hs(e22)];
}, sl = Object.prototype.hasOwnProperty;
function ul(e22, t2) {
  var n2 = Gs(e22), r2 = !n2 && Uc(e22), i2 = !n2 && !r2 && Zc(e22), o2 = !n2 && !r2 && !i2 && al(e22), a2 = n2 || r2 || i2 || o2, s2 = a2 ? Fc(e22.length, String) : [], u2 = s2.length;
  for (var c2 in e22)
    !t2 && !sl.call(e22, c2) || a2 && (c2 == "length" || i2 && (c2 == "offset" || c2 == "parent") || o2 && (c2 == "buffer" || c2 == "byteLength" || c2 == "byteOffset") || bc(c2, u2)) || s2.push(c2);
  return s2;
}
function cl(e22, t2) {
  return function(n2) {
    return e22(t2(n2));
  };
}
var ll = cl(Object.keys, Object), fl = Object.prototype.hasOwnProperty;
function hl(e22) {
  if (!qc(e22))
    return ll(e22);
  var t2 = [];
  for (var n2 in Object(e22))
    fl.call(e22, n2) && n2 != "constructor" && t2.push(n2);
  return t2;
}
function dl(e22) {
  return Dc(e22) ? ul(e22) : hl(e22);
}
var vl = Object.prototype.hasOwnProperty, pl = Lc(function(e22, t2) {
  if (qc(t2) || Dc(t2))
    Pc(t2, dl(t2), e22);
  else
    for (var n2 in t2)
      vl.call(t2, n2) && Ec(e22, n2, t2[n2]);
});
var ml = Object.prototype.hasOwnProperty;
function gl(e22) {
  if (!ou(e22))
    return function(e23) {
      var t3 = [];
      if (e23 != null)
        for (var n3 in Object(e23))
          t3.push(n3);
      return t3;
    }(e22);
  var t2 = qc(e22), n2 = [];
  for (var r2 in e22)
    (r2 != "constructor" || !t2 && ml.call(e22, r2)) && n2.push(r2);
  return n2;
}
function yl(e22) {
  return Dc(e22) ? ul(e22, true) : gl(e22);
}
var bl = Lc(function(e22, t2) {
  Pc(t2, yl(t2), e22);
}), kl = Lc(function(e22, t2, n2, r2) {
  Pc(t2, yl(t2), e22, r2);
}), wl = Lc(function(e22, t2, n2, r2) {
  Pc(t2, dl(t2), e22, r2);
}), xl = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, jl = /^\w*$/;
function Sl(e22, t2) {
  if (Gs(e22))
    return false;
  var n2 = Li(e22);
  return !(n2 != "number" && n2 != "symbol" && n2 != "boolean" && e22 != null && !Js(e22)) || (jl.test(e22) || !xl.test(e22) || t2 != null && e22 in Object(t2));
}
var Cl = Ou(Object, "create");
var _l = Object.prototype.hasOwnProperty;
var $l = Object.prototype.hasOwnProperty;
function Ol(e22) {
  var t2 = -1, n2 = e22 == null ? 0 : e22.length;
  for (this.clear(); ++t2 < n2; ) {
    var r2 = e22[t2];
    this.set(r2[0], r2[1]);
  }
}
function Al(e22, t2) {
  for (var n2 = e22.length; n2--; )
    if (Ac(e22[n2][0], t2))
      return n2;
  return -1;
}
Ol.prototype.clear = function() {
  this.__data__ = Cl ? Cl(null) : {}, this.size = 0;
}, Ol.prototype.delete = function(e22) {
  var t2 = this.has(e22) && delete this.__data__[e22];
  return this.size -= t2 ? 1 : 0, t2;
}, Ol.prototype.get = function(e22) {
  var t2 = this.__data__;
  if (Cl) {
    var n2 = t2[e22];
    return n2 === "__lodash_hash_undefined__" ? void 0 : n2;
  }
  return _l.call(t2, e22) ? t2[e22] : void 0;
}, Ol.prototype.has = function(e22) {
  var t2 = this.__data__;
  return Cl ? t2[e22] !== void 0 : $l.call(t2, e22);
}, Ol.prototype.set = function(e22, t2) {
  var n2 = this.__data__;
  return this.size += this.has(e22) ? 0 : 1, n2[e22] = Cl && t2 === void 0 ? "__lodash_hash_undefined__" : t2, this;
};
var Ml = Array.prototype.splice;
function El(e22) {
  var t2 = -1, n2 = e22 == null ? 0 : e22.length;
  for (this.clear(); ++t2 < n2; ) {
    var r2 = e22[t2];
    this.set(r2[0], r2[1]);
  }
}
El.prototype.clear = function() {
  this.__data__ = [], this.size = 0;
}, El.prototype.delete = function(e22) {
  var t2 = this.__data__, n2 = Al(t2, e22);
  return !(n2 < 0) && (n2 == t2.length - 1 ? t2.pop() : Ml.call(t2, n2, 1), --this.size, true);
}, El.prototype.get = function(e22) {
  var t2 = this.__data__, n2 = Al(t2, e22);
  return n2 < 0 ? void 0 : t2[n2][1];
}, El.prototype.has = function(e22) {
  return Al(this.__data__, e22) > -1;
}, El.prototype.set = function(e22, t2) {
  var n2 = this.__data__, r2 = Al(n2, e22);
  return r2 < 0 ? (++this.size, n2.push([e22, t2])) : n2[r2][1] = t2, this;
};
var Pl = Ou(Rs, "Map");
function Nl(e22, t2) {
  var n2, r2, i2 = e22.__data__;
  return ((r2 = Li(n2 = t2)) == "string" || r2 == "number" || r2 == "symbol" || r2 == "boolean" ? n2 !== "__proto__" : n2 === null) ? i2[typeof t2 == "string" ? "string" : "hash"] : i2.map;
}
function Tl(e22) {
  var t2 = -1, n2 = e22 == null ? 0 : e22.length;
  for (this.clear(); ++t2 < n2; ) {
    var r2 = e22[t2];
    this.set(r2[0], r2[1]);
  }
}
Tl.prototype.clear = function() {
  this.size = 0, this.__data__ = { hash: new Ol(), map: new (Pl || El)(), string: new Ol() };
}, Tl.prototype.delete = function(e22) {
  var t2 = Nl(this, e22).delete(e22);
  return this.size -= t2 ? 1 : 0, t2;
}, Tl.prototype.get = function(e22) {
  return Nl(this, e22).get(e22);
}, Tl.prototype.has = function(e22) {
  return Nl(this, e22).has(e22);
}, Tl.prototype.set = function(e22, t2) {
  var n2 = Nl(this, e22), r2 = n2.size;
  return n2.set(e22, t2), this.size += n2.size == r2 ? 0 : 1, this;
};
function Il(e22, t2) {
  if (typeof e22 != "function" || t2 != null && typeof t2 != "function")
    throw new TypeError("Expected a function");
  var n2 = function n3() {
    var r2 = arguments, i2 = t2 ? t2.apply(this, r2) : r2[0], o2 = n3.cache;
    if (o2.has(i2))
      return o2.get(i2);
    var a2 = e22.apply(this, r2);
    return n3.cache = o2.set(i2, a2) || o2, a2;
  };
  return n2.cache = new (Il.Cache || Tl)(), n2;
}
Il.Cache = Tl;
var Rl = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, Dl = /\\(\\)?/g, zl = function(e22) {
  var t2 = Il(e22, function(e23) {
    return n2.size === 500 && n2.clear(), e23;
  }), n2 = t2.cache;
  return t2;
}(function(e22) {
  var t2 = [];
  return e22.charCodeAt(0) === 46 && t2.push(""), e22.replace(Rl, function(e23, n2, r2, i2) {
    t2.push(r2 ? i2.replace(Dl, "$1") : n2 || e23);
  }), t2;
});
function Ll(e22) {
  return e22 == null ? "" : Zs(e22);
}
function Bl(e22, t2) {
  return Gs(e22) ? e22 : Sl(e22, t2) ? [e22] : zl(Ll(e22));
}
function ql(e22) {
  if (typeof e22 == "string" || Js(e22))
    return e22;
  var t2 = e22 + "";
  return t2 == "0" && 1 / e22 == -Infinity ? "-0" : t2;
}
function Fl(e22, t2) {
  for (var n2 = 0, r2 = (t2 = Bl(t2, e22)).length; e22 != null && n2 < r2; )
    e22 = e22[ql(t2[n2++])];
  return n2 && n2 == r2 ? e22 : void 0;
}
function Vl(e22, t2, n2) {
  var r2 = e22 == null ? void 0 : Fl(e22, t2);
  return r2 === void 0 ? n2 : r2;
}
function Hl(e22, t2) {
  for (var n2 = -1, r2 = t2.length, i2 = Array(r2), o2 = e22 == null; ++n2 < r2; )
    i2[n2] = o2 ? void 0 : Vl(e22, t2[n2]);
  return i2;
}
function Wl(e22, t2) {
  for (var n2 = -1, r2 = t2.length, i2 = e22.length; ++n2 < r2; )
    e22[i2 + n2] = t2[n2];
  return e22;
}
var Jl = Ds ? Ds.isConcatSpreadable : void 0;
function Ul(e22) {
  return Gs(e22) || Uc(e22) || !!(Jl && e22 && e22[Jl]);
}
function Kl(e22, t2, n2, r2, i2) {
  var o2 = -1, a2 = e22.length;
  for (n2 || (n2 = Ul), i2 || (i2 = []); ++o2 < a2; ) {
    var s2 = e22[o2];
    t2 > 0 && n2(s2) ? t2 > 1 ? Kl(s2, t2 - 1, n2, r2, i2) : Wl(i2, s2) : r2 || (i2[i2.length] = s2);
  }
  return i2;
}
function Gl(e22) {
  return (e22 == null ? 0 : e22.length) ? Kl(e22, 1) : [];
}
function Ql(e22) {
  return uc(Tc(e22, void 0, Gl), e22 + "");
}
var Yl = Ql(Hl), Zl = cl(Object.getPrototypeOf, Object), Xl = Function.prototype, ef = Object.prototype, tf = Xl.toString, nf = ef.hasOwnProperty, rf = tf.call(Object);
function of(e22) {
  if (!Ws(e22) || Hs(e22) != "[object Object]")
    return false;
  var t2 = Zl(e22);
  if (t2 === null)
    return true;
  var n2 = nf.call(t2, "constructor") && t2.constructor;
  return typeof n2 == "function" && n2 instanceof n2 && tf.call(n2) == rf;
}
function af(e22) {
  if (!Ws(e22))
    return false;
  var t2 = Hs(e22);
  return t2 == "[object Error]" || t2 == "[object DOMException]" || typeof e22.message == "string" && typeof e22.name == "string" && !of(e22);
}
var sf = Ic(function(e22, t2) {
  try {
    return Iu(e22, void 0, t2);
  } catch (e23) {
    return af(e23) ? e23 : new Error(e23);
  }
});
function uf(e22, t2) {
  var n2;
  if (typeof t2 != "function")
    throw new TypeError("Expected a function");
  return e22 = hu(e22), function() {
    return --e22 > 0 && (n2 = t2.apply(this, arguments)), e22 <= 1 && (t2 = void 0), n2;
  };
}
var cf = Ic(function(e22, t2, n2) {
  var r2 = 1;
  if (n2.length) {
    var i2 = xc(n2, gc(cf));
    r2 |= 32;
  }
  return _c(e22, r2, t2, n2, i2);
});
cf.placeholder = {};
var lf = Ql(function(e22, t2) {
  return cc(t2, function(t3) {
    t3 = ql(t3), Oc(e22, t3, cf(e22[t3], e22));
  }), e22;
}), ff = Ic(function(e22, t2, n2) {
  var r2 = 3;
  if (n2.length) {
    var i2 = xc(n2, gc(ff));
    r2 |= 32;
  }
  return _c(t2, r2, e22, n2, i2);
});
function hf(e22, t2, n2) {
  var r2 = -1, i2 = e22.length;
  t2 < 0 && (t2 = -t2 > i2 ? 0 : i2 + t2), (n2 = n2 > i2 ? i2 : n2) < 0 && (n2 += i2), i2 = t2 > n2 ? 0 : n2 - t2 >>> 0, t2 >>>= 0;
  for (var o2 = Array(i2); ++r2 < i2; )
    o2[r2] = e22[r2 + t2];
  return o2;
}
function df(e22, t2, n2) {
  var r2 = e22.length;
  return n2 = n2 === void 0 ? r2 : n2, !t2 && n2 >= r2 ? e22 : hf(e22, t2, n2);
}
ff.placeholder = {};
var vf = RegExp("[\\u200d\\ud800-\\udfff\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff\\ufe0e\\ufe0f]");
function pf(e22) {
  return vf.test(e22);
}
var mf = "[\\ud800-\\udfff]", gf = "[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]", yf = "\\ud83c[\\udffb-\\udfff]", bf = "[^\\ud800-\\udfff]", kf = "(?:\\ud83c[\\udde6-\\uddff]){2}", wf = "[\\ud800-\\udbff][\\udc00-\\udfff]", xf = "(?:" + gf + "|" + yf + ")?", jf = "[\\ufe0e\\ufe0f]?" + xf + ("(?:\\u200d(?:" + [bf, kf, wf].join("|") + ")[\\ufe0e\\ufe0f]?" + xf + ")*"), Sf = "(?:" + [bf + gf + "?", gf, kf, wf, mf].join("|") + ")", Cf = RegExp(yf + "(?=" + yf + ")|" + Sf + jf, "g");
function _f(e22) {
  return pf(e22) ? function(e23) {
    return e23.match(Cf) || [];
  }(e22) : function(e23) {
    return e23.split("");
  }(e22);
}
function $f(e22) {
  return function(t2) {
    var n2 = pf(t2 = Ll(t2)) ? _f(t2) : void 0, r2 = n2 ? n2[0] : t2.charAt(0), i2 = n2 ? df(n2, 1).join("") : t2.slice(1);
    return r2[e22]() + i2;
  };
}
var Of = $f("toUpperCase");
function Af(e22) {
  return Of(Ll(e22).toLowerCase());
}
function Mf(e22, t2, n2, r2) {
  var i2 = -1, o2 = e22 == null ? 0 : e22.length;
  for (r2 && o2 && (n2 = e22[++i2]); ++i2 < o2; )
    n2 = t2(n2, e22[i2], i2, e22);
  return n2;
}
function Ef(e22) {
  return function(t2) {
    return e22 == null ? void 0 : e22[t2];
  };
}
var Pf = Ef({ "\xC0": "A", "\xC1": "A", "\xC2": "A", "\xC3": "A", "\xC4": "A", "\xC5": "A", "\xE0": "a", "\xE1": "a", "\xE2": "a", "\xE3": "a", "\xE4": "a", "\xE5": "a", "\xC7": "C", "\xE7": "c", "\xD0": "D", "\xF0": "d", "\xC8": "E", "\xC9": "E", "\xCA": "E", "\xCB": "E", "\xE8": "e", "\xE9": "e", "\xEA": "e", "\xEB": "e", "\xCC": "I", "\xCD": "I", "\xCE": "I", "\xCF": "I", "\xEC": "i", "\xED": "i", "\xEE": "i", "\xEF": "i", "\xD1": "N", "\xF1": "n", "\xD2": "O", "\xD3": "O", "\xD4": "O", "\xD5": "O", "\xD6": "O", "\xD8": "O", "\xF2": "o", "\xF3": "o", "\xF4": "o", "\xF5": "o", "\xF6": "o", "\xF8": "o", "\xD9": "U", "\xDA": "U", "\xDB": "U", "\xDC": "U", "\xF9": "u", "\xFA": "u", "\xFB": "u", "\xFC": "u", "\xDD": "Y", "\xFD": "y", "\xFF": "y", "\xC6": "Ae", "\xE6": "ae", "\xDE": "Th", "\xFE": "th", "\xDF": "ss", "\u0100": "A", "\u0102": "A", "\u0104": "A", "\u0101": "a", "\u0103": "a", "\u0105": "a", "\u0106": "C", "\u0108": "C", "\u010A": "C", "\u010C": "C", "\u0107": "c", "\u0109": "c", "\u010B": "c", "\u010D": "c", "\u010E": "D", "\u0110": "D", "\u010F": "d", "\u0111": "d", "\u0112": "E", "\u0114": "E", "\u0116": "E", "\u0118": "E", "\u011A": "E", "\u0113": "e", "\u0115": "e", "\u0117": "e", "\u0119": "e", "\u011B": "e", "\u011C": "G", "\u011E": "G", "\u0120": "G", "\u0122": "G", "\u011D": "g", "\u011F": "g", "\u0121": "g", "\u0123": "g", "\u0124": "H", "\u0126": "H", "\u0125": "h", "\u0127": "h", "\u0128": "I", "\u012A": "I", "\u012C": "I", "\u012E": "I", "\u0130": "I", "\u0129": "i", "\u012B": "i", "\u012D": "i", "\u012F": "i", "\u0131": "i", "\u0134": "J", "\u0135": "j", "\u0136": "K", "\u0137": "k", "\u0138": "k", "\u0139": "L", "\u013B": "L", "\u013D": "L", "\u013F": "L", "\u0141": "L", "\u013A": "l", "\u013C": "l", "\u013E": "l", "\u0140": "l", "\u0142": "l", "\u0143": "N", "\u0145": "N", "\u0147": "N", "\u014A": "N", "\u0144": "n", "\u0146": "n", "\u0148": "n", "\u014B": "n", "\u014C": "O", "\u014E": "O", "\u0150": "O", "\u014D": "o", "\u014F": "o", "\u0151": "o", "\u0154": "R", "\u0156": "R", "\u0158": "R", "\u0155": "r", "\u0157": "r", "\u0159": "r", "\u015A": "S", "\u015C": "S", "\u015E": "S", "\u0160": "S", "\u015B": "s", "\u015D": "s", "\u015F": "s", "\u0161": "s", "\u0162": "T", "\u0164": "T", "\u0166": "T", "\u0163": "t", "\u0165": "t", "\u0167": "t", "\u0168": "U", "\u016A": "U", "\u016C": "U", "\u016E": "U", "\u0170": "U", "\u0172": "U", "\u0169": "u", "\u016B": "u", "\u016D": "u", "\u016F": "u", "\u0171": "u", "\u0173": "u", "\u0174": "W", "\u0175": "w", "\u0176": "Y", "\u0177": "y", "\u0178": "Y", "\u0179": "Z", "\u017B": "Z", "\u017D": "Z", "\u017A": "z", "\u017C": "z", "\u017E": "z", "\u0132": "IJ", "\u0133": "ij", "\u0152": "Oe", "\u0153": "oe", "\u0149": "'n", "\u017F": "s" }), Nf = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, Tf = RegExp("[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]", "g");
function If(e22) {
  return (e22 = Ll(e22)) && e22.replace(Nf, Pf).replace(Tf, "");
}
var Rf = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
var Df = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
var zf = "\\xac\\xb1\\xd7\\xf7\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf\\u2000-\\u206f \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", Lf = "[" + zf + "]", Bf = "\\d+", qf = "[\\u2700-\\u27bf]", Ff = "[a-z\\xdf-\\xf6\\xf8-\\xff]", Vf = "[^\\ud800-\\udfff" + zf + Bf + "\\u2700-\\u27bfa-z\\xdf-\\xf6\\xf8-\\xffA-Z\\xc0-\\xd6\\xd8-\\xde]", Hf = "(?:\\ud83c[\\udde6-\\uddff]){2}", Wf = "[\\ud800-\\udbff][\\udc00-\\udfff]", Jf = "[A-Z\\xc0-\\xd6\\xd8-\\xde]", Uf = "(?:" + Ff + "|" + Vf + ")", Kf = "(?:" + Jf + "|" + Vf + ")", Gf = "(?:[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]|\\ud83c[\\udffb-\\udfff])?", Qf = "[\\ufe0e\\ufe0f]?" + Gf + ("(?:\\u200d(?:" + ["[^\\ud800-\\udfff]", Hf, Wf].join("|") + ")[\\ufe0e\\ufe0f]?" + Gf + ")*"), Yf = "(?:" + [qf, Hf, Wf].join("|") + ")" + Qf, Zf = RegExp([Jf + "?" + Ff + "+(?:['\u2019](?:d|ll|m|re|s|t|ve))?(?=" + [Lf, Jf, "$"].join("|") + ")", Kf + "+(?:['\u2019](?:D|LL|M|RE|S|T|VE))?(?=" + [Lf, Jf + Uf, "$"].join("|") + ")", Jf + "?" + Uf + "+(?:['\u2019](?:d|ll|m|re|s|t|ve))?", Jf + "+(?:['\u2019](?:D|LL|M|RE|S|T|VE))?", "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", Bf, Yf].join("|"), "g");
function Xf(e22, t2, n2) {
  return e22 = Ll(e22), (t2 = n2 ? void 0 : t2) === void 0 ? function(e23) {
    return Df.test(e23);
  }(e22) ? function(e23) {
    return e23.match(Zf) || [];
  }(e22) : function(e23) {
    return e23.match(Rf) || [];
  }(e22) : e22.match(t2) || [];
}
var eh = RegExp("['\u2019]", "g");
function th(e22) {
  return function(t2) {
    return Mf(Xf(If(t2).replace(eh, "")), e22, "");
  };
}
var nh = th(function(e22, t2, n2) {
  return t2 = t2.toLowerCase(), e22 + (n2 ? Af(t2) : t2);
});
function rh() {
  if (!arguments.length)
    return [];
  var e22 = arguments[0];
  return Gs(e22) ? e22 : [e22];
}
var ih = Rs.isFinite, oh = Math.min;
function ah(e22) {
  var t2 = Math[e22];
  return function(e23, n2) {
    if (e23 = lu(e23), (n2 = n2 == null ? 0 : oh(hu(n2), 292)) && ih(e23)) {
      var r2 = (Ll(e23) + "e").split("e");
      return +((r2 = (Ll(t2(r2[0] + "e" + (+r2[1] + n2))) + "e").split("e"))[0] + "e" + (+r2[1] - n2));
    }
    return t2(e23);
  };
}
var sh = ah("ceil");
function uh(e22) {
  var t2 = Zu(e22);
  return t2.__chain__ = true, t2;
}
var ch = Math.ceil, lh = Math.max;
function fh(e22, t2, n2) {
  t2 = (n2 ? zc(e22, t2, n2) : t2 === void 0) ? 1 : lh(hu(t2), 0);
  var r2 = e22 == null ? 0 : e22.length;
  if (!r2 || t2 < 1)
    return [];
  for (var i2 = 0, o2 = 0, a2 = Array(ch(r2 / t2)); i2 < r2; )
    a2[o2++] = hf(e22, i2, i2 += t2);
  return a2;
}
function hh(e22, t2, n2) {
  return e22 == e22 && (n2 !== void 0 && (e22 = e22 <= n2 ? e22 : n2), t2 !== void 0 && (e22 = e22 >= t2 ? e22 : t2)), e22;
}
function dh(e22, t2, n2) {
  return n2 === void 0 && (n2 = t2, t2 = void 0), n2 !== void 0 && (n2 = (n2 = lu(n2)) == n2 ? n2 : 0), t2 !== void 0 && (t2 = (t2 = lu(t2)) == t2 ? t2 : 0), hh(lu(e22), t2, n2);
}
function vh(e22) {
  var t2 = this.__data__ = new El(e22);
  this.size = t2.size;
}
function ph(e22, t2) {
  return e22 && Pc(t2, dl(t2), e22);
}
vh.prototype.clear = function() {
  this.__data__ = new El(), this.size = 0;
}, vh.prototype.delete = function(e22) {
  var t2 = this.__data__, n2 = t2.delete(e22);
  return this.size = t2.size, n2;
}, vh.prototype.get = function(e22) {
  return this.__data__.get(e22);
}, vh.prototype.has = function(e22) {
  return this.__data__.has(e22);
}, vh.prototype.set = function(e22, t2) {
  var n2 = this.__data__;
  if (n2 instanceof El) {
    var r2 = n2.__data__;
    if (!Pl || r2.length < 199)
      return r2.push([e22, t2]), this.size = ++n2.size, this;
    n2 = this.__data__ = new Tl(r2);
  }
  return n2.set(e22, t2), this.size = n2.size, this;
};
var mh = (typeof exports == "undefined" ? "undefined" : Li(exports)) == "object" && exports && !exports.nodeType && exports, gh = mh && (typeof module == "undefined" ? "undefined" : Li(module)) == "object" && module && !module.nodeType && module, yh = gh && gh.exports === mh ? Rs.Buffer : void 0, bh = yh ? yh.allocUnsafe : void 0;
function kh(e22, t2) {
  if (t2)
    return e22.slice();
  var n2 = e22.length, r2 = bh ? bh(n2) : new e22.constructor(n2);
  return e22.copy(r2), r2;
}
function wh(e22, t2) {
  for (var n2 = -1, r2 = e22 == null ? 0 : e22.length, i2 = 0, o2 = []; ++n2 < r2; ) {
    var a2 = e22[n2];
    t2(a2, n2, e22) && (o2[i2++] = a2);
  }
  return o2;
}
function xh() {
  return [];
}
var jh = Object.prototype.propertyIsEnumerable, Sh = Object.getOwnPropertySymbols, Ch = Sh ? function(e22) {
  return e22 == null ? [] : (e22 = Object(e22), wh(Sh(e22), function(t2) {
    return jh.call(e22, t2);
  }));
} : xh;
var _h = Object.getOwnPropertySymbols ? function(e22) {
  for (var t2 = []; e22; )
    Wl(t2, Ch(e22)), e22 = Zl(e22);
  return t2;
} : xh;
function $h(e22, t2, n2) {
  var r2 = t2(e22);
  return Gs(e22) ? r2 : Wl(r2, n2(e22));
}
function Oh(e22) {
  return $h(e22, dl, Ch);
}
function Ah(e22) {
  return $h(e22, yl, _h);
}
var Mh = Ou(Rs, "DataView"), Eh = Ou(Rs, "Promise"), Ph = Ou(Rs, "Set"), Nh = ku(Mh), Th = ku(Pl), Ih = ku(Eh), Rh = ku(Ph), Dh = ku(Au), zh = Hs;
(Mh && zh(new Mh(new ArrayBuffer(1))) != "[object DataView]" || Pl && zh(new Pl()) != "[object Map]" || Eh && zh(Eh.resolve()) != "[object Promise]" || Ph && zh(new Ph()) != "[object Set]" || Au && zh(new Au()) != "[object WeakMap]") && (zh = function(e22) {
  var t2 = Hs(e22), n2 = t2 == "[object Object]" ? e22.constructor : void 0, r2 = n2 ? ku(n2) : "";
  if (r2)
    switch (r2) {
      case Nh:
        return "[object DataView]";
      case Th:
        return "[object Map]";
      case Ih:
        return "[object Promise]";
      case Rh:
        return "[object Set]";
      case Dh:
        return "[object WeakMap]";
    }
  return t2;
});
var Lh = zh, Bh = Object.prototype.hasOwnProperty;
var qh = Rs.Uint8Array;
function Fh(e22) {
  var t2 = new e22.constructor(e22.byteLength);
  return new qh(t2).set(new qh(e22)), t2;
}
var Vh = /\w*$/;
var Hh = Ds ? Ds.prototype : void 0, Wh = Hh ? Hh.valueOf : void 0;
function Jh(e22, t2) {
  var n2 = t2 ? Fh(e22.buffer) : e22.buffer;
  return new e22.constructor(n2, e22.byteOffset, e22.length);
}
function Uh(e22, t2, n2) {
  var r2, i2 = e22.constructor;
  switch (t2) {
    case "[object ArrayBuffer]":
      return Fh(e22);
    case "[object Boolean]":
    case "[object Date]":
      return new i2(+e22);
    case "[object DataView]":
      return function(e23, t3) {
        var n3 = t3 ? Fh(e23.buffer) : e23.buffer;
        return new e23.constructor(n3, e23.byteOffset, e23.byteLength);
      }(e22, n2);
    case "[object Float32Array]":
    case "[object Float64Array]":
    case "[object Int8Array]":
    case "[object Int16Array]":
    case "[object Int32Array]":
    case "[object Uint8Array]":
    case "[object Uint8ClampedArray]":
    case "[object Uint16Array]":
    case "[object Uint32Array]":
      return Jh(e22, n2);
    case "[object Map]":
      return new i2();
    case "[object Number]":
    case "[object String]":
      return new i2(e22);
    case "[object RegExp]":
      return function(e23) {
        var t3 = new e23.constructor(e23.source, Vh.exec(e23));
        return t3.lastIndex = e23.lastIndex, t3;
      }(e22);
    case "[object Set]":
      return new i2();
    case "[object Symbol]":
      return r2 = e22, Wh ? Object(Wh.call(r2)) : {};
  }
}
function Kh(e22) {
  return typeof e22.constructor != "function" || qc(e22) ? {} : Nu(Zl(e22));
}
var Gh = il && il.isMap, Qh = Gh ? el(Gh) : function(e22) {
  return Ws(e22) && Lh(e22) == "[object Map]";
};
var Yh = il && il.isSet, Zh = Yh ? el(Yh) : function(e22) {
  return Ws(e22) && Lh(e22) == "[object Set]";
}, Xh = {};
function ed(e22, t2, n2, r2, i2, o2) {
  var a2, s2 = 1 & t2, u2 = 2 & t2, c2 = 4 & t2;
  if (n2 && (a2 = i2 ? n2(e22, r2, i2, o2) : n2(e22)), a2 !== void 0)
    return a2;
  if (!ou(e22))
    return e22;
  var l2 = Gs(e22);
  if (l2) {
    if (a2 = function(e23) {
      var t3 = e23.length, n3 = new e23.constructor(t3);
      return t3 && typeof e23[0] == "string" && Bh.call(e23, "index") && (n3.index = e23.index, n3.input = e23.input), n3;
    }(e22), !s2)
      return Gu(e22, a2);
  } else {
    var f2 = Lh(e22), h2 = f2 == "[object Function]" || f2 == "[object GeneratorFunction]";
    if (Zc(e22))
      return kh(e22, s2);
    if (f2 == "[object Object]" || f2 == "[object Arguments]" || h2 && !i2) {
      if (a2 = u2 || h2 ? {} : Kh(e22), !s2)
        return u2 ? function(e23, t3) {
          return Pc(e23, _h(e23), t3);
        }(e22, function(e23, t3) {
          return e23 && Pc(t3, yl(t3), e23);
        }(a2, e22)) : function(e23, t3) {
          return Pc(e23, Ch(e23), t3);
        }(e22, ph(a2, e22));
    } else {
      if (!Xh[f2])
        return i2 ? e22 : {};
      a2 = Uh(e22, f2, s2);
    }
  }
  o2 || (o2 = new vh());
  var d2 = o2.get(e22);
  if (d2)
    return d2;
  o2.set(e22, a2), Zh(e22) ? e22.forEach(function(r3) {
    a2.add(ed(r3, t2, n2, r3, e22, o2));
  }) : Qh(e22) && e22.forEach(function(r3, i3) {
    a2.set(i3, ed(r3, t2, n2, i3, e22, o2));
  });
  var v2 = l2 ? void 0 : (c2 ? u2 ? Ah : Oh : u2 ? yl : dl)(e22);
  return cc(v2 || e22, function(r3, i3) {
    v2 && (r3 = e22[i3 = r3]), Ec(a2, i3, ed(r3, t2, n2, i3, e22, o2));
  }), a2;
}
Xh["[object Arguments]"] = Xh["[object Array]"] = Xh["[object ArrayBuffer]"] = Xh["[object DataView]"] = Xh["[object Boolean]"] = Xh["[object Date]"] = Xh["[object Float32Array]"] = Xh["[object Float64Array]"] = Xh["[object Int8Array]"] = Xh["[object Int16Array]"] = Xh["[object Int32Array]"] = Xh["[object Map]"] = Xh["[object Number]"] = Xh["[object Object]"] = Xh["[object RegExp]"] = Xh["[object Set]"] = Xh["[object String]"] = Xh["[object Symbol]"] = Xh["[object Uint8Array]"] = Xh["[object Uint8ClampedArray]"] = Xh["[object Uint16Array]"] = Xh["[object Uint32Array]"] = true, Xh["[object Error]"] = Xh["[object Function]"] = Xh["[object WeakMap]"] = false;
function td(e22) {
  return ed(e22, 4);
}
function nd(e22) {
  return ed(e22, 5);
}
function rd(e22, t2) {
  return ed(e22, 5, t2 = typeof t2 == "function" ? t2 : void 0);
}
function id(e22, t2) {
  return ed(e22, 4, t2 = typeof t2 == "function" ? t2 : void 0);
}
function od() {
  return new Ku(this.value(), this.__chain__);
}
function ad(e22) {
  for (var t2 = -1, n2 = e22 == null ? 0 : e22.length, r2 = 0, i2 = []; ++t2 < n2; ) {
    var o2 = e22[t2];
    o2 && (i2[r2++] = o2);
  }
  return i2;
}
function sd() {
  var e22 = arguments.length;
  if (!e22)
    return [];
  for (var t2 = Array(e22 - 1), n2 = arguments[0], r2 = e22; r2--; )
    t2[r2 - 1] = arguments[r2];
  return Wl(Gs(n2) ? Gu(n2) : [n2], Kl(t2, 1));
}
function ud(e22) {
  var t2 = -1, n2 = e22 == null ? 0 : e22.length;
  for (this.__data__ = new Tl(); ++t2 < n2; )
    this.add(e22[t2]);
}
function cd(e22, t2) {
  for (var n2 = -1, r2 = e22 == null ? 0 : e22.length; ++n2 < r2; )
    if (t2(e22[n2], n2, e22))
      return true;
  return false;
}
function ld(e22, t2) {
  return e22.has(t2);
}
ud.prototype.add = ud.prototype.push = function(e22) {
  return this.__data__.set(e22, "__lodash_hash_undefined__"), this;
}, ud.prototype.has = function(e22) {
  return this.__data__.has(e22);
};
function fd(e22, t2, n2, r2, i2, o2) {
  var a2 = 1 & n2, s2 = e22.length, u2 = t2.length;
  if (s2 != u2 && !(a2 && u2 > s2))
    return false;
  var c2 = o2.get(e22), l2 = o2.get(t2);
  if (c2 && l2)
    return c2 == t2 && l2 == e22;
  var f2 = -1, h2 = true, d2 = 2 & n2 ? new ud() : void 0;
  for (o2.set(e22, t2), o2.set(t2, e22); ++f2 < s2; ) {
    var v2 = e22[f2], p2 = t2[f2];
    if (r2)
      var m2 = a2 ? r2(p2, v2, f2, t2, e22, o2) : r2(v2, p2, f2, e22, t2, o2);
    if (m2 !== void 0) {
      if (m2)
        continue;
      h2 = false;
      break;
    }
    if (d2) {
      if (!cd(t2, function(e23, t3) {
        if (!ld(d2, t3) && (v2 === e23 || i2(v2, e23, n2, r2, o2)))
          return d2.push(t3);
      })) {
        h2 = false;
        break;
      }
    } else if (v2 !== p2 && !i2(v2, p2, n2, r2, o2)) {
      h2 = false;
      break;
    }
  }
  return o2.delete(e22), o2.delete(t2), h2;
}
function hd(e22) {
  var t2 = -1, n2 = Array(e22.size);
  return e22.forEach(function(e23, r2) {
    n2[++t2] = [r2, e23];
  }), n2;
}
function dd(e22) {
  var t2 = -1, n2 = Array(e22.size);
  return e22.forEach(function(e23) {
    n2[++t2] = e23;
  }), n2;
}
var vd = Ds ? Ds.prototype : void 0, pd = vd ? vd.valueOf : void 0;
var md = Object.prototype.hasOwnProperty;
var gd = "[object Object]", yd = Object.prototype.hasOwnProperty;
function bd(e22, t2, n2, r2, i2, o2) {
  var a2 = Gs(e22), s2 = Gs(t2), u2 = a2 ? "[object Array]" : Lh(e22), c2 = s2 ? "[object Array]" : Lh(t2), l2 = (u2 = u2 == "[object Arguments]" ? gd : u2) == gd, f2 = (c2 = c2 == "[object Arguments]" ? gd : c2) == gd, h2 = u2 == c2;
  if (h2 && Zc(e22)) {
    if (!Zc(t2))
      return false;
    a2 = true, l2 = false;
  }
  if (h2 && !l2)
    return o2 || (o2 = new vh()), a2 || al(e22) ? fd(e22, t2, n2, r2, i2, o2) : function(e23, t3, n3, r3, i3, o3, a3) {
      switch (n3) {
        case "[object DataView]":
          if (e23.byteLength != t3.byteLength || e23.byteOffset != t3.byteOffset)
            return false;
          e23 = e23.buffer, t3 = t3.buffer;
        case "[object ArrayBuffer]":
          return !(e23.byteLength != t3.byteLength || !o3(new qh(e23), new qh(t3)));
        case "[object Boolean]":
        case "[object Date]":
        case "[object Number]":
          return Ac(+e23, +t3);
        case "[object Error]":
          return e23.name == t3.name && e23.message == t3.message;
        case "[object RegExp]":
        case "[object String]":
          return e23 == t3 + "";
        case "[object Map]":
          var s3 = hd;
        case "[object Set]":
          var u3 = 1 & r3;
          if (s3 || (s3 = dd), e23.size != t3.size && !u3)
            return false;
          var c3 = a3.get(e23);
          if (c3)
            return c3 == t3;
          r3 |= 2, a3.set(e23, t3);
          var l3 = fd(s3(e23), s3(t3), r3, i3, o3, a3);
          return a3.delete(e23), l3;
        case "[object Symbol]":
          if (pd)
            return pd.call(e23) == pd.call(t3);
      }
      return false;
    }(e22, t2, u2, n2, r2, i2, o2);
  if (!(1 & n2)) {
    var d2 = l2 && yd.call(e22, "__wrapped__"), v2 = f2 && yd.call(t2, "__wrapped__");
    if (d2 || v2) {
      var p2 = d2 ? e22.value() : e22, m2 = v2 ? t2.value() : t2;
      return o2 || (o2 = new vh()), i2(p2, m2, n2, r2, o2);
    }
  }
  return !!h2 && (o2 || (o2 = new vh()), function(e23, t3, n3, r3, i3, o3) {
    var a3 = 1 & n3, s3 = Oh(e23), u3 = s3.length;
    if (u3 != Oh(t3).length && !a3)
      return false;
    for (var c3 = u3; c3--; ) {
      var l3 = s3[c3];
      if (!(a3 ? l3 in t3 : md.call(t3, l3)))
        return false;
    }
    var f3 = o3.get(e23), h3 = o3.get(t3);
    if (f3 && h3)
      return f3 == t3 && h3 == e23;
    var d3 = true;
    o3.set(e23, t3), o3.set(t3, e23);
    for (var v3 = a3; ++c3 < u3; ) {
      var p3 = e23[l3 = s3[c3]], m3 = t3[l3];
      if (r3)
        var g2 = a3 ? r3(m3, p3, l3, t3, e23, o3) : r3(p3, m3, l3, e23, t3, o3);
      if (!(g2 === void 0 ? p3 === m3 || i3(p3, m3, n3, r3, o3) : g2)) {
        d3 = false;
        break;
      }
      v3 || (v3 = l3 == "constructor");
    }
    if (d3 && !v3) {
      var y2 = e23.constructor, b2 = t3.constructor;
      y2 == b2 || !("constructor" in e23) || !("constructor" in t3) || typeof y2 == "function" && y2 instanceof y2 && typeof b2 == "function" && b2 instanceof b2 || (d3 = false);
    }
    return o3.delete(e23), o3.delete(t3), d3;
  }(e22, t2, n2, r2, i2, o2));
}
function kd(e22, t2, n2, r2, i2) {
  return e22 === t2 || (e22 == null || t2 == null || !Ws(e22) && !Ws(t2) ? e22 != e22 && t2 != t2 : bd(e22, t2, n2, r2, kd, i2));
}
function wd(e22, t2, n2, r2) {
  var i2 = n2.length, o2 = i2, a2 = !r2;
  if (e22 == null)
    return !o2;
  for (e22 = Object(e22); i2--; ) {
    var s2 = n2[i2];
    if (a2 && s2[2] ? s2[1] !== e22[s2[0]] : !(s2[0] in e22))
      return false;
  }
  for (; ++i2 < o2; ) {
    var u2 = (s2 = n2[i2])[0], c2 = e22[u2], l2 = s2[1];
    if (a2 && s2[2]) {
      if (c2 === void 0 && !(u2 in e22))
        return false;
    } else {
      var f2 = new vh();
      if (r2)
        var h2 = r2(c2, l2, u2, e22, t2, f2);
      if (!(h2 === void 0 ? kd(l2, c2, 3, r2, f2) : h2))
        return false;
    }
  }
  return true;
}
function xd(e22) {
  return e22 == e22 && !ou(e22);
}
function jd(e22) {
  for (var t2 = dl(e22), n2 = t2.length; n2--; ) {
    var r2 = t2[n2], i2 = e22[r2];
    t2[n2] = [r2, i2, xd(i2)];
  }
  return t2;
}
function Sd(e22, t2) {
  return function(n2) {
    return n2 != null && (n2[e22] === t2 && (t2 !== void 0 || e22 in Object(n2)));
  };
}
function Cd(e22) {
  var t2 = jd(e22);
  return t2.length == 1 && t2[0][2] ? Sd(t2[0][0], t2[0][1]) : function(n2) {
    return n2 === e22 || wd(n2, e22, t2);
  };
}
function _d(e22, t2) {
  return e22 != null && t2 in Object(e22);
}
function $d(e22, t2, n2) {
  for (var r2 = -1, i2 = (t2 = Bl(t2, e22)).length, o2 = false; ++r2 < i2; ) {
    var a2 = ql(t2[r2]);
    if (!(o2 = e22 != null && n2(e22, a2)))
      break;
    e22 = e22[a2];
  }
  return o2 || ++r2 != i2 ? o2 : !!(i2 = e22 == null ? 0 : e22.length) && Rc(i2) && bc(a2, i2) && (Gs(e22) || Uc(e22));
}
function Od(e22, t2) {
  return e22 != null && $d(e22, t2, _d);
}
function Ad(e22, t2) {
  return Sl(e22) && xd(t2) ? Sd(ql(e22), t2) : function(n2) {
    var r2 = Vl(n2, e22);
    return r2 === void 0 && r2 === t2 ? Od(n2, e22) : kd(t2, r2, 3);
  };
}
function Md(e22) {
  return function(t2) {
    return t2 == null ? void 0 : t2[e22];
  };
}
function Ed(e22) {
  return Sl(e22) ? Md(ql(e22)) : function(e23) {
    return function(t2) {
      return Fl(t2, e23);
    };
  }(e22);
}
function Pd(e22) {
  return typeof e22 == "function" ? e22 : e22 == null ? vu : Li(e22) == "object" ? Gs(e22) ? Ad(e22[0], e22[1]) : Cd(e22) : Ed(e22);
}
function Nd(e22) {
  var t2 = e22 == null ? 0 : e22.length, n2 = Pd;
  return e22 = t2 ? Ks(e22, function(e23) {
    if (typeof e23[1] != "function")
      throw new TypeError("Expected a function");
    return [n2(e23[0]), e23[1]];
  }) : [], Ic(function(n3) {
    for (var r2 = -1; ++r2 < t2; ) {
      var i2 = e22[r2];
      if (Iu(i2[0], this, n3))
        return Iu(i2[1], this, n3);
    }
  });
}
function Td(e22, t2, n2) {
  var r2 = n2.length;
  if (e22 == null)
    return !r2;
  for (e22 = Object(e22); r2--; ) {
    var i2 = n2[r2], o2 = t2[i2], a2 = e22[i2];
    if (a2 === void 0 && !(i2 in e22) || !o2(a2))
      return false;
  }
  return true;
}
function Id(e22) {
  return function(e23) {
    var t2 = dl(e23);
    return function(n2) {
      return Td(n2, e23, t2);
    };
  }(ed(e22, 1));
}
function Rd(e22, t2) {
  return t2 == null || Td(e22, t2, dl(t2));
}
function Dd(e22, t2, n2, r2) {
  for (var i2 = -1, o2 = e22 == null ? 0 : e22.length; ++i2 < o2; ) {
    var a2 = e22[i2];
    t2(r2, a2, n2(a2), e22);
  }
  return r2;
}
function zd(e22) {
  return function(t2, n2, r2) {
    for (var i2 = -1, o2 = Object(t2), a2 = r2(t2), s2 = a2.length; s2--; ) {
      var u2 = a2[e22 ? s2 : ++i2];
      if (n2(o2[u2], u2, o2) === false)
        break;
    }
    return t2;
  };
}
var Ld = zd();
function Bd(e22, t2) {
  return e22 && Ld(e22, t2, dl);
}
function qd(e22, t2) {
  return function(n2, r2) {
    if (n2 == null)
      return n2;
    if (!Dc(n2))
      return e22(n2, r2);
    for (var i2 = n2.length, o2 = t2 ? i2 : -1, a2 = Object(n2); (t2 ? o2-- : ++o2 < i2) && r2(a2[o2], o2, a2) !== false; )
      ;
    return n2;
  };
}
var Fd = qd(Bd);
function Vd(e22, t2, n2, r2) {
  return Fd(e22, function(e23, i2, o2) {
    t2(r2, e23, n2(e23), o2);
  }), r2;
}
function Hd(e22, t2) {
  return function(n2, r2) {
    var i2 = Gs(n2) ? Dd : Vd, o2 = t2 ? t2() : {};
    return i2(n2, e22, Pd(r2), o2);
  };
}
var Wd = Object.prototype.hasOwnProperty, Jd = Hd(function(e22, t2, n2) {
  Wd.call(e22, n2) ? ++e22[n2] : Oc(e22, n2, 1);
});
function Ud(e22, t2) {
  var n2 = Nu(e22);
  return t2 == null ? n2 : ph(n2, t2);
}
function Kd(e22, t2, n2) {
  var r2 = _c(e22, 8, void 0, void 0, void 0, void 0, void 0, t2 = n2 ? void 0 : t2);
  return r2.placeholder = Kd.placeholder, r2;
}
Kd.placeholder = {};
function Gd(e22, t2, n2) {
  var r2 = _c(e22, 16, void 0, void 0, void 0, void 0, void 0, t2 = n2 ? void 0 : t2);
  return r2.placeholder = Gd.placeholder, r2;
}
Gd.placeholder = {};
var Qd = function() {
  return Rs.Date.now();
}, Yd = Math.max, Zd = Math.min;
function Xd(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2 = 0, l2 = false, f2 = false, h2 = true;
  if (typeof e22 != "function")
    throw new TypeError("Expected a function");
  function d2(t3) {
    var n3 = r2, o3 = i2;
    return r2 = i2 = void 0, c2 = t3, a2 = e22.apply(o3, n3);
  }
  function v2(e23) {
    return c2 = e23, s2 = setTimeout(m2, t2), l2 ? d2(e23) : a2;
  }
  function p2(e23) {
    var n3 = e23 - u2;
    return u2 === void 0 || n3 >= t2 || n3 < 0 || f2 && e23 - c2 >= o2;
  }
  function m2() {
    var e23 = Qd();
    if (p2(e23))
      return g2(e23);
    s2 = setTimeout(m2, function(e24) {
      var n3 = t2 - (e24 - u2);
      return f2 ? Zd(n3, o2 - (e24 - c2)) : n3;
    }(e23));
  }
  function g2(e23) {
    return s2 = void 0, h2 && r2 ? d2(e23) : (r2 = i2 = void 0, a2);
  }
  function y2() {
    var e23 = Qd(), n3 = p2(e23);
    if (r2 = arguments, i2 = this, u2 = e23, n3) {
      if (s2 === void 0)
        return v2(u2);
      if (f2)
        return clearTimeout(s2), s2 = setTimeout(m2, t2), d2(u2);
    }
    return s2 === void 0 && (s2 = setTimeout(m2, t2)), a2;
  }
  return t2 = lu(t2) || 0, ou(n2) && (l2 = !!n2.leading, o2 = (f2 = "maxWait" in n2) ? Yd(lu(n2.maxWait) || 0, t2) : o2, h2 = "trailing" in n2 ? !!n2.trailing : h2), y2.cancel = function() {
    s2 !== void 0 && clearTimeout(s2), c2 = 0, r2 = u2 = i2 = s2 = void 0;
  }, y2.flush = function() {
    return s2 === void 0 ? a2 : g2(Qd());
  }, y2;
}
function ev(e22, t2) {
  return e22 == null || e22 != e22 ? t2 : e22;
}
var tv = Object.prototype, nv = tv.hasOwnProperty, rv = Ic(function(e22, t2) {
  e22 = Object(e22);
  var n2 = -1, r2 = t2.length, i2 = r2 > 2 ? t2[2] : void 0;
  for (i2 && zc(t2[0], t2[1], i2) && (r2 = 1); ++n2 < r2; )
    for (var o2 = t2[n2], a2 = yl(o2), s2 = -1, u2 = a2.length; ++s2 < u2; ) {
      var c2 = a2[s2], l2 = e22[c2];
      (l2 === void 0 || Ac(l2, tv[c2]) && !nv.call(e22, c2)) && (e22[c2] = o2[c2]);
    }
  return e22;
});
function iv(e22, t2, n2) {
  (n2 !== void 0 && !Ac(e22[t2], n2) || n2 === void 0 && !(t2 in e22)) && Oc(e22, t2, n2);
}
function ov(e22) {
  return Ws(e22) && Dc(e22);
}
function av(e22, t2) {
  if ((t2 !== "constructor" || typeof e22[t2] != "function") && t2 != "__proto__")
    return e22[t2];
}
function sv(e22) {
  return Pc(e22, yl(e22));
}
function uv(e22, t2, n2, r2, i2) {
  e22 !== t2 && Ld(t2, function(o2, a2) {
    if (i2 || (i2 = new vh()), ou(o2))
      !function(e23, t3, n3, r3, i3, o3, a3) {
        var s3 = av(e23, n3), u2 = av(t3, n3), c2 = a3.get(u2);
        if (c2)
          iv(e23, n3, c2);
        else {
          var l2 = o3 ? o3(s3, u2, n3 + "", e23, t3, a3) : void 0, f2 = l2 === void 0;
          if (f2) {
            var h2 = Gs(u2), d2 = !h2 && Zc(u2), v2 = !h2 && !d2 && al(u2);
            l2 = u2, h2 || d2 || v2 ? Gs(s3) ? l2 = s3 : ov(s3) ? l2 = Gu(s3) : d2 ? (f2 = false, l2 = kh(u2, true)) : v2 ? (f2 = false, l2 = Jh(u2, true)) : l2 = [] : of(u2) || Uc(u2) ? (l2 = s3, Uc(s3) ? l2 = sv(s3) : ou(s3) && !pu(s3) || (l2 = Kh(u2))) : f2 = false;
          }
          f2 && (a3.set(u2, l2), i3(l2, u2, r3, o3, a3), a3.delete(u2)), iv(e23, n3, l2);
        }
      }(e22, t2, a2, n2, uv, r2, i2);
    else {
      var s2 = r2 ? r2(av(e22, a2), o2, a2 + "", e22, t2, i2) : void 0;
      s2 === void 0 && (s2 = o2), iv(e22, a2, s2);
    }
  }, yl);
}
function cv(e22, t2, n2, r2, i2, o2) {
  return ou(e22) && ou(t2) && (o2.set(t2, e22), uv(e22, t2, void 0, cv, o2), o2.delete(t2)), e22;
}
var lv = Lc(function(e22, t2, n2, r2) {
  uv(e22, t2, n2, r2);
}), fv = Ic(function(e22) {
  return e22.push(void 0, cv), Iu(lv, void 0, e22);
});
function hv(e22, t2, n2) {
  if (typeof e22 != "function")
    throw new TypeError("Expected a function");
  return setTimeout(function() {
    e22.apply(void 0, n2);
  }, t2);
}
var dv = Ic(function(e22, t2) {
  return hv(e22, 1, t2);
}), vv = Ic(function(e22, t2, n2) {
  return hv(e22, lu(t2) || 0, n2);
});
function pv(e22, t2, n2) {
  for (var r2 = -1, i2 = e22 == null ? 0 : e22.length; ++r2 < i2; )
    if (n2(t2, e22[r2]))
      return true;
  return false;
}
function mv(e22, t2, n2, r2) {
  var i2 = -1, o2 = dc, a2 = true, s2 = e22.length, u2 = [], c2 = t2.length;
  if (!s2)
    return u2;
  n2 && (t2 = Ks(t2, el(n2))), r2 ? (o2 = pv, a2 = false) : t2.length >= 200 && (o2 = ld, a2 = false, t2 = new ud(t2));
  e:
    for (; ++i2 < s2; ) {
      var l2 = e22[i2], f2 = n2 == null ? l2 : n2(l2);
      if (l2 = r2 || l2 !== 0 ? l2 : 0, a2 && f2 == f2) {
        for (var h2 = c2; h2--; )
          if (t2[h2] === f2)
            continue e;
        u2.push(l2);
      } else
        o2(t2, f2, r2) || u2.push(l2);
    }
  return u2;
}
var gv = Ic(function(e22, t2) {
  return ov(e22) ? mv(e22, Kl(t2, 1, ov, true)) : [];
});
function yv(e22) {
  var t2 = e22 == null ? 0 : e22.length;
  return t2 ? e22[t2 - 1] : void 0;
}
var bv = Ic(function(e22, t2) {
  var n2 = yv(t2);
  return ov(n2) && (n2 = void 0), ov(e22) ? mv(e22, Kl(t2, 1, ov, true), Pd(n2)) : [];
}), kv = Ic(function(e22, t2) {
  var n2 = yv(t2);
  return ov(n2) && (n2 = void 0), ov(e22) ? mv(e22, Kl(t2, 1, ov, true), void 0, n2) : [];
}), wv = Xs(function(e22, t2) {
  return e22 / t2;
}, 1);
function xv(e22, t2, n2) {
  var r2 = e22 == null ? 0 : e22.length;
  return r2 ? hf(e22, (t2 = n2 || t2 === void 0 ? 1 : hu(t2)) < 0 ? 0 : t2, r2) : [];
}
function jv(e22, t2, n2) {
  var r2 = e22 == null ? 0 : e22.length;
  return r2 ? hf(e22, 0, (t2 = r2 - (t2 = n2 || t2 === void 0 ? 1 : hu(t2))) < 0 ? 0 : t2) : [];
}
function Sv(e22, t2, n2, r2) {
  for (var i2 = e22.length, o2 = r2 ? i2 : -1; (r2 ? o2-- : ++o2 < i2) && t2(e22[o2], o2, e22); )
    ;
  return n2 ? hf(e22, r2 ? 0 : o2, r2 ? o2 + 1 : i2) : hf(e22, r2 ? o2 + 1 : 0, r2 ? i2 : o2);
}
function Cv(e22, t2) {
  return e22 && e22.length ? Sv(e22, Pd(t2), true, true) : [];
}
function _v(e22, t2) {
  return e22 && e22.length ? Sv(e22, Pd(t2), true) : [];
}
function $v(e22) {
  return typeof e22 == "function" ? e22 : vu;
}
function Ov(e22, t2) {
  return (Gs(e22) ? cc : Fd)(e22, $v(t2));
}
function Av(e22, t2) {
  for (var n2 = e22 == null ? 0 : e22.length; n2-- && t2(e22[n2], n2, e22) !== false; )
    ;
  return e22;
}
var Mv = zd(true);
function Ev(e22, t2) {
  return e22 && Mv(e22, t2, dl);
}
var Pv = qd(Ev, true);
function Nv(e22, t2) {
  return (Gs(e22) ? Av : Pv)(e22, $v(t2));
}
function Tv(e22, t2, n2) {
  e22 = Ll(e22), t2 = Zs(t2);
  var r2 = e22.length, i2 = n2 = n2 === void 0 ? r2 : hh(hu(n2), 0, r2);
  return (n2 -= t2.length) >= 0 && e22.slice(n2, i2) == t2;
}
function Iv(e22) {
  return function(t2) {
    var n2 = Lh(t2);
    return n2 == "[object Map]" ? hd(t2) : n2 == "[object Set]" ? function(e23) {
      var t3 = -1, n3 = Array(e23.size);
      return e23.forEach(function(e24) {
        n3[++t3] = [e24, e24];
      }), n3;
    }(t2) : function(e23, t3) {
      return Ks(t3, function(t4) {
        return [t4, e23[t4]];
      });
    }(t2, e22(t2));
  };
}
var Rv = Iv(dl), Dv = Iv(yl), zv = Ef({ "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }), Lv = /[&<>"']/g, Bv = RegExp(Lv.source);
function qv(e22) {
  return (e22 = Ll(e22)) && Bv.test(e22) ? e22.replace(Lv, zv) : e22;
}
var Fv = /[\\^$.*+?()[\]{}|]/g, Vv = RegExp(Fv.source);
function Hv(e22) {
  return (e22 = Ll(e22)) && Vv.test(e22) ? e22.replace(Fv, "\\$&") : e22;
}
function Wv(e22, t2) {
  for (var n2 = -1, r2 = e22 == null ? 0 : e22.length; ++n2 < r2; )
    if (!t2(e22[n2], n2, e22))
      return false;
  return true;
}
function Jv(e22, t2) {
  var n2 = true;
  return Fd(e22, function(e23, r2, i2) {
    return n2 = !!t2(e23, r2, i2);
  }), n2;
}
function Uv(e22, t2, n2) {
  var r2 = Gs(e22) ? Wv : Jv;
  return n2 && zc(e22, t2, n2) && (t2 = void 0), r2(e22, Pd(t2));
}
function Kv(e22) {
  return e22 ? hh(hu(e22), 0, 4294967295) : 0;
}
function Gv(e22, t2, n2, r2) {
  var i2 = e22 == null ? 0 : e22.length;
  return i2 ? (n2 && typeof n2 != "number" && zc(e22, t2, n2) && (n2 = 0, r2 = i2), function(e23, t3, n3, r3) {
    var i3 = e23.length;
    for ((n3 = hu(n3)) < 0 && (n3 = -n3 > i3 ? 0 : i3 + n3), (r3 = r3 === void 0 || r3 > i3 ? i3 : hu(r3)) < 0 && (r3 += i3), r3 = n3 > r3 ? 0 : Kv(r3); n3 < r3; )
      e23[n3++] = t3;
    return e23;
  }(e22, t2, n2, r2)) : [];
}
function Qv(e22, t2) {
  var n2 = [];
  return Fd(e22, function(e23, r2, i2) {
    t2(e23, r2, i2) && n2.push(e23);
  }), n2;
}
function Yv(e22, t2) {
  return (Gs(e22) ? wh : Qv)(e22, Pd(t2));
}
function Zv(e22) {
  return function(t2, n2, r2) {
    var i2 = Object(t2);
    if (!Dc(t2)) {
      var o2 = Pd(n2);
      t2 = dl(t2), n2 = function(e23) {
        return o2(i2[e23], e23, i2);
      };
    }
    var a2 = e22(t2, n2, r2);
    return a2 > -1 ? i2[o2 ? t2[a2] : a2] : void 0;
  };
}
var Xv = Math.max;
function ep(e22, t2, n2) {
  var r2 = e22 == null ? 0 : e22.length;
  if (!r2)
    return -1;
  var i2 = n2 == null ? 0 : hu(n2);
  return i2 < 0 && (i2 = Xv(r2 + i2, 0)), lc(e22, Pd(t2), i2);
}
var tp = Zv(ep);
function np(e22, t2, n2) {
  var r2;
  return n2(e22, function(e23, n3, i2) {
    if (t2(e23, n3, i2))
      return r2 = n3, false;
  }), r2;
}
function rp(e22, t2) {
  return np(e22, Pd(t2), Bd);
}
var ip = Math.max, op = Math.min;
function ap(e22, t2, n2) {
  var r2 = e22 == null ? 0 : e22.length;
  if (!r2)
    return -1;
  var i2 = r2 - 1;
  return n2 !== void 0 && (i2 = hu(n2), i2 = n2 < 0 ? ip(r2 + i2, 0) : op(i2, r2 - 1)), lc(e22, Pd(t2), i2, true);
}
var sp = Zv(ap);
function up(e22, t2) {
  return np(e22, Pd(t2), Ev);
}
function cp(e22) {
  return e22 && e22.length ? e22[0] : void 0;
}
function lp(e22, t2) {
  var n2 = -1, r2 = Dc(e22) ? Array(e22.length) : [];
  return Fd(e22, function(e23, i2, o2) {
    r2[++n2] = t2(e23, i2, o2);
  }), r2;
}
function fp(e22, t2) {
  return (Gs(e22) ? Ks : lp)(e22, Pd(t2));
}
function hp(e22, t2) {
  return Kl(fp(e22, t2), 1);
}
function dp(e22, t2) {
  return Kl(fp(e22, t2), Infinity);
}
function vp(e22, t2, n2) {
  return n2 = n2 === void 0 ? 1 : hu(n2), Kl(fp(e22, t2), n2);
}
function pp(e22) {
  return (e22 == null ? 0 : e22.length) ? Kl(e22, Infinity) : [];
}
function mp(e22, t2) {
  return (e22 == null ? 0 : e22.length) ? Kl(e22, t2 = t2 === void 0 ? 1 : hu(t2)) : [];
}
function gp(e22) {
  return _c(e22, 512);
}
var yp = ah("floor");
function bp(e22) {
  return Ql(function(t2) {
    var n2 = t2.length, r2 = n2, i2 = Ku.prototype.thru;
    for (e22 && t2.reverse(); r2--; ) {
      var o2 = t2[r2];
      if (typeof o2 != "function")
        throw new TypeError("Expected a function");
      if (i2 && !a2 && Uu(o2) == "wrapper")
        var a2 = new Ku([], true);
    }
    for (r2 = a2 ? r2 : n2; ++r2 < n2; ) {
      var s2 = Uu(o2 = t2[r2]), u2 = s2 == "wrapper" ? Hu(o2) : void 0;
      a2 = u2 && Xu(u2[0]) && u2[1] == 424 && !u2[4].length && u2[9] == 1 ? a2[Uu(u2[0])].apply(a2, u2[3]) : o2.length == 1 && Xu(o2) ? a2[s2]() : a2.thru(o2);
    }
    return function() {
      var e23 = arguments, r3 = e23[0];
      if (a2 && e23.length == 1 && Gs(r3))
        return a2.plant(r3).value();
      for (var i3 = 0, o3 = n2 ? t2[i3].apply(this, e23) : r3; ++i3 < n2; )
        o3 = t2[i3].call(this, o3);
      return o3;
    };
  });
}
var kp = bp(), wp = bp(true);
function xp(e22, t2) {
  return e22 == null ? e22 : Ld(e22, $v(t2), yl);
}
function jp(e22, t2) {
  return e22 == null ? e22 : Mv(e22, $v(t2), yl);
}
function Sp(e22, t2) {
  return e22 && Bd(e22, $v(t2));
}
function Cp(e22, t2) {
  return e22 && Ev(e22, $v(t2));
}
function _p(e22) {
  for (var t2 = -1, n2 = e22 == null ? 0 : e22.length, r2 = {}; ++t2 < n2; ) {
    var i2 = e22[t2];
    r2[i2[0]] = i2[1];
  }
  return r2;
}
function $p(e22, t2) {
  return wh(t2, function(t3) {
    return pu(e22[t3]);
  });
}
function Op(e22) {
  return e22 == null ? [] : $p(e22, dl(e22));
}
function Ap(e22) {
  return e22 == null ? [] : $p(e22, yl(e22));
}
var Mp = Object.prototype.hasOwnProperty, Ep = Hd(function(e22, t2, n2) {
  Mp.call(e22, n2) ? e22[n2].push(t2) : Oc(e22, n2, [t2]);
});
function Pp(e22, t2) {
  return e22 > t2;
}
function Np(e22) {
  return function(t2, n2) {
    return typeof t2 == "string" && typeof n2 == "string" || (t2 = lu(t2), n2 = lu(n2)), e22(t2, n2);
  };
}
var Tp = Np(Pp), Ip = Np(function(e22, t2) {
  return e22 >= t2;
}), Rp = Object.prototype.hasOwnProperty;
function Dp(e22, t2) {
  return e22 != null && Rp.call(e22, t2);
}
function zp(e22, t2) {
  return e22 != null && $d(e22, t2, Dp);
}
var Lp = Math.max, Bp = Math.min;
function qp(e22, t2, n2) {
  return t2 = fu(t2), n2 === void 0 ? (n2 = t2, t2 = 0) : n2 = fu(n2), function(e23, t3, n3) {
    return e23 >= Bp(t3, n3) && e23 < Lp(t3, n3);
  }(e22 = lu(e22), t2, n2);
}
function Fp(e22) {
  return typeof e22 == "string" || !Gs(e22) && Ws(e22) && Hs(e22) == "[object String]";
}
function Vp(e22, t2) {
  return Ks(t2, function(t3) {
    return e22[t3];
  });
}
function Hp(e22) {
  return e22 == null ? [] : Vp(e22, dl(e22));
}
var Wp = Math.max;
function Jp(e22, t2, n2, r2) {
  e22 = Dc(e22) ? e22 : Hp(e22), n2 = n2 && !r2 ? hu(n2) : 0;
  var i2 = e22.length;
  return n2 < 0 && (n2 = Wp(i2 + n2, 0)), Fp(e22) ? n2 <= i2 && e22.indexOf(t2, n2) > -1 : !!i2 && hc(e22, t2, n2) > -1;
}
var Up = Math.max;
function Kp(e22, t2, n2) {
  var r2 = e22 == null ? 0 : e22.length;
  if (!r2)
    return -1;
  var i2 = n2 == null ? 0 : hu(n2);
  return i2 < 0 && (i2 = Up(r2 + i2, 0)), hc(e22, t2, i2);
}
function Gp(e22) {
  return (e22 == null ? 0 : e22.length) ? hf(e22, 0, -1) : [];
}
var Qp = Math.min;
function Yp(e22, t2, n2) {
  for (var r2 = n2 ? pv : dc, i2 = e22[0].length, o2 = e22.length, a2 = o2, s2 = Array(o2), u2 = 1 / 0, c2 = []; a2--; ) {
    var l2 = e22[a2];
    a2 && t2 && (l2 = Ks(l2, el(t2))), u2 = Qp(l2.length, u2), s2[a2] = !n2 && (t2 || i2 >= 120 && l2.length >= 120) ? new ud(a2 && l2) : void 0;
  }
  l2 = e22[0];
  var f2 = -1, h2 = s2[0];
  e:
    for (; ++f2 < i2 && c2.length < u2; ) {
      var d2 = l2[f2], v2 = t2 ? t2(d2) : d2;
      if (d2 = n2 || d2 !== 0 ? d2 : 0, !(h2 ? ld(h2, v2) : r2(c2, v2, n2))) {
        for (a2 = o2; --a2; ) {
          var p2 = s2[a2];
          if (!(p2 ? ld(p2, v2) : r2(e22[a2], v2, n2)))
            continue e;
        }
        h2 && h2.push(v2), c2.push(d2);
      }
    }
  return c2;
}
function Zp(e22) {
  return ov(e22) ? e22 : [];
}
var Xp = Ic(function(e22) {
  var t2 = Ks(e22, Zp);
  return t2.length && t2[0] === e22[0] ? Yp(t2) : [];
}), em = Ic(function(e22) {
  var t2 = yv(e22), n2 = Ks(e22, Zp);
  return t2 === yv(n2) ? t2 = void 0 : n2.pop(), n2.length && n2[0] === e22[0] ? Yp(n2, Pd(t2)) : [];
}), tm = Ic(function(e22) {
  var t2 = yv(e22), n2 = Ks(e22, Zp);
  return (t2 = typeof t2 == "function" ? t2 : void 0) && n2.pop(), n2.length && n2[0] === e22[0] ? Yp(n2, void 0, t2) : [];
});
function nm(e22, t2) {
  return function(n2, r2) {
    return function(e23, t3, n3, r3) {
      return Bd(e23, function(e24, i2, o2) {
        t3(r3, n3(e24), i2, o2);
      }), r3;
    }(n2, e22, t2(r2), {});
  };
}
var rm = Object.prototype.toString, im = nm(function(e22, t2, n2) {
  t2 != null && typeof t2.toString != "function" && (t2 = rm.call(t2)), e22[t2] = n2;
}, ac(vu)), om = Object.prototype, am = om.hasOwnProperty, sm = om.toString, um = nm(function(e22, t2, n2) {
  t2 != null && typeof t2.toString != "function" && (t2 = sm.call(t2)), am.call(e22, t2) ? e22[t2].push(n2) : e22[t2] = [n2];
}, Pd);
function cm(e22, t2) {
  return t2.length < 2 ? e22 : Fl(e22, hf(t2, 0, -1));
}
function lm(e22, t2, n2) {
  var r2 = (e22 = cm(e22, t2 = Bl(t2, e22))) == null ? e22 : e22[ql(yv(t2))];
  return r2 == null ? void 0 : Iu(r2, e22, n2);
}
var fm = Ic(lm), hm = Ic(function(e22, t2, n2) {
  var r2 = -1, i2 = typeof t2 == "function", o2 = Dc(e22) ? Array(e22.length) : [];
  return Fd(e22, function(e23) {
    o2[++r2] = i2 ? Iu(t2, e23, n2) : lm(e23, t2, n2);
  }), o2;
});
var dm = il && il.isArrayBuffer, vm = dm ? el(dm) : function(e22) {
  return Ws(e22) && Hs(e22) == "[object ArrayBuffer]";
};
function pm(e22) {
  return e22 === true || e22 === false || Ws(e22) && Hs(e22) == "[object Boolean]";
}
var mm = il && il.isDate, gm = mm ? el(mm) : function(e22) {
  return Ws(e22) && Hs(e22) == "[object Date]";
};
function ym(e22) {
  return Ws(e22) && e22.nodeType === 1 && !of(e22);
}
var bm = Object.prototype.hasOwnProperty;
function km(e22) {
  if (e22 == null)
    return true;
  if (Dc(e22) && (Gs(e22) || typeof e22 == "string" || typeof e22.splice == "function" || Zc(e22) || al(e22) || Uc(e22)))
    return !e22.length;
  var t2 = Lh(e22);
  if (t2 == "[object Map]" || t2 == "[object Set]")
    return !e22.size;
  if (qc(e22))
    return !hl(e22).length;
  for (var n2 in e22)
    if (bm.call(e22, n2))
      return false;
  return true;
}
function wm(e22, t2) {
  return kd(e22, t2);
}
function xm(e22, t2, n2) {
  var r2 = (n2 = typeof n2 == "function" ? n2 : void 0) ? n2(e22, t2) : void 0;
  return r2 === void 0 ? kd(e22, t2, void 0, n2) : !!r2;
}
var jm = Rs.isFinite;
function Sm(e22) {
  return typeof e22 == "number" && jm(e22);
}
function Cm(e22) {
  return typeof e22 == "number" && e22 == hu(e22);
}
function _m(e22, t2) {
  return e22 === t2 || wd(e22, t2, jd(t2));
}
function $m(e22, t2, n2) {
  return n2 = typeof n2 == "function" ? n2 : void 0, wd(e22, t2, jd(t2), n2);
}
function Om(e22) {
  return typeof e22 == "number" || Ws(e22) && Hs(e22) == "[object Number]";
}
function Am(e22) {
  return Om(e22) && e22 != +e22;
}
var Mm = gu ? pu : Kc;
function Em(e22) {
  if (Mm(e22))
    throw new Error("Unsupported core-js use. Try https://npms.io/search?q=ponyfill.");
  return $u(e22);
}
function Pm(e22) {
  return e22 == null;
}
function Nm(e22) {
  return e22 === null;
}
var Tm = il && il.isRegExp, Im = Tm ? el(Tm) : function(e22) {
  return Ws(e22) && Hs(e22) == "[object RegExp]";
};
function Rm(e22) {
  return Cm(e22) && e22 >= -9007199254740991 && e22 <= 9007199254740991;
}
function Dm(e22) {
  return e22 === void 0;
}
function zm(e22) {
  return Ws(e22) && Lh(e22) == "[object WeakMap]";
}
function Lm(e22) {
  return Ws(e22) && Hs(e22) == "[object WeakSet]";
}
function Bm(e22) {
  return Pd(typeof e22 == "function" ? e22 : ed(e22, 1));
}
var qm = Array.prototype.join;
function Fm(e22, t2) {
  return e22 == null ? "" : qm.call(e22, t2);
}
var Vm = th(function(e22, t2, n2) {
  return e22 + (n2 ? "-" : "") + t2.toLowerCase();
}), Hm = Hd(function(e22, t2, n2) {
  Oc(e22, n2, t2);
});
var Wm = Math.max, Jm = Math.min;
function Um(e22, t2, n2) {
  var r2 = e22 == null ? 0 : e22.length;
  if (!r2)
    return -1;
  var i2 = r2;
  return n2 !== void 0 && (i2 = (i2 = hu(n2)) < 0 ? Wm(r2 + i2, 0) : Jm(i2, r2 - 1)), t2 == t2 ? function(e23, t3, n3) {
    for (var r3 = n3 + 1; r3--; )
      if (e23[r3] === t3)
        return r3;
    return r3;
  }(e22, t2, i2) : lc(e22, fc, i2, true);
}
var Km = th(function(e22, t2, n2) {
  return e22 + (n2 ? " " : "") + t2.toLowerCase();
}), Gm = $f("toLowerCase");
function Qm(e22, t2) {
  return e22 < t2;
}
var Ym = Np(Qm), Zm = Np(function(e22, t2) {
  return e22 <= t2;
});
function Xm(e22, t2) {
  var n2 = {};
  return t2 = Pd(t2), Bd(e22, function(e23, r2, i2) {
    Oc(n2, t2(e23, r2, i2), e23);
  }), n2;
}
function eg(e22, t2) {
  var n2 = {};
  return t2 = Pd(t2), Bd(e22, function(e23, r2, i2) {
    Oc(n2, r2, t2(e23, r2, i2));
  }), n2;
}
function tg(e22) {
  return Cd(ed(e22, 1));
}
function ng(e22, t2) {
  return Ad(e22, ed(t2, 1));
}
function rg(e22, t2, n2) {
  for (var r2 = -1, i2 = e22.length; ++r2 < i2; ) {
    var o2 = e22[r2], a2 = t2(o2);
    if (a2 != null && (s2 === void 0 ? a2 == a2 && !Js(a2) : n2(a2, s2)))
      var s2 = a2, u2 = o2;
  }
  return u2;
}
function ig(e22) {
  return e22 && e22.length ? rg(e22, vu, Pp) : void 0;
}
function og(e22, t2) {
  return e22 && e22.length ? rg(e22, Pd(t2), Pp) : void 0;
}
function ag(e22, t2) {
  for (var n2, r2 = -1, i2 = e22.length; ++r2 < i2; ) {
    var o2 = t2(e22[r2]);
    o2 !== void 0 && (n2 = n2 === void 0 ? o2 : n2 + o2);
  }
  return n2;
}
function sg(e22, t2) {
  var n2 = e22 == null ? 0 : e22.length;
  return n2 ? ag(e22, t2) / n2 : NaN;
}
function ug(e22) {
  return sg(e22, vu);
}
function cg(e22, t2) {
  return sg(e22, Pd(t2));
}
var lg = Lc(function(e22, t2, n2) {
  uv(e22, t2, n2);
}), fg = Ic(function(e22, t2) {
  return function(n2) {
    return lm(n2, e22, t2);
  };
}), hg = Ic(function(e22, t2) {
  return function(n2) {
    return lm(e22, n2, t2);
  };
});
function dg(e22) {
  return e22 && e22.length ? rg(e22, vu, Qm) : void 0;
}
function vg(e22, t2) {
  return e22 && e22.length ? rg(e22, Pd(t2), Qm) : void 0;
}
function pg(e22, t2, n2) {
  var r2 = dl(t2), i2 = $p(t2, r2), o2 = !(ou(n2) && "chain" in n2 && !n2.chain), a2 = pu(e22);
  return cc(i2, function(n3) {
    var r3 = t2[n3];
    e22[n3] = r3, a2 && (e22.prototype[n3] = function() {
      var t3 = this.__chain__;
      if (o2 || t3) {
        var n4 = e22(this.__wrapped__), i3 = n4.__actions__ = Gu(this.__actions__);
        return i3.push({ func: r3, args: arguments, thisArg: e22 }), n4.__chain__ = t3, n4;
      }
      return r3.apply(e22, Wl([this.value()], arguments));
    });
  }), e22;
}
var mg = Xs(function(e22, t2) {
  return e22 * t2;
}, 1);
function gg(e22) {
  if (typeof e22 != "function")
    throw new TypeError("Expected a function");
  return function() {
    var t2 = arguments;
    switch (t2.length) {
      case 0:
        return !e22.call(this);
      case 1:
        return !e22.call(this, t2[0]);
      case 2:
        return !e22.call(this, t2[0], t2[1]);
      case 3:
        return !e22.call(this, t2[0], t2[1], t2[2]);
    }
    return !e22.apply(this, t2);
  };
}
var yg = Ds ? Ds.iterator : void 0;
function bg(e22) {
  if (!e22)
    return [];
  if (Dc(e22))
    return Fp(e22) ? _f(e22) : Gu(e22);
  if (yg && e22[yg])
    return function(e23) {
      for (var t3, n2 = []; !(t3 = e23.next()).done; )
        n2.push(t3.value);
      return n2;
    }(e22[yg]());
  var t2 = Lh(e22);
  return (t2 == "[object Map]" ? hd : t2 == "[object Set]" ? dd : Hp)(e22);
}
function kg() {
  this.__values__ === void 0 && (this.__values__ = bg(this.value()));
  var e22 = this.__index__ >= this.__values__.length;
  return { done: e22, value: e22 ? void 0 : this.__values__[this.__index__++] };
}
function wg(e22, t2) {
  var n2 = e22.length;
  if (n2)
    return bc(t2 += t2 < 0 ? n2 : 0, n2) ? e22[t2] : void 0;
}
function xg(e22, t2) {
  return e22 && e22.length ? wg(e22, hu(t2)) : void 0;
}
function jg(e22) {
  return e22 = hu(e22), Ic(function(t2) {
    return wg(t2, e22);
  });
}
function Sg(e22, t2) {
  return (e22 = cm(e22, t2 = Bl(t2, e22))) == null || delete e22[ql(yv(t2))];
}
function Cg(e22) {
  return of(e22) ? void 0 : e22;
}
var _g = Ql(function(e22, t2) {
  var n2 = {};
  if (e22 == null)
    return n2;
  var r2 = false;
  t2 = Ks(t2, function(t3) {
    return t3 = Bl(t3, e22), r2 || (r2 = t3.length > 1), t3;
  }), Pc(e22, Ah(e22), n2), r2 && (n2 = ed(n2, 7, Cg));
  for (var i2 = t2.length; i2--; )
    Sg(n2, t2[i2]);
  return n2;
});
function $g(e22, t2, n2, r2) {
  if (!ou(e22))
    return e22;
  for (var i2 = -1, o2 = (t2 = Bl(t2, e22)).length, a2 = o2 - 1, s2 = e22; s2 != null && ++i2 < o2; ) {
    var u2 = ql(t2[i2]), c2 = n2;
    if (u2 === "__proto__" || u2 === "constructor" || u2 === "prototype")
      return e22;
    if (i2 != a2) {
      var l2 = s2[u2];
      (c2 = r2 ? r2(l2, u2, s2) : void 0) === void 0 && (c2 = ou(l2) ? l2 : bc(t2[i2 + 1]) ? [] : {});
    }
    Ec(s2, u2, c2), s2 = s2[u2];
  }
  return e22;
}
function Og(e22, t2, n2) {
  for (var r2 = -1, i2 = t2.length, o2 = {}; ++r2 < i2; ) {
    var a2 = t2[r2], s2 = Fl(e22, a2);
    n2(s2, a2) && $g(o2, Bl(a2, e22), s2);
  }
  return o2;
}
function Ag(e22, t2) {
  if (e22 == null)
    return {};
  var n2 = Ks(Ah(e22), function(e23) {
    return [e23];
  });
  return t2 = Pd(t2), Og(e22, n2, function(e23, n3) {
    return t2(e23, n3[0]);
  });
}
function Mg(e22, t2) {
  return Ag(e22, gg(Pd(t2)));
}
function Eg(e22) {
  return uf(2, e22);
}
function Pg(e22, t2) {
  if (e22 !== t2) {
    var n2 = e22 !== void 0, r2 = e22 === null, i2 = e22 == e22, o2 = Js(e22), a2 = t2 !== void 0, s2 = t2 === null, u2 = t2 == t2, c2 = Js(t2);
    if (!s2 && !c2 && !o2 && e22 > t2 || o2 && a2 && u2 && !s2 && !c2 || r2 && a2 && u2 || !n2 && u2 || !i2)
      return 1;
    if (!r2 && !o2 && !c2 && e22 < t2 || c2 && n2 && i2 && !r2 && !o2 || s2 && n2 && i2 || !a2 && i2 || !u2)
      return -1;
  }
  return 0;
}
function Ng(e22, t2, n2) {
  t2 = t2.length ? Ks(t2, function(e23) {
    return Gs(e23) ? function(t3) {
      return Fl(t3, e23.length === 1 ? e23[0] : e23);
    } : e23;
  }) : [vu];
  var r2 = -1;
  return t2 = Ks(t2, el(Pd)), function(e23, t3) {
    var n3 = e23.length;
    for (e23.sort(t3); n3--; )
      e23[n3] = e23[n3].value;
    return e23;
  }(lp(e22, function(e23, n3, i2) {
    return { criteria: Ks(t2, function(t3) {
      return t3(e23);
    }), index: ++r2, value: e23 };
  }), function(e23, t3) {
    return function(e24, t4, n3) {
      for (var r3 = -1, i2 = e24.criteria, o2 = t4.criteria, a2 = i2.length, s2 = n3.length; ++r3 < a2; ) {
        var u2 = Pg(i2[r3], o2[r3]);
        if (u2)
          return r3 >= s2 ? u2 : u2 * (n3[r3] == "desc" ? -1 : 1);
      }
      return e24.index - t4.index;
    }(e23, t3, n2);
  });
}
function Tg(e22, t2, n2, r2) {
  return e22 == null ? [] : (Gs(t2) || (t2 = t2 == null ? [] : [t2]), Gs(n2 = r2 ? void 0 : n2) || (n2 = n2 == null ? [] : [n2]), Ng(e22, t2, n2));
}
function Ig(e22) {
  return Ql(function(t2) {
    return t2 = Ks(t2, el(Pd)), Ic(function(n2) {
      var r2 = this;
      return e22(t2, function(e23) {
        return Iu(e23, r2, n2);
      });
    });
  });
}
var Rg = Ig(Ks), Dg = Ic, zg = Math.min, Lg = Dg(function(e22, t2) {
  var n2 = (t2 = t2.length == 1 && Gs(t2[0]) ? Ks(t2[0], el(Pd)) : Ks(Kl(t2, 1), el(Pd))).length;
  return Ic(function(r2) {
    for (var i2 = -1, o2 = zg(r2.length, n2); ++i2 < o2; )
      r2[i2] = t2[i2].call(this, r2[i2]);
    return Iu(e22, this, r2);
  });
}), Bg = Ig(Wv), qg = Ig(cd), Fg = Math.floor;
function Vg(e22, t2) {
  var n2 = "";
  if (!e22 || t2 < 1 || t2 > 9007199254740991)
    return n2;
  do {
    t2 % 2 && (n2 += e22), (t2 = Fg(t2 / 2)) && (e22 += e22);
  } while (t2);
  return n2;
}
var Hg = Md("length"), Wg = "[\\ud800-\\udfff]", Jg = "[\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff]", Ug = "\\ud83c[\\udffb-\\udfff]", Kg = "[^\\ud800-\\udfff]", Gg = "(?:\\ud83c[\\udde6-\\uddff]){2}", Qg = "[\\ud800-\\udbff][\\udc00-\\udfff]", Yg = "(?:" + Jg + "|" + Ug + ")?", Zg = "[\\ufe0e\\ufe0f]?" + Yg + ("(?:\\u200d(?:" + [Kg, Gg, Qg].join("|") + ")[\\ufe0e\\ufe0f]?" + Yg + ")*"), Xg = "(?:" + [Kg + Jg + "?", Jg, Gg, Qg, Wg].join("|") + ")", ey = RegExp(Ug + "(?=" + Ug + ")|" + Xg + Zg, "g");
function ty(e22) {
  return pf(e22) ? function(e23) {
    for (var t2 = ey.lastIndex = 0; ey.test(e23); )
      ++t2;
    return t2;
  }(e22) : Hg(e22);
}
var ny = Math.ceil;
function ry(e22, t2) {
  var n2 = (t2 = t2 === void 0 ? " " : Zs(t2)).length;
  if (n2 < 2)
    return n2 ? Vg(t2, e22) : t2;
  var r2 = Vg(t2, ny(e22 / ty(t2)));
  return pf(t2) ? df(_f(r2), 0, e22).join("") : r2.slice(0, e22);
}
var iy = Math.ceil, oy = Math.floor;
function ay(e22, t2, n2) {
  e22 = Ll(e22);
  var r2 = (t2 = hu(t2)) ? ty(e22) : 0;
  if (!t2 || r2 >= t2)
    return e22;
  var i2 = (t2 - r2) / 2;
  return ry(oy(i2), n2) + e22 + ry(iy(i2), n2);
}
function sy(e22, t2, n2) {
  e22 = Ll(e22);
  var r2 = (t2 = hu(t2)) ? ty(e22) : 0;
  return t2 && r2 < t2 ? e22 + ry(t2 - r2, n2) : e22;
}
function uy(e22, t2, n2) {
  e22 = Ll(e22);
  var r2 = (t2 = hu(t2)) ? ty(e22) : 0;
  return t2 && r2 < t2 ? ry(t2 - r2, n2) + e22 : e22;
}
var cy = /^\s+/, ly = Rs.parseInt;
function fy(e22, t2, n2) {
  return n2 || t2 == null ? t2 = 0 : t2 && (t2 = +t2), ly(Ll(e22).replace(cy, ""), t2 || 0);
}
var hy = Ic(function(e22, t2) {
  return _c(e22, 32, void 0, t2, xc(t2, gc(hy)));
});
hy.placeholder = {};
var dy = Ic(function(e22, t2) {
  return _c(e22, 64, void 0, t2, xc(t2, gc(dy)));
});
dy.placeholder = {};
var vy = Hd(function(e22, t2, n2) {
  e22[n2 ? 0 : 1].push(t2);
}, function() {
  return [[], []];
});
var py = Ql(function(e22, t2) {
  return e22 == null ? {} : function(e23, t3) {
    return Og(e23, t3, function(t4, n2) {
      return Od(e23, n2);
    });
  }(e22, t2);
});
function my(e22) {
  for (var t2, n2 = this; n2 instanceof qu; ) {
    var r2 = Qu(n2);
    r2.__index__ = 0, r2.__values__ = void 0, t2 ? i2.__wrapped__ = r2 : t2 = r2;
    var i2 = r2;
    n2 = n2.__wrapped__;
  }
  return i2.__wrapped__ = e22, t2;
}
function gy(e22) {
  return function(t2) {
    return e22 == null ? void 0 : Fl(e22, t2);
  };
}
function yy(e22, t2, n2, r2) {
  for (var i2 = n2 - 1, o2 = e22.length; ++i2 < o2; )
    if (r2(e22[i2], t2))
      return i2;
  return -1;
}
var by = Array.prototype.splice;
function ky(e22, t2, n2, r2) {
  var i2 = r2 ? yy : hc, o2 = -1, a2 = t2.length, s2 = e22;
  for (e22 === t2 && (t2 = Gu(t2)), n2 && (s2 = Ks(e22, el(n2))); ++o2 < a2; )
    for (var u2 = 0, c2 = t2[o2], l2 = n2 ? n2(c2) : c2; (u2 = i2(s2, l2, u2, r2)) > -1; )
      s2 !== e22 && by.call(s2, u2, 1), by.call(e22, u2, 1);
  return e22;
}
function wy(e22, t2) {
  return e22 && e22.length && t2 && t2.length ? ky(e22, t2) : e22;
}
var xy = Ic(wy);
function jy(e22, t2, n2) {
  return e22 && e22.length && t2 && t2.length ? ky(e22, t2, Pd(n2)) : e22;
}
function Sy(e22, t2, n2) {
  return e22 && e22.length && t2 && t2.length ? ky(e22, t2, void 0, n2) : e22;
}
var Cy = Array.prototype.splice;
function _y(e22, t2) {
  for (var n2 = e22 ? t2.length : 0, r2 = n2 - 1; n2--; ) {
    var i2 = t2[n2];
    if (n2 == r2 || i2 !== o2) {
      var o2 = i2;
      bc(i2) ? Cy.call(e22, i2, 1) : Sg(e22, i2);
    }
  }
  return e22;
}
var $y = Ql(function(e22, t2) {
  var n2 = e22 == null ? 0 : e22.length, r2 = Hl(e22, t2);
  return _y(e22, Ks(t2, function(e23) {
    return bc(e23, n2) ? +e23 : e23;
  }).sort(Pg)), r2;
}), Oy = Math.floor, Ay = Math.random;
function My(e22, t2) {
  return e22 + Oy(Ay() * (t2 - e22 + 1));
}
var Ey = parseFloat, Py = Math.min, Ny = Math.random;
function Ty(e22, t2, n2) {
  if (n2 && typeof n2 != "boolean" && zc(e22, t2, n2) && (t2 = n2 = void 0), n2 === void 0 && (typeof t2 == "boolean" ? (n2 = t2, t2 = void 0) : typeof e22 == "boolean" && (n2 = e22, e22 = void 0)), e22 === void 0 && t2 === void 0 ? (e22 = 0, t2 = 1) : (e22 = fu(e22), t2 === void 0 ? (t2 = e22, e22 = 0) : t2 = fu(t2)), e22 > t2) {
    var r2 = e22;
    e22 = t2, t2 = r2;
  }
  if (n2 || e22 % 1 || t2 % 1) {
    var i2 = Ny();
    return Py(e22 + i2 * (t2 - e22 + Ey("1e-" + ((i2 + "").length - 1))), t2);
  }
  return My(e22, t2);
}
var Iy = Math.ceil, Ry = Math.max;
function Dy(e22) {
  return function(t2, n2, r2) {
    return r2 && typeof r2 != "number" && zc(t2, n2, r2) && (n2 = r2 = void 0), t2 = fu(t2), n2 === void 0 ? (n2 = t2, t2 = 0) : n2 = fu(n2), function(e23, t3, n3, r3) {
      for (var i2 = -1, o2 = Ry(Iy((t3 - e23) / (n3 || 1)), 0), a2 = Array(o2); o2--; )
        a2[r3 ? o2 : ++i2] = e23, e23 += n3;
      return a2;
    }(t2, n2, r2 = r2 === void 0 ? t2 < n2 ? 1 : -1 : fu(r2), e22);
  };
}
var zy = Dy(), Ly = Dy(true), By = Ql(function(e22, t2) {
  return _c(e22, 256, void 0, void 0, void 0, t2);
});
function qy(e22, t2, n2, r2, i2) {
  return i2(e22, function(e23, i3, o2) {
    n2 = r2 ? (r2 = false, e23) : t2(n2, e23, i3, o2);
  }), n2;
}
function Fy(e22, t2, n2) {
  var r2 = Gs(e22) ? Mf : qy, i2 = arguments.length < 3;
  return r2(e22, Pd(t2), n2, i2, Fd);
}
function Vy(e22, t2, n2, r2) {
  var i2 = e22 == null ? 0 : e22.length;
  for (r2 && i2 && (n2 = e22[--i2]); i2--; )
    n2 = t2(n2, e22[i2], i2, e22);
  return n2;
}
function Hy(e22, t2, n2) {
  var r2 = Gs(e22) ? Vy : qy, i2 = arguments.length < 3;
  return r2(e22, Pd(t2), n2, i2, Pv);
}
function Wy(e22, t2) {
  return (Gs(e22) ? wh : Qv)(e22, gg(Pd(t2)));
}
function Jy(e22, t2) {
  var n2 = [];
  if (!e22 || !e22.length)
    return n2;
  var r2 = -1, i2 = [], o2 = e22.length;
  for (t2 = Pd(t2); ++r2 < o2; ) {
    var a2 = e22[r2];
    t2(a2, r2, e22) && (n2.push(a2), i2.push(r2));
  }
  return _y(e22, i2), n2;
}
function Uy(e22, t2, n2) {
  return t2 = (n2 ? zc(e22, t2, n2) : t2 === void 0) ? 1 : hu(t2), Vg(Ll(e22), t2);
}
function Ky() {
  var e22 = arguments, t2 = Ll(e22[0]);
  return e22.length < 3 ? t2 : t2.replace(e22[1], e22[2]);
}
function Gy(e22, t2) {
  if (typeof e22 != "function")
    throw new TypeError("Expected a function");
  return Ic(e22, t2 = t2 === void 0 ? t2 : hu(t2));
}
function Qy(e22, t2, n2) {
  var r2 = -1, i2 = (t2 = Bl(t2, e22)).length;
  for (i2 || (i2 = 1, e22 = void 0); ++r2 < i2; ) {
    var o2 = e22 == null ? void 0 : e22[ql(t2[r2])];
    o2 === void 0 && (r2 = i2, o2 = n2), e22 = pu(o2) ? o2.call(e22) : o2;
  }
  return e22;
}
var Yy = Array.prototype.reverse;
function Zy(e22) {
  return e22 == null ? e22 : Yy.call(e22);
}
var Xy = ah("round");
function eb(e22) {
  var t2 = e22.length;
  return t2 ? e22[My(0, t2 - 1)] : void 0;
}
function tb(e22) {
  return eb(Hp(e22));
}
function nb(e22) {
  return (Gs(e22) ? eb : tb)(e22);
}
function rb(e22, t2) {
  var n2 = -1, r2 = e22.length, i2 = r2 - 1;
  for (t2 = t2 === void 0 ? r2 : t2; ++n2 < t2; ) {
    var o2 = My(n2, i2), a2 = e22[o2];
    e22[o2] = e22[n2], e22[n2] = a2;
  }
  return e22.length = t2, e22;
}
function ib(e22, t2) {
  return rb(Gu(e22), hh(t2, 0, e22.length));
}
function ob(e22, t2) {
  var n2 = Hp(e22);
  return rb(n2, hh(t2, 0, n2.length));
}
function ab(e22, t2, n2) {
  return t2 = (n2 ? zc(e22, t2, n2) : t2 === void 0) ? 1 : hu(t2), (Gs(e22) ? ib : ob)(e22, t2);
}
function sb(e22, t2, n2) {
  return e22 == null ? e22 : $g(e22, t2, n2);
}
function ub(e22, t2, n2, r2) {
  return r2 = typeof r2 == "function" ? r2 : void 0, e22 == null ? e22 : $g(e22, t2, n2, r2);
}
function cb(e22) {
  return rb(Gu(e22));
}
function lb(e22) {
  return rb(Hp(e22));
}
function fb(e22) {
  return (Gs(e22) ? cb : lb)(e22);
}
function hb(e22) {
  if (e22 == null)
    return 0;
  if (Dc(e22))
    return Fp(e22) ? ty(e22) : e22.length;
  var t2 = Lh(e22);
  return t2 == "[object Map]" || t2 == "[object Set]" ? e22.size : hl(e22).length;
}
function db(e22, t2, n2) {
  var r2 = e22 == null ? 0 : e22.length;
  return r2 ? (n2 && typeof n2 != "number" && zc(e22, t2, n2) ? (t2 = 0, n2 = r2) : (t2 = t2 == null ? 0 : hu(t2), n2 = n2 === void 0 ? r2 : hu(n2)), hf(e22, t2, n2)) : [];
}
var vb = th(function(e22, t2, n2) {
  return e22 + (n2 ? "_" : "") + t2.toLowerCase();
});
function pb(e22, t2) {
  var n2;
  return Fd(e22, function(e23, r2, i2) {
    return !(n2 = t2(e23, r2, i2));
  }), !!n2;
}
function mb(e22, t2, n2) {
  var r2 = Gs(e22) ? cd : pb;
  return n2 && zc(e22, t2, n2) && (t2 = void 0), r2(e22, Pd(t2));
}
var gb = Ic(function(e22, t2) {
  if (e22 == null)
    return [];
  var n2 = t2.length;
  return n2 > 1 && zc(e22, t2[0], t2[1]) ? t2 = [] : n2 > 2 && zc(t2[0], t2[1], t2[2]) && (t2 = [t2[0]]), Ng(e22, Kl(t2, 1), []);
}), yb = Math.floor, bb = Math.min;
function kb(e22, t2, n2, r2) {
  var i2 = 0, o2 = e22 == null ? 0 : e22.length;
  if (o2 === 0)
    return 0;
  for (var a2 = (t2 = n2(t2)) != t2, s2 = t2 === null, u2 = Js(t2), c2 = t2 === void 0; i2 < o2; ) {
    var l2 = yb((i2 + o2) / 2), f2 = n2(e22[l2]), h2 = f2 !== void 0, d2 = f2 === null, v2 = f2 == f2, p2 = Js(f2);
    if (a2)
      var m2 = r2 || v2;
    else
      m2 = c2 ? v2 && (r2 || h2) : s2 ? v2 && h2 && (r2 || !d2) : u2 ? v2 && h2 && !d2 && (r2 || !p2) : !d2 && !p2 && (r2 ? f2 <= t2 : f2 < t2);
    m2 ? i2 = l2 + 1 : o2 = l2;
  }
  return bb(o2, 4294967294);
}
function wb(e22, t2, n2) {
  var r2 = 0, i2 = e22 == null ? r2 : e22.length;
  if (typeof t2 == "number" && t2 == t2 && i2 <= 2147483647) {
    for (; r2 < i2; ) {
      var o2 = r2 + i2 >>> 1, a2 = e22[o2];
      a2 !== null && !Js(a2) && (n2 ? a2 <= t2 : a2 < t2) ? r2 = o2 + 1 : i2 = o2;
    }
    return i2;
  }
  return kb(e22, t2, vu, n2);
}
function xb(e22, t2) {
  return wb(e22, t2);
}
function jb(e22, t2, n2) {
  return kb(e22, t2, Pd(n2));
}
function Sb(e22, t2) {
  var n2 = e22 == null ? 0 : e22.length;
  if (n2) {
    var r2 = wb(e22, t2);
    if (r2 < n2 && Ac(e22[r2], t2))
      return r2;
  }
  return -1;
}
function Cb(e22, t2) {
  return wb(e22, t2, true);
}
function _b(e22, t2, n2) {
  return kb(e22, t2, Pd(n2), true);
}
function $b(e22, t2) {
  if (e22 == null ? 0 : e22.length) {
    var n2 = wb(e22, t2, true) - 1;
    if (Ac(e22[n2], t2))
      return n2;
  }
  return -1;
}
function Ob(e22, t2) {
  for (var n2 = -1, r2 = e22.length, i2 = 0, o2 = []; ++n2 < r2; ) {
    var a2 = e22[n2], s2 = t2 ? t2(a2) : a2;
    if (!n2 || !Ac(s2, u2)) {
      var u2 = s2;
      o2[i2++] = a2 === 0 ? 0 : a2;
    }
  }
  return o2;
}
function Ab(e22) {
  return e22 && e22.length ? Ob(e22) : [];
}
function Mb(e22, t2) {
  return e22 && e22.length ? Ob(e22, Pd(t2)) : [];
}
function Eb(e22, t2, n2) {
  return n2 && typeof n2 != "number" && zc(e22, t2, n2) && (t2 = n2 = void 0), (n2 = n2 === void 0 ? 4294967295 : n2 >>> 0) ? (e22 = Ll(e22)) && (typeof t2 == "string" || t2 != null && !Im(t2)) && !(t2 = Zs(t2)) && pf(e22) ? df(_f(e22), 0, n2) : e22.split(t2, n2) : [];
}
var Pb = Math.max;
function Nb(e22, t2) {
  if (typeof e22 != "function")
    throw new TypeError("Expected a function");
  return t2 = t2 == null ? 0 : Pb(hu(t2), 0), Ic(function(n2) {
    var r2 = n2[t2], i2 = df(n2, 0, t2);
    return r2 && Wl(i2, r2), Iu(e22, this, i2);
  });
}
var Tb = th(function(e22, t2, n2) {
  return e22 + (n2 ? " " : "") + Of(t2);
});
function Ib(e22, t2, n2) {
  return e22 = Ll(e22), n2 = n2 == null ? 0 : hh(hu(n2), 0, e22.length), t2 = Zs(t2), e22.slice(n2, n2 + t2.length) == t2;
}
function Rb() {
  return {};
}
function Db() {
  return "";
}
function zb() {
  return true;
}
var Lb = Xs(function(e22, t2) {
  return e22 - t2;
}, 0);
function Bb(e22) {
  return e22 && e22.length ? ag(e22, vu) : 0;
}
function qb(e22, t2) {
  return e22 && e22.length ? ag(e22, Pd(t2)) : 0;
}
function Fb(e22) {
  var t2 = e22 == null ? 0 : e22.length;
  return t2 ? hf(e22, 1, t2) : [];
}
function Vb(e22, t2, n2) {
  return e22 && e22.length ? hf(e22, 0, (t2 = n2 || t2 === void 0 ? 1 : hu(t2)) < 0 ? 0 : t2) : [];
}
function Hb(e22, t2, n2) {
  var r2 = e22 == null ? 0 : e22.length;
  return r2 ? hf(e22, (t2 = r2 - (t2 = n2 || t2 === void 0 ? 1 : hu(t2))) < 0 ? 0 : t2, r2) : [];
}
function Wb(e22, t2) {
  return e22 && e22.length ? Sv(e22, Pd(t2), false, true) : [];
}
function Jb(e22, t2) {
  return e22 && e22.length ? Sv(e22, Pd(t2)) : [];
}
function Ub(e22, t2) {
  return t2(e22), e22;
}
var Kb = Object.prototype, Gb = Kb.hasOwnProperty;
function Qb(e22, t2, n2, r2) {
  return e22 === void 0 || Ac(e22, Kb[n2]) && !Gb.call(r2, n2) ? t2 : e22;
}
var Yb = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" };
function Zb(e22) {
  return "\\" + Yb[e22];
}
var Xb = /<%=([\s\S]+?)%>/g, ek = { escape: /<%-([\s\S]+?)%>/g, evaluate: /<%([\s\S]+?)%>/g, interpolate: Xb, variable: "", imports: { _: { escape: qv } } }, tk = /\b__p \+= '';/g, nk = /\b(__p \+=) '' \+/g, rk = /(__e\(.*?\)|\b__t\)) \+\n'';/g, ik = /[()=,{}\[\]\/\s]/, ok = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, ak = /($^)/, sk = /['\n\r\u2028\u2029\\]/g, uk = Object.prototype.hasOwnProperty;
function ck(e22, t2, n2) {
  var r2 = ek.imports._.templateSettings || ek;
  n2 && zc(e22, t2, n2) && (t2 = void 0), e22 = Ll(e22), t2 = kl({}, t2, r2, Qb);
  var i2, o2, a2 = kl({}, t2.imports, r2.imports, Qb), s2 = dl(a2), u2 = Vp(a2, s2), c2 = 0, l2 = t2.interpolate || ak, f2 = "__p += '", h2 = RegExp((t2.escape || ak).source + "|" + l2.source + "|" + (l2 === Xb ? ok : ak).source + "|" + (t2.evaluate || ak).source + "|$", "g"), d2 = uk.call(t2, "sourceURL") ? "//# sourceURL=" + (t2.sourceURL + "").replace(/\s/g, " ") + "\n" : "";
  e22.replace(h2, function(t3, n3, r3, a3, s3, u3) {
    return r3 || (r3 = a3), f2 += e22.slice(c2, u3).replace(sk, Zb), n3 && (i2 = true, f2 += "' +\n__e(" + n3 + ") +\n'"), s3 && (o2 = true, f2 += "';\n" + s3 + ";\n__p += '"), r3 && (f2 += "' +\n((__t = (" + r3 + ")) == null ? '' : __t) +\n'"), c2 = u3 + t3.length, t3;
  }), f2 += "';\n";
  var v2 = uk.call(t2, "variable") && t2.variable;
  if (v2) {
    if (ik.test(v2))
      throw new Error("Invalid `variable` option passed into `_.template`");
  } else
    f2 = "with (obj) {\n" + f2 + "\n}\n";
  f2 = (o2 ? f2.replace(tk, "") : f2).replace(nk, "$1").replace(rk, "$1;"), f2 = "function(" + (v2 || "obj") + ") {\n" + (v2 ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (i2 ? ", __e = _.escape" : "") + (o2 ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + f2 + "return __p\n}";
  var p2 = sf(function() {
    return Function(s2, d2 + "return " + f2).apply(void 0, u2);
  });
  if (p2.source = f2, af(p2))
    throw p2;
  return p2;
}
function lk(e22, t2, n2) {
  var r2 = true, i2 = true;
  if (typeof e22 != "function")
    throw new TypeError("Expected a function");
  return ou(n2) && (r2 = "leading" in n2 ? !!n2.leading : r2, i2 = "trailing" in n2 ? !!n2.trailing : i2), Xd(e22, t2, { leading: r2, maxWait: t2, trailing: i2 });
}
function fk(e22, t2) {
  return t2(e22);
}
var hk = Math.min;
function dk(e22, t2) {
  if ((e22 = hu(e22)) < 1 || e22 > 9007199254740991)
    return [];
  var n2 = 4294967295, r2 = hk(e22, 4294967295);
  e22 -= 4294967295;
  for (var i2 = Fc(r2, t2 = $v(t2)); ++n2 < e22; )
    t2(n2);
  return i2;
}
function vk() {
  return this;
}
function pk(e22, t2) {
  var n2 = e22;
  return n2 instanceof Fu && (n2 = n2.value()), Mf(t2, function(e23, t3) {
    return t3.func.apply(t3.thisArg, Wl([e23], t3.args));
  }, n2);
}
function mk() {
  return pk(this.__wrapped__, this.__actions__);
}
function gk(e22) {
  return Ll(e22).toLowerCase();
}
function yk(e22) {
  return Gs(e22) ? Ks(e22, ql) : Js(e22) ? [e22] : Gu(zl(Ll(e22)));
}
function bk(e22) {
  return e22 ? hh(hu(e22), -9007199254740991, 9007199254740991) : e22 === 0 ? e22 : 0;
}
function kk(e22) {
  return Ll(e22).toUpperCase();
}
function wk(e22, t2, n2) {
  var r2 = Gs(e22), i2 = r2 || Zc(e22) || al(e22);
  if (t2 = Pd(t2), n2 == null) {
    var o2 = e22 && e22.constructor;
    n2 = i2 ? r2 ? new o2() : [] : ou(e22) && pu(o2) ? Nu(Zl(e22)) : {};
  }
  return (i2 ? cc : Bd)(e22, function(e23, r3, i3) {
    return t2(n2, e23, r3, i3);
  }), n2;
}
function xk(e22, t2) {
  for (var n2 = e22.length; n2-- && hc(t2, e22[n2], 0) > -1; )
    ;
  return n2;
}
function jk(e22, t2) {
  for (var n2 = -1, r2 = e22.length; ++n2 < r2 && hc(t2, e22[n2], 0) > -1; )
    ;
  return n2;
}
function Sk(e22, t2, n2) {
  if ((e22 = Ll(e22)) && (n2 || t2 === void 0))
    return iu(e22);
  if (!e22 || !(t2 = Zs(t2)))
    return e22;
  var r2 = _f(e22), i2 = _f(t2);
  return df(r2, jk(r2, i2), xk(r2, i2) + 1).join("");
}
function Ck(e22, t2, n2) {
  if ((e22 = Ll(e22)) && (n2 || t2 === void 0))
    return e22.slice(0, nu(e22) + 1);
  if (!e22 || !(t2 = Zs(t2)))
    return e22;
  var r2 = _f(e22);
  return df(r2, 0, xk(r2, _f(t2)) + 1).join("");
}
var _k = /^\s+/;
function $k(e22, t2, n2) {
  if ((e22 = Ll(e22)) && (n2 || t2 === void 0))
    return e22.replace(_k, "");
  if (!e22 || !(t2 = Zs(t2)))
    return e22;
  var r2 = _f(e22);
  return df(r2, jk(r2, _f(t2))).join("");
}
var Ok = /\w*$/;
function Ak(e22, t2) {
  var n2 = 30, r2 = "...";
  if (ou(t2)) {
    var i2 = "separator" in t2 ? t2.separator : i2;
    n2 = "length" in t2 ? hu(t2.length) : n2, r2 = "omission" in t2 ? Zs(t2.omission) : r2;
  }
  var o2 = (e22 = Ll(e22)).length;
  if (pf(e22)) {
    var a2 = _f(e22);
    o2 = a2.length;
  }
  if (n2 >= o2)
    return e22;
  var s2 = n2 - ty(r2);
  if (s2 < 1)
    return r2;
  var u2 = a2 ? df(a2, 0, s2).join("") : e22.slice(0, s2);
  if (i2 === void 0)
    return u2 + r2;
  if (a2 && (s2 += u2.length - s2), Im(i2)) {
    if (e22.slice(s2).search(i2)) {
      var c2, l2 = u2;
      for (i2.global || (i2 = RegExp(i2.source, Ll(Ok.exec(i2)) + "g")), i2.lastIndex = 0; c2 = i2.exec(l2); )
        var f2 = c2.index;
      u2 = u2.slice(0, f2 === void 0 ? s2 : f2);
    }
  } else if (e22.indexOf(Zs(i2), s2) != s2) {
    var h2 = u2.lastIndexOf(i2);
    h2 > -1 && (u2 = u2.slice(0, h2));
  }
  return u2 + r2;
}
function Mk(e22) {
  return $c(e22, 1);
}
var Ek = Ef({ "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }), Pk = /&(?:amp|lt|gt|quot|#39);/g, Nk = RegExp(Pk.source);
function Tk(e22) {
  return (e22 = Ll(e22)) && Nk.test(e22) ? e22.replace(Pk, Ek) : e22;
}
var Ik = Ph && 1 / dd(new Ph([, -0]))[1] == 1 / 0 ? function(e22) {
  return new Ph(e22);
} : Vu;
function Rk(e22, t2, n2) {
  var r2 = -1, i2 = dc, o2 = e22.length, a2 = true, s2 = [], u2 = s2;
  if (n2)
    a2 = false, i2 = pv;
  else if (o2 >= 200) {
    var c2 = t2 ? null : Ik(e22);
    if (c2)
      return dd(c2);
    a2 = false, i2 = ld, u2 = new ud();
  } else
    u2 = t2 ? [] : s2;
  e:
    for (; ++r2 < o2; ) {
      var l2 = e22[r2], f2 = t2 ? t2(l2) : l2;
      if (l2 = n2 || l2 !== 0 ? l2 : 0, a2 && f2 == f2) {
        for (var h2 = u2.length; h2--; )
          if (u2[h2] === f2)
            continue e;
        t2 && u2.push(f2), s2.push(l2);
      } else
        i2(u2, f2, n2) || (u2 !== s2 && u2.push(f2), s2.push(l2));
    }
  return s2;
}
var Dk = Ic(function(e22) {
  return Rk(Kl(e22, 1, ov, true));
}), zk = Ic(function(e22) {
  var t2 = yv(e22);
  return ov(t2) && (t2 = void 0), Rk(Kl(e22, 1, ov, true), Pd(t2));
}), Lk = Ic(function(e22) {
  var t2 = yv(e22);
  return t2 = typeof t2 == "function" ? t2 : void 0, Rk(Kl(e22, 1, ov, true), void 0, t2);
});
function Bk(e22) {
  return e22 && e22.length ? Rk(e22) : [];
}
function qk(e22, t2) {
  return e22 && e22.length ? Rk(e22, Pd(t2)) : [];
}
function Fk(e22, t2) {
  return t2 = typeof t2 == "function" ? t2 : void 0, e22 && e22.length ? Rk(e22, void 0, t2) : [];
}
var Vk = 0;
function Hk(e22) {
  var t2 = ++Vk;
  return Ll(e22) + t2;
}
function Wk(e22, t2) {
  return e22 == null || Sg(e22, t2);
}
var Jk = Math.max;
function Uk(e22) {
  if (!e22 || !e22.length)
    return [];
  var t2 = 0;
  return e22 = wh(e22, function(e23) {
    if (ov(e23))
      return t2 = Jk(e23.length, t2), true;
  }), Fc(t2, function(t3) {
    return Ks(e22, Md(t3));
  });
}
function Kk(e22, t2) {
  if (!e22 || !e22.length)
    return [];
  var n2 = Uk(e22);
  return t2 == null ? n2 : Ks(n2, function(e23) {
    return Iu(t2, void 0, e23);
  });
}
function Gk(e22, t2, n2, r2) {
  return $g(e22, t2, n2(Fl(e22, t2)), r2);
}
function Qk(e22, t2, n2) {
  return e22 == null ? e22 : Gk(e22, t2, $v(n2));
}
function Yk(e22, t2, n2, r2) {
  return r2 = typeof r2 == "function" ? r2 : void 0, e22 == null ? e22 : Gk(e22, t2, $v(n2), r2);
}
var Zk = th(function(e22, t2, n2) {
  return e22 + (n2 ? " " : "") + t2.toUpperCase();
});
function Xk(e22) {
  return e22 == null ? [] : Vp(e22, yl(e22));
}
var ew = Ic(function(e22, t2) {
  return ov(e22) ? mv(e22, t2) : [];
});
function tw(e22, t2) {
  return hy($v(t2), e22);
}
var nw = Ql(function(e22) {
  var t2 = e22.length, n2 = t2 ? e22[0] : 0, r2 = this.__wrapped__, i2 = function(t3) {
    return Hl(t3, e22);
  };
  return !(t2 > 1 || this.__actions__.length) && r2 instanceof Fu && bc(n2) ? ((r2 = r2.slice(n2, +n2 + (t2 ? 1 : 0))).__actions__.push({ func: fk, args: [i2], thisArg: void 0 }), new Ku(r2, this.__chain__).thru(function(e23) {
    return t2 && !e23.length && e23.push(void 0), e23;
  })) : this.thru(i2);
});
function rw() {
  return uh(this);
}
function iw() {
  var e22 = this.__wrapped__;
  if (e22 instanceof Fu) {
    var t2 = e22;
    return this.__actions__.length && (t2 = new Fu(this)), (t2 = t2.reverse()).__actions__.push({ func: fk, args: [Zy], thisArg: void 0 }), new Ku(t2, this.__chain__);
  }
  return this.thru(Zy);
}
function ow(e22, t2, n2) {
  var r2 = e22.length;
  if (r2 < 2)
    return r2 ? Rk(e22[0]) : [];
  for (var i2 = -1, o2 = Array(r2); ++i2 < r2; )
    for (var a2 = e22[i2], s2 = -1; ++s2 < r2; )
      s2 != i2 && (o2[i2] = mv(o2[i2] || a2, e22[s2], t2, n2));
  return Rk(Kl(o2, 1), t2, n2);
}
var aw = Ic(function(e22) {
  return ow(wh(e22, ov));
}), sw = Ic(function(e22) {
  var t2 = yv(e22);
  return ov(t2) && (t2 = void 0), ow(wh(e22, ov), Pd(t2));
}), uw = Ic(function(e22) {
  var t2 = yv(e22);
  return t2 = typeof t2 == "function" ? t2 : void 0, ow(wh(e22, ov), void 0, t2);
}), cw = Ic(Uk);
function lw(e22, t2, n2) {
  for (var r2 = -1, i2 = e22.length, o2 = t2.length, a2 = {}; ++r2 < i2; ) {
    var s2 = r2 < o2 ? t2[r2] : void 0;
    n2(a2, e22[r2], s2);
  }
  return a2;
}
function fw(e22, t2) {
  return lw(e22 || [], t2 || [], Ec);
}
function hw(e22, t2) {
  return lw(e22 || [], t2 || [], $g);
}
var dw = Ic(function(e22) {
  var t2 = e22.length, n2 = t2 > 1 ? e22[t2 - 1] : void 0;
  return n2 = typeof n2 == "function" ? (e22.pop(), n2) : void 0, Kk(e22, n2);
}), vw = { chunk: fh, compact: ad, concat: sd, difference: gv, differenceBy: bv, differenceWith: kv, drop: xv, dropRight: jv, dropRightWhile: Cv, dropWhile: _v, fill: Gv, findIndex: ep, findLastIndex: ap, first: cp, flatten: Gl, flattenDeep: pp, flattenDepth: mp, fromPairs: _p, head: cp, indexOf: Kp, initial: Gp, intersection: Xp, intersectionBy: em, intersectionWith: tm, join: Fm, last: yv, lastIndexOf: Um, nth: xg, pull: xy, pullAll: wy, pullAllBy: jy, pullAllWith: Sy, pullAt: $y, remove: Jy, reverse: Zy, slice: db, sortedIndex: xb, sortedIndexBy: jb, sortedIndexOf: Sb, sortedLastIndex: Cb, sortedLastIndexBy: _b, sortedLastIndexOf: $b, sortedUniq: Ab, sortedUniqBy: Mb, tail: Fb, take: Vb, takeRight: Hb, takeRightWhile: Wb, takeWhile: Jb, union: Dk, unionBy: zk, unionWith: Lk, uniq: Bk, uniqBy: qk, uniqWith: Fk, unzip: Uk, unzipWith: Kk, without: ew, xor: aw, xorBy: sw, xorWith: uw, zip: cw, zipObject: fw, zipObjectDeep: hw, zipWith: dw }, pw = { countBy: Jd, each: Ov, eachRight: Nv, every: Uv, filter: Yv, find: tp, findLast: sp, flatMap: hp, flatMapDeep: dp, flatMapDepth: vp, forEach: Ov, forEachRight: Nv, groupBy: Ep, includes: Jp, invokeMap: hm, keyBy: Hm, map: fp, orderBy: Tg, partition: vy, reduce: Fy, reduceRight: Hy, reject: Wy, sample: nb, sampleSize: ab, shuffle: fb, size: hb, some: mb, sortBy: gb }, mw = Qd, gw = { after: du, ary: $c, before: uf, bind: cf, bindKey: ff, curry: Kd, curryRight: Gd, debounce: Xd, defer: dv, delay: vv, flip: gp, memoize: Il, negate: gg, once: Eg, overArgs: Lg, partial: hy, partialRight: dy, rearg: By, rest: Gy, spread: Nb, throttle: lk, unary: Mk, wrap: tw }, yw = { castArray: rh, clone: td, cloneDeep: nd, cloneDeepWith: rd, cloneWith: id, conformsTo: Rd, eq: Ac, gt: Tp, gte: Ip, isArguments: Uc, isArray: Gs, isArrayBuffer: vm, isArrayLike: Dc, isArrayLikeObject: ov, isBoolean: pm, isBuffer: Zc, isDate: gm, isElement: ym, isEmpty: km, isEqual: wm, isEqualWith: xm, isError: af, isFinite: Sm, isFunction: pu, isInteger: Cm, isLength: Rc, isMap: Qh, isMatch: _m, isMatchWith: $m, isNaN: Am, isNative: Em, isNil: Pm, isNull: Nm, isNumber: Om, isObject: ou, isObjectLike: Ws, isPlainObject: of, isRegExp: Im, isSafeInteger: Rm, isSet: Zh, isString: Fp, isSymbol: Js, isTypedArray: al, isUndefined: Dm, isWeakMap: zm, isWeakSet: Lm, lt: Ym, lte: Zm, toArray: bg, toFinite: fu, toInteger: hu, toLength: Kv, toNumber: lu, toPlainObject: sv, toSafeInteger: bk, toString: Ll }, bw = { add: eu, ceil: sh, divide: wv, floor: yp, max: ig, maxBy: og, mean: ug, meanBy: cg, min: dg, minBy: vg, multiply: mg, round: Xy, subtract: Lb, sum: Bb, sumBy: qb }, kw = dh, ww = qp, xw = Ty, jw = { assign: pl, assignIn: bl, assignInWith: kl, assignWith: wl, at: Yl, create: Ud, defaults: rv, defaultsDeep: fv, entries: Rv, entriesIn: Dv, extend: bl, extendWith: kl, findKey: rp, findLastKey: up, forIn: xp, forInRight: jp, forOwn: Sp, forOwnRight: Cp, functions: Op, functionsIn: Ap, get: Vl, has: zp, hasIn: Od, invert: im, invertBy: um, invoke: fm, keys: dl, keysIn: yl, mapKeys: Xm, mapValues: eg, merge: lg, mergeWith: lv, omit: _g, omitBy: Mg, pick: py, pickBy: Ag, result: Qy, set: sb, setWith: ub, toPairs: Rv, toPairsIn: Dv, transform: wk, unset: Wk, update: Qk, updateWith: Yk, values: Hp, valuesIn: Xk }, Sw = { at: nw, chain: uh, commit: od, lodash: Zu, next: kg, plant: my, reverse: iw, tap: Ub, thru: fk, toIterator: vk, toJSON: mk, value: mk, valueOf: mk, wrapperChain: rw }, Cw = { camelCase: nh, capitalize: Af, deburr: If, endsWith: Tv, escape: qv, escapeRegExp: Hv, kebabCase: Vm, lowerCase: Km, lowerFirst: Gm, pad: ay, padEnd: sy, padStart: uy, parseInt: fy, repeat: Uy, replace: Ky, snakeCase: vb, split: Eb, startCase: Tb, startsWith: Ib, template: ck, templateSettings: ek, toLower: gk, toUpper: kk, trim: Sk, trimEnd: Ck, trimStart: $k, truncate: Ak, unescape: Tk, upperCase: Zk, upperFirst: Of, words: Xf }, _w = { attempt: sf, bindAll: lf, cond: Nd, conforms: Id, constant: ac, defaultTo: ev, flow: kp, flowRight: wp, identity: vu, iteratee: Bm, matches: tg, matchesProperty: ng, method: fg, methodOf: hg, mixin: pg, noop: Vu, nthArg: jg, over: Rg, overEvery: Bg, overSome: qg, property: Ed, propertyOf: gy, range: zy, rangeRight: Ly, stubArray: xh, stubFalse: Kc, stubObject: Rb, stubString: Db, stubTrue: zb, times: dk, toPath: yk, uniqueId: Hk };
var $w = Math.max, Ow = Math.min;
var Aw = Math.min;
/**
 * @license
 * Lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="es" -o ./`
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
var Mw, Ew = Array.prototype, Pw = Object.prototype.hasOwnProperty, Nw = Ds ? Ds.iterator : void 0, Tw = Math.max, Iw = Math.min, Rw = function(e22) {
  return function(t2, n2, r2) {
    if (r2 == null) {
      var i2 = ou(n2), o2 = i2 && dl(n2), a2 = o2 && o2.length && $p(n2, o2);
      (a2 ? a2.length : i2) || (r2 = n2, n2 = t2, t2 = this);
    }
    return e22(t2, n2, r2);
  };
}(pg);
Zu.after = gw.after, Zu.ary = gw.ary, Zu.assign = jw.assign, Zu.assignIn = jw.assignIn, Zu.assignInWith = jw.assignInWith, Zu.assignWith = jw.assignWith, Zu.at = jw.at, Zu.before = gw.before, Zu.bind = gw.bind, Zu.bindAll = _w.bindAll, Zu.bindKey = gw.bindKey, Zu.castArray = yw.castArray, Zu.chain = Sw.chain, Zu.chunk = vw.chunk, Zu.compact = vw.compact, Zu.concat = vw.concat, Zu.cond = _w.cond, Zu.conforms = _w.conforms, Zu.constant = _w.constant, Zu.countBy = pw.countBy, Zu.create = jw.create, Zu.curry = gw.curry, Zu.curryRight = gw.curryRight, Zu.debounce = gw.debounce, Zu.defaults = jw.defaults, Zu.defaultsDeep = jw.defaultsDeep, Zu.defer = gw.defer, Zu.delay = gw.delay, Zu.difference = vw.difference, Zu.differenceBy = vw.differenceBy, Zu.differenceWith = vw.differenceWith, Zu.drop = vw.drop, Zu.dropRight = vw.dropRight, Zu.dropRightWhile = vw.dropRightWhile, Zu.dropWhile = vw.dropWhile, Zu.fill = vw.fill, Zu.filter = pw.filter, Zu.flatMap = pw.flatMap, Zu.flatMapDeep = pw.flatMapDeep, Zu.flatMapDepth = pw.flatMapDepth, Zu.flatten = vw.flatten, Zu.flattenDeep = vw.flattenDeep, Zu.flattenDepth = vw.flattenDepth, Zu.flip = gw.flip, Zu.flow = _w.flow, Zu.flowRight = _w.flowRight, Zu.fromPairs = vw.fromPairs, Zu.functions = jw.functions, Zu.functionsIn = jw.functionsIn, Zu.groupBy = pw.groupBy, Zu.initial = vw.initial, Zu.intersection = vw.intersection, Zu.intersectionBy = vw.intersectionBy, Zu.intersectionWith = vw.intersectionWith, Zu.invert = jw.invert, Zu.invertBy = jw.invertBy, Zu.invokeMap = pw.invokeMap, Zu.iteratee = _w.iteratee, Zu.keyBy = pw.keyBy, Zu.keys = dl, Zu.keysIn = jw.keysIn, Zu.map = pw.map, Zu.mapKeys = jw.mapKeys, Zu.mapValues = jw.mapValues, Zu.matches = _w.matches, Zu.matchesProperty = _w.matchesProperty, Zu.memoize = gw.memoize, Zu.merge = jw.merge, Zu.mergeWith = jw.mergeWith, Zu.method = _w.method, Zu.methodOf = _w.methodOf, Zu.mixin = Rw, Zu.negate = gg, Zu.nthArg = _w.nthArg, Zu.omit = jw.omit, Zu.omitBy = jw.omitBy, Zu.once = gw.once, Zu.orderBy = pw.orderBy, Zu.over = _w.over, Zu.overArgs = gw.overArgs, Zu.overEvery = _w.overEvery, Zu.overSome = _w.overSome, Zu.partial = gw.partial, Zu.partialRight = gw.partialRight, Zu.partition = pw.partition, Zu.pick = jw.pick, Zu.pickBy = jw.pickBy, Zu.property = _w.property, Zu.propertyOf = _w.propertyOf, Zu.pull = vw.pull, Zu.pullAll = vw.pullAll, Zu.pullAllBy = vw.pullAllBy, Zu.pullAllWith = vw.pullAllWith, Zu.pullAt = vw.pullAt, Zu.range = _w.range, Zu.rangeRight = _w.rangeRight, Zu.rearg = gw.rearg, Zu.reject = pw.reject, Zu.remove = vw.remove, Zu.rest = gw.rest, Zu.reverse = vw.reverse, Zu.sampleSize = pw.sampleSize, Zu.set = jw.set, Zu.setWith = jw.setWith, Zu.shuffle = pw.shuffle, Zu.slice = vw.slice, Zu.sortBy = pw.sortBy, Zu.sortedUniq = vw.sortedUniq, Zu.sortedUniqBy = vw.sortedUniqBy, Zu.split = Cw.split, Zu.spread = gw.spread, Zu.tail = vw.tail, Zu.take = vw.take, Zu.takeRight = vw.takeRight, Zu.takeRightWhile = vw.takeRightWhile, Zu.takeWhile = vw.takeWhile, Zu.tap = Sw.tap, Zu.throttle = gw.throttle, Zu.thru = fk, Zu.toArray = yw.toArray, Zu.toPairs = jw.toPairs, Zu.toPairsIn = jw.toPairsIn, Zu.toPath = _w.toPath, Zu.toPlainObject = yw.toPlainObject, Zu.transform = jw.transform, Zu.unary = gw.unary, Zu.union = vw.union, Zu.unionBy = vw.unionBy, Zu.unionWith = vw.unionWith, Zu.uniq = vw.uniq, Zu.uniqBy = vw.uniqBy, Zu.uniqWith = vw.uniqWith, Zu.unset = jw.unset, Zu.unzip = vw.unzip, Zu.unzipWith = vw.unzipWith, Zu.update = jw.update, Zu.updateWith = jw.updateWith, Zu.values = jw.values, Zu.valuesIn = jw.valuesIn, Zu.without = vw.without, Zu.words = Cw.words, Zu.wrap = gw.wrap, Zu.xor = vw.xor, Zu.xorBy = vw.xorBy, Zu.xorWith = vw.xorWith, Zu.zip = vw.zip, Zu.zipObject = vw.zipObject, Zu.zipObjectDeep = vw.zipObjectDeep, Zu.zipWith = vw.zipWith, Zu.entries = jw.toPairs, Zu.entriesIn = jw.toPairsIn, Zu.extend = jw.assignIn, Zu.extendWith = jw.assignInWith, Rw(Zu, Zu), Zu.add = bw.add, Zu.attempt = _w.attempt, Zu.camelCase = Cw.camelCase, Zu.capitalize = Cw.capitalize, Zu.ceil = bw.ceil, Zu.clamp = kw, Zu.clone = yw.clone, Zu.cloneDeep = yw.cloneDeep, Zu.cloneDeepWith = yw.cloneDeepWith, Zu.cloneWith = yw.cloneWith, Zu.conformsTo = yw.conformsTo, Zu.deburr = Cw.deburr, Zu.defaultTo = _w.defaultTo, Zu.divide = bw.divide, Zu.endsWith = Cw.endsWith, Zu.eq = yw.eq, Zu.escape = Cw.escape, Zu.escapeRegExp = Cw.escapeRegExp, Zu.every = pw.every, Zu.find = pw.find, Zu.findIndex = vw.findIndex, Zu.findKey = jw.findKey, Zu.findLast = pw.findLast, Zu.findLastIndex = vw.findLastIndex, Zu.findLastKey = jw.findLastKey, Zu.floor = bw.floor, Zu.forEach = pw.forEach, Zu.forEachRight = pw.forEachRight, Zu.forIn = jw.forIn, Zu.forInRight = jw.forInRight, Zu.forOwn = jw.forOwn, Zu.forOwnRight = jw.forOwnRight, Zu.get = jw.get, Zu.gt = yw.gt, Zu.gte = yw.gte, Zu.has = jw.has, Zu.hasIn = jw.hasIn, Zu.head = vw.head, Zu.identity = vu, Zu.includes = pw.includes, Zu.indexOf = vw.indexOf, Zu.inRange = ww, Zu.invoke = jw.invoke, Zu.isArguments = yw.isArguments, Zu.isArray = Gs, Zu.isArrayBuffer = yw.isArrayBuffer, Zu.isArrayLike = yw.isArrayLike, Zu.isArrayLikeObject = yw.isArrayLikeObject, Zu.isBoolean = yw.isBoolean, Zu.isBuffer = yw.isBuffer, Zu.isDate = yw.isDate, Zu.isElement = yw.isElement, Zu.isEmpty = yw.isEmpty, Zu.isEqual = yw.isEqual, Zu.isEqualWith = yw.isEqualWith, Zu.isError = yw.isError, Zu.isFinite = yw.isFinite, Zu.isFunction = yw.isFunction, Zu.isInteger = yw.isInteger, Zu.isLength = yw.isLength, Zu.isMap = yw.isMap, Zu.isMatch = yw.isMatch, Zu.isMatchWith = yw.isMatchWith, Zu.isNaN = yw.isNaN, Zu.isNative = yw.isNative, Zu.isNil = yw.isNil, Zu.isNull = yw.isNull, Zu.isNumber = yw.isNumber, Zu.isObject = ou, Zu.isObjectLike = yw.isObjectLike, Zu.isPlainObject = yw.isPlainObject, Zu.isRegExp = yw.isRegExp, Zu.isSafeInteger = yw.isSafeInteger, Zu.isSet = yw.isSet, Zu.isString = yw.isString, Zu.isSymbol = yw.isSymbol, Zu.isTypedArray = yw.isTypedArray, Zu.isUndefined = yw.isUndefined, Zu.isWeakMap = yw.isWeakMap, Zu.isWeakSet = yw.isWeakSet, Zu.join = vw.join, Zu.kebabCase = Cw.kebabCase, Zu.last = yv, Zu.lastIndexOf = vw.lastIndexOf, Zu.lowerCase = Cw.lowerCase, Zu.lowerFirst = Cw.lowerFirst, Zu.lt = yw.lt, Zu.lte = yw.lte, Zu.max = bw.max, Zu.maxBy = bw.maxBy, Zu.mean = bw.mean, Zu.meanBy = bw.meanBy, Zu.min = bw.min, Zu.minBy = bw.minBy, Zu.stubArray = _w.stubArray, Zu.stubFalse = _w.stubFalse, Zu.stubObject = _w.stubObject, Zu.stubString = _w.stubString, Zu.stubTrue = _w.stubTrue, Zu.multiply = bw.multiply, Zu.nth = vw.nth, Zu.noop = _w.noop, Zu.now = mw, Zu.pad = Cw.pad, Zu.padEnd = Cw.padEnd, Zu.padStart = Cw.padStart, Zu.parseInt = Cw.parseInt, Zu.random = xw, Zu.reduce = pw.reduce, Zu.reduceRight = pw.reduceRight, Zu.repeat = Cw.repeat, Zu.replace = Cw.replace, Zu.result = jw.result, Zu.round = bw.round, Zu.sample = pw.sample, Zu.size = pw.size, Zu.snakeCase = Cw.snakeCase, Zu.some = pw.some, Zu.sortedIndex = vw.sortedIndex, Zu.sortedIndexBy = vw.sortedIndexBy, Zu.sortedIndexOf = vw.sortedIndexOf, Zu.sortedLastIndex = vw.sortedLastIndex, Zu.sortedLastIndexBy = vw.sortedLastIndexBy, Zu.sortedLastIndexOf = vw.sortedLastIndexOf, Zu.startCase = Cw.startCase, Zu.startsWith = Cw.startsWith, Zu.subtract = bw.subtract, Zu.sum = bw.sum, Zu.sumBy = bw.sumBy, Zu.template = Cw.template, Zu.times = _w.times, Zu.toFinite = yw.toFinite, Zu.toInteger = hu, Zu.toLength = yw.toLength, Zu.toLower = Cw.toLower, Zu.toNumber = yw.toNumber, Zu.toSafeInteger = yw.toSafeInteger, Zu.toString = yw.toString, Zu.toUpper = Cw.toUpper, Zu.trim = Cw.trim, Zu.trimEnd = Cw.trimEnd, Zu.trimStart = Cw.trimStart, Zu.truncate = Cw.truncate, Zu.unescape = Cw.unescape, Zu.uniqueId = _w.uniqueId, Zu.upperCase = Cw.upperCase, Zu.upperFirst = Cw.upperFirst, Zu.each = pw.forEach, Zu.eachRight = pw.forEachRight, Zu.first = vw.head, Rw(Zu, (Mw = {}, Bd(Zu, function(e22, t2) {
  Pw.call(Zu.prototype, t2) || (Mw[t2] = e22);
}), Mw), { chain: false }), Zu.VERSION = "4.17.21", (Zu.templateSettings = Cw.templateSettings).imports._ = Zu, cc(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(e22) {
  Zu[e22].placeholder = Zu;
}), cc(["drop", "take"], function(e22, t2) {
  Fu.prototype[e22] = function(n2) {
    n2 = n2 === void 0 ? 1 : Tw(hu(n2), 0);
    var r2 = this.__filtered__ && !t2 ? new Fu(this) : this.clone();
    return r2.__filtered__ ? r2.__takeCount__ = Iw(n2, r2.__takeCount__) : r2.__views__.push({ size: Iw(n2, 4294967295), type: e22 + (r2.__dir__ < 0 ? "Right" : "") }), r2;
  }, Fu.prototype[e22 + "Right"] = function(t3) {
    return this.reverse()[e22](t3).reverse();
  };
}), cc(["filter", "map", "takeWhile"], function(e22, t2) {
  var n2 = t2 + 1, r2 = n2 == 1 || n2 == 3;
  Fu.prototype[e22] = function(e23) {
    var t3 = this.clone();
    return t3.__iteratees__.push({ iteratee: Pd(e23), type: n2 }), t3.__filtered__ = t3.__filtered__ || r2, t3;
  };
}), cc(["head", "last"], function(e22, t2) {
  var n2 = "take" + (t2 ? "Right" : "");
  Fu.prototype[e22] = function() {
    return this[n2](1).value()[0];
  };
}), cc(["initial", "tail"], function(e22, t2) {
  var n2 = "drop" + (t2 ? "" : "Right");
  Fu.prototype[e22] = function() {
    return this.__filtered__ ? new Fu(this) : this[n2](1);
  };
}), Fu.prototype.compact = function() {
  return this.filter(vu);
}, Fu.prototype.find = function(e22) {
  return this.filter(e22).head();
}, Fu.prototype.findLast = function(e22) {
  return this.reverse().find(e22);
}, Fu.prototype.invokeMap = Ic(function(e22, t2) {
  return typeof e22 == "function" ? new Fu(this) : this.map(function(n2) {
    return lm(n2, e22, t2);
  });
}), Fu.prototype.reject = function(e22) {
  return this.filter(gg(Pd(e22)));
}, Fu.prototype.slice = function(e22, t2) {
  e22 = hu(e22);
  var n2 = this;
  return n2.__filtered__ && (e22 > 0 || t2 < 0) ? new Fu(n2) : (e22 < 0 ? n2 = n2.takeRight(-e22) : e22 && (n2 = n2.drop(e22)), t2 !== void 0 && (n2 = (t2 = hu(t2)) < 0 ? n2.dropRight(-t2) : n2.take(t2 - e22)), n2);
}, Fu.prototype.takeRightWhile = function(e22) {
  return this.reverse().takeWhile(e22).reverse();
}, Fu.prototype.toArray = function() {
  return this.take(4294967295);
}, Bd(Fu.prototype, function(e22, t2) {
  var n2 = /^(?:filter|find|map|reject)|While$/.test(t2), r2 = /^(?:head|last)$/.test(t2), i2 = Zu[r2 ? "take" + (t2 == "last" ? "Right" : "") : t2], o2 = r2 || /^find/.test(t2);
  i2 && (Zu.prototype[t2] = function() {
    var t3 = this.__wrapped__, a2 = r2 ? [1] : arguments, s2 = t3 instanceof Fu, u2 = a2[0], c2 = s2 || Gs(t3), l2 = function(e23) {
      var t4 = i2.apply(Zu, Wl([e23], a2));
      return r2 && f2 ? t4[0] : t4;
    };
    c2 && n2 && typeof u2 == "function" && u2.length != 1 && (s2 = c2 = false);
    var f2 = this.__chain__, h2 = !!this.__actions__.length, d2 = o2 && !f2, v2 = s2 && !h2;
    if (!o2 && c2) {
      t3 = v2 ? t3 : new Fu(this);
      var p2 = e22.apply(t3, a2);
      return p2.__actions__.push({ func: fk, args: [l2], thisArg: void 0 }), new Ku(p2, f2);
    }
    return d2 && v2 ? e22.apply(this, a2) : (p2 = this.thru(l2), d2 ? r2 ? p2.value()[0] : p2.value() : p2);
  });
}), cc(["pop", "push", "shift", "sort", "splice", "unshift"], function(e22) {
  var t2 = Ew[e22], n2 = /^(?:push|sort|unshift)$/.test(e22) ? "tap" : "thru", r2 = /^(?:pop|shift)$/.test(e22);
  Zu.prototype[e22] = function() {
    var e23 = arguments;
    if (r2 && !this.__chain__) {
      var i2 = this.value();
      return t2.apply(Gs(i2) ? i2 : [], e23);
    }
    return this[n2](function(n3) {
      return t2.apply(Gs(n3) ? n3 : [], e23);
    });
  };
}), Bd(Fu.prototype, function(e22, t2) {
  var n2 = Zu[t2];
  if (n2) {
    var r2 = n2.name + "";
    Pw.call(Wu, r2) || (Wu[r2] = []), Wu[r2].push({ name: t2, func: n2 });
  }
}), Wu[jc(void 0, 2).name] = [{ name: "wrapper", func: void 0 }], Fu.prototype.clone = function() {
  var e22 = new Fu(this.__wrapped__);
  return e22.__actions__ = Gu(this.__actions__), e22.__dir__ = this.__dir__, e22.__filtered__ = this.__filtered__, e22.__iteratees__ = Gu(this.__iteratees__), e22.__takeCount__ = this.__takeCount__, e22.__views__ = Gu(this.__views__), e22;
}, Fu.prototype.reverse = function() {
  if (this.__filtered__) {
    var e22 = new Fu(this);
    e22.__dir__ = -1, e22.__filtered__ = true;
  } else
    (e22 = this.clone()).__dir__ *= -1;
  return e22;
}, Fu.prototype.value = function() {
  var e22 = this.__wrapped__.value(), t2 = this.__dir__, n2 = Gs(e22), r2 = t2 < 0, i2 = n2 ? e22.length : 0, o2 = function(e23, t3, n3) {
    for (var r3 = -1, i3 = n3.length; ++r3 < i3; ) {
      var o3 = n3[r3], a3 = o3.size;
      switch (o3.type) {
        case "drop":
          e23 += a3;
          break;
        case "dropRight":
          t3 -= a3;
          break;
        case "take":
          t3 = Ow(t3, e23 + a3);
          break;
        case "takeRight":
          e23 = $w(e23, t3 - a3);
      }
    }
    return { start: e23, end: t3 };
  }(0, i2, this.__views__), a2 = o2.start, s2 = o2.end, u2 = s2 - a2, c2 = r2 ? s2 : a2 - 1, l2 = this.__iteratees__, f2 = l2.length, h2 = 0, d2 = Aw(u2, this.__takeCount__);
  if (!n2 || !r2 && i2 == u2 && d2 == u2)
    return pk(e22, this.__actions__);
  var v2 = [];
  e:
    for (; u2-- && h2 < d2; ) {
      for (var p2 = -1, m2 = e22[c2 += t2]; ++p2 < f2; ) {
        var g2 = l2[p2], y2 = g2.iteratee, b2 = g2.type, k2 = y2(m2);
        if (b2 == 2)
          m2 = k2;
        else if (!k2) {
          if (b2 == 1)
            continue e;
          break e;
        }
      }
      v2[h2++] = m2;
    }
  return v2;
}, Zu.prototype.at = Sw.at, Zu.prototype.chain = Sw.wrapperChain, Zu.prototype.commit = Sw.commit, Zu.prototype.next = Sw.next, Zu.prototype.plant = Sw.plant, Zu.prototype.reverse = Sw.reverse, Zu.prototype.toJSON = Zu.prototype.valueOf = Zu.prototype.value = Sw.value, Zu.prototype.first = Zu.prototype.head, Nw && (Zu.prototype[Nw] = Sw.toIterator);
Object.freeze({ __proto__: null, add: eu, after: du, ary: $c, assign: pl, assignIn: bl, assignInWith: kl, assignWith: wl, at: Yl, attempt: sf, before: uf, bind: cf, bindAll: lf, bindKey: ff, camelCase: nh, capitalize: Af, castArray: rh, ceil: sh, chain: uh, chunk: fh, clamp: dh, clone: td, cloneDeep: nd, cloneDeepWith: rd, cloneWith: id, commit: od, compact: ad, concat: sd, cond: Nd, conforms: Id, conformsTo: Rd, constant: ac, countBy: Jd, create: Ud, curry: Kd, curryRight: Gd, debounce: Xd, deburr: If, defaultTo: ev, defaults: rv, defaultsDeep: fv, defer: dv, delay: vv, difference: gv, differenceBy: bv, differenceWith: kv, divide: wv, drop: xv, dropRight: jv, dropRightWhile: Cv, dropWhile: _v, each: Ov, eachRight: Nv, endsWith: Tv, entries: Rv, entriesIn: Dv, eq: Ac, escape: qv, escapeRegExp: Hv, every: Uv, extend: bl, extendWith: kl, fill: Gv, filter: Yv, find: tp, findIndex: ep, findKey: rp, findLast: sp, findLastIndex: ap, findLastKey: up, first: cp, flatMap: hp, flatMapDeep: dp, flatMapDepth: vp, flatten: Gl, flattenDeep: pp, flattenDepth: mp, flip: gp, floor: yp, flow: kp, flowRight: wp, forEach: Ov, forEachRight: Nv, forIn: xp, forInRight: jp, forOwn: Sp, forOwnRight: Cp, fromPairs: _p, functions: Op, functionsIn: Ap, get: Vl, groupBy: Ep, gt: Tp, gte: Ip, has: zp, hasIn: Od, head: cp, identity: vu, inRange: qp, includes: Jp, indexOf: Kp, initial: Gp, intersection: Xp, intersectionBy: em, intersectionWith: tm, invert: im, invertBy: um, invoke: fm, invokeMap: hm, isArguments: Uc, isArray: Gs, isArrayBuffer: vm, isArrayLike: Dc, isArrayLikeObject: ov, isBoolean: pm, isBuffer: Zc, isDate: gm, isElement: ym, isEmpty: km, isEqual: wm, isEqualWith: xm, isError: af, isFinite: Sm, isFunction: pu, isInteger: Cm, isLength: Rc, isMap: Qh, isMatch: _m, isMatchWith: $m, isNaN: Am, isNative: Em, isNil: Pm, isNull: Nm, isNumber: Om, isObject: ou, isObjectLike: Ws, isPlainObject: of, isRegExp: Im, isSafeInteger: Rm, isSet: Zh, isString: Fp, isSymbol: Js, isTypedArray: al, isUndefined: Dm, isWeakMap: zm, isWeakSet: Lm, iteratee: Bm, join: Fm, kebabCase: Vm, keyBy: Hm, keys: dl, keysIn: yl, last: yv, lastIndexOf: Um, lodash: Zu, lowerCase: Km, lowerFirst: Gm, lt: Ym, lte: Zm, map: fp, mapKeys: Xm, mapValues: eg, matches: tg, matchesProperty: ng, max: ig, maxBy: og, mean: ug, meanBy: cg, memoize: Il, merge: lg, mergeWith: lv, method: fg, methodOf: hg, min: dg, minBy: vg, mixin: pg, multiply: mg, negate: gg, next: kg, noop: Vu, now: Qd, nth: xg, nthArg: jg, omit: _g, omitBy: Mg, once: Eg, orderBy: Tg, over: Rg, overArgs: Lg, overEvery: Bg, overSome: qg, pad: ay, padEnd: sy, padStart: uy, parseInt: fy, partial: hy, partialRight: dy, partition: vy, pick: py, pickBy: Ag, plant: my, property: Ed, propertyOf: gy, pull: xy, pullAll: wy, pullAllBy: jy, pullAllWith: Sy, pullAt: $y, random: Ty, range: zy, rangeRight: Ly, rearg: By, reduce: Fy, reduceRight: Hy, reject: Wy, remove: Jy, repeat: Uy, replace: Ky, rest: Gy, result: Qy, reverse: Zy, round: Xy, sample: nb, sampleSize: ab, set: sb, setWith: ub, shuffle: fb, size: hb, slice: db, snakeCase: vb, some: mb, sortBy: gb, sortedIndex: xb, sortedIndexBy: jb, sortedIndexOf: Sb, sortedLastIndex: Cb, sortedLastIndexBy: _b, sortedLastIndexOf: $b, sortedUniq: Ab, sortedUniqBy: Mb, split: Eb, spread: Nb, startCase: Tb, startsWith: Ib, stubArray: xh, stubFalse: Kc, stubObject: Rb, stubString: Db, stubTrue: zb, subtract: Lb, sum: Bb, sumBy: qb, tail: Fb, take: Vb, takeRight: Hb, takeRightWhile: Wb, takeWhile: Jb, tap: Ub, template: ck, templateSettings: ek, throttle: lk, thru: fk, times: dk, toArray: bg, toFinite: fu, toInteger: hu, toIterator: vk, toJSON: mk, toLength: Kv, toLower: gk, toNumber: lu, toPairs: Rv, toPairsIn: Dv, toPath: yk, toPlainObject: sv, toSafeInteger: bk, toString: Ll, toUpper: kk, transform: wk, trim: Sk, trimEnd: Ck, trimStart: $k, truncate: Ak, unary: Mk, unescape: Tk, union: Dk, unionBy: zk, unionWith: Lk, uniq: Bk, uniqBy: qk, uniqWith: Fk, uniqueId: Hk, unset: Wk, unzip: Uk, unzipWith: Kk, update: Qk, updateWith: Yk, upperCase: Zk, upperFirst: Of, value: mk, valueOf: mk, values: Hp, valuesIn: Xk, without: ew, words: Xf, wrap: tw, wrapperAt: nw, wrapperChain: rw, wrapperCommit: od, wrapperLodash: Zu, wrapperNext: kg, wrapperPlant: my, wrapperReverse: iw, wrapperToIterator: vk, wrapperValue: mk, xor: aw, xorBy: sw, xorWith: uw, zip: cw, zipObject: fw, zipObjectDeep: hw, zipWith: dw, default: Zu });
var zw = [];
function Lw(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1], n2 = {};
  if (!Array.isArray(e22))
    throw new TypeError("Array expected");
  function r2(e23, i3) {
    (!Array.isArray(e23) && !$s(e23) || t2 && i3.length > 0) && (n2[cs.exports.compileJSONPointer(i3)] = true), $s(e23) && Object.keys(e23).forEach(function(t3) {
      r2(e23[t3], i3.concat(t3));
    });
  }
  for (var i2 = Math.min(e22.length, 1e4), o2 = 0; o2 < i2; o2++) {
    var a2 = e22[o2];
    r2(a2, zw);
  }
  var s2 = Object.keys(n2).sort();
  return s2.map(cs.exports.parseJSONPointer);
}
function Bw(e22, t2, n2) {
  if (!(t2 <= e22))
    for (var r2 = e22; r2 < t2; r2++)
      n2(r2);
}
function qw(e22, t2) {
  return e22.length > t2 ? e22.slice(0, t2) : e22;
}
function Fw(e22) {
  return Ei({}, e22);
}
function Vw(e22) {
  return Object.values(e22);
}
function Hw(e22, t2, n2, r2) {
  var i2 = e22.slice(0), o2 = i2.splice(t2, n2);
  return i2.splice.apply(i2, [t2 + r2, 0].concat(Ni(o2))), i2;
}
function Ww(e22) {
  return parseInt(e22, 10);
}
function Jw(e22) {
  return $s(e22);
}
function Uw(e22) {
  return Array.isArray(e22);
}
function Kw(e22) {
  try {
    return JSON.parse(e22);
  } catch (t2) {
    return JSON.parse(_s(e22));
  }
}
function Gw(e22) {
  try {
    return Kw(e22);
  } catch (e23) {
    return;
  }
}
function Qw(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : JSON.parse;
  e22 = e22.replace(Zw, "");
  try {
    return t2(e22);
  } catch (e23) {
  }
  try {
    return t2("[" + e22 + "]");
  } catch (e23) {
  }
  try {
    return t2("{" + e22 + "}");
  } catch (e23) {
  }
  throw new Error("Failed to parse partial JSON");
}
function Yw(e22) {
  e22 = e22.replace(Zw, "");
  try {
    return _s(e22);
  } catch (e23) {
  }
  try {
    var t2 = _s("[" + e22 + "]");
    return t2.substring(1, t2.length - 1);
  } catch (e23) {
  }
  try {
    var n2 = _s("{" + e22 + "}");
    return n2.substring(1, n2.length - 1);
  } catch (e23) {
  }
  throw new Error("Failed to repair partial JSON");
}
var Zw = /,\s*$/;
function Xw(e22, t2) {
  var n2 = ux.exec(t2);
  if (n2) {
    var r2 = Ww(n2[2]), i2 = function(e23, t3) {
      for (var n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, r3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : e23.length, i3 = 0, o3 = n3; o3 < r3; o3++)
        e23.charAt(o3) === t3 && i3++;
      return i3;
    }(e22, "\n", 0, r2), o2 = r2 - e22.lastIndexOf("\n", r2) - 1;
    return { position: r2, line: i2, column: o2, message: t2.replace(ux, function() {
      return "line ".concat(i2 + 1, " column ").concat(o2 + 1);
    }) };
  }
  var a2 = cx.exec(t2), s2 = a2 ? Ww(a2[1]) : null, u2 = s2 !== null ? s2 - 1 : null, c2 = lx.exec(t2), l2 = c2 ? Ww(c2[1]) : null, f2 = l2 !== null ? l2 - 1 : null;
  return { position: u2 !== null && f2 !== null ? function(e23, t3, n3) {
    var r3 = e23.indexOf("\n"), i3 = 1;
    for (; i3 < t3 && r3 !== -1; )
      r3 = e23.indexOf("\n", r3 + 1), i3++;
    return r3 !== -1 ? r3 + n3 + 1 : null;
  }(e22, u2, f2) : null, line: u2, column: f2, message: t2.replace(/^JSON.parse: /, "").replace(/ of the JSON data$/, "") };
}
function ex(e22) {
  return $s(e22) ? e22.json !== void 0 ? e22.text !== void 0 ? 'Content must contain either a property "json" or a property "text" but not both' : null : e22.text === void 0 ? 'Content must contain either a property "json" or a property "text"' : typeof e22.text != "string" ? 'Content "text" property must be string' : null : "Content must be an object";
}
function tx(e22) {
  return typeof e22.text == "string";
}
function nx(e22, t2) {
  return rx(e22, t2) > t2;
}
function rx(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1 / 0;
  if (tx(e22))
    return e22.text.length;
  var n2 = e22.json, r2 = 0;
  function i2(e23) {
    if (Array.isArray(e23)) {
      if ((r2 += e23.length - 1 + 2) > t2)
        return r2;
      for (var n3 = 0; n3 < e23.length; n3++) {
        if (i2(e23[n3]), r2 > t2)
          return r2;
      }
    } else if ($s(e23)) {
      var o2 = Object.keys(e23);
      r2 += 2 + o2.length + (o2.length - 1);
      for (var a2 = 0; a2 < o2.length; a2++) {
        var s2 = o2[a2], u2 = e23[s2];
        r2 += s2.length + 2, i2(u2);
      }
    } else
      r2 += typeof e23 == "string" ? e23.length + 2 : String(e23).length;
  }
  return i2(n2), r2;
}
var ix, ox, ax, sx, ux = /(position|char) (\d+)/, cx = /line (\d+)/, lx = /column (\d+)/;
function fx(e22) {
  var t2 = e22.escapeControlCharacters, n2 = e22.escapeUnicodeCharacters;
  return t2 ? n2 ? hx : dx : n2 ? vx : px;
}
!function(e22) {
  e22.text = "text", e22.tree = "tree";
}(ix || (ix = {})), function(e22) {
  e22.after = "after", e22.inside = "inside", e22.key = "key", e22.value = "value", e22.multi = "multi";
}(ox || (ox = {})), function(e22) {
  e22.after = "after", e22.key = "key", e22.value = "value", e22.inside = "inside";
}(ax || (ax = {})), function(e22) {
  e22.key = "key", e22.value = "value";
}(sx || (sx = {}));
var hx = { escapeValue: function(e22) {
  return mx(kx(String(e22)));
}, unescapeValue: function(e22) {
  return wx(gx(e22));
} }, dx = { escapeValue: function(e22) {
  return kx(String(e22));
}, unescapeValue: function(e22) {
  return wx(e22);
} }, vx = { escapeValue: function(e22) {
  return mx(String(e22));
}, unescapeValue: function(e22) {
  return gx(e22);
} }, px = { escapeValue: function(e22) {
  return String(e22);
}, unescapeValue: function(e22) {
  return e22;
} };
function mx(e22) {
  return e22.replace(/[^\x20-\x7F]/g, function(e23) {
    return e23 === "\b" || e23 === "\f" || e23 === "\n" || e23 === "\r" || e23 === "	" ? e23 : "\\u" + ("000" + e23.codePointAt(0).toString(16)).slice(-4);
  });
}
function gx(e22) {
  return e22.replace(/\\u[a-fA-F0-9]{4}/g, function(e23) {
    try {
      return JSON.parse('"' + e23 + '"');
    } catch (t2) {
      return e23;
    }
  });
}
var yx = { "\b": "\\b", "\f": "\\f", "\n": "\\n", "\r": "\\r", "	": "\\t" }, bx = { "\\b": "\b", "\\f": "\f", "\\n": "\n", "\\r": "\r", "\\t": "	" };
function kx(e22) {
  return e22.replace(/[\b\f\n\r\t]/g, function(e23) {
    return yx[e23] || e23;
  });
}
function wx(e22) {
  return e22.replace(/\\[bfnrt]/g, function(e23) {
    return bx[e23] || e23;
  });
}
function xx(e22) {
  return typeof e22 != "string" ? String(e22) : e22.endsWith("\n") ? e22 + "\n" : e22;
}
function jx(e22, t2) {
  return Cx(e22, function(e23) {
    return e23.nodeName.toUpperCase() === t2.toUpperCase();
  });
}
function Sx(e22, t2, n2) {
  return Cx(e22, function(e23) {
    return function(e24, t3, n3) {
      return typeof e24.getAttribute == "function" && e24.getAttribute(t3) === n3;
    }(e23, t2, n2);
  });
}
function Cx(e22, t2) {
  return !!_x(e22, t2);
}
function _x(e22, t2) {
  for (var n2 = e22; n2 && !t2(n2); )
    n2 = n2.parentNode;
  return n2 || void 0;
}
function $x(e22) {
  if (e22.firstChild != null) {
    var t2 = document.createRange(), n2 = window.getSelection();
    t2.setStart(e22, 1), t2.collapse(true), n2.removeAllRanges(), n2.addRange(t2);
  } else
    e22.focus();
}
function Ox(e22) {
  return e22 && e22.ownerDocument && e22.ownerDocument.defaultView;
}
function Ax(e22) {
  return Cx(Ox(e22).document.activeElement, function(t2) {
    return t2 === e22;
  });
}
function Mx(e22, t2) {
  return _x(e22, function(e23) {
    return e23.nodeName === t2;
  });
}
function Ex(e22) {
  return Sx(e22, "data-type", "selectable-key") ? ox.key : Sx(e22, "data-type", "selectable-value") ? ox.value : Sx(e22, "data-type", "insert-selection-area-inside") ? ox.inside : Sx(e22, "data-type", "insert-selection-area-after") ? ox.after : ox.multi;
}
function Px(e22) {
  return encodeURIComponent(cs.exports.compileJSONPointer(e22));
}
function Nx(e22) {
  var t2, n2 = _x(e22, function(e23) {
    return e23.hasAttribute("data-path");
  });
  return n2 ? (t2 = n2.getAttribute("data-path"), cs.exports.parseJSONPointer(decodeURIComponent(t2))) : null;
}
function Tx(e22) {
  var t2 = e22.allElements, n2 = e22.currentElement, r2 = e22.direction, i2 = e22.hasPrio, o2 = i2 === void 0 ? function() {
    return true;
  } : i2, a2 = e22.margin, s2 = a2 === void 0 ? 10 : a2, u2 = fp(t2.filter(function(e23) {
    var t3 = e23.getBoundingClientRect();
    return t3.width > 0 && t3.height > 0;
  }), l2), c2 = l2(n2);
  function l2(e23) {
    var t3 = e23.getBoundingClientRect();
    return { x: t3.left + t3.width / 2, y: t3.top + t3.height / 2, rect: t3, element: e23 };
  }
  function f2(e23, t3) {
    var n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 1, r3 = e23.x - t3.x, i3 = (e23.y - t3.y) * n3;
    return Math.sqrt(r3 * r3 + i3 * i3);
  }
  var h2 = function(e23) {
    return f2(e23, c2);
  };
  if (r2 === "Left" || r2 === "Right") {
    var d2 = r2 === "Left" ? u2.filter(function(e23) {
      return t3 = c2, e23.rect.left + s2 < t3.rect.left;
      var t3;
    }) : u2.filter(function(e23) {
      return t3 = c2, e23.rect.right > t3.rect.right + s2;
      var t3;
    }), v2 = vg(d2.filter(function(e23) {
      return t3 = e23, n3 = c2, Math.abs(t3.y - n3.y) < s2;
      var t3, n3;
    }), h2) || vg(d2, function(e23) {
      return f2(e23, c2, 10);
    });
    return v2 == null ? void 0 : v2.element;
  }
  if (r2 === "Up" || r2 === "Down") {
    var p2 = r2 === "Up" ? u2.filter(function(e23) {
      return t3 = c2, e23.y + s2 < t3.y;
      var t3;
    }) : u2.filter(function(e23) {
      return t3 = c2, e23.y > t3.y + s2;
      var t3;
    }), m2 = vg(p2.filter(function(e23) {
      return o2(e23.element);
    }), h2) || vg(p2, h2);
    return m2 == null ? void 0 : m2.element;
  }
}
var Ix = typeof navigator != "undefined" && navigator.platform.toUpperCase().indexOf("MAC") >= 0;
function Rx(e22) {
  var t2 = [];
  e22.ctrlKey && t2.push("Ctrl"), e22.metaKey && t2.push("Command"), e22.altKey && t2.push(Ix ? "Option" : "Alt"), e22.shiftKey && t2.push("Shift");
  var n2 = function(e23) {
    return zx[e23] || "";
  }(e22.which);
  return Dx[n2] || t2.push(n2), t2.join("+");
}
var Dx = { Ctrl: true, Command: true, Alt: true, Option: true, Shift: true }, zx = { 8: "Backspace", 9: "Tab", 13: "Enter", 16: "Shift", 17: "Ctrl", 18: "Alt", 19: "Pause_Break", 20: "Caps_Lock", 27: "Escape", 33: "Page_Up", 34: "Page_Down", 35: "End", 36: "Home", 37: "Left", 38: "Up", 39: "Right", 40: "Down", 45: "Insert", 46: "Delete", 48: "0", 49: "1", 50: "2", 51: "3", 52: "4", 53: "5", 54: "6", 55: "7", 56: "8", 57: "9", 65: "A", 66: "B", 67: "C", 68: "D", 69: "E", 70: "F", 71: "G", 72: "H", 73: "I", 74: "J", 75: "K", 76: "L", 77: "M", 78: "N", 79: "O", 80: "P", 81: "Q", 82: "R", 83: "S", 84: "T", 85: "U", 86: "V", 87: "W", 88: "X", 89: "Y", 90: "Z", 91: "Left_Window_Key", 92: "Right_Window_Key", 93: "Select_Key", 96: "Numpad_0", 97: "Numpad_1", 98: "Numpad_2", 99: "Numpad_3", 100: "Numpad_4", 101: "Numpad_5", 102: "Numpad_6", 103: "Numpad_7", 104: "Numpad_8", 105: "Numpad_9", 106: "Numpad_*", 107: "Numpad_+", 109: "Numpad_-", 110: "Numpad_.", 111: "Numpad_/", 112: "F1", 113: "F2", 114: "F3", 115: "F4", 116: "F5", 117: "F6", 118: "F7", 119: "F8", 120: "F9", 121: "F10", 122: "F11", 123: "F12", 144: "Num_Lock", 145: "Scroll_Lock", 186: ";", 187: "=", 188: ",", 189: "-", 190: ".", 191: "/", 192: "`", 219: "[", 220: "\\", 221: "]", 222: "'" }, Lx = xa.window;
function Bx(e22) {
  co(e22, "svelte-p9zniz", ".jse-absolute-popup.svelte-p9zniz.svelte-p9zniz{position:relative;left:0;top:0;width:0;height:0;z-index:1001}.jse-absolute-popup.svelte-p9zniz .jse-hidden-input.svelte-p9zniz{position:absolute;left:0;top:0;width:0;height:0;padding:0;margin:0;border:none;outline:none;overflow:hidden}.jse-absolute-popup.svelte-p9zniz .jse-absolute-popup-content.svelte-p9zniz{position:absolute}");
}
function qx(e22) {
  var t2, n2, r2, i2, o2, a2, s2 = [e22[0].props], u2 = e22[0].component;
  function c2(e23) {
    for (var t3 = {}, n3 = 0; n3 < s2.length; n3 += 1)
      t3 = Fi(t3, s2[n3]);
    return { props: t3 };
  }
  return u2 && (i2 = new u2(c2())), { c: function() {
    t2 = go("div"), n2 = go("input"), r2 = ko(), i2 && Aa(i2.$$.fragment), So(n2, "class", "jse-hidden-input svelte-p9zniz"), So(t2, "class", "jse-absolute-popup-content svelte-p9zniz"), So(t2, "style", o2 = Hx(e22[1], e22[0].options));
  }, m: function(o3, s3) {
    vo(o3, t2, s3), uo(t2, n2), e22[7](n2), uo(t2, r2), i2 && Ma(i2, t2, null), a2 = true;
  }, p: function(e23, n3) {
    var r3 = 1 & n3 ? _a(s2, [$a(e23[0].props)]) : {};
    if (u2 !== (u2 = e23[0].component)) {
      if (i2) {
        ma();
        var l2 = i2;
        ba(l2.$$.fragment, 1, 0, function() {
          Ea(l2, 1);
        }), ga();
      }
      u2 ? (Aa((i2 = new u2(c2())).$$.fragment), ya(i2.$$.fragment, 1), Ma(i2, t2, null)) : i2 = null;
    } else
      u2 && i2.$set(r3);
    (!a2 || 3 & n3 && o2 !== (o2 = Hx(e23[1], e23[0].options))) && So(t2, "style", o2);
  }, i: function(e23) {
    a2 || (i2 && ya(i2.$$.fragment, e23), a2 = true);
  }, o: function(e23) {
    i2 && ba(i2.$$.fragment, e23), a2 = false;
  }, d: function(n3) {
    n3 && po(t2), e22[7](null), i2 && Ea(i2);
  } };
}
function Fx(e22) {
  var t2, n2, r2, i2, o2 = e22[1] && qx(e22);
  return { c: function() {
    t2 = go("div"), o2 && o2.c(), So(t2, "class", "jse-absolute-popup svelte-p9zniz");
  }, m: function(a2, s2) {
    vo(a2, t2, s2), o2 && o2.m(t2, null), e22[8](t2), n2 = true, r2 || (i2 = [xo(Lx, "mousedown", e22[3], true), xo(Lx, "keydown", e22[4], true), xo(Lx, "wheel", e22[5], true), xo(t2, "mousedown", Vx), xo(t2, "keydown", e22[4])], r2 = true);
  }, p: function(e23, n3) {
    var r3 = xi(n3, 1)[0];
    e23[1] ? o2 ? (o2.p(e23, r3), 2 & r3 && ya(o2, 1)) : ((o2 = qx(e23)).c(), ya(o2, 1), o2.m(t2, null)) : o2 && (ma(), ba(o2, 1, 1, function() {
      o2 = null;
    }), ga());
  }, i: function(e23) {
    n2 || (ya(o2), n2 = true);
  }, o: function(e23) {
    ba(o2), n2 = false;
  }, d: function(n3) {
    n3 && po(t2), o2 && o2.d(), e22[8](null), r2 = false, Wi(i2);
  } };
}
function Vx(e22) {
  e22.stopPropagation();
}
function Hx(e22, t2) {
  var n2 = e22.getBoundingClientRect(), r2 = function() {
    if (t2.anchor) {
      var e23 = t2.anchor, n3 = t2.width, r3 = n3 === void 0 ? 0 : n3, i3 = t2.height, o3 = i3 === void 0 ? 0 : i3, a3 = t2.offsetTop, s3 = a3 === void 0 ? 0 : a3, u2 = t2.offsetLeft, c2 = u2 === void 0 ? 0 : u2, l2 = t2.position, f2 = e23.getBoundingClientRect(), h2 = f2.left, d2 = f2.top, v2 = f2.bottom, p2 = f2.right, m2 = l2 === "top" || d2 + o3 > window.innerHeight && d2 > o3, g2 = l2 === "left" || h2 + r3 > window.innerWidth && h2 > r3;
      return { left: g2 ? p2 - c2 : h2 + c2, top: m2 ? d2 - s3 : v2 + s3, positionAbove: m2, positionLeft: g2 };
    }
    if (typeof t2.left == "number" && typeof t2.top == "number") {
      var y2 = t2.left, b2 = t2.top, k2 = t2.width, w2 = k2 === void 0 ? 0 : k2, x2 = t2.height, j2 = x2 === void 0 ? 0 : x2;
      return { left: y2, top: b2, positionAbove: b2 + j2 > window.innerHeight && b2 > j2, positionLeft: y2 + w2 > window.innerWidth && y2 > w2 };
    }
    throw new Error('Invalid config: pass either "left" and "top", or pass "anchor"');
  }(), i2 = r2.left, o2 = r2.top, a2 = r2.positionAbove, s2 = r2.positionLeft;
  return (a2 ? "bottom: ".concat(n2.top - o2, "px;") : "top: ".concat(o2 - n2.top, "px;")) + (s2 ? "right: ".concat(n2.left - i2, "px;") : "left: ".concat(i2 - n2.left, "px;"));
}
function Wx(e22, t2, n2) {
  var r2, i2, o2 = t2.popup, a2 = t2.closeAbsolutePopup;
  function s2(e23) {
    o2.options && o2.options.closeOnOuterClick && !Cx(e23.target, function(e24) {
      return e24 === r2;
    }) && a2(o2.id);
  }
  return Uo(function() {
    i2 && i2.focus();
  }), e22.$$set = function(e23) {
    "popup" in e23 && n2(0, o2 = e23.popup), "closeAbsolutePopup" in e23 && n2(6, a2 = e23.closeAbsolutePopup);
  }, [o2, r2, i2, function(e23) {
    s2(e23);
  }, function(e23) {
    Rx(e23) === "Escape" && a2(o2.id);
  }, function(e23) {
    s2(e23);
  }, a2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(2, i2 = e23);
    });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(1, r2 = e23);
    });
  }];
}
var Jx = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, Wx, Fx, Ui, { popup: 0, closeAbsolutePopup: 6 }, Bx), r2;
  }
  return zi(n2);
}();
function Ux(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[6] = t2[n2], r2;
}
function Kx(e22) {
  var t2, n2;
  return t2 = new Jx({ props: { popup: e22[6], closeAbsolutePopup: e22[1] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    1 & n3 && (r2.popup = e23[6]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function Gx(e22) {
  for (var t2, n2, r2 = e22[0], i2 = [], o2 = 0; o2 < r2.length; o2 += 1)
    i2[o2] = Kx(Ux(e22, r2, o2));
  var a2 = function(e23) {
    return ba(i2[e23], 1, 1, function() {
      i2[e23] = null;
    });
  }, s2 = e22[3].default, u2 = Gi(s2, e22, e22[2], null);
  return { c: function() {
    for (var e23 = 0; e23 < i2.length; e23 += 1)
      i2[e23].c();
    t2 = ko(), u2 && u2.c();
  }, m: function(e23, r3) {
    for (var o3 = 0; o3 < i2.length; o3 += 1)
      i2[o3].m(e23, r3);
    vo(e23, t2, r3), u2 && u2.m(e23, r3), n2 = true;
  }, p: function(e23, o3) {
    var c2 = xi(o3, 1)[0];
    if (3 & c2) {
      var l2;
      for (r2 = e23[0], l2 = 0; l2 < r2.length; l2 += 1) {
        var f2 = Ux(e23, r2, l2);
        i2[l2] ? (i2[l2].p(f2, c2), ya(i2[l2], 1)) : (i2[l2] = Kx(f2), i2[l2].c(), ya(i2[l2], 1), i2[l2].m(t2.parentNode, t2));
      }
      for (ma(), l2 = r2.length; l2 < i2.length; l2 += 1)
        a2(l2);
      ga();
    }
    u2 && u2.p && (!n2 || 4 & c2) && Zi(u2, s2, e23, e23[2], n2 ? Yi(s2, e23[2], c2, null) : Xi(e23[2]), null);
  }, i: function(e23) {
    if (!n2) {
      for (var t3 = 0; t3 < r2.length; t3 += 1)
        ya(i2[t3]);
      ya(u2, e23), n2 = true;
    }
  }, o: function(e23) {
    i2 = i2.filter(Boolean);
    for (var t3 = 0; t3 < i2.length; t3 += 1)
      ba(i2[t3]);
    ba(u2, e23), n2 = false;
  }, d: function(e23) {
    mo(i2, e23), e23 && po(t2), u2 && u2.d(e23);
  } };
}
function Qx(e22, t2, n2) {
  var r2 = t2.$$slots, i2 = r2 === void 0 ? {} : r2, o2 = t2.$$scope, a2 = Ia("jsoneditor:AbsolutePopup"), s2 = [];
  function u2(e23) {
    var t3 = s2.findIndex(function(t4) {
      return t4.id === e23;
    });
    if (t3 !== -1) {
      var r3 = s2[t3];
      r3.options.onClose && r3.options.onClose(), n2(0, s2 = s2.filter(function(t4) {
        return t4.id !== e23;
      }));
    }
  }
  return Qo("absolute-popup", { openAbsolutePopup: function(e23, t3, r3) {
    a2("open...", t3, r3);
    var i3 = { id: ss(), component: e23, props: t3 || {}, options: r3 || {} };
    return n2(0, s2 = [].concat(Ni(s2), [i3])), i3.id;
  }, closeAbsolutePopup: u2 }), e22.$$set = function(e23) {
    "$$scope" in e23 && n2(2, o2 = e23.$$scope);
  }, e22.$$.update = function() {
    1 & e22.$$.dirty && a2("popups", s2);
  }, [s2, u2, o2, i2];
}
var Yx = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, Qx, Gx, Ki, {}), r2;
  }
  return zi(n2);
}(), Zx = { prefix: "fas", iconName: "angle-down", icon: [384, 512, [8964], "f107", "M192 384c-8.188 0-16.38-3.125-22.62-9.375l-160-160c-12.5-12.5-12.5-32.75 0-45.25s32.75-12.5 45.25 0L192 306.8l137.4-137.4c12.5-12.5 32.75-12.5 45.25 0s12.5 32.75 0 45.25l-160 160C208.4 380.9 200.2 384 192 384z"] }, Xx = { prefix: "fas", iconName: "angle-right", icon: [256, 512, [8250], "f105", "M64 448c-8.188 0-16.38-3.125-22.62-9.375c-12.5-12.5-12.5-32.75 0-45.25L178.8 256L41.38 118.6c-12.5-12.5-12.5-32.75 0-45.25s32.75-12.5 45.25 0l160 160c12.5 12.5 12.5 32.75 0 45.25l-160 160C80.38 444.9 72.19 448 64 448z"] }, ej = { prefix: "fas", iconName: "arrow-down", icon: [384, 512, [8595], "f063", "M374.6 310.6l-160 160C208.4 476.9 200.2 480 192 480s-16.38-3.125-22.62-9.375l-160-160c-12.5-12.5-12.5-32.75 0-45.25s32.75-12.5 45.25 0L160 370.8V64c0-17.69 14.33-31.1 31.1-31.1S224 46.31 224 64v306.8l105.4-105.4c12.5-12.5 32.75-12.5 45.25 0S387.1 298.1 374.6 310.6z"] }, tj = { prefix: "fas", iconName: "arrow-down-short-wide", icon: [576, 512, ["sort-amount-desc", "sort-amount-down-alt"], "f884", "M320 224H416c17.67 0 32-14.33 32-32s-14.33-32-32-32h-95.1c-17.67 0-32 14.33-32 32S302.3 224 320 224zM320 352H480c17.67 0 32-14.33 32-32s-14.33-32-32-32h-159.1c-17.67 0-32 14.33-32 32S302.3 352 320 352zM320 96h32c17.67 0 31.1-14.33 31.1-32s-14.33-32-31.1-32h-32c-17.67 0-32 14.33-32 32S302.3 96 320 96zM544 416h-223.1c-17.67 0-32 14.33-32 32s14.33 32 32 32H544c17.67 0 32-14.33 32-32S561.7 416 544 416zM192.4 330.7L160 366.1V64.03C160 46.33 145.7 32 128 32S96 46.33 96 64.03v302L63.6 330.7c-6.312-6.883-14.94-10.38-23.61-10.38c-7.719 0-15.47 2.781-21.61 8.414c-13.03 11.95-13.9 32.22-1.969 45.27l87.1 96.09c12.12 13.26 35.06 13.26 47.19 0l87.1-96.09c11.94-13.05 11.06-33.31-1.969-45.27C224.6 316.8 204.4 317.7 192.4 330.7z"] }, nj = { prefix: "fas", iconName: "arrow-rotate-left", icon: [512, 512, [8634, "arrow-left-rotate", "arrow-rotate-back", "arrow-rotate-backward", "undo"], "f0e2", "M480 256c0 123.4-100.5 223.9-223.9 223.9c-48.86 0-95.19-15.58-134.2-44.86c-14.14-10.59-17-30.66-6.391-44.81c10.61-14.09 30.69-16.97 44.8-6.375c27.84 20.91 61 31.94 95.89 31.94C344.3 415.8 416 344.1 416 256s-71.67-159.8-159.8-159.8C205.9 96.22 158.6 120.3 128.6 160H192c17.67 0 32 14.31 32 32S209.7 224 192 224H48c-17.67 0-32-14.31-32-32V48c0-17.69 14.33-32 32-32s32 14.31 32 32v70.23C122.1 64.58 186.1 32.11 256.1 32.11C379.5 32.11 480 132.6 480 256z"] }, rj = { prefix: "fas", iconName: "arrow-rotate-right", icon: [512, 512, [8635, "arrow-right-rotate", "arrow-rotate-forward", "redo"], "f01e", "M496 48V192c0 17.69-14.31 32-32 32H320c-17.69 0-32-14.31-32-32s14.31-32 32-32h63.39c-29.97-39.7-77.25-63.78-127.6-63.78C167.7 96.22 96 167.9 96 256s71.69 159.8 159.8 159.8c34.88 0 68.03-11.03 95.88-31.94c14.22-10.53 34.22-7.75 44.81 6.375c10.59 14.16 7.75 34.22-6.375 44.81c-39.03 29.28-85.36 44.86-134.2 44.86C132.5 479.9 32 379.4 32 256s100.5-223.9 223.9-223.9c69.15 0 134 32.47 176.1 86.12V48c0-17.69 14.31-32 32-32S496 30.31 496 48z"] }, ij = { prefix: "fas", iconName: "caret-down", icon: [320, 512, [], "f0d7", "M310.6 246.6l-127.1 128C176.4 380.9 168.2 384 160 384s-16.38-3.125-22.63-9.375l-127.1-128C.2244 237.5-2.516 223.7 2.438 211.8S19.07 192 32 192h255.1c12.94 0 24.62 7.781 29.58 19.75S319.8 237.5 310.6 246.6z"] }, oj = { prefix: "fas", iconName: "caret-right", icon: [256, 512, [], "f0da", "M118.6 105.4l128 127.1C252.9 239.6 256 247.8 256 255.1s-3.125 16.38-9.375 22.63l-128 127.1c-9.156 9.156-22.91 11.9-34.88 6.943S64 396.9 64 383.1V128c0-12.94 7.781-24.62 19.75-29.58S109.5 96.23 118.6 105.4z"] }, aj = { prefix: "fas", iconName: "check", icon: [448, 512, [10004, 10003], "f00c", "M438.6 105.4C451.1 117.9 451.1 138.1 438.6 150.6L182.6 406.6C170.1 419.1 149.9 419.1 137.4 406.6L9.372 278.6C-3.124 266.1-3.124 245.9 9.372 233.4C21.87 220.9 42.13 220.9 54.63 233.4L159.1 338.7L393.4 105.4C405.9 92.88 426.1 92.88 438.6 105.4H438.6z"] }, sj = { prefix: "fas", iconName: "chevron-down", icon: [448, 512, [], "f078", "M224 416c-8.188 0-16.38-3.125-22.62-9.375l-192-192c-12.5-12.5-12.5-32.75 0-45.25s32.75-12.5 45.25 0L224 338.8l169.4-169.4c12.5-12.5 32.75-12.5 45.25 0s12.5 32.75 0 45.25l-192 192C240.4 412.9 232.2 416 224 416z"] }, uj = { prefix: "fas", iconName: "chevron-up", icon: [448, 512, [], "f077", "M416 352c-8.188 0-16.38-3.125-22.62-9.375L224 173.3l-169.4 169.4c-12.5 12.5-32.75 12.5-45.25 0s-12.5-32.75 0-45.25l192-192c12.5-12.5 32.75-12.5 45.25 0l192 192c12.5 12.5 12.5 32.75 0 45.25C432.4 348.9 424.2 352 416 352z"] }, cj = { prefix: "fas", iconName: "circle-notch", icon: [512, 512, [], "f1ce", "M222.7 32.15C227.7 49.08 218.1 66.9 201.1 71.94C121.8 95.55 64 169.1 64 255.1C64 362 149.1 447.1 256 447.1C362 447.1 448 362 448 255.1C448 169.1 390.2 95.55 310.9 71.94C293.9 66.9 284.3 49.08 289.3 32.15C294.4 15.21 312.2 5.562 329.1 10.6C434.9 42.07 512 139.1 512 255.1C512 397.4 397.4 511.1 256 511.1C114.6 511.1 0 397.4 0 255.1C0 139.1 77.15 42.07 182.9 10.6C199.8 5.562 217.6 15.21 222.7 32.15V32.15z"] }, lj = { prefix: "fas", iconName: "clone", icon: [512, 512, [], "f24d", "M0 224C0 188.7 28.65 160 64 160H128V288C128 341 170.1 384 224 384H352V448C352 483.3 323.3 512 288 512H64C28.65 512 0 483.3 0 448V224zM224 352C188.7 352 160 323.3 160 288V64C160 28.65 188.7 0 224 0H448C483.3 0 512 28.65 512 64V288C512 323.3 483.3 352 448 352H224z"] }, fj = { prefix: "fas", iconName: "code", icon: [640, 512, [], "f121", "M414.8 40.79L286.8 488.8C281.9 505.8 264.2 515.6 247.2 510.8C230.2 505.9 220.4 488.2 225.2 471.2L353.2 23.21C358.1 6.216 375.8-3.624 392.8 1.232C409.8 6.087 419.6 23.8 414.8 40.79H414.8zM518.6 121.4L630.6 233.4C643.1 245.9 643.1 266.1 630.6 278.6L518.6 390.6C506.1 403.1 485.9 403.1 473.4 390.6C460.9 378.1 460.9 357.9 473.4 345.4L562.7 256L473.4 166.6C460.9 154.1 460.9 133.9 473.4 121.4C485.9 108.9 506.1 108.9 518.6 121.4V121.4zM166.6 166.6L77.25 256L166.6 345.4C179.1 357.9 179.1 378.1 166.6 390.6C154.1 403.1 133.9 403.1 121.4 390.6L9.372 278.6C-3.124 266.1-3.124 245.9 9.372 233.4L121.4 121.4C133.9 108.9 154.1 108.9 166.6 121.4C179.1 133.9 179.1 154.1 166.6 166.6V166.6z"] }, hj = { prefix: "fas", iconName: "copy", icon: [512, 512, [], "f0c5", "M384 96L384 0h-112c-26.51 0-48 21.49-48 48v288c0 26.51 21.49 48 48 48H464c26.51 0 48-21.49 48-48V128h-95.1C398.4 128 384 113.6 384 96zM416 0v96h96L416 0zM192 352V128h-144c-26.51 0-48 21.49-48 48v288c0 26.51 21.49 48 48 48h192c26.51 0 48-21.49 48-48L288 416h-32C220.7 416 192 387.3 192 352z"] }, dj = { prefix: "fas", iconName: "crop-simple", icon: [512, 512, ["crop-alt"], "f565", "M128 384H352V448H128C92.65 448 64 419.3 64 384V128H32C14.33 128 0 113.7 0 96C0 78.33 14.33 64 32 64H64V32C64 14.33 78.33 0 96 0C113.7 0 128 14.33 128 32V384zM384 128H160V64H384C419.3 64 448 92.65 448 128V384H480C497.7 384 512 398.3 512 416C512 433.7 497.7 448 480 448H448V480C448 497.7 433.7 512 416 512C398.3 512 384 497.7 384 480V128z"] }, vj = { prefix: "fas", iconName: "ellipsis-vertical", icon: [128, 512, ["ellipsis-v"], "f142", "M64 360C94.93 360 120 385.1 120 416C120 446.9 94.93 472 64 472C33.07 472 8 446.9 8 416C8 385.1 33.07 360 64 360zM64 200C94.93 200 120 225.1 120 256C120 286.9 94.93 312 64 312C33.07 312 8 286.9 8 256C8 225.1 33.07 200 64 200zM64 152C33.07 152 8 126.9 8 96C8 65.07 33.07 40 64 40C94.93 40 120 65.07 120 96C120 126.9 94.93 152 64 152z"] }, pj = { prefix: "fas", iconName: "filter", icon: [512, 512, [], "f0b0", "M3.853 54.87C10.47 40.9 24.54 32 40 32H472C487.5 32 501.5 40.9 508.1 54.87C514.8 68.84 512.7 85.37 502.1 97.33L320 320.9V448C320 460.1 313.2 471.2 302.3 476.6C291.5 482 278.5 480.9 268.8 473.6L204.8 425.6C196.7 419.6 192 410.1 192 400V320.9L9.042 97.33C-.745 85.37-2.765 68.84 3.854 54.87L3.853 54.87z"] }, mj = { prefix: "fas", iconName: "gear", icon: [512, 512, [9881, "cog"], "f013", "M495.9 166.6C499.2 175.2 496.4 184.9 489.6 191.2L446.3 230.6C447.4 238.9 448 247.4 448 256C448 264.6 447.4 273.1 446.3 281.4L489.6 320.8C496.4 327.1 499.2 336.8 495.9 345.4C491.5 357.3 486.2 368.8 480.2 379.7L475.5 387.8C468.9 398.8 461.5 409.2 453.4 419.1C447.4 426.2 437.7 428.7 428.9 425.9L373.2 408.1C359.8 418.4 344.1 427 329.2 433.6L316.7 490.7C314.7 499.7 307.7 506.1 298.5 508.5C284.7 510.8 270.5 512 255.1 512C241.5 512 227.3 510.8 213.5 508.5C204.3 506.1 197.3 499.7 195.3 490.7L182.8 433.6C167 427 152.2 418.4 138.8 408.1L83.14 425.9C74.3 428.7 64.55 426.2 58.63 419.1C50.52 409.2 43.12 398.8 36.52 387.8L31.84 379.7C25.77 368.8 20.49 357.3 16.06 345.4C12.82 336.8 15.55 327.1 22.41 320.8L65.67 281.4C64.57 273.1 64 264.6 64 256C64 247.4 64.57 238.9 65.67 230.6L22.41 191.2C15.55 184.9 12.82 175.3 16.06 166.6C20.49 154.7 25.78 143.2 31.84 132.3L36.51 124.2C43.12 113.2 50.52 102.8 58.63 92.95C64.55 85.8 74.3 83.32 83.14 86.14L138.8 103.9C152.2 93.56 167 84.96 182.8 78.43L195.3 21.33C197.3 12.25 204.3 5.04 213.5 3.51C227.3 1.201 241.5 0 256 0C270.5 0 284.7 1.201 298.5 3.51C307.7 5.04 314.7 12.25 316.7 21.33L329.2 78.43C344.1 84.96 359.8 93.56 373.2 103.9L428.9 86.14C437.7 83.32 447.4 85.8 453.4 92.95C461.5 102.8 468.9 113.2 475.5 124.2L480.2 132.3C486.2 143.2 491.5 154.7 495.9 166.6V166.6zM256 336C300.2 336 336 300.2 336 255.1C336 211.8 300.2 175.1 256 175.1C211.8 175.1 176 211.8 176 255.1C176 300.2 211.8 336 256 336z"] }, gj = { prefix: "fas", iconName: "magnifying-glass", icon: [512, 512, [128269, "search"], "f002", "M500.3 443.7l-119.7-119.7c27.22-40.41 40.65-90.9 33.46-144.7C401.8 87.79 326.8 13.32 235.2 1.723C99.01-15.51-15.51 99.01 1.724 235.2c11.6 91.64 86.08 166.7 177.6 178.9c53.8 7.189 104.3-6.236 144.7-33.46l119.7 119.7c15.62 15.62 40.95 15.62 56.57 0C515.9 484.7 515.9 459.3 500.3 443.7zM79.1 208c0-70.58 57.42-128 128-128s128 57.42 128 128c0 70.58-57.42 128-128 128S79.1 278.6 79.1 208z"] }, yj = { prefix: "fas", iconName: "paste", icon: [512, 512, ["file-clipboard"], "f0ea", "M320 96V80C320 53.49 298.5 32 272 32H215.4C204.3 12.89 183.6 0 160 0S115.7 12.89 104.6 32H48C21.49 32 0 53.49 0 80v320C0 426.5 21.49 448 48 448l144 .0013L192 176C192 131.8 227.8 96 272 96H320zM160 88C146.8 88 136 77.25 136 64S146.8 40 160 40S184 50.75 184 64S173.3 88 160 88zM416 128v96h96L416 128zM384 224L384 128h-112C245.5 128 224 149.5 224 176v288c0 26.51 21.49 48 48 48h192c26.51 0 48-21.49 48-48V256h-95.99C398.4 256 384 241.6 384 224z"] }, bj = { prefix: "fas", iconName: "pen", icon: [512, 512, [128394], "f304", "M362.7 19.32C387.7-5.678 428.3-5.678 453.3 19.32L492.7 58.75C517.7 83.74 517.7 124.3 492.7 149.3L444.3 197.7L314.3 67.72L362.7 19.32zM421.7 220.3L188.5 453.4C178.1 463.8 165.2 471.5 151.1 475.6L30.77 511C22.35 513.5 13.24 511.2 7.03 504.1C.8198 498.8-1.502 489.7 .976 481.2L36.37 360.9C40.53 346.8 48.16 333.9 58.57 323.5L291.7 90.34L421.7 220.3z"] }, kj = { prefix: "fas", iconName: "scissors", icon: [512, 512, [9986, 9988, 9984, "cut"], "f0c4", "M396.8 51.2C425.1 22.92 470.9 22.92 499.2 51.2C506.3 58.27 506.3 69.73 499.2 76.8L216.5 359.5C221.3 372.1 224 385.7 224 400C224 461.9 173.9 512 112 512C50.14 512 0 461.9 0 400C0 338.1 50.14 287.1 112 287.1C126.3 287.1 139.9 290.7 152.5 295.5L191.1 255.1L152.5 216.5C139.9 221.3 126.3 224 112 224C50.14 224 0 173.9 0 112C0 50.14 50.14 0 112 0C173.9 0 224 50.14 224 112C224 126.3 221.3 139.9 216.5 152.5L255.1 191.1L396.8 51.2zM160 111.1C160 85.49 138.5 63.1 112 63.1C85.49 63.1 64 85.49 64 111.1C64 138.5 85.49 159.1 112 159.1C138.5 159.1 160 138.5 160 111.1zM112 448C138.5 448 160 426.5 160 400C160 373.5 138.5 352 112 352C85.49 352 64 373.5 64 400C64 426.5 85.49 448 112 448zM278.6 342.6L342.6 278.6L499.2 435.2C506.3 442.3 506.3 453.7 499.2 460.8C470.9 489.1 425.1 489.1 396.8 460.8L278.6 342.6z"] }, wj = { prefix: "fas", iconName: "square-caret-down", icon: [448, 512, ["caret-square-down"], "f150", "M384 32H64C28.65 32 0 60.65 0 96v320c0 35.34 28.65 64 64 64h320c35.35 0 64-28.66 64-64V96C448 60.65 419.3 32 384 32zM345.6 232.3l-104 112C237 349.2 230.7 352 224 352s-13.03-2.781-17.59-7.656l-104-112c-6.5-7-8.219-17.19-4.407-25.94C101.8 197.7 110.5 192 120 192h208c9.531 0 18.19 5.656 21.1 14.41C353.8 215.2 352.1 225.3 345.6 232.3z"] }, xj = { prefix: "fas", iconName: "square-caret-up", icon: [448, 512, ["caret-square-up"], "f151", "M384 32H64C28.65 32 0 60.65 0 96v320c0 35.34 28.65 64 64 64h320c35.35 0 64-28.66 64-64V96C448 60.65 419.3 32 384 32zM349.1 305.6C346.2 314.3 337.5 320 328 320h-208c-9.531 0-18.19-5.656-22-14.41C94.19 296.8 95.91 286.7 102.4 279.7l104-112c9.125-9.75 26.06-9.75 35.19 0l104 112C352.1 286.7 353.8 296.8 349.1 305.6z"] }, jj = { prefix: "fas", iconName: "triangle-exclamation", icon: [512, 512, [9888, "exclamation-triangle", "warning"], "f071", "M506.3 417l-213.3-364c-16.33-28-57.54-28-73.98 0l-213.2 364C-10.59 444.9 9.849 480 42.74 480h426.6C502.1 480 522.6 445 506.3 417zM232 168c0-13.25 10.75-24 24-24S280 154.8 280 168v128c0 13.25-10.75 24-23.1 24S232 309.3 232 296V168zM256 416c-17.36 0-31.44-14.08-31.44-31.44c0-17.36 14.07-31.44 31.44-31.44s31.44 14.08 31.44 31.44C287.4 401.9 273.4 416 256 416z"] }, Sj = { prefix: "fas", iconName: "wrench", icon: [512, 512, [128295], "f0ad", "M507.6 122.8c-2.904-12.09-18.25-16.13-27.04-7.338l-76.55 76.56l-83.1-.0002l0-83.1l76.55-76.56c8.791-8.789 4.75-24.14-7.336-27.04c-23.69-5.693-49.34-6.111-75.92 .2484c-61.45 14.7-109.4 66.9-119.2 129.3C189.8 160.8 192.3 186.7 200.1 210.1l-178.1 178.1c-28.12 28.12-28.12 73.69 0 101.8C35.16 504.1 53.56 512 71.1 512s36.84-7.031 50.91-21.09l178.1-178.1c23.46 7.736 49.31 10.24 76.17 6.004c62.41-9.84 114.6-57.8 129.3-119.2C513.7 172.1 513.3 146.5 507.6 122.8zM80 456c-13.25 0-24-10.75-24-24c0-13.26 10.75-24 24-24s24 10.74 24 24C104 445.3 93.25 456 80 456z"] }, Cj = { prefix: "fas", iconName: "xmark", icon: [320, 512, [128473, 10005, 10006, 10060, 215, "close", "multiply", "remove", "times"], "f00d", "M310.6 361.4c12.5 12.5 12.5 32.75 0 45.25C304.4 412.9 296.2 416 288 416s-16.38-3.125-22.62-9.375L160 301.3L54.63 406.6C48.38 412.9 40.19 416 32 416S15.63 412.9 9.375 406.6c-12.5-12.5-12.5-32.75 0-45.25l105.4-105.4L9.375 150.6c-12.5-12.5-12.5-32.75 0-45.25s32.75-12.5 45.25 0L160 210.8l105.4-105.4c12.5-12.5 32.75-12.5 45.25 0s12.5 32.75 0 45.25l-105.4 105.4L310.6 361.4z"] };
/*!
 * Font Awesome Free 6.1.1 by @fontawesome - https://fontawesome.com
 * License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License)
 * Copyright 2022 Fonticons, Inc.
 */
function _j(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1e3;
  if (e22 < 0.9 * t2)
    return e22.toFixed() + " B";
  var n2 = e22 / t2;
  if (n2 < 0.9 * t2)
    return n2.toFixed(1) + " KB";
  var r2 = n2 / t2;
  if (r2 < 0.9 * t2)
    return r2.toFixed(1) + " MB";
  var i2 = r2 / t2;
  if (i2 < 0.9 * t2)
    return i2.toFixed(1) + " GB";
  var o2 = i2 / t2;
  return o2.toFixed(1) + " TB";
}
var $j = Ia("jsoneditor:FocusTracker");
function Oj(e22) {
  var t2, n2 = e22.onMount, r2 = e22.onDestroy, i2 = e22.getWindow, o2 = e22.hasFocus, a2 = e22.onFocus, s2 = e22.onBlur, u2 = false;
  function c2() {
    var e23 = o2();
    e23 && (clearTimeout(t2), u2 || ($j("focus"), a2(), u2 = e23));
  }
  function l2() {
    u2 && (clearTimeout(t2), t2 = setTimeout(function() {
      $j("blur"), u2 = false, s2();
    }));
  }
  n2(function() {
    $j("mount FocusTracker");
    var e23 = i2();
    e23 && (e23.addEventListener("focusin", c2, true), e23.addEventListener("focusout", l2, true));
  }), r2(function() {
    $j("destroy FocusTracker");
    var e23 = i2();
    e23 && (e23.removeEventListener("focusin", c2, true), e23.removeEventListener("focusout", l2, true));
  });
}
function Aj(e22) {
  for (var t2, n2, r2 = [{ id: n2 = "path-" + e22[0] }, e22[1]], i2 = {}, o2 = 0; o2 < r2.length; o2 += 1)
    i2 = Fi(i2, r2[o2]);
  return { c: function() {
    _o(t2 = yo("path"), i2);
  }, m: function(e23, n3) {
    vo(e23, t2, n3);
  }, p: function(e23, o3) {
    var a2 = xi(o3, 1)[0];
    _o(t2, i2 = _a(r2, [1 & a2 && n2 !== (n2 = "path-" + e23[0]) && { id: n2 }, 2 & a2 && e23[1]]));
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function Mj(e22, t2, n2) {
  var r2 = t2.id, i2 = t2.data, o2 = i2 === void 0 ? {} : i2;
  return e22.$$set = function(e23) {
    "id" in e23 && n2(0, r2 = e23.id), "data" in e23 && n2(1, o2 = e23.data);
  }, [r2, o2];
}
var Ej = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, Mj, Aj, Ui, { id: 0, data: 1 }), r2;
  }
  return zi(n2);
}();
function Pj(e22) {
  for (var t2, n2, r2 = [{ id: n2 = "polygon-" + e22[0] }, e22[1]], i2 = {}, o2 = 0; o2 < r2.length; o2 += 1)
    i2 = Fi(i2, r2[o2]);
  return { c: function() {
    _o(t2 = yo("polygon"), i2);
  }, m: function(e23, n3) {
    vo(e23, t2, n3);
  }, p: function(e23, o3) {
    var a2 = xi(o3, 1)[0];
    _o(t2, i2 = _a(r2, [1 & a2 && n2 !== (n2 = "polygon-" + e23[0]) && { id: n2 }, 2 & a2 && e23[1]]));
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function Nj(e22, t2, n2) {
  var r2 = t2.id, i2 = t2.data, o2 = i2 === void 0 ? {} : i2;
  return e22.$$set = function(e23) {
    "id" in e23 && n2(0, r2 = e23.id), "data" in e23 && n2(1, o2 = e23.data);
  }, [r2, o2];
}
var Tj = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, Nj, Pj, Ui, { id: 0, data: 1 }), r2;
  }
  return zi(n2);
}();
function Ij(e22) {
  var t2;
  return { c: function() {
    t2 = yo("g");
  }, m: function(n2, r2) {
    vo(n2, t2, r2), t2.innerHTML = e22[0];
  }, p: function(e23, n2) {
    1 & xi(n2, 1)[0] && (t2.innerHTML = e23[0]);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function Rj(e22, t2, n2) {
  var r2, i2 = 870711;
  var o2 = t2.data;
  function a2(e23) {
    if (!e23 || !e23.raw)
      return null;
    var t3 = e23.raw, n3 = {};
    return t3 = (t3 = t3.replace(/\s(?:xml:)?id=["']?([^"')\s]+)/g, function(e24, t4) {
      var r3 = "fa-".concat((i2 += 1).toString(16));
      return n3[t4] = r3, ' id="'.concat(r3, '"');
    })).replace(/#(?:([^'")\s]+)|xpointer\(id\((['"]?)([^')]+)\2\)\))/g, function(e24, t4, r3, i3) {
      var o3 = t4 || i3;
      return o3 && n3[o3] ? "#".concat(n3[o3]) : e24;
    });
  }
  return e22.$$set = function(e23) {
    "data" in e23 && n2(1, o2 = e23.data);
  }, e22.$$.update = function() {
    2 & e22.$$.dirty && n2(0, r2 = a2(o2));
  }, [r2, o2];
}
var Dj = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, Rj, Ij, Ui, { data: 1 }), r2;
  }
  return zi(n2);
}();
function zj(e22) {
  co(e22, "svelte-1dof0an", ".fa-icon.svelte-1dof0an{display:inline-block;fill:currentColor}.fa-flip-horizontal.svelte-1dof0an{transform:scale(-1, 1)}.fa-flip-vertical.svelte-1dof0an{transform:scale(1, -1)}.fa-spin.svelte-1dof0an{animation:svelte-1dof0an-fa-spin 1s 0s infinite linear}.fa-inverse.svelte-1dof0an{color:#fff}.fa-pulse.svelte-1dof0an{animation:svelte-1dof0an-fa-spin 1s infinite steps(8)}@keyframes svelte-1dof0an-fa-spin{0%{transform:rotate(0deg)}100%{transform:rotate(360deg)}}");
}
function Lj(e22) {
  var t2, n2, r2, i2, o2 = e22[13].default, a2 = Gi(o2, e22, e22[12], null);
  return { c: function() {
    t2 = yo("svg"), a2 && a2.c(), So(t2, "version", "1.1"), So(t2, "class", n2 = "fa-icon " + e22[0] + " svelte-1dof0an"), So(t2, "x", e22[8]), So(t2, "y", e22[9]), So(t2, "width", e22[1]), So(t2, "height", e22[2]), So(t2, "aria-label", e22[11]), So(t2, "role", r2 = e22[11] ? "img" : "presentation"), So(t2, "viewBox", e22[3]), So(t2, "style", e22[10]), To(t2, "fa-spin", e22[4]), To(t2, "fa-pulse", e22[6]), To(t2, "fa-inverse", e22[5]), To(t2, "fa-flip-horizontal", e22[7] === "horizontal"), To(t2, "fa-flip-vertical", e22[7] === "vertical");
  }, m: function(e23, n3) {
    vo(e23, t2, n3), a2 && a2.m(t2, null), i2 = true;
  }, p: function(e23, s2) {
    var u2 = xi(s2, 1)[0];
    a2 && a2.p && (!i2 || 4096 & u2) && Zi(a2, o2, e23, e23[12], i2 ? Yi(o2, e23[12], u2, null) : Xi(e23[12]), null), (!i2 || 1 & u2 && n2 !== (n2 = "fa-icon " + e23[0] + " svelte-1dof0an")) && So(t2, "class", n2), (!i2 || 256 & u2) && So(t2, "x", e23[8]), (!i2 || 512 & u2) && So(t2, "y", e23[9]), (!i2 || 2 & u2) && So(t2, "width", e23[1]), (!i2 || 4 & u2) && So(t2, "height", e23[2]), (!i2 || 2048 & u2) && So(t2, "aria-label", e23[11]), (!i2 || 2048 & u2 && r2 !== (r2 = e23[11] ? "img" : "presentation")) && So(t2, "role", r2), (!i2 || 8 & u2) && So(t2, "viewBox", e23[3]), (!i2 || 1024 & u2) && So(t2, "style", e23[10]), 17 & u2 && To(t2, "fa-spin", e23[4]), 65 & u2 && To(t2, "fa-pulse", e23[6]), 33 & u2 && To(t2, "fa-inverse", e23[5]), 129 & u2 && To(t2, "fa-flip-horizontal", e23[7] === "horizontal"), 129 & u2 && To(t2, "fa-flip-vertical", e23[7] === "vertical");
  }, i: function(e23) {
    i2 || (ya(a2, e23), i2 = true);
  }, o: function(e23) {
    ba(a2, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), a2 && a2.d(e23);
  } };
}
function Bj(e22, t2, n2) {
  var r2 = t2.$$slots, i2 = r2 === void 0 ? {} : r2, o2 = t2.$$scope, a2 = t2.class, s2 = t2.width, u2 = t2.height, c2 = t2.box, l2 = t2.spin, f2 = l2 !== void 0 && l2, h2 = t2.inverse, d2 = h2 !== void 0 && h2, v2 = t2.pulse, p2 = v2 !== void 0 && v2, m2 = t2.flip, g2 = m2 === void 0 ? null : m2, y2 = t2.x, b2 = y2 === void 0 ? void 0 : y2, k2 = t2.y, w2 = k2 === void 0 ? void 0 : k2, x2 = t2.style, j2 = x2 === void 0 ? void 0 : x2, S2 = t2.label, C2 = S2 === void 0 ? void 0 : S2;
  return e22.$$set = function(e23) {
    "class" in e23 && n2(0, a2 = e23.class), "width" in e23 && n2(1, s2 = e23.width), "height" in e23 && n2(2, u2 = e23.height), "box" in e23 && n2(3, c2 = e23.box), "spin" in e23 && n2(4, f2 = e23.spin), "inverse" in e23 && n2(5, d2 = e23.inverse), "pulse" in e23 && n2(6, p2 = e23.pulse), "flip" in e23 && n2(7, g2 = e23.flip), "x" in e23 && n2(8, b2 = e23.x), "y" in e23 && n2(9, w2 = e23.y), "style" in e23 && n2(10, j2 = e23.style), "label" in e23 && n2(11, C2 = e23.label), "$$scope" in e23 && n2(12, o2 = e23.$$scope);
  }, [a2, s2, u2, c2, f2, d2, p2, g2, b2, w2, j2, C2, o2, i2];
}
var qj = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, Bj, Lj, Ui, { class: 0, width: 1, height: 2, box: 3, spin: 4, inverse: 5, pulse: 6, flip: 7, x: 8, y: 9, style: 10, label: 11 }, zj), r2;
  }
  return zi(n2);
}();
function Fj(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[24] = t2[n2], r2[26] = n2, r2;
}
function Vj(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[27] = t2[n2], r2[26] = n2, r2;
}
function Hj(e22) {
  var t2, n2, r2, i2, o2 = e22[6].paths && Wj(e22), a2 = e22[6].polygons && Uj(e22), s2 = e22[6].raw && Gj(e22);
  return { c: function() {
    o2 && o2.c(), t2 = ko(), a2 && a2.c(), n2 = ko(), s2 && s2.c(), r2 = wo();
  }, m: function(e23, u2) {
    o2 && o2.m(e23, u2), vo(e23, t2, u2), a2 && a2.m(e23, u2), vo(e23, n2, u2), s2 && s2.m(e23, u2), vo(e23, r2, u2), i2 = true;
  }, p: function(e23, i3) {
    e23[6].paths ? o2 ? (o2.p(e23, i3), 64 & i3 && ya(o2, 1)) : ((o2 = Wj(e23)).c(), ya(o2, 1), o2.m(t2.parentNode, t2)) : o2 && (ma(), ba(o2, 1, 1, function() {
      o2 = null;
    }), ga()), e23[6].polygons ? a2 ? (a2.p(e23, i3), 64 & i3 && ya(a2, 1)) : ((a2 = Uj(e23)).c(), ya(a2, 1), a2.m(n2.parentNode, n2)) : a2 && (ma(), ba(a2, 1, 1, function() {
      a2 = null;
    }), ga()), e23[6].raw ? s2 ? (s2.p(e23, i3), 64 & i3 && ya(s2, 1)) : ((s2 = Gj(e23)).c(), ya(s2, 1), s2.m(r2.parentNode, r2)) : s2 && (ma(), ba(s2, 1, 1, function() {
      s2 = null;
    }), ga());
  }, i: function(e23) {
    i2 || (ya(o2), ya(a2), ya(s2), i2 = true);
  }, o: function(e23) {
    ba(o2), ba(a2), ba(s2), i2 = false;
  }, d: function(e23) {
    o2 && o2.d(e23), e23 && po(t2), a2 && a2.d(e23), e23 && po(n2), s2 && s2.d(e23), e23 && po(r2);
  } };
}
function Wj(e22) {
  for (var t2, n2, r2 = e22[6].paths, i2 = [], o2 = 0; o2 < r2.length; o2 += 1)
    i2[o2] = Jj(Vj(e22, r2, o2));
  var a2 = function(e23) {
    return ba(i2[e23], 1, 1, function() {
      i2[e23] = null;
    });
  };
  return { c: function() {
    for (var e23 = 0; e23 < i2.length; e23 += 1)
      i2[e23].c();
    t2 = wo();
  }, m: function(e23, r3) {
    for (var o3 = 0; o3 < i2.length; o3 += 1)
      i2[o3].m(e23, r3);
    vo(e23, t2, r3), n2 = true;
  }, p: function(e23, n3) {
    if (64 & n3) {
      var o3;
      for (r2 = e23[6].paths, o3 = 0; o3 < r2.length; o3 += 1) {
        var s2 = Vj(e23, r2, o3);
        i2[o3] ? (i2[o3].p(s2, n3), ya(i2[o3], 1)) : (i2[o3] = Jj(s2), i2[o3].c(), ya(i2[o3], 1), i2[o3].m(t2.parentNode, t2));
      }
      for (ma(), o3 = r2.length; o3 < i2.length; o3 += 1)
        a2(o3);
      ga();
    }
  }, i: function(e23) {
    if (!n2) {
      for (var t3 = 0; t3 < r2.length; t3 += 1)
        ya(i2[t3]);
      n2 = true;
    }
  }, o: function(e23) {
    i2 = i2.filter(Boolean);
    for (var t3 = 0; t3 < i2.length; t3 += 1)
      ba(i2[t3]);
    n2 = false;
  }, d: function(e23) {
    mo(i2, e23), e23 && po(t2);
  } };
}
function Jj(e22) {
  var t2, n2;
  return t2 = new Ej({ props: { id: e22[26], data: e22[27] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    64 & n3 && (r2.data = e23[27]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function Uj(e22) {
  for (var t2, n2, r2 = e22[6].polygons, i2 = [], o2 = 0; o2 < r2.length; o2 += 1)
    i2[o2] = Kj(Fj(e22, r2, o2));
  var a2 = function(e23) {
    return ba(i2[e23], 1, 1, function() {
      i2[e23] = null;
    });
  };
  return { c: function() {
    for (var e23 = 0; e23 < i2.length; e23 += 1)
      i2[e23].c();
    t2 = wo();
  }, m: function(e23, r3) {
    for (var o3 = 0; o3 < i2.length; o3 += 1)
      i2[o3].m(e23, r3);
    vo(e23, t2, r3), n2 = true;
  }, p: function(e23, n3) {
    if (64 & n3) {
      var o3;
      for (r2 = e23[6].polygons, o3 = 0; o3 < r2.length; o3 += 1) {
        var s2 = Fj(e23, r2, o3);
        i2[o3] ? (i2[o3].p(s2, n3), ya(i2[o3], 1)) : (i2[o3] = Kj(s2), i2[o3].c(), ya(i2[o3], 1), i2[o3].m(t2.parentNode, t2));
      }
      for (ma(), o3 = r2.length; o3 < i2.length; o3 += 1)
        a2(o3);
      ga();
    }
  }, i: function(e23) {
    if (!n2) {
      for (var t3 = 0; t3 < r2.length; t3 += 1)
        ya(i2[t3]);
      n2 = true;
    }
  }, o: function(e23) {
    i2 = i2.filter(Boolean);
    for (var t3 = 0; t3 < i2.length; t3 += 1)
      ba(i2[t3]);
    n2 = false;
  }, d: function(e23) {
    mo(i2, e23), e23 && po(t2);
  } };
}
function Kj(e22) {
  var t2, n2;
  return t2 = new Tj({ props: { id: e22[26], data: e22[24] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    64 & n3 && (r2.data = e23[24]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function Gj(e22) {
  var t2, n2, r2;
  function i2(t3) {
    e22[15](t3);
  }
  var o2 = {};
  return e22[6] !== void 0 && (o2.data = e22[6]), t2 = new Dj({ props: o2 }), Xo.push(function() {
    return Oa(t2, "data", i2);
  }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, n3) {
    Ma(t2, e23, n3), r2 = true;
  }, p: function(e23, r3) {
    var i3 = {};
    !n2 && 64 & r3 && (n2 = true, i3.data = e23[6], sa(function() {
      return n2 = false;
    })), t2.$set(i3);
  }, i: function(e23) {
    r2 || (ya(t2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function Qj(e22) {
  var t2, n2 = e22[14].default, r2 = Gi(n2, e22, e22[16], null), i2 = r2 || function(e23) {
    var t3, n3, r3 = e23[6] && Hj(e23);
    return { c: function() {
      r3 && r3.c(), t3 = wo();
    }, m: function(e24, i3) {
      r3 && r3.m(e24, i3), vo(e24, t3, i3), n3 = true;
    }, p: function(e24, n4) {
      e24[6] ? r3 ? (r3.p(e24, n4), 64 & n4 && ya(r3, 1)) : ((r3 = Hj(e24)).c(), ya(r3, 1), r3.m(t3.parentNode, t3)) : r3 && (ma(), ba(r3, 1, 1, function() {
        r3 = null;
      }), ga());
    }, i: function(e24) {
      n3 || (ya(r3), n3 = true);
    }, o: function(e24) {
      ba(r3), n3 = false;
    }, d: function(e24) {
      r3 && r3.d(e24), e24 && po(t3);
    } };
  }(e22);
  return { c: function() {
    i2 && i2.c();
  }, m: function(e23, n3) {
    i2 && i2.m(e23, n3), t2 = true;
  }, p: function(e23, o2) {
    r2 ? r2.p && (!t2 || 65536 & o2) && Zi(r2, n2, e23, e23[16], t2 ? Yi(n2, e23[16], o2, null) : Xi(e23[16]), null) : i2 && i2.p && (!t2 || 64 & o2) && i2.p(e23, t2 ? o2 : -1);
  }, i: function(e23) {
    t2 || (ya(i2, e23), t2 = true);
  }, o: function(e23) {
    ba(i2, e23), t2 = false;
  }, d: function(e23) {
    i2 && i2.d(e23);
  } };
}
function Yj(e22) {
  var t2, n2;
  return t2 = new qj({ props: { label: e22[5], width: e22[7], height: e22[8], box: e22[10], style: e22[9], spin: e22[1], flip: e22[4], inverse: e22[2], pulse: e22[3], class: e22[0], $$slots: { default: [Qj] }, $$scope: { ctx: e22 } } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = xi(n3, 1)[0], i2 = {};
    32 & r2 && (i2.label = e23[5]), 128 & r2 && (i2.width = e23[7]), 256 & r2 && (i2.height = e23[8]), 1024 & r2 && (i2.box = e23[10]), 512 & r2 && (i2.style = e23[9]), 2 & r2 && (i2.spin = e23[1]), 16 & r2 && (i2.flip = e23[4]), 4 & r2 && (i2.inverse = e23[2]), 8 & r2 && (i2.pulse = e23[3]), 1 & r2 && (i2.class = e23[0]), 65600 & r2 && (i2.$$scope = { dirty: r2, ctx: e23 }), t2.$set(i2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function Zj(e22, t2, n2) {
  var r2, i2, o2, a2, s2 = t2.$$slots, u2 = s2 === void 0 ? {} : s2, c2 = t2.$$scope, l2 = t2.class, f2 = l2 === void 0 ? "" : l2, h2 = t2.data, d2 = t2.scale, v2 = d2 === void 0 ? 1 : d2, p2 = t2.spin, m2 = p2 !== void 0 && p2, g2 = t2.inverse, y2 = g2 !== void 0 && g2, b2 = t2.pulse, k2 = b2 !== void 0 && b2, w2 = t2.flip, x2 = w2 === void 0 ? null : w2, j2 = t2.label, S2 = j2 === void 0 ? null : j2, C2 = null, _2 = t2.style, $2 = _2 === void 0 ? null : _2;
  function O2() {
    var e23 = 1;
    return v2 !== void 0 && (e23 = Number(v2)), isNaN(e23) || e23 <= 0 ? (console.warn('Invalid prop: prop "scale" should be a number over 0.'), 1) : 1 * e23;
  }
  function A2() {
    return C2 ? Math.max(C2.width, C2.height) / 16 : 1;
  }
  return e22.$$set = function(e23) {
    "class" in e23 && n2(0, f2 = e23.class), "data" in e23 && n2(11, h2 = e23.data), "scale" in e23 && n2(12, v2 = e23.scale), "spin" in e23 && n2(1, m2 = e23.spin), "inverse" in e23 && n2(2, y2 = e23.inverse), "pulse" in e23 && n2(3, k2 = e23.pulse), "flip" in e23 && n2(4, x2 = e23.flip), "label" in e23 && n2(5, S2 = e23.label), "style" in e23 && n2(13, $2 = e23.style), "$$scope" in e23 && n2(16, c2 = e23.$$scope);
  }, e22.$$.update = function() {
    14336 & e22.$$.dirty && (!function() {
      if (h2 !== void 0) {
        var e23 = function(e24) {
          if ("iconName" in e24 && "icon" in e24) {
            var t4 = {}, n3 = e24.icon, r3 = e24.iconName, i3 = { width: n3[0], height: n3[1], paths: [{ d: n3[4] }] };
            return t4[r3] = i3, t4;
          }
          return e24;
        }(h2), t3 = e23[xi(Object.keys(e23), 1)[0]];
        t3.paths || (t3.paths = []), t3.d && t3.paths.push({ d: t3.d }), t3.polygons || (t3.polygons = []), t3.points && t3.polygons.push({ points: t3.points }), n2(6, C2 = t3);
      }
    }(), n2(7, r2 = C2 ? C2.width / A2() * O2() : 0), n2(8, i2 = C2 ? C2.height / A2() * O2() : 0), n2(9, o2 = function() {
      var e23 = "";
      $2 !== null && (e23 += $2);
      var t3 = O2();
      if (t3 === 1) {
        if (e23.length === 0)
          return;
        return e23;
      }
      return e23 === "" || e23.endsWith(";") || (e23 += "; "), "".concat(e23, "font-size: ").concat(t3, "em");
    }()), n2(10, a2 = C2 ? "0 0 ".concat(C2.width, " ").concat(C2.height) : "0 0 ".concat(r2, " ").concat(i2)));
  }, [f2, m2, y2, k2, x2, S2, C2, r2, i2, o2, a2, h2, v2, $2, u2, function(e23) {
    n2(6, C2 = e23);
  }, c2];
}
var Xj = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, Zj, Yj, Ui, { class: 0, data: 11, scale: 12, spin: 1, inverse: 2, pulse: 3, flip: 4, label: 5, style: 13 }), r2;
  }
  return zi(n2);
}();
function eS(e22) {
  co(e22, "svelte-kvi5ls", ".jse-message.svelte-kvi5ls.svelte-kvi5ls{font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono);padding:var(--jse-padding);display:flex;gap:var(--jse-padding);flex-wrap:wrap;align-items:center}.jse-message.jse-success.svelte-kvi5ls.svelte-kvi5ls{background:var(--jse-message-success-background);color:var(--jse-message-success-color)}.jse-message.svelte-kvi5ls .jse-text.svelte-kvi5ls{flex:1;min-width:60%}.jse-message.svelte-kvi5ls .jse-text.jse-clickable.svelte-kvi5ls{cursor:pointer}.jse-message.svelte-kvi5ls .jse-text.jse-clickable.svelte-kvi5ls:hover{background-color:rgba(255, 255, 255, 0.1)}.jse-message.jse-error.svelte-kvi5ls.svelte-kvi5ls{background:var(--jse-message-error-background);color:var(--jse-message-error-color)}.jse-message.jse-warning.svelte-kvi5ls.svelte-kvi5ls{background:var(--jse-message-warning-background);color:var(--jse-message-warning-color)}.jse-message.jse-info.svelte-kvi5ls.svelte-kvi5ls{background:var(--jse-message-info-background);color:var(--jse-message-info-color)}.jse-message.svelte-kvi5ls .jse-actions.svelte-kvi5ls{display:flex;gap:var(--jse-padding)}.jse-message.svelte-kvi5ls .jse-actions button.jse-action.svelte-kvi5ls{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;background:var(--jse-message-action-background);color:inherit;padding:calc(0.5 * var(--jse-padding)) var(--jse-padding)}.jse-message.svelte-kvi5ls .jse-actions button.jse-action.svelte-kvi5ls:hover{background:var(--jse-message-action-background-highlight)}");
}
function tS(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[8] = t2[n2], r2;
}
function nS(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: e22[1] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    2 & n3 && (r2.data = e23[1]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function rS(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: e22[8].icon } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    8 & n3 && (r2.data = e23[8].icon), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function iS(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2 = e22[8].text + "", f2 = e22[8].icon && rS(e22);
  function h2() {
    return e22[6](e22[8]);
  }
  function d2() {
    return e22[7](e22[8]);
  }
  return { c: function() {
    t2 = go("button"), f2 && f2.c(), n2 = ko(), r2 = bo(l2), i2 = ko(), So(t2, "type", "button"), So(t2, "class", "jse-button jse-action jse-primary svelte-kvi5ls"), So(t2, "title", o2 = e22[8].title), t2.disabled = a2 = e22[8].disabled;
  }, m: function(e23, o3) {
    vo(e23, t2, o3), f2 && f2.m(t2, null), uo(t2, n2), uo(t2, r2), uo(t2, i2), s2 = true, u2 || (c2 = [xo(t2, "click", h2), xo(t2, "mousedown", d2)], u2 = true);
  }, p: function(i3, u3) {
    (e22 = i3)[8].icon ? f2 ? (f2.p(e22, u3), 8 & u3 && ya(f2, 1)) : ((f2 = rS(e22)).c(), ya(f2, 1), f2.m(t2, n2)) : f2 && (ma(), ba(f2, 1, 1, function() {
      f2 = null;
    }), ga()), (!s2 || 8 & u3) && l2 !== (l2 = e22[8].text + "") && Ao(r2, l2), (!s2 || 8 & u3 && o2 !== (o2 = e22[8].title)) && So(t2, "title", o2), (!s2 || 8 & u3 && a2 !== (a2 = e22[8].disabled)) && (t2.disabled = a2);
  }, i: function(e23) {
    s2 || (ya(f2), s2 = true);
  }, o: function(e23) {
    ba(f2), s2 = false;
  }, d: function(e23) {
    e23 && po(t2), f2 && f2.d(), u2 = false, Wi(c2);
  } };
}
function oS(e22) {
  for (var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2 = e22[1] && nS(e22), h2 = e22[3], d2 = [], v2 = 0; v2 < h2.length; v2 += 1)
    d2[v2] = iS(tS(e22, h2, v2));
  var p2 = function(e23) {
    return ba(d2[e23], 1, 1, function() {
      d2[e23] = null;
    });
  };
  return { c: function() {
    t2 = go("div"), n2 = go("div"), f2 && f2.c(), r2 = ko(), i2 = bo(e22[2]), o2 = ko(), a2 = go("div");
    for (var u3 = 0; u3 < d2.length; u3 += 1)
      d2[u3].c();
    So(n2, "class", "jse-text svelte-kvi5ls"), To(n2, "jse-clickable", e22[4] !== null), So(a2, "class", "jse-actions svelte-kvi5ls"), So(t2, "class", s2 = "jse-message jse-" + e22[0] + " svelte-kvi5ls");
  }, m: function(s3, h3) {
    vo(s3, t2, h3), uo(t2, n2), f2 && f2.m(n2, null), uo(n2, r2), uo(n2, i2), uo(t2, o2), uo(t2, a2);
    for (var v3 = 0; v3 < d2.length; v3 += 1)
      d2[v3].m(a2, null);
    u2 = true, c2 || (l2 = xo(n2, "click", e22[5]), c2 = true);
  }, p: function(e23, o3) {
    var c3 = xi(o3, 1)[0];
    if (e23[1] ? f2 ? (f2.p(e23, c3), 2 & c3 && ya(f2, 1)) : ((f2 = nS(e23)).c(), ya(f2, 1), f2.m(n2, r2)) : f2 && (ma(), ba(f2, 1, 1, function() {
      f2 = null;
    }), ga()), (!u2 || 4 & c3) && Ao(i2, e23[2]), 16 & c3 && To(n2, "jse-clickable", e23[4] !== null), 8 & c3) {
      var l3;
      for (h2 = e23[3], l3 = 0; l3 < h2.length; l3 += 1) {
        var v3 = tS(e23, h2, l3);
        d2[l3] ? (d2[l3].p(v3, c3), ya(d2[l3], 1)) : (d2[l3] = iS(v3), d2[l3].c(), ya(d2[l3], 1), d2[l3].m(a2, null));
      }
      for (ma(), l3 = h2.length; l3 < d2.length; l3 += 1)
        p2(l3);
      ga();
    }
    (!u2 || 1 & c3 && s2 !== (s2 = "jse-message jse-" + e23[0] + " svelte-kvi5ls")) && So(t2, "class", s2);
  }, i: function(e23) {
    if (!u2) {
      ya(f2);
      for (var t3 = 0; t3 < h2.length; t3 += 1)
        ya(d2[t3]);
      u2 = true;
    }
  }, o: function(e23) {
    ba(f2), d2 = d2.filter(Boolean);
    for (var t3 = 0; t3 < d2.length; t3 += 1)
      ba(d2[t3]);
    u2 = false;
  }, d: function(e23) {
    e23 && po(t2), f2 && f2.d(), mo(d2, e23), c2 = false, l2();
  } };
}
function aS(e22, t2, n2) {
  var r2 = t2.type, i2 = r2 === void 0 ? "success" : r2, o2 = t2.icon, a2 = o2 === void 0 ? void 0 : o2, s2 = t2.message, u2 = s2 === void 0 ? void 0 : s2, c2 = t2.actions, l2 = c2 === void 0 ? [] : c2, f2 = t2.onClick, h2 = f2 === void 0 ? void 0 : f2;
  return e22.$$set = function(e23) {
    "type" in e23 && n2(0, i2 = e23.type), "icon" in e23 && n2(1, a2 = e23.icon), "message" in e23 && n2(2, u2 = e23.message), "actions" in e23 && n2(3, l2 = e23.actions), "onClick" in e23 && n2(4, h2 = e23.onClick);
  }, [i2, a2, u2, l2, h2, function() {
    h2 && h2();
  }, function(e23) {
    e23.onClick && e23.onClick();
  }, function(e23) {
    e23.onMouseDown && e23.onMouseDown();
  }];
}
var sS = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, aS, oS, Ki, { type: 0, icon: 1, message: 2, actions: 3, onClick: 4 }, eS), r2;
  }
  return zi(n2);
}();
function uS(e22) {
  return e22.map(cS).join("");
}
function cS(e22) {
  return hS.test(e22) ? "[" + e22 + "]" : fS.test(e22) ? "." + e22 : "[" + JSON.stringify(e22) + "]";
}
function lS(e22) {
  return e22.map(function(e23) {
    return hS.test(e23) ? "?.[".concat(e23, "]") : fS.test(e23) ? "?.".concat(e23) : "?.[".concat(JSON.stringify(e23), "]");
  }).join("");
}
var fS = /^[A-z$_][A-z$_\d]*$/i, hS = /^\d+$/;
function dS(e22) {
  co(e22, "svelte-1oe8e8r", ".jse-validation-errors-overview.svelte-1oe8e8r.svelte-1oe8e8r{font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono);background:var(--jse-message-warning-background);color:var(--jse-message-warning-color);overflow:auto;max-height:25%}.jse-validation-errors-overview.svelte-1oe8e8r table.svelte-1oe8e8r{border-collapse:collapse;width:100%}.jse-validation-errors-overview.svelte-1oe8e8r table tr.svelte-1oe8e8r{cursor:pointer}.jse-validation-errors-overview.svelte-1oe8e8r table tr.svelte-1oe8e8r:hover{background-color:rgba(255, 255, 255, 0.1)}.jse-validation-errors-overview.svelte-1oe8e8r table tr td.svelte-1oe8e8r{padding:4px var(--jse-padding);vertical-align:middle}.jse-validation-errors-overview.svelte-1oe8e8r table tr td.jse-validation-error-icon.svelte-1oe8e8r{width:36px;box-sizing:border-box}.jse-validation-errors-overview.svelte-1oe8e8r table tr td.jse-validation-error-action.svelte-1oe8e8r{width:36px;box-sizing:border-box;padding:0}.jse-validation-errors-overview.svelte-1oe8e8r table tr td.jse-validation-error-action button.jse-validation-errors-collapse.svelte-1oe8e8r{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;width:36px;height:26px;cursor:pointer}.jse-validation-errors-overview.svelte-1oe8e8r table tr td.jse-validation-error-action button.jse-validation-errors-collapse.svelte-1oe8e8r:hover{background-color:rgba(255, 255, 255, 0.2)}.jse-validation-errors-overview.svelte-1oe8e8r table tr td div.jse-validation-errors-expand.svelte-1oe8e8r{display:inline-block;position:relative;top:3px}");
}
function vS(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[6] = t2[n2], r2[8] = n2, r2;
}
function pS(e22) {
  var t2, n2, r2, i2, o2 = [gS, mS], a2 = [];
  function s2(e23, t3) {
    return e23[2] || e23[0].length === 1 ? 0 : 1;
  }
  return n2 = s2(e22), r2 = a2[n2] = o2[n2](e22), { c: function() {
    t2 = go("div"), r2.c(), So(t2, "class", "jse-validation-errors-overview svelte-1oe8e8r");
  }, m: function(e23, r3) {
    vo(e23, t2, r3), a2[n2].m(t2, null), i2 = true;
  }, p: function(e23, i3) {
    var u2 = n2;
    (n2 = s2(e23)) === u2 ? a2[n2].p(e23, i3) : (ma(), ba(a2[u2], 1, 1, function() {
      a2[u2] = null;
    }), ga(), (r2 = a2[n2]) ? r2.p(e23, i3) : (r2 = a2[n2] = o2[n2](e23)).c(), ya(r2, 1), r2.m(t2, null));
  }, i: function(e23) {
    i2 || (ya(r2), i2 = true);
  }, o: function(e23) {
    ba(r2), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), a2[n2].d();
  } };
}
function mS(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2 = e22[0].length + "";
  return o2 = new Xj({ props: { data: jj } }), f2 = new Xj({ props: { data: Xx } }), { c: function() {
    t2 = go("table"), n2 = go("tbody"), r2 = go("tr"), i2 = go("td"), Aa(o2.$$.fragment), a2 = ko(), s2 = go("td"), u2 = bo(p2), c2 = bo(" validation errors\n              "), l2 = go("div"), Aa(f2.$$.fragment), So(i2, "class", "jse-validation-error-icon svelte-1oe8e8r"), So(l2, "class", "jse-validation-errors-expand svelte-1oe8e8r"), So(s2, "class", "svelte-1oe8e8r"), So(r2, "class", "jse-validation-error svelte-1oe8e8r"), So(t2, "class", "svelte-1oe8e8r");
  }, m: function(p3, m2) {
    vo(p3, t2, m2), uo(t2, n2), uo(n2, r2), uo(r2, i2), Ma(o2, i2, null), uo(r2, a2), uo(r2, s2), uo(s2, u2), uo(s2, c2), uo(s2, l2), Ma(f2, l2, null), h2 = true, d2 || (v2 = xo(r2, "click", e22[4]), d2 = true);
  }, p: function(e23, t3) {
    (!h2 || 1 & t3) && p2 !== (p2 = e23[0].length + "") && Ao(u2, p2);
  }, i: function(e23) {
    h2 || (ya(o2.$$.fragment, e23), ya(f2.$$.fragment, e23), h2 = true);
  }, o: function(e23) {
    ba(o2.$$.fragment, e23), ba(f2.$$.fragment, e23), h2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(o2), Ea(f2), d2 = false, v2();
  } };
}
function gS(e22) {
  for (var t2, n2, r2, i2 = e22[0], o2 = [], a2 = 0; a2 < i2.length; a2 += 1)
    o2[a2] = bS(vS(e22, i2, a2));
  var s2 = function(e23) {
    return ba(o2[e23], 1, 1, function() {
      o2[e23] = null;
    });
  };
  return { c: function() {
    t2 = go("table"), n2 = go("tbody");
    for (var e23 = 0; e23 < o2.length; e23 += 1)
      o2[e23].c();
    So(t2, "class", "svelte-1oe8e8r");
  }, m: function(e23, i3) {
    vo(e23, t2, i3), uo(t2, n2);
    for (var a3 = 0; a3 < o2.length; a3 += 1)
      o2[a3].m(n2, null);
    r2 = true;
  }, p: function(e23, t3) {
    if (11 & t3) {
      var r3;
      for (i2 = e23[0], r3 = 0; r3 < i2.length; r3 += 1) {
        var a3 = vS(e23, i2, r3);
        o2[r3] ? (o2[r3].p(a3, t3), ya(o2[r3], 1)) : (o2[r3] = bS(a3), o2[r3].c(), ya(o2[r3], 1), o2[r3].m(n2, null));
      }
      for (ma(), r3 = i2.length; r3 < o2.length; r3 += 1)
        s2(r3);
      ga();
    }
  }, i: function(e23) {
    if (!r2) {
      for (var t3 = 0; t3 < i2.length; t3 += 1)
        ya(o2[t3]);
      r2 = true;
    }
  }, o: function(e23) {
    o2 = o2.filter(Boolean);
    for (var t3 = 0; t3 < o2.length; t3 += 1)
      ba(o2[t3]);
    r2 = false;
  }, d: function(e23) {
    e23 && po(t2), mo(o2, e23);
  } };
}
function yS(e22) {
  var t2, n2, r2, i2, o2;
  return n2 = new Xj({ props: { data: Zx } }), { c: function() {
    t2 = go("button"), Aa(n2.$$.fragment), So(t2, "type", "button"), So(t2, "class", "jse-validation-errors-collapse svelte-1oe8e8r"), So(t2, "title", "Collapse validation errors");
  }, m: function(a2, s2) {
    vo(a2, t2, s2), Ma(n2, t2, null), r2 = true, i2 || (o2 = xo(t2, "click", jo(e22[3])), i2 = true);
  }, p: Bi, i: function(e23) {
    r2 || (ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), i2 = false, o2();
  } };
}
function bS(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2 = uS(e22[6].path) + "", g2 = e22[6].message + "";
  r2 = new Xj({ props: { data: jj } });
  var y2 = e22[8] === 0 && e22[0].length > 1 && yS(e22);
  function b2() {
    return e22[5](e22[6]);
  }
  return { c: function() {
    t2 = go("tr"), n2 = go("td"), Aa(r2.$$.fragment), i2 = ko(), o2 = go("td"), a2 = bo(m2), s2 = ko(), u2 = go("td"), c2 = bo(g2), l2 = ko(), f2 = go("td"), y2 && y2.c(), h2 = ko(), So(n2, "class", "jse-validation-error-icon svelte-1oe8e8r"), So(o2, "class", "svelte-1oe8e8r"), So(u2, "class", "svelte-1oe8e8r"), So(f2, "class", "jse-validation-error-action svelte-1oe8e8r"), So(t2, "class", "jse-validation-error svelte-1oe8e8r");
  }, m: function(e23, m3) {
    vo(e23, t2, m3), uo(t2, n2), Ma(r2, n2, null), uo(t2, i2), uo(t2, o2), uo(o2, a2), uo(t2, s2), uo(t2, u2), uo(u2, c2), uo(t2, l2), uo(t2, f2), y2 && y2.m(f2, null), uo(t2, h2), d2 = true, v2 || (p2 = xo(t2, "click", b2), v2 = true);
  }, p: function(t3, n3) {
    e22 = t3, (!d2 || 1 & n3) && m2 !== (m2 = uS(e22[6].path) + "") && Ao(a2, m2), (!d2 || 1 & n3) && g2 !== (g2 = e22[6].message + "") && Ao(c2, g2), e22[8] === 0 && e22[0].length > 1 ? y2 ? (y2.p(e22, n3), 1 & n3 && ya(y2, 1)) : ((y2 = yS(e22)).c(), ya(y2, 1), y2.m(f2, null)) : y2 && (ma(), ba(y2, 1, 1, function() {
      y2 = null;
    }), ga());
  }, i: function(e23) {
    d2 || (ya(r2.$$.fragment, e23), ya(y2), d2 = true);
  }, o: function(e23) {
    ba(r2.$$.fragment, e23), ba(y2), d2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(r2), y2 && y2.d(), v2 = false, p2();
  } };
}
function kS(e22) {
  var t2, n2, r2 = !km(e22[0]), i2 = r2 && pS(e22);
  return { c: function() {
    i2 && i2.c(), t2 = wo();
  }, m: function(e23, r3) {
    i2 && i2.m(e23, r3), vo(e23, t2, r3), n2 = true;
  }, p: function(e23, n3) {
    var o2 = xi(n3, 1)[0];
    1 & o2 && (r2 = !km(e23[0])), r2 ? i2 ? (i2.p(e23, o2), 1 & o2 && ya(i2, 1)) : ((i2 = pS(e23)).c(), ya(i2, 1), i2.m(t2.parentNode, t2)) : i2 && (ma(), ba(i2, 1, 1, function() {
      i2 = null;
    }), ga());
  }, i: function(e23) {
    n2 || (ya(i2), n2 = true);
  }, o: function(e23) {
    ba(i2), n2 = false;
  }, d: function(e23) {
    i2 && i2.d(e23), e23 && po(t2);
  } };
}
function wS(e22, t2, n2) {
  var r2 = t2.validationErrors, i2 = t2.selectError, o2 = true;
  return e22.$$set = function(e23) {
    "validationErrors" in e23 && n2(0, r2 = e23.validationErrors), "selectError" in e23 && n2(1, i2 = e23.selectError);
  }, [r2, i2, o2, function() {
    n2(2, o2 = false);
  }, function() {
    n2(2, o2 = true);
  }, function(e23) {
    setTimeout(function() {
      return i2(e23);
    });
  }];
}
var xS = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, wS, kS, Ki, { validationErrors: 0, selectError: 1 }, dS), r2;
  }
  return zi(n2);
}(), jS = { prefix: "fas", iconName: "jsoneditor-expand", icon: [512, 512, [], null, "M 0,448 V 512 h 512 v -64 z M 0,0 V 64 H 512 V 0 Z M 256,96 128,224 h 256 z M 256,416 384,288 H 128 Z"] }, SS = { prefix: "fas", iconName: "jsoneditor-collapse", icon: [512, 512, [], null, "m 0,224 v 64 h 512 v -64 z M 256,192 384,64 H 128 Z M 256,320 128,448 h 256 z"] }, CS = { prefix: "fas", iconName: "jsoneditor-format", icon: [512, 512, [], null, "M 0,32 v 64 h 416 v -64 z M 160,160 v 64 h 352 v -64 z M 160,288 v 64 h 288 v -64 z M 0,416 v 64 h 320 v -64 z"] }, _S = { prefix: "fas", iconName: "jsoneditor-compact", icon: [512, 512, [], null, "M 0,32 v 64 h 512 v -64 z M 0,160 v 64 h 512 v -64 z M 0,288 v 64 h 352 v -64 z"] };
function $S(e22) {
  co(e22, "svelte-v4jelk", ".jse-menu.svelte-v4jelk.svelte-v4jelk{background:var(--jse-theme-color);border-bottom:1px solid var(--jse-theme-color);color:var(--jse-menu-color);display:flex;flex-wrap:wrap;align-items:center;position:relative}.jse-menu.svelte-v4jelk .jse-button.svelte-v4jelk{width:var(--jse-menu-button-size);height:var(--jse-menu-button-size);border:none;background:transparent;color:inherit;cursor:pointer;padding:calc(0.5 * var(--jse-padding));margin:0;border-radius:0}.jse-menu.svelte-v4jelk .jse-button.svelte-v4jelk:hover,.jse-menu.svelte-v4jelk .jse-button.svelte-v4jelk:focus{background:var(--jse-theme-color-highlight)}.jse-menu.svelte-v4jelk .jse-button.svelte-v4jelk:disabled{color:var(--jse-menu-color);opacity:0.5;background:transparent}.jse-menu.svelte-v4jelk .jse-button.jse-group-button.svelte-v4jelk{border:1px solid var(--jse-menu-color);padding:0;margin:calc(0.5 * var(--jse-padding)) 0;height:calc(var(--jse-menu-button-size) - var(--jse-padding));width:40px}.jse-menu.svelte-v4jelk .jse-button.jse-group-button.svelte-v4jelk:not(.jse-last){border-right:none}.jse-menu.svelte-v4jelk .jse-button.jse-group-button.jse-first.svelte-v4jelk{margin-left:calc(0.5 * var(--jse-padding))}.jse-menu.svelte-v4jelk .jse-button.jse-group-button.jse-last.svelte-v4jelk{margin-right:calc(0.5 * var(--jse-padding))}.jse-menu.svelte-v4jelk .jse-button.jse-group-button.svelte-v4jelk:hover,.jse-menu.svelte-v4jelk .jse-button.jse-group-button.svelte-v4jelk:focus{background:var(--jse-theme-color-highlight)}.jse-menu.svelte-v4jelk .jse-button.jse-group-button.jse-selected.svelte-v4jelk{background:var(--jse-menu-color);color:var(--jse-theme-color)}.jse-menu.svelte-v4jelk .jse-space.svelte-v4jelk{flex:1}.jse-menu.svelte-v4jelk .jse-separator.svelte-v4jelk{background:var(--jse-menu-color);opacity:0.3;box-sizing:border-box;width:1px;height:calc(var(--jse-menu-button-size) - 6px);margin:3px}");
}
var OS = function(e22) {
  return {};
}, AS = function(e22) {
  return {};
};
function MS(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[3] = t2[n2], r2;
}
var ES = function(e22) {
  return {};
}, PS = function(e22) {
  return {};
};
function NS(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2 = e22[3].icon && RS(e22), l2 = e22[3].text && DS(e22);
  return { c: function() {
    t2 = go("button"), c2 && c2.c(), n2 = ko(), l2 && l2.c(), So(t2, "type", "button"), So(t2, "class", r2 = "jse-button " + e22[3].className + " svelte-v4jelk"), So(t2, "title", i2 = e22[3].title), t2.disabled = o2 = e22[3].disabled || false;
  }, m: function(r3, i3) {
    vo(r3, t2, i3), c2 && c2.m(t2, null), uo(t2, n2), l2 && l2.m(t2, null), a2 = true, s2 || (u2 = xo(t2, "click", function() {
      Ji(e22[3].onClick) && e22[3].onClick.apply(this, arguments);
    }), s2 = true);
  }, p: function(s3, u3) {
    (e22 = s3)[3].icon ? c2 ? (c2.p(e22, u3), 1 & u3 && ya(c2, 1)) : ((c2 = RS(e22)).c(), ya(c2, 1), c2.m(t2, n2)) : c2 && (ma(), ba(c2, 1, 1, function() {
      c2 = null;
    }), ga()), e22[3].text ? l2 ? l2.p(e22, u3) : ((l2 = DS(e22)).c(), l2.m(t2, null)) : l2 && (l2.d(1), l2 = null), (!a2 || 1 & u3 && r2 !== (r2 = "jse-button " + e22[3].className + " svelte-v4jelk")) && So(t2, "class", r2), (!a2 || 1 & u3 && i2 !== (i2 = e22[3].title)) && So(t2, "title", i2), (!a2 || 1 & u3 && o2 !== (o2 = e22[3].disabled || false)) && (t2.disabled = o2);
  }, i: function(e23) {
    a2 || (ya(c2), a2 = true);
  }, o: function(e23) {
    ba(c2), a2 = false;
  }, d: function(e23) {
    e23 && po(t2), c2 && c2.d(), l2 && l2.d(), s2 = false, u2();
  } };
}
function TS(e22) {
  var t2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-space svelte-v4jelk");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, p: Bi, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function IS(e22) {
  var t2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-separator svelte-v4jelk");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, p: Bi, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function RS(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: e22[3].icon } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    1 & n3 && (r2.data = e23[3].icon), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function DS(e22) {
  var t2, n2 = e22[3].text + "";
  return { c: function() {
    t2 = bo(n2);
  }, m: function(e23, n3) {
    vo(e23, t2, n3);
  }, p: function(e23, r2) {
    1 & r2 && n2 !== (n2 = e23[3].text + "") && Ao(t2, n2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function zS(e22) {
  var t2, n2, r2, i2, o2 = [IS, TS, NS], a2 = [];
  function s2(e23, t3) {
    return e23[3].separator === true ? 0 : e23[3].space === true ? 1 : 2;
  }
  return t2 = s2(e22), n2 = a2[t2] = o2[t2](e22), { c: function() {
    n2.c(), r2 = wo();
  }, m: function(e23, n3) {
    a2[t2].m(e23, n3), vo(e23, r2, n3), i2 = true;
  }, p: function(e23, i3) {
    var u2 = t2;
    (t2 = s2(e23)) === u2 ? a2[t2].p(e23, i3) : (ma(), ba(a2[u2], 1, 1, function() {
      a2[u2] = null;
    }), ga(), (n2 = a2[t2]) ? n2.p(e23, i3) : (n2 = a2[t2] = o2[t2](e23)).c(), ya(n2, 1), n2.m(r2.parentNode, r2));
  }, i: function(e23) {
    i2 || (ya(n2), i2 = true);
  }, o: function(e23) {
    ba(n2), i2 = false;
  }, d: function(e23) {
    a2[t2].d(e23), e23 && po(r2);
  } };
}
function LS(e22) {
  for (var t2, n2, r2, i2, o2 = e22[2].left, a2 = Gi(o2, e22, e22[1], PS), s2 = e22[0], u2 = [], c2 = 0; c2 < s2.length; c2 += 1)
    u2[c2] = zS(MS(e22, s2, c2));
  var l2 = function(e23) {
    return ba(u2[e23], 1, 1, function() {
      u2[e23] = null;
    });
  }, f2 = e22[2].right, h2 = Gi(f2, e22, e22[1], AS);
  return { c: function() {
    t2 = go("div"), a2 && a2.c(), n2 = ko();
    for (var e23 = 0; e23 < u2.length; e23 += 1)
      u2[e23].c();
    r2 = ko(), h2 && h2.c(), So(t2, "class", "jse-menu svelte-v4jelk");
  }, m: function(e23, o3) {
    vo(e23, t2, o3), a2 && a2.m(t2, null), uo(t2, n2);
    for (var s3 = 0; s3 < u2.length; s3 += 1)
      u2[s3].m(t2, null);
    uo(t2, r2), h2 && h2.m(t2, null), i2 = true;
  }, p: function(e23, n3) {
    var c3 = xi(n3, 1)[0];
    if (a2 && a2.p && (!i2 || 2 & c3) && Zi(a2, o2, e23, e23[1], i2 ? Yi(o2, e23[1], c3, ES) : Xi(e23[1]), PS), 1 & c3) {
      var d2;
      for (s2 = e23[0], d2 = 0; d2 < s2.length; d2 += 1) {
        var v2 = MS(e23, s2, d2);
        u2[d2] ? (u2[d2].p(v2, c3), ya(u2[d2], 1)) : (u2[d2] = zS(v2), u2[d2].c(), ya(u2[d2], 1), u2[d2].m(t2, r2));
      }
      for (ma(), d2 = s2.length; d2 < u2.length; d2 += 1)
        l2(d2);
      ga();
    }
    h2 && h2.p && (!i2 || 2 & c3) && Zi(h2, f2, e23, e23[1], i2 ? Yi(f2, e23[1], c3, OS) : Xi(e23[1]), AS);
  }, i: function(e23) {
    if (!i2) {
      ya(a2, e23);
      for (var t3 = 0; t3 < s2.length; t3 += 1)
        ya(u2[t3]);
      ya(h2, e23), i2 = true;
    }
  }, o: function(e23) {
    ba(a2, e23), u2 = u2.filter(Boolean);
    for (var t3 = 0; t3 < u2.length; t3 += 1)
      ba(u2[t3]);
    ba(h2, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), a2 && a2.d(e23), mo(u2, e23), h2 && h2.d(e23);
  } };
}
function BS(e22, t2, n2) {
  var r2 = t2.$$slots, i2 = r2 === void 0 ? {} : r2, o2 = t2.$$scope, a2 = t2.items, s2 = a2 === void 0 ? [] : a2;
  return e22.$$set = function(e23) {
    "items" in e23 && n2(0, s2 = e23.items), "$$scope" in e23 && n2(1, o2 = e23.$$scope);
  }, [s2, o2, i2];
}
var qS = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, BS, LS, Ki, { items: 0 }, $S), r2;
  }
  return zi(n2);
}();
function FS(e22) {
  var t2, n2;
  return t2 = new qS({ props: { items: e22[0] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    1 & xi(n3, 1)[0] && (r2.items = e23[0]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function VS(e22, t2, n2) {
  var r2, i2, o2 = t2.readOnly, a2 = o2 !== void 0 && o2, s2 = t2.onFormat, u2 = t2.onCompact, c2 = t2.onSort, l2 = t2.onTransform, f2 = t2.onToggleSearch, h2 = t2.onUndo, d2 = t2.onRedo, v2 = t2.canUndo, p2 = t2.canRedo, m2 = t2.canFormat, g2 = t2.canCompact, y2 = t2.canSort, b2 = t2.canTransform, k2 = t2.onRenderMenu, w2 = k2 === void 0 ? Vu : k2;
  return e22.$$set = function(e23) {
    "readOnly" in e23 && n2(1, a2 = e23.readOnly), "onFormat" in e23 && n2(2, s2 = e23.onFormat), "onCompact" in e23 && n2(3, u2 = e23.onCompact), "onSort" in e23 && n2(4, c2 = e23.onSort), "onTransform" in e23 && n2(5, l2 = e23.onTransform), "onToggleSearch" in e23 && n2(6, f2 = e23.onToggleSearch), "onUndo" in e23 && n2(7, h2 = e23.onUndo), "onRedo" in e23 && n2(8, d2 = e23.onRedo), "canUndo" in e23 && n2(9, v2 = e23.canUndo), "canRedo" in e23 && n2(10, p2 = e23.canRedo), "canFormat" in e23 && n2(11, m2 = e23.canFormat), "canCompact" in e23 && n2(12, g2 = e23.canCompact), "canSort" in e23 && n2(13, y2 = e23.canSort), "canTransform" in e23 && n2(14, b2 = e23.canTransform), "onRenderMenu" in e23 && n2(15, w2 = e23.onRenderMenu);
  }, e22.$$.update = function() {
    32766 & e22.$$.dirty && n2(16, r2 = a2 ? [{ space: true }] : [{ icon: CS, title: "Format JSON: add proper indentation and new lines (Ctrl+I)", className: "jse-format", onClick: s2, disabled: a2 || !m2 }, { icon: _S, title: "Compact JSON: remove all white spacing and new lines (Ctrl+Shift+I)", className: "jse-compact", onClick: u2, disabled: a2 || !g2 }, { separator: true }, { icon: tj, title: "Sort", className: "jse-sort", onClick: c2, disabled: a2 || !y2 }, { icon: pj, title: "Transform contents (filter, sort, project)", className: "jse-transform", onClick: l2, disabled: a2 || !b2 }, { icon: gj, title: "Search (Ctrl+F)", className: "jse-search", onClick: f2 }, { separator: true }, { icon: nj, title: "Undo (Ctrl+Z)", className: "jse-undo", onClick: h2, disabled: !v2 }, { icon: rj, title: "Redo (Ctrl+Shift+Z)", className: "jse-redo", onClick: d2, disabled: !p2 }, { space: true }]), 98304 & e22.$$.dirty && n2(0, i2 = w2("text", r2) || r2);
  }, [i2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2, w2, r2];
}
var HS = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, VS, FS, Ki, { readOnly: 1, onFormat: 2, onCompact: 3, onSort: 4, onTransform: 5, onToggleSearch: 6, onUndo: 7, onRedo: 8, canUndo: 9, canRedo: 10, canFormat: 11, canCompact: 12, canSort: 13, canTransform: 14, onRenderMenu: 15 }), r2;
  }
  return zi(n2);
}(), WS = function() {
  function e22() {
    Ri(this, e22);
  }
  return zi(e22, [{ key: "lineAt", value: function(e23) {
    if (e23 < 0 || e23 > this.length)
      throw new RangeError("Invalid position ".concat(e23, " in document of length ").concat(this.length));
    return this.lineInner(e23, false, 1, 0);
  } }, { key: "line", value: function(e23) {
    if (e23 < 1 || e23 > this.lines)
      throw new RangeError("Invalid line number ".concat(e23, " in ").concat(this.lines, "-line document"));
    return this.lineInner(e23, true, 1, 0);
  } }, { key: "replace", value: function(e23, t2, n2) {
    var r2 = [];
    return this.decompose(0, e23, r2, 2), n2.length && n2.decompose(0, n2.length, r2, 3), this.decompose(t2, this.length, r2, 1), US.from(r2, this.length - (t2 - e23) + n2.length);
  } }, { key: "append", value: function(e23) {
    return this.replace(this.length, this.length, e23);
  } }, { key: "slice", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.length, n2 = [];
    return this.decompose(e23, t2, n2, 0), US.from(n2, t2 - e23);
  } }, { key: "eq", value: function(e23) {
    if (e23 == this)
      return true;
    if (e23.length != this.length || e23.lines != this.lines)
      return false;
    for (var t2 = this.scanIdentical(e23, 1), n2 = this.length - this.scanIdentical(e23, -1), r2 = new YS(this), i2 = new YS(e23), o2 = t2, a2 = t2; ; ) {
      if (r2.next(o2), i2.next(o2), o2 = 0, r2.lineBreak != i2.lineBreak || r2.done != i2.done || r2.value != i2.value)
        return false;
      if (a2 += r2.value.length, r2.done || a2 >= n2)
        return true;
    }
  } }, { key: "iter", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 1;
    return new YS(this, e23);
  } }, { key: "iterRange", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.length;
    return new ZS(this, e23, t2);
  } }, { key: "iterLines", value: function(e23, t2) {
    var n2;
    if (e23 == null)
      n2 = this.iter();
    else {
      t2 == null && (t2 = this.lines + 1);
      var r2 = this.line(e23).from;
      n2 = this.iterRange(r2, Math.max(r2, t2 == this.lines + 1 ? this.length : t2 <= 1 ? 0 : this.line(t2 - 1).to));
    }
    return new XS(n2);
  } }, { key: "toString", value: function() {
    return this.sliceString(0);
  } }, { key: "toJSON", value: function() {
    var e23 = [];
    return this.flatten(e23), e23;
  } }], [{ key: "of", value: function(t2) {
    if (t2.length == 0)
      throw new RangeError("A document must have at least one line");
    return t2.length != 1 || t2[0] ? t2.length <= 32 ? new JS(t2) : US.from(JS.split(t2, [])) : e22.empty;
  } }]), e22;
}(), JS = function(e22) {
  ji(n2, WS);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2, i2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : KS(e23);
    return Ri(this, n2), (r2 = t2.call(this)).text = e23, r2.length = i2, r2;
  }
  return zi(n2, [{ key: "lines", get: function() {
    return this.text.length;
  } }, { key: "children", get: function() {
    return null;
  } }, { key: "lineInner", value: function(e23, t3, n3, r2) {
    for (var i2 = 0; ; i2++) {
      var o2 = this.text[i2], a2 = r2 + o2.length;
      if ((t3 ? n3 : a2) >= e23)
        return new eC(r2, a2, n3, o2);
      r2 = a2 + 1, n3++;
    }
  } }, { key: "decompose", value: function(e23, t3, r2, i2) {
    var o2 = e23 <= 0 && t3 >= this.length ? this : new n2(QS(this.text, e23, t3), Math.min(t3, this.length) - Math.max(0, e23));
    if (1 & i2) {
      var a2 = r2.pop(), s2 = GS(o2.text, a2.text.slice(), 0, o2.length);
      if (s2.length <= 32)
        r2.push(new n2(s2, a2.length + o2.length));
      else {
        var u2 = s2.length >> 1;
        r2.push(new n2(s2.slice(0, u2)), new n2(s2.slice(u2)));
      }
    } else
      r2.push(o2);
  } }, { key: "replace", value: function(e23, t3, r2) {
    if (!(r2 instanceof n2))
      return ki(Ai(n2.prototype), "replace", this).call(this, e23, t3, r2);
    var i2 = GS(this.text, GS(r2.text, QS(this.text, 0, e23)), t3), o2 = this.length + r2.length - (t3 - e23);
    return i2.length <= 32 ? new n2(i2, o2) : US.from(n2.split(i2, []), o2);
  } }, { key: "sliceString", value: function(e23) {
    for (var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.length, n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "\n", r2 = "", i2 = 0, o2 = 0; i2 <= t3 && o2 < this.text.length; o2++) {
      var a2 = this.text[o2], s2 = i2 + a2.length;
      i2 > e23 && o2 && (r2 += n3), e23 < s2 && t3 > i2 && (r2 += a2.slice(Math.max(0, e23 - i2), t3 - i2)), i2 = s2 + 1;
    }
    return r2;
  } }, { key: "flatten", value: function(e23) {
    var t3, n3 = bi(this.text);
    try {
      for (n3.s(); !(t3 = n3.n()).done; ) {
        var r2 = t3.value;
        e23.push(r2);
      }
    } catch (e24) {
      n3.e(e24);
    } finally {
      n3.f();
    }
  } }, { key: "scanIdentical", value: function() {
    return 0;
  } }], [{ key: "split", value: function(e23, t3) {
    var r2, i2 = [], o2 = -1, a2 = bi(e23);
    try {
      for (a2.s(); !(r2 = a2.n()).done; ) {
        var s2 = r2.value;
        i2.push(s2), o2 += s2.length + 1, i2.length == 32 && (t3.push(new n2(i2, o2)), i2 = [], o2 = -1);
      }
    } catch (e24) {
      a2.e(e24);
    } finally {
      a2.f();
    }
    return o2 > -1 && t3.push(new n2(i2, o2)), t3;
  } }]), n2;
}(), US = function(e22) {
  ji(n2, WS);
  var t2 = Ci(n2);
  function n2(e23, r2) {
    var i2;
    Ri(this, n2), (i2 = t2.call(this)).children = e23, i2.length = r2, i2.lines = 0;
    var o2, a2 = bi(e23);
    try {
      for (a2.s(); !(o2 = a2.n()).done; ) {
        var s2 = o2.value;
        i2.lines += s2.lines;
      }
    } catch (e24) {
      a2.e(e24);
    } finally {
      a2.f();
    }
    return i2;
  }
  return zi(n2, [{ key: "lineInner", value: function(e23, t3, n3, r2) {
    for (var i2 = 0; ; i2++) {
      var o2 = this.children[i2], a2 = r2 + o2.length, s2 = n3 + o2.lines - 1;
      if ((t3 ? s2 : a2) >= e23)
        return o2.lineInner(e23, t3, n3, r2);
      r2 = a2 + 1, n3 = s2 + 1;
    }
  } }, { key: "decompose", value: function(e23, t3, n3, r2) {
    for (var i2 = 0, o2 = 0; o2 <= t3 && i2 < this.children.length; i2++) {
      var a2 = this.children[i2], s2 = o2 + a2.length;
      if (e23 <= s2 && t3 >= o2) {
        var u2 = r2 & ((o2 <= e23 ? 1 : 0) | (s2 >= t3 ? 2 : 0));
        o2 >= e23 && s2 <= t3 && !u2 ? n3.push(a2) : a2.decompose(e23 - o2, t3 - o2, n3, u2);
      }
      o2 = s2 + 1;
    }
  } }, { key: "replace", value: function(e23, t3, r2) {
    if (r2.lines < this.lines)
      for (var i2 = 0, o2 = 0; i2 < this.children.length; i2++) {
        var a2 = this.children[i2], s2 = o2 + a2.length;
        if (e23 >= o2 && t3 <= s2) {
          var u2 = a2.replace(e23 - o2, t3 - o2, r2), c2 = this.lines - a2.lines + u2.lines;
          if (u2.lines < c2 >> 4 && u2.lines > c2 >> 6) {
            var l2 = this.children.slice();
            return l2[i2] = u2, new n2(l2, this.length - (t3 - e23) + r2.length);
          }
          return ki(Ai(n2.prototype), "replace", this).call(this, o2, s2, u2);
        }
        o2 = s2 + 1;
      }
    return ki(Ai(n2.prototype), "replace", this).call(this, e23, t3, r2);
  } }, { key: "sliceString", value: function(e23) {
    for (var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.length, n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "\n", r2 = "", i2 = 0, o2 = 0; i2 < this.children.length && o2 <= t3; i2++) {
      var a2 = this.children[i2], s2 = o2 + a2.length;
      o2 > e23 && i2 && (r2 += n3), e23 < s2 && t3 > o2 && (r2 += a2.sliceString(e23 - o2, t3 - o2, n3)), o2 = s2 + 1;
    }
    return r2;
  } }, { key: "flatten", value: function(e23) {
    var t3, n3 = bi(this.children);
    try {
      for (n3.s(); !(t3 = n3.n()).done; ) {
        t3.value.flatten(e23);
      }
    } catch (e24) {
      n3.e(e24);
    } finally {
      n3.f();
    }
  } }, { key: "scanIdentical", value: function(e23, t3) {
    if (!(e23 instanceof n2))
      return 0;
    for (var r2 = 0, i2 = xi(t3 > 0 ? [0, 0, this.children.length, e23.children.length] : [this.children.length - 1, e23.children.length - 1, -1, -1], 4), o2 = i2[0], a2 = i2[1], s2 = i2[2], u2 = i2[3]; ; o2 += t3, a2 += t3) {
      if (o2 == s2 || a2 == u2)
        return r2;
      var c2 = this.children[o2], l2 = e23.children[a2];
      if (c2 != l2)
        return r2 + c2.scanIdentical(l2, t3);
      r2 += c2.length + 1;
    }
  } }], [{ key: "from", value: function(e23) {
    var t3, r2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23.reduce(function(e24, t4) {
      return e24 + t4.length + 1;
    }, -1), i2 = 0, o2 = bi(e23);
    try {
      for (o2.s(); !(t3 = o2.n()).done; ) {
        var a2 = t3.value;
        i2 += a2.lines;
      }
    } catch (e24) {
      o2.e(e24);
    } finally {
      o2.f();
    }
    if (i2 < 32) {
      var s2, u2 = [], c2 = bi(e23);
      try {
        for (c2.s(); !(s2 = c2.n()).done; ) {
          var l2 = s2.value;
          l2.flatten(u2);
        }
      } catch (e24) {
        c2.e(e24);
      } finally {
        c2.f();
      }
      return new JS(u2, r2);
    }
    var f2 = Math.max(32, i2 >> 5), h2 = f2 << 1, d2 = f2 >> 1, v2 = [], p2 = 0, m2 = -1, g2 = [];
    function y2(e24) {
      var t4;
      if (e24.lines > h2 && e24 instanceof n2) {
        var r3, i3 = bi(e24.children);
        try {
          for (i3.s(); !(r3 = i3.n()).done; ) {
            y2(r3.value);
          }
        } catch (e25) {
          i3.e(e25);
        } finally {
          i3.f();
        }
      } else
        e24.lines > d2 && (p2 > d2 || !p2) ? (b2(), v2.push(e24)) : e24 instanceof JS && p2 && (t4 = g2[g2.length - 1]) instanceof JS && e24.lines + t4.lines <= 32 ? (p2 += e24.lines, m2 += e24.length + 1, g2[g2.length - 1] = new JS(t4.text.concat(e24.text), t4.length + 1 + e24.length)) : (p2 + e24.lines > f2 && b2(), p2 += e24.lines, m2 += e24.length + 1, g2.push(e24));
    }
    function b2() {
      p2 != 0 && (v2.push(g2.length == 1 ? g2[0] : n2.from(g2, m2)), m2 = -1, p2 = g2.length = 0);
    }
    var k2, w2 = bi(e23);
    try {
      for (w2.s(); !(k2 = w2.n()).done; ) {
        var x2 = k2.value;
        y2(x2);
      }
    } catch (e24) {
      w2.e(e24);
    } finally {
      w2.f();
    }
    return b2(), v2.length == 1 ? v2[0] : new n2(v2, r2);
  } }]), n2;
}();
function KS(e22) {
  var t2, n2 = -1, r2 = bi(e22);
  try {
    for (r2.s(); !(t2 = r2.n()).done; ) {
      n2 += t2.value.length + 1;
    }
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
  return n2;
}
function GS(e22, t2) {
  for (var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 1e9, i2 = 0, o2 = 0, a2 = true; o2 < e22.length && i2 <= r2; o2++) {
    var s2 = e22[o2], u2 = i2 + s2.length;
    u2 >= n2 && (u2 > r2 && (s2 = s2.slice(0, r2 - i2)), i2 < n2 && (s2 = s2.slice(n2 - i2)), a2 ? (t2[t2.length - 1] += s2, a2 = false) : t2.push(s2)), i2 = u2 + 1;
  }
  return t2;
}
function QS(e22, t2, n2) {
  return GS(e22, [""], t2, n2);
}
WS.empty = new JS([""], 0);
var YS = function() {
  function e22(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
    Ri(this, e22), this.dir = n2, this.done = false, this.lineBreak = false, this.value = "", this.nodes = [t2], this.offsets = [n2 > 0 ? 1 : (t2 instanceof JS ? t2.text.length : t2.children.length) << 1];
  }
  return zi(e22, [{ key: "nextInner", value: function(e23, t2) {
    for (this.done = this.lineBreak = false; ; ) {
      var n2 = this.nodes.length - 1, r2 = this.nodes[n2], i2 = this.offsets[n2], o2 = i2 >> 1, a2 = r2 instanceof JS ? r2.text.length : r2.children.length;
      if (o2 == (t2 > 0 ? a2 : 0)) {
        if (n2 == 0)
          return this.done = true, this.value = "", this;
        t2 > 0 && this.offsets[n2 - 1]++, this.nodes.pop(), this.offsets.pop();
      } else if ((1 & i2) == (t2 > 0 ? 0 : 1)) {
        if (this.offsets[n2] += t2, e23 == 0)
          return this.lineBreak = true, this.value = "\n", this;
        e23--;
      } else if (r2 instanceof JS) {
        var s2 = r2.text[o2 + (t2 < 0 ? -1 : 0)];
        if (this.offsets[n2] += t2, s2.length > Math.max(0, e23))
          return this.value = e23 == 0 ? s2 : t2 > 0 ? s2.slice(e23) : s2.slice(0, s2.length - e23), this;
        e23 -= s2.length;
      } else {
        var u2 = r2.children[o2 + (t2 < 0 ? -1 : 0)];
        e23 > u2.length ? (e23 -= u2.length, this.offsets[n2] += t2) : (t2 < 0 && this.offsets[n2]--, this.nodes.push(u2), this.offsets.push(t2 > 0 ? 1 : (u2 instanceof JS ? u2.text.length : u2.children.length) << 1));
      }
    }
  } }, { key: "next", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return e23 < 0 && (this.nextInner(-e23, -this.dir), e23 = this.value.length), this.nextInner(e23, this.dir);
  } }]), e22;
}(), ZS = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.value = "", this.done = false, this.cursor = new YS(t2, n2 > r2 ? -1 : 1), this.pos = n2 > r2 ? t2.length : 0, this.from = Math.min(n2, r2), this.to = Math.max(n2, r2);
  }
  return zi(e22, [{ key: "nextInner", value: function(e23, t2) {
    if (t2 < 0 ? this.pos <= this.from : this.pos >= this.to)
      return this.value = "", this.done = true, this;
    e23 += Math.max(0, t2 < 0 ? this.pos - this.to : this.from - this.pos);
    var n2 = t2 < 0 ? this.pos - this.from : this.to - this.pos;
    e23 > n2 && (e23 = n2), n2 -= e23;
    var r2 = this.cursor.next(e23).value;
    return this.pos += (r2.length + e23) * t2, this.value = r2.length <= n2 ? r2 : t2 < 0 ? r2.slice(r2.length - n2) : r2.slice(0, n2), this.done = !this.value, this;
  } }, { key: "next", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return e23 < 0 ? e23 = Math.max(e23, this.from - this.pos) : e23 > 0 && (e23 = Math.min(e23, this.to - this.pos)), this.nextInner(e23, this.cursor.dir);
  } }, { key: "lineBreak", get: function() {
    return this.cursor.lineBreak && this.value != "";
  } }]), e22;
}(), XS = function() {
  function e22(t2) {
    Ri(this, e22), this.inner = t2, this.afterBreak = true, this.value = "", this.done = false;
  }
  return zi(e22, [{ key: "next", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0, t2 = this.inner.next(e23), n2 = t2.done, r2 = t2.lineBreak, i2 = t2.value;
    return n2 ? (this.done = true, this.value = "") : r2 ? this.afterBreak ? this.value = "" : (this.afterBreak = true, this.next()) : (this.value = i2, this.afterBreak = false), this;
  } }, { key: "lineBreak", get: function() {
    return false;
  } }]), e22;
}();
typeof Symbol != "undefined" && (WS.prototype[Symbol.iterator] = function() {
  return this.iter();
}, YS.prototype[Symbol.iterator] = ZS.prototype[Symbol.iterator] = XS.prototype[Symbol.iterator] = function() {
  return this;
});
for (var eC = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.from = t2, this.to = n2, this.number = r2, this.text = i2;
  }
  return zi(e22, [{ key: "length", get: function() {
    return this.to - this.from;
  } }]), e22;
}(), tC = "lc,34,7n,7,7b,19,,,,2,,2,,,20,b,1c,l,g,,2t,7,2,6,2,2,,4,z,,u,r,2j,b,1m,9,9,,o,4,,9,,3,,5,17,3,3b,f,,w,1j,,,,4,8,4,,3,7,a,2,t,,1m,,,,2,4,8,,9,,a,2,q,,2,2,1l,,4,2,4,2,2,3,3,,u,2,3,,b,2,1l,,4,5,,2,4,,k,2,m,6,,,1m,,,2,,4,8,,7,3,a,2,u,,1n,,,,c,,9,,14,,3,,1l,3,5,3,,4,7,2,b,2,t,,1m,,2,,2,,3,,5,2,7,2,b,2,s,2,1l,2,,,2,4,8,,9,,a,2,t,,20,,4,,2,3,,,8,,29,,2,7,c,8,2q,,2,9,b,6,22,2,r,,,,,,1j,e,,5,,2,5,b,,10,9,,2u,4,,6,,2,2,2,p,2,4,3,g,4,d,,2,2,6,,f,,jj,3,qa,3,t,3,t,2,u,2,1s,2,,7,8,,2,b,9,,19,3,3b,2,y,,3a,3,4,2,9,,6,3,63,2,2,,1m,,,7,,,,,2,8,6,a,2,,1c,h,1r,4,1c,7,,,5,,14,9,c,2,w,4,2,2,,3,1k,,,2,3,,,3,1m,8,2,2,48,3,,d,,7,4,,6,,3,2,5i,1m,,5,ek,,5f,x,2da,3,3x,,2o,w,fe,6,2x,2,n9w,4,,a,w,2,28,2,7k,,3,,4,,p,2,5,,47,2,q,i,d,,12,8,p,b,1a,3,1c,,2,4,2,2,13,,1v,6,2,2,2,2,c,,8,,1b,,1f,,,3,2,2,5,2,,,16,2,8,,6m,,2,,4,,fn4,,kh,g,g,g,a6,2,gt,,6a,,45,5,1ae,3,,2,5,4,14,3,4,,4l,2,fx,4,ar,2,49,b,4w,,1i,f,1k,3,1d,4,2,2,1x,3,10,5,,8,1q,,c,2,1g,9,a,4,2,,2n,3,2,,,2,6,,4g,,3,8,l,2,1l,2,,,,,m,,e,7,3,5,5f,8,2,3,,,n,,29,,2,6,,,2,,,2,,2,6j,,2,4,6,2,,2,r,2,2d,8,2,,,2,2y,,,,2,6,,,2t,3,2,4,,5,77,9,,2,6t,,a,2,,,4,,40,4,2,2,4,,w,a,14,6,2,4,8,,9,6,2,3,1a,d,,2,ba,7,,6,,,2a,m,2,7,,2,,2,3e,6,3,,,2,,7,,,20,2,3,,,,9n,2,f0b,5,1n,7,t4,,1r,4,29,,f5k,2,43q,,,3,4,5,8,8,2,7,u,4,44,3,1iz,1j,4,1e,8,,e,,m,5,,f,11s,7,,h,2,7,,2,,5,79,7,c5,4,15s,7,31,7,240,5,gx7k,2o,3k,6o".split(",").map(function(e22) {
  return e22 ? parseInt(e22, 36) : 1;
}), nC = 1; nC < tC.length; nC++)
  tC[nC] += tC[nC - 1];
function rC(e22) {
  for (var t2 = 1; t2 < tC.length; t2 += 2)
    if (tC[t2] > e22)
      return tC[t2 - 1] <= e22;
  return false;
}
function iC(e22) {
  return e22 >= 127462 && e22 <= 127487;
}
function oC(e22, t2) {
  var n2 = !(arguments.length > 2 && arguments[2] !== void 0) || arguments[2], r2 = !(arguments.length > 3 && arguments[3] !== void 0) || arguments[3];
  return (n2 ? aC : sC)(e22, t2, r2);
}
function aC(e22, t2, n2) {
  if (t2 == e22.length)
    return t2;
  t2 && uC(e22.charCodeAt(t2)) && cC(e22.charCodeAt(t2 - 1)) && t2--;
  var r2 = lC(e22, t2);
  for (t2 += hC(r2); t2 < e22.length; ) {
    var i2 = lC(e22, t2);
    if (r2 == 8205 || i2 == 8205 || n2 && rC(i2))
      t2 += hC(i2), r2 = i2;
    else {
      if (!iC(i2))
        break;
      for (var o2 = 0, a2 = t2 - 2; a2 >= 0 && iC(lC(e22, a2)); )
        o2++, a2 -= 2;
      if (o2 % 2 == 0)
        break;
      t2 += 2;
    }
  }
  return t2;
}
function sC(e22, t2, n2) {
  for (; t2 > 0; ) {
    var r2 = aC(e22, t2 - 2, n2);
    if (r2 < t2)
      return r2;
    t2--;
  }
  return 0;
}
function uC(e22) {
  return e22 >= 56320 && e22 < 57344;
}
function cC(e22) {
  return e22 >= 55296 && e22 < 56320;
}
function lC(e22, t2) {
  var n2 = e22.charCodeAt(t2);
  if (!cC(n2) || t2 + 1 == e22.length)
    return n2;
  var r2 = e22.charCodeAt(t2 + 1);
  return uC(r2) ? r2 - 56320 + (n2 - 55296 << 10) + 65536 : n2;
}
function fC(e22) {
  return e22 <= 65535 ? String.fromCharCode(e22) : (e22 -= 65536, String.fromCharCode(55296 + (e22 >> 10), 56320 + (1023 & e22)));
}
function hC(e22) {
  return e22 < 65536 ? 1 : 2;
}
var dC = /\r\n?|\n/, vC = function(e22) {
  return e22[e22.Simple = 0] = "Simple", e22[e22.TrackDel = 1] = "TrackDel", e22[e22.TrackBefore = 2] = "TrackBefore", e22[e22.TrackAfter = 3] = "TrackAfter", e22;
}(vC || (vC = {})), pC = function() {
  function e22(t2) {
    Ri(this, e22), this.sections = t2;
  }
  return zi(e22, [{ key: "length", get: function() {
    for (var e23 = 0, t2 = 0; t2 < this.sections.length; t2 += 2)
      e23 += this.sections[t2];
    return e23;
  } }, { key: "newLength", get: function() {
    for (var e23 = 0, t2 = 0; t2 < this.sections.length; t2 += 2) {
      var n2 = this.sections[t2 + 1];
      e23 += n2 < 0 ? this.sections[t2] : n2;
    }
    return e23;
  } }, { key: "empty", get: function() {
    return this.sections.length == 0 || this.sections.length == 2 && this.sections[1] < 0;
  } }, { key: "iterGaps", value: function(e23) {
    for (var t2 = 0, n2 = 0, r2 = 0; t2 < this.sections.length; ) {
      var i2 = this.sections[t2++], o2 = this.sections[t2++];
      o2 < 0 ? (e23(n2, r2, i2), r2 += i2) : r2 += o2, n2 += i2;
    }
  } }, { key: "iterChangedRanges", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1];
    bC(this, e23, t2);
  } }, { key: "invertedDesc", get: function() {
    for (var t2 = [], n2 = 0; n2 < this.sections.length; ) {
      var r2 = this.sections[n2++], i2 = this.sections[n2++];
      i2 < 0 ? t2.push(r2, i2) : t2.push(i2, r2);
    }
    return new e22(t2);
  } }, { key: "composeDesc", value: function(e23) {
    return this.empty ? e23 : e23.empty ? this : wC(this, e23);
  } }, { key: "mapDesc", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1];
    return e23.empty ? this : kC(this, e23, t2);
  } }, { key: "mapPos", value: function(e23) {
    for (var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : -1, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : vC.Simple, r2 = 0, i2 = 0, o2 = 0; o2 < this.sections.length; ) {
      var a2 = this.sections[o2++], s2 = this.sections[o2++], u2 = r2 + a2;
      if (s2 < 0) {
        if (u2 > e23)
          return i2 + (e23 - r2);
        i2 += a2;
      } else {
        if (n2 != vC.Simple && u2 >= e23 && (n2 == vC.TrackDel && r2 < e23 && u2 > e23 || n2 == vC.TrackBefore && r2 < e23 || n2 == vC.TrackAfter && u2 > e23))
          return null;
        if (u2 > e23 || u2 == e23 && t2 < 0 && !a2)
          return e23 == r2 || t2 < 0 ? i2 : i2 + s2;
        i2 += s2;
      }
      r2 = u2;
    }
    if (e23 > r2)
      throw new RangeError("Position ".concat(e23, " is out of range for changeset of length ").concat(r2));
    return i2;
  } }, { key: "touchesRange", value: function(e23) {
    for (var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23, n2 = 0, r2 = 0; n2 < this.sections.length && r2 <= t2; ) {
      var i2 = this.sections[n2++], o2 = this.sections[n2++], a2 = r2 + i2;
      if (o2 >= 0 && r2 <= t2 && a2 >= e23)
        return !(r2 < e23 && a2 > t2) || "cover";
      r2 = a2;
    }
    return false;
  } }, { key: "toString", value: function() {
    for (var e23 = "", t2 = 0; t2 < this.sections.length; ) {
      var n2 = this.sections[t2++], r2 = this.sections[t2++];
      e23 += (e23 ? " " : "") + n2 + (r2 >= 0 ? ":" + r2 : "");
    }
    return e23;
  } }, { key: "toJSON", value: function() {
    return this.sections;
  } }], [{ key: "fromJSON", value: function(t2) {
    if (!Array.isArray(t2) || t2.length % 2 || t2.some(function(e23) {
      return typeof e23 != "number";
    }))
      throw new RangeError("Invalid JSON representation of ChangeDesc");
    return new e22(t2);
  } }, { key: "create", value: function(t2) {
    return new e22(t2);
  } }]), e22;
}(), mC = function(e22) {
  ji(n2, pC);
  var t2 = Ci(n2);
  function n2(e23, r2) {
    var i2;
    return Ri(this, n2), (i2 = t2.call(this, e23)).inserted = r2, i2;
  }
  return zi(n2, [{ key: "apply", value: function(e23) {
    if (this.length != e23.length)
      throw new RangeError("Applying change set to a document with the wrong length");
    return bC(this, function(t3, n3, r2, i2, o2) {
      return e23 = e23.replace(r2, r2 + (n3 - t3), o2);
    }, false), e23;
  } }, { key: "mapDesc", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1];
    return kC(this, e23, t3, true);
  } }, { key: "invert", value: function(e23) {
    for (var t3 = this.sections.slice(), r2 = [], i2 = 0, o2 = 0; i2 < t3.length; i2 += 2) {
      var a2 = t3[i2], s2 = t3[i2 + 1];
      if (s2 >= 0) {
        t3[i2] = s2, t3[i2 + 1] = a2;
        for (var u2 = i2 >> 1; r2.length < u2; )
          r2.push(WS.empty);
        r2.push(a2 ? e23.slice(o2, o2 + a2) : WS.empty);
      }
      o2 += a2;
    }
    return new n2(t3, r2);
  } }, { key: "compose", value: function(e23) {
    return this.empty ? e23 : e23.empty ? this : wC(this, e23, true);
  } }, { key: "map", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1];
    return e23.empty ? this : kC(this, e23, t3, true);
  } }, { key: "iterChanges", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1];
    bC(this, e23, t3);
  } }, { key: "desc", get: function() {
    return pC.create(this.sections);
  } }, { key: "filter", value: function(e23) {
    var t3 = [], r2 = [], i2 = [], o2 = new xC(this);
    e:
      for (var a2 = 0, s2 = 0; ; ) {
        for (var u2 = a2 == e23.length ? 1e9 : e23[a2++]; s2 < u2 || s2 == u2 && o2.len == 0; ) {
          if (o2.done)
            break e;
          var c2 = Math.min(o2.len, u2 - s2);
          gC(i2, c2, -1);
          var l2 = o2.ins == -1 ? -1 : o2.off == 0 ? o2.ins : 0;
          gC(t3, c2, l2), l2 > 0 && yC(r2, t3, o2.text), o2.forward(c2), s2 += c2;
        }
        for (var f2 = e23[a2++]; s2 < f2; ) {
          if (o2.done)
            break e;
          var h2 = Math.min(o2.len, f2 - s2);
          gC(t3, h2, -1), gC(i2, h2, o2.ins == -1 ? -1 : o2.off == 0 ? o2.ins : 0), o2.forward(h2), s2 += h2;
        }
      }
    return { changes: new n2(t3, r2), filtered: pC.create(i2) };
  } }, { key: "toJSON", value: function() {
    for (var e23 = [], t3 = 0; t3 < this.sections.length; t3 += 2) {
      var n3 = this.sections[t3], r2 = this.sections[t3 + 1];
      r2 < 0 ? e23.push(n3) : r2 == 0 ? e23.push([n3]) : e23.push([n3].concat(this.inserted[t3 >> 1].toJSON()));
    }
    return e23;
  } }], [{ key: "of", value: function(e23, t3, r2) {
    var i2 = [], o2 = [], a2 = 0, s2 = null;
    function u2() {
      var e24 = arguments.length > 0 && arguments[0] !== void 0 && arguments[0];
      if (e24 || i2.length) {
        a2 < t3 && gC(i2, t3 - a2, -1);
        var r3 = new n2(i2, o2);
        s2 = s2 ? s2.compose(r3.map(s2)) : r3, i2 = [], o2 = [], a2 = 0;
      }
    }
    return function e24(c2) {
      if (Array.isArray(c2)) {
        var l2, f2 = bi(c2);
        try {
          for (f2.s(); !(l2 = f2.n()).done; ) {
            e24(l2.value);
          }
        } catch (e25) {
          f2.e(e25);
        } finally {
          f2.f();
        }
      } else if (c2 instanceof n2) {
        if (c2.length != t3)
          throw new RangeError("Mismatched change set length (got ".concat(c2.length, ", expected ").concat(t3, ")"));
        u2(), s2 = s2 ? s2.compose(c2.map(s2)) : c2;
      } else {
        var h2 = c2.from, d2 = c2.to, v2 = d2 === void 0 ? h2 : d2, p2 = c2.insert;
        if (h2 > v2 || h2 < 0 || v2 > t3)
          throw new RangeError("Invalid change range ".concat(h2, " to ").concat(v2, " (in doc of length ").concat(t3, ")"));
        var m2 = p2 ? typeof p2 == "string" ? WS.of(p2.split(r2 || dC)) : p2 : WS.empty, g2 = m2.length;
        if (h2 == v2 && g2 == 0)
          return;
        h2 < a2 && u2(), h2 > a2 && gC(i2, h2 - a2, -1), gC(i2, v2 - h2, g2), yC(o2, i2, m2), a2 = v2;
      }
    }(e23), u2(!s2), s2;
  } }, { key: "empty", value: function(e23) {
    return new n2(e23 ? [e23, -1] : [], []);
  } }, { key: "fromJSON", value: function(e23) {
    if (!Array.isArray(e23))
      throw new RangeError("Invalid JSON representation of ChangeSet");
    for (var t3 = [], r2 = [], i2 = 0; i2 < e23.length; i2++) {
      var o2 = e23[i2];
      if (typeof o2 == "number")
        t3.push(o2, -1);
      else {
        if (!Array.isArray(o2) || typeof o2[0] != "number" || o2.some(function(e24, t4) {
          return t4 && typeof e24 != "string";
        }))
          throw new RangeError("Invalid JSON representation of ChangeSet");
        if (o2.length == 1)
          t3.push(o2[0], 0);
        else {
          for (; r2.length < i2; )
            r2.push(WS.empty);
          r2[i2] = WS.of(o2.slice(1)), t3.push(o2[0], r2[i2].length);
        }
      }
    }
    return new n2(t3, r2);
  } }, { key: "createSet", value: function(e23, t3) {
    return new n2(e23, t3);
  } }]), n2;
}();
function gC(e22, t2, n2) {
  var r2 = arguments.length > 3 && arguments[3] !== void 0 && arguments[3];
  if (!(t2 == 0 && n2 <= 0)) {
    var i2 = e22.length - 2;
    i2 >= 0 && n2 <= 0 && n2 == e22[i2 + 1] ? e22[i2] += t2 : t2 == 0 && e22[i2] == 0 ? e22[i2 + 1] += n2 : r2 ? (e22[i2] += t2, e22[i2 + 1] += n2) : e22.push(t2, n2);
  }
}
function yC(e22, t2, n2) {
  if (n2.length != 0) {
    var r2 = t2.length - 2 >> 1;
    if (r2 < e22.length)
      e22[e22.length - 1] = e22[e22.length - 1].append(n2);
    else {
      for (; e22.length < r2; )
        e22.push(WS.empty);
      e22.push(n2);
    }
  }
}
function bC(e22, t2, n2) {
  for (var r2 = e22.inserted, i2 = 0, o2 = 0, a2 = 0; a2 < e22.sections.length; ) {
    var s2 = e22.sections[a2++], u2 = e22.sections[a2++];
    if (u2 < 0)
      i2 += s2, o2 += s2;
    else {
      for (var c2 = i2, l2 = o2, f2 = WS.empty; c2 += s2, l2 += u2, u2 && r2 && (f2 = f2.append(r2[a2 - 2 >> 1])), !(n2 || a2 == e22.sections.length || e22.sections[a2 + 1] < 0); )
        s2 = e22.sections[a2++], u2 = e22.sections[a2++];
      t2(i2, c2, o2, l2, f2), i2 = c2, o2 = l2;
    }
  }
}
function kC(e22, t2, n2) {
  for (var r2 = arguments.length > 3 && arguments[3] !== void 0 && arguments[3], i2 = [], o2 = r2 ? [] : null, a2 = new xC(e22), s2 = new xC(t2), u2 = -1; ; )
    if (a2.ins == -1 && s2.ins == -1) {
      var c2 = Math.min(a2.len, s2.len);
      gC(i2, c2, -1), a2.forward(c2), s2.forward(c2);
    } else if (s2.ins >= 0 && (a2.ins < 0 || u2 == a2.i || a2.off == 0 && (s2.len < a2.len || s2.len == a2.len && !n2))) {
      var l2 = s2.len;
      for (gC(i2, s2.ins, -1); l2; ) {
        var f2 = Math.min(a2.len, l2);
        a2.ins >= 0 && u2 < a2.i && a2.len <= f2 && (gC(i2, 0, a2.ins), o2 && yC(o2, i2, a2.text), u2 = a2.i), a2.forward(f2), l2 -= f2;
      }
      s2.next();
    } else {
      if (!(a2.ins >= 0)) {
        if (a2.done && s2.done)
          return o2 ? mC.createSet(i2, o2) : pC.create(i2);
        throw new Error("Mismatched change set lengths");
      }
      for (var h2 = 0, d2 = a2.len; d2; )
        if (s2.ins == -1) {
          var v2 = Math.min(d2, s2.len);
          h2 += v2, d2 -= v2, s2.forward(v2);
        } else {
          if (!(s2.ins == 0 && s2.len < d2))
            break;
          d2 -= s2.len, s2.next();
        }
      gC(i2, h2, u2 < a2.i ? a2.ins : 0), o2 && u2 < a2.i && yC(o2, i2, a2.text), u2 = a2.i, a2.forward(a2.len - d2);
    }
}
function wC(e22, t2) {
  for (var n2 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], r2 = [], i2 = n2 ? [] : null, o2 = new xC(e22), a2 = new xC(t2), s2 = false; ; ) {
    if (o2.done && a2.done)
      return i2 ? mC.createSet(r2, i2) : pC.create(r2);
    if (o2.ins == 0)
      gC(r2, o2.len, 0, s2), o2.next();
    else if (a2.len != 0 || a2.done) {
      if (o2.done || a2.done)
        throw new Error("Mismatched change set lengths");
      var u2 = Math.min(o2.len2, a2.len), c2 = r2.length;
      if (o2.ins == -1) {
        var l2 = a2.ins == -1 ? -1 : a2.off ? 0 : a2.ins;
        gC(r2, u2, l2, s2), i2 && l2 && yC(i2, r2, a2.text);
      } else
        a2.ins == -1 ? (gC(r2, o2.off ? 0 : o2.len, u2, s2), i2 && yC(i2, r2, o2.textBit(u2))) : (gC(r2, o2.off ? 0 : o2.len, a2.off ? 0 : a2.ins, s2), i2 && !a2.off && yC(i2, r2, a2.text));
      s2 = (o2.ins > u2 || a2.ins >= 0 && a2.len > u2) && (s2 || r2.length > c2), o2.forward2(u2), a2.forward(u2);
    } else
      gC(r2, 0, a2.ins, s2), i2 && yC(i2, r2, a2.text), a2.next();
  }
}
var xC = function() {
  function e22(t2) {
    Ri(this, e22), this.set = t2, this.i = 0, this.next();
  }
  return zi(e22, [{ key: "next", value: function() {
    var e23 = this.set.sections;
    this.i < e23.length ? (this.len = e23[this.i++], this.ins = e23[this.i++]) : (this.len = 0, this.ins = -2), this.off = 0;
  } }, { key: "done", get: function() {
    return this.ins == -2;
  } }, { key: "len2", get: function() {
    return this.ins < 0 ? this.len : this.ins;
  } }, { key: "text", get: function() {
    var e23 = this.set.inserted, t2 = this.i - 2 >> 1;
    return t2 >= e23.length ? WS.empty : e23[t2];
  } }, { key: "textBit", value: function(e23) {
    var t2 = this.set.inserted, n2 = this.i - 2 >> 1;
    return n2 >= t2.length && !e23 ? WS.empty : t2[n2].slice(this.off, e23 == null ? void 0 : this.off + e23);
  } }, { key: "forward", value: function(e23) {
    e23 == this.len ? this.next() : (this.len -= e23, this.off += e23);
  } }, { key: "forward2", value: function(e23) {
    this.ins == -1 ? this.forward(e23) : e23 == this.ins ? this.next() : (this.ins -= e23, this.off += e23);
  } }]), e22;
}(), jC = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.from = t2, this.to = n2, this.flags = r2;
  }
  return zi(e22, [{ key: "anchor", get: function() {
    return 16 & this.flags ? this.to : this.from;
  } }, { key: "head", get: function() {
    return 16 & this.flags ? this.from : this.to;
  } }, { key: "empty", get: function() {
    return this.from == this.to;
  } }, { key: "assoc", get: function() {
    return 4 & this.flags ? -1 : 8 & this.flags ? 1 : 0;
  } }, { key: "bidiLevel", get: function() {
    var e23 = 3 & this.flags;
    return e23 == 3 ? null : e23;
  } }, { key: "goalColumn", get: function() {
    var e23 = this.flags >> 5;
    return e23 == 33554431 ? void 0 : e23;
  } }, { key: "map", value: function(t2) {
    var n2, r2, i2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : -1;
    return this.empty ? n2 = r2 = t2.mapPos(this.from, i2) : (n2 = t2.mapPos(this.from, 1), r2 = t2.mapPos(this.to, -1)), n2 == this.from && r2 == this.to ? this : new e22(n2, r2, this.flags);
  } }, { key: "extend", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23;
    if (e23 <= this.anchor && t2 >= this.anchor)
      return SC.range(e23, t2);
    var n2 = Math.abs(e23 - this.anchor) > Math.abs(t2 - this.anchor) ? e23 : t2;
    return SC.range(this.anchor, n2);
  } }, { key: "eq", value: function(e23) {
    return this.anchor == e23.anchor && this.head == e23.head;
  } }, { key: "toJSON", value: function() {
    return { anchor: this.anchor, head: this.head };
  } }], [{ key: "fromJSON", value: function(e23) {
    if (!e23 || typeof e23.anchor != "number" || typeof e23.head != "number")
      throw new RangeError("Invalid JSON representation for SelectionRange");
    return SC.range(e23.anchor, e23.head);
  } }, { key: "create", value: function(t2, n2, r2) {
    return new e22(t2, n2, r2);
  } }]), e22;
}(), SC = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.ranges = t2, this.mainIndex = n2;
  }
  return zi(e22, [{ key: "map", value: function(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : -1;
    return t2.empty ? this : e22.create(this.ranges.map(function(e23) {
      return e23.map(t2, n2);
    }), this.mainIndex);
  } }, { key: "eq", value: function(e23) {
    if (this.ranges.length != e23.ranges.length || this.mainIndex != e23.mainIndex)
      return false;
    for (var t2 = 0; t2 < this.ranges.length; t2++)
      if (!this.ranges[t2].eq(e23.ranges[t2]))
        return false;
    return true;
  } }, { key: "main", get: function() {
    return this.ranges[this.mainIndex];
  } }, { key: "asSingle", value: function() {
    return this.ranges.length == 1 ? this : new e22([this.main], 0);
  } }, { key: "addRange", value: function(t2) {
    var n2 = !(arguments.length > 1 && arguments[1] !== void 0) || arguments[1];
    return e22.create([t2].concat(this.ranges), n2 ? 0 : this.mainIndex + 1);
  } }, { key: "replaceRange", value: function(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.mainIndex, r2 = this.ranges.slice();
    return r2[n2] = t2, e22.create(r2, this.mainIndex);
  } }, { key: "toJSON", value: function() {
    return { ranges: this.ranges.map(function(e23) {
      return e23.toJSON();
    }), main: this.mainIndex };
  } }], [{ key: "fromJSON", value: function(t2) {
    if (!t2 || !Array.isArray(t2.ranges) || typeof t2.main != "number" || t2.main >= t2.ranges.length)
      throw new RangeError("Invalid JSON representation for EditorSelection");
    return new e22(t2.ranges.map(function(e23) {
      return jC.fromJSON(e23);
    }), t2.main);
  } }, { key: "single", value: function(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : t2;
    return new e22([e22.range(t2, n2)], 0);
  } }, { key: "create", value: function(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    if (t2.length == 0)
      throw new RangeError("A selection needs at least one range");
    for (var r2 = 0, i2 = 0; i2 < t2.length; i2++) {
      var o2 = t2[i2];
      if (o2.empty ? o2.from <= r2 : o2.from < r2)
        return e22.normalized(t2.slice(), n2);
      r2 = o2.to;
    }
    return new e22(t2, n2);
  } }, { key: "cursor", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = arguments.length > 2 ? arguments[2] : void 0, r2 = arguments.length > 3 ? arguments[3] : void 0;
    return jC.create(e23, e23, (t2 == 0 ? 0 : t2 < 0 ? 4 : 8) | (n2 == null ? 3 : Math.min(2, n2)) | (r2 != null ? r2 : 33554431) << 5);
  } }, { key: "range", value: function(e23, t2, n2) {
    var r2 = (n2 != null ? n2 : 33554431) << 5;
    return t2 < e23 ? jC.create(t2, e23, 24 | r2) : jC.create(e23, t2, r2 | (t2 > e23 ? 4 : 0));
  } }, { key: "normalized", value: function(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, r2 = t2[n2];
    t2.sort(function(e23, t3) {
      return e23.from - t3.from;
    }), n2 = t2.indexOf(r2);
    for (var i2 = 1; i2 < t2.length; i2++) {
      var o2 = t2[i2], a2 = t2[i2 - 1];
      if (o2.empty ? o2.from <= a2.to : o2.from < a2.to) {
        var s2 = a2.from, u2 = Math.max(o2.to, a2.to);
        i2 <= n2 && n2--, t2.splice(--i2, 2, o2.anchor > o2.head ? e22.range(u2, s2) : e22.range(s2, u2));
      }
    }
    return new e22(t2, n2);
  } }]), e22;
}();
function CC(e22, t2) {
  var n2, r2 = bi(e22.ranges);
  try {
    for (r2.s(); !(n2 = r2.n()).done; ) {
      if (n2.value.to > t2)
        throw new RangeError("Selection points outside of document");
    }
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
}
var _C = 0, $C = function() {
  function e22(t2, n2, r2, i2, o2) {
    Ri(this, e22), this.combine = t2, this.compareInput = n2, this.compare = r2, this.isStatic = i2, this.id = _C++, this.default = t2([]), this.extensions = typeof o2 == "function" ? o2(this) : o2;
  }
  return zi(e22, [{ key: "of", value: function(e23) {
    return new AC([], this, 0, e23);
  } }, { key: "compute", value: function(e23, t2) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new AC(e23, this, 1, t2);
  } }, { key: "computeN", value: function(e23, t2) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new AC(e23, this, 2, t2);
  } }, { key: "from", value: function(e23, t2) {
    return t2 || (t2 = function(e24) {
      return e24;
    }), this.compute([e23], function(n2) {
      return t2(n2.field(e23));
    });
  } }], [{ key: "define", value: function() {
    var t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return new e22(t2.combine || function(e23) {
      return e23;
    }, t2.compareInput || function(e23, t3) {
      return e23 === t3;
    }, t2.compare || (t2.combine ? function(e23, t3) {
      return e23 === t3;
    } : OC), !!t2.static, t2.enables);
  } }]), e22;
}();
function OC(e22, t2) {
  return e22 == t2 || e22.length == t2.length && e22.every(function(e23, n2) {
    return e23 === t2[n2];
  });
}
var AC = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.dependencies = t2, this.facet = n2, this.type = r2, this.value = i2, this.id = _C++;
  }
  return zi(e22, [{ key: "dynamicSlot", value: function(e23) {
    var t2, n2, r2 = this, i2 = this.value, o2 = this.facet.compareInput, a2 = this.id, s2 = e23[a2] >> 1, u2 = this.type == 2, c2 = false, l2 = false, f2 = [], h2 = bi(this.dependencies);
    try {
      for (h2.s(); !(n2 = h2.n()).done; ) {
        var d2 = n2.value;
        d2 == "doc" ? c2 = true : d2 == "selection" ? l2 = true : (1 & ((t2 = e23[d2.id]) !== null && t2 !== void 0 ? t2 : 1)) == 0 && f2.push(e23[d2.id]);
      }
    } catch (e24) {
      h2.e(e24);
    } finally {
      h2.f();
    }
    return { create: function(e24) {
      return e24.values[s2] = i2(e24), 1;
    }, update: function(e24, t3) {
      if (c2 && t3.docChanged || l2 && (t3.docChanged || t3.selection) || EC(e24, f2)) {
        var n3 = i2(e24);
        if (u2 ? !MC(n3, e24.values[s2], o2) : !o2(n3, e24.values[s2]))
          return e24.values[s2] = n3, 1;
      }
      return 0;
    }, reconfigure: function(e24, t3) {
      var n3 = i2(e24), c3 = t3.config.address[a2];
      if (c3 != null) {
        var l3 = WC(t3, c3);
        if (r2.dependencies.every(function(n4) {
          return n4 instanceof $C ? t3.facet(n4) === e24.facet(n4) : !(n4 instanceof NC) || t3.field(n4, false) == e24.field(n4, false);
        }) || (u2 ? MC(n3, l3, o2) : o2(n3, l3)))
          return e24.values[s2] = l3, 0;
      }
      return e24.values[s2] = n3, 1;
    } };
  } }]), e22;
}();
function MC(e22, t2, n2) {
  if (e22.length != t2.length)
    return false;
  for (var r2 = 0; r2 < e22.length; r2++)
    if (!n2(e22[r2], t2[r2]))
      return false;
  return true;
}
function EC(e22, t2) {
  var n2, r2 = false, i2 = bi(t2);
  try {
    for (i2.s(); !(n2 = i2.n()).done; ) {
      1 & HC(e22, n2.value) && (r2 = true);
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  return r2;
}
var PC = $C.define({ static: true }), NC = function() {
  function e22(t2, n2, r2, i2, o2) {
    Ri(this, e22), this.id = t2, this.createF = n2, this.updateF = r2, this.compareF = i2, this.spec = o2, this.provides = void 0;
  }
  return zi(e22, [{ key: "create", value: function(e23) {
    var t2 = this, n2 = e23.facet(PC).find(function(e24) {
      return e24.field == t2;
    });
    return ((n2 == null ? void 0 : n2.create) || this.createF)(e23);
  } }, { key: "slot", value: function(e23) {
    var t2 = this, n2 = e23[this.id] >> 1;
    return { create: function(e24) {
      return e24.values[n2] = t2.create(e24), 1;
    }, update: function(e24, r2) {
      var i2 = e24.values[n2], o2 = t2.updateF(i2, r2);
      return t2.compareF(i2, o2) ? 0 : (e24.values[n2] = o2, 1);
    }, reconfigure: function(e24, r2) {
      return r2.config.address[t2.id] != null ? (e24.values[n2] = r2.field(t2), 0) : (e24.values[n2] = t2.create(e24), 1);
    } };
  } }, { key: "init", value: function(e23) {
    return [this, PC.of({ field: this, create: e23 })];
  } }, { key: "extension", get: function() {
    return this;
  } }], [{ key: "define", value: function(t2) {
    var n2 = new e22(_C++, t2.create, t2.update, t2.compare || function(e23, t3) {
      return e23 === t3;
    }, t2);
    return t2.provide && (n2.provides = t2.provide(n2)), n2;
  } }]), e22;
}(), TC = 4, IC = 3, RC = 2, DC = 1;
function zC(e22) {
  return function(t2) {
    return new BC(t2, e22);
  };
}
var LC = { highest: zC(0), high: zC(DC), default: zC(RC), low: zC(IC), lowest: zC(TC) }, BC = zi(function e2(t2, n2) {
  Ri(this, e2), this.inner = t2, this.prec = n2;
}), qC = function() {
  function e22() {
    Ri(this, e22);
  }
  return zi(e22, [{ key: "of", value: function(e23) {
    return new FC(this, e23);
  } }, { key: "reconfigure", value: function(t2) {
    return e22.reconfigure.of({ compartment: this, extension: t2 });
  } }, { key: "get", value: function(e23) {
    return e23.config.compartments.get(this);
  } }]), e22;
}(), FC = zi(function e3(t2, n2) {
  Ri(this, e3), this.compartment = t2, this.inner = n2;
}), VC = function() {
  function e22(t2, n2, r2, i2, o2, a2) {
    for (Ri(this, e22), this.base = t2, this.compartments = n2, this.dynamicSlots = r2, this.address = i2, this.staticValues = o2, this.facets = a2, this.statusTemplate = []; this.statusTemplate.length < r2.length; )
      this.statusTemplate.push(0);
  }
  return zi(e22, [{ key: "staticFacet", value: function(e23) {
    var t2 = this.address[e23.id];
    return t2 == null ? e23.default : this.staticValues[t2 >> 1];
  } }], [{ key: "resolve", value: function(t2, n2, r2) {
    var i2, o2 = [], a2 = /* @__PURE__ */ Object.create(null), s2 = /* @__PURE__ */ new Map(), u2 = bi(function(e23, t3, n3) {
      var r3 = [[], [], [], [], []], i3 = /* @__PURE__ */ new Map();
      function o3(e24, a3) {
        var s3 = i3.get(e24);
        if (s3 != null) {
          if (s3 <= a3)
            return;
          var u3 = r3[s3].indexOf(e24);
          u3 > -1 && r3[s3].splice(u3, 1), e24 instanceof FC && n3.delete(e24.compartment);
        }
        if (i3.set(e24, a3), Array.isArray(e24)) {
          var c3, l3 = bi(e24);
          try {
            for (l3.s(); !(c3 = l3.n()).done; ) {
              o3(c3.value, a3);
            }
          } catch (e25) {
            l3.e(e25);
          } finally {
            l3.f();
          }
        } else if (e24 instanceof FC) {
          if (n3.has(e24.compartment))
            throw new RangeError("Duplicate use of compartment in extensions");
          var f3 = t3.get(e24.compartment) || e24.inner;
          n3.set(e24.compartment, f3), o3(f3, a3);
        } else if (e24 instanceof BC)
          o3(e24.inner, e24.prec);
        else if (e24 instanceof NC)
          r3[a3].push(e24), e24.provides && o3(e24.provides, a3);
        else if (e24 instanceof AC)
          r3[a3].push(e24), e24.facet.extensions && o3(e24.facet.extensions, a3);
        else {
          var h3 = e24.extension;
          if (!h3)
            throw new Error("Unrecognized extension value in extension set (".concat(e24, "). This sometimes happens because multiple instances of @codemirror/state are loaded, breaking instanceof checks."));
          o3(h3, a3);
        }
      }
      return o3(e23, RC), r3.reduce(function(e24, t4) {
        return e24.concat(t4);
      });
    }(t2, n2, s2));
    try {
      for (u2.s(); !(i2 = u2.n()).done; ) {
        var c2 = i2.value;
        c2 instanceof NC ? o2.push(c2) : (a2[c2.facet.id] || (a2[c2.facet.id] = [])).push(c2);
      }
    } catch (e23) {
      u2.e(e23);
    } finally {
      u2.f();
    }
    for (var l2 = /* @__PURE__ */ Object.create(null), f2 = [], h2 = [], d2 = function() {
      var e23 = p2[v2];
      l2[e23.id] = h2.length << 1, h2.push(function(t3) {
        return e23.slot(t3);
      });
    }, v2 = 0, p2 = o2; v2 < p2.length; v2++)
      d2();
    var m2 = r2 == null ? void 0 : r2.config.facets, g2 = function(e23) {
      var t3 = a2[e23], n3 = t3[0].facet, i3 = m2 && m2[e23] || [];
      if (t3.every(function(e24) {
        return e24.type == 0;
      }))
        if (l2[n3.id] = f2.length << 1 | 1, OC(i3, t3))
          f2.push(r2.facet(n3));
        else {
          var o3 = n3.combine(t3.map(function(e24) {
            return e24.value;
          }));
          f2.push(r2 && n3.compare(o3, r2.facet(n3)) ? r2.facet(n3) : o3);
        }
      else {
        var s3, u3 = bi(t3);
        try {
          var c3 = function() {
            var e24 = s3.value;
            e24.type == 0 ? (l2[e24.id] = f2.length << 1 | 1, f2.push(e24.value)) : (l2[e24.id] = h2.length << 1, h2.push(function(t4) {
              return e24.dynamicSlot(t4);
            }));
          };
          for (u3.s(); !(s3 = u3.n()).done; )
            c3();
        } catch (e24) {
          u3.e(e24);
        } finally {
          u3.f();
        }
        l2[n3.id] = h2.length << 1, h2.push(function(e24) {
          return function(e25, t4, n4) {
            var r3 = n4.map(function(t5) {
              return e25[t5.id];
            }), i4 = n4.map(function(e26) {
              return e26.type;
            }), o4 = r3.filter(function(e26) {
              return !(1 & e26);
            }), a3 = e25[t4.id] >> 1;
            function s4(e26) {
              for (var n5 = [], o5 = 0; o5 < r3.length; o5++) {
                var a4 = WC(e26, r3[o5]);
                if (i4[o5] == 2) {
                  var s5, u4 = bi(a4);
                  try {
                    for (u4.s(); !(s5 = u4.n()).done; ) {
                      var c4 = s5.value;
                      n5.push(c4);
                    }
                  } catch (e27) {
                    u4.e(e27);
                  } finally {
                    u4.f();
                  }
                } else
                  n5.push(a4);
              }
              return t4.combine(n5);
            }
            return { create: function(e26) {
              var t5, n5 = bi(r3);
              try {
                for (n5.s(); !(t5 = n5.n()).done; )
                  HC(e26, t5.value);
              } catch (e27) {
                n5.e(e27);
              } finally {
                n5.f();
              }
              return e26.values[a3] = s4(e26), 1;
            }, update: function(e26, n5) {
              if (!EC(e26, o4))
                return 0;
              var r4 = s4(e26);
              return t4.compare(r4, e26.values[a3]) ? 0 : (e26.values[a3] = r4, 1);
            }, reconfigure: function(e26, i5) {
              var o5 = EC(e26, r3), u4 = i5.config.facets[t4.id], c4 = i5.facet(t4);
              if (u4 && !o5 && OC(n4, u4))
                return e26.values[a3] = c4, 0;
              var l3 = s4(e26);
              return t4.compare(l3, c4) ? (e26.values[a3] = c4, 0) : (e26.values[a3] = l3, 1);
            } };
          }(e24, n3, t3);
        });
      }
    };
    for (var y2 in a2)
      g2(y2);
    return new e22(t2, s2, h2.map(function(e23) {
      return e23(l2);
    }), l2, f2, a2);
  } }]), e22;
}();
function HC(e22, t2) {
  if (1 & t2)
    return 2;
  var n2 = t2 >> 1, r2 = e22.status[n2];
  if (r2 == 4)
    throw new Error("Cyclic dependency between fields and/or facets");
  if (2 & r2)
    return r2;
  e22.status[n2] = 4;
  var i2 = e22.computeSlot(e22, e22.config.dynamicSlots[n2]);
  return e22.status[n2] = 2 | i2;
}
function WC(e22, t2) {
  return 1 & t2 ? e22.config.staticValues[t2 >> 1] : e22.values[t2 >> 1];
}
var JC = $C.define(), UC = $C.define({ combine: function(e22) {
  return e22.some(function(e23) {
    return e23;
  });
}, static: true }), KC = $C.define({ combine: function(e22) {
  return e22.length ? e22[0] : void 0;
}, static: true }), GC = $C.define(), QC = $C.define(), YC = $C.define(), ZC = $C.define({ combine: function(e22) {
  return !!e22.length && e22[0];
} }), XC = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.type = t2, this.value = n2;
  }
  return zi(e22, null, [{ key: "define", value: function() {
    return new e_();
  } }]), e22;
}(), e_ = function() {
  function e22() {
    Ri(this, e22);
  }
  return zi(e22, [{ key: "of", value: function(e23) {
    return new XC(this, e23);
  } }]), e22;
}(), t_ = function() {
  function e22(t2) {
    Ri(this, e22), this.map = t2;
  }
  return zi(e22, [{ key: "of", value: function(e23) {
    return new n_(this, e23);
  } }]), e22;
}(), n_ = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.type = t2, this.value = n2;
  }
  return zi(e22, [{ key: "map", value: function(t2) {
    var n2 = this.type.map(this.value, t2);
    return n2 === void 0 ? void 0 : n2 == this.value ? this : new e22(this.type, n2);
  } }, { key: "is", value: function(e23) {
    return this.type == e23;
  } }], [{ key: "define", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return new t_(e23.map || function(e24) {
      return e24;
    });
  } }, { key: "mapEffects", value: function(e23, t2) {
    if (!e23.length)
      return e23;
    var n2, r2 = [], i2 = bi(e23);
    try {
      for (i2.s(); !(n2 = i2.n()).done; ) {
        var o2 = n2.value.map(t2);
        o2 && r2.push(o2);
      }
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    return r2;
  } }]), e22;
}();
n_.reconfigure = n_.define(), n_.appendConfig = n_.define();
var r_ = function() {
  function e22(t2, n2, r2, i2, o2, a2) {
    Ri(this, e22), this.startState = t2, this.changes = n2, this.selection = r2, this.effects = i2, this.annotations = o2, this.scrollIntoView = a2, this._doc = null, this._state = null, r2 && CC(r2, n2.newLength), o2.some(function(t3) {
      return t3.type == e22.time;
    }) || (this.annotations = o2.concat(e22.time.of(Date.now())));
  }
  return zi(e22, [{ key: "newDoc", get: function() {
    return this._doc || (this._doc = this.changes.apply(this.startState.doc));
  } }, { key: "newSelection", get: function() {
    return this.selection || this.startState.selection.map(this.changes);
  } }, { key: "state", get: function() {
    return this._state || this.startState.applyTransaction(this), this._state;
  } }, { key: "annotation", value: function(e23) {
    var t2, n2 = bi(this.annotations);
    try {
      for (n2.s(); !(t2 = n2.n()).done; ) {
        var r2 = t2.value;
        if (r2.type == e23)
          return r2.value;
      }
    } catch (e24) {
      n2.e(e24);
    } finally {
      n2.f();
    }
  } }, { key: "docChanged", get: function() {
    return !this.changes.empty;
  } }, { key: "reconfigured", get: function() {
    return this.startState.config != this.state.config;
  } }, { key: "isUserEvent", value: function(t2) {
    var n2 = this.annotation(e22.userEvent);
    return !(!n2 || !(n2 == t2 || n2.length > t2.length && n2.slice(0, t2.length) == t2 && n2[t2.length] == "."));
  } }], [{ key: "create", value: function(t2, n2, r2, i2, o2, a2) {
    return new e22(t2, n2, r2, i2, o2, a2);
  } }]), e22;
}();
function i_(e22, t2) {
  for (var n2 = [], r2 = 0, i2 = 0; ; ) {
    var o2 = void 0, a2 = void 0;
    if (r2 < e22.length && (i2 == t2.length || t2[i2] >= e22[r2]))
      o2 = e22[r2++], a2 = e22[r2++];
    else {
      if (!(i2 < t2.length))
        return n2;
      o2 = t2[i2++], a2 = t2[i2++];
    }
    !n2.length || n2[n2.length - 1] < o2 ? n2.push(o2, a2) : n2[n2.length - 1] < a2 && (n2[n2.length - 1] = a2);
  }
}
function o_(e22, t2, n2) {
  var r2, i2, o2, a2;
  return n2 ? (i2 = t2.changes, o2 = mC.empty(t2.changes.length), a2 = e22.changes.compose(t2.changes)) : (i2 = t2.changes.map(e22.changes), o2 = e22.changes.mapDesc(t2.changes, true), a2 = e22.changes.compose(i2)), { changes: a2, selection: t2.selection ? t2.selection.map(o2) : (r2 = e22.selection) === null || r2 === void 0 ? void 0 : r2.map(i2), effects: n_.mapEffects(e22.effects, i2).concat(n_.mapEffects(t2.effects, o2)), annotations: e22.annotations.length ? e22.annotations.concat(t2.annotations) : t2.annotations, scrollIntoView: e22.scrollIntoView || t2.scrollIntoView };
}
function a_(e22, t2, n2) {
  var r2 = t2.selection, i2 = c_(t2.annotations);
  return t2.userEvent && (i2 = i2.concat(r_.userEvent.of(t2.userEvent))), { changes: t2.changes instanceof mC ? t2.changes : mC.of(t2.changes || [], n2, e22.facet(KC)), selection: r2 && (r2 instanceof SC ? r2 : SC.single(r2.anchor, r2.head)), effects: c_(t2.effects), annotations: i2, scrollIntoView: !!t2.scrollIntoView };
}
function s_(e22, t2, n2) {
  var r2 = a_(e22, t2.length ? t2[0] : {}, e22.doc.length);
  t2.length && t2[0].filter === false && (n2 = false);
  for (var i2 = 1; i2 < t2.length; i2++) {
    t2[i2].filter === false && (n2 = false);
    var o2 = !!t2[i2].sequential;
    r2 = o_(r2, a_(e22, t2[i2], o2 ? r2.changes.newLength : e22.doc.length), o2);
  }
  var a2 = r_.create(e22, r2.changes, r2.selection, r2.effects, r2.annotations, r2.scrollIntoView);
  return function(e23) {
    for (var t3 = e23.startState, n3 = t3.facet(YC), r3 = e23, i3 = n3.length - 1; i3 >= 0; i3--) {
      var o3 = n3[i3](e23);
      o3 && Object.keys(o3).length && (r3 = o_(e23, a_(t3, o3, e23.changes.newLength), true));
    }
    return r3 == e23 ? e23 : r_.create(t3, e23.changes, e23.selection, r3.effects, r3.annotations, r3.scrollIntoView);
  }(n2 ? function(e23) {
    var t3, n3 = e23.startState, r3 = true, i3 = bi(n3.facet(GC));
    try {
      for (i3.s(); !(t3 = i3.n()).done; ) {
        var o3 = (0, t3.value)(e23);
        if (o3 === false) {
          r3 = false;
          break;
        }
        Array.isArray(o3) && (r3 = r3 === true ? o3 : i_(r3, o3));
      }
    } catch (e24) {
      i3.e(e24);
    } finally {
      i3.f();
    }
    if (r3 !== true) {
      var a3, s2;
      if (r3 === false)
        s2 = e23.changes.invertedDesc, a3 = mC.empty(n3.doc.length);
      else {
        var u2 = e23.changes.filter(r3);
        a3 = u2.changes, s2 = u2.filtered.mapDesc(u2.changes).invertedDesc;
      }
      e23 = r_.create(n3, a3, e23.selection && e23.selection.map(s2), n_.mapEffects(e23.effects, s2), e23.annotations, e23.scrollIntoView);
    }
    for (var c2 = n3.facet(QC), l2 = c2.length - 1; l2 >= 0; l2--) {
      var f2 = c2[l2](e23);
      e23 = f2 instanceof r_ ? f2 : Array.isArray(f2) && f2.length == 1 && f2[0] instanceof r_ ? f2[0] : s_(n3, c_(f2), false);
    }
    return e23;
  }(a2) : a2);
}
r_.time = XC.define(), r_.userEvent = XC.define(), r_.addToHistory = XC.define(), r_.remote = XC.define();
var u_ = [];
function c_(e22) {
  return e22 == null ? u_ : Array.isArray(e22) ? e22 : [e22];
}
var l_, f_ = function(e22) {
  return e22[e22.Word = 0] = "Word", e22[e22.Space = 1] = "Space", e22[e22.Other = 2] = "Other", e22;
}(f_ || (f_ = {})), h_ = /[\u00df\u0587\u0590-\u05f4\u0600-\u06ff\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/;
try {
  l_ = new RegExp("[\\p{Alphabetic}\\p{Number}_]", "u");
} catch (Dw) {
}
function d_(e22) {
  return function(t2) {
    if (!/\S/.test(t2))
      return f_.Space;
    if (function(e23) {
      if (l_)
        return l_.test(e23);
      for (var t3 = 0; t3 < e23.length; t3++) {
        var n3 = e23[t3];
        if (/\w/.test(n3) || n3 > "\x80" && (n3.toUpperCase() != n3.toLowerCase() || h_.test(n3)))
          return true;
      }
      return false;
    }(t2))
      return f_.Word;
    for (var n2 = 0; n2 < e22.length; n2++)
      if (t2.indexOf(e22[n2]) > -1)
        return f_.Word;
    return f_.Other;
  };
}
var v_ = function() {
  function e22(t2, n2, r2, i2, o2, a2) {
    Ri(this, e22), this.config = t2, this.doc = n2, this.selection = r2, this.values = i2, this.status = t2.statusTemplate.slice(), this.computeSlot = o2, a2 && (a2._state = this);
    for (var s2 = 0; s2 < this.config.dynamicSlots.length; s2++)
      HC(this, s2 << 1);
    this.computeSlot = null;
  }
  return zi(e22, [{ key: "field", value: function(e23) {
    var t2 = !(arguments.length > 1 && arguments[1] !== void 0) || arguments[1], n2 = this.config.address[e23.id];
    if (n2 != null)
      return HC(this, n2), WC(this, n2);
    if (t2)
      throw new RangeError("Field is not present in this state");
  } }, { key: "update", value: function() {
    for (var e23 = arguments.length, t2 = new Array(e23), n2 = 0; n2 < e23; n2++)
      t2[n2] = arguments[n2];
    return s_(this, t2, true);
  } }, { key: "applyTransaction", value: function(t2) {
    var n2, r2, i2 = this, o2 = this.config, a2 = o2, s2 = a2.base, u2 = a2.compartments, c2 = bi(t2.effects);
    try {
      for (c2.s(); !(n2 = c2.n()).done; ) {
        var l2 = n2.value;
        l2.is(qC.reconfigure) ? (o2 && (u2 = /* @__PURE__ */ new Map(), o2.compartments.forEach(function(e23, t3) {
          return u2.set(t3, e23);
        }), o2 = null), u2.set(l2.value.compartment, l2.value.extension)) : l2.is(n_.reconfigure) ? (o2 = null, s2 = l2.value) : l2.is(n_.appendConfig) && (o2 = null, s2 = c_(s2).concat(l2.value));
      }
    } catch (e23) {
      c2.e(e23);
    } finally {
      c2.f();
    }
    o2 ? r2 = t2.startState.values.slice() : r2 = new e22(o2 = VC.resolve(s2, u2, this), this.doc, this.selection, o2.dynamicSlots.map(function() {
      return null;
    }), function(e23, t3) {
      return t3.reconfigure(e23, i2);
    }, null).values;
    new e22(o2, t2.newDoc, t2.newSelection, r2, function(e23, n3) {
      return n3.update(e23, t2);
    }, t2);
  } }, { key: "replaceSelection", value: function(e23) {
    return typeof e23 == "string" && (e23 = this.toText(e23)), this.changeByRange(function(t2) {
      return { changes: { from: t2.from, to: t2.to, insert: e23 }, range: SC.cursor(t2.from + e23.length) };
    });
  } }, { key: "changeByRange", value: function(e23) {
    for (var t2 = this.selection, n2 = e23(t2.ranges[0]), r2 = this.changes(n2.changes), i2 = [n2.range], o2 = c_(n2.effects), a2 = 1; a2 < t2.ranges.length; a2++) {
      for (var s2 = e23(t2.ranges[a2]), u2 = this.changes(s2.changes), c2 = u2.map(r2), l2 = 0; l2 < a2; l2++)
        i2[l2] = i2[l2].map(c2);
      var f2 = r2.mapDesc(u2, true);
      i2.push(s2.range.map(f2)), r2 = r2.compose(c2), o2 = n_.mapEffects(o2, c2).concat(n_.mapEffects(c_(s2.effects), f2));
    }
    return { changes: r2, selection: SC.create(i2, t2.mainIndex), effects: o2 };
  } }, { key: "changes", value: function() {
    var t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
    return t2 instanceof mC ? t2 : mC.of(t2, this.doc.length, this.facet(e22.lineSeparator));
  } }, { key: "toText", value: function(t2) {
    return WS.of(t2.split(this.facet(e22.lineSeparator) || dC));
  } }, { key: "sliceDoc", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0, t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.doc.length;
    return this.doc.sliceString(e23, t2, this.lineBreak);
  } }, { key: "facet", value: function(e23) {
    var t2 = this.config.address[e23.id];
    return t2 == null ? e23.default : (HC(this, t2), WC(this, t2));
  } }, { key: "toJSON", value: function(e23) {
    var t2 = { doc: this.sliceDoc(), selection: this.selection.toJSON() };
    if (e23)
      for (var n2 in e23) {
        var r2 = e23[n2];
        r2 instanceof NC && this.config.address[r2.id] != null && (t2[n2] = r2.spec.toJSON(this.field(e23[n2]), this));
      }
    return t2;
  } }, { key: "tabSize", get: function() {
    return this.facet(e22.tabSize);
  } }, { key: "lineBreak", get: function() {
    return this.facet(e22.lineSeparator) || "\n";
  } }, { key: "readOnly", get: function() {
    return this.facet(ZC);
  } }, { key: "phrase", value: function(t2) {
    for (var n2 = arguments.length, r2 = new Array(n2 > 1 ? n2 - 1 : 0), i2 = 1; i2 < n2; i2++)
      r2[i2 - 1] = arguments[i2];
    var o2, a2 = bi(this.facet(e22.phrases));
    try {
      for (a2.s(); !(o2 = a2.n()).done; ) {
        var s2 = o2.value;
        if (Object.prototype.hasOwnProperty.call(s2, t2)) {
          t2 = s2[t2];
          break;
        }
      }
    } catch (e23) {
      a2.e(e23);
    } finally {
      a2.f();
    }
    return r2.length && (t2 = t2.replace(/\$(\$|\d*)/g, function(e23, t3) {
      if (t3 == "$")
        return "$";
      var n3 = +(t3 || 1);
      return !n3 || n3 > r2.length ? e23 : r2[n3 - 1];
    })), t2;
  } }, { key: "languageDataAt", value: function(e23, t2) {
    var n2, r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : -1, i2 = [], o2 = bi(this.facet(JC));
    try {
      for (o2.s(); !(n2 = o2.n()).done; ) {
        var a2, s2 = n2.value, u2 = bi(s2(this, t2, r2));
        try {
          for (u2.s(); !(a2 = u2.n()).done; ) {
            var c2 = a2.value;
            Object.prototype.hasOwnProperty.call(c2, e23) && i2.push(c2[e23]);
          }
        } catch (e24) {
          u2.e(e24);
        } finally {
          u2.f();
        }
      }
    } catch (e24) {
      o2.e(e24);
    } finally {
      o2.f();
    }
    return i2;
  } }, { key: "charCategorizer", value: function(e23) {
    return d_(this.languageDataAt("wordChars", e23).join(""));
  } }, { key: "wordAt", value: function(e23) {
    for (var t2 = this.doc.lineAt(e23), n2 = t2.text, r2 = t2.from, i2 = t2.length, o2 = this.charCategorizer(e23), a2 = e23 - r2, s2 = e23 - r2; a2 > 0; ) {
      var u2 = oC(n2, a2, false);
      if (o2(n2.slice(u2, a2)) != f_.Word)
        break;
      a2 = u2;
    }
    for (; s2 < i2; ) {
      var c2 = oC(n2, s2);
      if (o2(n2.slice(s2, c2)) != f_.Word)
        break;
      s2 = c2;
    }
    return a2 == s2 ? null : SC.range(a2 + r2, s2 + r2);
  } }], [{ key: "fromJSON", value: function(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r2 = arguments.length > 2 ? arguments[2] : void 0;
    if (!t2 || typeof t2.doc != "string")
      throw new RangeError("Invalid JSON representation for EditorState");
    var i2 = [];
    if (r2)
      for (var o2 in r2)
        Object.prototype.hasOwnProperty.call(t2, o2) && function() {
          var e23 = r2[o2], n3 = t2[o2];
          i2.push(e23.init(function(t3) {
            return e23.spec.fromJSON(n3, t3);
          }));
        }();
    return e22.create({ doc: t2.doc, selection: SC.fromJSON(t2.selection), extensions: n2.extensions ? i2.concat([n2.extensions]) : i2 });
  } }, { key: "create", value: function() {
    var t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, n2 = VC.resolve(t2.extensions || [], /* @__PURE__ */ new Map()), r2 = t2.doc instanceof WS ? t2.doc : WS.of((t2.doc || "").split(n2.staticFacet(e22.lineSeparator) || dC)), i2 = t2.selection ? t2.selection instanceof SC ? t2.selection : SC.single(t2.selection.anchor, t2.selection.head) : SC.single(0);
    return CC(i2, r2.length), n2.staticFacet(UC) || (i2 = i2.asSingle()), new e22(n2, r2, i2, n2.dynamicSlots.map(function() {
      return null;
    }), function(e23, t3) {
      return t3.create(e23);
    }, null);
  } }]), e22;
}();
function p_(e22, t2) {
  var n2, r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, i2 = {}, o2 = bi(e22);
  try {
    for (o2.s(); !(n2 = o2.n()).done; )
      for (var a2 = n2.value, s2 = 0, u2 = Object.keys(a2); s2 < u2.length; s2++) {
        var c2 = u2[s2], l2 = a2[c2], f2 = i2[c2];
        if (f2 === void 0)
          i2[c2] = l2;
        else if (f2 === l2 || l2 === void 0)
          ;
        else {
          if (!Object.hasOwnProperty.call(r2, c2))
            throw new Error("Config merge conflict for field " + c2);
          i2[c2] = r2[c2](f2, l2);
        }
      }
  } catch (e23) {
    o2.e(e23);
  } finally {
    o2.f();
  }
  for (var h2 in t2)
    i2[h2] === void 0 && (i2[h2] = t2[h2]);
  return i2;
}
v_.allowMultipleSelections = UC, v_.tabSize = $C.define({ combine: function(e22) {
  return e22.length ? e22[0] : 4;
} }), v_.lineSeparator = KC, v_.readOnly = ZC, v_.phrases = $C.define({ compare: function(e22, t2) {
  var n2 = Object.keys(e22), r2 = Object.keys(t2);
  return n2.length == r2.length && n2.every(function(n3) {
    return e22[n3] == t2[n3];
  });
} }), v_.languageData = JC, v_.changeFilter = GC, v_.transactionFilter = QC, v_.transactionExtender = YC, qC.reconfigure = n_.define();
var m_ = function() {
  function e22() {
    Ri(this, e22);
  }
  return zi(e22, [{ key: "eq", value: function(e23) {
    return this == e23;
  } }, { key: "range", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23;
    return g_.create(e23, t2, this);
  } }]), e22;
}();
m_.prototype.startSide = m_.prototype.endSide = 0, m_.prototype.point = false, m_.prototype.mapMode = vC.TrackDel;
var g_ = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.from = t2, this.to = n2, this.value = r2;
  }
  return zi(e22, null, [{ key: "create", value: function(t2, n2, r2) {
    return new e22(t2, n2, r2);
  } }]), e22;
}();
function y_(e22, t2) {
  return e22.from - t2.from || e22.value.startSide - t2.value.startSide;
}
var b_ = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.from = t2, this.to = n2, this.value = r2, this.maxPoint = i2;
  }
  return zi(e22, [{ key: "length", get: function() {
    return this.to[this.to.length - 1];
  } }, { key: "findIndex", value: function(e23, t2, n2) {
    for (var r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0, i2 = n2 ? this.to : this.from, o2 = r2, a2 = i2.length; ; ) {
      if (o2 == a2)
        return o2;
      var s2 = o2 + a2 >> 1, u2 = i2[s2] - e23 || (n2 ? this.value[s2].endSide : this.value[s2].startSide) - t2;
      if (s2 == o2)
        return u2 >= 0 ? o2 : a2;
      u2 >= 0 ? a2 = s2 : o2 = s2 + 1;
    }
  } }, { key: "between", value: function(e23, t2, n2, r2) {
    for (var i2 = this.findIndex(t2, -1e9, true), o2 = this.findIndex(n2, 1e9, false, i2); i2 < o2; i2++)
      if (r2(this.from[i2] + e23, this.to[i2] + e23, this.value[i2]) === false)
        return false;
  } }, { key: "map", value: function(t2, n2) {
    for (var r2 = [], i2 = [], o2 = [], a2 = -1, s2 = -1, u2 = 0; u2 < this.value.length; u2++) {
      var c2 = this.value[u2], l2 = this.from[u2] + t2, f2 = this.to[u2] + t2, h2 = void 0, d2 = void 0;
      if (l2 == f2) {
        var v2 = n2.mapPos(l2, c2.startSide, c2.mapMode);
        if (v2 == null)
          continue;
        if (h2 = d2 = v2, c2.startSide != c2.endSide && (d2 = n2.mapPos(l2, c2.endSide)) < h2)
          continue;
      } else if ((h2 = n2.mapPos(l2, c2.startSide)) > (d2 = n2.mapPos(f2, c2.endSide)) || h2 == d2 && c2.startSide > 0 && c2.endSide <= 0)
        continue;
      (d2 - h2 || c2.endSide - c2.startSide) < 0 || (a2 < 0 && (a2 = h2), c2.point && (s2 = Math.max(s2, d2 - h2)), r2.push(c2), i2.push(h2 - a2), o2.push(d2 - a2));
    }
    return { mapped: r2.length ? new e22(i2, o2, r2, s2) : null, pos: a2 };
  } }]), e22;
}(), k_ = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.chunkPos = t2, this.chunk = n2, this.nextLayer = r2, this.maxPoint = i2;
  }
  return zi(e22, [{ key: "length", get: function() {
    var e23 = this.chunk.length - 1;
    return e23 < 0 ? 0 : Math.max(this.chunkEnd(e23), this.nextLayer.length);
  } }, { key: "size", get: function() {
    if (this.isEmpty)
      return 0;
    var e23, t2 = this.nextLayer.size, n2 = bi(this.chunk);
    try {
      for (n2.s(); !(e23 = n2.n()).done; ) {
        t2 += e23.value.value.length;
      }
    } catch (e24) {
      n2.e(e24);
    } finally {
      n2.f();
    }
    return t2;
  } }, { key: "chunkEnd", value: function(e23) {
    return this.chunkPos[e23] + this.chunk[e23].length;
  } }, { key: "update", value: function(t2) {
    var n2 = t2.add, r2 = n2 === void 0 ? [] : n2, i2 = t2.sort, o2 = i2 !== void 0 && i2, a2 = t2.filterFrom, s2 = a2 === void 0 ? 0 : a2, u2 = t2.filterTo, c2 = u2 === void 0 ? this.length : u2, l2 = t2.filter;
    if (r2.length == 0 && !l2)
      return this;
    if (o2 && (r2 = r2.slice().sort(y_)), this.isEmpty)
      return r2.length ? e22.of(r2) : this;
    for (var f2 = new S_(this, null, -1).goto(0), h2 = 0, d2 = [], v2 = new x_(); f2.value || h2 < r2.length; )
      if (h2 < r2.length && (f2.from - r2[h2].from || f2.startSide - r2[h2].value.startSide) >= 0) {
        var p2 = r2[h2++];
        v2.addInner(p2.from, p2.to, p2.value) || d2.push(p2);
      } else
        f2.rangeIndex == 1 && f2.chunkIndex < this.chunk.length && (h2 == r2.length || this.chunkEnd(f2.chunkIndex) < r2[h2].from) && (!l2 || s2 > this.chunkEnd(f2.chunkIndex) || c2 < this.chunkPos[f2.chunkIndex]) && v2.addChunk(this.chunkPos[f2.chunkIndex], this.chunk[f2.chunkIndex]) ? f2.nextChunk() : ((!l2 || s2 > f2.to || c2 < f2.from || l2(f2.from, f2.to, f2.value)) && (v2.addInner(f2.from, f2.to, f2.value) || d2.push(g_.create(f2.from, f2.to, f2.value))), f2.next());
    return v2.finishInner(this.nextLayer.isEmpty && !d2.length ? e22.empty : this.nextLayer.update({ add: d2, filter: l2, filterFrom: s2, filterTo: c2 }));
  } }, { key: "map", value: function(t2) {
    if (t2.empty || this.isEmpty)
      return this;
    for (var n2 = [], r2 = [], i2 = -1, o2 = 0; o2 < this.chunk.length; o2++) {
      var a2 = this.chunkPos[o2], s2 = this.chunk[o2], u2 = t2.touchesRange(a2, a2 + s2.length);
      if (u2 === false)
        i2 = Math.max(i2, s2.maxPoint), n2.push(s2), r2.push(t2.mapPos(a2));
      else if (u2 === true) {
        var c2 = s2.map(a2, t2), l2 = c2.mapped, f2 = c2.pos;
        l2 && (i2 = Math.max(i2, l2.maxPoint), n2.push(l2), r2.push(f2));
      }
    }
    var h2 = this.nextLayer.map(t2);
    return n2.length == 0 ? h2 : new e22(r2, n2, h2 || e22.empty, i2);
  } }, { key: "between", value: function(e23, t2, n2) {
    if (!this.isEmpty) {
      for (var r2 = 0; r2 < this.chunk.length; r2++) {
        var i2 = this.chunkPos[r2], o2 = this.chunk[r2];
        if (t2 >= i2 && e23 <= i2 + o2.length && o2.between(i2, e23 - i2, t2 - i2, n2) === false)
          return;
      }
      this.nextLayer.between(e23, t2, n2);
    }
  } }, { key: "iter", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return C_.from([this]).goto(e23);
  } }, { key: "isEmpty", get: function() {
    return this.nextLayer == this;
  } }], [{ key: "create", value: function(t2, n2, r2, i2) {
    return new e22(t2, n2, r2, i2);
  } }, { key: "iter", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return C_.from(e23).goto(t2);
  } }, { key: "compare", value: function(e23, t2, n2, r2) {
    var i2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : -1, o2 = e23.filter(function(e24) {
      return e24.maxPoint > 0 || !e24.isEmpty && e24.maxPoint >= i2;
    }), a2 = t2.filter(function(e24) {
      return e24.maxPoint > 0 || !e24.isEmpty && e24.maxPoint >= i2;
    }), s2 = j_(o2, a2, n2), u2 = new $_(o2, s2, i2), c2 = new $_(a2, s2, i2);
    n2.iterGaps(function(e24, t3, n3) {
      return O_(u2, e24, c2, t3, n3, r2);
    }), n2.empty && n2.length == 0 && O_(u2, 0, c2, 0, 0, r2);
  } }, { key: "eq", value: function(e23, t2) {
    var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, r2 = arguments.length > 3 ? arguments[3] : void 0;
    r2 == null && (r2 = 1e9);
    var i2 = e23.filter(function(e24) {
      return !e24.isEmpty && t2.indexOf(e24) < 0;
    }), o2 = t2.filter(function(t3) {
      return !t3.isEmpty && e23.indexOf(t3) < 0;
    });
    if (i2.length != o2.length)
      return false;
    if (!i2.length)
      return true;
    for (var a2 = j_(i2, o2), s2 = new $_(i2, a2, 0).goto(n2), u2 = new $_(o2, a2, 0).goto(n2); ; ) {
      if (s2.to != u2.to || !A_(s2.active, u2.active) || s2.point && (!u2.point || !s2.point.eq(u2.point)))
        return false;
      if (s2.to > r2)
        return true;
      s2.next(), u2.next();
    }
  } }, { key: "spans", value: function(e23, t2, n2, r2) {
    for (var i2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : -1, o2 = new $_(e23, null, i2).goto(t2), a2 = t2, s2 = o2.openStart; ; ) {
      var u2 = Math.min(o2.to, n2);
      if (o2.point ? (r2.point(a2, u2, o2.point, o2.activeForPoint(o2.to), s2, o2.pointRank), s2 = o2.openEnd(u2) + (o2.to > u2 ? 1 : 0)) : u2 > a2 && (r2.span(a2, u2, o2.active, s2), s2 = o2.openEnd(u2)), o2.to > n2)
        break;
      a2 = o2.to, o2.next();
    }
    return s2;
  } }, { key: "of", value: function(e23) {
    var t2, n2 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1], r2 = new x_(), i2 = bi(e23 instanceof g_ ? [e23] : n2 ? w_(e23) : e23);
    try {
      for (i2.s(); !(t2 = i2.n()).done; ) {
        var o2 = t2.value;
        r2.add(o2.from, o2.to, o2.value);
      }
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    return r2.finish();
  } }]), e22;
}();
function w_(e22) {
  if (e22.length > 1)
    for (var t2 = e22[0], n2 = 1; n2 < e22.length; n2++) {
      var r2 = e22[n2];
      if (y_(t2, r2) > 0)
        return e22.slice().sort(y_);
      t2 = r2;
    }
  return e22;
}
k_.empty = new k_([], [], null, -1), k_.empty.nextLayer = k_.empty;
var x_ = function() {
  function e22() {
    Ri(this, e22), this.chunks = [], this.chunkPos = [], this.chunkStart = -1, this.last = null, this.lastFrom = -1e9, this.lastTo = -1e9, this.from = [], this.to = [], this.value = [], this.maxPoint = -1, this.setMaxPoint = -1, this.nextLayer = null;
  }
  return zi(e22, [{ key: "finishChunk", value: function(e23) {
    this.chunks.push(new b_(this.from, this.to, this.value, this.maxPoint)), this.chunkPos.push(this.chunkStart), this.chunkStart = -1, this.setMaxPoint = Math.max(this.setMaxPoint, this.maxPoint), this.maxPoint = -1, e23 && (this.from = [], this.to = [], this.value = []);
  } }, { key: "add", value: function(t2, n2, r2) {
    this.addInner(t2, n2, r2) || (this.nextLayer || (this.nextLayer = new e22())).add(t2, n2, r2);
  } }, { key: "addInner", value: function(e23, t2, n2) {
    var r2 = e23 - this.lastTo || n2.startSide - this.last.endSide;
    if (r2 <= 0 && (e23 - this.lastFrom || n2.startSide - this.last.startSide) < 0)
      throw new Error("Ranges must be added sorted by `from` position and `startSide`");
    return !(r2 < 0) && (this.from.length == 250 && this.finishChunk(true), this.chunkStart < 0 && (this.chunkStart = e23), this.from.push(e23 - this.chunkStart), this.to.push(t2 - this.chunkStart), this.last = n2, this.lastFrom = e23, this.lastTo = t2, this.value.push(n2), n2.point && (this.maxPoint = Math.max(this.maxPoint, t2 - e23)), true);
  } }, { key: "addChunk", value: function(e23, t2) {
    if ((e23 - this.lastTo || t2.value[0].startSide - this.last.endSide) < 0)
      return false;
    this.from.length && this.finishChunk(true), this.setMaxPoint = Math.max(this.setMaxPoint, t2.maxPoint), this.chunks.push(t2), this.chunkPos.push(e23);
    var n2 = t2.value.length - 1;
    return this.last = t2.value[n2], this.lastFrom = t2.from[n2] + e23, this.lastTo = t2.to[n2] + e23, true;
  } }, { key: "finish", value: function() {
    return this.finishInner(k_.empty);
  } }, { key: "finishInner", value: function(e23) {
    if (this.from.length && this.finishChunk(false), this.chunks.length == 0)
      return e23;
    var t2 = k_.create(this.chunkPos, this.chunks, this.nextLayer ? this.nextLayer.finishInner(e23) : e23, this.setMaxPoint);
    return this.from = null, t2;
  } }]), e22;
}();
function j_(e22, t2, n2) {
  var r2, i2 = /* @__PURE__ */ new Map(), o2 = bi(e22);
  try {
    for (o2.s(); !(r2 = o2.n()).done; )
      for (var a2 = r2.value, s2 = 0; s2 < a2.chunk.length; s2++)
        a2.chunk[s2].maxPoint <= 0 && i2.set(a2.chunk[s2], a2.chunkPos[s2]);
  } catch (e23) {
    o2.e(e23);
  } finally {
    o2.f();
  }
  var u2, c2 = /* @__PURE__ */ new Set(), l2 = bi(t2);
  try {
    for (l2.s(); !(u2 = l2.n()).done; )
      for (var f2 = u2.value, h2 = 0; h2 < f2.chunk.length; h2++) {
        var d2 = i2.get(f2.chunk[h2]);
        d2 == null || (n2 ? n2.mapPos(d2) : d2) != f2.chunkPos[h2] || (n2 == null ? void 0 : n2.touchesRange(d2, d2 + f2.chunk[h2].length)) || c2.add(f2.chunk[h2]);
      }
  } catch (e23) {
    l2.e(e23);
  } finally {
    l2.f();
  }
  return c2;
}
var S_ = function() {
  function e22(t2, n2, r2) {
    var i2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0;
    Ri(this, e22), this.layer = t2, this.skip = n2, this.minPoint = r2, this.rank = i2;
  }
  return zi(e22, [{ key: "startSide", get: function() {
    return this.value ? this.value.startSide : 0;
  } }, { key: "endSide", get: function() {
    return this.value ? this.value.endSide : 0;
  } }, { key: "goto", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : -1e9;
    return this.chunkIndex = this.rangeIndex = 0, this.gotoInner(e23, t2, false), this;
  } }, { key: "gotoInner", value: function(e23, t2, n2) {
    for (; this.chunkIndex < this.layer.chunk.length; ) {
      var r2 = this.layer.chunk[this.chunkIndex];
      if (!(this.skip && this.skip.has(r2) || this.layer.chunkEnd(this.chunkIndex) < e23 || r2.maxPoint < this.minPoint))
        break;
      this.chunkIndex++, n2 = false;
    }
    if (this.chunkIndex < this.layer.chunk.length) {
      var i2 = this.layer.chunk[this.chunkIndex].findIndex(e23 - this.layer.chunkPos[this.chunkIndex], t2, true);
      (!n2 || this.rangeIndex < i2) && this.setRangeIndex(i2);
    }
    this.next();
  } }, { key: "forward", value: function(e23, t2) {
    (this.to - e23 || this.endSide - t2) < 0 && this.gotoInner(e23, t2, true);
  } }, { key: "next", value: function() {
    for (; ; ) {
      if (this.chunkIndex == this.layer.chunk.length) {
        this.from = this.to = 1e9, this.value = null;
        break;
      }
      var e23 = this.layer.chunkPos[this.chunkIndex], t2 = this.layer.chunk[this.chunkIndex], n2 = e23 + t2.from[this.rangeIndex];
      if (this.from = n2, this.to = e23 + t2.to[this.rangeIndex], this.value = t2.value[this.rangeIndex], this.setRangeIndex(this.rangeIndex + 1), this.minPoint < 0 || this.value.point && this.to - this.from >= this.minPoint)
        break;
    }
  } }, { key: "setRangeIndex", value: function(e23) {
    if (e23 == this.layer.chunk[this.chunkIndex].value.length) {
      if (this.chunkIndex++, this.skip)
        for (; this.chunkIndex < this.layer.chunk.length && this.skip.has(this.layer.chunk[this.chunkIndex]); )
          this.chunkIndex++;
      this.rangeIndex = 0;
    } else
      this.rangeIndex = e23;
  } }, { key: "nextChunk", value: function() {
    this.chunkIndex++, this.rangeIndex = 0, this.next();
  } }, { key: "compare", value: function(e23) {
    return this.from - e23.from || this.startSide - e23.startSide || this.rank - e23.rank || this.to - e23.to || this.endSide - e23.endSide;
  } }]), e22;
}(), C_ = function() {
  function e22(t2) {
    Ri(this, e22), this.heap = t2;
  }
  return zi(e22, [{ key: "startSide", get: function() {
    return this.value ? this.value.startSide : 0;
  } }, { key: "goto", value: function(e23) {
    var t2, n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : -1e9, r2 = bi(this.heap);
    try {
      for (r2.s(); !(t2 = r2.n()).done; ) {
        var i2 = t2.value;
        i2.goto(e23, n2);
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    for (var o2 = this.heap.length >> 1; o2 >= 0; o2--)
      __(this.heap, o2);
    return this.next(), this;
  } }, { key: "forward", value: function(e23, t2) {
    var n2, r2 = bi(this.heap);
    try {
      for (r2.s(); !(n2 = r2.n()).done; ) {
        n2.value.forward(e23, t2);
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    for (var i2 = this.heap.length >> 1; i2 >= 0; i2--)
      __(this.heap, i2);
    (this.to - e23 || this.value.endSide - t2) < 0 && this.next();
  } }, { key: "next", value: function() {
    if (this.heap.length == 0)
      this.from = this.to = 1e9, this.value = null, this.rank = -1;
    else {
      var e23 = this.heap[0];
      this.from = e23.from, this.to = e23.to, this.value = e23.value, this.rank = e23.rank, e23.value && e23.next(), __(this.heap, 0);
    }
  } }], [{ key: "from", value: function(t2) {
    for (var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : -1, i2 = [], o2 = 0; o2 < t2.length; o2++)
      for (var a2 = t2[o2]; !a2.isEmpty; a2 = a2.nextLayer)
        a2.maxPoint >= r2 && i2.push(new S_(a2, n2, r2, o2));
    return i2.length == 1 ? i2[0] : new e22(i2);
  } }]), e22;
}();
function __(e22, t2) {
  for (var n2 = e22[t2]; ; ) {
    var r2 = 1 + (t2 << 1);
    if (r2 >= e22.length)
      break;
    var i2 = e22[r2];
    if (r2 + 1 < e22.length && i2.compare(e22[r2 + 1]) >= 0 && (i2 = e22[r2 + 1], r2++), n2.compare(i2) < 0)
      break;
    e22[r2] = n2, e22[t2] = i2, t2 = r2;
  }
}
var $_ = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.minPoint = r2, this.active = [], this.activeTo = [], this.activeRank = [], this.minActive = -1, this.point = null, this.pointFrom = 0, this.pointRank = 0, this.to = -1e9, this.endSide = 0, this.openStart = -1, this.cursor = C_.from(t2, n2, r2);
  }
  return zi(e22, [{ key: "goto", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : -1e9;
    return this.cursor.goto(e23, t2), this.active.length = this.activeTo.length = this.activeRank.length = 0, this.minActive = -1, this.to = e23, this.endSide = t2, this.openStart = -1, this.next(), this;
  } }, { key: "forward", value: function(e23, t2) {
    for (; this.minActive > -1 && (this.activeTo[this.minActive] - e23 || this.active[this.minActive].endSide - t2) < 0; )
      this.removeActive(this.minActive);
    this.cursor.forward(e23, t2);
  } }, { key: "removeActive", value: function(e23) {
    M_(this.active, e23), M_(this.activeTo, e23), M_(this.activeRank, e23), this.minActive = P_(this.active, this.activeTo);
  } }, { key: "addActive", value: function(e23) {
    for (var t2 = 0, n2 = this.cursor, r2 = n2.value, i2 = n2.to, o2 = n2.rank; t2 < this.activeRank.length && this.activeRank[t2] <= o2; )
      t2++;
    E_(this.active, t2, r2), E_(this.activeTo, t2, i2), E_(this.activeRank, t2, o2), e23 && E_(e23, t2, this.cursor.from), this.minActive = P_(this.active, this.activeTo);
  } }, { key: "next", value: function() {
    var e23 = this.to, t2 = this.point;
    this.point = null;
    for (var n2 = this.openStart < 0 ? [] : null, r2 = 0; ; ) {
      var i2 = this.minActive;
      if (i2 > -1 && (this.activeTo[i2] - this.cursor.from || this.active[i2].endSide - this.cursor.startSide) < 0) {
        if (this.activeTo[i2] > e23) {
          this.to = this.activeTo[i2], this.endSide = this.active[i2].endSide;
          break;
        }
        this.removeActive(i2), n2 && M_(n2, i2);
      } else {
        if (!this.cursor.value) {
          this.to = this.endSide = 1e9;
          break;
        }
        if (this.cursor.from > e23) {
          this.to = this.cursor.from, this.endSide = this.cursor.startSide;
          break;
        }
        var o2 = this.cursor.value;
        if (o2.point) {
          if (!(t2 && this.cursor.to == this.to && this.cursor.from < this.cursor.to)) {
            this.point = o2, this.pointFrom = this.cursor.from, this.pointRank = this.cursor.rank, this.to = this.cursor.to, this.endSide = o2.endSide, this.cursor.from < e23 && (r2 = 1), this.cursor.next(), this.forward(this.to, this.endSide);
            break;
          }
          this.cursor.next();
        } else
          this.addActive(n2), this.cursor.next();
      }
    }
    if (n2) {
      for (var a2 = 0; a2 < n2.length && n2[a2] < e23; )
        a2++;
      this.openStart = a2 + r2;
    }
  } }, { key: "activeForPoint", value: function(e23) {
    if (!this.active.length)
      return this.active;
    for (var t2 = [], n2 = this.active.length - 1; n2 >= 0 && !(this.activeRank[n2] < this.pointRank); n2--)
      (this.activeTo[n2] > e23 || this.activeTo[n2] == e23 && this.active[n2].endSide >= this.point.endSide) && t2.push(this.active[n2]);
    return t2.reverse();
  } }, { key: "openEnd", value: function(e23) {
    for (var t2 = 0, n2 = this.activeTo.length - 1; n2 >= 0 && this.activeTo[n2] > e23; n2--)
      t2++;
    return t2;
  } }]), e22;
}();
function O_(e22, t2, n2, r2, i2, o2) {
  e22.goto(t2), n2.goto(r2);
  for (var a2 = r2 + i2, s2 = r2, u2 = r2 - t2; ; ) {
    var c2 = e22.to + u2 - n2.to || e22.endSide - n2.endSide, l2 = c2 < 0 ? e22.to + u2 : n2.to, f2 = Math.min(l2, a2);
    if (e22.point || n2.point ? e22.point && n2.point && (e22.point == n2.point || e22.point.eq(n2.point)) && A_(e22.activeForPoint(e22.to + u2), n2.activeForPoint(n2.to)) || o2.comparePoint(s2, f2, e22.point, n2.point) : f2 > s2 && !A_(e22.active, n2.active) && o2.compareRange(s2, f2, e22.active, n2.active), l2 > a2)
      break;
    s2 = l2, c2 <= 0 && e22.next(), c2 >= 0 && n2.next();
  }
}
function A_(e22, t2) {
  if (e22.length != t2.length)
    return false;
  for (var n2 = 0; n2 < e22.length; n2++)
    if (e22[n2] != t2[n2] && !e22[n2].eq(t2[n2]))
      return false;
  return true;
}
function M_(e22, t2) {
  for (var n2 = t2, r2 = e22.length - 1; n2 < r2; n2++)
    e22[n2] = e22[n2 + 1];
  e22.pop();
}
function E_(e22, t2, n2) {
  for (var r2 = e22.length - 1; r2 >= t2; r2--)
    e22[r2 + 1] = e22[r2];
  e22[t2] = n2;
}
function P_(e22, t2) {
  for (var n2 = -1, r2 = 1e9, i2 = 0; i2 < t2.length; i2++)
    (t2[i2] - r2 || e22[i2].endSide - e22[n2].endSide) < 0 && (n2 = i2, r2 = t2[i2]);
  return n2;
}
function N_(e22, t2) {
  for (var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : e22.length, r2 = 0, i2 = 0; i2 < n2; )
    e22.charCodeAt(i2) == 9 ? (r2 += t2 - r2 % t2, i2++) : (r2++, i2 = oC(e22, i2));
  return r2;
}
function T_(e22, t2, n2, r2) {
  for (var i2 = 0, o2 = 0; ; ) {
    if (o2 >= t2)
      return i2;
    if (i2 == e22.length)
      break;
    o2 += e22.charCodeAt(i2) == 9 ? n2 - o2 % n2 : 1, i2 = oC(e22, i2);
  }
  return r2 === true ? -1 : e22.length;
}
for (var I_ = typeof Symbol == "undefined" ? "__\u037C" : Symbol.for("\u037C"), R_ = typeof Symbol == "undefined" ? "__styleSet" + Math.floor(1e8 * Math.random()) : Symbol("styleSet"), D_ = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : {}, z_ = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.rules = [];
    var r2 = (n2 || {}).finish;
    function i2(e23) {
      return /^@/.test(e23) ? [e23] : e23.split(/,\s*/);
    }
    function o2(e23, t3, n3, a3) {
      var s2 = [], u2 = /^@(\w+)\b/.exec(e23[0]), c2 = u2 && u2[1] == "keyframes";
      if (u2 && t3 == null)
        return n3.push(e23[0] + ";");
      for (var l2 in t3) {
        var f2 = t3[l2];
        if (/&/.test(l2))
          o2(l2.split(/,\s*/).map(function(t4) {
            return e23.map(function(e24) {
              return t4.replace(/&/, e24);
            });
          }).reduce(function(e24, t4) {
            return e24.concat(t4);
          }), f2, n3);
        else if (f2 && Li(f2) == "object") {
          if (!u2)
            throw new RangeError("The value of a property (" + l2 + ") should be a primitive value.");
          o2(i2(l2), f2, s2, c2);
        } else
          f2 != null && s2.push(l2.replace(/_.*/, "").replace(/[A-Z]/g, function(e24) {
            return "-" + e24.toLowerCase();
          }) + ": " + f2 + ";");
      }
      (s2.length || c2) && n3.push((!r2 || u2 || a3 ? e23 : e23.map(r2)).join(", ") + " {" + s2.join(" ") + "}");
    }
    for (var a2 in t2)
      o2(i2(a2), t2[a2], this.rules);
  }
  return zi(e22, [{ key: "getRules", value: function() {
    return this.rules.join("\n");
  } }], [{ key: "newName", value: function() {
    var e23 = D_[I_] || 1;
    return D_[I_] = e23 + 1, "\u037C" + e23.toString(36);
  } }, { key: "mount", value: function(e23, t2) {
    (e23[R_] || new B_(e23)).mount(Array.isArray(t2) ? t2 : [t2]);
  } }]), e22;
}(), L_ = null, B_ = function() {
  function e22(t2) {
    if (Ri(this, e22), !t2.head && t2.adoptedStyleSheets && typeof CSSStyleSheet != "undefined") {
      if (L_)
        return t2.adoptedStyleSheets = [L_.sheet].concat(t2.adoptedStyleSheets), t2[R_] = L_;
      this.sheet = new CSSStyleSheet(), t2.adoptedStyleSheets = [this.sheet].concat(t2.adoptedStyleSheets), L_ = this;
    } else {
      this.styleTag = (t2.ownerDocument || t2).createElement("style");
      var n2 = t2.head || t2;
      n2.insertBefore(this.styleTag, n2.firstChild);
    }
    this.modules = [], t2[R_] = this;
  }
  return zi(e22, [{ key: "mount", value: function(e23) {
    for (var t2 = this.sheet, n2 = 0, r2 = 0, i2 = 0; i2 < e23.length; i2++) {
      var o2 = e23[i2], a2 = this.modules.indexOf(o2);
      if (a2 < r2 && a2 > -1 && (this.modules.splice(a2, 1), r2--, a2 = -1), a2 == -1) {
        if (this.modules.splice(r2++, 0, o2), t2)
          for (var s2 = 0; s2 < o2.rules.length; s2++)
            t2.insertRule(o2.rules[s2], n2++);
      } else {
        for (; r2 < a2; )
          n2 += this.modules[r2++].rules.length;
        n2 += o2.rules.length, r2++;
      }
    }
    if (!t2) {
      for (var u2 = "", c2 = 0; c2 < this.modules.length; c2++)
        u2 += this.modules[c2].getRules() + "\n";
      this.styleTag.textContent = u2;
    }
  } }]), e22;
}(), q_ = { 8: "Backspace", 9: "Tab", 10: "Enter", 12: "NumLock", 13: "Enter", 16: "Shift", 17: "Control", 18: "Alt", 20: "CapsLock", 27: "Escape", 32: " ", 33: "PageUp", 34: "PageDown", 35: "End", 36: "Home", 37: "ArrowLeft", 38: "ArrowUp", 39: "ArrowRight", 40: "ArrowDown", 44: "PrintScreen", 45: "Insert", 46: "Delete", 59: ";", 61: "=", 91: "Meta", 92: "Meta", 106: "*", 107: "+", 108: ",", 109: "-", 110: ".", 111: "/", 144: "NumLock", 145: "ScrollLock", 160: "Shift", 161: "Shift", 162: "Control", 163: "Control", 164: "Alt", 165: "Alt", 173: "-", 186: ";", 187: "=", 188: ",", 189: "-", 190: ".", 191: "/", 192: "`", 219: "[", 220: "\\", 221: "]", 222: "'", 229: "q" }, F_ = { 48: ")", 49: "!", 50: "@", 51: "#", 52: "$", 53: "%", 54: "^", 55: "&", 56: "*", 57: "(", 59: ":", 61: "+", 173: "_", 186: ":", 187: "+", 188: "<", 189: "_", 190: ">", 191: "?", 192: "~", 219: "{", 220: "|", 221: "}", 222: '"', 229: "Q" }, V_ = typeof navigator != "undefined" && /Chrome\/(\d+)/.exec(navigator.userAgent), H_ = typeof navigator != "undefined" && /Apple Computer/.test(navigator.vendor), W_ = typeof navigator != "undefined" && /Gecko\/\d+/.test(navigator.userAgent), J_ = typeof navigator != "undefined" && /Mac/.test(navigator.platform), U_ = typeof navigator != "undefined" && /MSIE \d|Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(navigator.userAgent), K_ = V_ && (J_ || +V_[1] < 57) || W_ && J_, G_ = 0; G_ < 10; G_++)
  q_[48 + G_] = q_[96 + G_] = String(G_);
for (G_ = 1; G_ <= 24; G_++)
  q_[G_ + 111] = "F" + G_;
for (G_ = 65; G_ <= 90; G_++)
  q_[G_] = String.fromCharCode(G_ + 32), F_[G_] = String.fromCharCode(G_);
for (var Q_ in q_)
  F_.hasOwnProperty(Q_) || (F_[Q_] = q_[Q_]);
function Y_(e22) {
  return (e22.nodeType == 11 ? e22.getSelection ? e22 : e22.ownerDocument : e22).getSelection();
}
function Z_(e22, t2) {
  return !!t2 && (e22 == t2 || e22.contains(t2.nodeType != 1 ? t2.parentNode : t2));
}
function X_(e22, t2) {
  if (!t2.anchorNode)
    return false;
  try {
    return Z_(e22, t2.anchorNode);
  } catch (e23) {
    return false;
  }
}
function e$(e22) {
  return e22.nodeType == 3 ? h$(e22, 0, e22.nodeValue.length).getClientRects() : e22.nodeType == 1 ? e22.getClientRects() : [];
}
function t$(e22, t2, n2, r2) {
  return !!n2 && (r$(e22, t2, n2, r2, -1) || r$(e22, t2, n2, r2, 1));
}
function n$(e22) {
  for (var t2 = 0; ; t2++)
    if (!(e22 = e22.previousSibling))
      return t2;
}
function r$(e22, t2, n2, r2, i2) {
  for (; ; ) {
    if (e22 == n2 && t2 == r2)
      return true;
    if (t2 == (i2 < 0 ? 0 : i$(e22))) {
      if (e22.nodeName == "DIV")
        return false;
      var o2 = e22.parentNode;
      if (!o2 || o2.nodeType != 1)
        return false;
      t2 = n$(e22) + (i2 < 0 ? 0 : 1), e22 = o2;
    } else {
      if (e22.nodeType != 1)
        return false;
      if ((e22 = e22.childNodes[t2 + (i2 < 0 ? -1 : 0)]).nodeType == 1 && e22.contentEditable == "false")
        return false;
      t2 = i2 < 0 ? i$(e22) : 0;
    }
  }
}
function i$(e22) {
  return e22.nodeType == 3 ? e22.nodeValue.length : e22.childNodes.length;
}
var o$ = { left: 0, right: 0, top: 0, bottom: 0 };
function a$(e22, t2) {
  var n2 = t2 ? e22.left : e22.right;
  return { left: n2, right: n2, top: e22.top, bottom: e22.bottom };
}
function s$(e22) {
  return { left: 0, right: e22.innerWidth, top: 0, bottom: e22.innerHeight };
}
var u$, c$ = function() {
  function e22() {
    Ri(this, e22), this.anchorNode = null, this.anchorOffset = 0, this.focusNode = null, this.focusOffset = 0;
  }
  return zi(e22, [{ key: "eq", value: function(e23) {
    return this.anchorNode == e23.anchorNode && this.anchorOffset == e23.anchorOffset && this.focusNode == e23.focusNode && this.focusOffset == e23.focusOffset;
  } }, { key: "setRange", value: function(e23) {
    this.set(e23.anchorNode, e23.anchorOffset, e23.focusNode, e23.focusOffset);
  } }, { key: "set", value: function(e23, t2, n2, r2) {
    this.anchorNode = e23, this.anchorOffset = t2, this.focusNode = n2, this.focusOffset = r2;
  } }]), e22;
}(), l$ = null;
function f$(e22) {
  if (e22.setActive)
    return e22.setActive();
  if (l$)
    return e22.focus(l$);
  for (var t2 = [], n2 = e22; n2 && (t2.push(n2, n2.scrollTop, n2.scrollLeft), n2 != n2.ownerDocument); n2 = n2.parentNode)
    ;
  if (e22.focus(l$ == null ? { get preventScroll() {
    return l$ = { preventScroll: true }, true;
  } } : void 0), !l$) {
    l$ = false;
    for (var r2 = 0; r2 < t2.length; ) {
      var i2 = t2[r2++], o2 = t2[r2++], a2 = t2[r2++];
      i2.scrollTop != o2 && (i2.scrollTop = o2), i2.scrollLeft != a2 && (i2.scrollLeft = a2);
    }
  }
}
function h$(e22, t2) {
  var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : t2, r2 = u$ || (u$ = document.createRange());
  return r2.setEnd(e22, n2), r2.setStart(e22, t2), r2;
}
function d$(e22, t2, n2) {
  var r2 = { key: t2, code: t2, keyCode: n2, which: n2, cancelable: true }, i2 = new KeyboardEvent("keydown", r2);
  i2.synthetic = true, e22.dispatchEvent(i2);
  var o2 = new KeyboardEvent("keyup", r2);
  return o2.synthetic = true, e22.dispatchEvent(o2), i2.defaultPrevented || o2.defaultPrevented;
}
function v$(e22) {
  for (; e22; ) {
    if (e22 && (e22.nodeType == 9 || e22.nodeType == 11 && e22.host))
      return e22;
    e22 = e22.assignedSlot || e22.parentNode;
  }
  return null;
}
function p$(e22) {
  for (; e22.attributes.length; )
    e22.removeAttributeNode(e22.attributes[0]);
}
var m$ = function() {
  function e22(t2, n2) {
    var r2 = !(arguments.length > 2 && arguments[2] !== void 0) || arguments[2];
    Ri(this, e22), this.node = t2, this.offset = n2, this.precise = r2;
  }
  return zi(e22, null, [{ key: "before", value: function(t2, n2) {
    return new e22(t2.parentNode, n$(t2), n2);
  } }, { key: "after", value: function(t2, n2) {
    return new e22(t2.parentNode, n$(t2) + 1, n2);
  } }]), e22;
}(), g$ = [], y$ = function() {
  function e22() {
    Ri(this, e22), this.parent = null, this.dom = null, this.dirty = 2;
  }
  return zi(e22, [{ key: "editorView", get: function() {
    if (!this.parent)
      throw new Error("Accessing view in orphan content view");
    return this.parent.editorView;
  } }, { key: "overrideDOMText", get: function() {
    return null;
  } }, { key: "posAtStart", get: function() {
    return this.parent ? this.parent.posBefore(this) : 0;
  } }, { key: "posAtEnd", get: function() {
    return this.posAtStart + this.length;
  } }, { key: "posBefore", value: function(e23) {
    var t2, n2 = this.posAtStart, r2 = bi(this.children);
    try {
      for (r2.s(); !(t2 = r2.n()).done; ) {
        var i2 = t2.value;
        if (i2 == e23)
          return n2;
        n2 += i2.length + i2.breakAfter;
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    throw new RangeError("Invalid child in posBefore");
  } }, { key: "posAfter", value: function(e23) {
    return this.posBefore(e23) + e23.length;
  } }, { key: "coordsAt", value: function(e23, t2) {
    return null;
  } }, { key: "sync", value: function(t2) {
    if (2 & this.dirty) {
      var n2, r2, i2 = this.dom, o2 = null, a2 = bi(this.children);
      try {
        for (a2.s(); !(r2 = a2.n()).done; ) {
          var s2 = r2.value;
          if (s2.dirty) {
            if (!s2.dom && (n2 = o2 ? o2.nextSibling : i2.firstChild)) {
              var u2 = e22.get(n2);
              u2 && (u2.parent || u2.constructor != s2.constructor) || s2.reuseDOM(n2);
            }
            s2.sync(t2), s2.dirty = 0;
          }
          if (n2 = o2 ? o2.nextSibling : i2.firstChild, t2 && !t2.written && t2.node == i2 && n2 != s2.dom && (t2.written = true), s2.dom.parentNode == i2)
            for (; n2 && n2 != s2.dom; )
              n2 = b$(n2);
          else
            i2.insertBefore(s2.dom, n2);
          o2 = s2.dom;
        }
      } catch (e23) {
        a2.e(e23);
      } finally {
        a2.f();
      }
      for ((n2 = o2 ? o2.nextSibling : i2.firstChild) && t2 && t2.node == i2 && (t2.written = true); n2; )
        n2 = b$(n2);
    } else if (1 & this.dirty) {
      var c2, l2 = bi(this.children);
      try {
        for (l2.s(); !(c2 = l2.n()).done; ) {
          var f2 = c2.value;
          f2.dirty && (f2.sync(t2), f2.dirty = 0);
        }
      } catch (e23) {
        l2.e(e23);
      } finally {
        l2.f();
      }
    }
  } }, { key: "reuseDOM", value: function(e23) {
  } }, { key: "localPosFromDOM", value: function(t2, n2) {
    var r2;
    if (t2 == this.dom)
      r2 = this.dom.childNodes[n2];
    else {
      for (var i2 = i$(t2) == 0 ? 0 : n2 == 0 ? -1 : 1; ; ) {
        var o2 = t2.parentNode;
        if (o2 == this.dom)
          break;
        i2 == 0 && o2.firstChild != o2.lastChild && (i2 = t2 == o2.firstChild ? -1 : 1), t2 = o2;
      }
      r2 = i2 < 0 ? t2 : t2.nextSibling;
    }
    if (r2 == this.dom.firstChild)
      return 0;
    for (; r2 && !e22.get(r2); )
      r2 = r2.nextSibling;
    if (!r2)
      return this.length;
    for (var a2 = 0, s2 = 0; ; a2++) {
      var u2 = this.children[a2];
      if (u2.dom == r2)
        return s2;
      s2 += u2.length + u2.breakAfter;
    }
  } }, { key: "domBoundsAround", value: function(e23, t2) {
    for (var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, r2 = -1, i2 = -1, o2 = -1, a2 = -1, s2 = 0, u2 = n2, c2 = n2; s2 < this.children.length; s2++) {
      var l2 = this.children[s2], f2 = u2 + l2.length;
      if (u2 < e23 && f2 > t2)
        return l2.domBoundsAround(e23, t2, u2);
      if (f2 >= e23 && r2 == -1 && (r2 = s2, i2 = u2), u2 > t2 && l2.dom.parentNode == this.dom) {
        o2 = s2, a2 = c2;
        break;
      }
      c2 = f2, u2 = f2 + l2.breakAfter;
    }
    return { from: i2, to: a2 < 0 ? n2 + this.length : a2, startDOM: (r2 ? this.children[r2 - 1].dom.nextSibling : null) || this.dom.firstChild, endDOM: o2 < this.children.length && o2 >= 0 ? this.children[o2].dom : null };
  } }, { key: "markDirty", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 && arguments[0];
    this.dirty |= 2, this.markParentsDirty(e23);
  } }, { key: "markParentsDirty", value: function(e23) {
    for (var t2 = this.parent; t2; t2 = t2.parent) {
      if (e23 && (t2.dirty |= 2), 1 & t2.dirty)
        return;
      t2.dirty |= 1, e23 = false;
    }
  } }, { key: "setParent", value: function(e23) {
    this.parent != e23 && (this.parent = e23, this.dirty && this.markParentsDirty(true));
  } }, { key: "setDOM", value: function(e23) {
    this.dom && (this.dom.cmView = null), this.dom = e23, e23.cmView = this;
  } }, { key: "rootView", get: function() {
    for (var e23 = this; ; ) {
      var t2 = e23.parent;
      if (!t2)
        return e23;
      e23 = t2;
    }
  } }, { key: "replaceChildren", value: function(e23, t2) {
    var n2, r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : g$;
    this.markDirty();
    for (var i2 = e23; i2 < t2; i2++) {
      var o2 = this.children[i2];
      o2.parent == this && o2.destroy();
    }
    (n2 = this.children).splice.apply(n2, [e23, t2 - e23].concat(Ni(r2)));
    for (var a2 = 0; a2 < r2.length; a2++)
      r2[a2].setParent(this);
  } }, { key: "ignoreMutation", value: function(e23) {
    return false;
  } }, { key: "ignoreEvent", value: function(e23) {
    return false;
  } }, { key: "childCursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.length;
    return new k$(this.children, e23, this.children.length);
  } }, { key: "childPos", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
    return this.childCursor().findPos(e23, t2);
  } }, { key: "toString", value: function() {
    var e23 = this.constructor.name.replace("View", "");
    return e23 + (this.children.length ? "(" + this.children.join() + ")" : this.length ? "[" + (e23 == "Text" ? this.text : this.length) + "]" : "") + (this.breakAfter ? "#" : "");
  } }, { key: "isEditable", get: function() {
    return true;
  } }, { key: "merge", value: function(e23, t2, n2, r2, i2, o2) {
    return false;
  } }, { key: "become", value: function(e23) {
    return false;
  } }, { key: "getSide", value: function() {
    return 0;
  } }, { key: "destroy", value: function() {
    this.parent = null;
  } }], [{ key: "get", value: function(e23) {
    return e23.cmView;
  } }]), e22;
}();
function b$(e22) {
  var t2 = e22.nextSibling;
  return e22.parentNode.removeChild(e22), t2;
}
y$.prototype.breakAfter = 0;
var k$ = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.children = t2, this.pos = n2, this.i = r2, this.off = 0;
  }
  return zi(e22, [{ key: "findPos", value: function(e23) {
    for (var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1; ; ) {
      if (e23 > this.pos || e23 == this.pos && (t2 > 0 || this.i == 0 || this.children[this.i - 1].breakAfter))
        return this.off = e23 - this.pos, this;
      var n2 = this.children[--this.i];
      this.pos -= n2.length + n2.breakAfter;
    }
  } }]), e22;
}();
function w$(e22, t2, n2, r2, i2, o2, a2, s2, u2) {
  var c2 = e22.children, l2 = c2.length ? c2[t2] : null, f2 = o2.length ? o2[o2.length - 1] : null, h2 = f2 ? f2.breakAfter : a2;
  if (!(t2 == r2 && l2 && !a2 && !h2 && o2.length < 2 && l2.merge(n2, i2, o2.length ? f2 : null, n2 == 0, s2, u2))) {
    if (r2 < c2.length) {
      var d2 = c2[r2];
      d2 && i2 < d2.length ? (t2 == r2 && (d2 = d2.split(i2), i2 = 0), !h2 && f2 && d2.merge(0, i2, f2, true, 0, u2) ? o2[o2.length - 1] = d2 : (i2 && d2.merge(0, i2, null, false, 0, u2), o2.push(d2))) : (d2 == null ? void 0 : d2.breakAfter) && (f2 ? f2.breakAfter = 1 : a2 = 1), r2++;
    }
    for (l2 && (l2.breakAfter = a2, n2 > 0 && (!a2 && o2.length && l2.merge(n2, l2.length, o2[0], false, s2, 0) ? l2.breakAfter = o2.shift().breakAfter : (n2 < l2.length || l2.children.length && l2.children[l2.children.length - 1].length == 0) && l2.merge(n2, l2.length, null, false, s2, 0), t2++)); t2 < r2 && o2.length; )
      if (c2[r2 - 1].become(o2[o2.length - 1]))
        r2--, o2.pop(), u2 = o2.length ? 0 : s2;
      else {
        if (!c2[t2].become(o2[0]))
          break;
        t2++, o2.shift(), s2 = o2.length ? 0 : u2;
      }
    !o2.length && t2 && r2 < c2.length && !c2[t2 - 1].breakAfter && c2[r2].merge(0, 0, c2[t2 - 1], false, s2, u2) && t2--, (t2 < r2 || o2.length) && e22.replaceChildren(t2, r2, o2);
  }
}
function x$(e22, t2, n2, r2, i2, o2) {
  var a2, s2 = e22.childCursor(), u2 = s2.findPos(n2, 1), c2 = u2.i, l2 = u2.off, f2 = s2.findPos(t2, -1), h2 = f2.i, d2 = f2.off, v2 = t2 - n2, p2 = bi(r2);
  try {
    for (p2.s(); !(a2 = p2.n()).done; ) {
      v2 += a2.value.length;
    }
  } catch (e23) {
    p2.e(e23);
  } finally {
    p2.f();
  }
  e22.length += v2, w$(e22, h2, d2, c2, l2, r2, 0, i2, o2);
}
var j$ = typeof navigator != "undefined" ? navigator : { userAgent: "", vendor: "", platform: "" }, S$ = typeof document != "undefined" ? document : { documentElement: { style: {} } }, C$ = /Edge\/(\d+)/.exec(j$.userAgent), _$ = /MSIE \d/.test(j$.userAgent), $$ = /Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(j$.userAgent), O$ = !!(_$ || $$ || C$), A$ = !O$ && /gecko\/(\d+)/i.test(j$.userAgent), M$ = !O$ && /Chrome\/(\d+)/.exec(j$.userAgent), E$ = "webkitFontSmoothing" in S$.documentElement.style, P$ = !O$ && /Apple Computer/.test(j$.vendor), N$ = P$ && (/Mobile\/\w+/.test(j$.userAgent) || j$.maxTouchPoints > 2), T$ = { mac: N$ || /Mac/.test(j$.platform), windows: /Win/.test(j$.platform), linux: /Linux|X11/.test(j$.platform), ie: O$, ie_version: _$ ? S$.documentMode || 6 : $$ ? +$$[1] : C$ ? +C$[1] : 0, gecko: A$, gecko_version: A$ ? +(/Firefox\/(\d+)/.exec(j$.userAgent) || [0, 0])[1] : 0, chrome: !!M$, chrome_version: M$ ? +M$[1] : 0, ios: N$, android: /Android\b/.test(j$.userAgent), webkit: E$, safari: P$, webkit_version: E$ ? +(/\bAppleWebKit\/(\d+)/.exec(navigator.userAgent) || [0, 0])[1] : 0, tabSize: S$.documentElement.style.tabSize != null ? "tab-size" : "-moz-tab-size" }, I$ = function(e22) {
  ji(n2, y$);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), (r2 = t2.call(this)).text = e23, r2;
  }
  return zi(n2, [{ key: "length", get: function() {
    return this.text.length;
  } }, { key: "createDOM", value: function(e23) {
    this.setDOM(e23 || document.createTextNode(this.text));
  } }, { key: "sync", value: function(e23) {
    this.dom || this.createDOM(), this.dom.nodeValue != this.text && (e23 && e23.node == this.dom && (e23.written = true), this.dom.nodeValue = this.text);
  } }, { key: "reuseDOM", value: function(e23) {
    e23.nodeType == 3 && this.createDOM(e23);
  } }, { key: "merge", value: function(e23, t3, r2) {
    return (!r2 || r2 instanceof n2 && !(this.length - (t3 - e23) + r2.length > 256)) && (this.text = this.text.slice(0, e23) + (r2 ? r2.text : "") + this.text.slice(t3), this.markDirty(), true);
  } }, { key: "split", value: function(e23) {
    var t3 = new n2(this.text.slice(e23));
    return this.text = this.text.slice(0, e23), this.markDirty(), t3;
  } }, { key: "localPosFromDOM", value: function(e23, t3) {
    return e23 == this.dom ? t3 : t3 ? this.text.length : 0;
  } }, { key: "domAtPos", value: function(e23) {
    return new m$(this.dom, e23);
  } }, { key: "domBoundsAround", value: function(e23, t3, n3) {
    return { from: n3, to: n3 + this.length, startDOM: this.dom, endDOM: this.dom.nextSibling };
  } }, { key: "coordsAt", value: function(e23, t3) {
    return D$(this.dom, e23, t3);
  } }]), n2;
}(), R$ = function(e22) {
  ji(n2, y$);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2, i2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [], o2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    Ri(this, n2), (r2 = t2.call(this)).mark = e23, r2.children = i2, r2.length = o2;
    var a2, s2 = bi(i2);
    try {
      for (s2.s(); !(a2 = s2.n()).done; ) {
        var u2 = a2.value;
        u2.setParent($i(r2));
      }
    } catch (e24) {
      s2.e(e24);
    } finally {
      s2.f();
    }
    return r2;
  }
  return zi(n2, [{ key: "setAttrs", value: function(e23) {
    if (p$(e23), this.mark.class && (e23.className = this.mark.class), this.mark.attrs)
      for (var t3 in this.mark.attrs)
        e23.setAttribute(t3, this.mark.attrs[t3]);
    return e23;
  } }, { key: "reuseDOM", value: function(e23) {
    e23.nodeName == this.mark.tagName.toUpperCase() && (this.setDOM(e23), this.dirty |= 6);
  } }, { key: "sync", value: function(e23) {
    this.dom ? 4 & this.dirty && this.setAttrs(this.dom) : this.setDOM(this.setAttrs(document.createElement(this.mark.tagName))), ki(Ai(n2.prototype), "sync", this).call(this, e23);
  } }, { key: "merge", value: function(e23, t3, r2, i2, o2, a2) {
    return (!r2 || !(!(r2 instanceof n2 && r2.mark.eq(this.mark)) || e23 && o2 <= 0 || t3 < this.length && a2 <= 0)) && (x$(this, e23, t3, r2 ? r2.children : [], o2 - 1, a2 - 1), this.markDirty(), true);
  } }, { key: "split", value: function(e23) {
    var t3, r2 = [], i2 = 0, o2 = -1, a2 = 0, s2 = bi(this.children);
    try {
      for (s2.s(); !(t3 = s2.n()).done; ) {
        var u2 = t3.value, c2 = i2 + u2.length;
        c2 > e23 && r2.push(i2 < e23 ? u2.split(e23 - i2) : u2), o2 < 0 && i2 >= e23 && (o2 = a2), i2 = c2, a2++;
      }
    } catch (e24) {
      s2.e(e24);
    } finally {
      s2.f();
    }
    var l2 = this.length - e23;
    return this.length = e23, o2 > -1 && (this.children.length = o2, this.markDirty()), new n2(this.mark, r2, l2);
  } }, { key: "domAtPos", value: function(e23) {
    return V$(this.dom, this.children, e23);
  } }, { key: "coordsAt", value: function(e23, t3) {
    return W$(this, e23, t3);
  } }]), n2;
}();
function D$(e22, t2, n2) {
  var r2 = e22.nodeValue.length;
  t2 > r2 && (t2 = r2);
  var i2 = t2, o2 = t2, a2 = 0;
  t2 == 0 && n2 < 0 || t2 == r2 && n2 >= 0 ? T$.chrome || T$.gecko || (t2 ? (i2--, a2 = 1) : o2 < r2 && (o2++, a2 = -1)) : n2 < 0 ? i2-- : o2 < r2 && o2++;
  var s2 = h$(e22, i2, o2).getClientRects();
  if (!s2.length)
    return o$;
  var u2 = s2[(a2 ? a2 < 0 : n2 >= 0) ? 0 : s2.length - 1];
  return T$.safari && !a2 && u2.width == 0 && (u2 = Array.prototype.find.call(s2, function(e23) {
    return e23.width;
  }) || u2), a2 ? a$(u2, a2 < 0) : u2 || null;
}
var z$ = function(e22) {
  ji(n2, y$);
  var t2 = Ci(n2);
  function n2(e23, r2, i2) {
    var o2;
    return Ri(this, n2), (o2 = t2.call(this)).widget = e23, o2.length = r2, o2.side = i2, o2.prevWidget = null, o2;
  }
  return zi(n2, [{ key: "split", value: function(e23) {
    var t3 = n2.create(this.widget, this.length - e23, this.side);
    return this.length -= e23, t3;
  } }, { key: "sync", value: function() {
    this.dom && this.widget.updateDOM(this.dom) || (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(this.editorView)), this.dom.contentEditable = "false");
  } }, { key: "getSide", value: function() {
    return this.side;
  } }, { key: "merge", value: function(e23, t3, r2, i2, o2, a2) {
    return !(r2 && (!(r2 instanceof n2 && this.widget.compare(r2.widget)) || e23 > 0 && o2 <= 0 || t3 < this.length && a2 <= 0)) && (this.length = e23 + (r2 ? r2.length : 0) + (this.length - t3), true);
  } }, { key: "become", value: function(e23) {
    return e23.length == this.length && e23 instanceof n2 && e23.side == this.side && this.widget.constructor == e23.widget.constructor && (this.widget.eq(e23.widget) || this.markDirty(true), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e23.widget, true);
  } }, { key: "ignoreMutation", value: function() {
    return true;
  } }, { key: "ignoreEvent", value: function(e23) {
    return this.widget.ignoreEvent(e23);
  } }, { key: "overrideDOMText", get: function() {
    if (this.length == 0)
      return WS.empty;
    for (var e23 = this; e23.parent; )
      e23 = e23.parent;
    var t3 = e23.editorView, n3 = t3 && t3.state.doc, r2 = this.posAtStart;
    return n3 ? n3.slice(r2, r2 + this.length) : WS.empty;
  } }, { key: "domAtPos", value: function(e23) {
    return e23 == 0 ? m$.before(this.dom) : m$.after(this.dom, e23 == this.length);
  } }, { key: "domBoundsAround", value: function() {
    return null;
  } }, { key: "coordsAt", value: function(e23, t3) {
    var n3 = this.dom.getClientRects(), r2 = null;
    if (!n3.length)
      return o$;
    for (var i2 = e23 > 0 ? n3.length - 1 : 0; r2 = n3[i2], !(e23 > 0 ? i2 == 0 : i2 == n3.length - 1 || r2.top < r2.bottom); i2 += e23 > 0 ? -1 : 1)
      ;
    return e23 == 0 && t3 > 0 || e23 == this.length && t3 <= 0 ? r2 : a$(r2, e23 == 0);
  } }, { key: "isEditable", get: function() {
    return false;
  } }, { key: "destroy", value: function() {
    ki(Ai(n2.prototype), "destroy", this).call(this), this.dom && this.widget.destroy(this.dom);
  } }], [{ key: "create", value: function(e23, t3, r2) {
    return new (e23.customView || n2)(e23, t3, r2);
  } }]), n2;
}(), L$ = function(e22) {
  ji(n2, z$);
  var t2 = Ci(n2);
  function n2() {
    return Ri(this, n2), t2.apply(this, arguments);
  }
  return zi(n2, [{ key: "domAtPos", value: function(e23) {
    var t3 = this.widget, n3 = t3.topView, r2 = t3.text;
    return n3 ? B$(e23, 0, n3, r2, function(e24, t4) {
      return e24.domAtPos(t4);
    }, function(e24) {
      return new m$(r2, Math.min(e24, r2.nodeValue.length));
    }) : new m$(r2, Math.min(e23, r2.nodeValue.length));
  } }, { key: "sync", value: function() {
    this.setDOM(this.widget.toDOM());
  } }, { key: "localPosFromDOM", value: function(e23, t3) {
    var n3 = this.widget, r2 = n3.topView, i2 = n3.text;
    return r2 ? q$(e23, t3, r2, i2) : Math.min(t3, this.length);
  } }, { key: "ignoreMutation", value: function() {
    return false;
  } }, { key: "overrideDOMText", get: function() {
    return null;
  } }, { key: "coordsAt", value: function(e23, t3) {
    var n3 = this.widget, r2 = n3.topView, i2 = n3.text;
    return r2 ? B$(e23, t3, r2, i2, function(e24, t4, n4) {
      return e24.coordsAt(t4, n4);
    }, function(e24, t4) {
      return D$(i2, e24, t4);
    }) : D$(i2, e23, t3);
  } }, { key: "destroy", value: function() {
    var e23;
    ki(Ai(n2.prototype), "destroy", this).call(this), (e23 = this.widget.topView) === null || e23 === void 0 || e23.destroy();
  } }, { key: "isEditable", get: function() {
    return true;
  } }]), n2;
}();
function B$(e22, t2, n2, r2, i2, o2) {
  if (n2 instanceof R$) {
    var a2, s2 = bi(n2.children);
    try {
      for (s2.s(); !(a2 = s2.n()).done; ) {
        var u2 = a2.value, c2 = Z_(u2.dom, r2), l2 = c2 ? r2.nodeValue.length : u2.length;
        if (e22 < l2 || e22 == l2 && u2.getSide() <= 0)
          return c2 ? B$(e22, t2, u2, r2, i2, o2) : i2(u2, e22, t2);
        e22 -= l2;
      }
    } catch (e23) {
      s2.e(e23);
    } finally {
      s2.f();
    }
    return i2(n2, n2.length, -1);
  }
  return n2.dom == r2 ? o2(e22, t2) : i2(n2, e22, t2);
}
function q$(e22, t2, n2, r2) {
  if (n2 instanceof R$) {
    var i2, o2 = bi(n2.children);
    try {
      for (o2.s(); !(i2 = o2.n()).done; ) {
        var a2 = i2.value, s2 = 0, u2 = Z_(a2.dom, r2);
        if (Z_(a2.dom, e22))
          return s2 + (u2 ? q$(e22, t2, a2, r2) : a2.localPosFromDOM(e22, t2));
        s2 += u2 ? r2.nodeValue.length : a2.length;
      }
    } catch (e23) {
      o2.e(e23);
    } finally {
      o2.f();
    }
  } else if (n2.dom == r2)
    return Math.min(t2, r2.nodeValue.length);
  return n2.localPosFromDOM(e22, t2);
}
var F$ = function(e22) {
  ji(n2, y$);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), (r2 = t2.call(this)).side = e23, r2;
  }
  return zi(n2, [{ key: "length", get: function() {
    return 0;
  } }, { key: "merge", value: function() {
    return false;
  } }, { key: "become", value: function(e23) {
    return e23 instanceof n2 && e23.side == this.side;
  } }, { key: "split", value: function() {
    return new n2(this.side);
  } }, { key: "sync", value: function() {
    if (!this.dom) {
      var e23 = document.createElement("img");
      e23.className = "cm-widgetBuffer", e23.setAttribute("aria-hidden", "true"), this.setDOM(e23);
    }
  } }, { key: "getSide", value: function() {
    return this.side;
  } }, { key: "domAtPos", value: function(e23) {
    return m$.before(this.dom);
  } }, { key: "localPosFromDOM", value: function() {
    return 0;
  } }, { key: "domBoundsAround", value: function() {
    return null;
  } }, { key: "coordsAt", value: function(e23) {
    var t3 = this.dom.getBoundingClientRect(), n3 = function(e24, t4) {
      var n4 = e24.parent, r2 = n4 ? n4.children.indexOf(e24) : -1;
      for (; n4 && r2 >= 0; )
        if (t4 < 0 ? r2 > 0 : r2 < n4.children.length) {
          var i2 = n4.children[r2 + t4];
          if (i2 instanceof I$) {
            var o2 = i2.coordsAt(t4 < 0 ? i2.length : 0, t4);
            if (o2)
              return o2;
          }
          r2 += t4;
        } else {
          if (!(n4 instanceof R$ && n4.parent)) {
            var a2 = n4.dom.lastChild;
            if (a2 && a2.nodeName == "BR")
              return a2.getClientRects()[0];
            break;
          }
          r2 = n4.parent.children.indexOf(n4) + (t4 < 0 ? 0 : 1), n4 = n4.parent;
        }
      return;
    }(this, this.side > 0 ? -1 : 1);
    return n3 && n3.top < t3.bottom && n3.bottom > t3.top ? { left: t3.left, right: t3.right, top: n3.top, bottom: n3.bottom } : t3;
  } }, { key: "overrideDOMText", get: function() {
    return WS.empty;
  } }]), n2;
}();
function V$(e22, t2, n2) {
  for (var r2 = 0, i2 = 0; r2 < t2.length; r2++) {
    var o2 = t2[r2], a2 = i2 + o2.length;
    if (!(a2 == i2 && o2.getSide() <= 0)) {
      if (n2 > i2 && n2 < a2 && o2.dom.parentNode == e22)
        return o2.domAtPos(n2 - i2);
      if (n2 <= i2)
        break;
      i2 = a2;
    }
  }
  for (; r2 > 0; r2--) {
    var s2 = t2[r2 - 1].dom;
    if (s2.parentNode == e22)
      return m$.after(s2);
  }
  return new m$(e22, 0);
}
function H$(e22, t2, n2) {
  var r2, i2 = e22.children;
  n2 > 0 && t2 instanceof R$ && i2.length && (r2 = i2[i2.length - 1]) instanceof R$ && r2.mark.eq(t2.mark) ? H$(r2, t2.children[0], n2 - 1) : (i2.push(t2), t2.setParent(e22)), e22.length += t2.length;
}
function W$(e22, t2, n2) {
  for (var r2 = 0, i2 = 0; i2 < e22.children.length; i2++) {
    var o2 = e22.children[i2], a2 = r2 + o2.length, s2 = void 0;
    if ((n2 <= 0 || a2 == e22.length || o2.getSide() > 0 ? a2 >= t2 : a2 > t2) && (t2 < a2 || i2 + 1 == e22.children.length || (s2 = e22.children[i2 + 1]).length || s2.getSide() > 0)) {
      var u2 = 0;
      if (a2 == r2) {
        if (o2.getSide() <= 0)
          continue;
        u2 = n2 = -o2.getSide();
      }
      var c2 = o2.coordsAt(Math.max(0, t2 - r2), n2);
      return u2 && c2 ? a$(c2, n2 < 0) : c2;
    }
    r2 = a2;
  }
  var l2 = e22.dom.lastChild;
  if (!l2)
    return e22.dom.getBoundingClientRect();
  var f2 = e$(l2);
  return f2[f2.length - 1] || null;
}
function J$(e22, t2) {
  for (var n2 in e22)
    n2 == "class" && t2.class ? t2.class += " " + e22.class : n2 == "style" && t2.style ? t2.style += ";" + e22.style : t2[n2] = e22[n2];
  return t2;
}
function U$(e22, t2) {
  if (e22 == t2)
    return true;
  if (!e22 || !t2)
    return false;
  var n2 = Object.keys(e22), r2 = Object.keys(t2);
  if (n2.length != r2.length)
    return false;
  for (var i2 = 0, o2 = n2; i2 < o2.length; i2++) {
    var a2 = o2[i2];
    if (r2.indexOf(a2) == -1 || e22[a2] !== t2[a2])
      return false;
  }
  return true;
}
function K$(e22, t2, n2) {
  var r2 = null;
  if (t2)
    for (var i2 in t2)
      n2 && i2 in n2 || e22.removeAttribute(r2 = i2);
  if (n2)
    for (var o2 in n2)
      t2 && t2[o2] == n2[o2] || e22.setAttribute(r2 = o2, n2[o2]);
  return !!r2;
}
I$.prototype.children = z$.prototype.children = F$.prototype.children = g$;
var G$ = function() {
  function e22() {
    Ri(this, e22);
  }
  return zi(e22, [{ key: "eq", value: function(e23) {
    return false;
  } }, { key: "updateDOM", value: function(e23) {
    return false;
  } }, { key: "compare", value: function(e23) {
    return this == e23 || this.constructor == e23.constructor && this.eq(e23);
  } }, { key: "estimatedHeight", get: function() {
    return -1;
  } }, { key: "ignoreEvent", value: function(e23) {
    return true;
  } }, { key: "customView", get: function() {
    return null;
  } }, { key: "destroy", value: function(e23) {
  } }]), e22;
}(), Q$ = function(e22) {
  return e22[e22.Text = 0] = "Text", e22[e22.WidgetBefore = 1] = "WidgetBefore", e22[e22.WidgetAfter = 2] = "WidgetAfter", e22[e22.WidgetRange = 3] = "WidgetRange", e22;
}(Q$ || (Q$ = {})), Y$ = function(e22) {
  ji(n2, m_);
  var t2 = Ci(n2);
  function n2(e23, r2, i2, o2) {
    var a2;
    return Ri(this, n2), (a2 = t2.call(this)).startSide = e23, a2.endSide = r2, a2.widget = i2, a2.spec = o2, a2;
  }
  return zi(n2, [{ key: "heightRelevant", get: function() {
    return false;
  } }, { key: "hasHeight", value: function() {
    return !!this.widget && this.widget.estimatedHeight > -1;
  } }], [{ key: "mark", value: function(e23) {
    return new Z$(e23);
  } }, { key: "widget", value: function(e23) {
    var t3 = e23.side || 0, n3 = !!e23.block;
    return new eO(e23, t3 += n3 ? t3 > 0 ? 3e8 : -4e8 : t3 > 0 ? 1e8 : -1e8, t3, n3, e23.widget || null, false);
  } }, { key: "replace", value: function(e23) {
    var t3, n3, r2 = !!e23.block;
    if (e23.isBlockGap)
      t3 = -5e8, n3 = 4e8;
    else {
      var i2 = tO(e23, r2);
      t3 = (i2.start ? r2 ? -3e8 : -1 : 5e8) - 1, n3 = 1 + (i2.end ? r2 ? 2e8 : 1 : -6e8);
    }
    return new eO(e23, t3, n3, r2, e23.widget || null, true);
  } }, { key: "line", value: function(e23) {
    return new X$(e23);
  } }, { key: "set", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1];
    return k_.of(e23, t3);
  } }]), n2;
}();
Y$.none = k_.empty;
var Z$ = function(e22) {
  ji(n2, Y$);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    Ri(this, n2);
    var i2 = tO(e23), o2 = i2.start, a2 = i2.end;
    return (r2 = t2.call(this, o2 ? -1 : 5e8, a2 ? 1 : -6e8, null, e23)).tagName = e23.tagName || "span", r2.class = e23.class || "", r2.attrs = e23.attributes || null, r2;
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return this == e23 || e23 instanceof n2 && this.tagName == e23.tagName && this.class == e23.class && U$(this.attrs, e23.attrs);
  } }, { key: "range", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23;
    if (e23 >= t3)
      throw new RangeError("Mark decorations may not be empty");
    return ki(Ai(n2.prototype), "range", this).call(this, e23, t3);
  } }]), n2;
}();
Z$.prototype.point = false;
var X$ = function(e22) {
  ji(n2, Y$);
  var t2 = Ci(n2);
  function n2(e23) {
    return Ri(this, n2), t2.call(this, -2e8, -2e8, null, e23);
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return e23 instanceof n2 && U$(this.spec.attributes, e23.spec.attributes);
  } }, { key: "range", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23;
    if (t3 != e23)
      throw new RangeError("Line decoration ranges must be zero-length");
    return ki(Ai(n2.prototype), "range", this).call(this, e23, t3);
  } }]), n2;
}();
X$.prototype.mapMode = vC.TrackBefore, X$.prototype.point = true;
var eO = function(e22) {
  ji(n2, Y$);
  var t2 = Ci(n2);
  function n2(e23, r2, i2, o2, a2, s2) {
    var u2;
    return Ri(this, n2), (u2 = t2.call(this, r2, i2, a2, e23)).block = o2, u2.isReplace = s2, u2.mapMode = o2 ? r2 <= 0 ? vC.TrackBefore : vC.TrackAfter : vC.TrackDel, u2;
  }
  return zi(n2, [{ key: "type", get: function() {
    return this.startSide < this.endSide ? Q$.WidgetRange : this.startSide <= 0 ? Q$.WidgetBefore : Q$.WidgetAfter;
  } }, { key: "heightRelevant", get: function() {
    return this.block || !!this.widget && this.widget.estimatedHeight >= 5;
  } }, { key: "eq", value: function(e23) {
    return e23 instanceof n2 && (t3 = this.widget, r2 = e23.widget, t3 == r2 || !!(t3 && r2 && t3.compare(r2))) && this.block == e23.block && this.startSide == e23.startSide && this.endSide == e23.endSide;
    var t3, r2;
  } }, { key: "range", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23;
    if (this.isReplace && (e23 > t3 || e23 == t3 && this.startSide > 0 && this.endSide <= 0))
      throw new RangeError("Invalid range for replacement decoration");
    if (!this.isReplace && t3 != e23)
      throw new RangeError("Widget decorations can only have zero-length ranges");
    return ki(Ai(n2.prototype), "range", this).call(this, e23, t3);
  } }]), n2;
}();
function tO(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1], n2 = e22.inclusiveStart, r2 = e22.inclusiveEnd;
  return n2 == null && (n2 = e22.inclusive), r2 == null && (r2 = e22.inclusive), { start: n2 != null ? n2 : t2, end: r2 != null ? r2 : t2 };
}
function nO(e22, t2, n2) {
  var r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0, i2 = n2.length - 1;
  i2 >= 0 && n2[i2] + r2 >= e22 ? n2[i2] = Math.max(n2[i2], t2) : n2.push(e22, t2);
}
eO.prototype.point = true;
var rO = function(e22) {
  ji(n2, y$);
  var t2 = Ci(n2);
  function n2() {
    var e23;
    return Ri(this, n2), (e23 = t2.apply(this, arguments)).children = [], e23.length = 0, e23.prevAttrs = void 0, e23.attrs = null, e23.breakAfter = 0, e23;
  }
  return zi(n2, [{ key: "merge", value: function(e23, t3, r2, i2, o2, a2) {
    if (r2) {
      if (!(r2 instanceof n2))
        return false;
      this.dom || r2.transferDOM(this);
    }
    return i2 && this.setDeco(r2 ? r2.attrs : null), x$(this, e23, t3, r2 ? r2.children : [], o2, a2), true;
  } }, { key: "split", value: function(e23) {
    var t3 = new n2();
    if (t3.breakAfter = this.breakAfter, this.length == 0)
      return t3;
    var r2 = this.childPos(e23), i2 = r2.i, o2 = r2.off;
    o2 && (t3.append(this.children[i2].split(o2), 0), this.children[i2].merge(o2, this.children[i2].length, null, false, 0, 0), i2++);
    for (var a2 = i2; a2 < this.children.length; a2++)
      t3.append(this.children[a2], 0);
    for (; i2 > 0 && this.children[i2 - 1].length == 0; )
      this.children[--i2].destroy();
    return this.children.length = i2, this.markDirty(), this.length = e23, t3;
  } }, { key: "transferDOM", value: function(e23) {
    this.dom && (this.markDirty(), e23.setDOM(this.dom), e23.prevAttrs = this.prevAttrs === void 0 ? this.attrs : this.prevAttrs, this.prevAttrs = void 0, this.dom = null);
  } }, { key: "setDeco", value: function(e23) {
    U$(this.attrs, e23) || (this.dom && (this.prevAttrs = this.attrs, this.markDirty()), this.attrs = e23);
  } }, { key: "append", value: function(e23, t3) {
    H$(this, e23, t3);
  } }, { key: "addLineDeco", value: function(e23) {
    var t3 = e23.spec.attributes, n3 = e23.spec.class;
    t3 && (this.attrs = J$(t3, this.attrs || {})), n3 && (this.attrs = J$({ class: n3 }, this.attrs || {}));
  } }, { key: "domAtPos", value: function(e23) {
    return V$(this.dom, this.children, e23);
  } }, { key: "reuseDOM", value: function(e23) {
    e23.nodeName == "DIV" && (this.setDOM(e23), this.dirty |= 6);
  } }, { key: "sync", value: function(e23) {
    var t3;
    this.dom ? 4 & this.dirty && (p$(this.dom), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0) : (this.setDOM(document.createElement("div")), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0), this.prevAttrs !== void 0 && (K$(this.dom, this.prevAttrs, this.attrs), this.dom.classList.add("cm-line"), this.prevAttrs = void 0), ki(Ai(n2.prototype), "sync", this).call(this, e23);
    for (var r2 = this.dom.lastChild; r2 && y$.get(r2) instanceof R$; )
      r2 = r2.lastChild;
    if (!(r2 && this.length && (r2.nodeName == "BR" || ((t3 = y$.get(r2)) === null || t3 === void 0 ? void 0 : t3.isEditable) != 0 || T$.ios && this.children.some(function(e24) {
      return e24 instanceof I$;
    })))) {
      var i2 = document.createElement("BR");
      i2.cmIgnore = true, this.dom.appendChild(i2);
    }
  } }, { key: "measureTextSize", value: function() {
    if (this.children.length == 0 || this.length > 20)
      return null;
    var e23, t3 = 0, n3 = bi(this.children);
    try {
      for (n3.s(); !(e23 = n3.n()).done; ) {
        var r2 = e23.value;
        if (!(r2 instanceof I$))
          return null;
        var i2 = e$(r2.dom);
        if (i2.length != 1)
          return null;
        t3 += i2[0].width;
      }
    } catch (e24) {
      n3.e(e24);
    } finally {
      n3.f();
    }
    return { lineHeight: this.dom.getBoundingClientRect().height, charWidth: t3 / this.length };
  } }, { key: "coordsAt", value: function(e23, t3) {
    return W$(this, e23, t3);
  } }, { key: "become", value: function(e23) {
    return false;
  } }, { key: "type", get: function() {
    return Q$.Text;
  } }], [{ key: "find", value: function(e23, t3) {
    for (var r2 = 0, i2 = 0; r2 < e23.children.length; r2++) {
      var o2 = e23.children[r2], a2 = i2 + o2.length;
      if (a2 >= t3) {
        if (o2 instanceof n2)
          return o2;
        if (a2 > t3)
          break;
      }
      i2 = a2 + o2.breakAfter;
    }
    return null;
  } }]), n2;
}(), iO = function(e22) {
  ji(n2, y$);
  var t2 = Ci(n2);
  function n2(e23, r2, i2) {
    var o2;
    return Ri(this, n2), (o2 = t2.call(this)).widget = e23, o2.length = r2, o2.type = i2, o2.breakAfter = 0, o2.prevWidget = null, o2;
  }
  return zi(n2, [{ key: "merge", value: function(e23, t3, r2, i2, o2, a2) {
    return !(r2 && (!(r2 instanceof n2 && this.widget.compare(r2.widget)) || e23 > 0 && o2 <= 0 || t3 < this.length && a2 <= 0)) && (this.length = e23 + (r2 ? r2.length : 0) + (this.length - t3), true);
  } }, { key: "domAtPos", value: function(e23) {
    return e23 == 0 ? m$.before(this.dom) : m$.after(this.dom, e23 == this.length);
  } }, { key: "split", value: function(e23) {
    var t3 = this.length - e23;
    this.length = e23;
    var r2 = new n2(this.widget, t3, this.type);
    return r2.breakAfter = this.breakAfter, r2;
  } }, { key: "children", get: function() {
    return g$;
  } }, { key: "sync", value: function() {
    this.dom && this.widget.updateDOM(this.dom) || (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(this.editorView)), this.dom.contentEditable = "false");
  } }, { key: "overrideDOMText", get: function() {
    return this.parent ? this.parent.view.state.doc.slice(this.posAtStart, this.posAtEnd) : WS.empty;
  } }, { key: "domBoundsAround", value: function() {
    return null;
  } }, { key: "become", value: function(e23) {
    return e23 instanceof n2 && e23.type == this.type && e23.widget.constructor == this.widget.constructor && (e23.widget.eq(this.widget) || this.markDirty(true), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e23.widget, this.length = e23.length, this.breakAfter = e23.breakAfter, true);
  } }, { key: "ignoreMutation", value: function() {
    return true;
  } }, { key: "ignoreEvent", value: function(e23) {
    return this.widget.ignoreEvent(e23);
  } }, { key: "destroy", value: function() {
    ki(Ai(n2.prototype), "destroy", this).call(this), this.dom && this.widget.destroy(this.dom);
  } }]), n2;
}(), oO = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.doc = t2, this.pos = n2, this.end = r2, this.disallowBlockEffectsFor = i2, this.content = [], this.curLine = null, this.breakAtStart = 0, this.pendingBuffer = 0, this.atCursorPos = true, this.openStart = -1, this.openEnd = -1, this.text = "", this.textOff = 0, this.cursor = t2.iter(), this.skip = n2;
  }
  return zi(e22, [{ key: "posCovered", value: function() {
    if (this.content.length == 0)
      return !this.breakAtStart && this.doc.lineAt(this.pos).from != this.pos;
    var e23 = this.content[this.content.length - 1];
    return !(e23.breakAfter || e23 instanceof iO && e23.type == Q$.WidgetBefore);
  } }, { key: "getLine", value: function() {
    return this.curLine || (this.content.push(this.curLine = new rO()), this.atCursorPos = true), this.curLine;
  } }, { key: "flushBuffer", value: function(e23) {
    this.pendingBuffer && (this.curLine.append(aO(new F$(-1), e23), e23.length), this.pendingBuffer = 0);
  } }, { key: "addBlockWidget", value: function(e23) {
    this.flushBuffer([]), this.curLine = null, this.content.push(e23);
  } }, { key: "finish", value: function(e23) {
    e23 ? this.pendingBuffer = 0 : this.flushBuffer([]), this.posCovered() || this.getLine();
  } }, { key: "buildText", value: function(e23, t2, n2) {
    for (; e23 > 0; ) {
      if (this.textOff == this.text.length) {
        var r2 = this.cursor.next(this.skip), i2 = r2.value, o2 = r2.lineBreak, a2 = r2.done;
        if (this.skip = 0, a2)
          throw new Error("Ran out of text content when drawing inline views");
        if (o2) {
          this.posCovered() || this.getLine(), this.content.length ? this.content[this.content.length - 1].breakAfter = 1 : this.breakAtStart = 1, this.flushBuffer([]), this.curLine = null, e23--;
          continue;
        }
        this.text = i2, this.textOff = 0;
      }
      var s2 = Math.min(this.text.length - this.textOff, e23, 512);
      this.flushBuffer(t2.slice(0, n2)), this.getLine().append(aO(new I$(this.text.slice(this.textOff, this.textOff + s2)), t2), n2), this.atCursorPos = true, this.textOff += s2, e23 -= s2, n2 = 0;
    }
  } }, { key: "span", value: function(e23, t2, n2, r2) {
    this.buildText(t2 - e23, n2, r2), this.pos = t2, this.openStart < 0 && (this.openStart = r2);
  } }, { key: "point", value: function(e23, t2, n2, r2, i2, o2) {
    if (this.disallowBlockEffectsFor[o2] && n2 instanceof eO) {
      if (n2.block)
        throw new RangeError("Block decorations may not be specified via plugins");
      if (t2 > this.doc.lineAt(this.pos).to)
        throw new RangeError("Decorations that replace line breaks may not be specified via plugins");
    }
    var a2 = t2 - e23;
    if (n2 instanceof eO)
      if (n2.block) {
        var s2 = n2.type;
        s2 != Q$.WidgetAfter || this.posCovered() || this.getLine(), this.addBlockWidget(new iO(n2.widget || new sO("div"), a2, s2));
      } else {
        var u2 = z$.create(n2.widget || new sO("span"), a2, n2.startSide), c2 = this.atCursorPos && !u2.isEditable && i2 <= r2.length && (e23 < t2 || n2.startSide > 0), l2 = !u2.isEditable && (e23 < t2 || n2.startSide <= 0), f2 = this.getLine();
        this.pendingBuffer != 2 || c2 || (this.pendingBuffer = 0), this.flushBuffer(r2), c2 && (f2.append(aO(new F$(1), r2), i2), i2 = r2.length + Math.max(0, i2 - r2.length)), f2.append(aO(u2, r2), i2), this.atCursorPos = l2, this.pendingBuffer = l2 ? e23 < t2 ? 1 : 2 : 0;
      }
    else
      this.doc.lineAt(this.pos).from == this.pos && this.getLine().addLineDeco(n2);
    a2 && (this.textOff + a2 <= this.text.length ? this.textOff += a2 : (this.skip += a2 - (this.text.length - this.textOff), this.text = "", this.textOff = 0), this.pos = t2), this.openStart < 0 && (this.openStart = i2);
  } }], [{ key: "build", value: function(t2, n2, r2, i2, o2) {
    var a2 = new e22(t2, n2, r2, o2);
    return a2.openEnd = k_.spans(i2, n2, r2, a2), a2.openStart < 0 && (a2.openStart = a2.openEnd), a2.finish(a2.openEnd), a2;
  } }]), e22;
}();
function aO(e22, t2) {
  var n2, r2 = bi(t2);
  try {
    for (r2.s(); !(n2 = r2.n()).done; ) {
      var i2 = n2.value;
      e22 = new R$(i2, [e22], e22.length);
    }
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
  return e22;
}
var sO = function(e22) {
  ji(n2, G$);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), (r2 = t2.call(this)).tag = e23, r2;
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return e23.tag == this.tag;
  } }, { key: "toDOM", value: function() {
    return document.createElement(this.tag);
  } }, { key: "updateDOM", value: function(e23) {
    return e23.nodeName.toLowerCase() == this.tag;
  } }]), n2;
}(), uO = $C.define(), cO = $C.define(), lO = $C.define(), fO = $C.define(), hO = $C.define(), dO = $C.define(), vO = $C.define({ combine: function(e22) {
  return e22.some(function(e23) {
    return e23;
  });
} }), pO = function() {
  function e22(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "nearest", r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "nearest", i2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 5, o2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 5;
    Ri(this, e22), this.range = t2, this.y = n2, this.x = r2, this.yMargin = i2, this.xMargin = o2;
  }
  return zi(e22, [{ key: "map", value: function(t2) {
    return t2.empty ? this : new e22(this.range.map(t2), this.y, this.x, this.yMargin, this.xMargin);
  } }]), e22;
}(), mO = n_.define({ map: function(e22, t2) {
  return e22.map(t2);
} });
function gO(e22, t2, n2) {
  var r2 = e22.facet(fO);
  r2.length ? r2[0](t2) : window.onerror ? window.onerror(String(t2), n2, void 0, void 0, t2) : n2 ? console.error(n2 + ":", t2) : console.error(t2);
}
var yO = $C.define({ combine: function(e22) {
  return !e22.length || e22[0];
} }), bO = 0, kO = $C.define(), wO = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.id = t2, this.create = n2, this.domEventHandlers = r2, this.extension = i2(this);
  }
  return zi(e22, null, [{ key: "define", value: function(t2, n2) {
    var r2 = n2 || {}, i2 = r2.eventHandlers, o2 = r2.provide, a2 = r2.decorations;
    return new e22(bO++, t2, i2, function(e23) {
      var t3 = [kO.of(e23)];
      return a2 && t3.push(CO.of(function(t4) {
        var n3 = t4.plugin(e23);
        return n3 ? a2(n3) : Y$.none;
      })), o2 && t3.push(o2(e23)), t3;
    });
  } }, { key: "fromClass", value: function(t2, n2) {
    return e22.define(function(e23) {
      return new t2(e23);
    }, n2);
  } }]), e22;
}(), xO = function() {
  function e22(t2) {
    Ri(this, e22), this.spec = t2, this.mustUpdate = null, this.value = null;
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    if (this.value) {
      if (this.mustUpdate) {
        var t2 = this.mustUpdate;
        if (this.mustUpdate = null, this.value.update)
          try {
            this.value.update(t2);
          } catch (e24) {
            if (gO(t2.state, e24, "CodeMirror plugin crashed"), this.value.destroy)
              try {
                this.value.destroy();
              } catch (e25) {
              }
            this.deactivate();
          }
      }
    } else if (this.spec)
      try {
        this.value = this.spec.create(e23);
      } catch (t3) {
        gO(e23.state, t3, "CodeMirror plugin crashed"), this.deactivate();
      }
    return this;
  } }, { key: "destroy", value: function(e23) {
    var t2;
    if ((t2 = this.value) === null || t2 === void 0 ? void 0 : t2.destroy)
      try {
        this.value.destroy();
      } catch (t3) {
        gO(e23.state, t3, "CodeMirror plugin crashed");
      }
  } }, { key: "deactivate", value: function() {
    this.spec = this.value = null;
  } }]), e22;
}(), jO = $C.define(), SO = $C.define(), CO = $C.define(), _O = $C.define(), $O = $C.define(), OO = $C.define(), AO = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.fromA = t2, this.toA = n2, this.fromB = r2, this.toB = i2;
  }
  return zi(e22, [{ key: "join", value: function(t2) {
    return new e22(Math.min(this.fromA, t2.fromA), Math.max(this.toA, t2.toA), Math.min(this.fromB, t2.fromB), Math.max(this.toB, t2.toB));
  } }, { key: "addToSet", value: function(e23) {
    for (var t2 = e23.length, n2 = this; t2 > 0; t2--) {
      var r2 = e23[t2 - 1];
      if (!(r2.fromA > n2.toA)) {
        if (r2.toA < n2.fromA)
          break;
        n2 = n2.join(r2), e23.splice(t2 - 1, 1);
      }
    }
    return e23.splice(t2, 0, n2), e23;
  } }], [{ key: "extendWithRanges", value: function(t2, n2) {
    if (n2.length == 0)
      return t2;
    for (var r2 = [], i2 = 0, o2 = 0, a2 = 0, s2 = 0; ; i2++) {
      for (var u2 = i2 == t2.length ? null : t2[i2], c2 = a2 - s2, l2 = u2 ? u2.fromB : 1e9; o2 < n2.length && n2[o2] < l2; ) {
        var f2 = n2[o2], h2 = n2[o2 + 1], d2 = Math.max(s2, f2), v2 = Math.min(l2, h2);
        if (d2 <= v2 && new e22(d2 + c2, v2 + c2, d2, v2).addToSet(r2), h2 > l2)
          break;
        o2 += 2;
      }
      if (!u2)
        return r2;
      new e22(u2.fromA, u2.toA, u2.fromB, u2.toB).addToSet(r2), a2 = u2.toA, s2 = u2.toB;
    }
  } }]), e22;
}(), MO = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.view = t2, this.state = n2, this.transactions = r2, this.flags = 0, this.startState = t2.state, this.changes = mC.empty(this.startState.doc.length);
    var i2, o2 = bi(r2);
    try {
      for (o2.s(); !(i2 = o2.n()).done; ) {
        var a2 = i2.value;
        this.changes = this.changes.compose(a2.changes);
      }
    } catch (e23) {
      o2.e(e23);
    } finally {
      o2.f();
    }
    var s2 = [];
    this.changes.iterChangedRanges(function(e23, t3, n3, r3) {
      return s2.push(new AO(e23, t3, n3, r3));
    }), this.changedRanges = s2;
    var u2 = t2.hasFocus;
    u2 != t2.inputState.notifiedFocused && (t2.inputState.notifiedFocused = u2, this.flags |= 1);
  }
  return zi(e22, [{ key: "viewportChanged", get: function() {
    return (4 & this.flags) > 0;
  } }, { key: "heightChanged", get: function() {
    return (2 & this.flags) > 0;
  } }, { key: "geometryChanged", get: function() {
    return this.docChanged || (10 & this.flags) > 0;
  } }, { key: "focusChanged", get: function() {
    return (1 & this.flags) > 0;
  } }, { key: "docChanged", get: function() {
    return !this.changes.empty;
  } }, { key: "selectionSet", get: function() {
    return this.transactions.some(function(e23) {
      return e23.selection;
    });
  } }, { key: "empty", get: function() {
    return this.flags == 0 && this.transactions.length == 0;
  } }], [{ key: "create", value: function(t2, n2, r2) {
    return new e22(t2, n2, r2);
  } }]), e22;
}(), EO = function(e22) {
  return e22[e22.LTR = 0] = "LTR", e22[e22.RTL = 1] = "RTL", e22;
}(EO || (EO = {})), PO = EO.LTR, NO = EO.RTL;
function TO(e22) {
  for (var t2 = [], n2 = 0; n2 < e22.length; n2++)
    t2.push(1 << +e22[n2]);
  return t2;
}
for (var IO = TO("88888888888888888888888888888888888666888888787833333333337888888000000000000000000000000008888880000000000000000000000000088888888888888888888888888888888888887866668888088888663380888308888800000000000000000000000800000000000000000000000000000008"), RO = TO("4444448826627288999999999992222222222222222222222222222222222222222222222229999999999999999999994444444444644222822222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222999999949999999229989999223333333333"), DO = /* @__PURE__ */ Object.create(null), zO = [], LO = 0, BO = ["()", "[]", "{}"]; LO < BO.length; LO++) {
  var qO = BO[LO], FO = qO.charCodeAt(0), VO = qO.charCodeAt(1);
  DO[FO] = VO, DO[VO] = -FO;
}
function HO(e22) {
  return e22 <= 247 ? IO[e22] : 1424 <= e22 && e22 <= 1524 ? 2 : 1536 <= e22 && e22 <= 1785 ? RO[e22 - 1536] : 1774 <= e22 && e22 <= 2220 ? 4 : 8192 <= e22 && e22 <= 8203 || e22 == 8204 ? 256 : 1;
}
var WO = /[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac]/, JO = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.from = t2, this.to = n2, this.level = r2;
  }
  return zi(e22, [{ key: "dir", get: function() {
    return this.level % 2 ? NO : PO;
  } }, { key: "side", value: function(e23, t2) {
    return this.dir == t2 == e23 ? this.to : this.from;
  } }], [{ key: "find", value: function(e23, t2, n2, r2) {
    for (var i2 = -1, o2 = 0; o2 < e23.length; o2++) {
      var a2 = e23[o2];
      if (a2.from <= t2 && a2.to >= t2) {
        if (a2.level == n2)
          return o2;
        (i2 < 0 || (r2 != 0 ? r2 < 0 ? a2.from < t2 : a2.to > t2 : e23[i2].level > a2.level)) && (i2 = o2);
      }
    }
    if (i2 < 0)
      throw new RangeError("Index out of range");
    return i2;
  } }]), e22;
}(), UO = [];
function KO(e22) {
  return [new JO(0, e22, 0)];
}
var GO = "";
function QO(e22, t2, n2, r2, i2) {
  var o2, a2 = r2.head - e22.from, s2 = -1;
  if (a2 == 0) {
    if (!i2 || !e22.length)
      return null;
    t2[0].level != n2 && (a2 = t2[0].side(false, n2), s2 = 0);
  } else if (a2 == e22.length) {
    if (i2)
      return null;
    var u2 = t2[t2.length - 1];
    u2.level != n2 && (a2 = u2.side(true, n2), s2 = t2.length - 1);
  }
  s2 < 0 && (s2 = JO.find(t2, a2, (o2 = r2.bidiLevel) !== null && o2 !== void 0 ? o2 : -1, r2.assoc));
  var c2 = t2[s2];
  a2 == c2.side(i2, n2) && (a2 = (c2 = t2[s2 += i2 ? 1 : -1]).side(!i2, n2));
  var l2 = i2 == (c2.dir == n2), f2 = oC(e22.text, a2, l2);
  if (GO = e22.text.slice(Math.min(a2, f2), Math.max(a2, f2)), f2 != c2.side(i2, n2))
    return SC.cursor(f2 + e22.from, l2 ? -1 : 1, c2.level);
  var h2 = s2 == (i2 ? t2.length - 1 : 0) ? null : t2[s2 + (i2 ? 1 : -1)];
  return h2 || c2.level == n2 ? h2 && h2.level < c2.level ? SC.cursor(h2.side(!i2, n2) + e22.from, i2 ? 1 : -1, h2.level) : SC.cursor(f2 + e22.from, i2 ? -1 : 1, c2.level) : SC.cursor(i2 ? e22.to : e22.from, i2 ? -1 : 1, n2);
}
var YO = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.points = t2, this.text = "", this.lineSeparator = n2.facet(v_.lineSeparator);
  }
  return zi(e22, [{ key: "append", value: function(e23) {
    this.text += e23;
  } }, { key: "lineBreak", value: function() {
    this.text += "\uFFFF";
  } }, { key: "readRange", value: function(e23, t2) {
    if (!e23)
      return this;
    for (var n2 = e23.parentNode, r2 = e23; ; ) {
      this.findPointBefore(n2, r2), this.readNode(r2);
      var i2 = r2.nextSibling;
      if (i2 == t2)
        break;
      var o2 = y$.get(r2), a2 = y$.get(i2);
      (o2 && a2 ? o2.breakAfter : (o2 ? o2.breakAfter : ZO(r2)) || ZO(i2) && (r2.nodeName != "BR" || r2.cmIgnore)) && this.lineBreak(), r2 = i2;
    }
    return this.findPointBefore(n2, t2), this;
  } }, { key: "readTextNode", value: function(e23) {
    var t2, n2 = e23.nodeValue, r2 = bi(this.points);
    try {
      for (r2.s(); !(t2 = r2.n()).done; ) {
        var i2 = t2.value;
        i2.node == e23 && (i2.pos = this.text.length + Math.min(i2.offset, n2.length));
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    for (var o2 = 0, a2 = this.lineSeparator ? null : /\r\n?|\n/g; ; ) {
      var s2 = -1, u2 = 1, c2 = void 0;
      if (this.lineSeparator ? (s2 = n2.indexOf(this.lineSeparator, o2), u2 = this.lineSeparator.length) : (c2 = a2.exec(n2)) && (s2 = c2.index, u2 = c2[0].length), this.append(n2.slice(o2, s2 < 0 ? n2.length : s2)), s2 < 0)
        break;
      if (this.lineBreak(), u2 > 1) {
        var l2, f2 = bi(this.points);
        try {
          for (f2.s(); !(l2 = f2.n()).done; ) {
            var h2 = l2.value;
            h2.node == e23 && h2.pos > this.text.length && (h2.pos -= u2 - 1);
          }
        } catch (e24) {
          f2.e(e24);
        } finally {
          f2.f();
        }
      }
      o2 = s2 + u2;
    }
  } }, { key: "readNode", value: function(e23) {
    if (!e23.cmIgnore) {
      var t2 = y$.get(e23), n2 = t2 && t2.overrideDOMText;
      if (n2 != null) {
        this.findPointInside(e23, n2.length);
        for (var r2 = n2.iter(); !r2.next().done; )
          r2.lineBreak ? this.lineBreak() : this.append(r2.value);
      } else
        e23.nodeType == 3 ? this.readTextNode(e23) : e23.nodeName == "BR" ? e23.nextSibling && this.lineBreak() : e23.nodeType == 1 && this.readRange(e23.firstChild, null);
    }
  } }, { key: "findPointBefore", value: function(e23, t2) {
    var n2, r2 = bi(this.points);
    try {
      for (r2.s(); !(n2 = r2.n()).done; ) {
        var i2 = n2.value;
        i2.node == e23 && e23.childNodes[i2.offset] == t2 && (i2.pos = this.text.length);
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
  } }, { key: "findPointInside", value: function(e23, t2) {
    var n2, r2 = bi(this.points);
    try {
      for (r2.s(); !(n2 = r2.n()).done; ) {
        var i2 = n2.value;
        (e23.nodeType == 3 ? i2.node == e23 : e23.contains(i2.node)) && (i2.pos = this.text.length + Math.min(t2, i2.offset));
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
  } }]), e22;
}();
function ZO(e22) {
  return e22.nodeType == 1 && /^(DIV|P|LI|UL|OL|BLOCKQUOTE|DD|DT|H\d|SECTION|PRE)$/.test(e22.nodeName);
}
var XO = zi(function e4(t2, n2) {
  Ri(this, e4), this.node = t2, this.offset = n2, this.pos = -1;
}), eA = function(e22) {
  ji(n2, y$);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), (r2 = t2.call(this)).view = e23, r2.compositionDeco = Y$.none, r2.decorations = [], r2.dynamicDecorationMap = [], r2.minWidth = 0, r2.minWidthFrom = 0, r2.minWidthTo = 0, r2.impreciseAnchor = null, r2.impreciseHead = null, r2.forceSelection = false, r2.lastUpdate = Date.now(), r2.setDOM(e23.contentDOM), r2.children = [new rO()], r2.children[0].setParent($i(r2)), r2.updateDeco(), r2.updateInner([new AO(0, 0, 0, e23.state.doc.length)], 0), r2;
  }
  return zi(n2, [{ key: "root", get: function() {
    return this.view.root;
  } }, { key: "editorView", get: function() {
    return this.view;
  } }, { key: "length", get: function() {
    return this.view.state.doc.length;
  } }, { key: "update", value: function(e23) {
    var t3 = this, n3 = e23.changedRanges;
    this.minWidth > 0 && n3.length && (n3.every(function(e24) {
      var n4 = e24.fromA;
      return e24.toA < t3.minWidthFrom || n4 > t3.minWidthTo;
    }) ? (this.minWidthFrom = e23.changes.mapPos(this.minWidthFrom, 1), this.minWidthTo = e23.changes.mapPos(this.minWidthTo, 1)) : this.minWidth = this.minWidthFrom = this.minWidthTo = 0), this.view.inputState.composing < 0 ? this.compositionDeco = Y$.none : (e23.transactions.length || this.dirty) && (this.compositionDeco = function(e24, t4) {
      var n4 = rA(e24);
      if (!n4)
        return Y$.none;
      var r3 = n4.from, i3 = n4.to, o3 = n4.node, a3 = n4.text, s3 = t4.mapPos(r3, 1), u3 = Math.max(s3, t4.mapPos(i3, -1)), c3 = e24.state, l2 = o3.nodeType == 3 ? o3.nodeValue : new YO([], c3).readRange(o3.firstChild, null).text;
      if (u3 - s3 < l2.length)
        if (c3.doc.sliceString(s3, Math.min(c3.doc.length, s3 + l2.length), "\uFFFF") == l2)
          u3 = s3 + l2.length;
        else {
          if (c3.doc.sliceString(Math.max(0, u3 - l2.length), u3, "\uFFFF") != l2)
            return Y$.none;
          s3 = u3 - l2.length;
        }
      else if (c3.doc.sliceString(s3, u3, "\uFFFF") != l2)
        return Y$.none;
      var f2 = y$.get(o3);
      f2 instanceof L$ ? f2 = f2.widget.topView : f2 && (f2.parent = null);
      return Y$.set(Y$.replace({ widget: new iA(o3, a3, f2), inclusive: true }).range(s3, u3));
    }(this.view, e23.changes)), (T$.ie || T$.chrome) && !this.compositionDeco.size && e23 && e23.state.doc.lines != e23.startState.doc.lines && (this.forceSelection = true);
    var r2, i2, o2, a2, s2 = this.decorations, u2 = this.updateDeco(), c2 = (r2 = s2, i2 = u2, o2 = e23.changes, a2 = new sA(), k_.compare(r2, i2, o2, a2), a2.changes);
    return n3 = AO.extendWithRanges(n3, c2), (this.dirty != 0 || n3.length != 0) && (this.updateInner(n3, e23.startState.doc.length), e23.transactions.length && (this.lastUpdate = Date.now()), true);
  } }, { key: "updateInner", value: function(e23, t3) {
    var n3 = this;
    this.view.viewState.mustMeasureContent = true, this.updateChildren(e23, t3);
    var r2 = this.view.observer;
    r2.ignore(function() {
      n3.dom.style.height = n3.view.viewState.contentHeight + "px", n3.dom.style.flexBasis = n3.minWidth ? n3.minWidth + "px" : "";
      var e24 = T$.chrome || T$.ios ? { node: r2.selectionRange.focusNode, written: false } : void 0;
      n3.sync(e24), n3.dirty = 0, e24 && (e24.written || r2.selectionRange.focusNode != e24.node) && (n3.forceSelection = true), n3.dom.style.height = "";
    });
    var i2 = [];
    if (this.view.viewport.from || this.view.viewport.to < this.view.state.doc.length) {
      var o2, a2 = bi(this.children);
      try {
        for (a2.s(); !(o2 = a2.n()).done; ) {
          var s2 = o2.value;
          s2 instanceof iO && s2.widget instanceof nA && i2.push(s2.dom);
        }
      } catch (e24) {
        a2.e(e24);
      } finally {
        a2.f();
      }
    }
    r2.updateGaps(i2);
  } }, { key: "updateChildren", value: function(e23, t3) {
    for (var n3 = this.childCursor(t3), r2 = e23.length - 1; ; r2--) {
      var i2 = r2 >= 0 ? e23[r2] : null;
      if (!i2)
        break;
      var o2 = i2.fromA, a2 = i2.toA, s2 = i2.fromB, u2 = i2.toB, c2 = oO.build(this.view.state.doc, s2, u2, this.decorations, this.dynamicDecorationMap), l2 = c2.content, f2 = c2.breakAtStart, h2 = c2.openStart, d2 = c2.openEnd, v2 = n3.findPos(a2, 1), p2 = v2.i, m2 = v2.off, g2 = n3.findPos(o2, -1);
      w$(this, g2.i, g2.off, p2, m2, l2, f2, h2, d2);
    }
  } }, { key: "updateSelection", value: function() {
    var e23 = this, t3 = arguments.length > 0 && arguments[0] !== void 0 && arguments[0], n3 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1];
    if (!t3 && this.view.observer.selectionRange.focusNode || this.view.observer.readSelectionRange(), !(!n3 && !this.mayControlSelection() || T$.ios && this.view.inputState.rapidCompositionStart)) {
      var r2 = this.forceSelection;
      this.forceSelection = false;
      var i2 = this.view.state.selection.main, o2 = this.domAtPos(i2.anchor), a2 = i2.empty ? o2 : this.domAtPos(i2.head);
      if (T$.gecko && i2.empty && tA(o2)) {
        var s2 = document.createTextNode("");
        this.view.observer.ignore(function() {
          return o2.node.insertBefore(s2, o2.node.childNodes[o2.offset] || null);
        }), o2 = a2 = new m$(s2, 0), r2 = true;
      }
      var u2 = this.view.observer.selectionRange;
      !r2 && u2.focusNode && t$(o2.node, o2.offset, u2.anchorNode, u2.anchorOffset) && t$(a2.node, a2.offset, u2.focusNode, u2.focusOffset) || (this.view.observer.ignore(function() {
        T$.android && T$.chrome && e23.dom.contains(u2.focusNode) && uA(u2.focusNode, e23.dom) && (e23.dom.blur(), e23.dom.focus({ preventScroll: true }));
        var t4 = Y_(e23.root);
        if (t4)
          if (i2.empty) {
            if (T$.gecko) {
              var n4 = aA(o2.node, o2.offset);
              if (n4 && n4 != 3) {
                var r3 = oA(o2.node, o2.offset, n4 == 1 ? 1 : -1);
                r3 && (o2 = new m$(r3, n4 == 1 ? 0 : r3.nodeValue.length));
              }
            }
            t4.collapse(o2.node, o2.offset), i2.bidiLevel != null && u2.cursorBidiLevel != null && (u2.cursorBidiLevel = i2.bidiLevel);
          } else if (t4.extend)
            t4.collapse(o2.node, o2.offset), t4.extend(a2.node, a2.offset);
          else {
            var s3 = document.createRange();
            if (i2.anchor > i2.head) {
              var c2 = [a2, o2];
              o2 = c2[0], a2 = c2[1];
            }
            s3.setEnd(a2.node, a2.offset), s3.setStart(o2.node, o2.offset), t4.removeAllRanges(), t4.addRange(s3);
          }
      }), this.view.observer.setSelectionRange(o2, a2)), this.impreciseAnchor = o2.precise ? null : new m$(u2.anchorNode, u2.anchorOffset), this.impreciseHead = a2.precise ? null : new m$(u2.focusNode, u2.focusOffset);
    }
  } }, { key: "enforceCursorAssoc", value: function() {
    if (!this.compositionDeco.size) {
      var e23 = this.view.state.selection.main, t3 = Y_(this.root);
      if (t3 && e23.empty && e23.assoc && t3.modify) {
        var n3 = rO.find(this, e23.head);
        if (n3) {
          var r2 = n3.posAtStart;
          if (e23.head != r2 && e23.head != r2 + n3.length) {
            var i2 = this.coordsAt(e23.head, -1), o2 = this.coordsAt(e23.head, 1);
            if (i2 && o2 && !(i2.bottom > o2.top)) {
              var a2 = this.domAtPos(e23.head + e23.assoc);
              t3.collapse(a2.node, a2.offset), t3.modify("move", e23.assoc < 0 ? "forward" : "backward", "lineboundary");
            }
          }
        }
      }
    }
  } }, { key: "mayControlSelection", value: function() {
    var e23 = this.root.activeElement;
    return e23 == this.dom || X_(this.dom, this.view.observer.selectionRange) && !(e23 && this.dom.contains(e23));
  } }, { key: "nearest", value: function(e23) {
    for (var t3 = e23; t3; ) {
      var n3 = y$.get(t3);
      if (n3 && n3.rootView == this)
        return n3;
      t3 = t3.parentNode;
    }
    return null;
  } }, { key: "posFromDOM", value: function(e23, t3) {
    var n3 = this.nearest(e23);
    if (!n3)
      throw new RangeError("Trying to find position for a DOM position outside of the document");
    return n3.localPosFromDOM(e23, t3) + n3.posAtStart;
  } }, { key: "domAtPos", value: function(e23) {
    for (var t3 = this.childCursor().findPos(e23, -1), n3 = t3.i, r2 = t3.off; n3 < this.children.length - 1; ) {
      var i2 = this.children[n3];
      if (r2 < i2.length || i2 instanceof rO)
        break;
      n3++, r2 = 0;
    }
    return this.children[n3].domAtPos(r2);
  } }, { key: "coordsAt", value: function(e23, t3) {
    for (var n3 = this.length, r2 = this.children.length - 1; ; r2--) {
      var i2 = this.children[r2], o2 = n3 - i2.breakAfter - i2.length;
      if (e23 > o2 || e23 == o2 && i2.type != Q$.WidgetBefore && i2.type != Q$.WidgetAfter && (!r2 || t3 == 2 || this.children[r2 - 1].breakAfter || this.children[r2 - 1].type == Q$.WidgetBefore && t3 > -2))
        return i2.coordsAt(e23 - o2, t3);
      n3 = o2;
    }
  } }, { key: "measureVisibleLineHeights", value: function(e23) {
    for (var t3 = [], n3 = e23.from, r2 = e23.to, i2 = this.view.contentDOM.clientWidth, o2 = i2 > Math.max(this.view.scrollDOM.clientWidth, this.minWidth) + 1, a2 = -1, s2 = this.view.textDirection == EO.LTR, u2 = 0, c2 = 0; c2 < this.children.length; c2++) {
      var l2 = this.children[c2], f2 = u2 + l2.length;
      if (f2 > r2)
        break;
      if (u2 >= n3) {
        var h2 = l2.dom.getBoundingClientRect();
        if (t3.push(h2.height), o2) {
          var d2 = l2.dom.lastChild, v2 = d2 ? e$(d2) : [];
          if (v2.length) {
            var p2 = v2[v2.length - 1], m2 = s2 ? p2.right - h2.left : h2.right - p2.left;
            m2 > a2 && (a2 = m2, this.minWidth = i2, this.minWidthFrom = u2, this.minWidthTo = f2);
          }
        }
      }
      u2 = f2 + l2.breakAfter;
    }
    return t3;
  } }, { key: "textDirectionAt", value: function(e23) {
    var t3 = this.childPos(e23, 1).i;
    return getComputedStyle(this.children[t3].dom).direction == "rtl" ? EO.RTL : EO.LTR;
  } }, { key: "measureTextSize", value: function() {
    var e23, t3 = this, n3 = bi(this.children);
    try {
      for (n3.s(); !(e23 = n3.n()).done; ) {
        var r2 = e23.value;
        if (r2 instanceof rO) {
          var i2 = r2.measureTextSize();
          if (i2)
            return i2;
        }
      }
    } catch (e24) {
      n3.e(e24);
    } finally {
      n3.f();
    }
    var o2, a2, s2 = document.createElement("div");
    return s2.className = "cm-line", s2.style.width = "99999px", s2.textContent = "abc def ghi jkl mno pqr stu", this.view.observer.ignore(function() {
      t3.dom.appendChild(s2);
      var e24 = e$(s2.firstChild)[0];
      o2 = s2.getBoundingClientRect().height, a2 = e24 ? e24.width / 27 : 7, s2.remove();
    }), { lineHeight: o2, charWidth: a2 };
  } }, { key: "childCursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.length, t3 = this.children.length;
    return t3 && (e23 -= this.children[--t3].length), new k$(this.children, e23, t3);
  } }, { key: "computeBlockGapDeco", value: function() {
    for (var e23 = [], t3 = this.view.viewState, n3 = 0, r2 = 0; ; r2++) {
      var i2 = r2 == t3.viewports.length ? null : t3.viewports[r2], o2 = i2 ? i2.from - 1 : this.length;
      if (o2 > n3) {
        var a2 = t3.lineBlockAt(o2).bottom - t3.lineBlockAt(n3).top;
        e23.push(Y$.replace({ widget: new nA(a2), block: true, inclusive: true, isBlockGap: true }).range(n3, o2));
      }
      if (!i2)
        break;
      n3 = i2.to + 1;
    }
    return Y$.set(e23);
  } }, { key: "updateDeco", value: function() {
    for (var e23 = this, t3 = this.view.state.facet(CO).map(function(t4, n4) {
      return (e23.dynamicDecorationMap[n4] = typeof t4 == "function") ? t4(e23.view) : t4;
    }), n3 = t3.length; n3 < t3.length + 3; n3++)
      this.dynamicDecorationMap[n3] = false;
    return this.decorations = [].concat(Ni(t3), [this.compositionDeco, this.computeBlockGapDeco(), this.view.viewState.lineGapDeco]);
  } }, { key: "scrollIntoView", value: function(e23) {
    var t3, n3 = this, r2 = e23.range, i2 = this.coordsAt(r2.head, r2.empty ? r2.assoc : r2.head > r2.anchor ? -1 : 1);
    if (i2) {
      !r2.empty && (t3 = this.coordsAt(r2.anchor, r2.anchor > r2.head ? -1 : 1)) && (i2 = { left: Math.min(i2.left, t3.left), top: Math.min(i2.top, t3.top), right: Math.max(i2.right, t3.right), bottom: Math.max(i2.bottom, t3.bottom) });
      var o2, a2 = 0, s2 = 0, u2 = 0, c2 = 0, l2 = bi(this.view.state.facet($O).map(function(e24) {
        return e24(n3.view);
      }));
      try {
        for (l2.s(); !(o2 = l2.n()).done; ) {
          var f2 = o2.value;
          if (f2) {
            var h2 = f2.left, d2 = f2.right, v2 = f2.top, p2 = f2.bottom;
            h2 != null && (a2 = Math.max(a2, h2)), d2 != null && (s2 = Math.max(s2, d2)), v2 != null && (u2 = Math.max(u2, v2)), p2 != null && (c2 = Math.max(c2, p2));
          }
        }
      } catch (e24) {
        l2.e(e24);
      } finally {
        l2.f();
      }
      var m2 = { left: i2.left - a2, top: i2.top - u2, right: i2.right + s2, bottom: i2.bottom + c2 };
      !function(e24, t4, n4, r3, i3, o3, a3, s3) {
        for (var u3 = e24.ownerDocument, c3 = u3.defaultView, l3 = e24; l3; )
          if (l3.nodeType == 1) {
            var f3 = void 0, h3 = l3 == u3.body;
            if (h3)
              f3 = s$(c3);
            else {
              if (l3.scrollHeight <= l3.clientHeight && l3.scrollWidth <= l3.clientWidth) {
                l3 = l3.parentNode;
                continue;
              }
              var d3 = l3.getBoundingClientRect();
              f3 = { left: d3.left, right: d3.left + l3.clientWidth, top: d3.top, bottom: d3.top + l3.clientHeight };
            }
            var v3 = 0, p3 = 0;
            if (i3 == "nearest")
              t4.top < f3.top ? (p3 = -(f3.top - t4.top + a3), n4 > 0 && t4.bottom > f3.bottom + p3 && (p3 = t4.bottom - f3.bottom + p3 + a3)) : t4.bottom > f3.bottom && (p3 = t4.bottom - f3.bottom + a3, n4 < 0 && t4.top - p3 < f3.top && (p3 = -(f3.top + p3 - t4.top + a3)));
            else {
              var m3 = t4.bottom - t4.top, g2 = f3.bottom - f3.top;
              p3 = (i3 == "center" && m3 <= g2 ? t4.top + m3 / 2 - g2 / 2 : i3 == "start" || i3 == "center" && n4 < 0 ? t4.top - a3 : t4.bottom - g2 + a3) - f3.top;
            }
            if (r3 == "nearest" ? t4.left < f3.left ? (v3 = -(f3.left - t4.left + o3), n4 > 0 && t4.right > f3.right + v3 && (v3 = t4.right - f3.right + v3 + o3)) : t4.right > f3.right && (v3 = t4.right - f3.right + o3, n4 < 0 && t4.left < f3.left + v3 && (v3 = -(f3.left + v3 - t4.left + o3))) : v3 = (r3 == "center" ? t4.left + (t4.right - t4.left) / 2 - (f3.right - f3.left) / 2 : r3 == "start" == s3 ? t4.left - o3 : t4.right - (f3.right - f3.left) + o3) - f3.left, v3 || p3)
              if (h3)
                c3.scrollBy(v3, p3);
              else {
                if (p3) {
                  var y2 = l3.scrollTop;
                  l3.scrollTop += p3, p3 = l3.scrollTop - y2;
                }
                if (v3) {
                  var b2 = l3.scrollLeft;
                  l3.scrollLeft += v3, v3 = l3.scrollLeft - b2;
                }
                t4 = { left: t4.left - v3, top: t4.top - p3, right: t4.right - v3, bottom: t4.bottom - p3 };
              }
            if (h3)
              break;
            l3 = l3.assignedSlot || l3.parentNode, r3 = i3 = "nearest";
          } else {
            if (l3.nodeType != 11)
              break;
            l3 = l3.host;
          }
      }(this.view.scrollDOM, m2, r2.head < r2.anchor ? -1 : 1, e23.x, e23.y, e23.xMargin, e23.yMargin, this.view.textDirection == EO.LTR);
    }
  } }]), n2;
}();
function tA(e22) {
  return e22.node.nodeType == 1 && e22.node.firstChild && (e22.offset == 0 || e22.node.childNodes[e22.offset - 1].contentEditable == "false") && (e22.offset == e22.node.childNodes.length || e22.node.childNodes[e22.offset].contentEditable == "false");
}
var nA = function(e22) {
  ji(n2, G$);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), (r2 = t2.call(this)).height = e23, r2;
  }
  return zi(n2, [{ key: "toDOM", value: function() {
    var e23 = document.createElement("div");
    return this.updateDOM(e23), e23;
  } }, { key: "eq", value: function(e23) {
    return e23.height == this.height;
  } }, { key: "updateDOM", value: function(e23) {
    return e23.style.height = this.height + "px", true;
  } }, { key: "estimatedHeight", get: function() {
    return this.height;
  } }]), n2;
}();
function rA(e22) {
  var t2 = e22.observer.selectionRange, n2 = t2.focusNode && oA(t2.focusNode, t2.focusOffset, 0);
  if (!n2)
    return null;
  var r2 = e22.docView.nearest(n2);
  if (!r2)
    return null;
  if (r2 instanceof rO) {
    for (var i2 = n2; i2.parentNode != r2.dom; )
      i2 = i2.parentNode;
    for (var o2 = i2.previousSibling; o2 && !y$.get(o2); )
      o2 = o2.previousSibling;
    var a2 = o2 ? y$.get(o2).posAtEnd : r2.posAtStart;
    return { from: a2, to: a2, node: i2, text: n2 };
  }
  for (; ; ) {
    var s2 = r2.parent;
    if (!s2)
      return null;
    if (s2 instanceof rO)
      break;
    r2 = s2;
  }
  var u2 = r2.posAtStart;
  return { from: u2, to: u2 + r2.length, node: r2.dom, text: n2 };
}
var iA = function(e22) {
  ji(n2, G$);
  var t2 = Ci(n2);
  function n2(e23, r2, i2) {
    var o2;
    return Ri(this, n2), (o2 = t2.call(this)).top = e23, o2.text = r2, o2.topView = i2, o2;
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return this.top == e23.top && this.text == e23.text;
  } }, { key: "toDOM", value: function() {
    return this.top;
  } }, { key: "ignoreEvent", value: function() {
    return false;
  } }, { key: "customView", get: function() {
    return L$;
  } }]), n2;
}();
function oA(e22, t2, n2) {
  for (; ; ) {
    if (e22.nodeType == 3)
      return e22;
    if (e22.nodeType == 1 && t2 > 0 && n2 <= 0)
      t2 = i$(e22 = e22.childNodes[t2 - 1]);
    else {
      if (!(e22.nodeType == 1 && t2 < e22.childNodes.length && n2 >= 0))
        return null;
      e22 = e22.childNodes[t2], t2 = 0;
    }
  }
}
function aA(e22, t2) {
  return e22.nodeType != 1 ? 0 : (t2 && e22.childNodes[t2 - 1].contentEditable == "false" ? 1 : 0) | (t2 < e22.childNodes.length && e22.childNodes[t2].contentEditable == "false" ? 2 : 0);
}
var sA = function() {
  function e22() {
    Ri(this, e22), this.changes = [];
  }
  return zi(e22, [{ key: "compareRange", value: function(e23, t2) {
    nO(e23, t2, this.changes);
  } }, { key: "comparePoint", value: function(e23, t2) {
    nO(e23, t2, this.changes);
  } }]), e22;
}();
function uA(e22, t2) {
  for (var n2 = e22; n2 && n2 != t2; n2 = n2.assignedSlot || n2.parentNode)
    if (n2.nodeType == 1 && n2.contentEditable == "false")
      return true;
  return false;
}
function cA(e22, t2) {
  return t2.left > e22 ? t2.left - e22 : Math.max(0, e22 - t2.right);
}
function lA(e22, t2) {
  return t2.top > e22 ? t2.top - e22 : Math.max(0, e22 - t2.bottom);
}
function fA(e22, t2) {
  return e22.top < t2.bottom - 1 && e22.bottom > t2.top + 1;
}
function hA(e22, t2) {
  return t2 < e22.top ? { top: t2, left: e22.left, right: e22.right, bottom: e22.bottom } : e22;
}
function dA(e22, t2) {
  return t2 > e22.bottom ? { top: e22.top, left: e22.left, right: e22.right, bottom: t2 } : e22;
}
function vA(e22, t2, n2) {
  for (var r2, i2, o2, a2, s2, u2, c2, l2, f2 = e22.firstChild; f2; f2 = f2.nextSibling)
    for (var h2 = e$(f2), d2 = 0; d2 < h2.length; d2++) {
      var v2 = h2[d2];
      i2 && fA(i2, v2) && (v2 = hA(dA(v2, i2.bottom), i2.top));
      var p2 = cA(t2, v2), m2 = lA(n2, v2);
      if (p2 == 0 && m2 == 0)
        return f2.nodeType == 3 ? pA(f2, t2, n2) : vA(f2, t2, n2);
      (!r2 || a2 > m2 || a2 == m2 && o2 > p2) && (r2 = f2, i2 = v2, o2 = p2, a2 = m2), p2 == 0 ? n2 > v2.bottom && (!c2 || c2.bottom < v2.bottom) ? (s2 = f2, c2 = v2) : n2 < v2.top && (!l2 || l2.top > v2.top) && (u2 = f2, l2 = v2) : c2 && fA(c2, v2) ? c2 = dA(c2, v2.bottom) : l2 && fA(l2, v2) && (l2 = hA(l2, v2.top));
    }
  if (c2 && c2.bottom >= n2 ? (r2 = s2, i2 = c2) : l2 && l2.top <= n2 && (r2 = u2, i2 = l2), !r2)
    return { node: e22, offset: 0 };
  var g2 = Math.max(i2.left, Math.min(i2.right, t2));
  return r2.nodeType == 3 ? pA(r2, g2, n2) : o2 || r2.contentEditable != "true" ? { node: e22, offset: Array.prototype.indexOf.call(e22.childNodes, r2) + (t2 >= (i2.left + i2.right) / 2 ? 1 : 0) } : vA(r2, g2, n2);
}
function pA(e22, t2, n2) {
  for (var r2 = e22.nodeValue.length, i2 = -1, o2 = 1e9, a2 = 0, s2 = 0; s2 < r2; s2++)
    for (var u2 = h$(e22, s2, s2 + 1).getClientRects(), c2 = 0; c2 < u2.length; c2++) {
      var l2 = u2[c2];
      if (l2.top != l2.bottom) {
        a2 || (a2 = t2 - l2.left);
        var f2 = (l2.top > n2 ? l2.top - n2 : n2 - l2.bottom) - 1;
        if (l2.left - 1 <= t2 && l2.right + 1 >= t2 && f2 < o2) {
          var h2 = t2 >= (l2.left + l2.right) / 2, d2 = h2;
          if (T$.chrome || T$.gecko)
            h$(e22, s2).getBoundingClientRect().left == l2.right && (d2 = !h2);
          if (f2 <= 0)
            return { node: e22, offset: s2 + (d2 ? 1 : 0) };
          i2 = s2 + (d2 ? 1 : 0), o2 = f2;
        }
      }
    }
  return { node: e22, offset: i2 > -1 ? i2 : a2 > 0 ? e22.nodeValue.length : 0 };
}
function mA(e22, t2, n2) {
  var r2, i2, o2 = t2.x, a2 = t2.y, s2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : -1, u2 = e22.contentDOM.getBoundingClientRect(), c2 = u2.top + e22.viewState.paddingTop, l2 = e22.viewState.docHeight, f2 = a2 - c2;
  if (f2 < 0)
    return 0;
  if (f2 > l2)
    return e22.state.doc.length;
  for (var h2 = e22.defaultLineHeight / 2, d2 = false; (i2 = e22.elementAtHeight(f2)).type != Q$.Text; )
    for (; !((f2 = s2 > 0 ? i2.bottom + h2 : i2.top - h2) >= 0 && f2 <= l2); ) {
      if (d2)
        return n2 ? null : 0;
      d2 = true, s2 = -s2;
    }
  a2 = c2 + f2;
  var v2 = i2.from;
  if (v2 < e22.viewport.from)
    return e22.viewport.from == 0 ? 0 : n2 ? null : gA(e22, u2, i2, o2, a2);
  if (v2 > e22.viewport.to)
    return e22.viewport.to == e22.state.doc.length ? e22.state.doc.length : n2 ? null : gA(e22, u2, i2, o2, a2);
  var p2 = e22.dom.ownerDocument, m2 = e22.root.elementFromPoint ? e22.root : p2, g2 = m2.elementFromPoint(o2, a2);
  g2 && !e22.contentDOM.contains(g2) && (g2 = null), g2 || (o2 = Math.max(u2.left + 1, Math.min(u2.right - 1, o2)), (g2 = m2.elementFromPoint(o2, a2)) && !e22.contentDOM.contains(g2) && (g2 = null));
  var y2, b2 = -1;
  if (g2 && ((r2 = e22.docView.nearest(g2)) === null || r2 === void 0 ? void 0 : r2.isEditable) != 0) {
    if (p2.caretPositionFromPoint) {
      var k2 = p2.caretPositionFromPoint(o2, a2);
      k2 && (y2 = k2.offsetNode, b2 = k2.offset);
    } else if (p2.caretRangeFromPoint) {
      var w2 = p2.caretRangeFromPoint(o2, a2);
      w2 && (y2 = w2.startContainer, b2 = w2.startOffset, T$.safari && yA(y2, b2, o2) && (y2 = void 0));
    }
  }
  if (!y2 || !e22.docView.dom.contains(y2)) {
    var x2 = rO.find(e22.docView, v2);
    if (!x2)
      return f2 > i2.top + i2.height / 2 ? i2.to : i2.from;
    var j2 = vA(x2.dom, o2, a2);
    y2 = j2.node, b2 = j2.offset;
  }
  return e22.docView.posFromDOM(y2, b2);
}
function gA(e22, t2, n2, r2, i2) {
  var o2 = Math.round((r2 - t2.left) * e22.defaultCharacterWidth);
  e22.lineWrapping && n2.height > 1.5 * e22.defaultLineHeight && (o2 += Math.floor((i2 - n2.top) / e22.defaultLineHeight) * e22.viewState.heightOracle.lineLength);
  var a2 = e22.state.sliceDoc(n2.from, n2.to);
  return n2.from + T_(a2, o2, e22.state.tabSize);
}
function yA(e22, t2, n2) {
  var r2;
  if (e22.nodeType != 3 || t2 != (r2 = e22.nodeValue.length))
    return false;
  for (var i2 = e22.nextSibling; i2; i2 = i2.nextSibling)
    if (i2.nodeType != 1 || i2.nodeName != "BR")
      return false;
  return h$(e22, r2 - 1, r2).getBoundingClientRect().left > n2;
}
function bA(e22, t2, n2, r2) {
  var i2 = e22.state.doc.lineAt(t2.head), o2 = r2 && e22.lineWrapping ? e22.coordsAtPos(t2.assoc < 0 && t2.head > i2.from ? t2.head - 1 : t2.head) : null;
  if (o2) {
    var a2 = e22.dom.getBoundingClientRect(), s2 = e22.textDirectionAt(i2.from), u2 = e22.posAtCoords({ x: n2 == (s2 == EO.LTR) ? a2.right - 1 : a2.left + 1, y: (o2.top + o2.bottom) / 2 });
    if (u2 != null)
      return SC.cursor(u2, n2 ? -1 : 1);
  }
  var c2 = rO.find(e22.docView, t2.head), l2 = c2 ? n2 ? c2.posAtEnd : c2.posAtStart : n2 ? i2.to : i2.from;
  return SC.cursor(l2, n2 ? -1 : 1);
}
function kA(e22, t2, n2, r2) {
  for (var i2 = e22.state.doc.lineAt(t2.head), o2 = e22.bidiSpans(i2), a2 = e22.textDirectionAt(i2.from), s2 = t2, u2 = null; ; ) {
    var c2 = QO(i2, o2, a2, s2, n2), l2 = GO;
    if (!c2) {
      if (i2.number == (n2 ? e22.state.doc.lines : 1))
        return s2;
      l2 = "\n", i2 = e22.state.doc.line(i2.number + (n2 ? 1 : -1)), o2 = e22.bidiSpans(i2), c2 = SC.cursor(n2 ? i2.from : i2.to);
    }
    if (u2) {
      if (!u2(l2))
        return s2;
    } else {
      if (!r2)
        return c2;
      u2 = r2(l2);
    }
    s2 = c2;
  }
}
function wA(e22, t2, n2) {
  for (var r2 = e22.state.facet(_O).map(function(t3) {
    return t3(e22);
  }); ; ) {
    var i2, o2 = false, a2 = bi(r2);
    try {
      for (a2.s(); !(i2 = a2.n()).done; ) {
        i2.value.between(n2.from - 1, n2.from + 1, function(e23, r3, i3) {
          n2.from > e23 && n2.from < r3 && (n2 = t2.from > n2.from ? SC.cursor(e23, 1) : SC.cursor(r3, -1), o2 = true);
        });
      }
    } catch (e23) {
      a2.e(e23);
    } finally {
      a2.f();
    }
    if (!o2)
      return n2;
  }
}
var xA = function() {
  function e22(t2) {
    var n2 = this;
    Ri(this, e22), this.lastKeyCode = 0, this.lastKeyTime = 0, this.chromeScrollHack = -1, this.pendingIOSKey = void 0, this.lastSelectionOrigin = null, this.lastSelectionTime = 0, this.lastEscPress = 0, this.lastContextMenu = 0, this.scrollHandlers = [], this.registeredEvents = [], this.customHandlers = [], this.composing = -1, this.compositionFirstChange = null, this.compositionEndedAt = 0, this.rapidCompositionStart = false, this.mouseSelection = null;
    var r2 = function(e23) {
      var r3 = $A[e23];
      t2.contentDOM.addEventListener(e23, function(i3) {
        _A(t2, i3) && !n2.ignoreDuringComposition(i3) && (e23 == "keydown" && n2.keydown(t2, i3) || (n2.mustFlushObserver(i3) && t2.observer.forceFlush(), n2.runCustomHandlers(e23, t2, i3) ? i3.preventDefault() : r3(t2, i3)));
      }), n2.registeredEvents.push(e23);
    };
    for (var i2 in $A)
      r2(i2);
    T$.chrome && T$.chrome_version >= 102 && t2.scrollDOM.addEventListener("wheel", function() {
      n2.chromeScrollHack < 0 ? t2.contentDOM.style.pointerEvents = "none" : window.clearTimeout(n2.chromeScrollHack), n2.chromeScrollHack = setTimeout(function() {
        n2.chromeScrollHack = -1, t2.contentDOM.style.pointerEvents = "";
      }, 100);
    }, { passive: true }), this.notifiedFocused = t2.hasFocus, T$.safari && t2.contentDOM.addEventListener("input", function() {
      return null;
    });
  }
  return zi(e22, [{ key: "setSelectionOrigin", value: function(e23) {
    this.lastSelectionOrigin = e23, this.lastSelectionTime = Date.now();
  } }, { key: "ensureHandlers", value: function(e23, t2) {
    var n2, r2, i2 = this;
    this.customHandlers = [];
    var o2, a2 = bi(t2);
    try {
      for (a2.s(); !(o2 = a2.n()).done; ) {
        var s2 = o2.value;
        if (r2 = (n2 = s2.update(e23).spec) === null || n2 === void 0 ? void 0 : n2.domEventHandlers) {
          this.customHandlers.push({ plugin: s2.value, handlers: r2 });
          var u2 = function(t3) {
            i2.registeredEvents.indexOf(t3) < 0 && t3 != "scroll" && (i2.registeredEvents.push(t3), e23.contentDOM.addEventListener(t3, function(n3) {
              _A(e23, n3) && i2.runCustomHandlers(t3, e23, n3) && n3.preventDefault();
            }));
          };
          for (var c2 in r2)
            u2(c2);
        }
      }
    } catch (e24) {
      a2.e(e24);
    } finally {
      a2.f();
    }
  } }, { key: "runCustomHandlers", value: function(e23, t2, n2) {
    var r2, i2 = bi(this.customHandlers);
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        var o2 = r2.value, a2 = o2.handlers[e23];
        if (a2)
          try {
            if (a2.call(o2.plugin, n2, t2) || n2.defaultPrevented)
              return true;
          } catch (e24) {
            gO(t2.state, e24);
          }
      }
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    return false;
  } }, { key: "runScrollHandlers", value: function(e23, t2) {
    var n2, r2 = bi(this.customHandlers);
    try {
      for (r2.s(); !(n2 = r2.n()).done; ) {
        var i2 = n2.value, o2 = i2.handlers.scroll;
        if (o2)
          try {
            o2.call(i2.plugin, t2, e23);
          } catch (t3) {
            gO(e23.state, t3);
          }
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
  } }, { key: "keydown", value: function(e23, t2) {
    var n2, r2 = this;
    return this.lastKeyCode = t2.keyCode, this.lastKeyTime = Date.now(), t2.keyCode == 9 && Date.now() < this.lastEscPress + 2e3 || (!T$.android || !T$.chrome || t2.synthetic || t2.keyCode != 13 && t2.keyCode != 8 ? !(!T$.ios || !(n2 = jA.find(function(e24) {
      return e24.keyCode == t2.keyCode;
    })) || t2.ctrlKey || t2.altKey || t2.metaKey || t2.synthetic) && (this.pendingIOSKey = n2, setTimeout(function() {
      return r2.flushIOSKey(e23);
    }, 250), true) : (e23.observer.delayAndroidKey(t2.key, t2.keyCode), true));
  } }, { key: "flushIOSKey", value: function(e23) {
    var t2 = this.pendingIOSKey;
    return !!t2 && (this.pendingIOSKey = void 0, d$(e23.contentDOM, t2.key, t2.keyCode));
  } }, { key: "ignoreDuringComposition", value: function(e23) {
    return !!/^key/.test(e23.type) && (this.composing > 0 || !!(T$.safari && Date.now() - this.compositionEndedAt < 100) && (this.compositionEndedAt = 0, true));
  } }, { key: "mustFlushObserver", value: function(e23) {
    return e23.type == "keydown" && e23.keyCode != 229 || e23.type == "compositionend" && !T$.ios;
  } }, { key: "startMouseSelection", value: function(e23) {
    this.mouseSelection && this.mouseSelection.destroy(), this.mouseSelection = e23;
  } }, { key: "update", value: function(e23) {
    this.mouseSelection && this.mouseSelection.update(e23), e23.transactions.length && (this.lastKeyCode = this.lastSelectionTime = 0);
  } }, { key: "destroy", value: function() {
    this.mouseSelection && this.mouseSelection.destroy();
  } }]), e22;
}(), jA = [{ key: "Backspace", keyCode: 8, inputType: "deleteContentBackward" }, { key: "Enter", keyCode: 13, inputType: "insertParagraph" }, { key: "Delete", keyCode: 46, inputType: "deleteContentForward" }], SA = [16, 17, 18, 20, 91, 92, 224, 225], CA = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.view = t2, this.style = r2, this.mustSelect = i2, this.lastEvent = n2;
    var o2 = t2.contentDOM.ownerDocument;
    o2.addEventListener("mousemove", this.move = this.move.bind(this)), o2.addEventListener("mouseup", this.up = this.up.bind(this)), this.extend = n2.shiftKey, this.multiple = t2.state.facet(v_.allowMultipleSelections) && function(e23, t3) {
      var n3 = e23.state.facet(uO);
      return n3.length ? n3[0](t3) : T$.mac ? t3.metaKey : t3.ctrlKey;
    }(t2, n2), this.dragMove = function(e23, t3) {
      var n3 = e23.state.facet(cO);
      return n3.length ? n3[0](t3) : T$.mac ? !t3.altKey : !t3.ctrlKey;
    }(t2, n2), this.dragging = !(!function(e23, t3) {
      if (e23.state.selection.main.empty)
        return false;
      var n3 = Y_(e23.root);
      if (!n3 || n3.rangeCount == 0)
        return true;
      for (var r3 = n3.getRangeAt(0).getClientRects(), i3 = 0; i3 < r3.length; i3++) {
        var o3 = r3[i3];
        if (o3.left <= t3.clientX && o3.right >= t3.clientX && o3.top <= t3.clientY && o3.bottom >= t3.clientY)
          return true;
      }
      return false;
    }(t2, n2) || BA(n2) != 1) && null, this.dragging === false && (n2.preventDefault(), this.select(n2));
  }
  return zi(e22, [{ key: "move", value: function(e23) {
    if (e23.buttons == 0)
      return this.destroy();
    this.dragging === false && this.select(this.lastEvent = e23);
  } }, { key: "up", value: function(e23) {
    this.dragging == null && this.select(this.lastEvent), this.dragging || e23.preventDefault(), this.destroy();
  } }, { key: "destroy", value: function() {
    var e23 = this.view.contentDOM.ownerDocument;
    e23.removeEventListener("mousemove", this.move), e23.removeEventListener("mouseup", this.up), this.view.inputState.mouseSelection = null;
  } }, { key: "select", value: function(e23) {
    var t2 = this.style.get(e23, this.extend, this.multiple);
    !this.mustSelect && t2.eq(this.view.state.selection) && t2.main.assoc == this.view.state.selection.main.assoc || this.view.dispatch({ selection: t2, userEvent: "select.pointer", scrollIntoView: true }), this.mustSelect = false;
  } }, { key: "update", value: function(e23) {
    var t2 = this;
    e23.docChanged && this.dragging && (this.dragging = this.dragging.map(e23.changes)), this.style.update(e23) && setTimeout(function() {
      return t2.select(t2.lastEvent);
    }, 20);
  } }]), e22;
}();
function _A(e22, t2) {
  if (!t2.bubbles)
    return true;
  if (t2.defaultPrevented)
    return false;
  for (var n2, r2 = t2.target; r2 != e22.contentDOM; r2 = r2.parentNode)
    if (!r2 || r2.nodeType == 11 || (n2 = y$.get(r2)) && n2.ignoreEvent(t2))
      return false;
  return true;
}
var $A = /* @__PURE__ */ Object.create(null), OA = T$.ie && T$.ie_version < 15 || T$.ios && T$.webkit_version < 604;
function AA(e22, t2) {
  var n2, r2 = e22.state, i2 = 1, o2 = r2.toText(t2), a2 = o2.lines == r2.selection.ranges.length;
  if (FA != null && r2.selection.ranges.every(function(e23) {
    return e23.empty;
  }) && FA == o2.toString()) {
    var s2 = -1;
    n2 = r2.changeByRange(function(e23) {
      var n3 = r2.doc.lineAt(e23.from);
      if (n3.from == s2)
        return { range: e23 };
      s2 = n3.from;
      var u2 = r2.toText((a2 ? o2.line(i2++).text : t2) + r2.lineBreak);
      return { changes: { from: n3.from, insert: u2 }, range: SC.cursor(e23.from + u2.length) };
    });
  } else
    n2 = a2 ? r2.changeByRange(function(e23) {
      var t3 = o2.line(i2++);
      return { changes: { from: e23.from, to: e23.to, insert: t3.text }, range: SC.cursor(e23.from + t3.length) };
    }) : r2.replaceSelection(o2);
  e22.dispatch(n2, { userEvent: "input.paste", scrollIntoView: true });
}
$A.keydown = function(e22, t2) {
  e22.inputState.setSelectionOrigin("select"), t2.keyCode == 27 ? e22.inputState.lastEscPress = Date.now() : SA.indexOf(t2.keyCode) < 0 && (e22.inputState.lastEscPress = 0);
};
var MA = 0;
function EA(e22, t2, n2, r2) {
  if (r2 == 1)
    return SC.cursor(t2, n2);
  if (r2 == 2)
    return function(e23, t3) {
      var n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 1, r3 = e23.charCategorizer(t3), i3 = e23.doc.lineAt(t3), o3 = t3 - i3.from;
      if (i3.length == 0)
        return SC.cursor(t3);
      o3 == 0 ? n3 = 1 : o3 == i3.length && (n3 = -1);
      var a3 = o3, s3 = o3;
      n3 < 0 ? a3 = oC(i3.text, o3, false) : s3 = oC(i3.text, o3);
      for (var u2 = r3(i3.text.slice(a3, s3)); a3 > 0; ) {
        var c2 = oC(i3.text, a3, false);
        if (r3(i3.text.slice(c2, a3)) != u2)
          break;
        a3 = c2;
      }
      for (; s3 < i3.length; ) {
        var l2 = oC(i3.text, s3);
        if (r3(i3.text.slice(s3, l2)) != u2)
          break;
        s3 = l2;
      }
      return SC.range(a3 + i3.from, s3 + i3.from);
    }(e22.state, t2, n2);
  var i2 = rO.find(e22.docView, t2), o2 = e22.state.doc.lineAt(i2 ? i2.posAtEnd : t2), a2 = i2 ? i2.posAtStart : o2.from, s2 = i2 ? i2.posAtEnd : o2.to;
  return s2 < e22.state.doc.length && s2 == o2.to && s2++, SC.range(a2, s2);
}
$A.touchstart = function(e22, t2) {
  MA = Date.now(), e22.inputState.setSelectionOrigin("select.pointer");
}, $A.touchmove = function(e22) {
  e22.inputState.setSelectionOrigin("select.pointer");
}, $A.mousedown = function(e22, t2) {
  if (e22.observer.flush(), !(MA > Date.now() - 2e3 && BA(t2) == 1)) {
    var n2, r2 = null, i2 = bi(e22.state.facet(lO));
    try {
      for (i2.s(); !(n2 = i2.n()).done; ) {
        if (r2 = (0, n2.value)(e22, t2))
          break;
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
    if (r2 || t2.button != 0 || (r2 = function(e23, t3) {
      var n3 = IA(e23, t3), r3 = BA(t3), i3 = e23.state.selection, o3 = n3, a2 = t3;
      return { update: function(e24) {
        e24.docChanged && (n3 && (n3.pos = e24.changes.mapPos(n3.pos)), i3 = i3.map(e24.changes), a2 = null);
      }, get: function(t4, s2, u2) {
        var c2;
        if (a2 && t4.clientX == a2.clientX && t4.clientY == a2.clientY ? c2 = o3 : (c2 = o3 = IA(e23, t4), a2 = t4), !c2 || !n3)
          return i3;
        var l2 = EA(e23, c2.pos, c2.bias, r3);
        if (n3.pos != c2.pos && !s2) {
          var f2 = EA(e23, n3.pos, n3.bias, r3), h2 = Math.min(f2.from, l2.from), d2 = Math.max(f2.to, l2.to);
          l2 = h2 < l2.from ? SC.range(h2, d2) : SC.range(d2, h2);
        }
        return s2 ? i3.replaceRange(i3.main.extend(l2.from, l2.to)) : u2 ? i3.addRange(l2) : SC.create([l2]);
      } };
    }(e22, t2)), r2) {
      var o2 = e22.root.activeElement != e22.contentDOM;
      o2 && e22.observer.ignore(function() {
        return f$(e22.contentDOM);
      }), e22.inputState.startMouseSelection(new CA(e22, t2, r2, o2));
    }
  }
};
var PA = function(e22, t2) {
  return e22 >= t2.top && e22 <= t2.bottom;
}, NA = function(e22, t2, n2) {
  return PA(t2, n2) && e22 >= n2.left && e22 <= n2.right;
};
function TA(e22, t2, n2, r2) {
  var i2 = rO.find(e22.docView, t2);
  if (!i2)
    return 1;
  var o2 = t2 - i2.posAtStart;
  if (o2 == 0)
    return 1;
  if (o2 == i2.length)
    return -1;
  var a2 = i2.coordsAt(o2, -1);
  if (a2 && NA(n2, r2, a2))
    return -1;
  var s2 = i2.coordsAt(o2, 1);
  return s2 && NA(n2, r2, s2) ? 1 : a2 && PA(r2, a2) ? -1 : 1;
}
function IA(e22, t2) {
  var n2 = e22.posAtCoords({ x: t2.clientX, y: t2.clientY }, false);
  return { pos: n2, bias: TA(e22, n2, t2.clientX, t2.clientY) };
}
var RA = T$.ie && T$.ie_version <= 11, DA = null, zA = 0, LA = 0;
function BA(e22) {
  if (!RA)
    return e22.detail;
  var t2 = DA, n2 = LA;
  return DA = e22, LA = Date.now(), zA = !t2 || n2 > Date.now() - 400 && Math.abs(t2.clientX - e22.clientX) < 2 && Math.abs(t2.clientY - e22.clientY) < 2 ? (zA + 1) % 3 : 1;
}
function qA(e22, t2, n2, r2) {
  if (n2) {
    var i2 = e22.posAtCoords({ x: t2.clientX, y: t2.clientY }, false);
    t2.preventDefault();
    var o2 = e22.inputState.mouseSelection, a2 = r2 && o2 && o2.dragging && o2.dragMove ? { from: o2.dragging.from, to: o2.dragging.to } : null, s2 = { from: i2, insert: n2 }, u2 = e22.state.changes(a2 ? [a2, s2] : s2);
    e22.focus(), e22.dispatch({ changes: u2, selection: { anchor: u2.mapPos(i2, -1), head: u2.mapPos(i2, 1) }, userEvent: a2 ? "move.drop" : "input.drop" });
  }
}
$A.dragstart = function(e22, t2) {
  var n2 = e22.state.selection.main, r2 = e22.inputState.mouseSelection;
  r2 && (r2.dragging = n2), t2.dataTransfer && (t2.dataTransfer.setData("Text", e22.state.sliceDoc(n2.from, n2.to)), t2.dataTransfer.effectAllowed = "copyMove");
}, $A.drop = function(e22, t2) {
  if (t2.dataTransfer) {
    if (e22.state.readOnly)
      return t2.preventDefault();
    var n2 = t2.dataTransfer.files;
    n2 && n2.length ? function() {
      t2.preventDefault();
      for (var r2 = Array(n2.length), i2 = 0, o2 = function() {
        ++i2 == n2.length && qA(e22, t2, r2.filter(function(e23) {
          return e23 != null;
        }).join(e22.state.lineBreak), false);
      }, a2 = function(e23) {
        var t3 = new FileReader();
        t3.onerror = o2, t3.onload = function() {
          /[\x00-\x08\x0e-\x1f]{2}/.test(t3.result) || (r2[e23] = t3.result), o2();
        }, t3.readAsText(n2[e23]);
      }, s2 = 0; s2 < n2.length; s2++)
        a2(s2);
    }() : qA(e22, t2, t2.dataTransfer.getData("Text"), true);
  }
}, $A.paste = function(e22, t2) {
  if (e22.state.readOnly)
    return t2.preventDefault();
  e22.observer.flush();
  var n2 = OA ? null : t2.clipboardData;
  n2 ? (AA(e22, n2.getData("text/plain")), t2.preventDefault()) : function(e23) {
    var t3 = e23.dom.parentNode;
    if (t3) {
      var n3 = t3.appendChild(document.createElement("textarea"));
      n3.style.cssText = "position: fixed; left: -10000px; top: 10px", n3.focus(), setTimeout(function() {
        e23.focus(), n3.remove(), AA(e23, n3.value);
      }, 50);
    }
  }(e22);
};
var FA = null;
function VA(e22) {
  setTimeout(function() {
    e22.hasFocus != e22.inputState.notifiedFocused && e22.update([]);
  }, 10);
}
function HA(e22, t2) {
  if (e22.docView.compositionDeco.size) {
    e22.inputState.rapidCompositionStart = t2;
    try {
      e22.update([]);
    } finally {
      e22.inputState.rapidCompositionStart = false;
    }
  }
}
$A.copy = $A.cut = function(e22, t2) {
  var n2 = function(e23) {
    var t3, n3 = [], r3 = [], i3 = false, o3 = bi(e23.selection.ranges);
    try {
      for (o3.s(); !(t3 = o3.n()).done; ) {
        var a3 = t3.value;
        a3.empty || (n3.push(e23.sliceDoc(a3.from, a3.to)), r3.push(a3));
      }
    } catch (e24) {
      o3.e(e24);
    } finally {
      o3.f();
    }
    if (!n3.length) {
      var s2, u2 = -1, c2 = bi(e23.selection.ranges);
      try {
        for (c2.s(); !(s2 = c2.n()).done; ) {
          var l2 = s2.value.from, f2 = e23.doc.lineAt(l2);
          f2.number > u2 && (n3.push(f2.text), r3.push({ from: f2.from, to: Math.min(e23.doc.length, f2.to + 1) })), u2 = f2.number;
        }
      } catch (e24) {
        c2.e(e24);
      } finally {
        c2.f();
      }
      i3 = true;
    }
    return { text: n3.join(e23.lineBreak), ranges: r3, linewise: i3 };
  }(e22.state), r2 = n2.text, i2 = n2.ranges, o2 = n2.linewise;
  if (r2 || o2) {
    FA = o2 ? r2 : null;
    var a2 = OA ? null : t2.clipboardData;
    a2 ? (t2.preventDefault(), a2.clearData(), a2.setData("text/plain", r2)) : function(e23, t3) {
      var n3 = e23.dom.parentNode;
      if (n3) {
        var r3 = n3.appendChild(document.createElement("textarea"));
        r3.style.cssText = "position: fixed; left: -10000px; top: 10px", r3.value = t3, r3.focus(), r3.selectionEnd = t3.length, r3.selectionStart = 0, setTimeout(function() {
          r3.remove(), e23.focus();
        }, 50);
      }
    }(e22, r2), t2.type != "cut" || e22.state.readOnly || e22.dispatch({ changes: i2, scrollIntoView: true, userEvent: "delete.cut" });
  }
}, $A.focus = VA, $A.blur = function(e22) {
  e22.observer.clearSelectionRange(), VA(e22);
}, $A.compositionstart = $A.compositionupdate = function(e22) {
  e22.inputState.compositionFirstChange == null && (e22.inputState.compositionFirstChange = true), e22.inputState.composing < 0 && (e22.inputState.composing = 0, e22.docView.compositionDeco.size && (e22.observer.flush(), HA(e22, true)));
}, $A.compositionend = function(e22) {
  e22.inputState.composing = -1, e22.inputState.compositionEndedAt = Date.now(), e22.inputState.compositionFirstChange = null, setTimeout(function() {
    e22.inputState.composing < 0 && HA(e22, false);
  }, 50);
}, $A.contextmenu = function(e22) {
  e22.inputState.lastContextMenu = Date.now();
}, $A.beforeinput = function(e22, t2) {
  var n2, r2;
  if (T$.chrome && T$.android && (r2 = jA.find(function(e23) {
    return e23.inputType == t2.inputType;
  })) && (e22.observer.delayAndroidKey(r2.key, r2.keyCode), r2.key == "Backspace" || r2.key == "Delete")) {
    var i2 = ((n2 = window.visualViewport) === null || n2 === void 0 ? void 0 : n2.height) || 0;
    setTimeout(function() {
      var t3;
      (((t3 = window.visualViewport) === null || t3 === void 0 ? void 0 : t3.height) || 0) > i2 + 10 && e22.hasFocus && (e22.contentDOM.blur(), e22.focus());
    }, 100);
  }
};
var WA = ["pre-wrap", "normal", "pre-line", "break-spaces"], JA = function() {
  function e22() {
    Ri(this, e22), this.doc = WS.empty, this.lineWrapping = false, this.heightSamples = {}, this.lineHeight = 14, this.charWidth = 7, this.lineLength = 30, this.heightChanged = false;
  }
  return zi(e22, [{ key: "heightForGap", value: function(e23, t2) {
    var n2 = this.doc.lineAt(t2).number - this.doc.lineAt(e23).number + 1;
    return this.lineWrapping && (n2 += Math.ceil((t2 - e23 - n2 * this.lineLength * 0.5) / this.lineLength)), this.lineHeight * n2;
  } }, { key: "heightForLine", value: function(e23) {
    return this.lineWrapping ? (1 + Math.max(0, Math.ceil((e23 - this.lineLength) / (this.lineLength - 5)))) * this.lineHeight : this.lineHeight;
  } }, { key: "setDoc", value: function(e23) {
    return this.doc = e23, this;
  } }, { key: "mustRefreshForWrapping", value: function(e23) {
    return WA.indexOf(e23) > -1 != this.lineWrapping;
  } }, { key: "mustRefreshForHeights", value: function(e23) {
    for (var t2 = false, n2 = 0; n2 < e23.length; n2++) {
      var r2 = e23[n2];
      r2 < 0 ? n2++ : this.heightSamples[Math.floor(10 * r2)] || (t2 = true, this.heightSamples[Math.floor(10 * r2)] = true);
    }
    return t2;
  } }, { key: "refresh", value: function(e23, t2, n2, r2, i2) {
    var o2 = WA.indexOf(e23) > -1, a2 = Math.round(t2) != Math.round(this.lineHeight) || this.lineWrapping != o2;
    if (this.lineWrapping = o2, this.lineHeight = t2, this.charWidth = n2, this.lineLength = r2, a2) {
      this.heightSamples = {};
      for (var s2 = 0; s2 < i2.length; s2++) {
        var u2 = i2[s2];
        u2 < 0 ? s2++ : this.heightSamples[Math.floor(10 * u2)] = true;
      }
    }
    return a2;
  } }]), e22;
}(), UA = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.from = t2, this.heights = n2, this.index = 0;
  }
  return zi(e22, [{ key: "more", get: function() {
    return this.index < this.heights.length;
  } }]), e22;
}(), KA = function() {
  function e22(t2, n2, r2, i2, o2) {
    Ri(this, e22), this.from = t2, this.length = n2, this.top = r2, this.height = i2, this.type = o2;
  }
  return zi(e22, [{ key: "to", get: function() {
    return this.from + this.length;
  } }, { key: "bottom", get: function() {
    return this.top + this.height;
  } }, { key: "join", value: function(t2) {
    var n2 = (Array.isArray(this.type) ? this.type : [this]).concat(Array.isArray(t2.type) ? t2.type : [t2]);
    return new e22(this.from, this.length + t2.length, this.top, this.height + t2.height, n2);
  } }]), e22;
}(), GA = function(e22) {
  return e22[e22.ByPos = 0] = "ByPos", e22[e22.ByHeight = 1] = "ByHeight", e22[e22.ByPosNoHeight = 2] = "ByPosNoHeight", e22;
}(GA || (GA = {})), QA = function() {
  function e22(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 2;
    Ri(this, e22), this.length = t2, this.height = n2, this.flags = r2;
  }
  return zi(e22, [{ key: "outdated", get: function() {
    return (2 & this.flags) > 0;
  }, set: function(e23) {
    this.flags = (e23 ? 2 : 0) | -3 & this.flags;
  } }, { key: "setHeight", value: function(e23, t2) {
    this.height != t2 && (Math.abs(this.height - t2) > 1e-3 && (e23.heightChanged = true), this.height = t2);
  } }, { key: "replace", value: function(t2, n2, r2) {
    return e22.of(r2);
  } }, { key: "decomposeLeft", value: function(e23, t2) {
    t2.push(this);
  } }, { key: "decomposeRight", value: function(e23, t2) {
    t2.push(this);
  } }, { key: "applyChanges", value: function(e23, t2, n2, r2) {
    for (var i2 = this, o2 = r2.length - 1; o2 >= 0; o2--) {
      var a2 = r2[o2], s2 = a2.fromA, u2 = a2.toA, c2 = a2.fromB, l2 = a2.toB, f2 = i2.lineAt(s2, GA.ByPosNoHeight, t2, 0, 0), h2 = f2.to >= u2 ? f2 : i2.lineAt(u2, GA.ByPosNoHeight, t2, 0, 0);
      for (l2 += h2.to - u2, u2 = h2.to; o2 > 0 && f2.from <= r2[o2 - 1].toA; )
        s2 = r2[o2 - 1].fromA, c2 = r2[o2 - 1].fromB, o2--, s2 < f2.from && (f2 = i2.lineAt(s2, GA.ByPosNoHeight, t2, 0, 0));
      c2 += f2.from - s2, s2 = f2.from;
      var d2 = nM.build(n2, e23, c2, l2);
      i2 = i2.replace(s2, u2, d2);
    }
    return i2.updateHeight(n2, 0);
  } }], [{ key: "empty", value: function() {
    return new ZA(0, 0);
  } }, { key: "of", value: function(t2) {
    if (t2.length == 1)
      return t2[0];
    for (var n2 = 0, r2 = t2.length, i2 = 0, o2 = 0; ; )
      if (n2 == r2)
        if (i2 > 2 * o2) {
          var a2 = t2[n2 - 1];
          a2.break ? t2.splice(--n2, 1, a2.left, null, a2.right) : t2.splice(--n2, 1, a2.left, a2.right), r2 += 1 + a2.break, i2 -= a2.size;
        } else {
          if (!(o2 > 2 * i2))
            break;
          var s2 = t2[r2];
          s2.break ? t2.splice(r2, 1, s2.left, null, s2.right) : t2.splice(r2, 1, s2.left, s2.right), r2 += 2 + s2.break, o2 -= s2.size;
        }
      else if (i2 < o2) {
        var u2 = t2[n2++];
        u2 && (i2 += u2.size);
      } else {
        var c2 = t2[--r2];
        c2 && (o2 += c2.size);
      }
    var l2 = 0;
    return t2[n2 - 1] == null ? (l2 = 1, n2--) : t2[n2] == null && (l2 = 1, r2++), new eM(e22.of(t2.slice(0, n2)), l2, e22.of(t2.slice(r2)));
  } }]), e22;
}();
QA.prototype.size = 1;
var YA = function(e22) {
  ji(n2, QA);
  var t2 = Ci(n2);
  function n2(e23, r2, i2) {
    var o2;
    return Ri(this, n2), (o2 = t2.call(this, e23, r2)).type = i2, o2;
  }
  return zi(n2, [{ key: "blockAt", value: function(e23, t3, n3, r2) {
    return new KA(r2, this.length, n3, this.height, this.type);
  } }, { key: "lineAt", value: function(e23, t3, n3, r2, i2) {
    return this.blockAt(0, n3, r2, i2);
  } }, { key: "forEachLine", value: function(e23, t3, n3, r2, i2, o2) {
    e23 <= i2 + this.length && t3 >= i2 && o2(this.blockAt(0, n3, r2, i2));
  } }, { key: "updateHeight", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n3 = arguments.length > 3 ? arguments[3] : void 0;
    return n3 && n3.from <= t3 && n3.more && this.setHeight(e23, n3.heights[n3.index++]), this.outdated = false, this;
  } }, { key: "toString", value: function() {
    return "block(".concat(this.length, ")");
  } }]), n2;
}(), ZA = function(e22) {
  ji(n2, YA);
  var t2 = Ci(n2);
  function n2(e23, r2) {
    var i2;
    return Ri(this, n2), (i2 = t2.call(this, e23, r2, Q$.Text)).collapsed = 0, i2.widgetHeight = 0, i2;
  }
  return zi(n2, [{ key: "replace", value: function(e23, t3, r2) {
    var i2 = r2[0];
    return r2.length == 1 && (i2 instanceof n2 || i2 instanceof XA && 4 & i2.flags) && Math.abs(this.length - i2.length) < 10 ? (i2 instanceof XA ? i2 = new n2(i2.length, this.height) : i2.height = this.height, this.outdated || (i2.outdated = false), i2) : QA.of(r2);
  } }, { key: "updateHeight", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n3 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], r2 = arguments.length > 3 ? arguments[3] : void 0;
    return r2 && r2.from <= t3 && r2.more ? this.setHeight(e23, r2.heights[r2.index++]) : (n3 || this.outdated) && this.setHeight(e23, Math.max(this.widgetHeight, e23.heightForLine(this.length - this.collapsed))), this.outdated = false, this;
  } }, { key: "toString", value: function() {
    return "line(".concat(this.length).concat(this.collapsed ? -this.collapsed : "").concat(this.widgetHeight ? ":" + this.widgetHeight : "", ")");
  } }]), n2;
}(), XA = function(e22) {
  ji(n2, QA);
  var t2 = Ci(n2);
  function n2(e23) {
    return Ri(this, n2), t2.call(this, e23, 0);
  }
  return zi(n2, [{ key: "lines", value: function(e23, t3) {
    var n3 = e23.lineAt(t3).number, r2 = e23.lineAt(t3 + this.length).number;
    return { firstLine: n3, lastLine: r2, lineHeight: this.height / (r2 - n3 + 1) };
  } }, { key: "blockAt", value: function(e23, t3, n3, r2) {
    var i2 = this.lines(t3, r2), o2 = i2.firstLine, a2 = i2.lastLine, s2 = i2.lineHeight, u2 = Math.max(0, Math.min(a2 - o2, Math.floor((e23 - n3) / s2))), c2 = t3.line(o2 + u2), l2 = c2.from, f2 = c2.length;
    return new KA(l2, f2, n3 + s2 * u2, s2, Q$.Text);
  } }, { key: "lineAt", value: function(e23, t3, n3, r2, i2) {
    if (t3 == GA.ByHeight)
      return this.blockAt(e23, n3, r2, i2);
    if (t3 == GA.ByPosNoHeight) {
      var o2 = n3.lineAt(e23), a2 = o2.from, s2 = o2.to;
      return new KA(a2, s2 - a2, 0, 0, Q$.Text);
    }
    var u2 = this.lines(n3, i2), c2 = u2.firstLine, l2 = u2.lineHeight, f2 = n3.lineAt(e23), h2 = f2.from, d2 = f2.length, v2 = f2.number;
    return new KA(h2, d2, r2 + l2 * (v2 - c2), l2, Q$.Text);
  } }, { key: "forEachLine", value: function(e23, t3, n3, r2, i2, o2) {
    for (var a2 = this.lines(n3, i2), s2 = a2.firstLine, u2 = a2.lineHeight, c2 = Math.max(e23, i2), l2 = Math.min(i2 + this.length, t3); c2 <= l2; ) {
      var f2 = n3.lineAt(c2);
      c2 == e23 && (r2 += u2 * (f2.number - s2)), o2(new KA(f2.from, f2.length, r2, u2, Q$.Text)), r2 += u2, c2 = f2.to + 1;
    }
  } }, { key: "replace", value: function(e23, t3, r2) {
    var i2 = this.length - t3;
    if (i2 > 0) {
      var o2 = r2[r2.length - 1];
      o2 instanceof n2 ? r2[r2.length - 1] = new n2(o2.length + i2) : r2.push(null, new n2(i2 - 1));
    }
    if (e23 > 0) {
      var a2 = r2[0];
      a2 instanceof n2 ? r2[0] = new n2(e23 + a2.length) : r2.unshift(new n2(e23 - 1), null);
    }
    return QA.of(r2);
  } }, { key: "decomposeLeft", value: function(e23, t3) {
    t3.push(new n2(e23 - 1), null);
  } }, { key: "decomposeRight", value: function(e23, t3) {
    t3.push(null, new n2(this.length - e23 - 1));
  } }, { key: "updateHeight", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, r2 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], i2 = arguments.length > 3 ? arguments[3] : void 0, o2 = t3 + this.length;
    if (i2 && i2.from <= t3 + this.length && i2.more) {
      var a2 = [], s2 = Math.max(t3, i2.from), u2 = -1, c2 = e23.heightChanged;
      for (i2.from > t3 && a2.push(new n2(i2.from - t3 - 1).updateHeight(e23, t3)); s2 <= o2 && i2.more; ) {
        var l2 = e23.doc.lineAt(s2).length;
        a2.length && a2.push(null);
        var f2 = i2.heights[i2.index++];
        u2 == -1 ? u2 = f2 : Math.abs(f2 - u2) >= 1e-3 && (u2 = -2);
        var h2 = new ZA(l2, f2);
        h2.outdated = false, a2.push(h2), s2 += l2 + 1;
      }
      s2 <= o2 && a2.push(null, new n2(o2 - s2).updateHeight(e23, s2));
      var d2 = QA.of(a2);
      return e23.heightChanged = c2 || u2 < 0 || Math.abs(d2.height - this.height) >= 1e-3 || Math.abs(u2 - this.lines(e23.doc, t3).lineHeight) >= 1e-3, d2;
    }
    return (r2 || this.outdated) && (this.setHeight(e23, e23.heightForGap(t3, t3 + this.length)), this.outdated = false), this;
  } }, { key: "toString", value: function() {
    return "gap(".concat(this.length, ")");
  } }]), n2;
}(), eM = function(e22) {
  ji(n2, QA);
  var t2 = Ci(n2);
  function n2(e23, r2, i2) {
    var o2;
    return Ri(this, n2), (o2 = t2.call(this, e23.length + r2 + i2.length, e23.height + i2.height, r2 | (e23.outdated || i2.outdated ? 2 : 0))).left = e23, o2.right = i2, o2.size = e23.size + i2.size, o2;
  }
  return zi(n2, [{ key: "break", get: function() {
    return 1 & this.flags;
  } }, { key: "blockAt", value: function(e23, t3, n3, r2) {
    var i2 = n3 + this.left.height;
    return e23 < i2 ? this.left.blockAt(e23, t3, n3, r2) : this.right.blockAt(e23, t3, i2, r2 + this.left.length + this.break);
  } }, { key: "lineAt", value: function(e23, t3, n3, r2, i2) {
    var o2 = r2 + this.left.height, a2 = i2 + this.left.length + this.break, s2 = t3 == GA.ByHeight ? e23 < o2 : e23 < a2, u2 = s2 ? this.left.lineAt(e23, t3, n3, r2, i2) : this.right.lineAt(e23, t3, n3, o2, a2);
    if (this.break || (s2 ? u2.to < a2 : u2.from > a2))
      return u2;
    var c2 = t3 == GA.ByPosNoHeight ? GA.ByPosNoHeight : GA.ByPos;
    return s2 ? u2.join(this.right.lineAt(a2, c2, n3, o2, a2)) : this.left.lineAt(a2, c2, n3, r2, i2).join(u2);
  } }, { key: "forEachLine", value: function(e23, t3, n3, r2, i2, o2) {
    var a2 = r2 + this.left.height, s2 = i2 + this.left.length + this.break;
    if (this.break)
      e23 < s2 && this.left.forEachLine(e23, t3, n3, r2, i2, o2), t3 >= s2 && this.right.forEachLine(e23, t3, n3, a2, s2, o2);
    else {
      var u2 = this.lineAt(s2, GA.ByPos, n3, r2, i2);
      e23 < u2.from && this.left.forEachLine(e23, u2.from - 1, n3, r2, i2, o2), u2.to >= e23 && u2.from <= t3 && o2(u2), t3 > u2.to && this.right.forEachLine(u2.to + 1, t3, n3, a2, s2, o2);
    }
  } }, { key: "replace", value: function(e23, t3, n3) {
    var r2 = this.left.length + this.break;
    if (t3 < r2)
      return this.balanced(this.left.replace(e23, t3, n3), this.right);
    if (e23 > this.left.length)
      return this.balanced(this.left, this.right.replace(e23 - r2, t3 - r2, n3));
    var i2 = [];
    e23 > 0 && this.decomposeLeft(e23, i2);
    var o2, a2 = i2.length, s2 = bi(n3);
    try {
      for (s2.s(); !(o2 = s2.n()).done; ) {
        var u2 = o2.value;
        i2.push(u2);
      }
    } catch (e24) {
      s2.e(e24);
    } finally {
      s2.f();
    }
    if (e23 > 0 && tM(i2, a2 - 1), t3 < this.length) {
      var c2 = i2.length;
      this.decomposeRight(t3, i2), tM(i2, c2);
    }
    return QA.of(i2);
  } }, { key: "decomposeLeft", value: function(e23, t3) {
    var n3 = this.left.length;
    if (e23 <= n3)
      return this.left.decomposeLeft(e23, t3);
    t3.push(this.left), this.break && e23 >= ++n3 && t3.push(null), e23 > n3 && this.right.decomposeLeft(e23 - n3, t3);
  } }, { key: "decomposeRight", value: function(e23, t3) {
    var n3 = this.left.length, r2 = n3 + this.break;
    if (e23 >= r2)
      return this.right.decomposeRight(e23 - r2, t3);
    e23 < n3 && this.left.decomposeRight(e23, t3), this.break && e23 < r2 && t3.push(null), t3.push(this.right);
  } }, { key: "balanced", value: function(e23, t3) {
    return e23.size > 2 * t3.size || t3.size > 2 * e23.size ? QA.of(this.break ? [e23, null, t3] : [e23, t3]) : (this.left = e23, this.right = t3, this.height = e23.height + t3.height, this.outdated = e23.outdated || t3.outdated, this.size = e23.size + t3.size, this.length = e23.length + this.break + t3.length, this);
  } }, { key: "updateHeight", value: function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n3 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], r2 = arguments.length > 3 ? arguments[3] : void 0, i2 = this.left, o2 = this.right, a2 = t3 + i2.length + this.break, s2 = null;
    return r2 && r2.from <= t3 + i2.length && r2.more ? s2 = i2 = i2.updateHeight(e23, t3, n3, r2) : i2.updateHeight(e23, t3, n3), r2 && r2.from <= a2 + o2.length && r2.more ? s2 = o2 = o2.updateHeight(e23, a2, n3, r2) : o2.updateHeight(e23, a2, n3), s2 ? this.balanced(i2, o2) : (this.height = this.left.height + this.right.height, this.outdated = false, this);
  } }, { key: "toString", value: function() {
    return this.left + (this.break ? " " : "-") + this.right;
  } }]), n2;
}();
function tM(e22, t2) {
  var n2, r2;
  e22[t2] == null && (n2 = e22[t2 - 1]) instanceof XA && (r2 = e22[t2 + 1]) instanceof XA && e22.splice(t2 - 1, 3, new XA(n2.length + 1 + r2.length));
}
var nM = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.pos = t2, this.oracle = n2, this.nodes = [], this.lineStart = -1, this.lineEnd = -1, this.covering = null, this.writtenTo = t2;
  }
  return zi(e22, [{ key: "isCovered", get: function() {
    return this.covering && this.nodes[this.nodes.length - 1] == this.covering;
  } }, { key: "span", value: function(e23, t2) {
    if (this.lineStart > -1) {
      var n2 = Math.min(t2, this.lineEnd), r2 = this.nodes[this.nodes.length - 1];
      r2 instanceof ZA ? r2.length += n2 - this.pos : (n2 > this.pos || !this.isCovered) && this.nodes.push(new ZA(n2 - this.pos, -1)), this.writtenTo = n2, t2 > n2 && (this.nodes.push(null), this.writtenTo++, this.lineStart = -1);
    }
    this.pos = t2;
  } }, { key: "point", value: function(e23, t2, n2) {
    if (e23 < t2 || n2.heightRelevant) {
      var r2 = n2.widget ? n2.widget.estimatedHeight : 0;
      r2 < 0 && (r2 = this.oracle.lineHeight);
      var i2 = t2 - e23;
      n2.block ? this.addBlock(new YA(i2, r2, n2.type)) : (i2 || r2 >= 5) && this.addLineDeco(r2, i2);
    } else
      t2 > e23 && this.span(e23, t2);
    this.lineEnd > -1 && this.lineEnd < this.pos && (this.lineEnd = this.oracle.doc.lineAt(this.pos).to);
  } }, { key: "enterLine", value: function() {
    if (!(this.lineStart > -1)) {
      var e23 = this.oracle.doc.lineAt(this.pos), t2 = e23.from, n2 = e23.to;
      this.lineStart = t2, this.lineEnd = n2, this.writtenTo < t2 && ((this.writtenTo < t2 - 1 || this.nodes[this.nodes.length - 1] == null) && this.nodes.push(this.blankContent(this.writtenTo, t2 - 1)), this.nodes.push(null)), this.pos > t2 && this.nodes.push(new ZA(this.pos - t2, -1)), this.writtenTo = this.pos;
    }
  } }, { key: "blankContent", value: function(e23, t2) {
    var n2 = new XA(t2 - e23);
    return this.oracle.doc.lineAt(e23).to == t2 && (n2.flags |= 4), n2;
  } }, { key: "ensureLine", value: function() {
    this.enterLine();
    var e23 = this.nodes.length ? this.nodes[this.nodes.length - 1] : null;
    if (e23 instanceof ZA)
      return e23;
    var t2 = new ZA(0, -1);
    return this.nodes.push(t2), t2;
  } }, { key: "addBlock", value: function(e23) {
    this.enterLine(), e23.type != Q$.WidgetAfter || this.isCovered || this.ensureLine(), this.nodes.push(e23), this.writtenTo = this.pos = this.pos + e23.length, e23.type != Q$.WidgetBefore && (this.covering = e23);
  } }, { key: "addLineDeco", value: function(e23, t2) {
    var n2 = this.ensureLine();
    n2.length += t2, n2.collapsed += t2, n2.widgetHeight = Math.max(n2.widgetHeight, e23), this.writtenTo = this.pos = this.pos + t2;
  } }, { key: "finish", value: function(e23) {
    var t2 = this.nodes.length == 0 ? null : this.nodes[this.nodes.length - 1];
    !(this.lineStart > -1) || t2 instanceof ZA || this.isCovered ? (this.writtenTo < this.pos || t2 == null) && this.nodes.push(this.blankContent(this.writtenTo, this.pos)) : this.nodes.push(new ZA(0, -1));
    var n2, r2 = e23, i2 = bi(this.nodes);
    try {
      for (i2.s(); !(n2 = i2.n()).done; ) {
        var o2 = n2.value;
        o2 instanceof ZA && o2.updateHeight(this.oracle, r2), r2 += o2 ? o2.length : 1;
      }
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    return this.nodes;
  } }], [{ key: "build", value: function(t2, n2, r2, i2) {
    var o2 = new e22(r2, t2);
    return k_.spans(n2, r2, i2, o2, 0), o2.finish(r2);
  } }]), e22;
}();
function rM(e22, t2, n2) {
  var r2 = new iM();
  return k_.compare(e22, t2, n2, r2, 0), r2.changes;
}
var iM = function() {
  function e22() {
    Ri(this, e22), this.changes = [];
  }
  return zi(e22, [{ key: "compareRange", value: function() {
  } }, { key: "comparePoint", value: function(e23, t2, n2, r2) {
    (e23 < t2 || n2 && n2.heightRelevant || r2 && r2.heightRelevant) && nO(e23, t2, this.changes, 5);
  } }]), e22;
}();
function oM(e22, t2) {
  for (var n2 = e22.getBoundingClientRect(), r2 = Math.max(0, n2.left), i2 = Math.min(innerWidth, n2.right), o2 = Math.max(0, n2.top), a2 = Math.min(innerHeight, n2.bottom), s2 = e22.ownerDocument.body, u2 = e22.parentNode; u2 && u2 != s2; )
    if (u2.nodeType == 1) {
      var c2 = u2, l2 = window.getComputedStyle(c2);
      if ((c2.scrollHeight > c2.clientHeight || c2.scrollWidth > c2.clientWidth) && l2.overflow != "visible") {
        var f2 = c2.getBoundingClientRect();
        r2 = Math.max(r2, f2.left), i2 = Math.min(i2, f2.right), o2 = Math.max(o2, f2.top), a2 = Math.min(a2, f2.bottom);
      }
      u2 = l2.position == "absolute" || l2.position == "fixed" ? c2.offsetParent : c2.parentNode;
    } else {
      if (u2.nodeType != 11)
        break;
      u2 = u2.host;
    }
  return { left: r2 - n2.left, right: Math.max(r2, i2) - n2.left, top: o2 - (n2.top + t2), bottom: Math.max(o2, a2) - (n2.top + t2) };
}
function aM(e22, t2) {
  var n2 = e22.getBoundingClientRect();
  return { left: 0, right: n2.right - n2.left, top: t2, bottom: n2.bottom - (n2.top + t2) };
}
var sM = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.from = t2, this.to = n2, this.size = r2;
  }
  return zi(e22, [{ key: "draw", value: function(e23) {
    return Y$.replace({ widget: new uM(this.size, e23) }).range(this.from, this.to);
  } }], [{ key: "same", value: function(e23, t2) {
    if (e23.length != t2.length)
      return false;
    for (var n2 = 0; n2 < e23.length; n2++) {
      var r2 = e23[n2], i2 = t2[n2];
      if (r2.from != i2.from || r2.to != i2.to || r2.size != i2.size)
        return false;
    }
    return true;
  } }]), e22;
}(), uM = function(e22) {
  ji(n2, G$);
  var t2 = Ci(n2);
  function n2(e23, r2) {
    var i2;
    return Ri(this, n2), (i2 = t2.call(this)).size = e23, i2.vertical = r2, i2;
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return e23.size == this.size && e23.vertical == this.vertical;
  } }, { key: "toDOM", value: function() {
    var e23 = document.createElement("div");
    return this.vertical ? e23.style.height = this.size + "px" : (e23.style.width = this.size + "px", e23.style.height = "2px", e23.style.display = "inline-block"), e23;
  } }, { key: "estimatedHeight", get: function() {
    return this.vertical ? this.size : -1;
  } }]), n2;
}(), cM = function() {
  function e22(t2) {
    Ri(this, e22), this.state = t2, this.pixelViewport = { left: 0, right: window.innerWidth, top: 0, bottom: 0 }, this.inView = true, this.paddingTop = 0, this.paddingBottom = 0, this.contentDOMWidth = 0, this.contentDOMHeight = 0, this.editorHeight = 0, this.editorWidth = 0, this.heightOracle = new JA(), this.scaler = vM, this.scrollTarget = null, this.printing = false, this.mustMeasureContent = true, this.defaultTextDirection = EO.RTL, this.visibleRanges = [], this.mustEnforceCursorAssoc = false, this.stateDeco = t2.facet(CO).filter(function(e23) {
      return typeof e23 != "function";
    }), this.heightMap = QA.empty().applyChanges(this.stateDeco, WS.empty, this.heightOracle.setDoc(t2.doc), [new AO(0, 0, 0, t2.doc.length)]), this.viewport = this.getViewport(0, null), this.updateViewportLines(), this.updateForViewport(), this.lineGaps = this.ensureLineGaps([]), this.lineGapDeco = Y$.set(this.lineGaps.map(function(e23) {
      return e23.draw(false);
    })), this.computeVisibleRanges();
  }
  return zi(e22, [{ key: "updateForViewport", value: function() {
    for (var e23 = this, t2 = [this.viewport], n2 = this.state.selection.main, r2 = function(r3) {
      var i3 = r3 ? n2.head : n2.anchor;
      if (!t2.some(function(e24) {
        var t3 = e24.from, n3 = e24.to;
        return i3 >= t3 && i3 <= n3;
      })) {
        var o2 = e23.lineBlockAt(i3), a2 = o2.from, s2 = o2.to;
        t2.push(new lM(a2, s2));
      }
    }, i2 = 0; i2 <= 1; i2++)
      r2(i2);
    this.viewports = t2.sort(function(e24, t3) {
      return e24.from - t3.from;
    }), this.scaler = this.heightMap.height <= 7e6 ? vM : new pM(this.heightOracle.doc, this.heightMap, this.viewports);
  } }, { key: "updateViewportLines", value: function() {
    var e23 = this;
    this.viewportLines = [], this.heightMap.forEachLine(this.viewport.from, this.viewport.to, this.state.doc, 0, 0, function(t2) {
      e23.viewportLines.push(e23.scaler.scale == 1 ? t2 : mM(t2, e23.scaler));
    });
  } }, { key: "update", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    this.state = e23.state;
    var n2 = this.stateDeco;
    this.stateDeco = this.state.facet(CO).filter(function(e24) {
      return typeof e24 != "function";
    });
    var r2 = e23.changedRanges, i2 = AO.extendWithRanges(r2, rM(n2, this.stateDeco, e23 ? e23.changes : mC.empty(this.state.doc.length))), o2 = this.heightMap.height;
    this.heightMap = this.heightMap.applyChanges(this.stateDeco, e23.startState.doc, this.heightOracle.setDoc(this.state.doc), i2), this.heightMap.height != o2 && (e23.flags |= 2);
    var a2 = i2.length ? this.mapViewport(this.viewport, e23.changes) : this.viewport;
    (t2 && (t2.range.head < a2.from || t2.range.head > a2.to) || !this.viewportIsAppropriate(a2)) && (a2 = this.getViewport(0, t2));
    var s2 = !e23.changes.empty || 2 & e23.flags || a2.from != this.viewport.from || a2.to != this.viewport.to;
    this.viewport = a2, this.updateForViewport(), s2 && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(this.mapLineGaps(this.lineGaps, e23.changes))), e23.flags |= this.computeVisibleRanges(), t2 && (this.scrollTarget = t2), !this.mustEnforceCursorAssoc && e23.selectionSet && e23.view.lineWrapping && e23.state.selection.main.empty && e23.state.selection.main.assoc && (this.mustEnforceCursorAssoc = true);
  } }, { key: "measure", value: function(e23) {
    var t2 = e23.contentDOM, n2 = window.getComputedStyle(t2), r2 = this.heightOracle, i2 = n2.whiteSpace;
    this.defaultTextDirection = n2.direction == "rtl" ? EO.RTL : EO.LTR;
    var o2 = this.heightOracle.mustRefreshForWrapping(i2), a2 = o2 || this.mustMeasureContent || this.contentDOMHeight != t2.clientHeight;
    this.contentDOMHeight = t2.clientHeight, this.mustMeasureContent = false;
    var s2 = 0, u2 = 0, c2 = parseInt(n2.paddingTop) || 0, l2 = parseInt(n2.paddingBottom) || 0;
    this.paddingTop == c2 && this.paddingBottom == l2 || (this.paddingTop = c2, this.paddingBottom = l2, s2 |= 10), this.editorWidth != e23.scrollDOM.clientWidth && (r2.lineWrapping && (a2 = true), this.editorWidth = e23.scrollDOM.clientWidth, s2 |= 8);
    var f2 = (this.printing ? aM : oM)(t2, this.paddingTop), h2 = f2.top - this.pixelViewport.top, d2 = f2.bottom - this.pixelViewport.bottom;
    this.pixelViewport = f2;
    var v2 = this.pixelViewport.bottom > this.pixelViewport.top && this.pixelViewport.right > this.pixelViewport.left;
    if (v2 != this.inView && (this.inView = v2, v2 && (a2 = true)), !this.inView)
      return 0;
    var p2 = t2.clientWidth;
    if (this.contentDOMWidth == p2 && this.editorHeight == e23.scrollDOM.clientHeight || (this.contentDOMWidth = p2, this.editorHeight = e23.scrollDOM.clientHeight, s2 |= 8), a2) {
      var m2 = e23.docView.measureVisibleLineHeights(this.viewport);
      if (r2.mustRefreshForHeights(m2) && (o2 = true), o2 || r2.lineWrapping && Math.abs(p2 - this.contentDOMWidth) > r2.charWidth) {
        var g2 = e23.docView.measureTextSize(), y2 = g2.lineHeight, b2 = g2.charWidth;
        (o2 = r2.refresh(i2, y2, b2, p2 / b2, m2)) && (e23.docView.minWidth = 0, s2 |= 8);
      }
      h2 > 0 && d2 > 0 ? u2 = Math.max(h2, d2) : h2 < 0 && d2 < 0 && (u2 = Math.min(h2, d2)), r2.heightChanged = false;
      var k2, w2 = bi(this.viewports);
      try {
        for (w2.s(); !(k2 = w2.n()).done; ) {
          var x2 = k2.value, j2 = x2.from == this.viewport.from ? m2 : e23.docView.measureVisibleLineHeights(x2);
          this.heightMap = this.heightMap.updateHeight(r2, 0, o2, new UA(x2.from, j2));
        }
      } catch (e24) {
        w2.e(e24);
      } finally {
        w2.f();
      }
      r2.heightChanged && (s2 |= 2);
    }
    var S2 = !this.viewportIsAppropriate(this.viewport, u2) || this.scrollTarget && (this.scrollTarget.range.head < this.viewport.from || this.scrollTarget.range.head > this.viewport.to);
    return S2 && (this.viewport = this.getViewport(u2, this.scrollTarget)), this.updateForViewport(), (2 & s2 || S2) && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(o2 ? [] : this.lineGaps)), s2 |= this.computeVisibleRanges(), this.mustEnforceCursorAssoc && (this.mustEnforceCursorAssoc = false, e23.docView.enforceCursorAssoc()), s2;
  } }, { key: "visibleTop", get: function() {
    return this.scaler.fromDOM(this.pixelViewport.top);
  } }, { key: "visibleBottom", get: function() {
    return this.scaler.fromDOM(this.pixelViewport.bottom);
  } }, { key: "getViewport", value: function(e23, t2) {
    var n2 = 0.5 - Math.max(-0.5, Math.min(0.5, e23 / 1e3 / 2)), r2 = this.heightMap, i2 = this.state.doc, o2 = this.visibleTop, a2 = this.visibleBottom, s2 = new lM(r2.lineAt(o2 - 1e3 * n2, GA.ByHeight, i2, 0, 0).from, r2.lineAt(a2 + 1e3 * (1 - n2), GA.ByHeight, i2, 0, 0).to);
    if (t2) {
      var u2 = t2.range.head;
      if (u2 < s2.from || u2 > s2.to) {
        var c2, l2 = Math.min(this.editorHeight, this.pixelViewport.bottom - this.pixelViewport.top), f2 = r2.lineAt(u2, GA.ByPos, i2, 0, 0);
        c2 = t2.y == "center" ? (f2.top + f2.bottom) / 2 - l2 / 2 : t2.y == "start" || t2.y == "nearest" && u2 < s2.from ? f2.top : f2.bottom - l2, s2 = new lM(r2.lineAt(c2 - 500, GA.ByHeight, i2, 0, 0).from, r2.lineAt(c2 + l2 + 500, GA.ByHeight, i2, 0, 0).to);
      }
    }
    return s2;
  } }, { key: "mapViewport", value: function(e23, t2) {
    var n2 = t2.mapPos(e23.from, -1), r2 = t2.mapPos(e23.to, 1);
    return new lM(this.heightMap.lineAt(n2, GA.ByPos, this.state.doc, 0, 0).from, this.heightMap.lineAt(r2, GA.ByPos, this.state.doc, 0, 0).to);
  } }, { key: "viewportIsAppropriate", value: function(e23) {
    var t2 = e23.from, n2 = e23.to, r2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    if (!this.inView)
      return true;
    var i2 = this.heightMap.lineAt(t2, GA.ByPos, this.state.doc, 0, 0), o2 = i2.top, a2 = this.heightMap.lineAt(n2, GA.ByPos, this.state.doc, 0, 0), s2 = a2.bottom, u2 = this.visibleTop, c2 = this.visibleBottom;
    return (t2 == 0 || o2 <= u2 - Math.max(10, Math.min(-r2, 250))) && (n2 == this.state.doc.length || s2 >= c2 + Math.max(10, Math.min(r2, 250))) && o2 > u2 - 2e3 && s2 < c2 + 2e3;
  } }, { key: "mapLineGaps", value: function(e23, t2) {
    if (!e23.length || t2.empty)
      return e23;
    var n2, r2 = [], i2 = bi(e23);
    try {
      for (i2.s(); !(n2 = i2.n()).done; ) {
        var o2 = n2.value;
        t2.touchesRange(o2.from, o2.to) || r2.push(new sM(t2.mapPos(o2.from), t2.mapPos(o2.to), o2.size));
      }
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    return r2;
  } }, { key: "ensureLineGaps", value: function(e23) {
    var t2 = this, n2 = [];
    if (this.defaultTextDirection != EO.LTR)
      return n2;
    var r2, i2 = bi(this.viewportLines);
    try {
      var o2 = function() {
        var i3 = r2.value;
        if (i3.length < 4e3)
          return "continue";
        var o3 = function(e24, t3, n3) {
          var r3 = [], i4 = e24, o4 = 0;
          k_.spans(n3, e24, t3, { span: function() {
          }, point: function(e25, t4) {
            e25 > i4 && (r3.push({ from: i4, to: e25 }), o4 += e25 - i4), i4 = t4;
          } }, 20), i4 < t3 && (r3.push({ from: i4, to: t3 }), o4 += t3 - i4);
          return { total: o4, ranges: r3 };
        }(i3.from, i3.to, t2.stateDeco);
        if (o3.total < 4e3)
          return "continue";
        var a2 = void 0, s2 = void 0;
        if (t2.heightOracle.lineWrapping) {
          var u2 = 2e3 / t2.heightOracle.lineLength * t2.heightOracle.lineHeight;
          a2 = fM(o3, (t2.visibleTop - i3.top - u2) / i3.height), s2 = fM(o3, (t2.visibleBottom - i3.top + u2) / i3.height);
        } else {
          var c2 = o3.total * t2.heightOracle.charWidth, l2 = 2e3 * t2.heightOracle.charWidth;
          a2 = fM(o3, (t2.pixelViewport.left - l2) / c2), s2 = fM(o3, (t2.pixelViewport.right + l2) / c2);
        }
        var f2 = [];
        a2 > i3.from && f2.push({ from: i3.from, to: a2 }), s2 < i3.to && f2.push({ from: s2, to: i3.to });
        var h2 = t2.state.selection.main;
        h2.from >= i3.from && h2.from <= i3.to && dM(f2, h2.from - 10, h2.from + 10), !h2.empty && h2.to >= i3.from && h2.to <= i3.to && dM(f2, h2.to - 10, h2.to + 10);
        for (var d2 = function() {
          var r3 = p2[v2], a3 = r3.from, s3 = r3.to;
          s3 - a3 > 1e3 && n2.push(function(e24, t3) {
            var n3, r4 = bi(e24);
            try {
              for (r4.s(); !(n3 = r4.n()).done; ) {
                var i4 = n3.value;
                if (t3(i4))
                  return i4;
              }
            } catch (e25) {
              r4.e(e25);
            } finally {
              r4.f();
            }
            return;
          }(e23, function(e24) {
            return e24.from >= i3.from && e24.to <= i3.to && Math.abs(e24.from - a3) < 1e3 && Math.abs(e24.to - s3) < 1e3;
          }) || new sM(a3, s3, t2.gapSize(i3, a3, s3, o3)));
        }, v2 = 0, p2 = f2; v2 < p2.length; v2++)
          d2();
      };
      for (i2.s(); !(r2 = i2.n()).done; )
        o2();
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    return n2;
  } }, { key: "gapSize", value: function(e23, t2, n2, r2) {
    var i2 = hM(r2, n2) - hM(r2, t2);
    return this.heightOracle.lineWrapping ? e23.height * i2 : r2.total * this.heightOracle.charWidth * i2;
  } }, { key: "updateLineGaps", value: function(e23) {
    var t2 = this;
    sM.same(e23, this.lineGaps) || (this.lineGaps = e23, this.lineGapDeco = Y$.set(e23.map(function(e24) {
      return e24.draw(t2.heightOracle.lineWrapping);
    })));
  } }, { key: "computeVisibleRanges", value: function() {
    var e23 = this.stateDeco;
    this.lineGaps.length && (e23 = e23.concat(this.lineGapDeco));
    var t2 = [];
    k_.spans(e23, this.viewport.from, this.viewport.to, { span: function(e24, n3) {
      t2.push({ from: e24, to: n3 });
    }, point: function() {
    } }, 20);
    var n2 = t2.length != this.visibleRanges.length || this.visibleRanges.some(function(e24, n3) {
      return e24.from != t2[n3].from || e24.to != t2[n3].to;
    });
    return this.visibleRanges = t2, n2 ? 4 : 0;
  } }, { key: "lineBlockAt", value: function(e23) {
    return e23 >= this.viewport.from && e23 <= this.viewport.to && this.viewportLines.find(function(t2) {
      return t2.from <= e23 && t2.to >= e23;
    }) || mM(this.heightMap.lineAt(e23, GA.ByPos, this.state.doc, 0, 0), this.scaler);
  } }, { key: "lineBlockAtHeight", value: function(e23) {
    return mM(this.heightMap.lineAt(this.scaler.fromDOM(e23), GA.ByHeight, this.state.doc, 0, 0), this.scaler);
  } }, { key: "elementAtHeight", value: function(e23) {
    return mM(this.heightMap.blockAt(this.scaler.fromDOM(e23), this.state.doc, 0, 0), this.scaler);
  } }, { key: "docHeight", get: function() {
    return this.scaler.toDOM(this.heightMap.height);
  } }, { key: "contentHeight", get: function() {
    return this.docHeight + this.paddingTop + this.paddingBottom;
  } }]), e22;
}(), lM = zi(function e5(t2, n2) {
  Ri(this, e5), this.from = t2, this.to = n2;
});
function fM(e22, t2) {
  var n2 = e22.total, r2 = e22.ranges;
  if (t2 <= 0)
    return r2[0].from;
  if (t2 >= 1)
    return r2[r2.length - 1].to;
  for (var i2 = Math.floor(n2 * t2), o2 = 0; ; o2++) {
    var a2 = r2[o2], s2 = a2.from, u2 = a2.to - s2;
    if (i2 <= u2)
      return s2 + i2;
    i2 -= u2;
  }
}
function hM(e22, t2) {
  var n2, r2 = 0, i2 = bi(e22.ranges);
  try {
    for (i2.s(); !(n2 = i2.n()).done; ) {
      var o2 = n2.value, a2 = o2.from, s2 = o2.to;
      if (t2 <= s2) {
        r2 += t2 - a2;
        break;
      }
      r2 += s2 - a2;
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  return r2 / e22.total;
}
function dM(e22, t2, n2) {
  for (var r2 = 0; r2 < e22.length; r2++) {
    var i2 = e22[r2];
    if (i2.from < n2 && i2.to > t2) {
      var o2 = [];
      i2.from < t2 && o2.push({ from: i2.from, to: t2 }), i2.to > n2 && o2.push({ from: n2, to: i2.to }), e22.splice.apply(e22, [r2, 1].concat(o2)), r2 += o2.length - 1;
    }
  }
}
var vM = { toDOM: function(e22) {
  return e22;
}, fromDOM: function(e22) {
  return e22;
}, scale: 1 }, pM = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22);
    var i2 = 0, o2 = 0, a2 = 0;
    this.viewports = r2.map(function(e23) {
      var r3 = e23.from, o3 = e23.to, a3 = n2.lineAt(r3, GA.ByPos, t2, 0, 0).top, s3 = n2.lineAt(o3, GA.ByPos, t2, 0, 0).bottom;
      return i2 += s3 - a3, { from: r3, to: o3, top: a3, bottom: s3, domTop: 0, domBottom: 0 };
    }), this.scale = (7e6 - i2) / (n2.height - i2);
    var s2, u2 = bi(this.viewports);
    try {
      for (u2.s(); !(s2 = u2.n()).done; ) {
        var c2 = s2.value;
        c2.domTop = a2 + (c2.top - o2) * this.scale, a2 = c2.domBottom = c2.domTop + (c2.bottom - c2.top), o2 = c2.bottom;
      }
    } catch (e23) {
      u2.e(e23);
    } finally {
      u2.f();
    }
  }
  return zi(e22, [{ key: "toDOM", value: function(e23) {
    for (var t2 = 0, n2 = 0, r2 = 0; ; t2++) {
      var i2 = t2 < this.viewports.length ? this.viewports[t2] : null;
      if (!i2 || e23 < i2.top)
        return r2 + (e23 - n2) * this.scale;
      if (e23 <= i2.bottom)
        return i2.domTop + (e23 - i2.top);
      n2 = i2.bottom, r2 = i2.domBottom;
    }
  } }, { key: "fromDOM", value: function(e23) {
    for (var t2 = 0, n2 = 0, r2 = 0; ; t2++) {
      var i2 = t2 < this.viewports.length ? this.viewports[t2] : null;
      if (!i2 || e23 < i2.domTop)
        return n2 + (e23 - r2) / this.scale;
      if (e23 <= i2.domBottom)
        return i2.top + (e23 - i2.domTop);
      n2 = i2.bottom, r2 = i2.domBottom;
    }
  } }]), e22;
}();
function mM(e22, t2) {
  if (t2.scale == 1)
    return e22;
  var n2 = t2.toDOM(e22.top), r2 = t2.toDOM(e22.bottom);
  return new KA(e22.from, e22.length, n2, r2 - n2, Array.isArray(e22.type) ? e22.type.map(function(e23) {
    return mM(e23, t2);
  }) : e22.type);
}
var gM = $C.define({ combine: function(e22) {
  return e22.join(" ");
} }), yM = $C.define({ combine: function(e22) {
  return e22.indexOf(true) > -1;
} }), bM = z_.newName(), kM = z_.newName(), wM = z_.newName(), xM = { "&light": "." + kM, "&dark": "." + wM };
function jM(e22, t2, n2) {
  return new z_(t2, { finish: function(t3) {
    return /&/.test(t3) ? t3.replace(/&\w*/, function(t4) {
      if (t4 == "&")
        return e22;
      if (!n2 || !n2[t4])
        throw new RangeError("Unsupported selector: ".concat(t4));
      return n2[t4];
    }) : e22 + " " + t3;
  } });
}
var SM = jM("." + bM, { "&.cm-editor": { position: "relative !important", boxSizing: "border-box", "&.cm-focused": { outline: "1px dotted #212121" }, display: "flex !important", flexDirection: "column" }, ".cm-scroller": { display: "flex !important", alignItems: "flex-start !important", fontFamily: "monospace", lineHeight: 1.4, height: "100%", overflowX: "auto", position: "relative", zIndex: 0 }, ".cm-content": { margin: 0, flexGrow: 2, flexShrink: 0, minHeight: "100%", display: "block", whiteSpace: "pre", wordWrap: "normal", boxSizing: "border-box", padding: "4px 0", outline: "none", "&[contenteditable=true]": { WebkitUserModify: "read-write-plaintext-only" } }, ".cm-lineWrapping": { whiteSpace_fallback: "pre-wrap", whiteSpace: "break-spaces", wordBreak: "break-word", overflowWrap: "anywhere", flexShrink: 1 }, "&light .cm-content": { caretColor: "black" }, "&dark .cm-content": { caretColor: "white" }, ".cm-line": { display: "block", padding: "0 2px 0 4px" }, ".cm-selectionLayer": { zIndex: -1, contain: "size style" }, ".cm-selectionBackground": { position: "absolute" }, "&light .cm-selectionBackground": { background: "#d9d9d9" }, "&dark .cm-selectionBackground": { background: "#222" }, "&light.cm-focused .cm-selectionBackground": { background: "#d7d4f0" }, "&dark.cm-focused .cm-selectionBackground": { background: "#233" }, ".cm-cursorLayer": { zIndex: 100, contain: "size style", pointerEvents: "none" }, "&.cm-focused .cm-cursorLayer": { animation: "steps(1) cm-blink 1.2s infinite" }, "@keyframes cm-blink": { "0%": {}, "50%": { visibility: "hidden" }, "100%": {} }, "@keyframes cm-blink2": { "0%": {}, "50%": { visibility: "hidden" }, "100%": {} }, ".cm-cursor, .cm-dropCursor": { position: "absolute", borderLeft: "1.2px solid black", marginLeft: "-0.6px", pointerEvents: "none" }, ".cm-cursor": { display: "none" }, "&dark .cm-cursor": { borderLeftColor: "#444" }, "&.cm-focused .cm-cursor": { display: "block" }, "&light .cm-activeLine": { backgroundColor: "#f3f9ff" }, "&dark .cm-activeLine": { backgroundColor: "#223039" }, "&light .cm-specialChar": { color: "red" }, "&dark .cm-specialChar": { color: "#f78" }, ".cm-gutters": { display: "flex", height: "100%", boxSizing: "border-box", left: 0, zIndex: 200 }, "&light .cm-gutters": { backgroundColor: "#f5f5f5", color: "#6c6c6c", borderRight: "1px solid #ddd" }, "&dark .cm-gutters": { backgroundColor: "#333338", color: "#ccc" }, ".cm-gutter": { display: "flex !important", flexDirection: "column", flexShrink: 0, boxSizing: "border-box", minHeight: "100%", overflow: "hidden" }, ".cm-gutterElement": { boxSizing: "border-box" }, ".cm-lineNumbers .cm-gutterElement": { padding: "0 3px 0 5px", minWidth: "20px", textAlign: "right", whiteSpace: "nowrap" }, "&light .cm-activeLineGutter": { backgroundColor: "#e2f2ff" }, "&dark .cm-activeLineGutter": { backgroundColor: "#222227" }, ".cm-panels": { boxSizing: "border-box", position: "sticky", left: 0, right: 0 }, "&light .cm-panels": { backgroundColor: "#f5f5f5", color: "black" }, "&light .cm-panels-top": { borderBottom: "1px solid #ddd" }, "&light .cm-panels-bottom": { borderTop: "1px solid #ddd" }, "&dark .cm-panels": { backgroundColor: "#333338", color: "white" }, ".cm-tab": { display: "inline-block", overflow: "hidden", verticalAlign: "bottom" }, ".cm-widgetBuffer": { verticalAlign: "text-top", height: "1em", display: "inline" }, ".cm-placeholder": { color: "#888", display: "inline-block", verticalAlign: "top" }, ".cm-button": { verticalAlign: "middle", color: "inherit", fontSize: "70%", padding: ".2em 1em", borderRadius: "1px" }, "&light .cm-button": { backgroundImage: "linear-gradient(#eff1f5, #d9d9df)", border: "1px solid #888", "&:active": { backgroundImage: "linear-gradient(#b4b4b4, #d0d3d6)" } }, "&dark .cm-button": { backgroundImage: "linear-gradient(#393939, #111)", border: "1px solid #888", "&:active": { backgroundImage: "linear-gradient(#111, #333)" } }, ".cm-textfield": { verticalAlign: "middle", color: "inherit", fontSize: "70%", border: "1px solid silver", padding: ".2em .5em" }, "&light .cm-textfield": { backgroundColor: "white" }, "&dark .cm-textfield": { border: "1px solid #555", backgroundColor: "inherit" } }, xM), CM = { childList: true, characterData: true, subtree: true, attributes: true, characterDataOldValue: true }, _M = T$.ie && T$.ie_version <= 11, $M = function() {
  function e22(t2, n2, r2) {
    var i2 = this;
    Ri(this, e22), this.view = t2, this.onChange = n2, this.onScrollChanged = r2, this.active = false, this.selectionRange = new c$(), this.selectionChanged = false, this.delayedFlush = -1, this.resizeTimeout = -1, this.queue = [], this.delayedAndroidKey = null, this.scrollTargets = [], this.intersection = null, this.resize = null, this.intersecting = false, this.gapIntersection = null, this.gaps = [], this.parentCheck = -1, this.dom = t2.contentDOM, this.observer = new MutationObserver(function(e23) {
      var n3, r3 = bi(e23);
      try {
        for (r3.s(); !(n3 = r3.n()).done; ) {
          var o2 = n3.value;
          i2.queue.push(o2);
        }
      } catch (e24) {
        r3.e(e24);
      } finally {
        r3.f();
      }
      (T$.ie && T$.ie_version <= 11 || T$.ios && t2.composing) && e23.some(function(e24) {
        return e24.type == "childList" && e24.removedNodes.length || e24.type == "characterData" && e24.oldValue.length > e24.target.nodeValue.length;
      }) ? i2.flushSoon() : i2.flush();
    }), _M && (this.onCharData = function(e23) {
      i2.queue.push({ target: e23.target, type: "characterData", oldValue: e23.prevValue }), i2.flushSoon();
    }), this.onSelectionChange = this.onSelectionChange.bind(this), window.addEventListener("resize", this.onResize = this.onResize.bind(this)), typeof ResizeObserver == "function" && (this.resize = new ResizeObserver(function() {
      i2.view.docView.lastUpdate < Date.now() - 75 && i2.onResize();
    }), this.resize.observe(t2.scrollDOM)), window.addEventListener("beforeprint", this.onPrint = this.onPrint.bind(this)), this.start(), window.addEventListener("scroll", this.onScroll = this.onScroll.bind(this)), typeof IntersectionObserver == "function" && (this.intersection = new IntersectionObserver(function(e23) {
      i2.parentCheck < 0 && (i2.parentCheck = setTimeout(i2.listenForScroll.bind(i2), 1e3)), e23.length > 0 && e23[e23.length - 1].intersectionRatio > 0 != i2.intersecting && (i2.intersecting = !i2.intersecting, i2.intersecting != i2.view.inView && i2.onScrollChanged(document.createEvent("Event")));
    }, {}), this.intersection.observe(this.dom), this.gapIntersection = new IntersectionObserver(function(e23) {
      e23.length > 0 && e23[e23.length - 1].intersectionRatio > 0 && i2.onScrollChanged(document.createEvent("Event"));
    }, {})), this.listenForScroll(), this.readSelectionRange(), this.dom.ownerDocument.addEventListener("selectionchange", this.onSelectionChange);
  }
  return zi(e22, [{ key: "onScroll", value: function(e23) {
    this.intersecting && this.flush(false), this.onScrollChanged(e23);
  } }, { key: "onResize", value: function() {
    var e23 = this;
    this.resizeTimeout < 0 && (this.resizeTimeout = setTimeout(function() {
      e23.resizeTimeout = -1, e23.view.requestMeasure();
    }, 50));
  } }, { key: "onPrint", value: function() {
    var e23 = this;
    this.view.viewState.printing = true, this.view.measure(), setTimeout(function() {
      e23.view.viewState.printing = false, e23.view.requestMeasure();
    }, 500);
  } }, { key: "updateGaps", value: function(e23) {
    if (this.gapIntersection && (e23.length != this.gaps.length || this.gaps.some(function(t3, n3) {
      return t3 != e23[n3];
    }))) {
      this.gapIntersection.disconnect();
      var t2, n2 = bi(e23);
      try {
        for (n2.s(); !(t2 = n2.n()).done; ) {
          var r2 = t2.value;
          this.gapIntersection.observe(r2);
        }
      } catch (e24) {
        n2.e(e24);
      } finally {
        n2.f();
      }
      this.gaps = e23;
    }
  } }, { key: "onSelectionChange", value: function(e23) {
    if (this.readSelectionRange() && !this.delayedAndroidKey) {
      var t2 = this.view, n2 = this.selectionRange;
      if (t2.state.facet(yO) ? t2.root.activeElement == this.dom : X_(t2.dom, n2)) {
        var r2 = n2.anchorNode && t2.docView.nearest(n2.anchorNode);
        r2 && r2.ignoreEvent(e23) || ((T$.ie && T$.ie_version <= 11 || T$.android && T$.chrome) && !t2.state.selection.main.empty && n2.focusNode && t$(n2.focusNode, n2.focusOffset, n2.anchorNode, n2.anchorOffset) ? this.flushSoon() : this.flush(false));
      }
    }
  } }, { key: "readSelectionRange", value: function() {
    var e23 = this.view.root, t2 = T$.safari && e23.nodeType == 11 && function() {
      for (var e24 = document.activeElement; e24 && e24.shadowRoot; )
        e24 = e24.shadowRoot.activeElement;
      return e24;
    }() == this.view.contentDOM && function(e24) {
      var t3 = null;
      function n2(e25) {
        e25.preventDefault(), e25.stopImmediatePropagation(), t3 = e25.getTargetRanges()[0];
      }
      if (e24.contentDOM.addEventListener("beforeinput", n2, true), document.execCommand("indent"), e24.contentDOM.removeEventListener("beforeinput", n2, true), !t3)
        return null;
      var r2 = t3.startContainer, i2 = t3.startOffset, o2 = t3.endContainer, a2 = t3.endOffset, s2 = e24.docView.domAtPos(e24.state.selection.main.anchor);
      if (t$(s2.node, s2.offset, o2, a2)) {
        var u2 = [o2, a2, r2, i2];
        r2 = u2[0], i2 = u2[1], o2 = u2[2], a2 = u2[3];
      }
      return { anchorNode: r2, anchorOffset: i2, focusNode: o2, focusOffset: a2 };
    }(this.view) || Y_(e23);
    return !(!t2 || this.selectionRange.eq(t2)) && (this.selectionRange.setRange(t2), this.selectionChanged = true);
  } }, { key: "setSelectionRange", value: function(e23, t2) {
    this.selectionRange.set(e23.node, e23.offset, t2.node, t2.offset), this.selectionChanged = false;
  } }, { key: "clearSelectionRange", value: function() {
    this.selectionRange.set(null, 0, null, 0);
  } }, { key: "listenForScroll", value: function() {
    this.parentCheck = -1;
    for (var e23 = 0, t2 = null, n2 = this.dom; n2; )
      if (n2.nodeType == 1)
        !t2 && e23 < this.scrollTargets.length && this.scrollTargets[e23] == n2 ? e23++ : t2 || (t2 = this.scrollTargets.slice(0, e23)), t2 && t2.push(n2), n2 = n2.assignedSlot || n2.parentNode;
      else {
        if (n2.nodeType != 11)
          break;
        n2 = n2.host;
      }
    if (e23 < this.scrollTargets.length && !t2 && (t2 = this.scrollTargets.slice(0, e23)), t2) {
      var r2, i2 = bi(this.scrollTargets);
      try {
        for (i2.s(); !(r2 = i2.n()).done; ) {
          r2.value.removeEventListener("scroll", this.onScroll);
        }
      } catch (e24) {
        i2.e(e24);
      } finally {
        i2.f();
      }
      var o2, a2 = bi(this.scrollTargets = t2);
      try {
        for (a2.s(); !(o2 = a2.n()).done; ) {
          o2.value.addEventListener("scroll", this.onScroll);
        }
      } catch (e24) {
        a2.e(e24);
      } finally {
        a2.f();
      }
    }
  } }, { key: "ignore", value: function(e23) {
    if (!this.active)
      return e23();
    try {
      return this.stop(), e23();
    } finally {
      this.start(), this.clear();
    }
  } }, { key: "start", value: function() {
    this.active || (this.observer.observe(this.dom, CM), _M && this.dom.addEventListener("DOMCharacterDataModified", this.onCharData), this.active = true);
  } }, { key: "stop", value: function() {
    this.active && (this.active = false, this.observer.disconnect(), _M && this.dom.removeEventListener("DOMCharacterDataModified", this.onCharData));
  } }, { key: "clear", value: function() {
    this.processRecords(), this.queue.length = 0, this.selectionChanged = false;
  } }, { key: "delayAndroidKey", value: function(e23, t2) {
    var n2 = this;
    this.delayedAndroidKey || requestAnimationFrame(function() {
      var e24 = n2.delayedAndroidKey;
      n2.delayedAndroidKey = null, n2.delayedFlush = -1, n2.flush() || d$(n2.view.contentDOM, e24.key, e24.keyCode);
    }), this.delayedAndroidKey && e23 != "Enter" || (this.delayedAndroidKey = { key: e23, keyCode: t2 });
  } }, { key: "flushSoon", value: function() {
    var e23 = this;
    this.delayedFlush < 0 && (this.delayedFlush = window.setTimeout(function() {
      e23.delayedFlush = -1, e23.flush();
    }, 20));
  } }, { key: "forceFlush", value: function() {
    this.delayedFlush >= 0 && (window.clearTimeout(this.delayedFlush), this.delayedFlush = -1, this.flush());
  } }, { key: "processRecords", value: function() {
    var e23, t2 = this.queue, n2 = bi(this.observer.takeRecords());
    try {
      for (n2.s(); !(e23 = n2.n()).done; ) {
        var r2 = e23.value;
        t2.push(r2);
      }
    } catch (e24) {
      n2.e(e24);
    } finally {
      n2.f();
    }
    t2.length && (this.queue = []);
    var i2, o2 = -1, a2 = -1, s2 = false, u2 = bi(t2);
    try {
      for (u2.s(); !(i2 = u2.n()).done; ) {
        var c2 = i2.value, l2 = this.readMutation(c2);
        l2 && (l2.typeOver && (s2 = true), o2 == -1 ? (o2 = l2.from, a2 = l2.to) : (o2 = Math.min(l2.from, o2), a2 = Math.max(l2.to, a2)));
      }
    } catch (e24) {
      u2.e(e24);
    } finally {
      u2.f();
    }
    return { from: o2, to: a2, typeOver: s2 };
  } }, { key: "flush", value: function() {
    var e23 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    if (!(this.delayedFlush >= 0 || this.delayedAndroidKey)) {
      e23 && this.readSelectionRange();
      var t2 = this.processRecords(), n2 = t2.from, r2 = t2.to, i2 = t2.typeOver, o2 = this.selectionChanged && X_(this.dom, this.selectionRange);
      if (!(n2 < 0) || o2) {
        this.selectionChanged = false;
        var a2 = this.view.state, s2 = this.onChange(n2, r2, i2);
        return this.view.state == a2 && this.view.update([]), s2;
      }
    }
  } }, { key: "readMutation", value: function(e23) {
    var t2 = this.view.docView.nearest(e23.target);
    if (!t2 || t2.ignoreMutation(e23))
      return null;
    if (t2.markDirty(e23.type == "attributes"), e23.type == "attributes" && (t2.dirty |= 4), e23.type == "childList") {
      var n2 = OM(t2, e23.previousSibling || e23.target.previousSibling, -1), r2 = OM(t2, e23.nextSibling || e23.target.nextSibling, 1);
      return { from: n2 ? t2.posAfter(n2) : t2.posAtStart, to: r2 ? t2.posBefore(r2) : t2.posAtEnd, typeOver: false };
    }
    return e23.type == "characterData" ? { from: t2.posAtStart, to: t2.posAtEnd, typeOver: e23.target.nodeValue == e23.oldValue } : null;
  } }, { key: "destroy", value: function() {
    var e23, t2, n2;
    this.stop(), (e23 = this.intersection) === null || e23 === void 0 || e23.disconnect(), (t2 = this.gapIntersection) === null || t2 === void 0 || t2.disconnect(), (n2 = this.resize) === null || n2 === void 0 || n2.disconnect();
    var r2, i2 = bi(this.scrollTargets);
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        r2.value.removeEventListener("scroll", this.onScroll);
      }
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    window.removeEventListener("scroll", this.onScroll), window.removeEventListener("resize", this.onResize), window.removeEventListener("beforeprint", this.onPrint), this.dom.ownerDocument.removeEventListener("selectionchange", this.onSelectionChange), clearTimeout(this.parentCheck), clearTimeout(this.resizeTimeout);
  } }]), e22;
}();
function OM(e22, t2, n2) {
  for (; t2; ) {
    var r2 = y$.get(t2);
    if (r2 && r2.parent == e22)
      return r2;
    var i2 = t2.parentNode;
    t2 = i2 != e22.dom ? i2 : n2 > 0 ? t2.nextSibling : t2.previousSibling;
  }
  return null;
}
function AM(e22, t2, n2, r2) {
  var i2, o2, a2 = e22.state.selection.main;
  if (t2 > -1) {
    var s2 = e22.docView.domBoundsAround(t2, n2, 0);
    if (!s2 || e22.state.readOnly)
      return false;
    var u2 = s2.from, c2 = s2.to, l2 = e22.docView.impreciseHead || e22.docView.impreciseAnchor ? [] : function(e23) {
      var t3 = [];
      if (e23.root.activeElement != e23.contentDOM)
        return t3;
      var n3 = e23.observer.selectionRange, r3 = n3.anchorNode, i3 = n3.anchorOffset, o3 = n3.focusNode, a3 = n3.focusOffset;
      r3 && (t3.push(new XO(r3, i3)), o3 == r3 && a3 == i3 || t3.push(new XO(o3, a3)));
      return t3;
    }(e22), f2 = new YO(l2, e22.state);
    f2.readRange(s2.startDOM, s2.endDOM);
    var h2 = a2.from, d2 = null;
    (e22.inputState.lastKeyCode === 8 && e22.inputState.lastKeyTime > Date.now() - 100 || T$.android && f2.text.length < c2 - u2) && (h2 = a2.to, d2 = "end");
    var v2 = function(e23, t3, n3, r3) {
      var i3 = Math.min(e23.length, t3.length), o3 = 0;
      for (; o3 < i3 && e23.charCodeAt(o3) == t3.charCodeAt(o3); )
        o3++;
      if (o3 == i3 && e23.length == t3.length)
        return null;
      var a3 = e23.length, s3 = t3.length;
      for (; a3 > 0 && s3 > 0 && e23.charCodeAt(a3 - 1) == t3.charCodeAt(s3 - 1); )
        a3--, s3--;
      if (r3 == "end") {
        n3 -= a3 + Math.max(0, o3 - Math.min(a3, s3)) - o3;
      }
      if (a3 < o3 && e23.length < t3.length) {
        s3 = (o3 -= n3 <= o3 && n3 >= a3 ? o3 - n3 : 0) + (s3 - a3), a3 = o3;
      } else if (s3 < o3) {
        a3 = (o3 -= n3 <= o3 && n3 >= s3 ? o3 - n3 : 0) + (a3 - s3), s3 = o3;
      }
      return { from: o3, toA: a3, toB: s3 };
    }(e22.state.doc.sliceString(u2, c2, "\uFFFF"), f2.text, h2 - u2, d2);
    v2 && (T$.chrome && e22.inputState.lastKeyCode == 13 && v2.toB == v2.from + 2 && f2.text.slice(v2.from, v2.toB) == "\uFFFF\uFFFF" && v2.toB--, i2 = { from: u2 + v2.from, to: u2 + v2.toA, insert: WS.of(f2.text.slice(v2.from, v2.toB).split("\uFFFF")) }), o2 = function(e23, t3) {
      if (e23.length == 0)
        return null;
      var n3 = e23[0].pos, r3 = e23.length == 2 ? e23[1].pos : n3;
      return n3 > -1 && r3 > -1 ? SC.single(n3 + t3, r3 + t3) : null;
    }(l2, u2);
  } else if (e22.hasFocus || !e22.state.facet(yO)) {
    var p2 = e22.observer.selectionRange, m2 = e22.docView, g2 = m2.impreciseHead, y2 = m2.impreciseAnchor, b2 = g2 && g2.node == p2.focusNode && g2.offset == p2.focusOffset || !Z_(e22.contentDOM, p2.focusNode) ? e22.state.selection.main.head : e22.docView.posFromDOM(p2.focusNode, p2.focusOffset), k2 = y2 && y2.node == p2.anchorNode && y2.offset == p2.anchorOffset || !Z_(e22.contentDOM, p2.anchorNode) ? e22.state.selection.main.anchor : e22.docView.posFromDOM(p2.anchorNode, p2.anchorOffset);
    b2 == a2.head && k2 == a2.anchor || (o2 = SC.single(k2, b2));
  }
  if (!i2 && !o2)
    return false;
  if (!i2 && r2 && !a2.empty && o2 && o2.main.empty ? i2 = { from: a2.from, to: a2.to, insert: e22.state.doc.slice(a2.from, a2.to) } : i2 && i2.from >= a2.from && i2.to <= a2.to && (i2.from != a2.from || i2.to != a2.to) && a2.to - a2.from - (i2.to - i2.from) <= 4 ? i2 = { from: a2.from, to: a2.to, insert: e22.state.doc.slice(a2.from, i2.from).append(i2.insert).append(e22.state.doc.slice(i2.to, a2.to)) } : (T$.mac || T$.android) && i2 && i2.from == i2.to && i2.from == a2.head - 1 && i2.insert.toString() == "." && (i2 = { from: a2.from, to: a2.to, insert: WS.of([" "]) }), i2) {
    var w2 = e22.state;
    if (T$.ios && e22.inputState.flushIOSKey(e22))
      return true;
    if (T$.android && (i2.from == a2.from && i2.to == a2.to && i2.insert.length == 1 && i2.insert.lines == 2 && d$(e22.contentDOM, "Enter", 13) || i2.from == a2.from - 1 && i2.to == a2.to && i2.insert.length == 0 && d$(e22.contentDOM, "Backspace", 8) || i2.from == a2.from && i2.to == a2.to + 1 && i2.insert.length == 0 && d$(e22.contentDOM, "Delete", 46)))
      return true;
    var x2, j2 = i2.insert.toString();
    if (e22.state.facet(dO).some(function(t3) {
      return t3(e22, i2.from, i2.to, j2);
    }))
      return true;
    if (e22.inputState.composing >= 0 && e22.inputState.composing++, i2.from >= a2.from && i2.to <= a2.to && i2.to - i2.from >= (a2.to - a2.from) / 3 && (!o2 || o2.main.empty && o2.main.from == i2.from + i2.insert.length) && e22.inputState.composing < 0) {
      var S2 = a2.from < i2.from ? w2.sliceDoc(a2.from, i2.from) : "", C2 = a2.to > i2.to ? w2.sliceDoc(i2.to, a2.to) : "";
      x2 = w2.replaceSelection(e22.state.toText(S2 + i2.insert.sliceString(0, void 0, e22.state.lineBreak) + C2));
    } else {
      var _2 = w2.changes(i2), $2 = o2 && !w2.selection.main.eq(o2.main) && o2.main.to <= _2.newLength ? o2.main : void 0;
      if (w2.selection.ranges.length > 1 && e22.inputState.composing >= 0 && i2.to <= a2.to && i2.to >= a2.to - 10) {
        var O2 = e22.state.sliceDoc(i2.from, i2.to), A2 = rA(e22) || e22.state.doc.lineAt(a2.head), M2 = a2.to - i2.to, E2 = a2.to - a2.from;
        x2 = w2.changeByRange(function(t3) {
          if (t3.from == a2.from && t3.to == a2.to)
            return { changes: _2, range: $2 || t3.map(_2) };
          var n3 = t3.to - M2, r3 = n3 - O2.length;
          if (t3.to - t3.from != E2 || e22.state.sliceDoc(r3, n3) != O2 || A2 && t3.to >= A2.from && t3.from <= A2.to)
            return { range: t3 };
          var o3 = w2.changes({ from: r3, to: n3, insert: i2.insert }), s3 = t3.to - a2.to;
          return { changes: o3, range: $2 ? SC.range(Math.max(0, $2.anchor + s3), Math.max(0, $2.head + s3)) : t3.map(o3) };
        });
      } else
        x2 = { changes: _2, selection: $2 && w2.selection.replaceRange($2) };
    }
    var P2 = "input.type";
    return e22.composing && (P2 += ".compose", e22.inputState.compositionFirstChange && (P2 += ".start", e22.inputState.compositionFirstChange = false)), e22.dispatch(x2, { scrollIntoView: true, userEvent: P2 }), true;
  }
  if (o2 && !o2.main.eq(a2)) {
    var N2 = false, T2 = "select";
    return e22.inputState.lastSelectionTime > Date.now() - 50 && (e22.inputState.lastSelectionOrigin == "select" && (N2 = true), T2 = e22.inputState.lastSelectionOrigin), e22.dispatch({ selection: o2, scrollIntoView: N2, userEvent: T2 }), true;
  }
  return false;
}
var MM = function() {
  function e22() {
    var t2 = this, n2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    Ri(this, e22), this.plugins = [], this.pluginMap = /* @__PURE__ */ new Map(), this.editorAttrs = {}, this.contentAttrs = {}, this.bidiCache = [], this.destroyed = false, this.updateState = 2, this.measureScheduled = -1, this.measureRequests = [], this.contentDOM = document.createElement("div"), this.scrollDOM = document.createElement("div"), this.scrollDOM.tabIndex = -1, this.scrollDOM.className = "cm-scroller", this.scrollDOM.appendChild(this.contentDOM), this.announceDOM = document.createElement("div"), this.announceDOM.style.cssText = "position: absolute; top: -10000px", this.announceDOM.setAttribute("aria-live", "polite"), this.dom = document.createElement("div"), this.dom.appendChild(this.announceDOM), this.dom.appendChild(this.scrollDOM), this._dispatch = n2.dispatch || function(e23) {
      return t2.update([e23]);
    }, this.dispatch = this.dispatch.bind(this), this.root = n2.root || v$(n2.parent) || document, this.viewState = new cM(n2.state || v_.create(n2)), this.plugins = this.state.facet(kO).map(function(e23) {
      return new xO(e23);
    });
    var r2, i2 = bi(this.plugins);
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        var o2 = r2.value;
        o2.update(this);
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
    this.observer = new $M(this, function(e23, n3, r3) {
      return AM(t2, e23, n3, r3);
    }, function(e23) {
      t2.inputState.runScrollHandlers(t2, e23), t2.observer.intersecting && t2.measure();
    }), this.inputState = new xA(this), this.inputState.ensureHandlers(this, this.plugins), this.docView = new eA(this), this.mountStyles(), this.updateAttrs(), this.updateState = 0, this.requestMeasure(), n2.parent && n2.parent.appendChild(this.dom);
  }
  return zi(e22, [{ key: "state", get: function() {
    return this.viewState.state;
  } }, { key: "viewport", get: function() {
    return this.viewState.viewport;
  } }, { key: "visibleRanges", get: function() {
    return this.viewState.visibleRanges;
  } }, { key: "inView", get: function() {
    return this.viewState.inView;
  } }, { key: "composing", get: function() {
    return this.inputState.composing > 0;
  } }, { key: "compositionStarted", get: function() {
    return this.inputState.composing >= 0;
  } }, { key: "dispatch", value: function() {
    var e23;
    this._dispatch(arguments.length == 1 && (arguments.length <= 0 ? void 0 : arguments[0]) instanceof r_ ? arguments.length <= 0 ? void 0 : arguments[0] : (e23 = this.state).update.apply(e23, arguments));
  } }, { key: "update", value: function(e23) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.update are not allowed while an update is in progress");
    var t2, n2, r2 = false, i2 = false, o2 = this.state, a2 = bi(e23);
    try {
      for (a2.s(); !(n2 = a2.n()).done; ) {
        var s2 = n2.value;
        if (s2.startState != o2)
          throw new RangeError("Trying to update state with a transaction that doesn't start from the previous state.");
        o2 = s2.state;
      }
    } catch (e24) {
      a2.e(e24);
    } finally {
      a2.f();
    }
    if (this.destroyed)
      this.viewState.state = o2;
    else {
      if (this.observer.clear(), o2.facet(v_.phrases) != this.state.facet(v_.phrases))
        return this.setState(o2);
      t2 = MO.create(this, o2, e23);
      var u2 = this.viewState.scrollTarget;
      try {
        this.updateState = 2;
        var c2, l2 = bi(e23);
        try {
          for (l2.s(); !(c2 = l2.n()).done; ) {
            var f2 = c2.value;
            if (u2 && (u2 = u2.map(f2.changes)), f2.scrollIntoView) {
              var h2 = f2.state.selection.main;
              u2 = new pO(h2.empty ? h2 : SC.cursor(h2.head, h2.head > h2.anchor ? -1 : 1));
            }
            var d2, v2 = bi(f2.effects);
            try {
              for (v2.s(); !(d2 = v2.n()).done; ) {
                var p2 = d2.value;
                p2.is(mO) && (u2 = p2.value);
              }
            } catch (e24) {
              v2.e(e24);
            } finally {
              v2.f();
            }
          }
        } catch (e24) {
          l2.e(e24);
        } finally {
          l2.f();
        }
        this.viewState.update(t2, u2), this.bidiCache = NM.update(this.bidiCache, t2.changes), t2.empty || (this.updatePlugins(t2), this.inputState.update(t2)), r2 = this.docView.update(t2), this.state.facet(OO) != this.styleModules && this.mountStyles(), i2 = this.updateAttrs(), this.showAnnouncements(e23), this.docView.updateSelection(r2, e23.some(function(e24) {
          return e24.isUserEvent("select.pointer");
        }));
      } finally {
        this.updateState = 0;
      }
      if (t2.startState.facet(gM) != t2.state.facet(gM) && (this.viewState.mustMeasureContent = true), (r2 || i2 || u2 || this.viewState.mustEnforceCursorAssoc || this.viewState.mustMeasureContent) && this.requestMeasure(), !t2.empty) {
        var m2, g2 = bi(this.state.facet(hO));
        try {
          for (g2.s(); !(m2 = g2.n()).done; ) {
            (0, m2.value)(t2);
          }
        } catch (e24) {
          g2.e(e24);
        } finally {
          g2.f();
        }
      }
    }
  } }, { key: "setState", value: function(e23) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.setState are not allowed while an update is in progress");
    if (this.destroyed)
      this.viewState.state = e23;
    else {
      this.updateState = 2;
      var t2 = this.hasFocus;
      try {
        var n2, r2 = bi(this.plugins);
        try {
          for (r2.s(); !(n2 = r2.n()).done; ) {
            n2.value.destroy(this);
          }
        } catch (e24) {
          r2.e(e24);
        } finally {
          r2.f();
        }
        this.viewState = new cM(e23), this.plugins = e23.facet(kO).map(function(e24) {
          return new xO(e24);
        }), this.pluginMap.clear();
        var i2, o2 = bi(this.plugins);
        try {
          for (o2.s(); !(i2 = o2.n()).done; ) {
            i2.value.update(this);
          }
        } catch (e24) {
          o2.e(e24);
        } finally {
          o2.f();
        }
        this.docView = new eA(this), this.inputState.ensureHandlers(this, this.plugins), this.mountStyles(), this.updateAttrs(), this.bidiCache = [];
      } finally {
        this.updateState = 0;
      }
      t2 && this.focus(), this.requestMeasure();
    }
  } }, { key: "updatePlugins", value: function(e23) {
    var t2 = e23.startState.facet(kO), n2 = e23.state.facet(kO);
    if (t2 != n2) {
      var r2, i2 = [], o2 = bi(n2);
      try {
        for (o2.s(); !(r2 = o2.n()).done; ) {
          var a2 = r2.value, s2 = t2.indexOf(a2);
          if (s2 < 0)
            i2.push(new xO(a2));
          else {
            var u2 = this.plugins[s2];
            u2.mustUpdate = e23, i2.push(u2);
          }
        }
      } catch (e24) {
        o2.e(e24);
      } finally {
        o2.f();
      }
      var c2, l2 = bi(this.plugins);
      try {
        for (l2.s(); !(c2 = l2.n()).done; ) {
          var f2 = c2.value;
          f2.mustUpdate != e23 && f2.destroy(this);
        }
      } catch (e24) {
        l2.e(e24);
      } finally {
        l2.f();
      }
      this.plugins = i2, this.pluginMap.clear(), this.inputState.ensureHandlers(this, this.plugins);
    } else {
      var h2, d2 = bi(this.plugins);
      try {
        for (d2.s(); !(h2 = d2.n()).done; ) {
          h2.value.mustUpdate = e23;
        }
      } catch (e24) {
        d2.e(e24);
      } finally {
        d2.f();
      }
    }
    for (var v2 = 0; v2 < this.plugins.length; v2++)
      this.plugins[v2].update(this);
  } }, { key: "measure", value: function() {
    var e23 = this, t2 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    if (!this.destroyed) {
      this.measureScheduled > -1 && cancelAnimationFrame(this.measureScheduled), this.measureScheduled = 0, t2 && this.observer.flush();
      var n2 = null;
      try {
        for (var r2 = 0; ; r2++) {
          this.updateState = 1;
          var i2 = this.viewport, o2 = this.viewState.measure(this);
          if (!o2 && !this.measureRequests.length && this.viewState.scrollTarget == null)
            break;
          if (r2 > 5) {
            console.warn(this.measureRequests.length ? "Measure loop restarted more than 5 times" : "Viewport failed to stabilize");
            break;
          }
          var a2 = [];
          if (!(4 & o2)) {
            var s2 = [a2, this.measureRequests];
            this.measureRequests = s2[0], a2 = s2[1];
          }
          var u2 = a2.map(function(t3) {
            try {
              return t3.read(e23);
            } catch (t4) {
              return gO(e23.state, t4), PM;
            }
          }), c2 = MO.create(this, this.state, []), l2 = false, f2 = false;
          c2.flags |= o2, n2 ? n2.flags |= o2 : n2 = c2, this.updateState = 2, c2.empty || (this.updatePlugins(c2), this.inputState.update(c2), this.updateAttrs(), l2 = this.docView.update(c2));
          for (var h2 = 0; h2 < a2.length; h2++)
            if (u2[h2] != PM)
              try {
                var d2 = a2[h2];
                d2.write && d2.write(u2[h2], this);
              } catch (e24) {
                gO(this.state, e24);
              }
          if (this.viewState.scrollTarget && (this.docView.scrollIntoView(this.viewState.scrollTarget), this.viewState.scrollTarget = null, f2 = true), l2 && this.docView.updateSelection(true), this.viewport.from == i2.from && this.viewport.to == i2.to && !f2 && this.measureRequests.length == 0)
            break;
        }
      } finally {
        this.updateState = 0, this.measureScheduled = -1;
      }
      if (n2 && !n2.empty) {
        var v2, p2 = bi(this.state.facet(hO));
        try {
          for (p2.s(); !(v2 = p2.n()).done; ) {
            var m2 = v2.value;
            m2(n2);
          }
        } catch (e24) {
          p2.e(e24);
        } finally {
          p2.f();
        }
      }
    }
  } }, { key: "themeClasses", get: function() {
    return bM + " " + (this.state.facet(yM) ? wM : kM) + " " + this.state.facet(gM);
  } }, { key: "updateAttrs", value: function() {
    var e23 = this, t2 = TM(this, jO, { class: "cm-editor" + (this.hasFocus ? " cm-focused " : " ") + this.themeClasses }), n2 = { spellcheck: "false", autocorrect: "off", autocapitalize: "off", translate: "no", contenteditable: this.state.facet(yO) ? "true" : "false", class: "cm-content", style: "".concat(T$.tabSize, ": ").concat(this.state.tabSize), role: "textbox", "aria-multiline": "true" };
    this.state.readOnly && (n2["aria-readonly"] = "true"), TM(this, SO, n2);
    var r2 = this.observer.ignore(function() {
      var r3 = K$(e23.contentDOM, e23.contentAttrs, n2), i2 = K$(e23.dom, e23.editorAttrs, t2);
      return r3 || i2;
    });
    return this.editorAttrs = t2, this.contentAttrs = n2, r2;
  } }, { key: "showAnnouncements", value: function(t2) {
    var n2, r2 = true, i2 = bi(t2);
    try {
      for (i2.s(); !(n2 = i2.n()).done; ) {
        var o2, a2 = bi(n2.value.effects);
        try {
          for (a2.s(); !(o2 = a2.n()).done; ) {
            var s2 = o2.value;
            if (s2.is(e22.announce))
              r2 && (this.announceDOM.textContent = ""), r2 = false, this.announceDOM.appendChild(document.createElement("div")).textContent = s2.value;
          }
        } catch (e23) {
          a2.e(e23);
        } finally {
          a2.f();
        }
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
  } }, { key: "mountStyles", value: function() {
    this.styleModules = this.state.facet(OO), z_.mount(this.root, this.styleModules.concat(SM).reverse());
  } }, { key: "readMeasured", value: function() {
    if (this.updateState == 2)
      throw new Error("Reading the editor layout isn't allowed during an update");
    this.updateState == 0 && this.measureScheduled > -1 && this.measure(false);
  } }, { key: "requestMeasure", value: function(e23) {
    var t2 = this;
    if (this.measureScheduled < 0 && (this.measureScheduled = requestAnimationFrame(function() {
      return t2.measure();
    })), e23) {
      if (e23.key != null) {
        for (var n2 = 0; n2 < this.measureRequests.length; n2++)
          if (this.measureRequests[n2].key === e23.key)
            return void (this.measureRequests[n2] = e23);
      }
      this.measureRequests.push(e23);
    }
  } }, { key: "plugin", value: function(e23) {
    var t2 = this.pluginMap.get(e23);
    return (t2 === void 0 || t2 && t2.spec != e23) && this.pluginMap.set(e23, t2 = this.plugins.find(function(t3) {
      return t3.spec == e23;
    }) || null), t2 && t2.update(this).value;
  } }, { key: "documentTop", get: function() {
    return this.contentDOM.getBoundingClientRect().top + this.viewState.paddingTop;
  } }, { key: "documentPadding", get: function() {
    return { top: this.viewState.paddingTop, bottom: this.viewState.paddingBottom };
  } }, { key: "elementAtHeight", value: function(e23) {
    return this.readMeasured(), this.viewState.elementAtHeight(e23);
  } }, { key: "lineBlockAtHeight", value: function(e23) {
    return this.readMeasured(), this.viewState.lineBlockAtHeight(e23);
  } }, { key: "viewportLineBlocks", get: function() {
    return this.viewState.viewportLines;
  } }, { key: "lineBlockAt", value: function(e23) {
    return this.viewState.lineBlockAt(e23);
  } }, { key: "contentHeight", get: function() {
    return this.viewState.contentHeight;
  } }, { key: "moveByChar", value: function(e23, t2, n2) {
    return wA(this, e23, kA(this, e23, t2, n2));
  } }, { key: "moveByGroup", value: function(e23, t2) {
    var n2 = this;
    return wA(this, e23, kA(this, e23, t2, function(t3) {
      return function(e24, t4, n3) {
        var r2 = e24.state.charCategorizer(t4), i2 = r2(n3);
        return function(e25) {
          var t5 = r2(e25);
          return i2 == f_.Space && (i2 = t5), i2 == t5;
        };
      }(n2, e23.head, t3);
    }));
  } }, { key: "moveToLineBoundary", value: function(e23, t2) {
    var n2 = !(arguments.length > 2 && arguments[2] !== void 0) || arguments[2];
    return bA(this, e23, t2, n2);
  } }, { key: "moveVertically", value: function(e23, t2, n2) {
    return wA(this, e23, function(e24, t3, n3, r2) {
      var i2 = t3.head, o2 = n3 ? 1 : -1;
      if (i2 == (n3 ? e24.state.doc.length : 0))
        return SC.cursor(i2, t3.assoc);
      var a2, s2 = t3.goalColumn, u2 = e24.contentDOM.getBoundingClientRect(), c2 = e24.coordsAtPos(i2), l2 = e24.documentTop;
      if (c2)
        s2 == null && (s2 = c2.left - u2.left), a2 = o2 < 0 ? c2.top : c2.bottom;
      else {
        var f2 = e24.viewState.lineBlockAt(i2);
        s2 == null && (s2 = Math.min(u2.right - u2.left, e24.defaultCharacterWidth * (i2 - f2.from))), a2 = (o2 < 0 ? f2.top : f2.bottom) + l2;
      }
      for (var h2 = u2.left + s2, d2 = r2 != null ? r2 : e24.defaultLineHeight >> 1, v2 = 0; ; v2 += 10) {
        var p2 = a2 + (d2 + v2) * o2, m2 = mA(e24, { x: h2, y: p2 }, false, o2);
        if (p2 < u2.top || p2 > u2.bottom || (o2 < 0 ? m2 < i2 : m2 > i2))
          return SC.cursor(m2, t3.assoc, void 0, s2);
      }
    }(this, e23, t2, n2));
  } }, { key: "domAtPos", value: function(e23) {
    return this.docView.domAtPos(e23);
  } }, { key: "posAtDOM", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return this.docView.posFromDOM(e23, t2);
  } }, { key: "posAtCoords", value: function(e23) {
    var t2 = !(arguments.length > 1 && arguments[1] !== void 0) || arguments[1];
    return this.readMeasured(), mA(this, e23, t2);
  } }, { key: "coordsAtPos", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
    this.readMeasured();
    var n2 = this.docView.coordsAt(e23, t2);
    if (!n2 || n2.left == n2.right)
      return n2;
    var r2 = this.state.doc.lineAt(e23), i2 = this.bidiSpans(r2), o2 = i2[JO.find(i2, e23 - r2.from, -1, t2)];
    return a$(n2, o2.dir == EO.LTR == t2 > 0);
  } }, { key: "defaultCharacterWidth", get: function() {
    return this.viewState.heightOracle.charWidth;
  } }, { key: "defaultLineHeight", get: function() {
    return this.viewState.heightOracle.lineHeight;
  } }, { key: "textDirection", get: function() {
    return this.viewState.defaultTextDirection;
  } }, { key: "textDirectionAt", value: function(e23) {
    return !this.state.facet(vO) || e23 < this.viewport.from || e23 > this.viewport.to ? this.textDirection : (this.readMeasured(), this.docView.textDirectionAt(e23));
  } }, { key: "lineWrapping", get: function() {
    return this.viewState.heightOracle.lineWrapping;
  } }, { key: "bidiSpans", value: function(e23) {
    if (e23.length > EM)
      return KO(e23.length);
    var t2, n2 = this.textDirectionAt(e23.from), r2 = bi(this.bidiCache);
    try {
      for (r2.s(); !(t2 = r2.n()).done; ) {
        var i2 = t2.value;
        if (i2.from == e23.from && i2.dir == n2)
          return i2.order;
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    var o2 = function(e24, t3) {
      var n3 = e24.length, r3 = t3 == PO ? 1 : 2, i3 = t3 == PO ? 2 : 1;
      if (!e24 || r3 == 1 && !WO.test(e24))
        return KO(n3);
      for (var o3 = 0, a2 = r3, s2 = r3; o3 < n3; o3++) {
        var u2 = HO(e24.charCodeAt(o3));
        u2 == 512 ? u2 = a2 : u2 == 8 && s2 == 4 && (u2 = 16), UO[o3] = u2 == 4 ? 2 : u2, 7 & u2 && (s2 = u2), a2 = u2;
      }
      for (var c2 = 0, l2 = r3, f2 = r3; c2 < n3; c2++) {
        var h2 = UO[c2];
        if (h2 == 128)
          c2 < n3 - 1 && l2 == UO[c2 + 1] && 24 & l2 ? h2 = UO[c2] = l2 : UO[c2] = 256;
        else if (h2 == 64) {
          for (var d2 = c2 + 1; d2 < n3 && UO[d2] == 64; )
            d2++;
          for (var v2 = c2 && l2 == 8 || d2 < n3 && UO[d2] == 8 ? f2 == 1 ? 1 : 8 : 256, p2 = c2; p2 < d2; p2++)
            UO[p2] = v2;
          c2 = d2 - 1;
        } else
          h2 == 8 && f2 == 1 && (UO[c2] = 1);
        l2 = h2, 7 & h2 && (f2 = h2);
      }
      for (var m2, g2, y2, b2 = 0, k2 = 0, w2 = 0; b2 < n3; b2++)
        if (g2 = DO[m2 = e24.charCodeAt(b2)])
          if (g2 < 0) {
            for (var x2 = k2 - 3; x2 >= 0; x2 -= 3)
              if (zO[x2 + 1] == -g2) {
                var j2 = zO[x2 + 2], S2 = 2 & j2 ? r3 : 4 & j2 ? 1 & j2 ? i3 : r3 : 0;
                S2 && (UO[b2] = UO[zO[x2]] = S2), k2 = x2;
                break;
              }
          } else {
            if (zO.length == 189)
              break;
            zO[k2++] = b2, zO[k2++] = m2, zO[k2++] = w2;
          }
        else if ((y2 = UO[b2]) == 2 || y2 == 1) {
          var C2 = y2 == r3;
          w2 = C2 ? 0 : 1;
          for (var _2 = k2 - 3; _2 >= 0; _2 -= 3) {
            var $2 = zO[_2 + 2];
            if (2 & $2)
              break;
            if (C2)
              zO[_2 + 2] |= 2;
            else {
              if (4 & $2)
                break;
              zO[_2 + 2] |= 4;
            }
          }
        }
      for (var O2 = 0; O2 < n3; O2++)
        if (UO[O2] == 256) {
          for (var A2 = O2 + 1; A2 < n3 && UO[A2] == 256; )
            A2++;
          for (var M2 = (O2 ? UO[O2 - 1] : r3) == 1, E2 = M2 == ((A2 < n3 ? UO[A2] : r3) == 1) ? M2 ? 1 : 2 : r3, P2 = O2; P2 < A2; P2++)
            UO[P2] = E2;
          O2 = A2 - 1;
        }
      var N2 = [];
      if (r3 == 1)
        for (var T2 = 0; T2 < n3; ) {
          for (var I2 = T2, R2 = UO[T2++] != 1; T2 < n3 && R2 == (UO[T2] != 1); )
            T2++;
          if (R2)
            for (var D2 = T2; D2 > I2; ) {
              for (var z2 = D2, L2 = UO[--D2] != 2; D2 > I2 && L2 == (UO[D2 - 1] != 2); )
                D2--;
              N2.push(new JO(D2, z2, L2 ? 2 : 1));
            }
          else
            N2.push(new JO(I2, T2, 0));
        }
      else
        for (var B2 = 0; B2 < n3; ) {
          for (var q2 = B2, F2 = UO[B2++] == 2; B2 < n3 && F2 == (UO[B2] == 2); )
            B2++;
          N2.push(new JO(q2, B2, F2 ? 1 : 2));
        }
      return N2;
    }(e23.text, n2);
    return this.bidiCache.push(new NM(e23.from, e23.to, n2, o2)), o2;
  } }, { key: "hasFocus", get: function() {
    var e23;
    return (document.hasFocus() || T$.safari && ((e23 = this.inputState) === null || e23 === void 0 ? void 0 : e23.lastContextMenu) > Date.now() - 3e4) && this.root.activeElement == this.contentDOM;
  } }, { key: "focus", value: function() {
    var e23 = this;
    this.observer.ignore(function() {
      f$(e23.contentDOM), e23.docView.updateSelection();
    });
  } }, { key: "destroy", value: function() {
    var e23, t2 = bi(this.plugins);
    try {
      for (t2.s(); !(e23 = t2.n()).done; ) {
        e23.value.destroy(this);
      }
    } catch (e24) {
      t2.e(e24);
    } finally {
      t2.f();
    }
    this.plugins = [], this.inputState.destroy(), this.dom.remove(), this.observer.destroy(), this.measureScheduled > -1 && cancelAnimationFrame(this.measureScheduled), this.destroyed = true;
  } }], [{ key: "scrollIntoView", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    return mO.of(new pO(typeof e23 == "number" ? SC.cursor(e23) : e23, t2.y, t2.x, t2.yMargin, t2.xMargin));
  } }, { key: "domEventHandlers", value: function(e23) {
    return wO.define(function() {
      return {};
    }, { eventHandlers: e23 });
  } }, { key: "theme", value: function(e23, t2) {
    var n2 = z_.newName(), r2 = [gM.of(n2), OO.of(jM(".".concat(n2), e23))];
    return t2 && t2.dark && r2.push(yM.of(true)), r2;
  } }, { key: "baseTheme", value: function(e23) {
    return LC.lowest(OO.of(jM("." + bM, e23, xM)));
  } }, { key: "findFromDOM", value: function(e23) {
    var t2, n2 = e23.querySelector(".cm-content"), r2 = n2 && y$.get(n2) || y$.get(e23);
    return ((t2 = r2 == null ? void 0 : r2.rootView) === null || t2 === void 0 ? void 0 : t2.view) || null;
  } }]), e22;
}();
MM.styleModule = OO, MM.inputHandler = dO, MM.perLineTextDirection = vO, MM.exceptionSink = fO, MM.updateListener = hO, MM.editable = yO, MM.mouseSelectionStyle = lO, MM.dragMovesSelection = cO, MM.clickAddsSelectionRange = uO, MM.decorations = CO, MM.atomicRanges = _O, MM.scrollMargins = $O, MM.darkTheme = yM, MM.contentAttributes = SO, MM.editorAttributes = jO, MM.lineWrapping = MM.contentAttributes.of({ class: "cm-lineWrapping" }), MM.announce = n_.define();
var EM = 4096, PM = {}, NM = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.from = t2, this.to = n2, this.dir = r2, this.order = i2;
  }
  return zi(e22, null, [{ key: "update", value: function(t2, n2) {
    if (n2.empty)
      return t2;
    for (var r2 = [], i2 = t2.length ? t2[t2.length - 1].dir : EO.LTR, o2 = Math.max(0, t2.length - 10); o2 < t2.length; o2++) {
      var a2 = t2[o2];
      a2.dir != i2 || n2.touchesRange(a2.from, a2.to) || r2.push(new e22(n2.mapPos(a2.from, 1), n2.mapPos(a2.to, -1), a2.dir, a2.order));
    }
    return r2;
  } }]), e22;
}();
function TM(e22, t2, n2) {
  for (var r2 = e22.state.facet(t2), i2 = r2.length - 1; i2 >= 0; i2--) {
    var o2 = r2[i2], a2 = typeof o2 == "function" ? o2(e22) : o2;
    a2 && J$(a2, n2);
  }
  return n2;
}
var IM = T$.mac ? "mac" : T$.windows ? "win" : T$.linux ? "linux" : "key";
function RM(e22, t2) {
  var n2, r2, i2, o2, a2 = e22.split(/-(?!$)/), s2 = a2[a2.length - 1];
  s2 == "Space" && (s2 = " ");
  for (var u2 = 0; u2 < a2.length - 1; ++u2) {
    var c2 = a2[u2];
    if (/^(cmd|meta|m)$/i.test(c2))
      o2 = true;
    else if (/^a(lt)?$/i.test(c2))
      n2 = true;
    else if (/^(c|ctrl|control)$/i.test(c2))
      r2 = true;
    else if (/^s(hift)?$/i.test(c2))
      i2 = true;
    else {
      if (!/^mod$/i.test(c2))
        throw new Error("Unrecognized modifier name: " + c2);
      t2 == "mac" ? o2 = true : r2 = true;
    }
  }
  return n2 && (s2 = "Alt-" + s2), r2 && (s2 = "Ctrl-" + s2), o2 && (s2 = "Meta-" + s2), i2 && (s2 = "Shift-" + s2), s2;
}
function DM(e22, t2, n2) {
  return t2.altKey && (e22 = "Alt-" + e22), t2.ctrlKey && (e22 = "Ctrl-" + e22), t2.metaKey && (e22 = "Meta-" + e22), n2 !== false && t2.shiftKey && (e22 = "Shift-" + e22), e22;
}
var zM = MM.domEventHandlers({ keydown: function(e22, t2) {
  return VM(qM(t2.state), e22, t2, "editor");
} }), LM = $C.define({ enables: zM }), BM = /* @__PURE__ */ new WeakMap();
function qM(e22) {
  var t2 = e22.facet(LM), n2 = BM.get(t2);
  return n2 || BM.set(t2, n2 = function(e23) {
    var t3, n3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : IM, r2 = /* @__PURE__ */ Object.create(null), i2 = /* @__PURE__ */ Object.create(null), o2 = function(e24, t4) {
      var n4 = i2[e24];
      if (n4 == null)
        i2[e24] = t4;
      else if (n4 != t4)
        throw new Error("Key binding " + e24 + " is used both as a regular binding and as a multi-stroke prefix");
    }, a2 = function(e24, t4, i3, a3) {
      for (var s3 = r2[e24] || (r2[e24] = /* @__PURE__ */ Object.create(null)), u3 = t4.split(/ (?!$)/).map(function(e25) {
        return RM(e25, n3);
      }), c3 = function(t5) {
        var n4 = u3.slice(0, t5).join(" ");
        o2(n4, true), s3[n4] || (s3[n4] = { preventDefault: true, commands: [function(t6) {
          var r3 = FM = { view: t6, prefix: n4, scope: e24 };
          return setTimeout(function() {
            FM == r3 && (FM = null);
          }, 4e3), true;
        }] });
      }, l3 = 1; l3 < u3.length; l3++)
        c3(l3);
      var f3 = u3.join(" ");
      o2(f3, false);
      var h3 = s3[f3] || (s3[f3] = { preventDefault: false, commands: [] });
      h3.commands.push(i3), a3 && (h3.preventDefault = true);
    }, s2 = bi(e23);
    try {
      for (s2.s(); !(t3 = s2.n()).done; ) {
        var u2 = t3.value, c2 = u2[n3] || u2.key;
        if (c2) {
          var l2, f2 = bi(u2.scope ? u2.scope.split(" ") : ["editor"]);
          try {
            for (f2.s(); !(l2 = f2.n()).done; ) {
              var h2 = l2.value;
              a2(h2, c2, u2.run, u2.preventDefault), u2.shift && a2(h2, "Shift-" + c2, u2.shift, u2.preventDefault);
            }
          } catch (e24) {
            f2.e(e24);
          } finally {
            f2.f();
          }
        }
      }
    } catch (e24) {
      s2.e(e24);
    } finally {
      s2.f();
    }
    return r2;
  }(t2.reduce(function(e23, t3) {
    return e23.concat(t3);
  }, []))), n2;
}
var FM = null;
function VM(e22, t2, n2, r2) {
  var i2 = function(e23) {
    var t3 = !(K_ && (e23.ctrlKey || e23.altKey || e23.metaKey) || (H_ || U_) && e23.shiftKey && e23.key && e23.key.length == 1) && e23.key || (e23.shiftKey ? F_ : q_)[e23.keyCode] || e23.key || "Unidentified";
    return t3 == "Esc" && (t3 = "Escape"), t3 == "Del" && (t3 = "Delete"), t3 == "Left" && (t3 = "ArrowLeft"), t3 == "Up" && (t3 = "ArrowUp"), t3 == "Right" && (t3 = "ArrowRight"), t3 == "Down" && (t3 = "ArrowDown"), t3;
  }(t2), o2 = lC(i2, 0), a2 = hC(o2) == i2.length && i2 != " ", s2 = "", u2 = false;
  FM && FM.view == n2 && FM.scope == r2 && (s2 = FM.prefix + " ", (u2 = SA.indexOf(t2.keyCode) < 0) && (FM = null));
  var c2, l2 = function(e23) {
    if (e23) {
      var t3, r3 = bi(e23.commands);
      try {
        for (r3.s(); !(t3 = r3.n()).done; ) {
          if ((0, t3.value)(n2))
            return true;
        }
      } catch (e24) {
        r3.e(e24);
      } finally {
        r3.f();
      }
      e23.preventDefault && (u2 = true);
    }
    return false;
  }, f2 = e22[r2];
  if (f2) {
    if (l2(f2[s2 + DM(i2, t2, !a2)]))
      return true;
    if (a2 && (t2.shiftKey || t2.altKey || t2.metaKey || o2 > 127) && (c2 = q_[t2.keyCode]) && c2 != i2) {
      if (l2(f2[s2 + DM(c2, t2, true)]))
        return true;
      if (t2.shiftKey && F_[t2.keyCode] != c2 && l2(f2[s2 + DM(F_[t2.keyCode], t2, false)]))
        return true;
    } else if (a2 && t2.shiftKey && l2(f2[s2 + DM(i2, t2, true)]))
      return true;
  }
  return u2;
}
var HM = !T$.ios, WM = $C.define({ combine: function(e22) {
  return p_(e22, { cursorBlinkRate: 1200, drawRangeCursor: true }, { cursorBlinkRate: function(e23, t2) {
    return Math.min(e23, t2);
  }, drawRangeCursor: function(e23, t2) {
    return e23 || t2;
  } });
} });
function JM() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return [WM.of(e22), KM, QM];
}
var UM = function() {
  function e22(t2, n2, r2, i2, o2) {
    Ri(this, e22), this.left = t2, this.top = n2, this.width = r2, this.height = i2, this.className = o2;
  }
  return zi(e22, [{ key: "draw", value: function() {
    var e23 = document.createElement("div");
    return e23.className = this.className, this.adjust(e23), e23;
  } }, { key: "adjust", value: function(e23) {
    e23.style.left = this.left + "px", e23.style.top = this.top + "px", this.width >= 0 && (e23.style.width = this.width + "px"), e23.style.height = this.height + "px";
  } }, { key: "eq", value: function(e23) {
    return this.left == e23.left && this.top == e23.top && this.width == e23.width && this.height == e23.height && this.className == e23.className;
  } }]), e22;
}(), KM = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.view = t2, this.rangePieces = [], this.cursors = [], this.measureReq = { read: this.readPos.bind(this), write: this.drawSel.bind(this) }, this.selectionLayer = t2.scrollDOM.appendChild(document.createElement("div")), this.selectionLayer.className = "cm-selectionLayer", this.selectionLayer.setAttribute("aria-hidden", "true"), this.cursorLayer = t2.scrollDOM.appendChild(document.createElement("div")), this.cursorLayer.className = "cm-cursorLayer", this.cursorLayer.setAttribute("aria-hidden", "true"), t2.requestMeasure(this.measureReq), this.setBlinkRate();
  }
  return zi(e22, [{ key: "setBlinkRate", value: function() {
    this.cursorLayer.style.animationDuration = this.view.state.facet(WM).cursorBlinkRate + "ms";
  } }, { key: "update", value: function(e23) {
    var t2 = e23.startState.facet(WM) != e23.state.facet(WM);
    (t2 || e23.selectionSet || e23.geometryChanged || e23.viewportChanged) && this.view.requestMeasure(this.measureReq), e23.transactions.some(function(e24) {
      return e24.scrollIntoView;
    }) && (this.cursorLayer.style.animationName = this.cursorLayer.style.animationName == "cm-blink" ? "cm-blink2" : "cm-blink"), t2 && this.setBlinkRate();
  } }, { key: "readPos", value: function() {
    var e23, t2 = this, n2 = this.view.state, r2 = n2.facet(WM), i2 = n2.selection.ranges.map(function(e24) {
      return e24.empty ? [] : function(e25, t3) {
        if (t3.to <= e25.viewport.from || t3.from >= e25.viewport.to)
          return [];
        var n3 = Math.max(t3.from, e25.viewport.from), r3 = Math.min(t3.to, e25.viewport.to), i3 = e25.textDirection == EO.LTR, o3 = e25.contentDOM, a3 = o3.getBoundingClientRect(), s3 = YM(e25), u3 = window.getComputedStyle(o3.firstChild), c3 = a3.left + parseInt(u3.paddingLeft) + Math.min(0, parseInt(u3.textIndent)), l2 = a3.right - parseInt(u3.paddingRight), f2 = XM(e25, n3), h2 = XM(e25, r3), d2 = f2.type == Q$.Text ? f2 : null, v2 = h2.type == Q$.Text ? h2 : null;
        e25.lineWrapping && (d2 && (d2 = ZM(e25, n3, d2)), v2 && (v2 = ZM(e25, r3, v2)));
        if (d2 && v2 && d2.from == v2.from)
          return b2(k2(t3.from, t3.to, d2));
        var p2 = d2 ? k2(t3.from, null, d2) : w2(f2, false), m2 = v2 ? k2(null, t3.to, v2) : w2(h2, true), g2 = [];
        return (d2 || f2).to < (v2 || h2).from - 1 ? g2.push(y2(c3, p2.bottom, l2, m2.top)) : p2.bottom < m2.top && e25.elementAtHeight((p2.bottom + m2.top) / 2).type == Q$.Text && (p2.bottom = m2.top = (p2.bottom + m2.top) / 2), b2(p2).concat(g2).concat(b2(m2));
        function y2(e26, t4, n4, r4) {
          return new UM(e26 - s3.left, t4 - s3.top - 0.01, n4 - e26, r4 - t4 + 0.01, "cm-selectionBackground");
        }
        function b2(e26) {
          for (var t4 = e26.top, n4 = e26.bottom, r4 = e26.horizontal, i4 = [], o4 = 0; o4 < r4.length; o4 += 2)
            i4.push(y2(r4[o4], t4, r4[o4 + 1], n4));
          return i4;
        }
        function k2(t4, n4, r4) {
          var o4 = 1e9, a4 = -1e9, s4 = [];
          function u4(t5, n5, u5, f4, h4) {
            var d4 = e25.coordsAtPos(t5, t5 == r4.to ? -2 : 2), v4 = e25.coordsAtPos(u5, u5 == r4.from ? 2 : -2);
            o4 = Math.min(d4.top, v4.top, o4), a4 = Math.max(d4.bottom, v4.bottom, a4), h4 == EO.LTR ? s4.push(i3 && n5 ? c3 : d4.left, i3 && f4 ? l2 : v4.right) : s4.push(!i3 && f4 ? c3 : v4.left, !i3 && n5 ? l2 : d4.right);
          }
          var f3, h3 = t4 != null ? t4 : r4.from, d3 = n4 != null ? n4 : r4.to, v3 = bi(e25.visibleRanges);
          try {
            for (v3.s(); !(f3 = v3.n()).done; ) {
              var p3 = f3.value;
              if (p3.to > h3 && p3.from < d3)
                for (var m3 = Math.max(p3.from, h3), g3 = Math.min(p3.to, d3); ; ) {
                  var y3, b3 = e25.state.doc.lineAt(m3), k3 = bi(e25.bidiSpans(b3));
                  try {
                    for (k3.s(); !(y3 = k3.n()).done; ) {
                      var w3 = y3.value, x2 = w3.from + b3.from, j2 = w3.to + b3.from;
                      if (x2 >= g3)
                        break;
                      j2 > m3 && u4(Math.max(x2, m3), t4 == null && x2 <= h3, Math.min(j2, g3), n4 == null && j2 >= d3, w3.dir);
                    }
                  } catch (e26) {
                    k3.e(e26);
                  } finally {
                    k3.f();
                  }
                  if ((m3 = b3.to + 1) >= g3)
                    break;
                }
            }
          } catch (e26) {
            v3.e(e26);
          } finally {
            v3.f();
          }
          return s4.length == 0 && u4(h3, t4 == null, d3, n4 == null, e25.textDirection), { top: o4, bottom: a4, horizontal: s4 };
        }
        function w2(e26, t4) {
          var n4 = a3.top + (t4 ? e26.top : e26.bottom);
          return { top: n4, bottom: n4, horizontal: [] };
        }
      }(t2.view, e24);
    }).reduce(function(e24, t3) {
      return e24.concat(t3);
    }), o2 = [], a2 = bi(n2.selection.ranges);
    try {
      for (a2.s(); !(e23 = a2.n()).done; ) {
        var s2 = e23.value, u2 = s2 == n2.selection.main;
        if (s2.empty ? !u2 || HM : r2.drawRangeCursor) {
          var c2 = eE(this.view, s2, u2);
          c2 && o2.push(c2);
        }
      }
    } catch (e24) {
      a2.e(e24);
    } finally {
      a2.f();
    }
    return { rangePieces: i2, cursors: o2 };
  } }, { key: "drawSel", value: function(e23) {
    var t2 = this, n2 = e23.rangePieces, r2 = e23.cursors;
    if (n2.length != this.rangePieces.length || n2.some(function(e24, n3) {
      return !e24.eq(t2.rangePieces[n3]);
    })) {
      this.selectionLayer.textContent = "";
      var i2, o2 = bi(n2);
      try {
        for (o2.s(); !(i2 = o2.n()).done; ) {
          var a2 = i2.value;
          this.selectionLayer.appendChild(a2.draw());
        }
      } catch (e24) {
        o2.e(e24);
      } finally {
        o2.f();
      }
      this.rangePieces = n2;
    }
    if (r2.length != this.cursors.length || r2.some(function(e24, n3) {
      return !e24.eq(t2.cursors[n3]);
    })) {
      var s2 = this.cursorLayer.children;
      if (s2.length !== r2.length) {
        this.cursorLayer.textContent = "";
        var u2, c2 = bi(r2);
        try {
          for (c2.s(); !(u2 = c2.n()).done; ) {
            var l2 = u2.value;
            this.cursorLayer.appendChild(l2.draw());
          }
        } catch (e24) {
          c2.e(e24);
        } finally {
          c2.f();
        }
      } else
        r2.forEach(function(e24, t3) {
          return e24.adjust(s2[t3]);
        });
      this.cursors = r2;
    }
  } }, { key: "destroy", value: function() {
    this.selectionLayer.remove(), this.cursorLayer.remove();
  } }]), e22;
}()), GM = { ".cm-line": { "& ::selection": { backgroundColor: "transparent !important" }, "&::selection": { backgroundColor: "transparent !important" } } };
HM && (GM[".cm-line"].caretColor = "transparent !important");
var QM = LC.highest(MM.theme(GM));
function YM(e22) {
  var t2 = e22.scrollDOM.getBoundingClientRect();
  return { left: (e22.textDirection == EO.LTR ? t2.left : t2.right - e22.scrollDOM.clientWidth) - e22.scrollDOM.scrollLeft, top: t2.top - e22.scrollDOM.scrollTop };
}
function ZM(e22, t2, n2) {
  var r2 = SC.cursor(t2);
  return { from: Math.max(n2.from, e22.moveToLineBoundary(r2, false, true).from), to: Math.min(n2.to, e22.moveToLineBoundary(r2, true, true).from), type: Q$.Text };
}
function XM(e22, t2) {
  var n2 = e22.lineBlockAt(t2);
  if (Array.isArray(n2.type)) {
    var r2, i2 = bi(n2.type);
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        var o2 = r2.value;
        if (o2.to > t2 || o2.to == t2 && (o2.to == n2.to || o2.type == Q$.Text))
          return o2;
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
  }
  return n2;
}
function eE(e22, t2, n2) {
  var r2 = e22.coordsAtPos(t2.head, t2.assoc || 1);
  if (!r2)
    return null;
  var i2 = YM(e22);
  return new UM(r2.left - i2.left, r2.top - i2.top, -1, r2.bottom - r2.top, n2 ? "cm-cursor cm-cursor-primary" : "cm-cursor cm-cursor-secondary");
}
var tE = n_.define({ map: function(e22, t2) {
  return e22 == null ? null : t2.mapPos(e22);
} }), nE = NC.define({ create: function() {
  return null;
}, update: function(e22, t2) {
  return e22 != null && (e22 = t2.changes.mapPos(e22)), t2.effects.reduce(function(e23, t3) {
    return t3.is(tE) ? t3.value : e23;
  }, e22);
} }), rE = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.view = t2, this.cursor = null, this.measureReq = { read: this.readPos.bind(this), write: this.drawCursor.bind(this) };
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    var t2, n2 = e23.state.field(nE);
    n2 == null ? this.cursor != null && ((t2 = this.cursor) === null || t2 === void 0 || t2.remove(), this.cursor = null) : (this.cursor || (this.cursor = this.view.scrollDOM.appendChild(document.createElement("div")), this.cursor.className = "cm-dropCursor"), (e23.startState.field(nE) != n2 || e23.docChanged || e23.geometryChanged) && this.view.requestMeasure(this.measureReq));
  } }, { key: "readPos", value: function() {
    var e23 = this.view.state.field(nE), t2 = e23 != null && this.view.coordsAtPos(e23);
    if (!t2)
      return null;
    var n2 = this.view.scrollDOM.getBoundingClientRect();
    return { left: t2.left - n2.left + this.view.scrollDOM.scrollLeft, top: t2.top - n2.top + this.view.scrollDOM.scrollTop, height: t2.bottom - t2.top };
  } }, { key: "drawCursor", value: function(e23) {
    this.cursor && (e23 ? (this.cursor.style.left = e23.left + "px", this.cursor.style.top = e23.top + "px", this.cursor.style.height = e23.height + "px") : this.cursor.style.left = "-100000px");
  } }, { key: "destroy", value: function() {
    this.cursor && this.cursor.remove();
  } }, { key: "setDropPos", value: function(e23) {
    this.view.state.field(nE) != e23 && this.view.dispatch({ effects: tE.of(e23) });
  } }]), e22;
}(), { eventHandlers: { dragover: function(e22) {
  this.setDropPos(this.view.posAtCoords({ x: e22.clientX, y: e22.clientY }));
}, dragleave: function(e22) {
  e22.target != this.view.contentDOM && this.view.contentDOM.contains(e22.relatedTarget) || this.setDropPos(null);
}, dragend: function() {
  this.setDropPos(null);
}, drop: function() {
  this.setDropPos(null);
} } });
function iE(e22, t2, n2, r2, i2) {
  t2.lastIndex = 0;
  for (var o2, a2 = e22.iterRange(n2, r2), s2 = n2; !a2.next().done; s2 += a2.value.length)
    if (!a2.lineBreak)
      for (; o2 = t2.exec(a2.value); )
        i2(s2 + o2.index, s2 + o2.index + o2[0].length, o2);
}
var oE = function() {
  function e22(t2) {
    Ri(this, e22);
    var n2 = t2.regexp, r2 = t2.decoration, i2 = t2.boundary, o2 = t2.maxLength, a2 = o2 === void 0 ? 1e3 : o2;
    if (!n2.global)
      throw new RangeError("The regular expression given to MatchDecorator should have its 'g' flag set");
    this.regexp = n2, this.getDeco = typeof r2 == "function" ? r2 : function() {
      return r2;
    }, this.boundary = i2, this.maxLength = a2;
  }
  return zi(e22, [{ key: "createDeco", value: function(e23) {
    var t2, n2 = this, r2 = new x_(), i2 = bi(function(e24, t3) {
      var n3 = e24.visibleRanges;
      if (n3.length == 1 && n3[0].from == e24.viewport.from && n3[0].to == e24.viewport.to)
        return n3;
      var r3, i3 = [], o3 = bi(n3);
      try {
        for (o3.s(); !(r3 = o3.n()).done; ) {
          var a3 = r3.value, s3 = a3.from, u2 = a3.to;
          s3 = Math.max(e24.state.doc.lineAt(s3).from, s3 - t3), u2 = Math.min(e24.state.doc.lineAt(u2).to, u2 + t3), i3.length && i3[i3.length - 1].to >= s3 ? i3[i3.length - 1].to = u2 : i3.push({ from: s3, to: u2 });
        }
      } catch (e25) {
        o3.e(e25);
      } finally {
        o3.f();
      }
      return i3;
    }(e23, this.maxLength));
    try {
      for (i2.s(); !(t2 = i2.n()).done; ) {
        var o2 = t2.value, a2 = o2.from, s2 = o2.to;
        iE(e23.state.doc, this.regexp, a2, s2, function(t3, i3, o3) {
          return r2.add(t3, i3, n2.getDeco(o3, e23, t3));
        });
      }
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    return r2.finish();
  } }, { key: "updateDeco", value: function(e23, t2) {
    var n2 = 1e9, r2 = -1;
    return e23.docChanged && e23.changes.iterChanges(function(t3, i2, o2, a2) {
      a2 > e23.view.viewport.from && o2 < e23.view.viewport.to && (n2 = Math.min(o2, n2), r2 = Math.max(a2, r2));
    }), e23.viewportChanged || r2 - n2 > 1e3 ? this.createDeco(e23.view) : r2 > -1 ? this.updateRange(e23.view, t2.map(e23.changes), n2, r2) : t2;
  } }, { key: "updateRange", value: function(e23, t2, n2, r2) {
    var i2, o2 = this, a2 = bi(e23.visibleRanges);
    try {
      for (a2.s(); !(i2 = a2.n()).done; ) {
        var s2 = i2.value, u2 = Math.max(s2.from, n2), c2 = Math.min(s2.to, r2);
        c2 > u2 && function() {
          var n3 = e23.state.doc.lineAt(u2), r3 = n3.to < c2 ? e23.state.doc.lineAt(c2) : n3, i3 = Math.max(s2.from, n3.from), a3 = Math.min(s2.to, r3.to);
          if (o2.boundary) {
            for (; u2 > n3.from; u2--)
              if (o2.boundary.test(n3.text[u2 - 1 - n3.from])) {
                i3 = u2;
                break;
              }
            for (; c2 < r3.to; c2++)
              if (o2.boundary.test(r3.text[c2 - r3.from])) {
                a3 = c2;
                break;
              }
          }
          var l2 = [], f2 = void 0;
          if (n3 == r3)
            for (o2.regexp.lastIndex = i3 - n3.from; (f2 = o2.regexp.exec(n3.text)) && f2.index < a3 - n3.from; ) {
              var h2 = f2.index + n3.from;
              l2.push(o2.getDeco(f2, e23, h2).range(h2, h2 + f2[0].length));
            }
          else
            iE(e23.state.doc, o2.regexp, i3, a3, function(t3, n4, r4) {
              return l2.push(o2.getDeco(r4, e23, t3).range(t3, n4));
            });
          t2 = t2.update({ filterFrom: i3, filterTo: a3, filter: function(e24, t3) {
            return e24 < i3 || t3 > a3;
          }, add: l2 });
        }();
      }
    } catch (e24) {
      a2.e(e24);
    } finally {
      a2.f();
    }
    return t2;
  } }]), e22;
}(), aE = /x/.unicode != null ? "gu" : "g", sE = new RegExp("[\0-\b\n-\x7F-\x9F\xAD\u061C\u200B\u200E\u200F\u2028\u2029\u202D\u202E\uFEFF\uFFF9-\uFFFC]", aE), uE = { 0: "null", 7: "bell", 8: "backspace", 10: "newline", 11: "vertical tab", 13: "carriage return", 27: "escape", 8203: "zero width space", 8204: "zero width non-joiner", 8205: "zero width joiner", 8206: "left-to-right mark", 8207: "right-to-left mark", 8232: "line separator", 8237: "left-to-right override", 8238: "right-to-left override", 8233: "paragraph separator", 65279: "zero width no-break space", 65532: "object replacement" }, cE = null;
var lE = $C.define({ combine: function(e22) {
  var t2 = p_(e22, { render: null, specialChars: sE, addSpecialChars: null });
  return (t2.replaceTabs = !function() {
    var e23;
    if (cE == null && typeof document != "undefined" && document.body) {
      var t3 = document.body.style;
      cE = ((e23 = t3.tabSize) !== null && e23 !== void 0 ? e23 : t3.MozTabSize) != null;
    }
    return cE || false;
  }()) && (t2.specialChars = new RegExp("	|" + t2.specialChars.source, aE)), t2.addSpecialChars && (t2.specialChars = new RegExp(t2.specialChars.source + "|" + t2.addSpecialChars.source, aE)), t2;
} });
function fE() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return [lE.of(e22), dE()];
}
var hE = null;
function dE() {
  return hE || (hE = wO.fromClass(function() {
    function e22(t2) {
      Ri(this, e22), this.view = t2, this.decorations = Y$.none, this.decorationCache = /* @__PURE__ */ Object.create(null), this.decorator = this.makeDecorator(t2.state.facet(lE)), this.decorations = this.decorator.createDeco(t2);
    }
    return zi(e22, [{ key: "makeDecorator", value: function(e23) {
      var t2 = this;
      return new oE({ regexp: e23.specialChars, decoration: function(n2, r2, i2) {
        var o2 = r2.state.doc, a2 = lC(n2[0], 0);
        if (a2 == 9) {
          var s2 = o2.lineAt(i2), u2 = r2.state.tabSize, c2 = N_(s2.text, u2, i2 - s2.from);
          return Y$.replace({ widget: new pE((u2 - c2 % u2) * t2.view.defaultCharacterWidth) });
        }
        return t2.decorationCache[a2] || (t2.decorationCache[a2] = Y$.replace({ widget: new vE(e23, a2) }));
      }, boundary: e23.replaceTabs ? void 0 : /[^]/ });
    } }, { key: "update", value: function(e23) {
      var t2 = e23.state.facet(lE);
      e23.startState.facet(lE) != t2 ? (this.decorator = this.makeDecorator(t2), this.decorations = this.decorator.createDeco(e23.view)) : this.decorations = this.decorator.updateDeco(e23, this.decorations);
    } }]), e22;
  }(), { decorations: function(e22) {
    return e22.decorations;
  } }));
}
var vE = function(e22) {
  ji(n2, G$);
  var t2 = Ci(n2);
  function n2(e23, r2) {
    var i2;
    return Ri(this, n2), (i2 = t2.call(this)).options = e23, i2.code = r2, i2;
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return e23.code == this.code;
  } }, { key: "toDOM", value: function(e23) {
    var t3 = function(e24) {
      return e24 >= 32 ? "\u2022" : e24 == 10 ? "\u2424" : String.fromCharCode(9216 + e24);
    }(this.code), n3 = e23.state.phrase("Control character") + " " + (uE[this.code] || "0x" + this.code.toString(16)), r2 = this.options.render && this.options.render(this.code, n3, t3);
    if (r2)
      return r2;
    var i2 = document.createElement("span");
    return i2.textContent = t3, i2.title = n3, i2.setAttribute("aria-label", n3), i2.className = "cm-specialChar", i2;
  } }, { key: "ignoreEvent", value: function() {
    return false;
  } }]), n2;
}(), pE = function(e22) {
  ji(n2, G$);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), (r2 = t2.call(this)).width = e23, r2;
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return e23.width == this.width;
  } }, { key: "toDOM", value: function() {
    var e23 = document.createElement("span");
    return e23.textContent = "	", e23.className = "cm-tab", e23.style.width = this.width + "px", e23;
  } }, { key: "ignoreEvent", value: function() {
    return false;
  } }]), n2;
}();
var mE = Y$.line({ class: "cm-activeLine" }), gE = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.decorations = this.getDeco(t2);
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    (e23.docChanged || e23.selectionSet) && (this.decorations = this.getDeco(e23.view));
  } }, { key: "getDeco", value: function(e23) {
    var t2, n2 = -1, r2 = [], i2 = bi(e23.state.selection.ranges);
    try {
      for (i2.s(); !(t2 = i2.n()).done; ) {
        var o2 = t2.value;
        if (!o2.empty)
          return Y$.none;
        var a2 = e23.lineBlockAt(o2.head);
        a2.from > n2 && (r2.push(mE.range(a2.from)), n2 = a2.from);
      }
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    return Y$.set(r2);
  } }]), e22;
}(), { decorations: function(e22) {
  return e22.decorations;
} });
function yE(e22, t2) {
  var n2 = e22.posAtCoords({ x: t2.clientX, y: t2.clientY }, false), r2 = e22.state.doc.lineAt(n2), i2 = n2 - r2.from, o2 = i2 > 2e3 ? -1 : i2 == r2.length ? function(e23, t3) {
    var n3 = e23.coordsAtPos(e23.viewport.from);
    return n3 ? Math.round(Math.abs((n3.left - t3) / e23.defaultCharacterWidth)) : -1;
  }(e22, t2.clientX) : N_(r2.text, e22.state.tabSize, n2 - r2.from);
  return { line: r2.number, col: o2, off: i2 };
}
function bE(e22, t2) {
  var n2 = yE(e22, t2), r2 = e22.state.selection;
  return n2 ? { update: function(e23) {
    if (e23.docChanged) {
      var t3 = e23.changes.mapPos(e23.startState.doc.line(n2.line).from), i2 = e23.state.doc.lineAt(t3);
      n2 = { line: i2.number, col: n2.col, off: Math.min(n2.off, i2.length) }, r2 = r2.map(e23.changes);
    }
  }, get: function(t3, i2, o2) {
    var a2 = yE(e22, t3);
    if (!a2)
      return r2;
    var s2 = function(e23, t4, n3) {
      var r3 = Math.min(t4.line, n3.line), i3 = Math.max(t4.line, n3.line), o3 = [];
      if (t4.off > 2e3 || n3.off > 2e3 || t4.col < 0 || n3.col < 0)
        for (var a3 = Math.min(t4.off, n3.off), s3 = Math.max(t4.off, n3.off), u2 = r3; u2 <= i3; u2++) {
          var c2 = e23.doc.line(u2);
          c2.length <= s3 && o3.push(SC.range(c2.from + a3, c2.to + s3));
        }
      else
        for (var l2 = Math.min(t4.col, n3.col), f2 = Math.max(t4.col, n3.col), h2 = r3; h2 <= i3; h2++) {
          var d2 = e23.doc.line(h2), v2 = T_(d2.text, l2, e23.tabSize, true);
          if (v2 > -1) {
            var p2 = T_(d2.text, f2, e23.tabSize);
            o3.push(SC.range(d2.from + v2, d2.from + p2));
          }
        }
      return o3;
    }(e22.state, n2, a2);
    return s2.length ? o2 ? SC.create(s2.concat(r2.ranges)) : SC.create(s2) : r2;
  } } : null;
}
function kE(e22) {
  var t2 = (e22 == null ? void 0 : e22.eventFilter) || function(e23) {
    return e23.altKey && e23.button == 0;
  };
  return MM.mouseSelectionStyle.of(function(e23, n2) {
    return t2(n2) ? bE(e23, n2) : null;
  });
}
var wE = { Alt: [18, function(e22) {
  return e22.altKey;
}], Control: [17, function(e22) {
  return e22.ctrlKey;
}], Shift: [16, function(e22) {
  return e22.shiftKey;
}], Meta: [91, function(e22) {
  return e22.metaKey;
}] }, xE = { style: "cursor: crosshair" };
function jE() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, t2 = xi(wE[e22.key || "Alt"], 2), n2 = t2[0], r2 = t2[1], i2 = wO.fromClass(function() {
    function e23(t3) {
      Ri(this, e23), this.view = t3, this.isDown = false;
    }
    return zi(e23, [{ key: "set", value: function(e24) {
      this.isDown != e24 && (this.isDown = e24, this.view.update([]));
    } }]), e23;
  }(), { eventHandlers: { keydown: function(e23) {
    this.set(e23.keyCode == n2 || r2(e23));
  }, keyup: function(e23) {
    e23.keyCode != n2 && r2(e23) || this.set(false);
  } } });
  return [i2, MM.contentAttributes.of(function(e23) {
    var t3;
    return ((t3 = e23.plugin(i2)) === null || t3 === void 0 ? void 0 : t3.isDown) ? xE : null;
  })];
}
var SE = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.facet = n2, this.createTooltipView = r2, this.input = t2.state.facet(n2), this.tooltips = this.input.filter(function(e23) {
      return e23;
    }), this.tooltipViews = this.tooltips.map(r2);
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    var t2 = e23.state.facet(this.facet), n2 = t2.filter(function(e24) {
      return e24;
    });
    if (t2 === this.input) {
      var r2, i2 = bi(this.tooltipViews);
      try {
        for (i2.s(); !(r2 = i2.n()).done; ) {
          var o2 = r2.value;
          o2.update && o2.update(e23);
        }
      } catch (e24) {
        i2.e(e24);
      } finally {
        i2.f();
      }
      return false;
    }
    for (var a2 = [], s2 = 0; s2 < n2.length; s2++) {
      var u2 = n2[s2], c2 = -1;
      if (u2) {
        for (var l2 = 0; l2 < this.tooltips.length; l2++) {
          var f2 = this.tooltips[l2];
          f2 && f2.create == u2.create && (c2 = l2);
        }
        if (c2 < 0)
          a2[s2] = this.createTooltipView(u2);
        else {
          var h2 = a2[s2] = this.tooltipViews[c2];
          h2.update && h2.update(e23);
        }
      }
    }
    var d2, v2 = bi(this.tooltipViews);
    try {
      for (v2.s(); !(d2 = v2.n()).done; ) {
        var p2 = d2.value;
        a2.indexOf(p2) < 0 && p2.dom.remove();
      }
    } catch (e24) {
      v2.e(e24);
    } finally {
      v2.f();
    }
    return this.input = t2, this.tooltips = n2, this.tooltipViews = a2, true;
  } }]), e22;
}();
function CE() {
  return { top: 0, left: 0, bottom: innerHeight, right: innerWidth };
}
var _E = $C.define({ combine: function(e22) {
  var t2, n2, r2;
  return { position: T$.ios ? "absolute" : ((t2 = e22.find(function(e23) {
    return e23.position;
  })) === null || t2 === void 0 ? void 0 : t2.position) || "fixed", parent: ((n2 = e22.find(function(e23) {
    return e23.parent;
  })) === null || n2 === void 0 ? void 0 : n2.parent) || null, tooltipSpace: ((r2 = e22.find(function(e23) {
    return e23.tooltipSpace;
  })) === null || r2 === void 0 ? void 0 : r2.tooltipSpace) || CE };
} }), $E = wO.fromClass(function() {
  function e22(t2) {
    var n2, r2 = this;
    Ri(this, e22), this.view = t2, this.inView = true, this.lastTransaction = 0, this.measureTimeout = -1;
    var i2 = t2.state.facet(_E);
    this.position = i2.position, this.parent = i2.parent, this.classes = t2.themeClasses, this.createContainer(), this.measureReq = { read: this.readMeasure.bind(this), write: this.writeMeasure.bind(this), key: this }, this.manager = new SE(t2, ME, function(e23) {
      return r2.createTooltip(e23);
    }), this.intersectionObserver = typeof IntersectionObserver == "function" ? new IntersectionObserver(function(e23) {
      Date.now() > r2.lastTransaction - 50 && e23.length > 0 && e23[e23.length - 1].intersectionRatio < 1 && r2.measureSoon();
    }, { threshold: [1] }) : null, this.observeIntersection(), (n2 = t2.dom.ownerDocument.defaultView) === null || n2 === void 0 || n2.addEventListener("resize", this.measureSoon = this.measureSoon.bind(this)), this.maybeMeasure();
  }
  return zi(e22, [{ key: "createContainer", value: function() {
    this.parent ? (this.container = document.createElement("div"), this.container.style.position = "relative", this.container.className = this.view.themeClasses, this.parent.appendChild(this.container)) : this.container = this.view.dom;
  } }, { key: "observeIntersection", value: function() {
    if (this.intersectionObserver) {
      this.intersectionObserver.disconnect();
      var e23, t2 = bi(this.manager.tooltipViews);
      try {
        for (t2.s(); !(e23 = t2.n()).done; ) {
          var n2 = e23.value;
          this.intersectionObserver.observe(n2.dom);
        }
      } catch (e24) {
        t2.e(e24);
      } finally {
        t2.f();
      }
    }
  } }, { key: "measureSoon", value: function() {
    var e23 = this;
    this.measureTimeout < 0 && (this.measureTimeout = setTimeout(function() {
      e23.measureTimeout = -1, e23.maybeMeasure();
    }, 50));
  } }, { key: "update", value: function(e23) {
    e23.transactions.length && (this.lastTransaction = Date.now());
    var t2 = this.manager.update(e23);
    t2 && this.observeIntersection();
    var n2 = t2 || e23.geometryChanged, r2 = e23.state.facet(_E);
    if (r2.position != this.position) {
      this.position = r2.position;
      var i2, o2 = bi(this.manager.tooltipViews);
      try {
        for (o2.s(); !(i2 = o2.n()).done; ) {
          i2.value.dom.style.position = this.position;
        }
      } catch (e24) {
        o2.e(e24);
      } finally {
        o2.f();
      }
      n2 = true;
    }
    if (r2.parent != this.parent) {
      this.parent && this.container.remove(), this.parent = r2.parent, this.createContainer();
      var a2, s2 = bi(this.manager.tooltipViews);
      try {
        for (s2.s(); !(a2 = s2.n()).done; ) {
          var u2 = a2.value;
          this.container.appendChild(u2.dom);
        }
      } catch (e24) {
        s2.e(e24);
      } finally {
        s2.f();
      }
      n2 = true;
    } else
      this.parent && this.view.themeClasses != this.classes && (this.classes = this.container.className = this.view.themeClasses);
    n2 && this.maybeMeasure();
  } }, { key: "createTooltip", value: function(e23) {
    var t2 = e23.create(this.view);
    if (t2.dom.classList.add("cm-tooltip"), e23.arrow && !t2.dom.querySelector(".cm-tooltip > .cm-tooltip-arrow")) {
      var n2 = document.createElement("div");
      n2.className = "cm-tooltip-arrow", t2.dom.appendChild(n2);
    }
    return t2.dom.style.position = this.position, t2.dom.style.top = "-10000px", this.container.appendChild(t2.dom), t2.mount && t2.mount(this.view), t2;
  } }, { key: "destroy", value: function() {
    var e23, t2;
    (e23 = this.view.dom.ownerDocument.defaultView) === null || e23 === void 0 || e23.removeEventListener("resize", this.measureSoon);
    var n2, r2 = bi(this.manager.tooltipViews);
    try {
      for (r2.s(); !(n2 = r2.n()).done; ) {
        n2.value.dom.remove();
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    (t2 = this.intersectionObserver) === null || t2 === void 0 || t2.disconnect(), clearTimeout(this.measureTimeout);
  } }, { key: "readMeasure", value: function() {
    var e23 = this, t2 = this.view.dom.getBoundingClientRect();
    return { editor: t2, parent: this.parent ? this.container.getBoundingClientRect() : t2, pos: this.manager.tooltips.map(function(t3, n2) {
      var r2 = e23.manager.tooltipViews[n2];
      return r2.getCoords ? r2.getCoords(t3.pos) : e23.view.coordsAtPos(t3.pos);
    }), size: this.manager.tooltipViews.map(function(e24) {
      return e24.dom.getBoundingClientRect();
    }), space: this.view.state.facet(_E).tooltipSpace(this.view) };
  } }, { key: "writeMeasure", value: function(e23) {
    for (var t2 = e23.editor, n2 = e23.space, r2 = [], i2 = 0; i2 < this.manager.tooltips.length; i2++) {
      var o2 = this.manager.tooltips[i2], a2 = this.manager.tooltipViews[i2], s2 = a2.dom, u2 = e23.pos[i2], c2 = e23.size[i2];
      if (!u2 || u2.bottom <= Math.max(t2.top, n2.top) || u2.top >= Math.min(t2.bottom, n2.bottom) || u2.right < Math.max(t2.left, n2.left) - 0.1 || u2.left > Math.min(t2.right, n2.right) + 0.1)
        s2.style.top = "-10000px";
      else {
        var l2 = o2.arrow ? a2.dom.querySelector(".cm-tooltip-arrow") : null, f2 = l2 ? 7 : 0, h2 = c2.right - c2.left, d2 = c2.bottom - c2.top, v2 = a2.offset || AE, p2 = this.view.textDirection == EO.LTR, m2 = c2.width > n2.right - n2.left ? p2 ? n2.left : n2.right - c2.width : p2 ? Math.min(u2.left - (l2 ? 14 : 0) + v2.x, n2.right - h2) : Math.max(n2.left, u2.left - h2 + (l2 ? 14 : 0) - v2.x), g2 = !!o2.above;
        !o2.strictSide && (g2 ? u2.top - (c2.bottom - c2.top) - v2.y < n2.top : u2.bottom + (c2.bottom - c2.top) + v2.y > n2.bottom) && g2 == n2.bottom - u2.bottom > u2.top - n2.top && (g2 = !g2);
        var y2 = g2 ? u2.top - d2 - f2 - v2.y : u2.bottom + f2 + v2.y, b2 = m2 + h2;
        if (a2.overlap !== true) {
          var k2, w2 = bi(r2);
          try {
            for (w2.s(); !(k2 = w2.n()).done; ) {
              var x2 = k2.value;
              x2.left < b2 && x2.right > m2 && x2.top < y2 + d2 && x2.bottom > y2 && (y2 = g2 ? x2.top - d2 - 2 - f2 : x2.bottom + f2 + 2);
            }
          } catch (e24) {
            w2.e(e24);
          } finally {
            w2.f();
          }
        }
        this.position == "absolute" ? (s2.style.top = y2 - e23.parent.top + "px", s2.style.left = m2 - e23.parent.left + "px") : (s2.style.top = y2 + "px", s2.style.left = m2 + "px"), l2 && (l2.style.left = "".concat(u2.left + (p2 ? v2.x : -v2.x) - (m2 + 14 - 7), "px")), a2.overlap !== true && r2.push({ left: m2, top: y2, right: b2, bottom: y2 + d2 }), s2.classList.toggle("cm-tooltip-above", g2), s2.classList.toggle("cm-tooltip-below", !g2), a2.positioned && a2.positioned();
      }
    }
  } }, { key: "maybeMeasure", value: function() {
    if (this.manager.tooltips.length && (this.view.inView && this.view.requestMeasure(this.measureReq), this.inView != this.view.inView && (this.inView = this.view.inView, !this.inView))) {
      var e23, t2 = bi(this.manager.tooltipViews);
      try {
        for (t2.s(); !(e23 = t2.n()).done; ) {
          e23.value.dom.style.top = "-10000px";
        }
      } catch (e24) {
        t2.e(e24);
      } finally {
        t2.f();
      }
    }
  } }]), e22;
}(), { eventHandlers: { scroll: function() {
  this.maybeMeasure();
} } }), OE = MM.baseTheme({ ".cm-tooltip": { zIndex: 100 }, "&light .cm-tooltip": { border: "1px solid #bbb", backgroundColor: "#f5f5f5" }, "&light .cm-tooltip-section:not(:first-child)": { borderTop: "1px solid #bbb" }, "&dark .cm-tooltip": { backgroundColor: "#333338", color: "white" }, ".cm-tooltip-arrow": { height: "".concat(7, "px"), width: "".concat(14, "px"), position: "absolute", zIndex: -1, overflow: "hidden", "&:before, &:after": { content: "''", position: "absolute", width: 0, height: 0, borderLeft: "".concat(7, "px solid transparent"), borderRight: "".concat(7, "px solid transparent") }, ".cm-tooltip-above &": { bottom: "-".concat(7, "px"), "&:before": { borderTop: "".concat(7, "px solid #bbb") }, "&:after": { borderTop: "".concat(7, "px solid #f5f5f5"), bottom: "1px" } }, ".cm-tooltip-below &": { top: "-".concat(7, "px"), "&:before": { borderBottom: "".concat(7, "px solid #bbb") }, "&:after": { borderBottom: "".concat(7, "px solid #f5f5f5"), top: "1px" } } }, "&dark .cm-tooltip .cm-tooltip-arrow": { "&:before": { borderTopColor: "#333338", borderBottomColor: "#333338" }, "&:after": { borderTopColor: "transparent", borderBottomColor: "transparent" } } }), AE = { x: 0, y: 0 }, ME = $C.define({ enables: [$E, OE] }), EE = $C.define(), PE = function() {
  function e22(t2) {
    var n2 = this;
    Ri(this, e22), this.view = t2, this.mounted = false, this.dom = document.createElement("div"), this.dom.classList.add("cm-tooltip-hover"), this.manager = new SE(t2, EE, function(e23) {
      return n2.createHostedView(e23);
    });
  }
  return zi(e22, [{ key: "createHostedView", value: function(e23) {
    var t2 = e23.create(this.view);
    return t2.dom.classList.add("cm-tooltip-section"), this.dom.appendChild(t2.dom), this.mounted && t2.mount && t2.mount(this.view), t2;
  } }, { key: "mount", value: function(e23) {
    var t2, n2 = bi(this.manager.tooltipViews);
    try {
      for (n2.s(); !(t2 = n2.n()).done; ) {
        var r2 = t2.value;
        r2.mount && r2.mount(e23);
      }
    } catch (e24) {
      n2.e(e24);
    } finally {
      n2.f();
    }
    this.mounted = true;
  } }, { key: "positioned", value: function() {
    var e23, t2 = bi(this.manager.tooltipViews);
    try {
      for (t2.s(); !(e23 = t2.n()).done; ) {
        var n2 = e23.value;
        n2.positioned && n2.positioned();
      }
    } catch (e24) {
      t2.e(e24);
    } finally {
      t2.f();
    }
  } }, { key: "update", value: function(e23) {
    this.manager.update(e23);
  } }], [{ key: "create", value: function(t2) {
    return new e22(t2);
  } }]), e22;
}(), NE = ME.compute([EE], function(e22) {
  var t2 = e22.facet(EE).filter(function(e23) {
    return e23;
  });
  return t2.length === 0 ? null : { pos: Math.min.apply(Math, Ni(t2.map(function(e23) {
    return e23.pos;
  }))), end: Math.max.apply(Math, Ni(t2.filter(function(e23) {
    return e23.end != null;
  }).map(function(e23) {
    return e23.end;
  }))), create: PE.create, above: t2[0].above, arrow: t2.some(function(e23) {
    return e23.arrow;
  }) };
}), TE = function() {
  function e22(t2, n2, r2, i2, o2) {
    Ri(this, e22), this.view = t2, this.source = n2, this.field = r2, this.setHover = i2, this.hoverTime = o2, this.hoverTimeout = -1, this.restartTimeout = -1, this.pending = null, this.lastMove = { x: 0, y: 0, target: t2.dom, time: 0 }, this.checkHover = this.checkHover.bind(this), t2.dom.addEventListener("mouseleave", this.mouseleave = this.mouseleave.bind(this)), t2.dom.addEventListener("mousemove", this.mousemove = this.mousemove.bind(this));
  }
  return zi(e22, [{ key: "update", value: function() {
    var e23 = this;
    this.pending && (this.pending = null, clearTimeout(this.restartTimeout), this.restartTimeout = setTimeout(function() {
      return e23.startHover();
    }, 20));
  } }, { key: "active", get: function() {
    return this.view.state.field(this.field);
  } }, { key: "checkHover", value: function() {
    if (this.hoverTimeout = -1, !this.active) {
      var e23 = Date.now() - this.lastMove.time;
      e23 < this.hoverTime ? this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime - e23) : this.startHover();
    }
  } }, { key: "startHover", value: function() {
    var e23 = this;
    clearTimeout(this.restartTimeout);
    var t2 = this.lastMove, n2 = this.view.contentDOM.contains(t2.target) ? this.view.posAtCoords(t2) : null;
    if (n2 != null) {
      var r2 = this.view.coordsAtPos(n2);
      if (!(r2 == null || t2.y < r2.top || t2.y > r2.bottom || t2.x < r2.left - this.view.defaultCharacterWidth || t2.x > r2.right + this.view.defaultCharacterWidth)) {
        var i2 = this.view.bidiSpans(this.view.state.doc.lineAt(n2)).find(function(e24) {
          return e24.from <= n2 && e24.to >= n2;
        }), o2 = i2 && i2.dir == EO.RTL ? -1 : 1, a2 = this.source(this.view, n2, t2.x < r2.left ? -o2 : o2);
        if (a2 == null ? void 0 : a2.then) {
          var s2 = this.pending = { pos: n2 };
          a2.then(function(t3) {
            e23.pending == s2 && (e23.pending = null, t3 && e23.view.dispatch({ effects: e23.setHover.of(t3) }));
          }, function(t3) {
            return gO(e23.view.state, t3, "hover tooltip");
          });
        } else
          a2 && this.view.dispatch({ effects: this.setHover.of(a2) });
      }
    }
  } }, { key: "mousemove", value: function(e23) {
    var t2;
    this.lastMove = { x: e23.clientX, y: e23.clientY, target: e23.target, time: Date.now() }, this.hoverTimeout < 0 && (this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime));
    var n2 = this.active;
    if (n2 && !function(e24) {
      for (var t3 = e24; t3; t3 = t3.parentNode)
        if (t3.nodeType == 1 && t3.classList.contains("cm-tooltip"))
          return true;
      return false;
    }(this.lastMove.target) || this.pending) {
      var r2 = (n2 || this.pending).pos, i2 = (t2 = n2 == null ? void 0 : n2.end) !== null && t2 !== void 0 ? t2 : r2;
      (r2 == i2 ? this.view.posAtCoords(this.lastMove) == r2 : function(e24, t3, n3, r3, i3, o2) {
        var a2 = document.createRange(), s2 = e24.domAtPos(t3), u2 = e24.domAtPos(n3);
        a2.setEnd(u2.node, u2.offset), a2.setStart(s2.node, s2.offset);
        var c2 = a2.getClientRects();
        a2.detach();
        for (var l2 = 0; l2 < c2.length; l2++) {
          var f2 = c2[l2];
          if (Math.max(f2.top - i3, i3 - f2.bottom, f2.left - r3, r3 - f2.right) <= o2)
            return true;
        }
        return false;
      }(this.view, r2, i2, e23.clientX, e23.clientY, 6)) || (this.view.dispatch({ effects: this.setHover.of(null) }), this.pending = null);
    }
  } }, { key: "mouseleave", value: function() {
    clearTimeout(this.hoverTimeout), this.hoverTimeout = -1, this.active && this.view.dispatch({ effects: this.setHover.of(null) });
  } }, { key: "destroy", value: function() {
    clearTimeout(this.hoverTimeout), this.view.dom.removeEventListener("mouseleave", this.mouseleave), this.view.dom.removeEventListener("mousemove", this.mousemove);
  } }]), e22;
}();
function IE(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n2 = n_.define(), r2 = NC.define({ create: function() {
    return null;
  }, update: function(e23, r3) {
    if (e23 && (t2.hideOnChange && (r3.docChanged || r3.selection) || t2.hideOn && t2.hideOn(r3, e23)))
      return null;
    if (e23 && r3.docChanged) {
      var i2 = r3.changes.mapPos(e23.pos, -1, vC.TrackDel);
      if (i2 == null)
        return null;
      var o2 = Object.assign(/* @__PURE__ */ Object.create(null), e23);
      o2.pos = i2, e23.end != null && (o2.end = r3.changes.mapPos(e23.end)), e23 = o2;
    }
    var a2, s2 = bi(r3.effects);
    try {
      for (s2.s(); !(a2 = s2.n()).done; ) {
        var u2 = a2.value;
        u2.is(n2) && (e23 = u2.value), u2.is(DE) && (e23 = null);
      }
    } catch (e24) {
      s2.e(e24);
    } finally {
      s2.f();
    }
    return e23;
  }, provide: function(e23) {
    return EE.from(e23);
  } });
  return [r2, wO.define(function(i2) {
    return new TE(i2, e22, r2, n2, t2.hoverTime || 300);
  }), NE];
}
function RE(e22, t2) {
  var n2 = e22.plugin($E);
  if (!n2)
    return null;
  var r2 = n2.manager.tooltips.indexOf(t2);
  return r2 < 0 ? null : n2.manager.tooltipViews[r2];
}
var DE = n_.define(), zE = $C.define({ combine: function(e22) {
  var t2, n2, r2, i2 = bi(e22);
  try {
    for (i2.s(); !(r2 = i2.n()).done; ) {
      var o2 = r2.value;
      t2 = t2 || o2.topContainer, n2 = n2 || o2.bottomContainer;
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  return { topContainer: t2, bottomContainer: n2 };
} });
function LE(e22, t2) {
  var n2 = e22.plugin(BE), r2 = n2 ? n2.specs.indexOf(t2) : -1;
  return r2 > -1 ? n2.panels[r2] : null;
}
var BE = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.input = t2.state.facet(VE), this.specs = this.input.filter(function(e23) {
      return e23;
    }), this.panels = this.specs.map(function(e23) {
      return e23(t2);
    });
    var n2 = t2.state.facet(zE);
    this.top = new qE(t2, true, n2.topContainer), this.bottom = new qE(t2, false, n2.bottomContainer), this.top.sync(this.panels.filter(function(e23) {
      return e23.top;
    })), this.bottom.sync(this.panels.filter(function(e23) {
      return !e23.top;
    }));
    var r2, i2 = bi(this.panels);
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        var o2 = r2.value;
        o2.dom.classList.add("cm-panel"), o2.mount && o2.mount();
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    var t2 = e23.state.facet(zE);
    this.top.container != t2.topContainer && (this.top.sync([]), this.top = new qE(e23.view, true, t2.topContainer)), this.bottom.container != t2.bottomContainer && (this.bottom.sync([]), this.bottom = new qE(e23.view, false, t2.bottomContainer)), this.top.syncClasses(), this.bottom.syncClasses();
    var n2 = e23.state.facet(VE);
    if (n2 != this.input) {
      var r2, i2 = n2.filter(function(e24) {
        return e24;
      }), o2 = [], a2 = [], s2 = [], u2 = [], c2 = bi(i2);
      try {
        for (c2.s(); !(r2 = c2.n()).done; ) {
          var l2 = r2.value, f2 = this.specs.indexOf(l2), h2 = void 0;
          f2 < 0 ? (h2 = l2(e23.view), u2.push(h2)) : (h2 = this.panels[f2]).update && h2.update(e23), o2.push(h2), (h2.top ? a2 : s2).push(h2);
        }
      } catch (e24) {
        c2.e(e24);
      } finally {
        c2.f();
      }
      this.specs = i2, this.panels = o2, this.top.sync(a2), this.bottom.sync(s2);
      for (var d2 = 0, v2 = u2; d2 < v2.length; d2++) {
        var p2 = v2[d2];
        p2.dom.classList.add("cm-panel"), p2.mount && p2.mount();
      }
    } else {
      var m2, g2 = bi(this.panels);
      try {
        for (g2.s(); !(m2 = g2.n()).done; ) {
          var y2 = m2.value;
          y2.update && y2.update(e23);
        }
      } catch (e24) {
        g2.e(e24);
      } finally {
        g2.f();
      }
    }
  } }, { key: "destroy", value: function() {
    this.top.sync([]), this.bottom.sync([]);
  } }]), e22;
}(), { provide: function(e22) {
  return MM.scrollMargins.of(function(t2) {
    var n2 = t2.plugin(e22);
    return n2 && { top: n2.top.scrollMargin(), bottom: n2.bottom.scrollMargin() };
  });
} }), qE = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.view = t2, this.top = n2, this.container = r2, this.dom = void 0, this.classes = "", this.panels = [], this.syncClasses();
  }
  return zi(e22, [{ key: "sync", value: function(e23) {
    var t2, n2 = bi(this.panels);
    try {
      for (n2.s(); !(t2 = n2.n()).done; ) {
        var r2 = t2.value;
        r2.destroy && e23.indexOf(r2) < 0 && r2.destroy();
      }
    } catch (e24) {
      n2.e(e24);
    } finally {
      n2.f();
    }
    this.panels = e23, this.syncDOM();
  } }, { key: "syncDOM", value: function() {
    if (this.panels.length != 0) {
      if (!this.dom) {
        this.dom = document.createElement("div"), this.dom.className = this.top ? "cm-panels cm-panels-top" : "cm-panels cm-panels-bottom", this.dom.style[this.top ? "top" : "bottom"] = "0";
        var e23 = this.container || this.view.dom;
        e23.insertBefore(this.dom, this.top ? e23.firstChild : null);
      }
      var t2, n2 = this.dom.firstChild, r2 = bi(this.panels);
      try {
        for (r2.s(); !(t2 = r2.n()).done; ) {
          var i2 = t2.value;
          if (i2.dom.parentNode == this.dom) {
            for (; n2 != i2.dom; )
              n2 = FE(n2);
            n2 = n2.nextSibling;
          } else
            this.dom.insertBefore(i2.dom, n2);
        }
      } catch (e24) {
        r2.e(e24);
      } finally {
        r2.f();
      }
      for (; n2; )
        n2 = FE(n2);
    } else
      this.dom && (this.dom.remove(), this.dom = void 0);
  } }, { key: "scrollMargin", value: function() {
    return !this.dom || this.container ? 0 : Math.max(0, this.top ? this.dom.getBoundingClientRect().bottom - Math.max(0, this.view.scrollDOM.getBoundingClientRect().top) : Math.min(innerHeight, this.view.scrollDOM.getBoundingClientRect().bottom) - this.dom.getBoundingClientRect().top);
  } }, { key: "syncClasses", value: function() {
    if (this.container && this.classes != this.view.themeClasses) {
      var e23, t2 = bi(this.classes.split(" "));
      try {
        for (t2.s(); !(e23 = t2.n()).done; ) {
          var n2 = e23.value;
          n2 && this.container.classList.remove(n2);
        }
      } catch (e24) {
        t2.e(e24);
      } finally {
        t2.f();
      }
      var r2, i2 = bi((this.classes = this.view.themeClasses).split(" "));
      try {
        for (i2.s(); !(r2 = i2.n()).done; ) {
          var o2 = r2.value;
          o2 && this.container.classList.add(o2);
        }
      } catch (e24) {
        i2.e(e24);
      } finally {
        i2.f();
      }
    }
  } }]), e22;
}();
function FE(e22) {
  var t2 = e22.nextSibling;
  return e22.remove(), t2;
}
var VE = $C.define({ enables: BE }), HE = function(e22) {
  ji(n2, m_);
  var t2 = Ci(n2);
  function n2() {
    return Ri(this, n2), t2.apply(this, arguments);
  }
  return zi(n2, [{ key: "compare", value: function(e23) {
    return this == e23 || this.constructor == e23.constructor && this.eq(e23);
  } }, { key: "eq", value: function(e23) {
    return false;
  } }, { key: "destroy", value: function(e23) {
  } }]), n2;
}();
HE.prototype.elementClass = "", HE.prototype.toDOM = void 0, HE.prototype.mapMode = vC.TrackBefore, HE.prototype.startSide = HE.prototype.endSide = -1, HE.prototype.point = true;
var WE = $C.define(), JE = { class: "", renderEmptyElements: false, elementStyle: "", markers: function() {
  return k_.empty;
}, lineMarker: function() {
  return null;
}, lineMarkerChange: null, initialSpacer: null, updateSpacer: null, domEventHandlers: {} }, UE = $C.define();
function KE(e22) {
  return [QE(), UE.of(Object.assign(Object.assign({}, JE), e22))];
}
var GE = $C.define({ combine: function(e22) {
  return e22.some(function(e23) {
    return e23;
  });
} });
function QE(e22) {
  var t2 = [YE];
  return e22 && e22.fixed === false && t2.push(GE.of(true)), t2;
}
var YE = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.view = t2, this.prevViewport = t2.viewport, this.dom = document.createElement("div"), this.dom.className = "cm-gutters", this.dom.setAttribute("aria-hidden", "true"), this.dom.style.minHeight = this.view.contentHeight + "px", this.gutters = t2.state.facet(UE).map(function(e23) {
      return new tP(t2, e23);
    });
    var n2, r2 = bi(this.gutters);
    try {
      for (r2.s(); !(n2 = r2.n()).done; ) {
        var i2 = n2.value;
        this.dom.appendChild(i2.dom);
      }
    } catch (e23) {
      r2.e(e23);
    } finally {
      r2.f();
    }
    this.fixed = !t2.state.facet(GE), this.fixed && (this.dom.style.position = "sticky"), this.syncGutters(false), t2.scrollDOM.insertBefore(this.dom, t2.contentDOM);
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    if (this.updateGutters(e23)) {
      var t2 = this.prevViewport, n2 = e23.view.viewport, r2 = Math.min(t2.to, n2.to) - Math.max(t2.from, n2.from);
      this.syncGutters(r2 < 0.8 * (n2.to - n2.from));
    }
    e23.geometryChanged && (this.dom.style.minHeight = this.view.contentHeight + "px"), this.view.state.facet(GE) != !this.fixed && (this.fixed = !this.fixed, this.dom.style.position = this.fixed ? "sticky" : ""), this.prevViewport = e23.view.viewport;
  } }, { key: "syncGutters", value: function(e23) {
    var t2 = this, n2 = this.dom.nextSibling;
    e23 && this.dom.remove();
    var r2, i2 = k_.iter(this.view.state.facet(WE), this.view.viewport.from), o2 = [], a2 = this.gutters.map(function(e24) {
      return new eP(e24, t2.view.viewport, -t2.view.documentPadding.top);
    }), s2 = bi(this.view.viewportLineBlocks);
    try {
      for (s2.s(); !(r2 = s2.n()).done; ) {
        var u2 = r2.value, c2 = void 0;
        if (Array.isArray(u2.type)) {
          var l2, f2 = bi(u2.type);
          try {
            for (f2.s(); !(l2 = f2.n()).done; ) {
              var h2 = l2.value;
              if (h2.type == Q$.Text) {
                c2 = h2;
                break;
              }
            }
          } catch (e24) {
            f2.e(e24);
          } finally {
            f2.f();
          }
        } else
          c2 = u2.type == Q$.Text ? u2 : void 0;
        if (c2) {
          o2.length && (o2 = []), XE(i2, o2, u2.from);
          var d2, v2 = bi(a2);
          try {
            for (v2.s(); !(d2 = v2.n()).done; ) {
              d2.value.line(this.view, c2, o2);
            }
          } catch (e24) {
            v2.e(e24);
          } finally {
            v2.f();
          }
        }
      }
    } catch (e24) {
      s2.e(e24);
    } finally {
      s2.f();
    }
    var p2, m2 = bi(a2);
    try {
      for (m2.s(); !(p2 = m2.n()).done; ) {
        p2.value.finish();
      }
    } catch (e24) {
      m2.e(e24);
    } finally {
      m2.f();
    }
    e23 && this.view.scrollDOM.insertBefore(this.dom, n2);
  } }, { key: "updateGutters", value: function(e23) {
    var t2 = e23.startState.facet(UE), n2 = e23.state.facet(UE), r2 = e23.docChanged || e23.heightChanged || e23.viewportChanged || !k_.eq(e23.startState.facet(WE), e23.state.facet(WE), e23.view.viewport.from, e23.view.viewport.to);
    if (t2 == n2) {
      var i2, o2 = bi(this.gutters);
      try {
        for (o2.s(); !(i2 = o2.n()).done; ) {
          i2.value.update(e23) && (r2 = true);
        }
      } catch (e24) {
        o2.e(e24);
      } finally {
        o2.f();
      }
    } else {
      r2 = true;
      var a2, s2 = [], u2 = bi(n2);
      try {
        for (u2.s(); !(a2 = u2.n()).done; ) {
          var c2 = a2.value, l2 = t2.indexOf(c2);
          l2 < 0 ? s2.push(new tP(this.view, c2)) : (this.gutters[l2].update(e23), s2.push(this.gutters[l2]));
        }
      } catch (e24) {
        u2.e(e24);
      } finally {
        u2.f();
      }
      var f2, h2 = bi(this.gutters);
      try {
        for (h2.s(); !(f2 = h2.n()).done; ) {
          var d2 = f2.value;
          d2.dom.remove(), s2.indexOf(d2) < 0 && d2.destroy();
        }
      } catch (e24) {
        h2.e(e24);
      } finally {
        h2.f();
      }
      for (var v2 = 0, p2 = s2; v2 < p2.length; v2++) {
        var m2 = p2[v2];
        this.dom.appendChild(m2.dom);
      }
      this.gutters = s2;
    }
    return r2;
  } }, { key: "destroy", value: function() {
    var e23, t2 = bi(this.gutters);
    try {
      for (t2.s(); !(e23 = t2.n()).done; ) {
        e23.value.destroy();
      }
    } catch (e24) {
      t2.e(e24);
    } finally {
      t2.f();
    }
    this.dom.remove();
  } }]), e22;
}(), { provide: function(e22) {
  return MM.scrollMargins.of(function(t2) {
    var n2 = t2.plugin(e22);
    return n2 && n2.gutters.length != 0 && n2.fixed ? t2.textDirection == EO.LTR ? { left: n2.dom.offsetWidth } : { right: n2.dom.offsetWidth } : null;
  });
} });
function ZE(e22) {
  return Array.isArray(e22) ? e22 : [e22];
}
function XE(e22, t2, n2) {
  for (; e22.value && e22.from <= n2; )
    e22.from == n2 && t2.push(e22.value), e22.next();
}
var eP = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.gutter = t2, this.height = r2, this.localMarkers = [], this.i = 0, this.cursor = k_.iter(t2.markers, n2.from);
  }
  return zi(e22, [{ key: "line", value: function(e23, t2, n2) {
    this.localMarkers.length && (this.localMarkers = []), XE(this.cursor, this.localMarkers, t2.from);
    var r2 = n2.length ? this.localMarkers.concat(n2) : this.localMarkers, i2 = this.gutter.config.lineMarker(e23, t2, r2);
    i2 && r2.unshift(i2);
    var o2 = this.gutter;
    if (r2.length != 0 || o2.config.renderEmptyElements) {
      var a2 = t2.top - this.height;
      if (this.i == o2.elements.length) {
        var s2 = new nP(e23, t2.height, a2, r2);
        o2.elements.push(s2), o2.dom.appendChild(s2.dom);
      } else
        o2.elements[this.i].update(e23, t2.height, a2, r2);
      this.height = t2.bottom, this.i++;
    }
  } }, { key: "finish", value: function() {
    for (var e23 = this.gutter; e23.elements.length > this.i; ) {
      var t2 = e23.elements.pop();
      e23.dom.removeChild(t2.dom), t2.destroy();
    }
  } }]), e22;
}(), tP = function() {
  function e22(t2, n2) {
    var r2 = this;
    Ri(this, e22), this.view = t2, this.config = n2, this.elements = [], this.spacer = null, this.dom = document.createElement("div"), this.dom.className = "cm-gutter" + (this.config.class ? " " + this.config.class : "");
    var i2 = function(e23) {
      r2.dom.addEventListener(e23, function(r3) {
        var i3 = t2.lineBlockAtHeight(r3.clientY - t2.documentTop);
        n2.domEventHandlers[e23](t2, i3, r3) && r3.preventDefault();
      });
    };
    for (var o2 in n2.domEventHandlers)
      i2(o2);
    this.markers = ZE(n2.markers(t2)), n2.initialSpacer && (this.spacer = new nP(t2, 0, 0, [n2.initialSpacer(t2)]), this.dom.appendChild(this.spacer.dom), this.spacer.dom.style.cssText += "visibility: hidden; pointer-events: none");
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    var t2 = this.markers;
    if (this.markers = ZE(this.config.markers(e23.view)), this.spacer && this.config.updateSpacer) {
      var n2 = this.config.updateSpacer(this.spacer.markers[0], e23);
      n2 != this.spacer.markers[0] && this.spacer.update(e23.view, 0, 0, [n2]);
    }
    var r2 = e23.view.viewport;
    return !k_.eq(this.markers, t2, r2.from, r2.to) || !!this.config.lineMarkerChange && this.config.lineMarkerChange(e23);
  } }, { key: "destroy", value: function() {
    var e23, t2 = bi(this.elements);
    try {
      for (t2.s(); !(e23 = t2.n()).done; ) {
        e23.value.destroy();
      }
    } catch (e24) {
      t2.e(e24);
    } finally {
      t2.f();
    }
  } }]), e22;
}(), nP = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.height = -1, this.above = 0, this.markers = [], this.dom = document.createElement("div"), this.dom.className = "cm-gutterElement", this.update(t2, n2, r2, i2);
  }
  return zi(e22, [{ key: "update", value: function(e23, t2, n2, r2) {
    this.height != t2 && (this.dom.style.height = (this.height = t2) + "px"), this.above != n2 && (this.dom.style.marginTop = (this.above = n2) ? n2 + "px" : ""), function(e24, t3) {
      if (e24.length != t3.length)
        return false;
      for (var n3 = 0; n3 < e24.length; n3++)
        if (!e24[n3].compare(t3[n3]))
          return false;
      return true;
    }(this.markers, r2) || this.setMarkers(e23, r2);
  } }, { key: "setMarkers", value: function(e23, t2) {
    for (var n2 = "cm-gutterElement", r2 = this.dom.firstChild, i2 = 0, o2 = 0; ; ) {
      var a2 = o2, s2 = i2 < t2.length ? t2[i2++] : null, u2 = false;
      if (s2) {
        var c2 = s2.elementClass;
        c2 && (n2 += " " + c2);
        for (var l2 = o2; l2 < this.markers.length; l2++)
          if (this.markers[l2].compare(s2)) {
            a2 = l2, u2 = true;
            break;
          }
      } else
        a2 = this.markers.length;
      for (; o2 < a2; ) {
        var f2 = this.markers[o2++];
        if (f2.toDOM) {
          f2.destroy(r2);
          var h2 = r2.nextSibling;
          r2.remove(), r2 = h2;
        }
      }
      if (!s2)
        break;
      s2.toDOM && (u2 ? r2 = r2.nextSibling : this.dom.insertBefore(s2.toDOM(e23), r2)), u2 && o2++;
    }
    this.dom.className = n2, this.markers = t2;
  } }, { key: "destroy", value: function() {
    this.setMarkers(null, []);
  } }]), e22;
}();
var rP = $C.define(), iP = $C.define({ combine: function(e22) {
  return p_(e22, { formatNumber: String, domEventHandlers: {} }, { domEventHandlers: function(e23, t2) {
    var n2 = Object.assign({}, e23), r2 = function(e24) {
      var r3 = n2[e24], i3 = t2[e24];
      n2[e24] = r3 ? function(e25, t3, n3) {
        return r3(e25, t3, n3) || i3(e25, t3, n3);
      } : i3;
    };
    for (var i2 in t2)
      r2(i2);
    return n2;
  } });
} }), oP = function(e22) {
  ji(n2, HE);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), (r2 = t2.call(this)).number = e23, r2;
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return this.number == e23.number;
  } }, { key: "toDOM", value: function() {
    return document.createTextNode(this.number);
  } }]), n2;
}();
function aP(e22, t2) {
  return e22.state.facet(iP).formatNumber(t2, e22.state);
}
var sP = UE.compute([iP], function(e22) {
  return { class: "cm-lineNumbers", renderEmptyElements: false, markers: function(e23) {
    return e23.state.facet(rP);
  }, lineMarker: function(e23, t2, n2) {
    return n2.some(function(e24) {
      return e24.toDOM;
    }) ? null : new oP(aP(e23, e23.state.doc.lineAt(t2.from).number));
  }, lineMarkerChange: function(e23) {
    return e23.startState.facet(iP) != e23.state.facet(iP);
  }, initialSpacer: function(e23) {
    return new oP(aP(e23, cP(e23.state.doc.lines)));
  }, updateSpacer: function(e23, t2) {
    var n2 = aP(t2.view, cP(t2.view.state.doc.lines));
    return n2 == e23.number ? e23 : new oP(n2);
  }, domEventHandlers: e22.facet(iP).domEventHandlers };
});
function uP() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return [iP.of(e22), QE(), sP];
}
function cP(e22) {
  for (var t2 = 9; t2 < e22; )
    t2 = 10 * t2 + 9;
  return t2;
}
var lP = new (function(e22) {
  ji(n2, HE);
  var t2 = Ci(n2);
  function n2() {
    var e23;
    return Ri(this, n2), (e23 = t2.apply(this, arguments)).elementClass = "cm-activeLineGutter", e23;
  }
  return zi(n2);
}())(), fP = WE.compute(["selection"], function(e22) {
  var t2, n2 = [], r2 = -1, i2 = bi(e22.selection.ranges);
  try {
    for (i2.s(); !(t2 = i2.n()).done; ) {
      var o2 = t2.value;
      if (o2.empty) {
        var a2 = e22.doc.lineAt(o2.head).from;
        a2 > r2 && (r2 = a2, n2.push(lP.range(a2)));
      }
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  return k_.of(n2);
});
var hP = 0, dP = zi(function e6(t2, n2) {
  Ri(this, e6), this.from = t2, this.to = n2;
}), vP = function() {
  function e22() {
    var t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    Ri(this, e22), this.id = hP++, this.perNode = !!t2.perNode, this.deserialize = t2.deserialize || function() {
      throw new Error("This node type doesn't define a deserialize function");
    };
  }
  return zi(e22, [{ key: "add", value: function(e23) {
    var t2 = this;
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e23 != "function" && (e23 = mP.match(e23)), function(n2) {
      var r2 = e23(n2);
      return r2 === void 0 ? null : [t2, r2];
    };
  } }]), e22;
}();
vP.closedBy = new vP({ deserialize: function(e22) {
  return e22.split(" ");
} }), vP.openedBy = new vP({ deserialize: function(e22) {
  return e22.split(" ");
} }), vP.group = new vP({ deserialize: function(e22) {
  return e22.split(" ");
} }), vP.contextHash = new vP({ perNode: true }), vP.lookAhead = new vP({ perNode: true }), vP.mounted = new vP({ perNode: true });
var pP = /* @__PURE__ */ Object.create(null), mP = function() {
  function e22(t2, n2, r2) {
    var i2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0;
    Ri(this, e22), this.name = t2, this.props = n2, this.id = r2, this.flags = i2;
  }
  return zi(e22, [{ key: "prop", value: function(e23) {
    return this.props[e23.id];
  } }, { key: "isTop", get: function() {
    return (1 & this.flags) > 0;
  } }, { key: "isSkipped", get: function() {
    return (2 & this.flags) > 0;
  } }, { key: "isError", get: function() {
    return (4 & this.flags) > 0;
  } }, { key: "isAnonymous", get: function() {
    return (8 & this.flags) > 0;
  } }, { key: "is", value: function(e23) {
    if (typeof e23 == "string") {
      if (this.name == e23)
        return true;
      var t2 = this.prop(vP.group);
      return !!t2 && t2.indexOf(e23) > -1;
    }
    return this.id == e23;
  } }], [{ key: "define", value: function(t2) {
    var n2 = t2.props && t2.props.length ? /* @__PURE__ */ Object.create(null) : pP, r2 = (t2.top ? 1 : 0) | (t2.skipped ? 2 : 0) | (t2.error ? 4 : 0) | (t2.name == null ? 8 : 0), i2 = new e22(t2.name || "", n2, t2.id, r2);
    if (t2.props) {
      var o2, a2 = bi(t2.props);
      try {
        for (a2.s(); !(o2 = a2.n()).done; ) {
          var s2 = o2.value;
          if (Array.isArray(s2) || (s2 = s2(i2)), s2) {
            if (s2[0].perNode)
              throw new RangeError("Can't store a per-node prop on a node type");
            n2[s2[0].id] = s2[1];
          }
        }
      } catch (e23) {
        a2.e(e23);
      } finally {
        a2.f();
      }
    }
    return i2;
  } }, { key: "match", value: function(e23) {
    var t2 = /* @__PURE__ */ Object.create(null);
    for (var n2 in e23) {
      var r2, i2 = bi(n2.split(" "));
      try {
        for (i2.s(); !(r2 = i2.n()).done; ) {
          var o2 = r2.value;
          t2[o2] = e23[n2];
        }
      } catch (e24) {
        i2.e(e24);
      } finally {
        i2.f();
      }
    }
    return function(e24) {
      for (var n3 = e24.prop(vP.group), r3 = -1; r3 < (n3 ? n3.length : 0); r3++) {
        var i3 = t2[r3 < 0 ? e24.name : n3[r3]];
        if (i3)
          return i3;
      }
    };
  } }]), e22;
}();
mP.none = new mP("", /* @__PURE__ */ Object.create(null), 0, 8);
var gP, yP = /* @__PURE__ */ new WeakMap(), bP = /* @__PURE__ */ new WeakMap();
!function(e22) {
  e22[e22.ExcludeBuffers = 1] = "ExcludeBuffers", e22[e22.IncludeAnonymous = 2] = "IncludeAnonymous", e22[e22.IgnoreMounts = 4] = "IgnoreMounts", e22[e22.IgnoreOverlays = 8] = "IgnoreOverlays";
}(gP || (gP = {}));
var kP = function() {
  function e22(t2, n2, r2, i2, o2) {
    if (Ri(this, e22), this.type = t2, this.children = n2, this.positions = r2, this.length = i2, this.props = null, o2 && o2.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      var a2, s2 = bi(o2);
      try {
        for (s2.s(); !(a2 = s2.n()).done; ) {
          var u2 = xi(a2.value, 2), c2 = u2[0], l2 = u2[1];
          this.props[typeof c2 == "number" ? c2 : c2.id] = l2;
        }
      } catch (e23) {
        s2.e(e23);
      } finally {
        s2.f();
      }
    }
  }
  return zi(e22, [{ key: "toString", value: function() {
    var e23 = this.prop(vP.mounted);
    if (e23 && !e23.overlay)
      return e23.tree.toString();
    var t2, n2 = "", r2 = bi(this.children);
    try {
      for (r2.s(); !(t2 = r2.n()).done; ) {
        var i2 = t2.value.toString();
        i2 && (n2 && (n2 += ","), n2 += i2);
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (n2.length ? "(" + n2 + ")" : "") : n2;
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new EP(this.topNode, e23);
  } }, { key: "cursorAt", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = yP.get(this) || this.topNode, r2 = new EP(n2);
    return r2.moveTo(e23, t2), yP.set(this, r2._tree), r2;
  } }, { key: "topNode", get: function() {
    return new _P(this, 0, 0, null);
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = CP(yP.get(this) || this.topNode, e23, t2, false);
    return yP.set(this, n2), n2;
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = CP(bP.get(this) || this.topNode, e23, t2, true);
    return bP.set(this, n2), n2;
  } }, { key: "iterate", value: function(e23) {
    for (var t2 = e23.enter, n2 = e23.leave, r2 = e23.from, i2 = r2 === void 0 ? 0 : r2, o2 = e23.to, a2 = o2 === void 0 ? this.length : o2, s2 = this.cursor((e23.mode || 0) | gP.IncludeAnonymous); ; ) {
      var u2 = false;
      if (s2.from <= a2 && s2.to >= i2 && (s2.type.isAnonymous || t2(s2) !== false)) {
        if (s2.firstChild())
          continue;
        u2 = true;
      }
      for (; u2 && n2 && !s2.type.isAnonymous && n2(s2), !s2.nextSibling(); ) {
        if (!s2.parent())
          return;
        u2 = true;
      }
    }
  } }, { key: "prop", value: function(e23) {
    return e23.perNode ? this.props ? this.props[e23.id] : void 0 : this.type.prop(e23);
  } }, { key: "propValues", get: function() {
    var e23 = [];
    if (this.props)
      for (var t2 in this.props)
        e23.push([+t2, this.props[t2]]);
    return e23;
  } }, { key: "balance", value: function() {
    var t2 = this, n2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return this.children.length <= 8 ? this : RP(mP.none, this.children, this.positions, 0, this.children.length, 0, this.length, function(n3, r2, i2) {
      return new e22(t2.type, n3, r2, i2, t2.propValues);
    }, n2.makeTree || function(t3, n3, r2) {
      return new e22(mP.none, t3, n3, r2);
    });
  } }], [{ key: "build", value: function(e23) {
    return NP(e23);
  } }]), e22;
}();
kP.empty = new kP(mP.none, [], [], 0);
var wP = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.buffer = t2, this.index = n2;
  }
  return zi(e22, [{ key: "id", get: function() {
    return this.buffer[this.index - 4];
  } }, { key: "start", get: function() {
    return this.buffer[this.index - 3];
  } }, { key: "end", get: function() {
    return this.buffer[this.index - 2];
  } }, { key: "size", get: function() {
    return this.buffer[this.index - 1];
  } }, { key: "pos", get: function() {
    return this.index;
  } }, { key: "next", value: function() {
    this.index -= 4;
  } }, { key: "fork", value: function() {
    return new e22(this.buffer, this.index);
  } }]), e22;
}(), xP = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.buffer = t2, this.length = n2, this.set = r2;
  }
  return zi(e22, [{ key: "type", get: function() {
    return mP.none;
  } }, { key: "toString", value: function() {
    for (var e23 = [], t2 = 0; t2 < this.buffer.length; )
      e23.push(this.childString(t2)), t2 = this.buffer[t2 + 3];
    return e23.join(",");
  } }, { key: "childString", value: function(e23) {
    var t2 = this.buffer[e23], n2 = this.buffer[e23 + 3], r2 = this.set.types[t2], i2 = r2.name;
    if (/\W/.test(i2) && !r2.isError && (i2 = JSON.stringify(i2)), n2 == (e23 += 4))
      return i2;
    for (var o2 = []; e23 < n2; )
      o2.push(this.childString(e23)), e23 = this.buffer[e23 + 3];
    return i2 + "(" + o2.join(",") + ")";
  } }, { key: "findChild", value: function(e23, t2, n2, r2, i2) {
    for (var o2 = this.buffer, a2 = -1, s2 = e23; s2 != t2 && !(jP(i2, r2, o2[s2 + 1], o2[s2 + 2]) && (a2 = s2, n2 > 0)); s2 = o2[s2 + 3])
      ;
    return a2;
  } }, { key: "slice", value: function(t2, n2, r2, i2) {
    for (var o2 = this.buffer, a2 = new Uint16Array(n2 - t2), s2 = t2, u2 = 0; s2 < n2; )
      a2[u2++] = o2[s2++], a2[u2++] = o2[s2++] - r2, a2[u2++] = o2[s2++] - r2, a2[u2++] = o2[s2++] - t2;
    return new e22(a2, i2 - r2, this.set);
  } }]), e22;
}();
function jP(e22, t2, n2, r2) {
  switch (e22) {
    case -2:
      return n2 < t2;
    case -1:
      return r2 >= t2 && n2 < t2;
    case 0:
      return n2 < t2 && r2 > t2;
    case 1:
      return n2 <= t2 && r2 > t2;
    case 2:
      return r2 > t2;
    case 4:
      return true;
  }
}
function SP(e22, t2) {
  for (var n2 = e22.childBefore(t2); n2; ) {
    var r2 = n2.lastChild;
    if (!r2 || r2.to != n2.to)
      break;
    r2.type.isError && r2.from == r2.to ? (e22 = n2, n2 = r2.prevSibling) : n2 = r2;
  }
  return e22;
}
function CP(e22, t2, n2, r2) {
  for (var i2; e22.from == e22.to || (n2 < 1 ? e22.from >= t2 : e22.from > t2) || (n2 > -1 ? e22.to <= t2 : e22.to < t2); ) {
    var o2 = !r2 && e22 instanceof _P && e22.index < 0 ? null : e22.parent;
    if (!o2)
      return e22;
    e22 = o2;
  }
  var a2 = r2 ? 0 : gP.IgnoreOverlays;
  if (r2)
    for (var s2 = e22, u2 = s2.parent; u2; u2 = (s2 = u2).parent)
      s2 instanceof _P && s2.index < 0 && ((i2 = u2.enter(t2, n2, a2)) === null || i2 === void 0 ? void 0 : i2.from) != s2.from && (e22 = u2);
  for (; ; ) {
    var c2 = e22.enter(t2, n2, a2);
    if (!c2)
      return e22;
    e22 = c2;
  }
}
var _P = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this._tree = t2, this.from = n2, this.index = r2, this._parent = i2;
  }
  return zi(e22, [{ key: "type", get: function() {
    return this._tree.type;
  } }, { key: "name", get: function() {
    return this._tree.type.name;
  } }, { key: "to", get: function() {
    return this.from + this._tree.length;
  } }, { key: "nextChild", value: function(t2, n2, r2, i2) {
    for (var o2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0, a2 = this; ; ) {
      for (var s2 = a2._tree, u2 = s2.children, c2 = s2.positions, l2 = n2 > 0 ? u2.length : -1; t2 != l2; t2 += n2) {
        var f2 = u2[t2], h2 = c2[t2] + a2.from;
        if (jP(i2, r2, h2, h2 + f2.length)) {
          if (f2 instanceof xP) {
            if (o2 & gP.ExcludeBuffers)
              continue;
            var d2 = f2.findChild(0, f2.buffer.length, n2, r2 - h2, i2);
            if (d2 > -1)
              return new MP(new AP(a2, f2, t2, h2), null, d2);
          } else if (o2 & gP.IncludeAnonymous || !f2.type.isAnonymous || PP(f2)) {
            var v2 = void 0;
            if (!(o2 & gP.IgnoreMounts) && f2.props && (v2 = f2.prop(vP.mounted)) && !v2.overlay)
              return new e22(v2.tree, h2, t2, a2);
            var p2 = new e22(f2, h2, t2, a2);
            return o2 & gP.IncludeAnonymous || !p2.type.isAnonymous ? p2 : p2.nextChild(n2 < 0 ? f2.children.length - 1 : 0, n2, r2, i2);
          }
        }
      }
      if (o2 & gP.IncludeAnonymous || !a2.type.isAnonymous)
        return null;
      if (t2 = a2.index >= 0 ? a2.index + n2 : n2 < 0 ? -1 : a2._parent._tree.children.length, !(a2 = a2._parent))
        return null;
    }
  } }, { key: "firstChild", get: function() {
    return this.nextChild(0, 1, 0, 4);
  } }, { key: "lastChild", get: function() {
    return this.nextChild(this._tree.children.length - 1, -1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.nextChild(0, 1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.nextChild(this._tree.children.length - 1, -1, e23, -2);
  } }, { key: "enter", value: function(t2, n2) {
    var r2, i2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    if (!(i2 & gP.IgnoreOverlays) && (r2 = this._tree.prop(vP.mounted)) && r2.overlay) {
      var o2, a2 = t2 - this.from, s2 = bi(r2.overlay);
      try {
        for (s2.s(); !(o2 = s2.n()).done; ) {
          var u2 = o2.value, c2 = u2.from, l2 = u2.to;
          if ((n2 > 0 ? c2 <= a2 : c2 < a2) && (n2 < 0 ? l2 >= a2 : l2 > a2))
            return new e22(r2.tree, r2.overlay[0].from + this.from, -1, this);
        }
      } catch (e23) {
        s2.e(e23);
      } finally {
        s2.f();
      }
    }
    return this.nextChild(0, 1, t2, n2, i2);
  } }, { key: "nextSignificantParent", value: function() {
    for (var e23 = this; e23.type.isAnonymous && e23._parent; )
      e23 = e23._parent;
    return e23;
  } }, { key: "parent", get: function() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  } }, { key: "nextSibling", get: function() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(this.index + 1, 1, 0, 4) : null;
  } }, { key: "prevSibling", get: function() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(this.index - 1, -1, 0, 4) : null;
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new EP(this, e23);
  } }, { key: "tree", get: function() {
    return this._tree;
  } }, { key: "toTree", value: function() {
    return this._tree;
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return CP(this, e23, t2, false);
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return CP(this, e23, t2, true);
  } }, { key: "enterUnfinishedNodesBefore", value: function(e23) {
    return SP(this, e23);
  } }, { key: "getChild", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, r2 = $P(this, e23, t2, n2);
    return r2.length ? r2[0] : null;
  } }, { key: "getChildren", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return $P(this, e23, t2, n2);
  } }, { key: "toString", value: function() {
    return this._tree.toString();
  } }, { key: "node", get: function() {
    return this;
  } }, { key: "matchContext", value: function(e23) {
    return OP(this, e23);
  } }]), e22;
}();
function $P(e22, t2, n2, r2) {
  var i2 = e22.cursor(), o2 = [];
  if (!i2.firstChild())
    return o2;
  if (n2 != null) {
    for (; !i2.type.is(n2); )
      if (!i2.nextSibling())
        return o2;
  }
  for (; ; ) {
    if (r2 != null && i2.type.is(r2))
      return o2;
    if (i2.type.is(t2) && o2.push(i2.node), !i2.nextSibling())
      return r2 == null ? o2 : [];
  }
}
function OP(e22, t2) {
  for (var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : t2.length - 1, r2 = e22.parent; n2 >= 0; r2 = r2.parent) {
    if (!r2)
      return false;
    if (!r2.type.isAnonymous) {
      if (t2[n2] && t2[n2] != r2.name)
        return false;
      n2--;
    }
  }
  return true;
}
var AP = zi(function e7(t2, n2, r2, i2) {
  Ri(this, e7), this.parent = t2, this.buffer = n2, this.index = r2, this.start = i2;
}), MP = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.context = t2, this._parent = n2, this.index = r2, this.type = t2.buffer.set.types[t2.buffer.buffer[r2]];
  }
  return zi(e22, [{ key: "name", get: function() {
    return this.type.name;
  } }, { key: "from", get: function() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  } }, { key: "to", get: function() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  } }, { key: "child", value: function(t2, n2, r2) {
    var i2 = this.context.buffer, o2 = i2.findChild(this.index + 4, i2.buffer[this.index + 3], t2, n2 - this.context.start, r2);
    return o2 < 0 ? null : new e22(this.context, this, o2);
  } }, { key: "firstChild", get: function() {
    return this.child(1, 0, 4);
  } }, { key: "lastChild", get: function() {
    return this.child(-1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.child(1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.child(-1, e23, -2);
  } }, { key: "enter", value: function(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    if (r2 & gP.ExcludeBuffers)
      return null;
    var i2 = this.context.buffer, o2 = i2.findChild(this.index + 4, i2.buffer[this.index + 3], n2 > 0 ? 1 : -1, t2 - this.context.start, n2);
    return o2 < 0 ? null : new e22(this.context, this, o2);
  } }, { key: "parent", get: function() {
    return this._parent || this.context.parent.nextSignificantParent();
  } }, { key: "externalSibling", value: function(e23) {
    return this._parent ? null : this.context.parent.nextChild(this.context.index + e23, e23, 0, 4);
  } }, { key: "nextSibling", get: function() {
    var t2 = this.context.buffer, n2 = t2.buffer[this.index + 3];
    return n2 < (this._parent ? t2.buffer[this._parent.index + 3] : t2.buffer.length) ? new e22(this.context, this._parent, n2) : this.externalSibling(1);
  } }, { key: "prevSibling", get: function() {
    var t2 = this.context.buffer, n2 = this._parent ? this._parent.index + 4 : 0;
    return this.index == n2 ? this.externalSibling(-1) : new e22(this.context, this._parent, t2.findChild(n2, this.index, -1, 0, 4));
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new EP(this, e23);
  } }, { key: "tree", get: function() {
    return null;
  } }, { key: "toTree", value: function() {
    var e23 = [], t2 = [], n2 = this.context.buffer, r2 = this.index + 4, i2 = n2.buffer[this.index + 3];
    if (i2 > r2) {
      var o2 = n2.buffer[this.index + 1], a2 = n2.buffer[this.index + 2];
      e23.push(n2.slice(r2, i2, o2, a2)), t2.push(0);
    }
    return new kP(this.type, e23, t2, this.to - this.from);
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return CP(this, e23, t2, false);
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return CP(this, e23, t2, true);
  } }, { key: "enterUnfinishedNodesBefore", value: function(e23) {
    return SP(this, e23);
  } }, { key: "toString", value: function() {
    return this.context.buffer.childString(this.index);
  } }, { key: "getChild", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, r2 = $P(this, e23, t2, n2);
    return r2.length ? r2[0] : null;
  } }, { key: "getChildren", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return $P(this, e23, t2, n2);
  } }, { key: "node", get: function() {
    return this;
  } }, { key: "matchContext", value: function(e23) {
    return OP(this, e23);
  } }]), e22;
}(), EP = function() {
  function e22(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    if (Ri(this, e22), this.mode = n2, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, t2 instanceof _P)
      this.yieldNode(t2);
    else {
      this._tree = t2.context.parent, this.buffer = t2.context;
      for (var r2 = t2._parent; r2; r2 = r2._parent)
        this.stack.unshift(r2.index);
      this.bufferNode = t2, this.yieldBuf(t2.index);
    }
  }
  return zi(e22, [{ key: "name", get: function() {
    return this.type.name;
  } }, { key: "yieldNode", value: function(e23) {
    return !!e23 && (this._tree = e23, this.type = e23.type, this.from = e23.from, this.to = e23.to, true);
  } }, { key: "yieldBuf", value: function(e23, t2) {
    this.index = e23;
    var n2 = this.buffer, r2 = n2.start, i2 = n2.buffer;
    return this.type = t2 || i2.set.types[i2.buffer[e23]], this.from = r2 + i2.buffer[e23 + 1], this.to = r2 + i2.buffer[e23 + 2], true;
  } }, { key: "yield", value: function(e23) {
    return !!e23 && (e23 instanceof _P ? (this.buffer = null, this.yieldNode(e23)) : (this.buffer = e23.context, this.yieldBuf(e23.index, e23.type)));
  } }, { key: "toString", value: function() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  } }, { key: "enterChild", value: function(e23, t2, n2) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e23 < 0 ? this._tree._tree.children.length - 1 : 0, e23, t2, n2, this.mode));
    var r2 = this.buffer.buffer, i2 = r2.findChild(this.index + 4, r2.buffer[this.index + 3], e23, t2 - this.buffer.start, n2);
    return !(i2 < 0) && (this.stack.push(this.index), this.yieldBuf(i2));
  } }, { key: "firstChild", value: function() {
    return this.enterChild(1, 0, 4);
  } }, { key: "lastChild", value: function() {
    return this.enterChild(-1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.enterChild(1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.enterChild(-1, e23, -2);
  } }, { key: "enter", value: function(e23, t2) {
    var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : this.mode;
    return this.buffer ? !(n2 & gP.ExcludeBuffers) && this.enterChild(1, e23, t2) : this.yield(this._tree.enter(e23, t2, n2));
  } }, { key: "parent", value: function() {
    if (!this.buffer)
      return this.yieldNode(this.mode & gP.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    var e23 = this.mode & gP.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e23);
  } }, { key: "sibling", value: function(e23) {
    if (!this.buffer)
      return !!this._tree._parent && this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e23, e23, 0, 4, this.mode));
    var t2 = this.buffer.buffer, n2 = this.stack.length - 1;
    if (e23 < 0) {
      var r2 = n2 < 0 ? 0 : this.stack[n2] + 4;
      if (this.index != r2)
        return this.yieldBuf(t2.findChild(r2, this.index, -1, 0, 4));
    } else {
      var i2 = t2.buffer[this.index + 3];
      if (i2 < (n2 < 0 ? t2.buffer.length : t2.buffer[this.stack[n2] + 3]))
        return this.yieldBuf(i2);
    }
    return n2 < 0 && this.yield(this.buffer.parent.nextChild(this.buffer.index + e23, e23, 0, 4, this.mode));
  } }, { key: "nextSibling", value: function() {
    return this.sibling(1);
  } }, { key: "prevSibling", value: function() {
    return this.sibling(-1);
  } }, { key: "atLastNode", value: function(e23) {
    var t2, n2, r2 = this.buffer;
    if (r2) {
      if (e23 > 0) {
        if (this.index < r2.buffer.buffer.length)
          return false;
      } else
        for (var i2 = 0; i2 < this.index; i2++)
          if (r2.buffer.buffer[i2 + 3] < this.index)
            return false;
      t2 = r2.index, n2 = r2.parent;
    } else {
      var o2 = this._tree;
      t2 = o2.index, n2 = o2._parent;
    }
    for (; n2; t2 = (a2 = n2).index, n2 = a2._parent, a2) {
      var a2;
      if (t2 > -1)
        for (var s2 = t2 + e23, u2 = e23 < 0 ? -1 : n2._tree.children.length; s2 != u2; s2 += e23) {
          var c2 = n2._tree.children[s2];
          if (this.mode & gP.IncludeAnonymous || c2 instanceof xP || !c2.type.isAnonymous || PP(c2))
            return false;
        }
    }
    return true;
  } }, { key: "move", value: function(e23, t2) {
    if (t2 && this.enterChild(e23, 0, 4))
      return true;
    for (; ; ) {
      if (this.sibling(e23))
        return true;
      if (this.atLastNode(e23) || !this.parent())
        return false;
    }
  } }, { key: "next", value: function() {
    var e23 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    return this.move(1, e23);
  } }, { key: "prev", value: function() {
    var e23 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    return this.move(-1, e23);
  } }, { key: "moveTo", value: function(e23) {
    for (var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0; (this.from == this.to || (t2 < 1 ? this.from >= e23 : this.from > e23) || (t2 > -1 ? this.to <= e23 : this.to < e23)) && this.parent(); )
      ;
    for (; this.enterChild(1, e23, t2); )
      ;
    return this;
  } }, { key: "node", get: function() {
    if (!this.buffer)
      return this._tree;
    var e23 = this.bufferNode, t2 = null, n2 = 0;
    if (e23 && e23.context == this.buffer)
      e:
        for (var r2 = this.index, i2 = this.stack.length; i2 >= 0; ) {
          for (var o2 = e23; o2; o2 = o2._parent)
            if (o2.index == r2) {
              if (r2 == this.index)
                return o2;
              t2 = o2, n2 = i2 + 1;
              break e;
            }
          r2 = this.stack[--i2];
        }
    for (var a2 = n2; a2 < this.stack.length; a2++)
      t2 = new MP(this.buffer, t2, this.stack[a2]);
    return this.bufferNode = new MP(this.buffer, t2, this.index);
  } }, { key: "tree", get: function() {
    return this.buffer ? null : this._tree._tree;
  } }, { key: "iterate", value: function(e23, t2) {
    for (var n2 = 0; ; ) {
      var r2 = false;
      if (this.type.isAnonymous || e23(this) !== false) {
        if (this.firstChild()) {
          n2++;
          continue;
        }
        this.type.isAnonymous || (r2 = true);
      }
      for (; r2 && t2 && t2(this), r2 = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!n2)
          return;
        this.parent(), n2--, r2 = true;
      }
    }
  } }, { key: "matchContext", value: function(e23) {
    if (!this.buffer)
      return OP(this.node, e23);
    for (var t2 = this.buffer.buffer, n2 = t2.set.types, r2 = e23.length - 1, i2 = this.stack.length - 1; r2 >= 0; i2--) {
      if (i2 < 0)
        return OP(this.node, e23, r2);
      var o2 = n2[t2.buffer[this.stack[i2]]];
      if (!o2.isAnonymous) {
        if (e23[r2] && e23[r2] != o2.name)
          return false;
        r2--;
      }
    }
    return true;
  } }]), e22;
}();
function PP(e22) {
  return e22.children.some(function(e23) {
    return e23 instanceof xP || !e23.type.isAnonymous || PP(e23);
  });
}
function NP(e22) {
  var t2, n2 = e22.buffer, r2 = e22.nodeSet, i2 = e22.maxBufferLength, o2 = i2 === void 0 ? 1024 : i2, a2 = e22.reused, s2 = a2 === void 0 ? [] : a2, u2 = e22.minRepeatType, c2 = u2 === void 0 ? r2.types.length : u2, l2 = Array.isArray(n2) ? new wP(n2, n2.length) : n2, f2 = r2.types, h2 = 0, d2 = 0;
  function v2(e23, t3, n3, i3, a3) {
    for (var u3 = l2.id, y3 = l2.start, b3 = l2.end, k3 = l2.size, w2 = d2; k3 < 0; ) {
      if (l2.next(), k3 == -1) {
        var x2 = s2[u3];
        return n3.push(x2), void i3.push(y3 - e23);
      }
      if (k3 == -3)
        return void (h2 = u3);
      if (k3 == -4)
        return void (d2 = u3);
      throw new RangeError("Unrecognized record size: ".concat(k3));
    }
    var j2, S2, C2 = f2[u3], _2 = y3 - e23;
    if (b3 - y3 <= o2 && (S2 = function(e24, t4) {
      var n4 = l2.fork(), r3 = 0, i4 = 0, a4 = 0, s3 = n4.end - o2, u4 = { size: 0, start: 0, skip: 0 };
      e:
        for (var f3 = n4.pos - e24; n4.pos > f3; ) {
          var h3 = n4.size;
          if (n4.id == t4 && h3 >= 0)
            u4.size = r3, u4.start = i4, u4.skip = a4, a4 += 4, r3 += 4, n4.next();
          else {
            var d3 = n4.pos - h3;
            if (h3 < 0 || d3 < f3 || n4.start < s3)
              break;
            var v3 = n4.id >= c2 ? 4 : 0, p3 = n4.start;
            for (n4.next(); n4.pos > d3; ) {
              if (n4.size < 0) {
                if (n4.size != -3)
                  break e;
                v3 += 4;
              } else
                n4.id >= c2 && (v3 += 4);
              n4.next();
            }
            i4 = p3, r3 += h3, a4 += v3;
          }
        }
      (t4 < 0 || r3 == e24) && (u4.size = r3, u4.start = i4, u4.skip = a4);
      return u4.size > 4 ? u4 : void 0;
    }(l2.pos - t3, a3))) {
      for (var $2 = new Uint16Array(S2.size - S2.skip), O2 = l2.pos - S2.size, A2 = $2.length; l2.pos > O2; )
        A2 = g2(S2.start, $2, A2);
      j2 = new xP($2, b3 - S2.start, r2), _2 = S2.start - e23;
    } else {
      var M2 = l2.pos - k3;
      l2.next();
      for (var E2 = [], P2 = [], N2 = u3 >= c2 ? u3 : -1, T2 = 0, I2 = b3; l2.pos > M2; )
        N2 >= 0 && l2.id == N2 && l2.size >= 0 ? (l2.end <= I2 - o2 && (p2(E2, P2, y3, T2, l2.end, I2, N2, w2), T2 = E2.length, I2 = l2.end), l2.next()) : v2(y3, M2, E2, P2, N2);
      if (N2 >= 0 && T2 > 0 && T2 < E2.length && p2(E2, P2, y3, T2, y3, I2, N2, w2), E2.reverse(), P2.reverse(), N2 > -1 && T2 > 0) {
        var R2 = function(e24) {
          return function(t4, n4, r3) {
            var i4, o3, a4 = 0, s3 = t4.length - 1;
            if (s3 >= 0 && (i4 = t4[s3]) instanceof kP) {
              if (!s3 && i4.type == e24 && i4.length == r3)
                return i4;
              (o3 = i4.prop(vP.lookAhead)) && (a4 = n4[s3] + i4.length + o3);
            }
            return m2(e24, t4, n4, r3, a4);
          };
        }(C2);
        j2 = RP(C2, E2, P2, 0, E2.length, 0, b3 - y3, R2, R2);
      } else
        j2 = m2(C2, E2, P2, b3 - y3, w2 - b3);
    }
    n3.push(j2), i3.push(_2);
  }
  function p2(e23, t3, n3, i3, o3, a3, s3, u3) {
    for (var c3 = [], l3 = []; e23.length > i3; )
      c3.push(e23.pop()), l3.push(t3.pop() + n3 - o3);
    e23.push(m2(r2.types[s3], c3, l3, a3 - o3, u3 - a3)), t3.push(o3 - n3);
  }
  function m2(e23, t3, n3, r3) {
    var i3 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0, o3 = arguments.length > 5 ? arguments[5] : void 0;
    if (h2) {
      var a3 = [vP.contextHash, h2];
      o3 = o3 ? [a3].concat(o3) : [a3];
    }
    if (i3 > 25) {
      var s3 = [vP.lookAhead, i3];
      o3 = o3 ? [s3].concat(o3) : [s3];
    }
    return new kP(e23, t3, n3, r3, o3);
  }
  function g2(e23, t3, n3) {
    var r3 = l2.id, i3 = l2.start, o3 = l2.end, a3 = l2.size;
    if (l2.next(), a3 >= 0 && r3 < c2) {
      var s3 = n3;
      if (a3 > 4)
        for (var u3 = l2.pos - (a3 - 4); l2.pos > u3; )
          n3 = g2(e23, t3, n3);
      t3[--n3] = s3, t3[--n3] = o3 - e23, t3[--n3] = i3 - e23, t3[--n3] = r3;
    } else
      a3 == -3 ? h2 = r3 : a3 == -4 && (d2 = r3);
    return n3;
  }
  for (var y2 = [], b2 = []; l2.pos > 0; )
    v2(e22.start || 0, e22.bufferStart || 0, y2, b2, -1);
  var k2 = (t2 = e22.length) !== null && t2 !== void 0 ? t2 : y2.length ? b2[0] + y2[0].length : 0;
  return new kP(f2[e22.topID], y2.reverse(), b2.reverse(), k2);
}
var TP = /* @__PURE__ */ new WeakMap();
function IP(e22, t2) {
  if (!e22.isAnonymous || t2 instanceof xP || t2.type != e22)
    return 1;
  var n2 = TP.get(t2);
  if (n2 == null) {
    n2 = 1;
    var r2, i2 = bi(t2.children);
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        var o2 = r2.value;
        if (o2.type != e22 || !(o2 instanceof kP)) {
          n2 = 1;
          break;
        }
        n2 += IP(e22, o2);
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
    TP.set(t2, n2);
  }
  return n2;
}
function RP(e22, t2, n2, r2, i2, o2, a2, s2, u2) {
  for (var c2 = 0, l2 = r2; l2 < i2; l2++)
    c2 += IP(e22, t2[l2]);
  var f2 = Math.ceil(1.5 * c2 / 8), h2 = [], d2 = [];
  return function t3(n3, r3, i3, a3, s3) {
    for (var c3 = i3; c3 < a3; ) {
      var l3 = c3, v2 = r3[c3], p2 = IP(e22, n3[c3]);
      for (c3++; c3 < a3; c3++) {
        var m2 = IP(e22, n3[c3]);
        if (p2 + m2 >= f2)
          break;
        p2 += m2;
      }
      if (c3 == l3 + 1) {
        if (p2 > f2) {
          var g2 = n3[l3];
          t3(g2.children, g2.positions, 0, g2.children.length, r3[l3] + s3);
          continue;
        }
        h2.push(n3[l3]);
      } else {
        var y2 = r3[c3 - 1] + n3[c3 - 1].length - v2;
        h2.push(RP(e22, n3, r3, l3, c3, v2, y2, null, u2));
      }
      d2.push(v2 + s3 - o2);
    }
  }(t2, n2, r2, i2, 0), (s2 || u2)(h2, d2, a2);
}
var DP = function() {
  function e22(t2, n2, r2, i2) {
    var o2 = arguments.length > 4 && arguments[4] !== void 0 && arguments[4], a2 = arguments.length > 5 && arguments[5] !== void 0 && arguments[5];
    Ri(this, e22), this.from = t2, this.to = n2, this.tree = r2, this.offset = i2, this.open = (o2 ? 1 : 0) | (a2 ? 2 : 0);
  }
  return zi(e22, [{ key: "openStart", get: function() {
    return (1 & this.open) > 0;
  } }, { key: "openEnd", get: function() {
    return (2 & this.open) > 0;
  } }], [{ key: "addTree", value: function(t2) {
    var n2, r2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [], i2 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], o2 = [new e22(0, t2.length, t2, 0, false, i2)], a2 = bi(r2);
    try {
      for (a2.s(); !(n2 = a2.n()).done; ) {
        var s2 = n2.value;
        s2.to > t2.length && o2.push(s2);
      }
    } catch (e23) {
      a2.e(e23);
    } finally {
      a2.f();
    }
    return o2;
  } }, { key: "applyChanges", value: function(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 128;
    if (!n2.length)
      return t2;
    for (var i2 = [], o2 = 1, a2 = t2.length ? t2[0] : null, s2 = 0, u2 = 0, c2 = 0; ; s2++) {
      var l2 = s2 < n2.length ? n2[s2] : null, f2 = l2 ? l2.fromA : 1e9;
      if (f2 - u2 >= r2)
        for (; a2 && a2.from < f2; ) {
          var h2 = a2;
          if (u2 >= h2.from || f2 <= h2.to || c2) {
            var d2 = Math.max(h2.from, u2) - c2, v2 = Math.min(h2.to, f2) - c2;
            h2 = d2 >= v2 ? null : new e22(d2, v2, h2.tree, h2.offset + c2, s2 > 0, !!l2);
          }
          if (h2 && i2.push(h2), a2.to > f2)
            break;
          a2 = o2 < t2.length ? t2[o2++] : null;
        }
      if (!l2)
        break;
      u2 = l2.toA, c2 = l2.toA - l2.toB;
    }
    return i2;
  } }]), e22;
}(), zP = function() {
  function e22() {
    Ri(this, e22);
  }
  return zi(e22, [{ key: "startParse", value: function(e23, t2, n2) {
    return typeof e23 == "string" && (e23 = new LP(e23)), n2 = n2 ? n2.length ? n2.map(function(e24) {
      return new dP(e24.from, e24.to);
    }) : [new dP(0, 0)] : [new dP(0, e23.length)], this.createParse(e23, t2 || [], n2);
  } }, { key: "parse", value: function(e23, t2, n2) {
    for (var r2 = this.startParse(e23, t2, n2); ; ) {
      var i2 = r2.advance();
      if (i2)
        return i2;
    }
  } }]), e22;
}(), LP = function() {
  function e22(t2) {
    Ri(this, e22), this.string = t2;
  }
  return zi(e22, [{ key: "length", get: function() {
    return this.string.length;
  } }, { key: "chunk", value: function(e23) {
    return this.string.slice(e23);
  } }, { key: "lineChunks", get: function() {
    return false;
  } }, { key: "read", value: function(e23, t2) {
    return this.string.slice(e23, t2);
  } }]), e22;
}();
new vP({ perNode: true });
var BP = 0, qP = function() {
  function e22() {
    var t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    Ri(this, e22), this.id = BP++, this.perNode = !!t2.perNode, this.deserialize = t2.deserialize || function() {
      throw new Error("This node type doesn't define a deserialize function");
    };
  }
  return zi(e22, [{ key: "add", value: function(e23) {
    var t2 = this;
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e23 != "function" && (e23 = VP.match(e23)), function(n2) {
      var r2 = e23(n2);
      return r2 === void 0 ? null : [t2, r2];
    };
  } }]), e22;
}();
qP.closedBy = new qP({ deserialize: function(e22) {
  return e22.split(" ");
} }), qP.openedBy = new qP({ deserialize: function(e22) {
  return e22.split(" ");
} }), qP.group = new qP({ deserialize: function(e22) {
  return e22.split(" ");
} }), qP.contextHash = new qP({ perNode: true }), qP.lookAhead = new qP({ perNode: true }), qP.mounted = new qP({ perNode: true });
var FP = /* @__PURE__ */ Object.create(null), VP = function() {
  function e22(t2, n2, r2) {
    var i2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0;
    Ri(this, e22), this.name = t2, this.props = n2, this.id = r2, this.flags = i2;
  }
  return zi(e22, [{ key: "prop", value: function(e23) {
    return this.props[e23.id];
  } }, { key: "isTop", get: function() {
    return (1 & this.flags) > 0;
  } }, { key: "isSkipped", get: function() {
    return (2 & this.flags) > 0;
  } }, { key: "isError", get: function() {
    return (4 & this.flags) > 0;
  } }, { key: "isAnonymous", get: function() {
    return (8 & this.flags) > 0;
  } }, { key: "is", value: function(e23) {
    if (typeof e23 == "string") {
      if (this.name == e23)
        return true;
      var t2 = this.prop(qP.group);
      return !!t2 && t2.indexOf(e23) > -1;
    }
    return this.id == e23;
  } }], [{ key: "define", value: function(t2) {
    var n2 = t2.props && t2.props.length ? /* @__PURE__ */ Object.create(null) : FP, r2 = (t2.top ? 1 : 0) | (t2.skipped ? 2 : 0) | (t2.error ? 4 : 0) | (t2.name == null ? 8 : 0), i2 = new e22(t2.name || "", n2, t2.id, r2);
    if (t2.props) {
      var o2, a2 = bi(t2.props);
      try {
        for (a2.s(); !(o2 = a2.n()).done; ) {
          var s2 = o2.value;
          if (Array.isArray(s2) || (s2 = s2(i2)), s2) {
            if (s2[0].perNode)
              throw new RangeError("Can't store a per-node prop on a node type");
            n2[s2[0].id] = s2[1];
          }
        }
      } catch (e23) {
        a2.e(e23);
      } finally {
        a2.f();
      }
    }
    return i2;
  } }, { key: "match", value: function(e23) {
    var t2 = /* @__PURE__ */ Object.create(null);
    for (var n2 in e23) {
      var r2, i2 = bi(n2.split(" "));
      try {
        for (i2.s(); !(r2 = i2.n()).done; ) {
          var o2 = r2.value;
          t2[o2] = e23[n2];
        }
      } catch (e24) {
        i2.e(e24);
      } finally {
        i2.f();
      }
    }
    return function(e24) {
      for (var n3 = e24.prop(qP.group), r3 = -1; r3 < (n3 ? n3.length : 0); r3++) {
        var i3 = t2[r3 < 0 ? e24.name : n3[r3]];
        if (i3)
          return i3;
      }
    };
  } }]), e22;
}();
VP.none = new VP("", /* @__PURE__ */ Object.create(null), 0, 8);
var HP, WP = /* @__PURE__ */ new WeakMap(), JP = /* @__PURE__ */ new WeakMap();
!function(e22) {
  e22[e22.ExcludeBuffers = 1] = "ExcludeBuffers", e22[e22.IncludeAnonymous = 2] = "IncludeAnonymous", e22[e22.IgnoreMounts = 4] = "IgnoreMounts", e22[e22.IgnoreOverlays = 8] = "IgnoreOverlays";
}(HP || (HP = {}));
var UP = function() {
  function e22(t2, n2, r2, i2, o2) {
    if (Ri(this, e22), this.type = t2, this.children = n2, this.positions = r2, this.length = i2, this.props = null, o2 && o2.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      var a2, s2 = bi(o2);
      try {
        for (s2.s(); !(a2 = s2.n()).done; ) {
          var u2 = xi(a2.value, 2), c2 = u2[0], l2 = u2[1];
          this.props[typeof c2 == "number" ? c2 : c2.id] = l2;
        }
      } catch (e23) {
        s2.e(e23);
      } finally {
        s2.f();
      }
    }
  }
  return zi(e22, [{ key: "toString", value: function() {
    var e23 = this.prop(qP.mounted);
    if (e23 && !e23.overlay)
      return e23.tree.toString();
    var t2, n2 = "", r2 = bi(this.children);
    try {
      for (r2.s(); !(t2 = r2.n()).done; ) {
        var i2 = t2.value.toString();
        i2 && (n2 && (n2 += ","), n2 += i2);
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (n2.length ? "(" + n2 + ")" : "") : n2;
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new iN(this.topNode, e23);
  } }, { key: "cursorAt", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = WP.get(this) || this.topNode, r2 = new iN(n2);
    return r2.moveTo(e23, t2), WP.set(this, r2._tree), r2;
  } }, { key: "topNode", get: function() {
    return new XP(this, 0, 0, null);
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = ZP(WP.get(this) || this.topNode, e23, t2, false);
    return WP.set(this, n2), n2;
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = ZP(JP.get(this) || this.topNode, e23, t2, true);
    return JP.set(this, n2), n2;
  } }, { key: "iterate", value: function(e23) {
    for (var t2 = e23.enter, n2 = e23.leave, r2 = e23.from, i2 = r2 === void 0 ? 0 : r2, o2 = e23.to, a2 = o2 === void 0 ? this.length : o2, s2 = this.cursor((e23.mode || 0) | HP.IncludeAnonymous); ; ) {
      var u2 = false;
      if (s2.from <= a2 && s2.to >= i2 && (s2.type.isAnonymous || t2(s2) !== false)) {
        if (s2.firstChild())
          continue;
        u2 = true;
      }
      for (; u2 && n2 && !s2.type.isAnonymous && n2(s2), !s2.nextSibling(); ) {
        if (!s2.parent())
          return;
        u2 = true;
      }
    }
  } }, { key: "prop", value: function(e23) {
    return e23.perNode ? this.props ? this.props[e23.id] : void 0 : this.type.prop(e23);
  } }, { key: "propValues", get: function() {
    var e23 = [];
    if (this.props)
      for (var t2 in this.props)
        e23.push([+t2, this.props[t2]]);
    return e23;
  } }, { key: "balance", value: function() {
    var t2 = this, n2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return this.children.length <= 8 ? this : cN(VP.none, this.children, this.positions, 0, this.children.length, 0, this.length, function(n3, r2, i2) {
      return new e22(t2.type, n3, r2, i2, t2.propValues);
    }, n2.makeTree || function(t3, n3, r2) {
      return new e22(VP.none, t3, n3, r2);
    });
  } }], [{ key: "build", value: function(e23) {
    return aN(e23);
  } }]), e22;
}();
UP.empty = new UP(VP.none, [], [], 0);
var KP = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.buffer = t2, this.index = n2;
  }
  return zi(e22, [{ key: "id", get: function() {
    return this.buffer[this.index - 4];
  } }, { key: "start", get: function() {
    return this.buffer[this.index - 3];
  } }, { key: "end", get: function() {
    return this.buffer[this.index - 2];
  } }, { key: "size", get: function() {
    return this.buffer[this.index - 1];
  } }, { key: "pos", get: function() {
    return this.index;
  } }, { key: "next", value: function() {
    this.index -= 4;
  } }, { key: "fork", value: function() {
    return new e22(this.buffer, this.index);
  } }]), e22;
}(), GP = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.buffer = t2, this.length = n2, this.set = r2;
  }
  return zi(e22, [{ key: "type", get: function() {
    return VP.none;
  } }, { key: "toString", value: function() {
    for (var e23 = [], t2 = 0; t2 < this.buffer.length; )
      e23.push(this.childString(t2)), t2 = this.buffer[t2 + 3];
    return e23.join(",");
  } }, { key: "childString", value: function(e23) {
    var t2 = this.buffer[e23], n2 = this.buffer[e23 + 3], r2 = this.set.types[t2], i2 = r2.name;
    if (/\W/.test(i2) && !r2.isError && (i2 = JSON.stringify(i2)), n2 == (e23 += 4))
      return i2;
    for (var o2 = []; e23 < n2; )
      o2.push(this.childString(e23)), e23 = this.buffer[e23 + 3];
    return i2 + "(" + o2.join(",") + ")";
  } }, { key: "findChild", value: function(e23, t2, n2, r2, i2) {
    for (var o2 = this.buffer, a2 = -1, s2 = e23; s2 != t2 && !(QP(i2, r2, o2[s2 + 1], o2[s2 + 2]) && (a2 = s2, n2 > 0)); s2 = o2[s2 + 3])
      ;
    return a2;
  } }, { key: "slice", value: function(t2, n2, r2, i2) {
    for (var o2 = this.buffer, a2 = new Uint16Array(n2 - t2), s2 = t2, u2 = 0; s2 < n2; )
      a2[u2++] = o2[s2++], a2[u2++] = o2[s2++] - r2, a2[u2++] = o2[s2++] - r2, a2[u2++] = o2[s2++] - t2;
    return new e22(a2, i2 - r2, this.set);
  } }]), e22;
}();
function QP(e22, t2, n2, r2) {
  switch (e22) {
    case -2:
      return n2 < t2;
    case -1:
      return r2 >= t2 && n2 < t2;
    case 0:
      return n2 < t2 && r2 > t2;
    case 1:
      return n2 <= t2 && r2 > t2;
    case 2:
      return r2 > t2;
    case 4:
      return true;
  }
}
function YP(e22, t2) {
  for (var n2 = e22.childBefore(t2); n2; ) {
    var r2 = n2.lastChild;
    if (!r2 || r2.to != n2.to)
      break;
    r2.type.isError && r2.from == r2.to ? (e22 = n2, n2 = r2.prevSibling) : n2 = r2;
  }
  return e22;
}
function ZP(e22, t2, n2, r2) {
  for (var i2; e22.from == e22.to || (n2 < 1 ? e22.from >= t2 : e22.from > t2) || (n2 > -1 ? e22.to <= t2 : e22.to < t2); ) {
    var o2 = !r2 && e22 instanceof XP && e22.index < 0 ? null : e22.parent;
    if (!o2)
      return e22;
    e22 = o2;
  }
  var a2 = r2 ? 0 : HP.IgnoreOverlays;
  if (r2)
    for (var s2 = e22, u2 = s2.parent; u2; u2 = (s2 = u2).parent)
      s2 instanceof XP && s2.index < 0 && ((i2 = u2.enter(t2, n2, a2)) === null || i2 === void 0 ? void 0 : i2.from) != s2.from && (e22 = u2);
  for (; ; ) {
    var c2 = e22.enter(t2, n2, a2);
    if (!c2)
      return e22;
    e22 = c2;
  }
}
var XP = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this._tree = t2, this.from = n2, this.index = r2, this._parent = i2;
  }
  return zi(e22, [{ key: "type", get: function() {
    return this._tree.type;
  } }, { key: "name", get: function() {
    return this._tree.type.name;
  } }, { key: "to", get: function() {
    return this.from + this._tree.length;
  } }, { key: "nextChild", value: function(t2, n2, r2, i2) {
    for (var o2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0, a2 = this; ; ) {
      for (var s2 = a2._tree, u2 = s2.children, c2 = s2.positions, l2 = n2 > 0 ? u2.length : -1; t2 != l2; t2 += n2) {
        var f2 = u2[t2], h2 = c2[t2] + a2.from;
        if (QP(i2, r2, h2, h2 + f2.length)) {
          if (f2 instanceof GP) {
            if (o2 & HP.ExcludeBuffers)
              continue;
            var d2 = f2.findChild(0, f2.buffer.length, n2, r2 - h2, i2);
            if (d2 > -1)
              return new rN(new nN(a2, f2, t2, h2), null, d2);
          } else if (o2 & HP.IncludeAnonymous || !f2.type.isAnonymous || oN(f2)) {
            var v2 = void 0;
            if (!(o2 & HP.IgnoreMounts) && f2.props && (v2 = f2.prop(qP.mounted)) && !v2.overlay)
              return new e22(v2.tree, h2, t2, a2);
            var p2 = new e22(f2, h2, t2, a2);
            return o2 & HP.IncludeAnonymous || !p2.type.isAnonymous ? p2 : p2.nextChild(n2 < 0 ? f2.children.length - 1 : 0, n2, r2, i2);
          }
        }
      }
      if (o2 & HP.IncludeAnonymous || !a2.type.isAnonymous)
        return null;
      if (t2 = a2.index >= 0 ? a2.index + n2 : n2 < 0 ? -1 : a2._parent._tree.children.length, !(a2 = a2._parent))
        return null;
    }
  } }, { key: "firstChild", get: function() {
    return this.nextChild(0, 1, 0, 4);
  } }, { key: "lastChild", get: function() {
    return this.nextChild(this._tree.children.length - 1, -1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.nextChild(0, 1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.nextChild(this._tree.children.length - 1, -1, e23, -2);
  } }, { key: "enter", value: function(t2, n2) {
    var r2, i2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    if (!(i2 & HP.IgnoreOverlays) && (r2 = this._tree.prop(qP.mounted)) && r2.overlay) {
      var o2, a2 = t2 - this.from, s2 = bi(r2.overlay);
      try {
        for (s2.s(); !(o2 = s2.n()).done; ) {
          var u2 = o2.value, c2 = u2.from, l2 = u2.to;
          if ((n2 > 0 ? c2 <= a2 : c2 < a2) && (n2 < 0 ? l2 >= a2 : l2 > a2))
            return new e22(r2.tree, r2.overlay[0].from + this.from, -1, this);
        }
      } catch (e23) {
        s2.e(e23);
      } finally {
        s2.f();
      }
    }
    return this.nextChild(0, 1, t2, n2, i2);
  } }, { key: "nextSignificantParent", value: function() {
    for (var e23 = this; e23.type.isAnonymous && e23._parent; )
      e23 = e23._parent;
    return e23;
  } }, { key: "parent", get: function() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  } }, { key: "nextSibling", get: function() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(this.index + 1, 1, 0, 4) : null;
  } }, { key: "prevSibling", get: function() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(this.index - 1, -1, 0, 4) : null;
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new iN(this, e23);
  } }, { key: "tree", get: function() {
    return this._tree;
  } }, { key: "toTree", value: function() {
    return this._tree;
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return ZP(this, e23, t2, false);
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return ZP(this, e23, t2, true);
  } }, { key: "enterUnfinishedNodesBefore", value: function(e23) {
    return YP(this, e23);
  } }, { key: "getChild", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, r2 = eN(this, e23, t2, n2);
    return r2.length ? r2[0] : null;
  } }, { key: "getChildren", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return eN(this, e23, t2, n2);
  } }, { key: "toString", value: function() {
    return this._tree.toString();
  } }, { key: "node", get: function() {
    return this;
  } }, { key: "matchContext", value: function(e23) {
    return tN(this, e23);
  } }]), e22;
}();
function eN(e22, t2, n2, r2) {
  var i2 = e22.cursor(), o2 = [];
  if (!i2.firstChild())
    return o2;
  if (n2 != null) {
    for (; !i2.type.is(n2); )
      if (!i2.nextSibling())
        return o2;
  }
  for (; ; ) {
    if (r2 != null && i2.type.is(r2))
      return o2;
    if (i2.type.is(t2) && o2.push(i2.node), !i2.nextSibling())
      return r2 == null ? o2 : [];
  }
}
function tN(e22, t2) {
  for (var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : t2.length - 1, r2 = e22.parent; n2 >= 0; r2 = r2.parent) {
    if (!r2)
      return false;
    if (!r2.type.isAnonymous) {
      if (t2[n2] && t2[n2] != r2.name)
        return false;
      n2--;
    }
  }
  return true;
}
var nN = zi(function e8(t2, n2, r2, i2) {
  Ri(this, e8), this.parent = t2, this.buffer = n2, this.index = r2, this.start = i2;
}), rN = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.context = t2, this._parent = n2, this.index = r2, this.type = t2.buffer.set.types[t2.buffer.buffer[r2]];
  }
  return zi(e22, [{ key: "name", get: function() {
    return this.type.name;
  } }, { key: "from", get: function() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  } }, { key: "to", get: function() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  } }, { key: "child", value: function(t2, n2, r2) {
    var i2 = this.context.buffer, o2 = i2.findChild(this.index + 4, i2.buffer[this.index + 3], t2, n2 - this.context.start, r2);
    return o2 < 0 ? null : new e22(this.context, this, o2);
  } }, { key: "firstChild", get: function() {
    return this.child(1, 0, 4);
  } }, { key: "lastChild", get: function() {
    return this.child(-1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.child(1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.child(-1, e23, -2);
  } }, { key: "enter", value: function(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    if (r2 & HP.ExcludeBuffers)
      return null;
    var i2 = this.context.buffer, o2 = i2.findChild(this.index + 4, i2.buffer[this.index + 3], n2 > 0 ? 1 : -1, t2 - this.context.start, n2);
    return o2 < 0 ? null : new e22(this.context, this, o2);
  } }, { key: "parent", get: function() {
    return this._parent || this.context.parent.nextSignificantParent();
  } }, { key: "externalSibling", value: function(e23) {
    return this._parent ? null : this.context.parent.nextChild(this.context.index + e23, e23, 0, 4);
  } }, { key: "nextSibling", get: function() {
    var t2 = this.context.buffer, n2 = t2.buffer[this.index + 3];
    return n2 < (this._parent ? t2.buffer[this._parent.index + 3] : t2.buffer.length) ? new e22(this.context, this._parent, n2) : this.externalSibling(1);
  } }, { key: "prevSibling", get: function() {
    var t2 = this.context.buffer, n2 = this._parent ? this._parent.index + 4 : 0;
    return this.index == n2 ? this.externalSibling(-1) : new e22(this.context, this._parent, t2.findChild(n2, this.index, -1, 0, 4));
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new iN(this, e23);
  } }, { key: "tree", get: function() {
    return null;
  } }, { key: "toTree", value: function() {
    var e23 = [], t2 = [], n2 = this.context.buffer, r2 = this.index + 4, i2 = n2.buffer[this.index + 3];
    if (i2 > r2) {
      var o2 = n2.buffer[this.index + 1], a2 = n2.buffer[this.index + 2];
      e23.push(n2.slice(r2, i2, o2, a2)), t2.push(0);
    }
    return new UP(this.type, e23, t2, this.to - this.from);
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return ZP(this, e23, t2, false);
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return ZP(this, e23, t2, true);
  } }, { key: "enterUnfinishedNodesBefore", value: function(e23) {
    return YP(this, e23);
  } }, { key: "toString", value: function() {
    return this.context.buffer.childString(this.index);
  } }, { key: "getChild", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, r2 = eN(this, e23, t2, n2);
    return r2.length ? r2[0] : null;
  } }, { key: "getChildren", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return eN(this, e23, t2, n2);
  } }, { key: "node", get: function() {
    return this;
  } }, { key: "matchContext", value: function(e23) {
    return tN(this, e23);
  } }]), e22;
}(), iN = function() {
  function e22(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    if (Ri(this, e22), this.mode = n2, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, t2 instanceof XP)
      this.yieldNode(t2);
    else {
      this._tree = t2.context.parent, this.buffer = t2.context;
      for (var r2 = t2._parent; r2; r2 = r2._parent)
        this.stack.unshift(r2.index);
      this.bufferNode = t2, this.yieldBuf(t2.index);
    }
  }
  return zi(e22, [{ key: "name", get: function() {
    return this.type.name;
  } }, { key: "yieldNode", value: function(e23) {
    return !!e23 && (this._tree = e23, this.type = e23.type, this.from = e23.from, this.to = e23.to, true);
  } }, { key: "yieldBuf", value: function(e23, t2) {
    this.index = e23;
    var n2 = this.buffer, r2 = n2.start, i2 = n2.buffer;
    return this.type = t2 || i2.set.types[i2.buffer[e23]], this.from = r2 + i2.buffer[e23 + 1], this.to = r2 + i2.buffer[e23 + 2], true;
  } }, { key: "yield", value: function(e23) {
    return !!e23 && (e23 instanceof XP ? (this.buffer = null, this.yieldNode(e23)) : (this.buffer = e23.context, this.yieldBuf(e23.index, e23.type)));
  } }, { key: "toString", value: function() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  } }, { key: "enterChild", value: function(e23, t2, n2) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e23 < 0 ? this._tree._tree.children.length - 1 : 0, e23, t2, n2, this.mode));
    var r2 = this.buffer.buffer, i2 = r2.findChild(this.index + 4, r2.buffer[this.index + 3], e23, t2 - this.buffer.start, n2);
    return !(i2 < 0) && (this.stack.push(this.index), this.yieldBuf(i2));
  } }, { key: "firstChild", value: function() {
    return this.enterChild(1, 0, 4);
  } }, { key: "lastChild", value: function() {
    return this.enterChild(-1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.enterChild(1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.enterChild(-1, e23, -2);
  } }, { key: "enter", value: function(e23, t2) {
    var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : this.mode;
    return this.buffer ? !(n2 & HP.ExcludeBuffers) && this.enterChild(1, e23, t2) : this.yield(this._tree.enter(e23, t2, n2));
  } }, { key: "parent", value: function() {
    if (!this.buffer)
      return this.yieldNode(this.mode & HP.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    var e23 = this.mode & HP.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e23);
  } }, { key: "sibling", value: function(e23) {
    if (!this.buffer)
      return !!this._tree._parent && this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e23, e23, 0, 4, this.mode));
    var t2 = this.buffer.buffer, n2 = this.stack.length - 1;
    if (e23 < 0) {
      var r2 = n2 < 0 ? 0 : this.stack[n2] + 4;
      if (this.index != r2)
        return this.yieldBuf(t2.findChild(r2, this.index, -1, 0, 4));
    } else {
      var i2 = t2.buffer[this.index + 3];
      if (i2 < (n2 < 0 ? t2.buffer.length : t2.buffer[this.stack[n2] + 3]))
        return this.yieldBuf(i2);
    }
    return n2 < 0 && this.yield(this.buffer.parent.nextChild(this.buffer.index + e23, e23, 0, 4, this.mode));
  } }, { key: "nextSibling", value: function() {
    return this.sibling(1);
  } }, { key: "prevSibling", value: function() {
    return this.sibling(-1);
  } }, { key: "atLastNode", value: function(e23) {
    var t2, n2, r2 = this.buffer;
    if (r2) {
      if (e23 > 0) {
        if (this.index < r2.buffer.buffer.length)
          return false;
      } else
        for (var i2 = 0; i2 < this.index; i2++)
          if (r2.buffer.buffer[i2 + 3] < this.index)
            return false;
      t2 = r2.index, n2 = r2.parent;
    } else {
      var o2 = this._tree;
      t2 = o2.index, n2 = o2._parent;
    }
    for (; n2; t2 = (a2 = n2).index, n2 = a2._parent, a2) {
      var a2;
      if (t2 > -1)
        for (var s2 = t2 + e23, u2 = e23 < 0 ? -1 : n2._tree.children.length; s2 != u2; s2 += e23) {
          var c2 = n2._tree.children[s2];
          if (this.mode & HP.IncludeAnonymous || c2 instanceof GP || !c2.type.isAnonymous || oN(c2))
            return false;
        }
    }
    return true;
  } }, { key: "move", value: function(e23, t2) {
    if (t2 && this.enterChild(e23, 0, 4))
      return true;
    for (; ; ) {
      if (this.sibling(e23))
        return true;
      if (this.atLastNode(e23) || !this.parent())
        return false;
    }
  } }, { key: "next", value: function() {
    var e23 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    return this.move(1, e23);
  } }, { key: "prev", value: function() {
    var e23 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    return this.move(-1, e23);
  } }, { key: "moveTo", value: function(e23) {
    for (var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0; (this.from == this.to || (t2 < 1 ? this.from >= e23 : this.from > e23) || (t2 > -1 ? this.to <= e23 : this.to < e23)) && this.parent(); )
      ;
    for (; this.enterChild(1, e23, t2); )
      ;
    return this;
  } }, { key: "node", get: function() {
    if (!this.buffer)
      return this._tree;
    var e23 = this.bufferNode, t2 = null, n2 = 0;
    if (e23 && e23.context == this.buffer)
      e:
        for (var r2 = this.index, i2 = this.stack.length; i2 >= 0; ) {
          for (var o2 = e23; o2; o2 = o2._parent)
            if (o2.index == r2) {
              if (r2 == this.index)
                return o2;
              t2 = o2, n2 = i2 + 1;
              break e;
            }
          r2 = this.stack[--i2];
        }
    for (var a2 = n2; a2 < this.stack.length; a2++)
      t2 = new rN(this.buffer, t2, this.stack[a2]);
    return this.bufferNode = new rN(this.buffer, t2, this.index);
  } }, { key: "tree", get: function() {
    return this.buffer ? null : this._tree._tree;
  } }, { key: "iterate", value: function(e23, t2) {
    for (var n2 = 0; ; ) {
      var r2 = false;
      if (this.type.isAnonymous || e23(this) !== false) {
        if (this.firstChild()) {
          n2++;
          continue;
        }
        this.type.isAnonymous || (r2 = true);
      }
      for (; r2 && t2 && t2(this), r2 = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!n2)
          return;
        this.parent(), n2--, r2 = true;
      }
    }
  } }, { key: "matchContext", value: function(e23) {
    if (!this.buffer)
      return tN(this.node, e23);
    for (var t2 = this.buffer.buffer, n2 = t2.set.types, r2 = e23.length - 1, i2 = this.stack.length - 1; r2 >= 0; i2--) {
      if (i2 < 0)
        return tN(this.node, e23, r2);
      var o2 = n2[t2.buffer[this.stack[i2]]];
      if (!o2.isAnonymous) {
        if (e23[r2] && e23[r2] != o2.name)
          return false;
        r2--;
      }
    }
    return true;
  } }]), e22;
}();
function oN(e22) {
  return e22.children.some(function(e23) {
    return e23 instanceof GP || !e23.type.isAnonymous || oN(e23);
  });
}
function aN(e22) {
  var t2, n2 = e22.buffer, r2 = e22.nodeSet, i2 = e22.maxBufferLength, o2 = i2 === void 0 ? 1024 : i2, a2 = e22.reused, s2 = a2 === void 0 ? [] : a2, u2 = e22.minRepeatType, c2 = u2 === void 0 ? r2.types.length : u2, l2 = Array.isArray(n2) ? new KP(n2, n2.length) : n2, f2 = r2.types, h2 = 0, d2 = 0;
  function v2(e23, t3, n3, i3, a3) {
    for (var u3 = l2.id, y3 = l2.start, b3 = l2.end, k3 = l2.size, w2 = d2; k3 < 0; ) {
      if (l2.next(), k3 == -1) {
        var x2 = s2[u3];
        return n3.push(x2), void i3.push(y3 - e23);
      }
      if (k3 == -3)
        return void (h2 = u3);
      if (k3 == -4)
        return void (d2 = u3);
      throw new RangeError("Unrecognized record size: ".concat(k3));
    }
    var j2, S2, C2 = f2[u3], _2 = y3 - e23;
    if (b3 - y3 <= o2 && (S2 = function(e24, t4) {
      var n4 = l2.fork(), r3 = 0, i4 = 0, a4 = 0, s3 = n4.end - o2, u4 = { size: 0, start: 0, skip: 0 };
      e:
        for (var f3 = n4.pos - e24; n4.pos > f3; ) {
          var h3 = n4.size;
          if (n4.id == t4 && h3 >= 0)
            u4.size = r3, u4.start = i4, u4.skip = a4, a4 += 4, r3 += 4, n4.next();
          else {
            var d3 = n4.pos - h3;
            if (h3 < 0 || d3 < f3 || n4.start < s3)
              break;
            var v3 = n4.id >= c2 ? 4 : 0, p3 = n4.start;
            for (n4.next(); n4.pos > d3; ) {
              if (n4.size < 0) {
                if (n4.size != -3)
                  break e;
                v3 += 4;
              } else
                n4.id >= c2 && (v3 += 4);
              n4.next();
            }
            i4 = p3, r3 += h3, a4 += v3;
          }
        }
      (t4 < 0 || r3 == e24) && (u4.size = r3, u4.start = i4, u4.skip = a4);
      return u4.size > 4 ? u4 : void 0;
    }(l2.pos - t3, a3))) {
      for (var $2 = new Uint16Array(S2.size - S2.skip), O2 = l2.pos - S2.size, A2 = $2.length; l2.pos > O2; )
        A2 = g2(S2.start, $2, A2);
      j2 = new GP($2, b3 - S2.start, r2), _2 = S2.start - e23;
    } else {
      var M2 = l2.pos - k3;
      l2.next();
      for (var E2 = [], P2 = [], N2 = u3 >= c2 ? u3 : -1, T2 = 0, I2 = b3; l2.pos > M2; )
        N2 >= 0 && l2.id == N2 && l2.size >= 0 ? (l2.end <= I2 - o2 && (p2(E2, P2, y3, T2, l2.end, I2, N2, w2), T2 = E2.length, I2 = l2.end), l2.next()) : v2(y3, M2, E2, P2, N2);
      if (N2 >= 0 && T2 > 0 && T2 < E2.length && p2(E2, P2, y3, T2, y3, I2, N2, w2), E2.reverse(), P2.reverse(), N2 > -1 && T2 > 0) {
        var R2 = function(e24) {
          return function(t4, n4, r3) {
            var i4, o3, a4 = 0, s3 = t4.length - 1;
            if (s3 >= 0 && (i4 = t4[s3]) instanceof UP) {
              if (!s3 && i4.type == e24 && i4.length == r3)
                return i4;
              (o3 = i4.prop(qP.lookAhead)) && (a4 = n4[s3] + i4.length + o3);
            }
            return m2(e24, t4, n4, r3, a4);
          };
        }(C2);
        j2 = cN(C2, E2, P2, 0, E2.length, 0, b3 - y3, R2, R2);
      } else
        j2 = m2(C2, E2, P2, b3 - y3, w2 - b3);
    }
    n3.push(j2), i3.push(_2);
  }
  function p2(e23, t3, n3, i3, o3, a3, s3, u3) {
    for (var c3 = [], l3 = []; e23.length > i3; )
      c3.push(e23.pop()), l3.push(t3.pop() + n3 - o3);
    e23.push(m2(r2.types[s3], c3, l3, a3 - o3, u3 - a3)), t3.push(o3 - n3);
  }
  function m2(e23, t3, n3, r3) {
    var i3 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0, o3 = arguments.length > 5 ? arguments[5] : void 0;
    if (h2) {
      var a3 = [qP.contextHash, h2];
      o3 = o3 ? [a3].concat(o3) : [a3];
    }
    if (i3 > 25) {
      var s3 = [qP.lookAhead, i3];
      o3 = o3 ? [s3].concat(o3) : [s3];
    }
    return new UP(e23, t3, n3, r3, o3);
  }
  function g2(e23, t3, n3) {
    var r3 = l2.id, i3 = l2.start, o3 = l2.end, a3 = l2.size;
    if (l2.next(), a3 >= 0 && r3 < c2) {
      var s3 = n3;
      if (a3 > 4)
        for (var u3 = l2.pos - (a3 - 4); l2.pos > u3; )
          n3 = g2(e23, t3, n3);
      t3[--n3] = s3, t3[--n3] = o3 - e23, t3[--n3] = i3 - e23, t3[--n3] = r3;
    } else
      a3 == -3 ? h2 = r3 : a3 == -4 && (d2 = r3);
    return n3;
  }
  for (var y2 = [], b2 = []; l2.pos > 0; )
    v2(e22.start || 0, e22.bufferStart || 0, y2, b2, -1);
  var k2 = (t2 = e22.length) !== null && t2 !== void 0 ? t2 : y2.length ? b2[0] + y2[0].length : 0;
  return new UP(f2[e22.topID], y2.reverse(), b2.reverse(), k2);
}
var sN = /* @__PURE__ */ new WeakMap();
function uN(e22, t2) {
  if (!e22.isAnonymous || t2 instanceof GP || t2.type != e22)
    return 1;
  var n2 = sN.get(t2);
  if (n2 == null) {
    n2 = 1;
    var r2, i2 = bi(t2.children);
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        var o2 = r2.value;
        if (o2.type != e22 || !(o2 instanceof UP)) {
          n2 = 1;
          break;
        }
        n2 += uN(e22, o2);
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
    sN.set(t2, n2);
  }
  return n2;
}
function cN(e22, t2, n2, r2, i2, o2, a2, s2, u2) {
  for (var c2 = 0, l2 = r2; l2 < i2; l2++)
    c2 += uN(e22, t2[l2]);
  var f2 = Math.ceil(1.5 * c2 / 8), h2 = [], d2 = [];
  return function t3(n3, r3, i3, a3, s3) {
    for (var c3 = i3; c3 < a3; ) {
      var l3 = c3, v2 = r3[c3], p2 = uN(e22, n3[c3]);
      for (c3++; c3 < a3; c3++) {
        var m2 = uN(e22, n3[c3]);
        if (p2 + m2 >= f2)
          break;
        p2 += m2;
      }
      if (c3 == l3 + 1) {
        if (p2 > f2) {
          var g2 = n3[l3];
          t3(g2.children, g2.positions, 0, g2.children.length, r3[l3] + s3);
          continue;
        }
        h2.push(n3[l3]);
      } else {
        var y2 = r3[c3 - 1] + n3[c3 - 1].length - v2;
        h2.push(cN(e22, n3, r3, l3, c3, v2, y2, null, u2));
      }
      d2.push(v2 + s3 - o2);
    }
  }(t2, n2, r2, i2, 0), (s2 || u2)(h2, d2, a2);
}
new qP({ perNode: true });
var lN = 0, fN = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.set = t2, this.base = n2, this.modified = r2, this.id = lN++;
  }
  return zi(e22, null, [{ key: "define", value: function(t2) {
    if (t2 == null ? void 0 : t2.base)
      throw new Error("Can not derive from a modified tag");
    var n2 = new e22([], null, []);
    if (n2.set.push(n2), t2) {
      var r2, i2 = bi(t2.set);
      try {
        for (i2.s(); !(r2 = i2.n()).done; ) {
          var o2 = r2.value;
          n2.set.push(o2);
        }
      } catch (e23) {
        i2.e(e23);
      } finally {
        i2.f();
      }
    }
    return n2;
  } }, { key: "defineModifier", value: function() {
    var e23 = new dN();
    return function(t2) {
      return t2.modified.indexOf(e23) > -1 ? t2 : dN.get(t2.base || t2, t2.modified.concat(e23).sort(function(e24, t3) {
        return e24.id - t3.id;
      }));
    };
  } }]), e22;
}(), hN = 0, dN = function() {
  function e22() {
    Ri(this, e22), this.instances = [], this.id = hN++;
  }
  return zi(e22, null, [{ key: "get", value: function(t2, n2) {
    if (!n2.length)
      return t2;
    var r2 = n2[0].instances.find(function(e23) {
      return e23.base == t2 && (r3 = n2, i3 = e23.modified, r3.length == i3.length && r3.every(function(e24, t3) {
        return e24 == i3[t3];
      }));
      var r3, i3;
    });
    if (r2)
      return r2;
    var i2, o2 = [], a2 = new fN(o2, t2, n2), s2 = bi(n2);
    try {
      for (s2.s(); !(i2 = s2.n()).done; ) {
        i2.value.instances.push(a2);
      }
    } catch (e23) {
      s2.e(e23);
    } finally {
      s2.f();
    }
    var u2, c2 = vN(n2), l2 = bi(t2.set);
    try {
      for (l2.s(); !(u2 = l2.n()).done; ) {
        var f2, h2 = u2.value, d2 = bi(c2);
        try {
          for (d2.s(); !(f2 = d2.n()).done; ) {
            var v2 = f2.value;
            o2.push(e22.get(h2, v2));
          }
        } catch (e23) {
          d2.e(e23);
        } finally {
          d2.f();
        }
      }
    } catch (e23) {
      l2.e(e23);
    } finally {
      l2.f();
    }
    return a2;
  } }]), e22;
}();
function vN(e22) {
  for (var t2 = [e22], n2 = 0; n2 < e22.length; n2++) {
    var r2, i2 = bi(vN(e22.slice(0, n2).concat(e22.slice(n2 + 1))));
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        var o2 = r2.value;
        t2.push(o2);
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
  }
  return t2;
}
function pN(e22) {
  var t2 = /* @__PURE__ */ Object.create(null);
  for (var n2 in e22) {
    var r2 = e22[n2];
    Array.isArray(r2) || (r2 = [r2]);
    var i2, o2 = bi(n2.split(" "));
    try {
      for (o2.s(); !(i2 = o2.n()).done; ) {
        var a2 = i2.value;
        if (a2) {
          for (var s2 = [], u2 = 2, c2 = a2, l2 = 0; ; ) {
            if (c2 == "..." && l2 > 0 && l2 + 3 == a2.length) {
              u2 = 1;
              break;
            }
            var f2 = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(c2);
            if (!f2)
              throw new RangeError("Invalid path: " + a2);
            if (s2.push(f2[0] == "*" ? "" : f2[0][0] == '"' ? JSON.parse(f2[0]) : f2[0]), (l2 += f2[0].length) == a2.length)
              break;
            var h2 = a2[l2++];
            if (l2 == a2.length && h2 == "!") {
              u2 = 0;
              break;
            }
            if (h2 != "/")
              throw new RangeError("Invalid path: " + a2);
            c2 = a2.slice(l2);
          }
          var d2 = s2.length - 1, v2 = s2[d2];
          if (!v2)
            throw new RangeError("Invalid path: " + a2);
          var p2 = new gN(r2, u2, d2 > 0 ? s2.slice(0, d2) : null);
          t2[v2] = p2.sort(t2[v2]);
        }
      }
    } catch (e23) {
      o2.e(e23);
    } finally {
      o2.f();
    }
  }
  return mN.add(t2);
}
var mN = new qP(), gN = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.tags = t2, this.mode = n2, this.context = r2, this.next = i2;
  }
  return zi(e22, [{ key: "sort", value: function(e23) {
    return !e23 || e23.depth < this.depth ? (this.next = e23, this) : (e23.next = this.sort(e23.next), e23);
  } }, { key: "depth", get: function() {
    return this.context ? this.context.length : 0;
  } }]), e22;
}();
function yN(e22, t2) {
  var n2, r2 = /* @__PURE__ */ Object.create(null), i2 = bi(e22);
  try {
    for (i2.s(); !(n2 = i2.n()).done; ) {
      var o2 = n2.value;
      if (Array.isArray(o2.tag)) {
        var a2, s2 = bi(o2.tag);
        try {
          for (s2.s(); !(a2 = s2.n()).done; ) {
            var u2 = a2.value;
            r2[u2.id] = o2.class;
          }
        } catch (e23) {
          s2.e(e23);
        } finally {
          s2.f();
        }
      } else
        r2[o2.tag.id] = o2.class;
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  var c2 = t2 || {}, l2 = c2.scope, f2 = c2.all, h2 = f2 === void 0 ? null : f2;
  return { style: function(e23) {
    var t3, n3 = h2, i3 = bi(e23);
    try {
      for (i3.s(); !(t3 = i3.n()).done; ) {
        var o3, a3 = bi(t3.value.set);
        try {
          for (a3.s(); !(o3 = a3.n()).done; ) {
            var s3 = o3.value, u3 = r2[s3.id];
            if (u3) {
              n3 = n3 ? n3 + " " + u3 : u3;
              break;
            }
          }
        } catch (e24) {
          a3.e(e24);
        } finally {
          a3.f();
        }
      }
    } catch (e24) {
      i3.e(e24);
    } finally {
      i3.f();
    }
    return n3;
  }, scope: l2 };
}
function bN(e22, t2) {
  var n2, r2 = null, i2 = bi(e22);
  try {
    for (i2.s(); !(n2 = i2.n()).done; ) {
      var o2 = n2.value.style(t2);
      o2 && (r2 = r2 ? r2 + " " + o2 : o2);
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  return r2;
}
function kN(e22, t2, n2) {
  var r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0, i2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : e22.length, o2 = new xN(r2, Array.isArray(t2) ? t2 : [t2], n2);
  o2.highlightRange(e22.cursor(), r2, i2, "", o2.highlighters), o2.flush(i2);
}
var wN, xN = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.at = t2, this.highlighters = n2, this.span = r2, this.class = "";
  }
  return zi(e22, [{ key: "startSpan", value: function(e23, t2) {
    t2 != this.class && (this.flush(e23), e23 > this.at && (this.at = e23), this.class = t2);
  } }, { key: "flush", value: function(e23) {
    e23 > this.at && this.class && this.span(this.at, e23, this.class);
  } }, { key: "highlightRange", value: function(e23, t2, n2, r2, i2) {
    var o2 = e23.type, a2 = e23.from, s2 = e23.to;
    if (!(a2 >= n2 || s2 <= t2)) {
      o2.isTop && (i2 = this.highlighters.filter(function(e24) {
        return !e24.scope || e24.scope(o2);
      }));
      for (var u2 = r2, c2 = o2.prop(mN), l2 = false; c2; ) {
        if (!c2.context || e23.matchContext(c2.context)) {
          var f2 = bN(i2, c2.tags);
          f2 && (u2 && (u2 += " "), u2 += f2, c2.mode == 1 ? r2 += (r2 ? " " : "") + f2 : c2.mode == 0 && (l2 = true));
          break;
        }
        c2 = c2.next;
      }
      if (this.startSpan(e23.from, u2), !l2) {
        var h2 = e23.tree && e23.tree.prop(qP.mounted);
        if (h2 && h2.overlay) {
          for (var d2 = e23.node.enter(h2.overlay[0].from + a2, 1), v2 = this.highlighters.filter(function(e24) {
            return !e24.scope || e24.scope(h2.tree.type);
          }), p2 = e23.firstChild(), m2 = 0, g2 = a2; ; m2++) {
            var y2 = m2 < h2.overlay.length ? h2.overlay[m2] : null, b2 = y2 ? y2.from + a2 : s2, k2 = Math.max(t2, g2), w2 = Math.min(n2, b2);
            if (k2 < w2 && p2)
              for (; e23.from < w2 && (this.highlightRange(e23, k2, w2, r2, i2), this.startSpan(Math.min(n2, e23.to), u2), !(e23.to >= b2) && e23.nextSibling()); )
                ;
            if (!y2 || b2 > n2)
              break;
            (g2 = y2.to + a2) > t2 && (this.highlightRange(d2.cursor(), Math.max(t2, y2.from + a2), Math.min(n2, g2), r2, v2), this.startSpan(g2, u2));
          }
          p2 && e23.parent();
        } else if (e23.firstChild()) {
          do {
            if (!(e23.to <= t2)) {
              if (e23.from >= n2)
                break;
              this.highlightRange(e23, t2, n2, r2, i2), this.startSpan(Math.min(n2, e23.to), u2);
            }
          } while (e23.nextSibling());
          e23.parent();
        }
      }
    }
  } }]), e22;
}(), jN = fN.define, SN = jN(), CN = jN(), _N = jN(CN), $N = jN(CN), ON = jN(), AN = jN(ON), MN = jN(ON), EN = jN(), PN = jN(EN), NN = jN(), TN = jN(), IN = jN(), RN = jN(IN), DN = jN(), zN = { comment: SN, lineComment: jN(SN), blockComment: jN(SN), docComment: jN(SN), name: CN, variableName: jN(CN), typeName: _N, tagName: jN(_N), propertyName: $N, attributeName: jN($N), className: jN(CN), labelName: jN(CN), namespace: jN(CN), macroName: jN(CN), literal: ON, string: AN, docString: jN(AN), character: jN(AN), attributeValue: jN(AN), number: MN, integer: jN(MN), float: jN(MN), bool: jN(ON), regexp: jN(ON), escape: jN(ON), color: jN(ON), url: jN(ON), keyword: NN, self: jN(NN), null: jN(NN), atom: jN(NN), unit: jN(NN), modifier: jN(NN), operatorKeyword: jN(NN), controlKeyword: jN(NN), definitionKeyword: jN(NN), moduleKeyword: jN(NN), operator: TN, derefOperator: jN(TN), arithmeticOperator: jN(TN), logicOperator: jN(TN), bitwiseOperator: jN(TN), compareOperator: jN(TN), updateOperator: jN(TN), definitionOperator: jN(TN), typeOperator: jN(TN), controlOperator: jN(TN), punctuation: IN, separator: jN(IN), bracket: RN, angleBracket: jN(RN), squareBracket: jN(RN), paren: jN(RN), brace: jN(RN), content: EN, heading: PN, heading1: jN(PN), heading2: jN(PN), heading3: jN(PN), heading4: jN(PN), heading5: jN(PN), heading6: jN(PN), contentSeparator: jN(EN), list: jN(EN), quote: jN(EN), emphasis: jN(EN), strong: jN(EN), link: jN(EN), monospace: jN(EN), strikethrough: jN(EN), inserted: jN(), deleted: jN(), changed: jN(), invalid: jN(), meta: DN, documentMeta: jN(DN), annotation: jN(DN), processingInstruction: jN(DN), definition: fN.defineModifier(), constant: fN.defineModifier(), function: fN.defineModifier(), standard: fN.defineModifier(), local: fN.defineModifier(), special: fN.defineModifier() };
yN([{ tag: zN.link, class: "tok-link" }, { tag: zN.heading, class: "tok-heading" }, { tag: zN.emphasis, class: "tok-emphasis" }, { tag: zN.strong, class: "tok-strong" }, { tag: zN.keyword, class: "tok-keyword" }, { tag: zN.atom, class: "tok-atom" }, { tag: zN.bool, class: "tok-bool" }, { tag: zN.url, class: "tok-url" }, { tag: zN.labelName, class: "tok-labelName" }, { tag: zN.inserted, class: "tok-inserted" }, { tag: zN.deleted, class: "tok-deleted" }, { tag: zN.literal, class: "tok-literal" }, { tag: zN.string, class: "tok-string" }, { tag: zN.number, class: "tok-number" }, { tag: [zN.regexp, zN.escape, zN.special(zN.string)], class: "tok-string2" }, { tag: zN.variableName, class: "tok-variableName" }, { tag: zN.local(zN.variableName), class: "tok-variableName tok-local" }, { tag: zN.definition(zN.variableName), class: "tok-variableName tok-definition" }, { tag: zN.special(zN.variableName), class: "tok-variableName2" }, { tag: zN.definition(zN.propertyName), class: "tok-propertyName tok-definition" }, { tag: zN.typeName, class: "tok-typeName" }, { tag: zN.namespace, class: "tok-namespace" }, { tag: zN.className, class: "tok-className" }, { tag: zN.macroName, class: "tok-macroName" }, { tag: zN.propertyName, class: "tok-propertyName" }, { tag: zN.operator, class: "tok-operator" }, { tag: zN.comment, class: "tok-comment" }, { tag: zN.meta, class: "tok-meta" }, { tag: zN.invalid, class: "tok-invalid" }, { tag: zN.punctuation, class: "tok-punctuation" }]);
var LN = new vP();
var BN = function() {
  function e22(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
    Ri(this, e22), this.data = t2, v_.prototype.hasOwnProperty("tree") || Object.defineProperty(v_.prototype, "tree", { get: function() {
      return VN(this);
    } }), this.parser = n2, this.extension = [ZN.of(this), v_.languageData.of(function(e23, t3, n3) {
      return e23.facet(qN(e23, t3, n3));
    })].concat(r2);
  }
  return zi(e22, [{ key: "isActiveAt", value: function(e23, t2) {
    var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : -1;
    return qN(e23, t2, n2) == this.data;
  } }, { key: "findRegions", value: function(e23) {
    var t2 = this, n2 = e23.facet(ZN);
    if ((n2 == null ? void 0 : n2.data) == this.data)
      return [{ from: 0, to: e23.doc.length }];
    if (!n2 || !n2.allowsNesting)
      return [];
    var r2 = [];
    return function e24(n3, i2) {
      if (n3.prop(LN) != t2.data) {
        var o2 = n3.prop(vP.mounted);
        if (o2) {
          if (o2.tree.prop(LN) == t2.data) {
            if (o2.overlay) {
              var a2, s2 = bi(o2.overlay);
              try {
                for (s2.s(); !(a2 = s2.n()).done; ) {
                  var u2 = a2.value;
                  r2.push({ from: u2.from + i2, to: u2.to + i2 });
                }
              } catch (e25) {
                s2.e(e25);
              } finally {
                s2.f();
              }
            } else
              r2.push({ from: i2, to: i2 + n3.length });
            return;
          }
          if (o2.overlay) {
            var c2 = r2.length;
            if (e24(o2.tree, o2.overlay[0].from + i2), r2.length > c2)
              return;
          }
        }
        for (var l2 = 0; l2 < n3.children.length; l2++) {
          var f2 = n3.children[l2];
          f2 instanceof kP && e24(f2, n3.positions[l2] + i2);
        }
      } else
        r2.push({ from: i2, to: i2 + n3.length });
    }(VN(e23), 0), r2;
  } }, { key: "allowsNesting", get: function() {
    return true;
  } }]), e22;
}();
function qN(e22, t2, n2) {
  var r2 = e22.facet(ZN);
  if (!r2)
    return null;
  var i2 = r2.data;
  if (r2.allowsNesting)
    for (var o2 = VN(e22).topNode; o2; o2 = o2.enter(t2, n2, gP.ExcludeBuffers))
      i2 = o2.type.prop(LN) || i2;
  return i2;
}
BN.setState = n_.define();
var FN = function(e22) {
  ji(n2, BN);
  var t2 = Ci(n2);
  function n2(e23, r2) {
    var i2;
    return Ri(this, n2), (i2 = t2.call(this, e23, r2)).parser = r2, i2;
  }
  return zi(n2, [{ key: "configure", value: function(e23) {
    return new n2(this.data, this.parser.configure(e23));
  } }, { key: "allowsNesting", get: function() {
    return this.parser.hasWrappers();
  } }], [{ key: "define", value: function(e23) {
    var t3, r2 = (t3 = e23.languageData, $C.define({ combine: t3 ? function(e24) {
      return e24.concat(t3);
    } : void 0 }));
    return new n2(r2, e23.parser.configure({ props: [LN.add(function(e24) {
      return e24.isTop ? r2 : void 0;
    })] }));
  } }]), n2;
}();
function VN(e22) {
  var t2 = e22.field(BN.state, false);
  return t2 ? t2.tree : kP.empty;
}
var HN = function() {
  function e22(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : t2.length;
    Ri(this, e22), this.doc = t2, this.length = n2, this.cursorPos = 0, this.string = "", this.cursor = t2.iter();
  }
  return zi(e22, [{ key: "syncTo", value: function(e23) {
    return this.string = this.cursor.next(e23 - this.cursorPos).value, this.cursorPos = e23 + this.string.length, this.cursorPos - this.string.length;
  } }, { key: "chunk", value: function(e23) {
    return this.syncTo(e23), this.string;
  } }, { key: "lineChunks", get: function() {
    return true;
  } }, { key: "read", value: function(e23, t2) {
    var n2 = this.cursorPos - this.string.length;
    return e23 < n2 || t2 >= this.cursorPos ? this.doc.sliceString(e23, t2) : this.string.slice(e23 - n2, t2 - n2);
  } }]), e22;
}(), WN = null, JN = function() {
  function e22(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [], i2 = arguments.length > 3 ? arguments[3] : void 0, o2 = arguments.length > 4 ? arguments[4] : void 0, a2 = arguments.length > 5 ? arguments[5] : void 0, s2 = arguments.length > 6 ? arguments[6] : void 0, u2 = arguments.length > 7 ? arguments[7] : void 0;
    Ri(this, e22), this.parser = t2, this.state = n2, this.fragments = r2, this.tree = i2, this.treeLen = o2, this.viewport = a2, this.skipped = s2, this.scheduleOn = u2, this.parse = null, this.tempSkipped = [];
  }
  return zi(e22, [{ key: "startParse", value: function() {
    return this.parser.startParse(new HN(this.state.doc), this.fragments);
  } }, { key: "work", value: function(e23, t2) {
    var n2 = this;
    return t2 != null && t2 >= this.state.doc.length && (t2 = void 0), this.tree != kP.empty && this.isDone(t2 != null ? t2 : this.state.doc.length) ? (this.takeTree(), true) : this.withContext(function() {
      var r2;
      if (typeof e23 == "number") {
        var i2 = Date.now() + e23;
        e23 = function() {
          return Date.now() > i2;
        };
      }
      for (n2.parse || (n2.parse = n2.startParse()), t2 != null && (n2.parse.stoppedAt == null || n2.parse.stoppedAt > t2) && t2 < n2.state.doc.length && n2.parse.stopAt(t2); ; ) {
        var o2 = n2.parse.advance();
        if (o2) {
          if (n2.fragments = n2.withoutTempSkipped(DP.addTree(o2, n2.fragments, n2.parse.stoppedAt != null)), n2.treeLen = (r2 = n2.parse.stoppedAt) !== null && r2 !== void 0 ? r2 : n2.state.doc.length, n2.tree = o2, n2.parse = null, !(n2.treeLen < (t2 != null ? t2 : n2.state.doc.length)))
            return true;
          n2.parse = n2.startParse();
        }
        if (e23())
          return false;
      }
    });
  } }, { key: "takeTree", value: function() {
    var e23, t2, n2 = this;
    this.parse && (e23 = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > e23) && this.parse.stopAt(e23), this.withContext(function() {
      for (; !(t2 = n2.parse.advance()); )
        ;
    }), this.treeLen = e23, this.tree = t2, this.fragments = this.withoutTempSkipped(DP.addTree(this.tree, this.fragments, true)), this.parse = null);
  } }, { key: "withContext", value: function(e23) {
    var t2 = WN;
    WN = this;
    try {
      return e23();
    } finally {
      WN = t2;
    }
  } }, { key: "withoutTempSkipped", value: function(e23) {
    for (var t2; t2 = this.tempSkipped.pop(); )
      e23 = UN(e23, t2.from, t2.to);
    return e23;
  } }, { key: "changes", value: function(t2, n2) {
    var r2 = this.fragments, i2 = this.tree, o2 = this.treeLen, a2 = this.viewport, s2 = this.skipped;
    if (this.takeTree(), !t2.empty) {
      var u2 = [];
      if (t2.iterChangedRanges(function(e23, t3, n3, r3) {
        return u2.push({ fromA: e23, toA: t3, fromB: n3, toB: r3 });
      }), r2 = DP.applyChanges(r2, u2), i2 = kP.empty, o2 = 0, a2 = { from: t2.mapPos(a2.from, -1), to: t2.mapPos(a2.to, 1) }, this.skipped.length) {
        s2 = [];
        var c2, l2 = bi(this.skipped);
        try {
          for (l2.s(); !(c2 = l2.n()).done; ) {
            var f2 = c2.value, h2 = t2.mapPos(f2.from, 1), d2 = t2.mapPos(f2.to, -1);
            h2 < d2 && s2.push({ from: h2, to: d2 });
          }
        } catch (e23) {
          l2.e(e23);
        } finally {
          l2.f();
        }
      }
    }
    return new e22(this.parser, n2, r2, i2, o2, a2, s2, this.scheduleOn);
  } }, { key: "updateViewport", value: function(e23) {
    if (this.viewport.from == e23.from && this.viewport.to == e23.to)
      return false;
    this.viewport = e23;
    for (var t2 = this.skipped.length, n2 = 0; n2 < this.skipped.length; n2++) {
      var r2 = this.skipped[n2], i2 = r2.from, o2 = r2.to;
      i2 < e23.to && o2 > e23.from && (this.fragments = UN(this.fragments, i2, o2), this.skipped.splice(n2--, 1));
    }
    return !(this.skipped.length >= t2) && (this.reset(), true);
  } }, { key: "reset", value: function() {
    this.parse && (this.takeTree(), this.parse = null);
  } }, { key: "skipUntilInView", value: function(e23, t2) {
    this.skipped.push({ from: e23, to: t2 });
  } }, { key: "isDone", value: function(e23) {
    e23 = Math.min(e23, this.state.doc.length);
    var t2 = this.fragments;
    return this.treeLen >= e23 && t2.length && t2[0].from == 0 && t2[0].to >= e23;
  } }], [{ key: "create", value: function(t2, n2, r2) {
    return new e22(t2, n2, [], kP.empty, 0, r2, [], null);
  } }, { key: "getSkippingParser", value: function(e23) {
    return new (function(t2) {
      ji(r2, zP);
      var n2 = Ci(r2);
      function r2() {
        return Ri(this, r2), n2.apply(this, arguments);
      }
      return zi(r2, [{ key: "createParse", value: function(t3, n3, r3) {
        var i2 = r3[0].from, o2 = r3[r3.length - 1].to;
        return { parsedPos: i2, advance: function() {
          var t4 = WN;
          if (t4) {
            var n4, a2 = bi(r3);
            try {
              for (a2.s(); !(n4 = a2.n()).done; ) {
                var s2 = n4.value;
                t4.tempSkipped.push(s2);
              }
            } catch (e24) {
              a2.e(e24);
            } finally {
              a2.f();
            }
            e23 && (t4.scheduleOn = t4.scheduleOn ? Promise.all([t4.scheduleOn, e23]) : e23);
          }
          return this.parsedPos = o2, new kP(mP.none, [], [], o2 - i2);
        }, stoppedAt: null, stopAt: function() {
        } };
      } }]), r2;
    }())();
  } }, { key: "get", value: function() {
    return WN;
  } }]), e22;
}();
function UN(e22, t2, n2) {
  return DP.applyChanges(e22, [{ fromA: t2, toA: n2, fromB: t2, toB: n2 }]);
}
var KN = function() {
  function e22(t2) {
    Ri(this, e22), this.context = t2, this.tree = t2.tree;
  }
  return zi(e22, [{ key: "apply", value: function(t2) {
    if (!t2.docChanged && this.tree == this.context.tree)
      return this;
    var n2 = this.context.changes(t2.changes, t2.state), r2 = this.context.treeLen == t2.startState.doc.length ? void 0 : Math.max(t2.changes.mapPos(this.context.treeLen), n2.viewport.to);
    return n2.work(20, r2) || n2.takeTree(), new e22(n2);
  } }], [{ key: "init", value: function(t2) {
    var n2 = Math.min(3e3, t2.doc.length), r2 = JN.create(t2.facet(ZN).parser, t2, { from: 0, to: n2 });
    return r2.work(20, n2) || r2.takeTree(), new e22(r2);
  } }]), e22;
}();
BN.state = NC.define({ create: KN.init, update: function(e22, t2) {
  var n2, r2 = bi(t2.effects);
  try {
    for (r2.s(); !(n2 = r2.n()).done; ) {
      var i2 = n2.value;
      if (i2.is(BN.setState))
        return i2.value;
    }
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
  return t2.startState.facet(ZN) != t2.state.facet(ZN) ? KN.init(t2.state) : e22.apply(t2);
} });
var GN = function(e22) {
  var t2 = setTimeout(function() {
    return e22();
  }, 500);
  return function() {
    return clearTimeout(t2);
  };
};
typeof requestIdleCallback != "undefined" && (GN = function(e22) {
  var t2 = -1, n2 = setTimeout(function() {
    t2 = requestIdleCallback(e22, { timeout: 400 });
  }, 100);
  return function() {
    return t2 < 0 ? clearTimeout(n2) : cancelIdleCallback(t2);
  };
});
var QN = typeof navigator != "undefined" && ((wN = navigator.scheduling) === null || wN === void 0 ? void 0 : wN.isInputPending) ? function() {
  return navigator.scheduling.isInputPending();
} : null, YN = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.view = t2, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    var t2 = this.view.state.field(BN.state).context;
    (t2.updateViewport(e23.view.viewport) || this.view.viewport.to > t2.treeLen) && this.scheduleWork(), e23.docChanged && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(t2);
  } }, { key: "scheduleWork", value: function() {
    if (!this.working) {
      var e23 = this.view.state, t2 = e23.field(BN.state);
      t2.tree == t2.context.tree && t2.context.isDone(e23.doc.length) || (this.working = GN(this.work));
    }
  } }, { key: "work", value: function(e23) {
    this.working = null;
    var t2 = Date.now();
    if (this.chunkEnd < t2 && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = t2 + 3e4, this.chunkBudget = 3e3), !(this.chunkBudget <= 0)) {
      var n2 = this.view, r2 = n2.state, i2 = n2.viewport.to, o2 = r2.field(BN.state);
      if (o2.tree != o2.context.tree || !o2.context.isDone(i2 + 1e5)) {
        var a2 = Date.now() + Math.min(this.chunkBudget, 100, e23 && !QN ? Math.max(25, e23.timeRemaining() - 5) : 1e9), s2 = o2.context.treeLen < i2 && r2.doc.length > i2 + 1e3, u2 = o2.context.work(function() {
          return QN && QN() || Date.now() > a2;
        }, i2 + (s2 ? 0 : 1e5));
        this.chunkBudget -= Date.now() - t2, (u2 || this.chunkBudget <= 0) && (o2.context.takeTree(), this.view.dispatch({ effects: BN.setState.of(new KN(o2.context)) })), this.chunkBudget > 0 && (!u2 || s2) && this.scheduleWork(), this.checkAsyncSchedule(o2.context);
      }
    }
  } }, { key: "checkAsyncSchedule", value: function(e23) {
    var t2 = this;
    e23.scheduleOn && (this.workScheduled++, e23.scheduleOn.then(function() {
      return t2.scheduleWork();
    }).catch(function(e24) {
      return gO(t2.view.state, e24);
    }).then(function() {
      return t2.workScheduled--;
    }), e23.scheduleOn = null);
  } }, { key: "destroy", value: function() {
    this.working && this.working();
  } }, { key: "isWorking", value: function() {
    return !!(this.working || this.workScheduled > 0);
  } }]), e22;
}(), { eventHandlers: { focus: function() {
  this.scheduleWork();
} } }), ZN = $C.define({ combine: function(e22) {
  return e22.length ? e22[0] : null;
}, enables: [BN.state, YN] }), XN = zi(function e9(t2) {
  var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [];
  Ri(this, e9), this.language = t2, this.support = n2, this.extension = [t2, n2];
}), eT = $C.define(), tT = $C.define({ combine: function(e22) {
  if (!e22.length)
    return "  ";
  if (!/^(?: +|\t+)$/.test(e22[0]))
    throw new Error("Invalid indent unit: " + JSON.stringify(e22[0]));
  return e22[0];
} });
function nT(e22) {
  var t2 = e22.facet(tT);
  return t2.charCodeAt(0) == 9 ? e22.tabSize * t2.length : t2.length;
}
function rT(e22, t2) {
  var n2 = "", r2 = e22.tabSize;
  if (e22.facet(tT).charCodeAt(0) == 9)
    for (; t2 >= r2; )
      n2 += "	", t2 -= r2;
  for (var i2 = 0; i2 < t2; i2++)
    n2 += " ";
  return n2;
}
function iT(e22, t2) {
  e22 instanceof v_ && (e22 = new oT(e22));
  var n2, r2 = bi(e22.state.facet(eT));
  try {
    for (r2.s(); !(n2 = r2.n()).done; ) {
      var i2 = (0, n2.value)(e22, t2);
      if (i2 != null)
        return i2;
    }
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
  var o2 = VN(e22.state);
  return o2 ? function(e23, t3, n3) {
    return uT(t3.resolveInner(n3).enterUnfinishedNodesBefore(n3), n3, e23);
  }(e22, o2, t2) : null;
}
var oT = function() {
  function e22(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    Ri(this, e22), this.state = t2, this.options = n2, this.unit = nT(t2);
  }
  return zi(e22, [{ key: "lineAt", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, n2 = this.state.doc.lineAt(e23), r2 = this.options, i2 = r2.simulateBreak, o2 = r2.simulateDoubleBreak;
    return i2 != null && i2 >= n2.from && i2 <= n2.to ? o2 && i2 == e23 ? { text: "", from: e23 } : (t2 < 0 ? i2 < e23 : i2 <= e23) ? { text: n2.text.slice(i2 - n2.from), from: i2 } : { text: n2.text.slice(0, i2 - n2.from), from: n2.from } : n2;
  } }, { key: "textAfterPos", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
    if (this.options.simulateDoubleBreak && e23 == this.options.simulateBreak)
      return "";
    var n2 = this.lineAt(e23, t2), r2 = n2.text, i2 = n2.from;
    return r2.slice(e23 - i2, Math.min(r2.length, e23 + 100 - i2));
  } }, { key: "column", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, n2 = this.lineAt(e23, t2), r2 = n2.text, i2 = n2.from, o2 = this.countColumn(r2, e23 - i2), a2 = this.options.overrideIndentation ? this.options.overrideIndentation(i2) : -1;
    return a2 > -1 && (o2 += a2 - this.countColumn(r2, r2.search(/\S|$/))), o2;
  } }, { key: "countColumn", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23.length;
    return N_(e23, this.state.tabSize, t2);
  } }, { key: "lineIndent", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, n2 = this.lineAt(e23, t2), r2 = n2.text, i2 = n2.from, o2 = this.options.overrideIndentation;
    if (o2) {
      var a2 = o2(i2);
      if (a2 > -1)
        return a2;
    }
    return this.countColumn(r2, r2.search(/\S|$/));
  } }, { key: "simulatedBreak", get: function() {
    return this.options.simulateBreak || null;
  } }]), e22;
}(), aT = new vP();
function sT(e22) {
  var t2 = e22.type.prop(aT);
  if (t2)
    return t2;
  var n2, r2 = e22.firstChild;
  if (r2 && (n2 = r2.type.prop(vP.closedBy))) {
    var i2 = e22.lastChild, o2 = i2 && n2.indexOf(i2.name) > -1;
    return function(e23) {
      return function(e24, t3, n3, r3, i3) {
        var o3 = e24.textAfter, a2 = o3.match(/^\s*/)[0].length, s2 = r3 && o3.slice(a2, a2 + r3.length) == r3 || i3 == e24.pos + a2, u2 = t3 ? function(e25) {
          var t4 = e25.node, n4 = t4.childAfter(t4.from), r4 = t4.lastChild;
          if (!n4)
            return null;
          for (var i4 = e25.options.simulateBreak, o4 = e25.state.doc.lineAt(n4.from), a3 = i4 == null || i4 <= o4.from ? o4.to : Math.min(o4.to, i4), s3 = n4.to; ; ) {
            var u3 = t4.childAfter(s3);
            if (!u3 || u3 == r4)
              return null;
            if (!u3.type.isSkipped)
              return u3.from < a3 ? n4 : null;
            s3 = u3.to;
          }
        }(e24) : null;
        return u2 ? s2 ? e24.column(u2.from) : e24.column(u2.to) : e24.baseIndent + (s2 ? 0 : e24.unit * n3);
      }(e23, true, 1, void 0, o2 && !function(e24) {
        return e24.pos == e24.options.simulateBreak && e24.options.simulateDoubleBreak;
      }(e23) ? i2.from : void 0);
    };
  }
  return e22.parent == null ? cT : null;
}
function uT(e22, t2, n2) {
  for (; e22; e22 = e22.parent) {
    var r2 = sT(e22);
    if (r2)
      return r2(lT.create(n2, t2, e22));
  }
  return null;
}
function cT() {
  return 0;
}
var lT = function(e22) {
  ji(n2, oT);
  var t2 = Ci(n2);
  function n2(e23, r2, i2) {
    var o2;
    return Ri(this, n2), (o2 = t2.call(this, e23.state, e23.options)).base = e23, o2.pos = r2, o2.node = i2, o2;
  }
  return zi(n2, [{ key: "textAfter", get: function() {
    return this.textAfterPos(this.pos);
  } }, { key: "baseIndent", get: function() {
    for (var e23 = this.state.doc.lineAt(this.node.from); ; ) {
      for (var t3 = this.node.resolve(e23.from); t3.parent && t3.parent.from == t3.from; )
        t3 = t3.parent;
      if (fT(t3, this.node))
        break;
      e23 = this.state.doc.lineAt(t3.from);
    }
    return this.lineIndent(e23.from);
  } }, { key: "continue", value: function() {
    var e23 = this.node.parent;
    return e23 ? uT(e23, this.pos, this.base) : 0;
  } }], [{ key: "create", value: function(e23, t3, r2) {
    return new n2(e23, t3, r2);
  } }]), n2;
}();
function fT(e22, t2) {
  for (var n2 = t2; n2; n2 = n2.parent)
    if (e22 == n2)
      return true;
  return false;
}
function hT() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, t2 = e22.except, n2 = e22.units, r2 = n2 === void 0 ? 1 : n2;
  return function(e23) {
    var n3 = t2 && t2.test(e23.textAfter);
    return e23.baseIndent + (n3 ? 0 : r2 * e23.unit);
  };
}
var dT = $C.define(), vT = new vP();
function pT(e22, t2, n2) {
  var r2, i2 = bi(e22.facet(dT));
  try {
    for (i2.s(); !(r2 = i2.n()).done; ) {
      var o2 = (0, r2.value)(e22, t2, n2);
      if (o2)
        return o2;
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  return function(e23, t3, n3) {
    var r3 = VN(e23);
    if (r3.length < n3)
      return null;
    for (var i3, o3, a2 = null, s2 = r3.resolveInner(n3); s2; s2 = s2.parent)
      if (!(s2.to <= n3 || s2.from > n3)) {
        if (a2 && s2.from < t3)
          break;
        var u2 = s2.type.prop(vT);
        if (u2 && (s2.to < r3.length - 50 || r3.length == e23.doc.length || (o3 = void 0, !(o3 = (i3 = s2).lastChild) || o3.to != i3.to || !o3.type.isError))) {
          var c2 = u2(s2, e23);
          c2 && c2.from <= n3 && c2.from >= t3 && c2.to > n3 && (a2 = c2);
        }
      }
    return a2;
  }(e22, t2, n2);
}
function mT(e22, t2) {
  var n2 = t2.mapPos(e22.from, 1), r2 = t2.mapPos(e22.to, -1);
  return n2 >= r2 ? void 0 : { from: n2, to: r2 };
}
var gT = n_.define({ map: mT }), yT = n_.define({ map: mT });
function bT(e22) {
  var t2, n2 = [], r2 = bi(e22.state.selection.ranges);
  try {
    var i2 = function() {
      var r3 = t2.value.head;
      if (n2.some(function(e23) {
        return e23.from <= r3 && e23.to >= r3;
      }))
        return "continue";
      n2.push(e22.lineBlockAt(r3));
    };
    for (r2.s(); !(t2 = r2.n()).done; )
      i2();
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
  return n2;
}
var kT = NC.define({ create: function() {
  return Y$.none;
}, update: function(e22, t2) {
  e22 = e22.map(t2.changes);
  var n2, r2 = bi(t2.effects);
  try {
    var i2 = function() {
      var t3 = n2.value;
      t3.is(gT) && !function(e23, t4, n3) {
        var r3 = false;
        return e23.between(t4, t4, function(e24, i3) {
          e24 == t4 && i3 == n3 && (r3 = true);
        }), r3;
      }(e22, t3.value.from, t3.value.to) ? e22 = e22.update({ add: [OT.range(t3.value.from, t3.value.to)] }) : t3.is(yT) && (e22 = e22.update({ filter: function(e23, n3) {
        return t3.value.from != e23 || t3.value.to != n3;
      }, filterFrom: t3.value.from, filterTo: t3.value.to }));
    };
    for (r2.s(); !(n2 = r2.n()).done; )
      i2();
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
  if (t2.selection) {
    var o2 = false, a2 = t2.selection.main.head;
    e22.between(a2, a2, function(e23, t3) {
      e23 < a2 && t3 > a2 && (o2 = true);
    }), o2 && (e22 = e22.update({ filterFrom: a2, filterTo: a2, filter: function(e23, t3) {
      return t3 <= a2 || e23 >= a2;
    } }));
  }
  return e22;
}, provide: function(e22) {
  return MM.decorations.from(e22);
}, toJSON: function(e22, t2) {
  var n2 = [];
  return e22.between(0, t2.doc.length, function(e23, t3) {
    n2.push(e23, t3);
  }), n2;
}, fromJSON: function(e22) {
  if (!Array.isArray(e22) || e22.length % 2)
    throw new RangeError("Invalid JSON for fold state");
  for (var t2 = [], n2 = 0; n2 < e22.length; ) {
    var r2 = e22[n2++], i2 = e22[n2++];
    if (typeof r2 != "number" || typeof i2 != "number")
      throw new RangeError("Invalid JSON for fold state");
    t2.push(OT.range(r2, i2));
  }
  return Y$.set(t2, true);
} });
function wT(e22, t2, n2) {
  var r2, i2 = null;
  return (r2 = e22.field(kT, false)) === null || r2 === void 0 || r2.between(t2, n2, function(e23, t3) {
    (!i2 || i2.from > e23) && (i2 = { from: e23, to: t3 });
  }), i2;
}
function xT(e22, t2) {
  return e22.field(kT, false) ? t2 : t2.concat(n_.appendConfig.of($T()));
}
function jT(e22, t2) {
  var n2 = !(arguments.length > 2 && arguments[2] !== void 0) || arguments[2], r2 = e22.state.doc.lineAt(t2.from).number, i2 = e22.state.doc.lineAt(t2.to).number;
  return MM.announce.of("".concat(e22.state.phrase(n2 ? "Folded lines" : "Unfolded lines"), " ").concat(r2, " ").concat(e22.state.phrase("to"), " ").concat(i2, "."));
}
var ST = [{ key: "Ctrl-Shift-[", mac: "Cmd-Alt-[", run: function(e22) {
  var t2, n2 = bi(bT(e22));
  try {
    for (n2.s(); !(t2 = n2.n()).done; ) {
      var r2 = t2.value, i2 = pT(e22.state, r2.from, r2.to);
      if (i2)
        return e22.dispatch({ effects: xT(e22.state, [gT.of(i2), jT(e22, i2)]) }), true;
    }
  } catch (e23) {
    n2.e(e23);
  } finally {
    n2.f();
  }
  return false;
} }, { key: "Ctrl-Shift-]", mac: "Cmd-Alt-]", run: function(e22) {
  if (!e22.state.field(kT, false))
    return false;
  var t2, n2 = [], r2 = bi(bT(e22));
  try {
    for (r2.s(); !(t2 = r2.n()).done; ) {
      var i2 = t2.value, o2 = wT(e22.state, i2.from, i2.to);
      o2 && n2.push(yT.of(o2), jT(e22, o2, false));
    }
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
  return n2.length && e22.dispatch({ effects: n2 }), n2.length > 0;
} }, { key: "Ctrl-Alt-[", run: function(e22) {
  for (var t2 = e22.state, n2 = [], r2 = 0; r2 < t2.doc.length; ) {
    var i2 = e22.lineBlockAt(r2), o2 = pT(t2, i2.from, i2.to);
    o2 && n2.push(gT.of(o2)), r2 = (o2 ? e22.lineBlockAt(o2.to) : i2).to + 1;
  }
  return n2.length && e22.dispatch({ effects: xT(e22.state, n2) }), !!n2.length;
} }, { key: "Ctrl-Alt-]", run: function(e22) {
  var t2 = e22.state.field(kT, false);
  if (!t2 || !t2.size)
    return false;
  var n2 = [];
  return t2.between(0, e22.state.doc.length, function(e23, t3) {
    n2.push(yT.of({ from: e23, to: t3 }));
  }), e22.dispatch({ effects: n2 }), true;
} }], CT = { placeholderDOM: null, placeholderText: "\u2026" }, _T = $C.define({ combine: function(e22) {
  return p_(e22, CT);
} });
function $T(e22) {
  var t2 = [kT, PT];
  return e22 && t2.push(_T.of(e22)), t2;
}
var OT = Y$.replace({ widget: new (function(e22) {
  ji(n2, G$);
  var t2 = Ci(n2);
  function n2() {
    return Ri(this, n2), t2.apply(this, arguments);
  }
  return zi(n2, [{ key: "toDOM", value: function(e23) {
    var t3 = e23.state, n3 = t3.facet(_T), r2 = function(t4) {
      var n4 = e23.lineBlockAt(e23.posAtDOM(t4.target)), r3 = wT(e23.state, n4.from, n4.to);
      r3 && e23.dispatch({ effects: yT.of(r3) }), t4.preventDefault();
    };
    if (n3.placeholderDOM)
      return n3.placeholderDOM(e23, r2);
    var i2 = document.createElement("span");
    return i2.textContent = n3.placeholderText, i2.setAttribute("aria-label", t3.phrase("folded code")), i2.title = t3.phrase("unfold"), i2.className = "cm-foldPlaceholder", i2.onclick = r2, i2;
  } }]), n2;
}())() }), AT = { openText: "\u2304", closedText: "\u203A", markerDOM: null, domEventHandlers: {}, foldingChanged: function() {
  return false;
} }, MT = function(e22) {
  ji(n2, HE);
  var t2 = Ci(n2);
  function n2(e23, r2) {
    var i2;
    return Ri(this, n2), (i2 = t2.call(this)).config = e23, i2.open = r2, i2;
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return this.config == e23.config && this.open == e23.open;
  } }, { key: "toDOM", value: function(e23) {
    if (this.config.markerDOM)
      return this.config.markerDOM(this.open);
    var t3 = document.createElement("span");
    return t3.textContent = this.open ? this.config.openText : this.config.closedText, t3.title = e23.state.phrase(this.open ? "Fold line" : "Unfold line"), t3;
  } }]), n2;
}();
function ET() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, t2 = Object.assign(Object.assign({}, AT), e22), n2 = new MT(t2, true), r2 = new MT(t2, false), i2 = wO.fromClass(function() {
    function e23(t3) {
      Ri(this, e23), this.from = t3.viewport.from, this.markers = this.buildMarkers(t3);
    }
    return zi(e23, [{ key: "update", value: function(e24) {
      (e24.docChanged || e24.viewportChanged || e24.startState.facet(ZN) != e24.state.facet(ZN) || e24.startState.field(kT, false) != e24.state.field(kT, false) || VN(e24.startState) != VN(e24.state) || t2.foldingChanged(e24)) && (this.markers = this.buildMarkers(e24.view));
    } }, { key: "buildMarkers", value: function(e24) {
      var t3, i3 = new x_(), o3 = bi(e24.viewportLineBlocks);
      try {
        for (o3.s(); !(t3 = o3.n()).done; ) {
          var a2 = t3.value, s2 = wT(e24.state, a2.from, a2.to) ? r2 : pT(e24.state, a2.from, a2.to) ? n2 : null;
          s2 && i3.add(a2.from, a2.from, s2);
        }
      } catch (e25) {
        o3.e(e25);
      } finally {
        o3.f();
      }
      return i3.finish();
    } }]), e23;
  }()), o2 = t2.domEventHandlers;
  return [i2, KE({ class: "cm-foldGutter", markers: function(e23) {
    var t3;
    return ((t3 = e23.plugin(i2)) === null || t3 === void 0 ? void 0 : t3.markers) || k_.empty;
  }, initialSpacer: function() {
    return new MT(t2, false);
  }, domEventHandlers: Object.assign(Object.assign({}, o2), { click: function(e23, t3, n3) {
    if (o2.click && o2.click(e23, t3, n3))
      return true;
    var r3 = wT(e23.state, t3.from, t3.to);
    if (r3)
      return e23.dispatch({ effects: yT.of(r3) }), true;
    var i3 = pT(e23.state, t3.from, t3.to);
    return !!i3 && (e23.dispatch({ effects: gT.of(i3) }), true);
  } }) }), $T()];
}
var PT = MM.baseTheme({ ".cm-foldPlaceholder": { backgroundColor: "#eee", border: "1px solid #ddd", color: "#888", borderRadius: ".2em", margin: "0 1px", padding: "0 1px", cursor: "pointer" }, ".cm-foldGutter span": { padding: "0 1px", cursor: "pointer" } }), NT = function() {
  function e22(t2, n2) {
    var r2;
    function i2(e23) {
      var t3 = z_.newName();
      return (r2 || (r2 = /* @__PURE__ */ Object.create(null)))["." + t3] = e23, t3;
    }
    Ri(this, e22);
    var o2 = typeof n2.all == "string" ? n2.all : n2.all ? i2(n2.all) : void 0, a2 = n2.scope;
    this.scope = a2 instanceof BN ? function(e23) {
      return e23.prop(LN) == a2.data;
    } : a2 ? function(e23) {
      return e23 == a2;
    } : void 0, this.style = yN(t2.map(function(e23) {
      return { tag: e23.tag, class: e23.class || i2(Object.assign({}, e23, { tag: null })) };
    }), { all: o2 }).style, this.module = r2 ? new z_(r2) : null, this.themeType = n2.themeType;
  }
  return zi(e22, null, [{ key: "define", value: function(t2, n2) {
    return new e22(t2, n2 || {});
  } }]), e22;
}(), TT = $C.define(), IT = $C.define({ combine: function(e22) {
  return e22.length ? [e22[0]] : null;
} });
function RT(e22) {
  var t2 = e22.facet(TT);
  return t2.length ? t2 : e22.facet(IT);
}
function DT(e22, t2) {
  var n2, r2 = [LT];
  return e22 instanceof NT && (e22.module && r2.push(MM.styleModule.of(e22.module)), n2 = e22.themeType), (t2 == null ? void 0 : t2.fallback) ? r2.push(IT.of(e22)) : n2 ? r2.push(TT.computeN([MM.darkTheme], function(t3) {
    return t3.facet(MM.darkTheme) == (n2 == "dark") ? [e22] : [];
  })) : r2.push(TT.of(e22)), r2;
}
var zT = function() {
  function e22(t2) {
    Ri(this, e22), this.markCache = /* @__PURE__ */ Object.create(null), this.tree = VN(t2.state), this.decorations = this.buildDeco(t2, RT(t2.state));
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    var t2 = VN(e23.state), n2 = RT(e23.state), r2 = n2 != RT(e23.startState);
    t2.length < e23.view.viewport.to && !r2 && t2.type == this.tree.type ? this.decorations = this.decorations.map(e23.changes) : (t2 != this.tree || e23.viewportChanged || r2) && (this.tree = t2, this.decorations = this.buildDeco(e23.view, n2));
  } }, { key: "buildDeco", value: function(e23, t2) {
    var n2 = this;
    if (!t2 || !this.tree.length)
      return Y$.none;
    var r2, i2 = new x_(), o2 = bi(e23.visibleRanges);
    try {
      for (o2.s(); !(r2 = o2.n()).done; ) {
        var a2 = r2.value, s2 = a2.from, u2 = a2.to;
        kN(this.tree, t2, function(e24, t3, r3) {
          i2.add(e24, t3, n2.markCache[r3] || (n2.markCache[r3] = Y$.mark({ class: r3 })));
        }, s2, u2);
      }
    } catch (e24) {
      o2.e(e24);
    } finally {
      o2.f();
    }
    return i2.finish();
  } }]), e22;
}(), LT = LC.high(wO.fromClass(zT, { decorations: function(e22) {
  return e22.decorations;
} })), BT = NT.define([{ tag: zN.meta, color: "#7a757a" }, { tag: zN.link, textDecoration: "underline" }, { tag: zN.heading, textDecoration: "underline", fontWeight: "bold" }, { tag: zN.emphasis, fontStyle: "italic" }, { tag: zN.strong, fontWeight: "bold" }, { tag: zN.strikethrough, textDecoration: "line-through" }, { tag: zN.keyword, color: "#708" }, { tag: [zN.atom, zN.bool, zN.url, zN.contentSeparator, zN.labelName], color: "#219" }, { tag: [zN.literal, zN.inserted], color: "#164" }, { tag: [zN.string, zN.deleted], color: "#a11" }, { tag: [zN.regexp, zN.escape, zN.special(zN.string)], color: "#e40" }, { tag: zN.definition(zN.variableName), color: "#00f" }, { tag: zN.local(zN.variableName), color: "#30a" }, { tag: [zN.typeName, zN.namespace], color: "#085" }, { tag: zN.className, color: "#167" }, { tag: [zN.special(zN.variableName), zN.macroName], color: "#256" }, { tag: zN.definition(zN.propertyName), color: "#00c" }, { tag: zN.comment, color: "#940" }, { tag: zN.invalid, color: "#f00" }]), qT = MM.baseTheme({ "&.cm-focused .cm-matchingBracket": { backgroundColor: "#328c8252" }, "&.cm-focused .cm-nonmatchingBracket": { backgroundColor: "#bb555544" } }), FT = $C.define({ combine: function(e22) {
  return p_(e22, { afterCursor: true, brackets: "()[]{}", maxScanDistance: 1e4, renderMatch: WT });
} }), VT = Y$.mark({ class: "cm-matchingBracket" }), HT = Y$.mark({ class: "cm-nonmatchingBracket" });
function WT(e22) {
  var t2 = [], n2 = e22.matched ? VT : HT;
  return t2.push(n2.range(e22.start.from, e22.start.to)), e22.end && t2.push(n2.range(e22.end.from, e22.end.to)), t2;
}
var JT = [NC.define({ create: function() {
  return Y$.none;
}, update: function(e22, t2) {
  if (!t2.docChanged && !t2.selection)
    return e22;
  var n2, r2 = [], i2 = t2.state.facet(FT), o2 = bi(t2.state.selection.ranges);
  try {
    for (o2.s(); !(n2 = o2.n()).done; ) {
      var a2 = n2.value;
      if (a2.empty) {
        var s2 = GT(t2.state, a2.head, -1, i2) || a2.head > 0 && GT(t2.state, a2.head - 1, 1, i2) || i2.afterCursor && (GT(t2.state, a2.head, 1, i2) || a2.head < t2.state.doc.length && GT(t2.state, a2.head + 1, -1, i2));
        s2 && (r2 = r2.concat(i2.renderMatch(s2, t2.state)));
      }
    }
  } catch (e23) {
    o2.e(e23);
  } finally {
    o2.f();
  }
  return Y$.set(r2, true);
}, provide: function(e22) {
  return MM.decorations.from(e22);
} }), qT];
function UT() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return [FT.of(e22), JT];
}
function KT(e22, t2, n2) {
  var r2 = e22.prop(t2 < 0 ? vP.openedBy : vP.closedBy);
  if (r2)
    return r2;
  if (e22.name.length == 1) {
    var i2 = n2.indexOf(e22.name);
    if (i2 > -1 && i2 % 2 == (t2 < 0 ? 1 : 0))
      return [n2[i2 + t2]];
  }
  return null;
}
function GT(e22, t2, n2) {
  for (var r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : {}, i2 = r2.maxScanDistance || 1e4, o2 = r2.brackets || "()[]{}", a2 = VN(e22), s2 = a2.resolveInner(t2, n2), u2 = s2; u2; u2 = u2.parent) {
    var c2 = KT(u2.type, n2, o2);
    if (c2 && u2.from < u2.to)
      return QT(e22, t2, n2, u2, c2, o2);
  }
  return YT(e22, t2, n2, a2, s2.type, i2, o2);
}
function QT(e22, t2, n2, r2, i2, o2) {
  var a2 = r2.parent, s2 = { from: r2.from, to: r2.to }, u2 = 0, c2 = a2 == null ? void 0 : a2.cursor();
  if (c2 && (n2 < 0 ? c2.childBefore(r2.from) : c2.childAfter(r2.to)))
    do {
      if (n2 < 0 ? c2.to <= r2.from : c2.from >= r2.to) {
        if (u2 == 0 && i2.indexOf(c2.type.name) > -1 && c2.from < c2.to)
          return { start: s2, end: { from: c2.from, to: c2.to }, matched: true };
        if (KT(c2.type, n2, o2))
          u2++;
        else if (KT(c2.type, -n2, o2) && --u2 == 0)
          return { start: s2, end: c2.from == c2.to ? void 0 : { from: c2.from, to: c2.to }, matched: false };
      }
    } while (n2 < 0 ? c2.prevSibling() : c2.nextSibling());
  return { start: s2, matched: false };
}
function YT(e22, t2, n2, r2, i2, o2, a2) {
  var s2 = n2 < 0 ? e22.sliceDoc(t2 - 1, t2) : e22.sliceDoc(t2, t2 + 1), u2 = a2.indexOf(s2);
  if (u2 < 0 || u2 % 2 == 0 != n2 > 0)
    return null;
  for (var c2 = { from: n2 < 0 ? t2 - 1 : t2, to: n2 > 0 ? t2 + 1 : t2 }, l2 = e22.doc.iterRange(t2, n2 > 0 ? e22.doc.length : 0), f2 = 0, h2 = 0; !l2.next().done && h2 <= o2; ) {
    var d2 = l2.value;
    n2 < 0 && (h2 += d2.length);
    for (var v2 = t2 + h2 * n2, p2 = n2 > 0 ? 0 : d2.length - 1, m2 = n2 > 0 ? d2.length : -1; p2 != m2; p2 += n2) {
      var g2 = a2.indexOf(d2[p2]);
      if (!(g2 < 0 || r2.resolveInner(v2 + p2, 1).type != i2))
        if (g2 % 2 == 0 == n2 > 0)
          f2++;
        else {
          if (f2 == 1)
            return { start: c2, end: { from: v2 + p2, to: v2 + p2 + 1 }, matched: g2 >> 1 == u2 >> 1 };
          f2--;
        }
    }
    n2 > 0 && (h2 += d2.length);
  }
  return l2.done ? { start: c2, matched: false } : null;
}
for (var ZT = /* @__PURE__ */ Object.create(null), XT = [mP.none], eI = [], tI = /* @__PURE__ */ Object.create(null), nI = 0, rI = [["variable", "variableName"], ["variable-2", "variableName.special"], ["string-2", "string.special"], ["def", "variableName.definition"], ["tag", "tagName"], ["attribute", "attributeName"], ["type", "typeName"], ["builtin", "variableName.standard"], ["qualifier", "modifier"], ["error", "invalid"], ["header", "heading"], ["property", "propertyName"]]; nI < rI.length; nI++) {
  var iI = xi(rI[nI], 2), oI = iI[0], aI = iI[1];
  tI[oI] = uI(ZT, aI);
}
function sI(e22, t2) {
  eI.indexOf(e22) > -1 || (eI.push(e22), console.warn(t2));
}
function uI(e22, t2) {
  var n2, r2 = null, i2 = bi(t2.split("."));
  try {
    for (i2.s(); !(n2 = i2.n()).done; ) {
      var o2 = n2.value, a2 = e22[o2] || zN[o2];
      a2 ? typeof a2 == "function" ? r2 ? r2 = a2(r2) : sI(o2, "Modifier ".concat(o2, " used at start of tag")) : r2 ? sI(o2, "Tag ".concat(o2, " used as modifier")) : r2 = a2 : sI(o2, "Unknown highlighting tag ".concat(o2));
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  if (!r2)
    return 0;
  var s2 = t2.replace(/ /g, "_"), u2 = mP.define({ id: XT.length, name: s2, props: [pN(Pi({}, s2, r2))] });
  return XT.push(u2), u2.id;
}
var cI = 0, lI = function() {
  function e22() {
    var t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    Ri(this, e22), this.id = cI++, this.perNode = !!t2.perNode, this.deserialize = t2.deserialize || function() {
      throw new Error("This node type doesn't define a deserialize function");
    };
  }
  return zi(e22, [{ key: "add", value: function(e23) {
    var t2 = this;
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e23 != "function" && (e23 = hI.match(e23)), function(n2) {
      var r2 = e23(n2);
      return r2 === void 0 ? null : [t2, r2];
    };
  } }]), e22;
}();
lI.closedBy = new lI({ deserialize: function(e22) {
  return e22.split(" ");
} }), lI.openedBy = new lI({ deserialize: function(e22) {
  return e22.split(" ");
} }), lI.group = new lI({ deserialize: function(e22) {
  return e22.split(" ");
} }), lI.contextHash = new lI({ perNode: true }), lI.lookAhead = new lI({ perNode: true }), lI.mounted = new lI({ perNode: true });
var fI = /* @__PURE__ */ Object.create(null), hI = function() {
  function e22(t2, n2, r2) {
    var i2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0;
    Ri(this, e22), this.name = t2, this.props = n2, this.id = r2, this.flags = i2;
  }
  return zi(e22, [{ key: "prop", value: function(e23) {
    return this.props[e23.id];
  } }, { key: "isTop", get: function() {
    return (1 & this.flags) > 0;
  } }, { key: "isSkipped", get: function() {
    return (2 & this.flags) > 0;
  } }, { key: "isError", get: function() {
    return (4 & this.flags) > 0;
  } }, { key: "isAnonymous", get: function() {
    return (8 & this.flags) > 0;
  } }, { key: "is", value: function(e23) {
    if (typeof e23 == "string") {
      if (this.name == e23)
        return true;
      var t2 = this.prop(lI.group);
      return !!t2 && t2.indexOf(e23) > -1;
    }
    return this.id == e23;
  } }], [{ key: "define", value: function(t2) {
    var n2 = t2.props && t2.props.length ? /* @__PURE__ */ Object.create(null) : fI, r2 = (t2.top ? 1 : 0) | (t2.skipped ? 2 : 0) | (t2.error ? 4 : 0) | (t2.name == null ? 8 : 0), i2 = new e22(t2.name || "", n2, t2.id, r2);
    if (t2.props) {
      var o2, a2 = bi(t2.props);
      try {
        for (a2.s(); !(o2 = a2.n()).done; ) {
          var s2 = o2.value;
          if (Array.isArray(s2) || (s2 = s2(i2)), s2) {
            if (s2[0].perNode)
              throw new RangeError("Can't store a per-node prop on a node type");
            n2[s2[0].id] = s2[1];
          }
        }
      } catch (e23) {
        a2.e(e23);
      } finally {
        a2.f();
      }
    }
    return i2;
  } }, { key: "match", value: function(e23) {
    var t2 = /* @__PURE__ */ Object.create(null);
    for (var n2 in e23) {
      var r2, i2 = bi(n2.split(" "));
      try {
        for (i2.s(); !(r2 = i2.n()).done; ) {
          var o2 = r2.value;
          t2[o2] = e23[n2];
        }
      } catch (e24) {
        i2.e(e24);
      } finally {
        i2.f();
      }
    }
    return function(e24) {
      for (var n3 = e24.prop(lI.group), r3 = -1; r3 < (n3 ? n3.length : 0); r3++) {
        var i3 = t2[r3 < 0 ? e24.name : n3[r3]];
        if (i3)
          return i3;
      }
    };
  } }]), e22;
}();
hI.none = new hI("", /* @__PURE__ */ Object.create(null), 0, 8);
var dI, vI = /* @__PURE__ */ new WeakMap(), pI = /* @__PURE__ */ new WeakMap();
!function(e22) {
  e22[e22.ExcludeBuffers = 1] = "ExcludeBuffers", e22[e22.IncludeAnonymous = 2] = "IncludeAnonymous", e22[e22.IgnoreMounts = 4] = "IgnoreMounts", e22[e22.IgnoreOverlays = 8] = "IgnoreOverlays";
}(dI || (dI = {}));
var mI = function() {
  function e22(t2, n2, r2, i2, o2) {
    if (Ri(this, e22), this.type = t2, this.children = n2, this.positions = r2, this.length = i2, this.props = null, o2 && o2.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      var a2, s2 = bi(o2);
      try {
        for (s2.s(); !(a2 = s2.n()).done; ) {
          var u2 = xi(a2.value, 2), c2 = u2[0], l2 = u2[1];
          this.props[typeof c2 == "number" ? c2 : c2.id] = l2;
        }
      } catch (e23) {
        s2.e(e23);
      } finally {
        s2.f();
      }
    }
  }
  return zi(e22, [{ key: "toString", value: function() {
    var e23 = this.prop(lI.mounted);
    if (e23 && !e23.overlay)
      return e23.tree.toString();
    var t2, n2 = "", r2 = bi(this.children);
    try {
      for (r2.s(); !(t2 = r2.n()).done; ) {
        var i2 = t2.value.toString();
        i2 && (n2 && (n2 += ","), n2 += i2);
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (n2.length ? "(" + n2 + ")" : "") : n2;
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new $I(this.topNode, e23);
  } }, { key: "cursorAt", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = vI.get(this) || this.topNode, r2 = new $I(n2);
    return r2.moveTo(e23, t2), vI.set(this, r2._tree), r2;
  } }, { key: "topNode", get: function() {
    return new xI(this, 0, 0, null);
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = wI(vI.get(this) || this.topNode, e23, t2, false);
    return vI.set(this, n2), n2;
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = wI(pI.get(this) || this.topNode, e23, t2, true);
    return pI.set(this, n2), n2;
  } }, { key: "iterate", value: function(e23) {
    for (var t2 = e23.enter, n2 = e23.leave, r2 = e23.from, i2 = r2 === void 0 ? 0 : r2, o2 = e23.to, a2 = o2 === void 0 ? this.length : o2, s2 = this.cursor((e23.mode || 0) | dI.IncludeAnonymous); ; ) {
      var u2 = false;
      if (s2.from <= a2 && s2.to >= i2 && (s2.type.isAnonymous || t2(s2) !== false)) {
        if (s2.firstChild())
          continue;
        u2 = true;
      }
      for (; u2 && n2 && !s2.type.isAnonymous && n2(s2), !s2.nextSibling(); ) {
        if (!s2.parent())
          return;
        u2 = true;
      }
    }
  } }, { key: "prop", value: function(e23) {
    return e23.perNode ? this.props ? this.props[e23.id] : void 0 : this.type.prop(e23);
  } }, { key: "propValues", get: function() {
    var e23 = [];
    if (this.props)
      for (var t2 in this.props)
        e23.push([+t2, this.props[t2]]);
    return e23;
  } }, { key: "balance", value: function() {
    var t2 = this, n2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return this.children.length <= 8 ? this : PI(hI.none, this.children, this.positions, 0, this.children.length, 0, this.length, function(n3, r2, i2) {
      return new e22(t2.type, n3, r2, i2, t2.propValues);
    }, n2.makeTree || function(t3, n3, r2) {
      return new e22(hI.none, t3, n3, r2);
    });
  } }], [{ key: "build", value: function(e23) {
    return AI(e23);
  } }]), e22;
}();
mI.empty = new mI(hI.none, [], [], 0);
var gI = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.buffer = t2, this.index = n2;
  }
  return zi(e22, [{ key: "id", get: function() {
    return this.buffer[this.index - 4];
  } }, { key: "start", get: function() {
    return this.buffer[this.index - 3];
  } }, { key: "end", get: function() {
    return this.buffer[this.index - 2];
  } }, { key: "size", get: function() {
    return this.buffer[this.index - 1];
  } }, { key: "pos", get: function() {
    return this.index;
  } }, { key: "next", value: function() {
    this.index -= 4;
  } }, { key: "fork", value: function() {
    return new e22(this.buffer, this.index);
  } }]), e22;
}(), yI = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.buffer = t2, this.length = n2, this.set = r2;
  }
  return zi(e22, [{ key: "type", get: function() {
    return hI.none;
  } }, { key: "toString", value: function() {
    for (var e23 = [], t2 = 0; t2 < this.buffer.length; )
      e23.push(this.childString(t2)), t2 = this.buffer[t2 + 3];
    return e23.join(",");
  } }, { key: "childString", value: function(e23) {
    var t2 = this.buffer[e23], n2 = this.buffer[e23 + 3], r2 = this.set.types[t2], i2 = r2.name;
    if (/\W/.test(i2) && !r2.isError && (i2 = JSON.stringify(i2)), n2 == (e23 += 4))
      return i2;
    for (var o2 = []; e23 < n2; )
      o2.push(this.childString(e23)), e23 = this.buffer[e23 + 3];
    return i2 + "(" + o2.join(",") + ")";
  } }, { key: "findChild", value: function(e23, t2, n2, r2, i2) {
    for (var o2 = this.buffer, a2 = -1, s2 = e23; s2 != t2 && !(bI(i2, r2, o2[s2 + 1], o2[s2 + 2]) && (a2 = s2, n2 > 0)); s2 = o2[s2 + 3])
      ;
    return a2;
  } }, { key: "slice", value: function(t2, n2, r2, i2) {
    for (var o2 = this.buffer, a2 = new Uint16Array(n2 - t2), s2 = t2, u2 = 0; s2 < n2; )
      a2[u2++] = o2[s2++], a2[u2++] = o2[s2++] - r2, a2[u2++] = o2[s2++] - r2, a2[u2++] = o2[s2++] - t2;
    return new e22(a2, i2 - r2, this.set);
  } }]), e22;
}();
function bI(e22, t2, n2, r2) {
  switch (e22) {
    case -2:
      return n2 < t2;
    case -1:
      return r2 >= t2 && n2 < t2;
    case 0:
      return n2 < t2 && r2 > t2;
    case 1:
      return n2 <= t2 && r2 > t2;
    case 2:
      return r2 > t2;
    case 4:
      return true;
  }
}
function kI(e22, t2) {
  for (var n2 = e22.childBefore(t2); n2; ) {
    var r2 = n2.lastChild;
    if (!r2 || r2.to != n2.to)
      break;
    r2.type.isError && r2.from == r2.to ? (e22 = n2, n2 = r2.prevSibling) : n2 = r2;
  }
  return e22;
}
function wI(e22, t2, n2, r2) {
  for (var i2; e22.from == e22.to || (n2 < 1 ? e22.from >= t2 : e22.from > t2) || (n2 > -1 ? e22.to <= t2 : e22.to < t2); ) {
    var o2 = !r2 && e22 instanceof xI && e22.index < 0 ? null : e22.parent;
    if (!o2)
      return e22;
    e22 = o2;
  }
  var a2 = r2 ? 0 : dI.IgnoreOverlays;
  if (r2)
    for (var s2 = e22, u2 = s2.parent; u2; u2 = (s2 = u2).parent)
      s2 instanceof xI && s2.index < 0 && ((i2 = u2.enter(t2, n2, a2)) === null || i2 === void 0 ? void 0 : i2.from) != s2.from && (e22 = u2);
  for (; ; ) {
    var c2 = e22.enter(t2, n2, a2);
    if (!c2)
      return e22;
    e22 = c2;
  }
}
var xI = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this._tree = t2, this.from = n2, this.index = r2, this._parent = i2;
  }
  return zi(e22, [{ key: "type", get: function() {
    return this._tree.type;
  } }, { key: "name", get: function() {
    return this._tree.type.name;
  } }, { key: "to", get: function() {
    return this.from + this._tree.length;
  } }, { key: "nextChild", value: function(t2, n2, r2, i2) {
    for (var o2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0, a2 = this; ; ) {
      for (var s2 = a2._tree, u2 = s2.children, c2 = s2.positions, l2 = n2 > 0 ? u2.length : -1; t2 != l2; t2 += n2) {
        var f2 = u2[t2], h2 = c2[t2] + a2.from;
        if (bI(i2, r2, h2, h2 + f2.length)) {
          if (f2 instanceof yI) {
            if (o2 & dI.ExcludeBuffers)
              continue;
            var d2 = f2.findChild(0, f2.buffer.length, n2, r2 - h2, i2);
            if (d2 > -1)
              return new _I(new CI(a2, f2, t2, h2), null, d2);
          } else if (o2 & dI.IncludeAnonymous || !f2.type.isAnonymous || OI(f2)) {
            var v2 = void 0;
            if (!(o2 & dI.IgnoreMounts) && f2.props && (v2 = f2.prop(lI.mounted)) && !v2.overlay)
              return new e22(v2.tree, h2, t2, a2);
            var p2 = new e22(f2, h2, t2, a2);
            return o2 & dI.IncludeAnonymous || !p2.type.isAnonymous ? p2 : p2.nextChild(n2 < 0 ? f2.children.length - 1 : 0, n2, r2, i2);
          }
        }
      }
      if (o2 & dI.IncludeAnonymous || !a2.type.isAnonymous)
        return null;
      if (t2 = a2.index >= 0 ? a2.index + n2 : n2 < 0 ? -1 : a2._parent._tree.children.length, !(a2 = a2._parent))
        return null;
    }
  } }, { key: "firstChild", get: function() {
    return this.nextChild(0, 1, 0, 4);
  } }, { key: "lastChild", get: function() {
    return this.nextChild(this._tree.children.length - 1, -1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.nextChild(0, 1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.nextChild(this._tree.children.length - 1, -1, e23, -2);
  } }, { key: "enter", value: function(t2, n2) {
    var r2, i2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    if (!(i2 & dI.IgnoreOverlays) && (r2 = this._tree.prop(lI.mounted)) && r2.overlay) {
      var o2, a2 = t2 - this.from, s2 = bi(r2.overlay);
      try {
        for (s2.s(); !(o2 = s2.n()).done; ) {
          var u2 = o2.value, c2 = u2.from, l2 = u2.to;
          if ((n2 > 0 ? c2 <= a2 : c2 < a2) && (n2 < 0 ? l2 >= a2 : l2 > a2))
            return new e22(r2.tree, r2.overlay[0].from + this.from, -1, this);
        }
      } catch (e23) {
        s2.e(e23);
      } finally {
        s2.f();
      }
    }
    return this.nextChild(0, 1, t2, n2, i2);
  } }, { key: "nextSignificantParent", value: function() {
    for (var e23 = this; e23.type.isAnonymous && e23._parent; )
      e23 = e23._parent;
    return e23;
  } }, { key: "parent", get: function() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  } }, { key: "nextSibling", get: function() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(this.index + 1, 1, 0, 4) : null;
  } }, { key: "prevSibling", get: function() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(this.index - 1, -1, 0, 4) : null;
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new $I(this, e23);
  } }, { key: "tree", get: function() {
    return this._tree;
  } }, { key: "toTree", value: function() {
    return this._tree;
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return wI(this, e23, t2, false);
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return wI(this, e23, t2, true);
  } }, { key: "enterUnfinishedNodesBefore", value: function(e23) {
    return kI(this, e23);
  } }, { key: "getChild", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, r2 = jI(this, e23, t2, n2);
    return r2.length ? r2[0] : null;
  } }, { key: "getChildren", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return jI(this, e23, t2, n2);
  } }, { key: "toString", value: function() {
    return this._tree.toString();
  } }, { key: "node", get: function() {
    return this;
  } }, { key: "matchContext", value: function(e23) {
    return SI(this, e23);
  } }]), e22;
}();
function jI(e22, t2, n2, r2) {
  var i2 = e22.cursor(), o2 = [];
  if (!i2.firstChild())
    return o2;
  if (n2 != null) {
    for (; !i2.type.is(n2); )
      if (!i2.nextSibling())
        return o2;
  }
  for (; ; ) {
    if (r2 != null && i2.type.is(r2))
      return o2;
    if (i2.type.is(t2) && o2.push(i2.node), !i2.nextSibling())
      return r2 == null ? o2 : [];
  }
}
function SI(e22, t2) {
  for (var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : t2.length - 1, r2 = e22.parent; n2 >= 0; r2 = r2.parent) {
    if (!r2)
      return false;
    if (!r2.type.isAnonymous) {
      if (t2[n2] && t2[n2] != r2.name)
        return false;
      n2--;
    }
  }
  return true;
}
var CI = zi(function e10(t2, n2, r2, i2) {
  Ri(this, e10), this.parent = t2, this.buffer = n2, this.index = r2, this.start = i2;
}), _I = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.context = t2, this._parent = n2, this.index = r2, this.type = t2.buffer.set.types[t2.buffer.buffer[r2]];
  }
  return zi(e22, [{ key: "name", get: function() {
    return this.type.name;
  } }, { key: "from", get: function() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  } }, { key: "to", get: function() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  } }, { key: "child", value: function(t2, n2, r2) {
    var i2 = this.context.buffer, o2 = i2.findChild(this.index + 4, i2.buffer[this.index + 3], t2, n2 - this.context.start, r2);
    return o2 < 0 ? null : new e22(this.context, this, o2);
  } }, { key: "firstChild", get: function() {
    return this.child(1, 0, 4);
  } }, { key: "lastChild", get: function() {
    return this.child(-1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.child(1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.child(-1, e23, -2);
  } }, { key: "enter", value: function(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    if (r2 & dI.ExcludeBuffers)
      return null;
    var i2 = this.context.buffer, o2 = i2.findChild(this.index + 4, i2.buffer[this.index + 3], n2 > 0 ? 1 : -1, t2 - this.context.start, n2);
    return o2 < 0 ? null : new e22(this.context, this, o2);
  } }, { key: "parent", get: function() {
    return this._parent || this.context.parent.nextSignificantParent();
  } }, { key: "externalSibling", value: function(e23) {
    return this._parent ? null : this.context.parent.nextChild(this.context.index + e23, e23, 0, 4);
  } }, { key: "nextSibling", get: function() {
    var t2 = this.context.buffer, n2 = t2.buffer[this.index + 3];
    return n2 < (this._parent ? t2.buffer[this._parent.index + 3] : t2.buffer.length) ? new e22(this.context, this._parent, n2) : this.externalSibling(1);
  } }, { key: "prevSibling", get: function() {
    var t2 = this.context.buffer, n2 = this._parent ? this._parent.index + 4 : 0;
    return this.index == n2 ? this.externalSibling(-1) : new e22(this.context, this._parent, t2.findChild(n2, this.index, -1, 0, 4));
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new $I(this, e23);
  } }, { key: "tree", get: function() {
    return null;
  } }, { key: "toTree", value: function() {
    var e23 = [], t2 = [], n2 = this.context.buffer, r2 = this.index + 4, i2 = n2.buffer[this.index + 3];
    if (i2 > r2) {
      var o2 = n2.buffer[this.index + 1], a2 = n2.buffer[this.index + 2];
      e23.push(n2.slice(r2, i2, o2, a2)), t2.push(0);
    }
    return new mI(this.type, e23, t2, this.to - this.from);
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return wI(this, e23, t2, false);
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return wI(this, e23, t2, true);
  } }, { key: "enterUnfinishedNodesBefore", value: function(e23) {
    return kI(this, e23);
  } }, { key: "toString", value: function() {
    return this.context.buffer.childString(this.index);
  } }, { key: "getChild", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, r2 = jI(this, e23, t2, n2);
    return r2.length ? r2[0] : null;
  } }, { key: "getChildren", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return jI(this, e23, t2, n2);
  } }, { key: "node", get: function() {
    return this;
  } }, { key: "matchContext", value: function(e23) {
    return SI(this, e23);
  } }]), e22;
}(), $I = function() {
  function e22(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    if (Ri(this, e22), this.mode = n2, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, t2 instanceof xI)
      this.yieldNode(t2);
    else {
      this._tree = t2.context.parent, this.buffer = t2.context;
      for (var r2 = t2._parent; r2; r2 = r2._parent)
        this.stack.unshift(r2.index);
      this.bufferNode = t2, this.yieldBuf(t2.index);
    }
  }
  return zi(e22, [{ key: "name", get: function() {
    return this.type.name;
  } }, { key: "yieldNode", value: function(e23) {
    return !!e23 && (this._tree = e23, this.type = e23.type, this.from = e23.from, this.to = e23.to, true);
  } }, { key: "yieldBuf", value: function(e23, t2) {
    this.index = e23;
    var n2 = this.buffer, r2 = n2.start, i2 = n2.buffer;
    return this.type = t2 || i2.set.types[i2.buffer[e23]], this.from = r2 + i2.buffer[e23 + 1], this.to = r2 + i2.buffer[e23 + 2], true;
  } }, { key: "yield", value: function(e23) {
    return !!e23 && (e23 instanceof xI ? (this.buffer = null, this.yieldNode(e23)) : (this.buffer = e23.context, this.yieldBuf(e23.index, e23.type)));
  } }, { key: "toString", value: function() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  } }, { key: "enterChild", value: function(e23, t2, n2) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e23 < 0 ? this._tree._tree.children.length - 1 : 0, e23, t2, n2, this.mode));
    var r2 = this.buffer.buffer, i2 = r2.findChild(this.index + 4, r2.buffer[this.index + 3], e23, t2 - this.buffer.start, n2);
    return !(i2 < 0) && (this.stack.push(this.index), this.yieldBuf(i2));
  } }, { key: "firstChild", value: function() {
    return this.enterChild(1, 0, 4);
  } }, { key: "lastChild", value: function() {
    return this.enterChild(-1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.enterChild(1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.enterChild(-1, e23, -2);
  } }, { key: "enter", value: function(e23, t2) {
    var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : this.mode;
    return this.buffer ? !(n2 & dI.ExcludeBuffers) && this.enterChild(1, e23, t2) : this.yield(this._tree.enter(e23, t2, n2));
  } }, { key: "parent", value: function() {
    if (!this.buffer)
      return this.yieldNode(this.mode & dI.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    var e23 = this.mode & dI.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e23);
  } }, { key: "sibling", value: function(e23) {
    if (!this.buffer)
      return !!this._tree._parent && this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e23, e23, 0, 4, this.mode));
    var t2 = this.buffer.buffer, n2 = this.stack.length - 1;
    if (e23 < 0) {
      var r2 = n2 < 0 ? 0 : this.stack[n2] + 4;
      if (this.index != r2)
        return this.yieldBuf(t2.findChild(r2, this.index, -1, 0, 4));
    } else {
      var i2 = t2.buffer[this.index + 3];
      if (i2 < (n2 < 0 ? t2.buffer.length : t2.buffer[this.stack[n2] + 3]))
        return this.yieldBuf(i2);
    }
    return n2 < 0 && this.yield(this.buffer.parent.nextChild(this.buffer.index + e23, e23, 0, 4, this.mode));
  } }, { key: "nextSibling", value: function() {
    return this.sibling(1);
  } }, { key: "prevSibling", value: function() {
    return this.sibling(-1);
  } }, { key: "atLastNode", value: function(e23) {
    var t2, n2, r2 = this.buffer;
    if (r2) {
      if (e23 > 0) {
        if (this.index < r2.buffer.buffer.length)
          return false;
      } else
        for (var i2 = 0; i2 < this.index; i2++)
          if (r2.buffer.buffer[i2 + 3] < this.index)
            return false;
      t2 = r2.index, n2 = r2.parent;
    } else {
      var o2 = this._tree;
      t2 = o2.index, n2 = o2._parent;
    }
    for (; n2; t2 = (a2 = n2).index, n2 = a2._parent, a2) {
      var a2;
      if (t2 > -1)
        for (var s2 = t2 + e23, u2 = e23 < 0 ? -1 : n2._tree.children.length; s2 != u2; s2 += e23) {
          var c2 = n2._tree.children[s2];
          if (this.mode & dI.IncludeAnonymous || c2 instanceof yI || !c2.type.isAnonymous || OI(c2))
            return false;
        }
    }
    return true;
  } }, { key: "move", value: function(e23, t2) {
    if (t2 && this.enterChild(e23, 0, 4))
      return true;
    for (; ; ) {
      if (this.sibling(e23))
        return true;
      if (this.atLastNode(e23) || !this.parent())
        return false;
    }
  } }, { key: "next", value: function() {
    var e23 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    return this.move(1, e23);
  } }, { key: "prev", value: function() {
    var e23 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    return this.move(-1, e23);
  } }, { key: "moveTo", value: function(e23) {
    for (var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0; (this.from == this.to || (t2 < 1 ? this.from >= e23 : this.from > e23) || (t2 > -1 ? this.to <= e23 : this.to < e23)) && this.parent(); )
      ;
    for (; this.enterChild(1, e23, t2); )
      ;
    return this;
  } }, { key: "node", get: function() {
    if (!this.buffer)
      return this._tree;
    var e23 = this.bufferNode, t2 = null, n2 = 0;
    if (e23 && e23.context == this.buffer)
      e:
        for (var r2 = this.index, i2 = this.stack.length; i2 >= 0; ) {
          for (var o2 = e23; o2; o2 = o2._parent)
            if (o2.index == r2) {
              if (r2 == this.index)
                return o2;
              t2 = o2, n2 = i2 + 1;
              break e;
            }
          r2 = this.stack[--i2];
        }
    for (var a2 = n2; a2 < this.stack.length; a2++)
      t2 = new _I(this.buffer, t2, this.stack[a2]);
    return this.bufferNode = new _I(this.buffer, t2, this.index);
  } }, { key: "tree", get: function() {
    return this.buffer ? null : this._tree._tree;
  } }, { key: "iterate", value: function(e23, t2) {
    for (var n2 = 0; ; ) {
      var r2 = false;
      if (this.type.isAnonymous || e23(this) !== false) {
        if (this.firstChild()) {
          n2++;
          continue;
        }
        this.type.isAnonymous || (r2 = true);
      }
      for (; r2 && t2 && t2(this), r2 = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!n2)
          return;
        this.parent(), n2--, r2 = true;
      }
    }
  } }, { key: "matchContext", value: function(e23) {
    if (!this.buffer)
      return SI(this.node, e23);
    for (var t2 = this.buffer.buffer, n2 = t2.set.types, r2 = e23.length - 1, i2 = this.stack.length - 1; r2 >= 0; i2--) {
      if (i2 < 0)
        return SI(this.node, e23, r2);
      var o2 = n2[t2.buffer[this.stack[i2]]];
      if (!o2.isAnonymous) {
        if (e23[r2] && e23[r2] != o2.name)
          return false;
        r2--;
      }
    }
    return true;
  } }]), e22;
}();
function OI(e22) {
  return e22.children.some(function(e23) {
    return e23 instanceof yI || !e23.type.isAnonymous || OI(e23);
  });
}
function AI(e22) {
  var t2, n2 = e22.buffer, r2 = e22.nodeSet, i2 = e22.maxBufferLength, o2 = i2 === void 0 ? 1024 : i2, a2 = e22.reused, s2 = a2 === void 0 ? [] : a2, u2 = e22.minRepeatType, c2 = u2 === void 0 ? r2.types.length : u2, l2 = Array.isArray(n2) ? new gI(n2, n2.length) : n2, f2 = r2.types, h2 = 0, d2 = 0;
  function v2(e23, t3, n3, i3, a3) {
    for (var u3 = l2.id, y3 = l2.start, b3 = l2.end, k3 = l2.size, w2 = d2; k3 < 0; ) {
      if (l2.next(), k3 == -1) {
        var x2 = s2[u3];
        return n3.push(x2), void i3.push(y3 - e23);
      }
      if (k3 == -3)
        return void (h2 = u3);
      if (k3 == -4)
        return void (d2 = u3);
      throw new RangeError("Unrecognized record size: ".concat(k3));
    }
    var j2, S2, C2 = f2[u3], _2 = y3 - e23;
    if (b3 - y3 <= o2 && (S2 = function(e24, t4) {
      var n4 = l2.fork(), r3 = 0, i4 = 0, a4 = 0, s3 = n4.end - o2, u4 = { size: 0, start: 0, skip: 0 };
      e:
        for (var f3 = n4.pos - e24; n4.pos > f3; ) {
          var h3 = n4.size;
          if (n4.id == t4 && h3 >= 0)
            u4.size = r3, u4.start = i4, u4.skip = a4, a4 += 4, r3 += 4, n4.next();
          else {
            var d3 = n4.pos - h3;
            if (h3 < 0 || d3 < f3 || n4.start < s3)
              break;
            var v3 = n4.id >= c2 ? 4 : 0, p3 = n4.start;
            for (n4.next(); n4.pos > d3; ) {
              if (n4.size < 0) {
                if (n4.size != -3)
                  break e;
                v3 += 4;
              } else
                n4.id >= c2 && (v3 += 4);
              n4.next();
            }
            i4 = p3, r3 += h3, a4 += v3;
          }
        }
      (t4 < 0 || r3 == e24) && (u4.size = r3, u4.start = i4, u4.skip = a4);
      return u4.size > 4 ? u4 : void 0;
    }(l2.pos - t3, a3))) {
      for (var $2 = new Uint16Array(S2.size - S2.skip), O2 = l2.pos - S2.size, A2 = $2.length; l2.pos > O2; )
        A2 = g2(S2.start, $2, A2);
      j2 = new yI($2, b3 - S2.start, r2), _2 = S2.start - e23;
    } else {
      var M2 = l2.pos - k3;
      l2.next();
      for (var E2 = [], P2 = [], N2 = u3 >= c2 ? u3 : -1, T2 = 0, I2 = b3; l2.pos > M2; )
        N2 >= 0 && l2.id == N2 && l2.size >= 0 ? (l2.end <= I2 - o2 && (p2(E2, P2, y3, T2, l2.end, I2, N2, w2), T2 = E2.length, I2 = l2.end), l2.next()) : v2(y3, M2, E2, P2, N2);
      if (N2 >= 0 && T2 > 0 && T2 < E2.length && p2(E2, P2, y3, T2, y3, I2, N2, w2), E2.reverse(), P2.reverse(), N2 > -1 && T2 > 0) {
        var R2 = function(e24) {
          return function(t4, n4, r3) {
            var i4, o3, a4 = 0, s3 = t4.length - 1;
            if (s3 >= 0 && (i4 = t4[s3]) instanceof mI) {
              if (!s3 && i4.type == e24 && i4.length == r3)
                return i4;
              (o3 = i4.prop(lI.lookAhead)) && (a4 = n4[s3] + i4.length + o3);
            }
            return m2(e24, t4, n4, r3, a4);
          };
        }(C2);
        j2 = PI(C2, E2, P2, 0, E2.length, 0, b3 - y3, R2, R2);
      } else
        j2 = m2(C2, E2, P2, b3 - y3, w2 - b3);
    }
    n3.push(j2), i3.push(_2);
  }
  function p2(e23, t3, n3, i3, o3, a3, s3, u3) {
    for (var c3 = [], l3 = []; e23.length > i3; )
      c3.push(e23.pop()), l3.push(t3.pop() + n3 - o3);
    e23.push(m2(r2.types[s3], c3, l3, a3 - o3, u3 - a3)), t3.push(o3 - n3);
  }
  function m2(e23, t3, n3, r3) {
    var i3 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0, o3 = arguments.length > 5 ? arguments[5] : void 0;
    if (h2) {
      var a3 = [lI.contextHash, h2];
      o3 = o3 ? [a3].concat(o3) : [a3];
    }
    if (i3 > 25) {
      var s3 = [lI.lookAhead, i3];
      o3 = o3 ? [s3].concat(o3) : [s3];
    }
    return new mI(e23, t3, n3, r3, o3);
  }
  function g2(e23, t3, n3) {
    var r3 = l2.id, i3 = l2.start, o3 = l2.end, a3 = l2.size;
    if (l2.next(), a3 >= 0 && r3 < c2) {
      var s3 = n3;
      if (a3 > 4)
        for (var u3 = l2.pos - (a3 - 4); l2.pos > u3; )
          n3 = g2(e23, t3, n3);
      t3[--n3] = s3, t3[--n3] = o3 - e23, t3[--n3] = i3 - e23, t3[--n3] = r3;
    } else
      a3 == -3 ? h2 = r3 : a3 == -4 && (d2 = r3);
    return n3;
  }
  for (var y2 = [], b2 = []; l2.pos > 0; )
    v2(e22.start || 0, e22.bufferStart || 0, y2, b2, -1);
  var k2 = (t2 = e22.length) !== null && t2 !== void 0 ? t2 : y2.length ? b2[0] + y2[0].length : 0;
  return new mI(f2[e22.topID], y2.reverse(), b2.reverse(), k2);
}
var MI = /* @__PURE__ */ new WeakMap();
function EI(e22, t2) {
  if (!e22.isAnonymous || t2 instanceof yI || t2.type != e22)
    return 1;
  var n2 = MI.get(t2);
  if (n2 == null) {
    n2 = 1;
    var r2, i2 = bi(t2.children);
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        var o2 = r2.value;
        if (o2.type != e22 || !(o2 instanceof mI)) {
          n2 = 1;
          break;
        }
        n2 += EI(e22, o2);
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
    MI.set(t2, n2);
  }
  return n2;
}
function PI(e22, t2, n2, r2, i2, o2, a2, s2, u2) {
  for (var c2 = 0, l2 = r2; l2 < i2; l2++)
    c2 += EI(e22, t2[l2]);
  var f2 = Math.ceil(1.5 * c2 / 8), h2 = [], d2 = [];
  return function t3(n3, r3, i3, a3, s3) {
    for (var c3 = i3; c3 < a3; ) {
      var l3 = c3, v2 = r3[c3], p2 = EI(e22, n3[c3]);
      for (c3++; c3 < a3; c3++) {
        var m2 = EI(e22, n3[c3]);
        if (p2 + m2 >= f2)
          break;
        p2 += m2;
      }
      if (c3 == l3 + 1) {
        if (p2 > f2) {
          var g2 = n3[l3];
          t3(g2.children, g2.positions, 0, g2.children.length, r3[l3] + s3);
          continue;
        }
        h2.push(n3[l3]);
      } else {
        var y2 = r3[c3 - 1] + n3[c3 - 1].length - v2;
        h2.push(PI(e22, n3, r3, l3, c3, v2, y2, null, u2));
      }
      d2.push(v2 + s3 - o2);
    }
  }(t2, n2, r2, i2, 0), (s2 || u2)(h2, d2, a2);
}
new lI({ perNode: true });
function NI(e22, t2) {
  return function(n2) {
    var r2 = n2.state, i2 = n2.dispatch;
    if (r2.readOnly)
      return false;
    var o2 = e22(t2, r2);
    return !!o2 && (i2(r2.update(o2)), true);
  };
}
var TI = NI(BI, 0), II = NI(LI, 0), RI = NI(function(e22, t2) {
  return LI(e22, t2, function(e23) {
    var t3, n2 = [], r2 = bi(e23.selection.ranges);
    try {
      for (r2.s(); !(t3 = r2.n()).done; ) {
        var i2 = t3.value, o2 = e23.doc.lineAt(i2.from), a2 = i2.to <= o2.to ? o2 : e23.doc.lineAt(i2.to), s2 = n2.length - 1;
        s2 >= 0 && n2[s2].to > o2.from ? n2[s2].to = a2.to : n2.push({ from: o2.from, to: a2.to });
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    return n2;
  }(t2));
}, 0);
function DI(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e22.selection.main.head, n2 = e22.languageDataAt("commentTokens", t2);
  return n2.length ? n2[0] : {};
}
function zI(e22, t2, n2, r2) {
  var i2, o2, a2 = t2.open, s2 = t2.close, u2 = e22.sliceDoc(n2 - 50, n2), c2 = e22.sliceDoc(r2, r2 + 50), l2 = /\s*$/.exec(u2)[0].length, f2 = /^\s*/.exec(c2)[0].length, h2 = u2.length - l2;
  if (u2.slice(h2 - a2.length, h2) == a2 && c2.slice(f2, f2 + s2.length) == s2)
    return { open: { pos: n2 - l2, margin: l2 && 1 }, close: { pos: r2 + f2, margin: f2 && 1 } };
  r2 - n2 <= 100 ? i2 = o2 = e22.sliceDoc(n2, r2) : (i2 = e22.sliceDoc(n2, n2 + 50), o2 = e22.sliceDoc(r2 - 50, r2));
  var d2 = /^\s*/.exec(i2)[0].length, v2 = /\s*$/.exec(o2)[0].length, p2 = o2.length - v2 - s2.length;
  return i2.slice(d2, d2 + a2.length) == a2 && o2.slice(p2, p2 + s2.length) == s2 ? { open: { pos: n2 + d2 + a2.length, margin: /\s/.test(i2.charAt(d2 + a2.length)) ? 1 : 0 }, close: { pos: r2 - v2 - s2.length, margin: /\s/.test(o2.charAt(p2 - 1)) ? 1 : 0 } } : null;
}
function LI(e22, t2) {
  var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : t2.selection.ranges, r2 = n2.map(function(e23) {
    return DI(t2, e23.from).block;
  });
  if (!r2.every(function(e23) {
    return e23;
  }))
    return null;
  var i2 = n2.map(function(e23, n3) {
    return zI(t2, r2[n3], e23.from, e23.to);
  });
  if (e22 != 2 && !i2.every(function(e23) {
    return e23;
  }))
    return { changes: t2.changes(n2.map(function(e23, t3) {
      return i2[t3] ? [] : [{ from: e23.from, insert: r2[t3].open + " " }, { from: e23.to, insert: " " + r2[t3].close }];
    })) };
  if (e22 != 1 && i2.some(function(e23) {
    return e23;
  })) {
    for (var o2, a2 = [], s2 = 0; s2 < i2.length; s2++)
      if (o2 = i2[s2]) {
        var u2 = r2[s2], c2 = o2, l2 = c2.open, f2 = c2.close;
        a2.push({ from: l2.pos - u2.open.length, to: l2.pos + l2.margin }, { from: f2.pos - f2.margin, to: f2.pos + u2.close.length });
      }
    return { changes: a2 };
  }
  return null;
}
function BI(e22, t2) {
  var n2, r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : t2.selection.ranges, i2 = [], o2 = -1, a2 = bi(r2);
  try {
    for (a2.s(); !(n2 = a2.n()).done; ) {
      for (var s2 = n2.value, u2 = s2.from, c2 = s2.to, l2 = i2.length, f2 = 1e9, h2 = u2; h2 <= c2; ) {
        var d2 = t2.doc.lineAt(h2);
        if (d2.from > o2 && (u2 == c2 || c2 > d2.from)) {
          o2 = d2.from;
          var v2 = DI(t2, h2).line;
          if (!v2)
            continue;
          var p2 = /^\s*/.exec(d2.text)[0].length, m2 = p2 == d2.length, g2 = d2.text.slice(p2, p2 + v2.length) == v2 ? p2 : -1;
          p2 < d2.text.length && p2 < f2 && (f2 = p2), i2.push({ line: d2, comment: g2, token: v2, indent: p2, empty: m2, single: false });
        }
        h2 = d2.to + 1;
      }
      if (f2 < 1e9)
        for (var y2 = l2; y2 < i2.length; y2++)
          i2[y2].indent < i2[y2].line.text.length && (i2[y2].indent = f2);
      i2.length == l2 + 1 && (i2[l2].single = true);
    }
  } catch (e23) {
    a2.e(e23);
  } finally {
    a2.f();
  }
  if (e22 != 2 && i2.some(function(e23) {
    return e23.comment < 0 && (!e23.empty || e23.single);
  })) {
    var b2, k2 = [], w2 = bi(i2);
    try {
      for (w2.s(); !(b2 = w2.n()).done; ) {
        var x2 = b2.value, j2 = x2.line, S2 = x2.token, C2 = x2.indent, _2 = x2.empty, $2 = x2.single;
        !$2 && _2 || k2.push({ from: j2.from + C2, insert: S2 + " " });
      }
    } catch (e23) {
      w2.e(e23);
    } finally {
      w2.f();
    }
    var O2 = t2.changes(k2);
    return { changes: O2, selection: t2.selection.map(O2, 1) };
  }
  if (e22 != 1 && i2.some(function(e23) {
    return e23.comment >= 0;
  })) {
    var A2, M2 = [], E2 = bi(i2);
    try {
      for (E2.s(); !(A2 = E2.n()).done; ) {
        var P2 = A2.value, N2 = P2.line, T2 = P2.comment, I2 = P2.token;
        if (T2 >= 0) {
          var R2 = N2.from + T2, D2 = R2 + I2.length;
          N2.text[D2 - N2.from] == " " && D2++, M2.push({ from: R2, to: D2 });
        }
      }
    } catch (e23) {
      E2.e(e23);
    } finally {
      E2.f();
    }
    return { changes: M2 };
  }
  return null;
}
var qI = XC.define(), FI = XC.define(), VI = $C.define(), HI = $C.define({ combine: function(e22) {
  return p_(e22, { minDepth: 100, newGroupDelay: 500 }, { minDepth: Math.max, newGroupDelay: Math.min });
} });
var WI = NC.define({ create: function() {
  return lR.empty;
}, update: function(e22, t2) {
  var n2, r2, i2 = t2.state.facet(HI), o2 = t2.annotation(qI);
  if (o2) {
    var a2 = t2.docChanged ? SC.single((n2 = t2.changes, r2 = 0, n2.iterChangedRanges(function(e23, t3) {
      return r2 = t3;
    }), r2)) : void 0, s2 = tR.fromTransaction(t2, a2), u2 = o2.side, c2 = u2 == 0 ? e22.undone : e22.done;
    return c2 = s2 ? nR(c2, c2.length, i2.minDepth, s2) : oR(c2, t2.startState.selection), new lR(u2 == 0 ? o2.rest : c2, u2 == 0 ? c2 : o2.rest);
  }
  var l2 = t2.annotation(FI);
  if (l2 != "full" && l2 != "before" || (e22 = e22.isolate()), t2.annotation(r_.addToHistory) === false)
    return t2.changes.empty ? e22 : e22.addMapping(t2.changes.desc);
  var f2 = tR.fromTransaction(t2), h2 = t2.annotation(r_.time), d2 = t2.annotation(r_.userEvent);
  return f2 ? e22 = e22.addChanges(f2, h2, d2, i2.newGroupDelay, i2.minDepth) : t2.selection && (e22 = e22.addSelection(t2.startState.selection, h2, d2, i2.newGroupDelay)), l2 != "full" && l2 != "after" || (e22 = e22.isolate()), e22;
}, toJSON: function(e22) {
  return { done: e22.done.map(function(e23) {
    return e23.toJSON();
  }), undone: e22.undone.map(function(e23) {
    return e23.toJSON();
  }) };
}, fromJSON: function(e22) {
  return new lR(e22.done.map(tR.fromJSON), e22.undone.map(tR.fromJSON));
} });
function JI() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return [WI, HI.of(e22), MM.domEventHandlers({ beforeinput: function(e23, t2) {
    var n2 = e23.inputType == "historyUndo" ? KI : e23.inputType == "historyRedo" ? GI : null;
    return !!n2 && (e23.preventDefault(), n2(t2));
  } })];
}
function UI(e22, t2) {
  return function(n2) {
    var r2 = n2.state, i2 = n2.dispatch;
    if (!t2 && r2.readOnly)
      return false;
    var o2 = r2.field(WI, false);
    if (!o2)
      return false;
    var a2 = o2.pop(e22, r2, t2);
    return !!a2 && (i2(a2), true);
  };
}
var KI = UI(0, false), GI = UI(1, false), QI = UI(0, true), YI = UI(1, true);
function ZI(e22) {
  return function(t2) {
    var n2 = t2.field(WI, false);
    if (!n2)
      return 0;
    var r2 = e22 == 0 ? n2.done : n2.undone;
    return r2.length - (r2.length && !r2[0].changes ? 1 : 0);
  };
}
var XI = ZI(0), eR = ZI(1), tR = function() {
  function e22(t2, n2, r2, i2, o2) {
    Ri(this, e22), this.changes = t2, this.effects = n2, this.mapped = r2, this.startSelection = i2, this.selectionsAfter = o2;
  }
  return zi(e22, [{ key: "setSelAfter", value: function(t2) {
    return new e22(this.changes, this.effects, this.mapped, this.startSelection, t2);
  } }, { key: "toJSON", value: function() {
    var e23, t2, n2;
    return { changes: (e23 = this.changes) === null || e23 === void 0 ? void 0 : e23.toJSON(), mapped: (t2 = this.mapped) === null || t2 === void 0 ? void 0 : t2.toJSON(), startSelection: (n2 = this.startSelection) === null || n2 === void 0 ? void 0 : n2.toJSON(), selectionsAfter: this.selectionsAfter.map(function(e24) {
      return e24.toJSON();
    }) };
  } }], [{ key: "fromJSON", value: function(t2) {
    return new e22(t2.changes && mC.fromJSON(t2.changes), [], t2.mapped && pC.fromJSON(t2.mapped), t2.startSelection && SC.fromJSON(t2.startSelection), t2.selectionsAfter.map(SC.fromJSON));
  } }, { key: "fromTransaction", value: function(t2, n2) {
    var r2, i2 = iR, o2 = bi(t2.startState.facet(VI));
    try {
      for (o2.s(); !(r2 = o2.n()).done; ) {
        var a2 = (0, r2.value)(t2);
        a2.length && (i2 = i2.concat(a2));
      }
    } catch (e23) {
      o2.e(e23);
    } finally {
      o2.f();
    }
    return !i2.length && t2.changes.empty ? null : new e22(t2.changes.invert(t2.startState.doc), i2, void 0, n2 || t2.startState.selection, iR);
  } }, { key: "selection", value: function(t2) {
    return new e22(void 0, iR, void 0, void 0, t2);
  } }]), e22;
}();
function nR(e22, t2, n2, r2) {
  var i2 = t2 + 1 > n2 + 20 ? t2 - n2 - 1 : 0, o2 = e22.slice(i2, t2);
  return o2.push(r2), o2;
}
function rR(e22, t2) {
  return e22.length ? t2.length ? e22.concat(t2) : e22 : t2;
}
var iR = [];
function oR(e22, t2) {
  if (e22.length) {
    var n2 = e22[e22.length - 1], r2 = n2.selectionsAfter.slice(Math.max(0, n2.selectionsAfter.length - 200));
    return r2.length && r2[r2.length - 1].eq(t2) ? e22 : (r2.push(t2), nR(e22, e22.length - 1, 1e9, n2.setSelAfter(r2)));
  }
  return [tR.selection([t2])];
}
function aR(e22) {
  var t2 = e22[e22.length - 1], n2 = e22.slice();
  return n2[e22.length - 1] = t2.setSelAfter(t2.selectionsAfter.slice(0, t2.selectionsAfter.length - 1)), n2;
}
function sR(e22, t2) {
  if (!e22.length)
    return e22;
  for (var n2 = e22.length, r2 = iR; n2; ) {
    var i2 = uR(e22[n2 - 1], t2, r2);
    if (i2.changes && !i2.changes.empty || i2.effects.length) {
      var o2 = e22.slice(0, n2);
      return o2[n2 - 1] = i2, o2;
    }
    t2 = i2.mapped, n2--, r2 = i2.selectionsAfter;
  }
  return r2.length ? [tR.selection(r2)] : iR;
}
function uR(e22, t2, n2) {
  var r2 = rR(e22.selectionsAfter.length ? e22.selectionsAfter.map(function(e23) {
    return e23.map(t2);
  }) : iR, n2);
  if (!e22.changes)
    return tR.selection(r2);
  var i2 = e22.changes.map(t2), o2 = t2.mapDesc(e22.changes, true), a2 = e22.mapped ? e22.mapped.composeDesc(o2) : o2;
  return new tR(i2, n_.mapEffects(e22.effects, t2), a2, e22.startSelection.map(o2), r2);
}
var cR = /^(input\.type|delete)($|\.)/, lR = function() {
  function e22(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, i2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : void 0;
    Ri(this, e22), this.done = t2, this.undone = n2, this.prevTime = r2, this.prevUserEvent = i2;
  }
  return zi(e22, [{ key: "isolate", value: function() {
    return this.prevTime ? new e22(this.done, this.undone) : this;
  } }, { key: "addChanges", value: function(t2, n2, r2, i2, o2) {
    var a2 = this.done, s2 = a2[a2.length - 1];
    return new e22(a2 = s2 && s2.changes && !s2.changes.empty && t2.changes && (!r2 || cR.test(r2)) && (!s2.selectionsAfter.length && n2 - this.prevTime < i2 && function(e23, t3) {
      var n3 = [], r3 = false;
      return e23.iterChangedRanges(function(e24, t4) {
        return n3.push(e24, t4);
      }), t3.iterChangedRanges(function(e24, t4, i3, o3) {
        for (var a3 = 0; a3 < n3.length; ) {
          var s3 = n3[a3++], u2 = n3[a3++];
          o3 >= s3 && i3 <= u2 && (r3 = true);
        }
      }), r3;
    }(s2.changes, t2.changes) || r2 == "input.type.compose") ? nR(a2, a2.length - 1, o2, new tR(t2.changes.compose(s2.changes), rR(t2.effects, s2.effects), s2.mapped, s2.startSelection, iR)) : nR(a2, a2.length, o2, t2), iR, n2, r2);
  } }, { key: "addSelection", value: function(t2, n2, r2, i2) {
    var o2, a2, s2 = this.done.length ? this.done[this.done.length - 1].selectionsAfter : iR;
    return s2.length > 0 && n2 - this.prevTime < i2 && r2 == this.prevUserEvent && r2 && /^select($|\.)/.test(r2) && (o2 = s2[s2.length - 1], a2 = t2, o2.ranges.length == a2.ranges.length && o2.ranges.filter(function(e23, t3) {
      return e23.empty != a2.ranges[t3].empty;
    }).length === 0) ? this : new e22(oR(this.done, t2), this.undone, n2, r2);
  } }, { key: "addMapping", value: function(t2) {
    return new e22(sR(this.done, t2), sR(this.undone, t2), this.prevTime, this.prevUserEvent);
  } }, { key: "pop", value: function(e23, t2, n2) {
    var r2 = e23 == 0 ? this.done : this.undone;
    if (r2.length == 0)
      return null;
    var i2 = r2[r2.length - 1];
    if (n2 && i2.selectionsAfter.length)
      return t2.update({ selection: i2.selectionsAfter[i2.selectionsAfter.length - 1], annotations: qI.of({ side: e23, rest: aR(r2) }), userEvent: e23 == 0 ? "select.undo" : "select.redo", scrollIntoView: true });
    if (i2.changes) {
      var o2 = r2.length == 1 ? iR : r2.slice(0, r2.length - 1);
      return i2.mapped && (o2 = sR(o2, i2.mapped)), t2.update({ changes: i2.changes, selection: i2.startSelection, effects: i2.effects, annotations: qI.of({ side: e23, rest: o2 }), filter: false, userEvent: e23 == 0 ? "undo" : "redo", scrollIntoView: true });
    }
    return null;
  } }]), e22;
}();
lR.empty = new lR(iR, iR);
var fR = [{ key: "Mod-z", run: KI, preventDefault: true }, { key: "Mod-y", mac: "Mod-Shift-z", run: GI, preventDefault: true }, { linux: "Ctrl-Shift-z", run: GI, preventDefault: true }, { key: "Mod-u", run: QI, preventDefault: true }, { key: "Alt-u", mac: "Mod-Shift-u", run: YI, preventDefault: true }];
function hR(e22, t2) {
  return SC.create(e22.ranges.map(t2), e22.mainIndex);
}
function dR(e22, t2) {
  return e22.update({ selection: t2, scrollIntoView: true, userEvent: "select" });
}
function vR(e22, t2) {
  var n2 = e22.state, r2 = e22.dispatch, i2 = hR(n2.selection, t2);
  return !i2.eq(n2.selection) && (r2(dR(n2, i2)), true);
}
function pR(e22, t2) {
  return SC.cursor(t2 ? e22.to : e22.from);
}
function mR(e22, t2) {
  return vR(e22, function(n2) {
    return n2.empty ? e22.moveByChar(n2, t2) : pR(n2, t2);
  });
}
function gR(e22) {
  return e22.textDirectionAt(e22.state.selection.main.head) == EO.LTR;
}
var yR = function(e22) {
  return mR(e22, !gR(e22));
}, bR = function(e22) {
  return mR(e22, gR(e22));
};
function kR(e22, t2) {
  return vR(e22, function(n2) {
    return n2.empty ? e22.moveByGroup(n2, t2) : pR(n2, t2);
  });
}
function wR(e22, t2, n2) {
  if (t2.type.prop(n2))
    return true;
  var r2 = t2.to - t2.from;
  return r2 && (r2 > 2 || /[^\s,.;:]/.test(e22.sliceDoc(t2.from, t2.to))) || t2.firstChild;
}
function xR(e22, t2, n2) {
  for (var r2 = VN(e22).resolveInner(t2.head), i2 = n2 ? lI.closedBy : lI.openedBy, o2 = t2.head; ; ) {
    var a2 = n2 ? r2.childAfter(o2) : r2.childBefore(o2);
    if (!a2)
      break;
    wR(e22, a2, i2) ? r2 = a2 : o2 = n2 ? a2.to : a2.from;
  }
  var s2, u2;
  return u2 = r2.type.prop(i2) && (s2 = n2 ? GT(e22, r2.from, 1) : GT(e22, r2.to, -1)) && s2.matched ? n2 ? s2.end.to : s2.end.from : n2 ? r2.to : r2.from, SC.cursor(u2, n2 ? -1 : 1);
}
function jR(e22, t2) {
  return vR(e22, function(n2) {
    if (!n2.empty)
      return pR(n2, t2);
    var r2 = e22.moveVertically(n2, t2);
    return r2.head != n2.head ? r2 : e22.moveToLineBoundary(n2, t2);
  });
}
var SR = function(e22) {
  return jR(e22, false);
}, CR = function(e22) {
  return jR(e22, true);
};
function _R(e22) {
  return Math.max(e22.defaultLineHeight, Math.min(e22.dom.clientHeight, innerHeight) - 5);
}
function $R(e22, t2) {
  var n2 = e22.state, r2 = hR(n2.selection, function(n3) {
    return n3.empty ? e22.moveVertically(n3, t2, _R(e22)) : pR(n3, t2);
  });
  if (r2.eq(n2.selection))
    return false;
  var i2, o2 = e22.coordsAtPos(n2.selection.main.head), a2 = e22.scrollDOM.getBoundingClientRect();
  return o2 && o2.top > a2.top && o2.bottom < a2.bottom && o2.top - a2.top <= e22.scrollDOM.scrollHeight - e22.scrollDOM.scrollTop - e22.scrollDOM.clientHeight && (i2 = MM.scrollIntoView(r2.main.head, { y: "start", yMargin: o2.top - a2.top })), e22.dispatch(dR(n2, r2), { effects: i2 }), true;
}
var OR = function(e22) {
  return $R(e22, false);
}, AR = function(e22) {
  return $R(e22, true);
};
function MR(e22, t2, n2) {
  var r2 = e22.lineBlockAt(t2.head), i2 = e22.moveToLineBoundary(t2, n2);
  if (i2.head == t2.head && i2.head != (n2 ? r2.to : r2.from) && (i2 = e22.moveToLineBoundary(t2, n2, false)), !n2 && i2.head == r2.from && r2.length) {
    var o2 = /^\s*/.exec(e22.state.sliceDoc(r2.from, Math.min(r2.from + 100, r2.to)))[0].length;
    o2 && t2.head != r2.from + o2 && (i2 = SC.cursor(r2.from + o2));
  }
  return i2;
}
var ER = function(e22) {
  return vR(e22, function(t2) {
    return MR(e22, t2, true);
  });
}, PR = function(e22) {
  return vR(e22, function(t2) {
    return MR(e22, t2, false);
  });
};
function NR(e22, t2) {
  var n2 = hR(e22.state.selection, function(e23) {
    var n3 = t2(e23);
    return SC.range(e23.anchor, n3.head, n3.goalColumn);
  });
  return !n2.eq(e22.state.selection) && (e22.dispatch(dR(e22.state, n2)), true);
}
function TR(e22, t2) {
  return NR(e22, function(n2) {
    return e22.moveByChar(n2, t2);
  });
}
var IR = function(e22) {
  return TR(e22, !gR(e22));
}, RR = function(e22) {
  return TR(e22, gR(e22));
};
function DR(e22, t2) {
  return NR(e22, function(n2) {
    return e22.moveByGroup(n2, t2);
  });
}
function zR(e22, t2) {
  return NR(e22, function(n2) {
    return e22.moveVertically(n2, t2);
  });
}
var LR = function(e22) {
  return zR(e22, false);
}, BR = function(e22) {
  return zR(e22, true);
};
function qR(e22, t2) {
  return NR(e22, function(n2) {
    return e22.moveVertically(n2, t2, _R(e22));
  });
}
var FR = function(e22) {
  return qR(e22, false);
}, VR = function(e22) {
  return qR(e22, true);
}, HR = function(e22) {
  return NR(e22, function(t2) {
    return MR(e22, t2, true);
  });
}, WR = function(e22) {
  return NR(e22, function(t2) {
    return MR(e22, t2, false);
  });
}, JR = function(e22) {
  var t2 = e22.state;
  return (0, e22.dispatch)(dR(t2, { anchor: 0 })), true;
}, UR = function(e22) {
  var t2 = e22.state;
  return (0, e22.dispatch)(dR(t2, { anchor: t2.doc.length })), true;
}, KR = function(e22) {
  var t2 = e22.state;
  return (0, e22.dispatch)(dR(t2, { anchor: t2.selection.main.anchor, head: 0 })), true;
}, GR = function(e22) {
  var t2 = e22.state;
  return (0, e22.dispatch)(dR(t2, { anchor: t2.selection.main.anchor, head: t2.doc.length })), true;
};
function QR(e22, t2) {
  var n2 = e22.state, r2 = e22.dispatch;
  if (n2.readOnly)
    return false;
  var i2 = "delete.selection", o2 = n2.changeByRange(function(e23) {
    var n3 = e23.from, r3 = e23.to;
    if (n3 == r3) {
      var o3 = t2(n3);
      o3 < n3 ? i2 = "delete.backward" : o3 > n3 && (i2 = "delete.forward"), n3 = Math.min(n3, o3), r3 = Math.max(r3, o3);
    }
    return n3 == r3 ? { range: e23 } : { changes: { from: n3, to: r3 }, range: SC.cursor(n3) };
  });
  return !o2.changes.empty && (r2(n2.update(o2, { scrollIntoView: true, userEvent: i2, effects: i2 == "delete.selection" ? MM.announce.of(n2.phrase("Selection deleted")) : void 0 })), true);
}
function YR(e22, t2, n2) {
  if (e22 instanceof MM) {
    var r2, i2 = bi(e22.state.facet(MM.atomicRanges).map(function(t3) {
      return t3(e22);
    }));
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        r2.value.between(t2, t2, function(e23, r3) {
          e23 < t2 && r3 > t2 && (t2 = n2 ? r3 : e23);
        });
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
  }
  return t2;
}
var ZR = function(e22, t2) {
  return QR(e22, function(n2) {
    var r2, i2, o2 = e22.state, a2 = o2.doc.lineAt(n2);
    if (!t2 && n2 > a2.from && n2 < a2.from + 200 && !/[^ \t]/.test(r2 = a2.text.slice(0, n2 - a2.from))) {
      if (r2[r2.length - 1] == "	")
        return n2 - 1;
      for (var s2 = N_(r2, o2.tabSize) % nT(o2) || nT(o2), u2 = 0; u2 < s2 && r2[r2.length - 1 - u2] == " "; u2++)
        n2--;
      i2 = n2;
    } else
      (i2 = oC(a2.text, n2 - a2.from, t2, t2) + a2.from) == n2 && a2.number != (t2 ? o2.doc.lines : 1) && (i2 += t2 ? 1 : -1);
    return YR(e22, i2, t2);
  });
}, XR = function(e22) {
  return ZR(e22, false);
}, eD = function(e22) {
  return ZR(e22, true);
}, tD = function(e22, t2) {
  return QR(e22, function(n2) {
    for (var r2 = n2, i2 = e22.state, o2 = i2.doc.lineAt(r2), a2 = i2.charCategorizer(r2), s2 = null; ; ) {
      if (r2 == (t2 ? o2.to : o2.from)) {
        r2 == n2 && o2.number != (t2 ? i2.doc.lines : 1) && (r2 += t2 ? 1 : -1);
        break;
      }
      var u2 = oC(o2.text, r2 - o2.from, t2) + o2.from, c2 = o2.text.slice(Math.min(r2, u2) - o2.from, Math.max(r2, u2) - o2.from), l2 = a2(c2);
      if (s2 != null && l2 != s2)
        break;
      c2 == " " && r2 == n2 || (s2 = l2), r2 = u2;
    }
    return YR(e22, r2, t2);
  });
}, nD = function(e22) {
  return tD(e22, false);
}, rD = function(e22) {
  return QR(e22, function(t2) {
    var n2 = e22.lineBlockAt(t2).to;
    return YR(e22, t2 < n2 ? n2 : Math.min(e22.state.doc.length, t2 + 1), true);
  });
};
function iD(e22) {
  var t2, n2 = [], r2 = -1, i2 = bi(e22.selection.ranges);
  try {
    for (i2.s(); !(t2 = i2.n()).done; ) {
      var o2 = t2.value, a2 = e22.doc.lineAt(o2.from), s2 = e22.doc.lineAt(o2.to);
      if (o2.empty || o2.to != s2.from || (s2 = e22.doc.lineAt(o2.to - 1)), r2 >= a2.number) {
        var u2 = n2[n2.length - 1];
        u2.to = s2.to, u2.ranges.push(o2);
      } else
        n2.push({ from: a2.from, to: s2.to, ranges: [o2] });
      r2 = s2.number + 1;
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  return n2;
}
function oD(e22, t2, n2) {
  if (e22.readOnly)
    return false;
  var r2, i2 = [], o2 = [], a2 = bi(iD(e22));
  try {
    for (a2.s(); !(r2 = a2.n()).done; ) {
      var s2 = r2.value;
      if (n2 ? s2.to != e22.doc.length : s2.from != 0) {
        var u2 = e22.doc.lineAt(n2 ? s2.to + 1 : s2.from - 1), c2 = u2.length + 1;
        if (n2) {
          i2.push({ from: s2.to, to: u2.to }, { from: s2.from, insert: u2.text + e22.lineBreak });
          var l2, f2 = bi(s2.ranges);
          try {
            for (f2.s(); !(l2 = f2.n()).done; ) {
              var h2 = l2.value;
              o2.push(SC.range(Math.min(e22.doc.length, h2.anchor + c2), Math.min(e22.doc.length, h2.head + c2)));
            }
          } catch (e23) {
            f2.e(e23);
          } finally {
            f2.f();
          }
        } else {
          i2.push({ from: u2.from, to: s2.from }, { from: s2.to, insert: e22.lineBreak + u2.text });
          var d2, v2 = bi(s2.ranges);
          try {
            for (v2.s(); !(d2 = v2.n()).done; ) {
              var p2 = d2.value;
              o2.push(SC.range(p2.anchor - c2, p2.head - c2));
            }
          } catch (e23) {
            v2.e(e23);
          } finally {
            v2.f();
          }
        }
      }
    }
  } catch (e23) {
    a2.e(e23);
  } finally {
    a2.f();
  }
  return !!i2.length && (t2(e22.update({ changes: i2, scrollIntoView: true, selection: SC.create(o2, e22.selection.mainIndex), userEvent: "move.line" })), true);
}
function aD(e22, t2, n2) {
  if (e22.readOnly)
    return false;
  var r2, i2 = [], o2 = bi(iD(e22));
  try {
    for (o2.s(); !(r2 = o2.n()).done; ) {
      var a2 = r2.value;
      n2 ? i2.push({ from: a2.from, insert: e22.doc.slice(a2.from, a2.to) + e22.lineBreak }) : i2.push({ from: a2.to, insert: e22.lineBreak + e22.doc.slice(a2.from, a2.to) });
    }
  } catch (e23) {
    o2.e(e23);
  } finally {
    o2.f();
  }
  return t2(e22.update({ changes: i2, scrollIntoView: true, userEvent: "input.copyline" })), true;
}
var sD = uD(false);
function uD(e22) {
  return function(t2) {
    var n2 = t2.state, r2 = t2.dispatch;
    if (n2.readOnly)
      return false;
    var i2 = n2.changeByRange(function(t3) {
      var r3 = t3.from, i3 = t3.to, o2 = n2.doc.lineAt(r3), a2 = !e22 && r3 == i3 && function(e23, t4) {
        if (/\(\)|\[\]|\{\}/.test(e23.sliceDoc(t4 - 1, t4 + 1)))
          return { from: t4, to: t4 };
        var n3, r4 = VN(e23).resolveInner(t4), i4 = r4.childBefore(t4), o3 = r4.childAfter(t4);
        return i4 && o3 && i4.to <= t4 && o3.from >= t4 && (n3 = i4.type.prop(lI.closedBy)) && n3.indexOf(o3.name) > -1 && e23.doc.lineAt(i4.to).from == e23.doc.lineAt(o3.from).from ? { from: i4.to, to: o3.from } : null;
      }(n2, r3);
      e22 && (r3 = i3 = (i3 <= o2.to ? o2 : n2.doc.lineAt(i3)).to);
      var s2 = new oT(n2, { simulateBreak: r3, simulateDoubleBreak: !!a2 }), u2 = iT(s2, r3);
      for (u2 == null && (u2 = /^\s*/.exec(n2.doc.lineAt(r3).text)[0].length); i3 < o2.to && /\s/.test(o2.text[i3 - o2.from]); )
        i3++;
      a2 ? (r3 = a2.from, i3 = a2.to) : r3 > o2.from && r3 < o2.from + 100 && !/\S/.test(o2.text.slice(0, r3)) && (r3 = o2.from);
      var c2 = ["", rT(n2, u2)];
      return a2 && c2.push(rT(n2, s2.lineIndent(o2.from, -1))), { changes: { from: r3, to: i3, insert: WS.of(c2) }, range: SC.cursor(r3 + 1 + c2[1].length) };
    });
    return r2(n2.update(i2, { scrollIntoView: true, userEvent: "input" })), true;
  };
}
function cD(e22, t2) {
  var n2 = -1;
  return e22.changeByRange(function(r2) {
    for (var i2 = [], o2 = r2.from; o2 <= r2.to; ) {
      var a2 = e22.doc.lineAt(o2);
      a2.number > n2 && (r2.empty || r2.to > a2.from) && (t2(a2, i2, r2), n2 = a2.number), o2 = a2.to + 1;
    }
    var s2 = e22.changes(i2);
    return { changes: i2, range: SC.range(s2.mapPos(r2.anchor, 1), s2.mapPos(r2.head, 1)) };
  });
}
var lD = function(e22) {
  var t2 = e22.state, n2 = e22.dispatch;
  return !t2.readOnly && (n2(t2.update(cD(t2, function(e23, n3) {
    n3.push({ from: e23.from, insert: t2.facet(tT) });
  }), { userEvent: "input.indent" })), true);
}, fD = function(e22) {
  var t2 = e22.state, n2 = e22.dispatch;
  return !t2.readOnly && (n2(t2.update(cD(t2, function(e23, n3) {
    var r2 = /^\s*/.exec(e23.text)[0];
    if (r2) {
      for (var i2 = N_(r2, t2.tabSize), o2 = 0, a2 = rT(t2, Math.max(0, i2 - nT(t2))); o2 < r2.length && o2 < a2.length && r2.charCodeAt(o2) == a2.charCodeAt(o2); )
        o2++;
      n3.push({ from: e23.from + o2, to: e23.from + r2.length, insert: a2.slice(o2) });
    }
  }), { userEvent: "delete.dedent" })), true);
}, hD = [{ key: "Alt-ArrowLeft", mac: "Ctrl-ArrowLeft", run: function(e22) {
  return vR(e22, function(t2) {
    return xR(e22.state, t2, !gR(e22));
  });
}, shift: function(e22) {
  return NR(e22, function(t2) {
    return xR(e22.state, t2, !gR(e22));
  });
} }, { key: "Alt-ArrowRight", mac: "Ctrl-ArrowRight", run: function(e22) {
  return vR(e22, function(t2) {
    return xR(e22.state, t2, gR(e22));
  });
}, shift: function(e22) {
  return NR(e22, function(t2) {
    return xR(e22.state, t2, gR(e22));
  });
} }, { key: "Alt-ArrowUp", run: function(e22) {
  return oD(e22.state, e22.dispatch, false);
} }, { key: "Shift-Alt-ArrowUp", run: function(e22) {
  return aD(e22.state, e22.dispatch, false);
} }, { key: "Alt-ArrowDown", run: function(e22) {
  return oD(e22.state, e22.dispatch, true);
} }, { key: "Shift-Alt-ArrowDown", run: function(e22) {
  return aD(e22.state, e22.dispatch, true);
} }, { key: "Escape", run: function(e22) {
  var t2 = e22.state, n2 = e22.dispatch, r2 = t2.selection, i2 = null;
  return r2.ranges.length > 1 ? i2 = SC.create([r2.main]) : r2.main.empty || (i2 = SC.create([SC.cursor(r2.main.head)])), !!i2 && (n2(dR(t2, i2)), true);
} }, { key: "Mod-Enter", run: uD(true) }, { key: "Alt-l", mac: "Ctrl-l", run: function(e22) {
  var t2 = e22.state, n2 = e22.dispatch, r2 = iD(t2).map(function(e23) {
    var n3 = e23.from, r3 = e23.to;
    return SC.range(n3, Math.min(r3 + 1, t2.doc.length));
  });
  return n2(t2.update({ selection: SC.create(r2), userEvent: "select" })), true;
} }, { key: "Mod-i", run: function(e22) {
  var t2 = e22.state, n2 = e22.dispatch, r2 = hR(t2.selection, function(e23) {
    for (var n3, r3 = VN(t2).resolveInner(e23.head, 1); !(r3.from < e23.from && r3.to >= e23.to || r3.to > e23.to && r3.from <= e23.from) && ((n3 = r3.parent) === null || n3 === void 0 ? void 0 : n3.parent); )
      r3 = r3.parent;
    return SC.range(r3.to, r3.from);
  });
  return n2(dR(t2, r2)), true;
}, preventDefault: true }, { key: "Mod-[", run: fD }, { key: "Mod-]", run: lD }, { key: "Mod-Alt-\\", run: function(e22) {
  var t2 = e22.state, n2 = e22.dispatch;
  if (t2.readOnly)
    return false;
  var r2 = /* @__PURE__ */ Object.create(null), i2 = new oT(t2, { overrideIndentation: function(e23) {
    var t3 = r2[e23];
    return t3 == null ? -1 : t3;
  } }), o2 = cD(t2, function(e23, n3, o3) {
    var a2 = iT(i2, e23.from);
    if (a2 != null) {
      /\S/.test(e23.text) || (a2 = 0);
      var s2 = /^\s*/.exec(e23.text)[0], u2 = rT(t2, a2);
      (s2 != u2 || o3.from < e23.from + s2.length) && (r2[e23.from] = a2, n3.push({ from: e23.from, to: e23.from + s2.length, insert: u2 }));
    }
  });
  return o2.changes.empty || n2(t2.update(o2, { userEvent: "indent" })), true;
} }, { key: "Shift-Mod-k", run: function(e22) {
  if (e22.state.readOnly)
    return false;
  var t2 = e22.state, n2 = t2.changes(iD(t2).map(function(e23) {
    var n3 = e23.from, r3 = e23.to;
    return n3 > 0 ? n3-- : r3 < t2.doc.length && r3++, { from: n3, to: r3 };
  })), r2 = hR(t2.selection, function(t3) {
    return e22.moveVertically(t3, true);
  }).map(n2);
  return e22.dispatch({ changes: n2, selection: r2, scrollIntoView: true, userEvent: "delete.line" }), true;
} }, { key: "Shift-Mod-\\", run: function(e22) {
  return function(e23, t2, n2) {
    var r2 = false, i2 = hR(e23.selection, function(t3) {
      var i3 = GT(e23, t3.head, -1) || GT(e23, t3.head, 1) || t3.head > 0 && GT(e23, t3.head - 1, 1) || t3.head < e23.doc.length && GT(e23, t3.head + 1, -1);
      if (!i3 || !i3.end)
        return t3;
      r2 = true;
      var o2 = i3.start.from == t3.head ? i3.end.to : i3.end.from;
      return n2 ? SC.range(t3.anchor, o2) : SC.cursor(o2);
    });
    return !!r2 && (t2(dR(e23, i2)), true);
  }(e22.state, e22.dispatch, false);
} }, { key: "Mod-/", run: function(e22) {
  var t2 = DI(e22.state);
  return t2.line ? TI(e22) : !!t2.block && RI(e22);
} }, { key: "Alt-A", run: II }].concat([{ key: "ArrowLeft", run: yR, shift: IR, preventDefault: true }, { key: "Mod-ArrowLeft", mac: "Alt-ArrowLeft", run: function(e22) {
  return kR(e22, !gR(e22));
}, shift: function(e22) {
  return DR(e22, !gR(e22));
} }, { mac: "Cmd-ArrowLeft", run: PR, shift: WR }, { key: "ArrowRight", run: bR, shift: RR, preventDefault: true }, { key: "Mod-ArrowRight", mac: "Alt-ArrowRight", run: function(e22) {
  return kR(e22, gR(e22));
}, shift: function(e22) {
  return DR(e22, gR(e22));
} }, { mac: "Cmd-ArrowRight", run: ER, shift: HR }, { key: "ArrowUp", run: SR, shift: LR, preventDefault: true }, { mac: "Cmd-ArrowUp", run: JR, shift: KR }, { mac: "Ctrl-ArrowUp", run: OR, shift: FR }, { key: "ArrowDown", run: CR, shift: BR, preventDefault: true }, { mac: "Cmd-ArrowDown", run: UR, shift: GR }, { mac: "Ctrl-ArrowDown", run: AR, shift: VR }, { key: "PageUp", run: OR, shift: FR }, { key: "PageDown", run: AR, shift: VR }, { key: "Home", run: PR, shift: WR, preventDefault: true }, { key: "Mod-Home", run: JR, shift: KR }, { key: "End", run: ER, shift: HR, preventDefault: true }, { key: "Mod-End", run: UR, shift: GR }, { key: "Enter", run: sD }, { key: "Mod-a", run: function(e22) {
  var t2 = e22.state;
  return (0, e22.dispatch)(t2.update({ selection: { anchor: 0, head: t2.doc.length }, userEvent: "select" })), true;
} }, { key: "Backspace", run: XR, shift: XR }, { key: "Delete", run: eD }, { key: "Mod-Backspace", mac: "Alt-Backspace", run: nD }, { key: "Mod-Delete", mac: "Alt-Delete", run: function(e22) {
  return tD(e22, true);
} }, { mac: "Mod-Backspace", run: function(e22) {
  return QR(e22, function(t2) {
    var n2 = e22.lineBlockAt(t2).from;
    return YR(e22, t2 > n2 ? n2 : Math.max(0, t2 - 1), false);
  });
} }, { mac: "Mod-Delete", run: rD }].concat([{ key: "Ctrl-b", run: yR, shift: IR, preventDefault: true }, { key: "Ctrl-f", run: bR, shift: RR }, { key: "Ctrl-p", run: SR, shift: LR }, { key: "Ctrl-n", run: CR, shift: BR }, { key: "Ctrl-a", run: function(e22) {
  return vR(e22, function(t2) {
    return SC.cursor(e22.lineBlockAt(t2.head).from, 1);
  });
}, shift: function(e22) {
  return NR(e22, function(t2) {
    return SC.cursor(e22.lineBlockAt(t2.head).from);
  });
} }, { key: "Ctrl-e", run: function(e22) {
  return vR(e22, function(t2) {
    return SC.cursor(e22.lineBlockAt(t2.head).to, -1);
  });
}, shift: function(e22) {
  return NR(e22, function(t2) {
    return SC.cursor(e22.lineBlockAt(t2.head).to);
  });
} }, { key: "Ctrl-d", run: eD }, { key: "Ctrl-h", run: XR }, { key: "Ctrl-k", run: rD }, { key: "Ctrl-Alt-h", run: nD }, { key: "Ctrl-o", run: function(e22) {
  var t2 = e22.state, n2 = e22.dispatch;
  if (t2.readOnly)
    return false;
  var r2 = t2.changeByRange(function(e23) {
    return { changes: { from: e23.from, to: e23.to, insert: WS.of(["", ""]) }, range: SC.cursor(e23.from) };
  });
  return n2(t2.update(r2, { scrollIntoView: true, userEvent: "input" })), true;
} }, { key: "Ctrl-t", run: function(e22) {
  var t2 = e22.state, n2 = e22.dispatch;
  if (t2.readOnly)
    return false;
  var r2 = t2.changeByRange(function(e23) {
    if (!e23.empty || e23.from == 0 || e23.from == t2.doc.length)
      return { range: e23 };
    var n3 = e23.from, r3 = t2.doc.lineAt(n3), i2 = n3 == r3.from ? n3 - 1 : oC(r3.text, n3 - r3.from, false) + r3.from, o2 = n3 == r3.to ? n3 + 1 : oC(r3.text, n3 - r3.from, true) + r3.from;
    return { changes: { from: i2, to: o2, insert: t2.doc.slice(n3, o2).append(t2.doc.slice(i2, n3)) }, range: SC.cursor(o2) };
  });
  return !r2.changes.empty && (n2(t2.update(r2, { scrollIntoView: true, userEvent: "move.character" })), true);
} }, { key: "Ctrl-v", run: AR }].map(function(e22) {
  return { mac: e22.key, run: e22.run, shift: e22.shift };
}))), dD = { key: "Tab", run: lD, shift: fD };
function vD() {
  var e22 = arguments[0];
  typeof e22 == "string" && (e22 = document.createElement(e22));
  var t2 = 1, n2 = arguments[1];
  if (n2 && Li(n2) == "object" && n2.nodeType == null && !Array.isArray(n2)) {
    for (var r2 in n2)
      if (Object.prototype.hasOwnProperty.call(n2, r2)) {
        var i2 = n2[r2];
        typeof i2 == "string" ? e22.setAttribute(r2, i2) : i2 != null && (e22[r2] = i2);
      }
    t2++;
  }
  for (; t2 < arguments.length; t2++)
    pD(e22, arguments[t2]);
  return e22;
}
function pD(e22, t2) {
  if (typeof t2 == "string")
    e22.appendChild(document.createTextNode(t2));
  else if (t2 == null)
    ;
  else if (t2.nodeType != null)
    e22.appendChild(t2);
  else {
    if (!Array.isArray(t2))
      throw new RangeError("Unsupported child node: " + t2);
    for (var n2 = 0; n2 < t2.length; n2++)
      pD(e22, t2[n2]);
  }
}
var mD = typeof String.prototype.normalize == "function" ? function(e22) {
  return e22.normalize("NFKD");
} : function(e22) {
  return e22;
}, gD = function() {
  function e22(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, i2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : t2.length, o2 = arguments.length > 4 ? arguments[4] : void 0;
    Ri(this, e22), this.value = { from: 0, to: 0 }, this.done = false, this.matches = [], this.buffer = "", this.bufferPos = 0, this.iter = t2.iterRange(r2, i2), this.bufferStart = r2, this.normalize = o2 ? function(e23) {
      return o2(mD(e23));
    } : mD, this.query = this.normalize(n2);
  }
  return zi(e22, [{ key: "peek", value: function() {
    if (this.bufferPos == this.buffer.length) {
      if (this.bufferStart += this.buffer.length, this.iter.next(), this.iter.done)
        return -1;
      this.bufferPos = 0, this.buffer = this.iter.value;
    }
    return lC(this.buffer, this.bufferPos);
  } }, { key: "next", value: function() {
    for (; this.matches.length; )
      this.matches.pop();
    return this.nextOverlapping();
  } }, { key: "nextOverlapping", value: function() {
    for (; ; ) {
      var e23 = this.peek();
      if (e23 < 0)
        return this.done = true, this;
      var t2 = fC(e23), n2 = this.bufferStart + this.bufferPos;
      this.bufferPos += hC(e23);
      for (var r2 = this.normalize(t2), i2 = 0, o2 = n2; ; i2++) {
        var a2 = r2.charCodeAt(i2), s2 = this.match(a2, o2);
        if (s2)
          return this.value = s2, this;
        if (i2 == r2.length - 1)
          break;
        o2 == n2 && i2 < t2.length && t2.charCodeAt(i2) == a2 && o2++;
      }
    }
  } }, { key: "match", value: function(e23, t2) {
    for (var n2 = null, r2 = 0; r2 < this.matches.length; r2 += 2) {
      var i2 = this.matches[r2], o2 = false;
      this.query.charCodeAt(i2) == e23 && (i2 == this.query.length - 1 ? n2 = { from: this.matches[r2 + 1], to: t2 + 1 } : (this.matches[r2]++, o2 = true)), o2 || (this.matches.splice(r2, 2), r2 -= 2);
    }
    return this.query.charCodeAt(0) == e23 && (this.query.length == 1 ? n2 = { from: t2, to: t2 + 1 } : this.matches.push(1, t2)), n2;
  } }]), e22;
}();
typeof Symbol != "undefined" && (gD.prototype[Symbol.iterator] = function() {
  return this;
});
var yD = { from: -1, to: -1, match: /.*/.exec("") }, bD = "gm" + (/x/.unicode == null ? "" : "u"), kD = function() {
  function e22(t2, n2, r2) {
    var i2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0, o2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : t2.length;
    if (Ri(this, e22), this.to = o2, this.curLine = "", this.done = false, this.value = yD, /\\[sWDnr]|\n|\r|\[\^/.test(n2))
      return new jD(t2, n2, r2, i2, o2);
    this.re = new RegExp(n2, bD + ((r2 == null ? void 0 : r2.ignoreCase) ? "i" : "")), this.iter = t2.iter();
    var a2 = t2.lineAt(i2);
    this.curLineStart = a2.from, this.matchPos = i2, this.getLine(this.curLineStart);
  }
  return zi(e22, [{ key: "getLine", value: function(e23) {
    this.iter.next(e23), this.iter.lineBreak ? this.curLine = "" : (this.curLine = this.iter.value, this.curLineStart + this.curLine.length > this.to && (this.curLine = this.curLine.slice(0, this.to - this.curLineStart)), this.iter.next());
  } }, { key: "nextLine", value: function() {
    this.curLineStart = this.curLineStart + this.curLine.length + 1, this.curLineStart > this.to ? this.curLine = "" : this.getLine(0);
  } }, { key: "next", value: function() {
    for (var e23 = this.matchPos - this.curLineStart; ; ) {
      this.re.lastIndex = e23;
      var t2 = this.matchPos <= this.to && this.re.exec(this.curLine);
      if (t2) {
        var n2 = this.curLineStart + t2.index, r2 = n2 + t2[0].length;
        if (this.matchPos = r2 + (n2 == r2 ? 1 : 0), n2 == this.curLine.length && this.nextLine(), n2 < r2 || n2 > this.value.to)
          return this.value = { from: n2, to: r2, match: t2 }, this;
        e23 = this.matchPos - this.curLineStart;
      } else {
        if (!(this.curLineStart + this.curLine.length < this.to))
          return this.done = true, this;
        this.nextLine(), e23 = 0;
      }
    }
  } }]), e22;
}(), wD = /* @__PURE__ */ new WeakMap(), xD = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.from = t2, this.text = n2;
  }
  return zi(e22, [{ key: "to", get: function() {
    return this.from + this.text.length;
  } }], [{ key: "get", value: function(t2, n2, r2) {
    var i2 = wD.get(t2);
    if (!i2 || i2.from >= r2 || i2.to <= n2) {
      var o2 = new e22(n2, t2.sliceString(n2, r2));
      return wD.set(t2, o2), o2;
    }
    if (i2.from == n2 && i2.to == r2)
      return i2;
    var a2 = i2.text, s2 = i2.from;
    return s2 > n2 && (a2 = t2.sliceString(n2, s2) + a2, s2 = n2), i2.to < r2 && (a2 += t2.sliceString(i2.to, r2)), wD.set(t2, new e22(s2, a2)), new e22(n2, a2.slice(n2 - s2, r2 - s2));
  } }]), e22;
}(), jD = function() {
  function e22(t2, n2, r2, i2, o2) {
    Ri(this, e22), this.text = t2, this.to = o2, this.done = false, this.value = yD, this.matchPos = i2, this.re = new RegExp(n2, bD + ((r2 == null ? void 0 : r2.ignoreCase) ? "i" : "")), this.flat = xD.get(t2, i2, this.chunkEnd(i2 + 5e3));
  }
  return zi(e22, [{ key: "chunkEnd", value: function(e23) {
    return e23 >= this.to ? this.to : this.text.lineAt(e23).to;
  } }, { key: "next", value: function() {
    for (; ; ) {
      var e23 = this.re.lastIndex = this.matchPos - this.flat.from, t2 = this.re.exec(this.flat.text);
      if (t2 && !t2[0] && t2.index == e23 && (this.re.lastIndex = e23 + 1, t2 = this.re.exec(this.flat.text)), t2 && this.flat.to < this.to && t2.index + t2[0].length > this.flat.text.length - 10 && (t2 = null), t2) {
        var n2 = this.flat.from + t2.index, r2 = n2 + t2[0].length;
        return this.value = { from: n2, to: r2, match: t2 }, this.matchPos = r2 + (n2 == r2 ? 1 : 0), this;
      }
      if (this.flat.to == this.to)
        return this.done = true, this;
      this.flat = xD.get(this.text, this.flat.from, this.chunkEnd(this.flat.from + 2 * this.flat.text.length));
    }
  } }]), e22;
}();
function SD(e22) {
  var t2 = vD("input", { class: "cm-textfield", name: "line" });
  function n2() {
    var n3 = /^([+-])?(\d+)?(:\d+)?(%)?$/.exec(t2.value);
    if (n3) {
      var r2 = e22.state, i2 = r2.doc.lineAt(r2.selection.main.head), o2 = xi(n3, 5), a2 = o2[1], s2 = o2[2], u2 = o2[3], c2 = o2[4], l2 = u2 ? +u2.slice(1) : 0, f2 = s2 ? +s2 : i2.number;
      if (s2 && c2) {
        var h2 = f2 / 100;
        a2 && (h2 = h2 * (a2 == "-" ? -1 : 1) + i2.number / r2.doc.lines), f2 = Math.round(r2.doc.lines * h2);
      } else
        s2 && a2 && (f2 = f2 * (a2 == "-" ? -1 : 1) + i2.number);
      var d2 = r2.doc.line(Math.max(1, Math.min(r2.doc.lines, f2)));
      e22.dispatch({ effects: CD.of(false), selection: SC.cursor(d2.from + Math.max(0, Math.min(l2, d2.length))), scrollIntoView: true }), e22.focus();
    }
  }
  return { dom: vD("form", { class: "cm-gotoLine", onkeydown: function(t3) {
    t3.keyCode == 27 ? (t3.preventDefault(), e22.dispatch({ effects: CD.of(false) }), e22.focus()) : t3.keyCode == 13 && (t3.preventDefault(), n2());
  }, onsubmit: function(e23) {
    e23.preventDefault(), n2();
  } }, vD("label", e22.state.phrase("Go to line"), ": ", t2), " ", vD("button", { class: "cm-button", type: "submit" }, e22.state.phrase("go"))) };
}
typeof Symbol != "undefined" && (kD.prototype[Symbol.iterator] = jD.prototype[Symbol.iterator] = function() {
  return this;
});
var CD = n_.define(), _D = NC.define({ create: function() {
  return true;
}, update: function(e22, t2) {
  var n2, r2 = bi(t2.effects);
  try {
    for (r2.s(); !(n2 = r2.n()).done; ) {
      var i2 = n2.value;
      i2.is(CD) && (e22 = i2.value);
    }
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
  return e22;
}, provide: function(e22) {
  return VE.from(e22, function(e23) {
    return e23 ? SD : null;
  });
} }), $D = MM.baseTheme({ ".cm-panel.cm-gotoLine": { padding: "2px 6px 4px", "& label": { fontSize: "80%" } } }), OD = { highlightWordAroundCursor: false, minSelectionLength: 1, maxMatches: 100, wholeWords: false }, AD = $C.define({ combine: function(e22) {
  return p_(e22, OD, { highlightWordAroundCursor: function(e23, t2) {
    return e23 || t2;
  }, minSelectionLength: Math.min, maxMatches: Math.min });
} });
var MD = Y$.mark({ class: "cm-selectionMatch" }), ED = Y$.mark({ class: "cm-selectionMatch cm-selectionMatch-main" });
function PD(e22, t2, n2, r2) {
  return !(n2 != 0 && e22(t2.sliceDoc(n2 - 1, n2)) == f_.Word || r2 != t2.doc.length && e22(t2.sliceDoc(r2, r2 + 1)) == f_.Word);
}
var ND = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.decorations = this.getDeco(t2);
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    (e23.selectionSet || e23.docChanged || e23.viewportChanged) && (this.decorations = this.getDeco(e23.view));
  } }, { key: "getDeco", value: function(e23) {
    var t2 = e23.state.facet(AD), n2 = e23.state, r2 = n2.selection;
    if (r2.ranges.length > 1)
      return Y$.none;
    var i2, o2 = r2.main, a2 = null;
    if (o2.empty) {
      if (!t2.highlightWordAroundCursor)
        return Y$.none;
      var s2 = n2.wordAt(o2.head);
      if (!s2)
        return Y$.none;
      a2 = n2.charCategorizer(o2.head), i2 = n2.sliceDoc(s2.from, s2.to);
    } else {
      var u2 = o2.to - o2.from;
      if (u2 < t2.minSelectionLength || u2 > 200)
        return Y$.none;
      if (t2.wholeWords) {
        if (i2 = n2.sliceDoc(o2.from, o2.to), !PD(a2 = n2.charCategorizer(o2.head), n2, o2.from, o2.to) || !function(e24, t3, n3, r3) {
          return e24(t3.sliceDoc(n3, n3 + 1)) == f_.Word && e24(t3.sliceDoc(r3 - 1, r3)) == f_.Word;
        }(a2, n2, o2.from, o2.to))
          return Y$.none;
      } else if (!(i2 = n2.sliceDoc(o2.from, o2.to).trim()))
        return Y$.none;
    }
    var c2, l2 = [], f2 = bi(e23.visibleRanges);
    try {
      for (f2.s(); !(c2 = f2.n()).done; )
        for (var h2 = c2.value, d2 = new gD(n2.doc, i2, h2.from, h2.to); !d2.next().done; ) {
          var v2 = d2.value, p2 = v2.from, m2 = v2.to;
          if ((!a2 || PD(a2, n2, p2, m2)) && (o2.empty && p2 <= o2.from && m2 >= o2.to ? l2.push(ED.range(p2, m2)) : (p2 >= o2.to || m2 <= o2.from) && l2.push(MD.range(p2, m2)), l2.length > t2.maxMatches))
            return Y$.none;
        }
    } catch (e24) {
      f2.e(e24);
    } finally {
      f2.f();
    }
    return Y$.set(l2);
  } }]), e22;
}(), { decorations: function(e22) {
  return e22.decorations;
} }), TD = MM.baseTheme({ ".cm-selectionMatch": { backgroundColor: "#99ff7780" }, ".cm-searchMatch .cm-selectionMatch": { backgroundColor: "transparent" } });
var ID = $C.define({ combine: function(e22) {
  var t2;
  return { top: e22.reduce(function(e23, t3) {
    return e23 != null ? e23 : t3.top;
  }, void 0) || false, caseSensitive: e22.reduce(function(e23, t3) {
    return e23 != null ? e23 : t3.caseSensitive;
  }, void 0) || false, createPanel: ((t2 = e22.find(function(e23) {
    return e23.createPanel;
  })) === null || t2 === void 0 ? void 0 : t2.createPanel) || function(e23) {
    return new sz(e23);
  } };
} });
function RD(e22) {
  return e22 ? [ID.of(e22), hz] : hz;
}
var DD = function() {
  function e22(t2) {
    Ri(this, e22), this.search = t2.search, this.caseSensitive = !!t2.caseSensitive, this.regexp = !!t2.regexp, this.replace = t2.replace || "", this.valid = !!this.search && (!this.regexp || function(e23) {
      try {
        return new RegExp(e23, bD), true;
      } catch (e24) {
        return false;
      }
    }(this.search)), this.unquoted = t2.literal ? this.search : this.search.replace(/\\([nrt\\])/g, function(e23, t3) {
      return t3 == "n" ? "\n" : t3 == "r" ? "\r" : t3 == "t" ? "	" : "\\";
    });
  }
  return zi(e22, [{ key: "eq", value: function(e23) {
    return this.search == e23.search && this.replace == e23.replace && this.caseSensitive == e23.caseSensitive && this.regexp == e23.regexp;
  } }, { key: "create", value: function() {
    return this.regexp ? new FD(this) : new BD(this);
  } }, { key: "getCursor", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : e23.length;
    return this.regexp ? qD(this, e23, t2, n2) : LD(this, e23, t2, n2);
  } }]), e22;
}(), zD = zi(function e11(t2) {
  Ri(this, e11), this.spec = t2;
});
function LD(e22, t2, n2, r2) {
  return new gD(t2, e22.unquoted, n2, r2, e22.caseSensitive ? void 0 : function(e23) {
    return e23.toLowerCase();
  });
}
var BD = function(e22) {
  ji(n2, zD);
  var t2 = Ci(n2);
  function n2(e23) {
    return Ri(this, n2), t2.call(this, e23);
  }
  return zi(n2, [{ key: "nextMatch", value: function(e23, t3, n3) {
    var r2 = LD(this.spec, e23, n3, e23.length).nextOverlapping();
    return r2.done && (r2 = LD(this.spec, e23, 0, t3).nextOverlapping()), r2.done ? null : r2.value;
  } }, { key: "prevMatchInRange", value: function(e23, t3, n3) {
    for (var r2 = n3; ; ) {
      for (var i2 = Math.max(t3, r2 - 1e4 - this.spec.unquoted.length), o2 = LD(this.spec, e23, i2, r2), a2 = null; !o2.nextOverlapping().done; )
        a2 = o2.value;
      if (a2)
        return a2;
      if (i2 == t3)
        return null;
      r2 -= 1e4;
    }
  } }, { key: "prevMatch", value: function(e23, t3, n3) {
    return this.prevMatchInRange(e23, 0, t3) || this.prevMatchInRange(e23, n3, e23.length);
  } }, { key: "getReplacement", value: function(e23) {
    return this.spec.replace;
  } }, { key: "matchAll", value: function(e23, t3) {
    for (var n3 = LD(this.spec, e23, 0, e23.length), r2 = []; !n3.next().done; ) {
      if (r2.length >= t3)
        return null;
      r2.push(n3.value);
    }
    return r2;
  } }, { key: "highlight", value: function(e23, t3, n3, r2) {
    for (var i2 = LD(this.spec, e23, Math.max(0, t3 - this.spec.unquoted.length), Math.min(n3 + this.spec.unquoted.length, e23.length)); !i2.next().done; )
      r2(i2.value.from, i2.value.to);
  } }]), n2;
}();
function qD(e22, t2, n2, r2) {
  return new kD(t2, e22.search, e22.caseSensitive ? void 0 : { ignoreCase: true }, n2, r2);
}
var FD = function(e22) {
  ji(n2, zD);
  var t2 = Ci(n2);
  function n2() {
    return Ri(this, n2), t2.apply(this, arguments);
  }
  return zi(n2, [{ key: "nextMatch", value: function(e23, t3, n3) {
    var r2 = qD(this.spec, e23, n3, e23.length).next();
    return r2.done && (r2 = qD(this.spec, e23, 0, t3).next()), r2.done ? null : r2.value;
  } }, { key: "prevMatchInRange", value: function(e23, t3, n3) {
    for (var r2 = 1; ; r2++) {
      for (var i2 = Math.max(t3, n3 - 1e4 * r2), o2 = qD(this.spec, e23, i2, n3), a2 = null; !o2.next().done; )
        a2 = o2.value;
      if (a2 && (i2 == t3 || a2.from > i2 + 10))
        return a2;
      if (i2 == t3)
        return null;
    }
  } }, { key: "prevMatch", value: function(e23, t3, n3) {
    return this.prevMatchInRange(e23, 0, t3) || this.prevMatchInRange(e23, n3, e23.length);
  } }, { key: "getReplacement", value: function(e23) {
    return this.spec.replace.replace(/\$([$&\d+])/g, function(t3, n3) {
      return n3 == "$" ? "$" : n3 == "&" ? e23.match[0] : n3 != "0" && +n3 < e23.match.length ? e23.match[n3] : t3;
    });
  } }, { key: "matchAll", value: function(e23, t3) {
    for (var n3 = qD(this.spec, e23, 0, e23.length), r2 = []; !n3.next().done; ) {
      if (r2.length >= t3)
        return null;
      r2.push(n3.value);
    }
    return r2;
  } }, { key: "highlight", value: function(e23, t3, n3, r2) {
    for (var i2 = qD(this.spec, e23, Math.max(0, t3 - 250), Math.min(n3 + 250, e23.length)); !i2.next().done; )
      r2(i2.value.from, i2.value.to);
  } }]), n2;
}(), VD = n_.define(), HD = n_.define(), WD = NC.define({ create: function(e22) {
  return new JD(rz(e22).create(), null);
}, update: function(e22, t2) {
  var n2, r2 = bi(t2.effects);
  try {
    for (r2.s(); !(n2 = r2.n()).done; ) {
      var i2 = n2.value;
      i2.is(VD) ? e22 = new JD(i2.value.create(), e22.panel) : i2.is(HD) && (e22 = new JD(e22.query, i2.value ? nz : null));
    }
  } catch (e23) {
    r2.e(e23);
  } finally {
    r2.f();
  }
  return e22;
}, provide: function(e22) {
  return VE.from(e22, function(e23) {
    return e23.panel;
  });
} }), JD = zi(function e12(t2, n2) {
  Ri(this, e12), this.query = t2, this.panel = n2;
}), UD = Y$.mark({ class: "cm-searchMatch" }), KD = Y$.mark({ class: "cm-searchMatch cm-searchMatch-selected" }), GD = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.view = t2, this.decorations = this.highlight(t2.state.field(WD));
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    var t2 = e23.state.field(WD);
    (t2 != e23.startState.field(WD) || e23.docChanged || e23.selectionSet || e23.viewportChanged) && (this.decorations = this.highlight(t2));
  } }, { key: "highlight", value: function(e23) {
    var t2 = e23.query;
    if (!e23.panel || !t2.spec.valid)
      return Y$.none;
    for (var n2 = this.view, r2 = new x_(), i2 = 0, o2 = n2.visibleRanges, a2 = o2.length; i2 < a2; i2++) {
      for (var s2 = o2[i2], u2 = s2.from, c2 = s2.to; i2 < a2 - 1 && c2 > o2[i2 + 1].from - 500; )
        c2 = o2[++i2].to;
      t2.highlight(n2.state.doc, u2, c2, function(e24, t3) {
        var i3 = n2.state.selection.ranges.some(function(n3) {
          return n3.from == e24 && n3.to == t3;
        });
        r2.add(e24, t3, i3 ? KD : UD);
      });
    }
    return r2.finish();
  } }]), e22;
}(), { decorations: function(e22) {
  return e22.decorations;
} });
function QD(e22) {
  return function(t2) {
    var n2 = t2.state.field(WD, false);
    return n2 && n2.query.spec.valid ? e22(t2, n2) : iz(t2);
  };
}
var YD = QD(function(e22, t2) {
  var n2 = t2.query, r2 = e22.state.selection.main, i2 = r2.from, o2 = r2.to, a2 = n2.nextMatch(e22.state.doc, i2, o2);
  return !(!a2 || a2.from == i2 && a2.to == o2) && (e22.dispatch({ selection: { anchor: a2.from, head: a2.to }, scrollIntoView: true, effects: lz(e22, a2), userEvent: "select.search" }), true);
}), ZD = QD(function(e22, t2) {
  var n2 = t2.query, r2 = e22.state, i2 = r2.selection.main, o2 = i2.from, a2 = i2.to, s2 = n2.prevMatch(r2.doc, o2, a2);
  return !!s2 && (e22.dispatch({ selection: { anchor: s2.from, head: s2.to }, scrollIntoView: true, effects: lz(e22, s2), userEvent: "select.search" }), true);
}), XD = QD(function(e22, t2) {
  var n2 = t2.query.matchAll(e22.state.doc, 1e3);
  return !(!n2 || !n2.length) && (e22.dispatch({ selection: SC.create(n2.map(function(e23) {
    return SC.range(e23.from, e23.to);
  })), userEvent: "select.search.matches" }), true);
}), ez = QD(function(e22, t2) {
  var n2 = t2.query, r2 = e22.state, i2 = r2.selection.main, o2 = i2.from, a2 = i2.to;
  if (r2.readOnly)
    return false;
  var s2 = n2.nextMatch(r2.doc, o2, o2);
  if (!s2)
    return false;
  var u2, c2, l2 = [], f2 = [];
  if (s2.from == o2 && s2.to == a2 && (c2 = r2.toText(n2.getReplacement(s2)), l2.push({ from: s2.from, to: s2.to, insert: c2 }), s2 = n2.nextMatch(r2.doc, s2.from, s2.to), f2.push(MM.announce.of(r2.phrase("replaced match on line $", r2.doc.lineAt(o2).number) + "."))), s2) {
    var h2 = l2.length == 0 || l2[0].from >= s2.to ? 0 : s2.to - s2.from - c2.length;
    u2 = { anchor: s2.from - h2, head: s2.to - h2 }, f2.push(lz(e22, s2));
  }
  return e22.dispatch({ changes: l2, selection: u2, scrollIntoView: !!u2, effects: f2, userEvent: "input.replace" }), true;
}), tz = QD(function(e22, t2) {
  var n2 = t2.query;
  if (e22.state.readOnly)
    return false;
  var r2 = n2.matchAll(e22.state.doc, 1e9).map(function(e23) {
    return { from: e23.from, to: e23.to, insert: n2.getReplacement(e23) };
  });
  if (!r2.length)
    return false;
  var i2 = e22.state.phrase("replaced $ matches", r2.length) + ".";
  return e22.dispatch({ changes: r2, effects: MM.announce.of(i2), userEvent: "input.replace.all" }), true;
});
function nz(e22) {
  return e22.state.facet(ID).createPanel(e22);
}
function rz(e22, t2) {
  var n2, r2 = e22.selection.main, i2 = r2.empty || r2.to > r2.from + 100 ? "" : e22.sliceDoc(r2.from, r2.to), o2 = (n2 = t2 == null ? void 0 : t2.caseSensitive) !== null && n2 !== void 0 ? n2 : e22.facet(ID).caseSensitive;
  return t2 && !i2 ? t2 : new DD({ search: i2.replace(/\n/g, "\\n"), caseSensitive: o2 });
}
var iz = function(e22) {
  var t2 = e22.state.field(WD, false);
  if (t2 && t2.panel) {
    var n2 = LE(e22, nz);
    if (!n2)
      return false;
    var r2 = n2.dom.querySelector("[main-field]");
    if (r2 && r2 != e22.root.activeElement) {
      var i2 = rz(e22.state, t2.query.spec);
      i2.valid && e22.dispatch({ effects: VD.of(i2) }), r2.focus(), r2.select();
    }
  } else
    e22.dispatch({ effects: [HD.of(true), t2 ? VD.of(rz(e22.state, t2.query.spec)) : n_.appendConfig.of(hz)] });
  return true;
}, oz = function(e22) {
  var t2 = e22.state.field(WD, false);
  if (!t2 || !t2.panel)
    return false;
  var n2 = LE(e22, nz);
  return n2 && n2.dom.contains(e22.root.activeElement) && e22.focus(), e22.dispatch({ effects: HD.of(false) }), true;
}, az = [{ key: "Mod-f", run: iz, scope: "editor search-panel" }, { key: "F3", run: YD, shift: ZD, scope: "editor search-panel", preventDefault: true }, { key: "Mod-g", run: YD, shift: ZD, scope: "editor search-panel", preventDefault: true }, { key: "Escape", run: oz, scope: "editor search-panel" }, { key: "Mod-Shift-l", run: function(e22) {
  var t2 = e22.state, n2 = e22.dispatch, r2 = t2.selection;
  if (r2.ranges.length > 1 || r2.main.empty)
    return false;
  for (var i2 = r2.main, o2 = i2.from, a2 = i2.to, s2 = [], u2 = 0, c2 = new gD(t2.doc, t2.sliceDoc(o2, a2)); !c2.next().done; ) {
    if (s2.length > 1e3)
      return false;
    c2.value.from == o2 && (u2 = s2.length), s2.push(SC.range(c2.value.from, c2.value.to));
  }
  return n2(t2.update({ selection: SC.create(s2, u2), userEvent: "select.search.matches" })), true;
} }, { key: "Alt-g", run: function(e22) {
  var t2 = LE(e22, SD);
  if (!t2) {
    var n2 = [CD.of(true)];
    e22.state.field(_D, false) == null && n2.push(n_.appendConfig.of([_D, $D])), e22.dispatch({ effects: n2 }), t2 = LE(e22, SD);
  }
  return t2 && t2.dom.querySelector("input").focus(), true;
} }, { key: "Mod-d", run: function(e22) {
  var t2 = e22.state, n2 = e22.dispatch, r2 = t2.selection.ranges;
  if (r2.some(function(e23) {
    return e23.from === e23.to;
  }))
    return function(e23) {
      var t3 = e23.state, n3 = e23.dispatch, r3 = t3.selection, i3 = SC.create(r3.ranges.map(function(e24) {
        return t3.wordAt(e24.head) || SC.cursor(e24.head);
      }), r3.mainIndex);
      return !i3.eq(r3) && (n3(t3.update({ selection: i3 })), true);
    }({ state: t2, dispatch: n2 });
  var i2 = t2.sliceDoc(r2[0].from, r2[0].to);
  if (t2.selection.ranges.some(function(e23) {
    return t2.sliceDoc(e23.from, e23.to) != i2;
  }))
    return false;
  var o2 = function(e23, t3) {
    for (var n3 = e23.selection, r3 = n3.main, i3 = n3.ranges, o3 = e23.wordAt(r3.head), a2 = o3 && o3.from == r3.from && o3.to == r3.to, s2 = function(n4, r4) {
      if (r4.next(), !r4.done) {
        if (n4 && i3.some(function(e24) {
          return e24.from == r4.value.from;
        }))
          return c2 = r4, u2 = n4, "continue";
        if (a2) {
          var o4 = e23.wordAt(r4.value.from);
          if (!o4 || o4.from != r4.value.from || o4.to != r4.value.to)
            return c2 = r4, u2 = n4, "continue";
        }
        return u2 = n4, c2 = r4, { v: r4.value };
      }
      if (n4)
        return c2 = r4, u2 = n4, { v: null };
      r4 = new gD(e23.doc, t3, 0, Math.max(0, i3[i3.length - 1].from - 1)), u2 = n4 = true, c2 = r4;
    }, u2 = false, c2 = new gD(e23.doc, t3, i3[i3.length - 1].to); ; ) {
      var l2 = s2(u2, c2);
      if (l2 !== "continue" && Li(l2) === "object")
        return l2.v;
    }
  }(t2, i2);
  return !!o2 && (n2(t2.update({ selection: t2.selection.addRange(SC.range(o2.from, o2.to), false), effects: MM.scrollIntoView(o2.to) })), true);
}, preventDefault: true }], sz = function() {
  function e22(t2) {
    var n2 = this;
    Ri(this, e22), this.view = t2;
    var r2 = this.query = t2.state.field(WD).query.spec;
    function i2(e23, t3, n3) {
      return vD("button", { class: "cm-button", name: e23, onclick: t3, type: "button" }, n3);
    }
    this.commit = this.commit.bind(this), this.searchField = vD("input", { value: r2.search, placeholder: uz(t2, "Find"), "aria-label": uz(t2, "Find"), class: "cm-textfield", name: "search", "main-field": "true", onchange: this.commit, onkeyup: this.commit }), this.replaceField = vD("input", { value: r2.replace, placeholder: uz(t2, "Replace"), "aria-label": uz(t2, "Replace"), class: "cm-textfield", name: "replace", onchange: this.commit, onkeyup: this.commit }), this.caseField = vD("input", { type: "checkbox", name: "case", checked: r2.caseSensitive, onchange: this.commit }), this.reField = vD("input", { type: "checkbox", name: "re", checked: r2.regexp, onchange: this.commit }), this.dom = vD("div", { onkeydown: function(e23) {
      return n2.keydown(e23);
    }, class: "cm-search" }, [this.searchField, i2("next", function() {
      return YD(t2);
    }, [uz(t2, "next")]), i2("prev", function() {
      return ZD(t2);
    }, [uz(t2, "previous")]), i2("select", function() {
      return XD(t2);
    }, [uz(t2, "all")]), vD("label", null, [this.caseField, uz(t2, "match case")]), vD("label", null, [this.reField, uz(t2, "regexp")])].concat(Ni(t2.state.readOnly ? [] : [vD("br"), this.replaceField, i2("replace", function() {
      return ez(t2);
    }, [uz(t2, "replace")]), i2("replaceAll", function() {
      return tz(t2);
    }, [uz(t2, "replace all")]), vD("button", { name: "close", onclick: function() {
      return oz(t2);
    }, "aria-label": uz(t2, "close"), type: "button" }, ["\xD7"])])));
  }
  return zi(e22, [{ key: "commit", value: function() {
    var e23 = new DD({ search: this.searchField.value, caseSensitive: this.caseField.checked, regexp: this.reField.checked, replace: this.replaceField.value });
    e23.eq(this.query) || (this.query = e23, this.view.dispatch({ effects: VD.of(e23) }));
  } }, { key: "keydown", value: function(e23) {
    var t2, n2, r2;
    t2 = this.view, n2 = e23, r2 = "search-panel", VM(qM(t2.state), n2, t2, r2) ? e23.preventDefault() : e23.keyCode == 13 && e23.target == this.searchField ? (e23.preventDefault(), (e23.shiftKey ? ZD : YD)(this.view)) : e23.keyCode == 13 && e23.target == this.replaceField && (e23.preventDefault(), ez(this.view));
  } }, { key: "update", value: function(e23) {
    var t2, n2 = bi(e23.transactions);
    try {
      for (n2.s(); !(t2 = n2.n()).done; ) {
        var r2, i2 = bi(t2.value.effects);
        try {
          for (i2.s(); !(r2 = i2.n()).done; ) {
            var o2 = r2.value;
            o2.is(VD) && !o2.value.eq(this.query) && this.setQuery(o2.value);
          }
        } catch (e24) {
          i2.e(e24);
        } finally {
          i2.f();
        }
      }
    } catch (e24) {
      n2.e(e24);
    } finally {
      n2.f();
    }
  } }, { key: "setQuery", value: function(e23) {
    this.query = e23, this.searchField.value = e23.search, this.replaceField.value = e23.replace, this.caseField.checked = e23.caseSensitive, this.reField.checked = e23.regexp;
  } }, { key: "mount", value: function() {
    this.searchField.select();
  } }, { key: "pos", get: function() {
    return 80;
  } }, { key: "top", get: function() {
    return this.view.state.facet(ID).top;
  } }]), e22;
}();
function uz(e22, t2) {
  return e22.state.phrase(t2);
}
var cz = /[\s\.,:;?!]/;
function lz(e22, t2) {
  var n2 = t2.from, r2 = t2.to, i2 = e22.state.doc.lineAt(n2), o2 = e22.state.doc.lineAt(r2).to, a2 = Math.max(i2.from, n2 - 30), s2 = Math.min(o2, r2 + 30), u2 = e22.state.sliceDoc(a2, s2);
  if (a2 != i2.from) {
    for (var c2 = 0; c2 < 30; c2++)
      if (!cz.test(u2[c2 + 1]) && cz.test(u2[c2])) {
        u2 = u2.slice(c2);
        break;
      }
  }
  if (s2 != o2) {
    for (var l2 = u2.length - 1; l2 > u2.length - 30; l2--)
      if (!cz.test(u2[l2 - 1]) && cz.test(u2[l2])) {
        u2 = u2.slice(0, l2);
        break;
      }
  }
  return MM.announce.of("".concat(e22.state.phrase("current match"), ". ").concat(u2, " ").concat(e22.state.phrase("on line"), " ").concat(i2.number, "."));
}
var fz = MM.baseTheme({ ".cm-panel.cm-search": { padding: "2px 6px 4px", position: "relative", "& [name=close]": { position: "absolute", top: "0", right: "4px", backgroundColor: "inherit", border: "none", font: "inherit", padding: 0, margin: 0 }, "& input, & button, & label": { margin: ".2em .6em .2em 0" }, "& input[type=checkbox]": { marginRight: ".2em" }, "& label": { fontSize: "80%", whiteSpace: "pre" } }, "&light .cm-searchMatch": { backgroundColor: "#ffff0054" }, "&dark .cm-searchMatch": { backgroundColor: "#00ffff8a" }, "&light .cm-searchMatch-selected": { backgroundColor: "#ff6a0054" }, "&dark .cm-searchMatch-selected": { backgroundColor: "#ff00ff8a" } }), hz = [WD, LC.lowest(GD), fz], dz = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.state = t2, this.pos = n2, this.explicit = r2, this.abortListeners = [];
  }
  return zi(e22, [{ key: "tokenBefore", value: function(e23) {
    for (var t2 = VN(this.state).resolveInner(this.pos, -1); t2 && e23.indexOf(t2.name) < 0; )
      t2 = t2.parent;
    return t2 ? { from: t2.from, to: this.pos, text: this.state.sliceDoc(t2.from, this.pos), type: t2.type } : null;
  } }, { key: "matchBefore", value: function(e23) {
    var t2 = this.state.doc.lineAt(this.pos), n2 = Math.max(t2.from, this.pos - 250), r2 = t2.text.slice(n2 - t2.from, this.pos - t2.from), i2 = r2.search(yz(e23, false));
    return i2 < 0 ? null : { from: n2 + i2, to: this.pos, text: r2.slice(i2) };
  } }, { key: "aborted", get: function() {
    return this.abortListeners == null;
  } }, { key: "addEventListener", value: function(e23, t2) {
    e23 == "abort" && this.abortListeners && this.abortListeners.push(t2);
  } }]), e22;
}();
function vz(e22) {
  var t2 = Object.keys(e22).join(""), n2 = /\w/.test(t2);
  return n2 && (t2 = t2.replace(/\w/g, "")), "[".concat(n2 ? "\\w" : "").concat(t2.replace(/[^\w\s]/g, "\\$&"), "]");
}
function pz(e22) {
  var t2 = e22.map(function(e23) {
    return typeof e23 == "string" ? { label: e23 } : e23;
  }), n2 = xi(t2.every(function(e23) {
    return /^\w+$/.test(e23.label);
  }) ? [/\w*$/, /\w+$/] : function(e23) {
    var t3, n3 = /* @__PURE__ */ Object.create(null), r3 = /* @__PURE__ */ Object.create(null), i3 = bi(e23);
    try {
      for (i3.s(); !(t3 = i3.n()).done; ) {
        var o2 = t3.value.label;
        n3[o2[0]] = true;
        for (var a2 = 1; a2 < o2.length; a2++)
          r3[o2[a2]] = true;
      }
    } catch (e24) {
      i3.e(e24);
    } finally {
      i3.f();
    }
    var s2 = vz(n3) + vz(r3) + "*$";
    return [new RegExp("^" + s2), new RegExp(s2)];
  }(t2), 2), r2 = n2[0], i2 = n2[1];
  return function(e23) {
    var n3 = e23.matchBefore(i2);
    return n3 || e23.explicit ? { from: n3 ? n3.from : e23.pos, options: t2, validFor: r2 } : null;
  };
}
var mz = zi(function e13(t2, n2, r2) {
  Ri(this, e13), this.completion = t2, this.source = n2, this.match = r2;
});
function gz(e22) {
  return e22.selection.main.head;
}
function yz(e22, t2) {
  var n2, r2 = e22.source, i2 = t2 && r2[0] != "^", o2 = r2[r2.length - 1] != "$";
  return i2 || o2 ? new RegExp("".concat(i2 ? "^" : "", "(?:").concat(r2, ")").concat(o2 ? "$" : ""), (n2 = e22.flags) !== null && n2 !== void 0 ? n2 : e22.ignoreCase ? "i" : "") : e22;
}
function bz(e22, t2) {
  var n2 = t2.completion.apply || t2.completion.label, r2 = t2.source;
  typeof n2 == "string" ? e22.dispatch(function(e23, t3, n3, r3) {
    return Object.assign(Object.assign({}, e23.changeByRange(function(i2) {
      if (i2 == e23.selection.main)
        return { changes: { from: n3, to: r3, insert: t3 }, range: SC.cursor(n3 + t3.length) };
      var o2 = r3 - n3;
      return !i2.empty || o2 && e23.sliceDoc(i2.from - o2, i2.from) != e23.sliceDoc(n3, r3) ? { range: i2 } : { changes: { from: i2.from - o2, to: i2.from, insert: t3 }, range: SC.cursor(i2.from - o2 + t3.length) };
    })), { userEvent: "input.complete" });
  }(e22.state, n2, r2.from, r2.to)) : n2(e22, t2.completion, r2.from, r2.to);
}
var kz = /* @__PURE__ */ new WeakMap();
function wz(e22) {
  if (!Array.isArray(e22))
    return e22;
  var t2 = kz.get(e22);
  return t2 || kz.set(e22, t2 = pz(e22)), t2;
}
var xz = function() {
  function e22(t2) {
    Ri(this, e22), this.pattern = t2, this.chars = [], this.folded = [], this.any = [], this.precise = [], this.byWord = [];
    for (var n2 = 0; n2 < t2.length; ) {
      var r2 = lC(t2, n2), i2 = hC(r2);
      this.chars.push(r2);
      var o2 = t2.slice(n2, n2 + i2), a2 = o2.toUpperCase();
      this.folded.push(lC(a2 == o2 ? o2.toLowerCase() : a2, 0)), n2 += i2;
    }
    this.astral = t2.length != this.chars.length;
  }
  return zi(e22, [{ key: "match", value: function(e23) {
    if (this.pattern.length == 0)
      return [0];
    if (e23.length < this.pattern.length)
      return null;
    var t2 = this.chars, n2 = this.folded, r2 = this.any, i2 = this.precise, o2 = this.byWord;
    if (t2.length == 1) {
      var a2 = lC(e23, 0);
      return a2 == t2[0] ? [0, 0, hC(a2)] : a2 == n2[0] ? [-200, 0, hC(a2)] : null;
    }
    var s2 = e23.indexOf(this.pattern);
    if (s2 == 0)
      return [0, 0, this.pattern.length];
    var u2 = t2.length, c2 = 0;
    if (s2 < 0) {
      for (var l2 = 0, f2 = Math.min(e23.length, 200); l2 < f2 && c2 < u2; ) {
        var h2 = lC(e23, l2);
        h2 != t2[c2] && h2 != n2[c2] || (r2[c2++] = l2), l2 += hC(h2);
      }
      if (c2 < u2)
        return null;
    }
    for (var d2 = 0, v2 = 0, p2 = false, m2 = 0, g2 = -1, y2 = -1, b2 = /[a-z]/.test(e23), k2 = true, w2 = 0, x2 = Math.min(e23.length, 200), j2 = 0; w2 < x2 && v2 < u2; ) {
      var S2 = lC(e23, w2);
      s2 < 0 && (d2 < u2 && S2 == t2[d2] && (i2[d2++] = w2), m2 < u2 && (S2 == t2[m2] || S2 == n2[m2] ? (m2 == 0 && (g2 = w2), y2 = w2 + 1, m2++) : m2 = 0));
      var C2 = void 0, _2 = S2 < 255 ? S2 >= 48 && S2 <= 57 || S2 >= 97 && S2 <= 122 ? 2 : S2 >= 65 && S2 <= 90 ? 1 : 0 : (C2 = fC(S2)) != C2.toLowerCase() ? 1 : C2 != C2.toUpperCase() ? 2 : 0;
      (!w2 || _2 == 1 && b2 || j2 == 0 && _2 != 0) && (t2[v2] == S2 || n2[v2] == S2 && (p2 = true) ? o2[v2++] = w2 : o2.length && (k2 = false)), j2 = _2, w2 += hC(S2);
    }
    return v2 == u2 && o2[0] == 0 && k2 ? this.result((p2 ? -200 : 0) - 100, o2, e23) : m2 == u2 && g2 == 0 ? [-200 - e23.length, 0, y2] : s2 > -1 ? [-700 - e23.length, s2, s2 + this.pattern.length] : m2 == u2 ? [-900 - e23.length, g2, y2] : v2 == u2 ? this.result((p2 ? -200 : 0) - 100 - 700 + (k2 ? 0 : -1100), o2, e23) : t2.length == 2 ? null : this.result((r2[0] ? -700 : 0) - 200 - 1100, r2, e23);
  } }, { key: "result", value: function(e23, t2, n2) {
    var r2, i2 = [e23 - n2.length], o2 = 1, a2 = bi(t2);
    try {
      for (a2.s(); !(r2 = a2.n()).done; ) {
        var s2 = r2.value, u2 = s2 + (this.astral ? hC(lC(n2, s2)) : 1);
        o2 > 1 && i2[o2 - 1] == s2 ? i2[o2 - 1] = u2 : (i2[o2++] = s2, i2[o2++] = u2);
      }
    } catch (e24) {
      a2.e(e24);
    } finally {
      a2.f();
    }
    return i2;
  } }]), e22;
}(), jz = $C.define({ combine: function(e22) {
  return p_(e22, { activateOnTyping: true, override: null, closeOnBlur: true, maxRenderedOptions: 100, defaultKeymap: true, optionClass: function() {
    return "";
  }, aboveCursor: false, icons: true, addToOptions: [] }, { defaultKeymap: function(e23, t2) {
    return e23 && t2;
  }, closeOnBlur: function(e23, t2) {
    return e23 && t2;
  }, icons: function(e23, t2) {
    return e23 && t2;
  }, optionClass: function(e23, t2) {
    return function(n2) {
      return function(e24, t3) {
        return e24 ? t3 ? e24 + " " + t3 : e24 : t3;
      }(e23(n2), t2(n2));
    };
  }, addToOptions: function(e23, t2) {
    return e23.concat(t2);
  } });
} });
function Sz(e22, t2, n2) {
  if (e22 <= n2)
    return { from: 0, to: e22 };
  if (t2 <= e22 >> 1) {
    var r2 = Math.floor(t2 / n2);
    return { from: r2 * n2, to: (r2 + 1) * n2 };
  }
  var i2 = Math.floor((e22 - t2) / n2);
  return { from: e22 - (i2 + 1) * n2, to: e22 - i2 * n2 };
}
var Cz = function() {
  function e22(t2, n2) {
    var r2 = this;
    Ri(this, e22), this.view = t2, this.stateField = n2, this.info = null, this.placeInfo = { read: function() {
      return r2.measureInfo();
    }, write: function(e23) {
      return r2.positionInfo(e23);
    }, key: this };
    var i2 = t2.state.field(n2), o2 = i2.open, a2 = o2.options, s2 = o2.selected, u2 = t2.state.facet(jz);
    this.optionContent = function(e23) {
      var t3 = e23.addToOptions.slice();
      return e23.icons && t3.push({ render: function(e24) {
        var t4, n3 = document.createElement("div");
        return n3.classList.add("cm-completionIcon"), e24.type && (t4 = n3.classList).add.apply(t4, Ni(e24.type.split(/\s+/g).map(function(e25) {
          return "cm-completionIcon-" + e25;
        }))), n3.setAttribute("aria-hidden", "true"), n3;
      }, position: 20 }), t3.push({ render: function(e24, t4, n3) {
        var r3 = document.createElement("span");
        r3.className = "cm-completionLabel";
        for (var i3 = e24.label, o3 = 0, a3 = 1; a3 < n3.length; ) {
          var s3 = n3[a3++], u3 = n3[a3++];
          s3 > o3 && r3.appendChild(document.createTextNode(i3.slice(o3, s3)));
          var c2 = r3.appendChild(document.createElement("span"));
          c2.appendChild(document.createTextNode(i3.slice(s3, u3))), c2.className = "cm-completionMatchedText", o3 = u3;
        }
        return o3 < i3.length && r3.appendChild(document.createTextNode(i3.slice(o3))), r3;
      }, position: 50 }, { render: function(e24) {
        if (!e24.detail)
          return null;
        var t4 = document.createElement("span");
        return t4.className = "cm-completionDetail", t4.textContent = e24.detail, t4;
      }, position: 80 }), t3.sort(function(e24, t4) {
        return e24.position - t4.position;
      }).map(function(e24) {
        return e24.render;
      });
    }(u2), this.optionClass = u2.optionClass, this.range = Sz(a2.length, s2, u2.maxRenderedOptions), this.dom = document.createElement("div"), this.dom.className = "cm-tooltip-autocomplete", this.dom.addEventListener("mousedown", function(e23) {
      for (var n3, i3 = e23.target; i3 && i3 != r2.dom; i3 = i3.parentNode)
        if (i3.nodeName == "LI" && (n3 = /-(\d+)$/.exec(i3.id)) && +n3[1] < a2.length)
          return bz(t2, a2[+n3[1]]), void e23.preventDefault();
    }), this.list = this.dom.appendChild(this.createListBox(a2, i2.id, this.range)), this.list.addEventListener("scroll", function() {
      r2.info && r2.view.requestMeasure(r2.placeInfo);
    });
  }
  return zi(e22, [{ key: "mount", value: function() {
    this.updateSel();
  } }, { key: "update", value: function(e23) {
    e23.state.field(this.stateField) != e23.startState.field(this.stateField) && this.updateSel();
  } }, { key: "positioned", value: function() {
    this.info && this.view.requestMeasure(this.placeInfo);
  } }, { key: "updateSel", value: function() {
    var e23 = this, t2 = this.view.state.field(this.stateField), n2 = t2.open;
    if ((n2.selected < this.range.from || n2.selected >= this.range.to) && (this.range = Sz(n2.options.length, n2.selected, this.view.state.facet(jz).maxRenderedOptions), this.list.remove(), this.list = this.dom.appendChild(this.createListBox(n2.options, t2.id, this.range)), this.list.addEventListener("scroll", function() {
      e23.info && e23.view.requestMeasure(e23.placeInfo);
    })), this.updateSelectedOption(n2.selected)) {
      this.info && (this.info.remove(), this.info = null);
      var r2 = n2.options[n2.selected].completion, i2 = r2.info;
      if (!i2)
        return;
      var o2 = typeof i2 == "string" ? document.createTextNode(i2) : i2(r2);
      if (!o2)
        return;
      "then" in o2 ? o2.then(function(n3) {
        n3 && e23.view.state.field(e23.stateField, false) == t2 && e23.addInfoPane(n3);
      }).catch(function(t3) {
        return gO(e23.view.state, t3, "completion info");
      }) : this.addInfoPane(o2);
    }
  } }, { key: "addInfoPane", value: function(e23) {
    var t2 = this.info = document.createElement("div");
    t2.className = "cm-tooltip cm-completionInfo", t2.appendChild(e23), this.dom.appendChild(t2), this.view.requestMeasure(this.placeInfo);
  } }, { key: "updateSelectedOption", value: function(e23) {
    for (var t2 = null, n2 = this.list.firstChild, r2 = this.range.from; n2; n2 = n2.nextSibling, r2++)
      r2 == e23 ? n2.hasAttribute("aria-selected") || (n2.setAttribute("aria-selected", "true"), t2 = n2) : n2.hasAttribute("aria-selected") && n2.removeAttribute("aria-selected");
    return t2 && function(e24, t3) {
      var n3 = e24.getBoundingClientRect(), r3 = t3.getBoundingClientRect();
      r3.top < n3.top ? e24.scrollTop -= n3.top - r3.top : r3.bottom > n3.bottom && (e24.scrollTop += r3.bottom - n3.bottom);
    }(this.list, t2), t2;
  } }, { key: "measureInfo", value: function() {
    var e23 = this.dom.querySelector("[aria-selected]");
    if (!e23 || !this.info)
      return null;
    var t2 = this.dom.getBoundingClientRect(), n2 = this.info.getBoundingClientRect(), r2 = e23.getBoundingClientRect();
    if (r2.top > Math.min(innerHeight, t2.bottom) - 10 || r2.bottom < Math.max(0, t2.top) + 10)
      return null;
    var i2 = Math.max(0, Math.min(r2.top, innerHeight - n2.height)) - t2.top, o2 = this.view.textDirection == EO.RTL, a2 = t2.left, s2 = innerWidth - t2.right;
    return o2 && a2 < Math.min(n2.width, s2) ? o2 = false : !o2 && s2 < Math.min(n2.width, a2) && (o2 = true), { top: i2, left: o2 };
  } }, { key: "positionInfo", value: function(e23) {
    this.info && (this.info.style.top = (e23 ? e23.top : -1e6) + "px", e23 && (this.info.classList.toggle("cm-completionInfo-left", e23.left), this.info.classList.toggle("cm-completionInfo-right", !e23.left)));
  } }, { key: "createListBox", value: function(e23, t2, n2) {
    var r2 = document.createElement("ul");
    r2.id = t2, r2.setAttribute("role", "listbox"), r2.setAttribute("aria-expanded", "true"), r2.setAttribute("aria-label", this.view.state.phrase("Completions"));
    for (var i2 = n2.from; i2 < n2.to; i2++) {
      var o2 = e23[i2], a2 = o2.completion, s2 = o2.match, u2 = r2.appendChild(document.createElement("li"));
      u2.id = t2 + "-" + i2, u2.setAttribute("role", "option");
      var c2 = this.optionClass(a2);
      c2 && (u2.className = c2);
      var l2, f2 = bi(this.optionContent);
      try {
        for (f2.s(); !(l2 = f2.n()).done; ) {
          var h2 = (0, l2.value)(a2, this.view.state, s2);
          h2 && u2.appendChild(h2);
        }
      } catch (e24) {
        f2.e(e24);
      } finally {
        f2.f();
      }
    }
    return n2.from && r2.classList.add("cm-completionListIncompleteTop"), n2.to < e23.length && r2.classList.add("cm-completionListIncompleteBottom"), r2;
  } }]), e22;
}();
function _z(e22) {
  return 100 * (e22.boost || 0) + (e22.apply ? 10 : 0) + (e22.info ? 5 : 0) + (e22.type ? 1 : 0);
}
var $z = function() {
  function e22(t2, n2, r2, i2, o2) {
    Ri(this, e22), this.options = t2, this.attrs = n2, this.tooltip = r2, this.timestamp = i2, this.selected = o2;
  }
  return zi(e22, [{ key: "setSelected", value: function(t2, n2) {
    return t2 == this.selected || t2 >= this.options.length ? this : new e22(this.options, Mz(n2, t2), this.tooltip, this.timestamp, t2);
  } }, { key: "map", value: function(t2) {
    return new e22(this.options, this.attrs, Object.assign(Object.assign({}, this.tooltip), { pos: t2.mapPos(this.tooltip.pos) }), this.timestamp, this.selected);
  } }], [{ key: "build", value: function(t2, n2, r2, i2, o2) {
    var a2 = function(e23, t3) {
      var n3, r3 = [], i3 = 0, o3 = bi(e23);
      try {
        for (o3.s(); !(n3 = o3.n()).done; ) {
          var a3 = n3.value;
          if (a3.hasResult())
            if (a3.result.filter === false) {
              var s3, u3 = a3.result.getMatch, c3 = bi(a3.result.options);
              try {
                for (c3.s(); !(s3 = c3.n()).done; ) {
                  var l3 = s3.value, f2 = [1e9 - i3++];
                  if (u3) {
                    var h2, d2 = bi(u3(l3));
                    try {
                      for (d2.s(); !(h2 = d2.n()).done; ) {
                        var v2 = h2.value;
                        f2.push(v2);
                      }
                    } catch (e24) {
                      d2.e(e24);
                    } finally {
                      d2.f();
                    }
                  }
                  r3.push(new mz(l3, a3, f2));
                }
              } catch (e24) {
                c3.e(e24);
              } finally {
                c3.f();
              }
            } else {
              var p2, m2 = new xz(t3.sliceDoc(a3.from, a3.to)), g2 = void 0, y2 = bi(a3.result.options);
              try {
                for (y2.s(); !(p2 = y2.n()).done; ) {
                  var b2 = p2.value;
                  (g2 = m2.match(b2.label)) && (b2.boost != null && (g2[0] += b2.boost), r3.push(new mz(b2, a3, g2)));
                }
              } catch (e24) {
                y2.e(e24);
              } finally {
                y2.f();
              }
            }
        }
      } catch (e24) {
        o3.e(e24);
      } finally {
        o3.f();
      }
      var k2, w2 = [], x2 = null, j2 = bi(r3.sort(Pz));
      try {
        for (j2.s(); !(k2 = j2.n()).done; ) {
          var S2 = k2.value;
          !x2 || x2.label != S2.completion.label || x2.detail != S2.completion.detail || x2.type != null && S2.completion.type != null && x2.type != S2.completion.type || x2.apply != S2.completion.apply ? w2.push(S2) : _z(S2.completion) > _z(x2) && (w2[w2.length - 1] = S2), x2 = S2.completion;
        }
      } catch (e24) {
        j2.e(e24);
      } finally {
        j2.f();
      }
      return w2;
    }(t2, n2);
    if (!a2.length)
      return null;
    var s2, u2 = 0;
    if (i2 && i2.selected) {
      for (var c2 = i2.options[i2.selected].completion, l2 = 0; l2 < a2.length; l2++)
        if (a2[l2].completion == c2) {
          u2 = l2;
          break;
        }
    }
    return new e22(a2, Mz(r2, u2), { pos: t2.reduce(function(e23, t3) {
      return t3.hasResult() ? Math.min(e23, t3.from) : e23;
    }, 1e8), create: (s2 = Bz, function(e23) {
      return new Cz(e23, s2);
    }), above: o2.aboveCursor }, i2 ? i2.timestamp : Date.now(), u2);
  } }]), e22;
}(), Oz = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.active = t2, this.id = n2, this.open = r2;
  }
  return zi(e22, [{ key: "update", value: function(t2) {
    var n2 = this, r2 = t2.state, i2 = r2.facet(jz), o2 = (i2.override || r2.languageDataAt("autocomplete", gz(r2)).map(wz)).map(function(e23) {
      return (n2.active.find(function(t3) {
        return t3.source == e23;
      }) || new Tz(e23, n2.active.some(function(e24) {
        return e24.state != 0;
      }) ? 1 : 0)).update(t2, i2);
    });
    o2.length == this.active.length && o2.every(function(e23, t3) {
      return e23 == n2.active[t3];
    }) && (o2 = this.active);
    var a2 = t2.selection || o2.some(function(e23) {
      return e23.hasResult() && t2.changes.touchesRange(e23.from, e23.to);
    }) || !function(e23, t3) {
      if (e23 == t3)
        return true;
      for (var n3 = 0, r3 = 0; ; ) {
        for (; n3 < e23.length && !e23[n3].hasResult; )
          n3++;
        for (; r3 < t3.length && !t3[r3].hasResult; )
          r3++;
        var i3 = n3 == e23.length, o3 = r3 == t3.length;
        if (i3 || o3)
          return i3 == o3;
        if (e23[n3++].result != t3[r3++].result)
          return false;
      }
    }(o2, this.active) ? $z.build(o2, r2, this.id, this.open, i2) : this.open && t2.docChanged ? this.open.map(t2.changes) : this.open;
    !a2 && o2.every(function(e23) {
      return e23.state != 1;
    }) && o2.some(function(e23) {
      return e23.hasResult();
    }) && (o2 = o2.map(function(e23) {
      return e23.hasResult() ? new Tz(e23.source, 0) : e23;
    }));
    var s2, u2 = bi(t2.effects);
    try {
      for (u2.s(); !(s2 = u2.n()).done; ) {
        var c2 = s2.value;
        c2.is(Lz) && (a2 = a2 && a2.setSelected(c2.value, this.id));
      }
    } catch (e23) {
      u2.e(e23);
    } finally {
      u2.f();
    }
    return o2 == this.active && a2 == this.open ? this : new e22(o2, this.id, a2);
  } }, { key: "tooltip", get: function() {
    return this.open ? this.open.tooltip : null;
  } }, { key: "attrs", get: function() {
    return this.open ? this.open.attrs : Az;
  } }], [{ key: "start", value: function() {
    return new e22(Ez, "cm-ac-" + Math.floor(2e6 * Math.random()).toString(36), null);
  } }]), e22;
}();
var Az = { "aria-autocomplete": "list" };
function Mz(e22, t2) {
  return { "aria-autocomplete": "list", "aria-haspopup": "listbox", "aria-activedescendant": e22 + "-" + t2, "aria-controls": e22 };
}
var Ez = [];
function Pz(e22, t2) {
  var n2 = t2.match[0] - e22.match[0];
  return n2 || e22.completion.label.localeCompare(t2.completion.label);
}
function Nz(e22) {
  return e22.isUserEvent("input.type") ? "input" : e22.isUserEvent("delete.backward") ? "delete" : null;
}
var Tz = function() {
  function e22(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : -1;
    Ri(this, e22), this.source = t2, this.state = n2, this.explicitPos = r2;
  }
  return zi(e22, [{ key: "hasResult", value: function() {
    return false;
  } }, { key: "update", value: function(t2, n2) {
    var r2 = Nz(t2), i2 = this;
    r2 ? i2 = i2.handleUserEvent(t2, r2, n2) : t2.docChanged ? i2 = i2.handleChange(t2) : t2.selection && i2.state != 0 && (i2 = new e22(i2.source, 0));
    var o2, a2 = bi(t2.effects);
    try {
      for (a2.s(); !(o2 = a2.n()).done; ) {
        var s2 = o2.value;
        if (s2.is(Rz))
          i2 = new e22(i2.source, 1, s2.value ? gz(t2.state) : -1);
        else if (s2.is(Dz))
          i2 = new e22(i2.source, 0);
        else if (s2.is(zz)) {
          var u2, c2 = bi(s2.value);
          try {
            for (c2.s(); !(u2 = c2.n()).done; ) {
              var l2 = u2.value;
              l2.source == i2.source && (i2 = l2);
            }
          } catch (e23) {
            c2.e(e23);
          } finally {
            c2.f();
          }
        }
      }
    } catch (e23) {
      a2.e(e23);
    } finally {
      a2.f();
    }
    return i2;
  } }, { key: "handleUserEvent", value: function(t2, n2, r2) {
    return n2 != "delete" && r2.activateOnTyping ? new e22(this.source, 1) : this.map(t2.changes);
  } }, { key: "handleChange", value: function(t2) {
    return t2.changes.touchesRange(gz(t2.startState)) ? new e22(this.source, 0) : this.map(t2.changes);
  } }, { key: "map", value: function(t2) {
    return t2.empty || this.explicitPos < 0 ? this : new e22(this.source, this.state, t2.mapPos(this.explicitPos));
  } }]), e22;
}(), Iz = function(e22) {
  ji(n2, Tz);
  var t2 = Ci(n2);
  function n2(e23, r2, i2, o2, a2) {
    var s2;
    return Ri(this, n2), (s2 = t2.call(this, e23, 2, r2)).result = i2, s2.from = o2, s2.to = a2, s2;
  }
  return zi(n2, [{ key: "hasResult", value: function() {
    return true;
  } }, { key: "handleUserEvent", value: function(e23, t3, r2) {
    var i2, o2 = e23.changes.mapPos(this.from), a2 = e23.changes.mapPos(this.to, 1), s2 = gz(e23.state);
    if ((this.explicitPos < 0 ? s2 <= o2 : s2 < this.from) || s2 > a2 || t3 == "delete" && gz(e23.startState) == this.from)
      return new Tz(this.source, t3 == "input" && r2.activateOnTyping ? 1 : 0);
    var u2, c2 = this.explicitPos < 0 ? -1 : e23.changes.mapPos(this.explicitPos);
    return function(e24, t4, n3, r3) {
      if (!e24)
        return false;
      var i3 = t4.sliceDoc(n3, r3);
      return typeof e24 == "function" ? e24(i3, n3, r3, t4) : yz(e24, true).test(i3);
    }(this.result.validFor, e23.state, o2, a2) ? new n2(this.source, c2, this.result, o2, a2) : this.result.update && (u2 = this.result.update(this.result, o2, a2, new dz(e23.state, s2, c2 >= 0))) ? new n2(this.source, c2, u2, u2.from, (i2 = u2.to) !== null && i2 !== void 0 ? i2 : gz(e23.state)) : new Tz(this.source, 1, c2);
  } }, { key: "handleChange", value: function(e23) {
    return e23.changes.touchesRange(this.from, this.to) ? new Tz(this.source, 0) : this.map(e23.changes);
  } }, { key: "map", value: function(e23) {
    return e23.empty ? this : new n2(this.source, this.explicitPos < 0 ? -1 : e23.mapPos(this.explicitPos), this.result, e23.mapPos(this.from), e23.mapPos(this.to, 1));
  } }]), n2;
}();
var Rz = n_.define(), Dz = n_.define(), zz = n_.define({ map: function(e22, t2) {
  return e22.map(function(e23) {
    return e23.map(t2);
  });
} }), Lz = n_.define(), Bz = NC.define({ create: function() {
  return Oz.start();
}, update: function(e22, t2) {
  return e22.update(t2);
}, provide: function(e22) {
  return [ME.from(e22, function(e23) {
    return e23.tooltip;
  }), MM.contentAttributes.from(e22, function(e23) {
    return e23.attrs;
  })];
} });
function qz(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "option";
  return function(n2) {
    var r2 = n2.state.field(Bz, false);
    if (!r2 || !r2.open || Date.now() - r2.open.timestamp < 75)
      return false;
    var i2, o2 = 1;
    t2 == "page" && (i2 = RE(n2, r2.open.tooltip)) && (o2 = Math.max(2, Math.floor(i2.dom.offsetHeight / i2.dom.querySelector("li").offsetHeight) - 1));
    var a2 = r2.open.selected + o2 * (e22 ? 1 : -1), s2 = r2.open.options.length;
    return a2 < 0 ? a2 = t2 == "page" ? 0 : s2 - 1 : a2 >= s2 && (a2 = t2 == "page" ? s2 - 1 : 0), n2.dispatch({ effects: Lz.of(a2) }), true;
  };
}
var Fz = zi(function e14(t2, n2) {
  Ri(this, e14), this.active = t2, this.context = n2, this.time = Date.now(), this.updates = [], this.done = void 0;
}), Vz = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.view = t2, this.debounceUpdate = -1, this.running = [], this.debounceAccept = -1, this.composing = 0;
    var n2, r2 = bi(t2.state.field(Bz).active);
    try {
      for (r2.s(); !(n2 = r2.n()).done; ) {
        var i2 = n2.value;
        i2.state == 1 && this.startQuery(i2);
      }
    } catch (e23) {
      r2.e(e23);
    } finally {
      r2.f();
    }
  }
  return zi(e22, [{ key: "update", value: function(e23) {
    var t2 = this, n2 = e23.state.field(Bz);
    if (e23.selectionSet || e23.docChanged || e23.startState.field(Bz) != n2) {
      for (var r2 = e23.transactions.some(function(e24) {
        return (e24.selection || e24.docChanged) && !Nz(e24);
      }), i2 = 0; i2 < this.running.length; i2++) {
        var o2 = this.running[i2];
        if (r2 || o2.updates.length + e23.transactions.length > 50 && Date.now() - o2.time > 1e3) {
          var a2, s2 = bi(o2.context.abortListeners);
          try {
            for (s2.s(); !(a2 = s2.n()).done; ) {
              var u2 = a2.value;
              try {
                u2();
              } catch (e24) {
                gO(this.view.state, e24);
              }
            }
          } catch (e24) {
            s2.e(e24);
          } finally {
            s2.f();
          }
          o2.context.abortListeners = null, this.running.splice(i2--, 1);
        } else {
          var c2;
          (c2 = o2.updates).push.apply(c2, Ni(e23.transactions));
        }
      }
      if (this.debounceUpdate > -1 && clearTimeout(this.debounceUpdate), this.debounceUpdate = n2.active.some(function(e24) {
        return e24.state == 1 && !t2.running.some(function(t3) {
          return t3.active.source == e24.source;
        });
      }) ? setTimeout(function() {
        return t2.startUpdate();
      }, 50) : -1, this.composing != 0) {
        var l2, f2 = bi(e23.transactions);
        try {
          for (f2.s(); !(l2 = f2.n()).done; ) {
            var h2 = l2.value;
            Nz(h2) == "input" ? this.composing = 2 : this.composing == 2 && h2.selection && (this.composing = 3);
          }
        } catch (e24) {
          f2.e(e24);
        } finally {
          f2.f();
        }
      }
    }
  } }, { key: "startUpdate", value: function() {
    var e23 = this;
    this.debounceUpdate = -1;
    var t2, n2 = bi(this.view.state.field(Bz).active);
    try {
      var r2 = function() {
        var n3 = t2.value;
        n3.state != 1 || e23.running.some(function(e24) {
          return e24.active.source == n3.source;
        }) || e23.startQuery(n3);
      };
      for (n2.s(); !(t2 = n2.n()).done; )
        r2();
    } catch (e24) {
      n2.e(e24);
    } finally {
      n2.f();
    }
  } }, { key: "startQuery", value: function(e23) {
    var t2 = this, n2 = this.view.state, r2 = gz(n2), i2 = new dz(n2, r2, e23.explicitPos == r2), o2 = new Fz(e23, i2);
    this.running.push(o2), Promise.resolve(e23.source(i2)).then(function(e24) {
      o2.context.aborted || (o2.done = e24 || null, t2.scheduleAccept());
    }, function(e24) {
      t2.view.dispatch({ effects: Dz.of(null) }), gO(t2.view.state, e24);
    });
  } }, { key: "scheduleAccept", value: function() {
    var e23 = this;
    this.running.every(function(e24) {
      return e24.done !== void 0;
    }) ? this.accept() : this.debounceAccept < 0 && (this.debounceAccept = setTimeout(function() {
      return e23.accept();
    }, 50));
  } }, { key: "accept", value: function() {
    var e23, t2 = this;
    this.debounceAccept > -1 && clearTimeout(this.debounceAccept), this.debounceAccept = -1;
    for (var n2 = [], r2 = this.view.state.facet(jz), i2 = function(i3) {
      var a2 = t2.running[i3];
      if (a2.done === void 0)
        return o2 = i3, "continue";
      if (t2.running.splice(i3--, 1), a2.done) {
        var s2, u2 = new Iz(a2.active.source, a2.active.explicitPos, a2.done, a2.done.from, (e23 = a2.done.to) !== null && e23 !== void 0 ? e23 : gz(a2.updates.length ? a2.updates[0].startState : t2.view.state)), c2 = bi(a2.updates);
        try {
          for (c2.s(); !(s2 = c2.n()).done; ) {
            var l2 = s2.value;
            u2 = u2.update(l2, r2);
          }
        } catch (e24) {
          c2.e(e24);
        } finally {
          c2.f();
        }
        if (u2.hasResult())
          return n2.push(u2), o2 = i3, "continue";
      }
      var f2 = t2.view.state.field(Bz).active.find(function(e24) {
        return e24.source == a2.active.source;
      });
      if (f2 && f2.state == 1)
        if (a2.done == null) {
          var h2, d2 = new Tz(a2.active.source, 0), v2 = bi(a2.updates);
          try {
            for (v2.s(); !(h2 = v2.n()).done; ) {
              var p2 = h2.value;
              d2 = d2.update(p2, r2);
            }
          } catch (e24) {
            v2.e(e24);
          } finally {
            v2.f();
          }
          d2.state != 1 && n2.push(d2);
        } else
          t2.startQuery(f2);
      o2 = i3;
    }, o2 = 0; o2 < this.running.length; o2++)
      i2(o2);
    n2.length && this.view.dispatch({ effects: zz.of(n2) });
  } }]), e22;
}(), { eventHandlers: { blur: function() {
  var e22 = this.view.state.field(Bz, false);
  e22 && e22.tooltip && this.view.state.facet(jz).closeOnBlur && this.view.dispatch({ effects: Dz.of(null) });
}, compositionstart: function() {
  this.composing = 1;
}, compositionend: function() {
  var e22 = this;
  this.composing == 3 && setTimeout(function() {
    return e22.view.dispatch({ effects: Rz.of(false) });
  }, 20), this.composing = 0;
} } }), Hz = MM.baseTheme({ ".cm-tooltip.cm-tooltip-autocomplete": { "& > ul": { fontFamily: "monospace", whiteSpace: "nowrap", overflow: "hidden auto", maxWidth_fallback: "700px", maxWidth: "min(700px, 95vw)", minWidth: "250px", maxHeight: "10em", listStyle: "none", margin: 0, padding: 0, "& > li": { overflowX: "hidden", textOverflow: "ellipsis", cursor: "pointer", padding: "1px 3px", lineHeight: 1.2 } } }, "&light .cm-tooltip-autocomplete ul li[aria-selected]": { background: "#17c", color: "white" }, "&dark .cm-tooltip-autocomplete ul li[aria-selected]": { background: "#347", color: "white" }, ".cm-completionListIncompleteTop:before, .cm-completionListIncompleteBottom:after": { content: '"\xB7\xB7\xB7"', opacity: 0.5, display: "block", textAlign: "center" }, ".cm-tooltip.cm-completionInfo": { position: "absolute", padding: "3px 9px", width: "max-content", maxWidth: "300px" }, ".cm-completionInfo.cm-completionInfo-left": { right: "100%" }, ".cm-completionInfo.cm-completionInfo-right": { left: "100%" }, "&light .cm-snippetField": { backgroundColor: "#00000022" }, "&dark .cm-snippetField": { backgroundColor: "#ffffff22" }, ".cm-snippetFieldPosition": { verticalAlign: "text-top", width: 0, height: "1.15em", margin: "0 -0.7px -.7em", borderLeft: "1.4px dotted #888" }, ".cm-completionMatchedText": { textDecoration: "underline" }, ".cm-completionDetail": { marginLeft: "0.5em", fontStyle: "italic" }, ".cm-completionIcon": { fontSize: "90%", width: ".8em", display: "inline-block", textAlign: "center", paddingRight: ".6em", opacity: "0.6" }, ".cm-completionIcon-function, .cm-completionIcon-method": { "&:after": { content: "'\u0192'" } }, ".cm-completionIcon-class": { "&:after": { content: "'\u25CB'" } }, ".cm-completionIcon-interface": { "&:after": { content: "'\u25CC'" } }, ".cm-completionIcon-variable": { "&:after": { content: "'\u{1D465}'" } }, ".cm-completionIcon-constant": { "&:after": { content: "'\u{1D436}'" } }, ".cm-completionIcon-type": { "&:after": { content: "'\u{1D461}'" } }, ".cm-completionIcon-enum": { "&:after": { content: "'\u222A'" } }, ".cm-completionIcon-property": { "&:after": { content: "'\u25A1'" } }, ".cm-completionIcon-keyword": { "&:after": { content: "'\u{1F511}\uFE0E'" } }, ".cm-completionIcon-namespace": { "&:after": { content: "'\u25A2'" } }, ".cm-completionIcon-text": { "&:after": { content: "'abc'", fontSize: "50%", verticalAlign: "middle" } } }), Wz = { brackets: ["(", "[", "{", "'", '"'], before: ")]}:;>" }, Jz = n_.define({ map: function(e22, t2) {
  var n2 = t2.mapPos(e22, -1, vC.TrackAfter);
  return n2 == null ? void 0 : n2;
} }), Uz = n_.define({ map: function(e22, t2) {
  return t2.mapPos(e22);
} }), Kz = new (function(e22) {
  ji(n2, m_);
  var t2 = Ci(n2);
  function n2() {
    return Ri(this, n2), t2.apply(this, arguments);
  }
  return zi(n2);
}())();
Kz.startSide = 1, Kz.endSide = -1;
var Gz = NC.define({ create: function() {
  return k_.empty;
}, update: function(e22, t2) {
  if (t2.selection) {
    var n2 = t2.state.doc.lineAt(t2.selection.main.head).from, r2 = t2.startState.doc.lineAt(t2.startState.selection.main.head).from;
    n2 != t2.changes.mapPos(r2, -1) && (e22 = k_.empty);
  }
  e22 = e22.map(t2.changes);
  var i2, o2 = bi(t2.effects);
  try {
    var a2 = function() {
      var t3 = i2.value;
      t3.is(Jz) ? e22 = e22.update({ add: [Kz.range(t3.value, t3.value + 1)] }) : t3.is(Uz) && (e22 = e22.update({ filter: function(e23) {
        return e23 != t3.value;
      } }));
    };
    for (o2.s(); !(i2 = o2.n()).done; )
      a2();
  } catch (e23) {
    o2.e(e23);
  } finally {
    o2.f();
  }
  return e22;
} });
function Qz(e22) {
  for (var t2 = 0; t2 < "()[]{}<>".length; t2 += 2)
    if ("()[]{}<>".charCodeAt(t2) == e22)
      return "()[]{}<>".charAt(t2 + 1);
  return fC(e22 < 128 ? e22 : e22 + 1);
}
function Yz(e22, t2) {
  return e22.languageDataAt("closeBrackets", t2)[0] || Wz;
}
var Zz = (typeof navigator == "undefined" ? "undefined" : Li(navigator)) == "object" && /Android\b/.test(navigator.userAgent), Xz = MM.inputHandler.of(function(e22, t2, n2, r2) {
  if ((Zz ? e22.composing : e22.compositionStarted) || e22.state.readOnly)
    return false;
  var i2 = e22.state.selection.main;
  if (r2.length > 2 || r2.length == 2 && hC(lC(r2, 0)) == 1 || t2 != i2.from || n2 != i2.to)
    return false;
  var o2 = function(e23, t3) {
    var n3, r3 = Yz(e23, e23.selection.main.head), i3 = r3.brackets || Wz.brackets, o3 = bi(i3);
    try {
      for (o3.s(); !(n3 = o3.n()).done; ) {
        var a2 = n3.value, s2 = Qz(lC(a2, 0));
        if (t3 == a2)
          return s2 == a2 ? oL(e23, a2, i3.indexOf(a2 + a2 + a2) > -1) : rL(e23, a2, s2, r3.before || Wz.before);
        if (t3 == s2 && tL(e23, e23.selection.main.from))
          return iL(e23, a2, s2);
      }
    } catch (e24) {
      o3.e(e24);
    } finally {
      o3.f();
    }
    return null;
  }(e22.state, r2);
  return !!o2 && (e22.dispatch(o2), true);
}), eL = [{ key: "Backspace", run: function(e22) {
  var t2 = e22.state, n2 = e22.dispatch;
  if (t2.readOnly)
    return false;
  var r2 = Yz(t2, t2.selection.main.head).brackets || Wz.brackets, i2 = null, o2 = t2.changeByRange(function(e23) {
    if (e23.empty) {
      var n3, o3 = function(e24, t3) {
        var n4 = e24.sliceString(t3 - 2, t3);
        return hC(lC(n4, 0)) == n4.length ? n4 : n4.slice(1);
      }(t2.doc, e23.head), a2 = bi(r2);
      try {
        for (a2.s(); !(n3 = a2.n()).done; ) {
          var s2 = n3.value;
          if (s2 == o3 && nL(t2.doc, e23.head) == Qz(lC(s2, 0)))
            return { changes: { from: e23.head - s2.length, to: e23.head + s2.length }, range: SC.cursor(e23.head - s2.length), userEvent: "delete.backward" };
        }
      } catch (e24) {
        a2.e(e24);
      } finally {
        a2.f();
      }
    }
    return { range: i2 = e23 };
  });
  return i2 || n2(t2.update(o2, { scrollIntoView: true })), !i2;
} }];
function tL(e22, t2) {
  var n2 = false;
  return e22.field(Gz).between(0, e22.doc.length, function(e23) {
    e23 == t2 && (n2 = true);
  }), n2;
}
function nL(e22, t2) {
  var n2 = e22.sliceString(t2, t2 + 2);
  return n2.slice(0, hC(lC(n2, 0)));
}
function rL(e22, t2, n2, r2) {
  var i2 = null, o2 = e22.changeByRange(function(o3) {
    if (!o3.empty)
      return { changes: [{ insert: t2, from: o3.from }, { insert: n2, from: o3.to }], effects: Jz.of(o3.to + t2.length), range: SC.range(o3.anchor + t2.length, o3.head + t2.length) };
    var a2 = nL(e22.doc, o3.head);
    return !a2 || /\s/.test(a2) || r2.indexOf(a2) > -1 ? { changes: { insert: t2 + n2, from: o3.head }, effects: Jz.of(o3.head + t2.length), range: SC.cursor(o3.head + t2.length) } : { range: i2 = o3 };
  });
  return i2 ? null : e22.update(o2, { scrollIntoView: true, userEvent: "input.type" });
}
function iL(e22, t2, n2) {
  var r2 = null, i2 = e22.selection.ranges.map(function(t3) {
    return t3.empty && nL(e22.doc, t3.head) == n2 ? SC.cursor(t3.head + n2.length) : r2 = t3;
  });
  return r2 ? null : e22.update({ selection: SC.create(i2, e22.selection.mainIndex), scrollIntoView: true, effects: e22.selection.ranges.map(function(e23) {
    var t3 = e23.from;
    return Uz.of(t3);
  }) });
}
function oL(e22, t2, n2) {
  var r2 = null, i2 = e22.changeByRange(function(i3) {
    if (!i3.empty)
      return { changes: [{ insert: t2, from: i3.from }, { insert: t2, from: i3.to }], effects: Jz.of(i3.to + t2.length), range: SC.range(i3.anchor + t2.length, i3.head + t2.length) };
    var o2 = i3.head, a2 = nL(e22.doc, o2);
    if (a2 == t2) {
      if (aL(e22, o2))
        return { changes: { insert: t2 + t2, from: o2 }, effects: Jz.of(o2 + t2.length), range: SC.cursor(o2 + t2.length) };
      if (tL(e22, o2)) {
        var s2 = n2 && e22.sliceDoc(o2, o2 + 3 * t2.length) == t2 + t2 + t2;
        return { range: SC.cursor(o2 + t2.length * (s2 ? 3 : 1)), effects: Uz.of(o2) };
      }
    } else {
      if (n2 && e22.sliceDoc(o2 - 2 * t2.length, o2) == t2 + t2 && aL(e22, o2 - 2 * t2.length))
        return { changes: { insert: t2 + t2 + t2 + t2, from: o2 }, effects: Jz.of(o2 + t2.length), range: SC.cursor(o2 + t2.length) };
      if (e22.charCategorizer(o2)(a2) != f_.Word) {
        var u2 = e22.sliceDoc(o2 - 1, o2);
        if (u2 != t2 && e22.charCategorizer(o2)(u2) != f_.Word && !function(e23, t3, n3) {
          for (var r3 = VN(e23).resolveInner(t3, -1), i4 = 0; i4 < 5; i4++) {
            if (e23.sliceDoc(r3.from, r3.from + n3.length) == n3)
              return true;
            var o3 = r3.to == t3 && r3.parent;
            if (!o3)
              break;
            r3 = o3;
          }
          return false;
        }(e22, o2, t2))
          return { changes: { insert: t2 + t2, from: o2 }, effects: Jz.of(o2 + t2.length), range: SC.cursor(o2 + t2.length) };
      }
    }
    return { range: r2 = i3 };
  });
  return r2 ? null : e22.update(i2, { scrollIntoView: true, userEvent: "input.type" });
}
function aL(e22, t2) {
  var n2 = VN(e22).resolveInner(t2 + 1);
  return n2.parent && n2.from == t2;
}
function sL() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return [Bz, jz.of(e22), Vz, cL, Hz];
}
var uL = [{ key: "Ctrl-Space", run: function(e22) {
  return !!e22.state.field(Bz, false) && (e22.dispatch({ effects: Rz.of(true) }), true);
} }, { key: "Escape", run: function(e22) {
  var t2 = e22.state.field(Bz, false);
  return !(!t2 || !t2.active.some(function(e23) {
    return e23.state != 0;
  })) && (e22.dispatch({ effects: Dz.of(null) }), true);
} }, { key: "ArrowDown", run: qz(true) }, { key: "ArrowUp", run: qz(false) }, { key: "PageDown", run: qz(true, "page") }, { key: "PageUp", run: qz(false, "page") }, { key: "Enter", run: function(e22) {
  var t2 = e22.state.field(Bz, false);
  return !(e22.state.readOnly || !t2 || !t2.open || Date.now() - t2.open.timestamp < 75) && (bz(e22, t2.open.options[t2.open.selected]), true);
} }], cL = LC.highest(LM.computeN([jz], function(e22) {
  return e22.facet(jz).defaultKeymap ? [uL] : [];
})), lL = zi(function e15(t2, n2, r2) {
  Ri(this, e15), this.from = t2, this.to = n2, this.diagnostic = r2;
}), fL = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.diagnostics = t2, this.panel = n2, this.selected = r2;
  }
  return zi(e22, null, [{ key: "init", value: function(t2, n2, r2) {
    var i2 = t2, o2 = r2.facet(CL).markerFilter;
    o2 && (i2 = o2(i2));
    var a2 = Y$.set(i2.map(function(e23) {
      return e23.from == e23.to || e23.from == e23.to - 1 && r2.doc.lineAt(e23.from).to == e23.from ? Y$.widget({ widget: new AL(e23), diagnostic: e23 }).range(e23.from) : Y$.mark({ attributes: { class: "cm-lintRange cm-lintRange-" + e23.severity }, diagnostic: e23 }).range(e23.from, e23.to);
    }), true);
    return new e22(a2, n2, hL(a2));
  } }]), e22;
}();
function hL(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, r2 = null;
  return e22.between(n2, 1e9, function(e23, n3, i2) {
    var o2 = i2.spec;
    if (!t2 || o2.diagnostic == t2)
      return r2 = new lL(e23, n3, o2.diagnostic), false;
  }), r2;
}
function dL(e22, t2) {
  return !(!e22.effects.some(function(e23) {
    return e23.is(pL);
  }) && !e22.changes.touchesRange(t2.pos));
}
function vL(e22, t2) {
  return e22.field(yL, false) ? t2 : t2.concat(n_.appendConfig.of([yL, MM.decorations.compute([yL], function(e23) {
    var t3 = e23.field(yL), n2 = t3.selected, r2 = t3.panel;
    return n2 && r2 && n2.from != n2.to ? Y$.set([bL.range(n2.from, n2.to)]) : Y$.none;
  }), IE(kL, { hideOn: dL }), TL]));
}
var pL = n_.define(), mL = n_.define(), gL = n_.define(), yL = NC.define({ create: function() {
  return new fL(Y$.none, null, null);
}, update: function(e22, t2) {
  if (t2.docChanged) {
    var n2 = e22.diagnostics.map(t2.changes), r2 = null;
    if (e22.selected) {
      var i2 = t2.changes.mapPos(e22.selected.from, 1);
      r2 = hL(n2, e22.selected.diagnostic, i2) || hL(n2, null, i2);
    }
    e22 = new fL(n2, e22.panel, r2);
  }
  var o2, a2 = bi(t2.effects);
  try {
    for (a2.s(); !(o2 = a2.n()).done; ) {
      var s2 = o2.value;
      s2.is(pL) ? e22 = fL.init(s2.value, e22.panel, t2.state) : s2.is(mL) ? e22 = new fL(e22.diagnostics, s2.value ? EL.open : null, e22.selected) : s2.is(gL) && (e22 = new fL(e22.diagnostics, e22.panel, s2.value));
    }
  } catch (e23) {
    a2.e(e23);
  } finally {
    a2.f();
  }
  return e22;
}, provide: function(e22) {
  return [VE.from(e22, function(e23) {
    return e23.panel;
  }), MM.decorations.from(e22, function(e23) {
    return e23.diagnostics;
  })];
} }), bL = Y$.mark({ class: "cm-lintRange cm-lintRange-active" });
function kL(e22, t2, n2) {
  var r2 = e22.state.field(yL).diagnostics, i2 = [], o2 = 2e8, a2 = 0;
  r2.between(t2 - (n2 < 0 ? 1 : 0), t2 + (n2 > 0 ? 1 : 0), function(e23, r3, s3) {
    var u2 = s3.spec;
    t2 >= e23 && t2 <= r3 && (e23 == r3 || (t2 > e23 || n2 > 0) && (t2 < r3 || n2 < 0)) && (i2.push(u2.diagnostic), o2 = Math.min(e23, o2), a2 = Math.max(r3, a2));
  });
  var s2 = e22.state.facet(CL).tooltipFilter;
  return s2 && (i2 = s2(i2)), i2.length ? { pos: o2, end: a2, above: e22.state.doc.lineAt(o2).to < a2, create: function() {
    return { dom: wL(e22, i2) };
  } } : null;
}
function wL(e22, t2) {
  return vD("ul", { class: "cm-tooltip-lint" }, t2.map(function(t3) {
    return OL(e22, t3, false);
  }));
}
var xL = function(e22) {
  var t2 = e22.state.field(yL, false);
  return !(!t2 || !t2.panel) && (e22.dispatch({ effects: mL.of(false) }), true);
}, jL = [{ key: "Mod-Shift-m", run: function(e22) {
  var t2 = e22.state.field(yL, false);
  t2 && t2.panel || e22.dispatch({ effects: vL(e22.state, [mL.of(true)]) });
  var n2 = LE(e22, EL.open);
  return n2 && n2.dom.querySelector(".cm-panel-lint ul").focus(), true;
} }, { key: "F8", run: function(e22) {
  var t2 = e22.state.field(yL, false);
  if (!t2)
    return false;
  var n2 = e22.state.selection.main, r2 = t2.diagnostics.iter(n2.to + 1);
  return !(!r2.value && (!(r2 = t2.diagnostics.iter(0)).value || r2.from == n2.from && r2.to == n2.to)) && (e22.dispatch({ selection: { anchor: r2.from, head: r2.to }, scrollIntoView: true }), true);
} }], SL = wO.fromClass(function() {
  function e22(t2) {
    Ri(this, e22), this.view = t2, this.timeout = -1, this.set = true;
    var n2 = t2.state.facet(CL).delay;
    this.lintTime = Date.now() + n2, this.run = this.run.bind(this), this.timeout = setTimeout(this.run, n2);
  }
  return zi(e22, [{ key: "run", value: function() {
    var e23 = this, t2 = Date.now();
    if (t2 < this.lintTime - 10)
      setTimeout(this.run, this.lintTime - t2);
    else {
      this.set = false;
      var n2 = this.view.state, r2 = n2.facet(CL).sources;
      Promise.all(r2.map(function(t3) {
        return Promise.resolve(t3(e23.view));
      })).then(function(t3) {
        var r3 = t3.reduce(function(e24, t4) {
          return e24.concat(t4);
        });
        e23.view.state.doc == n2.doc && e23.view.dispatch(function(e24, t4) {
          return { effects: vL(e24, [pL.of(t4)]) };
        }(e23.view.state, r3));
      }, function(t3) {
        gO(e23.view.state, t3);
      });
    }
  } }, { key: "update", value: function(e23) {
    var t2 = e23.state.facet(CL);
    (e23.docChanged || t2 != e23.startState.facet(CL)) && (this.lintTime = Date.now() + t2.delay, this.set || (this.set = true, this.timeout = setTimeout(this.run, t2.delay)));
  } }, { key: "force", value: function() {
    this.set && (this.lintTime = Date.now(), this.run());
  } }, { key: "destroy", value: function() {
    clearTimeout(this.timeout);
  } }]), e22;
}()), CL = $C.define({ combine: function(e22) {
  return Object.assign({ sources: e22.map(function(e23) {
    return e23.source;
  }) }, p_(e22.map(function(e23) {
    return e23.config;
  }), { delay: 750, markerFilter: null, tooltipFilter: null }));
}, enables: SL });
function _L(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  return CL.of({ source: e22, config: t2 });
}
function $L(e22) {
  var t2 = [];
  if (e22) {
    var n2, r2 = bi(e22);
    try {
      e:
        for (r2.s(); !(n2 = r2.n()).done; ) {
          for (var i2 = n2.value.name, o2 = function(e23) {
            var n3 = i2[e23];
            if (/[a-zA-Z]/.test(n3) && !t2.some(function(e24) {
              return e24.toLowerCase() == n3.toLowerCase();
            }))
              return t2.push(n3), "continue|actions";
          }, a2 = 0; a2 < i2.length; a2++) {
            if (o2(a2) === "continue|actions")
              continue e;
          }
          t2.push("");
        }
    } catch (e23) {
      r2.e(e23);
    } finally {
      r2.f();
    }
  }
  return t2;
}
function OL(e22, t2, n2) {
  var r2, i2 = n2 ? $L(t2.actions) : [];
  return vD("li", { class: "cm-diagnostic cm-diagnostic-" + t2.severity }, vD("span", { class: "cm-diagnosticText" }, t2.renderMessage ? t2.renderMessage() : t2.message), (r2 = t2.actions) === null || r2 === void 0 ? void 0 : r2.map(function(n3, r3) {
    var o2 = function(r4) {
      r4.preventDefault();
      var i3 = hL(e22.state.field(yL).diagnostics, t2);
      i3 && n3.apply(e22, i3.from, i3.to);
    }, a2 = n3.name, s2 = i2[r3] ? a2.indexOf(i2[r3]) : -1, u2 = s2 < 0 ? a2 : [a2.slice(0, s2), vD("u", a2.slice(s2, s2 + 1)), a2.slice(s2 + 1)];
    return vD("button", { type: "button", class: "cm-diagnosticAction", onclick: o2, onmousedown: o2, "aria-label": " Action: ".concat(a2).concat(s2 < 0 ? "" : ' (access key "'.concat(i2[r3], ')"'), ".") }, u2);
  }), t2.source && vD("div", { class: "cm-diagnosticSource" }, t2.source));
}
var AL = function(e22) {
  ji(n2, G$);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), (r2 = t2.call(this)).diagnostic = e23, r2;
  }
  return zi(n2, [{ key: "eq", value: function(e23) {
    return e23.diagnostic == this.diagnostic;
  } }, { key: "toDOM", value: function() {
    return vD("span", { class: "cm-lintPoint cm-lintPoint-" + this.diagnostic.severity });
  } }]), n2;
}(), ML = zi(function e16(t2, n2) {
  Ri(this, e16), this.diagnostic = n2, this.id = "item_" + Math.floor(4294967295 * Math.random()).toString(16), this.dom = OL(t2, n2, true), this.dom.id = this.id, this.dom.setAttribute("role", "option");
}), EL = function() {
  function e22(t2) {
    var n2 = this;
    Ri(this, e22), this.view = t2, this.items = [];
    this.list = vD("ul", { tabIndex: 0, role: "listbox", "aria-label": this.view.state.phrase("Diagnostics"), onkeydown: function(e23) {
      if (e23.keyCode == 27)
        xL(n2.view), n2.view.focus();
      else if (e23.keyCode == 38 || e23.keyCode == 33)
        n2.moveSelection((n2.selectedIndex - 1 + n2.items.length) % n2.items.length);
      else if (e23.keyCode == 40 || e23.keyCode == 34)
        n2.moveSelection((n2.selectedIndex + 1) % n2.items.length);
      else if (e23.keyCode == 36)
        n2.moveSelection(0);
      else if (e23.keyCode == 35)
        n2.moveSelection(n2.items.length - 1);
      else if (e23.keyCode == 13)
        n2.view.focus();
      else {
        if (!(e23.keyCode >= 65 && e23.keyCode <= 90 && n2.selectedIndex >= 0))
          return;
        for (var r2 = n2.items[n2.selectedIndex].diagnostic, i2 = $L(r2.actions), o2 = 0; o2 < i2.length; o2++)
          if (i2[o2].toUpperCase().charCodeAt(0) == e23.keyCode) {
            var a2 = hL(n2.view.state.field(yL).diagnostics, r2);
            a2 && r2.actions[o2].apply(t2, a2.from, a2.to);
          }
      }
      e23.preventDefault();
    }, onclick: function(e23) {
      for (var t3 = 0; t3 < n2.items.length; t3++)
        n2.items[t3].dom.contains(e23.target) && n2.moveSelection(t3);
    } }), this.dom = vD("div", { class: "cm-panel-lint" }, this.list, vD("button", { type: "button", name: "close", "aria-label": this.view.state.phrase("close"), onclick: function() {
      return xL(n2.view);
    } }, "\xD7")), this.update();
  }
  return zi(e22, [{ key: "selectedIndex", get: function() {
    var e23 = this.view.state.field(yL).selected;
    if (!e23)
      return -1;
    for (var t2 = 0; t2 < this.items.length; t2++)
      if (this.items[t2].diagnostic == e23.diagnostic)
        return t2;
    return -1;
  } }, { key: "update", value: function() {
    var e23 = this, t2 = this.view.state.field(yL), n2 = t2.diagnostics, r2 = t2.selected, i2 = 0, o2 = false, a2 = null;
    for (n2.between(0, this.view.state.doc.length, function(t3, n3, s2) {
      for (var u2, c2 = s2.spec, l2 = -1, f2 = i2; f2 < e23.items.length; f2++)
        if (e23.items[f2].diagnostic == c2.diagnostic) {
          l2 = f2;
          break;
        }
      l2 < 0 ? (u2 = new ML(e23.view, c2.diagnostic), e23.items.splice(i2, 0, u2), o2 = true) : (u2 = e23.items[l2], l2 > i2 && (e23.items.splice(i2, l2 - i2), o2 = true)), r2 && u2.diagnostic == r2.diagnostic ? u2.dom.hasAttribute("aria-selected") || (u2.dom.setAttribute("aria-selected", "true"), a2 = u2) : u2.dom.hasAttribute("aria-selected") && u2.dom.removeAttribute("aria-selected"), i2++;
    }); i2 < this.items.length && !(this.items.length == 1 && this.items[0].diagnostic.from < 0); )
      o2 = true, this.items.pop();
    this.items.length == 0 && (this.items.push(new ML(this.view, { from: -1, to: -1, severity: "info", message: this.view.state.phrase("No diagnostics") })), o2 = true), a2 ? (this.list.setAttribute("aria-activedescendant", a2.id), this.view.requestMeasure({ key: this, read: function() {
      return { sel: a2.dom.getBoundingClientRect(), panel: e23.list.getBoundingClientRect() };
    }, write: function(t3) {
      var n3 = t3.sel, r3 = t3.panel;
      n3.top < r3.top ? e23.list.scrollTop -= r3.top - n3.top : n3.bottom > r3.bottom && (e23.list.scrollTop += n3.bottom - r3.bottom);
    } })) : this.selectedIndex < 0 && this.list.removeAttribute("aria-activedescendant"), o2 && this.sync();
  } }, { key: "sync", value: function() {
    var e23 = this.list.firstChild;
    function t2() {
      var t3 = e23;
      e23 = t3.nextSibling, t3.remove();
    }
    var n2, r2 = bi(this.items);
    try {
      for (r2.s(); !(n2 = r2.n()).done; ) {
        var i2 = n2.value;
        if (i2.dom.parentNode == this.list) {
          for (; e23 != i2.dom; )
            t2();
          e23 = i2.dom.nextSibling;
        } else
          this.list.insertBefore(i2.dom, e23);
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    for (; e23; )
      t2();
  } }, { key: "moveSelection", value: function(e23) {
    if (!(this.selectedIndex < 0)) {
      var t2 = hL(this.view.state.field(yL).diagnostics, this.items[e23].diagnostic);
      t2 && this.view.dispatch({ selection: { anchor: t2.from, head: t2.to }, scrollIntoView: true, effects: gL.of(t2) });
    }
  } }], [{ key: "open", value: function(t2) {
    return new e22(t2);
  } }]), e22;
}();
function PL(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 'viewBox="0 0 40 40"';
  return `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" `.concat(t2, ">").concat(encodeURIComponent(e22), "</svg>')");
}
function NL(e22) {
  return PL('<path d="m0 2.5 l2 -1.5 l1 0 l2 1.5 l1 0" stroke="'.concat(e22, '" fill="none" stroke-width=".7"/>'), 'width="6" height="3"');
}
var TL = MM.baseTheme({ ".cm-diagnostic": { padding: "3px 6px 3px 8px", marginLeft: "-1px", display: "block", whiteSpace: "pre-wrap" }, ".cm-diagnostic-error": { borderLeft: "5px solid #d11" }, ".cm-diagnostic-warning": { borderLeft: "5px solid orange" }, ".cm-diagnostic-info": { borderLeft: "5px solid #999" }, ".cm-diagnosticAction": { font: "inherit", border: "none", padding: "2px 4px", backgroundColor: "#444", color: "white", borderRadius: "3px", marginLeft: "8px" }, ".cm-diagnosticSource": { fontSize: "70%", opacity: 0.7 }, ".cm-lintRange": { backgroundPosition: "left bottom", backgroundRepeat: "repeat-x", paddingBottom: "0.7px" }, ".cm-lintRange-error": { backgroundImage: NL("#d11") }, ".cm-lintRange-warning": { backgroundImage: NL("orange") }, ".cm-lintRange-info": { backgroundImage: NL("#999") }, ".cm-lintRange-active": { backgroundColor: "#ffdd9980" }, ".cm-tooltip-lint": { padding: 0, margin: 0 }, ".cm-lintPoint": { position: "relative", "&:after": { content: '""', position: "absolute", bottom: 0, left: "-2px", borderLeft: "3px solid transparent", borderRight: "3px solid transparent", borderBottom: "4px solid #d11" } }, ".cm-lintPoint-warning": { "&:after": { borderBottomColor: "orange" } }, ".cm-lintPoint-info": { "&:after": { borderBottomColor: "#999" } }, ".cm-panel.cm-panel-lint": { position: "relative", "& ul": { maxHeight: "100px", overflowY: "auto", "& [aria-selected]": { backgroundColor: "#ddd", "& u": { textDecoration: "underline" } }, "&:focus [aria-selected]": { background_fallback: "#bdf", backgroundColor: "Highlight", color_fallback: "white", color: "HighlightText" }, "& u": { textDecoration: "none" }, padding: 0, margin: 0 }, "& [name=close]": { position: "absolute", top: "0", right: "2px", background: "inherit", border: "none", font: "inherit", padding: 0, margin: 0 } } }), IL = function(e22) {
  ji(n2, HE);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), (r2 = t2.call(this)).diagnostics = e23, r2.severity = e23.reduce(function(e24, t3) {
      var n3 = t3.severity;
      return n3 == "error" || n3 == "warning" && e24 == "info" ? n3 : e24;
    }, "info"), r2;
  }
  return zi(n2, [{ key: "toDOM", value: function(e23) {
    var t3 = document.createElement("div");
    t3.className = "cm-lint-marker cm-lint-marker-" + this.severity;
    var n3 = this.diagnostics, r2 = e23.state.facet(FL).tooltipFilter;
    return r2 && (n3 = r2(n3)), n3.length && (t3.onmouseover = function() {
      return function(e24, t4, n4) {
        function r3() {
          var r4 = e24.elementAtHeight(t4.getBoundingClientRect().top + 5 - e24.documentTop);
          e24.coordsAtPos(r4.from) && e24.dispatch({ effects: LL.of({ pos: r4.from, above: false, create: function() {
            return { dom: wL(e24, n4), getCoords: function() {
              return t4.getBoundingClientRect();
            } };
          } }) }), t4.onmouseout = t4.onmousemove = null, function(e25, t5) {
            var n5 = function n6(r5) {
              var i3 = t5.getBoundingClientRect();
              if (!(r5.clientX > i3.left - 10 && r5.clientX < i3.right + 10 && r5.clientY > i3.top - 10 && r5.clientY < i3.bottom + 10)) {
                for (var o3 = r5.target; o3; o3 = o3.parentNode)
                  if (o3.nodeType == 1 && o3.classList.contains("cm-tooltip-lint"))
                    return;
                window.removeEventListener("mousemove", n6), e25.state.field(BL) && e25.dispatch({ effects: LL.of(null) });
              }
            };
            window.addEventListener("mousemove", n5);
          }(e24, t4);
        }
        var i2 = e24.state.facet(FL).hoverTime, o2 = setTimeout(r3, i2);
        t4.onmouseout = function() {
          clearTimeout(o2), t4.onmouseout = t4.onmousemove = null;
        }, t4.onmousemove = function() {
          clearTimeout(o2), o2 = setTimeout(r3, i2);
        };
      }(e23, t3, n3);
    }), t3;
  } }]), n2;
}();
function RL(e22, t2) {
  var n2, r2 = /* @__PURE__ */ Object.create(null), i2 = bi(t2);
  try {
    for (i2.s(); !(n2 = i2.n()).done; ) {
      var o2 = n2.value, a2 = e22.lineAt(o2.from);
      (r2[a2.from] || (r2[a2.from] = [])).push(o2);
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  var s2 = [];
  for (var u2 in r2)
    s2.push(new IL(r2[u2]).range(+u2));
  return k_.of(s2, true);
}
var DL = KE({ class: "cm-gutter-lint", markers: function(e22) {
  return e22.state.field(zL);
} }), zL = NC.define({ create: function() {
  return k_.empty;
}, update: function(e22, t2) {
  e22 = e22.map(t2.changes);
  var n2, r2 = t2.state.facet(FL).markerFilter, i2 = bi(t2.effects);
  try {
    for (i2.s(); !(n2 = i2.n()).done; ) {
      var o2 = n2.value;
      if (o2.is(pL)) {
        var a2 = o2.value;
        r2 && (a2 = r2(a2 || [])), e22 = RL(t2.state.doc, a2.slice(0));
      }
    }
  } catch (e23) {
    i2.e(e23);
  } finally {
    i2.f();
  }
  return e22;
} }), LL = n_.define(), BL = NC.define({ create: function() {
  return null;
}, update: function(e22, t2) {
  return e22 && t2.docChanged && (e22 = dL(t2, e22) ? null : Object.assign(Object.assign({}, e22), { pos: t2.changes.mapPos(e22.pos) })), t2.effects.reduce(function(e23, t3) {
    return t3.is(LL) ? t3.value : e23;
  }, e22);
}, provide: function(e22) {
  return ME.from(e22);
} }), qL = MM.baseTheme({ ".cm-gutter-lint": { width: "1.4em", "& .cm-gutterElement": { padding: ".2em" } }, ".cm-lint-marker": { width: "1em", height: "1em" }, ".cm-lint-marker-info": { content: PL('<path fill="#aaf" stroke="#77e" stroke-width="6" stroke-linejoin="round" d="M5 5L35 5L35 35L5 35Z"/>') }, ".cm-lint-marker-warning": { content: PL('<path fill="#fe8" stroke="#fd7" stroke-width="6" stroke-linejoin="round" d="M20 6L37 35L3 35Z"/>') }, ".cm-lint-marker-error:before": { content: PL('<circle cx="20" cy="20" r="15" fill="#f87" stroke="#f43" stroke-width="6"/>') } }), FL = $C.define({ combine: function(e22) {
  return p_(e22, { hoverTime: 300, markerFilter: null, tooltipFilter: null });
} });
function VL() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return [FL.of(e22), zL, DL, qL, BL];
}
var HL = function() {
  return [uP(), fP, fE(), JI(), ET(), JM(), [nE, rE], v_.allowMultipleSelections.of(true), v_.transactionFilter.of(function(e23) {
    if (!e23.docChanged || !e23.isUserEvent("input.type") && !e23.isUserEvent("input.complete"))
      return e23;
    var t3 = e23.startState.languageDataAt("indentOnInput", e23.startState.selection.main.head);
    if (!t3.length)
      return e23;
    var n2 = e23.newDoc, r2 = e23.newSelection.main.head, i2 = n2.lineAt(r2);
    if (r2 > i2.from + 200)
      return e23;
    var o2 = n2.sliceString(i2.from, r2);
    if (!t3.some(function(e24) {
      return e24.test(o2);
    }))
      return e23;
    var a2, s2 = e23.state, u2 = -1, c2 = [], l2 = bi(s2.selection.ranges);
    try {
      for (l2.s(); !(a2 = l2.n()).done; ) {
        var f2 = a2.value.head, h2 = s2.doc.lineAt(f2);
        if (h2.from != u2) {
          u2 = h2.from;
          var d2 = iT(s2, h2.from);
          if (d2 != null) {
            var v2 = /^\s*/.exec(h2.text)[0], p2 = rT(s2, d2);
            v2 != p2 && c2.push({ from: h2.from, to: h2.from + v2.length, insert: p2 });
          }
        }
      }
    } catch (e24) {
      l2.e(e24);
    } finally {
      l2.f();
    }
    return c2.length ? [e23, { changes: c2, sequential: true }] : e23;
  }), DT(BT, { fallback: true }), UT(), [Xz, Gz], sL(), kE(), jE(), gE, (t2 = [TD, ND], e22 && t2.push(AD.of(e22)), t2), LM.of([].concat(eL, Ni(hD), az, fR, ST, uL, jL))];
  var e22, t2;
}(), WL = 0, JL = zi(function e17(t2, n2) {
  Ri(this, e17), this.from = t2, this.to = n2;
}), UL = function() {
  function e22() {
    var t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    Ri(this, e22), this.id = WL++, this.perNode = !!t2.perNode, this.deserialize = t2.deserialize || function() {
      throw new Error("This node type doesn't define a deserialize function");
    };
  }
  return zi(e22, [{ key: "add", value: function(e23) {
    var t2 = this;
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e23 != "function" && (e23 = GL.match(e23)), function(n2) {
      var r2 = e23(n2);
      return r2 === void 0 ? null : [t2, r2];
    };
  } }]), e22;
}();
UL.closedBy = new UL({ deserialize: function(e22) {
  return e22.split(" ");
} }), UL.openedBy = new UL({ deserialize: function(e22) {
  return e22.split(" ");
} }), UL.group = new UL({ deserialize: function(e22) {
  return e22.split(" ");
} }), UL.contextHash = new UL({ perNode: true }), UL.lookAhead = new UL({ perNode: true }), UL.mounted = new UL({ perNode: true });
var KL = /* @__PURE__ */ Object.create(null), GL = function() {
  function e22(t2, n2, r2) {
    var i2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0;
    Ri(this, e22), this.name = t2, this.props = n2, this.id = r2, this.flags = i2;
  }
  return zi(e22, [{ key: "prop", value: function(e23) {
    return this.props[e23.id];
  } }, { key: "isTop", get: function() {
    return (1 & this.flags) > 0;
  } }, { key: "isSkipped", get: function() {
    return (2 & this.flags) > 0;
  } }, { key: "isError", get: function() {
    return (4 & this.flags) > 0;
  } }, { key: "isAnonymous", get: function() {
    return (8 & this.flags) > 0;
  } }, { key: "is", value: function(e23) {
    if (typeof e23 == "string") {
      if (this.name == e23)
        return true;
      var t2 = this.prop(UL.group);
      return !!t2 && t2.indexOf(e23) > -1;
    }
    return this.id == e23;
  } }], [{ key: "define", value: function(t2) {
    var n2 = t2.props && t2.props.length ? /* @__PURE__ */ Object.create(null) : KL, r2 = (t2.top ? 1 : 0) | (t2.skipped ? 2 : 0) | (t2.error ? 4 : 0) | (t2.name == null ? 8 : 0), i2 = new e22(t2.name || "", n2, t2.id, r2);
    if (t2.props) {
      var o2, a2 = bi(t2.props);
      try {
        for (a2.s(); !(o2 = a2.n()).done; ) {
          var s2 = o2.value;
          if (Array.isArray(s2) || (s2 = s2(i2)), s2) {
            if (s2[0].perNode)
              throw new RangeError("Can't store a per-node prop on a node type");
            n2[s2[0].id] = s2[1];
          }
        }
      } catch (e23) {
        a2.e(e23);
      } finally {
        a2.f();
      }
    }
    return i2;
  } }, { key: "match", value: function(e23) {
    var t2 = /* @__PURE__ */ Object.create(null);
    for (var n2 in e23) {
      var r2, i2 = bi(n2.split(" "));
      try {
        for (i2.s(); !(r2 = i2.n()).done; ) {
          var o2 = r2.value;
          t2[o2] = e23[n2];
        }
      } catch (e24) {
        i2.e(e24);
      } finally {
        i2.f();
      }
    }
    return function(e24) {
      for (var n3 = e24.prop(UL.group), r3 = -1; r3 < (n3 ? n3.length : 0); r3++) {
        var i3 = t2[r3 < 0 ? e24.name : n3[r3]];
        if (i3)
          return i3;
      }
    };
  } }]), e22;
}();
GL.none = new GL("", /* @__PURE__ */ Object.create(null), 0, 8);
var QL, YL = function() {
  function e22(t2) {
    Ri(this, e22), this.types = t2;
    for (var n2 = 0; n2 < t2.length; n2++)
      if (t2[n2].id != n2)
        throw new RangeError("Node type ids should correspond to array positions when creating a node set");
  }
  return zi(e22, [{ key: "extend", value: function() {
    for (var t2 = [], n2 = arguments.length, r2 = new Array(n2), i2 = 0; i2 < n2; i2++)
      r2[i2] = arguments[i2];
    var o2, a2 = bi(this.types);
    try {
      for (a2.s(); !(o2 = a2.n()).done; ) {
        var s2, u2 = o2.value, c2 = null, l2 = bi(r2);
        try {
          for (l2.s(); !(s2 = l2.n()).done; ) {
            var f2 = s2.value, h2 = f2(u2);
            h2 && (c2 || (c2 = Object.assign({}, u2.props)), c2[h2[0].id] = h2[1]);
          }
        } catch (e23) {
          l2.e(e23);
        } finally {
          l2.f();
        }
        t2.push(c2 ? new GL(u2.name, c2, u2.id, u2.flags) : u2);
      }
    } catch (e23) {
      a2.e(e23);
    } finally {
      a2.f();
    }
    return new e22(t2);
  } }]), e22;
}(), ZL = /* @__PURE__ */ new WeakMap(), XL = /* @__PURE__ */ new WeakMap();
!function(e22) {
  e22[e22.ExcludeBuffers = 1] = "ExcludeBuffers", e22[e22.IncludeAnonymous = 2] = "IncludeAnonymous", e22[e22.IgnoreMounts = 4] = "IgnoreMounts", e22[e22.IgnoreOverlays = 8] = "IgnoreOverlays";
}(QL || (QL = {}));
var eB = function() {
  function e22(t2, n2, r2, i2, o2) {
    if (Ri(this, e22), this.type = t2, this.children = n2, this.positions = r2, this.length = i2, this.props = null, o2 && o2.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      var a2, s2 = bi(o2);
      try {
        for (s2.s(); !(a2 = s2.n()).done; ) {
          var u2 = xi(a2.value, 2), c2 = u2[0], l2 = u2[1];
          this.props[typeof c2 == "number" ? c2 : c2.id] = l2;
        }
      } catch (e23) {
        s2.e(e23);
      } finally {
        s2.f();
      }
    }
  }
  return zi(e22, [{ key: "toString", value: function() {
    var e23 = this.prop(UL.mounted);
    if (e23 && !e23.overlay)
      return e23.tree.toString();
    var t2, n2 = "", r2 = bi(this.children);
    try {
      for (r2.s(); !(t2 = r2.n()).done; ) {
        var i2 = t2.value.toString();
        i2 && (n2 && (n2 += ","), n2 += i2);
      }
    } catch (e24) {
      r2.e(e24);
    } finally {
      r2.f();
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (n2.length ? "(" + n2 + ")" : "") : n2;
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new fB(this.topNode, e23);
  } }, { key: "cursorAt", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = ZL.get(this) || this.topNode, r2 = new fB(n2);
    return r2.moveTo(e23, t2), ZL.set(this, r2._tree), r2;
  } }, { key: "topNode", get: function() {
    return new aB(this, 0, 0, null);
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = oB(ZL.get(this) || this.topNode, e23, t2, false);
    return ZL.set(this, n2), n2;
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = oB(XL.get(this) || this.topNode, e23, t2, true);
    return XL.set(this, n2), n2;
  } }, { key: "iterate", value: function(e23) {
    for (var t2 = e23.enter, n2 = e23.leave, r2 = e23.from, i2 = r2 === void 0 ? 0 : r2, o2 = e23.to, a2 = o2 === void 0 ? this.length : o2, s2 = this.cursor((e23.mode || 0) | QL.IncludeAnonymous); ; ) {
      var u2 = false;
      if (s2.from <= a2 && s2.to >= i2 && (s2.type.isAnonymous || t2(s2) !== false)) {
        if (s2.firstChild())
          continue;
        u2 = true;
      }
      for (; u2 && n2 && !s2.type.isAnonymous && n2(s2), !s2.nextSibling(); ) {
        if (!s2.parent())
          return;
        u2 = true;
      }
    }
  } }, { key: "prop", value: function(e23) {
    return e23.perNode ? this.props ? this.props[e23.id] : void 0 : this.type.prop(e23);
  } }, { key: "propValues", get: function() {
    var e23 = [];
    if (this.props)
      for (var t2 in this.props)
        e23.push([+t2, this.props[t2]]);
    return e23;
  } }, { key: "balance", value: function() {
    var t2 = this, n2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return this.children.length <= 8 ? this : mB(GL.none, this.children, this.positions, 0, this.children.length, 0, this.length, function(n3, r2, i2) {
      return new e22(t2.type, n3, r2, i2, t2.propValues);
    }, n2.makeTree || function(t3, n3, r2) {
      return new e22(GL.none, t3, n3, r2);
    });
  } }], [{ key: "build", value: function(e23) {
    return dB(e23);
  } }]), e22;
}();
eB.empty = new eB(GL.none, [], [], 0);
var tB = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.buffer = t2, this.index = n2;
  }
  return zi(e22, [{ key: "id", get: function() {
    return this.buffer[this.index - 4];
  } }, { key: "start", get: function() {
    return this.buffer[this.index - 3];
  } }, { key: "end", get: function() {
    return this.buffer[this.index - 2];
  } }, { key: "size", get: function() {
    return this.buffer[this.index - 1];
  } }, { key: "pos", get: function() {
    return this.index;
  } }, { key: "next", value: function() {
    this.index -= 4;
  } }, { key: "fork", value: function() {
    return new e22(this.buffer, this.index);
  } }]), e22;
}(), nB = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.buffer = t2, this.length = n2, this.set = r2;
  }
  return zi(e22, [{ key: "type", get: function() {
    return GL.none;
  } }, { key: "toString", value: function() {
    for (var e23 = [], t2 = 0; t2 < this.buffer.length; )
      e23.push(this.childString(t2)), t2 = this.buffer[t2 + 3];
    return e23.join(",");
  } }, { key: "childString", value: function(e23) {
    var t2 = this.buffer[e23], n2 = this.buffer[e23 + 3], r2 = this.set.types[t2], i2 = r2.name;
    if (/\W/.test(i2) && !r2.isError && (i2 = JSON.stringify(i2)), n2 == (e23 += 4))
      return i2;
    for (var o2 = []; e23 < n2; )
      o2.push(this.childString(e23)), e23 = this.buffer[e23 + 3];
    return i2 + "(" + o2.join(",") + ")";
  } }, { key: "findChild", value: function(e23, t2, n2, r2, i2) {
    for (var o2 = this.buffer, a2 = -1, s2 = e23; s2 != t2 && !(rB(i2, r2, o2[s2 + 1], o2[s2 + 2]) && (a2 = s2, n2 > 0)); s2 = o2[s2 + 3])
      ;
    return a2;
  } }, { key: "slice", value: function(t2, n2, r2, i2) {
    for (var o2 = this.buffer, a2 = new Uint16Array(n2 - t2), s2 = t2, u2 = 0; s2 < n2; )
      a2[u2++] = o2[s2++], a2[u2++] = o2[s2++] - r2, a2[u2++] = o2[s2++] - r2, a2[u2++] = o2[s2++] - t2;
    return new e22(a2, i2 - r2, this.set);
  } }]), e22;
}();
function rB(e22, t2, n2, r2) {
  switch (e22) {
    case -2:
      return n2 < t2;
    case -1:
      return r2 >= t2 && n2 < t2;
    case 0:
      return n2 < t2 && r2 > t2;
    case 1:
      return n2 <= t2 && r2 > t2;
    case 2:
      return r2 > t2;
    case 4:
      return true;
  }
}
function iB(e22, t2) {
  for (var n2 = e22.childBefore(t2); n2; ) {
    var r2 = n2.lastChild;
    if (!r2 || r2.to != n2.to)
      break;
    r2.type.isError && r2.from == r2.to ? (e22 = n2, n2 = r2.prevSibling) : n2 = r2;
  }
  return e22;
}
function oB(e22, t2, n2, r2) {
  for (var i2; e22.from == e22.to || (n2 < 1 ? e22.from >= t2 : e22.from > t2) || (n2 > -1 ? e22.to <= t2 : e22.to < t2); ) {
    var o2 = !r2 && e22 instanceof aB && e22.index < 0 ? null : e22.parent;
    if (!o2)
      return e22;
    e22 = o2;
  }
  var a2 = r2 ? 0 : QL.IgnoreOverlays;
  if (r2)
    for (var s2 = e22, u2 = s2.parent; u2; u2 = (s2 = u2).parent)
      s2 instanceof aB && s2.index < 0 && ((i2 = u2.enter(t2, n2, a2)) === null || i2 === void 0 ? void 0 : i2.from) != s2.from && (e22 = u2);
  for (; ; ) {
    var c2 = e22.enter(t2, n2, a2);
    if (!c2)
      return e22;
    e22 = c2;
  }
}
var aB = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this._tree = t2, this.from = n2, this.index = r2, this._parent = i2;
  }
  return zi(e22, [{ key: "type", get: function() {
    return this._tree.type;
  } }, { key: "name", get: function() {
    return this._tree.type.name;
  } }, { key: "to", get: function() {
    return this.from + this._tree.length;
  } }, { key: "nextChild", value: function(t2, n2, r2, i2) {
    for (var o2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0, a2 = this; ; ) {
      for (var s2 = a2._tree, u2 = s2.children, c2 = s2.positions, l2 = n2 > 0 ? u2.length : -1; t2 != l2; t2 += n2) {
        var f2 = u2[t2], h2 = c2[t2] + a2.from;
        if (rB(i2, r2, h2, h2 + f2.length)) {
          if (f2 instanceof nB) {
            if (o2 & QL.ExcludeBuffers)
              continue;
            var d2 = f2.findChild(0, f2.buffer.length, n2, r2 - h2, i2);
            if (d2 > -1)
              return new lB(new cB(a2, f2, t2, h2), null, d2);
          } else if (o2 & QL.IncludeAnonymous || !f2.type.isAnonymous || hB(f2)) {
            var v2 = void 0;
            if (!(o2 & QL.IgnoreMounts) && f2.props && (v2 = f2.prop(UL.mounted)) && !v2.overlay)
              return new e22(v2.tree, h2, t2, a2);
            var p2 = new e22(f2, h2, t2, a2);
            return o2 & QL.IncludeAnonymous || !p2.type.isAnonymous ? p2 : p2.nextChild(n2 < 0 ? f2.children.length - 1 : 0, n2, r2, i2);
          }
        }
      }
      if (o2 & QL.IncludeAnonymous || !a2.type.isAnonymous)
        return null;
      if (t2 = a2.index >= 0 ? a2.index + n2 : n2 < 0 ? -1 : a2._parent._tree.children.length, !(a2 = a2._parent))
        return null;
    }
  } }, { key: "firstChild", get: function() {
    return this.nextChild(0, 1, 0, 4);
  } }, { key: "lastChild", get: function() {
    return this.nextChild(this._tree.children.length - 1, -1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.nextChild(0, 1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.nextChild(this._tree.children.length - 1, -1, e23, -2);
  } }, { key: "enter", value: function(t2, n2) {
    var r2, i2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    if (!(i2 & QL.IgnoreOverlays) && (r2 = this._tree.prop(UL.mounted)) && r2.overlay) {
      var o2, a2 = t2 - this.from, s2 = bi(r2.overlay);
      try {
        for (s2.s(); !(o2 = s2.n()).done; ) {
          var u2 = o2.value, c2 = u2.from, l2 = u2.to;
          if ((n2 > 0 ? c2 <= a2 : c2 < a2) && (n2 < 0 ? l2 >= a2 : l2 > a2))
            return new e22(r2.tree, r2.overlay[0].from + this.from, -1, this);
        }
      } catch (e23) {
        s2.e(e23);
      } finally {
        s2.f();
      }
    }
    return this.nextChild(0, 1, t2, n2, i2);
  } }, { key: "nextSignificantParent", value: function() {
    for (var e23 = this; e23.type.isAnonymous && e23._parent; )
      e23 = e23._parent;
    return e23;
  } }, { key: "parent", get: function() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  } }, { key: "nextSibling", get: function() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(this.index + 1, 1, 0, 4) : null;
  } }, { key: "prevSibling", get: function() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(this.index - 1, -1, 0, 4) : null;
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new fB(this, e23);
  } }, { key: "tree", get: function() {
    return this._tree;
  } }, { key: "toTree", value: function() {
    return this._tree;
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return oB(this, e23, t2, false);
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return oB(this, e23, t2, true);
  } }, { key: "enterUnfinishedNodesBefore", value: function(e23) {
    return iB(this, e23);
  } }, { key: "getChild", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, r2 = sB(this, e23, t2, n2);
    return r2.length ? r2[0] : null;
  } }, { key: "getChildren", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return sB(this, e23, t2, n2);
  } }, { key: "toString", value: function() {
    return this._tree.toString();
  } }, { key: "node", get: function() {
    return this;
  } }, { key: "matchContext", value: function(e23) {
    return uB(this, e23);
  } }]), e22;
}();
function sB(e22, t2, n2, r2) {
  var i2 = e22.cursor(), o2 = [];
  if (!i2.firstChild())
    return o2;
  if (n2 != null) {
    for (; !i2.type.is(n2); )
      if (!i2.nextSibling())
        return o2;
  }
  for (; ; ) {
    if (r2 != null && i2.type.is(r2))
      return o2;
    if (i2.type.is(t2) && o2.push(i2.node), !i2.nextSibling())
      return r2 == null ? o2 : [];
  }
}
function uB(e22, t2) {
  for (var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : t2.length - 1, r2 = e22.parent; n2 >= 0; r2 = r2.parent) {
    if (!r2)
      return false;
    if (!r2.type.isAnonymous) {
      if (t2[n2] && t2[n2] != r2.name)
        return false;
      n2--;
    }
  }
  return true;
}
var cB = zi(function e18(t2, n2, r2, i2) {
  Ri(this, e18), this.parent = t2, this.buffer = n2, this.index = r2, this.start = i2;
}), lB = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.context = t2, this._parent = n2, this.index = r2, this.type = t2.buffer.set.types[t2.buffer.buffer[r2]];
  }
  return zi(e22, [{ key: "name", get: function() {
    return this.type.name;
  } }, { key: "from", get: function() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  } }, { key: "to", get: function() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  } }, { key: "child", value: function(t2, n2, r2) {
    var i2 = this.context.buffer, o2 = i2.findChild(this.index + 4, i2.buffer[this.index + 3], t2, n2 - this.context.start, r2);
    return o2 < 0 ? null : new e22(this.context, this, o2);
  } }, { key: "firstChild", get: function() {
    return this.child(1, 0, 4);
  } }, { key: "lastChild", get: function() {
    return this.child(-1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.child(1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.child(-1, e23, -2);
  } }, { key: "enter", value: function(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    if (r2 & QL.ExcludeBuffers)
      return null;
    var i2 = this.context.buffer, o2 = i2.findChild(this.index + 4, i2.buffer[this.index + 3], n2 > 0 ? 1 : -1, t2 - this.context.start, n2);
    return o2 < 0 ? null : new e22(this.context, this, o2);
  } }, { key: "parent", get: function() {
    return this._parent || this.context.parent.nextSignificantParent();
  } }, { key: "externalSibling", value: function(e23) {
    return this._parent ? null : this.context.parent.nextChild(this.context.index + e23, e23, 0, 4);
  } }, { key: "nextSibling", get: function() {
    var t2 = this.context.buffer, n2 = t2.buffer[this.index + 3];
    return n2 < (this._parent ? t2.buffer[this._parent.index + 3] : t2.buffer.length) ? new e22(this.context, this._parent, n2) : this.externalSibling(1);
  } }, { key: "prevSibling", get: function() {
    var t2 = this.context.buffer, n2 = this._parent ? this._parent.index + 4 : 0;
    return this.index == n2 ? this.externalSibling(-1) : new e22(this.context, this._parent, t2.findChild(n2, this.index, -1, 0, 4));
  } }, { key: "cursor", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return new fB(this, e23);
  } }, { key: "tree", get: function() {
    return null;
  } }, { key: "toTree", value: function() {
    var e23 = [], t2 = [], n2 = this.context.buffer, r2 = this.index + 4, i2 = n2.buffer[this.index + 3];
    if (i2 > r2) {
      var o2 = n2.buffer[this.index + 1], a2 = n2.buffer[this.index + 2];
      e23.push(n2.slice(r2, i2, o2, a2)), t2.push(0);
    }
    return new eB(this.type, e23, t2, this.to - this.from);
  } }, { key: "resolve", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return oB(this, e23, t2, false);
  } }, { key: "resolveInner", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return oB(this, e23, t2, true);
  } }, { key: "enterUnfinishedNodesBefore", value: function(e23) {
    return iB(this, e23);
  } }, { key: "toString", value: function() {
    return this.context.buffer.childString(this.index);
  } }, { key: "getChild", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, r2 = sB(this, e23, t2, n2);
    return r2.length ? r2[0] : null;
  } }, { key: "getChildren", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return sB(this, e23, t2, n2);
  } }, { key: "node", get: function() {
    return this;
  } }, { key: "matchContext", value: function(e23) {
    return uB(this, e23);
  } }]), e22;
}(), fB = function() {
  function e22(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    if (Ri(this, e22), this.mode = n2, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, t2 instanceof aB)
      this.yieldNode(t2);
    else {
      this._tree = t2.context.parent, this.buffer = t2.context;
      for (var r2 = t2._parent; r2; r2 = r2._parent)
        this.stack.unshift(r2.index);
      this.bufferNode = t2, this.yieldBuf(t2.index);
    }
  }
  return zi(e22, [{ key: "name", get: function() {
    return this.type.name;
  } }, { key: "yieldNode", value: function(e23) {
    return !!e23 && (this._tree = e23, this.type = e23.type, this.from = e23.from, this.to = e23.to, true);
  } }, { key: "yieldBuf", value: function(e23, t2) {
    this.index = e23;
    var n2 = this.buffer, r2 = n2.start, i2 = n2.buffer;
    return this.type = t2 || i2.set.types[i2.buffer[e23]], this.from = r2 + i2.buffer[e23 + 1], this.to = r2 + i2.buffer[e23 + 2], true;
  } }, { key: "yield", value: function(e23) {
    return !!e23 && (e23 instanceof aB ? (this.buffer = null, this.yieldNode(e23)) : (this.buffer = e23.context, this.yieldBuf(e23.index, e23.type)));
  } }, { key: "toString", value: function() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  } }, { key: "enterChild", value: function(e23, t2, n2) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e23 < 0 ? this._tree._tree.children.length - 1 : 0, e23, t2, n2, this.mode));
    var r2 = this.buffer.buffer, i2 = r2.findChild(this.index + 4, r2.buffer[this.index + 3], e23, t2 - this.buffer.start, n2);
    return !(i2 < 0) && (this.stack.push(this.index), this.yieldBuf(i2));
  } }, { key: "firstChild", value: function() {
    return this.enterChild(1, 0, 4);
  } }, { key: "lastChild", value: function() {
    return this.enterChild(-1, 0, 4);
  } }, { key: "childAfter", value: function(e23) {
    return this.enterChild(1, e23, 2);
  } }, { key: "childBefore", value: function(e23) {
    return this.enterChild(-1, e23, -2);
  } }, { key: "enter", value: function(e23, t2) {
    var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : this.mode;
    return this.buffer ? !(n2 & QL.ExcludeBuffers) && this.enterChild(1, e23, t2) : this.yield(this._tree.enter(e23, t2, n2));
  } }, { key: "parent", value: function() {
    if (!this.buffer)
      return this.yieldNode(this.mode & QL.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    var e23 = this.mode & QL.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e23);
  } }, { key: "sibling", value: function(e23) {
    if (!this.buffer)
      return !!this._tree._parent && this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e23, e23, 0, 4, this.mode));
    var t2 = this.buffer.buffer, n2 = this.stack.length - 1;
    if (e23 < 0) {
      var r2 = n2 < 0 ? 0 : this.stack[n2] + 4;
      if (this.index != r2)
        return this.yieldBuf(t2.findChild(r2, this.index, -1, 0, 4));
    } else {
      var i2 = t2.buffer[this.index + 3];
      if (i2 < (n2 < 0 ? t2.buffer.length : t2.buffer[this.stack[n2] + 3]))
        return this.yieldBuf(i2);
    }
    return n2 < 0 && this.yield(this.buffer.parent.nextChild(this.buffer.index + e23, e23, 0, 4, this.mode));
  } }, { key: "nextSibling", value: function() {
    return this.sibling(1);
  } }, { key: "prevSibling", value: function() {
    return this.sibling(-1);
  } }, { key: "atLastNode", value: function(e23) {
    var t2, n2, r2 = this.buffer;
    if (r2) {
      if (e23 > 0) {
        if (this.index < r2.buffer.buffer.length)
          return false;
      } else
        for (var i2 = 0; i2 < this.index; i2++)
          if (r2.buffer.buffer[i2 + 3] < this.index)
            return false;
      t2 = r2.index, n2 = r2.parent;
    } else {
      var o2 = this._tree;
      t2 = o2.index, n2 = o2._parent;
    }
    for (; n2; t2 = (a2 = n2).index, n2 = a2._parent, a2) {
      var a2;
      if (t2 > -1)
        for (var s2 = t2 + e23, u2 = e23 < 0 ? -1 : n2._tree.children.length; s2 != u2; s2 += e23) {
          var c2 = n2._tree.children[s2];
          if (this.mode & QL.IncludeAnonymous || c2 instanceof nB || !c2.type.isAnonymous || hB(c2))
            return false;
        }
    }
    return true;
  } }, { key: "move", value: function(e23, t2) {
    if (t2 && this.enterChild(e23, 0, 4))
      return true;
    for (; ; ) {
      if (this.sibling(e23))
        return true;
      if (this.atLastNode(e23) || !this.parent())
        return false;
    }
  } }, { key: "next", value: function() {
    var e23 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    return this.move(1, e23);
  } }, { key: "prev", value: function() {
    var e23 = !(arguments.length > 0 && arguments[0] !== void 0) || arguments[0];
    return this.move(-1, e23);
  } }, { key: "moveTo", value: function(e23) {
    for (var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0; (this.from == this.to || (t2 < 1 ? this.from >= e23 : this.from > e23) || (t2 > -1 ? this.to <= e23 : this.to < e23)) && this.parent(); )
      ;
    for (; this.enterChild(1, e23, t2); )
      ;
    return this;
  } }, { key: "node", get: function() {
    if (!this.buffer)
      return this._tree;
    var e23 = this.bufferNode, t2 = null, n2 = 0;
    if (e23 && e23.context == this.buffer)
      e:
        for (var r2 = this.index, i2 = this.stack.length; i2 >= 0; ) {
          for (var o2 = e23; o2; o2 = o2._parent)
            if (o2.index == r2) {
              if (r2 == this.index)
                return o2;
              t2 = o2, n2 = i2 + 1;
              break e;
            }
          r2 = this.stack[--i2];
        }
    for (var a2 = n2; a2 < this.stack.length; a2++)
      t2 = new lB(this.buffer, t2, this.stack[a2]);
    return this.bufferNode = new lB(this.buffer, t2, this.index);
  } }, { key: "tree", get: function() {
    return this.buffer ? null : this._tree._tree;
  } }, { key: "iterate", value: function(e23, t2) {
    for (var n2 = 0; ; ) {
      var r2 = false;
      if (this.type.isAnonymous || e23(this) !== false) {
        if (this.firstChild()) {
          n2++;
          continue;
        }
        this.type.isAnonymous || (r2 = true);
      }
      for (; r2 && t2 && t2(this), r2 = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!n2)
          return;
        this.parent(), n2--, r2 = true;
      }
    }
  } }, { key: "matchContext", value: function(e23) {
    if (!this.buffer)
      return uB(this.node, e23);
    for (var t2 = this.buffer.buffer, n2 = t2.set.types, r2 = e23.length - 1, i2 = this.stack.length - 1; r2 >= 0; i2--) {
      if (i2 < 0)
        return uB(this.node, e23, r2);
      var o2 = n2[t2.buffer[this.stack[i2]]];
      if (!o2.isAnonymous) {
        if (e23[r2] && e23[r2] != o2.name)
          return false;
        r2--;
      }
    }
    return true;
  } }]), e22;
}();
function hB(e22) {
  return e22.children.some(function(e23) {
    return e23 instanceof nB || !e23.type.isAnonymous || hB(e23);
  });
}
function dB(e22) {
  var t2, n2 = e22.buffer, r2 = e22.nodeSet, i2 = e22.maxBufferLength, o2 = i2 === void 0 ? 1024 : i2, a2 = e22.reused, s2 = a2 === void 0 ? [] : a2, u2 = e22.minRepeatType, c2 = u2 === void 0 ? r2.types.length : u2, l2 = Array.isArray(n2) ? new tB(n2, n2.length) : n2, f2 = r2.types, h2 = 0, d2 = 0;
  function v2(e23, t3, n3, i3, a3) {
    for (var u3 = l2.id, y3 = l2.start, b3 = l2.end, k3 = l2.size, w2 = d2; k3 < 0; ) {
      if (l2.next(), k3 == -1) {
        var x2 = s2[u3];
        return n3.push(x2), void i3.push(y3 - e23);
      }
      if (k3 == -3)
        return void (h2 = u3);
      if (k3 == -4)
        return void (d2 = u3);
      throw new RangeError("Unrecognized record size: ".concat(k3));
    }
    var j2, S2, C2 = f2[u3], _2 = y3 - e23;
    if (b3 - y3 <= o2 && (S2 = function(e24, t4) {
      var n4 = l2.fork(), r3 = 0, i4 = 0, a4 = 0, s3 = n4.end - o2, u4 = { size: 0, start: 0, skip: 0 };
      e:
        for (var f3 = n4.pos - e24; n4.pos > f3; ) {
          var h3 = n4.size;
          if (n4.id == t4 && h3 >= 0)
            u4.size = r3, u4.start = i4, u4.skip = a4, a4 += 4, r3 += 4, n4.next();
          else {
            var d3 = n4.pos - h3;
            if (h3 < 0 || d3 < f3 || n4.start < s3)
              break;
            var v3 = n4.id >= c2 ? 4 : 0, p3 = n4.start;
            for (n4.next(); n4.pos > d3; ) {
              if (n4.size < 0) {
                if (n4.size != -3)
                  break e;
                v3 += 4;
              } else
                n4.id >= c2 && (v3 += 4);
              n4.next();
            }
            i4 = p3, r3 += h3, a4 += v3;
          }
        }
      (t4 < 0 || r3 == e24) && (u4.size = r3, u4.start = i4, u4.skip = a4);
      return u4.size > 4 ? u4 : void 0;
    }(l2.pos - t3, a3))) {
      for (var $2 = new Uint16Array(S2.size - S2.skip), O2 = l2.pos - S2.size, A2 = $2.length; l2.pos > O2; )
        A2 = g2(S2.start, $2, A2);
      j2 = new nB($2, b3 - S2.start, r2), _2 = S2.start - e23;
    } else {
      var M2 = l2.pos - k3;
      l2.next();
      for (var E2 = [], P2 = [], N2 = u3 >= c2 ? u3 : -1, T2 = 0, I2 = b3; l2.pos > M2; )
        N2 >= 0 && l2.id == N2 && l2.size >= 0 ? (l2.end <= I2 - o2 && (p2(E2, P2, y3, T2, l2.end, I2, N2, w2), T2 = E2.length, I2 = l2.end), l2.next()) : v2(y3, M2, E2, P2, N2);
      if (N2 >= 0 && T2 > 0 && T2 < E2.length && p2(E2, P2, y3, T2, y3, I2, N2, w2), E2.reverse(), P2.reverse(), N2 > -1 && T2 > 0) {
        var R2 = function(e24) {
          return function(t4, n4, r3) {
            var i4, o3, a4 = 0, s3 = t4.length - 1;
            if (s3 >= 0 && (i4 = t4[s3]) instanceof eB) {
              if (!s3 && i4.type == e24 && i4.length == r3)
                return i4;
              (o3 = i4.prop(UL.lookAhead)) && (a4 = n4[s3] + i4.length + o3);
            }
            return m2(e24, t4, n4, r3, a4);
          };
        }(C2);
        j2 = mB(C2, E2, P2, 0, E2.length, 0, b3 - y3, R2, R2);
      } else
        j2 = m2(C2, E2, P2, b3 - y3, w2 - b3);
    }
    n3.push(j2), i3.push(_2);
  }
  function p2(e23, t3, n3, i3, o3, a3, s3, u3) {
    for (var c3 = [], l3 = []; e23.length > i3; )
      c3.push(e23.pop()), l3.push(t3.pop() + n3 - o3);
    e23.push(m2(r2.types[s3], c3, l3, a3 - o3, u3 - a3)), t3.push(o3 - n3);
  }
  function m2(e23, t3, n3, r3) {
    var i3 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0, o3 = arguments.length > 5 ? arguments[5] : void 0;
    if (h2) {
      var a3 = [UL.contextHash, h2];
      o3 = o3 ? [a3].concat(o3) : [a3];
    }
    if (i3 > 25) {
      var s3 = [UL.lookAhead, i3];
      o3 = o3 ? [s3].concat(o3) : [s3];
    }
    return new eB(e23, t3, n3, r3, o3);
  }
  function g2(e23, t3, n3) {
    var r3 = l2.id, i3 = l2.start, o3 = l2.end, a3 = l2.size;
    if (l2.next(), a3 >= 0 && r3 < c2) {
      var s3 = n3;
      if (a3 > 4)
        for (var u3 = l2.pos - (a3 - 4); l2.pos > u3; )
          n3 = g2(e23, t3, n3);
      t3[--n3] = s3, t3[--n3] = o3 - e23, t3[--n3] = i3 - e23, t3[--n3] = r3;
    } else
      a3 == -3 ? h2 = r3 : a3 == -4 && (d2 = r3);
    return n3;
  }
  for (var y2 = [], b2 = []; l2.pos > 0; )
    v2(e22.start || 0, e22.bufferStart || 0, y2, b2, -1);
  var k2 = (t2 = e22.length) !== null && t2 !== void 0 ? t2 : y2.length ? b2[0] + y2[0].length : 0;
  return new eB(f2[e22.topID], y2.reverse(), b2.reverse(), k2);
}
var vB = /* @__PURE__ */ new WeakMap();
function pB(e22, t2) {
  if (!e22.isAnonymous || t2 instanceof nB || t2.type != e22)
    return 1;
  var n2 = vB.get(t2);
  if (n2 == null) {
    n2 = 1;
    var r2, i2 = bi(t2.children);
    try {
      for (i2.s(); !(r2 = i2.n()).done; ) {
        var o2 = r2.value;
        if (o2.type != e22 || !(o2 instanceof eB)) {
          n2 = 1;
          break;
        }
        n2 += pB(e22, o2);
      }
    } catch (e23) {
      i2.e(e23);
    } finally {
      i2.f();
    }
    vB.set(t2, n2);
  }
  return n2;
}
function mB(e22, t2, n2, r2, i2, o2, a2, s2, u2) {
  for (var c2 = 0, l2 = r2; l2 < i2; l2++)
    c2 += pB(e22, t2[l2]);
  var f2 = Math.ceil(1.5 * c2 / 8), h2 = [], d2 = [];
  return function t3(n3, r3, i3, a3, s3) {
    for (var c3 = i3; c3 < a3; ) {
      var l3 = c3, v2 = r3[c3], p2 = pB(e22, n3[c3]);
      for (c3++; c3 < a3; c3++) {
        var m2 = pB(e22, n3[c3]);
        if (p2 + m2 >= f2)
          break;
        p2 += m2;
      }
      if (c3 == l3 + 1) {
        if (p2 > f2) {
          var g2 = n3[l3];
          t3(g2.children, g2.positions, 0, g2.children.length, r3[l3] + s3);
          continue;
        }
        h2.push(n3[l3]);
      } else {
        var y2 = r3[c3 - 1] + n3[c3 - 1].length - v2;
        h2.push(mB(e22, n3, r3, l3, c3, v2, y2, null, u2));
      }
      d2.push(v2 + s3 - o2);
    }
  }(t2, n2, r2, i2, 0), (s2 || u2)(h2, d2, a2);
}
var gB = function() {
  function e22() {
    Ri(this, e22);
  }
  return zi(e22, [{ key: "startParse", value: function(e23, t2, n2) {
    return typeof e23 == "string" && (e23 = new yB(e23)), n2 = n2 ? n2.length ? n2.map(function(e24) {
      return new JL(e24.from, e24.to);
    }) : [new JL(0, 0)] : [new JL(0, e23.length)], this.createParse(e23, t2 || [], n2);
  } }, { key: "parse", value: function(e23, t2, n2) {
    for (var r2 = this.startParse(e23, t2, n2); ; ) {
      var i2 = r2.advance();
      if (i2)
        return i2;
    }
  } }]), e22;
}(), yB = function() {
  function e22(t2) {
    Ri(this, e22), this.string = t2;
  }
  return zi(e22, [{ key: "length", get: function() {
    return this.string.length;
  } }, { key: "chunk", value: function(e23) {
    return this.string.slice(e23);
  } }, { key: "lineChunks", get: function() {
    return false;
  } }, { key: "read", value: function(e23, t2) {
    return this.string.slice(e23, t2);
  } }]), e22;
}();
new UL({ perNode: true });
var bB, kB = function() {
  function e22(t2, n2, r2, i2, o2, a2, s2, u2, c2) {
    var l2 = arguments.length > 9 && arguments[9] !== void 0 ? arguments[9] : 0, f2 = arguments.length > 10 ? arguments[10] : void 0;
    Ri(this, e22), this.p = t2, this.stack = n2, this.state = r2, this.reducePos = i2, this.pos = o2, this.score = a2, this.buffer = s2, this.bufferBase = u2, this.curContext = c2, this.lookAhead = l2, this.parent = f2;
  }
  return zi(e22, [{ key: "toString", value: function() {
    return "[".concat(this.stack.filter(function(e23, t2) {
      return t2 % 3 == 0;
    }).concat(this.state), "]@").concat(this.pos).concat(this.score ? "!" + this.score : "");
  } }, { key: "context", get: function() {
    return this.curContext ? this.curContext.context : null;
  } }, { key: "pushState", value: function(e23, t2) {
    this.stack.push(this.state, t2, this.bufferBase + this.buffer.length), this.state = e23;
  } }, { key: "reduce", value: function(e23) {
    var t2 = e23 >> 19, n2 = 65535 & e23, r2 = this.p.parser, i2 = r2.dynamicPrecedence(n2);
    if (i2 && (this.score += i2), t2 == 0)
      return this.pushState(r2.getGoto(this.state, n2, true), this.reducePos), n2 < r2.minRepeatTerm && this.storeNode(n2, this.reducePos, this.reducePos, 4, true), void this.reduceContext(n2, this.reducePos);
    var o2 = this.stack.length - 3 * (t2 - 1) - (262144 & e23 ? 6 : 0), a2 = this.stack[o2 - 2], s2 = this.stack[o2 - 1], u2 = this.bufferBase + this.buffer.length - s2;
    if (n2 < r2.minRepeatTerm || 131072 & e23) {
      var c2 = r2.stateFlag(this.state, 1) ? this.pos : this.reducePos;
      this.storeNode(n2, a2, c2, u2 + 4, true);
    }
    if (262144 & e23)
      this.state = this.stack[o2];
    else {
      var l2 = this.stack[o2 - 3];
      this.state = r2.getGoto(l2, n2, true);
    }
    for (; this.stack.length > o2; )
      this.stack.pop();
    this.reduceContext(n2, a2);
  } }, { key: "storeNode", value: function(e23, t2, n2) {
    var r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 4, i2 = arguments.length > 4 && arguments[4] !== void 0 && arguments[4];
    if (e23 == 0 && (!this.stack.length || this.stack[this.stack.length - 1] < this.buffer.length + this.bufferBase)) {
      var o2 = this, a2 = this.buffer.length;
      if (a2 == 0 && o2.parent && (a2 = o2.bufferBase - o2.parent.bufferBase, o2 = o2.parent), a2 > 0 && o2.buffer[a2 - 4] == 0 && o2.buffer[a2 - 1] > -1) {
        if (t2 == n2)
          return;
        if (o2.buffer[a2 - 2] >= t2)
          return void (o2.buffer[a2 - 2] = n2);
      }
    }
    if (i2 && this.pos != n2) {
      var s2 = this.buffer.length;
      if (s2 > 0 && this.buffer[s2 - 4] != 0)
        for (; s2 > 0 && this.buffer[s2 - 2] > n2; )
          this.buffer[s2] = this.buffer[s2 - 4], this.buffer[s2 + 1] = this.buffer[s2 - 3], this.buffer[s2 + 2] = this.buffer[s2 - 2], this.buffer[s2 + 3] = this.buffer[s2 - 1], s2 -= 4, r2 > 4 && (r2 -= 4);
      this.buffer[s2] = e23, this.buffer[s2 + 1] = t2, this.buffer[s2 + 2] = n2, this.buffer[s2 + 3] = r2;
    } else
      this.buffer.push(e23, t2, n2, r2);
  } }, { key: "shift", value: function(e23, t2, n2) {
    var r2 = this.pos;
    if (131072 & e23)
      this.pushState(65535 & e23, this.pos);
    else if ((262144 & e23) == 0) {
      var i2 = e23, o2 = this.p.parser;
      (n2 > this.pos || t2 <= o2.maxNode) && (this.pos = n2, o2.stateFlag(i2, 1) || (this.reducePos = n2)), this.pushState(i2, r2), this.shiftContext(t2, r2), t2 <= o2.maxNode && this.buffer.push(t2, r2, n2, 4);
    } else
      this.pos = n2, this.shiftContext(t2, r2), t2 <= this.p.parser.maxNode && this.buffer.push(t2, r2, n2, 4);
  } }, { key: "apply", value: function(e23, t2, n2) {
    65536 & e23 ? this.reduce(e23) : this.shift(e23, t2, n2);
  } }, { key: "useNode", value: function(e23, t2) {
    var n2 = this.p.reused.length - 1;
    (n2 < 0 || this.p.reused[n2] != e23) && (this.p.reused.push(e23), n2++);
    var r2 = this.pos;
    this.reducePos = this.pos = r2 + e23.length, this.pushState(t2, r2), this.buffer.push(n2, r2, this.reducePos, -1), this.curContext && this.updateContext(this.curContext.tracker.reuse(this.curContext.context, e23, this, this.p.stream.reset(this.pos - e23.length)));
  } }, { key: "split", value: function() {
    for (var t2 = this, n2 = t2.buffer.length; n2 > 0 && t2.buffer[n2 - 2] > t2.reducePos; )
      n2 -= 4;
    for (var r2 = t2.buffer.slice(n2), i2 = t2.bufferBase + n2; t2 && i2 == t2.bufferBase; )
      t2 = t2.parent;
    return new e22(this.p, this.stack.slice(), this.state, this.reducePos, this.pos, this.score, r2, i2, this.curContext, this.lookAhead, t2);
  } }, { key: "recoverByDelete", value: function(e23, t2) {
    var n2 = e23 <= this.p.parser.maxNode;
    n2 && this.storeNode(e23, this.pos, t2, 4), this.storeNode(0, this.pos, t2, n2 ? 8 : 4), this.pos = this.reducePos = t2, this.score -= 190;
  } }, { key: "canShift", value: function(e23) {
    for (var t2 = new xB(this); ; ) {
      var n2 = this.p.parser.stateSlot(t2.state, 4) || this.p.parser.hasAction(t2.state, e23);
      if ((65536 & n2) == 0)
        return true;
      if (n2 == 0)
        return false;
      t2.reduce(n2);
    }
  } }, { key: "recoverByInsert", value: function(e23) {
    if (this.stack.length >= 300)
      return [];
    var t2 = this.p.parser.nextStates(this.state);
    if (t2.length > 8 || this.stack.length >= 120) {
      for (var n2, r2 = [], i2 = 0; i2 < t2.length; i2 += 2)
        (n2 = t2[i2 + 1]) != this.state && this.p.parser.hasAction(n2, e23) && r2.push(t2[i2], n2);
      if (this.stack.length < 120)
        for (var o2 = function(e24) {
          var n3 = t2[e24 + 1];
          r2.some(function(e25, t3) {
            return 1 & t3 && e25 == n3;
          }) || r2.push(t2[e24], n3);
        }, a2 = 0; r2.length < 8 && a2 < t2.length; a2 += 2)
          o2(a2);
      t2 = r2;
    }
    for (var s2 = [], u2 = 0; u2 < t2.length && s2.length < 4; u2 += 2) {
      var c2 = t2[u2 + 1];
      if (c2 != this.state) {
        var l2 = this.split();
        l2.pushState(c2, this.pos), l2.storeNode(0, l2.pos, l2.pos, 4, true), l2.shiftContext(t2[u2], this.pos), l2.score -= 200, s2.push(l2);
      }
    }
    return s2;
  } }, { key: "forceReduce", value: function() {
    var e23 = this.p.parser.stateSlot(this.state, 5);
    if ((65536 & e23) == 0)
      return false;
    var t2 = this.p.parser;
    if (!t2.validAction(this.state, e23)) {
      var n2 = e23 >> 19, r2 = 65535 & e23, i2 = this.stack.length - 3 * n2;
      if (i2 < 0 || t2.getGoto(this.stack[i2], r2, false) < 0)
        return false;
      this.storeNode(0, this.reducePos, this.reducePos, 4, true), this.score -= 100;
    }
    return this.reducePos = this.pos, this.reduce(e23), true;
  } }, { key: "forceAll", value: function() {
    for (; !this.p.parser.stateFlag(this.state, 2); )
      if (!this.forceReduce()) {
        this.storeNode(0, this.pos, this.pos, 4, true);
        break;
      }
    return this;
  } }, { key: "deadEnd", get: function() {
    if (this.stack.length != 3)
      return false;
    var e23 = this.p.parser;
    return e23.data[e23.stateSlot(this.state, 1)] == 65535 && !e23.stateSlot(this.state, 4);
  } }, { key: "restart", value: function() {
    this.state = this.stack[0], this.stack.length = 0;
  } }, { key: "sameState", value: function(e23) {
    if (this.state != e23.state || this.stack.length != e23.stack.length)
      return false;
    for (var t2 = 0; t2 < this.stack.length; t2 += 3)
      if (this.stack[t2] != e23.stack[t2])
        return false;
    return true;
  } }, { key: "parser", get: function() {
    return this.p.parser;
  } }, { key: "dialectEnabled", value: function(e23) {
    return this.p.parser.dialect.flags[e23];
  } }, { key: "shiftContext", value: function(e23, t2) {
    this.curContext && this.updateContext(this.curContext.tracker.shift(this.curContext.context, e23, this, this.p.stream.reset(t2)));
  } }, { key: "reduceContext", value: function(e23, t2) {
    this.curContext && this.updateContext(this.curContext.tracker.reduce(this.curContext.context, e23, this, this.p.stream.reset(t2)));
  } }, { key: "emitContext", value: function() {
    var e23 = this.buffer.length - 1;
    (e23 < 0 || this.buffer[e23] != -3) && this.buffer.push(this.curContext.hash, this.reducePos, this.reducePos, -3);
  } }, { key: "emitLookAhead", value: function() {
    var e23 = this.buffer.length - 1;
    (e23 < 0 || this.buffer[e23] != -4) && this.buffer.push(this.lookAhead, this.reducePos, this.reducePos, -4);
  } }, { key: "updateContext", value: function(e23) {
    if (e23 != this.curContext.context) {
      var t2 = new wB(this.curContext.tracker, e23);
      t2.hash != this.curContext.hash && this.emitContext(), this.curContext = t2;
    }
  } }, { key: "setLookAhead", value: function(e23) {
    e23 > this.lookAhead && (this.emitLookAhead(), this.lookAhead = e23);
  } }, { key: "close", value: function() {
    this.curContext && this.curContext.tracker.strict && this.emitContext(), this.lookAhead > 0 && this.emitLookAhead();
  } }], [{ key: "start", value: function(t2, n2) {
    var r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, i2 = t2.parser.context;
    return new e22(t2, [], n2, r2, r2, 0, [], 0, i2 ? new wB(i2, i2.start) : null, 0, null);
  } }]), e22;
}(), wB = zi(function e19(t2, n2) {
  Ri(this, e19), this.tracker = t2, this.context = n2, this.hash = t2.strict ? t2.hash(n2) : 0;
});
!function(e22) {
  e22[e22.Insert = 200] = "Insert", e22[e22.Delete = 190] = "Delete", e22[e22.Reduce = 100] = "Reduce", e22[e22.MaxNext = 4] = "MaxNext", e22[e22.MaxInsertStackDepth = 300] = "MaxInsertStackDepth", e22[e22.DampenInsertStackDepth = 120] = "DampenInsertStackDepth";
}(bB || (bB = {}));
var xB = function() {
  function e22(t2) {
    Ri(this, e22), this.start = t2, this.state = t2.state, this.stack = t2.stack, this.base = this.stack.length;
  }
  return zi(e22, [{ key: "reduce", value: function(e23) {
    var t2 = 65535 & e23, n2 = e23 >> 19;
    n2 == 0 ? (this.stack == this.start.stack && (this.stack = this.stack.slice()), this.stack.push(this.state, 0, 0), this.base += 3) : this.base -= 3 * (n2 - 1);
    var r2 = this.start.p.parser.getGoto(this.stack[this.base - 3], t2, true);
    this.state = r2;
  } }]), e22;
}(), jB = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.stack = t2, this.pos = n2, this.index = r2, this.buffer = t2.buffer, this.index == 0 && this.maybeNext();
  }
  return zi(e22, [{ key: "maybeNext", value: function() {
    var e23 = this.stack.parent;
    e23 != null && (this.index = this.stack.bufferBase - e23.bufferBase, this.stack = e23, this.buffer = e23.buffer);
  } }, { key: "id", get: function() {
    return this.buffer[this.index - 4];
  } }, { key: "start", get: function() {
    return this.buffer[this.index - 3];
  } }, { key: "end", get: function() {
    return this.buffer[this.index - 2];
  } }, { key: "size", get: function() {
    return this.buffer[this.index - 1];
  } }, { key: "next", value: function() {
    this.index -= 4, this.pos -= 4, this.index == 0 && this.maybeNext();
  } }, { key: "fork", value: function() {
    return new e22(this.stack, this.pos, this.index);
  } }], [{ key: "create", value: function(t2) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : t2.bufferBase + t2.buffer.length;
    return new e22(t2, n2, n2 - t2.bufferBase);
  } }]), e22;
}(), SB = zi(function e20() {
  Ri(this, e20), this.start = -1, this.value = -1, this.end = -1, this.extended = -1, this.lookAhead = 0, this.mask = 0, this.context = 0;
}), CB = new SB(), _B = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.input = t2, this.ranges = n2, this.chunk = "", this.chunkOff = 0, this.chunk2 = "", this.chunk2Pos = 0, this.next = -1, this.token = CB, this.rangeIndex = 0, this.pos = this.chunkPos = n2[0].from, this.range = n2[0], this.end = n2[n2.length - 1].to, this.readNext();
  }
  return zi(e22, [{ key: "resolveOffset", value: function(e23, t2) {
    for (var n2 = this.range, r2 = this.rangeIndex, i2 = this.pos + e23; i2 < n2.from; ) {
      if (!r2)
        return null;
      var o2 = this.ranges[--r2];
      i2 -= n2.from - o2.to, n2 = o2;
    }
    for (; t2 < 0 ? i2 > n2.to : i2 >= n2.to; ) {
      if (r2 == this.ranges.length - 1)
        return null;
      var a2 = this.ranges[++r2];
      i2 += a2.from - n2.to, n2 = a2;
    }
    return i2;
  } }, { key: "peek", value: function(e23) {
    var t2, n2, r2 = this.chunkOff + e23;
    if (r2 >= 0 && r2 < this.chunk.length)
      t2 = this.pos + e23, n2 = this.chunk.charCodeAt(r2);
    else {
      var i2 = this.resolveOffset(e23, 1);
      if (i2 == null)
        return -1;
      if ((t2 = i2) >= this.chunk2Pos && t2 < this.chunk2Pos + this.chunk2.length)
        n2 = this.chunk2.charCodeAt(t2 - this.chunk2Pos);
      else {
        for (var o2 = this.rangeIndex, a2 = this.range; a2.to <= t2; )
          a2 = this.ranges[++o2];
        this.chunk2 = this.input.chunk(this.chunk2Pos = t2), t2 + this.chunk2.length > a2.to && (this.chunk2 = this.chunk2.slice(0, a2.to - t2)), n2 = this.chunk2.charCodeAt(0);
      }
    }
    return t2 >= this.token.lookAhead && (this.token.lookAhead = t2 + 1), n2;
  } }, { key: "acceptToken", value: function(e23) {
    var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0, n2 = t2 ? this.resolveOffset(t2, -1) : this.pos;
    if (n2 == null || n2 < this.token.start)
      throw new RangeError("Token end out of bounds");
    this.token.value = e23, this.token.end = n2;
  } }, { key: "getChunk", value: function() {
    if (this.pos >= this.chunk2Pos && this.pos < this.chunk2Pos + this.chunk2.length) {
      var e23 = this.chunk, t2 = this.chunkPos;
      this.chunk = this.chunk2, this.chunkPos = this.chunk2Pos, this.chunk2 = e23, this.chunk2Pos = t2, this.chunkOff = this.pos - this.chunkPos;
    } else {
      this.chunk2 = this.chunk, this.chunk2Pos = this.chunkPos;
      var n2 = this.input.chunk(this.pos), r2 = this.pos + n2.length;
      this.chunk = r2 > this.range.to ? n2.slice(0, this.range.to - this.pos) : n2, this.chunkPos = this.pos, this.chunkOff = 0;
    }
  } }, { key: "readNext", value: function() {
    return this.chunkOff >= this.chunk.length && (this.getChunk(), this.chunkOff == this.chunk.length) ? this.next = -1 : this.next = this.chunk.charCodeAt(this.chunkOff);
  } }, { key: "advance", value: function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 1;
    for (this.chunkOff += e23; this.pos + e23 >= this.range.to; ) {
      if (this.rangeIndex == this.ranges.length - 1)
        return this.setDone();
      e23 -= this.range.to - this.pos, this.range = this.ranges[++this.rangeIndex], this.pos = this.range.from;
    }
    return this.pos += e23, this.pos >= this.token.lookAhead && (this.token.lookAhead = this.pos + 1), this.readNext();
  } }, { key: "setDone", value: function() {
    return this.pos = this.chunkPos = this.end, this.range = this.ranges[this.rangeIndex = this.ranges.length - 1], this.chunk = "", this.next = -1;
  } }, { key: "reset", value: function(e23, t2) {
    if (t2 ? (this.token = t2, t2.start = e23, t2.lookAhead = e23 + 1, t2.value = t2.extended = -1) : this.token = CB, this.pos != e23) {
      if (this.pos = e23, e23 == this.end)
        return this.setDone(), this;
      for (; e23 < this.range.from; )
        this.range = this.ranges[--this.rangeIndex];
      for (; e23 >= this.range.to; )
        this.range = this.ranges[++this.rangeIndex];
      e23 >= this.chunkPos && e23 < this.chunkPos + this.chunk.length ? this.chunkOff = e23 - this.chunkPos : (this.chunk = "", this.chunkOff = 0), this.readNext();
    }
    return this;
  } }, { key: "read", value: function(e23, t2) {
    if (e23 >= this.chunkPos && t2 <= this.chunkPos + this.chunk.length)
      return this.chunk.slice(e23 - this.chunkPos, t2 - this.chunkPos);
    if (e23 >= this.chunk2Pos && t2 <= this.chunk2Pos + this.chunk2.length)
      return this.chunk2.slice(e23 - this.chunk2Pos, t2 - this.chunk2Pos);
    if (e23 >= this.range.from && t2 <= this.range.to)
      return this.input.read(e23, t2);
    var n2, r2 = "", i2 = bi(this.ranges);
    try {
      for (i2.s(); !(n2 = i2.n()).done; ) {
        var o2 = n2.value;
        if (o2.from >= t2)
          break;
        o2.to > e23 && (r2 += this.input.read(Math.max(o2.from, e23), Math.min(o2.to, t2)));
      }
    } catch (e24) {
      i2.e(e24);
    } finally {
      i2.f();
    }
    return r2;
  } }]), e22;
}(), $B = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.data = t2, this.id = n2;
  }
  return zi(e22, [{ key: "token", value: function(e23, t2) {
    !function(e24, t3, n2, r2) {
      var i2 = 0, o2 = 1 << r2, a2 = n2.p.parser, s2 = a2.dialect;
      e:
        for (; (o2 & e24[i2]) != 0; ) {
          for (var u2 = e24[i2 + 1], c2 = i2 + 3; c2 < u2; c2 += 2)
            if ((e24[c2 + 1] & o2) > 0) {
              var l2 = e24[c2];
              if (s2.allows(l2) && (t3.token.value == -1 || t3.token.value == l2 || a2.overrides(l2, t3.token.value))) {
                t3.acceptToken(l2);
                break;
              }
            }
          for (var f2 = t3.next, h2 = 0, d2 = e24[i2 + 2]; h2 < d2; ) {
            var v2 = h2 + d2 >> 1, p2 = u2 + v2 + (v2 << 1), m2 = e24[p2], g2 = e24[p2 + 1];
            if (f2 < m2)
              d2 = v2;
            else {
              if (!(f2 >= g2)) {
                i2 = e24[p2 + 2], t3.advance();
                continue e;
              }
              h2 = v2 + 1;
            }
          }
          break;
        }
    }(this.data, e23, t2, this.id);
  } }]), e22;
}();
function OB(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : Uint16Array;
  if (typeof e22 != "string")
    return e22;
  for (var n2 = null, r2 = 0, i2 = 0; r2 < e22.length; ) {
    for (var o2 = 0; ; ) {
      var a2 = e22.charCodeAt(r2++), s2 = false;
      if (a2 == 126) {
        o2 = 65535;
        break;
      }
      a2 >= 92 && a2--, a2 >= 34 && a2--;
      var u2 = a2 - 32;
      if (u2 >= 46 && (u2 -= 46, s2 = true), o2 += u2, s2)
        break;
      o2 *= 46;
    }
    n2 ? n2[i2++] = o2 : n2 = new t2(o2);
  }
  return n2;
}
$B.prototype.contextual = $B.prototype.fallback = $B.prototype.extend = false;
var AB, MB = typeof process != "undefined" && process.env && /\bparse\b/.test({}.LOG), EB = null;
function PB(e22, t2, n2) {
  var r2 = e22.cursor(QL.IncludeAnonymous);
  for (r2.moveTo(t2); ; )
    if (!(n2 < 0 ? r2.childBefore(t2) : r2.childAfter(t2)))
      for (; ; ) {
        if ((n2 < 0 ? r2.to < t2 : r2.from > t2) && !r2.type.isError)
          return n2 < 0 ? Math.max(0, Math.min(r2.to - 1, t2 - 25)) : Math.min(e22.length, Math.max(r2.from + 1, t2 + 25));
        if (n2 < 0 ? r2.prevSibling() : r2.nextSibling())
          break;
        if (!r2.parent())
          return n2 < 0 ? 0 : e22.length;
      }
}
!function(e22) {
  e22[e22.Margin = 25] = "Margin";
}(AB || (AB = {}));
var NB, TB = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.fragments = t2, this.nodeSet = n2, this.i = 0, this.fragment = null, this.safeFrom = -1, this.safeTo = -1, this.trees = [], this.start = [], this.index = [], this.nextFragment();
  }
  return zi(e22, [{ key: "nextFragment", value: function() {
    var e23 = this.fragment = this.i == this.fragments.length ? null : this.fragments[this.i++];
    if (e23) {
      for (this.safeFrom = e23.openStart ? PB(e23.tree, e23.from + e23.offset, 1) - e23.offset : e23.from, this.safeTo = e23.openEnd ? PB(e23.tree, e23.to + e23.offset, -1) - e23.offset : e23.to; this.trees.length; )
        this.trees.pop(), this.start.pop(), this.index.pop();
      this.trees.push(e23.tree), this.start.push(-e23.offset), this.index.push(0), this.nextStart = this.safeFrom;
    } else
      this.nextStart = 1e9;
  } }, { key: "nodeAt", value: function(e23) {
    if (e23 < this.nextStart)
      return null;
    for (; this.fragment && this.safeTo <= e23; )
      this.nextFragment();
    if (!this.fragment)
      return null;
    for (; ; ) {
      var t2 = this.trees.length - 1;
      if (t2 < 0)
        return this.nextFragment(), null;
      var n2 = this.trees[t2], r2 = this.index[t2];
      if (r2 != n2.children.length) {
        var i2 = n2.children[r2], o2 = this.start[t2] + n2.positions[r2];
        if (o2 > e23)
          return this.nextStart = o2, null;
        if (i2 instanceof eB) {
          if (o2 == e23) {
            if (o2 < this.safeFrom)
              return null;
            var a2 = o2 + i2.length;
            if (a2 <= this.safeTo) {
              var s2 = i2.prop(UL.lookAhead);
              if (!s2 || a2 + s2 < this.fragment.to)
                return i2;
            }
          }
          this.index[t2]++, o2 + i2.length >= Math.max(this.safeFrom, e23) && (this.trees.push(i2), this.start.push(o2), this.index.push(0));
        } else
          this.index[t2]++, this.nextStart = o2 + i2.length;
      } else
        this.trees.pop(), this.start.pop(), this.index.pop();
    }
  } }]), e22;
}(), IB = function() {
  function e22(t2, n2) {
    Ri(this, e22), this.stream = n2, this.tokens = [], this.mainToken = null, this.actions = [], this.tokens = t2.tokenizers.map(function(e23) {
      return new SB();
    });
  }
  return zi(e22, [{ key: "getActions", value: function(e23) {
    for (var t2 = 0, n2 = null, r2 = e23.p.parser, i2 = r2.tokenizers, o2 = r2.stateSlot(e23.state, 3), a2 = e23.curContext ? e23.curContext.hash : 0, s2 = 0, u2 = 0; u2 < i2.length; u2++)
      if ((1 << u2 & o2) != 0) {
        var c2 = i2[u2], l2 = this.tokens[u2];
        if ((!n2 || c2.fallback) && ((c2.contextual || l2.start != e23.pos || l2.mask != o2 || l2.context != a2) && (this.updateCachedToken(l2, c2, e23), l2.mask = o2, l2.context = a2), l2.lookAhead > l2.end + 25 && (s2 = Math.max(l2.lookAhead, s2)), l2.value != 0)) {
          var f2 = t2;
          if (l2.extended > -1 && (t2 = this.addActions(e23, l2.extended, l2.end, t2)), t2 = this.addActions(e23, l2.value, l2.end, t2), !c2.extend && (n2 = l2, t2 > f2))
            break;
        }
      }
    for (; this.actions.length > t2; )
      this.actions.pop();
    return s2 && e23.setLookAhead(s2), n2 || e23.pos != this.stream.end || ((n2 = new SB()).value = e23.p.parser.eofTerm, n2.start = n2.end = e23.pos, t2 = this.addActions(e23, n2.value, n2.end, t2)), this.mainToken = n2, this.actions;
  } }, { key: "getMainToken", value: function(e23) {
    if (this.mainToken)
      return this.mainToken;
    var t2 = new SB(), n2 = e23.pos, r2 = e23.p;
    return t2.start = n2, t2.end = Math.min(n2 + 1, r2.stream.end), t2.value = n2 == r2.stream.end ? r2.parser.eofTerm : 0, t2;
  } }, { key: "updateCachedToken", value: function(e23, t2, n2) {
    if (t2.token(this.stream.reset(n2.pos, e23), n2), e23.value > -1) {
      for (var r2 = n2.p.parser, i2 = 0; i2 < r2.specialized.length; i2++)
        if (r2.specialized[i2] == e23.value) {
          var o2 = r2.specializers[i2](this.stream.read(e23.start, e23.end), n2);
          if (o2 >= 0 && n2.p.parser.dialect.allows(o2 >> 1)) {
            (1 & o2) == 0 ? e23.value = o2 >> 1 : e23.extended = o2 >> 1;
            break;
          }
        }
    } else
      e23.value = 0, e23.end = Math.min(n2.p.stream.end, n2.pos + 1);
  } }, { key: "putAction", value: function(e23, t2, n2, r2) {
    for (var i2 = 0; i2 < r2; i2 += 3)
      if (this.actions[i2] == e23)
        return r2;
    return this.actions[r2++] = e23, this.actions[r2++] = t2, this.actions[r2++] = n2, r2;
  } }, { key: "addActions", value: function(e23, t2, n2, r2) {
    for (var i2 = e23.state, o2 = e23.p.parser, a2 = o2.data, s2 = 0; s2 < 2; s2++)
      for (var u2 = o2.stateSlot(i2, s2 ? 2 : 1); ; u2 += 3) {
        if (a2[u2] == 65535) {
          if (a2[u2 + 1] != 1) {
            r2 == 0 && a2[u2 + 1] == 2 && (r2 = this.putAction(BB(a2, u2 + 2), t2, n2, r2));
            break;
          }
          u2 = BB(a2, u2 + 2);
        }
        a2[u2] == t2 && (r2 = this.putAction(BB(a2, u2 + 1), t2, n2, r2));
      }
    return r2;
  } }]), e22;
}();
!function(e22) {
  e22[e22.Distance = 5] = "Distance", e22[e22.MaxRemainingPerStep = 3] = "MaxRemainingPerStep", e22[e22.MinBufferLengthPrune = 500] = "MinBufferLengthPrune", e22[e22.ForceReduceLimit = 10] = "ForceReduceLimit", e22[e22.CutDepth = 15e3] = "CutDepth", e22[e22.CutTo = 9e3] = "CutTo";
}(NB || (NB = {}));
var RB = function() {
  function e22(t2, n2, r2, i2) {
    Ri(this, e22), this.parser = t2, this.input = n2, this.ranges = i2, this.recovering = 0, this.nextStackID = 9812, this.minStackPos = 0, this.reused = [], this.stoppedAt = null, this.stream = new _B(n2, i2), this.tokens = new IB(t2, this.stream), this.topTerm = t2.top[1];
    var o2 = i2[0].from;
    this.stacks = [kB.start(this, t2.top[0], o2)], this.fragments = r2.length && this.stream.end - o2 > 4 * t2.bufferLength ? new TB(r2, t2.nodeSet) : null;
  }
  return zi(e22, [{ key: "parsedPos", get: function() {
    return this.minStackPos;
  } }, { key: "advance", value: function() {
    for (var e23, t2, n2 = this.stacks, r2 = this.minStackPos, i2 = this.stacks = [], o2 = 0; o2 < n2.length; o2++)
      for (var a2 = n2[o2]; ; ) {
        if (this.tokens.mainToken = null, a2.pos > r2)
          i2.push(a2);
        else {
          if (this.advanceStack(a2, i2, n2))
            continue;
          e23 || (e23 = [], t2 = []), e23.push(a2);
          var s2 = this.tokens.getMainToken(a2);
          t2.push(s2.value, s2.end);
        }
        break;
      }
    if (!i2.length) {
      var u2 = e23 && function(e24) {
        var t3, n3 = null, r3 = bi(e24);
        try {
          for (r3.s(); !(t3 = r3.n()).done; ) {
            var i3 = t3.value, o3 = i3.p.stoppedAt;
            (i3.pos == i3.p.stream.end || o3 != null && i3.pos > o3) && i3.p.parser.stateFlag(i3.state, 2) && (!n3 || n3.score < i3.score) && (n3 = i3);
          }
        } catch (e25) {
          r3.e(e25);
        } finally {
          r3.f();
        }
        return n3;
      }(e23);
      if (u2)
        return this.stackToTree(u2);
      if (this.parser.strict)
        throw MB && e23 && console.log("Stuck with token " + (this.tokens.mainToken ? this.parser.getName(this.tokens.mainToken.value) : "none")), new SyntaxError("No parse at " + r2);
      this.recovering || (this.recovering = 5);
    }
    if (this.recovering && e23) {
      var c2 = this.stoppedAt != null && e23[0].pos > this.stoppedAt ? e23[0] : this.runRecovery(e23, t2, i2);
      if (c2)
        return this.stackToTree(c2.forceAll());
    }
    if (this.recovering) {
      var l2 = this.recovering == 1 ? 1 : 3 * this.recovering;
      if (i2.length > l2)
        for (i2.sort(function(e24, t3) {
          return t3.score - e24.score;
        }); i2.length > l2; )
          i2.pop();
      i2.some(function(e24) {
        return e24.reducePos > r2;
      }) && this.recovering--;
    } else if (i2.length > 1)
      e:
        for (var f2 = 0; f2 < i2.length - 1; f2++)
          for (var h2 = i2[f2], d2 = f2 + 1; d2 < i2.length; d2++) {
            var v2 = i2[d2];
            if (h2.sameState(v2) || h2.buffer.length > 500 && v2.buffer.length > 500) {
              if (!((h2.score - v2.score || h2.buffer.length - v2.buffer.length) > 0)) {
                i2.splice(f2--, 1);
                continue e;
              }
              i2.splice(d2--, 1);
            }
          }
    this.minStackPos = i2[0].pos;
    for (var p2 = 1; p2 < i2.length; p2++)
      i2[p2].pos < this.minStackPos && (this.minStackPos = i2[p2].pos);
    return null;
  } }, { key: "stopAt", value: function(e23) {
    if (this.stoppedAt != null && this.stoppedAt < e23)
      throw new RangeError("Can't move stoppedAt forward");
    this.stoppedAt = e23;
  } }, { key: "advanceStack", value: function(e23, t2, n2) {
    var r2 = e23.pos, i2 = this.parser, o2 = MB ? this.stackID(e23) + " -> " : "";
    if (this.stoppedAt != null && r2 > this.stoppedAt)
      return e23.forceReduce() ? e23 : null;
    if (this.fragments)
      for (var a2 = e23.curContext && e23.curContext.tracker.strict, s2 = a2 ? e23.curContext.hash : 0, u2 = this.fragments.nodeAt(r2); u2; ) {
        var c2 = this.parser.nodeSet.types[u2.type.id] == u2.type ? i2.getGoto(e23.state, u2.type.id) : -1;
        if (c2 > -1 && u2.length && (!a2 || (u2.prop(UL.contextHash) || 0) == s2))
          return e23.useNode(u2, c2), MB && console.log(o2 + this.stackID(e23) + " (via reuse of ".concat(i2.getName(u2.type.id), ")")), true;
        if (!(u2 instanceof eB) || u2.children.length == 0 || u2.positions[0] > 0)
          break;
        var l2 = u2.children[0];
        if (!(l2 instanceof eB && u2.positions[0] == 0))
          break;
        u2 = l2;
      }
    var f2 = i2.stateSlot(e23.state, 4);
    if (f2 > 0)
      return e23.reduce(f2), MB && console.log(o2 + this.stackID(e23) + " (via always-reduce ".concat(i2.getName(65535 & f2), ")")), true;
    if (e23.stack.length >= 15e3)
      for (; e23.stack.length > 9e3 && e23.forceReduce(); )
        ;
    for (var h2 = this.tokens.getActions(e23), d2 = 0; d2 < h2.length; ) {
      var v2 = h2[d2++], p2 = h2[d2++], m2 = h2[d2++], g2 = d2 == h2.length || !n2, y2 = g2 ? e23 : e23.split();
      if (y2.apply(v2, p2, m2), MB && console.log(o2 + this.stackID(y2) + " (via ".concat((65536 & v2) == 0 ? "shift" : "reduce of ".concat(i2.getName(65535 & v2)), " for ").concat(i2.getName(p2), " @ ").concat(r2).concat(y2 == e23 ? "" : ", split", ")")), g2)
        return true;
      y2.pos > r2 ? t2.push(y2) : n2.push(y2);
    }
    return false;
  } }, { key: "advanceFully", value: function(e23, t2) {
    for (var n2 = e23.pos; ; ) {
      if (!this.advanceStack(e23, null, null))
        return false;
      if (e23.pos > n2)
        return DB(e23, t2), true;
    }
  } }, { key: "runRecovery", value: function(e23, t2, n2) {
    for (var r2 = null, i2 = false, o2 = 0; o2 < e23.length; o2++) {
      var a2 = e23[o2], s2 = t2[o2 << 1], u2 = t2[1 + (o2 << 1)], c2 = MB ? this.stackID(a2) + " -> " : "";
      if (a2.deadEnd) {
        if (i2)
          continue;
        if (i2 = true, a2.restart(), MB && console.log(c2 + this.stackID(a2) + " (restarted)"), this.advanceFully(a2, n2))
          continue;
      }
      for (var l2 = a2.split(), f2 = c2, h2 = 0; l2.forceReduce() && h2 < 10; h2++) {
        if (MB && console.log(f2 + this.stackID(l2) + " (via force-reduce)"), this.advanceFully(l2, n2))
          break;
        MB && (f2 = this.stackID(l2) + " -> ");
      }
      var d2, v2 = bi(a2.recoverByInsert(s2));
      try {
        for (v2.s(); !(d2 = v2.n()).done; ) {
          var p2 = d2.value;
          MB && console.log(c2 + this.stackID(p2) + " (via recover-insert)"), this.advanceFully(p2, n2);
        }
      } catch (e24) {
        v2.e(e24);
      } finally {
        v2.f();
      }
      this.stream.end > a2.pos ? (u2 == a2.pos && (u2++, s2 = 0), a2.recoverByDelete(s2, u2), MB && console.log(c2 + this.stackID(a2) + " (via recover-delete ".concat(this.parser.getName(s2), ")")), DB(a2, n2)) : (!r2 || r2.score < a2.score) && (r2 = a2);
    }
    return r2;
  } }, { key: "stackToTree", value: function(e23) {
    return e23.close(), eB.build({ buffer: jB.create(e23), nodeSet: this.parser.nodeSet, topID: this.topTerm, maxBufferLength: this.parser.bufferLength, reused: this.reused, start: this.ranges[0].from, length: e23.pos - this.ranges[0].from, minRepeatType: this.parser.minRepeatTerm });
  } }, { key: "stackID", value: function(e23) {
    var t2 = (EB || (EB = /* @__PURE__ */ new WeakMap())).get(e23);
    return t2 || EB.set(e23, t2 = String.fromCodePoint(this.nextStackID++)), t2 + e23;
  } }]), e22;
}();
function DB(e22, t2) {
  for (var n2 = 0; n2 < t2.length; n2++) {
    var r2 = t2[n2];
    if (r2.pos == e22.pos && r2.sameState(e22))
      return void (t2[n2].score < e22.score && (t2[n2] = e22));
  }
  t2.push(e22);
}
var zB = function() {
  function e22(t2, n2, r2) {
    Ri(this, e22), this.source = t2, this.flags = n2, this.disabled = r2;
  }
  return zi(e22, [{ key: "allows", value: function(e23) {
    return !this.disabled || this.disabled[e23] == 0;
  } }]), e22;
}(), LB = function(e22) {
  ji(n2, gB);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2, i2;
    if (Ri(this, n2), (i2 = t2.call(this)).wrappers = [], e23.version != 14)
      throw new RangeError("Parser version (".concat(e23.version, ") doesn't match runtime version (", 14, ")"));
    var o2 = e23.nodeNames.split(" ");
    i2.minRepeatTerm = o2.length;
    for (var a2 = 0; a2 < e23.repeatNodeCount; a2++)
      o2.push("");
    for (var s2 = Object.keys(e23.topRules).map(function(t3) {
      return e23.topRules[t3][1];
    }), u2 = [], c2 = 0; c2 < o2.length; c2++)
      u2.push([]);
    function l2(e24, t3, n3) {
      u2[e24].push([t3, t3.deserialize(String(n3))]);
    }
    if (e23.nodeProps) {
      var f2, h2 = bi(e23.nodeProps);
      try {
        for (h2.s(); !(f2 = h2.n()).done; ) {
          var d2 = f2.value, v2 = d2[0];
          typeof v2 == "string" && (v2 = UL[v2]);
          for (var p2 = 1; p2 < d2.length; ) {
            var m2 = d2[p2++];
            if (m2 >= 0)
              l2(m2, v2, d2[p2++]);
            else {
              for (var g2 = d2[p2 + -m2], y2 = -m2; y2 > 0; y2--)
                l2(d2[p2++], v2, g2);
              p2++;
            }
          }
        }
      } catch (e24) {
        h2.e(e24);
      } finally {
        h2.f();
      }
    }
    i2.nodeSet = new YL(o2.map(function(t3, n3) {
      return GL.define({ name: n3 >= i2.minRepeatTerm ? void 0 : t3, id: n3, props: u2[n3], top: s2.indexOf(n3) > -1, error: n3 == 0, skipped: e23.skippedNodes && e23.skippedNodes.indexOf(n3) > -1 });
    })), e23.propSources && (i2.nodeSet = (r2 = i2.nodeSet).extend.apply(r2, Ni(e23.propSources))), i2.strict = false, i2.bufferLength = 1024;
    var b2 = OB(e23.tokenData);
    if (i2.context = e23.context, i2.specialized = new Uint16Array(e23.specialized ? e23.specialized.length : 0), i2.specializers = [], e23.specialized)
      for (var k2 = 0; k2 < e23.specialized.length; k2++)
        i2.specialized[k2] = e23.specialized[k2].term, i2.specializers[k2] = e23.specialized[k2].get;
    return i2.states = OB(e23.states, Uint32Array), i2.data = OB(e23.stateData), i2.goto = OB(e23.goto), i2.maxTerm = e23.maxTerm, i2.tokenizers = e23.tokenizers.map(function(e24) {
      return typeof e24 == "number" ? new $B(b2, e24) : e24;
    }), i2.topRules = e23.topRules, i2.dialects = e23.dialects || {}, i2.dynamicPrecedences = e23.dynamicPrecedences || null, i2.tokenPrecTable = e23.tokenPrec, i2.termNames = e23.termNames || null, i2.maxNode = i2.nodeSet.types.length - 1, i2.dialect = i2.parseDialect(), i2.top = i2.topRules[Object.keys(i2.topRules)[0]], i2;
  }
  return zi(n2, [{ key: "createParse", value: function(e23, t3, n3) {
    var r2, i2 = new RB(this, e23, t3, n3), o2 = bi(this.wrappers);
    try {
      for (o2.s(); !(r2 = o2.n()).done; ) {
        i2 = (0, r2.value)(i2, e23, t3, n3);
      }
    } catch (e24) {
      o2.e(e24);
    } finally {
      o2.f();
    }
    return i2;
  } }, { key: "getGoto", value: function(e23, t3) {
    var n3 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], r2 = this.goto;
    if (t3 >= r2[0])
      return -1;
    for (var i2 = r2[t3 + 1]; ; ) {
      var o2 = r2[i2++], a2 = 1 & o2, s2 = r2[i2++];
      if (a2 && n3)
        return s2;
      for (var u2 = i2 + (o2 >> 1); i2 < u2; i2++)
        if (r2[i2] == e23)
          return s2;
      if (a2)
        return -1;
    }
  } }, { key: "hasAction", value: function(e23, t3) {
    for (var n3 = this.data, r2 = 0; r2 < 2; r2++)
      for (var i2, o2 = this.stateSlot(e23, r2 ? 2 : 1); ; o2 += 3) {
        if ((i2 = n3[o2]) == 65535) {
          if (n3[o2 + 1] != 1) {
            if (n3[o2 + 1] == 2)
              return BB(n3, o2 + 2);
            break;
          }
          i2 = n3[o2 = BB(n3, o2 + 2)];
        }
        if (i2 == t3 || i2 == 0)
          return BB(n3, o2 + 1);
      }
    return 0;
  } }, { key: "stateSlot", value: function(e23, t3) {
    return this.states[6 * e23 + t3];
  } }, { key: "stateFlag", value: function(e23, t3) {
    return (this.stateSlot(e23, 0) & t3) > 0;
  } }, { key: "validAction", value: function(e23, t3) {
    if (t3 == this.stateSlot(e23, 4))
      return true;
    for (var n3 = this.stateSlot(e23, 1); ; n3 += 3) {
      if (this.data[n3] == 65535) {
        if (this.data[n3 + 1] != 1)
          return false;
        n3 = BB(this.data, n3 + 2);
      }
      if (t3 == BB(this.data, n3 + 1))
        return true;
    }
  } }, { key: "nextStates", value: function(e23) {
    for (var t3 = this, n3 = [], r2 = this.stateSlot(e23, 1); ; r2 += 3) {
      if (this.data[r2] == 65535) {
        if (this.data[r2 + 1] != 1)
          break;
        r2 = BB(this.data, r2 + 2);
      }
      (1 & this.data[r2 + 2]) == 0 && function() {
        var e24 = t3.data[r2 + 1];
        n3.some(function(t4, n4) {
          return 1 & n4 && t4 == e24;
        }) || n3.push(t3.data[r2], e24);
      }();
    }
    return n3;
  } }, { key: "overrides", value: function(e23, t3) {
    var n3 = qB(this.data, this.tokenPrecTable, t3);
    return n3 < 0 || qB(this.data, this.tokenPrecTable, e23) < n3;
  } }, { key: "configure", value: function(e23) {
    var t3, r2 = Object.assign(Object.create(n2.prototype), this);
    if (e23.props && (r2.nodeSet = (t3 = this.nodeSet).extend.apply(t3, Ni(e23.props))), e23.top) {
      var i2 = this.topRules[e23.top];
      if (!i2)
        throw new RangeError("Invalid top rule name ".concat(e23.top));
      r2.top = i2;
    }
    return e23.tokenizers && (r2.tokenizers = this.tokenizers.map(function(t4) {
      var n3 = e23.tokenizers.find(function(e24) {
        return e24.from == t4;
      });
      return n3 ? n3.to : t4;
    })), e23.contextTracker && (r2.context = e23.contextTracker), e23.dialect && (r2.dialect = this.parseDialect(e23.dialect)), e23.strict != null && (r2.strict = e23.strict), e23.wrap && (r2.wrappers = r2.wrappers.concat(e23.wrap)), e23.bufferLength != null && (r2.bufferLength = e23.bufferLength), r2;
  } }, { key: "hasWrappers", value: function() {
    return this.wrappers.length > 0;
  } }, { key: "getName", value: function(e23) {
    return this.termNames ? this.termNames[e23] : String(e23 <= this.maxNode && this.nodeSet.types[e23].name || e23);
  } }, { key: "eofTerm", get: function() {
    return this.maxNode + 1;
  } }, { key: "topNode", get: function() {
    return this.nodeSet.types[this.top[1]];
  } }, { key: "dynamicPrecedence", value: function(e23) {
    var t3 = this.dynamicPrecedences;
    return t3 == null ? 0 : t3[e23] || 0;
  } }, { key: "parseDialect", value: function(e23) {
    var t3 = Object.keys(this.dialects), n3 = t3.map(function() {
      return false;
    });
    if (e23) {
      var r2, i2 = bi(e23.split(" "));
      try {
        for (i2.s(); !(r2 = i2.n()).done; ) {
          var o2 = r2.value, a2 = t3.indexOf(o2);
          a2 >= 0 && (n3[a2] = true);
        }
      } catch (e24) {
        i2.e(e24);
      } finally {
        i2.f();
      }
    }
    for (var s2 = null, u2 = 0; u2 < t3.length; u2++)
      if (!n3[u2])
        for (var c2, l2 = this.dialects[t3[u2]]; (c2 = this.data[l2++]) != 65535; )
          (s2 || (s2 = new Uint8Array(this.maxTerm + 1)))[c2] = 1;
    return new zB(e23, n3, s2);
  } }], [{ key: "deserialize", value: function(e23) {
    return new n2(e23);
  } }]), n2;
}();
function BB(e22, t2) {
  return e22[t2] | e22[t2 + 1] << 16;
}
function qB(e22, t2, n2) {
  for (var r2, i2 = t2; (r2 = e22[i2]) != 65535; i2++)
    if (r2 == n2)
      return i2 - t2;
  return -1;
}
var FB = pN({ String: zN.string, Number: zN.number, "True False": zN.bool, PropertyName: zN.propertyName, Null: zN.null, ",": zN.separator, "[ ]": zN.squareBracket, "{ }": zN.brace }), VB = LB.deserialize({ version: 14, states: "$bOVQPOOOOQO'#Cb'#CbOnQPO'#CeOvQPO'#CjOOQO'#Cp'#CpQOQPOOOOQO'#Cg'#CgO}QPO'#CfO!SQPO'#CrOOQO,59P,59PO![QPO,59PO!aQPO'#CuOOQO,59U,59UO!iQPO,59UOVQPO,59QOqQPO'#CkO!nQPO,59^OOQO1G.k1G.kOVQPO'#ClO!vQPO,59aOOQO1G.p1G.pOOQO1G.l1G.lOOQO,59V,59VOOQO-E6i-E6iOOQO,59W,59WOOQO-E6j-E6j", stateData: "#O~OcOS~OQSORSOSSOTSOWQO]ROePO~OVXOeUO~O[[O~PVOg^O~Oh_OVfX~OVaO~OhbO[iX~O[dO~Oh_OVfa~OhbO[ia~O", goto: "!kjPPPPPPkPPkqwPPk{!RPPP!XP!ePP!hXSOR^bQWQRf_TVQ_Q`WRg`QcZRicQTOQZRQe^RhbRYQR]R", nodeNames: "\u26A0 JsonText True False Null Number String } { Object Property PropertyName ] [ Array", maxTerm: 25, nodeProps: [["openedBy", 7, "{", 12, "["], ["closedBy", 8, "}", 13, "]"]], propSources: [FB], skippedNodes: [0], repeatNodeCount: 2, tokenData: "(p~RaXY!WYZ!W]^!Wpq!Wrs!]|}$i}!O$n!Q!R$w!R![&V![!]&h!}#O&m#P#Q&r#Y#Z&w#b#c'f#h#i'}#o#p(f#q#r(k~!]Oc~~!`Upq!]qr!]rs!rs#O!]#O#P!w#P~!]~!wOe~~!zXrs!]!P!Q!]#O#P!]#U#V!]#Y#Z!]#b#c!]#f#g!]#h#i!]#i#j#g~#jR!Q![#s!c!i#s#T#Z#s~#vR!Q![$P!c!i$P#T#Z$P~$SR!Q![$]!c!i$]#T#Z$]~$`R!Q![!]!c!i!]#T#Z!]~$nOh~~$qQ!Q!R$w!R![&V~$|RT~!O!P%V!g!h%k#X#Y%k~%YP!Q![%]~%bRT~!Q![%]!g!h%k#X#Y%k~%nR{|%w}!O%w!Q![%}~%zP!Q![%}~&SPT~!Q![%}~&[ST~!O!P%V!Q![&V!g!h%k#X#Y%k~&mOg~~&rO]~~&wO[~~&zP#T#U&}~'QP#`#a'T~'WP#g#h'Z~'^P#X#Y'a~'fOR~~'iP#i#j'l~'oP#`#a'r~'uP#`#a'x~'}OS~~(QP#f#g(T~(WP#i#j(Z~(^P#X#Y(a~(fOQ~~(kOW~~(pOV~", tokenizers: [0], topRules: { JsonText: [0, 1] }, tokenPrec: 0 }), HB = FN.define({ parser: VB.configure({ props: [aT.add({ Object: hT({ except: /^\s*\}/ }), Array: hT({ except: /^\s*\]/ }) }), vT.add({ "Object Array": function(e22) {
  var t2 = e22.firstChild, n2 = e22.lastChild;
  return t2 && t2.to < n2.from ? { from: t2.to, to: n2.type.isError ? e22.to : n2.from } : null;
} })] }), languageData: { closeBrackets: { brackets: ["[", "{", '"'] }, indentOnInput: /^\s*[\}\]]$/ } });
function WB(e22, t2) {
  var n2 = Date.now(), r2 = e22();
  return t2(Date.now() - n2), r2;
}
function JB(e22) {
  co(e22, "svelte-1oo7hnc", ".jse-status-bar.svelte-1oo7hnc.svelte-1oo7hnc{background:var(--jse-panel-background);color:var(--jse-panel-color-readonly);font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono);margin:0;border-top:var(--jse-panel-border);border-left:var(--jse-main-border);border-right:var(--jse-main-border);display:flex;gap:var(--jse-padding)}.jse-status-bar.svelte-1oo7hnc.svelte-1oo7hnc:last-child{border-bottom:var(--jse-main-border)}.jse-status-bar.svelte-1oo7hnc .jse-status-bar-info.svelte-1oo7hnc{padding:2px}");
}
function UB(e22) {
  var t2, n2, r2;
  return { c: function() {
    t2 = go("div"), n2 = bo("Line: "), r2 = bo(e22[0]), So(t2, "class", "jse-status-bar-info svelte-1oo7hnc");
  }, m: function(e23, i2) {
    vo(e23, t2, i2), uo(t2, n2), uo(t2, r2);
  }, p: function(e23, t3) {
    1 & t3 && Ao(r2, e23[0]);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function KB(e22) {
  var t2, n2, r2;
  return { c: function() {
    t2 = go("div"), n2 = bo("Column: "), r2 = bo(e22[1]), So(t2, "class", "jse-status-bar-info svelte-1oo7hnc");
  }, m: function(e23, i2) {
    vo(e23, t2, i2), uo(t2, n2), uo(t2, r2);
  }, p: function(e23, t3) {
    2 & t3 && Ao(r2, e23[1]);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function GB(e22) {
  var t2, n2, r2, i2;
  return { c: function() {
    t2 = go("div"), n2 = bo("Selection: "), r2 = bo(e22[2]), i2 = bo(" characters"), So(t2, "class", "jse-status-bar-info svelte-1oo7hnc");
  }, m: function(e23, o2) {
    vo(e23, t2, o2), uo(t2, n2), uo(t2, r2), uo(t2, i2);
  }, p: function(e23, t3) {
    4 & t3 && Ao(r2, e23[2]);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function QB(e22) {
  var t2, n2, r2, i2 = e22[0] !== void 0 && UB(e22), o2 = e22[1] !== void 0 && KB(e22), a2 = e22[2] !== void 0 && e22[2] > 0 && GB(e22);
  return { c: function() {
    t2 = go("div"), i2 && i2.c(), n2 = ko(), o2 && o2.c(), r2 = ko(), a2 && a2.c(), So(t2, "class", "jse-status-bar svelte-1oo7hnc");
  }, m: function(e23, s2) {
    vo(e23, t2, s2), i2 && i2.m(t2, null), uo(t2, n2), o2 && o2.m(t2, null), uo(t2, r2), a2 && a2.m(t2, null);
  }, p: function(e23, s2) {
    var u2 = xi(s2, 1)[0];
    e23[0] !== void 0 ? i2 ? i2.p(e23, u2) : ((i2 = UB(e23)).c(), i2.m(t2, n2)) : i2 && (i2.d(1), i2 = null), e23[1] !== void 0 ? o2 ? o2.p(e23, u2) : ((o2 = KB(e23)).c(), o2.m(t2, r2)) : o2 && (o2.d(1), o2 = null), e23[2] !== void 0 && e23[2] > 0 ? a2 ? a2.p(e23, u2) : ((a2 = GB(e23)).c(), a2.m(t2, null)) : a2 && (a2.d(1), a2 = null);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2), i2 && i2.d(), o2 && o2.d(), a2 && a2.d();
  } };
}
function YB(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2 = t2.editorState;
  return e22.$$set = function(e23) {
    "editorState" in e23 && n2(3, d2 = e23.editorState);
  }, e22.$$.update = function() {
    56 & e22.$$.dirty && n2(9, u2 = n2(5, i2 = n2(4, r2 = d2 == null ? void 0 : d2.selection) === null || r2 === void 0 ? void 0 : r2.main) === null || i2 === void 0 ? void 0 : i2.head), 584 & e22.$$.dirty && n2(10, c2 = n2(6, o2 = d2 == null ? void 0 : d2.doc) === null || o2 === void 0 ? void 0 : o2.lineAt(u2)), 1024 & e22.$$.dirty && n2(0, l2 = c2 ? c2.number : void 0), 1536 & e22.$$.dirty && n2(1, f2 = c2 ? u2 - c2.from + 1 : void 0), 392 & e22.$$.dirty && n2(2, h2 = n2(8, s2 = n2(7, a2 = d2 == null ? void 0 : d2.selection) === null || a2 === void 0 ? void 0 : a2.ranges) === null || s2 === void 0 ? void 0 : s2.reduce(function(e23, t3) {
      return e23 + t3.to - t3.from;
    }, 0));
  }, [l2, f2, h2, d2, r2, i2, o2, a2, s2, u2, c2];
}
var ZB = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, YB, QB, Ui, { editorState: 3 }, JB), r2;
  }
  return zi(n2);
}(), XB = NT.define([{ tag: zN.propertyName, color: "var(--jse-key-color)" }, { tag: zN.number, color: "var(--jse-value-color-number)" }, { tag: zN.bool, color: "var(--jse-value-color-boolean)" }, { tag: zN.string, color: "var(--jse-value-color-string)" }, { tag: zN.keyword, color: "var(--jse-value-color-null)" }]), eq$1 = DT(XB), tq = XB.style;
function nq(e22) {
  co(e22, "svelte-cmeafv", '.jse-text-mode.svelte-cmeafv.svelte-cmeafv{flex:1;box-sizing:border-box;display:flex;flex-direction:column;background:var(--jse-background-color)}.jse-text-mode.no-main-menu.svelte-cmeafv.svelte-cmeafv{border-top:var(--jse-main-border)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv{flex:1;display:flex;flex-direction:column;overflow:hidden;min-width:0;min-height:0;border-left:var(--jse-main-border);border-right:var(--jse-main-border)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv:last-child{border-bottom:var(--jse-main-border)}.jse-text-mode.svelte-cmeafv .jse-contents.jse-hidden.svelte-cmeafv{visibility:hidden}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor{flex:1;overflow:hidden}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-scroller{font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono);line-height:var(--jse-line-height);color:var(--jse-delimiter-color)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-gutters{background:var(--jse-panel-background);color:var(--jse-panel-color-readonly);border-right:var(--jse-panel-border)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-activeLine,.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-activeLineGutter{background:var(--jse-hover-background-color)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-selectionBackground{background:var(--jse-selection-background-color)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-searchMatch{background-color:var(--jse-search-match-color);outline:var(--jse-search-match-outline)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-searchMatch.cm-searchMatch-selected{background-color:var(--jse-search-match-active-color);outline:var(--jse-search-match-active-outline)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-foldPlaceholder{background:var(--jse-tag-background);color:var(--jse-tag-color);border:none;padding:0 var(--jse-padding)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-diagnostic{font-size:var(--jse-font-size);font-family:var(--jse-font-family)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-panels{border-bottom:var(--jse-panel-border)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-search{background:var(--jse-panel-background);color:var(--jse-panel-color);font-family:var(--jse-font-family);font-size:var(--jse-font-size)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-search input{font-family:var(--jse-font-family);font-size:var(--jse-font-size-text-mode-search);color:var(--jse-input-color);border:var(--jse-input-border);background:var(--jse-input-background);margin-right:2px}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-search button{font-family:var(--jse-font-family);font-size:var(--jse-font-size-text-mode-search);color:var(--jse-panel-button-color);background:var(--jse-panel-button-background);border:none;cursor:pointer;text-transform:capitalize;padding:calc(0.5 * var(--jse-padding)) var(--jse-padding);margin:0}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-search button:hover{color:var(--jse-panel-button-color-highlight);background:var(--jse-panel-button-background-highlight)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-search label{font-family:var(--jse-font-family);font-size:var(--jse-font-size-text-mode-search);padding-left:var(--jse-padding)}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-search label input{margin-right:2px}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-search button[name="close"]{width:32px;height:32px;font-size:24px;line-height:24px;padding:0;right:0;top:-4px}.jse-text-mode.svelte-cmeafv .jse-contents.svelte-cmeafv .cm-editor .cm-cursor-primary{border-color:var(--jse-text-color)}.jse-text-mode.svelte-cmeafv .jse-contents .jse-loading-space.svelte-cmeafv{flex:1}.jse-text-mode.svelte-cmeafv .jse-contents .jse-loading.svelte-cmeafv{flex:2;text-align:center;color:var(--jse-panel-color-readonly);box-sizing:border-box;font-family:var(--jse-font-family);font-size:var(--jse-font-size)}');
}
function rq(e22) {
  var t2, n2;
  return t2 = new HS({ props: { readOnly: e22[1], onFormat: e22[17], onCompact: e22[18], onSort: e22[19], onTransform: e22[20], onToggleSearch: e22[21], onUndo: e22[22], onRedo: e22[23], canFormat: !e22[15], canCompact: !e22[15], canSort: !e22[15], canTransform: !e22[15], canUndo: e22[10], canRedo: e22[11], onRenderMenu: e22[5] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    2 & n3[0] && (r2.readOnly = e23[1]), 32768 & n3[0] && (r2.canFormat = !e23[15]), 32768 & n3[0] && (r2.canCompact = !e23[15]), 32768 & n3[0] && (r2.canSort = !e23[15]), 32768 & n3[0] && (r2.canTransform = !e23[15]), 1024 & n3[0] && (r2.canUndo = e23[10]), 2048 & n3[0] && (r2.canRedo = e23[11]), 32 & n3[0] && (r2.onRenderMenu = e23[5]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function iq(e22) {
  var t2;
  return { c: function() {
    (t2 = go("div")).innerHTML = '<div class="jse-loading-space svelte-cmeafv"></div> \n      <div class="jse-loading svelte-cmeafv">loading...</div>', So(t2, "class", "jse-contents svelte-cmeafv");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, p: Bi, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function oq(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2 = e22[14] && aq(e22), c2 = e22[3] && sq(e22), l2 = e22[12] && uq(e22);
  return a2 = new xS({ props: { validationErrors: e22[9], selectError: e22[26] } }), { c: function() {
    u2 && u2.c(), t2 = ko(), n2 = go("div"), r2 = ko(), c2 && c2.c(), i2 = ko(), l2 && l2.c(), o2 = ko(), Aa(a2.$$.fragment), So(n2, "class", "jse-contents svelte-cmeafv"), To(n2, "jse-hidden", e22[14]);
  }, m: function(f2, h2) {
    u2 && u2.m(f2, h2), vo(f2, t2, h2), vo(f2, n2, h2), e22[46](n2), vo(f2, r2, h2), c2 && c2.m(f2, h2), vo(f2, i2, h2), l2 && l2.m(f2, h2), vo(f2, o2, h2), Ma(a2, f2, h2), s2 = true;
  }, p: function(e23, r3) {
    e23[14] ? u2 ? (u2.p(e23, r3), 16384 & r3[0] && ya(u2, 1)) : ((u2 = aq(e23)).c(), ya(u2, 1), u2.m(t2.parentNode, t2)) : u2 && (ma(), ba(u2, 1, 1, function() {
      u2 = null;
    }), ga()), 16384 & r3[0] && To(n2, "jse-hidden", e23[14]), e23[3] ? c2 ? (c2.p(e23, r3), 8 & r3[0] && ya(c2, 1)) : ((c2 = sq(e23)).c(), ya(c2, 1), c2.m(i2.parentNode, i2)) : c2 && (ma(), ba(c2, 1, 1, function() {
      c2 = null;
    }), ga()), e23[12] ? l2 ? (l2.p(e23, r3), 4096 & r3[0] && ya(l2, 1)) : ((l2 = uq(e23)).c(), ya(l2, 1), l2.m(o2.parentNode, o2)) : l2 && (ma(), ba(l2, 1, 1, function() {
      l2 = null;
    }), ga());
    var s3 = {};
    512 & r3[0] && (s3.validationErrors = e23[9]), a2.$set(s3);
  }, i: function(e23) {
    s2 || (ya(u2), ya(c2), ya(l2), ya(a2.$$.fragment, e23), s2 = true);
  }, o: function(e23) {
    ba(u2), ba(c2), ba(l2), ba(a2.$$.fragment, e23), s2 = false;
  }, d: function(s3) {
    u2 && u2.d(s3), s3 && po(t2), s3 && po(n2), e22[46](null), s3 && po(r2), c2 && c2.d(s3), s3 && po(i2), l2 && l2.d(s3), s3 && po(o2), Ea(a2, s3);
  } };
}
function aq(e22) {
  var t2, n2;
  return t2 = new sS({ props: { icon: jj, type: "error", message: "The JSON document is larger than ".concat(_j(10485760, 1024), ", ") + "and may crash your browser when loading it in text mode. Actual size: ".concat(_j(e22[0].length, 1024), "."), actions: [{ text: "Open anyway", title: "Open the document in text mode. This may freeze or crash your browser.", onClick: e22[24] }, { text: "Open in tree mode", title: "Open the document in tree mode. Tree mode can handle large documents.", onClick: e22[4] }, { text: "Cancel", title: "Cancel opening this large document.", onClick: e22[25] }] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    1 & n3[0] && (r2.message = "The JSON document is larger than ".concat(_j(10485760, 1024), ", ") + "and may crash your browser when loading it in text mode. Actual size: ".concat(_j(e23[0].length, 1024), ".")), 16 & n3[0] && (r2.actions = [{ text: "Open anyway", title: "Open the document in text mode. This may freeze or crash your browser.", onClick: e23[24] }, { text: "Open in tree mode", title: "Open the document in tree mode. Tree mode can handle large documents.", onClick: e23[4] }, { text: "Cancel", title: "Cancel opening this large document.", onClick: e23[25] }]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function sq(e22) {
  var t2, n2;
  return t2 = new ZB({ props: { editorState: e22[8] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    256 & n3[0] && (r2.editorState = e23[8]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function uq(e22) {
  var t2, n2;
  return t2 = new sS({ props: { type: "error", icon: jj, message: e22[12].message, actions: e22[13], onClick: e22[47] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    4096 & n3[0] && (r2.message = e23[12].message), 8192 & n3[0] && (r2.actions = e23[13]), 4096 & n3[0] && (r2.onClick = e23[47]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function cq(e22) {
  var t2, n2, r2, i2, o2, a2 = e22[2] && rq(e22), s2 = [oq, iq], u2 = [];
  return r2 = function(e23, t3) {
    return e23[16] ? 1 : 0;
  }(e22), i2 = u2[r2] = s2[r2](e22), { c: function() {
    t2 = go("div"), a2 && a2.c(), n2 = ko(), i2.c(), So(t2, "class", "jse-text-mode svelte-cmeafv"), To(t2, "no-main-menu", !e22[2]);
  }, m: function(i3, s3) {
    vo(i3, t2, s3), a2 && a2.m(t2, null), uo(t2, n2), u2[r2].m(t2, null), e22[48](t2), o2 = true;
  }, p: function(e23, r3) {
    e23[2] ? a2 ? (a2.p(e23, r3), 4 & r3[0] && ya(a2, 1)) : ((a2 = rq(e23)).c(), ya(a2, 1), a2.m(t2, n2)) : a2 && (ma(), ba(a2, 1, 1, function() {
      a2 = null;
    }), ga()), i2.p(e23, r3), 4 & r3[0] && To(t2, "no-main-menu", !e23[2]);
  }, i: function(e23) {
    o2 || (ya(a2), ya(i2), o2 = true);
  }, o: function(e23) {
    ba(a2), ba(i2), o2 = false;
  }, d: function(n3) {
    n3 && po(t2), a2 && a2.d(), u2[r2].d(), e22[48](null);
  } };
}
function lq(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2 = t2.readOnly, v2 = d2 !== void 0 && d2, p2 = t2.mainMenuBar, m2 = p2 === void 0 || p2, g2 = t2.statusBar, y2 = g2 === void 0 || g2, b2 = t2.text, k2 = b2 === void 0 ? "" : b2, w2 = t2.indentation, x2 = w2 === void 0 ? 2 : w2, j2 = t2.tabSize, S2 = j2 === void 0 ? 4 : j2, C2 = t2.escapeUnicodeCharacters, _2 = C2 !== void 0 && C2, $2 = t2.validator, O2 = $2 === void 0 ? null : $2, A2 = t2.onChange, M2 = A2 === void 0 ? null : A2, E2 = t2.onSwitchToTreeMode, P2 = E2 === void 0 ? Vu : E2, N2 = t2.onError, T2 = t2.onFocus, I2 = T2 === void 0 ? Vu : T2, R2 = t2.onBlur, D2 = R2 === void 0 ? Vu : R2, z2 = t2.onRenderMenu, L2 = z2 === void 0 ? Vu : z2, B2 = t2.onSortModal, q2 = t2.onTransformModal, F2 = Ia("jsoneditor:TextMode"), V2 = { key: "Mod-i", run: ie2, shift: oe2, preventDefault: true }, H2 = typeof window == "undefined";
  F2("isSSR:", H2);
  var W2 = false, J2 = [], U2 = new qC(), K2 = new qC(), G2 = new qC(), Q2 = _2;
  Uo(yi(mi().mark(function e23() {
    return mi().wrap(function(e24) {
      for (; ; )
        switch (e24.prev = e24.next) {
          case 0:
            if (!H2) {
              e24.next = 2;
              break;
            }
            return e24.abrupt("return");
          case 2:
            try {
              c2 = fe2({ target: u2, initialText: o2 ? "" : k2, readOnly: v2, indentation: x2 }), te2();
            } catch (e25) {
              console.error(e25);
            }
          case 3:
          case "end":
            return e24.stop();
        }
    }, e23);
  }))), Ko(function() {
    c2 && (F2("Destroy CodeMirror editor"), c2.destroy());
  });
  var Y2 = false, Z2 = false, X2 = Hk(), ee2 = Hk();
  function te2() {
    c2 && (F2("focus"), c2.focus());
  }
  var ne2 = false;
  function re2(e23) {
    F2("patch", e23);
    var t3 = k2, r3 = JSON.parse(k2), i3 = cs.exports.immutableJSONPatch(r3, e23), o3 = cs.exports.revertJSONPatch(r3, e23);
    return n2(0, k2 = JSON.stringify(i3, null, x2)), k2 !== t3 && ke2(k2, t3), { json: i3, previousJson: r3, undo: o3, redo: e23 };
  }
  function ie2() {
    if (F2("format"), !v2)
      try {
        var e23 = k2, t3 = JSON.parse(k2);
        n2(0, k2 = JSON.stringify(t3, null, x2)), k2 !== e23 && ke2(k2, e23);
      } catch (e24) {
        N2(e24);
      }
  }
  function oe2() {
    if (F2("compact"), !v2)
      try {
        var e23 = k2, t3 = JSON.parse(k2);
        n2(0, k2 = JSON.stringify(t3)), k2 !== e23 && ke2(k2, e23);
      } catch (e24) {
        N2(e24);
      }
  }
  function ae2() {
    if (F2("repair"), !v2)
      try {
        var e23 = k2;
        n2(0, k2 = _s(k2)), n2(44, we2 = "valid"), n2(12, xe2 = void 0), k2 !== e23 && ke2(k2, e23);
      } catch (e24) {
        N2(e24);
      }
  }
  function se2(e23) {
    var t3 = e23.id, n3 = e23.selectedPath, r3 = e23.onTransform, i3 = e23.onClose;
    try {
      var o3 = JSON.parse(k2);
      ne2 = true, q2({ id: t3 || ee2, json: o3, selectedPath: n3, onTransform: r3 ? function(e24) {
        r3({ operations: e24, json: o3, transformedJson: cs.exports.immutableJSONPatch(o3, e24) });
      } : function(e24) {
        F2("onTransform", e24), re2(e24);
      }, onClose: function() {
        ne2 = false, te2(), i3 && i3();
      } });
    } catch (e24) {
      N2(e24);
    }
  }
  function ue2(e23) {
    F2("select parse error", e23);
    var t3 = de2(e23, false);
    ce2(t3.from, t3.to), te2();
  }
  function ce2(e23, t3) {
    F2("setSelection", { anchor: e23, head: t3 }), c2 && c2.dispatch(c2.state.update({ selection: { anchor: e23, head: t3 }, scrollIntoView: true }));
  }
  function le2(e23, t3) {
    if (t3.state.selection.ranges.length === 1) {
      var n3 = t3.state.selection.ranges[0], r3 = k2.slice(n3.from, n3.to);
      if (r3 === "{" || r3 === "[") {
        var i3 = ls.parse(k2), o3 = Object.keys(i3.pointers).find(function(e24) {
          var t4;
          return ((t4 = i3.pointers[e24].value) === null || t4 === void 0 ? void 0 : t4.pos) === n3.from;
        }), a3 = i3.pointers[o3];
        if (o3 && a3 && a3.value && a3.valueEnd)
          F2("pointer found, selecting inner contents of path:", o3, a3), ce2(a3.value.pos + 1, a3.valueEnd.pos - 1);
      }
    }
  }
  function fe2(e23) {
    var t3 = e23.target, r3 = e23.initialText, i3 = e23.readOnly, o3 = e23.indentation;
    F2("Create CodeMirror editor", { readOnly: i3, indentation: o3 });
    var a3 = v_.create({ doc: r3, extensions: [LM.of([dD, V2]), _L(function() {
      return be2.flush(), function() {
        if (F2("validate"), n2(44, we2 = "valid"), n2(12, xe2 = null), n2(9, J2 = []), k2.length > 104857600)
          return [{ from: 0, to: 0, message: "Validation turned off: the document is too large", severity: "info" }];
        if (k2.length === 0)
          return [];
        try {
          var e24 = WB(function() {
            return JSON.parse(k2);
          }, function(e25) {
            return F2("validate: parsed json in ".concat(e25, " ms"));
          });
          return O2 ? (n2(9, J2 = WB(function() {
            return O2(e24);
          }, function(e25) {
            return F2("validate: validated json in ".concat(e25, " ms"));
          })), J2.map(he2)) : [];
        } catch (e25) {
          var t4 = WB(function() {
            return function(e26) {
              if (e26.length > 1048576)
                return false;
              try {
                return JSON.parse(_s(e26)), true;
              } catch (e27) {
                return false;
              }
            }(k2);
          }, function(e26) {
            return F2("validate: checked whether repairable in ".concat(e26, " ms"));
          });
          return n2(12, xe2 = Xw(k2, e25.message || e25.toString())), n2(44, we2 = t4 ? "repairable" : "invalid"), [de2(xe2, t4)];
        }
      }();
    }, { delay: 300 }), VL(), HL, eq$1, MM.domEventHandlers({ dblclick: le2 }), MM.updateListener.of(function(e24) {
      n2(8, h2 = e24.state), e24.docChanged && be2();
    }), new XN(HB), RD({ top: true }), U2.of(v_.readOnly.of(i3)), G2.of(v_.tabSize.of(S2)), K2.of(ge2(o3)), MM.lineWrapping] });
    return c2 = new MM({ state: a3, parent: t3 });
  }
  function he2(e23) {
    var t3 = e23.path, n3 = e23.message, r3 = e23.isChildError, i3 = function(e24, t4) {
      try {
        var n4 = ls.parse(e24), r4 = cs.exports.compileJSONPointer(t4), i4 = n4.pointers[r4];
        if (i4)
          return { path: t4, line: i4.key ? i4.key.line : i4.value ? i4.value.line : 0, column: i4.key ? i4.key.column : i4.value ? i4.value.column : 0, from: i4.key ? i4.key.pos : i4.value ? i4.value.pos : 0, to: i4.keyEnd ? i4.keyEnd.pos : i4.valueEnd ? i4.valueEnd.pos : 0 };
      } catch (e25) {
        console.error(e25);
      }
      return null;
    }(k2, t3);
    return { path: t3, isChildError: r3, line: i3.line, column: i3.column, from: i3.from, to: i3.to, message: n3, severity: "warning", actions: [] };
  }
  function de2(e23, t3) {
    var n3 = e23.line, r3 = e23.column, i3 = e23.position;
    return { path: null, line: n3, column: r3, from: i3 || 0, to: i3 || 0, severity: "error", message: e23.message, actions: t3 && !v2 ? [{ name: "Auto repair", apply: function() {
      return ae2();
    } }] : null };
  }
  function ve2(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 && arguments[1];
    !o2 || t3 ? c2 && e23 !== l2 && (F2("setCodeMirrorValue length=", e23.length), l2 = e23, c2.dispatch({ changes: { from: 0, to: c2.state.doc.length, insert: a2.escapeValue(e23) } }), ye2()) : F2("not applying text: editor is disabled");
  }
  function pe2() {
    F2("forceUpdateText", { escapeUnicodeCharacters: _2 }), c2 && c2.dispatch({ changes: { from: 0, to: c2.state.doc.length, insert: a2.escapeValue(k2) } });
  }
  function me2() {
    if (c2 && (l2 = c2 ? a2.unescapeValue(c2.state.doc.toString()) : "") !== k2) {
      var e23 = l2;
      F2("text changed"), n2(0, k2 = l2), ye2(), ke2(k2, e23);
    }
  }
  function ge2(e23) {
    return tT.of(typeof e23 == "number" ? " ".repeat(e23) : e23);
  }
  function ye2() {
    n2(10, Y2 = XI(c2.state) > 0), n2(11, Z2 = eR(c2.state) > 0), F2({ canUndo: Y2, canRedo: Z2 });
  }
  Oj({ onMount: Uo, onDestroy: Ko, getWindow: function() {
    return Ox(f2);
  }, hasFocus: function() {
    return ne2 && document.hasFocus() || Ax(f2);
  }, onFocus: I2, onBlur: D2 });
  var be2 = Xd(me2, 300);
  function ke2(e23, t3) {
    M2 && M2(e23, t3);
  }
  var we2 = "valid", xe2 = null;
  return e22.$$set = function(e23) {
    "readOnly" in e23 && n2(1, v2 = e23.readOnly), "mainMenuBar" in e23 && n2(2, m2 = e23.mainMenuBar), "statusBar" in e23 && n2(3, y2 = e23.statusBar), "text" in e23 && n2(0, k2 = e23.text), "indentation" in e23 && n2(28, x2 = e23.indentation), "tabSize" in e23 && n2(29, S2 = e23.tabSize), "escapeUnicodeCharacters" in e23 && n2(30, _2 = e23.escapeUnicodeCharacters), "validator" in e23 && n2(31, O2 = e23.validator), "onChange" in e23 && n2(32, M2 = e23.onChange), "onSwitchToTreeMode" in e23 && n2(4, P2 = e23.onSwitchToTreeMode), "onError" in e23 && n2(33, N2 = e23.onError), "onFocus" in e23 && n2(34, I2 = e23.onFocus), "onBlur" in e23 && n2(35, D2 = e23.onBlur), "onRenderMenu" in e23 && n2(5, L2 = e23.onRenderMenu), "onSortModal" in e23 && n2(36, B2 = e23.onSortModal), "onTransformModal" in e23 && n2(37, q2 = e23.onTransformModal);
  }, e22.$$.update = function() {
    1 & e22.$$.dirty[0] && n2(15, r2 = k2.length === 0), 1 & e22.$$.dirty[0] && n2(45, i2 = k2 && k2.length > 10485760), 18432 & e22.$$.dirty[1] && n2(14, o2 = i2 && !W2), 1073741824 & e22.$$.dirty[0] && (a2 = fx({ escapeControlCharacters: false, escapeUnicodeCharacters: _2 })), 1 & e22.$$.dirty[0] && ve2(k2), 268435456 & e22.$$.dirty[0] && function(e23) {
      c2 && (F2("updateIndentation", e23), c2.dispatch({ effects: K2.reconfigure(ge2(e23)) }));
    }(x2), 536870912 & e22.$$.dirty[0] && function(e23) {
      c2 && (F2("updateTabSize", e23), c2.dispatch({ effects: G2.reconfigure(v_.tabSize.of(e23)) }));
    }(S2), 2 & e22.$$.dirty[0] && function(e23) {
      c2 && (F2("updateReadOnly", e23), c2.dispatch({ effects: U2.reconfigure(v_.readOnly.of(e23)) }));
    }(v2), 1073741824 & e22.$$.dirty[0] | 4096 & e22.$$.dirty[1] && Q2 !== _2 && (n2(43, Q2 = _2), pe2()), 2 & e22.$$.dirty[0] | 1 & e22.$$.dirty[1] && pe2(), 2 & e22.$$.dirty[0] | 8192 & e22.$$.dirty[1] && n2(13, s2 = we2 !== "repairable" || v2 ? [] : [{ icon: Sj, text: "Auto repair", title: "Automatically repair JSON", onClick: ae2 }]);
  }, [k2, v2, m2, y2, P2, L2, u2, f2, h2, J2, Y2, Z2, xe2, s2, o2, r2, H2, ie2, oe2, function() {
    var e23;
    if (!v2)
      try {
        var t3 = JSON.parse(k2);
        ne2 = true, B2({ id: X2, json: t3, selectedPath: [], onSort: (e23 = yi(mi().mark(function e24(t4) {
          return mi().wrap(function(e25) {
            for (; ; )
              switch (e25.prev = e25.next) {
                case 0:
                  F2("onSort", t4), re2(t4);
                case 2:
                case "end":
                  return e25.stop();
              }
          }, e24);
        })), function(t4) {
          return e23.apply(this, arguments);
        }), onClose: function() {
          ne2 = false, te2();
        } });
      } catch (e24) {
        N2(e24);
      }
  }, function() {
    v2 || se2({ selectedPath: [] });
  }, function() {
    c2 && (u2 && u2.querySelector(".cm-search") ? oz(c2) : iz(c2));
  }, function() {
    v2 || c2 && (KI(c2), te2());
  }, function() {
    v2 || c2 && (GI(c2), te2());
  }, function() {
    n2(42, W2 = true), ve2(k2, true);
  }, function() {
    me2();
  }, function(e23) {
    F2("select validation error", e23);
    var t3 = he2(e23);
    ce2(t3.from, t3.to), te2();
  }, ue2, x2, S2, _2, O2, M2, N2, I2, D2, B2, q2, te2, re2, se2, function() {
    F2("refresh");
    var e23 = c2.state.doc.length;
    c2.dispatch({ changes: { from: e23, to: e23, insert: " " } }), c2.dispatch({ changes: { from: e23, to: e23 + 1, insert: "" } });
  }, W2, Q2, we2, i2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(6, u2 = e23);
    });
  }, function() {
    return ue2(xe2);
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(7, f2 = e23);
    });
  }];
}
XB.style = function(e22) {
  return tq(e22 || []);
};
var fq = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, lq, cq, Ki, { readOnly: 1, mainMenuBar: 2, statusBar: 3, text: 0, indentation: 28, tabSize: 29, escapeUnicodeCharacters: 30, validator: 31, onChange: 32, onSwitchToTreeMode: 4, onError: 33, onFocus: 34, onBlur: 35, onRenderMenu: 5, onSortModal: 36, onTransformModal: 37, focus: 38, patch: 39, openTransformModal: 40, refresh: 41 }, nq, [-1, -1, -1]), r2;
  }
  return zi(n2, [{ key: "focus", get: function() {
    return this.$$.ctx[38];
  } }, { key: "patch", get: function() {
    return this.$$.ctx[39];
  } }, { key: "openTransformModal", get: function() {
    return this.$$.ctx[40];
  } }, { key: "refresh", get: function() {
    return this.$$.ctx[41];
  } }]), n2;
}(), hq = Ia("jsoneditor:AutoScrollHandler");
var dq = function(e22, t2, n2, r2) {
  return (e22 /= r2 / 2) < 1 ? n2 / 2 * e22 * e22 + t2 : -n2 / 2 * (--e22 * (e22 - 2) - 1) + t2;
}, vq = function() {
  var e22, t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2;
  function d2() {
    return e22.scrollY || e22.pageYOffset || e22.scrollTop;
  }
  function v2(t3) {
    return t3.getBoundingClientRect().top - (e22.getBoundingClientRect ? e22.getBoundingClientRect().top : 0) + n2;
  }
  function p2(t3) {
    e22.scrollTo ? e22.scrollTo(0, t3) : e22.scrollTop = t3;
  }
  function m2(e23) {
    c2 || (c2 = e23), p2(o2(l2 = e23 - c2, n2, s2, u2)), h2 = true, l2 < u2 ? requestAnimationFrame(m2) : function() {
      p2(n2 + s2), t2 && a2 && (t2.setAttribute("tabindex", "-1"), t2.focus());
      typeof f2 == "function" && f2();
      c2 = false, h2 = false;
    }();
  }
  return function(l3) {
    var p3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    switch (u2 = p3.duration || 1e3, i2 = p3.offset || 0, f2 = p3.callback, o2 = p3.easing || dq, a2 = p3.a11y || false, Li(p3.container)) {
      case "object":
        e22 = p3.container;
        break;
      case "string":
        e22 = document.querySelector(p3.container);
        break;
      default:
        e22 = window;
    }
    switch (n2 = d2(), Li(l3)) {
      case "number":
        t2 = void 0, a2 = false, r2 = n2 + l3;
        break;
      case "object":
        r2 = v2(t2 = l3);
        break;
      case "string":
        t2 = document.querySelector(l3), r2 = v2(t2);
    }
    switch (s2 = r2 - n2 + i2, Li(p3.duration)) {
      case "number":
        u2 = p3.duration;
        break;
      case "function":
        u2 = p3.duration(s2);
    }
    h2 ? c2 = false : requestAnimationFrame(m2);
  };
};
function pq(e22) {
  for (var t2 = gb(e22, function(e23) {
    return e23.start;
  }), n2 = [t2[0]], r2 = 0; r2 < t2.length; r2++) {
    var i2 = n2.length - 1, o2 = n2[i2], a2 = t2[r2];
    a2.start <= o2.end ? n2[i2] = { start: Math.min(o2.start, a2.start), end: Math.max(o2.end, a2.end) } : n2.push(a2);
  }
  return n2;
}
function mq(e22, t2) {
  return e22.some(function(e23) {
    return t2 >= e23.start && t2 < e23.end;
  });
}
function gq(e22) {
  return yq(e22) + 100;
}
function yq(e22) {
  return 100 * Math.floor(e22 / 100);
}
function bq(e22) {
  var t2 = { expandedMap: {}, enforceStringMap: {}, visibleSectionsMap: {}, selection: void 0 };
  return (e22 == null ? void 0 : e22.select) && (t2 = Ei(Ei({}, t2), {}, { selection: e22.select(e22.json, t2) })), (e22 == null ? void 0 : e22.expand) && (t2 = jq(e22.json, t2, [], e22.expand)), t2;
}
function kq(e22, t2) {
  return e22.visibleSectionsMap[t2] || Ya;
}
function wq(e22, t2, n2) {
  t2.forEach(function(t3) {
    var r2 = t3.start, i2 = t3.end;
    Bw(r2, Math.min(e22.length, i2), n2);
  });
}
function xq(e22, t2, n2) {
  for (var r2 = Ei({}, t2.expandedMap), i2 = Ei({}, t2.visibleSectionsMap), o2 = 0; o2 <= n2.length; o2++) {
    var a2 = n2.slice(0, o2), s2 = cs.exports.compileJSONPointer(a2), u2 = cs.exports.getIn(e22, a2);
    if (Os(u2) && (r2[s2] = true), Array.isArray(u2) && o2 < n2.length) {
      var c2 = i2[s2] || Ya, l2 = Ww(n2[o2]);
      if (!mq(c2, l2)) {
        var f2 = yq(l2), h2 = { start: f2, end: gq(f2) };
        i2[s2] = pq(c2.concat(h2));
      }
    }
  }
  return Ei(Ei({}, t2), {}, { expandedMap: r2, visibleSectionsMap: i2 });
}
function jq(e22, t2, n2, r2) {
  var i2 = Ei({}, t2.expandedMap);
  var o2 = n2.slice();
  return function e23(n3) {
    var a2 = o2.length;
    if (Array.isArray(n3)) {
      if (r2(o2)) {
        var s2 = cs.exports.compileJSONPointer(o2);
        if (i2[s2] = true, n3.length > 0) {
          var u2 = kq(t2, s2);
          wq(n3, u2, function(t3) {
            o2[a2] = String(t3), e23(n3[t3]);
          }), o2.pop();
        }
      }
    } else if ($s(n3) && r2(o2)) {
      i2[cs.exports.compileJSONPointer(o2)] = true;
      var c2 = Object.keys(n3);
      if (c2.length > 0) {
        var l2, f2 = bi(c2);
        try {
          for (f2.s(); !(l2 = f2.n()).done; ) {
            var h2 = l2.value;
            o2[a2] = h2, e23(n3[h2]);
          }
        } catch (e24) {
          f2.e(e24);
        } finally {
          f2.f();
        }
        o2.pop();
      }
    }
  }(cs.exports.getIn(e22, n2)), Ei(Ei({}, t2), {}, { expandedMap: i2 });
}
function Sq(e22, t2) {
  return Ei(Ei({}, e22), {}, { expandedMap: Ei(Ei({}, e22.expandedMap), {}, Pi({}, cs.exports.compileJSONPointer(t2), true)) });
}
function Cq(e22, t2) {
  var n2 = Mq(e22.expandedMap, t2), r2 = Mq(e22.enforceStringMap, t2), i2 = Mq(e22.visibleSectionsMap, t2);
  return Ei(Ei({}, e22), {}, { expandedMap: n2, enforceStringMap: r2, visibleSectionsMap: i2 });
}
function _q(e22, t2, n2) {
  if (n2) {
    var r2 = Ei({}, e22.enforceStringMap);
    return r2[t2] = n2, Ei(Ei({}, e22), {}, { enforceStringMap: r2 });
  }
  if (typeof e22.enforceStringMap[t2] == "boolean") {
    var i2 = Ei({}, e22.enforceStringMap);
    return delete i2[t2], Ei(Ei({}, e22), {}, { enforceStringMap: i2 });
  }
  return e22;
}
function $q(e22, t2, n2) {
  var r2 = cs.exports.immutableJSONPatch(e22, n2), i2 = n2.reduce(function(e23, t3) {
    return cs.exports.isJSONPatchAdd(t3) ? Oq(r2, e23, t3) : cs.exports.isJSONPatchRemove(t3) ? Aq(r2, e23, t3) : cs.exports.isJSONPatchReplace(t3) ? function(e24, t4, n3) {
      var r3 = n3.path, i3 = Iq(e24, t4.expandedMap), o2 = Iq(e24, t4.enforceStringMap), a2 = Iq(e24, t4.visibleSectionsMap);
      Jw(n3.value) || Uw(n3.value) || delete i3[r3];
      Uw(n3.value) || delete a2[r3];
      (Jw(n3.value) || Uw(n3.value)) && delete o2[r3];
      return Ei(Ei({}, t4), {}, { expandedMap: i3, enforceStringMap: o2, visibleSectionsMap: a2 });
    }(r2, e23, t3) : cs.exports.isJSONPatchCopy(t3) || cs.exports.isJSONPatchMove(t3) ? function(e24, t4, n3) {
      if (cs.exports.isJSONPatchMove(n3) && n3.from === n3.path)
        return t4;
      var r3 = function(e25) {
        return n3.path + e25.substring(n3.from.length);
      }, i3 = Nq(Eq(t4.expandedMap, n3.from), r3), o2 = Nq(Eq(t4.enforceStringMap, n3.from), r3), a2 = Nq(Eq(t4.visibleSectionsMap, n3.from), r3), s2 = t4;
      cs.exports.isJSONPatchMove(n3) && (s2 = Aq(e24, s2, { op: "remove", path: n3.from }));
      var u2 = Pq((s2 = Oq(e24, s2, { op: "add", path: n3.path, value: null })).expandedMap, i3), c2 = Pq(s2.enforceStringMap, o2), l2 = Pq(s2.visibleSectionsMap, a2);
      return Ei(Ei({}, t4), {}, { expandedMap: u2, enforceStringMap: c2, visibleSectionsMap: l2 });
    }(r2, e23, t3) : e23;
  }, t2);
  return { json: r2, documentState: i2 };
}
function Oq(e22, t2, n2) {
  var r2 = cs.exports.parsePath(e22, n2.path), i2 = Gp(r2), o2 = cs.exports.compileJSONPointer(i2);
  if (Uw(cs.exports.getIn(e22, i2))) {
    var a2 = Ww(yv(r2)), s2 = Tq(t2.expandedMap, i2, a2, 1), u2 = Tq(t2.enforceStringMap, i2, a2, 1), c2 = Tq(t2.visibleSectionsMap, i2, a2, 1);
    return c2 = Rq(c2, o2, function(e23) {
      return Dq(e23, a2, 1);
    }), Ei(Ei({}, t2), {}, { expandedMap: s2, enforceStringMap: u2, visibleSectionsMap: c2 });
  }
  return t2;
}
function Aq(e22, t2, n2) {
  var r2 = cs.exports.parsePath(e22, n2.path), i2 = Gp(r2), o2 = cs.exports.compileJSONPointer(i2), a2 = cs.exports.getIn(e22, i2), s2 = t2.expandedMap, u2 = t2.enforceStringMap, c2 = t2.visibleSectionsMap;
  if (s2 = Mq(s2, r2), u2 = Mq(u2, r2), c2 = Mq(c2, r2), Uw(a2)) {
    var l2 = Ww(yv(r2));
    s2 = Tq(s2, i2, l2, -1), u2 = Tq(u2, i2, l2, -1), c2 = Rq(c2 = Tq(c2, i2, l2, -1), o2, function(e23) {
      return Dq(e23, l2, -1);
    });
  }
  return Ei(Ei({}, t2), {}, { expandedMap: s2, enforceStringMap: u2, visibleSectionsMap: c2 });
}
function Mq(e22, t2) {
  var n2 = {}, r2 = cs.exports.compileJSONPointer(t2);
  return Object.keys(e22).forEach(function(t3) {
    cs.exports.startsWithJSONPointer(t3, r2) || (n2[t3] = e22[t3]);
  }), n2;
}
function Eq(e22, t2) {
  var n2 = {};
  return Object.keys(e22).forEach(function(r2) {
    cs.exports.startsWithJSONPointer(r2, t2) && (n2[r2] = e22[r2]);
  }), n2;
}
function Pq(e22, t2) {
  return Ei(Ei({}, e22), t2);
}
function Nq(e22, t2) {
  var n2 = {};
  return Object.keys(e22).forEach(function(r2) {
    var i2 = t2(r2);
    n2[i2] = e22[r2];
  }), n2;
}
function Tq(e22, t2, n2, r2) {
  for (var i2 = t2.length, o2 = cs.exports.compileJSONPointer(t2), a2 = [], s2 = 0, u2 = Object.keys(e22); s2 < u2.length; s2++) {
    var c2 = u2[s2];
    if (cs.exports.startsWithJSONPointer(c2, o2)) {
      var l2 = cs.exports.parseJSONPointer(c2), f2 = Ww(l2[i2]);
      f2 >= n2 && (l2[i2] = String(f2 + r2), a2.push({ oldPointer: c2, newPointer: cs.exports.compileJSONPointer(l2), value: e22[c2] }));
    }
  }
  if (a2.length === 0)
    return e22;
  var h2 = Ei({}, e22);
  return a2.forEach(function(e23) {
    delete h2[e23.oldPointer];
  }), a2.forEach(function(e23) {
    h2[e23.newPointer] = e23.value;
  }), h2;
}
function Iq(e22, t2) {
  var n2 = {};
  return Object.keys(t2).filter(function(t3) {
    return cs.exports.existsIn(e22, cs.exports.parsePath(e22, t3));
  }).forEach(function(e23) {
    n2[e23] = t2[e23];
  }), n2;
}
function Rq(e22, t2, n2) {
  var r2 = e22[t2];
  if (t2 in e22) {
    var i2 = n2(r2);
    if (!wm(r2, i2)) {
      var o2 = Ei({}, e22);
      return i2 === void 0 ? delete o2[t2] : o2[t2] = i2, o2;
    }
  }
  return e22;
}
function Dq(e22, t2, n2) {
  return e22.map(function(e23) {
    return { start: e23.start > t2 ? e23.start + n2 : e23.start, end: e23.end >= t2 ? e23.end + n2 : e23.end };
  });
}
function zq(e22, t2, n2) {
  var r2, i2 = t2 ? t2[n2] : void 0;
  return typeof i2 == "boolean" ? i2 : typeof (r2 = e22) == "string" && typeof Ns(r2) != "string";
}
function Lq(e22, t2) {
  var n2 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], r2 = e22.indexOf(t2);
  return r2 !== -1 ? n2 ? e22.slice(r2) : e22.slice(r2 + 1) : [];
}
function Bq(e22, t2) {
  var n2 = [];
  return function e23(r2, i2) {
    n2.push(i2);
    var o2 = cs.exports.compileJSONPointer(i2);
    if (r2 && t2.expandedMap[o2] === true) {
      if (Uw(r2)) {
        var a2 = kq(t2, o2);
        wq(r2, a2, function(t3) {
          e23(r2[t3], i2.concat(String(t3)));
        });
      }
      Jw(r2) && Object.keys(r2).forEach(function(t3) {
        e23(r2[t3], i2.concat(t3));
      });
    }
  }(e22, []), n2;
}
function qq(e22, t2) {
  var n2 = !(arguments.length > 2 && arguments[2] !== void 0) || arguments[2], r2 = [];
  function i2(e23, o2) {
    r2.push({ path: o2, type: ax.value });
    var a2 = cs.exports.compileJSONPointer(o2);
    if (e23 && t2.expandedMap[a2] === true) {
      if (n2 && r2.push({ path: o2, type: ax.inside }), Uw(e23)) {
        var s2 = kq(t2, a2);
        wq(e23, s2, function(t3) {
          var a3 = o2.concat(String(t3));
          i2(e23[t3], a3), n2 && r2.push({ path: a3, type: ax.after });
        });
      }
      if (Jw(e23))
        Object.keys(e23).forEach(function(t3) {
          var a3 = o2.concat(t3);
          r2.push({ path: a3, type: ax.key }), i2(e23[t3], a3), n2 && r2.push({ path: a3, type: ax.after });
        });
    }
  }
  return i2(e22, []), r2;
}
function Fq(e22, t2, n2) {
  var r2 = Bq(e22, t2), i2 = r2.map(cs.exports.compileJSONPointer), o2 = cs.exports.compileJSONPointer(n2), a2 = i2.indexOf(o2);
  return a2 !== -1 && a2 > 0 ? r2[a2 - 1] : null;
}
function Vq(e22, t2, n2) {
  var r2 = Bq(e22, t2), i2 = r2.map(cs.exports.compileJSONPointer).indexOf(cs.exports.compileJSONPointer(n2));
  return i2 !== -1 && i2 < r2.length - 1 ? r2[i2 + 1] : null;
}
var Hq = Ia("jsoneditor:History");
function Wq() {
  var e22 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, t2 = e22.maxItems || 1e3, n2 = [], r2 = 0;
  function i2() {
    return r2 < n2.length;
  }
  function o2() {
    return r2 > 0;
  }
  function a2() {
    return { canUndo: i2(), canRedo: o2(), length: n2.length };
  }
  function s2() {
    e22.onChange && e22.onChange(a2());
  }
  function u2(e23) {
    Hq("add", e23), n2 = [e23].concat(n2.slice(r2)).slice(0, t2), r2 = 0, s2();
  }
  function c2() {
    Hq("clear"), n2 = [], r2 = 0, s2();
  }
  function l2() {
    if (i2()) {
      var e23 = n2[r2];
      return r2 += 1, Hq("undo", e23), s2(), e23;
    }
  }
  function f2() {
    if (o2())
      return Hq("redo", n2[r2 -= 1]), s2(), n2[r2];
  }
  return { add: u2, clear: c2, getState: a2, undo: l2, redo: f2 };
}
function Jq(e22, t2) {
  for (var n2 = new Set(t2), r2 = e22.replace(/ \(copy( \d+)?\)$/, ""), i2 = e22, o2 = 1; n2.has(i2); ) {
    var a2 = "copy" + (o2 > 1 ? " " + o2 : "");
    i2 = "".concat(r2, " (").concat(a2, ")"), o2++;
  }
  return i2;
}
function Uq(e22, t2) {
  var n2 = t2 - "...".length;
  return e22.length > t2 ? e22.substring(0, n2) + "..." : e22;
}
function Kq(e22) {
  if (e22 === "")
    return "";
  var t2 = e22.toLowerCase();
  if (t2 === "null")
    return null;
  if (t2 === "true")
    return true;
  if (t2 === "false")
    return false;
  if (t2 !== "undefined") {
    var n2 = Number(e22), r2 = parseFloat(e22);
    return isNaN(n2) || isNaN(r2) ? e22 : n2;
  }
}
function Gq(e22) {
  return e22 && e22.type === ox.after;
}
function Qq(e22) {
  return e22 && e22.type === ox.inside;
}
function Yq(e22) {
  return e22 && e22.type === ox.key;
}
function Zq(e22) {
  return e22 && e22.type === ox.value;
}
function Xq(e22) {
  return e22 && e22.type === ox.multi;
}
function eF(e22) {
  return Qq(e22) ? e22.focusPath : Gp(e22.focusPath);
}
function tF(e22) {
  return Xq(e22) ? cp(e22.paths) : e22.focusPath;
}
function nF(e22) {
  return Xq(e22) ? yv(e22.paths) : e22.focusPath;
}
function rF(e22, t2) {
  return hF(e22.focusPath, t2) && (e22.focusPath.length > t2.length || Qq(e22));
}
function iF(e22, t2) {
  var n2 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], r2 = arguments.length > 3 && arguments[3] !== void 0 && arguments[3], i2 = t2.selection, o2 = !r2 && Xq(i2) ? cp(i2.paths) : i2.focusPath, a2 = Fq(e22, t2, o2);
  if (a2 === null)
    return null;
  var s2 = a2, u2 = a2;
  if (n2)
    return Gq(i2) || Qq(i2) ? yF(e22, i2.anchorPath, i2.anchorPath) : yF(e22, i2.anchorPath, u2);
  if (Yq(i2)) {
    var c2 = Gp(a2), l2 = cs.exports.getIn(e22, c2);
    return Array.isArray(l2) || km(a2) ? pF(a2, false) : vF(a2, false);
  }
  return Zq(i2) ? pF(a2, false) : Gq(i2) || Qq(i2) ? yF(e22, o2, o2) : yF(e22, s2, u2);
}
function oF(e22, t2, n2) {
  var r2 = t2.selection, i2 = qq(e22, t2, n2), o2 = i2.findIndex(function(e23) {
    return wm(e23.path, r2.focusPath) && String(e23.type) === String(r2.type);
  });
  return { caret: o2 !== -1 ? i2[o2] : null, previous: o2 !== -1 && o2 > 0 ? i2[o2 - 1] : null, next: o2 !== -1 && o2 < i2.length - 1 ? i2[o2 + 1] : null };
}
function aF(e22, t2) {
  for (var n2 = Bq(e22, t2), r2 = 0; r2 < n2.length - 1 && n2[r2 + 1].length > n2[r2].length; )
    r2++;
  var i2 = n2[r2];
  return i2.length === 0 || Array.isArray(cs.exports.getIn(e22, Gp(i2))) ? pF(i2, false) : vF(i2, false);
}
function sF(e22, t2) {
  if (t2.length === 1) {
    var n2 = cp(t2);
    if (n2.op === "replace" || n2.op === "move")
      return pF(cs.exports.parsePath(e22, n2.path), false);
  }
  if (!km(t2) && t2.every(function(e23) {
    return e23.op === "move";
  })) {
    var r2 = cp(t2), i2 = t2.slice(1);
    if ((cs.exports.isJSONPatchCopy(r2) || cs.exports.isJSONPatchMove(r2)) && r2.from !== r2.path && i2.every(function(e23) {
      return (cs.exports.isJSONPatchCopy(e23) || cs.exports.isJSONPatchMove(e23)) && e23.from === e23.path;
    }))
      return vF(cs.exports.parsePath(e22, r2.path), false);
  }
  var o2 = t2.filter(function(e23) {
    return e23.op !== "test" && e23.op !== "remove" && (e23.op !== "move" || e23.from !== e23.path) && typeof e23.path == "string";
  }).map(function(t3) {
    return cs.exports.parsePath(e22, t3.path);
  });
  return km(o2) ? null : { type: ox.multi, paths: o2, anchorPath: cp(o2), focusPath: yv(o2), pointersMap: uF(o2) };
}
function uF(e22) {
  var t2 = {};
  return e22.forEach(function(e23) {
    t2[cs.exports.compileJSONPointer(e23)] = true;
  }), t2;
}
function cF(e22) {
  return Pi({}, cs.exports.compileJSONPointer(e22), true);
}
function lF(e22) {
  return e22 && (Yq(e22) || Zq(e22) || Xq(e22) && e22.paths.length === 1);
}
function fF(e22, t2) {
  return lF(t2) && Os(cs.exports.getIn(e22, t2.focusPath)) ? t2.focusPath : Gp(t2.focusPath);
}
function hF(e22, t2) {
  if (e22.length < t2.length)
    return false;
  for (var n2 = 0; n2 < t2.length; n2++)
    if (e22[n2] !== t2[n2])
      return false;
  return true;
}
function dF(e22) {
  var t2 = e22.selection;
  return (Yq(t2) || Zq(t2)) && t2.edit ? Ei(Ei({}, e22), {}, { selection: Ei(Ei({}, t2), {}, { edit: false }) }) : e22;
}
function vF(e22, t2) {
  return { type: ox.key, anchorPath: e22, focusPath: e22, pointersMap: cF(e22), edit: t2 };
}
function pF(e22, t2) {
  return { type: ox.value, anchorPath: e22, focusPath: e22, pointersMap: cF(e22), edit: t2 };
}
function mF(e22) {
  return { type: ox.inside, anchorPath: e22, focusPath: e22, pointersMap: cF(e22) };
}
function gF(e22) {
  return { type: ox.after, anchorPath: e22, focusPath: e22, pointersMap: cF(e22) };
}
function yF(e22, t2, n2) {
  var r2 = function(e23, t3, n3) {
    if (wm(t3, n3))
      return [t3];
    var r3 = function(e24, t4) {
      for (var n4 = 0; n4 < e24.length && n4 < t4.length && e24[n4] === t4[n4]; )
        n4++;
      return e24.slice(0, n4);
    }(t3, n3);
    if (t3.length === r3.length || n3.length === r3.length)
      return [r3];
    var i3 = t3[r3.length], o2 = n3[r3.length], a2 = cs.exports.getIn(e23, r3);
    if (Jw(a2)) {
      var s2 = Object.keys(a2), u2 = s2.indexOf(i3), c2 = s2.indexOf(o2);
      if (u2 !== -1 && c2 !== -1) {
        for (var l2 = Math.min(u2, c2), f2 = Math.max(u2, c2), h2 = [], d2 = l2; d2 <= f2; d2++)
          h2.push(r3.concat(s2[d2]));
        return h2;
      }
    }
    if (Uw(a2)) {
      for (var v2 = Math.min(Ww(i3), Ww(o2)), p2 = Math.max(Ww(i3), Ww(o2)), m2 = [], g2 = v2; g2 <= p2; g2++)
        m2.push(r3.concat(String(g2)));
      return m2;
    }
    throw new Error("Failed to create selection");
  }(e22, t2, n2), i2 = hF(n2, yv(r2)) || hF(t2, cp(r2));
  return { type: ox.multi, anchorPath: i2 ? cp(r2) : yv(r2), focusPath: i2 ? yv(r2) : cp(r2), paths: r2, pointersMap: uF(r2) };
}
function bF(e22, t2) {
  var n2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 2;
  if (Yq(t2))
    return String(yv(t2.focusPath));
  if (Zq(t2)) {
    var r2 = cs.exports.getIn(e22, t2.focusPath);
    return typeof r2 == "string" ? r2 : JSON.stringify(r2, null, n2);
  }
  if (Xq(t2)) {
    if (km(t2.focusPath))
      return JSON.stringify(e22, null, n2);
    var i2 = eF(t2), o2 = cs.exports.getIn(e22, i2);
    if (Array.isArray(o2)) {
      if (t2.paths.length === 1) {
        var a2 = cs.exports.getIn(e22, cp(t2.paths));
        return JSON.stringify(a2, null, n2);
      }
      return t2.paths.map(function(t3) {
        var r3 = cs.exports.getIn(e22, t3);
        return "".concat(JSON.stringify(r3, null, n2), ",");
      }).join("\n");
    }
    return t2.paths.map(function(t3) {
      var r3 = yv(t3), i3 = cs.exports.getIn(e22, t3);
      return "".concat(JSON.stringify(r3), ": ").concat(JSON.stringify(i3, null, n2), ",");
    }).join("\n");
  }
  return null;
}
function kF(e22) {
  return Xq(e22) ? e22.paths : [e22.focusPath];
}
function wF(e22) {
  return (Yq(e22) || Zq(e22)) && e22.edit;
}
function xF(e22) {
  return !!e22 && (!(!Yq(e22) && !Zq(e22)) || (!(!Xq(e22) || e22.paths.length !== 1) || void 0));
}
function jF(e22) {
  switch (e22.type) {
    case ax.key:
      return vF(e22.path, false);
    case ax.value:
      return pF(e22.path, false);
    case ax.after:
      return gF(e22.path);
    case ax.inside:
      return mF(e22.path);
  }
}
function SF(e22, t2, n2) {
  switch (t2) {
    case ox.key:
      return vF(n2, false);
    case ox.value:
      return pF(n2, false);
    case ox.after:
      return gF(n2);
    case ox.inside:
      return mF(n2);
    case ox.multi:
      return yF(e22, n2, n2);
  }
}
function CF(e22, t2) {
  if (e22)
    return Object.keys(e22.pointersMap).some(function(e23) {
      return cs.exports.startsWithJSONPointer(e23, t2) || cs.exports.startsWithJSONPointer(t2, e23);
    }) ? e22 : void 0;
}
function _F(e22, t2, n2) {
  var r2 = Gp(t2), i2 = cs.exports.getIn(e22, r2);
  if (Uw(i2)) {
    var o2 = Ww(yv(t2));
    return n2.map(function(e23, t3) {
      return { op: "add", path: cs.exports.compileJSONPointer(r2.concat(String(o2 + t3))), value: e23.value };
    });
  }
  if (Jw(i2)) {
    var a2 = yv(t2), s2 = Object.keys(i2), u2 = Lq(s2, a2, true);
    return [].concat(Ni(n2.map(function(e23) {
      var t3 = Jq(e23.key, s2);
      return { op: "add", path: cs.exports.compileJSONPointer(r2.concat(t3)), value: e23.value };
    })), Ni(u2.map(function(e23) {
      return EF(r2, e23);
    })));
  }
  throw new Error("Cannot create insert operations: parent must be an Object or Array");
}
function $F(e22, t2, n2) {
  var r2 = cs.exports.getIn(e22, t2);
  if (Array.isArray(r2)) {
    var i2 = r2.length;
    return n2.map(function(e23, n3) {
      return { op: "add", path: cs.exports.compileJSONPointer(t2.concat(String(i2 + n3))), value: e23.value };
    });
  }
  return n2.map(function(e23) {
    var n3 = Jq(e23.key, Object.keys(r2));
    return { op: "add", path: cs.exports.compileJSONPointer(t2.concat(n3)), value: e23.value };
  });
}
function OF(e22, t2, n2, r2) {
  var i2 = Jq(r2, t2.filter(function(e23) {
    return e23 !== n2;
  })), o2 = Lq(t2, n2, false);
  return [{ op: "move", from: cs.exports.compileJSONPointer(e22.concat(n2)), path: cs.exports.compileJSONPointer(e22.concat(i2)) }].concat(Ni(o2.map(function(t3) {
    return EF(e22, t3);
  })));
}
function AF(e22, t2, n2) {
  if (Yq(t2)) {
    var r2 = Gw(n2), i2 = Gp(t2.focusPath), o2 = cs.exports.getIn(e22, i2);
    return OF(i2, Object.keys(o2), yv(t2.focusPath), typeof r2 == "string" ? r2 : n2);
  }
  if (Zq(t2) || Xq(t2) && km(t2.focusPath))
    try {
      return [{ op: "replace", path: cs.exports.compileJSONPointer(t2.focusPath), value: Qw(n2, Kw) }];
    } catch (e23) {
      return [{ op: "replace", path: cs.exports.compileJSONPointer(t2.focusPath), value: n2 }];
    }
  if (Xq(t2)) {
    var a2 = PF(n2);
    return function(e23, t3, n3) {
      var r3 = Gp(cp(t3)), i3 = cs.exports.getIn(e23, r3);
      if (Uw(i3)) {
        var o3 = cp(t3), a3 = o3 ? Ww(yv(o3)) : 0;
        return [].concat(Ni(MF(t3)), Ni(n3.map(function(e24, t4) {
          return { op: "add", path: cs.exports.compileJSONPointer(r3.concat(String(t4 + a3))), value: e24.value };
        })));
      }
      if (Jw(i3)) {
        var s3 = yv(t3), u3 = Gp(s3), c3 = yv(s3), l3 = Object.keys(i3), f3 = Lq(l3, c3, false), h3 = new Set(t3.map(function(e24) {
          return yv(e24);
        })), d3 = l3.filter(function(e24) {
          return !h3.has(e24);
        });
        return [].concat(Ni(MF(t3)), Ni(n3.map(function(e24) {
          var t4 = Jq(e24.key, d3);
          return { op: "add", path: cs.exports.compileJSONPointer(u3.concat(t4)), value: e24.value };
        })), Ni(f3.map(function(e24) {
          return EF(u3, e24);
        })));
      }
      throw new Error("Cannot create replace operations: parent must be an Object or Array");
    }(e22, t2.paths, a2);
  }
  if (Gq(t2)) {
    var s2 = PF(n2), u2 = t2.focusPath, c2 = Gp(u2), l2 = cs.exports.getIn(e22, c2);
    if (Uw(l2)) {
      var f2 = Ww(yv(u2));
      return _F(e22, c2.concat(String(f2 + 1)), s2);
    }
    if (Jw(l2)) {
      var h2 = String(yv(u2)), d2 = Object.keys(l2);
      if (km(d2) || yv(d2) === h2)
        return $F(e22, c2, s2);
      var v2 = d2.indexOf(h2), p2 = d2[v2 + 1];
      return _F(e22, c2.concat(p2), s2);
    }
    throw new Error("Cannot create insert operations: parent must be an Object or Array");
  }
  if (Qq(t2)) {
    var m2 = PF(n2), g2 = t2.focusPath, y2 = cs.exports.getIn(e22, g2);
    if (Uw(y2))
      return _F(e22, g2.concat("0"), m2);
    if (Jw(y2)) {
      var b2 = Object.keys(y2);
      if (km(b2))
        return $F(e22, g2, m2);
      var k2 = cp(b2);
      return _F(e22, g2.concat(k2), m2);
    }
    throw new Error("Cannot create insert operations: parent must be an Object or Array");
  }
  throw new Error("Cannot insert: unsupported type of selection " + JSON.stringify(t2));
}
function MF(e22) {
  return e22.map(function(e23) {
    return { op: "remove", path: cs.exports.compileJSONPointer(e23) };
  }).reverse();
}
function EF(e22, t2) {
  return { op: "move", from: cs.exports.compileJSONPointer(e22.concat(t2)), path: cs.exports.compileJSONPointer(e22.concat(t2)) };
}
function PF(e22) {
  var t2 = /^\s*{/.test(e22), n2 = /^\s*\[/.test(e22), r2 = Gw(e22), i2 = r2 !== void 0 ? r2 : Qw(e22, Kw);
  return t2 && $s(i2) || n2 && Array.isArray(i2) ? [{ key: "New item", value: i2 }] : Array.isArray(i2) ? i2.map(function(e23, t3) {
    return { key: "New item " + t3, value: e23 };
  }) : $s(i2) ? Object.keys(i2).map(function(e23) {
    return { key: e23, value: i2[e23] };
  }) : [{ key: "New item", value: i2 }];
}
function NF(e22, t2) {
  if (Yq(t2)) {
    var n2 = Gp(t2.focusPath), r2 = cs.exports.getIn(e22, n2), i2 = OF(n2, Object.keys(r2), yv(t2.focusPath), "");
    return { operations: i2, newSelection: sF(e22, i2) };
  }
  if (Zq(t2))
    return { operations: [{ op: "replace", path: cs.exports.compileJSONPointer(t2.focusPath), value: "" }], newSelection: t2 };
  if (Xq(t2)) {
    var o2 = MF(t2.paths), a2 = yv(t2.paths);
    if (km(a2)) {
      return { operations: [{ op: "replace", path: "", value: "" }], newSelection: pF([], false) };
    }
    var s2 = Gp(a2), u2 = cs.exports.getIn(e22, s2);
    if (Uw(u2)) {
      var c2 = Ww(yv(cp(t2.paths)));
      return { operations: o2, newSelection: c2 === 0 ? mF(s2) : gF(s2.concat(String(c2 - 1))) };
    }
    if (Jw(u2)) {
      var l2 = Object.keys(u2), f2 = yv(cp(t2.paths)), h2 = l2.indexOf(f2), d2 = l2[h2 - 1];
      return { operations: o2, newSelection: h2 === 0 ? mF(s2) : gF(s2.concat(d2)) };
    }
    throw new Error("Cannot create remove operations: parent must be an Object or Array");
  }
  throw new Error("Cannot remove: unsupported type of selection " + JSON.stringify(t2));
}
function TF(e22, t2) {
  var n2 = Gp(t2), r2 = yv(t2), i2 = cs.exports.getIn(e22, n2);
  return Jw(i2) ? Lq(Object.keys(i2), r2, false).map(function(e23) {
    return EF(n2, e23);
  }) : [];
}
function IF(e22) {
  var t2 = e22.activeIndex < e22.items.length - 1 ? e22.activeIndex + 1 : e22.items.length > 0 ? 0 : -1, n2 = e22.items[t2], r2 = e22.items.map(function(e23, n3) {
    return Ei(Ei({}, e23), {}, { active: n3 === t2 });
  });
  return Ei(Ei({}, e22), {}, { items: r2, itemsMap: Ep(r2, function(e23) {
    return cs.exports.compileJSONPointer(e23.path);
  }), activeItem: n2, activeIndex: t2 });
}
function RF(e22) {
  var t2 = e22.activeIndex > 0 ? e22.activeIndex - 1 : e22.items.length - 1, n2 = e22.items[t2], r2 = e22.items.map(function(e23, n3) {
    return Ei(Ei({}, e23), {}, { active: n3 === t2 });
  });
  return Ei(Ei({}, e22), {}, { items: r2, itemsMap: Ep(r2, function(e23) {
    return cs.exports.compileJSONPointer(e23.path);
  }), activeItem: n2, activeIndex: t2 });
}
function DF(e22, t2, n2) {
  var r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 1 / 0, i2 = [], o2 = [];
  function a2(e23) {
    i2.length < r2 && i2.push(e23);
  }
  function s2(e23, t3) {
    if (Uw(t3)) {
      var n3 = o2.length;
      o2.push("0");
      for (var u3 = 0; u3 < t3.length; u3++)
        if (o2[n3] = String(u3), s2(e23, t3[u3]), i2.length >= r2)
          return;
      o2.pop();
    } else if (Jw(t3)) {
      var c2 = Object.keys(t3), l2 = o2.length;
      o2.push("");
      for (var f2 = 0, h2 = c2; f2 < h2.length; f2++) {
        var d2 = h2[f2];
        if (o2[l2] = d2, zF(d2, e23, o2, sx.key, a2), s2(e23, t3[d2]), i2.length >= r2)
          return;
      }
      o2.pop();
    } else
      zF(String(t3), e23, o2, sx.value, a2);
  }
  if (typeof e22 == "string" && e22 !== "") {
    var u2 = e22.toLowerCase();
    s2(u2, t2);
  }
  return i2;
}
function zF(e22, t2, n2, r2, i2) {
  var o2 = e22.toLowerCase(), a2 = 0, s2 = -1, u2 = -1;
  do {
    (u2 = o2.indexOf(t2, s2)) !== -1 && (s2 = u2 + t2.length, i2({ path: n2.slice(0), field: r2, fieldIndex: a2, start: u2, end: s2 }), a2++);
  } while (u2 !== -1);
}
function LF(e22, t2, n2, r2) {
  return e22.substring(0, n2) + t2 + e22.substring(r2);
}
function BF(e22, t2, n2) {
  var r2 = e22;
  return Nv(n2, function(e23) {
    r2 = LF(r2, t2, e23.start, e23.end);
  }), r2;
}
function qF(e22, t2, n2, r2) {
  var i2 = r2.field, o2 = r2.path, a2 = r2.start, s2 = r2.end;
  if (i2 === sx.key) {
    var u2 = Gp(o2), c2 = cs.exports.getIn(e22, u2), l2 = yv(o2), f2 = OF(u2, Object.keys(c2), l2, LF(l2, n2, a2, s2));
    return { newSelection: sF(e22, f2), operations: f2 };
  }
  if (i2 === sx.value) {
    var h2 = cs.exports.getIn(e22, o2);
    if (h2 === void 0)
      throw new Error("Cannot replace: path not found ".concat(cs.exports.compileJSONPointer(o2)));
    var d2 = typeof h2 == "string" ? h2 : String(h2), v2 = cs.exports.compileJSONPointer(o2), p2 = zq(h2, t2.enforceStringMap, v2), m2 = LF(d2, n2, a2, s2), g2 = [{ op: "replace", path: cs.exports.compileJSONPointer(o2), value: p2 ? m2 : Ns(m2) }];
    return { newSelection: sF(e22, g2), operations: g2 };
  }
  throw new Error("Cannot replace: unknown type of search result field ".concat(i2));
}
function FF(e22, t2, n2, r2) {
  for (var i2 = DF(n2, e22, t2, 1 / 0), o2 = [], a2 = 0; a2 < i2.length; a2++) {
    var s2 = i2[a2 - 1], u2 = i2[a2];
    a2 !== 0 && u2.field === s2.field && wm(u2.path, s2.path) ? yv(o2).items.push(u2) : o2.push({ path: u2.path, field: u2.field, items: [u2] });
  }
  o2.sort(function(e23, t3) {
    return e23.field !== t3.field ? e23.field === sx.key ? 1 : -1 : t3.path.length - e23.path.length;
  });
  var c2 = [], l2 = void 0;
  return o2.forEach(function(n3) {
    var i3 = n3.field, o3 = n3.path, a3 = n3.items;
    if (i3 === sx.key) {
      var s3 = Gp(o3), u3 = cs.exports.getIn(e22, s3), f2 = yv(o3), h2 = OF(s3, Object.keys(u3), f2, BF(f2, r2, a3));
      c2 = c2.concat(h2), l2 = sF(e22, h2);
    } else {
      if (i3 !== sx.value)
        throw new Error("Cannot replace: unknown type of search result field ".concat(i3));
      var d2 = cs.exports.getIn(e22, o3);
      if (d2 === void 0)
        throw new Error("Cannot replace: path not found ".concat(cs.exports.compileJSONPointer(o3)));
      var v2 = typeof d2 == "string" ? d2 : String(d2), p2 = cs.exports.compileJSONPointer(o3), m2 = zq(d2, t2.enforceStringMap, p2), g2 = BF(v2, r2, a3), y2 = [{ op: "replace", path: cs.exports.compileJSONPointer(o3), value: m2 ? g2 : Ns(g2) }];
      c2 = c2.concat(y2), l2 = sF(e22, y2);
    }
  }), { operations: c2, newSelection: l2 };
}
function VF(e22) {
  return e22.path.concat(e22.field, String(e22.fieldIndex));
}
function HF(e22, t2) {
  var n2, r2 = (n2 = e22 == null ? void 0 : e22[t2]) === null || n2 === void 0 ? void 0 : n2.filter(function(e23) {
    return e23.field === sx.key;
  });
  if (r2 && r2.length !== 0)
    return r2;
}
function WF(e22, t2) {
  var n2, r2 = (n2 = e22 == null ? void 0 : e22[t2]) === null || n2 === void 0 ? void 0 : n2.filter(function(e23) {
    return e23.field === sx.value;
  });
  if (r2 && r2.length !== 0)
    return r2;
}
function JF(e22) {
  co(e22, "svelte-d01h2s", ".jse-header.svelte-d01h2s.svelte-d01h2s{display:flex;background:var(--jse-theme-color);color:var(--jse-menu-color)}.jse-header.svelte-d01h2s .jse-title.svelte-d01h2s{flex:1;padding:5px;vertical-align:middle}.jse-header.svelte-d01h2s button.svelte-d01h2s{border:none;background:transparent;min-width:32px;color:inherit;cursor:pointer}.jse-header.svelte-d01h2s button.svelte-d01h2s:hover{background:rgba(255, 255, 255, 0.1)}");
}
function UF(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2;
  return a2 = new Xj({ props: { data: Cj } }), { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = bo(e22[0]), i2 = ko(), o2 = go("button"), Aa(a2.$$.fragment), So(n2, "class", "jse-title svelte-d01h2s"), So(o2, "type", "button"), So(o2, "class", "jse-close svelte-d01h2s"), So(t2, "class", "jse-header svelte-d01h2s");
  }, m: function(l2, f2) {
    vo(l2, t2, f2), uo(t2, n2), uo(n2, r2), uo(t2, i2), uo(t2, o2), Ma(a2, o2, null), s2 = true, u2 || (c2 = xo(o2, "click", e22[1]), u2 = true);
  }, p: function(e23, t3) {
    var n3 = xi(t3, 1)[0];
    (!s2 || 1 & n3) && Ao(r2, e23[0]);
  }, i: function(e23) {
    s2 || (ya(a2.$$.fragment, e23), s2 = true);
  }, o: function(e23) {
    ba(a2.$$.fragment, e23), s2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(a2), u2 = false, c2();
  } };
}
function KF(e22, t2, n2) {
  var r2 = t2.title, i2 = r2 === void 0 ? "Modal" : r2, o2 = Yo("simple-modal").close;
  return e22.$$set = function(e23) {
    "title" in e23 && n2(0, i2 = e23.title);
  }, [i2, o2];
}
var GF = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, KF, UF, Ki, { title: 0 }, JF), r2;
  }
  return zi(n2);
}();
function QF(e22) {
  co(e22, "svelte-t45ah0", ".jse-modal.svelte-t45ah0.svelte-t45ah0{--height:36px;--multiItemHeight:28px;--multiItemMargin:2px;--multiItemPadding:2px 8px;--multiClearTop:5px;--multiItemBorderRadius:6px;--clearSelectTop:2px;--clearSelectBottom:2px;--indicatorTop:8px;flex:1;display:flex;flex-direction:column;font-family:var(--jse-font-family);font-size:var(--jse-font-size);line-height:normal;background:var(--jse-modal-background);color:var(--jse-text-color)}.jse-modal.svelte-t45ah0 .jse-contents.svelte-t45ah0{padding:20px;overflow:auto}.jse-modal.svelte-t45ah0 .jse-contents .jse-actions.svelte-t45ah0{display:flex;flex-direction:row;justify-content:flex-end;padding-top:var(--jse-padding)}.jse-modal.svelte-t45ah0 .jse-contents .jse-actions button.svelte-t45ah0{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;background:var(--jse-button-primary-background);color:var(--jse-button-primary-color);padding:var(--jse-padding) calc(2 * var(--jse-padding));border-radius:3px}.jse-modal.svelte-t45ah0 .jse-contents .jse-actions button.svelte-t45ah0:hover{background:var(--jse-button-primary-background-highlight)}.jse-modal.svelte-t45ah0 .jse-contents .jse-actions button.svelte-t45ah0:disabled{background:var(--jse-button-primary-background-disabled)}.bg.jse-modal-bg{width:100%;height:100%;top:0;left:0;background:var(--jse-modal-overlay-background)}.bg.jse-modal-bg .jse-modal-window-wrap{margin:0}.bg.jse-modal-bg .jse-modal-window{max-width:90%;margin:4rem auto 2rem auto;border-radius:2px}.bg.jse-modal-bg .jse-modal-window.jse-modal-window-sort{width:400px}.bg.jse-modal-bg .jse-modal-window.jse-modal-window-transform{width:1200px;height:1200px;max-height:80%;display:flex}.bg.jse-modal-bg .jse-modal-content{flex:1;display:flex;max-height:calc(100vh - 6rem);padding:0}.jse-modal.jse-copy-paste.svelte-t45ah0 .jse-shortcuts.svelte-t45ah0{display:flex;flex-wrap:wrap;justify-content:space-around;margin:calc(2 * var(--jse-padding)) 0}.jse-modal.jse-copy-paste.svelte-t45ah0 .jse-shortcuts .jse-shortcut .jse-key.svelte-t45ah0{font-size:200%;color:var(--jse-theme-color)}");
}
function YF(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2, k2, w2, x2, j2, S2;
  return n2 = new GF({ props: { title: "Copying and pasting" } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), r2 = ko(), i2 = go("div"), (o2 = go("div")).textContent = "These actions are unavailable via the menu. Please use:", a2 = ko(), s2 = go("div"), u2 = go("div"), (c2 = go("div")).textContent = "".concat(e22[1], "+C"), l2 = bo("\n        for copy"), f2 = ko(), h2 = go("div"), (d2 = go("div")).textContent = "".concat(e22[1], "+X"), v2 = bo("\n        for cut"), p2 = ko(), m2 = go("div"), (g2 = go("div")).textContent = "".concat(e22[1], "+V"), y2 = bo("\n        for paste"), b2 = ko(), k2 = go("div"), (w2 = go("button")).textContent = "Close", So(c2, "class", "jse-key svelte-t45ah0"), So(u2, "class", "jse-shortcut"), So(d2, "class", "jse-key svelte-t45ah0"), So(h2, "class", "jse-shortcut"), So(g2, "class", "jse-key svelte-t45ah0"), So(m2, "class", "jse-shortcut"), So(s2, "class", "jse-shortcuts svelte-t45ah0"), So(w2, "type", "button"), So(w2, "class", "jse-primary svelte-t45ah0"), So(k2, "class", "jse-actions svelte-t45ah0"), So(i2, "class", "jse-contents svelte-t45ah0"), So(t2, "class", "jse-modal jse-copy-paste svelte-t45ah0");
  }, m: function(C2, _2) {
    vo(C2, t2, _2), Ma(n2, t2, null), uo(t2, r2), uo(t2, i2), uo(i2, o2), uo(i2, a2), uo(i2, s2), uo(s2, u2), uo(u2, c2), uo(u2, l2), uo(s2, f2), uo(s2, h2), uo(h2, d2), uo(h2, v2), uo(s2, p2), uo(s2, m2), uo(m2, g2), uo(m2, y2), uo(i2, b2), uo(i2, k2), uo(k2, w2), x2 = true, j2 || (S2 = xo(w2, "click", e22[0]), j2 = true);
  }, p: Bi, i: function(e23) {
    x2 || (ya(n2.$$.fragment, e23), x2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), x2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), j2 = false, S2();
  } };
}
function ZF(e22) {
  return [Yo("simple-modal").close, Ix ? "\u2318" : "Ctrl"];
}
var XF = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, ZF, YF, Ki, {}, QF), r2;
  }
  return zi(n2);
}();
function eV(e22) {
  co(e22, "svelte-gz09vf", ".jse-json-repair-component.svelte-gz09vf.svelte-gz09vf{flex:1;display:flex;flex-direction:column;background:var(--jse-background-color);color:var(--jse-text-color)}.jse-json-repair-component.svelte-gz09vf .jse-menu .jse-info.svelte-gz09vf{padding:0 var(--jse-padding)}.jse-json-repair-component.svelte-gz09vf .jse-json-text.svelte-gz09vf{flex:1;border:none;padding:2px;font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono);background:var(--jse-background-color);color:var(--jse-text-color);resize:none;outline:none}");
}
function tV(e22) {
  var t2;
  return { c: function() {
    (t2 = go("div")).textContent = "Repair invalid JSON, then click apply", So(t2, "slot", "left"), So(t2, "class", "jse-info svelte-gz09vf");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, p: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function nV(e22) {
  var t2, n2;
  return t2 = new sS({ props: { type: "success", message: "JSON is valid now and can be parsed.", actions: e22[5] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    32 & n3 && (r2.actions = e23[5]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function rV(e22) {
  var t2, n2;
  return t2 = new sS({ props: { type: "error", icon: jj, message: "Cannot parse JSON: ".concat(e22[2].message), actions: e22[6] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    4 & n3 && (r2.message = "Cannot parse JSON: ".concat(e23[2].message)), 64 & n3 && (r2.actions = e23[6]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function iV(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2;
  n2 = new qS({ props: { items: e22[7], $$slots: { left: [tV] }, $$scope: { ctx: e22 } } });
  var f2 = [rV, nV], h2 = [];
  function d2(e23, t3) {
    return e23[2] ? 0 : 1;
  }
  return i2 = d2(e22), o2 = h2[i2] = f2[i2](e22), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), r2 = ko(), o2.c(), a2 = ko(), (s2 = go("textarea")).value = e22[0], s2.readOnly = e22[1], So(s2, "class", "jse-json-text svelte-gz09vf"), So(s2, "autocomplete", "off"), So(s2, "autocapitalize", "off"), So(s2, "spellcheck", "false"), So(t2, "class", "jse-json-repair-component svelte-gz09vf");
  }, m: function(o3, f3) {
    vo(o3, t2, f3), Ma(n2, t2, null), uo(t2, r2), h2[i2].m(t2, null), uo(t2, a2), uo(t2, s2), e22[19](s2), e22[20](t2), u2 = true, c2 || (l2 = xo(s2, "input", e22[8]), c2 = true);
  }, p: function(e23, r3) {
    var c3 = xi(r3, 1)[0], l3 = {};
    128 & c3 && (l3.items = e23[7]), 134217728 & c3 && (l3.$$scope = { dirty: c3, ctx: e23 }), n2.$set(l3);
    var v2 = i2;
    (i2 = d2(e23)) === v2 ? h2[i2].p(e23, c3) : (ma(), ba(h2[v2], 1, 1, function() {
      h2[v2] = null;
    }), ga(), (o2 = h2[i2]) ? o2.p(e23, c3) : (o2 = h2[i2] = f2[i2](e23)).c(), ya(o2, 1), o2.m(t2, a2)), (!u2 || 1 & c3) && (s2.value = e23[0]), (!u2 || 2 & c3) && (s2.readOnly = e23[1]);
  }, i: function(e23) {
    u2 || (ya(n2.$$.fragment, e23), ya(o2), u2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), ba(o2), u2 = false;
  }, d: function(r3) {
    r3 && po(t2), Ea(n2), h2[i2].d(), e22[19](null), e22[20](null), c2 = false, l2();
  } };
}
function oV(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2 = t2.text, v2 = d2 === void 0 ? "" : d2, p2 = t2.readOnly, m2 = p2 !== void 0 && p2, g2 = t2.onParse, y2 = t2.onRepair, b2 = t2.onChange, k2 = b2 === void 0 ? null : b2, w2 = t2.onApply, x2 = t2.onCancel, j2 = t2.onRenderMenu, S2 = j2 === void 0 ? Vu : j2, C2 = Ia("jsoneditor:JSONRepair");
  function _2() {
    w2(v2);
  }
  return e22.$$set = function(e23) {
    "text" in e23 && n2(0, v2 = e23.text), "readOnly" in e23 && n2(1, m2 = e23.readOnly), "onParse" in e23 && n2(9, g2 = e23.onParse), "onRepair" in e23 && n2(10, y2 = e23.onRepair), "onChange" in e23 && n2(11, k2 = e23.onChange), "onApply" in e23 && n2(12, w2 = e23.onApply), "onCancel" in e23 && n2(13, x2 = e23.onCancel), "onRenderMenu" in e23 && n2(14, S2 = e23.onRenderMenu);
  }, e22.$$.update = function() {
    1 & e22.$$.dirty && n2(2, r2 = function(e23) {
      try {
        return g2(e23), null;
      } catch (t3) {
        return Xw(e23, t3.message);
      }
    }(v2)), 1 & e22.$$.dirty && n2(17, i2 = function(e23) {
      try {
        return y2(e23), true;
      } catch (e24) {
        return false;
      }
    }(v2)), 4 & e22.$$.dirty && C2("error", r2), 8192 & e22.$$.dirty && n2(18, o2 = [{ space: true }, { icon: Cj, title: "Cancel repair", className: "jse-cancel", onClick: x2 }]), 278528 & e22.$$.dirty && n2(7, a2 = S2("repair", o2) || o2), 229376 & e22.$$.dirty && n2(6, c2 = i2 ? [s2, u2] : [s2]), 2 & e22.$$.dirty && n2(5, l2 = [{ icon: aj, text: "Apply", title: "Apply fixed JSON", disabled: m2, onClick: _2 }]);
  }, n2(15, s2 = { icon: ej, text: "Show me", title: "Scroll to the error location", onClick: function() {
    h2 && r2 && r2.position != null && (h2.setSelectionRange(r2.position, r2.position), setTimeout(function() {
      h2.focus();
    }));
  } }), n2(16, u2 = { icon: Sj, text: "Auto repair", title: "Automatically repair JSON", onClick: function() {
    try {
      n2(0, v2 = y2(v2)), k2 && k2(v2);
    } catch (e23) {
    }
  } }), [v2, m2, r2, f2, h2, l2, c2, a2, function(e23) {
    C2("handleChange");
    var t3 = e23.target.value;
    v2 !== t3 && (n2(0, v2 = t3), k2 && k2(v2));
  }, g2, y2, k2, w2, x2, S2, s2, u2, i2, o2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(4, h2 = e23);
    });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(3, f2 = e23);
    });
  }];
}
var aV = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, oV, iV, Ki, { text: 0, readOnly: 1, onParse: 9, onRepair: 10, onChange: 11, onApply: 12, onCancel: 13, onRenderMenu: 14 }, eV), r2;
  }
  return zi(n2);
}();
function sV(e22) {
  co(e22, "svelte-1ffm3pm", ".jse-modal.jse-repair.svelte-1ffm3pm{flex:1;display:flex;flex-direction:column;font-family:var(--jse-font-family);font-size:var(--jse-font-size);line-height:normal;background:var(--jse-background-color);color:var(--jse-text-color)}");
}
function uV(e22) {
  var t2, n2, r2, i2;
  function o2(t3) {
    e22[7](t3);
  }
  var a2 = { onParse: e22[1], onRepair: e22[2], onApply: e22[4], onCancel: e22[5], onRenderMenu: e22[3] };
  return e22[0] !== void 0 && (a2.text = e22[0]), n2 = new aV({ props: a2 }), Xo.push(function() {
    return Oa(n2, "text", o2);
  }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-modal jse-repair svelte-1ffm3pm");
  }, m: function(e23, r3) {
    vo(e23, t2, r3), Ma(n2, t2, null), i2 = true;
  }, p: function(e23, t3) {
    var i3 = xi(t3, 1)[0], o3 = {};
    2 & i3 && (o3.onParse = e23[1]), 4 & i3 && (o3.onRepair = e23[2]), 8 & i3 && (o3.onRenderMenu = e23[3]), !r2 && 1 & i3 && (r2 = true, o3.text = e23[0], sa(function() {
      return r2 = false;
    })), n2.$set(o3);
  }, i: function(e23) {
    i2 || (ya(n2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2);
  } };
}
function cV(e22, t2, n2) {
  var r2 = t2.text, i2 = t2.onParse, o2 = t2.onRepair, a2 = t2.onApply, s2 = t2.onRenderMenu, u2 = Yo("simple-modal").close;
  return e22.$$set = function(e23) {
    "text" in e23 && n2(0, r2 = e23.text), "onParse" in e23 && n2(1, i2 = e23.onParse), "onRepair" in e23 && n2(2, o2 = e23.onRepair), "onApply" in e23 && n2(6, a2 = e23.onApply), "onRenderMenu" in e23 && n2(3, s2 = e23.onRenderMenu);
  }, [r2, i2, o2, s2, function(e23) {
    u2(), a2(e23);
  }, function() {
    u2();
  }, a2, function(e23) {
    n2(0, r2 = e23);
  }];
}
var lV = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, cV, uV, Ki, { text: 0, onParse: 1, onRepair: 2, onApply: 6, onRenderMenu: 3 }, sV), r2;
  }
  return zi(n2);
}();
function fV(e22) {
  co(e22, "svelte-mojfmz", ".jse-dropdown-button.svelte-mojfmz.svelte-mojfmz{flex:1;line-height:normal;border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;position:relative;padding:0;display:flex}.jse-dropdown-button.svelte-mojfmz ul.svelte-mojfmz{margin:0;padding:0}.jse-dropdown-button.svelte-mojfmz ul li.svelte-mojfmz{margin:0;padding:0;list-style-type:none}.jse-dropdown-button.svelte-mojfmz button.jse-open-dropdown.svelte-mojfmz{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;width:2em;background:var(--jse-context-menu-background);color:var(--jse-context-menu-color);border-radius:0}.jse-dropdown-button.svelte-mojfmz button.jse-open-dropdown.jse-visible.svelte-mojfmz{background:var(--jse-context-menu-background)}.jse-dropdown-button.svelte-mojfmz button.jse-open-dropdown.svelte-mojfmz:hover{background:var(--jse-context-menu-background-highlight)}.jse-dropdown-button.svelte-mojfmz button.jse-open-dropdown.svelte-mojfmz:disabled{color:var(--jse-context-menu-color-disabled);background:unset}.jse-dropdown-button.svelte-mojfmz .jse-dropdown-items.svelte-mojfmz{display:none;position:absolute;top:100%;left:0;z-index:1;background:var(--jse-context-menu-background);color:var(--jse-context-menu-color);box-shadow:var(--jse-controls-box-shadow)}.jse-dropdown-button.svelte-mojfmz .jse-dropdown-items.jse-visible.svelte-mojfmz{display:block}.jse-dropdown-button.svelte-mojfmz .jse-dropdown-items button.svelte-mojfmz{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;width:100%;text-align:left;padding:var(--jse-padding);margin:0}.jse-dropdown-button.svelte-mojfmz .jse-dropdown-items button.svelte-mojfmz:hover{background:var(--jse-context-menu-background-highlight)}.jse-dropdown-button.svelte-mojfmz .jse-dropdown-items button.svelte-mojfmz:disabled{color:var(--jse-context-menu-color-disabled);background:unset}");
}
function hV(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[11] = t2[n2], r2;
}
var dV = function(e22) {
  return {};
}, vV = function(e22) {
  return {};
};
function pV(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: e22[11].icon } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    1 & n3 && (r2.data = e23[11].icon), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function mV(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2 = e22[11].text + "", h2 = e22[11].icon && pV(e22);
  function d2() {
    return e22[9](e22[11]);
  }
  return { c: function() {
    t2 = go("li"), n2 = go("button"), h2 && h2.c(), r2 = ko(), i2 = bo(f2), s2 = ko(), So(n2, "type", "button"), So(n2, "title", o2 = e22[11].title), n2.disabled = a2 = e22[11].disabled, So(n2, "class", "svelte-mojfmz"), So(t2, "class", "svelte-mojfmz");
  }, m: function(e23, o3) {
    vo(e23, t2, o3), uo(t2, n2), h2 && h2.m(n2, null), uo(n2, r2), uo(n2, i2), uo(t2, s2), u2 = true, c2 || (l2 = xo(n2, "click", d2), c2 = true);
  }, p: function(t3, s3) {
    (e22 = t3)[11].icon ? h2 ? (h2.p(e22, s3), 1 & s3 && ya(h2, 1)) : ((h2 = pV(e22)).c(), ya(h2, 1), h2.m(n2, r2)) : h2 && (ma(), ba(h2, 1, 1, function() {
      h2 = null;
    }), ga()), (!u2 || 1 & s3) && f2 !== (f2 = e22[11].text + "") && Ao(i2, f2), (!u2 || 1 & s3 && o2 !== (o2 = e22[11].title)) && So(n2, "title", o2), (!u2 || 1 & s3 && a2 !== (a2 = e22[11].disabled)) && (n2.disabled = a2);
  }, i: function(e23) {
    u2 || (ya(h2), u2 = true);
  }, o: function(e23) {
    ba(h2), u2 = false;
  }, d: function(e23) {
    e23 && po(t2), h2 && h2.d(), c2 = false, l2();
  } };
}
function gV(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2 = e22[8].defaultItem, h2 = Gi(f2, e22, e22[7], vV);
  i2 = new Xj({ props: { data: ij } });
  for (var d2 = e22[0], v2 = [], p2 = 0; p2 < d2.length; p2 += 1)
    v2[p2] = mV(hV(e22, d2, p2));
  var m2 = function(e23) {
    return ba(v2[e23], 1, 1, function() {
      v2[e23] = null;
    });
  };
  return { c: function() {
    t2 = go("div"), h2 && h2.c(), n2 = ko(), r2 = go("button"), Aa(i2.$$.fragment), o2 = ko(), a2 = go("div"), s2 = go("ul");
    for (var u3 = 0; u3 < v2.length; u3 += 1)
      v2[u3].c();
    So(r2, "type", "button"), So(r2, "class", "jse-open-dropdown svelte-mojfmz"), So(r2, "data-type", "jse-open-dropdown"), r2.disabled = e22[4], To(r2, "jse-visible", e22[3]), So(s2, "class", "svelte-mojfmz"), So(a2, "class", "jse-dropdown-items svelte-mojfmz"), Eo(a2, "width", e22[2]), To(a2, "jse-visible", e22[3]), So(t2, "class", "jse-dropdown-button svelte-mojfmz"), So(t2, "title", e22[1]);
  }, m: function(f3, d3) {
    vo(f3, t2, d3), h2 && h2.m(t2, null), uo(t2, n2), uo(t2, r2), Ma(i2, r2, null), uo(t2, o2), uo(t2, a2), uo(a2, s2);
    for (var p3 = 0; p3 < v2.length; p3 += 1)
      v2[p3].m(s2, null);
    u2 = true, c2 || (l2 = [xo(r2, "click", e22[5]), xo(t2, "click", e22[6])], c2 = true);
  }, p: function(e23, n3) {
    var i3 = xi(n3, 1)[0];
    if (h2 && h2.p && (!u2 || 128 & i3) && Zi(h2, f2, e23, e23[7], u2 ? Yi(f2, e23[7], i3, dV) : Xi(e23[7]), vV), (!u2 || 16 & i3) && (r2.disabled = e23[4]), 8 & i3 && To(r2, "jse-visible", e23[3]), 1 & i3) {
      var o3;
      for (d2 = e23[0], o3 = 0; o3 < d2.length; o3 += 1) {
        var c3 = hV(e23, d2, o3);
        v2[o3] ? (v2[o3].p(c3, i3), ya(v2[o3], 1)) : (v2[o3] = mV(c3), v2[o3].c(), ya(v2[o3], 1), v2[o3].m(s2, null));
      }
      for (ma(), o3 = d2.length; o3 < v2.length; o3 += 1)
        m2(o3);
      ga();
    }
    (!u2 || 4 & i3) && Eo(a2, "width", e23[2]), 8 & i3 && To(a2, "jse-visible", e23[3]), (!u2 || 2 & i3) && So(t2, "title", e23[1]);
  }, i: function(e23) {
    if (!u2) {
      ya(h2, e23), ya(i2.$$.fragment, e23);
      for (var t3 = 0; t3 < d2.length; t3 += 1)
        ya(v2[t3]);
      u2 = true;
    }
  }, o: function(e23) {
    ba(h2, e23), ba(i2.$$.fragment, e23), v2 = v2.filter(Boolean);
    for (var t3 = 0; t3 < v2.length; t3 += 1)
      ba(v2[t3]);
    u2 = false;
  }, d: function(e23) {
    e23 && po(t2), h2 && h2.d(e23), Ea(i2), mo(v2, e23), c2 = false, Wi(l2);
  } };
}
function yV(e22, t2, n2) {
  var r2, i2 = t2.$$slots, o2 = i2 === void 0 ? {} : i2, a2 = t2.$$scope, s2 = t2.items, u2 = s2 === void 0 ? [] : s2, c2 = t2.title, l2 = c2 === void 0 ? void 0 : c2, f2 = t2.width, h2 = f2 === void 0 ? "120px" : f2, d2 = false;
  function v2() {
    n2(3, d2 = false);
  }
  function p2(e23) {
    Rx(e23) === "Escape" && (e23.preventDefault(), n2(3, d2 = false));
  }
  Uo(function() {
    document.addEventListener("click", v2), document.addEventListener("keydown", p2);
  }), Ko(function() {
    document.removeEventListener("click", v2), document.removeEventListener("keydown", p2);
  });
  return e22.$$set = function(e23) {
    "items" in e23 && n2(0, u2 = e23.items), "title" in e23 && n2(1, l2 = e23.title), "width" in e23 && n2(2, h2 = e23.width), "$$scope" in e23 && n2(7, a2 = e23.$$scope);
  }, e22.$$.update = function() {
    1 & e22.$$.dirty && n2(4, r2 = u2.every(function(e23) {
      return e23.disabled === true;
    }));
  }, [u2, l2, h2, d2, r2, function() {
    var e23 = d2;
    setTimeout(function() {
      return n2(3, d2 = !e23);
    });
  }, v2, a2, o2, function(e23) {
    return e23.onClick();
  }];
}
var bV = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, yV, gV, Ki, { items: 0, title: 1, width: 2 }, fV), r2;
  }
  return zi(n2);
}(), kV = { prefix: "far", iconName: "clock", icon: [512, 512, [128339, "clock-four"], "f017", "M232 120C232 106.7 242.7 96 256 96C269.3 96 280 106.7 280 120V243.2L365.3 300C376.3 307.4 379.3 322.3 371.1 333.3C364.6 344.3 349.7 347.3 338.7 339.1L242.7 275.1C236 271.5 232 264 232 255.1L232 120zM256 0C397.4 0 512 114.6 512 256C512 397.4 397.4 512 256 512C114.6 512 0 397.4 0 256C0 114.6 114.6 0 256 0zM48 256C48 370.9 141.1 464 256 464C370.9 464 464 370.9 464 256C464 141.1 370.9 48 256 48C141.1 48 48 141.1 48 256z"] }, wV = { prefix: "far", iconName: "lightbulb", icon: [384, 512, [128161], "f0eb", "M112.1 454.3c0 6.297 1.816 12.44 5.284 17.69l17.14 25.69c5.25 7.875 17.17 14.28 26.64 14.28h61.67c9.438 0 21.36-6.401 26.61-14.28l17.08-25.68c2.938-4.438 5.348-12.37 5.348-17.7L272 415.1h-160L112.1 454.3zM192 0C90.02 .3203 16 82.97 16 175.1c0 44.38 16.44 84.84 43.56 115.8c16.53 18.84 42.34 58.23 52.22 91.45c.0313 .25 .0938 .5166 .125 .7823h160.2c.0313-.2656 .0938-.5166 .125-.7823c9.875-33.22 35.69-72.61 52.22-91.45C351.6 260.8 368 220.4 368 175.1C368 78.8 289.2 .0039 192 0zM288.4 260.1c-15.66 17.85-35.04 46.3-49.05 75.89h-94.61c-14.01-29.59-33.39-58.04-49.04-75.88C75.24 236.8 64 206.1 64 175.1C64 113.3 112.1 48.25 191.1 48C262.6 48 320 105.4 320 175.1C320 206.1 308.8 236.8 288.4 260.1zM176 80C131.9 80 96 115.9 96 160c0 8.844 7.156 16 16 16S128 168.8 128 160c0-26.47 21.53-48 48-48c8.844 0 16-7.148 16-15.99S184.8 80 176 80z"] }, xV = { prefix: "far", iconName: "square", icon: [448, 512, [9723, 9724, 61590, 9632], "f0c8", "M384 32C419.3 32 448 60.65 448 96V416C448 451.3 419.3 480 384 480H64C28.65 480 0 451.3 0 416V96C0 60.65 28.65 32 64 32H384zM384 80H64C55.16 80 48 87.16 48 96V416C48 424.8 55.16 432 64 432H384C392.8 432 400 424.8 400 416V96C400 87.16 392.8 80 384 80z"] }, jV = { prefix: "far", iconName: "square-check", icon: [448, 512, [9989, 61510, 9745, "check-square"], "f14a", "M211.8 339.8C200.9 350.7 183.1 350.7 172.2 339.8L108.2 275.8C97.27 264.9 97.27 247.1 108.2 236.2C119.1 225.3 136.9 225.3 147.8 236.2L192 280.4L300.2 172.2C311.1 161.3 328.9 161.3 339.8 172.2C350.7 183.1 350.7 200.9 339.8 211.8L211.8 339.8zM0 96C0 60.65 28.65 32 64 32H384C419.3 32 448 60.65 448 96V416C448 451.3 419.3 480 384 480H64C28.65 480 0 451.3 0 416V96zM48 96V416C48 424.8 55.16 432 64 432H384C392.8 432 400 424.8 400 416V96C400 87.16 392.8 80 384 80H64C55.16 80 48 87.16 48 96z"] };
/*!
 * Font Awesome Free 6.1.1 by @fontawesome - https://fontawesome.com
 * License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License)
 * Copyright 2022 Fonticons, Inc.
 */
function SV(e22) {
  co(e22, "svelte-1yai37q", ".jse-contextmenu.svelte-1yai37q.svelte-1yai37q{box-shadow:var(--jse-controls-box-shadow);font-family:var(--jse-font-family);font-size:var(--jse-font-size);background:var(--jse-context-menu-background);color:var(--jse-context-menu-color)}.jse-contextmenu.svelte-1yai37q button.svelte-1yai37q{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0}.jse-contextmenu.svelte-1yai37q button.svelte-1yai37q:focus{background:var(--jse-context-menu-background-highlight)}.jse-contextmenu.svelte-1yai37q .jse-row.svelte-1yai37q{display:flex;flex-direction:row;align-items:flex-start;justify-content:stretch}.jse-contextmenu.svelte-1yai37q .jse-row div.jse-label.svelte-1yai37q{flex:1;white-space:nowrap;padding:var(--jse-padding);color:var(--jse-context-menu-color-disabled);line-height:normal}.jse-contextmenu.svelte-1yai37q .jse-row div.jse-tip.svelte-1yai37q{flex:1;background:var(--jse-context-menu-tip-background);color:var(--jse-context-menu-tip-color);margin:calc(0.5 * var(--jse-padding));padding:calc(0.5 * var(--jse-padding)) var(--jse-padding);font-size:80%;line-height:1.3em;display:flex;flex-direction:row;align-items:center;gap:var(--jse-padding);border-radius:3px}.jse-contextmenu.svelte-1yai37q .jse-row div.jse-tip div.svelte-1yai37q{vertical-align:middle}.jse-contextmenu.svelte-1yai37q .jse-row button.svelte-1yai37q{flex:1;white-space:nowrap;padding:var(--jse-padding);color:inherit}.jse-contextmenu.svelte-1yai37q .jse-row button.svelte-1yai37q:hover{background:var(--jse-context-menu-background-highlight)}.jse-contextmenu.svelte-1yai37q .jse-row button.svelte-1yai37q:disabled{color:var(--jse-context-menu-color-disabled);background:unset}.jse-contextmenu.svelte-1yai37q .jse-row button .jse-insert.svelte-1yai37q{display:inline-block;position:relative;width:18px;height:18px;font-family:var(--jse-font-family-mono);font-weight:bold;font-size:16px}.jse-contextmenu.svelte-1yai37q .jse-row button .jse-insert .jse-quote.svelte-1yai37q,.jse-contextmenu.svelte-1yai37q .jse-row button .jse-insert .jse-plus.svelte-1yai37q{position:absolute;top:-4px;left:2px;font-size:24px}.jse-contextmenu.svelte-1yai37q .jse-column.svelte-1yai37q{flex:1;display:flex;flex-direction:column;align-items:stretch}.jse-contextmenu.svelte-1yai37q .jse-column.svelte-1yai37q:not(:last-child){border-right:1px solid var(--jse-context-menu-separator-color)}.jse-contextmenu.svelte-1yai37q .jse-column button.svelte-1yai37q{text-align:left;min-width:130px}.jse-contextmenu.svelte-1yai37q .jse-separator.svelte-1yai37q{width:100%;height:1px;background:var(--jse-context-menu-separator-color)}");
}
function CV(e22) {
  var t2, n2, r2, i2, o2, a2, s2;
  return n2 = new Xj({ props: { data: bj } }), { c: function() {
    t2 = go("button"), Aa(n2.$$.fragment), r2 = bo(" Edit value"), So(t2, "type", "button"), So(t2, "slot", "defaultItem"), So(t2, "title", "Edit the value (Double-click on the value)"), t2.disabled = i2 = !e22[2], So(t2, "class", "svelte-1yai37q");
  }, m: function(i3, u2) {
    vo(i3, t2, u2), Ma(n2, t2, null), uo(t2, r2), o2 = true, a2 || (s2 = xo(t2, "click", e22[18]), a2 = true);
  }, p: function(e23, n3) {
    (!o2 || 4 & n3[0] && i2 !== (i2 = !e23[2])) && (t2.disabled = i2);
  }, i: function(e23) {
    o2 || (ya(n2.$$.fragment, e23), o2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), o2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), a2 = false, s2();
  } };
}
function _V(e22) {
  var t2, n2, r2, i2, o2, a2, s2;
  return n2 = new Xj({ props: { data: kj } }), { c: function() {
    t2 = go("button"), Aa(n2.$$.fragment), r2 = bo(" Cut"), So(t2, "type", "button"), So(t2, "slot", "defaultItem"), So(t2, "title", "Cut selected contents, formatted with indentation (Ctrl+X)"), t2.disabled = i2 = !e22[1], So(t2, "class", "svelte-1yai37q");
  }, m: function(i3, u2) {
    vo(i3, t2, u2), Ma(n2, t2, null), uo(t2, r2), o2 = true, a2 || (s2 = xo(t2, "click", e22[19]), a2 = true);
  }, p: function(e23, n3) {
    (!o2 || 2 & n3[0] && i2 !== (i2 = !e23[1])) && (t2.disabled = i2);
  }, i: function(e23) {
    o2 || (ya(n2.$$.fragment, e23), o2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), o2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), a2 = false, s2();
  } };
}
function $V(e22) {
  var t2, n2, r2, i2, o2, a2, s2;
  return n2 = new Xj({ props: { data: hj } }), { c: function() {
    t2 = go("button"), Aa(n2.$$.fragment), r2 = bo(" Copy"), So(t2, "type", "button"), So(t2, "slot", "defaultItem"), So(t2, "title", "Copy selected contents, formatted with indentation (Ctrl+C)"), t2.disabled = i2 = !e22[1], So(t2, "class", "svelte-1yai37q");
  }, m: function(i3, u2) {
    vo(i3, t2, u2), Ma(n2, t2, null), uo(t2, r2), o2 = true, a2 || (s2 = xo(t2, "click", e22[20]), a2 = true);
  }, p: function(e23, n3) {
    (!o2 || 2 & n3[0] && i2 !== (i2 = !e23[1])) && (t2.disabled = i2);
  }, i: function(e23) {
    o2 || (ya(n2.$$.fragment, e23), o2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), o2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), a2 = false, s2();
  } };
}
function OV(e22) {
  var t2, n2, r2, i2, o2, a2, s2;
  return i2 = new Xj({ props: { data: wV } }), { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = go("div"), Aa(i2.$$.fragment), o2 = ko(), (a2 = go("div")).textContent = "Tip: you can open this context menu via right-click or with Ctrl+Q", So(r2, "class", "svelte-1yai37q"), So(a2, "class", "svelte-1yai37q"), So(n2, "class", "jse-tip svelte-1yai37q"), So(t2, "class", "jse-row svelte-1yai37q");
  }, m: function(e23, u2) {
    vo(e23, t2, u2), uo(t2, n2), uo(n2, r2), Ma(i2, r2, null), uo(n2, o2), uo(n2, a2), s2 = true;
  }, p: Bi, i: function(e23) {
    s2 || (ya(i2.$$.fragment, e23), s2 = true);
  }, o: function(e23) {
    ba(i2.$$.fragment, e23), s2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(i2);
  } };
}
function AV(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2, k2, w2, x2, j2, S2, C2, _2, $2, O2, A2, M2, E2, P2, N2, T2, I2, R2, D2, z2, L2, B2, q2, F2, V2, H2, W2, J2, U2, K2, G2, Q2, Y2, Z2, X2, ee2, te2, ne2, re2, ie2, oe2, ae2, se2, ue2, ce2, le2, fe2, he2, de2, ve2, pe2, me2, ge2, ye2, be2, ke2, we2, xe2, je2, Se2, Ce2, _e2, $e2, Oe2, Ae2, Me2, Ee2, Pe2, Ne2, Te2, Ie2, Re2, De2, ze2, Le2, Be2, qe2, Fe2;
  i2 = new Xj({ props: { data: bj } }), u2 = new bV({ props: { width: "11em", items: e22[8], $$slots: { defaultItem: [CV] }, $$scope: { ctx: e22 } } }), d2 = new bV({ props: { width: "10em", items: e22[7], $$slots: { defaultItem: [_V] }, $$scope: { ctx: e22 } } }), p2 = new bV({ props: { width: "12em", items: e22[6], $$slots: { defaultItem: [$V] }, $$scope: { ctx: e22 } } }), y2 = new Xj({ props: { data: yj } }), $2 = new Xj({ props: { data: Cj } }), P2 = new Xj({ props: { data: lj } }), D2 = new Xj({ props: { data: dj } }), F2 = new Xj({ props: { data: tj } }), U2 = new Xj({ props: { data: pj } }), Ee2 = new Xj({ props: { data: xj } }), Re2 = new Xj({ props: { data: wj } });
  var Ve2 = e22[0] && OV();
  return { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = go("button"), Aa(i2.$$.fragment), o2 = bo(" Edit key"), s2 = ko(), Aa(u2.$$.fragment), c2 = ko(), l2 = go("div"), f2 = ko(), h2 = go("div"), Aa(d2.$$.fragment), v2 = ko(), Aa(p2.$$.fragment), m2 = ko(), g2 = go("button"), Aa(y2.$$.fragment), b2 = bo(" Paste"), w2 = ko(), x2 = go("div"), j2 = ko(), S2 = go("div"), C2 = go("div"), _2 = go("button"), Aa($2.$$.fragment), O2 = bo(" Remove"), M2 = ko(), E2 = go("button"), Aa(P2.$$.fragment), N2 = bo(" Duplicate"), I2 = ko(), R2 = go("button"), Aa(D2.$$.fragment), z2 = bo(" Extract"), B2 = ko(), q2 = go("button"), Aa(F2.$$.fragment), V2 = bo(" Sort"), W2 = ko(), J2 = go("button"), Aa(U2.$$.fragment), K2 = bo(" Transform"), Q2 = ko(), Y2 = go("div"), Z2 = go("div"), X2 = bo(e22[13]), ee2 = bo(":"), te2 = ko(), ne2 = go("button"), re2 = go("span"), (ie2 = go("span")).textContent = "+", oe2 = bo(" Structure"), ue2 = ko(), ce2 = go("button"), (le2 = go("span")).textContent = "{}", fe2 = bo(" Object"), ve2 = ko(), pe2 = go("button"), (me2 = go("span")).textContent = "[]", ge2 = bo(" Array"), ke2 = ko(), we2 = go("button"), (xe2 = go("span")).innerHTML = '<span class="jse-quote svelte-1yai37q">&quot;</span>', je2 = bo(" Value"), _e2 = ko(), $e2 = go("div"), Oe2 = ko(), Ae2 = go("div"), Me2 = go("button"), Aa(Ee2.$$.fragment), Pe2 = bo(" Insert before"), Te2 = ko(), Ie2 = go("button"), Aa(Re2.$$.fragment), De2 = bo(" Insert after"), Le2 = ko(), Ve2 && Ve2.c(), So(r2, "type", "button"), So(r2, "title", "Edit the key (Double-click on the key)"), r2.disabled = a2 = !e22[14], So(r2, "class", "svelte-1yai37q"), So(n2, "class", "jse-row svelte-1yai37q"), So(l2, "class", "jse-separator svelte-1yai37q"), So(g2, "type", "button"), So(g2, "title", "Paste clipboard contents (Ctrl+V)"), g2.disabled = k2 = !e22[3], So(g2, "class", "svelte-1yai37q"), So(h2, "class", "jse-row svelte-1yai37q"), So(x2, "class", "jse-separator svelte-1yai37q"), So(_2, "type", "button"), So(_2, "title", "Remove selected contents (Delete)"), _2.disabled = A2 = !e22[1], So(_2, "class", "svelte-1yai37q"), So(E2, "type", "button"), So(E2, "title", "Duplicate selected contents (Ctrl+D)"), E2.disabled = T2 = !e22[16], So(E2, "class", "svelte-1yai37q"), So(R2, "type", "button"), So(R2, "title", "Extract selected contents"), R2.disabled = L2 = !e22[15], So(R2, "class", "svelte-1yai37q"), So(q2, "type", "button"), So(q2, "title", "Sort array or object contents"), q2.disabled = H2 = !e22[1], So(q2, "class", "svelte-1yai37q"), So(J2, "type", "button"), So(J2, "title", "Transform array or object contents (filter, sort, project)"), J2.disabled = G2 = !e22[1], So(J2, "class", "svelte-1yai37q"), So(C2, "class", "jse-column svelte-1yai37q"), So(Z2, "class", "jse-label svelte-1yai37q"), So(ie2, "class", "jse-plus svelte-1yai37q"), So(re2, "class", "jse-insert svelte-1yai37q"), So(ne2, "type", "button"), So(ne2, "title", ae2 = e22[13] + " structure"), ne2.disabled = se2 = !e22[12], So(ne2, "class", "svelte-1yai37q"), So(le2, "class", "jse-insert svelte-1yai37q"), So(ce2, "type", "button"), So(ce2, "title", he2 = e22[13] + " object"), ce2.disabled = de2 = !e22[11], So(ce2, "class", "svelte-1yai37q"), So(me2, "class", "jse-insert svelte-1yai37q"), So(pe2, "type", "button"), So(pe2, "title", ye2 = e22[13] + " array"), pe2.disabled = be2 = !e22[10], So(pe2, "class", "svelte-1yai37q"), So(xe2, "class", "jse-insert svelte-1yai37q"), So(we2, "type", "button"), So(we2, "title", Se2 = e22[13] + " value"), we2.disabled = Ce2 = !e22[9], So(we2, "class", "svelte-1yai37q"), So(Y2, "class", "jse-column svelte-1yai37q"), So(S2, "class", "jse-row svelte-1yai37q"), So($e2, "class", "jse-separator svelte-1yai37q"), So(Me2, "type", "button"), So(Me2, "title", "Select area before current entry to insert or paste contents"), Me2.disabled = Ne2 = !e22[1] || e22[4], So(Me2, "class", "svelte-1yai37q"), So(Ie2, "type", "button"), So(Ie2, "title", "Select area after current entry to insert or paste contents"), Ie2.disabled = ze2 = !e22[1] || e22[4], So(Ie2, "class", "svelte-1yai37q"), So(Ae2, "class", "jse-row svelte-1yai37q"), So(t2, "class", "jse-contextmenu svelte-1yai37q");
  }, m: function(a3, k3) {
    vo(a3, t2, k3), uo(t2, n2), uo(n2, r2), Ma(i2, r2, null), uo(r2, o2), uo(n2, s2), Ma(u2, n2, null), uo(t2, c2), uo(t2, l2), uo(t2, f2), uo(t2, h2), Ma(d2, h2, null), uo(h2, v2), Ma(p2, h2, null), uo(h2, m2), uo(h2, g2), Ma(y2, g2, null), uo(g2, b2), uo(t2, w2), uo(t2, x2), uo(t2, j2), uo(t2, S2), uo(S2, C2), uo(C2, _2), Ma($2, _2, null), uo(_2, O2), uo(C2, M2), uo(C2, E2), Ma(P2, E2, null), uo(E2, N2), uo(C2, I2), uo(C2, R2), Ma(D2, R2, null), uo(R2, z2), uo(C2, B2), uo(C2, q2), Ma(F2, q2, null), uo(q2, V2), uo(C2, W2), uo(C2, J2), Ma(U2, J2, null), uo(J2, K2), uo(S2, Q2), uo(S2, Y2), uo(Y2, Z2), uo(Z2, X2), uo(Z2, ee2), uo(Y2, te2), uo(Y2, ne2), uo(ne2, re2), uo(re2, ie2), uo(ne2, oe2), uo(Y2, ue2), uo(Y2, ce2), uo(ce2, le2), uo(ce2, fe2), uo(Y2, ve2), uo(Y2, pe2), uo(pe2, me2), uo(pe2, ge2), uo(Y2, ke2), uo(Y2, we2), uo(we2, xe2), uo(we2, je2), uo(t2, _e2), uo(t2, $e2), uo(t2, Oe2), uo(t2, Ae2), uo(Ae2, Me2), Ma(Ee2, Me2, null), uo(Me2, Pe2), uo(Ae2, Te2), uo(Ae2, Ie2), Ma(Re2, Ie2, null), uo(Ie2, De2), uo(t2, Le2), Ve2 && Ve2.m(t2, null), e22[58](t2), Be2 = true, qe2 || (Fe2 = [xo(r2, "click", e22[17]), xo(g2, "click", e22[21]), xo(_2, "click", e22[22]), xo(E2, "click", e22[23]), xo(R2, "click", e22[24]), xo(q2, "click", e22[26]), xo(J2, "click", e22[27]), xo(ne2, "click", e22[54]), xo(ce2, "click", e22[55]), xo(pe2, "click", e22[56]), xo(we2, "click", e22[57]), xo(Me2, "click", e22[28]), xo(Ie2, "click", e22[29]), xo(t2, "keydown", e22[30])], qe2 = true);
  }, p: function(e23, n3) {
    (!Be2 || 16384 & n3[0] && a2 !== (a2 = !e23[14])) && (r2.disabled = a2);
    var i3 = {};
    256 & n3[0] && (i3.items = e23[8]), 4 & n3[0] | 1 & n3[2] && (i3.$$scope = { dirty: n3, ctx: e23 }), u2.$set(i3);
    var o3 = {};
    128 & n3[0] && (o3.items = e23[7]), 2 & n3[0] | 1 & n3[2] && (o3.$$scope = { dirty: n3, ctx: e23 }), d2.$set(o3);
    var s3 = {};
    64 & n3[0] && (s3.items = e23[6]), 2 & n3[0] | 1 & n3[2] && (s3.$$scope = { dirty: n3, ctx: e23 }), p2.$set(s3), (!Be2 || 8 & n3[0] && k2 !== (k2 = !e23[3])) && (g2.disabled = k2), (!Be2 || 2 & n3[0] && A2 !== (A2 = !e23[1])) && (_2.disabled = A2), (!Be2 || 65536 & n3[0] && T2 !== (T2 = !e23[16])) && (E2.disabled = T2), (!Be2 || 32768 & n3[0] && L2 !== (L2 = !e23[15])) && (R2.disabled = L2), (!Be2 || 2 & n3[0] && H2 !== (H2 = !e23[1])) && (q2.disabled = H2), (!Be2 || 2 & n3[0] && G2 !== (G2 = !e23[1])) && (J2.disabled = G2), (!Be2 || 8192 & n3[0]) && Ao(X2, e23[13]), (!Be2 || 8192 & n3[0] && ae2 !== (ae2 = e23[13] + " structure")) && So(ne2, "title", ae2), (!Be2 || 4096 & n3[0] && se2 !== (se2 = !e23[12])) && (ne2.disabled = se2), (!Be2 || 8192 & n3[0] && he2 !== (he2 = e23[13] + " object")) && So(ce2, "title", he2), (!Be2 || 2048 & n3[0] && de2 !== (de2 = !e23[11])) && (ce2.disabled = de2), (!Be2 || 8192 & n3[0] && ye2 !== (ye2 = e23[13] + " array")) && So(pe2, "title", ye2), (!Be2 || 1024 & n3[0] && be2 !== (be2 = !e23[10])) && (pe2.disabled = be2), (!Be2 || 8192 & n3[0] && Se2 !== (Se2 = e23[13] + " value")) && So(we2, "title", Se2), (!Be2 || 512 & n3[0] && Ce2 !== (Ce2 = !e23[9])) && (we2.disabled = Ce2), (!Be2 || 18 & n3[0] && Ne2 !== (Ne2 = !e23[1] || e23[4])) && (Me2.disabled = Ne2), (!Be2 || 18 & n3[0] && ze2 !== (ze2 = !e23[1] || e23[4])) && (Ie2.disabled = ze2), e23[0] ? Ve2 ? (Ve2.p(e23, n3), 1 & n3[0] && ya(Ve2, 1)) : ((Ve2 = OV()).c(), ya(Ve2, 1), Ve2.m(t2, null)) : Ve2 && (ma(), ba(Ve2, 1, 1, function() {
      Ve2 = null;
    }), ga());
  }, i: function(e23) {
    Be2 || (ya(i2.$$.fragment, e23), ya(u2.$$.fragment, e23), ya(d2.$$.fragment, e23), ya(p2.$$.fragment, e23), ya(y2.$$.fragment, e23), ya($2.$$.fragment, e23), ya(P2.$$.fragment, e23), ya(D2.$$.fragment, e23), ya(F2.$$.fragment, e23), ya(U2.$$.fragment, e23), ya(Ee2.$$.fragment, e23), ya(Re2.$$.fragment, e23), ya(Ve2), Be2 = true);
  }, o: function(e23) {
    ba(i2.$$.fragment, e23), ba(u2.$$.fragment, e23), ba(d2.$$.fragment, e23), ba(p2.$$.fragment, e23), ba(y2.$$.fragment, e23), ba($2.$$.fragment, e23), ba(P2.$$.fragment, e23), ba(D2.$$.fragment, e23), ba(F2.$$.fragment, e23), ba(U2.$$.fragment, e23), ba(Ee2.$$.fragment, e23), ba(Re2.$$.fragment, e23), ba(Ve2), Be2 = false;
  }, d: function(n3) {
    n3 && po(t2), Ea(i2), Ea(u2), Ea(d2), Ea(p2), Ea(y2), Ea($2), Ea(P2), Ea(D2), Ea(F2), Ea(U2), Ea(Ee2), Ea(Re2), Ve2 && Ve2.d(), e22[58](null), qe2 = false, Wi(Fe2);
  } };
}
function MV(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2, k2, w2, x2, j2, S2 = t2.json, C2 = t2.documentState, _2 = t2.showTip, $2 = t2.onCloseContextMenu, O2 = t2.onEditKey, A2 = t2.onEditValue, M2 = t2.onToggleEnforceString, E2 = t2.onCut, P2 = t2.onCopy, N2 = t2.onPaste, T2 = t2.onRemove, I2 = t2.onDuplicate, R2 = t2.onExtract, D2 = t2.onInsertBefore, z2 = t2.onInsert, L2 = t2.onConvert, B2 = t2.onInsertAfter, q2 = t2.onSort, F2 = t2.onTransform;
  function V2() {
    $2(), A2();
  }
  function H2() {
    $2(), M2();
  }
  function W2() {
    $2(), E2(true);
  }
  function J2() {
    $2(), E2(false);
  }
  function U2() {
    $2(), P2(true);
  }
  function K2() {
    $2(), P2(false);
  }
  function G2(e23) {
    $2(), u2 ? L2(e23) : z2(e23);
  }
  Uo(function() {
    setTimeout(function() {
      var e23 = Ni(j2.querySelectorAll("button")).find(function(e24) {
        return !e24.disabled;
      });
      e23 && e23.focus();
    });
  });
  return e22.$$set = function(e23) {
    "json" in e23 && n2(31, S2 = e23.json), "documentState" in e23 && n2(32, C2 = e23.documentState), "showTip" in e23 && n2(0, _2 = e23.showTip), "onCloseContextMenu" in e23 && n2(33, $2 = e23.onCloseContextMenu), "onEditKey" in e23 && n2(34, O2 = e23.onEditKey), "onEditValue" in e23 && n2(35, A2 = e23.onEditValue), "onToggleEnforceString" in e23 && n2(36, M2 = e23.onToggleEnforceString), "onCut" in e23 && n2(37, E2 = e23.onCut), "onCopy" in e23 && n2(38, P2 = e23.onCopy), "onPaste" in e23 && n2(39, N2 = e23.onPaste), "onRemove" in e23 && n2(40, T2 = e23.onRemove), "onDuplicate" in e23 && n2(41, I2 = e23.onDuplicate), "onExtract" in e23 && n2(42, R2 = e23.onExtract), "onInsertBefore" in e23 && n2(43, D2 = e23.onInsertBefore), "onInsert" in e23 && n2(44, z2 = e23.onInsert), "onConvert" in e23 && n2(45, L2 = e23.onConvert), "onInsertAfter" in e23 && n2(46, B2 = e23.onInsertAfter), "onSort" in e23 && n2(47, q2 = e23.onSort), "onTransform" in e23 && n2(48, F2 = e23.onTransform);
  }, e22.$$.update = function() {
    2 & e22.$$.dirty[1] && n2(50, r2 = C2.selection), 1 & e22.$$.dirty[1] && n2(53, i2 = S2 !== void 0), 524288 & e22.$$.dirty[1] && n2(3, o2 = r2 != null), 8 & e22.$$.dirty[0] | 524288 & e22.$$.dirty[1] && n2(4, a2 = o2 && km(r2.focusPath)), 8 & e22.$$.dirty[0] | 524289 & e22.$$.dirty[1] && n2(51, s2 = o2 ? cs.exports.getIn(S2, r2.focusPath) : void 0), 4718592 & e22.$$.dirty[1] && n2(1, u2 = i2 && (Xq(r2) || Yq(r2) || Zq(r2))), 18 & e22.$$.dirty[0] | 4194304 & e22.$$.dirty[1] && n2(16, c2 = i2 && u2 && !a2), 16 & e22.$$.dirty[0] | 4718592 & e22.$$.dirty[1] && n2(15, l2 = i2 && r2 != null && (Xq(r2) || Zq(r2)) && !a2), 16 & e22.$$.dirty[0] | 4718593 & e22.$$.dirty[1] && n2(14, f2 = i2 && r2 != null && lF(r2) && !a2 && !Array.isArray(cs.exports.getIn(S2, Gp(r2.focusPath)))), 5767168 & e22.$$.dirty[1] && n2(2, h2 = i2 && r2 != null && lF(r2) && !Os(s2)), 2 & e22.$$.dirty[0] && n2(52, d2 = u2), 2097152 & e22.$$.dirty[1] && n2(13, v2 = d2 ? "Convert to" : "Insert"), 8 & e22.$$.dirty[0] | 2097152 & e22.$$.dirty[1] && n2(12, p2 = !d2 && o2), 8 & e22.$$.dirty[0] | 3670016 & e22.$$.dirty[1] && n2(11, m2 = d2 ? xF(r2) && !$s(s2) : o2), 8 & e22.$$.dirty[0] | 3670016 & e22.$$.dirty[1] && n2(10, g2 = d2 ? xF(r2) && !Array.isArray(s2) : o2), 8 & e22.$$.dirty[0] | 3670016 & e22.$$.dirty[1] && n2(9, y2 = d2 ? xF(r2) && Os(s2) : o2), 1572866 & e22.$$.dirty[1] && n2(49, b2 = r2 != null && zq(s2, C2.enforceStringMap, cs.exports.compileJSONPointer(r2.focusPath))), 4 & e22.$$.dirty[0] | 262144 & e22.$$.dirty[1] && n2(8, k2 = [{ icon: bj, text: "Edit value", title: "Edit the value (Double-click on the value)", onClick: V2, disabled: !h2 }, { icon: b2 ? jV : xV, text: "Enforce string", title: "Enforce keeping the value as string when it contains a numeric value", onClick: H2, disabled: !h2 }]), 2 & e22.$$.dirty[0] && n2(7, w2 = [{ icon: kj, text: "Cut formatted", title: "Cut selected contents, formatted with indentation (Ctrl+X)", onClick: W2, disabled: !u2 }, { icon: kj, text: "Cut compacted", title: "Cut selected contents, without indentation (Ctrl+Shift+X)", onClick: J2, disabled: !u2 }]), 2 & e22.$$.dirty[0] && n2(6, x2 = [{ icon: hj, text: "Copy formatted", title: "Copy selected contents, formatted with indentation (Ctrl+C)", onClick: U2, disabled: !u2 }, { icon: hj, text: "Copy compacted", title: "Copy selected contents, without indentation (Ctrl+Shift+C)", onClick: K2, disabled: !u2 }]);
  }, [_2, u2, h2, o2, a2, j2, x2, w2, k2, y2, g2, m2, p2, v2, f2, l2, c2, function() {
    $2(), O2();
  }, V2, W2, U2, function() {
    $2(), N2();
  }, function() {
    $2(), T2();
  }, function() {
    $2(), I2();
  }, function() {
    $2(), R2();
  }, G2, function() {
    $2(), q2();
  }, function() {
    $2(), F2();
  }, function() {
    $2(), D2();
  }, function() {
    $2(), B2();
  }, function(e23) {
    var t3 = Rx(e23).replace(/^Command\+/, "Ctrl+");
    if (t3 === "Up" || t3 === "Down" || t3 === "Left" || t3 === "Right") {
      e23.preventDefault();
      var n3 = Tx({ allElements: Array.from(j2.querySelectorAll("button:not([disabled])")), currentElement: e23.target, direction: t3, hasPrio: function(e24) {
        return e24.getAttribute("data-type") !== "jse-open-dropdown";
      } });
      n3 && n3.focus();
    }
  }, S2, C2, $2, O2, A2, M2, E2, P2, N2, T2, I2, R2, D2, z2, L2, B2, q2, F2, b2, r2, s2, d2, i2, function() {
    return G2("structure");
  }, function() {
    return G2("object");
  }, function() {
    return G2("array");
  }, function() {
    return G2("value");
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(5, j2 = e23);
    });
  }];
}
var EV = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, MV, AV, Ki, { json: 31, documentState: 32, showTip: 0, onCloseContextMenu: 33, onEditKey: 34, onEditValue: 35, onToggleEnforceString: 36, onCut: 37, onCopy: 38, onPaste: 39, onRemove: 40, onDuplicate: 41, onExtract: 42, onInsertBefore: 43, onInsert: 44, onConvert: 45, onInsertAfter: 46, onSort: 47, onTransform: 48 }, SV, [-1, -1, -1]), r2;
  }
  return zi(n2);
}(), PV = { exports: {} };
/*!
  Copyright (c) 2018 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
!function(e22) {
  !function() {
    var t2 = {}.hasOwnProperty;
    function n2() {
      for (var e23 = [], r2 = 0; r2 < arguments.length; r2++) {
        var i2 = arguments[r2];
        if (i2) {
          var o2 = Li(i2);
          if (o2 === "string" || o2 === "number")
            e23.push(i2);
          else if (Array.isArray(i2)) {
            if (i2.length) {
              var a2 = n2.apply(null, i2);
              a2 && e23.push(a2);
            }
          } else if (o2 === "object")
            if (i2.toString === Object.prototype.toString)
              for (var s2 in i2)
                t2.call(i2, s2) && i2[s2] && e23.push(s2);
            else
              e23.push(i2.toString());
        }
      }
      return e23.join(" ");
    }
    e22.exports ? (n2.default = n2, e22.exports = n2) : window.classNames = n2;
  }();
}(PV);
var NV = PV.exports;
function TV(e22) {
  co(e22, "svelte-1knbf5w", "div.jse-collapsed-items.svelte-1knbf5w.svelte-1knbf5w{font-family:var(--jse-font-family);font-size:var(--jse-font-size);color:var(--jse-collapsed-items-link-color);padding:calc(0.5 * var(--jse-padding));border:8px solid transparent;border-width:8px 0;background-color:transparent;background-image:linear-gradient(var(--jse-collapsed-items-background-color), var(--jse-collapsed-items-background-color)), linear-gradient(to bottom right, transparent 50.5%, var(--jse-collapsed-items-background-color) 50.5%), linear-gradient(to bottom left, transparent 50.5%, var(--jse-collapsed-items-background-color) 50.5%), linear-gradient(to top right, transparent 50.5%, var(--jse-collapsed-items-background-color) 50.5%), linear-gradient(to top left, transparent 50.5%, var(--jse-collapsed-items-background-color) 50.5%);background-repeat:repeat, repeat-x, repeat-x, repeat-x, repeat-x;background-position:0 0, 8px 0, 8px 0, 8px 100%, 8px 100%;background-size:auto auto, 16px 16px, 16px 16px, 16px 16px, 16px 16px;background-clip:padding-box, border-box, border-box, border-box, border-box;background-origin:padding-box, border-box, border-box, border-box, border-box;display:flex}div.jse-collapsed-items.svelte-1knbf5w div.jse-text.svelte-1knbf5w,div.jse-collapsed-items.svelte-1knbf5w button.jse-expand-items.svelte-1knbf5w{margin:0 calc(0.5 * var(--jse-padding))}div.jse-collapsed-items.svelte-1knbf5w div.jse-text.svelte-1knbf5w{display:inline}div.jse-collapsed-items.svelte-1knbf5w button.jse-expand-items.svelte-1knbf5w{font-family:inherit;font-size:inherit;color:var(--jse-collapsed-items-link-color);background:none;border:none;padding:0;text-decoration:underline;cursor:pointer}div.jse-collapsed-items.svelte-1knbf5w button.jse-expand-items.svelte-1knbf5w:hover,div.jse-collapsed-items.svelte-1knbf5w button.jse-expand-items.svelte-1knbf5w:focus{color:var(--jse-collapsed-items-link-color-highlight)}");
}
function IV(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[13] = t2[n2], r2;
}
function RV(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2 = e22[13].start + "", l2 = e22[13].end + "";
  function f2() {
    return e22[12](e22[13]);
  }
  return { c: function() {
    t2 = go("button"), n2 = bo("show "), r2 = bo(c2), i2 = bo("-"), o2 = bo(l2), a2 = ko(), So(t2, "type", "button"), So(t2, "class", "jse-expand-items svelte-1knbf5w");
  }, m: function(e23, c3) {
    vo(e23, t2, c3), uo(t2, n2), uo(t2, r2), uo(t2, i2), uo(t2, o2), uo(t2, a2), s2 || (u2 = xo(t2, "click", f2), s2 = true);
  }, p: function(t3, n3) {
    e22 = t3, 16 & n3 && c2 !== (c2 = e22[13].start + "") && Ao(r2, c2), 16 & n3 && l2 !== (l2 = e22[13].end + "") && Ao(o2, l2);
  }, d: function(e23) {
    e23 && po(t2), s2 = false, u2();
  } };
}
function DV(e22) {
  for (var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2 = e22[4], d2 = [], v2 = 0; v2 < h2.length; v2 += 1)
    d2[v2] = RV(IV(e22, h2, v2));
  return { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = go("div"), i2 = bo("Items "), o2 = bo(e22[3]), a2 = bo("-"), s2 = bo(e22[2]), u2 = ko();
    for (var l3 = 0; l3 < d2.length; l3 += 1)
      d2[l3].c();
    So(r2, "class", "jse-text svelte-1knbf5w"), So(t2, "class", "jse-collapsed-items svelte-1knbf5w"), So(t2, "style", c2 = zV(e22[0].length + 2)), To(t2, "jse-selected", e22[5]);
  }, m: function(e23, c3) {
    vo(e23, t2, c3), uo(t2, n2), uo(n2, r2), uo(r2, i2), uo(r2, o2), uo(r2, a2), uo(r2, s2), uo(n2, u2);
    for (var h3 = 0; h3 < d2.length; h3 += 1)
      d2[h3].m(n2, null);
    l2 || (f2 = xo(t2, "mousemove", LV), l2 = true);
  }, p: function(e23, r3) {
    var i3 = xi(r3, 1)[0];
    if (8 & i3 && Ao(o2, e23[3]), 4 & i3 && Ao(s2, e23[2]), 19 & i3) {
      var a3;
      for (h2 = e23[4], a3 = 0; a3 < h2.length; a3 += 1) {
        var u3 = IV(e23, h2, a3);
        d2[a3] ? d2[a3].p(u3, i3) : (d2[a3] = RV(u3), d2[a3].c(), d2[a3].m(n2, null));
      }
      for (; a3 < d2.length; a3 += 1)
        d2[a3].d(1);
      d2.length = h2.length;
    }
    1 & i3 && c2 !== (c2 = zV(e23[0].length + 2)) && So(t2, "style", c2), 32 & i3 && To(t2, "jse-selected", e23[5]);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2), mo(d2, e23), l2 = false, f2();
  } };
}
function zV(e22) {
  return "margin-left: calc(".concat(e22, " * var(--jse-indent-size))");
}
function LV(e22) {
  e22.stopPropagation();
}
function BV(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2 = t2.visibleSections, c2 = t2.sectionIndex, l2 = t2.total, f2 = t2.path, h2 = t2.pointer, d2 = t2.selection, v2 = t2.onExpandSection;
  return e22.$$set = function(e23) {
    "visibleSections" in e23 && n2(6, u2 = e23.visibleSections), "sectionIndex" in e23 && n2(7, c2 = e23.sectionIndex), "total" in e23 && n2(8, l2 = e23.total), "path" in e23 && n2(0, f2 = e23.path), "pointer" in e23 && n2(9, h2 = e23.pointer), "selection" in e23 && n2(10, d2 = e23.selection), "onExpandSection" in e23 && n2(1, v2 = e23.onExpandSection);
  }, e22.$$.update = function() {
    192 & e22.$$.dirty && n2(11, r2 = u2[c2]), 2048 & e22.$$.dirty && n2(3, i2 = r2.end), 448 & e22.$$.dirty && n2(2, o2 = u2[c2 + 1] ? u2[c2 + 1].start : l2), 1544 & e22.$$.dirty && n2(5, a2 = !!Xq(d2) && d2.pointersMap[cs.exports.appendToJSONPointer(h2, i2)] === true), 12 & e22.$$.dirty && n2(4, s2 = function(e23, t3) {
      var n3 = { start: e23, end: Math.min(gq(e23), t3) }, r3 = Math.max(yq((e23 + t3) / 2), e23), i3 = { start: r3, end: Math.min(gq(r3), t3) }, o3 = yq(t3), a3 = o3 === t3 ? o3 - 100 : o3, s3 = { start: Math.max(a3, e23), end: t3 }, u3 = [n3], c3 = i3.start >= n3.end && i3.end <= s3.start;
      return c3 && u3.push(i3), s3.start >= (c3 ? i3.end : n3.end) && u3.push(s3), u3;
    }(i2, o2));
  }, [f2, v2, o2, i2, s2, a2, u2, c2, l2, h2, d2, r2, function(e23) {
    return v2(f2, e23);
  }];
}
var qV = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, BV, DV, Ki, { visibleSections: 6, sectionIndex: 7, total: 8, path: 0, pointer: 9, selection: 10, onExpandSection: 1 }, TV), r2;
  }
  return zi(n2);
}();
function FV(e22) {
  co(e22, "svelte-dol684", ".jse-context-menu-button.svelte-dol684{position:absolute;top:calc(-0.5 * var(--jse-context-menu-button-size));right:calc(-0.5 * var(--jse-context-menu-button-size));width:var(--jse-context-menu-button-size);height:var(--jse-context-menu-button-size);padding:0;margin:0;z-index:2;cursor:pointer;background:transparent;border-radius:2px;background:var(--jse-context-menu-button-background);color:var(--jse-context-menu-button-color);border:none;box-shadow:var(--jse-controls-box-shadow)}.jse-context-menu-button.svelte-dol684:hover{background:var(--jse-context-menu-button-background-highlight)}");
}
function VV(e22) {
  var t2, n2, r2, i2, o2;
  return n2 = new Xj({ props: { data: ij } }), { c: function() {
    t2 = go("button"), Aa(n2.$$.fragment), So(t2, "type", "button"), So(t2, "class", "jse-context-menu-button svelte-dol684"), So(t2, "title", ns), To(t2, "jse-selected", e22[0]);
  }, m: function(a2, s2) {
    vo(a2, t2, s2), Ma(n2, t2, null), r2 = true, i2 || (o2 = xo(t2, "click", e22[1]), i2 = true);
  }, p: function(e23, n3) {
    1 & xi(n3, 1)[0] && To(t2, "jse-selected", e23[0]);
  }, i: function(e23) {
    r2 || (ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), i2 = false, o2();
  } };
}
function HV(e22, t2, n2) {
  var r2 = t2.selected, i2 = t2.onContextMenu;
  return e22.$$set = function(e23) {
    "selected" in e23 && n2(0, r2 = e23.selected), "onContextMenu" in e23 && n2(2, i2 = e23.onContextMenu);
  }, [r2, function(e23) {
    for (var t3 = e23.target; t3 && t3.nodeName !== "BUTTON"; )
      t3 = t3.parentNode;
    t3 && i2({ anchor: t3, left: 0, top: 0, width: 260, height: 336, offsetTop: 2, offsetLeft: 0, showTip: true });
  }, i2];
}
var WV = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, HV, VV, Ki, { selected: 0, onContextMenu: 2 }, FV), r2;
  }
  return zi(n2);
}();
function JV(e22) {
  co(e22, "svelte-s6kbew", ".jse-highlight.svelte-s6kbew{background-color:var(--jse-search-match-color);outline:var(--jse-search-match-outline)}.jse-highlight.jse-active.svelte-s6kbew{background-color:var(--jse-search-match-active-color);outline:var(--jse-search-match-active-outline)}");
}
function UV(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[3] = t2[n2], r2;
}
function KV(e22) {
  var t2, n2, r2 = xx(e22[3].text) + "";
  return { c: function() {
    t2 = go("span"), n2 = bo(r2), So(t2, "class", "jse-highlight svelte-s6kbew"), To(t2, "jse-active", e22[3].active);
  }, m: function(e23, r3) {
    vo(e23, t2, r3), uo(t2, n2);
  }, p: function(e23, i2) {
    1 & i2 && r2 !== (r2 = xx(e23[3].text) + "") && Ao(n2, r2), 1 & i2 && To(t2, "jse-active", e23[3].active);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function GV(e22) {
  var t2, n2 = e22[3].text + "";
  return { c: function() {
    t2 = bo(n2);
  }, m: function(e23, n3) {
    vo(e23, t2, n3);
  }, p: function(e23, r2) {
    1 & r2 && n2 !== (n2 = e23[3].text + "") && Ao(t2, n2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function QV(e22) {
  var t2;
  function n2(e23, t3) {
    return e23[3].type === "normal" ? GV : KV;
  }
  var r2 = n2(e22), i2 = r2(e22);
  return { c: function() {
    i2.c(), t2 = wo();
  }, m: function(e23, n3) {
    i2.m(e23, n3), vo(e23, t2, n3);
  }, p: function(e23, o2) {
    r2 === (r2 = n2(e23)) && i2 ? i2.p(e23, o2) : (i2.d(1), (i2 = r2(e23)) && (i2.c(), i2.m(t2.parentNode, t2)));
  }, d: function(e23) {
    i2.d(e23), e23 && po(t2);
  } };
}
function YV(e22) {
  for (var t2, n2 = e22[0], r2 = [], i2 = 0; i2 < n2.length; i2 += 1)
    r2[i2] = QV(UV(e22, n2, i2));
  return { c: function() {
    for (var e23 = 0; e23 < r2.length; e23 += 1)
      r2[e23].c();
    t2 = wo();
  }, m: function(e23, n3) {
    for (var i3 = 0; i3 < r2.length; i3 += 1)
      r2[i3].m(e23, n3);
    vo(e23, t2, n3);
  }, p: function(e23, i3) {
    var o2 = xi(i3, 1)[0];
    if (1 & o2) {
      var a2;
      for (n2 = e23[0], a2 = 0; a2 < n2.length; a2 += 1) {
        var s2 = UV(e23, n2, a2);
        r2[a2] ? r2[a2].p(s2, o2) : (r2[a2] = QV(s2), r2[a2].c(), r2[a2].m(t2.parentNode, t2));
      }
      for (; a2 < r2.length; a2 += 1)
        r2[a2].d(1);
      r2.length = n2.length;
    }
  }, i: Bi, o: Bi, d: function(e23) {
    mo(r2, e23), e23 && po(t2);
  } };
}
function ZV(e22, t2, n2) {
  var r2, i2 = t2.text, o2 = t2.searchResultItems;
  return e22.$$set = function(e23) {
    "text" in e23 && n2(1, i2 = e23.text), "searchResultItems" in e23 && n2(2, o2 = e23.searchResultItems);
  }, e22.$$.update = function() {
    6 & e22.$$.dirty && n2(0, r2 = function(e23, t3) {
      var n3, r3 = [], i3 = 0, o3 = bi(t3);
      try {
        for (o3.s(); !(n3 = o3.n()).done; ) {
          var a2 = n3.value, s2 = e23.slice(i3, a2.start);
          s2 !== "" && r3.push({ type: "normal", text: s2, active: false });
          var u2 = e23.slice(a2.start, a2.end);
          r3.push({ type: "highlight", text: u2, active: a2.active }), i3 = a2.end;
        }
      } catch (e24) {
        o3.e(e24);
      } finally {
        o3.f();
      }
      var c2 = yv(t3);
      return c2.end < e23.length && r3.push({ type: "normal", text: e23.slice(c2.end), active: false }), r3;
    }(String(i2), o2));
  }, [r2, i2, o2];
}
var XV = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, ZV, YV, Ui, { text: 1, searchResultItems: 2 }, JV), r2;
  }
  return zi(n2);
}();
function eH(e22) {
  co(e22, "svelte-rw77oa", ".jse-value.jse-string.svelte-rw77oa{color:var(--jse-value-color-string)}.jse-value.jse-object.svelte-rw77oa,.jse-value.jse-array.svelte-rw77oa{min-width:16px;color:var(--jse-delimiter-color)}.jse-value.jse-number.svelte-rw77oa{color:var(--jse-value-color-number)}.jse-value.jse-boolean.svelte-rw77oa{color:var(--jse-value-color-boolean)}.jse-value.jse-null.svelte-rw77oa{color:var(--jse-value-color-null)}.jse-value.jse-invalid.svelte-rw77oa{color:var(--jse-text-color)}.jse-value.jse-url.svelte-rw77oa{color:var(--jse-value-color-url);text-decoration:underline}div.jse-editable-div.svelte-rw77oa{min-width:2em;padding:0 5px;box-sizing:border-box;outline:none;border-radius:1px;vertical-align:top;word-break:normal;white-space:pre-wrap;overflow-wrap:anywhere}div.jse-editable-div.jse-short-text.svelte-rw77oa{overflow-wrap:normal}div.jse-editable-div[contenteditable=true].svelte-rw77oa{outline:var(--jse-edit-outline);background:inherit !important;position:relative;border-radius:0;z-index:3}div.jse-editable-div.jse-empty.svelte-rw77oa:not(:focus){outline:1px dotted var(--jse-tag-background);-moz-outline-radius:2px}div.jse-editable-div.jse-empty.svelte-rw77oa::after{pointer-events:none;color:var(--jse-tag-background)}");
}
function tH(e22) {
  var t2, n2, r2, i2;
  return { c: function() {
    So(t2 = go("div"), "class", n2 = eo(NV("jse-editable-div", e22[2], { "jse-short-text": e22[0] })) + " svelte-rw77oa"), So(t2, "contenteditable", "true"), So(t2, "spellcheck", "false");
  }, m: function(n3, o2) {
    vo(n3, t2, o2), e22[13](t2), r2 || (i2 = [xo(t2, "input", e22[3]), xo(t2, "keydown", e22[4]), xo(t2, "paste", e22[5]), xo(t2, "blur", e22[6])], r2 = true);
  }, p: function(e23, r3) {
    5 & xi(r3, 1)[0] && n2 !== (n2 = eo(NV("jse-editable-div", e23[2], { "jse-short-text": e23[0] })) + " svelte-rw77oa") && So(t2, "class", n2);
  }, i: Bi, o: Bi, d: function(n3) {
    n3 && po(t2), e22[13](null), r2 = false, Wi(i2);
  } };
}
function nH(e22, t2, n2) {
  var r2, i2 = Ia("jsoneditor:EditableDiv"), o2 = t2.value, a2 = t2.shortText, s2 = a2 !== void 0 && a2, u2 = t2.onChange, c2 = t2.onCancel, l2 = t2.onFind, f2 = t2.onPaste, h2 = f2 === void 0 ? Vu : f2, d2 = t2.onValueClass, v2 = d2 === void 0 ? function() {
    return "";
  } : d2, p2 = v2(o2), m2 = false;
  function g2() {
    return function(e23) {
      return e23.replace(/\n$/, "");
    }(r2.innerText);
  }
  function y2(e23) {
    n2(1, r2.innerText = xx(e23), r2);
  }
  return Uo(function() {
    i2("onMount", { value: o2 }), y2(o2), setTimeout(function() {
      return $x(r2);
    });
  }), Ko(function() {
    var e23 = g2();
    i2("onDestroy", { closed: m2, value: o2, newValue: e23 }), m2 || e23 === o2 || u2(e23, rs);
  }), e22.$$set = function(e23) {
    "value" in e23 && n2(7, o2 = e23.value), "shortText" in e23 && n2(0, s2 = e23.shortText), "onChange" in e23 && n2(8, u2 = e23.onChange), "onCancel" in e23 && n2(9, c2 = e23.onCancel), "onFind" in e23 && n2(10, l2 = e23.onFind), "onPaste" in e23 && n2(11, h2 = e23.onPaste), "onValueClass" in e23 && n2(12, v2 = e23.onValueClass);
  }, [s2, r2, p2, function() {
    var e23 = g2();
    e23 === "" && y2(""), n2(2, p2 = v2(e23));
  }, function(e23) {
    e23.stopPropagation();
    var t3 = Rx(e23).replace(/^Command\+/, "Ctrl+");
    if (t3 === "Escape" && (m2 = true, c2()), t3 === "Enter" || t3 === "Tab") {
      m2 = true;
      var n3 = g2();
      u2(n3, os);
    }
    t3 === "Ctrl+F" && (e23.preventDefault(), l2(false)), t3 === "Ctrl+H" && (e23.preventDefault(), l2(true));
  }, function(e23) {
    if (h2) {
      var t3 = e23.clipboardData.getData("text/plain");
      h2(t3);
    }
  }, function() {
    var e23 = document.hasFocus(), t3 = g2();
    i2("handleBlur", { hasFocus: e23, closed: m2, value: o2, newValue: t3 }), document.hasFocus() && !m2 && (m2 = true, t3 !== o2 ? u2(t3, is) : c2());
  }, o2, u2, c2, l2, h2, v2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(1, r2 = e23);
    });
  }];
}
var rH = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, nH, tH, Ki, { value: 7, shortText: 0, onChange: 8, onCancel: 9, onFind: 10, onPaste: 11, onValueClass: 12 }, eH), r2;
  }
  return zi(n2);
}();
function iH(e22) {
  co(e22, "svelte-566egb", '.jse-key.svelte-566egb{display:inline-block;min-width:2em;padding:0 5px;box-sizing:border-box;outline:none;border-radius:1px;vertical-align:top;color:var(--jse-key-color);word-break:normal;overflow-wrap:normal;white-space:pre-wrap}.jse-key.svelte-566egb:hover{background:var(--jse-hover-background-color)}.jse-key.svelte-566egb:hover{background:var(--jse-hover-background-color)}.jse-key.jse-empty.svelte-566egb{min-width:3em;outline:1px dotted var(--jse-tag-background);-moz-outline-radius:2px}.jse-key.jse-empty.svelte-566egb::after{pointer-events:none;color:var(--jse-tag-background);content:"key"}');
}
function oH(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2 = [uH, sH], c2 = [];
  function l2(e23, t3) {
    return e23[1] ? 0 : 1;
  }
  return n2 = l2(e22), r2 = c2[n2] = u2[n2](e22), { c: function() {
    t2 = go("div"), r2.c(), So(t2, "data-type", "selectable-key"), So(t2, "class", i2 = eo(e22[6](e22[0])) + " svelte-566egb");
  }, m: function(r3, i3) {
    vo(r3, t2, i3), c2[n2].m(t2, null), o2 = true, a2 || (s2 = xo(t2, "dblclick", e22[5]), a2 = true);
  }, p: function(e23, a3) {
    var s3 = n2;
    (n2 = l2(e23)) === s3 ? c2[n2].p(e23, a3) : (ma(), ba(c2[s3], 1, 1, function() {
      c2[s3] = null;
    }), ga(), (r2 = c2[n2]) ? r2.p(e23, a3) : (r2 = c2[n2] = u2[n2](e23)).c(), ya(r2, 1), r2.m(t2, null)), (!o2 || 1 & a3 && i2 !== (i2 = eo(e23[6](e23[0])) + " svelte-566egb")) && So(t2, "class", i2);
  }, i: function(e23) {
    o2 || (ya(r2), o2 = true);
  }, o: function(e23) {
    ba(r2), o2 = false;
  }, d: function(e23) {
    e23 && po(t2), c2[n2].d(), a2 = false, s2();
  } };
}
function aH(e22) {
  var t2, n2;
  return t2 = new rH({ props: { value: e22[2].normalization.escapeValue(e22[0]), shortText: true, onChange: e22[7], onCancel: e22[8], onFind: e22[2].onFind } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    5 & n3 && (r2.value = e23[2].normalization.escapeValue(e23[0])), 4 & n3 && (r2.onFind = e23[2].onFind), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function sH(e22) {
  var t2, n2 = xx(e22[2].normalization.escapeValue(e22[0])) + "";
  return { c: function() {
    t2 = bo(n2);
  }, m: function(e23, n3) {
    vo(e23, t2, n3);
  }, p: function(e23, r2) {
    5 & r2 && n2 !== (n2 = xx(e23[2].normalization.escapeValue(e23[0])) + "") && Ao(t2, n2);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function uH(e22) {
  var t2, n2;
  return t2 = new XV({ props: { text: e22[2].normalization.escapeValue(e22[0]), searchResultItems: e22[1] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    5 & n3 && (r2.text = e23[2].normalization.escapeValue(e23[0])), 2 & n3 && (r2.searchResultItems = e23[1]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function cH(e22) {
  var t2, n2;
  return t2 = new WV({ props: { selected: true, onContextMenu: e22[2].onContextMenu } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    4 & n3 && (r2.onContextMenu = e23[2].onContextMenu), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function lH(e22) {
  var t2, n2, r2, i2, o2, a2 = [aH, oH], s2 = [];
  function u2(e23, t3) {
    return e23[4] ? 0 : 1;
  }
  t2 = u2(e22), n2 = s2[t2] = a2[t2](e22);
  var c2 = !e22[2].readOnly && e22[3] && !e22[4] && cH(e22);
  return { c: function() {
    n2.c(), r2 = ko(), c2 && c2.c(), i2 = wo();
  }, m: function(e23, n3) {
    s2[t2].m(e23, n3), vo(e23, r2, n3), c2 && c2.m(e23, n3), vo(e23, i2, n3), o2 = true;
  }, p: function(e23, o3) {
    var l2 = xi(o3, 1)[0], f2 = t2;
    (t2 = u2(e23)) === f2 ? s2[t2].p(e23, l2) : (ma(), ba(s2[f2], 1, 1, function() {
      s2[f2] = null;
    }), ga(), (n2 = s2[t2]) ? n2.p(e23, l2) : (n2 = s2[t2] = a2[t2](e23)).c(), ya(n2, 1), n2.m(r2.parentNode, r2)), e23[2].readOnly || !e23[3] || e23[4] ? c2 && (ma(), ba(c2, 1, 1, function() {
      c2 = null;
    }), ga()) : c2 ? (c2.p(e23, l2), 28 & l2 && ya(c2, 1)) : ((c2 = cH(e23)).c(), ya(c2, 1), c2.m(i2.parentNode, i2));
  }, i: function(e23) {
    o2 || (ya(n2), ya(c2), o2 = true);
  }, o: function(e23) {
    ba(n2), ba(c2), o2 = false;
  }, d: function(e23) {
    s2[t2].d(e23), e23 && po(r2), c2 && c2.d(e23), e23 && po(i2);
  } };
}
function fH(e22, t2, n2) {
  var r2, i2, o2 = t2.path, a2 = t2.pointer, s2 = t2.key, u2 = t2.selection, c2 = t2.searchResultItems, l2 = t2.onUpdateKey, f2 = t2.context;
  return e22.$$set = function(e23) {
    "path" in e23 && n2(9, o2 = e23.path), "pointer" in e23 && n2(10, a2 = e23.pointer), "key" in e23 && n2(0, s2 = e23.key), "selection" in e23 && n2(11, u2 = e23.selection), "searchResultItems" in e23 && n2(1, c2 = e23.searchResultItems), "onUpdateKey" in e23 && n2(12, l2 = e23.onUpdateKey), "context" in e23 && n2(2, f2 = e23.context);
  }, e22.$$.update = function() {
    3072 & e22.$$.dirty && n2(3, r2 = u2 ? u2.pointersMap[a2] === true && Yq(u2) : void 0), 2056 & e22.$$.dirty && n2(4, i2 = r2 && wF(u2));
  }, [s2, c2, f2, r2, i2, function(e23) {
    i2 || f2.readOnly || (e23.preventDefault(), f2.onSelect(vF(o2, true)));
  }, function(e23) {
    return NV("jse-key", { "jse-empty": e23 === "" });
  }, function(e23, t3) {
    var n3 = l2(s2, f2.normalization.unescapeValue(e23)), r3 = Gp(o2).concat(n3);
    f2.onSelect(t3 === os ? pF(r3, false) : vF(r3, false)), t3 !== is && f2.focus();
  }, function() {
    f2.onSelect(vF(o2, false)), f2.focus();
  }, o2, a2, u2, l2];
}
var hH = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, fH, lH, Ki, { path: 9, pointer: 10, key: 0, selection: 11, searchResultItems: 1, onUpdateKey: 12, context: 2 }, iH), r2;
  }
  return zi(n2);
}();
function dH(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[9] = t2[n2], r2;
}
function vH(e22) {
  var t2, n2, r2, i2 = [e22[9].props], o2 = e22[9].component;
  function a2(e23) {
    for (var t3 = {}, n3 = 0; n3 < i2.length; n3 += 1)
      t3 = Fi(t3, i2[n3]);
    return { props: t3 };
  }
  return o2 && (t2 = new o2(a2())), { c: function() {
    t2 && Aa(t2.$$.fragment), n2 = wo();
  }, m: function(e23, i3) {
    t2 && Ma(t2, e23, i3), vo(e23, n2, i3), r2 = true;
  }, p: function(e23, r3) {
    var s2 = 1 & r3 ? _a(i2, [$a(e23[9].props)]) : {};
    if (o2 !== (o2 = e23[9].component)) {
      if (t2) {
        ma();
        var u2 = t2;
        ba(u2.$$.fragment, 1, 0, function() {
          Ea(u2, 1);
        }), ga();
      }
      o2 ? (Aa((t2 = new o2(a2())).$$.fragment), ya(t2.$$.fragment, 1), Ma(t2, n2.parentNode, n2)) : t2 = null;
    } else
      o2 && t2.$set(s2);
  }, i: function(e23) {
    r2 || (t2 && ya(t2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    t2 && ba(t2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(n2), t2 && Ea(t2, e23);
  } };
}
function pH(e22) {
  for (var t2, n2, r2 = e22[0], i2 = [], o2 = 0; o2 < r2.length; o2 += 1)
    i2[o2] = vH(dH(e22, r2, o2));
  var a2 = function(e23) {
    return ba(i2[e23], 1, 1, function() {
      i2[e23] = null;
    });
  };
  return { c: function() {
    for (var e23 = 0; e23 < i2.length; e23 += 1)
      i2[e23].c();
    t2 = wo();
  }, m: function(e23, r3) {
    for (var o3 = 0; o3 < i2.length; o3 += 1)
      i2[o3].m(e23, r3);
    vo(e23, t2, r3), n2 = true;
  }, p: function(e23, n3) {
    var o3 = xi(n3, 1)[0];
    if (1 & o3) {
      var s2;
      for (r2 = e23[0], s2 = 0; s2 < r2.length; s2 += 1) {
        var u2 = dH(e23, r2, s2);
        i2[s2] ? (i2[s2].p(u2, o3), ya(i2[s2], 1)) : (i2[s2] = vH(u2), i2[s2].c(), ya(i2[s2], 1), i2[s2].m(t2.parentNode, t2));
      }
      for (ma(), s2 = r2.length; s2 < i2.length; s2 += 1)
        a2(s2);
      ga();
    }
  }, i: function(e23) {
    if (!n2) {
      for (var t3 = 0; t3 < r2.length; t3 += 1)
        ya(i2[t3]);
      n2 = true;
    }
  }, o: function(e23) {
    i2 = i2.filter(Boolean);
    for (var t3 = 0; t3 < i2.length; t3 += 1)
      ba(i2[t3]);
    n2 = false;
  }, d: function(e23) {
    mo(i2, e23), e23 && po(t2);
  } };
}
function mH(e22, t2, n2) {
  var r2, i2, o2 = t2.path, a2 = t2.value, s2 = t2.context, u2 = t2.isSelected, c2 = t2.enforceString, l2 = t2.selection, f2 = t2.searchResultItems;
  return e22.$$set = function(e23) {
    "path" in e23 && n2(1, o2 = e23.path), "value" in e23 && n2(2, a2 = e23.value), "context" in e23 && n2(3, s2 = e23.context), "isSelected" in e23 && n2(4, u2 = e23.isSelected), "enforceString" in e23 && n2(5, c2 = e23.enforceString), "selection" in e23 && n2(6, l2 = e23.selection), "searchResultItems" in e23 && n2(7, f2 = e23.searchResultItems);
  }, e22.$$.update = function() {
    72 & e22.$$.dirty && n2(8, r2 = !s2.readOnly && Zq(l2) && wF(l2)), 510 & e22.$$.dirty && n2(0, i2 = s2.onRenderValue({ path: o2, value: a2, readOnly: s2.readOnly, enforceString: c2, isSelected: u2, isEditing: r2, normalization: s2.normalization, selection: l2, searchResultItems: f2, onPatch: s2.onPatch, onPasteJson: s2.onPasteJson, onSelect: s2.onSelect, onFind: s2.onFind, focus: s2.focus }));
  }, [i2, o2, a2, s2, u2, c2, l2, f2, r2];
}
var gH = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, mH, pH, Ki, { path: 1, value: 2, context: 3, isSelected: 4, enforceString: 5, selection: 6, searchResultItems: 7 }), r2;
  }
  return zi(n2);
}(), yH = { selecting: false, selectionAnchor: null, selectionAnchorType: null, selectionFocus: null, dragging: false };
function bH(e22) {
  var t2 = e22.json, n2 = e22.documentState, r2 = e22.deltaY, i2 = e22.items, o2 = n2.selection, a2 = r2 < 0 ? function(e23) {
    var t3 = e23.items, n3 = e23.selection, r3 = e23.deltaY, i3 = tF(n3), o3 = t3.findIndex(function(e24) {
      return wm(e24.path, i3);
    }), a3 = function() {
      var e24;
      return (e24 = t3[s3 - 1]) === null || e24 === void 0 ? void 0 : e24.height;
    }, s3 = o3, u3 = 0;
    for (; a3() !== void 0 && Math.abs(r3) > u3 + a3() / 2; )
      u3 += a3(), s3 -= 1;
    var c3 = t3[s3].path, l2 = s3 - o3;
    return s3 !== o3 && t3[s3] !== void 0 ? { beforePath: c3, offset: l2 } : void 0;
  }({ json: t2, selection: o2, deltaY: r2, items: i2 }) : function(e23) {
    var t3, n3 = e23.json, r3 = e23.items, i3 = e23.selection, o3 = e23.deltaY, a3 = nF(i3), s3 = r3.findIndex(function(e24) {
      return wm(e24.path, a3);
    }), u3 = 0, c3 = s3, l2 = function() {
      var e24;
      return (e24 = r3[c3 + 1]) === null || e24 === void 0 ? void 0 : e24.height;
    };
    for (; l2() !== void 0 && Math.abs(o3) > u3 + l2() / 2; )
      u3 += l2(), c3 += 1;
    var f2 = Gp(a3), h2 = cs.exports.getIn(n3, f2), d2 = Array.isArray(h2), v2 = (t3 = r3[d2 ? c3 : c3 + 1]) === null || t3 === void 0 ? void 0 : t3.path, p2 = c3 - s3;
    return v2 ? { beforePath: v2, offset: p2 } : { append: true, offset: p2 };
  }({ json: t2, selection: o2, deltaY: r2, items: i2 });
  if (!a2 || a2.offset === 0)
    return { operations: void 0, updatedSelection: void 0, offset: 0 };
  var s2 = function(e23, t3, n3) {
    var r3 = n3.beforePath, i3 = n3.append, o3 = Gp(t3.focusPath), a3 = cs.exports.getIn(e23, o3);
    if (!(i3 || r3 && hF(r3, o3) && r3.length > o3.length))
      return [];
    var s3 = tF(t3), u3 = nF(t3), c3 = yv(s3), l2 = yv(u3), f2 = r3 ? r3[o3.length] : void 0;
    if (!Jw(a3)) {
      if (Uw(a3)) {
        var h2 = Ww(c3), d2 = Ww(l2), v2 = f2 !== void 0 ? Ww(f2) : a3.length;
        return dk(d2 - h2 + 1, v2 < h2 ? function(e24) {
          return { op: "move", from: cs.exports.compileJSONPointer(o3.concat(String(h2 + e24))), path: cs.exports.compileJSONPointer(o3.concat(String(v2 + e24))) };
        } : function() {
          return { op: "move", from: cs.exports.compileJSONPointer(o3.concat(String(h2))), path: cs.exports.compileJSONPointer(o3.concat(String(v2))) };
        });
      }
      throw new Error("Cannot create move operations: parent must be an Object or Array");
    }
    var p2 = Object.keys(a3), m2 = p2.indexOf(c3), g2 = p2.indexOf(l2), y2 = i3 ? p2.length : p2.indexOf(f2);
    return m2 !== -1 && g2 !== -1 && y2 !== -1 ? y2 > m2 ? [].concat(Ni(p2.slice(m2, g2 + 1)), Ni(p2.slice(y2, p2.length))).map(function(e24) {
      return EF(o3, e24);
    }) : [].concat(Ni(p2.slice(y2, m2)), Ni(p2.slice(g2 + 1, p2.length))).map(function(e24) {
      return EF(o3, e24);
    }) : void 0;
  }(t2, n2.selection, a2), u2 = Gp(tF(o2)), c2 = cs.exports.getIn(t2, u2);
  return Array.isArray(c2) ? { operations: s2, updatedSelection: function(e23) {
    var t3, n3, r3 = e23.items, i3 = e23.json, o3 = e23.selection, a3 = e23.offset, s3 = tF(o3), u3 = nF(o3), c3 = r3.findIndex(function(e24) {
      return wm(e24.path, s3);
    }), l2 = r3.findIndex(function(e24) {
      return wm(e24.path, u3);
    }), f2 = (t3 = r3[c3 + a3]) === null || t3 === void 0 ? void 0 : t3.path, h2 = (n3 = r3[l2 + a3]) === null || n3 === void 0 ? void 0 : n3.path;
    return yF(i3, f2, h2);
  }({ items: i2, json: t2, selection: o2, offset: a2.offset }), offset: a2.offset } : { operations: s2, updatedSelection: void 0, offset: a2.offset };
}
function kH(e22, t2) {
  return function(e23, t3) {
    if (e23) {
      for (var n2 = {}, r2 = 0, i2 = Object.keys(e23); r2 < i2.length; r2++) {
        var o2 = i2[r2];
        t3(o2, e23[o2]) && (n2[o2] = e23[o2]);
      }
      return Object.keys(n2).length > 0 ? n2 : void 0;
    }
  }(e22, function(e23) {
    return cs.exports.startsWithJSONPointer(e23, t2);
  });
}
function wH(e22) {
  co(e22, "svelte-r4omvg", ".jse-tooltip.svelte-r4omvg{font-family:var(--jse-font-family);font-size:var(--jse-font-size);line-height:normal;padding:calc(0.5 * var(--jse-padding)) var(--jse-padding);border-radius:3px;background:var(--jse-context-menu-background);color:var(--jse-context-menu-color);white-space:nowrap;box-shadow:var(--jse-controls-box-shadow)}");
}
function xH(e22) {
  var t2, n2;
  return { c: function() {
    t2 = go("div"), n2 = bo(e22[0]), So(t2, "class", "jse-tooltip svelte-r4omvg");
  }, m: function(e23, r2) {
    vo(e23, t2, r2), uo(t2, n2);
  }, p: function(e23, t3) {
    1 & xi(t3, 1)[0] && Ao(n2, e23[0]);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function jH(e22, t2, n2) {
  var r2 = t2.text;
  return e22.$$set = function(e23) {
    "text" in e23 && n2(0, r2 = e23.text);
  }, [r2];
}
var SH = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, jH, xH, Ui, { text: 0 }, wH), r2;
  }
  return zi(n2);
}();
function CH(e22, t2) {
  var n2, r2 = t2.text, i2 = t2.openAbsolutePopup, o2 = t2.closeAbsolutePopup;
  function a2() {
    n2 = i2(SH, { text: r2 }, { position: "top", width: 10 * r2.length, offsetTop: 3, anchor: e22, closeOnOuterClick: true });
  }
  function s2() {
    o2(n2);
  }
  return e22.addEventListener("mouseenter", a2), e22.addEventListener("mouseleave", s2), { destroy: function() {
    e22.removeEventListener("mouseenter", a2), e22.removeEventListener("mouseleave", s2);
  } };
}
function _H(e22) {
  co(e22, "svelte-1q62mys", "button.jse-validation-error.svelte-1q62mys{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;color:var(--jse-warning-color);padding:0 5px;margin:0;font-size:var(--jse-font-size-mono);height:var(--jse-line-height);overflow:hidden}");
}
function $H(e22) {
  var t2, n2, r2, i2, o2, a2;
  return n2 = new Xj({ props: { data: jj } }), { c: function() {
    t2 = go("button"), Aa(n2.$$.fragment), So(t2, "type", "button"), So(t2, "class", "jse-validation-error svelte-1q62mys");
  }, m: function(s2, u2) {
    vo(s2, t2, u2), Ma(n2, t2, null), i2 = true, o2 || (a2 = [xo(t2, "click", function() {
      Ji(e22[0]) && e22[0].apply(this, arguments);
    }), to(r2 = CH.call(null, t2, Ei({ text: e22[1] }, e22[2])))], o2 = true);
  }, p: function(t3, n3) {
    var i3 = xi(n3, 1)[0];
    e22 = t3, r2 && Ji(r2.update) && 2 & i3 && r2.update.call(null, Ei({ text: e22[1] }, e22[2]));
  }, i: function(e23) {
    i2 || (ya(n2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), o2 = false, Wi(a2);
  } };
}
function OH(e22, t2, n2) {
  var r2, i2 = Yo("absolute-popup"), o2 = t2.validationError, a2 = t2.onExpand;
  return e22.$$set = function(e23) {
    "validationError" in e23 && n2(3, o2 = e23.validationError), "onExpand" in e23 && n2(0, a2 = e23.onExpand);
  }, e22.$$.update = function() {
    8 & e22.$$.dirty && n2(1, r2 = o2.isChildError ? "Contains invalid data" : o2.message);
  }, [a2, r2, i2, o2];
}
var AH = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, OH, $H, Ui, { validationError: 3, onExpand: 0 }, _H), r2;
  }
  return zi(n2);
}();
function MH(e22) {
  co(e22, "svelte-uj4yd7", ".jse-json-node.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{position:relative;color:var(--jse-text-color)}.jse-json-node.jse-root.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{min-height:100%;padding-bottom:2px;box-sizing:border-box}.jse-json-node.jse-root.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7 .jse-context-menu-button,.jse-json-node.jse-root.svelte-uj4yd7>.jse-contents-outer.svelte-uj4yd7>.jse-contents.svelte-uj4yd7 .jse-context-menu-button{top:0;right:calc(-2px - var(--jse-context-menu-button-size))}.jse-json-node.jse-root.svelte-uj4yd7>.jse-contents-outer.svelte-uj4yd7>.jse-contents.svelte-uj4yd7.svelte-uj4yd7{padding-left:0}.jse-json-node.jse-hovered.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7>.jse-header.svelte-uj4yd7>.jse-meta.svelte-uj4yd7,.jse-json-node.jse-hovered.svelte-uj4yd7 .jse-props .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-hovered.svelte-uj4yd7 .jse-items .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-hovered.svelte-uj4yd7 .jse-props .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-hovered.svelte-uj4yd7 .jse-items .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-hovered.svelte-uj4yd7 .jse-footer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{background:var(--jse-hover-background-color)}.jse-json-node.svelte-uj4yd7 .jse-props.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.svelte-uj4yd7 .jse-items.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{position:relative}.jse-json-node.svelte-uj4yd7 .jse-header-outer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.svelte-uj4yd7 .jse-footer-outer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{display:flex}.jse-json-node.svelte-uj4yd7 .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{position:relative}.jse-json-node.svelte-uj4yd7 .jse-header .jse-meta.svelte-uj4yd7>.jse-meta-inner.svelte-uj4yd7.svelte-uj4yd7{display:flex;justify-content:center}.jse-json-node.svelte-uj4yd7 .jse-contents-outer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{display:flex}.jse-json-node.svelte-uj4yd7 .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.svelte-uj4yd7 .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{display:flex;flex-direction:row}.jse-json-node.svelte-uj4yd7 .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{padding-left:var(--jse-indent-size)}.jse-json-node.svelte-uj4yd7 .jse-footer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{display:inline-flex;padding-left:calc(var(--jse-indent-size) + 5px)}.jse-json-node.svelte-uj4yd7 .jse-insert-selection-area.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{visibility:hidden;padding:0 calc(0.5 * var(--jse-padding));flex:1}.jse-json-node.svelte-uj4yd7 .jse-insert-selection-area.jse-inside.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{display:inline-flex;align-items:center}.jse-json-node.svelte-uj4yd7 .jse-insert-selection-area.jse-after.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{display:flex;align-items:flex-end}.jse-json-node.svelte-uj4yd7:hover>.jse-contents-outer .jse-insert-selection-area.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7:not(.jse-selected),.jse-json-node.svelte-uj4yd7 .jse-header-outer.svelte-uj4yd7:hover>.jse-insert-selection-area.svelte-uj4yd7.svelte-uj4yd7:not(.jse-selected),.jse-json-node.svelte-uj4yd7 .jse-footer-outer:hover .jse-insert-selection-area.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7:not(.jse-selected){visibility:visible;z-index:1}.jse-json-node.svelte-uj4yd7 .jse-context-menu-button-anchor.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{position:relative}.jse-json-node.svelte-uj4yd7 .jse-insert-area.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{display:flex;position:relative;max-width:250px;min-width:100px;height:0;margin-right:calc(0.5 * var(--jse-padding));outline:1px solid}.jse-json-node.svelte-uj4yd7 .jse-insert-area.svelte-uj4yd7 .jse-context-menu-button{right:-1px;background:var(--jse-selection-background-color)}.jse-json-node.svelte-uj4yd7 .jse-insert-area.jse-hovered.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{outline-color:var(--jse-selection-background-color)}.jse-json-node.jse-selected.svelte-uj4yd7 .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected.svelte-uj4yd7 .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected.svelte-uj4yd7 .jse-meta.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected.svelte-uj4yd7 .jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected.svelte-uj4yd7 .jse-footer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected.svelte-uj4yd7 .jse-value{background:var(--jse-selection-background-color) !important;cursor:grab}.jse-json-node.jse-selected.svelte-uj4yd7 .jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{cursor:pointer}.jse-json-node.jse-selected-key.svelte-uj4yd7>.jse-contents-outer.svelte-uj4yd7>.jse-contents.svelte-uj4yd7>.jse-identifier>.jse-key,.jse-json-node.jse-selected-key.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7>.jse-header.svelte-uj4yd7>.jse-identifier>.jse-key{background:var(--jse-selection-background-color);cursor:grab}.jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-contents-outer.svelte-uj4yd7>.jse-contents.svelte-uj4yd7>.jse-value{background:var(--jse-selection-background-color);cursor:grab}.jse-json-node.svelte-uj4yd7 .jse-collapsed-items.jse-selected,.jse-json-node.jse-selected.svelte-uj4yd7 .jse-collapsed-items,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-collapsed-items{background-color:var(--jse-selection-background-color);cursor:grab;background-image:linear-gradient(var(--jse-collapsed-items-selected-background-color), var(--jse-collapsed-items-selected-background-color)), linear-gradient(to bottom right, transparent 50.5%, var(--jse-collapsed-items-selected-background-color) 50.5%), linear-gradient(to bottom left, transparent 50.5%, var(--jse-collapsed-items-selected-background-color) 50.5%), linear-gradient(to top right, transparent 50.5%, var(--jse-collapsed-items-selected-background-color) 50.5%), linear-gradient(to top left, transparent 50.5%, var(--jse-collapsed-items-selected-background-color) 50.5%)}.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-meta.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7>.jse-header.svelte-uj4yd7>.jse-meta.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-footer-outer.svelte-uj4yd7>.jse-footer.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-footer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-footer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{background:var(--jse-selection-background-color) !important}.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-meta.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-meta.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7>.jse-header.svelte-uj4yd7>.jse-meta.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7>.jse-header.svelte-uj4yd7>.jse-meta.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-footer-outer.svelte-uj4yd7>.jse-footer.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-footer-outer.svelte-uj4yd7>.jse-footer.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-contents.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-contents.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-header.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-header.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-footer.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-footer.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-expand.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-expand.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-contents.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-contents.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-header.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-header.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-footer.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-footer.svelte-uj4yd7 .jse-value,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-expand.svelte-uj4yd7 .jse-key,.jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-expand.svelte-uj4yd7 .jse-value{background:var(--jse-selection-background-color);cursor:grab}.jse-json-node.svelte-uj4yd7 .jse-insert-area.jse-selected.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{z-index:2;outline-color:var(--jse-context-menu-button-background)}.jse-json-node.svelte-uj4yd7 .jse-insert-area.jse-selected.svelte-uj4yd7 .jse-context-menu-button{background:var(--jse-context-menu-button-background)}.jse-json-node.svelte-uj4yd7 .jse-insert-area.jse-selected.svelte-uj4yd7 .jse-context-menu-button:hover{background:var(--jse-context-menu-button-background-highlight)}.jse-main:not(.jse-focus) .jse-json-node.jse-selected.svelte-uj4yd7 .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected.svelte-uj4yd7 .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected.svelte-uj4yd7 .jse-meta.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected.svelte-uj4yd7 .jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected.svelte-uj4yd7 .jse-footer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected.svelte-uj4yd7 .jse-value{background:var(--jse-selection-background-light-color) !important;cursor:grab}.jse-main:not(.jse-focus) .jse-json-node.jse-selected.svelte-uj4yd7 .jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{cursor:pointer}.jse-main:not(.jse-focus) .jse-json-node.jse-selected-key.svelte-uj4yd7>.jse-contents-outer.svelte-uj4yd7>.jse-contents.svelte-uj4yd7>.jse-identifier>.jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-key.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7>.jse-header.svelte-uj4yd7>.jse-identifier>.jse-key{background:var(--jse-selection-background-light-color);cursor:grab}.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-contents-outer.svelte-uj4yd7>.jse-contents.svelte-uj4yd7>.jse-value{background:var(--jse-selection-background-light-color);cursor:grab}.jse-main:not(.jse-focus) .jse-json-node.svelte-uj4yd7 .jse-collapsed-items.jse-selected,.jse-main:not(.jse-focus) .jse-json-node.jse-selected.svelte-uj4yd7 .jse-collapsed-items,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-collapsed-items{background-color:var(--jse-selection-background-light-color);cursor:grab;background-image:linear-gradient(var(--jse-collapsed-items-selected-background-color), var(--jse-collapsed-items-selected-background-color)), linear-gradient(to bottom right, transparent 50.5%, var(--jse-collapsed-items-selected-background-color) 50.5%), linear-gradient(to bottom left, transparent 50.5%, var(--jse-collapsed-items-selected-background-color) 50.5%), linear-gradient(to top right, transparent 50.5%, var(--jse-collapsed-items-selected-background-color) 50.5%), linear-gradient(to top left, transparent 50.5%, var(--jse-collapsed-items-selected-background-color) 50.5%)}.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-meta.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7>.jse-header.svelte-uj4yd7>.jse-meta.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-footer-outer.svelte-uj4yd7>.jse-footer.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-footer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-contents.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-header.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-footer.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{background:var(--jse-selection-background-light-color) !important}.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-meta.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-meta.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7>.jse-header.svelte-uj4yd7>.jse-meta.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-header-outer.svelte-uj4yd7>.jse-header.svelte-uj4yd7>.jse-meta.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-footer-outer.svelte-uj4yd7>.jse-footer.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7>.jse-footer-outer.svelte-uj4yd7>.jse-footer.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-contents.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-contents.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-header.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-header.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-footer.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-footer.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-expand.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-props .jse-expand.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-contents.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-contents.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-header.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-header.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-footer.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-footer.svelte-uj4yd7 .jse-value,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-expand.svelte-uj4yd7 .jse-key,.jse-main:not(.jse-focus) .jse-json-node.jse-selected-value.svelte-uj4yd7 .jse-items .jse-expand.svelte-uj4yd7 .jse-value{background:var(--jse-selection-background-light-color);cursor:grab}.jse-main:not(.jse-focus) .jse-json-node.svelte-uj4yd7 .jse-insert-area.jse-selected.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{z-index:2;outline-color:var(--jse-selection-background-color)}.jse-main:not(.jse-focus) .jse-json-node.svelte-uj4yd7 .jse-insert-area.jse-selected.svelte-uj4yd7 .jse-context-menu-button{background:var(--jse-selection-background-color)}.jse-main:not(.jse-focus) .jse-json-node.svelte-uj4yd7 .jse-insert-area.jse-selected.svelte-uj4yd7 .jse-context-menu-button:hover{background:var(--jse-selection-background-color)}.jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{width:var(--jse-indent-size);padding:0;margin:0;border:none;cursor:pointer;background:transparent;color:var(--jse-delimiter-color);font-size:var(--jse-font-size-mono);height:var(--jse-line-height)}.jse-expand.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7:hover{opacity:0.8}.jse-meta.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-separator.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-index.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7,.jse-bracket.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{vertical-align:top;color:var(--jse-delimiter-color)}.jse-index.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{padding:0 calc(0.5 * var(--jse-padding))}.jse-bracket.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{padding:0 2px}.jse-bracket.jse-expanded.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{padding-right:var(--jse-padding)}.jse-tag.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{border:none;font-size:80%;font-family:var(--jse-font-family);color:var(--jse-tag-color);background:var(--jse-tag-background);border-radius:2px;cursor:pointer;position:relative;display:inline-block;padding:0 4px;line-height:normal;margin:1px 0}.jse-tag.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7:hover{opacity:0.8}.jse-tag.jse-expanded.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{opacity:0.7;cursor:inherit}.jse-identifier.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7.svelte-uj4yd7{vertical-align:top;position:relative}");
}
var EH = function(e22) {
  return {};
}, PH = function(e22) {
  return {};
};
function NH(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[54] = t2[n2], r2;
}
var TH = function(e22) {
  return {};
}, IH = function(e22) {
  return {};
};
function RH(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[48] = t2[n2], r2[50] = n2, r2;
}
function DH(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[51] = t2[n2], r2;
}
var zH = function(e22) {
  return {};
}, LH = function(e22) {
  return {};
};
function BH(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2 = !e22[8].readOnly && e22[16] && e22[7] && (Zq(e22[7]) || Xq(e22[7])) && !e22[7].edit && wm(e22[7].focusPath, e22[1]), f2 = e22[35].identifier, h2 = Gi(f2, e22, e22[36], PH), d2 = !e22[17] && VH();
  o2 = new gH({ props: { path: e22[1], value: e22[0], enforceString: e22[13], isSelected: e22[16], selection: e22[16] ? e22[7] : void 0, searchResultItems: WF(e22[6], e22[9]), context: e22[8] } });
  var v2 = l2 && HH(e22), p2 = e22[15] && WH(e22), m2 = !e22[17] && JH(e22);
  return { c: function() {
    t2 = go("div"), n2 = go("div"), h2 && h2.c(), r2 = ko(), d2 && d2.c(), i2 = ko(), Aa(o2.$$.fragment), a2 = ko(), v2 && v2.c(), s2 = ko(), p2 && p2.c(), u2 = ko(), m2 && m2.c(), So(n2, "class", "jse-contents svelte-uj4yd7"), So(t2, "class", "jse-contents-outer svelte-uj4yd7"), So(t2, "style", e22[18]);
  }, m: function(e23, l3) {
    vo(e23, t2, l3), uo(t2, n2), h2 && h2.m(n2, null), uo(n2, r2), d2 && d2.m(n2, null), uo(n2, i2), Ma(o2, n2, null), uo(n2, a2), v2 && v2.m(n2, null), uo(t2, s2), p2 && p2.m(t2, null), uo(t2, u2), m2 && m2.m(t2, null), c2 = true;
  }, p: function(e23, r3) {
    h2 && h2.p && (!c2 || 32 & r3[1]) && Zi(h2, f2, e23, e23[36], c2 ? Yi(f2, e23[36], r3, EH) : Xi(e23[36]), PH), e23[17] ? d2 && (d2.d(1), d2 = null) : d2 || ((d2 = VH()).c(), d2.m(n2, i2));
    var a3 = {};
    2 & r3[0] && (a3.path = e23[1]), 1 & r3[0] && (a3.value = e23[0]), 8192 & r3[0] && (a3.enforceString = e23[13]), 65536 & r3[0] && (a3.isSelected = e23[16]), 65664 & r3[0] && (a3.selection = e23[16] ? e23[7] : void 0), 576 & r3[0] && (a3.searchResultItems = WF(e23[6], e23[9])), 256 & r3[0] && (a3.context = e23[8]), o2.$set(a3), 65922 & r3[0] && (l2 = !e23[8].readOnly && e23[16] && e23[7] && (Zq(e23[7]) || Xq(e23[7])) && !e23[7].edit && wm(e23[7].focusPath, e23[1])), l2 ? v2 ? (v2.p(e23, r3), 65922 & r3[0] && ya(v2, 1)) : ((v2 = HH(e23)).c(), ya(v2, 1), v2.m(n2, null)) : v2 && (ma(), ba(v2, 1, 1, function() {
      v2 = null;
    }), ga()), e23[15] ? p2 ? (p2.p(e23, r3), 32768 & r3[0] && ya(p2, 1)) : ((p2 = WH(e23)).c(), ya(p2, 1), p2.m(t2, u2)) : p2 && (ma(), ba(p2, 1, 1, function() {
      p2 = null;
    }), ga()), e23[17] ? m2 && (m2.d(1), m2 = null) : m2 ? m2.p(e23, r3) : ((m2 = JH(e23)).c(), m2.m(t2, null)), (!c2 || 262144 & r3[0]) && So(t2, "style", e23[18]);
  }, i: function(e23) {
    c2 || (ya(h2, e23), ya(o2.$$.fragment, e23), ya(v2), ya(p2), c2 = true);
  }, o: function(e23) {
    ba(h2, e23), ba(o2.$$.fragment, e23), ba(v2), ba(p2), c2 = false;
  }, d: function(e23) {
    e23 && po(t2), h2 && h2.d(e23), d2 && d2.d(), Ea(o2), v2 && v2.d(), p2 && p2.d(), m2 && m2.d();
  } };
}
function qH(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2 = !e22[8].readOnly && e22[16] && e22[7] && (Zq(e22[7]) || Xq(e22[7])) && !e22[7].edit && wm(e22[7].focusPath, e22[1]), k2 = [KH, UH], w2 = [];
  function x2(e23, t3) {
    return e23[12] ? 0 : 1;
  }
  i2 = x2(e22), o2 = w2[i2] = k2[i2](e22);
  var j2 = e22[35].identifier, S2 = Gi(j2, e22, e22[36], IH), C2 = !e22[17] && GH();
  function _2(e23, t3) {
    return e23[12] ? YH : QH;
  }
  var $2 = _2(e22), O2 = $2(e22), A2 = b2 && ZH(e22), M2 = e22[15] && (!e22[12] || !e22[15].isChildError) && XH(e22);
  function E2(e23, t3) {
    return e23[12] ? tW : e23[17] ? void 0 : eW;
  }
  var P2 = E2(e22), N2 = P2 && P2(e22), T2 = e22[12] && nW(e22);
  return { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = go("button"), o2.c(), a2 = ko(), S2 && S2.c(), s2 = ko(), C2 && C2.c(), u2 = ko(), c2 = go("div"), l2 = go("div"), O2.c(), f2 = ko(), A2 && A2.c(), h2 = ko(), M2 && M2.c(), d2 = ko(), N2 && N2.c(), v2 = ko(), T2 && T2.c(), p2 = wo(), So(r2, "type", "button"), So(r2, "class", "jse-expand svelte-uj4yd7"), So(r2, "title", "Expand or collapse this object (Ctrl+Click to expand/collapse recursively)"), So(l2, "class", "jse-meta-inner svelte-uj4yd7"), So(c2, "class", "jse-meta svelte-uj4yd7"), So(c2, "data-type", "selectable-value"), So(n2, "class", "jse-header svelte-uj4yd7"), So(t2, "class", "jse-header-outer svelte-uj4yd7"), So(t2, "style", e22[18]);
  }, m: function(o3, b3) {
    vo(o3, t2, b3), uo(t2, n2), uo(n2, r2), w2[i2].m(r2, null), uo(n2, a2), S2 && S2.m(n2, null), uo(n2, s2), C2 && C2.m(n2, null), uo(n2, u2), uo(n2, c2), uo(c2, l2), O2.m(l2, null), uo(n2, f2), A2 && A2.m(n2, null), uo(t2, h2), M2 && M2.m(t2, null), uo(t2, d2), N2 && N2.m(t2, null), vo(o3, v2, b3), T2 && T2.m(o3, b3), vo(o3, p2, b3), m2 = true, g2 || (y2 = xo(r2, "click", e22[22]), g2 = true);
  }, p: function(e23, a3) {
    var s3 = i2;
    (i2 = x2(e23)) === s3 ? w2[i2].p(e23, a3) : (ma(), ba(w2[s3], 1, 1, function() {
      w2[s3] = null;
    }), ga(), (o2 = w2[i2]) ? o2.p(e23, a3) : (o2 = w2[i2] = k2[i2](e23)).c(), ya(o2, 1), o2.m(r2, null)), S2 && S2.p && (!m2 || 32 & a3[1]) && Zi(S2, j2, e23, e23[36], m2 ? Yi(j2, e23[36], a3, TH) : Xi(e23[36]), IH), e23[17] ? C2 && (C2.d(1), C2 = null) : C2 || ((C2 = GH()).c(), C2.m(n2, u2)), $2 === ($2 = _2(e23)) && O2 ? O2.p(e23, a3) : (O2.d(1), (O2 = $2(e23)) && (O2.c(), O2.m(l2, null))), 65922 & a3[0] && (b2 = !e23[8].readOnly && e23[16] && e23[7] && (Zq(e23[7]) || Xq(e23[7])) && !e23[7].edit && wm(e23[7].focusPath, e23[1])), b2 ? A2 ? (A2.p(e23, a3), 65922 & a3[0] && ya(A2, 1)) : ((A2 = ZH(e23)).c(), ya(A2, 1), A2.m(n2, null)) : A2 && (ma(), ba(A2, 1, 1, function() {
      A2 = null;
    }), ga()), !e23[15] || e23[12] && e23[15].isChildError ? M2 && (ma(), ba(M2, 1, 1, function() {
      M2 = null;
    }), ga()) : M2 ? (M2.p(e23, a3), 36864 & a3[0] && ya(M2, 1)) : ((M2 = XH(e23)).c(), ya(M2, 1), M2.m(t2, d2)), P2 === (P2 = E2(e23)) && N2 ? N2.p(e23, a3) : (N2 && N2.d(1), (N2 = P2 && P2(e23)) && (N2.c(), N2.m(t2, null))), (!m2 || 262144 & a3[0]) && So(t2, "style", e23[18]), e23[12] ? T2 ? (T2.p(e23, a3), 4096 & a3[0] && ya(T2, 1)) : ((T2 = nW(e23)).c(), ya(T2, 1), T2.m(p2.parentNode, p2)) : T2 && (ma(), ba(T2, 1, 1, function() {
      T2 = null;
    }), ga());
  }, i: function(e23) {
    m2 || (ya(o2), ya(S2, e23), ya(A2), ya(M2), ya(T2), m2 = true);
  }, o: function(e23) {
    ba(o2), ba(S2, e23), ba(A2), ba(M2), ba(T2), m2 = false;
  }, d: function(e23) {
    e23 && po(t2), w2[i2].d(), S2 && S2.d(e23), C2 && C2.d(), O2.d(), A2 && A2.d(), M2 && M2.d(), N2 && N2.d(), e23 && po(v2), T2 && T2.d(e23), e23 && po(p2), g2 = false, y2();
  } };
}
function FH(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2 = !e22[8].readOnly && e22[16] && e22[7] && (Zq(e22[7]) || Xq(e22[7])) && !e22[7].edit && wm(e22[7].focusPath, e22[1]), k2 = [uW, sW], w2 = [];
  function x2(e23, t3) {
    return e23[12] ? 0 : 1;
  }
  i2 = x2(e22), o2 = w2[i2] = k2[i2](e22);
  var j2 = e22[35].identifier, S2 = Gi(j2, e22, e22[36], LH), C2 = !e22[17] && cW();
  function _2(e23, t3) {
    return e23[12] ? fW : lW;
  }
  var $2 = _2(e22), O2 = $2(e22), A2 = b2 && hW(e22), M2 = e22[15] && (!e22[12] || !e22[15].isChildError) && dW(e22);
  function E2(e23, t3) {
    return e23[12] ? pW : vW;
  }
  var P2 = E2(e22), N2 = P2(e22), T2 = e22[12] && mW(e22);
  return { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = go("button"), o2.c(), a2 = ko(), S2 && S2.c(), s2 = ko(), C2 && C2.c(), u2 = ko(), c2 = go("div"), l2 = go("div"), O2.c(), f2 = ko(), A2 && A2.c(), h2 = ko(), M2 && M2.c(), d2 = ko(), N2.c(), v2 = ko(), T2 && T2.c(), p2 = wo(), So(r2, "type", "button"), So(r2, "class", "jse-expand svelte-uj4yd7"), So(r2, "title", "Expand or collapse this array (Ctrl+Click to expand/collapse recursively)"), So(l2, "class", "jse-meta-inner svelte-uj4yd7"), So(l2, "data-type", "selectable-value"), So(c2, "class", "jse-meta svelte-uj4yd7"), So(n2, "class", "jse-header svelte-uj4yd7"), So(t2, "class", "jse-header-outer svelte-uj4yd7"), So(t2, "style", e22[18]);
  }, m: function(o3, b3) {
    vo(o3, t2, b3), uo(t2, n2), uo(n2, r2), w2[i2].m(r2, null), uo(n2, a2), S2 && S2.m(n2, null), uo(n2, s2), C2 && C2.m(n2, null), uo(n2, u2), uo(n2, c2), uo(c2, l2), O2.m(l2, null), uo(n2, f2), A2 && A2.m(n2, null), uo(t2, h2), M2 && M2.m(t2, null), uo(t2, d2), N2.m(t2, null), vo(o3, v2, b3), T2 && T2.m(o3, b3), vo(o3, p2, b3), m2 = true, g2 || (y2 = xo(r2, "click", e22[22]), g2 = true);
  }, p: function(e23, a3) {
    var s3 = i2;
    (i2 = x2(e23)) === s3 ? w2[i2].p(e23, a3) : (ma(), ba(w2[s3], 1, 1, function() {
      w2[s3] = null;
    }), ga(), (o2 = w2[i2]) ? o2.p(e23, a3) : (o2 = w2[i2] = k2[i2](e23)).c(), ya(o2, 1), o2.m(r2, null)), S2 && S2.p && (!m2 || 32 & a3[1]) && Zi(S2, j2, e23, e23[36], m2 ? Yi(j2, e23[36], a3, zH) : Xi(e23[36]), LH), e23[17] ? C2 && (C2.d(1), C2 = null) : C2 || ((C2 = cW()).c(), C2.m(n2, u2)), $2 === ($2 = _2(e23)) && O2 ? O2.p(e23, a3) : (O2.d(1), (O2 = $2(e23)) && (O2.c(), O2.m(l2, null))), 65922 & a3[0] && (b2 = !e23[8].readOnly && e23[16] && e23[7] && (Zq(e23[7]) || Xq(e23[7])) && !e23[7].edit && wm(e23[7].focusPath, e23[1])), b2 ? A2 ? (A2.p(e23, a3), 65922 & a3[0] && ya(A2, 1)) : ((A2 = hW(e23)).c(), ya(A2, 1), A2.m(n2, null)) : A2 && (ma(), ba(A2, 1, 1, function() {
      A2 = null;
    }), ga()), !e23[15] || e23[12] && e23[15].isChildError ? M2 && (ma(), ba(M2, 1, 1, function() {
      M2 = null;
    }), ga()) : M2 ? (M2.p(e23, a3), 36864 & a3[0] && ya(M2, 1)) : ((M2 = dW(e23)).c(), ya(M2, 1), M2.m(t2, d2)), P2 === (P2 = E2(e23)) && N2 ? N2.p(e23, a3) : (N2.d(1), (N2 = P2(e23)) && (N2.c(), N2.m(t2, null))), (!m2 || 262144 & a3[0]) && So(t2, "style", e23[18]), e23[12] ? T2 ? (T2.p(e23, a3), 4096 & a3[0] && ya(T2, 1)) : ((T2 = mW(e23)).c(), ya(T2, 1), T2.m(p2.parentNode, p2)) : T2 && (ma(), ba(T2, 1, 1, function() {
      T2 = null;
    }), ga());
  }, i: function(e23) {
    m2 || (ya(o2), ya(S2, e23), ya(A2), ya(M2), ya(T2), m2 = true);
  }, o: function(e23) {
    ba(o2), ba(S2, e23), ba(A2), ba(M2), ba(T2), m2 = false;
  }, d: function(e23) {
    e23 && po(t2), w2[i2].d(), S2 && S2.d(e23), C2 && C2.d(), O2.d(), A2 && A2.d(), M2 && M2.d(), N2.d(), e23 && po(v2), T2 && T2.d(e23), e23 && po(p2), g2 = false, y2();
  } };
}
function VH(e22) {
  var t2;
  return { c: function() {
    (t2 = go("div")).textContent = ":", So(t2, "class", "jse-separator svelte-uj4yd7");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function HH(e22) {
  var t2, n2, r2;
  return n2 = new WV({ props: { selected: true, onContextMenu: e22[8].onContextMenu } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-context-menu-button-anchor svelte-uj4yd7");
  }, m: function(e23, i2) {
    vo(e23, t2, i2), Ma(n2, t2, null), r2 = true;
  }, p: function(e23, t3) {
    var r3 = {};
    256 & t3[0] && (r3.onContextMenu = e23[8].onContextMenu), n2.$set(r3);
  }, i: function(e23) {
    r2 || (ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2);
  } };
}
function WH(e22) {
  var t2, n2;
  return t2 = new AH({ props: { validationError: e22[15], onExpand: e22[23] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    32768 & n3[0] && (r2.validationError = e23[15]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function JH(e22) {
  var t2, n2, r2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-insert-selection-area jse-after svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-after");
  }, m: function(i2, o2) {
    vo(i2, t2, o2), n2 || (r2 = xo(t2, "click", e22[31]), n2 = true);
  }, p: Bi, d: function(e23) {
    e23 && po(t2), n2 = false, r2();
  } };
}
function UH(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: oj } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: Bi, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function KH(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: ij } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: Bi, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function GH(e22) {
  var t2;
  return { c: function() {
    (t2 = go("div")).textContent = ":", So(t2, "class", "jse-separator svelte-uj4yd7");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function QH(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2 = Object.keys(e22[0]).length + "", h2 = Object.keys(e22[0]).length === 1 ? "prop" : "props";
  return { c: function() {
    (t2 = go("div")).textContent = "{", n2 = ko(), r2 = go("button"), i2 = bo(f2), o2 = ko(), a2 = bo(h2), s2 = ko(), (u2 = go("div")).textContent = "}", So(t2, "class", "jse-bracket svelte-uj4yd7"), So(r2, "type", "button"), So(r2, "class", "jse-tag svelte-uj4yd7"), So(u2, "class", "jse-bracket svelte-uj4yd7");
  }, m: function(f3, h3) {
    vo(f3, t2, h3), vo(f3, n2, h3), vo(f3, r2, h3), uo(r2, i2), uo(r2, o2), uo(r2, a2), vo(f3, s2, h3), vo(f3, u2, h3), c2 || (l2 = xo(r2, "click", e22[23]), c2 = true);
  }, p: function(e23, t3) {
    1 & t3[0] && f2 !== (f2 = Object.keys(e23[0]).length + "") && Ao(i2, f2), 1 & t3[0] && h2 !== (h2 = Object.keys(e23[0]).length === 1 ? "prop" : "props") && Ao(a2, h2);
  }, d: function(e23) {
    e23 && po(t2), e23 && po(n2), e23 && po(r2), e23 && po(s2), e23 && po(u2), c2 = false, l2();
  } };
}
function YH(e22) {
  var t2;
  return { c: function() {
    (t2 = go("div")).textContent = "{", So(t2, "class", "jse-bracket jse-expanded svelte-uj4yd7");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, p: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function ZH(e22) {
  var t2, n2, r2;
  return n2 = new WV({ props: { selected: true, onContextMenu: e22[8].onContextMenu } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-context-menu-button-anchor svelte-uj4yd7");
  }, m: function(e23, i2) {
    vo(e23, t2, i2), Ma(n2, t2, null), r2 = true;
  }, p: function(e23, t3) {
    var r3 = {};
    256 & t3[0] && (r3.onContextMenu = e23[8].onContextMenu), n2.$set(r3);
  }, i: function(e23) {
    r2 || (ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2);
  } };
}
function XH(e22) {
  var t2, n2;
  return t2 = new AH({ props: { validationError: e22[15], onExpand: e22[23] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    32768 & n3[0] && (r2.validationError = e23[15]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function eW(e22) {
  var t2, n2, r2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-insert-selection-area jse-after svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-after");
  }, m: function(i2, o2) {
    vo(i2, t2, o2), n2 || (r2 = xo(t2, "click", e22[31]), n2 = true);
  }, p: Bi, d: function(e23) {
    e23 && po(t2), n2 = false, r2();
  } };
}
function tW(e22) {
  var t2, n2, r2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-insert-selection-area jse-inside svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-inside");
  }, m: function(i2, o2) {
    vo(i2, t2, o2), n2 || (r2 = xo(t2, "click", e22[30]), n2 = true);
  }, p: Bi, d: function(e23) {
    e23 && po(t2), n2 = false, r2();
  } };
}
function nW(e22) {
  for (var t2, n2, r2, i2, o2, a2, s2, u2 = !e22[8].readOnly && (e22[10] === "hover-insert-inside" || e22[16] && Qq(e22[7])), c2 = u2 && rW(e22), l2 = e22[20](e22[1], e22[0], e22[2], e22[3], e22[4], e22[5], e22[6], e22[7], e22[11]), f2 = [], h2 = 0; h2 < l2.length; h2 += 1)
    f2[h2] = oW(NH(e22, l2, h2));
  var d2 = function(e23) {
    return ba(f2[e23], 1, 1, function() {
      f2[e23] = null;
    });
  }, v2 = !e22[17] && aW(e22);
  return { c: function() {
    t2 = go("div"), c2 && c2.c(), n2 = ko();
    for (var s3 = 0; s3 < f2.length; s3 += 1)
      f2[s3].c();
    r2 = ko(), i2 = go("div"), (o2 = go("div")).innerHTML = '<div class="jse-bracket svelte-uj4yd7">}</div>', a2 = ko(), v2 && v2.c(), So(t2, "class", "jse-props svelte-uj4yd7"), So(o2, "data-type", "selectable-value"), So(o2, "class", "jse-footer svelte-uj4yd7"), So(i2, "class", "jse-footer-outer svelte-uj4yd7"), So(i2, "style", e22[18]);
  }, m: function(e23, u3) {
    vo(e23, t2, u3), c2 && c2.m(t2, null), uo(t2, n2);
    for (var l3 = 0; l3 < f2.length; l3 += 1)
      f2[l3].m(t2, null);
    vo(e23, r2, u3), vo(e23, i2, u3), uo(i2, o2), uo(i2, a2), v2 && v2.m(i2, null), s2 = true;
  }, p: function(e23, r3) {
    if (66944 & r3[0] && (u2 = !e23[8].readOnly && (e23[10] === "hover-insert-inside" || e23[16] && Qq(e23[7]))), u2 ? c2 ? (c2.p(e23, r3), 66944 & r3[0] && ya(c2, 1)) : ((c2 = rW(e23)).c(), ya(c2, 1), c2.m(t2, n2)) : c2 && (ma(), ba(c2, 1, 1, function() {
      c2 = null;
    }), ga()), 152046079 & r3[0]) {
      var o3;
      for (l2 = e23[20](e23[1], e23[0], e23[2], e23[3], e23[4], e23[5], e23[6], e23[7], e23[11]), o3 = 0; o3 < l2.length; o3 += 1) {
        var a3 = NH(e23, l2, o3);
        f2[o3] ? (f2[o3].p(a3, r3), ya(f2[o3], 1)) : (f2[o3] = oW(a3), f2[o3].c(), ya(f2[o3], 1), f2[o3].m(t2, null));
      }
      for (ma(), o3 = l2.length; o3 < f2.length; o3 += 1)
        d2(o3);
      ga();
    }
    e23[17] ? v2 && (v2.d(1), v2 = null) : v2 ? v2.p(e23, r3) : ((v2 = aW(e23)).c(), v2.m(i2, null)), (!s2 || 262144 & r3[0]) && So(i2, "style", e23[18]);
  }, i: function(e23) {
    if (!s2) {
      ya(c2);
      for (var t3 = 0; t3 < l2.length; t3 += 1)
        ya(f2[t3]);
      s2 = true;
    }
  }, o: function(e23) {
    ba(c2), f2 = f2.filter(Boolean);
    for (var t3 = 0; t3 < f2.length; t3 += 1)
      ba(f2[t3]);
    s2 = false;
  }, d: function(e23) {
    e23 && po(t2), c2 && c2.d(), mo(f2, e23), e23 && po(r2), e23 && po(i2), v2 && v2.d();
  } };
}
function rW(e22) {
  var t2, n2, r2, i2;
  return n2 = new WV({ props: { selected: e22[16] && Qq(e22[7]), onContextMenu: e22[32] } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-insert-area jse-inside svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-inside"), So(t2, "style", r2 = CW(e22[1].length + 1)), So(t2, "title", ts), To(t2, "jse-hovered", e22[10] === "hover-insert-inside"), To(t2, "jse-selected", e22[16] && Qq(e22[7]));
  }, m: function(e23, r3) {
    vo(e23, t2, r3), Ma(n2, t2, null), i2 = true;
  }, p: function(e23, o2) {
    var a2 = {};
    65664 & o2[0] && (a2.selected = e23[16] && Qq(e23[7])), n2.$set(a2), (!i2 || 2 & o2[0] && r2 !== (r2 = CW(e23[1].length + 1))) && So(t2, "style", r2), 1024 & o2[0] && To(t2, "jse-hovered", e23[10] === "hover-insert-inside"), 65664 & o2[0] && To(t2, "jse-selected", e23[16] && Qq(e23[7]));
  }, i: function(e23) {
    i2 || (ya(n2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2);
  } };
}
function iW(e22) {
  var t2, n2, r2, i2;
  return n2 = new hH({ props: { path: e22[54].path, pointer: e22[54].pointer, key: e22[54].key, selection: e22[54].selection, searchResultItems: e22[54].keySearchResultItemsMap, context: e22[8], onUpdateKey: e22[24] } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), r2 = ko(), So(t2, "slot", "identifier"), So(t2, "class", "jse-identifier svelte-uj4yd7");
  }, m: function(e23, o2) {
    vo(e23, t2, o2), Ma(n2, t2, null), uo(t2, r2), i2 = true;
  }, p: function(e23, t3) {
    var r3 = {};
    2303 & t3[0] && (r3.path = e23[54].path), 2303 & t3[0] && (r3.pointer = e23[54].pointer), 2303 & t3[0] && (r3.key = e23[54].key), 2303 & t3[0] && (r3.selection = e23[54].selection), 2303 & t3[0] && (r3.searchResultItems = e23[54].keySearchResultItemsMap), 256 & t3[0] && (r3.context = e23[8]), n2.$set(r3);
  }, i: function(e23) {
    i2 || (ya(n2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2);
  } };
}
function oW(e22) {
  var t2, n2;
  return t2 = new $W({ props: { value: e22[54].value, path: e22[54].path, expandedMap: e22[54].expandedMap, enforceStringMap: e22[54].enforceStringMap, visibleSectionsMap: e22[54].visibleSectionsMap, validationErrorsMap: e22[54].validationErrorsMap, searchResultItemsMap: e22[54].valueSearchResultItemsMap, selection: e22[54].selection, context: e22[8], onDragSelectionStart: e22[27], $$slots: { identifier: [iW] }, $$scope: { ctx: e22 } } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    2303 & n3[0] && (r2.value = e23[54].value), 2303 & n3[0] && (r2.path = e23[54].path), 2303 & n3[0] && (r2.expandedMap = e23[54].expandedMap), 2303 & n3[0] && (r2.enforceStringMap = e23[54].enforceStringMap), 2303 & n3[0] && (r2.visibleSectionsMap = e23[54].visibleSectionsMap), 2303 & n3[0] && (r2.validationErrorsMap = e23[54].validationErrorsMap), 2303 & n3[0] && (r2.searchResultItemsMap = e23[54].valueSearchResultItemsMap), 2303 & n3[0] && (r2.selection = e23[54].selection), 256 & n3[0] && (r2.context = e23[8]), 2559 & n3[0] | 32 & n3[1] && (r2.$$scope = { dirty: n3, ctx: e23 }), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function aW(e22) {
  var t2, n2, r2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-insert-selection-area jse-after svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-after");
  }, m: function(i2, o2) {
    vo(i2, t2, o2), n2 || (r2 = xo(t2, "click", e22[31]), n2 = true);
  }, p: Bi, d: function(e23) {
    e23 && po(t2), n2 = false, r2();
  } };
}
function sW(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: oj } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: Bi, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function uW(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: ij } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: Bi, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function cW(e22) {
  var t2;
  return { c: function() {
    (t2 = go("div")).textContent = ":", So(t2, "class", "jse-separator svelte-uj4yd7");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function lW(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2 = e22[0].length + "", h2 = e22[0].length === 1 ? "item" : "items";
  return { c: function() {
    (t2 = go("div")).textContent = "[", n2 = ko(), r2 = go("button"), i2 = bo(f2), o2 = ko(), a2 = bo(h2), s2 = ko(), (u2 = go("div")).textContent = "]", So(t2, "class", "jse-bracket svelte-uj4yd7"), So(r2, "type", "button"), So(r2, "class", "jse-tag svelte-uj4yd7"), So(u2, "class", "jse-bracket svelte-uj4yd7");
  }, m: function(f3, h3) {
    vo(f3, t2, h3), vo(f3, n2, h3), vo(f3, r2, h3), uo(r2, i2), uo(r2, o2), uo(r2, a2), vo(f3, s2, h3), vo(f3, u2, h3), c2 || (l2 = xo(r2, "click", e22[23]), c2 = true);
  }, p: function(e23, t3) {
    1 & t3[0] && f2 !== (f2 = e23[0].length + "") && Ao(i2, f2), 1 & t3[0] && h2 !== (h2 = e23[0].length === 1 ? "item" : "items") && Ao(a2, h2);
  }, d: function(e23) {
    e23 && po(t2), e23 && po(n2), e23 && po(r2), e23 && po(s2), e23 && po(u2), c2 = false, l2();
  } };
}
function fW(e22) {
  var t2, n2, r2, i2, o2, a2, s2 = e22[0].length + "", u2 = e22[0].length === 1 ? "item" : "items";
  return { c: function() {
    (t2 = go("div")).textContent = "[", n2 = ko(), r2 = go("span"), i2 = bo(s2), o2 = ko(), a2 = bo(u2), So(t2, "class", "jse-bracket svelte-uj4yd7"), So(r2, "class", "jse-tag jse-expanded svelte-uj4yd7");
  }, m: function(e23, s3) {
    vo(e23, t2, s3), vo(e23, n2, s3), vo(e23, r2, s3), uo(r2, i2), uo(r2, o2), uo(r2, a2);
  }, p: function(e23, t3) {
    1 & t3[0] && s2 !== (s2 = e23[0].length + "") && Ao(i2, s2), 1 & t3[0] && u2 !== (u2 = e23[0].length === 1 ? "item" : "items") && Ao(a2, u2);
  }, d: function(e23) {
    e23 && po(t2), e23 && po(n2), e23 && po(r2);
  } };
}
function hW(e22) {
  var t2, n2, r2;
  return n2 = new WV({ props: { selected: true, onContextMenu: e22[8].onContextMenu } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-context-menu-button-anchor svelte-uj4yd7");
  }, m: function(e23, i2) {
    vo(e23, t2, i2), Ma(n2, t2, null), r2 = true;
  }, p: function(e23, t3) {
    var r3 = {};
    256 & t3[0] && (r3.onContextMenu = e23[8].onContextMenu), n2.$set(r3);
  }, i: function(e23) {
    r2 || (ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2);
  } };
}
function dW(e22) {
  var t2, n2;
  return t2 = new AH({ props: { validationError: e22[15], onExpand: e22[23] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    32768 & n3[0] && (r2.validationError = e23[15]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function vW(e22) {
  var t2, n2, r2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-insert-selection-area jse-after svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-after");
  }, m: function(i2, o2) {
    vo(i2, t2, o2), n2 || (r2 = xo(t2, "click", e22[31]), n2 = true);
  }, p: Bi, d: function(e23) {
    e23 && po(t2), n2 = false, r2();
  } };
}
function pW(e22) {
  var t2, n2, r2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-insert-selection-area jse-inside svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-inside");
  }, m: function(i2, o2) {
    vo(i2, t2, o2), n2 || (r2 = xo(t2, "click", e22[30]), n2 = true);
  }, p: Bi, d: function(e23) {
    e23 && po(t2), n2 = false, r2();
  } };
}
function mW(e22) {
  for (var t2, n2, r2, i2, o2, a2, s2, u2 = !e22[8].readOnly && (e22[10] === "hover-insert-inside" || e22[16] && Qq(e22[7])), c2 = [], l2 = /* @__PURE__ */ new Map(), f2 = u2 && gW(e22), h2 = e22[14] || Ya, d2 = function(e23) {
    return e23[50];
  }, v2 = 0; v2 < h2.length; v2 += 1) {
    var p2 = RH(e22, h2, v2), m2 = d2(p2);
    l2.set(m2, c2[v2] = wW(m2, p2));
  }
  var g2 = !e22[17] && xW(e22);
  return { c: function() {
    t2 = go("div"), f2 && f2.c(), n2 = ko();
    for (var s3 = 0; s3 < c2.length; s3 += 1)
      c2[s3].c();
    r2 = ko(), i2 = go("div"), (o2 = go("div")).innerHTML = '<span class="jse-bracket svelte-uj4yd7">]</span>', a2 = ko(), g2 && g2.c(), So(t2, "class", "jse-items svelte-uj4yd7"), So(o2, "data-type", "selectable-value"), So(o2, "class", "jse-footer svelte-uj4yd7"), So(i2, "class", "jse-footer-outer svelte-uj4yd7"), So(i2, "style", e22[18]);
  }, m: function(e23, u3) {
    vo(e23, t2, u3), f2 && f2.m(t2, null), uo(t2, n2);
    for (var l3 = 0; l3 < c2.length; l3 += 1)
      c2[l3].m(t2, null);
    vo(e23, r2, u3), vo(e23, i2, u3), uo(i2, o2), uo(i2, a2), g2 && g2.m(i2, null), s2 = true;
  }, p: function(e23, r3) {
    66944 & r3[0] && (u2 = !e23[8].readOnly && (e23[10] === "hover-insert-inside" || e23[16] && Qq(e23[7]))), u2 ? f2 ? (f2.p(e23, r3), 66944 & r3[0] && ya(f2, 1)) : ((f2 = gW(e23)).c(), ya(f2, 1), f2.m(t2, n2)) : f2 && (ma(), ba(f2, 1, 1, function() {
      f2 = null;
    }), ga()), 136334335 & r3[0] && (h2 = e23[14] || Ya, ma(), c2 = Ca(c2, r3, d2, 1, e23, h2, l2, t2, Sa, wW, null, RH), ga()), e23[17] ? g2 && (g2.d(1), g2 = null) : g2 ? g2.p(e23, r3) : ((g2 = xW(e23)).c(), g2.m(i2, null)), (!s2 || 262144 & r3[0]) && So(i2, "style", e23[18]);
  }, i: function(e23) {
    if (!s2) {
      ya(f2);
      for (var t3 = 0; t3 < h2.length; t3 += 1)
        ya(c2[t3]);
      s2 = true;
    }
  }, o: function(e23) {
    ba(f2);
    for (var t3 = 0; t3 < c2.length; t3 += 1)
      ba(c2[t3]);
    s2 = false;
  }, d: function(e23) {
    e23 && po(t2), f2 && f2.d();
    for (var n3 = 0; n3 < c2.length; n3 += 1)
      c2[n3].d();
    e23 && po(r2), e23 && po(i2), g2 && g2.d();
  } };
}
function gW(e22) {
  var t2, n2, r2, i2;
  return n2 = new WV({ props: { selected: e22[16] && Qq(e22[7]), onContextMenu: e22[32] } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-insert-area jse-inside svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-inside"), So(t2, "style", r2 = CW(e22[1].length + 1)), So(t2, "title", ts), To(t2, "jse-hovered", e22[10] === "hover-insert-inside"), To(t2, "jse-selected", e22[16] && Qq(e22[7]));
  }, m: function(e23, r3) {
    vo(e23, t2, r3), Ma(n2, t2, null), i2 = true;
  }, p: function(e23, o2) {
    var a2 = {};
    65664 & o2[0] && (a2.selected = e23[16] && Qq(e23[7])), n2.$set(a2), (!i2 || 2 & o2[0] && r2 !== (r2 = CW(e23[1].length + 1))) && So(t2, "style", r2), 1024 & o2[0] && To(t2, "jse-hovered", e23[10] === "hover-insert-inside"), 65664 & o2[0] && To(t2, "jse-selected", e23[16] && Qq(e23[7]));
  }, i: function(e23) {
    i2 || (ya(n2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2);
  } };
}
function yW(e22) {
  var t2, n2, r2, i2 = e22[51].index + "";
  return { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = bo(i2), So(n2, "class", "jse-index svelte-uj4yd7"), So(t2, "slot", "identifier"), So(t2, "class", "jse-identifier svelte-uj4yd7");
  }, m: function(e23, i3) {
    vo(e23, t2, i3), uo(t2, n2), uo(n2, r2);
  }, p: function(e23, t3) {
    18687 & t3[0] && i2 !== (i2 = e23[51].index + "") && Ao(r2, i2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function bW(e22, t2) {
  var n2, r2, i2;
  return r2 = new $W({ props: { value: t2[51].value, path: t2[51].path, expandedMap: t2[51].expandedMap, enforceStringMap: t2[51].enforceStringMap, visibleSectionsMap: t2[51].visibleSectionsMap, validationErrorsMap: t2[51].validationErrorsMap, searchResultItemsMap: t2[51].searchResultItemsMap, selection: t2[51].selection, context: t2[8], onDragSelectionStart: t2[27], $$slots: { identifier: [yW] }, $$scope: { ctx: t2 } } }), { key: e22, first: null, c: function() {
    n2 = wo(), Aa(r2.$$.fragment), this.first = n2;
  }, m: function(e23, t3) {
    vo(e23, n2, t3), Ma(r2, e23, t3), i2 = true;
  }, p: function(e23, n3) {
    t2 = e23;
    var i3 = {};
    18687 & n3[0] && (i3.value = t2[51].value), 18687 & n3[0] && (i3.path = t2[51].path), 18687 & n3[0] && (i3.expandedMap = t2[51].expandedMap), 18687 & n3[0] && (i3.enforceStringMap = t2[51].enforceStringMap), 18687 & n3[0] && (i3.visibleSectionsMap = t2[51].visibleSectionsMap), 18687 & n3[0] && (i3.validationErrorsMap = t2[51].validationErrorsMap), 18687 & n3[0] && (i3.searchResultItemsMap = t2[51].searchResultItemsMap), 18687 & n3[0] && (i3.selection = t2[51].selection), 256 & n3[0] && (i3.context = t2[8]), 18687 & n3[0] | 32 & n3[1] && (i3.$$scope = { dirty: n3, ctx: t2 }), r2.$set(i3);
  }, i: function(e23) {
    i2 || (ya(r2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    ba(r2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(n2), Ea(r2, e23);
  } };
}
function kW(e22) {
  var t2, n2;
  return t2 = new qV({ props: { visibleSections: e22[14] || Ya, sectionIndex: e22[50], total: e22[0].length, path: e22[1], pointer: e22[9], onExpandSection: e22[8].onExpandSection, selection: e22[7] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    16384 & n3[0] && (r2.visibleSections = e23[14] || Ya), 16384 & n3[0] && (r2.sectionIndex = e23[50]), 1 & n3[0] && (r2.total = e23[0].length), 2 & n3[0] && (r2.path = e23[1]), 512 & n3[0] && (r2.pointer = e23[9]), 256 & n3[0] && (r2.onExpandSection = e23[8].onExpandSection), 128 & n3[0] && (r2.selection = e23[7]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function wW(e22, t2) {
  for (var n2, r2, i2, o2, a2 = [], s2 = /* @__PURE__ */ new Map(), u2 = t2[21](t2[1], t2[0], t2[48], t2[2], t2[3], t2[4], t2[5], t2[6], t2[7], t2[11]), c2 = function(e23) {
    return e23[51].index;
  }, l2 = 0; l2 < u2.length; l2 += 1) {
    var f2 = DH(t2, u2, l2), h2 = c2(f2);
    s2.set(h2, a2[l2] = bW(h2, f2));
  }
  var d2 = t2[48].end < t2[0].length && kW(t2);
  return { key: e22, first: null, c: function() {
    n2 = wo();
    for (var e23 = 0; e23 < a2.length; e23 += 1)
      a2[e23].c();
    r2 = ko(), d2 && d2.c(), i2 = wo(), this.first = n2;
  }, m: function(e23, t3) {
    vo(e23, n2, t3);
    for (var s3 = 0; s3 < a2.length; s3 += 1)
      a2[s3].m(e23, t3);
    vo(e23, r2, t3), d2 && d2.m(e23, t3), vo(e23, i2, t3), o2 = true;
  }, p: function(e23, n3) {
    t2 = e23, 136333823 & n3[0] && (u2 = t2[21](t2[1], t2[0], t2[48], t2[2], t2[3], t2[4], t2[5], t2[6], t2[7], t2[11]), ma(), a2 = Ca(a2, n3, c2, 1, t2, u2, s2, r2.parentNode, Sa, bW, r2, DH), ga()), t2[48].end < t2[0].length ? d2 ? (d2.p(t2, n3), 16385 & n3[0] && ya(d2, 1)) : ((d2 = kW(t2)).c(), ya(d2, 1), d2.m(i2.parentNode, i2)) : d2 && (ma(), ba(d2, 1, 1, function() {
      d2 = null;
    }), ga());
  }, i: function(e23) {
    if (!o2) {
      for (var t3 = 0; t3 < u2.length; t3 += 1)
        ya(a2[t3]);
      ya(d2), o2 = true;
    }
  }, o: function(e23) {
    for (var t3 = 0; t3 < a2.length; t3 += 1)
      ba(a2[t3]);
    ba(d2), o2 = false;
  }, d: function(e23) {
    e23 && po(n2);
    for (var t3 = 0; t3 < a2.length; t3 += 1)
      a2[t3].d(e23);
    e23 && po(r2), d2 && d2.d(e23), e23 && po(i2);
  } };
}
function xW(e22) {
  var t2, n2, r2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-insert-selection-area jse-after svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-after");
  }, m: function(i2, o2) {
    vo(i2, t2, o2), n2 || (r2 = xo(t2, "click", e22[31]), n2 = true);
  }, p: Bi, d: function(e23) {
    e23 && po(t2), n2 = false, r2();
  } };
}
function jW(e22) {
  var t2, n2, r2;
  return n2 = new WV({ props: { selected: e22[16] && Gq(e22[7]), onContextMenu: e22[33] } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-insert-area jse-after svelte-uj4yd7"), So(t2, "data-type", "insert-selection-area-after"), So(t2, "style", e22[18]), So(t2, "title", ts), To(t2, "jse-hovered", e22[10] === "hover-insert-after"), To(t2, "jse-selected", e22[16] && Gq(e22[7]));
  }, m: function(e23, i2) {
    vo(e23, t2, i2), Ma(n2, t2, null), r2 = true;
  }, p: function(e23, i2) {
    var o2 = {};
    65664 & i2[0] && (o2.selected = e23[16] && Gq(e23[7])), n2.$set(o2), (!r2 || 262144 & i2[0]) && So(t2, "style", e23[18]), 1024 & i2[0] && To(t2, "jse-hovered", e23[10] === "hover-insert-after"), 65664 & i2[0] && To(t2, "jse-selected", e23[16] && Gq(e23[7]));
  }, i: function(e23) {
    r2 || (ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2);
  } };
}
function SW(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2 = !e22[8].readOnly && (e22[10] === "hover-insert-after" || e22[16] && Gq(e22[7])), f2 = [FH, qH, BH], h2 = [];
  function d2(e23, t3) {
    return e23[19] === "array" ? 0 : e23[19] === "object" ? 1 : 2;
  }
  n2 = d2(e22), r2 = h2[n2] = f2[n2](e22);
  var v2 = l2 && jW(e22);
  return { c: function() {
    t2 = go("div"), r2.c(), i2 = ko(), v2 && v2.c(), So(t2, "class", o2 = eo(NV("jse-json-node", { "jse-expanded": e22[12] }, e22[8].onClassName(e22[1], e22[0]))) + " svelte-uj4yd7"), So(t2, "data-path", a2 = Px(e22[1])), To(t2, "jse-root", e22[17]), To(t2, "jse-selected", e22[16] && Xq(e22[7])), To(t2, "jse-selected-key", e22[16] && Yq(e22[7])), To(t2, "jse-selected-value", e22[16] && Zq(e22[7])), To(t2, "jse-hovered", e22[10] === "hover-collection");
  }, m: function(r3, o3) {
    vo(r3, t2, o3), h2[n2].m(t2, null), uo(t2, i2), v2 && v2.m(t2, null), s2 = true, u2 || (c2 = [xo(t2, "mousedown", e22[25]), xo(t2, "mousemove", e22[26]), xo(t2, "mouseover", e22[28]), xo(t2, "mouseout", e22[29]), xo(t2, "focus", void 0), xo(t2, "blur", void 0)], u2 = true);
  }, p: function(e23, u3) {
    var c3 = n2;
    (n2 = d2(e23)) === c3 ? h2[n2].p(e23, u3) : (ma(), ba(h2[c3], 1, 1, function() {
      h2[c3] = null;
    }), ga(), (r2 = h2[n2]) ? r2.p(e23, u3) : (r2 = h2[n2] = f2[n2](e23)).c(), ya(r2, 1), r2.m(t2, i2)), 66944 & u3[0] && (l2 = !e23[8].readOnly && (e23[10] === "hover-insert-after" || e23[16] && Gq(e23[7]))), l2 ? v2 ? (v2.p(e23, u3), 66944 & u3[0] && ya(v2, 1)) : ((v2 = jW(e23)).c(), ya(v2, 1), v2.m(t2, null)) : v2 && (ma(), ba(v2, 1, 1, function() {
      v2 = null;
    }), ga()), (!s2 || 4355 & u3[0] && o2 !== (o2 = eo(NV("jse-json-node", { "jse-expanded": e23[12] }, e23[8].onClassName(e23[1], e23[0]))) + " svelte-uj4yd7")) && So(t2, "class", o2), (!s2 || 2 & u3[0] && a2 !== (a2 = Px(e23[1]))) && So(t2, "data-path", a2), 135427 & u3[0] && To(t2, "jse-root", e23[17]), 70019 & u3[0] && To(t2, "jse-selected", e23[16] && Xq(e23[7])), 70019 & u3[0] && To(t2, "jse-selected-key", e23[16] && Yq(e23[7])), 70019 & u3[0] && To(t2, "jse-selected-value", e23[16] && Zq(e23[7])), 5379 & u3[0] && To(t2, "jse-hovered", e23[10] === "hover-collection");
  }, i: function(e23) {
    s2 || (ya(r2), ya(v2), s2 = true);
  }, o: function(e23) {
    ba(r2), ba(v2), s2 = false;
  }, d: function(e23) {
    e23 && po(t2), h2[n2].d(), v2 && v2.d(), u2 = false, Wi(c2);
  } };
}
function CW(e22) {
  return "margin-left: calc(".concat(e22, " * var(--jse-indent-size))");
}
function _W(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2, l2, f2, h2 = t2.$$slots, d2 = h2 === void 0 ? {} : h2, v2 = t2.$$scope, p2 = t2.value, m2 = t2.path, g2 = t2.expandedMap, y2 = t2.enforceStringMap, b2 = t2.visibleSectionsMap, k2 = t2.validationErrorsMap, w2 = t2.searchResultItemsMap, x2 = t2.selection, j2 = t2.context, S2 = t2.onDragSelectionStart, C2 = Ia("jsoneditor:JSONNode"), _2 = void 0, $2 = void 0, O2 = void 0, A2 = Il(function(e23) {
    return e23;
  }, uS);
  function M2(e23) {
    j2.onDrag(e23);
  }
  function E2(e23) {
    yH.selecting && (yH.selecting = false, e23.stopPropagation()), j2.onDragEnd(), document.removeEventListener("mousemove", M2, true), document.removeEventListener("mouseup", E2);
  }
  function P2() {
    var e23, t3;
    return ((t3 = (e23 = j2.findElement([])) === null || e23 === void 0 ? void 0 : e23.getBoundingClientRect()) === null || t3 === void 0 ? void 0 : t3.top) || 0;
  }
  function N2(e23, t3) {
    var n3 = P2() - e23.initialContentTop;
    return t3.clientY - e23.initialClientY - n3;
  }
  function T2(e23) {
    if (O2) {
      var t3 = j2.getJson(), r3 = j2.getDocumentState(), i3 = N2(O2, e23), o3 = bH({ json: t3, documentState: r3, deltaY: i3, items: O2.items }).offset;
      o3 !== O2.offset && (C2("drag selection", o3, i3), n2(11, O2 = Ei(Ei({}, O2), {}, { offset: o3, didMoveItems: true })));
    }
  }
  function I2(e23) {
    if (O2) {
      var t3 = j2.getJson(), r3 = bH({ json: t3, documentState: j2.getDocumentState(), deltaY: N2(O2, e23), items: O2.items }), i3 = r3.operations, o3 = r3.updatedSelection;
      if (i3)
        j2.onPatch(i3, function(e24, t4) {
          return { state: Ei(Ei({}, t4), {}, { selection: o3 || x2 }) };
        });
      else if (e23.target === O2.initialTarget && !O2.didMoveItems) {
        var a3 = Ex(e23.target), s3 = Nx(e23.target);
        s3 && j2.onSelect(SF(t3, a3, s3));
      }
      n2(11, O2 = void 0), yH.dragging = false, document.removeEventListener("mousemove", T2, true), document.removeEventListener("mouseup", I2);
    }
  }
  return e22.$$set = function(e23) {
    "value" in e23 && n2(0, p2 = e23.value), "path" in e23 && n2(1, m2 = e23.path), "expandedMap" in e23 && n2(2, g2 = e23.expandedMap), "enforceStringMap" in e23 && n2(3, y2 = e23.enforceStringMap), "visibleSectionsMap" in e23 && n2(4, b2 = e23.visibleSectionsMap), "validationErrorsMap" in e23 && n2(5, k2 = e23.validationErrorsMap), "searchResultItemsMap" in e23 && n2(6, w2 = e23.searchResultItemsMap), "selection" in e23 && n2(7, x2 = e23.selection), "context" in e23 && n2(8, j2 = e23.context), "onDragSelectionStart" in e23 && n2(34, S2 = e23.onDragSelectionStart), "$$scope" in e23 && n2(36, v2 = e23.$$scope);
  }, e22.$$.update = function() {
    2 & e22.$$.dirty[0] && n2(9, a2 = cs.exports.compileJSONPointer(m2)), 516 & e22.$$.dirty[0] && n2(12, s2 = !!g2 && g2[a2] === true), 521 & e22.$$.dirty[0] && n2(13, u2 = zq(p2, y2, a2)), 528 & e22.$$.dirty[0] && n2(14, c2 = b2 ? b2[a2] : void 0), 544 & e22.$$.dirty[0] && n2(15, l2 = k2 ? k2[a2] : void 0), 640 & e22.$$.dirty[0] && n2(16, f2 = !!x2 && x2.pointersMap[a2] === true), 2 & e22.$$.dirty[0] && n2(17, r2 = m2.length === 0), 1 & e22.$$.dirty[0] && n2(19, i2 = Ms(p2)), 2 & e22.$$.dirty[0] && n2(18, o2 = CW(m2.length));
  }, [p2, m2, g2, y2, b2, k2, w2, x2, j2, a2, _2, O2, s2, u2, c2, l2, f2, r2, o2, i2, function(e23, t3, n3, r3, i3, o3, s3, u3, c3) {
    var l3 = Object.keys(t3).map(function(c4) {
      var l4 = cs.exports.appendToJSONPointer(a2, c4);
      return { key: c4, value: t3[c4], path: A2(e23.concat(c4)), pointer: l4, expandedMap: kH(n3, l4), enforceStringMap: kH(r3, l4), visibleSectionsMap: kH(i3, l4), validationErrorsMap: kH(o3, l4), keySearchResultItemsMap: HF(s3, l4), valueSearchResultItemsMap: kH(s3, l4), selection: CF(u3, l4) };
    });
    return c3 && c3.offset !== 0 && (l3 = Hw(l3, c3.selectionStartIndex, c3.selectionItemsCount, c3.offset)), l3;
  }, function(e23, t3, n3, r3, i3, o3, s3, u3, c3, l3) {
    for (var f3 = n3.start, h3 = Math.min(n3.end, t3.length), d3 = [], v3 = f3; v3 < h3; v3++) {
      var p3 = cs.exports.appendToJSONPointer(a2, v3);
      d3.push({ index: v3, value: t3[v3], path: A2(e23.concat(String(v3))), pointer: p3, expandedMap: kH(r3, p3), enforceStringMap: kH(i3, p3), visibleSectionsMap: kH(o3, p3), validationErrorsMap: kH(s3, p3), searchResultItemsMap: kH(u3, p3), selection: CF(c3, p3) });
    }
    if (l3 && l3.offset !== 0) {
      var m3 = d3.map(function(e24) {
        return e24.index;
      });
      d3 = Hw(d3, l3.selectionStartIndex, l3.selectionItemsCount, l3.offset);
      for (var g3 = 0; g3 < d3.length; g3++)
        d3[g3].index = m3[g3];
    }
    return d3;
  }, function(e23) {
    e23.stopPropagation();
    var t3 = e23.ctrlKey;
    j2.onExpand(m2, !s2, t3);
  }, function(e23) {
    e23.stopPropagation(), j2.onExpand(m2, true);
  }, function(e23, t3) {
    var n3 = OF(m2, Object.keys(p2), e23, t3);
    return j2.onPatch(n3), yv(cs.exports.parseJSONPointer(n3[0].path));
  }, function(e23) {
    if (!(function(e24) {
      return e24.nodeName === "DIV" && e24.contentEditable === "true";
    }(e23.target) || e23.which === 1 && jx(e23.target, "BUTTON"))) {
      e23.stopPropagation(), e23.preventDefault(), document.addEventListener("mousemove", M2, true), document.addEventListener("mouseup", E2);
      var t3 = Ex(e23.target), n3 = j2.getJson(), i3 = j2.getDocumentState();
      if (function(e24, t4, n4) {
        if (!e24)
          return false;
        var r3 = t4.slice(0);
        if (Xq(e24))
          for (; r3.length > 0; ) {
            if (e24.pointersMap[cs.exports.compileJSONPointer(r3)] === true)
              return true;
            r3.pop();
          }
        if (Yq(e24))
          return n4 === ox.key && wm(e24.focusPath, t4);
        if (Zq(e24)) {
          if (n4 === ox.value && wm(e24.focusPath, t4))
            return true;
          if (hF(t4, e24.focusPath) && t4.length > e24.focusPath.length && (n4 === ox.key || n4 === ox.value || n4 === ox.multi))
            return true;
        }
        return false;
      }(x2, m2, t3))
        e23.button === 0 && S2(e23);
      else {
        if (yH.selecting = true, yH.selectionAnchor = m2, yH.selectionAnchorType = t3, yH.selectionFocus = m2, e23.shiftKey)
          x2 && j2.onSelect(yF(n3, x2.anchorPath, m2));
        else if (t3 === ox.multi)
          if (r2 && e23.target.hasAttribute("data-path")) {
            var o3 = yv(qq(p2, i3));
            j2.onSelect(jF(o3));
          } else
            j2.onSelect(yF(n3, m2, m2));
        else
          j2.onSelect(SF(n3, t3, m2));
        j2.focus();
      }
    }
  }, function(e23) {
    if (yH.selecting) {
      e23.preventDefault(), e23.stopPropagation(), yH.selectionFocus == null && window.getSelection && window.getSelection().empty();
      var t3 = Ex(e23.target);
      if (!wm(m2, yH.selectionFocus) || t3 !== yH.selectionAnchorType) {
        yH.selectionFocus = m2, yH.selectionAnchorType = t3;
        var n3 = j2.getJson();
        j2.onSelect(yF(n3, yH.selectionAnchor, yH.selectionFocus));
      }
    }
  }, function(e23) {
    if (!j2.readOnly) {
      var t3 = Gp(x2.focusPath);
      if (wm(m2, t3)) {
        var r3 = function(e24, t4) {
          var n3 = [];
          function r4(e25) {
            var t5 = m2.concat(e25), r5 = j2.findElement(t5);
            r5 != null && n3.push({ path: t5, height: r5.clientHeight });
          }
          if (Array.isArray(p2)) {
            var i4 = tF(e24), o4 = nF(e24), a4 = yv(i4), s3 = yv(o4), u3 = t4.find(function(e25) {
              return a4 >= e25.start && s3 <= e25.end;
            });
            if (!u3)
              return null;
            var c3 = u3.start, l3 = u3.end;
            Bw(c3, Math.min(p2.length, l3), function(e25) {
              return r4(String(e25));
            });
          } else
            Object.keys(p2).forEach(r4);
          return n3;
        }(x2, c2 || Ya);
        if (C2("dragSelectionStart", { selection: x2, items: r3 }), r3) {
          var i3 = tF(x2), o3 = r3.findIndex(function(e24) {
            return wm(e24.path, i3);
          }), a3 = bH({ json: j2.getJson(), documentState: j2.getDocumentState(), deltaY: 0, items: r3 }).offset;
          n2(11, O2 = { initialTarget: e23.target, initialClientY: e23.clientY, initialContentTop: P2(), selectionStartIndex: o3, selectionItemsCount: kF(x2).length, items: r3, offset: a3, didMoveItems: false }), yH.dragging = true, document.addEventListener("mousemove", T2, true), document.addEventListener("mouseup", I2);
        } else
          C2("Cannot drag the current selection (probably spread over multiple sections)");
      } else
        S2(e23);
    }
  }, function(e23) {
    yH.selecting || yH.dragging || (e23.stopPropagation(), Sx(e23.target, "data-type", "selectable-value") ? n2(10, _2 = "hover-collection") : Sx(e23.target, "data-type", "insert-selection-area-inside") ? n2(10, _2 = "hover-insert-inside") : Sx(e23.target, "data-type", "insert-selection-area-after") && n2(10, _2 = "hover-insert-after"), clearTimeout($2));
  }, function(e23) {
    e23.stopPropagation(), $2 = setTimeout(function() {
      return n2(10, _2 = void 0);
    });
  }, function(e23) {
    e23.shiftKey || (e23.stopPropagation(), e23.preventDefault(), j2.onSelect(mF(m2)));
  }, function(e23) {
    e23.shiftKey || (e23.stopPropagation(), e23.preventDefault(), j2.onSelect(gF(m2)));
  }, function(e23) {
    j2.onSelect(mF(m2)), j2.onContextMenu(e23);
  }, function(e23) {
    j2.onSelect(gF(m2)), j2.onContextMenu(e23);
  }, S2, d2, v2];
}
var $W = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, _W, SW, Ki, { value: 0, path: 1, expandedMap: 2, enforceStringMap: 3, visibleSectionsMap: 4, validationErrorsMap: 5, searchResultItemsMap: 6, selection: 7, context: 8, onDragSelectionStart: 34 }, MH, [-1, -1]), r2;
  }
  return zi(n2);
}();
function OW(e22) {
  var t2, n2;
  return t2 = new qS({ props: { items: e22[0] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    1 & xi(n3, 1)[0] && (r2.items = e23[0]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function AW(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2, l2 = t2.json, f2 = t2.selection, h2 = t2.readOnly, d2 = t2.showSearch, v2 = d2 !== void 0 && d2, p2 = t2.historyState, m2 = t2.onExpandAll, g2 = t2.onCollapseAll, y2 = t2.onUndo, b2 = t2.onRedo, k2 = t2.onSort, w2 = t2.onTransform, x2 = t2.onContextMenu, j2 = t2.onCopy, S2 = t2.onRenderMenu, C2 = S2 === void 0 ? Vu : S2;
  function _2() {
    n2(1, v2 = !v2);
  }
  return e22.$$set = function(e23) {
    "json" in e23 && n2(2, l2 = e23.json), "selection" in e23 && n2(3, f2 = e23.selection), "readOnly" in e23 && n2(4, h2 = e23.readOnly), "showSearch" in e23 && n2(1, v2 = e23.showSearch), "historyState" in e23 && n2(5, p2 = e23.historyState), "onExpandAll" in e23 && n2(6, m2 = e23.onExpandAll), "onCollapseAll" in e23 && n2(7, g2 = e23.onCollapseAll), "onUndo" in e23 && n2(8, y2 = e23.onUndo), "onRedo" in e23 && n2(9, b2 = e23.onRedo), "onSort" in e23 && n2(10, k2 = e23.onSort), "onTransform" in e23 && n2(11, w2 = e23.onTransform), "onContextMenu" in e23 && n2(12, x2 = e23.onContextMenu), "onCopy" in e23 && n2(13, j2 = e23.onCopy), "onRenderMenu" in e23 && n2(14, C2 = e23.onRenderMenu);
  }, e22.$$.update = function() {
    4 & e22.$$.dirty && n2(20, r2 = l2 !== void 0), e22.$$.dirty, 1048584 & e22.$$.dirty && n2(17, i2 = r2 && (Xq(f2) || Yq(f2) || Zq(f2))), 68 & e22.$$.dirty && n2(19, o2 = { icon: jS, title: "Expand all", className: "jse-expand-all", onClick: m2, disabled: !Os(l2) }), 132 & e22.$$.dirty && n2(18, a2 = { icon: SS, title: "Collapse all", className: "jse-collapse-all", onClick: g2, disabled: !Os(l2) }), 4 & e22.$$.dirty && n2(16, s2 = { icon: gj, title: "Search (Ctrl+F)", className: "jse-search", onClick: _2, disabled: l2 === void 0 }), 999220 & e22.$$.dirty && n2(15, u2 = h2 ? [o2, a2, { separator: true }, { icon: hj, title: "Copy (Ctrl+C)", className: "jse-copy", onClick: j2, disabled: !i2 }, { separator: true }, s2, { space: true }] : [o2, a2, { separator: true }, { icon: tj, title: "Sort", className: "jse-sort", onClick: k2, disabled: h2 || l2 === void 0 }, { icon: pj, title: "Transform contents (filter, sort, project)", className: "jse-transform", onClick: w2, disabled: h2 || l2 === void 0 }, s2, { icon: vj, title: ns, className: "jse-contextmenu", onClick: x2 }, { separator: true }, { icon: nj, title: "Undo (Ctrl+Z)", className: "jse-undo", onClick: y2, disabled: !p2.canUndo }, { icon: rj, title: "Redo (Ctrl+Shift+Z)", className: "jse-redo", onClick: b2, disabled: !p2.canRedo }, { space: true }]), 49152 & e22.$$.dirty && n2(0, c2 = C2("tree", u2) || u2);
  }, [c2, v2, l2, f2, h2, p2, m2, g2, y2, b2, k2, w2, x2, j2, C2, u2, s2, i2, a2, o2, r2];
}
var MW = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, AW, OW, Ki, { json: 2, selection: 3, readOnly: 4, showSearch: 1, historyState: 5, onExpandAll: 6, onCollapseAll: 7, onUndo: 8, onRedo: 9, onSort: 10, onTransform: 11, onContextMenu: 12, onCopy: 13, onRenderMenu: 14 }), r2;
  }
  return zi(n2);
}();
function EW(e22) {
  co(e22, "svelte-1q2qkk2", '@charset "UTF-8";.jse-welcome.svelte-1q2qkk2.svelte-1q2qkk2{flex:1;overflow:auto;font-family:var(--jse-font-family);font-size:var(--jse-font-size);display:flex;flex-direction:column;align-items:center;border-left:var(--jse-main-border);border-right:var(--jse-main-border)}.jse-welcome.svelte-1q2qkk2.svelte-1q2qkk2:last-child{border-bottom:var(--jse-main-border)}.jse-welcome.svelte-1q2qkk2 .jse-space.jse-before.svelte-1q2qkk2{flex:1}.jse-welcome.svelte-1q2qkk2 .jse-space.jse-after.svelte-1q2qkk2{flex:2}.jse-welcome.svelte-1q2qkk2 .jse-contents.svelte-1q2qkk2{margin:2em var(--jse-padding) 0;color:var(--jse-panel-color-readonly)}.jse-welcome.svelte-1q2qkk2 .jse-contents ul.svelte-1q2qkk2{list-style:"\u25CF";list-style-position:outside;padding-left:20px}.jse-welcome.svelte-1q2qkk2 .jse-contents ul li.svelte-1q2qkk2{padding-left:10px}.jse-welcome.svelte-1q2qkk2 .jse-contents ul li span.jse-bold.svelte-1q2qkk2{font-family:var(--jse-font-family-mono);font-weight:bold}');
}
function PW(e22) {
  var t2;
  return { c: function() {
    (t2 = go("ul")).innerHTML = '<li class="svelte-1q2qkk2">Click inside the editor</li> \n        <li class="svelte-1q2qkk2">Paste clipboard data using <span class="jse-bold svelte-1q2qkk2">Ctrl+V</span></li> \n        <li class="svelte-1q2qkk2">Create a new object by typing <span class="jse-bold svelte-1q2qkk2">{</span></li> \n        <li class="svelte-1q2qkk2">Create a new array by typing <span class="jse-bold svelte-1q2qkk2">[</span></li>', So(t2, "class", "svelte-1q2qkk2");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function NW(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2 = !e22[0] && PW();
  return { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = ko(), i2 = go("div"), o2 = bo("Empty document\n    "), u2 && u2.c(), a2 = ko(), s2 = go("div"), So(n2, "class", "jse-space jse-before svelte-1q2qkk2"), So(i2, "class", "jse-contents svelte-1q2qkk2"), So(s2, "class", "jse-space jse-after svelte-1q2qkk2"), So(t2, "class", "jse-welcome svelte-1q2qkk2");
  }, m: function(e23, c2) {
    vo(e23, t2, c2), uo(t2, n2), uo(t2, r2), uo(t2, i2), uo(i2, o2), u2 && u2.m(i2, null), uo(t2, a2), uo(t2, s2);
  }, p: function(e23, t3) {
    xi(t3, 1)[0];
    e23[0] ? u2 && (u2.d(1), u2 = null) : u2 || ((u2 = PW()).c(), u2.m(i2, null));
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2), u2 && u2.d();
  } };
}
function TW(e22, t2, n2) {
  var r2 = t2.readOnly;
  return e22.$$set = function(e23) {
    "readOnly" in e23 && n2(0, r2 = e23.readOnly);
  }, [r2];
}
var IW = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, TW, NW, Ki, { readOnly: 0 }, EW), r2;
  }
  return zi(n2);
}();
function RW(e22) {
  co(e22, "svelte-6hb2gf", ".jse-navigation-bar-dropdown.svelte-6hb2gf.svelte-6hb2gf{position:absolute;top:100%;left:0;z-index:3;background:var(--jse-navigation-bar-background);color:var(--jse-navigation-bar-dropdown-color);box-shadow:var(--jse-controls-box-shadow);display:flex;flex-direction:column;max-height:300px;overflow:auto;min-width:80px}.jse-navigation-bar-dropdown.svelte-6hb2gf button.jse-navigation-bar-dropdown-item.svelte-6hb2gf{font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono);border:none;background:transparent;color:inherit;cursor:pointer;outline:none;text-align:left;white-space:nowrap;box-sizing:border-box;padding:calc(0.5 * var(--jse-padding)) 36px}.jse-navigation-bar-dropdown.svelte-6hb2gf button.jse-navigation-bar-dropdown-item.svelte-6hb2gf:focus,.jse-navigation-bar-dropdown.svelte-6hb2gf button.jse-navigation-bar-dropdown-item.svelte-6hb2gf:hover{background:var(--jse-navigation-bar-background-highlight)}.jse-navigation-bar-dropdown.svelte-6hb2gf button.jse-navigation-bar-dropdown-item.jse-selected.svelte-6hb2gf{background:var(--jse-navigation-bar-dropdown-color);color:var(--jse-navigation-bar-background)}");
}
function DW(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[4] = t2[n2], r2;
}
function zW(e22, t2) {
  var n2, r2, i2, o2, a2, s2 = Uq(t2[4], FW) + "";
  function u2() {
    return t2[3](t2[4]);
  }
  return { key: e22, first: null, c: function() {
    n2 = go("button"), r2 = bo(s2), So(n2, "type", "button"), So(n2, "class", "jse-navigation-bar-dropdown-item svelte-6hb2gf"), So(n2, "title", i2 = t2[4]), To(n2, "jse-selected", t2[4] === t2[1]), this.first = n2;
  }, m: function(e23, t3) {
    vo(e23, n2, t3), uo(n2, r2), o2 || (a2 = xo(n2, "click", jo(u2)), o2 = true);
  }, p: function(e23, o3) {
    t2 = e23, 1 & o3 && s2 !== (s2 = Uq(t2[4], FW) + "") && Ao(r2, s2), 1 & o3 && i2 !== (i2 = t2[4]) && So(n2, "title", i2), 3 & o3 && To(n2, "jse-selected", t2[4] === t2[1]);
  }, d: function(e23) {
    e23 && po(n2), o2 = false, a2();
  } };
}
function LW(e22) {
  var t2, n2;
  return { c: function() {
    t2 = go("button"), n2 = bo("..."), So(t2, "type", "button"), So(t2, "class", "jse-navigation-bar-dropdown-item svelte-6hb2gf"), So(t2, "title", "Limited to " + qW + " items");
  }, m: function(e23, r2) {
    vo(e23, t2, r2), uo(t2, n2);
  }, p: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function BW(e22) {
  for (var t2, n2, r2 = [], i2 = /* @__PURE__ */ new Map(), o2 = qw(e22[0], qW), a2 = function(e23) {
    return e23[4];
  }, s2 = 0; s2 < o2.length; s2 += 1) {
    var u2 = DW(e22, o2, s2), c2 = a2(u2);
    i2.set(c2, r2[s2] = zW(c2, u2));
  }
  var l2 = e22[0].length > qW && LW();
  return { c: function() {
    t2 = go("div");
    for (var e23 = 0; e23 < r2.length; e23 += 1)
      r2[e23].c();
    n2 = ko(), l2 && l2.c(), So(t2, "class", "jse-navigation-bar-dropdown svelte-6hb2gf");
  }, m: function(e23, i3) {
    vo(e23, t2, i3);
    for (var o3 = 0; o3 < r2.length; o3 += 1)
      r2[o3].m(t2, null);
    uo(t2, n2), l2 && l2.m(t2, null);
  }, p: function(e23, s3) {
    var u3 = xi(s3, 1)[0];
    7 & u3 && (o2 = qw(e23[0], qW), r2 = Ca(r2, u3, a2, 1, e23, o2, i2, t2, ja, zW, n2, DW)), e23[0].length > qW ? l2 ? l2.p(e23, u3) : ((l2 = LW()).c(), l2.m(t2, null)) : l2 && (l2.d(1), l2 = null);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
    for (var n3 = 0; n3 < r2.length; n3 += 1)
      r2[n3].d();
    l2 && l2.d();
  } };
}
var qW = 100, FW = 30;
function VW(e22, t2, n2) {
  var r2 = t2.items, i2 = t2.selectedItem, o2 = t2.onSelect;
  return e22.$$set = function(e23) {
    "items" in e23 && n2(0, r2 = e23.items), "selectedItem" in e23 && n2(1, i2 = e23.selectedItem), "onSelect" in e23 && n2(2, o2 = e23.onSelect);
  }, [r2, i2, o2, function(e23) {
    return o2(e23);
  }];
}
var HW = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, VW, BW, Ki, { items: 0, selectedItem: 1, onSelect: 2 }, RW), r2;
  }
  return zi(n2);
}();
function WW(e22) {
  co(e22, "svelte-1r1k9th", ".jse-navigation-bar-item.svelte-1r1k9th.svelte-1r1k9th{position:relative;display:flex}.jse-navigation-bar-item.svelte-1r1k9th button.jse-navigation-bar-button.svelte-1r1k9th{font-family:inherit;font-size:inherit;padding:calc(0.5 * var(--jse-padding)) 2px;border:none;background:transparent;color:inherit;cursor:pointer;outline:none;min-width:2em;white-space:nowrap}.jse-navigation-bar-item.svelte-1r1k9th button.jse-navigation-bar-button.svelte-1r1k9th:focus,.jse-navigation-bar-item.svelte-1r1k9th button.jse-navigation-bar-button.svelte-1r1k9th:hover{background:var(--jse-panel-button-background-highlight);color:var(--jse-panel-button-color-highlight)}.jse-navigation-bar-item.svelte-1r1k9th button.jse-navigation-bar-button.jse-navigation-bar-arrow.svelte-1r1k9th{padding:2px var(--jse-padding) 0}.jse-navigation-bar-item.svelte-1r1k9th button.jse-navigation-bar-button.jse-navigation-bar-arrow.jse-open.svelte-1r1k9th{background:var(--jse-navigation-bar-background);color:var(--jse-navigation-bar-dropdown-color)}.jse-navigation-bar-item.svelte-1r1k9th.svelte-1r1k9th:last-child{padding-right:var(--jse-padding)}");
}
function JW(e22) {
  var t2, n2, r2, i2;
  return { c: function() {
    t2 = go("button"), n2 = bo(e22[2]), So(t2, "type", "button"), So(t2, "class", "jse-navigation-bar-button svelte-1r1k9th");
  }, m: function(o2, a2) {
    vo(o2, t2, a2), uo(t2, n2), r2 || (i2 = xo(t2, "click", e22[9]), r2 = true);
  }, p: function(e23, t3) {
    4 & t3 && Ao(n2, e23[2]);
  }, d: function(e23) {
    e23 && po(t2), r2 = false, i2();
  } };
}
function UW(e22) {
  var t2, n2, r2, i2, o2, a2, s2;
  r2 = new Xj({ props: { data: Xx } });
  var u2 = e22[2] !== void 0 && JW(e22);
  return { c: function() {
    t2 = go("div"), n2 = go("button"), Aa(r2.$$.fragment), i2 = ko(), u2 && u2.c(), So(n2, "type", "button"), So(n2, "class", "jse-navigation-bar-button jse-navigation-bar-arrow svelte-1r1k9th"), To(n2, "jse-open", e22[1]), So(t2, "class", "jse-navigation-bar-item svelte-1r1k9th");
  }, m: function(c2, l2) {
    vo(c2, t2, l2), uo(t2, n2), Ma(r2, n2, null), uo(t2, i2), u2 && u2.m(t2, null), e22[10](t2), o2 = true, a2 || (s2 = xo(n2, "click", e22[4]), a2 = true);
  }, p: function(e23, r3) {
    var i3 = xi(r3, 1)[0];
    2 & i3 && To(n2, "jse-open", e23[1]), e23[2] !== void 0 ? u2 ? u2.p(e23, i3) : ((u2 = JW(e23)).c(), u2.m(t2, null)) : u2 && (u2.d(1), u2 = null);
  }, i: function(e23) {
    o2 || (ya(r2.$$.fragment, e23), o2 = true);
  }, o: function(e23) {
    ba(r2.$$.fragment, e23), o2 = false;
  }, d: function(n3) {
    n3 && po(t2), Ea(r2), u2 && u2.d(), e22[10](null), a2 = false, s2();
  } };
}
function KW(e22, t2, n2) {
  var r2, i2, o2, a2, s2 = Yo("absolute-popup"), u2 = s2.openAbsolutePopup, c2 = s2.closeAbsolutePopup, l2 = t2.path, f2 = t2.index, h2 = t2.onSelect, d2 = t2.getItems, v2 = false;
  function p2(e23) {
    c2(a2), h2(r2.concat(e23));
  }
  return e22.$$set = function(e23) {
    "path" in e23 && n2(5, l2 = e23.path), "index" in e23 && n2(6, f2 = e23.index), "onSelect" in e23 && n2(7, h2 = e23.onSelect), "getItems" in e23 && n2(8, d2 = e23.getItems);
  }, e22.$$.update = function() {
    96 & e22.$$.dirty && (r2 = l2.slice(0, f2)), 96 & e22.$$.dirty && n2(2, i2 = l2[f2]);
  }, [o2, v2, i2, p2, function() {
    if (o2) {
      n2(1, v2 = true);
      var e23 = { items: d2(r2), selectedItem: i2, onSelect: p2 };
      a2 = u2(HW, e23, { anchor: o2, closeOnOuterClick: true, onClose: function() {
        n2(1, v2 = false);
      } });
    }
  }, l2, f2, h2, d2, function() {
    return p2(i2);
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(0, o2 = e23);
    });
  }];
}
var GW = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, KW, UW, Ki, { path: 5, index: 6, onSelect: 7, getItems: 8 }, WW), r2;
  }
  return zi(n2);
}(), QW = { exports: {} }, YW = function(e22, t2) {
  var n2, r2, i2 = 1, o2 = 0, a2 = 0, s2 = String.alphabet;
  function u2(e23, t3, r3) {
    if (r3) {
      for (n2 = t3; (r3 = u2(e23, n2)) < 76 && r3 > 65; )
        ++n2;
      return +e23.slice(t3 - 1, n2);
    }
    return (r3 = s2 && s2.indexOf(e23.charAt(t3))) > -1 ? r3 + 76 : (r3 = e23.charCodeAt(t3) || 0) < 45 || r3 > 127 ? r3 : r3 < 46 ? 65 : r3 < 48 ? r3 - 1 : r3 < 58 ? r3 + 18 : r3 < 65 ? r3 - 11 : r3 < 91 ? r3 + 11 : r3 < 97 ? r3 - 37 : r3 < 123 ? r3 + 5 : r3 - 63;
  }
  if ((e22 += "") != (t2 += "")) {
    for (; i2; )
      if (r2 = u2(e22, o2++), i2 = u2(t2, a2++), r2 < 76 && i2 < 76 && r2 > 66 && i2 > 66 && (r2 = u2(e22, o2, o2), i2 = u2(t2, a2, o2 = n2), a2 = n2), r2 != i2)
        return r2 < i2 ? -1 : 1;
  }
  return 0;
};
try {
  QW.exports = YW;
} catch (e22) {
  String.naturalCompare = YW;
}
function ZW(e22, t2) {
  var n2 = typeof e22 == "string" ? e22.toLowerCase() : e22, r2 = typeof t2 == "string" ? t2.toLowerCase() : t2;
  return QW.exports(n2, r2);
}
function XW(e22, t2) {
  return function(n2, r2) {
    var i2 = cs.exports.getIn(n2, e22), o2 = cs.exports.getIn(r2, e22);
    return i2 === void 0 ? t2 : o2 === void 0 ? -t2 : typeof i2 != "string" && typeof o2 != "string" ? i2 > o2 ? t2 : i2 < o2 ? -t2 : 0 : t2 * ZW(i2, o2);
  };
}
function eJ(e22) {
  co(e22, "svelte-5lwyke", ".jse-navigation-bar.svelte-5lwyke.svelte-5lwyke{font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono);background:var(--jse-panel-background);color:var(--jse-panel-button-color);padding:0;margin:0;display:flex;overflow:auto;border-left:var(--jse-main-border);border-right:var(--jse-main-border)}.jse-navigation-bar.svelte-5lwyke .jse-navigation-bar-space.svelte-5lwyke{padding:calc(0.5 * var(--jse-padding)) var(--jse-padding);color:var(--jse-navigation-bar-color)}");
}
function tJ(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[11] = t2[n2], r2[13] = n2, r2;
}
function nJ(e22, t2) {
  var n2, r2, i2;
  return r2 = new GW({ props: { getItems: t2[4], path: t2[1], index: t2[13], onSelect: t2[5] } }), { key: e22, first: null, c: function() {
    n2 = wo(), Aa(r2.$$.fragment), this.first = n2;
  }, m: function(e23, t3) {
    vo(e23, n2, t3), Ma(r2, e23, t3), i2 = true;
  }, p: function(e23, n3) {
    t2 = e23;
    var i3 = {};
    2 & n3 && (i3.path = t2[1]), 2 & n3 && (i3.index = t2[13]), r2.$set(i3);
  }, i: function(e23) {
    i2 || (ya(r2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    ba(r2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(n2), Ea(r2, e23);
  } };
}
function rJ(e22) {
  var t2, n2;
  return t2 = new GW({ props: { getItems: e22[4], path: e22[1], index: void 0, onSelect: e22[5] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    2 & n3 && (r2.path = e23[1]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function iJ(e22) {
  for (var t2, n2, r2, i2, o2, a2, s2 = [], u2 = /* @__PURE__ */ new Map(), c2 = Os(e22[0]) ? "\xA0" : "Navigation bar", l2 = e22[1], f2 = function(e23) {
    return e23[13];
  }, h2 = 0; h2 < l2.length; h2 += 1) {
    var d2 = tJ(e22, l2, h2), v2 = f2(d2);
    u2.set(v2, s2[h2] = nJ(v2, d2));
  }
  var p2 = e22[3] && rJ(e22);
  return { c: function() {
    t2 = go("div");
    for (var e23 = 0; e23 < s2.length; e23 += 1)
      s2[e23].c();
    n2 = ko(), p2 && p2.c(), r2 = ko(), i2 = go("div"), o2 = bo(c2), So(i2, "class", "jse-navigation-bar-space svelte-5lwyke"), So(t2, "class", "jse-navigation-bar svelte-5lwyke");
  }, m: function(u3, c3) {
    vo(u3, t2, c3);
    for (var l3 = 0; l3 < s2.length; l3 += 1)
      s2[l3].m(t2, null);
    uo(t2, n2), p2 && p2.m(t2, null), uo(t2, r2), uo(t2, i2), uo(i2, o2), e22[8](t2), a2 = true;
  }, p: function(e23, i3) {
    var h3 = xi(i3, 1)[0];
    50 & h3 && (l2 = e23[1], ma(), s2 = Ca(s2, h3, f2, 1, e23, l2, u2, t2, Sa, nJ, n2, tJ), ga()), e23[3] ? p2 ? (p2.p(e23, h3), 8 & h3 && ya(p2, 1)) : ((p2 = rJ(e23)).c(), ya(p2, 1), p2.m(t2, r2)) : p2 && (ma(), ba(p2, 1, 1, function() {
      p2 = null;
    }), ga()), (!a2 || 1 & h3) && c2 !== (c2 = Os(e23[0]) ? "\xA0" : "Navigation bar") && Ao(o2, c2);
  }, i: function(e23) {
    if (!a2) {
      for (var t3 = 0; t3 < l2.length; t3 += 1)
        ya(s2[t3]);
      ya(p2), a2 = true;
    }
  }, o: function(e23) {
    for (var t3 = 0; t3 < s2.length; t3 += 1)
      ba(s2[t3]);
    ba(p2), a2 = false;
  }, d: function(n3) {
    n3 && po(t2);
    for (var r3 = 0; r3 < s2.length; r3 += 1)
      s2[r3].d();
    p2 && p2.d(), e22[8](null);
  } };
}
function oJ(e22, t2, n2) {
  var r2, i2, o2, a2 = Ia("jsoneditor:NavigationBar"), s2 = t2.json, u2 = t2.documentState, c2 = t2.onSelect;
  return e22.$$set = function(e23) {
    "json" in e23 && n2(0, s2 = e23.json), "documentState" in e23 && n2(6, u2 = e23.documentState), "onSelect" in e23 && n2(7, c2 = e23.onSelect);
  }, e22.$$.update = function() {
    64 & e22.$$.dirty && n2(1, r2 = u2.selection ? u2.selection.focusPath : []), 3 & e22.$$.dirty && n2(3, i2 = Os(cs.exports.getIn(s2, r2))), 2 & e22.$$.dirty && setTimeout(function() {
      if (o2 && o2.scrollTo) {
        var e23 = o2.scrollWidth - o2.clientWidth;
        e23 > 0 && (a2("scrollTo ", e23), o2.scrollTo({ left: e23, behavior: "smooth" }));
      }
    });
  }, [s2, r2, o2, i2, function(e23) {
    a2("get items for path", e23);
    var t3 = cs.exports.getIn(s2, e23);
    if (Array.isArray(t3))
      return zy(0, t3.length).map(String);
    if ($s(t3)) {
      var n3 = Object.keys(t3).slice(0);
      return n3.sort(ZW), n3;
    }
    return [];
  }, function(e23) {
    a2("select path", JSON.stringify(e23)), c2(yF(s2, e23, e23));
  }, u2, c2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(2, o2 = e23);
    });
  }];
}
var aJ = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, oJ, iJ, Ki, { json: 0, documentState: 6, onSelect: 7 }, eJ), r2;
  }
  return zi(n2);
}();
function sJ(e22) {
  co(e22, "svelte-18vllqh", ".jse-search-box.svelte-18vllqh.svelte-18vllqh{border:var(--jse-panel-border);border-radius:3px;font-family:var(--jse-font-family);font-size:var(--jse-font-size);background:var(--jse-panel-background);color:var(--jse-panel-color-readonly);box-shadow:var(--jse-controls-box-shadow);display:inline-block;width:400px;max-width:100%;overflow:auto}.jse-search-box.svelte-18vllqh .jse-search-form.svelte-18vllqh{display:flex;align-items:stretch}.jse-search-box.svelte-18vllqh .jse-search-form button.svelte-18vllqh,.jse-search-box.svelte-18vllqh .jse-search-form input.svelte-18vllqh{font-family:inherit;font-size:inherit}.jse-search-box.svelte-18vllqh .jse-search-form button.svelte-18vllqh{display:block;text-align:center;border:none;padding:0 5px;margin:0;cursor:pointer;color:var(--jse-panel-button-color);background:var(--jse-panel-button-background)}.jse-search-box.svelte-18vllqh .jse-search-form button.svelte-18vllqh:hover{color:var(--jse-panel-button-color-highlight);background:var(--jse-panel-button-background-highlight)}.jse-search-box.svelte-18vllqh .jse-search-form input.svelte-18vllqh{color:var(--jse-panel-color);border:var(--jse-input-border);border-radius:3px;background:var(--jse-input-background);height:28px;padding:0 5px;margin:0;flex:1;outline:none}.jse-search-box.svelte-18vllqh .jse-search-form .jse-replace-toggle.svelte-18vllqh{padding:var(--jse-padding) calc(0.5 * var(--jse-padding));min-width:20px;background:var(--jse-panel-button-background-highlight)}.jse-search-box.svelte-18vllqh .jse-search-form .jse-search-contents.svelte-18vllqh{flex:1;display:flex;flex-direction:column;padding:calc(0.5 * var(--jse-padding));gap:calc(0.5 * var(--jse-padding))}.jse-search-box.svelte-18vllqh .jse-search-form .jse-search-contents .jse-search-section.svelte-18vllqh{flex:1;display:flex;align-items:center;position:relative;padding-left:32px}.jse-search-box.svelte-18vllqh .jse-search-form .jse-search-contents .jse-search-section .jse-search-icon.svelte-18vllqh{color:inherit;cursor:inherit;background:inherit;position:absolute;top:calc(0.5 * var(--jse-padding));left:calc(0.5 * var(--jse-padding))}.jse-search-box.svelte-18vllqh .jse-search-form .jse-search-contents .jse-search-section label.jse-search-input-label.svelte-18vllqh{flex:1;display:flex}.jse-search-box.svelte-18vllqh .jse-search-form .jse-search-contents .jse-search-section .jse-search-count.svelte-18vllqh{color:inherit;font-size:80%;visibility:hidden;padding:0 5px;min-width:36px;text-align:center}.jse-search-box.svelte-18vllqh .jse-search-form .jse-search-contents .jse-search-section .jse-search-count.jse-visible.svelte-18vllqh{visibility:visible}.jse-search-box.svelte-18vllqh .jse-search-form .jse-search-contents .jse-replace-section.svelte-18vllqh{padding-left:32px;flex:1;display:flex}.jse-search-box.svelte-18vllqh .jse-search-form .jse-search-contents .jse-replace-section button.svelte-18vllqh{width:auto}");
}
function uJ(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2, k2, w2, x2, j2, S2, C2, _2, $2, O2, A2 = (e22[3] !== -1 ? "".concat(e22[3] + 1, "/") : "") + "", M2 = !e22[4] && cJ(e22), E2 = [fJ, lJ], P2 = [];
  function N2(e23, t3) {
    return e23[2] ? 0 : 1;
  }
  s2 = N2(e22), u2 = P2[s2] = E2[s2](e22), y2 = new Xj({ props: { data: sj } }), w2 = new Xj({ props: { data: uj } }), S2 = new Xj({ props: { data: Cj } });
  var T2 = e22[0] && !e22[4] && hJ(e22);
  return { c: function() {
    t2 = go("div"), n2 = go("form"), M2 && M2.c(), r2 = ko(), i2 = go("div"), o2 = go("div"), a2 = go("div"), u2.c(), c2 = ko(), l2 = go("label"), f2 = go("input"), h2 = ko(), d2 = go("div"), v2 = bo(A2), p2 = bo(e22[10]), m2 = ko(), g2 = go("button"), Aa(y2.$$.fragment), b2 = ko(), k2 = go("button"), Aa(w2.$$.fragment), x2 = ko(), j2 = go("button"), Aa(S2.$$.fragment), C2 = ko(), T2 && T2.c(), So(a2, "class", "jse-search-icon svelte-18vllqh"), So(f2, "class", "jse-search-input svelte-18vllqh"), So(f2, "title", "Enter text to search"), So(f2, "type", "text"), So(f2, "placeholder", "Find"), So(l2, "class", "jse-search-input-label svelte-18vllqh"), So(l2, "about", "jse-search input"), So(d2, "class", "jse-search-count svelte-18vllqh"), To(d2, "jse-visible", e22[8] !== ""), So(g2, "type", "button"), So(g2, "class", "jse-search-next svelte-18vllqh"), So(g2, "title", "Go to next search result (Enter)"), So(k2, "type", "button"), So(k2, "class", "jse-search-previous svelte-18vllqh"), So(k2, "title", "Go to previous search result (Shift+Enter)"), So(j2, "type", "button"), So(j2, "class", "jse-search-clear svelte-18vllqh"), So(j2, "title", "Close search box (Esc)"), So(o2, "class", "jse-search-section svelte-18vllqh"), So(i2, "class", "jse-search-contents svelte-18vllqh"), So(n2, "class", "jse-search-form svelte-18vllqh"), So(t2, "class", "jse-search-box svelte-18vllqh");
  }, m: function(u3, A3) {
    vo(u3, t2, A3), uo(t2, n2), M2 && M2.m(n2, null), uo(n2, r2), uo(n2, i2), uo(i2, o2), uo(o2, a2), P2[s2].m(a2, null), uo(o2, c2), uo(o2, l2), uo(l2, f2), Mo(f2, e22[8]), uo(o2, h2), uo(o2, d2), uo(d2, v2), uo(d2, p2), uo(o2, m2), uo(o2, g2), Ma(y2, g2, null), uo(o2, b2), uo(o2, k2), Ma(w2, k2, null), uo(o2, x2), uo(o2, j2), Ma(S2, j2, null), uo(i2, C2), T2 && T2.m(i2, null), _2 = true, $2 || (O2 = [xo(f2, "input", e22[21]), to(vJ.call(null, f2)), xo(g2, "click", e22[22]), xo(k2, "click", e22[23]), xo(j2, "click", e22[24]), xo(n2, "submit", e22[12]), xo(n2, "keydown", e22[13])], $2 = true);
  }, p: function(e23, t3) {
    e23[4] ? M2 && (ma(), ba(M2, 1, 1, function() {
      M2 = null;
    }), ga()) : M2 ? (M2.p(e23, t3), 16 & t3 && ya(M2, 1)) : ((M2 = cJ(e23)).c(), ya(M2, 1), M2.m(n2, r2));
    var o3 = s2;
    (s2 = N2(e23)) === o3 ? P2[s2].p(e23, t3) : (ma(), ba(P2[o3], 1, 1, function() {
      P2[o3] = null;
    }), ga(), (u2 = P2[s2]) ? u2.p(e23, t3) : (u2 = P2[s2] = E2[s2](e23)).c(), ya(u2, 1), u2.m(a2, null)), 256 & t3 && f2.value !== e23[8] && Mo(f2, e23[8]), (!_2 || 8 & t3) && A2 !== (A2 = (e23[3] !== -1 ? "".concat(e23[3] + 1, "/") : "") + "") && Ao(v2, A2), (!_2 || 1024 & t3) && Ao(p2, e23[10]), 256 & t3 && To(d2, "jse-visible", e23[8] !== ""), e23[0] && !e23[4] ? T2 ? T2.p(e23, t3) : ((T2 = hJ(e23)).c(), T2.m(i2, null)) : T2 && (T2.d(1), T2 = null);
  }, i: function(e23) {
    _2 || (ya(M2), ya(u2), ya(y2.$$.fragment, e23), ya(w2.$$.fragment, e23), ya(S2.$$.fragment, e23), _2 = true);
  }, o: function(e23) {
    ba(M2), ba(u2), ba(y2.$$.fragment, e23), ba(w2.$$.fragment, e23), ba(S2.$$.fragment, e23), _2 = false;
  }, d: function(e23) {
    e23 && po(t2), M2 && M2.d(), P2[s2].d(), Ea(y2), Ea(w2), Ea(S2), T2 && T2.d(), $2 = false, Wi(O2);
  } };
}
function cJ(e22) {
  var t2, n2, r2, i2, o2;
  return n2 = new Xj({ props: { data: e22[0] ? ij : oj } }), { c: function() {
    t2 = go("button"), Aa(n2.$$.fragment), So(t2, "type", "button"), So(t2, "class", "jse-replace-toggle svelte-18vllqh"), So(t2, "title", "Toggle visibility of replace options (Ctrl+H)");
  }, m: function(a2, s2) {
    vo(a2, t2, s2), Ma(n2, t2, null), r2 = true, i2 || (o2 = xo(t2, "click", e22[11]), i2 = true);
  }, p: function(e23, t3) {
    var r3 = {};
    1 & t3 && (r3.data = e23[0] ? ij : oj), n2.$set(r3);
  }, i: function(e23) {
    r2 || (ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), i2 = false, o2();
  } };
}
function lJ(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: gj } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: Bi, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function fJ(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: cj, spin: true } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: Bi, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function hJ(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2;
  return { c: function() {
    t2 = go("div"), n2 = go("input"), r2 = ko(), (i2 = go("button")).textContent = "Replace", o2 = ko(), (a2 = go("button")).textContent = "All", So(n2, "class", "jse-replace-input svelte-18vllqh"), So(n2, "title", "Enter replacement text"), So(n2, "type", "text"), So(n2, "placeholder", "Replace"), So(i2, "type", "button"), So(i2, "title", "Replace current occurrence (Ctrl+Enter)"), So(i2, "class", "svelte-18vllqh"), So(a2, "type", "button"), So(a2, "title", "Replace all occurrences"), So(a2, "class", "svelte-18vllqh"), So(t2, "class", "jse-replace-section svelte-18vllqh");
  }, m: function(c2, l2) {
    vo(c2, t2, l2), uo(t2, n2), Mo(n2, e22[9]), uo(t2, r2), uo(t2, i2), uo(t2, o2), uo(t2, a2), s2 || (u2 = [xo(n2, "input", e22[25]), xo(i2, "click", e22[14]), xo(a2, "click", e22[15])], s2 = true);
  }, p: function(e23, t3) {
    512 & t3 && n2.value !== e23[9] && Mo(n2, e23[9]);
  }, d: function(e23) {
    e23 && po(t2), s2 = false, Wi(u2);
  } };
}
function dJ(e22) {
  var t2, n2, r2 = e22[1] && uJ(e22);
  return { c: function() {
    r2 && r2.c(), t2 = wo();
  }, m: function(e23, i2) {
    r2 && r2.m(e23, i2), vo(e23, t2, i2), n2 = true;
  }, p: function(e23, n3) {
    var i2 = xi(n3, 1)[0];
    e23[1] ? r2 ? (r2.p(e23, i2), 2 & i2 && ya(r2, 1)) : ((r2 = uJ(e23)).c(), ya(r2, 1), r2.m(t2.parentNode, t2)) : r2 && (ma(), ba(r2, 1, 1, function() {
      r2 = null;
    }), ga());
  }, i: function(e23) {
    n2 || (ya(r2), n2 = true);
  }, o: function(e23) {
    ba(r2), n2 = false;
  }, d: function(e23) {
    r2 && r2.d(e23), e23 && po(t2);
  } };
}
function vJ(e22) {
  e22.select();
}
function pJ(e22, t2, n2) {
  var r2, i2, o2 = t2.show, a2 = o2 !== void 0 && o2, s2 = t2.searching, u2 = t2.resultCount, c2 = u2 === void 0 ? 0 : u2, l2 = t2.activeIndex, f2 = l2 === void 0 ? 0 : l2, h2 = t2.showReplace, d2 = h2 !== void 0 && h2, v2 = t2.readOnly, p2 = v2 !== void 0 && v2, m2 = t2.onChange, g2 = m2 === void 0 ? Vu : m2, y2 = t2.onPrevious, b2 = y2 === void 0 ? Vu : y2, k2 = t2.onNext, w2 = k2 === void 0 ? Vu : k2, x2 = t2.onReplace, j2 = x2 === void 0 ? Vu : x2, S2 = t2.onReplaceAll, C2 = S2 === void 0 ? Vu : S2, _2 = t2.onClose, $2 = _2 === void 0 ? Vu : _2, O2 = "", A2 = "", M2 = "";
  function E2() {
    n2(0, d2 = !d2 && !p2);
  }
  function P2() {
    p2 || j2(O2, M2);
  }
  return e22.$$set = function(e23) {
    "show" in e23 && n2(1, a2 = e23.show), "searching" in e23 && n2(2, s2 = e23.searching), "resultCount" in e23 && n2(16, c2 = e23.resultCount), "activeIndex" in e23 && n2(3, f2 = e23.activeIndex), "showReplace" in e23 && n2(0, d2 = e23.showReplace), "readOnly" in e23 && n2(4, p2 = e23.readOnly), "onChange" in e23 && n2(17, g2 = e23.onChange), "onPrevious" in e23 && n2(5, b2 = e23.onPrevious), "onNext" in e23 && n2(6, w2 = e23.onNext), "onReplace" in e23 && n2(18, j2 = e23.onReplace), "onReplaceAll" in e23 && n2(19, C2 = e23.onReplaceAll), "onClose" in e23 && n2(7, $2 = e23.onClose);
  }, e22.$$.update = function() {
    65536 & e22.$$.dirty && n2(10, r2 = c2 >= 1e3 ? "".concat(999, "+") : String(c2)), 131072 & e22.$$.dirty && n2(20, i2 = Xd(g2, 300)), 1048832 & e22.$$.dirty && i2(O2), 2 & e22.$$.dirty && a2 && O2 !== "" && g2(O2);
  }, [d2, a2, s2, f2, p2, b2, w2, $2, O2, M2, r2, E2, function(e23) {
    e23.preventDefault(), O2 !== A2 ? (A2 = O2, i2.cancel(), g2(O2)) : w2();
  }, function(e23) {
    e23.stopPropagation();
    var t3 = Rx(e23);
    t3 === "Enter" && (e23.preventDefault(), w2()), t3 === "Shift+Enter" && (e23.preventDefault(), b2()), t3 !== "Ctrl+Enter" && t3 !== "Command+Enter" || (e23.preventDefault(), d2 ? P2() : w2()), t3 === "Ctrl+H" && (e23.preventDefault(), E2()), t3 === "Escape" && (e23.preventDefault(), $2());
  }, P2, function() {
    p2 || C2(O2, M2);
  }, c2, g2, j2, C2, i2, function() {
    O2 = this.value, n2(8, O2);
  }, function() {
    return w2();
  }, function() {
    return b2();
  }, function() {
    return $2();
  }, function() {
    M2 = this.value, n2(9, M2);
  }];
}
var mJ = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, pJ, dJ, Ki, { show: 1, searching: 2, resultCount: 16, activeIndex: 3, showReplace: 0, readOnly: 4, onChange: 17, onPrevious: 5, onNext: 6, onReplace: 18, onReplaceAll: 19, onClose: 7 }, sJ), r2;
  }
  return zi(n2);
}(), gJ = xa.window;
function yJ(e22) {
  co(e22, "svelte-1wno2xw", ".jse-tree-mode.svelte-1wno2xw.svelte-1wno2xw{flex:1;display:flex;flex-direction:column;position:relative;background:var(--jse-background-color);min-width:0;min-height:0;font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono);color:var(--jse-text-color);line-height:var(--jse-line-height)}.jse-tree-mode.svelte-1wno2xw .jse-hidden-input-label.svelte-1wno2xw{position:absolute;right:0;top:0;width:0;height:0}.jse-tree-mode.svelte-1wno2xw .jse-hidden-input-label .jse-hidden-input.svelte-1wno2xw{width:0;height:0;padding:0;border:0;outline:none}.jse-tree-mode.svelte-1wno2xw .jse-search-box-container.svelte-1wno2xw{position:relative;height:0;top:var(--jse-padding);margin-right:calc(var(--jse-padding) + 20px);margin-left:var(--jse-padding);text-align:right;z-index:3}.jse-tree-mode.no-main-menu.svelte-1wno2xw.svelte-1wno2xw{border-top:var(--jse-main-border)}.jse-tree-mode.svelte-1wno2xw .jse-contents.svelte-1wno2xw{border-left:var(--jse-main-border);border-right:var(--jse-main-border);flex:1;overflow:auto;position:relative;padding:2px;display:flex;flex-direction:column}.jse-tree-mode.svelte-1wno2xw .jse-contents.svelte-1wno2xw:last-child{border-bottom:var(--jse-main-border)}.jse-tree-mode.svelte-1wno2xw .jse-contents .jse-loading-space.svelte-1wno2xw{flex:1}.jse-tree-mode.svelte-1wno2xw .jse-contents .jse-loading.svelte-1wno2xw{flex:2;text-align:center;color:var(--jse-panel-color-readonly);box-sizing:border-box;font-family:var(--jse-font-family);font-size:var(--jse-font-size)}.jse-tree-mode.svelte-1wno2xw .jse-preview.svelte-1wno2xw{flex:1;color:var(--jse-panel-color-readonly);overflow:auto;white-space:pre-wrap;padding:2px}");
}
function bJ(e22) {
  var t2, n2, r2;
  function i2(t3) {
    e22[69](t3);
  }
  var o2 = { json: e22[7], selection: e22[13].selection, readOnly: e22[0], historyState: e22[19], onExpandAll: e22[37], onCollapseAll: e22[38], onUndo: e22[33], onRedo: e22[34], onSort: e22[35], onTransform: e22[36], onContextMenu: e22[42], onCopy: e22[31], onRenderMenu: e22[4] };
  return e22[16] !== void 0 && (o2.showSearch = e22[16]), t2 = new MW({ props: o2 }), Xo.push(function() {
    return Oa(t2, "showSearch", i2);
  }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, n3) {
    Ma(t2, e23, n3), r2 = true;
  }, p: function(e23, r3) {
    var i3 = {};
    128 & r3[0] && (i3.json = e23[7]), 8192 & r3[0] && (i3.selection = e23[13].selection), 1 & r3[0] && (i3.readOnly = e23[0]), 524288 & r3[0] && (i3.historyState = e23[19]), 16 & r3[0] && (i3.onRenderMenu = e23[4]), !n2 && 65536 & r3[0] && (n2 = true, i3.showSearch = e23[16], sa(function() {
      return n2 = false;
    })), t2.$set(i3);
  }, i: function(e23) {
    r2 || (ya(t2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function kJ(e22) {
  var t2, n2;
  return t2 = new aJ({ props: { json: e22[7], documentState: e22[13], onSelect: e22[45] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    128 & n3[0] && (r2.json = e23[7]), 8192 & n3[0] && (r2.documentState = e23[13]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function wJ(e22) {
  var t2;
  return { c: function() {
    (t2 = go("div")).innerHTML = '<div class="jse-loading-space svelte-1wno2xw"></div> \n      <div class="jse-loading svelte-1wno2xw">loading...</div>', So(t2, "class", "jse-contents svelte-1wno2xw");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, p: Bi, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function xJ(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2 = [SJ, jJ], f2 = [];
  function h2(e23, t3) {
    return e23[7] === void 0 ? 0 : 1;
  }
  return i2 = h2(e22), o2 = f2[i2] = l2[i2](e22), { c: function() {
    t2 = go("label"), n2 = go("input"), r2 = ko(), o2.c(), a2 = wo(), So(n2, "class", "jse-hidden-input svelte-1wno2xw"), So(n2, "tabindex", "-1"), So(t2, "class", "jse-hidden-input-label svelte-1wno2xw");
  }, m: function(o3, l3) {
    vo(o3, t2, l3), uo(t2, n2), e22[70](n2), vo(o3, r2, l3), f2[i2].m(o3, l3), vo(o3, a2, l3), s2 = true, u2 || (c2 = xo(n2, "paste", e22[32]), u2 = true);
  }, p: function(e23, t3) {
    var n3 = i2;
    (i2 = h2(e23)) === n3 ? f2[i2].p(e23, t3) : (ma(), ba(f2[n3], 1, 1, function() {
      f2[n3] = null;
    }), ga(), (o2 = f2[i2]) ? o2.p(e23, t3) : (o2 = f2[i2] = l2[i2](e23)).c(), ya(o2, 1), o2.m(a2.parentNode, a2));
  }, i: function(e23) {
    s2 || (ya(o2), s2 = true);
  }, o: function(e23) {
    ba(o2), s2 = false;
  }, d: function(n3) {
    n3 && po(t2), e22[70](null), n3 && po(r2), f2[i2].d(n3), n3 && po(a2), u2 = false, c2();
  } };
}
function jJ(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2;
  a2 = new mJ({ props: { show: e22[16], resultCount: ((t2 = e22[14]) === null || t2 === void 0 || (n2 = t2.items) === null || n2 === void 0 ? void 0 : n2.length) || 0, activeIndex: ((r2 = e22[14]) === null || r2 === void 0 ? void 0 : r2.activeIndex) || 0, showReplace: e22[17], searching: e22[18], readOnly: e22[0], onChange: e22[24], onNext: e22[25], onPrevious: e22[26], onReplace: e22[27], onReplaceAll: e22[28], onClose: e22[29] } }), c2 = new $W({ props: { value: e22[7], path: e22[23], expandedMap: e22[13].expandedMap, enforceStringMap: e22[13].enforceStringMap, visibleSectionsMap: e22[13].visibleSectionsMap, validationErrorsMap: e22[21], searchResultItemsMap: (i2 = e22[14]) === null || i2 === void 0 ? void 0 : i2.itemsMap, selection: e22[13].selection, context: e22[10], onDragSelectionStart: Vu } });
  var p2 = e22[15] && CJ(e22), m2 = e22[20] && _J(e22);
  return d2 = new xS({ props: { validationErrors: e22[9], selectError: e22[30] } }), { c: function() {
    o2 = go("div"), Aa(a2.$$.fragment), s2 = ko(), u2 = go("div"), Aa(c2.$$.fragment), l2 = ko(), p2 && p2.c(), f2 = ko(), m2 && m2.c(), h2 = ko(), Aa(d2.$$.fragment), So(o2, "class", "jse-search-box-container svelte-1wno2xw"), So(u2, "class", "jse-contents svelte-1wno2xw"), So(u2, "data-jsoneditor-scrollable-contents", true);
  }, m: function(t3, n3) {
    vo(t3, o2, n3), Ma(a2, o2, null), vo(t3, s2, n3), vo(t3, u2, n3), Ma(c2, u2, null), e22[71](u2), vo(t3, l2, n3), p2 && p2.m(t3, n3), vo(t3, f2, n3), m2 && m2.m(t3, n3), vo(t3, h2, n3), Ma(d2, t3, n3), v2 = true;
  }, p: function(e23, t3) {
    var n3, r3, i3, o3, s3 = {};
    65536 & t3[0] && (s3.show = e23[16]), 16384 & t3[0] && (s3.resultCount = ((n3 = e23[14]) === null || n3 === void 0 || (r3 = n3.items) === null || r3 === void 0 ? void 0 : r3.length) || 0), 16384 & t3[0] && (s3.activeIndex = ((i3 = e23[14]) === null || i3 === void 0 ? void 0 : i3.activeIndex) || 0), 131072 & t3[0] && (s3.showReplace = e23[17]), 262144 & t3[0] && (s3.searching = e23[18]), 1 & t3[0] && (s3.readOnly = e23[0]), a2.$set(s3);
    var u3 = {};
    128 & t3[0] && (u3.value = e23[7]), 8192 & t3[0] && (u3.expandedMap = e23[13].expandedMap), 8192 & t3[0] && (u3.enforceStringMap = e23[13].enforceStringMap), 8192 & t3[0] && (u3.visibleSectionsMap = e23[13].visibleSectionsMap), 2097152 & t3[0] && (u3.validationErrorsMap = e23[21]), 16384 & t3[0] && (u3.searchResultItemsMap = (o3 = e23[14]) === null || o3 === void 0 ? void 0 : o3.itemsMap), 8192 & t3[0] && (u3.selection = e23[13].selection), 1024 & t3[0] && (u3.context = e23[10]), c2.$set(u3), e23[15] ? p2 ? (p2.p(e23, t3), 32768 & t3[0] && ya(p2, 1)) : ((p2 = CJ(e23)).c(), ya(p2, 1), p2.m(f2.parentNode, f2)) : p2 && (ma(), ba(p2, 1, 1, function() {
      p2 = null;
    }), ga()), e23[20] ? m2 ? (m2.p(e23, t3), 1048576 & t3[0] && ya(m2, 1)) : ((m2 = _J(e23)).c(), ya(m2, 1), m2.m(h2.parentNode, h2)) : m2 && (ma(), ba(m2, 1, 1, function() {
      m2 = null;
    }), ga());
    var l3 = {};
    512 & t3[0] && (l3.validationErrors = e23[9]), d2.$set(l3);
  }, i: function(e23) {
    v2 || (ya(a2.$$.fragment, e23), ya(c2.$$.fragment, e23), ya(p2), ya(m2), ya(d2.$$.fragment, e23), v2 = true);
  }, o: function(e23) {
    ba(a2.$$.fragment, e23), ba(c2.$$.fragment, e23), ba(p2), ba(m2), ba(d2.$$.fragment, e23), v2 = false;
  }, d: function(t3) {
    t3 && po(o2), Ea(a2), t3 && po(s2), t3 && po(u2), Ea(c2), e22[71](null), t3 && po(l2), p2 && p2.d(t3), t3 && po(f2), m2 && m2.d(t3), t3 && po(h2), Ea(d2, t3);
  } };
}
function SJ(e22) {
  var t2, n2, r2, i2, o2 = [OJ, $J], a2 = [];
  function s2(e23, t3) {
    return e23[8] === "" || e23[8] === void 0 ? 0 : 1;
  }
  return t2 = s2(e22), n2 = a2[t2] = o2[t2](e22), { c: function() {
    n2.c(), r2 = wo();
  }, m: function(e23, n3) {
    a2[t2].m(e23, n3), vo(e23, r2, n3), i2 = true;
  }, p: function(e23, i3) {
    var u2 = t2;
    (t2 = s2(e23)) === u2 ? a2[t2].p(e23, i3) : (ma(), ba(a2[u2], 1, 1, function() {
      a2[u2] = null;
    }), ga(), (n2 = a2[t2]) ? n2.p(e23, i3) : (n2 = a2[t2] = o2[t2](e23)).c(), ya(n2, 1), n2.m(r2.parentNode, r2));
  }, i: function(e23) {
    i2 || (ya(n2), i2 = true);
  }, o: function(e23) {
    ba(n2), i2 = false;
  }, d: function(e23) {
    a2[t2].d(e23), e23 && po(r2);
  } };
}
function CJ(e22) {
  var t2, n2;
  return t2 = new sS({ props: { type: "info", message: "You pasted a JSON ".concat(Array.isArray(e22[15].contents) ? "array" : "object", " as text"), actions: [{ icon: Sj, text: "Paste as JSON instead", onMouseDown: e22[43] }, { text: "Leave as is", onClick: e22[44] }] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    32768 & n3[0] && (r2.message = "You pasted a JSON ".concat(Array.isArray(e23[15].contents) ? "array" : "object", " as text")), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function _J(e22) {
  var t2, n2;
  return t2 = new sS({ props: { type: "success", message: "The loaded JSON document was invalid but is successfully repaired.", actions: e22[0] ? [] : [{ icon: aj, text: "Ok", onClick: e22[5] }, { icon: fj, text: "Repair manually instead", onClick: e22[3] }] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    9 & n3[0] && (r2.actions = e23[0] ? [] : [{ icon: aj, text: "Ok", onClick: e23[5] }, { icon: fj, text: "Repair manually instead", onClick: e23[3] }]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function $J(e22) {
  var t2, n2, r2, i2, o2, a2 = Uq(e22[8], 2e4) + "";
  return t2 = new sS({ props: { type: "error", message: "The loaded JSON document is invalid and could not be repaired automatically.", actions: e22[0] ? [] : [{ icon: fj, text: "Repair manually", onClick: e22[3] }] } }), { c: function() {
    Aa(t2.$$.fragment), n2 = ko(), r2 = go("div"), i2 = bo(a2), So(r2, "class", "jse-preview svelte-1wno2xw");
  }, m: function(e23, a3) {
    Ma(t2, e23, a3), vo(e23, n2, a3), vo(e23, r2, a3), uo(r2, i2), o2 = true;
  }, p: function(e23, n3) {
    var r3 = {};
    9 & n3[0] && (r3.actions = e23[0] ? [] : [{ icon: fj, text: "Repair manually", onClick: e23[3] }]), t2.$set(r3), (!o2 || 256 & n3[0]) && a2 !== (a2 = Uq(e23[8], 2e4) + "") && Ao(i2, a2);
  }, i: function(e23) {
    o2 || (ya(t2.$$.fragment, e23), o2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), o2 = false;
  }, d: function(e23) {
    Ea(t2, e23), e23 && po(n2), e23 && po(r2);
  } };
}
function OJ(e22) {
  var t2, n2;
  return t2 = new IW({ props: { readOnly: e22[0] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    1 & n3[0] && (r2.readOnly = e23[0]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function AJ(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2 = e22[1] && bJ(e22), l2 = e22[2] && kJ(e22), f2 = [xJ, wJ], h2 = [];
  return i2 = function(e23, t3) {
    return e23[22] ? 1 : 0;
  }(e22), o2 = h2[i2] = f2[i2](e22), { c: function() {
    t2 = go("div"), c2 && c2.c(), n2 = ko(), l2 && l2.c(), r2 = ko(), o2.c(), So(t2, "class", "jse-tree-mode svelte-1wno2xw"), To(t2, "no-main-menu", !e22[1]);
  }, m: function(o3, f3) {
    vo(o3, t2, f3), c2 && c2.m(t2, null), uo(t2, n2), l2 && l2.m(t2, null), uo(t2, r2), h2[i2].m(t2, null), e22[72](t2), a2 = true, s2 || (u2 = [xo(gJ, "mousedown", e22[46]), xo(t2, "keydown", e22[39]), xo(t2, "mousedown", e22[40]), xo(t2, "contextmenu", e22[41])], s2 = true);
  }, p: function(e23, i3) {
    e23[1] ? c2 ? (c2.p(e23, i3), 2 & i3[0] && ya(c2, 1)) : ((c2 = bJ(e23)).c(), ya(c2, 1), c2.m(t2, n2)) : c2 && (ma(), ba(c2, 1, 1, function() {
      c2 = null;
    }), ga()), e23[2] ? l2 ? (l2.p(e23, i3), 4 & i3[0] && ya(l2, 1)) : ((l2 = kJ(e23)).c(), ya(l2, 1), l2.m(t2, r2)) : l2 && (ma(), ba(l2, 1, 1, function() {
      l2 = null;
    }), ga()), o2.p(e23, i3), 2 & i3[0] && To(t2, "no-main-menu", !e23[1]);
  }, i: function(e23) {
    a2 || (ya(c2), ya(l2), ya(o2), a2 = true);
  }, o: function(e23) {
    ba(c2), ba(l2), ba(o2), a2 = false;
  }, d: function(n3) {
    n3 && po(t2), c2 && c2.d(), l2 && l2.d(), h2[i2].d(), e22[72](null), s2 = false, Wi(u2);
  } };
}
function MJ(e22) {
  return e22.length === 0 || e22.length === 1 && e22[0] === "0";
}
function EJ() {
  return true;
}
function PJ(e22, t2, n2) {
  var r2, i2 = Ia("jsoneditor:TreeMode"), o2 = typeof window == "undefined";
  i2("isSSR:", o2);
  var a2, s2, u2, c2, l2, f2 = Yo("simple-modal").open, h2 = Hk(), d2 = Hk(), v2 = Yo("absolute-popup"), p2 = v2.openAbsolutePopup, m2 = v2.closeAbsolutePopup, g2 = false, y2 = vq(), b2 = t2.readOnly, k2 = b2 !== void 0 && b2, w2 = t2.externalContent, x2 = t2.mainMenuBar, j2 = x2 === void 0 || x2, S2 = t2.navigationBar, C2 = S2 === void 0 || S2, _2 = t2.escapeControlCharacters, $2 = _2 !== void 0 && _2, O2 = t2.escapeUnicodeCharacters, A2 = O2 !== void 0 && O2, M2 = t2.validator, E2 = M2 === void 0 ? null : M2, P2 = t2.indentation, N2 = P2 === void 0 ? 2 : P2, T2 = t2.onError, I2 = t2.onChange, R2 = t2.onRenderValue, D2 = t2.onRequestRepair, z2 = D2 === void 0 ? Vu : D2, L2 = t2.onRenderMenu, B2 = L2 === void 0 ? Vu : L2, q2 = t2.onClassName, F2 = t2.onFocus, V2 = t2.onBlur, H2 = t2.onSortModal, W2 = t2.onTransformModal, J2 = false;
  Oj({ onMount: Uo, onDestroy: Ko, getWindow: function() {
    return Ox(u2);
  }, hasFocus: function() {
    return J2 && document.hasFocus() || Ax(u2);
  }, onFocus: function() {
    g2 = true, F2 && F2();
  }, onBlur: function() {
    g2 = false, V2 && V2();
  } });
  var U2 = [];
  function K2(e23) {
    i2("updateSelection", e23);
    var t3 = typeof e23 == "function" ? e23(Z2.selection) : e23;
    wm(t3, Z2.selection) || n2(13, Z2 = Ei(Ei({}, Z2), {}, { selection: t3 }));
  }
  var G2, Q2, Y2, Z2 = bq({ json: c2, expand: X2(c2) });
  function X2(e23) {
    return nx({ json: e23 }, 10240) ? MJ : EJ;
  }
  var ee2 = false, te2 = false, ne2 = false, re2 = "";
  function ie2(e23) {
    return oe2.apply(this, arguments);
  }
  function oe2() {
    return (oe2 = yi(mi().mark(function e23(t3) {
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              return i2("search text updated", t3), n2(68, re2 = t3), e24.next = 4, oa();
            case 4:
              return e24.next = 6, le2();
            case 6:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function ae2() {
    return (ae2 = yi(mi().mark(function e23() {
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              return n2(14, G2 = G2 ? IF(G2) : void 0), e24.next = 3, le2();
            case 3:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function se2() {
    return (se2 = yi(mi().mark(function e23() {
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              return n2(14, G2 = G2 ? RF(G2) : void 0), e24.next = 3, le2();
            case 3:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function ue2() {
    return (ue2 = yi(mi().mark(function e23(t3, n3) {
      var r3, o3, a3, s3;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              if (r3 = G2 == null ? void 0 : G2.activeItem, i2("handleReplace", { replacementText: n3, activeItem: r3 }), r3) {
                e24.next = 4;
                break;
              }
              return e24.abrupt("return");
            case 4:
              return o3 = qF(c2, Z2, n3, r3), a3 = o3.operations, s3 = o3.newSelection, at2(a3, function(e25, t4) {
                return { state: Ei(Ei({}, t4), {}, { selection: s3 }) };
              }), e24.next = 8, oa();
            case 8:
              return e24.next = 10, le2();
            case 10:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function ce2() {
    return (ce2 = yi(mi().mark(function e23(t3, n3) {
      var r3, o3, a3;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              return i2("handleReplaceAll", { text: t3, replacementText: n3 }), r3 = FF(c2, Z2, t3, n3), o3 = r3.operations, a3 = r3.newSelection, at2(o3, function(e25, t4) {
                return { state: Ei(Ei({}, t4), {}, { selection: a3 }) };
              }), e24.next = 5, oa();
            case 5:
              return e24.next = 7, le2();
            case 7:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function le2() {
    return fe2.apply(this, arguments);
  }
  function fe2() {
    return (fe2 = yi(mi().mark(function e23() {
      var t3, r3;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              if (t3 = G2 == null ? void 0 : G2.activeItem, i2("focusActiveSearchResult", G2), !t3) {
                e24.next = 9;
                break;
              }
              return r3 = t3.path, n2(13, Z2 = Ei(Ei({}, xq(c2, Z2, r3)), {}, { selection: void 0 })), e24.next = 7, oa();
            case 7:
              return e24.next = 9, tt2(r3);
            case 9:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  var he2 = Wq({ onChange: function(e23) {
    n2(19, de2 = e23);
  } }), de2 = he2.getState();
  var ve2, pe2, me2 = lk(function() {
    if (re2 === "")
      return i2("clearing search result"), void (G2 !== void 0 && n2(14, G2 = void 0));
    n2(18, ne2 = true), setTimeout(function() {
      i2("searching...", re2);
      var e23 = DF(re2, c2, Z2, 1e3);
      n2(14, G2 = function(e24, t3, n3) {
        var r3 = (n3 == null ? void 0 : n3.activeItem) ? VF(n3.activeItem) : void 0, i3 = t3.findIndex(function(e25) {
          return wm(r3, VF(e25));
        }), o3 = i3 !== -1 ? i3 : (n3 == null ? void 0 : n3.activeIndex) < t3.length ? n3 == null ? void 0 : n3.activeIndex : t3.length > 0 ? 0 : -1, a3 = t3.map(function(e25, t4) {
          return Ei(Ei({}, e25), {}, { active: t4 === o3 });
        }), s3 = a3[o3];
        return { items: a3, itemsMap: Ep(a3, function(e25) {
          return cs.exports.compileJSONPointer(e25.path);
        }), activeItem: s3, activeIndex: o3 };
      }(0, e23, G2)), n2(18, ne2 = false);
    });
  }, 300), ge2 = false, ye2 = [];
  function be2() {
    return c2;
  }
  function ke2() {
    return Z2;
  }
  function we2(e23) {
    e23.json !== void 0 && function(e24) {
      if (e24 === void 0)
        return;
      var t3 = !wm(c2, e24);
      if (i2("update external json", { isChanged: t3, currentlyText: c2 === void 0 }), !t3)
        return;
      var r3 = Z2, o3 = c2, a3 = l2, s3 = ge2;
      n2(7, c2 = e24), n2(13, Z2 = jq(c2, Z2, U2, X2(c2))), n2(8, l2 = void 0), n2(20, ge2 = false), xe2(c2), je2({ previousJson: o3, previousState: r3, previousText: a3, previousTextIsRepaired: s3 });
    }(e23.json), e23.text !== void 0 && function(e24) {
      if (e24 === void 0 || w2.json !== void 0)
        return;
      if (e24 === l2)
        return;
      i2("update external text");
      var t3 = c2, r3 = Z2, o3 = l2, a3 = ge2;
      try {
        n2(7, c2 = JSON.parse(e24)), n2(13, Z2 = jq(c2, Z2, U2, X2(c2))), n2(8, l2 = e24), n2(20, ge2 = false), xe2(c2);
      } catch (t4) {
        try {
          n2(7, c2 = JSON.parse(_s(e24))), n2(13, Z2 = jq(c2, Z2, U2, X2(c2))), n2(8, l2 = e24), n2(20, ge2 = true), xe2(c2);
        } catch (e25) {
          n2(7, c2 = void 0), n2(8, l2 = w2.text), n2(20, ge2 = false), xe2(c2);
        }
      }
      je2({ previousJson: t3, previousState: r3, previousText: o3, previousTextIsRepaired: a3 });
    }(e23.text);
  }
  function xe2(e23) {
    Z2.selection !== void 0 && (Z2.selection && cs.exports.existsIn(e23, Z2.selection.anchorPath) && cs.exports.existsIn(e23, Z2.selection.focusPath) || (i2("clearing selection: path does not exist anymore", Z2.selection), n2(13, Z2 = Ei(Ei({}, Z2), {}, { selection: void 0 }))));
  }
  function je2(e23) {
    var t3 = e23.previousJson, n3 = e23.previousState, r3 = e23.previousText, i3 = e23.previousTextIsRepaired;
    t3 === void 0 && r3 === void 0 || (c2 !== void 0 ? t3 !== void 0 ? he2.add({ undo: { patch: [{ op: "replace", path: "", value: t3 }], state: dF(n3), json: void 0, text: r3, textIsRepaired: i3 }, redo: { patch: [{ op: "replace", path: "", value: c2 }], state: dF(Z2), json: void 0, text: l2, textIsRepaired: ge2 } }) : he2.add({ undo: { patch: void 0, json: void 0, text: r3, state: dF(n3), textIsRepaired: i3 }, redo: { patch: void 0, json: c2, state: dF(Z2), text: l2, textIsRepaired: ge2 } }) : t3 !== void 0 && he2.add({ undo: { patch: void 0, json: t3, state: dF(n3), text: r3, textIsRepaired: i3 }, redo: { patch: void 0, json: void 0, text: l2, textIsRepaired: ge2, state: dF(Z2) } }));
  }
  function Se2() {
    i2("createDefaultSelection"), n2(13, Z2 = Ei(Ei({}, Z2), {}, { selection: yF(c2 || {}, [], []) }));
  }
  function Ce2(e23, t3) {
    if (i2("patch", e23, t3), c2 === void 0)
      throw new Error("Cannot apply patch: no JSON");
    var r3 = c2, o3 = Z2, a3 = l2, s3 = ge2, u3 = function(e24, t4) {
      return cs.exports.revertJSONPatch(e24, t4, { before: function(e25, t5, n3) {
        if (cs.exports.isJSONPatchRemove(t5)) {
          var r4 = cs.exports.parseJSONPointer(t5.path);
          return { revertOperations: [].concat(Ni(n3), Ni(TF(e25, r4))) };
        }
        if (cs.exports.isJSONPatchMove(t5)) {
          var i3 = cs.exports.parseJSONPointer(t5.from);
          return { revertOperations: [].concat(Ni(n3), Ni(TF(e25, i3))) };
        }
        return { revertOperations: n3 };
      } });
    }(c2, e23), f3 = $q(c2, Z2, e23), h3 = sF(c2, e23), d3 = function(e24, t4) {
      var n3 = !(arguments.length > 2 && arguments[2] !== void 0) || arguments[2];
      return t4 !== void 0 || n3 ? Ei(Ei({}, e24), {}, { selection: t4 }) : e24;
    }(f3.documentState, h3, false);
    i2("patch updatedSelection", h3);
    var v3 = typeof t3 == "function" ? t3(f3.json, d3) : void 0;
    n2(7, c2 = v3 && v3.json !== void 0 ? v3.json : f3.json);
    var p3 = v3 && v3.state !== void 0 ? v3.state : d3;
    return n2(13, Z2 = p3), n2(8, l2 = void 0), n2(20, ge2 = false), xe2(c2), he2.add({ undo: { patch: u3, json: void 0, text: a3, state: dF(o3), textIsRepaired: s3 }, redo: { patch: e23, json: void 0, state: dF(p3), text: l2, textIsRepaired: ge2 } }), { json: c2, previousJson: r3, undo: u3, redo: e23 };
  }
  function _e2(e23) {
    return Xq(e23) || Yq(e23) || Zq(e23);
  }
  function $e2() {
    !k2 && Z2.selection && K2(vF(Z2.selection.focusPath, true));
  }
  function Oe2() {
    !k2 && Z2.selection && K2(pF(Z2.selection.focusPath, true));
  }
  function Ae2() {
    if (!k2 && Zq(Z2.selection)) {
      var e23 = Z2.selection.focusPath, t3 = cs.exports.compileJSONPointer(e23), n3 = cs.exports.getIn(c2, e23), r3 = !zq(n3, Z2.enforceStringMap, t3), o3 = r3 ? String(n3) : Ns(String(n3));
      i2("handleToggleEnforceString", { enforceString: r3, value: n3, updatedValue: o3 }), at2([{ op: "replace", path: cs.exports.compileJSONPointer(e23), value: o3 }], function(e24, n4) {
        return { state: _q(n4, t3, r3) };
      });
    }
  }
  function Me2() {
    return Ee2.apply(this, arguments);
  }
  function Ee2() {
    return (Ee2 = yi(mi().mark(function e23() {
      var t3, n3, r3, o3, a3, s3, u3 = arguments;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              if (t3 = !(u3.length > 0 && u3[0] !== void 0) || u3[0], !k2 && _e2(Z2.selection)) {
                e24.next = 3;
                break;
              }
              return e24.abrupt("return");
            case 3:
              if (n3 = t3 ? N2 : null, (r3 = bF(c2, Z2.selection, n3)) != null) {
                e24.next = 7;
                break;
              }
              return e24.abrupt("return");
            case 7:
              return i2("cut", { selection: Z2.selection, clipboard: r3, indent: t3 }), e24.prev = 8, e24.next = 11, navigator.clipboard.writeText(r3);
            case 11:
              e24.next = 16;
              break;
            case 13:
              e24.prev = 13, e24.t0 = e24.catch(8), T2(e24.t0);
            case 16:
              o3 = NF(c2, Z2.selection), a3 = o3.operations, s3 = o3.newSelection, at2(a3, function(e25, t4) {
                return { state: Ei(Ei({}, t4), {}, { selection: s3 }) };
              });
            case 18:
            case "end":
              return e24.stop();
          }
      }, e23, null, [[8, 13]]);
    }))).apply(this, arguments);
  }
  function Pe2() {
    return Ne2.apply(this, arguments);
  }
  function Ne2() {
    return (Ne2 = yi(mi().mark(function e23() {
      var t3, n3, r3, o3 = arguments;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              if (t3 = !(o3.length > 0 && o3[0] !== void 0) || o3[0], n3 = t3 ? N2 : null, (r3 = bF(c2, Z2.selection, n3)) != null) {
                e24.next = 5;
                break;
              }
              return e24.abrupt("return");
            case 5:
              return i2("copy", { clipboard: r3, indent: t3 }), e24.prev = 6, e24.next = 9, navigator.clipboard.writeText(r3);
            case 9:
              e24.next = 14;
              break;
            case 11:
              e24.prev = 11, e24.t0 = e24.catch(6), T2(e24.t0);
            case 14:
            case "end":
              return e24.stop();
          }
      }, e23, null, [[6, 11]]);
    }))).apply(this, arguments);
  }
  function Te2() {
    f2(XF, {}, Ei(Ei({}, Za), {}, { styleWindow: { width: "450px" } }), { onClose: function() {
      return mt2();
    } });
  }
  function Ie2(e23) {
    if (c2 !== void 0) {
      Z2.selection || Se2();
      var t3 = AF(c2, Z2.selection, e23);
      i2("paste", { clipboardText: e23, operations: t3, selection: Z2.selection }), at2(t3, function(e24, n3) {
        var r3 = n3;
        return t3.filter(function(e25) {
          return (cs.exports.isJSONPatchAdd(e25) || cs.exports.isJSONPatchReplace(e25)) && Os(e25.value);
        }).forEach(function(t4) {
          var n4 = cs.exports.parsePath(c2, t4.path);
          r3 = ut2(e24, r3, n4);
        }), { state: r3 };
      });
    } else
      i2("paste text", { clipboardText: e23 }), function(e24, t4) {
        i2("handleChangeText");
        var r3 = Z2, o3 = c2, a3 = l2, s3 = { json: c2, text: l2 }, u3 = ge2;
        try {
          n2(7, c2 = JSON.parse(e24)), n2(13, Z2 = jq(c2, Z2, U2, MJ)), n2(8, l2 = void 0), n2(20, ge2 = false);
        } catch (t5) {
          try {
            n2(7, c2 = JSON.parse(_s(e24))), n2(13, Z2 = jq(c2, Z2, U2, MJ)), n2(8, l2 = e24), n2(20, ge2 = true);
          } catch (t6) {
            n2(7, c2 = void 0), n2(13, Z2 = bq({ json: c2, expand: MJ })), n2(8, l2 = e24), n2(20, ge2 = false);
          }
        }
        if (typeof t4 == "function") {
          var f3 = t4(c2, Z2);
          n2(7, c2 = f3 && f3.json ? f3.json : c2), n2(13, Z2 = f3 && f3.state ? f3.state : Z2);
        }
        xe2(c2), je2({ previousJson: o3, previousState: r3, previousText: a3, previousTextIsRepaired: u3 }), ot2(s3, null);
      }(e23, function(e24, t4) {
        if (e24) {
          return { state: ut2(e24, t4, []) };
        }
      });
  }
  function Re2() {
    if (!k2 && Z2.selection) {
      var e23 = Yq(Z2.selection) || Zq(Z2.selection) ? yF(c2, Z2.selection.anchorPath, Z2.selection.focusPath) : Z2.selection;
      if (km(Z2.selection.focusPath)) {
        i2("remove root", { selection: Z2.selection });
        I2({ text: "", json: void 0 }, { text: l2, json: c2 }, null);
      } else {
        var t3 = NF(c2, e23), n3 = t3.operations, r3 = t3.newSelection;
        i2("remove", { operations: n3, selection: Z2.selection, newSelection: r3 }), at2(n3, function(e24, t4) {
          return { state: Ei(Ei({}, t4), {}, { selection: r3 }) };
        });
      }
    }
  }
  function De2() {
    k2 || !_e2(Z2.selection) || km(Z2.selection.focusPath) || (i2("duplicate", { selection: Z2.selection }), at2(function(e23, t3) {
      var n3 = yv(t3);
      if (km(n3))
        throw new Error("Cannot duplicate root object");
      var r3 = Gp(n3), i3 = yv(n3), o3 = cs.exports.getIn(e23, r3);
      if (Uw(o3)) {
        var a3 = yv(t3), s3 = a3 ? Ww(yv(a3)) + 1 : 0;
        return Ni(t3.map(function(e24, t4) {
          return { op: "copy", from: cs.exports.compileJSONPointer(e24), path: cs.exports.compileJSONPointer(r3.concat(String(t4 + s3))) };
        }));
      }
      if (Jw(o3)) {
        var u3 = Object.keys(o3), c3 = Lq(u3, i3, false);
        return [].concat(Ni(t3.map(function(e24) {
          var t4 = Jq(yv(e24), u3);
          return { op: "copy", from: cs.exports.compileJSONPointer(e24), path: cs.exports.compileJSONPointer(r3.concat(t4)) };
        })), Ni(c3.map(function(e24) {
          return EF(r3, e24);
        })));
      }
      throw new Error("Cannot create duplicate operations: parent must be an Object or Array");
    }(c2, kF(Z2.selection))));
  }
  function ze2() {
    k2 || !Z2.selection || !Xq(Z2.selection) && !Zq(Z2.selection) || km(Z2.selection.focusPath) || (i2("extract", { selection: Z2.selection }), at2(function(e23, t3) {
      if (Zq(t3))
        return [{ op: "move", from: cs.exports.compileJSONPointer(t3.focusPath), path: "" }];
      if (!Xq(t3))
        throw new Error("Cannot create extract operations: parent must be an Object or Array");
      var n3 = Gp(t3.focusPath), r3 = cs.exports.getIn(e23, n3);
      if (Uw(r3))
        return [{ op: "replace", path: "", value: t3.paths.map(function(e24) {
          var t4 = Ww(yv(e24));
          return r3[t4];
        }) }];
      if (Jw(r3)) {
        var i3 = {};
        return t3.paths.forEach(function(e24) {
          var t4 = String(yv(e24));
          i3[t4] = r3[t4];
        }), [{ op: "replace", path: "", value: i3 }];
      }
      throw new Error("Cannot extract: unsupported type of selection " + JSON.stringify(t3));
    }(c2, Z2.selection), function(e23, t3) {
      if (Os(e23)) {
        return { state: ut2(e23, t3, []) };
      }
    }));
  }
  function Le2(e23) {
    if (!k2 && Z2.selection) {
      var t3 = function(e24, t4, n4) {
        if (n4 === "object")
          return {};
        if (n4 === "array")
          return [];
        if (n4 === "structure") {
          var r4 = eF(t4), i3 = cs.exports.getIn(e24, r4);
          if (Array.isArray(i3) && !km(i3)) {
            var o4 = cp(i3);
            return Os(o4) ? rd(o4, function(e25) {
              return Array.isArray(e25) ? [] : $s(e25) ? void 0 : "";
            }) : "";
          }
        }
        return "";
      }(c2, Z2.selection, e23);
      if (c2 !== void 0) {
        var n3 = JSON.stringify(t3), r3 = AF(c2, Z2.selection, n3);
        i2("handleInsert", { type: e23, operations: r3, newValue: t3, data: n3 });
        var o3 = yv(r3.filter(function(e24) {
          return e24.op === "add" || e24.op === "replace";
        }));
        at2(r3, function(e24, n4) {
          if (o3) {
            var r4 = cs.exports.parsePath(e24, o3.path);
            if (Os(t3))
              return { state: Ei(Ei({}, jq(e24, n4, r4, EJ)), {}, { selection: mF(r4) }) };
            if (t3 === "") {
              var a4 = km(r4) ? null : cs.exports.getIn(e24, Gp(r4));
              return i2("test A", r4, mF(r4)), { state: xq(e24, Ei(Ei({}, Z2), {}, { selection: $s(a4) ? vF(r4, true) : pF(r4, true) }), r4) };
            }
          }
        }), i2("after patch"), o3 && t3 === "" && oa().then(function() {
          setTimeout(function() {
            return He2("", true);
          });
        });
      } else {
        i2("handleInsert", { type: e23, newValue: t3 });
        var a3 = [];
        st2(t3, function(e24, t4) {
          return { state: Ei(Ei({}, ut2(e24, t4, a3)), {}, { selection: mF(a3) }) };
        });
      }
    }
  }
  function Be2(e23) {
    Yq(Z2.selection) && K2(pF(Z2.selection.focusPath, false)), Le2(e23);
  }
  function qe2(e23) {
    if (!k2 && Z2.selection)
      if (xF(Z2.selection))
        try {
          var t3 = Z2.selection.anchorPath, n3 = cs.exports.getIn(c2, t3), r3 = function(e24, t4) {
            if (t4 === "array") {
              if (Array.isArray(e24))
                return e24;
              if ($s(e24))
                return Vw(e24);
              if (typeof e24 == "string") {
                var n4 = JSON.parse(e24);
                if (Array.isArray(n4))
                  return n4;
                if ($s(n4))
                  return Vw(n4);
              }
            }
            if (t4 === "object") {
              if (Array.isArray(e24))
                return Fw(e24);
              if ($s(e24))
                return e24;
              if (typeof e24 == "string") {
                var r4 = JSON.parse(e24);
                if ($s(r4))
                  return r4;
                if (Array.isArray(r4))
                  return Fw(r4);
              }
            }
            if (t4 === "value")
              return Os(e24) ? JSON.stringify(e24) : e24;
            throw new Error("Cannot convert ".concat(Ms(e24), " to ").concat(t4));
          }(n3, e23);
          if (r3 === n3)
            return;
          var o3 = [{ op: "replace", path: cs.exports.compileJSONPointer(t3), value: r3 }];
          i2("handleConvert", { selection: Z2.selection, path: t3, type: e23, operations: o3 }), at2(o3, function(e24, t4) {
            return { state: ut2(e24, t4, Z2.selection.focusPath) };
          });
        } catch (e24) {
          T2(e24);
        }
      else
        T2(new Error("Cannot convert current selection to ".concat(e23)));
  }
  function Fe2() {
    var e23 = iF(c2, Z2, false), t3 = Gp(Z2.selection.focusPath);
    !km(e23.focusPath) && wm(t3, Gp(e23.focusPath)) ? K2(gF(e23.focusPath)) : K2(mF(t3)), i2("insert before", { selection: Z2.selection, selectionBefore: e23, parentPath: t3 }), oa().then(vt2);
  }
  function Ve2() {
    var e23 = Xq(Z2.selection) ? yv(Z2.selection.paths) : Z2.selection.focusPath;
    i2("insert after", e23), K2(gF(e23)), oa().then(vt2);
  }
  function He2(e23, t3) {
    var n3 = Ox(u2).document.activeElement;
    n3.isContentEditable && (n3.textContent = t3 ? e23 : n3.textContent + e23, $x(n3));
  }
  function We2(e23) {
    return Je2.apply(this, arguments);
  }
  function Je2() {
    return (Je2 = yi(mi().mark(function e23(t3) {
      var n3, r3;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              if (!k2 && Z2.selection) {
                e24.next = 2;
                break;
              }
              return e24.abrupt("return");
            case 2:
              if (!Yq(Z2.selection)) {
                e24.next = 9;
                break;
              }
              return n3 = !Z2.selection.edit, K2(Ei(Ei({}, Z2.selection), {}, { edit: true })), e24.next = 7, oa();
            case 7:
              return setTimeout(function() {
                return He2(t3, n3);
              }), e24.abrupt("return");
            case 9:
              if (t3 !== "{") {
                e24.next = 13;
                break;
              }
              Le2("object"), e24.next = 28;
              break;
            case 13:
              if (t3 !== "[") {
                e24.next = 17;
                break;
              }
              Le2("array"), e24.next = 28;
              break;
            case 17:
              if (!Zq(Z2.selection)) {
                e24.next = 26;
                break;
              }
              if (Os(cs.exports.getIn(c2, Z2.selection.focusPath))) {
                e24.next = 24;
                break;
              }
              return r3 = !Z2.selection.edit, K2(Ei(Ei({}, Z2.selection), {}, { edit: true })), e24.next = 23, oa();
            case 23:
              setTimeout(function() {
                return He2(t3, r3);
              });
            case 24:
              e24.next = 28;
              break;
            case 26:
              return e24.next = 28, Ue2(t3);
            case 28:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function Ue2(e23) {
    return Ke2.apply(this, arguments);
  }
  function Ke2() {
    return (Ke2 = yi(mi().mark(function e23(t3) {
      var n3, r3, i3;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              if (!k2 && Z2.selection) {
                e24.next = 2;
                break;
              }
              return e24.abrupt("return");
            case 2:
              return Le2("value"), n3 = !wF(Z2.selection), r3 = Z2.selection.focusPath, i3 = cs.exports.getIn(c2, Gp(r3)), Array.isArray(i3) || !i3 || Zq(Z2.selection) ? K2(pF(r3, true)) : K2(vF(r3, true)), e24.next = 9, oa();
            case 9:
              setTimeout(function() {
                return He2(t3, n3);
              });
            case 10:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function Ge2() {
    if (!k2 && he2.getState().canUndo) {
      var e23 = he2.undo();
      if (e23) {
        var t3 = { json: c2, text: l2 };
        n2(7, c2 = e23.undo.patch ? cs.exports.immutableJSONPatch(c2, e23.undo.patch) : e23.undo.json), n2(13, Z2 = e23.undo.state), n2(8, l2 = e23.undo.text), n2(20, ge2 = e23.undo.textIsRepaired), i2("undo", { item: e23, json: c2, documentState: Z2 }), ot2(t3, { json: c2, previousJson: t3.json, redo: e23.undo.patch, undo: e23.redo.patch }), mt2(), Z2.selection && tt2(Z2.selection.focusPath, false);
      }
    }
  }
  function Qe2() {
    if (!k2 && he2.getState().canRedo) {
      var e23 = he2.redo();
      if (e23) {
        var t3 = { json: c2, text: l2 };
        n2(7, c2 = e23.redo.patch ? cs.exports.immutableJSONPatch(c2, e23.redo.patch) : e23.redo.json), n2(13, Z2 = e23.redo.state), n2(8, l2 = e23.redo.text), n2(20, ge2 = e23.redo.textIsRepaired), i2("redo", { item: e23, json: c2, documentState: Z2 }), ot2(t3, { json: c2, previousJson: t3.json, redo: e23.redo.patch, undo: e23.undo.patch }), mt2(), Z2.selection && tt2(Z2.selection.focusPath, false);
      }
    }
  }
  function Ye2(e23) {
    var t3;
    k2 || (J2 = true, H2({ id: h2, json: c2, selectedPath: e23, onSort: (t3 = yi(mi().mark(function t4(n3) {
      return mi().wrap(function(t5) {
        for (; ; )
          switch (t5.prev = t5.next) {
            case 0:
              i2("onSort", e23, n3), at2(n3, function(t6, n4) {
                return { state: Ei(Ei({}, ut2(t6, n4, e23)), {}, { selection: pF(e23, false) }) };
              });
            case 2:
            case "end":
              return t5.stop();
          }
      }, t4);
    })), function(e24) {
      return t3.apply(this, arguments);
    }), onClose: function() {
      J2 = false, mt2();
    } }));
  }
  function Ze2() {
    Z2.selection && Ye2(fF(c2, Z2.selection));
  }
  function Xe2(e23) {
    var t3 = e23.id, n3 = e23.selectedPath, r3 = e23.onTransform, o3 = e23.onClose;
    J2 = true, W2({ id: t3 || d2, json: c2, selectedPath: n3, onTransform: r3 ? function(e24) {
      r3({ operations: e24, json: c2, transformedJson: cs.exports.immutableJSONPatch(c2, e24) });
    } : function(e24) {
      i2("onTransform", n3, e24), at2(e24, function(e25, t4) {
        return { state: Ei(Ei({}, ut2(e25, t4, n3)), {}, { selection: pF(n3, false) }) };
      });
    }, onClose: function() {
      J2 = false, mt2(), o3 && o3();
    } });
  }
  function et2() {
    Z2.selection && Xe2({ selectedPath: fF(c2, Z2.selection) });
  }
  function tt2(e23) {
    return nt2.apply(this, arguments);
  }
  function nt2() {
    return (nt2 = yi(mi().mark(function e23(t3) {
      var r3, o3, s3, u3, l3, f3 = arguments;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              return r3 = !(f3.length > 1 && f3[1] !== void 0) || f3[1], n2(13, Z2 = xq(c2, Z2, Gp(t3))), e24.next = 4, oa();
            case 4:
              if (!(o3 = rt2(t3))) {
                e24.next = 14;
                break;
              }
              if (i2("scrollTo", { path: t3, elem: o3, refContents: a2 }), s3 = a2.getBoundingClientRect(), u3 = o3.getBoundingClientRect(), r3) {
                e24.next = 12;
                break;
              }
              if (!(u3.bottom > s3.top && u3.top < s3.bottom)) {
                e24.next = 12;
                break;
              }
              return e24.abrupt("return");
            case 12:
              l3 = -s3.height / 4, y2(o3, { container: a2, offset: l3, duration: 300 });
            case 14:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function rt2(e23) {
    return a2 ? a2.querySelector('div[data-path="'.concat(Px(e23), '"]')) : null;
  }
  function it2(e23) {
    var t3 = rt2(e23);
    if (t3 && a2) {
      var n3 = a2.getBoundingClientRect(), r3 = t3.getBoundingClientRect(), i3 = Os(cs.exports.getIn(c2, e23)) ? 20 : r3.height;
      r3.top < n3.top + 20 ? y2(t3, { container: a2, offset: -20, duration: 0 }) : r3.top + i3 > n3.bottom - 20 && y2(t3, { container: a2, offset: -(n3.height - i3 - 20), duration: 0 });
    }
  }
  function ot2(e23, t3) {
    l2 !== void 0 ? I2({ text: l2, json: void 0 }, e23, t3) : c2 !== void 0 && I2({ text: void 0, json: c2 }, e23, t3);
  }
  function at2(e23, t3) {
    if (!k2) {
      i2("handlePatch", e23, t3);
      var r3 = { json: c2, text: l2 }, o3 = Ce2(e23, t3);
      return n2(15, Y2 = void 0), ot2(r3, o3), o3;
    }
  }
  function st2(e23, t3) {
    var r3 = Z2, i3 = c2, o3 = l2, a3 = { json: c2, text: l2 }, s3 = ge2, u3 = jq(c2, Z2, U2, MJ), f3 = typeof t3 == "function" ? t3(e23, u3) : void 0;
    n2(7, c2 = f3 && f3.json !== void 0 ? f3.json : e23), n2(13, Z2 = f3 && f3.state !== void 0 ? f3.state : u3), n2(8, l2 = void 0), n2(20, ge2 = false), xe2(c2), je2({ previousJson: i3, previousState: r3, previousText: o3, previousTextIsRepaired: s3 });
    ot2(a3, null);
  }
  function ut2(e23, t3, n3) {
    return jq(e23, t3, n3, !nx({ json: cs.exports.getIn(e23, n3) }, 10240) ? EJ : MJ);
  }
  function ct2(e23, t3) {
    var r3 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2];
    i2("expand", { path: e23, expanded: t3, recursive: r3 }), n2(13, Z2 = t3 ? r3 ? jq(c2, Z2, e23, EJ) : Sq(Z2, e23) : Cq(Z2, e23)), Z2.selection && !t3 && rF(Z2.selection, e23) && K2(void 0), setTimeout(function() {
      Ax(u2) || mt2();
    });
  }
  function lt2(e23) {
    i2("openFind", { findAndReplace: e23 }), n2(16, ee2 = false), n2(17, te2 = false), oa().then(function() {
      n2(16, ee2 = true), n2(17, te2 = e23);
    });
  }
  function ft2(e23, t3) {
    i2("handleExpandSection", e23, t3);
    var r3 = cs.exports.compileJSONPointer(e23);
    n2(13, Z2 = function(e24, t4, n3, r4) {
      return Ei(Ei({}, t4), {}, { visibleSectionsMap: Ei(Ei({}, t4.visibleSectionsMap), {}, Pi({}, n3, pq(kq(t4, n3).concat(r4)))) });
    }(0, Z2, r3, t3));
  }
  function ht2(e23) {
    i2("pasted json as text", e23), n2(15, Y2 = e23);
  }
  function dt2(e23) {
    var t3 = e23.anchor, n3 = e23.left, r3 = e23.top, i3 = e23.width, o3 = e23.height, a3 = e23.offsetTop, s3 = e23.offsetLeft, u3 = e23.showTip;
    J2 = true;
    var l3 = p2(EV, { json: c2, documentState: Z2, showTip: u3, onEditKey: $e2, onEditValue: Oe2, onToggleEnforceString: Ae2, onCut: Me2, onCopy: Pe2, onPaste: Te2, onRemove: Re2, onDuplicate: De2, onExtract: ze2, onInsertBefore: Fe2, onInsert: Be2, onConvert: qe2, onInsertAfter: Ve2, onSort: Ze2, onTransform: et2, onCloseContextMenu: function() {
      m2(l3), mt2();
    } }, { left: n3, top: r3, offsetTop: a3, offsetLeft: s3, width: i3, height: o3, anchor: t3, closeOnOuterClick: true, onClose: function() {
      J2 = false, mt2();
    } });
  }
  function vt2(e23) {
    if (!k2 && !wF(Z2.selection)) {
      if (e23 && (e23.stopPropagation(), e23.preventDefault()), e23 && e23.type === "contextmenu" && e23.target !== s2)
        dt2({ left: e23.clientX, top: e23.clientY, width: 260, height: 336, showTip: false });
      else {
        var t3 = a2 == null ? void 0 : a2.querySelector(".jse-context-menu-button.jse-selected");
        if (t3)
          dt2({ anchor: t3, offsetTop: 2, width: 260, height: 336, showTip: false });
        else {
          var n3 = a2 == null ? void 0 : a2.getBoundingClientRect();
          n3 && dt2({ top: n3.top + 2, left: n3.left + 2, width: 260, height: 336, showTip: false });
        }
      }
      return false;
    }
  }
  function pt2() {
    return (pt2 = yi(mi().mark(function e23() {
      var t3, n3, r3;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              return i2("apply pasted json", Y2), n3 = (t3 = Y2).path, r3 = t3.contents, K2(pF(n3, false)), e24.next = 5, oa();
            case 5:
              at2([{ op: "replace", path: cs.exports.compileJSONPointer(n3), value: r3 }], function(e25, t4) {
                return { state: ut2(e25, t4, n3) };
              });
            case 7:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function mt2() {
    i2("focus"), s2 && (s2.focus(), s2.select());
  }
  function gt2(e23) {
    r2 && r2.onDrag(e23);
  }
  function yt2() {
    r2 && r2.onDragEnd();
  }
  return e22.$$set = function(e23) {
    "readOnly" in e23 && n2(0, k2 = e23.readOnly), "externalContent" in e23 && n2(47, w2 = e23.externalContent), "mainMenuBar" in e23 && n2(1, j2 = e23.mainMenuBar), "navigationBar" in e23 && n2(2, C2 = e23.navigationBar), "escapeControlCharacters" in e23 && n2(48, $2 = e23.escapeControlCharacters), "escapeUnicodeCharacters" in e23 && n2(49, A2 = e23.escapeUnicodeCharacters), "validator" in e23 && n2(50, E2 = e23.validator), "indentation" in e23 && n2(51, N2 = e23.indentation), "onError" in e23 && n2(52, T2 = e23.onError), "onChange" in e23 && n2(53, I2 = e23.onChange), "onRenderValue" in e23 && n2(54, R2 = e23.onRenderValue), "onRequestRepair" in e23 && n2(3, z2 = e23.onRequestRepair), "onRenderMenu" in e23 && n2(4, B2 = e23.onRenderMenu), "onClassName" in e23 && n2(55, q2 = e23.onClassName), "onFocus" in e23 && n2(56, F2 = e23.onFocus), "onBlur" in e23 && n2(57, V2 = e23.onBlur), "onSortModal" in e23 && n2(58, H2 = e23.onSortModal), "onTransformModal" in e23 && n2(59, W2 = e23.onTransformModal);
  }, e22.$$.update = function() {
    393216 & e22.$$.dirty[1] && n2(67, Q2 = fx({ escapeControlCharacters: $2, escapeUnicodeCharacters: A2 })), 65536 & e22.$$.dirty[1] && we2(w2), 128 & e22.$$.dirty[0] | 64 & e22.$$.dirty[2] && me2(re2, c2), e22.$$.dirty[0], 128 & e22.$$.dirty[0] | 524288 & e22.$$.dirty[1] && function(e23, t3) {
      var r3 = t3 ? t3(e23) : [];
      wm(r3, ye2) || (i2("updateValidationErrors", r3), n2(9, ye2 = r3));
    }(c2, E2), 512 & e22.$$.dirty[0] && n2(21, ve2 = function(e23) {
      var t3 = {};
      return e23.forEach(function(e24) {
        t3[cs.exports.compileJSONPointer(e24.path)] = e24;
      }), e23.forEach(function(e24) {
        for (var n3 = e24.path; n3.length > 0; ) {
          n3 = Gp(n3);
          var r3 = cs.exports.compileJSONPointer(n3);
          r3 in t3 || (t3[r3] = { isChildError: true, path: n3, message: "Contains invalid data" });
        }
      }), t3;
    }(ye2)), 64 & e22.$$.dirty[0] && (r2 = a2 ? function(e23) {
      var t3, n3;
      function r3(e24) {
        return e24 < 20 ? 200 : e24 < 50 ? 400 : 1200;
      }
      function i3() {
        if (e23) {
          var n4 = 0.05 * t3;
          e23.scrollTop += n4;
        }
      }
      function o3(e24) {
        n3 && e24 === t3 || (a3(), hq("startAutoScroll", e24), t3 = e24, n3 = setInterval(i3, 50));
      }
      function a3() {
        n3 && (hq("stopAutoScroll"), clearInterval(n3), n3 = void 0, t3 = void 0);
      }
      return hq("createAutoScrollHandler", e23), { onDrag: function(t4) {
        if (e23) {
          var n4 = t4.clientY, i4 = e23.getBoundingClientRect(), s3 = i4.top, u3 = i4.bottom;
          n4 < s3 ? o3(-r3(s3 - n4)) : n4 > u3 ? o3(r3(n4 - u3)) : a3();
        }
      }, onDragEnd: function() {
        a3();
      } };
    }(a2) : void 0), 1 & e22.$$.dirty[0] | 25165824 & e22.$$.dirty[1] | 32 & e22.$$.dirty[2] && n2(10, pe2 = { readOnly: k2, normalization: Q2, getJson: be2, getDocumentState: ke2, findElement: rt2, focus: mt2, onPatch: at2, onInsert: Le2, onExpand: ct2, onSelect: K2, onFind: lt2, onExpandSection: ft2, onPasteJson: ht2, onRenderValue: R2, onContextMenu: dt2, onClassName: q2 || function() {
    }, onDrag: gt2, onDragEnd: yt2 }), 1024 & e22.$$.dirty[0] && i2("context changed", pe2);
  }, [k2, j2, C2, z2, B2, function() {
    return ge2 && c2 !== void 0 && st2(c2), { json: c2, text: l2 };
  }, a2, c2, l2, ye2, pe2, s2, u2, Z2, G2, Y2, ee2, te2, ne2, de2, ge2, ve2, o2, U2, ie2, function() {
    return ae2.apply(this, arguments);
  }, function() {
    return se2.apply(this, arguments);
  }, function(e23, t3) {
    return ue2.apply(this, arguments);
  }, function(e23, t3) {
    return ce2.apply(this, arguments);
  }, function() {
    n2(16, ee2 = false), n2(17, te2 = false), ie2(""), mt2();
  }, function(e23) {
    i2("select validation error", e23), K2(pF(e23.path, false)), tt2(e23.path);
  }, Pe2, function(e23) {
    if (e23.preventDefault(), !k2) {
      var t3 = e23.clipboardData.getData("text/plain");
      try {
        Ie2(t3);
      } catch (e24) {
        !function(e25, t4) {
          f2(lV, { text: e25, onParse: Qw, onRepair: Yw, onApply: t4, onRenderMenu: B2 }, Ei(Ei({}, Za), {}, { styleWindow: { width: "600px", height: "500px" }, styleContent: { padding: 0, height: "100%" } }), { onClose: function() {
            return mt2();
          } });
        }(t3, function(e25) {
          i2("repaired pasted text: ", e25), Ie2(e25);
        });
      }
    }
  }, Ge2, Qe2, function() {
    Ye2([]);
  }, function() {
    Xe2({ selectedPath: [] });
  }, function() {
    ct2([], true, true);
  }, function() {
    ct2([], false, true);
  }, function(e23) {
    var t3 = Rx(e23).replace(/^Command\+/, "Ctrl+"), n3 = e23.shiftKey;
    if (t3 === "Ctrl+X" && (e23.preventDefault(), Me2(true)), t3 === "Ctrl+Shift+X" && (e23.preventDefault(), Me2(false)), t3 === "Ctrl+C" && (e23.preventDefault(), Pe2(true)), t3 === "Ctrl+Shift+C" && (e23.preventDefault(), Pe2(false)), t3 === "Ctrl+D" && (e23.preventDefault(), De2()), t3 !== "Delete" && t3 !== "Backspace" || (e23.preventDefault(), Re2()), t3 === "Insert" && (e23.preventDefault(), Le2("structure")), t3 === "Ctrl+A" && (e23.preventDefault(), K2(pF([], false))), t3 === "Ctrl+Q" && vt2(e23), t3 === "Up" || t3 === "Shift+Up") {
      e23.preventDefault();
      var r3 = Z2.selection ? iF(c2, Z2, n3, true) || Z2.selection : aF(c2, Z2);
      K2(r3), it2(r3.focusPath);
    }
    if (t3 === "Down" || t3 === "Shift+Down") {
      e23.preventDefault();
      var i3 = Z2.selection ? function(e24, t4) {
        var n4 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], r4 = arguments.length > 3 && arguments[3] !== void 0 && arguments[3], i4 = t4.selection, o4 = !r4 && Xq(i4) ? yv(i4.paths) : i4.focusPath, a4 = Vq(e24, t4, o4), s4 = a4, u4 = a4;
        if (a4 === null)
          return null;
        if (n4) {
          var c3 = Vq(e24, Os(cs.exports.getIn(e24, o4)) ? Cq(t4, o4) : t4, o4);
          return c3 === null ? null : Gq(i4) ? yF(e24, c3, c3) : Qq(i4) ? yF(e24, s4, u4) : yF(e24, i4.anchorPath, c3);
        }
        if (Yq(i4)) {
          var l4 = Gp(a4), f4 = cs.exports.getIn(e24, l4);
          return Array.isArray(f4) ? pF(u4, false) : vF(u4, false);
        }
        return Zq(i4) ? pF(u4, false) : Qq(i4) ? yF(e24, s4, u4) : yF(e24, a4, a4);
      }(c2, Z2, n3, true) || Z2.selection : aF(c2, Z2);
      K2(i3), it2(i3.focusPath);
    }
    if (t3 === "Left" || t3 === "Shift+Left") {
      e23.preventDefault();
      var o3 = Z2.selection ? function(e24, t4) {
        var n4 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], r4 = !(arguments.length > 3 && arguments[3] !== void 0) || arguments[3], i4 = t4.selection, o4 = oF(e24, t4, r4), a4 = o4.caret, s4 = o4.previous;
        if (n4)
          return Xq(i4) ? null : yF(e24, i4.anchorPath, i4.focusPath);
        if (a4 && s4)
          return jF(s4);
        var u4 = Gp(i4.focusPath), c3 = cs.exports.getIn(e24, u4);
        return Zq(i4) && Array.isArray(c3) ? yF(e24, i4.focusPath, i4.focusPath) : Xq(i4) && !Array.isArray(c3) ? vF(i4.focusPath, false) : null;
      }(c2, Z2, n3, !k2) || Z2.selection : aF(c2, Z2);
      K2(o3), it2(o3.focusPath);
    }
    if (t3 === "Right" || t3 === "Shift+Right") {
      e23.preventDefault();
      var a3 = Z2.selection ? function(e24, t4) {
        var n4 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2], r4 = !(arguments.length > 3 && arguments[3] !== void 0) || arguments[3], i4 = t4.selection, o4 = oF(e24, t4, r4), a4 = o4.caret, s4 = o4.next;
        return n4 ? Xq(i4) ? null : yF(e24, i4.anchorPath, i4.focusPath) : a4 && s4 ? jF(s4) : Xq(i4) ? pF(i4.focusPath, false) : null;
      }(c2, Z2, n3, !k2) || Z2.selection : aF(c2, Z2);
      K2(a3), it2(a3.focusPath);
    }
    if (t3 === "Enter" && Z2.selection) {
      if (!k2 && Xq(Z2.selection) && Z2.selection.paths.length === 1) {
        var s3 = Z2.selection.focusPath, u3 = cs.exports.getIn(c2, Gp(s3));
        Array.isArray(u3) && K2(pF(s3, false));
      }
      if (!k2 && Yq(Z2.selection) && (e23.preventDefault(), K2(Ei(Ei({}, Z2.selection), {}, { edit: true }))), Zq(Z2.selection))
        e23.preventDefault(), Os(cs.exports.getIn(c2, Z2.selection.focusPath)) ? ct2(Z2.selection.focusPath, true) : k2 || K2(Ei(Ei({}, Z2.selection), {}, { edit: true }));
    }
    if (t3.length === (t3.startsWith("Shift+") ? 7 : 1) && Z2.selection)
      return e23.preventDefault(), void We2(e23.key);
    if (t3 === "Enter" && (Gq(Z2.selection) || Qq(Z2.selection)))
      return e23.preventDefault(), void We2("");
    if (t3 === "Ctrl+Enter" && Zq(Z2.selection)) {
      var l3 = cs.exports.getIn(c2, Z2.selection.focusPath);
      Ps(l3) && window.open(String(l3), "_blank");
    }
    if (t3 === "Escape" && Z2.selection && (e23.preventDefault(), K2(void 0)), t3 === "Ctrl+F" && (e23.preventDefault(), lt2(false)), t3 === "Ctrl+H" && (e23.preventDefault(), lt2(true)), t3 === "Ctrl+Z") {
      e23.preventDefault();
      var f3 = document.activeElement;
      f3 && f3.blur && f3.focus ? (f3.blur(), setTimeout(function() {
        Ge2(), setTimeout(function() {
          return f3.select();
        });
      })) : Ge2();
    }
    if (t3 === "Ctrl+Shift+Z") {
      e23.preventDefault();
      var h3 = document.activeElement;
      h3 && h3.blur && h3.focus ? (h3.blur(), setTimeout(function() {
        Qe2(), setTimeout(function() {
          return h3.select();
        });
      })) : Qe2();
    }
  }, function(e23) {
    i2("handleMouseDown", e23), setTimeout(function() {
      setTimeout(function() {
        g2 || jx(e23.target, "BUTTON") || (mt2(), Z2.selection || c2 !== void 0 || l2 !== "" && l2 !== void 0 || Se2());
      });
    });
  }, vt2, function(e23) {
    k2 || dt2({ anchor: Mx(e23.target, "BUTTON"), offsetTop: 0, width: 260, height: 336, showTip: true });
  }, function() {
    return pt2.apply(this, arguments);
  }, function() {
    i2("clear pasted json"), n2(15, Y2 = void 0);
  }, function(e23) {
    K2(e23), mt2(), tt2(e23.focusPath);
  }, function(e23) {
    !Cx(e23.target, function(e24) {
      return e24 === u2;
    }) && wF(Z2.selection) && (i2("click outside the editor, stop edit mode"), K2(function(e24) {
      return Yq(e24) || Zq(e24) ? Ei(Ei({}, e24), {}, { edit: false }) : e24;
    }), g2 && s2 && (s2.focus(), s2.blur()), oa().then(function() {
      setTimeout(function() {
        s2 && s2.blur();
      });
    }));
  }, w2, $2, A2, E2, N2, T2, I2, R2, q2, F2, V2, H2, W2, function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : function() {
      return true;
    };
    i2("expand");
    var t3 = Ei(Ei({}, Z2), {}, { expandedMap: {}, visibleSectionsMap: {} });
    n2(13, Z2 = jq(c2, t3, U2, e23));
  }, be2, Ce2, Xe2, tt2, rt2, mt2, Q2, re2, function(e23) {
    n2(16, ee2 = e23);
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(11, s2 = e23);
    });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(6, a2 = e23);
    });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(12, u2 = e23);
    });
  }];
}
var NJ = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, PJ, AJ, Ki, { readOnly: 0, externalContent: 47, mainMenuBar: 1, navigationBar: 2, escapeControlCharacters: 48, escapeUnicodeCharacters: 49, validator: 50, indentation: 51, onError: 52, onChange: 53, onRenderValue: 54, onRequestRepair: 3, onRenderMenu: 4, onClassName: 55, onFocus: 56, onBlur: 57, onSortModal: 58, onTransformModal: 59, expand: 60, getJson: 61, patch: 62, acceptAutoRepair: 5, openTransformModal: 63, scrollTo: 64, findElement: 65, focus: 66 }, yJ, [-1, -1, -1, -1, -1]), r2;
  }
  return zi(n2, [{ key: "expand", get: function() {
    return this.$$.ctx[60];
  } }, { key: "getJson", get: function() {
    return this.$$.ctx[61];
  } }, { key: "patch", get: function() {
    return this.$$.ctx[62];
  } }, { key: "acceptAutoRepair", get: function() {
    return this.$$.ctx[5];
  } }, { key: "openTransformModal", get: function() {
    return this.$$.ctx[63];
  } }, { key: "scrollTo", get: function() {
    return this.$$.ctx[64];
  } }, { key: "findElement", get: function() {
    return this.$$.ctx[65];
  } }, { key: "focus", get: function() {
    return this.$$.ctx[66];
  } }]), n2;
}(), TJ = { id: "javascript", name: "JavaScript", description: "\n<p>\n  Enter a JavaScript function to filter, sort, or transform the data.\n</p>\n", createQuery: function(e22, t2) {
  var n2 = t2.filter, r2 = t2.sort, i2 = t2.projection, o2 = [];
  if (n2 && n2.path && n2.relation && n2.value) {
    var a2 = "item => item".concat(lS(n2.path)), s2 = typeof Kq(n2.value) == "string" ? "'".concat(n2.value, "'") : n2.value;
    o2.push("  data = data.filter(".concat(a2, " ").concat(n2.relation, " ").concat(s2, ")\n"));
  }
  r2 && r2.path && r2.direction && (r2.direction === "desc" ? o2.push("  data = data.slice().sort((a, b) => {\n    // sort descending\n" + "    const valueA = a".concat(lS(r2.path), "\n") + "    const valueB = b".concat(lS(r2.path), "\n") + "    return valueA > valueB ? -1 : valueA < valueB ? 1 : 0\n  })\n") : o2.push("  data = data.slice().sort((a, b) => {\n    // sort ascending\n" + "    const valueA = a".concat(lS(r2.path), "\n") + "    const valueB = b".concat(lS(r2.path), "\n") + "    return valueA > valueB ? 1 : valueA < valueB ? -1 : 0\n  })\n"));
  if (i2 && i2.paths)
    if (i2.paths.length > 1) {
      var u2 = i2.paths.map(function(e23) {
        var t3 = e23[e23.length - 1] || "item", n3 = "item".concat(lS(e23));
        return "    ".concat(JSON.stringify(t3), ": ").concat(n3);
      });
      o2.push("  data = data.map(item => ({\n".concat(u2.join(",\n"), "})\n  )\n"));
    } else {
      var c2 = "item".concat(lS(i2.paths[0]));
      o2.push("  data = data.map(item => ".concat(c2, ")\n"));
    }
  return o2.push("  return data\n"), "function query (data) {\n".concat(o2.join(""), "}");
}, executeQuery: function(e22, t2) {
  var n2 = new Function('"use strict";\n\n' + t2 + `

if (typeof query !== "function") {
  throw new Error("Cannot execute query: expecting a function named 'query' but is undefined")
}

return query;
`)()(e22);
  return n2 !== void 0 ? n2 : null;
} };
function IJ(e22) {
  co(e22, "svelte-zs5o25", ".jse-boolean-toggle.svelte-zs5o25{color:var(--jse-value-color-boolean);position:relative;padding-left:calc(0.5 * var(--jse-padding));padding-top:1px;height:var(--jse-line-height)}");
}
function RJ(e22) {
  var t2, n2, r2, i2, o2, a2;
  return n2 = new Xj({ props: { data: e22[0] === true ? jV : xV } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-boolean-toggle svelte-zs5o25"), So(t2, "title", r2 = e22[1] ? "Boolean value ".concat(e22[0]) : "Click to toggle this boolean value");
  }, m: function(r3, s2) {
    vo(r3, t2, s2), Ma(n2, t2, null), i2 = true, o2 || (a2 = xo(t2, "mousedown", e22[2]), o2 = true);
  }, p: function(e23, o3) {
    var a3 = xi(o3, 1)[0], s2 = {};
    1 & a3 && (s2.data = e23[0] === true ? jV : xV), n2.$set(s2), (!i2 || 3 & a3 && r2 !== (r2 = e23[1] ? "Boolean value ".concat(e23[0]) : "Click to toggle this boolean value")) && So(t2, "title", r2);
  }, i: function(e23) {
    i2 || (ya(n2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), o2 = false, a2();
  } };
}
function DJ(e22, t2, n2) {
  var r2 = t2.path, i2 = t2.value, o2 = t2.readOnly, a2 = t2.onPatch, s2 = t2.focus;
  return e22.$$set = function(e23) {
    "path" in e23 && n2(3, r2 = e23.path), "value" in e23 && n2(0, i2 = e23.value), "readOnly" in e23 && n2(1, o2 = e23.readOnly), "onPatch" in e23 && n2(4, a2 = e23.onPatch), "focus" in e23 && n2(5, s2 = e23.focus);
  }, [i2, o2, function(e23) {
    e23.stopPropagation(), o2 || (a2([{ op: "replace", path: cs.exports.compileJSONPointer(r2), value: !i2 }]), setTimeout(s2));
  }, r2, a2, s2];
}
var zJ = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, DJ, RJ, Ki, { path: 3, value: 0, readOnly: 1, onPatch: 4, focus: 5 }, IJ), r2;
  }
  return zi(n2);
}();
function LJ(e22) {
  co(e22, "svelte-1gn8yt9", ".jse-color-picker-popup.svelte-1gn8yt9 .picker_wrapper.popup,.jse-color-picker-popup.svelte-1gn8yt9 .picker_wrapper.popup .picker_arrow::before,.jse-color-picker-popup.svelte-1gn8yt9 .picker_wrapper.popup .picker_arrow::after{background:var(--jse-color-picker-background);line-height:normal}.jse-color-picker-popup.svelte-1gn8yt9 .picker_slider,.jse-color-picker-popup.svelte-1gn8yt9 .picker_sl,.jse-color-picker-popup.svelte-1gn8yt9 .picker_editor input,.jse-color-picker-popup.svelte-1gn8yt9 .picker_sample,.jse-color-picker-popup.svelte-1gn8yt9 .picker_done button{box-shadow:var(--jse-color-picker-border-box-shadow)}.jse-color-picker-popup.svelte-1gn8yt9 .picker_editor input{background:var(--jse-background-color);color:var(--jse-text-color)}.jse-color-picker-popup.svelte-1gn8yt9 .picker_done button{background:var(--jse-button-background);color:var(--jse-button-color)}.jse-color-picker-popup.svelte-1gn8yt9 .picker_done button:hover{background:var(--jse-button-background-highlight)}");
}
function BJ(e22) {
  var t2;
  return { c: function() {
    So(t2 = go("div"), "class", "jse-color-picker-popup svelte-1gn8yt9");
  }, m: function(n2, r2) {
    vo(n2, t2, r2), e22[4](t2);
  }, p: Bi, i: Bi, o: Bi, d: function(n2) {
    n2 && po(t2), e22[4](null);
  } };
}
function qJ(e22, t2, n2) {
  var r2, i2, o2 = t2.color, a2 = t2.onChange, s2 = t2.showOnTop;
  return Uo(yi(mi().mark(function e23() {
    var t3;
    return mi().wrap(function(e24) {
      for (; ; )
        switch (e24.prev = e24.next) {
          case 0:
            return e24.next = 2, Promise.resolve().then(function() {
              return WG;
            });
          case 2:
            t3 = e24.sent.default, (i2 = new t3({ parent: r2, color: o2, popup: s2 ? "top" : "bottom", onDone: function(e25) {
              var t4 = e25.rgba[3] === 1 ? e25.hex.substring(0, 7) : e25.hex;
              a2(t4);
            } })).show();
          case 5:
          case "end":
            return e24.stop();
        }
    }, e23);
  }))), Ko(function() {
    i2 && i2.destroy();
  }), e22.$$set = function(e23) {
    "color" in e23 && n2(1, o2 = e23.color), "onChange" in e23 && n2(2, a2 = e23.onChange), "showOnTop" in e23 && n2(3, s2 = e23.showOnTop);
  }, [r2, o2, a2, s2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(0, r2 = e23);
    });
  }];
}
var FJ = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, qJ, BJ, Ui, { color: 1, onChange: 2, showOnTop: 3 }, LJ), r2;
  }
  return zi(n2);
}();
function VJ(e22) {
  co(e22, "svelte-fk1u9y", ".jse-color-picker-button.svelte-fk1u9y{font-size:var(--jse-font-size-mono);width:var(--jse-color-picker-button-size);height:var(--jse-color-picker-button-size);box-sizing:border-box;padding:0;margin:2px;border:1px solid var(--jse-text-color);border-radius:2px;background:inherit;outline:none;cursor:pointer}");
}
function HJ(e22) {
  var t2, n2, r2, i2;
  return { c: function() {
    So(t2 = go("button"), "class", "jse-color-picker-button svelte-fk1u9y"), Eo(t2, "background", e22[2]), So(t2, "title", n2 = e22[1] ? "Color ".concat(e22[0]) : "Click to open a color picker");
  }, m: function(n3, o2) {
    vo(n3, t2, o2), r2 || (i2 = xo(t2, "click", e22[3]), r2 = true);
  }, p: function(e23, r3) {
    var i3 = xi(r3, 1)[0];
    4 & i3 && Eo(t2, "background", e23[2]), 3 & i3 && n2 !== (n2 = e23[1] ? "Color ".concat(e23[0]) : "Click to open a color picker") && So(t2, "title", n2);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2), r2 = false, i2();
  } };
}
function WJ(e22, t2, n2) {
  var r2, i2 = Yo("absolute-popup").openAbsolutePopup, o2 = t2.path, a2 = t2.value, s2 = t2.readOnly, u2 = t2.onPatch, c2 = t2.focus;
  function l2(e23) {
    u2([{ op: "replace", path: cs.exports.compileJSONPointer(o2), value: e23 }]), f2();
  }
  function f2() {
    c2();
  }
  return e22.$$set = function(e23) {
    "path" in e23 && n2(4, o2 = e23.path), "value" in e23 && n2(0, a2 = e23.value), "readOnly" in e23 && n2(1, s2 = e23.readOnly), "onPatch" in e23 && n2(5, u2 = e23.onPatch), "focus" in e23 && n2(6, c2 = e23.focus);
  }, e22.$$.update = function() {
    1 & e22.$$.dirty && n2(2, r2 = As(a2));
  }, [a2, s2, r2, function(e23) {
    if (!s2) {
      var t3 = e23.target.getBoundingClientRect().top, n3 = Ox(e23.target).innerHeight;
      i2(FJ, { color: a2, onChange: l2, showOnTop: n3 - t3 < 300 && t3 > 300 }, { anchor: e23.target, closeOnOuterClick: true, onClose: f2, offsetTop: 18, offsetLeft: -8, height: 300 });
    }
  }, o2, u2, c2];
}
var JJ = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, WJ, HJ, Ki, { path: 4, value: 0, readOnly: 1, onPatch: 5, focus: 6 }, VJ), r2;
  }
  return zi(n2);
}();
function UJ(e22) {
  var t2 = Ms(e22);
  return NV("jse-value", "jse-" + t2, { "jse-url": Ps(e22), "jse-empty": typeof e22 == "string" && e22.length === 0 });
}
function KJ(e22) {
  var t2, n2;
  return t2 = new rH({ props: { value: e22[1].escapeValue(e22[0]), onChange: e22[3], onCancel: e22[4], onPaste: e22[5], onFind: e22[2], onValueClass: e22[6] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = xi(n3, 1)[0], i2 = {};
    3 & r2 && (i2.value = e23[1].escapeValue(e23[0])), 4 & r2 && (i2.onFind = e23[2]), t2.$set(i2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function GJ(e22, t2, n2) {
  var r2 = t2.path, i2 = t2.value, o2 = t2.normalization, a2 = t2.enforceString, s2 = t2.onPatch, u2 = t2.onPasteJson, c2 = t2.onSelect, l2 = t2.onFind, f2 = t2.focus;
  function h2(e23) {
    return a2 ? e23 : Ns(e23);
  }
  return e22.$$set = function(e23) {
    "path" in e23 && n2(7, r2 = e23.path), "value" in e23 && n2(0, i2 = e23.value), "normalization" in e23 && n2(1, o2 = e23.normalization), "enforceString" in e23 && n2(8, a2 = e23.enforceString), "onPatch" in e23 && n2(9, s2 = e23.onPatch), "onPasteJson" in e23 && n2(10, u2 = e23.onPasteJson), "onSelect" in e23 && n2(11, c2 = e23.onSelect), "onFind" in e23 && n2(2, l2 = e23.onFind), "focus" in e23 && n2(12, f2 = e23.focus);
  }, [i2, o2, l2, function(e23, t3) {
    s2([{ op: "replace", path: cs.exports.compileJSONPointer(r2), value: h2(o2.unescapeValue(e23)) }], function(e24, n3) {
      var i3 = t3 === os ? function(e25, t4, n4) {
        var r3 = Gp(n4), i4 = [yv(n4)], o3 = Vq(cs.exports.getIn(e25, r3), t4, i4);
        return o3 ? pF(r3.concat(o3), false) : gF(n4);
      }(e24, n3, r2) || n3.selection : pF(r2, false);
      return { state: Ei(Ei({}, n3), {}, { selection: i3 }) };
    }), t3 !== is && f2();
  }, function() {
    c2(pF(r2, false)), f2();
  }, function(e23) {
    try {
      var t3 = JSON.parse(e23);
      Os(t3) && u2({ path: r2, contents: t3 });
    } catch (e24) {
    }
  }, function(e23) {
    return UJ(h2(o2.unescapeValue(e23)));
  }, r2, a2, s2, u2, c2, f2];
}
var QJ = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, GJ, KJ, Ki, { path: 7, value: 0, normalization: 1, enforceString: 8, onPatch: 9, onPasteJson: 10, onSelect: 11, onFind: 2, focus: 12 }), r2;
  }
  return zi(n2);
}();
function YJ(e22) {
  co(e22, "svelte-6ci2p7", '.jse-value.jse-string.svelte-6ci2p7{color:var(--jse-value-color-string)}.jse-value.jse-object.svelte-6ci2p7,.jse-value.jse-array.svelte-6ci2p7{min-width:16px;color:var(--jse-delimiter-color)}.jse-value.jse-number.svelte-6ci2p7{color:var(--jse-value-color-number)}.jse-value.jse-boolean.svelte-6ci2p7{color:var(--jse-value-color-boolean)}.jse-value.jse-null.svelte-6ci2p7{color:var(--jse-value-color-null)}.jse-value.jse-invalid.svelte-6ci2p7{color:var(--jse-text-color)}.jse-value.jse-url.svelte-6ci2p7{color:var(--jse-value-color-url);text-decoration:underline}.jse-value.svelte-6ci2p7{min-width:2em;padding:0 5px;box-sizing:border-box;outline:none;border-radius:1px;vertical-align:top;word-break:normal;overflow-wrap:anywhere;white-space:pre-wrap}.jse-value.svelte-6ci2p7:hover{background:var(--jse-hover-background-color)}.jse-value.jse-empty.svelte-6ci2p7{min-width:4em;outline:1px dotted var(--jse-tag-background);-moz-outline-radius:2px}.jse-value.jse-empty.svelte-6ci2p7::after{pointer-events:none;color:var(--jse-tag-background);content:"value"}');
}
function ZJ(e22) {
  var t2, n2 = xx(e22[1].escapeValue(e22[0])) + "";
  return { c: function() {
    t2 = bo(n2);
  }, m: function(e23, n3) {
    vo(e23, t2, n3);
  }, p: function(e23, r2) {
    3 & r2 && n2 !== (n2 = xx(e23[1].escapeValue(e23[0])) + "") && Ao(t2, n2);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function XJ(e22) {
  var t2, n2;
  return t2 = new XV({ props: { text: e22[1].escapeValue(e22[0]), searchResultItems: e22[2] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    3 & n3 && (r2.text = e23[1].escapeValue(e23[0])), 4 & n3 && (r2.searchResultItems = e23[2]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function eU(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2 = [XJ, ZJ], l2 = [];
  function f2(e23, t3) {
    return e23[2] ? 0 : 1;
  }
  return n2 = f2(e22), r2 = l2[n2] = c2[n2](e22), { c: function() {
    t2 = go("div"), r2.c(), So(t2, "data-type", "selectable-value"), So(t2, "class", i2 = eo(UJ(e22[0])) + " svelte-6ci2p7"), So(t2, "title", o2 = e22[3] ? "Ctrl+Click or Ctrl+Enter to open url in new window" : null);
  }, m: function(r3, i3) {
    vo(r3, t2, i3), l2[n2].m(t2, null), a2 = true, s2 || (u2 = [xo(t2, "click", e22[4]), xo(t2, "dblclick", e22[5])], s2 = true);
  }, p: function(e23, s3) {
    var u3 = xi(s3, 1)[0], h2 = n2;
    (n2 = f2(e23)) === h2 ? l2[n2].p(e23, u3) : (ma(), ba(l2[h2], 1, 1, function() {
      l2[h2] = null;
    }), ga(), (r2 = l2[n2]) ? r2.p(e23, u3) : (r2 = l2[n2] = c2[n2](e23)).c(), ya(r2, 1), r2.m(t2, null)), (!a2 || 1 & u3 && i2 !== (i2 = eo(UJ(e23[0])) + " svelte-6ci2p7")) && So(t2, "class", i2), (!a2 || 8 & u3 && o2 !== (o2 = e23[3] ? "Ctrl+Click or Ctrl+Enter to open url in new window" : null)) && So(t2, "title", o2);
  }, i: function(e23) {
    a2 || (ya(r2), a2 = true);
  }, o: function(e23) {
    ba(r2), a2 = false;
  }, d: function(e23) {
    e23 && po(t2), l2[n2].d(), s2 = false, Wi(u2);
  } };
}
function tU(e22, t2, n2) {
  var r2, i2 = t2.path, o2 = t2.value, a2 = t2.readOnly, s2 = t2.normalization, u2 = t2.onSelect, c2 = t2.searchResultItems;
  return e22.$$set = function(e23) {
    "path" in e23 && n2(6, i2 = e23.path), "value" in e23 && n2(0, o2 = e23.value), "readOnly" in e23 && n2(7, a2 = e23.readOnly), "normalization" in e23 && n2(1, s2 = e23.normalization), "onSelect" in e23 && n2(8, u2 = e23.onSelect), "searchResultItems" in e23 && n2(2, c2 = e23.searchResultItems);
  }, e22.$$.update = function() {
    1 & e22.$$.dirty && n2(3, r2 = Ps(o2));
  }, [o2, s2, c2, r2, function(e23) {
    typeof o2 == "string" && r2 && e23.ctrlKey && (e23.preventDefault(), e23.stopPropagation(), window.open(o2, "_blank"));
  }, function(e23) {
    a2 || (e23.preventDefault(), u2(pF(i2, true)));
  }, i2, a2, u2];
}
var nU = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, tU, eU, Ki, { path: 6, value: 0, readOnly: 7, normalization: 1, onSelect: 8, searchResultItems: 2 }, YJ), r2;
  }
  return zi(n2);
}();
function rU(e22) {
  co(e22, "svelte-1u00zub", ".jse-timestamp.svelte-1u00zub{padding:0;margin:0;height:var(--jse-line-height);color:var(--jse-value-color-number);border-radius:3px}");
}
function iU(e22) {
  var t2, n2, r2, i2, o2, a2;
  return n2 = new Xj({ props: { data: kV } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-timestamp svelte-1u00zub");
  }, m: function(s2, u2) {
    vo(s2, t2, u2), Ma(n2, t2, null), i2 = true, o2 || (a2 = to(r2 = CH.call(null, t2, Ei({ text: e22[0] }, e22[1]))), o2 = true);
  }, p: function(e23, t3) {
    var n3 = xi(t3, 1)[0];
    r2 && Ji(r2.update) && 1 & n3 && r2.update.call(null, Ei({ text: e23[0] }, e23[1]));
  }, i: function(e23) {
    i2 || (ya(n2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), o2 = false, a2();
  } };
}
function oU(e22, t2, n2) {
  var r2, i2 = Yo("absolute-popup"), o2 = t2.value;
  return e22.$$set = function(e23) {
    "value" in e23 && n2(2, o2 = e23.value);
  }, e22.$$.update = function() {
    4 & e22.$$.dirty && n2(0, r2 = "Time: ".concat(new Date(o2).toString()));
  }, [r2, i2, o2];
}
var aU = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, oU, iU, Ki, { value: 2 }, rU), r2;
  }
  return zi(n2);
}();
function sU(e22) {
  var t2 = e22.path, n2 = e22.value, r2 = e22.readOnly, i2 = e22.enforceString, o2 = e22.searchResultItems, a2 = e22.isEditing, s2 = e22.normalization, u2 = e22.onPatch, c2 = e22.onPasteJson, l2 = e22.onSelect, f2 = e22.onFind, h2 = e22.focus, d2 = [];
  return !a2 && function(e23) {
    return e23 === true || e23 === false;
  }(n2) && d2.push({ component: zJ, props: { path: t2, value: n2, readOnly: r2, onPatch: u2, focus: h2 } }), !a2 && function(e23) {
    return typeof e23 == "string" && !!As(e23);
  }(n2) && d2.push({ component: JJ, props: { path: t2, value: n2, readOnly: r2, onPatch: u2, focus: h2 } }), a2 && d2.push({ component: QJ, props: { path: t2, value: n2, enforceString: i2, normalization: s2, onPatch: u2, onPasteJson: c2, onSelect: l2, onFind: f2, focus: h2 } }), a2 || d2.push({ component: nU, props: { path: t2, value: n2, readOnly: r2, normalization: s2, searchResultItems: o2, onSelect: l2 } }), !a2 && function(e23) {
    return typeof e23 == "number" && e23 > 9466848e5 && isFinite(e23) && Math.floor(e23) === e23 && !isNaN(new Date(e23).valueOf());
  }(n2) && d2.push({ component: aU, props: { value: n2 } }), d2;
}
var uU = {};
function cU(e22) {
  co(e22, "svelte-3e0qet", ".item.svelte-3e0qet{cursor:default;height:var(--height, 42px);line-height:var(--height, 42px);padding:var(--itemPadding, 0 20px);color:var(--itemColor, inherit);text-overflow:ellipsis;overflow:hidden;white-space:nowrap}.groupHeader.svelte-3e0qet{text-transform:var(--groupTitleTextTransform, uppercase)}.groupItem.svelte-3e0qet{padding-left:var(--groupItemPaddingLeft, 40px)}.item.svelte-3e0qet:active{background:var(--itemActiveBackground, #b9daff)}.item.active.svelte-3e0qet{background:var(--itemIsActiveBG, #007aff);color:var(--itemIsActiveColor, #fff)}.item.notSelectable.svelte-3e0qet{color:var(--itemIsNotSelectableColor, #999)}.item.first.svelte-3e0qet{border-radius:var(--itemFirstBorderRadius, 4px 4px 0 0)}.item.hover.svelte-3e0qet:not(.active){background:var(--itemHoverBG, #e7f2ff);color:var(--itemHoverColor, inherit)}");
}
function lU(e22) {
  var t2, n2, r2 = e22[0](e22[1], e22[2]) + "";
  return { c: function() {
    So(t2 = go("div"), "class", n2 = "item " + e22[3] + " svelte-3e0qet");
  }, m: function(e23, n3) {
    vo(e23, t2, n3), t2.innerHTML = r2;
  }, p: function(e23, i2) {
    var o2 = xi(i2, 1)[0];
    7 & o2 && r2 !== (r2 = e23[0](e23[1], e23[2]) + "") && (t2.innerHTML = r2), 8 & o2 && n2 !== (n2 = "item " + e23[3] + " svelte-3e0qet") && So(t2, "class", n2);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function fU(e22, t2, n2) {
  var r2 = t2.isActive, i2 = r2 !== void 0 && r2, o2 = t2.isFirst, a2 = o2 !== void 0 && o2, s2 = t2.isHover, u2 = s2 !== void 0 && s2, c2 = t2.isSelectable, l2 = c2 !== void 0 && c2, f2 = t2.getOptionLabel, h2 = f2 === void 0 ? void 0 : f2, d2 = t2.item, v2 = d2 === void 0 ? void 0 : d2, p2 = t2.filterText, m2 = p2 === void 0 ? "" : p2, g2 = "";
  return e22.$$set = function(e23) {
    "isActive" in e23 && n2(4, i2 = e23.isActive), "isFirst" in e23 && n2(5, a2 = e23.isFirst), "isHover" in e23 && n2(6, u2 = e23.isHover), "isSelectable" in e23 && n2(7, l2 = e23.isSelectable), "getOptionLabel" in e23 && n2(0, h2 = e23.getOptionLabel), "item" in e23 && n2(1, v2 = e23.item), "filterText" in e23 && n2(2, m2 = e23.filterText);
  }, e22.$$.update = function() {
    if (242 & e22.$$.dirty) {
      var t3 = [];
      i2 && t3.push("active"), a2 && t3.push("first"), u2 && t3.push("hover"), v2.isGroupHeader && t3.push("groupHeader"), v2.isGroupItem && t3.push("groupItem"), l2 || t3.push("notSelectable"), n2(3, g2 = t3.join(" "));
    }
  }, [h2, v2, m2, g2, i2, a2, u2, l2];
}
var hU = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, fU, lU, Ui, { isActive: 4, isFirst: 5, isHover: 6, isSelectable: 7, getOptionLabel: 0, item: 1, filterText: 2 }, cU), r2;
  }
  return zi(n2);
}();
function dU(e22) {
  co(e22, "svelte-1uyqfml", ".listContainer.svelte-1uyqfml{box-shadow:var(--listShadow, 0 2px 3px 0 rgba(44, 62, 80, 0.24));border-radius:var(--listBorderRadius, 4px);max-height:var(--listMaxHeight, 250px);overflow-y:auto;background:var(--listBackground, #fff);border:var(--listBorder, none);position:var(--listPosition, absolute);z-index:var(--listZIndex, 2);width:100%;left:var(--listLeft, 0);right:var(--listRight, 0)}.virtualList.svelte-1uyqfml{height:var(--virtualListHeight, 200px)}.listGroupTitle.svelte-1uyqfml{color:var(--groupTitleColor, #8f8f8f);cursor:default;font-size:var(--groupTitleFontSize, 12px);font-weight:var(--groupTitleFontWeight, 600);height:var(--height, 42px);line-height:var(--height, 42px);padding:var(--groupTitlePadding, 0 20px);text-overflow:ellipsis;overflow-x:hidden;white-space:nowrap;text-transform:var(--groupTitleTextTransform, uppercase)}.empty.svelte-1uyqfml{text-align:var(--listEmptyTextAlign, center);padding:var(--listEmptyPadding, 20px 0);color:var(--listEmptyColor, #78848f)}");
}
function vU(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[41] = t2[n2], r2[42] = n2, r2;
}
function pU(e22) {
  for (var t2, n2, r2 = e22[1], i2 = [], o2 = 0; o2 < r2.length; o2 += 1)
    i2[o2] = wU(vU(e22, r2, o2));
  var a2 = function(e23) {
    return ba(i2[e23], 1, 1, function() {
      i2[e23] = null;
    });
  }, s2 = null;
  return r2.length || (s2 = gU(e22)), { c: function() {
    for (var e23 = 0; e23 < i2.length; e23 += 1)
      i2[e23].c();
    t2 = wo(), s2 && s2.c();
  }, m: function(e23, r3) {
    for (var o3 = 0; o3 < i2.length; o3 += 1)
      i2[o3].m(e23, r3);
    vo(e23, t2, r3), s2 && s2.m(e23, r3), n2 = true;
  }, p: function(e23, n3) {
    if (114390 & n3[0]) {
      var o3;
      for (r2 = e23[1], o3 = 0; o3 < r2.length; o3 += 1) {
        var u2 = vU(e23, r2, o3);
        i2[o3] ? (i2[o3].p(u2, n3), ya(i2[o3], 1)) : (i2[o3] = wU(u2), i2[o3].c(), ya(i2[o3], 1), i2[o3].m(t2.parentNode, t2));
      }
      for (ma(), o3 = r2.length; o3 < i2.length; o3 += 1)
        a2(o3);
      ga(), !r2.length && s2 ? s2.p(e23, n3) : r2.length ? s2 && (s2.d(1), s2 = null) : ((s2 = gU(e23)).c(), s2.m(t2.parentNode, t2));
    }
  }, i: function(e23) {
    if (!n2) {
      for (var t3 = 0; t3 < r2.length; t3 += 1)
        ya(i2[t3]);
      n2 = true;
    }
  }, o: function(e23) {
    i2 = i2.filter(Boolean);
    for (var t3 = 0; t3 < i2.length; t3 += 1)
      ba(i2[t3]);
    n2 = false;
  }, d: function(e23) {
    mo(i2, e23), e23 && po(t2), s2 && s2.d(e23);
  } };
}
function mU(e22) {
  var t2, n2, r2, i2 = e22[3];
  function o2(e23) {
    return { props: { items: e23[1], itemHeight: e23[8], $$slots: { default: [xU, function(e24) {
      return { 41: e24.item, 42: e24.i };
    }, function(e24) {
      return [0, (e24.item ? 1024 : 0) | (e24.i ? 2048 : 0)];
    }] }, $$scope: { ctx: e23 } } };
  }
  return i2 && (t2 = new i2(o2(e22))), { c: function() {
    t2 && Aa(t2.$$.fragment), n2 = wo();
  }, m: function(e23, i3) {
    t2 && Ma(t2, e23, i3), vo(e23, n2, i3), r2 = true;
  }, p: function(e23, r3) {
    var a2 = {};
    if (2 & r3[0] && (a2.items = e23[1]), 256 & r3[0] && (a2.itemHeight = e23[8]), 9814 & r3[0] | 11264 & r3[1] && (a2.$$scope = { dirty: r3, ctx: e23 }), i2 !== (i2 = e23[3])) {
      if (t2) {
        ma();
        var s2 = t2;
        ba(s2.$$.fragment, 1, 0, function() {
          Ea(s2, 1);
        }), ga();
      }
      i2 ? (Aa((t2 = new i2(o2(e23))).$$.fragment), ya(t2.$$.fragment, 1), Ma(t2, n2.parentNode, n2)) : t2 = null;
    } else
      i2 && t2.$set(a2);
  }, i: function(e23) {
    r2 || (t2 && ya(t2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    t2 && ba(t2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(n2), t2 && Ea(t2, e23);
  } };
}
function gU(e22) {
  var t2, n2 = !e22[11] && yU(e22);
  return { c: function() {
    n2 && n2.c(), t2 = wo();
  }, m: function(e23, r2) {
    n2 && n2.m(e23, r2), vo(e23, t2, r2);
  }, p: function(e23, r2) {
    e23[11] ? n2 && (n2.d(1), n2 = null) : n2 ? n2.p(e23, r2) : ((n2 = yU(e23)).c(), n2.m(t2.parentNode, t2));
  }, d: function(e23) {
    n2 && n2.d(e23), e23 && po(t2);
  } };
}
function yU(e22) {
  var t2, n2;
  return { c: function() {
    t2 = go("div"), n2 = bo(e22[12]), So(t2, "class", "empty svelte-1uyqfml");
  }, m: function(e23, r2) {
    vo(e23, t2, r2), uo(t2, n2);
  }, p: function(e23, t3) {
    4096 & t3[0] && Ao(n2, e23[12]);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function bU(e22) {
  var t2, n2, r2, i2, o2, a2, s2 = e22[4];
  function u2(e23) {
    return { props: { item: e23[41], filterText: e23[13], getOptionLabel: e23[6], isFirst: CU(e23[42]), isActive: SU(e23[41], e23[9], e23[10]), isHover: _U(e23[2], e23[41], e23[42], e23[1]), isSelectable: $U(e23[41]) } };
  }
  function c2() {
    return e22[29](e22[42]);
  }
  function l2() {
    return e22[30](e22[42]);
  }
  function f2() {
    for (var t3, n3 = arguments.length, r3 = new Array(n3), i3 = 0; i3 < n3; i3++)
      r3[i3] = arguments[i3];
    return (t3 = e22)[31].apply(t3, [e22[41], e22[42]].concat(r3));
  }
  return s2 && (n2 = new s2(u2(e22))), { c: function() {
    t2 = go("div"), n2 && Aa(n2.$$.fragment), r2 = ko(), So(t2, "class", "listItem"), So(t2, "tabindex", "-1");
  }, m: function(e23, s3) {
    vo(e23, t2, s3), n2 && Ma(n2, t2, null), uo(t2, r2), i2 = true, o2 || (a2 = [xo(t2, "mouseover", c2), xo(t2, "focus", l2), xo(t2, "click", f2)], o2 = true);
  }, p: function(i3, o3) {
    e22 = i3;
    var a3 = {};
    if (2 & o3[0] && (a3.item = e22[41]), 8192 & o3[0] && (a3.filterText = e22[13]), 64 & o3[0] && (a3.getOptionLabel = e22[6]), 1538 & o3[0] && (a3.isActive = SU(e22[41], e22[9], e22[10])), 6 & o3[0] && (a3.isHover = _U(e22[2], e22[41], e22[42], e22[1])), 2 & o3[0] && (a3.isSelectable = $U(e22[41])), s2 !== (s2 = e22[4])) {
      if (n2) {
        ma();
        var c3 = n2;
        ba(c3.$$.fragment, 1, 0, function() {
          Ea(c3, 1);
        }), ga();
      }
      s2 ? (Aa((n2 = new s2(u2(e22))).$$.fragment), ya(n2.$$.fragment, 1), Ma(n2, t2, r2)) : n2 = null;
    } else
      s2 && n2.$set(a3);
  }, i: function(e23) {
    i2 || (n2 && ya(n2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    n2 && ba(n2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(t2), n2 && Ea(n2), o2 = false, Wi(a2);
  } };
}
function kU(e22) {
  var t2, n2, r2 = e22[7](e22[41]) + "";
  return { c: function() {
    t2 = go("div"), n2 = bo(r2), So(t2, "class", "listGroupTitle svelte-1uyqfml");
  }, m: function(e23, r3) {
    vo(e23, t2, r3), uo(t2, n2);
  }, p: function(e23, t3) {
    130 & t3[0] && r2 !== (r2 = e23[7](e23[41]) + "") && Ao(n2, r2);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function wU(e22) {
  var t2, n2, r2, i2, o2 = [kU, bU], a2 = [];
  function s2(e23, t3) {
    return e23[41].isGroupHeader && !e23[41].isSelectable ? 0 : 1;
  }
  return t2 = s2(e22), n2 = a2[t2] = o2[t2](e22), { c: function() {
    n2.c(), r2 = wo();
  }, m: function(e23, n3) {
    a2[t2].m(e23, n3), vo(e23, r2, n3), i2 = true;
  }, p: function(e23, i3) {
    var u2 = t2;
    (t2 = s2(e23)) === u2 ? a2[t2].p(e23, i3) : (ma(), ba(a2[u2], 1, 1, function() {
      a2[u2] = null;
    }), ga(), (n2 = a2[t2]) ? n2.p(e23, i3) : (n2 = a2[t2] = o2[t2](e23)).c(), ya(n2, 1), n2.m(r2.parentNode, r2));
  }, i: function(e23) {
    i2 || (ya(n2), i2 = true);
  }, o: function(e23) {
    ba(n2), i2 = false;
  }, d: function(e23) {
    a2[t2].d(e23), e23 && po(r2);
  } };
}
function xU(e22) {
  var t2, n2, r2, i2, o2, a2 = e22[4];
  function s2(e23) {
    return { props: { item: e23[41], filterText: e23[13], getOptionLabel: e23[6], isFirst: CU(e23[42]), isActive: SU(e23[41], e23[9], e23[10]), isHover: _U(e23[2], e23[41], e23[42], e23[1]), isSelectable: $U(e23[41]) } };
  }
  function u2() {
    return e22[26](e22[42]);
  }
  function c2() {
    return e22[27](e22[42]);
  }
  function l2() {
    for (var t3, n3 = arguments.length, r3 = new Array(n3), i3 = 0; i3 < n3; i3++)
      r3[i3] = arguments[i3];
    return (t3 = e22)[28].apply(t3, [e22[41], e22[42]].concat(r3));
  }
  return a2 && (n2 = new a2(s2(e22))), { c: function() {
    t2 = go("div"), n2 && Aa(n2.$$.fragment), So(t2, "class", "listItem");
  }, m: function(e23, a3) {
    vo(e23, t2, a3), n2 && Ma(n2, t2, null), r2 = true, i2 || (o2 = [xo(t2, "mouseover", u2), xo(t2, "focus", c2), xo(t2, "click", l2)], i2 = true);
  }, p: function(r3, i3) {
    e22 = r3;
    var o3 = {};
    if (1024 & i3[1] && (o3.item = e22[41]), 8192 & i3[0] && (o3.filterText = e22[13]), 64 & i3[0] && (o3.getOptionLabel = e22[6]), 2048 & i3[1] && (o3.isFirst = CU(e22[42])), 1536 & i3[0] | 1024 & i3[1] && (o3.isActive = SU(e22[41], e22[9], e22[10])), 6 & i3[0] | 3072 & i3[1] && (o3.isHover = _U(e22[2], e22[41], e22[42], e22[1])), 1024 & i3[1] && (o3.isSelectable = $U(e22[41])), a2 !== (a2 = e22[4])) {
      if (n2) {
        ma();
        var u3 = n2;
        ba(u3.$$.fragment, 1, 0, function() {
          Ea(u3, 1);
        }), ga();
      }
      a2 ? (Aa((n2 = new a2(s2(e22))).$$.fragment), ya(n2.$$.fragment, 1), Ma(n2, t2, null)) : n2 = null;
    } else
      a2 && n2.$set(o3);
  }, i: function(e23) {
    r2 || (n2 && ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    n2 && ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), n2 && Ea(n2), i2 = false, Wi(o2);
  } };
}
function jU(e22) {
  var t2, n2, r2, i2, o2, a2, s2 = [mU, pU], u2 = [];
  function c2(e23, t3) {
    return e23[5] ? 0 : 1;
  }
  return n2 = c2(e22), r2 = u2[n2] = s2[n2](e22), { c: function() {
    t2 = go("div"), r2.c(), So(t2, "class", "listContainer svelte-1uyqfml"), So(t2, "style", e22[14]), To(t2, "virtualList", e22[5]);
  }, m: function(r3, s3) {
    vo(r3, t2, s3), u2[n2].m(t2, null), e22[32](t2), i2 = true, o2 || (a2 = [xo(window, "keydown", e22[17]), xo(window, "resize", e22[18])], o2 = true);
  }, p: function(e23, o3) {
    var a3 = n2;
    (n2 = c2(e23)) === a3 ? u2[n2].p(e23, o3) : (ma(), ba(u2[a3], 1, 1, function() {
      u2[a3] = null;
    }), ga(), (r2 = u2[n2]) ? r2.p(e23, o3) : (r2 = u2[n2] = s2[n2](e23)).c(), ya(r2, 1), r2.m(t2, null)), (!i2 || 16384 & o3[0]) && So(t2, "style", e23[14]), 32 & o3[0] && To(t2, "virtualList", e23[5]);
  }, i: function(e23) {
    i2 || (ya(r2), i2 = true);
  }, o: function(e23) {
    ba(r2), i2 = false;
  }, d: function(r3) {
    r3 && po(t2), u2[n2].d(), e22[32](null), o2 = false, Wi(a2);
  } };
}
function SU(e22, t2, n2) {
  return t2 && t2[n2] === e22[n2];
}
function CU(e22) {
  return e22 === 0;
}
function _U(e22, t2, n2, r2) {
  return $U(t2) && (e22 === n2 || r2.length === 1);
}
function $U(e22) {
  return e22.isGroupHeader && e22.isSelectable || e22.selectable || !e22.hasOwnProperty("selectable");
}
function OU(e22, t2, n2) {
  var r2, i2, o2 = Go(), a2 = t2.container, s2 = a2 === void 0 ? void 0 : a2, u2 = t2.VirtualList, c2 = u2 === void 0 ? null : u2, l2 = t2.Item, f2 = l2 === void 0 ? hU : l2, h2 = t2.isVirtualList, d2 = h2 !== void 0 && h2, v2 = t2.items, p2 = v2 === void 0 ? [] : v2, m2 = t2.labelIdentifier, g2 = m2 === void 0 ? "label" : m2, y2 = t2.getOptionLabel, b2 = y2 === void 0 ? function(e23, t3) {
    if (e23)
      return e23.isCreator ? 'Create "'.concat(t3, '"') : e23[g2];
  } : y2, k2 = t2.getGroupHeaderLabel, w2 = k2 === void 0 ? null : k2, x2 = t2.itemHeight, j2 = x2 === void 0 ? 40 : x2, S2 = t2.hoverItemIndex, C2 = S2 === void 0 ? 0 : S2, _2 = t2.value, $2 = _2 === void 0 ? void 0 : _2, O2 = t2.optionIdentifier, A2 = O2 === void 0 ? "value" : O2, M2 = t2.hideEmptyState, E2 = M2 !== void 0 && M2, P2 = t2.noOptionsMessage, N2 = P2 === void 0 ? "No options" : P2, T2 = t2.isMulti, I2 = T2 !== void 0 && T2, R2 = t2.activeItemIndex, D2 = R2 === void 0 ? 0 : R2, z2 = t2.filterText, L2 = z2 === void 0 ? "" : z2, B2 = t2.parent, q2 = B2 === void 0 ? null : B2, F2 = t2.listPlacement, V2 = F2 === void 0 ? null : F2, H2 = t2.listAutoWidth, W2 = H2 === void 0 ? null : H2, J2 = t2.listOffset, U2 = J2 === void 0 ? 5 : J2, K2 = 0, G2 = false;
  function Q2(e23) {
    e23.isCreator || o2("itemSelected", e23);
  }
  function Y2(e23) {
    G2 || n2(2, C2 = e23);
  }
  function Z2(e23) {
    var t3 = e23.item, r3 = e23.i;
    if (e23.event.stopPropagation(), $2 && !I2 && $2[A2] === t3[A2])
      return X2();
    t3.isCreator ? o2("itemCreated", L2) : $U(t3) && (n2(19, D2 = r3), n2(2, C2 = r3), Q2(t3));
  }
  function X2() {
    o2("closeList");
  }
  function ee2(e23) {
    return te2.apply(this, arguments);
  }
  function te2() {
    return (te2 = yi(mi().mark(function e23(t3) {
      var r3;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              if (!d2) {
                e24.next = 2;
                break;
              }
              return e24.abrupt("return");
            case 2:
              for (r3 = true; r3; )
                t3 > 0 && C2 === p2.length - 1 ? n2(2, C2 = 0) : n2(2, t3 < 0 && C2 === 0 ? C2 = p2.length - 1 : C2 += t3), r3 = !$U(p2[C2]);
              return e24.next = 6, oa();
            case 6:
              ne2("hover");
            case 7:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function ne2(e23) {
    if (!d2 && s2) {
      var t3, r3 = s2.querySelector(".listItem .".concat(e23));
      r3 && (t3 = s2.getBoundingClientRect().bottom - r3.getBoundingClientRect().bottom), n2(0, s2.scrollTop -= t3, s2);
    }
  }
  function re2() {
    var e23 = q2.getBoundingClientRect(), t3 = e23.height, r3 = e23.width;
    n2(14, i2 = ""), n2(14, i2 += "min-width:".concat(r3, "px;width:").concat(W2 ? "auto" : "100%", ";")), V2 === "top" || V2 === "auto" && function(e24, t4) {
      var n3 = e24.getBoundingClientRect(), r4 = t4.getBoundingClientRect(), i3 = {};
      return i3.top = n3.top < 0, i3.left = n3.left < 0, i3.bottom = n3.bottom + r4.height > (window.innerHeight || document.documentElement.clientHeight), i3.right = n3.right > (window.innerWidth || document.documentElement.clientWidth), i3.any = i3.top || i3.left || i3.bottom || i3.right, i3;
    }(q2, s2).bottom ? n2(14, i2 += "bottom:".concat(t3 + U2, "px;")) : n2(14, i2 += "top:".concat(t3 + U2, "px;"));
  }
  Uo(function() {
    if (p2.length > 0 && !I2 && $2) {
      var e23 = p2.findIndex(function(e24) {
        return e24[A2] === $2[A2];
      });
      e23 && n2(2, C2 = e23);
    }
    ne2("active"), s2.addEventListener("scroll", function() {
      clearTimeout(K2), K2 = setTimeout(function() {
        G2 = false;
      }, 100);
    }, false);
  }), Jo(function() {
    p2 || n2(1, p2 = []), p2 !== r2 && p2.length > 0 && n2(2, C2 = 0), r2 = p2;
  });
  return e22.$$set = function(e23) {
    "container" in e23 && n2(0, s2 = e23.container), "VirtualList" in e23 && n2(3, c2 = e23.VirtualList), "Item" in e23 && n2(4, f2 = e23.Item), "isVirtualList" in e23 && n2(5, d2 = e23.isVirtualList), "items" in e23 && n2(1, p2 = e23.items), "labelIdentifier" in e23 && n2(20, g2 = e23.labelIdentifier), "getOptionLabel" in e23 && n2(6, b2 = e23.getOptionLabel), "getGroupHeaderLabel" in e23 && n2(7, w2 = e23.getGroupHeaderLabel), "itemHeight" in e23 && n2(8, j2 = e23.itemHeight), "hoverItemIndex" in e23 && n2(2, C2 = e23.hoverItemIndex), "value" in e23 && n2(9, $2 = e23.value), "optionIdentifier" in e23 && n2(10, A2 = e23.optionIdentifier), "hideEmptyState" in e23 && n2(11, E2 = e23.hideEmptyState), "noOptionsMessage" in e23 && n2(12, N2 = e23.noOptionsMessage), "isMulti" in e23 && n2(21, I2 = e23.isMulti), "activeItemIndex" in e23 && n2(19, D2 = e23.activeItemIndex), "filterText" in e23 && n2(13, L2 = e23.filterText), "parent" in e23 && n2(22, q2 = e23.parent), "listPlacement" in e23 && n2(23, V2 = e23.listPlacement), "listAutoWidth" in e23 && n2(24, W2 = e23.listAutoWidth), "listOffset" in e23 && n2(25, U2 = e23.listOffset);
  }, e22.$$.update = function() {
    4194305 & e22.$$.dirty[0] && q2 && s2 && re2();
  }, [s2, p2, C2, c2, f2, d2, b2, w2, j2, $2, A2, E2, N2, L2, i2, Y2, Z2, function(e23) {
    switch (e23.key) {
      case "Escape":
        e23.preventDefault(), X2();
        break;
      case "ArrowDown":
        e23.preventDefault(), p2.length && ee2(1);
        break;
      case "ArrowUp":
        e23.preventDefault(), p2.length && ee2(-1);
        break;
      case "Enter":
        if (e23.preventDefault(), p2.length === 0)
          break;
        var t3 = p2[C2];
        if ($2 && !I2 && $2[A2] === t3[A2]) {
          X2();
          break;
        }
        t3.isCreator ? o2("itemCreated", L2) : (n2(19, D2 = C2), Q2(p2[C2]));
        break;
      case "Tab":
        if (e23.preventDefault(), p2.length === 0)
          return X2();
        if ($2 && $2[A2] === p2[C2][A2])
          return X2();
        n2(19, D2 = C2), Q2(p2[C2]);
    }
  }, re2, D2, g2, I2, q2, V2, W2, U2, function(e23) {
    return Y2(e23);
  }, function(e23) {
    return Y2(e23);
  }, function(e23, t3, n3) {
    return Z2({ item: e23, i: t3, event: n3 });
  }, function(e23) {
    return Y2(e23);
  }, function(e23) {
    return Y2(e23);
  }, function(e23, t3, n3) {
    return Z2({ item: e23, i: t3, event: n3 });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(0, s2 = e23);
    });
  }];
}
var AU = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, OU, jU, Ui, { container: 0, VirtualList: 3, Item: 4, isVirtualList: 5, items: 1, labelIdentifier: 20, getOptionLabel: 6, getGroupHeaderLabel: 7, itemHeight: 8, hoverItemIndex: 2, value: 9, optionIdentifier: 10, hideEmptyState: 11, noOptionsMessage: 12, isMulti: 21, activeItemIndex: 19, filterText: 13, parent: 22, listPlacement: 23, listAutoWidth: 24, listOffset: 25 }, dU, [-1, -1]), r2;
  }
  return zi(n2);
}();
function MU(e22) {
  co(e22, "svelte-pu1q1n", ".selection.svelte-pu1q1n{text-overflow:ellipsis;overflow-x:hidden;white-space:nowrap}");
}
function EU(e22) {
  var t2, n2 = e22[0](e22[1]) + "";
  return { c: function() {
    So(t2 = go("div"), "class", "selection svelte-pu1q1n");
  }, m: function(e23, r2) {
    vo(e23, t2, r2), t2.innerHTML = n2;
  }, p: function(e23, r2) {
    3 & xi(r2, 1)[0] && n2 !== (n2 = e23[0](e23[1]) + "") && (t2.innerHTML = n2);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function PU(e22, t2, n2) {
  var r2 = t2.getSelectionLabel, i2 = r2 === void 0 ? void 0 : r2, o2 = t2.item, a2 = o2 === void 0 ? void 0 : o2;
  return e22.$$set = function(e23) {
    "getSelectionLabel" in e23 && n2(0, i2 = e23.getSelectionLabel), "item" in e23 && n2(1, a2 = e23.item);
  }, [i2, a2];
}
var NU = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, PU, EU, Ui, { getSelectionLabel: 0, item: 1 }, MU), r2;
  }
  return zi(n2);
}();
function TU(e22) {
  co(e22, "svelte-liu9pa", ".multiSelectItem.svelte-liu9pa.svelte-liu9pa{background:var(--multiItemBG, #ebedef);margin:var(--multiItemMargin, 5px 5px 0 0);border-radius:var(--multiItemBorderRadius, 16px);height:var(--multiItemHeight, 32px);line-height:var(--multiItemHeight, 32px);display:flex;cursor:default;padding:var(--multiItemPadding, 0 10px 0 15px);max-width:100%}.multiSelectItem_label.svelte-liu9pa.svelte-liu9pa{margin:var(--multiLabelMargin, 0 5px 0 0);overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.multiSelectItem.svelte-liu9pa.svelte-liu9pa:hover,.multiSelectItem.active.svelte-liu9pa.svelte-liu9pa{background-color:var(--multiItemActiveBG, #006fff);color:var(--multiItemActiveColor, #fff)}.multiSelectItem.disabled.svelte-liu9pa.svelte-liu9pa:hover{background:var(--multiItemDisabledHoverBg, #ebedef);color:var(--multiItemDisabledHoverColor, #c1c6cc)}.multiSelectItem_clear.svelte-liu9pa.svelte-liu9pa{border-radius:var(--multiClearRadius, 50%);background:var(--multiClearBG, #52616f);min-width:var(--multiClearWidth, 16px);max-width:var(--multiClearWidth, 16px);height:var(--multiClearHeight, 16px);position:relative;top:var(--multiClearTop, 8px);text-align:var(--multiClearTextAlign, center);padding:var(--multiClearPadding, 1px)}.multiSelectItem_clear.svelte-liu9pa.svelte-liu9pa:hover,.active.svelte-liu9pa .multiSelectItem_clear.svelte-liu9pa{background:var(--multiClearHoverBG, #fff)}.multiSelectItem_clear.svelte-liu9pa:hover svg.svelte-liu9pa,.active.svelte-liu9pa .multiSelectItem_clear svg.svelte-liu9pa{fill:var(--multiClearHoverFill, #006fff)}.multiSelectItem_clear.svelte-liu9pa svg.svelte-liu9pa{fill:var(--multiClearFill, #ebedef);vertical-align:top}");
}
function IU(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[9] = t2[n2], r2[11] = n2, r2;
}
function RU(e22) {
  var t2, n2, r2;
  function i2() {
    for (var t3, n3 = arguments.length, r3 = new Array(n3), i3 = 0; i3 < n3; i3++)
      r3[i3] = arguments[i3];
    return (t3 = e22)[6].apply(t3, [e22[11]].concat(r3));
  }
  return { c: function() {
    (t2 = go("div")).innerHTML = '<svg width="100%" height="100%" viewBox="-2 -2 50 50" focusable="false" aria-hidden="true" role="presentation" class="svelte-liu9pa"><path d="M34.923,37.251L24,26.328L13.077,37.251L9.436,33.61l10.923-10.923L9.436,11.765l3.641-3.641L24,19.047L34.923,8.124 l3.641,3.641L27.641,22.688L38.564,33.61L34.923,37.251z"></path></svg>', So(t2, "class", "multiSelectItem_clear svelte-liu9pa");
  }, m: function(e23, o2) {
    vo(e23, t2, o2), n2 || (r2 = xo(t2, "click", i2), n2 = true);
  }, p: function(t3, n3) {
    e22 = t3;
  }, d: function(e23) {
    e23 && po(t2), n2 = false, r2();
  } };
}
function DU(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2 = e22[4](e22[9]) + "", c2 = !e22[2] && !e22[3] && RU(e22);
  function l2() {
    for (var t3, n3 = arguments.length, r3 = new Array(n3), i3 = 0; i3 < n3; i3++)
      r3[i3] = arguments[i3];
    return (t3 = e22)[7].apply(t3, [e22[11]].concat(r3));
  }
  return { c: function() {
    t2 = go("div"), n2 = go("div"), r2 = ko(), c2 && c2.c(), i2 = ko(), So(n2, "class", "multiSelectItem_label svelte-liu9pa"), So(t2, "class", o2 = "multiSelectItem " + (e22[1] === e22[11] ? "active" : "") + " " + (e22[2] ? "disabled" : "") + " svelte-liu9pa");
  }, m: function(e23, o3) {
    vo(e23, t2, o3), uo(t2, n2), n2.innerHTML = u2, uo(t2, r2), c2 && c2.m(t2, null), uo(t2, i2), a2 || (s2 = xo(t2, "click", l2), a2 = true);
  }, p: function(r3, a3) {
    e22 = r3, 17 & a3 && u2 !== (u2 = e22[4](e22[9]) + "") && (n2.innerHTML = u2), e22[2] || e22[3] ? c2 && (c2.d(1), c2 = null) : c2 ? c2.p(e22, a3) : ((c2 = RU(e22)).c(), c2.m(t2, i2)), 6 & a3 && o2 !== (o2 = "multiSelectItem " + (e22[1] === e22[11] ? "active" : "") + " " + (e22[2] ? "disabled" : "") + " svelte-liu9pa") && So(t2, "class", o2);
  }, d: function(e23) {
    e23 && po(t2), c2 && c2.d(), a2 = false, s2();
  } };
}
function zU(e22) {
  for (var t2, n2 = e22[0], r2 = [], i2 = 0; i2 < n2.length; i2 += 1)
    r2[i2] = DU(IU(e22, n2, i2));
  return { c: function() {
    for (var e23 = 0; e23 < r2.length; e23 += 1)
      r2[e23].c();
    t2 = wo();
  }, m: function(e23, n3) {
    for (var i3 = 0; i3 < r2.length; i3 += 1)
      r2[i3].m(e23, n3);
    vo(e23, t2, n3);
  }, p: function(e23, i3) {
    var o2 = xi(i3, 1)[0];
    if (63 & o2) {
      var a2;
      for (n2 = e23[0], a2 = 0; a2 < n2.length; a2 += 1) {
        var s2 = IU(e23, n2, a2);
        r2[a2] ? r2[a2].p(s2, o2) : (r2[a2] = DU(s2), r2[a2].c(), r2[a2].m(t2.parentNode, t2));
      }
      for (; a2 < r2.length; a2 += 1)
        r2[a2].d(1);
      r2.length = n2.length;
    }
  }, i: Bi, o: Bi, d: function(e23) {
    mo(r2, e23), e23 && po(t2);
  } };
}
function LU(e22, t2, n2) {
  var r2 = Go(), i2 = t2.value, o2 = i2 === void 0 ? [] : i2, a2 = t2.activeValue, s2 = a2 === void 0 ? void 0 : a2, u2 = t2.isDisabled, c2 = u2 !== void 0 && u2, l2 = t2.multiFullItemClearable, f2 = l2 !== void 0 && l2, h2 = t2.getSelectionLabel, d2 = h2 === void 0 ? void 0 : h2;
  function v2(e23, t3) {
    t3.stopPropagation(), r2("multiItemClear", { i: e23 });
  }
  return e22.$$set = function(e23) {
    "value" in e23 && n2(0, o2 = e23.value), "activeValue" in e23 && n2(1, s2 = e23.activeValue), "isDisabled" in e23 && n2(2, c2 = e23.isDisabled), "multiFullItemClearable" in e23 && n2(3, f2 = e23.multiFullItemClearable), "getSelectionLabel" in e23 && n2(4, d2 = e23.getSelectionLabel);
  }, [o2, s2, c2, f2, d2, v2, function(e23, t3) {
    return v2(e23, t3);
  }, function(e23, t3) {
    return f2 ? v2(e23, t3) : {};
  }];
}
var BU = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, LU, zU, Ui, { value: 0, activeValue: 1, isDisabled: 2, multiFullItemClearable: 3, getSelectionLabel: 4 }, TU), r2;
  }
  return zi(n2);
}();
function qU(e22) {
  co(e22, "svelte-g2cagw", "svelte-virtual-list-viewport.svelte-g2cagw{position:relative;overflow-y:auto;-webkit-overflow-scrolling:touch;display:block}svelte-virtual-list-contents.svelte-g2cagw,svelte-virtual-list-row.svelte-g2cagw{display:block}svelte-virtual-list-row.svelte-g2cagw{overflow:hidden}");
}
function FU(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[23] = t2[n2], r2;
}
var VU = function(e22) {
  return { item: 32 & e22, i: 32 & e22, hoverItemIndex: 2 & e22 };
}, HU = function(e22) {
  return { item: e22[23].data, i: e22[23].index, hoverItemIndex: e22[1] };
};
function WU(e22, t2) {
  var n2, r2, i2, o2 = t2[15].default, a2 = Gi(o2, t2, t2[14], HU), s2 = a2 || function(e23) {
    var t3;
    return { c: function() {
      t3 = bo("Missing template");
    }, m: function(e24, n3) {
      vo(e24, t3, n3);
    }, d: function(e24) {
      e24 && po(t3);
    } };
  }();
  return { key: e22, first: null, c: function() {
    n2 = go("svelte-virtual-list-row"), s2 && s2.c(), r2 = ko(), $o(n2, "class", "svelte-g2cagw"), this.first = n2;
  }, m: function(e23, t3) {
    vo(e23, n2, t3), s2 && s2.m(n2, null), uo(n2, r2), i2 = true;
  }, p: function(e23, n3) {
    t2 = e23, a2 && a2.p && (!i2 || 16418 & n3) && Zi(a2, o2, t2, t2[14], i2 ? Yi(o2, t2[14], n3, VU) : Xi(t2[14]), HU);
  }, i: function(e23) {
    i2 || (ya(s2, e23), i2 = true);
  }, o: function(e23) {
    ba(s2, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(n2), s2 && s2.d(e23);
  } };
}
function JU(e22) {
  for (var t2, n2, r2, i2, o2, a2, s2 = [], u2 = /* @__PURE__ */ new Map(), c2 = e22[5], l2 = function(e23) {
    return e23[23].index;
  }, f2 = 0; f2 < c2.length; f2 += 1) {
    var h2 = FU(e22, c2, f2), d2 = l2(h2);
    u2.set(d2, s2[f2] = WU(d2, h2));
  }
  return { c: function() {
    t2 = go("svelte-virtual-list-viewport"), n2 = go("svelte-virtual-list-contents");
    for (var r3 = 0; r3 < s2.length; r3 += 1)
      s2[r3].c();
    Eo(n2, "padding-top", e22[6] + "px"), Eo(n2, "padding-bottom", e22[7] + "px"), $o(n2, "class", "svelte-g2cagw"), Eo(t2, "height", e22[0]), $o(t2, "class", "svelte-g2cagw"), aa(function() {
      return e22[18].call(t2);
    });
  }, m: function(u3, c3) {
    vo(u3, t2, c3), uo(t2, n2);
    for (var l3 = 0; l3 < s2.length; l3 += 1)
      s2[l3].m(n2, null);
    e22[16](n2), e22[17](t2), r2 = function(e23, t3) {
      getComputedStyle(e23).position === "static" && (e23.style.position = "relative");
      var n3 = go("iframe");
      n3.setAttribute("style", "display: block; position: absolute; top: 0; left: 0; width: 100%; height: 100%; overflow: hidden; border: 0; opacity: 0; pointer-events: none; z-index: -1;"), n3.setAttribute("aria-hidden", "true"), n3.tabIndex = -1;
      var r3, i3 = No();
      return i3 ? (n3.src = "data:text/html,<script>onresize=function(){parent.postMessage(0,'*')}<\/script>", r3 = xo(window, "message", function(e24) {
        e24.source === n3.contentWindow && t3();
      })) : (n3.src = "about:blank", n3.onload = function() {
        r3 = xo(n3.contentWindow, "resize", t3);
      }), uo(e23, n3), function() {
        (i3 || r3 && n3.contentWindow) && r3(), po(n3);
      };
    }(t2, e22[18].bind(t2)), i2 = true, o2 || (a2 = xo(t2, "scroll", e22[8]), o2 = true);
  }, p: function(e23, r3) {
    var o3 = xi(r3, 1)[0];
    16418 & o3 && (c2 = e23[5], ma(), s2 = Ca(s2, o3, l2, 1, e23, c2, u2, n2, Sa, WU, null, FU), ga()), (!i2 || 64 & o3) && Eo(n2, "padding-top", e23[6] + "px"), (!i2 || 128 & o3) && Eo(n2, "padding-bottom", e23[7] + "px"), (!i2 || 1 & o3) && Eo(t2, "height", e23[0]);
  }, i: function(e23) {
    if (!i2) {
      for (var t3 = 0; t3 < c2.length; t3 += 1)
        ya(s2[t3]);
      i2 = true;
    }
  }, o: function(e23) {
    for (var t3 = 0; t3 < s2.length; t3 += 1)
      ba(s2[t3]);
    i2 = false;
  }, d: function(n3) {
    n3 && po(t2);
    for (var i3 = 0; i3 < s2.length; i3 += 1)
      s2[i3].d();
    e22[16](null), e22[17](null), r2(), o2 = false, a2();
  } };
}
function UU(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2 = t2.$$slots, l2 = c2 === void 0 ? {} : c2, f2 = t2.$$scope, h2 = t2.items, d2 = h2 === void 0 ? void 0 : h2, v2 = t2.height, p2 = v2 === void 0 ? "100%" : v2, m2 = t2.itemHeight, g2 = m2 === void 0 ? 40 : m2, y2 = t2.hoverItemIndex, b2 = y2 === void 0 ? 0 : y2, k2 = t2.start, w2 = k2 === void 0 ? 0 : k2, x2 = t2.end, j2 = x2 === void 0 ? 0 : x2, S2 = [], C2 = 0, _2 = 0, $2 = 0;
  function O2() {
    return (O2 = yi(mi().mark(function e23(t3, o3, a3) {
      var s3, c3, l3, f3, h3, d3;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              return s3 = i2.scrollTop, e24.next = 3, oa();
            case 3:
              c3 = _2 - s3, l3 = w2;
            case 5:
              if (!(c3 < o3 && l3 < t3.length)) {
                e24.next = 17;
                break;
              }
              if (f3 = r2[l3 - w2]) {
                e24.next = 12;
                break;
              }
              return n2(10, j2 = l3 + 1), e24.next = 11, oa();
            case 11:
              f3 = r2[l3 - w2];
            case 12:
              h3 = S2[l3] = a3 || f3.offsetHeight, c3 += h3, l3 += 1, e24.next = 5;
              break;
            case 17:
              n2(10, j2 = l3), d3 = t3.length - j2, n2(7, $2 = d3 * (u2 = (_2 + c3) / j2)), S2.length = t3.length, i2 && n2(3, i2.scrollTop = 0, i2);
            case 23:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function A2() {
    return (A2 = yi(mi().mark(function e23() {
      var t3, o3, a3, s3, c3, l3, f3, h3, v3, p3, m3;
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              for (t3 = i2.scrollTop, o3 = w2, a3 = 0; a3 < r2.length; a3 += 1)
                S2[w2 + a3] = g2 || r2[a3].offsetHeight;
              s3 = 0, c3 = 0;
            case 5:
              if (!(s3 < d2.length)) {
                e24.next = 15;
                break;
              }
              if (l3 = S2[s3] || u2, !(c3 + l3 > t3)) {
                e24.next = 11;
                break;
              }
              return n2(9, w2 = s3), n2(6, _2 = c3), e24.abrupt("break", 15);
            case 11:
              c3 += l3, s3 += 1, e24.next = 5;
              break;
            case 15:
              if (!(s3 < d2.length)) {
                e24.next = 22;
                break;
              }
              if (c3 += S2[s3] || u2, s3 += 1, !(c3 > t3 + C2)) {
                e24.next = 20;
                break;
              }
              return e24.abrupt("break", 22);
            case 20:
              e24.next = 15;
              break;
            case 22:
              for (n2(10, j2 = s3), f3 = d2.length - j2, u2 = c3 / j2; s3 < d2.length; )
                S2[s3++] = u2;
              if (n2(7, $2 = f3 * u2), !(w2 < o3)) {
                e24.next = 35;
                break;
              }
              return e24.next = 30, oa();
            case 30:
              for (h3 = 0, v3 = 0, p3 = w2; p3 < o3; p3 += 1)
                r2[p3 - w2] && (h3 += S2[p3], v3 += g2 || r2[p3 - w2].offsetHeight);
              m3 = v3 - h3, i2.scrollTo(0, t3 + m3);
            case 35:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  return Uo(function() {
    r2 = o2.getElementsByTagName("svelte-virtual-list-row"), n2(13, s2 = true);
  }), e22.$$set = function(e23) {
    "items" in e23 && n2(11, d2 = e23.items), "height" in e23 && n2(0, p2 = e23.height), "itemHeight" in e23 && n2(12, g2 = e23.itemHeight), "hoverItemIndex" in e23 && n2(1, b2 = e23.hoverItemIndex), "start" in e23 && n2(9, w2 = e23.start), "end" in e23 && n2(10, j2 = e23.end), "$$scope" in e23 && n2(14, f2 = e23.$$scope);
  }, e22.$$.update = function() {
    3584 & e22.$$.dirty && n2(5, a2 = d2.slice(w2, j2).map(function(e23, t3) {
      return { index: t3 + w2, data: e23 };
    })), 14340 & e22.$$.dirty && s2 && function(e23, t3, n3) {
      O2.apply(this, arguments);
    }(d2, C2, g2);
  }, [p2, b2, C2, i2, o2, a2, _2, $2, function() {
    return A2.apply(this, arguments);
  }, w2, j2, d2, g2, s2, f2, l2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(4, o2 = e23);
    });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(3, i2 = e23);
    });
  }, function() {
    C2 = this.offsetHeight, n2(2, C2);
  }];
}
var KU = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, UU, JU, Ui, { items: 11, height: 0, itemHeight: 12, hoverItemIndex: 1, start: 9, end: 10 }, qU), r2;
  }
  return zi(n2);
}();
function GU(e22) {
  var t2, n2;
  return { c: function() {
    t2 = yo("svg"), So(n2 = yo("path"), "fill", "currentColor"), So(n2, "d", "M34.923,37.251L24,26.328L13.077,37.251L9.436,33.61l10.923-10.923L9.436,11.765l3.641-3.641L24,19.047L34.923,8.124\n    l3.641,3.641L27.641,22.688L38.564,33.61L34.923,37.251z"), So(t2, "width", "100%"), So(t2, "height", "100%"), So(t2, "viewBox", "-2 -2 50 50"), So(t2, "focusable", "false"), So(t2, "aria-hidden", "true"), So(t2, "role", "presentation");
  }, m: function(e23, r2) {
    vo(e23, t2, r2), uo(t2, n2);
  }, p: Bi, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
var QU = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, null, GU, Ui, {}), r2;
  }
  return zi(n2);
}();
function YU(e22) {
  co(e22, "svelte-17l1npl", ".selectContainer.svelte-17l1npl.svelte-17l1npl{--internalPadding:0 16px;border:var(--border, 1px solid #d8dbdf);border-radius:var(--borderRadius, 3px);box-sizing:border-box;height:var(--height, 42px);position:relative;display:flex;align-items:center;padding:var(--padding, var(--internalPadding));background:var(--background, #fff);margin:var(--margin, 0)}.selectContainer.svelte-17l1npl input.svelte-17l1npl{cursor:default;border:none;color:var(--inputColor, #3f4f5f);height:var(--height, 42px);line-height:var(--height, 42px);padding:var(--inputPadding, var(--padding, var(--internalPadding)));width:100%;background:transparent;font-size:var(--inputFontSize, 14px);letter-spacing:var(--inputLetterSpacing, -0.08px);position:absolute;left:var(--inputLeft, 0);margin:var(--inputMargin, 0)}.selectContainer.svelte-17l1npl input.svelte-17l1npl::placeholder{color:var(--placeholderColor, #78848f);opacity:var(--placeholderOpacity, 1)}.selectContainer.svelte-17l1npl input.svelte-17l1npl:focus{outline:none}.selectContainer.svelte-17l1npl.svelte-17l1npl:hover{border-color:var(--borderHoverColor, #b2b8bf)}.selectContainer.focused.svelte-17l1npl.svelte-17l1npl{border-color:var(--borderFocusColor, #006fe8)}.selectContainer.disabled.svelte-17l1npl.svelte-17l1npl{background:var(--disabledBackground, #ebedef);border-color:var(--disabledBorderColor, #ebedef);color:var(--disabledColor, #c1c6cc)}.selectContainer.disabled.svelte-17l1npl input.svelte-17l1npl::placeholder{color:var(--disabledPlaceholderColor, #c1c6cc);opacity:var(--disabledPlaceholderOpacity, 1)}.selectedItem.svelte-17l1npl.svelte-17l1npl{line-height:var(--height, 42px);height:var(--height, 42px);overflow-x:hidden;padding:var(--selectedItemPadding, 0 20px 0 0)}.selectedItem.svelte-17l1npl.svelte-17l1npl:focus{outline:none}.clearSelect.svelte-17l1npl.svelte-17l1npl{position:absolute;right:var(--clearSelectRight, 10px);top:var(--clearSelectTop, 11px);bottom:var(--clearSelectBottom, 11px);width:var(--clearSelectWidth, 20px);color:var(--clearSelectColor, #c5cacf);flex:none !important}.clearSelect.svelte-17l1npl.svelte-17l1npl:hover{color:var(--clearSelectHoverColor, #2c3e50)}.selectContainer.focused.svelte-17l1npl .clearSelect.svelte-17l1npl{color:var(--clearSelectFocusColor, #3f4f5f)}.indicator.svelte-17l1npl.svelte-17l1npl{position:absolute;right:var(--indicatorRight, 10px);top:var(--indicatorTop, 11px);width:var(--indicatorWidth, 20px);height:var(--indicatorHeight, 20px);color:var(--indicatorColor, #c5cacf)}.indicator.svelte-17l1npl svg.svelte-17l1npl{display:inline-block;fill:var(--indicatorFill, currentcolor);line-height:1;stroke:var(--indicatorStroke, currentcolor);stroke-width:0}.spinner.svelte-17l1npl.svelte-17l1npl{position:absolute;right:var(--spinnerRight, 10px);top:var(--spinnerLeft, 11px);width:var(--spinnerWidth, 20px);height:var(--spinnerHeight, 20px);color:var(--spinnerColor, #51ce6c);animation:svelte-17l1npl-rotate 0.75s linear infinite}.spinner_icon.svelte-17l1npl.svelte-17l1npl{display:block;height:100%;transform-origin:center center;width:100%;position:absolute;top:0;bottom:0;left:0;right:0;margin:auto;-webkit-transform:none}.spinner_path.svelte-17l1npl.svelte-17l1npl{stroke-dasharray:90;stroke-linecap:round}.multiSelect.svelte-17l1npl.svelte-17l1npl{display:flex;padding:var(--multiSelectPadding, 0 35px 0 16px);height:auto;flex-wrap:wrap;align-items:stretch}.multiSelect.svelte-17l1npl>.svelte-17l1npl{flex:1 1 50px}.selectContainer.multiSelect.svelte-17l1npl input.svelte-17l1npl{padding:var(--multiSelectInputPadding, 0);position:relative;margin:var(--multiSelectInputMargin, 0)}.hasError.svelte-17l1npl.svelte-17l1npl{border:var(--errorBorder, 1px solid #ff2d55);background:var(--errorBackground, #fff)}.a11yText.svelte-17l1npl.svelte-17l1npl{z-index:9999;border:0px;clip:rect(1px, 1px, 1px, 1px);height:1px;width:1px;position:absolute;overflow:hidden;padding:0px;white-space:nowrap}@keyframes svelte-17l1npl-rotate{100%{transform:rotate(360deg)}}");
}
function ZU(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[103] = t2[n2], r2;
}
function XU(e22) {
  var t2, n2, r2, i2, o2;
  return { c: function() {
    t2 = go("span"), n2 = bo(e22[33]), r2 = ko(), i2 = go("span"), o2 = bo(e22[32]), So(t2, "id", "aria-selection"), So(i2, "id", "aria-context");
  }, m: function(e23, a2) {
    vo(e23, t2, a2), uo(t2, n2), vo(e23, r2, a2), vo(e23, i2, a2), uo(i2, o2);
  }, p: function(e23, t3) {
    4 & t3[1] && Ao(n2, e23[33]), 2 & t3[1] && Ao(o2, e23[32]);
  }, d: function(e23) {
    e23 && po(t2), e23 && po(r2), e23 && po(i2);
  } };
}
function eK(e22) {
  var t2, n2, r2, i2 = [e22[18]], o2 = e22[17];
  function a2(e23) {
    for (var t3 = {}, n3 = 0; n3 < i2.length; n3 += 1)
      t3 = Fi(t3, i2[n3]);
    return { props: t3 };
  }
  return o2 && (t2 = new o2(a2())), { c: function() {
    t2 && Aa(t2.$$.fragment), n2 = wo();
  }, m: function(e23, i3) {
    t2 && Ma(t2, e23, i3), vo(e23, n2, i3), r2 = true;
  }, p: function(e23, r3) {
    var s2 = 262144 & r3[0] ? _a(i2, [$a(e23[18])]) : {};
    if (o2 !== (o2 = e23[17])) {
      if (t2) {
        ma();
        var u2 = t2;
        ba(u2.$$.fragment, 1, 0, function() {
          Ea(u2, 1);
        }), ga();
      }
      o2 ? (Aa((t2 = new o2(a2())).$$.fragment), ya(t2.$$.fragment, 1), Ma(t2, n2.parentNode, n2)) : t2 = null;
    } else
      o2 && t2.$set(s2);
  }, i: function(e23) {
    r2 || (t2 && ya(t2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    t2 && ba(t2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(n2), t2 && Ea(t2, e23);
  } };
}
function tK(e22) {
  var t2, n2, r2, i2 = e22[26];
  function o2(e23) {
    return { props: { value: e23[2], getSelectionLabel: e23[12], activeValue: e23[30], isDisabled: e23[9], multiFullItemClearable: e23[8] } };
  }
  return i2 && ((t2 = new i2(o2(e22))).$on("multiItemClear", e22[38]), t2.$on("focus", e22[40])), { c: function() {
    t2 && Aa(t2.$$.fragment), n2 = wo();
  }, m: function(e23, i3) {
    t2 && Ma(t2, e23, i3), vo(e23, n2, i3), r2 = true;
  }, p: function(e23, r3) {
    var a2 = {};
    if (4 & r3[0] && (a2.value = e23[2]), 4096 & r3[0] && (a2.getSelectionLabel = e23[12]), 1073741824 & r3[0] && (a2.activeValue = e23[30]), 512 & r3[0] && (a2.isDisabled = e23[9]), 256 & r3[0] && (a2.multiFullItemClearable = e23[8]), i2 !== (i2 = e23[26])) {
      if (t2) {
        ma();
        var s2 = t2;
        ba(s2.$$.fragment, 1, 0, function() {
          Ea(s2, 1);
        }), ga();
      }
      i2 ? ((t2 = new i2(o2(e23))).$on("multiItemClear", e23[38]), t2.$on("focus", e23[40]), Aa(t2.$$.fragment), ya(t2.$$.fragment, 1), Ma(t2, n2.parentNode, n2)) : t2 = null;
    } else
      i2 && t2.$set(a2);
  }, i: function(e23) {
    r2 || (t2 && ya(t2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    t2 && ba(t2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(n2), t2 && Ea(t2, e23);
  } };
}
function nK(e22) {
  var t2, n2, r2, i2, o2, a2 = e22[25];
  function s2(e23) {
    return { props: { item: e23[2], getSelectionLabel: e23[12] } };
  }
  return a2 && (n2 = new a2(s2(e22))), { c: function() {
    t2 = go("div"), n2 && Aa(n2.$$.fragment), So(t2, "class", "selectedItem svelte-17l1npl");
  }, m: function(a3, s3) {
    vo(a3, t2, s3), n2 && Ma(n2, t2, null), r2 = true, i2 || (o2 = xo(t2, "focus", e22[40]), i2 = true);
  }, p: function(e23, r3) {
    var i3 = {};
    if (4 & r3[0] && (i3.item = e23[2]), 4096 & r3[0] && (i3.getSelectionLabel = e23[12]), a2 !== (a2 = e23[25])) {
      if (n2) {
        ma();
        var o3 = n2;
        ba(o3.$$.fragment, 1, 0, function() {
          Ea(o3, 1);
        }), ga();
      }
      a2 ? (Aa((n2 = new a2(s2(e23))).$$.fragment), ya(n2.$$.fragment, 1), Ma(n2, t2, null)) : n2 = null;
    } else
      a2 && n2.$set(i3);
  }, i: function(e23) {
    r2 || (n2 && ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    n2 && ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), n2 && Ea(n2), i2 = false, o2();
  } };
}
function rK(e22) {
  var t2, n2, r2, i2, o2, a2 = e22[23];
  return a2 && (n2 = new a2({})), { c: function() {
    t2 = go("div"), n2 && Aa(n2.$$.fragment), So(t2, "class", "clearSelect svelte-17l1npl"), So(t2, "aria-hidden", "true");
  }, m: function(a3, s2) {
    var u2;
    vo(a3, t2, s2), n2 && Ma(n2, t2, null), r2 = true, i2 || (o2 = xo(t2, "click", (u2 = e22[27], function(e23) {
      return e23.preventDefault(), u2.call(this, e23);
    })), i2 = true);
  }, p: function(e23, r3) {
    if (a2 !== (a2 = e23[23])) {
      if (n2) {
        ma();
        var i3 = n2;
        ba(i3.$$.fragment, 1, 0, function() {
          Ea(i3, 1);
        }), ga();
      }
      a2 ? (Aa((n2 = new a2({})).$$.fragment), ya(n2.$$.fragment, 1), Ma(n2, t2, null)) : n2 = null;
    }
  }, i: function(e23) {
    r2 || (n2 && ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    n2 && ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), n2 && Ea(n2), i2 = false, o2();
  } };
}
function iK(e22) {
  var t2;
  function n2(e23, t3) {
    return e23[22] ? aK : oK;
  }
  var r2 = n2(e22), i2 = r2(e22);
  return { c: function() {
    t2 = go("div"), i2.c(), So(t2, "class", "indicator svelte-17l1npl"), So(t2, "aria-hidden", "true");
  }, m: function(e23, n3) {
    vo(e23, t2, n3), i2.m(t2, null);
  }, p: function(e23, o2) {
    r2 === (r2 = n2(e23)) && i2 ? i2.p(e23, o2) : (i2.d(1), (i2 = r2(e23)) && (i2.c(), i2.m(t2, null)));
  }, d: function(e23) {
    e23 && po(t2), i2.d();
  } };
}
function oK(e22) {
  var t2, n2;
  return { c: function() {
    t2 = yo("svg"), So(n2 = yo("path"), "d", "M4.516 7.548c0.436-0.446 1.043-0.481 1.576 0l3.908 3.747\n          3.908-3.747c0.533-0.481 1.141-0.446 1.574 0 0.436 0.445 0.408 1.197 0\n          1.615-0.406 0.418-4.695 4.502-4.695 4.502-0.217 0.223-0.502\n          0.335-0.787 0.335s-0.57-0.112-0.789-0.335c0\n          0-4.287-4.084-4.695-4.502s-0.436-1.17 0-1.615z"), So(t2, "width", "100%"), So(t2, "height", "100%"), So(t2, "viewBox", "0 0 20 20"), So(t2, "focusable", "false"), So(t2, "aria-hidden", "true"), So(t2, "class", "svelte-17l1npl");
  }, m: function(e23, r2) {
    vo(e23, t2, r2), uo(t2, n2);
  }, p: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function aK(e22) {
  var t2, n2;
  return { c: function() {
    t2 = new Do(false), n2 = wo(), t2.a = n2;
  }, m: function(r2, i2) {
    t2.m(e22[22], r2, i2), vo(r2, n2, i2);
  }, p: function(e23, n3) {
    4194304 & n3[0] && t2.p(e23[22]);
  }, d: function(e23) {
    e23 && po(n2), e23 && t2.d();
  } };
}
function sK(e22) {
  var t2;
  return { c: function() {
    (t2 = go("div")).innerHTML = '<svg class="spinner_icon svelte-17l1npl" viewBox="25 25 50 50"><circle class="spinner_path svelte-17l1npl" cx="50" cy="50" r="20" fill="none" stroke="currentColor" stroke-width="5" stroke-miterlimit="10"></circle></svg>', So(t2, "class", "spinner svelte-17l1npl");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function uK(e22) {
  var t2, n2, r2, i2, o2 = [e22[34]];
  function a2(t3) {
    e22[84](t3);
  }
  var s2 = e22[24];
  function u2(e23) {
    for (var t3 = {}, n3 = 0; n3 < o2.length; n3 += 1)
      t3 = Fi(t3, o2[n3]);
    return e23[28] !== void 0 && (t3.hoverItemIndex = e23[28]), { props: t3 };
  }
  return s2 && (t2 = new s2(u2(e22)), Xo.push(function() {
    return Oa(t2, "hoverItemIndex", a2);
  }), t2.$on("itemSelected", e22[43]), t2.$on("itemCreated", e22[44]), t2.$on("closeList", e22[45])), { c: function() {
    t2 && Aa(t2.$$.fragment), r2 = wo();
  }, m: function(e23, n3) {
    t2 && Ma(t2, e23, n3), vo(e23, r2, n3), i2 = true;
  }, p: function(e23, i3) {
    var c2 = 8 & i3[1] ? _a(o2, [$a(e23[34])]) : {};
    if (!n2 && 268435456 & i3[0] && (n2 = true, c2.hoverItemIndex = e23[28], sa(function() {
      return n2 = false;
    })), s2 !== (s2 = e23[24])) {
      if (t2) {
        ma();
        var l2 = t2;
        ba(l2.$$.fragment, 1, 0, function() {
          Ea(l2, 1);
        }), ga();
      }
      s2 ? (t2 = new s2(u2(e23)), Xo.push(function() {
        return Oa(t2, "hoverItemIndex", a2);
      }), t2.$on("itemSelected", e23[43]), t2.$on("itemCreated", e23[44]), t2.$on("closeList", e23[45]), Aa(t2.$$.fragment), ya(t2.$$.fragment, 1), Ma(t2, r2.parentNode, r2)) : t2 = null;
    } else
      s2 && t2.$set(c2);
  }, i: function(e23) {
    i2 || (t2 && ya(t2.$$.fragment, e23), i2 = true);
  }, o: function(e23) {
    t2 && ba(t2.$$.fragment, e23), i2 = false;
  }, d: function(e23) {
    e23 && po(r2), t2 && Ea(t2, e23);
  } };
}
function cK(e22) {
  var t2, n2, r2;
  return { c: function() {
    So(t2 = go("input"), "name", n2 = e22[16].name), So(t2, "type", "hidden"), t2.value = r2 = e22[2] ? e22[12](e22[2]) : null, So(t2, "class", "svelte-17l1npl");
  }, m: function(e23, n3) {
    vo(e23, t2, n3);
  }, p: function(e23, i2) {
    65536 & i2[0] && n2 !== (n2 = e23[16].name) && So(t2, "name", n2), 4100 & i2[0] && r2 !== (r2 = e23[2] ? e23[12](e23[2]) : null) && (t2.value = r2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function lK(e22) {
  for (var t2, n2 = e22[2], r2 = [], i2 = 0; i2 < n2.length; i2 += 1)
    r2[i2] = fK(ZU(e22, n2, i2));
  return { c: function() {
    for (var e23 = 0; e23 < r2.length; e23 += 1)
      r2[e23].c();
    t2 = wo();
  }, m: function(e23, n3) {
    for (var i3 = 0; i3 < r2.length; i3 += 1)
      r2[i3].m(e23, n3);
    vo(e23, t2, n3);
  }, p: function(e23, i3) {
    if (69636 & i3[0]) {
      var o2;
      for (n2 = e23[2], o2 = 0; o2 < n2.length; o2 += 1) {
        var a2 = ZU(e23, n2, o2);
        r2[o2] ? r2[o2].p(a2, i3) : (r2[o2] = fK(a2), r2[o2].c(), r2[o2].m(t2.parentNode, t2));
      }
      for (; o2 < r2.length; o2 += 1)
        r2[o2].d(1);
      r2.length = n2.length;
    }
  }, d: function(e23) {
    mo(r2, e23), e23 && po(t2);
  } };
}
function fK(e22) {
  var t2, n2, r2;
  return { c: function() {
    So(t2 = go("input"), "name", n2 = e22[16].name), So(t2, "type", "hidden"), t2.value = r2 = e22[103] ? e22[12](e22[103]) : null, So(t2, "class", "svelte-17l1npl");
  }, m: function(e23, n3) {
    vo(e23, t2, n3);
  }, p: function(e23, i2) {
    65536 & i2[0] && n2 !== (n2 = e23[16].name) && So(t2, "name", n2), 4100 & i2[0] && r2 !== (r2 = e23[103] ? e23[12](e23[103]) : null) && (t2.value = r2);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function hK(e22) {
  for (var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2 = e22[1] && XU(e22), k2 = e22[17] && eK(e22), w2 = e22[35] && tK(e22), x2 = [{ readOnly: s2 = !e22[13] }, e22[31], { placeholder: e22[36] }, { style: e22[14] }, { disabled: e22[9] }], j2 = {}, S2 = 0; S2 < x2.length; S2 += 1)
    j2 = Fi(j2, x2[S2]);
  var C2 = !e22[7] && e22[29] && nK(e22), _2 = e22[37] && rK(e22), $2 = !e22[37] && (e22[20] || e22[19] && !e22[2] || !e22[13] && !e22[9] && !e22[4] && (e22[29] && !e22[15] || !e22[29])) && iK(e22), O2 = e22[4] && sK(), A2 = e22[5] && uK(e22), M2 = (!e22[7] || e22[7] && !e22[35]) && cK(e22), E2 = e22[7] && e22[35] && lK(e22);
  return { c: function() {
    t2 = go("div"), n2 = go("span"), b2 && b2.c(), r2 = ko(), k2 && k2.c(), i2 = ko(), w2 && w2.c(), o2 = ko(), a2 = go("input"), u2 = ko(), C2 && C2.c(), c2 = ko(), _2 && _2.c(), l2 = ko(), $2 && $2.c(), f2 = ko(), O2 && O2.c(), h2 = ko(), A2 && A2.c(), d2 = ko(), M2 && M2.c(), v2 = ko(), E2 && E2.c(), So(n2, "aria-live", "polite"), So(n2, "aria-atomic", "false"), So(n2, "aria-relevant", "additions text"), So(n2, "class", "a11yText svelte-17l1npl"), Co(a2, j2), To(a2, "svelte-17l1npl", true), So(t2, "class", p2 = "selectContainer " + e22[21] + " svelte-17l1npl"), So(t2, "style", e22[11]), To(t2, "hasError", e22[10]), To(t2, "multiSelect", e22[7]), To(t2, "disabled", e22[9]), To(t2, "focused", e22[1]);
  }, m: function(s3, p3) {
    vo(s3, t2, p3), uo(t2, n2), b2 && b2.m(n2, null), uo(t2, r2), k2 && k2.m(t2, null), uo(t2, i2), w2 && w2.m(t2, null), uo(t2, o2), uo(t2, a2), a2.autofocus && a2.focus(), e22[82](a2), Mo(a2, e22[3]), uo(t2, u2), C2 && C2.m(t2, null), uo(t2, c2), _2 && _2.m(t2, null), uo(t2, l2), $2 && $2.m(t2, null), uo(t2, f2), O2 && O2.m(t2, null), uo(t2, h2), A2 && A2.m(t2, null), uo(t2, d2), M2 && M2.m(t2, null), uo(t2, v2), E2 && E2.m(t2, null), e22[85](t2), m2 = true, g2 || (y2 = [xo(window, "click", e22[41]), xo(window, "focusin", e22[41]), xo(window, "keydown", e22[39]), xo(a2, "focus", e22[40]), xo(a2, "input", e22[83]), xo(t2, "click", e22[42])], g2 = true);
  }, p: function(e23, r3) {
    e23[1] ? b2 ? b2.p(e23, r3) : ((b2 = XU(e23)).c(), b2.m(n2, null)) : b2 && (b2.d(1), b2 = null), e23[17] ? k2 ? (k2.p(e23, r3), 131072 & r3[0] && ya(k2, 1)) : ((k2 = eK(e23)).c(), ya(k2, 1), k2.m(t2, i2)) : k2 && (ma(), ba(k2, 1, 1, function() {
      k2 = null;
    }), ga()), e23[35] ? w2 ? (w2.p(e23, r3), 16 & r3[1] && ya(w2, 1)) : ((w2 = tK(e23)).c(), ya(w2, 1), w2.m(t2, o2)) : w2 && (ma(), ba(w2, 1, 1, function() {
      w2 = null;
    }), ga()), Co(a2, j2 = _a(x2, [(!m2 || 8192 & r3[0] && s2 !== (s2 = !e23[13])) && { readOnly: s2 }, 1 & r3[1] && e23[31], (!m2 || 32 & r3[1]) && { placeholder: e23[36] }, (!m2 || 16384 & r3[0]) && { style: e23[14] }, (!m2 || 512 & r3[0]) && { disabled: e23[9] }])), 8 & r3[0] && a2.value !== e23[3] && Mo(a2, e23[3]), To(a2, "svelte-17l1npl", true), !e23[7] && e23[29] ? C2 ? (C2.p(e23, r3), 536871040 & r3[0] && ya(C2, 1)) : ((C2 = nK(e23)).c(), ya(C2, 1), C2.m(t2, c2)) : C2 && (ma(), ba(C2, 1, 1, function() {
      C2 = null;
    }), ga()), e23[37] ? _2 ? (_2.p(e23, r3), 64 & r3[1] && ya(_2, 1)) : ((_2 = rK(e23)).c(), ya(_2, 1), _2.m(t2, l2)) : _2 && (ma(), ba(_2, 1, 1, function() {
      _2 = null;
    }), ga()), e23[37] || !(e23[20] || e23[19] && !e23[2]) && (e23[13] || e23[9] || e23[4] || (!e23[29] || e23[15]) && e23[29]) ? $2 && ($2.d(1), $2 = null) : $2 ? $2.p(e23, r3) : (($2 = iK(e23)).c(), $2.m(t2, f2)), e23[4] ? O2 || ((O2 = sK()).c(), O2.m(t2, h2)) : O2 && (O2.d(1), O2 = null), e23[5] ? A2 ? (A2.p(e23, r3), 32 & r3[0] && ya(A2, 1)) : ((A2 = uK(e23)).c(), ya(A2, 1), A2.m(t2, d2)) : A2 && (ma(), ba(A2, 1, 1, function() {
      A2 = null;
    }), ga()), !e23[7] || e23[7] && !e23[35] ? M2 ? M2.p(e23, r3) : ((M2 = cK(e23)).c(), M2.m(t2, v2)) : M2 && (M2.d(1), M2 = null), e23[7] && e23[35] ? E2 ? E2.p(e23, r3) : ((E2 = lK(e23)).c(), E2.m(t2, null)) : E2 && (E2.d(1), E2 = null), (!m2 || 2097152 & r3[0] && p2 !== (p2 = "selectContainer " + e23[21] + " svelte-17l1npl")) && So(t2, "class", p2), (!m2 || 2048 & r3[0]) && So(t2, "style", e23[11]), 2098176 & r3[0] && To(t2, "hasError", e23[10]), 2097280 & r3[0] && To(t2, "multiSelect", e23[7]), 2097664 & r3[0] && To(t2, "disabled", e23[9]), 2097154 & r3[0] && To(t2, "focused", e23[1]);
  }, i: function(e23) {
    m2 || (ya(k2), ya(w2), ya(C2), ya(_2), ya(A2), m2 = true);
  }, o: function(e23) {
    ba(k2), ba(w2), ba(C2), ba(_2), ba(A2), m2 = false;
  }, d: function(n3) {
    n3 && po(t2), b2 && b2.d(), k2 && k2.d(), w2 && w2.d(), e22[82](null), C2 && C2.d(), _2 && _2.d(), $2 && $2.d(), O2 && O2.d(), A2 && A2.d(), M2 && M2.d(), E2 && E2.d(), e22[85](null), g2 = false, Wi(y2);
  } };
}
function dK(e22) {
  return e22.map(function(e23, t2) {
    return { index: t2, value: e23, label: "".concat(e23) };
  });
}
function vK(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2, l2, f2 = Go(), h2 = t2.id, d2 = h2 === void 0 ? null : h2, v2 = t2.container, p2 = v2 === void 0 ? void 0 : v2, m2 = t2.input, g2 = m2 === void 0 ? void 0 : m2, y2 = t2.isMulti, b2 = y2 !== void 0 && y2, k2 = t2.multiFullItemClearable, w2 = k2 !== void 0 && k2, x2 = t2.isDisabled, j2 = x2 !== void 0 && x2, S2 = t2.isCreatable, C2 = S2 !== void 0 && S2, _2 = t2.isFocused, $2 = _2 !== void 0 && _2, O2 = t2.value, A2 = O2 === void 0 ? null : O2, M2 = t2.filterText, E2 = M2 === void 0 ? "" : M2, P2 = t2.placeholder, N2 = P2 === void 0 ? "Select..." : P2, T2 = t2.placeholderAlwaysShow, I2 = T2 !== void 0 && T2, R2 = t2.items, D2 = R2 === void 0 ? null : R2, z2 = t2.itemFilter, L2 = z2 === void 0 ? function(e23, t3, n3) {
    return "".concat(e23).toLowerCase().includes(t3.toLowerCase());
  } : z2, B2 = t2.groupBy, q2 = B2 === void 0 ? void 0 : B2, F2 = t2.groupFilter, V2 = F2 === void 0 ? function(e23) {
    return e23;
  } : F2, H2 = t2.isGroupHeaderSelectable, W2 = H2 !== void 0 && H2, J2 = t2.getGroupHeaderLabel, U2 = J2 === void 0 ? function(e23) {
    return e23[G2] || e23.id;
  } : J2, K2 = t2.labelIdentifier, G2 = K2 === void 0 ? "label" : K2, Q2 = t2.getOptionLabel, Y2 = Q2 === void 0 ? function(e23, t3) {
    return e23.isCreator ? 'Create "'.concat(t3, '"') : e23[G2];
  } : Q2, Z2 = t2.optionIdentifier, X2 = Z2 === void 0 ? "value" : Z2, ee2 = t2.loadOptions, te2 = ee2 === void 0 ? void 0 : ee2, ne2 = t2.hasError, re2 = ne2 !== void 0 && ne2, ie2 = t2.containerStyles, oe2 = ie2 === void 0 ? "" : ie2, ae2 = t2.getSelectionLabel, se2 = ae2 === void 0 ? function(e23) {
    return e23 ? e23[G2] : null;
  } : ae2, ue2 = t2.createGroupHeaderItem, ce2 = ue2 === void 0 ? function(e23) {
    return { value: e23, label: e23 };
  } : ue2, le2 = t2.createItem, fe2 = le2 === void 0 ? function(e23) {
    return { value: e23, label: e23 };
  } : le2, he2 = t2.isSearchable, de2 = he2 === void 0 || he2, ve2 = t2.inputStyles, pe2 = ve2 === void 0 ? "" : ve2, me2 = t2.isClearable, ge2 = me2 === void 0 || me2, ye2 = t2.isWaiting, be2 = ye2 !== void 0 && ye2, ke2 = t2.listPlacement, we2 = ke2 === void 0 ? "auto" : ke2, xe2 = t2.listOpen, je2 = xe2 !== void 0 && xe2, Se2 = t2.isVirtualList, Ce2 = Se2 !== void 0 && Se2, _e2 = t2.loadOptionsInterval, $e2 = _e2 === void 0 ? 300 : _e2, Oe2 = t2.noOptionsMessage, Ae2 = Oe2 === void 0 ? "No options" : Oe2, Me2 = t2.hideEmptyState, Ee2 = Me2 !== void 0 && Me2, Pe2 = t2.inputAttributes, Ne2 = Pe2 === void 0 ? {} : Pe2, Te2 = t2.listAutoWidth, Ie2 = Te2 === void 0 || Te2, Re2 = t2.itemHeight, De2 = Re2 === void 0 ? 40 : Re2, ze2 = t2.Icon, Le2 = ze2 === void 0 ? void 0 : ze2, Be2 = t2.iconProps, qe2 = Be2 === void 0 ? {} : Be2, Fe2 = t2.showChevron, Ve2 = Fe2 !== void 0 && Fe2, He2 = t2.showIndicator, We2 = He2 !== void 0 && He2, Je2 = t2.containerClasses, Ue2 = Je2 === void 0 ? "" : Je2, Ke2 = t2.indicatorSvg, Ge2 = Ke2 === void 0 ? void 0 : Ke2, Qe2 = t2.listOffset, Ye2 = Qe2 === void 0 ? 5 : Qe2, Ze2 = t2.ClearIcon, Xe2 = Ze2 === void 0 ? QU : Ze2, et2 = t2.Item, tt2 = et2 === void 0 ? hU : et2, nt2 = t2.List, rt2 = nt2 === void 0 ? AU : nt2, it2 = t2.Selection, ot2 = it2 === void 0 ? NU : it2, at2 = t2.MultiSelection, st2 = at2 === void 0 ? BU : at2, ut2 = t2.VirtualList, ct2 = ut2 === void 0 ? KU : ut2;
  function lt2(e23) {
    if (!(e23.loadOptions && e23.filterText.length > 0)) {
      if (!e23.items)
        return [];
      e23.items && e23.items.length > 0 && Li(e23.items[0]) !== "object" && (e23.items = dK(e23.items));
      var t3 = e23.items.filter(function(t4) {
        var n3 = L2(Y2(t4, e23.filterText), e23.filterText, t4);
        return n3 && e23.isMulti && e23.value && Array.isArray(e23.value) && (n3 = !e23.value.some(function(n4) {
          return n4[e23.optionIdentifier] === t4[e23.optionIdentifier];
        })), n3;
      });
      return e23.groupBy && (t3 = function(e24) {
        var t4 = [], n3 = {};
        e24.forEach(function(e25) {
          var r4 = q2(e25);
          t4.includes(r4) || (t4.push(r4), n3[r4] = [], r4 && n3[r4].push(Object.assign(ce2(r4, e25), { id: r4, isGroupHeader: true, isSelectable: W2 }))), n3[r4].push(Object.assign({ isGroupItem: !!r4 }, e25));
        });
        var r3 = [];
        return V2(t4).forEach(function(e25) {
          r3.push.apply(r3, Ni(n3[e25]));
        }), r3;
      }(t3)), e23.isCreatable && (t3 = ft2(t3, e23.filterText)), t3;
    }
  }
  function ft2(e23, t3) {
    if (t3.length === 0)
      return e23;
    var n3 = fe2(t3);
    return e23[0] && t3 === e23[0][G2] ? e23 : (n3.isCreator = true, [].concat(Ni(e23), [n3]));
  }
  var ht2, dt2, vt2, pt2, mt2, gt2, yt2, bt2 = t2.selectedValue, kt2 = bt2 === void 0 ? null : bt2, wt2 = function(e23, t3, n3) {
    var r3;
    return function() {
      var i3 = this, o3 = arguments, a3 = function() {
        r3 = null, n3 || e23.apply(i3, o3);
      }, s3 = n3 && !r3;
      clearTimeout(r3), r3 = setTimeout(a3, t3), s3 && e23.apply(i3, o3);
    };
  }(yi(mi().mark(function e23() {
    var t3;
    return mi().wrap(function(e24) {
      for (; ; )
        switch (e24.prev = e24.next) {
          case 0:
            return n2(4, be2 = true), e24.next = 3, te2(E2).catch(function(e25) {
              console.warn("svelte-select loadOptions error :>> ", e25), f2("error", { type: "loadOptions", details: e25 });
            });
          case 3:
            (t3 = e24.sent) && !t3.cancelled && (t3 ? (t3 && t3.length > 0 && Li(t3[0]) !== "object" && (t3 = dK(t3)), n2(81, r2 = Ni(t3)), f2("loaded", { items: r2 })) : n2(81, r2 = []), C2 && n2(81, r2 = ft2(r2, E2)), n2(4, be2 = false), n2(1, $2 = true), n2(5, je2 = true));
          case 5:
          case "end":
            return e24.stop();
        }
    }, e23);
  })), $e2);
  function xt2() {
    var e23 = true;
    if (A2) {
      var t3 = [], r3 = [];
      A2.forEach(function(n3) {
        t3.includes(n3[X2]) ? e23 = false : (t3.push(n3[X2]), r3.push(n3));
      }), e23 || n2(2, A2 = r3);
    }
    return e23;
  }
  function jt2(e23) {
    var t3 = e23 ? e23[X2] : A2[X2];
    return D2.find(function(e24) {
      return e24[X2] === t3;
    });
  }
  function St2(e23) {
    var t3 = e23.detail, r3 = A2[t3 ? t3.i : A2.length - 1];
    A2.length === 1 ? n2(2, A2 = void 0) : n2(2, A2 = A2.filter(function(e24) {
      return e24 !== r3;
    })), f2("clear", r3);
  }
  function Ct2() {
    n2(1, $2 = true), g2 && g2.focus();
  }
  Jo(yi(mi().mark(function e23() {
    return mi().wrap(function(e24) {
      for (; ; )
        switch (e24.prev = e24.next) {
          case 0:
            n2(77, dt2 = A2), n2(78, vt2 = E2), n2(79, pt2 = $2), n2(80, mt2 = b2);
          case 4:
          case "end":
            return e24.stop();
        }
    }, e23);
  }))), Uo(function() {
    $2 && g2 && g2.focus();
  });
  var _t2 = t2.ariaValues, $t2 = _t2 === void 0 ? function(e23) {
    return "Option ".concat(e23, ", selected.");
  } : _t2, Ot2 = t2.ariaListOpen, At2 = Ot2 === void 0 ? function(e23, t3) {
    return "You are currently focused on option ".concat(e23, ". There are ").concat(t3, " results available.");
  } : Ot2, Mt2 = t2.ariaFocused, Et2 = Mt2 === void 0 ? function() {
    return "Select is focused, type to refine list, press down to open the menu.";
  } : Mt2;
  return e22.$$set = function(e23) {
    "id" in e23 && n2(46, d2 = e23.id), "container" in e23 && n2(0, p2 = e23.container), "input" in e23 && n2(6, g2 = e23.input), "isMulti" in e23 && n2(7, b2 = e23.isMulti), "multiFullItemClearable" in e23 && n2(8, w2 = e23.multiFullItemClearable), "isDisabled" in e23 && n2(9, j2 = e23.isDisabled), "isCreatable" in e23 && n2(47, C2 = e23.isCreatable), "isFocused" in e23 && n2(1, $2 = e23.isFocused), "value" in e23 && n2(2, A2 = e23.value), "filterText" in e23 && n2(3, E2 = e23.filterText), "placeholder" in e23 && n2(48, N2 = e23.placeholder), "placeholderAlwaysShow" in e23 && n2(49, I2 = e23.placeholderAlwaysShow), "items" in e23 && n2(50, D2 = e23.items), "itemFilter" in e23 && n2(51, L2 = e23.itemFilter), "groupBy" in e23 && n2(52, q2 = e23.groupBy), "groupFilter" in e23 && n2(53, V2 = e23.groupFilter), "isGroupHeaderSelectable" in e23 && n2(54, W2 = e23.isGroupHeaderSelectable), "getGroupHeaderLabel" in e23 && n2(55, U2 = e23.getGroupHeaderLabel), "labelIdentifier" in e23 && n2(56, G2 = e23.labelIdentifier), "getOptionLabel" in e23 && n2(57, Y2 = e23.getOptionLabel), "optionIdentifier" in e23 && n2(58, X2 = e23.optionIdentifier), "loadOptions" in e23 && n2(59, te2 = e23.loadOptions), "hasError" in e23 && n2(10, re2 = e23.hasError), "containerStyles" in e23 && n2(11, oe2 = e23.containerStyles), "getSelectionLabel" in e23 && n2(12, se2 = e23.getSelectionLabel), "createGroupHeaderItem" in e23 && n2(60, ce2 = e23.createGroupHeaderItem), "createItem" in e23 && n2(61, fe2 = e23.createItem), "isSearchable" in e23 && n2(13, de2 = e23.isSearchable), "inputStyles" in e23 && n2(14, pe2 = e23.inputStyles), "isClearable" in e23 && n2(15, ge2 = e23.isClearable), "isWaiting" in e23 && n2(4, be2 = e23.isWaiting), "listPlacement" in e23 && n2(63, we2 = e23.listPlacement), "listOpen" in e23 && n2(5, je2 = e23.listOpen), "isVirtualList" in e23 && n2(64, Ce2 = e23.isVirtualList), "loadOptionsInterval" in e23 && n2(65, $e2 = e23.loadOptionsInterval), "noOptionsMessage" in e23 && n2(66, Ae2 = e23.noOptionsMessage), "hideEmptyState" in e23 && n2(67, Ee2 = e23.hideEmptyState), "inputAttributes" in e23 && n2(16, Ne2 = e23.inputAttributes), "listAutoWidth" in e23 && n2(68, Ie2 = e23.listAutoWidth), "itemHeight" in e23 && n2(69, De2 = e23.itemHeight), "Icon" in e23 && n2(17, Le2 = e23.Icon), "iconProps" in e23 && n2(18, qe2 = e23.iconProps), "showChevron" in e23 && n2(19, Ve2 = e23.showChevron), "showIndicator" in e23 && n2(20, We2 = e23.showIndicator), "containerClasses" in e23 && n2(21, Ue2 = e23.containerClasses), "indicatorSvg" in e23 && n2(22, Ge2 = e23.indicatorSvg), "listOffset" in e23 && n2(70, Ye2 = e23.listOffset), "ClearIcon" in e23 && n2(23, Xe2 = e23.ClearIcon), "Item" in e23 && n2(71, tt2 = e23.Item), "List" in e23 && n2(24, rt2 = e23.List), "Selection" in e23 && n2(25, ot2 = e23.Selection), "MultiSelection" in e23 && n2(26, st2 = e23.MultiSelection), "VirtualList" in e23 && n2(72, ct2 = e23.VirtualList), "selectedValue" in e23 && n2(73, kt2 = e23.selectedValue), "ariaValues" in e23 && n2(74, $t2 = e23.ariaValues), "ariaListOpen" in e23 && n2(75, At2 = e23.ariaListOpen), "ariaFocused" in e23 && n2(76, Et2 = e23.ariaFocused);
  }, e22.$$.update = function() {
    var t3, h3;
    140 & e22.$$.dirty[0] | 405340160 & e22.$$.dirty[1] && n2(81, r2 = lt2({ loadOptions: te2, filterText: E2, items: D2, value: A2, isMulti: b2, optionIdentifier: X2, groupBy: q2, isCreatable: C2 })), 2048 & e22.$$.dirty[2] && kt2 && console.warn("selectedValue is no longer used. Please use value instead."), 524288 & e22.$$.dirty[1] && function(e23) {
      e23 && e23.length !== 0 && !e23.some(function(e24) {
        return Li(e24) !== "object";
      }) && A2 && (b2 ? !A2.some(function(e24) {
        return !e24 || !e24[X2];
      }) : A2[X2]) && (Array.isArray(A2) ? n2(2, A2 = A2.map(function(e24) {
        return jt2(e24) || e24;
      })) : n2(2, A2 = jt2() || A2));
    }(D2), 4 & e22.$$.dirty[0] && A2 && (typeof A2 == "string" ? n2(2, (Pi(t3 = {}, X2, A2), Pi(t3, "label", A2), A2 = t3)) : b2 && Array.isArray(A2) && A2.length > 0 && n2(2, A2 = A2.map(function(e23) {
      return typeof e23 == "string" ? { value: e23, label: e23 } : e23;
    }))), 73728 & e22.$$.dirty[0] && (!Ne2 && de2 || (n2(31, yt2 = Object.assign({ autocapitalize: "none", autocomplete: "off", autocorrect: "off", spellcheck: false, tabindex: 0, type: "text", "aria-autocomplete": "list" }, Ne2)), d2 && n2(31, yt2.id = d2, yt2), de2 || n2(31, yt2.readonly = true, yt2))), 128 & e22.$$.dirty[0] | 262144 & e22.$$.dirty[2] && (b2 && A2 && (Array.isArray(A2) ? n2(2, A2 = Ni(A2)) : n2(2, A2 = [A2])), mt2 && !b2 && A2 && n2(2, A2 = null)), 132 & e22.$$.dirty[0] && b2 && A2 && A2.length > 1 && xt2(), 4 & e22.$$.dirty[0] && A2 && (b2 ? JSON.stringify(A2) !== JSON.stringify(dt2) && xt2() && f2("select", A2) : dt2 && JSON.stringify(A2[X2]) === JSON.stringify(dt2[X2]) || f2("select", A2)), 132 & e22.$$.dirty[0] | 32768 & e22.$$.dirty[2] && !A2 && b2 && dt2 && f2("select", A2), 2 & e22.$$.dirty[0] | 131072 & e22.$$.dirty[2] && $2 !== pt2 && ($2 || je2 ? Ct2() : g2 && g2.blur()), 8 & e22.$$.dirty[0] | 65536 & e22.$$.dirty[2] && E2 !== vt2 && E2.length !== 0 && (n2(1, $2 = true), n2(5, je2 = true), te2 ? wt2() : (n2(5, je2 = true), b2 && n2(30, ht2 = void 0))), 12 & e22.$$.dirty[0] && n2(29, i2 = A2 && E2.length === 0), 536904208 & e22.$$.dirty[0] && n2(37, o2 = i2 && ge2 && !j2 && !be2), 132 & e22.$$.dirty[0] | 393216 & e22.$$.dirty[1] && n2(36, a2 = I2 && b2 ? N2 : A2 ? "" : N2), 132 & e22.$$.dirty[0] && n2(35, s2 = b2 && A2 && A2.length > 0), 141 & e22.$$.dirty[0] | 218103808 & e22.$$.dirty[1] | 526326 & e22.$$.dirty[2] && n2(34, u2 = { Item: tt2, filterText: E2, optionIdentifier: X2, noOptionsMessage: Ae2, hideEmptyState: Ee2, isVirtualList: Ce2, VirtualList: ct2, value: A2, isMulti: b2, getGroupHeaderLabel: U2, items: r2, itemHeight: De2, getOptionLabel: Y2, listPlacement: we2, parent: p2, listAutoWidth: Ie2, listOffset: Ye2 }), 132 & e22.$$.dirty[0] && n2(33, c2 = A2 ? (h3 = void 0, h3 = b2 && A2.length > 0 ? A2.map(function(e23) {
      return se2(e23);
    }).join(", ") : se2(A2), $t2(h3)) : ""), 268435490 & e22.$$.dirty[0] | 524288 & e22.$$.dirty[2] && n2(32, l2 = function() {
      if (!$2 || !r2 || r2.length === 0)
        return "";
      var e23 = r2[gt2];
      if (je2 && e23) {
        var t4 = se2(e23), n3 = r2 ? r2.length : 0;
        return At2(t4, n3);
      }
      return Et2();
    }());
  }, [p2, $2, A2, E2, be2, je2, g2, b2, w2, j2, re2, oe2, se2, de2, pe2, ge2, Ne2, Le2, qe2, Ve2, We2, Ue2, Ge2, Xe2, rt2, ot2, st2, function() {
    n2(2, A2 = void 0), n2(5, je2 = false), f2("clear", A2), Ct2();
  }, gt2, i2, ht2, yt2, l2, c2, u2, s2, a2, o2, St2, function(e23) {
    if ($2)
      switch (e23.key) {
        case "ArrowDown":
        case "ArrowUp":
          e23.preventDefault(), n2(5, je2 = true), n2(30, ht2 = void 0);
          break;
        case "Tab":
          je2 || n2(1, $2 = false);
          break;
        case "Backspace":
          if (!b2 || E2.length > 0)
            return;
          if (b2 && A2 && A2.length > 0) {
            if (St2(ht2 !== void 0 ? ht2 : A2.length - 1), ht2 === 0 || ht2 === void 0)
              break;
            n2(30, ht2 = A2.length > ht2 ? ht2 - 1 : void 0);
          }
          break;
        case "ArrowLeft":
          if (!b2 || E2.length > 0)
            return;
          ht2 === void 0 ? n2(30, ht2 = A2.length - 1) : A2.length > ht2 && ht2 !== 0 && n2(30, ht2 -= 1);
          break;
        case "ArrowRight":
          if (!b2 || E2.length > 0 || ht2 === void 0)
            return;
          ht2 === A2.length - 1 ? n2(30, ht2 = void 0) : ht2 < A2.length - 1 && n2(30, ht2 += 1);
      }
  }, Ct2, function(e23) {
    if (p2) {
      var t3 = e23.path && e23.path.length > 0 ? e23.path[0] : e23.target;
      p2.contains(t3) || p2.contains(e23.relatedTarget) || (n2(1, $2 = false), n2(5, je2 = false), n2(30, ht2 = void 0), g2 && g2.blur());
    }
  }, function() {
    j2 || (n2(1, $2 = true), n2(5, je2 = !je2));
  }, function(e23) {
    var t3 = e23.detail;
    if (t3) {
      n2(3, E2 = "");
      var r3 = Object.assign({}, t3);
      r3.isGroupHeader && !r3.isSelectable || (n2(2, A2 = b2 ? A2 ? A2.concat([r3]) : [r3] : r3), n2(2, A2), setTimeout(function() {
        n2(5, je2 = false), n2(30, ht2 = void 0);
      }));
    }
  }, function(e23) {
    var t3 = e23.detail;
    b2 ? (n2(2, A2 = A2 || []), n2(2, A2 = [].concat(Ni(A2), [fe2(t3)]))) : n2(2, A2 = fe2(t3)), f2("itemCreated", t3), n2(3, E2 = ""), n2(5, je2 = false), n2(30, ht2 = void 0);
  }, function() {
    n2(3, E2 = ""), n2(5, je2 = false);
  }, d2, C2, N2, I2, D2, L2, q2, V2, W2, U2, G2, Y2, X2, te2, ce2, fe2, function() {
    return r2;
  }, we2, Ce2, $e2, Ae2, Ee2, Ie2, De2, Ye2, tt2, ct2, kt2, $t2, At2, Et2, dt2, vt2, pt2, mt2, r2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(6, g2 = e23);
    });
  }, function() {
    E2 = this.value, n2(3, E2);
  }, function(e23) {
    n2(28, gt2 = e23);
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(0, p2 = e23);
    });
  }];
}
var pK = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, vK, hK, Ui, { id: 46, container: 0, input: 6, isMulti: 7, multiFullItemClearable: 8, isDisabled: 9, isCreatable: 47, isFocused: 1, value: 2, filterText: 3, placeholder: 48, placeholderAlwaysShow: 49, items: 50, itemFilter: 51, groupBy: 52, groupFilter: 53, isGroupHeaderSelectable: 54, getGroupHeaderLabel: 55, labelIdentifier: 56, getOptionLabel: 57, optionIdentifier: 58, loadOptions: 59, hasError: 10, containerStyles: 11, getSelectionLabel: 12, createGroupHeaderItem: 60, createItem: 61, getFilteredItems: 62, isSearchable: 13, inputStyles: 14, isClearable: 15, isWaiting: 4, listPlacement: 63, listOpen: 5, isVirtualList: 64, loadOptionsInterval: 65, noOptionsMessage: 66, hideEmptyState: 67, inputAttributes: 16, listAutoWidth: 68, itemHeight: 69, Icon: 17, iconProps: 18, showChevron: 19, showIndicator: 20, containerClasses: 21, indicatorSvg: 22, listOffset: 70, ClearIcon: 23, Item: 71, List: 24, Selection: 25, MultiSelection: 26, VirtualList: 72, selectedValue: 73, handleClear: 27, ariaValues: 74, ariaListOpen: 75, ariaFocused: 76 }, YU, [-1, -1, -1, -1]), r2;
  }
  return zi(n2, [{ key: "getFilteredItems", get: function() {
    return this.$$.ctx[62];
  } }, { key: "handleClear", get: function() {
    return this.$$.ctx[27];
  } }]), n2;
}();
function mK(e22) {
  co(e22, "svelte-13taczd", "table.jse-transform-wizard.svelte-13taczd.svelte-13taczd{border-collapse:collapse;border-spacing:0;width:100%}table.jse-transform-wizard.svelte-13taczd input.svelte-13taczd{font-family:inherit;font-size:inherit}table.jse-transform-wizard.svelte-13taczd tr th.svelte-13taczd{font-weight:normal;text-align:left;width:60px}table.jse-transform-wizard.svelte-13taczd tr td .jse-horizontal.svelte-13taczd{width:100%;display:flex;flex-direction:row;margin-bottom:calc(0.5 * var(--jse-padding))}table.jse-transform-wizard.svelte-13taczd tr td .jse-horizontal.svelte-13taczd .selectContainer.jse-filter-path{flex:4;margin-right:calc(0.5 * var(--jse-padding))}table.jse-transform-wizard.svelte-13taczd tr td .jse-horizontal.svelte-13taczd .selectContainer.jse-filter-relation{flex:1.5;margin-right:calc(0.5 * var(--jse-padding))}table.jse-transform-wizard.svelte-13taczd tr td .jse-horizontal.svelte-13taczd .selectContainer.jse-sort-path{flex:3;margin-right:calc(0.5 * var(--jse-padding))}table.jse-transform-wizard.svelte-13taczd tr td .jse-horizontal.svelte-13taczd .selectContainer.jse-sort-direction{flex:1}table.jse-transform-wizard.svelte-13taczd tr td .jse-horizontal.svelte-13taczd .selectContainer.jse-projection-paths{flex:1}table.jse-transform-wizard.svelte-13taczd tr td .jse-horizontal.svelte-13taczd .selectContainer input{box-sizing:border-box}table.jse-transform-wizard.svelte-13taczd tr td .jse-horizontal .jse-filter-value.svelte-13taczd{flex:4;padding:4px 8px;border:var(--jse-input-border);border-radius:var(--jse-input-radius);outline:none;background:var(--jse-input-background);color:inherit}table.jse-transform-wizard.svelte-13taczd tr td .jse-horizontal .jse-filter-value.svelte-13taczd:focus{border:var(--jse-input-border-focus)}");
}
function gK(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2, k2, w2, x2, j2, S2, C2, _2, $2, O2, A2, M2, E2, P2, N2, T2, I2;
  function R2(t3) {
    e22[18](t3);
  }
  var D2 = { containerClasses: "jse-filter-path", showIndicator: true, items: e22[6] };
  function z2(t3) {
    e22[19](t3);
  }
  e22[0] !== void 0 && (D2.value = e22[0]), s2 = new pK({ props: D2 }), Xo.push(function() {
    return Oa(s2, "value", R2);
  });
  var L2 = { containerClasses: "jse-filter-relation", showIndicator: true, items: e22[8] };
  function B2(t3) {
    e22[21](t3);
  }
  e22[1] !== void 0 && (L2.value = e22[1]), l2 = new pK({ props: L2 }), Xo.push(function() {
    return Oa(l2, "value", z2);
  });
  var q2 = { containerClasses: "jse-sort-path", showIndicator: true, items: e22[6] };
  function F2(t3) {
    e22[22](t3);
  }
  e22[3] !== void 0 && (q2.value = e22[3]), k2 = new pK({ props: q2 }), Xo.push(function() {
    return Oa(k2, "value", B2);
  });
  var V2 = { containerClasses: "jse-sort-direction", showIndicator: true, items: e22[9] };
  function H2(t3) {
    e22[23](t3);
  }
  e22[4] !== void 0 && (V2.value = e22[4]), j2 = new pK({ props: V2 }), Xo.push(function() {
    return Oa(j2, "value", F2);
  });
  var W2 = { containerClasses: "jse-projection-paths", isMulti: true, showIndicator: true, items: e22[7] };
  return e22[5] !== void 0 && (W2.value = e22[5]), E2 = new pK({ props: W2 }), Xo.push(function() {
    return Oa(E2, "value", H2);
  }), { c: function() {
    t2 = go("table"), n2 = go("tr"), (r2 = go("th")).textContent = "Filter", i2 = ko(), o2 = go("td"), a2 = go("div"), Aa(s2.$$.fragment), c2 = ko(), Aa(l2.$$.fragment), h2 = ko(), d2 = go("input"), v2 = ko(), p2 = go("tr"), (m2 = go("th")).textContent = "Sort", g2 = ko(), y2 = go("td"), b2 = go("div"), Aa(k2.$$.fragment), x2 = ko(), Aa(j2.$$.fragment), C2 = ko(), _2 = go("tr"), ($2 = go("th")).textContent = "Pick", O2 = ko(), A2 = go("td"), M2 = go("div"), Aa(E2.$$.fragment), So(r2, "class", "svelte-13taczd"), So(d2, "class", "jse-filter-value svelte-13taczd"), So(a2, "class", "jse-horizontal svelte-13taczd"), So(m2, "class", "svelte-13taczd"), So(b2, "class", "jse-horizontal svelte-13taczd"), So($2, "class", "svelte-13taczd"), So(M2, "class", "jse-horizontal svelte-13taczd"), So(t2, "class", "jse-transform-wizard svelte-13taczd");
  }, m: function(u3, f3) {
    vo(u3, t2, f3), uo(t2, n2), uo(n2, r2), uo(n2, i2), uo(n2, o2), uo(o2, a2), Ma(s2, a2, null), uo(a2, c2), Ma(l2, a2, null), uo(a2, h2), uo(a2, d2), Mo(d2, e22[2]), uo(t2, v2), uo(t2, p2), uo(p2, m2), uo(p2, g2), uo(p2, y2), uo(y2, b2), Ma(k2, b2, null), uo(b2, x2), Ma(j2, b2, null), uo(t2, C2), uo(t2, _2), uo(_2, $2), uo(_2, O2), uo(_2, A2), uo(A2, M2), Ma(E2, M2, null), N2 = true, T2 || (I2 = xo(d2, "input", e22[20]), T2 = true);
  }, p: function(e23, t3) {
    var n3 = {};
    64 & t3[0] && (n3.items = e23[6]), !u2 && 1 & t3[0] && (u2 = true, n3.value = e23[0], sa(function() {
      return u2 = false;
    })), s2.$set(n3);
    var r3 = {};
    !f2 && 2 & t3[0] && (f2 = true, r3.value = e23[1], sa(function() {
      return f2 = false;
    })), l2.$set(r3), 4 & t3[0] && d2.value !== e23[2] && Mo(d2, e23[2]);
    var i3 = {};
    64 & t3[0] && (i3.items = e23[6]), !w2 && 8 & t3[0] && (w2 = true, i3.value = e23[3], sa(function() {
      return w2 = false;
    })), k2.$set(i3);
    var o3 = {};
    !S2 && 16 & t3[0] && (S2 = true, o3.value = e23[4], sa(function() {
      return S2 = false;
    })), j2.$set(o3);
    var a3 = {};
    128 & t3[0] && (a3.items = e23[7]), !P2 && 32 & t3[0] && (P2 = true, a3.value = e23[5], sa(function() {
      return P2 = false;
    })), E2.$set(a3);
  }, i: function(e23) {
    N2 || (ya(s2.$$.fragment, e23), ya(l2.$$.fragment, e23), ya(k2.$$.fragment, e23), ya(j2.$$.fragment, e23), ya(E2.$$.fragment, e23), N2 = true);
  }, o: function(e23) {
    ba(s2.$$.fragment, e23), ba(l2.$$.fragment, e23), ba(k2.$$.fragment, e23), ba(j2.$$.fragment, e23), ba(E2.$$.fragment, e23), N2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(s2), Ea(l2), Ea(k2), Ea(j2), Ea(E2), T2 = false, I2();
  } };
}
function yK(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2 = Ia("jsoneditor:TransformWizard"), m2 = t2.json, g2 = t2.queryOptions, y2 = g2 === void 0 ? {} : g2, b2 = t2.onChange, k2 = ["==", "!=", "<", "<=", ">", ">="].map(function(e23) {
    return { value: e23, label: e23 };
  }), w2 = [{ value: "asc", label: "ascending" }, { value: "desc", label: "descending" }], x2 = ((u2 = y2 == null ? void 0 : y2.filter) === null || u2 === void 0 ? void 0 : u2.path) ? O2(y2.filter.path) : null, j2 = ((c2 = y2 == null ? void 0 : y2.filter) === null || c2 === void 0 ? void 0 : c2.relation) ? k2.find(function(e23) {
    return e23.value === y2.filter.relation;
  }) : null, S2 = ((l2 = y2 == null ? void 0 : y2.filter) === null || l2 === void 0 ? void 0 : l2.value) || "", C2 = ((f2 = y2 == null ? void 0 : y2.sort) === null || f2 === void 0 ? void 0 : f2.path) ? O2(y2.sort.path) : null, _2 = ((h2 = y2 == null ? void 0 : y2.sort) === null || h2 === void 0 ? void 0 : h2.direction) ? w2.find(function(e23) {
    return e23.value === y2.sort.direction;
  }) : null, $2 = ((d2 = y2 == null ? void 0 : y2.projection) === null || d2 === void 0 ? void 0 : d2.paths) ? y2.projection.paths.map(O2) : null;
  function O2(e23) {
    return { value: e23, label: km(e23) ? "(whole item)" : uS(e23) };
  }
  return e22.$$set = function(e23) {
    "json" in e23 && n2(11, m2 = e23.json), "queryOptions" in e23 && n2(10, y2 = e23.queryOptions), "onChange" in e23 && n2(12, b2 = e23.onChange);
  }, e22.$$.update = function() {
    2048 & e22.$$.dirty[0] && n2(17, r2 = Array.isArray(m2)), 133120 & e22.$$.dirty[0] && n2(16, i2 = r2 ? Lw(m2) : []), 133120 & e22.$$.dirty[0] && n2(15, o2 = r2 ? Lw(m2, true) : []), 65536 & e22.$$.dirty[0] && n2(6, a2 = i2.map(O2)), 32768 & e22.$$.dirty[0] && n2(7, s2 = o2 ? o2.map(O2) : []), 17472 & e22.$$.dirty[0] && (n2(14, v2 = y2 == null ? void 0 : y2.filter) === null || v2 === void 0 ? void 0 : v2.path) && a2.find(function(e23) {
      var t3;
      return wm(e23.value, (t3 = y2 == null ? void 0 : y2.filter) === null || t3 === void 0 ? void 0 : t3.path);
    }), 1 & e22.$$.dirty[0] && function(e23) {
      var t3;
      wm((t3 = y2 == null ? void 0 : y2.filter) === null || t3 === void 0 ? void 0 : t3.path, e23) || (p2("changeFilterPath", e23), n2(10, y2 = cs.exports.setIn(y2, ["filter", "path"], e23, true)), b2(y2));
    }((x2 == null ? void 0 : x2.value) || null), 2 & e22.$$.dirty[0] && function(e23) {
      var t3;
      wm((t3 = y2 == null ? void 0 : y2.filter) === null || t3 === void 0 ? void 0 : t3.relation, e23) || (p2("changeFilterRelation", e23), n2(10, y2 = cs.exports.setIn(y2, ["filter", "relation"], e23, true)), b2(y2));
    }((j2 == null ? void 0 : j2.value) || null), 4 & e22.$$.dirty[0] && function(e23) {
      var t3;
      wm((t3 = y2 == null ? void 0 : y2.filter) === null || t3 === void 0 ? void 0 : t3.value, e23) || (p2("changeFilterValue", e23), n2(10, y2 = cs.exports.setIn(y2, ["filter", "value"], e23, true)), b2(y2));
    }(S2 || null), 8 & e22.$$.dirty[0] && function(e23) {
      var t3;
      wm((t3 = y2 == null ? void 0 : y2.sort) === null || t3 === void 0 ? void 0 : t3.path, e23) || (p2("changeSortPath", e23), n2(10, y2 = cs.exports.setIn(y2, ["sort", "path"], e23, true)), b2(y2));
    }((C2 == null ? void 0 : C2.value) || null), 16 & e22.$$.dirty[0] && function(e23) {
      var t3;
      wm((t3 = y2 == null ? void 0 : y2.sort) === null || t3 === void 0 ? void 0 : t3.direction, e23) || (p2("changeSortDirection", e23), n2(10, y2 = cs.exports.setIn(y2, ["sort", "direction"], e23, true)), b2(y2));
    }((_2 == null ? void 0 : _2.value) || null), 32 & e22.$$.dirty[0] && function(e23) {
      var t3;
      wm((t3 = y2 == null ? void 0 : y2.projection) === null || t3 === void 0 ? void 0 : t3.paths, e23) || (p2("changeProjectionPaths", e23), n2(10, y2 = cs.exports.setIn(y2, ["projection", "paths"], e23, true)), b2(y2));
    }($2 ? $2.map(function(e23) {
      return e23.value;
    }) : null);
  }, [x2, j2, S2, C2, _2, $2, a2, s2, k2, w2, y2, m2, b2, u2, v2, o2, i2, r2, function(e23) {
    n2(0, x2 = e23);
  }, function(e23) {
    n2(1, j2 = e23);
  }, function() {
    S2 = this.value, n2(2, S2);
  }, function(e23) {
    n2(3, C2 = e23);
  }, function(e23) {
    n2(4, _2 = e23);
  }, function(e23) {
    n2(5, $2 = e23);
  }];
}
var bK = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, yK, gK, Ki, { json: 11, queryOptions: 10, onChange: 12 }, mK, [-1, -1]), r2;
  }
  return zi(n2);
}();
function kK(e22) {
  co(e22, "svelte-19cxesy", ".jse-select-query-language.svelte-19cxesy.svelte-19cxesy{position:relative;width:32px}.jse-select-query-language.svelte-19cxesy .jse-select-query-language-container.svelte-19cxesy{position:absolute;top:0;right:0;display:flex;flex-direction:column;box-shadow:var(--jse-controls-box-shadow)}.jse-select-query-language.svelte-19cxesy .jse-select-query-language-container .jse-query-language.svelte-19cxesy{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;text-align:left;padding:var(--jse-padding) calc(2 * var(--jse-padding));white-space:nowrap;color:var(--jse-context-menu-color);background:var(--jse-context-menu-background)}.jse-select-query-language.svelte-19cxesy .jse-select-query-language-container .jse-query-language.svelte-19cxesy:hover{background:var(--jse-context-menu-background-highlight)}");
}
function wK(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[5] = t2[n2], r2;
}
function xK(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: xV } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: Bi, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function jK(e22) {
  var t2, n2;
  return t2 = new Xj({ props: { data: jV } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: Bi, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function SK(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2 = e22[5].name + "", h2 = [jK, xK], d2 = [];
  function v2(e23, t3) {
    return e23[5].id === e23[0] ? 0 : 1;
  }
  function p2() {
    return e22[4](e22[5]);
  }
  return n2 = v2(e22), r2 = d2[n2] = h2[n2](e22), { c: function() {
    t2 = go("button"), r2.c(), i2 = ko(), o2 = bo(f2), a2 = ko(), So(t2, "type", "button"), So(t2, "class", "jse-query-language svelte-19cxesy"), So(t2, "title", s2 = "Select ".concat(e22[5].name, " as query language")), To(t2, "selected", e22[5].id === e22[0]);
  }, m: function(e23, r3) {
    vo(e23, t2, r3), d2[n2].m(t2, null), uo(t2, i2), uo(t2, o2), uo(t2, a2), u2 = true, c2 || (l2 = xo(t2, "click", p2), c2 = true);
  }, p: function(a3, c3) {
    var l3 = n2;
    (n2 = v2(e22 = a3)) === l3 ? d2[n2].p(e22, c3) : (ma(), ba(d2[l3], 1, 1, function() {
      d2[l3] = null;
    }), ga(), (r2 = d2[n2]) ? r2.p(e22, c3) : (r2 = d2[n2] = h2[n2](e22)).c(), ya(r2, 1), r2.m(t2, i2)), (!u2 || 2 & c3) && f2 !== (f2 = e22[5].name + "") && Ao(o2, f2), (!u2 || 2 & c3 && s2 !== (s2 = "Select ".concat(e22[5].name, " as query language"))) && So(t2, "title", s2), 3 & c3 && To(t2, "selected", e22[5].id === e22[0]);
  }, i: function(e23) {
    u2 || (ya(r2), u2 = true);
  }, o: function(e23) {
    ba(r2), u2 = false;
  }, d: function(e23) {
    e23 && po(t2), d2[n2].d(), c2 = false, l2();
  } };
}
function CK(e22) {
  for (var t2, n2, r2, i2 = e22[1], o2 = [], a2 = 0; a2 < i2.length; a2 += 1)
    o2[a2] = SK(wK(e22, i2, a2));
  var s2 = function(e23) {
    return ba(o2[e23], 1, 1, function() {
      o2[e23] = null;
    });
  };
  return { c: function() {
    t2 = go("div"), n2 = go("div");
    for (var e23 = 0; e23 < o2.length; e23 += 1)
      o2[e23].c();
    So(n2, "class", "jse-select-query-language-container svelte-19cxesy"), So(t2, "class", "jse-select-query-language svelte-19cxesy");
  }, m: function(e23, i3) {
    vo(e23, t2, i3), uo(t2, n2);
    for (var a3 = 0; a3 < o2.length; a3 += 1)
      o2[a3].m(n2, null);
    r2 = true;
  }, p: function(e23, t3) {
    var r3 = xi(t3, 1)[0];
    if (7 & r3) {
      var a3;
      for (i2 = e23[1], a3 = 0; a3 < i2.length; a3 += 1) {
        var u2 = wK(e23, i2, a3);
        o2[a3] ? (o2[a3].p(u2, r3), ya(o2[a3], 1)) : (o2[a3] = SK(u2), o2[a3].c(), ya(o2[a3], 1), o2[a3].m(n2, null));
      }
      for (ma(), a3 = i2.length; a3 < o2.length; a3 += 1)
        s2(a3);
      ga();
    }
  }, i: function(e23) {
    if (!r2) {
      for (var t3 = 0; t3 < i2.length; t3 += 1)
        ya(o2[t3]);
      r2 = true;
    }
  }, o: function(e23) {
    o2 = o2.filter(Boolean);
    for (var t3 = 0; t3 < o2.length; t3 += 1)
      ba(o2[t3]);
    r2 = false;
  }, d: function(e23) {
    e23 && po(t2), mo(o2, e23);
  } };
}
function _K(e22, t2, n2) {
  var r2 = t2.queryLanguages, i2 = t2.queryLanguageId, o2 = t2.onChangeQueryLanguage;
  function a2(e23) {
    n2(0, i2 = e23), o2(e23);
  }
  return e22.$$set = function(e23) {
    "queryLanguages" in e23 && n2(1, r2 = e23.queryLanguages), "queryLanguageId" in e23 && n2(0, i2 = e23.queryLanguageId), "onChangeQueryLanguage" in e23 && n2(3, o2 = e23.onChangeQueryLanguage);
  }, [i2, r2, a2, o2, function(e23) {
    return a2(e23.id);
  }];
}
var $K = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, _K, CK, Ui, { queryLanguages: 1, queryLanguageId: 0, onChangeQueryLanguage: 3 }, kK), r2;
  }
  return zi(n2);
}();
function OK(e22) {
  co(e22, "svelte-d01h2s", ".jse-header.svelte-d01h2s.svelte-d01h2s{display:flex;background:var(--jse-theme-color);color:var(--jse-menu-color)}.jse-header.svelte-d01h2s .jse-title.svelte-d01h2s{flex:1;padding:5px;vertical-align:middle}.jse-header.svelte-d01h2s button.svelte-d01h2s{border:none;background:transparent;min-width:32px;color:inherit;cursor:pointer}.jse-header.svelte-d01h2s button.svelte-d01h2s:hover{background:rgba(255, 255, 255, 0.1)}");
}
function AK(e22) {
  var t2, n2, r2, i2, o2;
  return n2 = new Xj({ props: { data: mj } }), { c: function() {
    t2 = go("button"), Aa(n2.$$.fragment), So(t2, "type", "button"), So(t2, "class", "jse-config svelte-d01h2s"), So(t2, "title", "Select a query language");
  }, m: function(a2, s2) {
    vo(a2, t2, s2), Ma(n2, t2, null), e22[6](t2), r2 = true, i2 || (o2 = xo(t2, "click", e22[3]), i2 = true);
  }, p: Bi, i: function(e23) {
    r2 || (ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(r3) {
    r3 && po(t2), Ea(n2), e22[6](null), i2 = false, o2();
  } };
}
function MK(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2 = e22[0].length > 1 && AK(e22);
  return a2 = new Xj({ props: { data: Cj } }), { c: function() {
    t2 = go("div"), (n2 = go("div")).textContent = "Transform", r2 = ko(), l2 && l2.c(), i2 = ko(), o2 = go("button"), Aa(a2.$$.fragment), So(n2, "class", "jse-title svelte-d01h2s"), So(o2, "type", "button"), So(o2, "class", "jse-close svelte-d01h2s"), So(t2, "class", "jse-header svelte-d01h2s");
  }, m: function(f2, h2) {
    vo(f2, t2, h2), uo(t2, n2), uo(t2, r2), l2 && l2.m(t2, null), uo(t2, i2), uo(t2, o2), Ma(a2, o2, null), s2 = true, u2 || (c2 = xo(o2, "click", e22[2]), u2 = true);
  }, p: function(e23, n3) {
    var r3 = xi(n3, 1)[0];
    e23[0].length > 1 ? l2 ? (l2.p(e23, r3), 1 & r3 && ya(l2, 1)) : ((l2 = AK(e23)).c(), ya(l2, 1), l2.m(t2, i2)) : l2 && (ma(), ba(l2, 1, 1, function() {
      l2 = null;
    }), ga());
  }, i: function(e23) {
    s2 || (ya(l2), ya(a2.$$.fragment, e23), s2 = true);
  }, o: function(e23) {
    ba(l2), ba(a2.$$.fragment, e23), s2 = false;
  }, d: function(e23) {
    e23 && po(t2), l2 && l2.d(), Ea(a2), u2 = false, c2();
  } };
}
function EK(e22, t2, n2) {
  var r2, i2, o2 = t2.queryLanguages, a2 = t2.queryLanguageId, s2 = t2.onChangeQueryLanguage, u2 = Yo("simple-modal").close, c2 = Yo("absolute-popup"), l2 = c2.openAbsolutePopup, f2 = c2.closeAbsolutePopup;
  return e22.$$set = function(e23) {
    "queryLanguages" in e23 && n2(0, o2 = e23.queryLanguages), "queryLanguageId" in e23 && n2(4, a2 = e23.queryLanguageId), "onChangeQueryLanguage" in e23 && n2(5, s2 = e23.onChangeQueryLanguage);
  }, [o2, r2, u2, function() {
    i2 = l2($K, { queryLanguages: o2, queryLanguageId: a2, onChangeQueryLanguage: function(e23) {
      f2(i2), s2(e23);
    } }, { position: "bottom", offsetTop: -2, offsetLeft: 0, anchor: r2, closeOnOuterClick: true });
  }, a2, s2, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(1, r2 = e23);
    });
  }];
}
var PK = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, EK, MK, Ki, { queryLanguages: 0, queryLanguageId: 4, onChangeQueryLanguage: 5 }, OK), r2;
  }
  return zi(n2);
}();
function NK(e22) {
  co(e22, "svelte-15uz9w0", ".jse-modal.svelte-15uz9w0.svelte-15uz9w0{--height:36px;--multiItemHeight:28px;--multiItemMargin:2px;--multiItemPadding:2px 8px;--multiClearTop:5px;--multiItemBorderRadius:6px;--clearSelectTop:2px;--clearSelectBottom:2px;--indicatorTop:8px;flex:1;display:flex;flex-direction:column;font-family:var(--jse-font-family);font-size:var(--jse-font-size);line-height:normal;background:var(--jse-modal-background);color:var(--jse-text-color)}.jse-modal.svelte-15uz9w0 .jse-contents.svelte-15uz9w0{padding:20px;overflow:auto}.jse-modal.svelte-15uz9w0 .jse-contents .jse-actions.svelte-15uz9w0{display:flex;flex-direction:row;justify-content:flex-end;padding-top:var(--jse-padding)}.jse-modal.svelte-15uz9w0 .jse-contents .jse-actions button.svelte-15uz9w0{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;background:var(--jse-button-primary-background);color:var(--jse-button-primary-color);padding:var(--jse-padding) calc(2 * var(--jse-padding));border-radius:3px}.jse-modal.svelte-15uz9w0 .jse-contents .jse-actions button.svelte-15uz9w0:hover{background:var(--jse-button-primary-background-highlight)}.jse-modal.svelte-15uz9w0 .jse-contents .jse-actions button.svelte-15uz9w0:disabled{background:var(--jse-button-primary-background-disabled)}.bg.jse-modal-bg{width:100%;height:100%;top:0;left:0;background:var(--jse-modal-overlay-background)}.bg.jse-modal-bg .jse-modal-window-wrap{margin:0}.bg.jse-modal-bg .jse-modal-window{max-width:90%;margin:4rem auto 2rem auto;border-radius:2px}.bg.jse-modal-bg .jse-modal-window.jse-modal-window-sort{width:400px}.bg.jse-modal-bg .jse-modal-window.jse-modal-window-transform{width:1200px;height:1200px;max-height:80%;display:flex}.bg.jse-modal-bg .jse-modal-content{flex:1;display:flex;max-height:calc(100vh - 6rem);padding:0}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents.svelte-15uz9w0{flex:1;display:flex;flex-direction:column;color:inherit;min-height:0;padding:0}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents.svelte-15uz9w0{flex:1;display:flex;gap:calc(2 * var(--jse-padding));min-height:0;box-sizing:border-box;padding:0 calc(2 * var(--jse-padding)) var(--jse-padding)}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-query-contents.svelte-15uz9w0{flex:1;display:flex;flex-direction:column}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-query-contents .jse-description.svelte-15uz9w0 p{margin:var(--jse-padding) 0}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-query-contents .jse-description.svelte-15uz9w0 p:first-child{margin-top:0}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-query-contents .jse-description.svelte-15uz9w0 p:last-child{margin-bottom:0}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-query-contents .jse-description.svelte-15uz9w0 code{background:var(--jse-modal-code-background);font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono)}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-query-contents textarea.jse-query.svelte-15uz9w0{flex:1;outline:none;resize:vertical}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-data-contents.svelte-15uz9w0{flex:1;display:flex;flex-direction:column;gap:calc(2 * var(--jse-padding))}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-data-contents .jse-original-data.svelte-15uz9w0{flex:1;display:flex;flex-direction:column;min-height:0;box-sizing:border-box}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-data-contents .jse-original-data.jse-hide.svelte-15uz9w0{flex:none}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-data-contents .jse-preview-data.svelte-15uz9w0{flex:1;display:flex;flex-direction:column;min-height:0;box-sizing:border-box}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-data-contents.jse-hide-original-data.svelte-15uz9w0{flex-direction:column;gap:0;margin-bottom:0}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-actions.svelte-15uz9w0{padding:var(--jse-padding) calc(2 * var(--jse-padding)) calc(2 * var(--jse-padding))}@media screen and (max-width: 1200px){.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents.svelte-15uz9w0{flex-direction:column;overflow:auto}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-query-contents textarea.jse-query.svelte-15uz9w0{min-height:150px;flex:none}.jse-modal.jse-transform.svelte-15uz9w0 .jse-contents .jse-main-contents .jse-data-contents.svelte-15uz9w0 .jse-tree-mode{height:300px;flex:none}}.jse-modal.jse-transform.svelte-15uz9w0 .jse-label.svelte-15uz9w0{font-weight:bold;display:block;box-sizing:border-box}.jse-modal.jse-transform.svelte-15uz9w0 .jse-label .jse-label-inner.svelte-15uz9w0{margin-top:calc(2 * var(--jse-padding));margin-bottom:calc(0.5 * var(--jse-padding));box-sizing:border-box}.jse-modal.jse-transform.svelte-15uz9w0 .jse-label .jse-label-inner button.svelte-15uz9w0{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;font-weight:bold;padding:0}.jse-modal.jse-transform.svelte-15uz9w0 .jse-tree-mode{flex:1;background:var(--jse-input-background-readonly);box-shadow:none;box-sizing:border-box;--jse-main-border:var(--jse-input-border)}.jse-modal.jse-transform.svelte-15uz9w0 input.svelte-15uz9w0,.jse-modal.jse-transform.svelte-15uz9w0 textarea.svelte-15uz9w0{border:var(--jse-input-border);outline:none;box-sizing:border-box;padding:calc(0.5 * var(--jse-padding));font-family:var(--jse-font-family-mono);font-size:var(--jse-font-size-mono);color:inherit;background:var(--jse-input-background)}.jse-modal.jse-transform.svelte-15uz9w0 input.svelte-15uz9w0:focus,.jse-modal.jse-transform.svelte-15uz9w0 textarea.svelte-15uz9w0:focus{border:var(--jse-input-border-focus)}.jse-modal.jse-transform.svelte-15uz9w0 input.svelte-15uz9w0:read-only,.jse-modal.jse-transform.svelte-15uz9w0 textarea.svelte-15uz9w0:read-only{background:var(--jse-input-background-readonly)}.jse-modal.jse-transform.svelte-15uz9w0 .jse-preview.jse-error.svelte-15uz9w0{flex:1;background:var(--jse-input-background-readonly);border:var(--jse-input-border);color:var(--jse-error-color);padding:calc(0.5 * var(--jse-padding))}.jse-modal.jse-transform.svelte-15uz9w0 a{color:var(--jse-a-color)}.jse-modal.jse-transform.svelte-15uz9w0 a:hover{color:var(--jse-a-color-highlight)}");
}
function TK(e22) {
  var t2, n2, r2, i2, o2, a2 = [RK, IK], s2 = [];
  function u2(e23, n3) {
    return 512 & n3[0] && (t2 = null), t2 == null && (t2 = !!Array.isArray(e23[9])), t2 ? 0 : 1;
  }
  return n2 = u2(e22, [-1, -1]), r2 = s2[n2] = a2[n2](e22), { c: function() {
    r2.c(), i2 = wo();
  }, m: function(e23, t3) {
    s2[n2].m(e23, t3), vo(e23, i2, t3), o2 = true;
  }, p: function(e23, t3) {
    var o3 = n2;
    (n2 = u2(e23, t3)) === o3 ? s2[n2].p(e23, t3) : (ma(), ba(s2[o3], 1, 1, function() {
      s2[o3] = null;
    }), ga(), (r2 = s2[n2]) ? r2.p(e23, t3) : (r2 = s2[n2] = a2[n2](e23)).c(), ya(r2, 1), r2.m(i2.parentNode, i2));
  }, i: function(e23) {
    o2 || (ya(r2), o2 = true);
  }, o: function(e23) {
    ba(r2), o2 = false;
  }, d: function(e23) {
    s2[n2].d(e23), e23 && po(i2);
  } };
}
function IK(e22) {
  var t2;
  return { c: function() {
    t2 = bo("(Only available for arrays, not for objects)");
  }, m: function(e23, n2) {
    vo(e23, t2, n2);
  }, p: Bi, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function RK(e22) {
  var t2, n2;
  return t2 = new bK({ props: { queryOptions: e22[7], json: e22[9], onChange: e22[16] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    128 & n3[0] && (r2.queryOptions = e23[7]), 512 & n3[0] && (r2.json = e23[9]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function DK(e22) {
  var t2, n2;
  return t2 = new NJ({ props: { externalContent: e22[14], readOnly: true, mainMenuBar: false, navigationBar: false, escapeControlCharacters: e22[2], escapeUnicodeCharacters: e22[3], onRenderValue: e22[5], onError: console.error, onChange: Vu, onFocus: Vu, onBlur: Vu, onSortModal: Vu, onTransformModal: Vu, onClassName: e22[6] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    16384 & n3[0] && (r2.externalContent = e23[14]), 4 & n3[0] && (r2.escapeControlCharacters = e23[2]), 8 & n3[0] && (r2.escapeUnicodeCharacters = e23[3]), 32 & n3[0] && (r2.onRenderValue = e23[5]), 64 & n3[0] && (r2.onClassName = e23[6]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function zK(e22) {
  var t2, n2, r2 = e22[12].toString() + "";
  return { c: function() {
    t2 = go("div"), n2 = bo(r2), So(t2, "class", "jse-preview jse-error svelte-15uz9w0");
  }, m: function(e23, r3) {
    vo(e23, t2, r3), uo(t2, n2);
  }, p: function(e23, t3) {
    4096 & t3[0] && r2 !== (r2 = e23[12].toString() + "") && Ao(n2, r2);
  }, i: Bi, o: Bi, d: function(e23) {
    e23 && po(t2);
  } };
}
function LK(e22) {
  var t2, n2;
  return t2 = new NJ({ props: { externalContent: e22[13], readOnly: true, mainMenuBar: false, navigationBar: false, escapeControlCharacters: e22[2], escapeUnicodeCharacters: e22[3], onRenderValue: e22[5], onError: console.error, onChange: Vu, onFocus: Vu, onBlur: Vu, onSortModal: Vu, onTransformModal: Vu, onClassName: e22[6] } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    8192 & n3[0] && (r2.externalContent = e23[13]), 4 & n3[0] && (r2.escapeControlCharacters = e23[2]), 8 & n3[0] && (r2.escapeUnicodeCharacters = e23[3]), 32 & n3[0] && (r2.onRenderValue = e23[5]), 64 & n3[0] && (r2.onClassName = e23[6]), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function BK(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2, k2, w2, x2, j2, S2, C2, _2, $2, O2, A2, M2, E2, P2, N2, T2, I2, R2, D2, z2, L2, B2, q2, F2, V2, H2, W2, J2, U2, K2 = e22[15](e22[0]).description + "";
  t2 = new PK({ props: { queryLanguages: e22[4], queryLanguageId: e22[0], onChangeQueryLanguage: e22[21] } }), y2 = new Xj({ props: { data: e22[10] ? ij : oj } });
  var G2 = e22[10] && TK(e22);
  E2 = new Xj({ props: { data: e22[11] ? ij : oj } });
  var Q2 = e22[11] && DK(e22), Y2 = [LK, zK], Z2 = [];
  function X2(e23, t3) {
    return e23[12] ? 1 : 0;
  }
  return z2 = X2(e22), L2 = Z2[z2] = Y2[z2](e22), { c: function() {
    Aa(t2.$$.fragment), n2 = ko(), r2 = go("div"), i2 = go("div"), o2 = go("div"), (a2 = go("div")).innerHTML = '<div class="jse-label-inner svelte-15uz9w0">Language</div>', s2 = ko(), u2 = go("div"), c2 = ko(), (l2 = go("div")).innerHTML = '<div class="jse-label-inner svelte-15uz9w0">Path</div>', f2 = ko(), h2 = go("input"), v2 = ko(), p2 = go("div"), m2 = go("div"), g2 = go("button"), Aa(y2.$$.fragment), b2 = bo("\n                Wizard"), k2 = ko(), G2 && G2.c(), w2 = ko(), (x2 = go("div")).innerHTML = '<div class="jse-label-inner svelte-15uz9w0">Query</div>', j2 = ko(), S2 = go("textarea"), C2 = ko(), _2 = go("div"), $2 = go("div"), O2 = go("div"), A2 = go("div"), M2 = go("button"), Aa(E2.$$.fragment), P2 = bo("\n                  Original"), N2 = ko(), Q2 && Q2.c(), T2 = ko(), I2 = go("div"), (R2 = go("div")).innerHTML = '<div class="jse-label-inner svelte-15uz9w0">Preview</div>', D2 = ko(), L2.c(), B2 = ko(), q2 = go("div"), F2 = go("button"), V2 = bo("Transform"), So(a2, "class", "jse-label svelte-15uz9w0"), So(u2, "class", "jse-description svelte-15uz9w0"), So(l2, "class", "jse-label svelte-15uz9w0"), So(h2, "class", "jse-path svelte-15uz9w0"), So(h2, "type", "text"), h2.readOnly = true, So(h2, "title", "Selected path"), h2.value = d2 = km(e22[1]) ? "(whole document)" : uS(e22[1]), So(g2, "type", "button"), So(g2, "class", "svelte-15uz9w0"), So(m2, "class", "jse-label-inner svelte-15uz9w0"), So(p2, "class", "jse-label svelte-15uz9w0"), So(x2, "class", "jse-label svelte-15uz9w0"), So(S2, "class", "jse-query svelte-15uz9w0"), So(S2, "spellcheck", "false"), S2.value = e22[8], So(o2, "class", "jse-query-contents svelte-15uz9w0"), So(M2, "type", "button"), So(M2, "class", "svelte-15uz9w0"), So(A2, "class", "jse-label-inner svelte-15uz9w0"), So(O2, "class", "jse-label svelte-15uz9w0"), So($2, "class", "jse-original-data svelte-15uz9w0"), To($2, "jse-hide", !e22[11]), So(R2, "class", "jse-label svelte-15uz9w0"), So(I2, "class", "jse-preview-data svelte-15uz9w0"), So(_2, "class", "jse-data-contents svelte-15uz9w0"), To(_2, "jse-hide-original-data", !e22[11]), So(i2, "class", "jse-main-contents svelte-15uz9w0"), So(F2, "type", "button"), So(F2, "class", "jse-primary svelte-15uz9w0"), F2.disabled = H2 = !!e22[12], So(q2, "class", "jse-actions svelte-15uz9w0"), So(r2, "class", "jse-contents svelte-15uz9w0");
  }, m: function(d3, L3) {
    Ma(t2, d3, L3), vo(d3, n2, L3), vo(d3, r2, L3), uo(r2, i2), uo(i2, o2), uo(o2, a2), uo(o2, s2), uo(o2, u2), u2.innerHTML = K2, uo(o2, c2), uo(o2, l2), uo(o2, f2), uo(o2, h2), uo(o2, v2), uo(o2, p2), uo(p2, m2), uo(m2, g2), Ma(y2, g2, null), uo(g2, b2), uo(o2, k2), G2 && G2.m(o2, null), uo(o2, w2), uo(o2, x2), uo(o2, j2), uo(o2, S2), uo(i2, C2), uo(i2, _2), uo(_2, $2), uo($2, O2), uo(O2, A2), uo(A2, M2), Ma(E2, M2, null), uo(M2, P2), uo($2, N2), Q2 && Q2.m($2, null), uo(_2, T2), uo(_2, I2), uo(I2, R2), uo(I2, D2), Z2[z2].m(I2, null), uo(r2, B2), uo(r2, q2), uo(q2, F2), uo(F2, V2), W2 = true, J2 || (U2 = [xo(g2, "click", e22[19]), xo(S2, "input", e22[17]), xo(M2, "click", e22[20]), xo(F2, "click", e22[18]), to(FK.call(null, F2))], J2 = true);
  }, p: function(e23, n3) {
    var r3 = {};
    16 & n3[0] && (r3.queryLanguages = e23[4]), 1 & n3[0] && (r3.queryLanguageId = e23[0]), t2.$set(r3), (!W2 || 1 & n3[0]) && K2 !== (K2 = e23[15](e23[0]).description + "") && (u2.innerHTML = K2), (!W2 || 2 & n3[0] && d2 !== (d2 = km(e23[1]) ? "(whole document)" : uS(e23[1])) && h2.value !== d2) && (h2.value = d2);
    var i3 = {};
    1024 & n3[0] && (i3.data = e23[10] ? ij : oj), y2.$set(i3), e23[10] ? G2 ? (G2.p(e23, n3), 1024 & n3[0] && ya(G2, 1)) : ((G2 = TK(e23)).c(), ya(G2, 1), G2.m(o2, w2)) : G2 && (ma(), ba(G2, 1, 1, function() {
      G2 = null;
    }), ga()), (!W2 || 256 & n3[0]) && (S2.value = e23[8]);
    var a3 = {};
    2048 & n3[0] && (a3.data = e23[11] ? ij : oj), E2.$set(a3), e23[11] ? Q2 ? (Q2.p(e23, n3), 2048 & n3[0] && ya(Q2, 1)) : ((Q2 = DK(e23)).c(), ya(Q2, 1), Q2.m($2, null)) : Q2 && (ma(), ba(Q2, 1, 1, function() {
      Q2 = null;
    }), ga()), 2048 & n3[0] && To($2, "jse-hide", !e23[11]);
    var s3 = z2;
    (z2 = X2(e23)) === s3 ? Z2[z2].p(e23, n3) : (ma(), ba(Z2[s3], 1, 1, function() {
      Z2[s3] = null;
    }), ga(), (L2 = Z2[z2]) ? L2.p(e23, n3) : (L2 = Z2[z2] = Y2[z2](e23)).c(), ya(L2, 1), L2.m(I2, null)), 2048 & n3[0] && To(_2, "jse-hide-original-data", !e23[11]), (!W2 || 4096 & n3[0] && H2 !== (H2 = !!e23[12])) && (F2.disabled = H2);
  }, i: function(e23) {
    W2 || (ya(t2.$$.fragment, e23), ya(y2.$$.fragment, e23), ya(G2), ya(E2.$$.fragment, e23), ya(Q2), ya(L2), W2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), ba(y2.$$.fragment, e23), ba(G2), ba(E2.$$.fragment, e23), ba(Q2), ba(L2), W2 = false;
  }, d: function(e23) {
    Ea(t2, e23), e23 && po(n2), e23 && po(r2), Ea(y2), G2 && G2.d(), Ea(E2), Q2 && Q2.d(), Z2[z2].d(), J2 = false, Wi(U2);
  } };
}
function qK(e22) {
  var t2, n2, r2;
  return n2 = new Yx({ props: { $$slots: { default: [BK] }, $$scope: { ctx: e22 } } }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), So(t2, "class", "jse-modal jse-transform svelte-15uz9w0");
  }, m: function(e23, i2) {
    vo(e23, t2, i2), Ma(n2, t2, null), r2 = true;
  }, p: function(e23, t3) {
    var r3 = {};
    32767 & t3[0] | 8 & t3[1] && (r3.$$scope = { dirty: t3, ctx: e23 }), n2.$set(r3);
  }, i: function(e23) {
    r2 || (ya(n2.$$.fragment, e23), r2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), r2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2);
  } };
}
function FK(e22) {
  e22.focus();
}
function VK(e22, t2, n2) {
  var r2, i2, o2 = Ia("jsoneditor:TransformModal"), a2 = t2.id, s2 = a2 === void 0 ? "transform-modal-" + ss() : a2, u2 = t2.json, c2 = t2.selectedPath, l2 = c2 === void 0 ? [] : c2, f2 = t2.escapeControlCharacters, h2 = t2.escapeUnicodeCharacters, d2 = t2.queryLanguages, v2 = t2.queryLanguageId, p2 = t2.onChangeQueryLanguage, m2 = t2.onRenderValue, g2 = t2.onClassName, y2 = t2.onTransform, b2 = Yo("simple-modal").close, k2 = "".concat(s2, ":").concat(cs.exports.compileJSONPointer(l2)), w2 = uU[k2] || {}, x2 = uU.showWizard !== false, j2 = uU.showOriginal !== false, S2 = w2.queryOptions || {}, C2 = v2 === w2.queryLanguageId && w2.query ? w2.query : A2(v2).createQuery(u2, w2.queryOptions || {}), _2 = w2.isManual || false, $2 = void 0, O2 = { text: "" };
  function A2(e23) {
    return d2.find(function(t3) {
      return t3.id === e23;
    }) || d2[0];
  }
  var M2 = Xd(function(e23, t3) {
    try {
      o2("previewTransform", { query: t3 });
      var r3 = A2(v2).executeQuery(e23, t3);
      n2(13, O2 = { json: r3 }), n2(12, $2 = void 0);
    } catch (e24) {
      n2(13, O2 = { text: "" }), n2(12, $2 = e24);
    }
  }, 300);
  return e22.$$set = function(e23) {
    "id" in e23 && n2(22, s2 = e23.id), "json" in e23 && n2(23, u2 = e23.json), "selectedPath" in e23 && n2(1, l2 = e23.selectedPath), "escapeControlCharacters" in e23 && n2(2, f2 = e23.escapeControlCharacters), "escapeUnicodeCharacters" in e23 && n2(3, h2 = e23.escapeUnicodeCharacters), "queryLanguages" in e23 && n2(4, d2 = e23.queryLanguages), "queryLanguageId" in e23 && n2(0, v2 = e23.queryLanguageId), "onChangeQueryLanguage" in e23 && n2(24, p2 = e23.onChangeQueryLanguage), "onRenderValue" in e23 && n2(5, m2 = e23.onRenderValue), "onClassName" in e23 && n2(6, g2 = e23.onClassName), "onTransform" in e23 && n2(25, y2 = e23.onTransform);
  }, e22.$$.update = function() {
    8388610 & e22.$$.dirty[0] && n2(9, r2 = cs.exports.getIn(u2, l2)), 512 & e22.$$.dirty[0] && n2(14, i2 = { json: r2 }), 768 & e22.$$.dirty[0] && M2(r2, C2), 201326977 & e22.$$.dirty[0] && (n2(26, uU[k2] = { queryOptions: S2, query: C2, queryLanguageId: v2, isManual: _2 }, uU), o2("store state in memory", k2, uU[k2]));
  }, [v2, l2, f2, h2, d2, m2, g2, S2, C2, r2, x2, j2, $2, O2, i2, A2, function(e23) {
    n2(7, S2 = e23), n2(8, C2 = A2(v2).createQuery(u2, e23)), n2(27, _2 = false), o2("updateQueryByWizard", { queryOptions: S2, query: C2, isManual: _2 });
  }, function(e23) {
    n2(8, C2 = e23.target.value), n2(27, _2 = true), o2("handleChangeQuery", { query: C2, isManual: _2 });
  }, function() {
    try {
      o2("handleTransform", { query: C2 });
      var e23 = A2(v2).executeQuery(r2, C2);
      y2([{ op: "replace", path: cs.exports.compileJSONPointer(l2), value: e23 }]), b2();
    } catch (e24) {
      console.error(e24), n2(13, O2 = { text: "" }), n2(12, $2 = e24.toString());
    }
  }, function() {
    n2(10, x2 = !x2), n2(26, uU.showWizard = x2, uU);
  }, function() {
    n2(11, j2 = !j2), n2(26, uU.showOriginal = j2, uU);
  }, function(e23) {
    o2("handleChangeQueryLanguage", e23), n2(0, v2 = e23), p2(e23);
    var t3 = A2(v2);
    n2(8, C2 = t3.createQuery(u2, S2)), n2(27, _2 = false);
  }, s2, u2, p2, y2, uU, _2];
}
var HK = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, VK, qK, Ki, { id: 22, json: 23, selectedPath: 1, escapeControlCharacters: 2, escapeUnicodeCharacters: 3, queryLanguages: 4, queryLanguageId: 0, onChangeQueryLanguage: 24, onRenderValue: 5, onClassName: 6, onTransform: 25 }, NK, [-1, -1]), r2;
  }
  return zi(n2);
}(), WK = {};
function JK(e22) {
  co(e22, "svelte-ery7bx", ".jse-modal.svelte-ery7bx.svelte-ery7bx{--height:36px;--multiItemHeight:28px;--multiItemMargin:2px;--multiItemPadding:2px 8px;--multiClearTop:5px;--multiItemBorderRadius:6px;--clearSelectTop:2px;--clearSelectBottom:2px;--indicatorTop:8px;flex:1;display:flex;flex-direction:column;font-family:var(--jse-font-family);font-size:var(--jse-font-size);line-height:normal;background:var(--jse-modal-background);color:var(--jse-text-color)}.jse-modal.svelte-ery7bx .jse-contents.svelte-ery7bx{padding:20px;overflow:auto}.jse-modal.svelte-ery7bx .jse-contents .jse-actions.svelte-ery7bx{display:flex;flex-direction:row;justify-content:flex-end;padding-top:var(--jse-padding)}.jse-modal.svelte-ery7bx .jse-contents .jse-actions button.svelte-ery7bx{border:none;background:transparent;color:inherit;cursor:pointer;font-family:var(--jse-font-family);font-size:var(--jse-font-size);padding:5px;margin:0;background:var(--jse-button-primary-background);color:var(--jse-button-primary-color);padding:var(--jse-padding) calc(2 * var(--jse-padding));border-radius:3px}.jse-modal.svelte-ery7bx .jse-contents .jse-actions button.svelte-ery7bx:hover{background:var(--jse-button-primary-background-highlight)}.jse-modal.svelte-ery7bx .jse-contents .jse-actions button.svelte-ery7bx:disabled{background:var(--jse-button-primary-background-disabled)}.bg.jse-modal-bg{width:100%;height:100%;top:0;left:0;background:var(--jse-modal-overlay-background)}.bg.jse-modal-bg .jse-modal-window-wrap{margin:0}.bg.jse-modal-bg .jse-modal-window{max-width:90%;margin:4rem auto 2rem auto;border-radius:2px}.bg.jse-modal-bg .jse-modal-window.jse-modal-window-sort{width:400px}.bg.jse-modal-bg .jse-modal-window.jse-modal-window-transform{width:1200px;height:1200px;max-height:80%;display:flex}.bg.jse-modal-bg .jse-modal-content{flex:1;display:flex;max-height:calc(100vh - 6rem);padding:0}.jse-modal.jse-sort.svelte-ery7bx table.svelte-ery7bx{width:100%;border-collapse:collapse;border-spacing:0}.jse-modal.jse-sort.svelte-ery7bx table th.svelte-ery7bx,.jse-modal.jse-sort.svelte-ery7bx table td.svelte-ery7bx{text-align:left;vertical-align:middle;font-weight:normal;padding-bottom:var(--jse-padding)}.jse-modal.jse-sort.svelte-ery7bx table th input.jse-path.svelte-ery7bx,.jse-modal.jse-sort.svelte-ery7bx table td input.jse-path.svelte-ery7bx{width:100%;box-sizing:border-box;padding:6px 16px;border:var(--jse-input-border);border-radius:var(--jse-input-radius);font-family:inherit;font-size:inherit;background:inherit;color:inherit;outline:none}.jse-modal.jse-sort.svelte-ery7bx table th input.jse-path.svelte-ery7bx:read-only,.jse-modal.jse-sort.svelte-ery7bx table td input.jse-path.svelte-ery7bx:read-only{background:var(--jse-input-background-readonly)}.jse-modal.jse-sort.svelte-ery7bx table th.svelte-ery7bx .selectContainer input,.jse-modal.jse-sort.svelte-ery7bx table td.svelte-ery7bx .selectContainer input{box-sizing:border-box}.jse-modal.jse-sort.svelte-ery7bx .jse-space.svelte-ery7bx{height:200px}");
}
function UK(e22) {
  var t2, n2, r2, i2, o2, a2, s2;
  function u2(t3) {
    e22[12](t3);
  }
  var c2 = { showIndicator: true, items: e22[4] };
  return e22[1] !== void 0 && (c2.value = e22[1]), o2 = new pK({ props: c2 }), Xo.push(function() {
    return Oa(o2, "value", u2);
  }), { c: function() {
    t2 = go("tr"), (n2 = go("th")).textContent = "Property", r2 = ko(), i2 = go("td"), Aa(o2.$$.fragment), So(n2, "class", "svelte-ery7bx"), So(i2, "class", "svelte-ery7bx");
  }, m: function(e23, a3) {
    vo(e23, t2, a3), uo(t2, n2), uo(t2, r2), uo(t2, i2), Ma(o2, i2, null), s2 = true;
  }, p: function(e23, t3) {
    var n3 = {};
    16 & t3 && (n3.items = e23[4]), !a2 && 2 & t3 && (a2 = true, n3.value = e23[1], sa(function() {
      return a2 = false;
    })), o2.$set(n3);
  }, i: function(e23) {
    s2 || (ya(o2.$$.fragment, e23), s2 = true);
  }, o: function(e23) {
    ba(o2.$$.fragment, e23), s2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(o2);
  } };
}
function KK(e22) {
  var t2, n2, r2, i2, o2, a2, s2, u2, c2, l2, f2, h2, d2, v2, p2, m2, g2, y2, b2, k2, w2, x2, j2, S2, C2, _2, $2, O2, A2, M2, E2, P2;
  n2 = new GF({ props: { title: e22[3] ? "Sort array items" : "Sort object keys" } });
  var N2 = e22[3] && (e22[4].length > 1 || e22[1] === void 0) && UK(e22);
  function T2(t3) {
    e22[13](t3);
  }
  var I2 = { showIndicator: true, items: e22[5], isClearable: false };
  return e22[2] !== void 0 && (I2.value = e22[2]), w2 = new pK({ props: I2 }), Xo.push(function() {
    return Oa(w2, "value", T2);
  }), { c: function() {
    t2 = go("div"), Aa(n2.$$.fragment), r2 = ko(), i2 = go("div"), o2 = go("table"), (a2 = go("colgroup")).innerHTML = '<col width="25%"/> \n        <col width="75%"/>', s2 = ko(), u2 = go("tbody"), c2 = go("tr"), (l2 = go("th")).textContent = "Path", f2 = ko(), h2 = go("td"), d2 = go("input"), p2 = ko(), N2 && N2.c(), m2 = ko(), g2 = go("tr"), (y2 = go("th")).textContent = "Direction", b2 = ko(), k2 = go("td"), Aa(w2.$$.fragment), j2 = ko(), S2 = go("div"), C2 = ko(), _2 = go("div"), $2 = go("button"), O2 = bo("Sort"), So(l2, "class", "svelte-ery7bx"), So(d2, "class", "jse-path svelte-ery7bx"), So(d2, "type", "text"), d2.readOnly = true, So(d2, "title", "Selected path"), d2.value = v2 = km(e22[0]) ? "(whole document)" : uS(e22[0]), So(h2, "class", "svelte-ery7bx"), So(y2, "class", "svelte-ery7bx"), So(k2, "class", "svelte-ery7bx"), So(o2, "class", "svelte-ery7bx"), So(S2, "class", "jse-space svelte-ery7bx"), So($2, "type", "button"), So($2, "class", "jse-primary svelte-ery7bx"), $2.disabled = A2 = !!e22[3] && !e22[1], So(_2, "class", "jse-actions svelte-ery7bx"), So(i2, "class", "jse-contents svelte-ery7bx"), So(t2, "class", "jse-modal jse-sort svelte-ery7bx");
  }, m: function(v3, x3) {
    vo(v3, t2, x3), Ma(n2, t2, null), uo(t2, r2), uo(t2, i2), uo(i2, o2), uo(o2, a2), uo(o2, s2), uo(o2, u2), uo(u2, c2), uo(c2, l2), uo(c2, f2), uo(c2, h2), uo(h2, d2), uo(u2, p2), N2 && N2.m(u2, null), uo(u2, m2), uo(u2, g2), uo(g2, y2), uo(g2, b2), uo(g2, k2), Ma(w2, k2, null), uo(i2, j2), uo(i2, S2), uo(i2, C2), uo(i2, _2), uo(_2, $2), uo($2, O2), M2 = true, E2 || (P2 = [xo($2, "click", e22[6]), to(GK.call(null, $2))], E2 = true);
  }, p: function(e23, t3) {
    var r3 = xi(t3, 1)[0], i3 = {};
    8 & r3 && (i3.title = e23[3] ? "Sort array items" : "Sort object keys"), n2.$set(i3), (!M2 || 1 & r3 && v2 !== (v2 = km(e23[0]) ? "(whole document)" : uS(e23[0])) && d2.value !== v2) && (d2.value = v2), e23[3] && (e23[4].length > 1 || e23[1] === void 0) ? N2 ? (N2.p(e23, r3), 26 & r3 && ya(N2, 1)) : ((N2 = UK(e23)).c(), ya(N2, 1), N2.m(u2, m2)) : N2 && (ma(), ba(N2, 1, 1, function() {
      N2 = null;
    }), ga());
    var o3 = {};
    !x2 && 4 & r3 && (x2 = true, o3.value = e23[2], sa(function() {
      return x2 = false;
    })), w2.$set(o3), (!M2 || 10 & r3 && A2 !== (A2 = !!e23[3] && !e23[1])) && ($2.disabled = A2);
  }, i: function(e23) {
    M2 || (ya(n2.$$.fragment, e23), ya(N2), ya(w2.$$.fragment, e23), M2 = true);
  }, o: function(e23) {
    ba(n2.$$.fragment, e23), ba(N2), ba(w2.$$.fragment, e23), M2 = false;
  }, d: function(e23) {
    e23 && po(t2), Ea(n2), N2 && N2.d(), Ea(w2), E2 = false, Wi(P2);
  } };
}
function GK(e22) {
  e22.focus();
}
function QK(e22, t2, n2) {
  var r2, i2, o2, a2 = Ia("jsoneditor:SortModal"), s2 = t2.id, u2 = t2.json, c2 = t2.selectedPath, l2 = t2.onSort, f2 = Yo("simple-modal").close, h2 = "".concat(s2, ":").concat(cs.exports.compileJSONPointer(c2)), d2 = cs.exports.getIn(u2, c2), v2 = { value: 1, label: "ascending" }, p2 = [v2, { value: -1, label: "descending" }], m2 = WK[h2] && WK[h2].selectedProperty || void 0, g2 = WK[h2] && WK[h2].selectedDirection || v2;
  function y2(e23) {
    return { value: e23, label: km(e23) ? "(whole item)" : cs.exports.compileJSONPointer(e23) };
  }
  return e22.$$set = function(e23) {
    "id" in e23 && n2(7, s2 = e23.id), "json" in e23 && n2(8, u2 = e23.json), "selectedPath" in e23 && n2(0, c2 = e23.selectedPath), "onSort" in e23 && n2(9, l2 = e23.onSort);
  }, e22.$$.update = function() {
    8 & e22.$$.dirty && n2(11, i2 = r2 ? Lw(d2) : void 0), 2048 & e22.$$.dirty && n2(4, o2 = i2 ? i2.map(y2) : void 0), 18 & e22.$$.dirty && m2 === void 0 && o2 && o2.length === 1 && n2(1, m2 = o2[0]), 1030 & e22.$$.dirty && (n2(10, WK[h2] = { selectedProperty: m2, selectedDirection: g2 }, WK), a2("store state in memory", h2, WK[h2]));
  }, n2(3, r2 = Array.isArray(d2)), [c2, m2, g2, r2, o2, p2, function() {
    if (r2) {
      if (!m2)
        return;
      var e23 = m2.value, t3 = g2.value, n3 = function(e24) {
        var t4 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [], n4 = XW(arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [], arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 1), r3 = cs.exports.getIn(e24, t4);
        return [{ op: "replace", path: cs.exports.compileJSONPointer(t4), value: r3.slice(0).sort(n4) }];
      }(u2, c2, e23, t3);
      l2(n3);
    } else if ($s(d2)) {
      var i3 = g2.value, o3 = function(e24) {
        var t4 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [], n4 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 1, r3 = cs.exports.getIn(e24, t4), i4 = Object.keys(r3).slice();
        i4.sort(function(e25, t5) {
          return n4 * ZW(e25, t5);
        });
        for (var o4 = [], a3 = 0; a3 < i4.length; a3++) {
          var s3 = i4[a3], u3 = cs.exports.compileJSONPointer(t4.concat(s3));
          o4.push({ op: "move", from: u3, path: u3 });
        }
        return o4;
      }(u2, c2, i3);
      l2(o3);
    } else
      console.error("Cannot sort: no array or object");
    f2();
  }, s2, u2, l2, WK, i2, function(e23) {
    n2(1, m2 = e23), n2(4, o2), n2(11, i2), n2(3, r2);
  }, function(e23) {
    n2(2, g2 = e23);
  }];
}
var YK = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, QK, KK, Ki, { id: 7, json: 8, selectedPath: 0, onSort: 9 }, JK), r2;
  }
  return zi(n2);
}();
function ZK(e22, t2, n2) {
  var r2 = Yo("simple-modal");
  return [r2.open, r2.close];
}
var XK = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, ZK, null, Ki, { open: 0, close: 1 }), r2;
  }
  return zi(n2, [{ key: "open", get: function() {
    return this.$$.ctx[0];
  } }, { key: "close", get: function() {
    return this.$$.ctx[1];
  } }]), n2;
}();
function eG(e22) {
  co(e22, "svelte-1tkifqe", ':root{--jse-font-family:-apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Oxygen-Sans, Ubuntu,\n    Cantarell, "Helvetica Neue", sans-serif;--jse-font-family-mono:consolas, menlo, monaco, "Ubuntu Mono", "source-code-pro", monospace;--jse-font-size-mono:14px;--jse-font-size:16px;--jse-font-size-text-mode-search:80%;--jse-line-height:calc(1em + 4px);--jse-indent-size:calc(1em + 4px);--jse-color-picker-button-size:1em;--jse-padding:10px;--jse-theme-color:#3883fa;--jse-theme-color-highlight:#5f9dff;--jse-background-color:#fff;--jse-text-color:#4d4d4d;--jse-text-color-inverse:#fff;--jse-error-color:#ee5341;--jse-warning-color:#fdc539;--jse-main-border:1px solid #d7d7d7;--jse-menu-color:var(--jse-text-color-inverse);--jse-menu-button-size:32px;--jse-modal-background:#f5f5f5;--jse-modal-overlay-background:rgba(0, 0, 0, 0.3);--jse-modal-code-background:rgba(0, 0, 0, 0.05);--jse-panel-background:#ebebeb;--jse-panel-color:var(--jse-text-color);--jse-panel-color-readonly:#b2b2b2;--jse-panel-border:var(--jse-main-border);--jse-panel-button-color:inherit;--jse-panel-button-background:transparent;--jse-panel-button-color-highlight:var(--jse-text-color);--jse-panel-button-background-highlight:#e0e0e0;--jse-navigation-bar-color:#656565;--jse-navigation-bar-background:var(--jse-background-color);--jse-navigation-bar-background-highlight:#e5e5e5;--jse-navigation-bar-dropdown-color:#656565;--jse-context-menu-background:#656565;--jse-context-menu-background-highlight:#7a7a7a;--jse-context-menu-color:var(--jse-text-color-inverse);--jse-context-menu-color-disabled:#9d9d9d;--jse-context-menu-separator-color:#7a7a7a;--jse-context-menu-button-background:var(--jse-context-menu-background);--jse-context-menu-button-background-highlight:var(--jse-context-menu-background-highlight);--jse-context-menu-button-color:var(--jse-context-menu-color);--jse-context-menu-button-size:calc(1em + 4px);--jse-context-menu-tip-background:rgba(255, 255, 255, 0.2);--jse-context-menu-tip-color:inherit;--jse-key-color:#1a1a1a;--jse-value-color:#1a1a1a;--jse-value-color-number:#ee422e;--jse-value-color-boolean:#ff8c00;--jse-value-color-null:#004ed0;--jse-value-color-string:#008000;--jse-value-color-url:#008000;--jse-delimiter-color:rgba(0, 0, 0, 0.38);--jse-edit-outline:2px solid #656565;--jse-hover-background-color:rgba(0, 0, 0, 0.06);--jse-selection-background-color:#d3d3d3;--jse-selection-background-light-color:#e8e8e8;--jse-collapsed-items-background-color:#f5f5f5;--jse-collapsed-items-selected-background-color:#c2c2c2;--jse-collapsed-items-link-color:rgba(0, 0, 0, 0.38);--jse-collapsed-items-link-color-highlight:#ee5341;--jse-search-match-color:#ffe665;--jse-search-match-outline:1px solid #ffd700;--jse-search-match-active-color:#ffd700;--jse-search-match-active-outline:1px solid #e1be00;--jse-tag-background:rgba(0, 0, 0, 0.2);--jse-tag-color:var(--jse-text-color-inverse);--jse-controls-box-shadow:0 2px 6px 0 rgba(0, 0, 0, 0.24);--jse-input-background:var(--jse-background-color);--jse-input-background-readonly:transparent;--jse-input-border:1px solid #d8dbdf;--jse-input-border-focus:1px solid var(--jse-theme-color);--jse-input-radius:3px;--jse-button-background:#e0e0e0;--jse-button-background-highlight:#e7e7e7;--jse-button-color:var(--jse-text-color);--jse-button-primary-background:var(--jse-theme-color);--jse-button-primary-background-highlight:var(--jse-theme-color-highlight);--jse-button-primary-background-disabled:#9d9d9d;--jse-button-primary-color:var(--jse-text-color-inverse);--jse-a-color:#156fc5;--jse-a-color-highlight:#0f508d;--jse-message-error-background:var(--jse-error-color);--jse-message-error-color:var(--jse-text-color-inverse);--jse-message-warning-background:#ffde5c;--jse-message-warning-color:var(--jse-text-color);--jse-message-success-background:#9ac45d;--jse-message-success-color:var(--jse-text-color-inverse);--jse-message-info-background:#9d9d9d;--jse-message-info-color:var(--jse-text-color-inverse);--jse-message-action-background:rgba(255, 255, 255, 0.2);--jse-message-action-background-highlight:rgba(255, 255, 255, 0.3);--itemIsActiveBG:#3883fa;--border:1px solid #d8dbdf;--borderRadius:3px;--background:#fff;--jse-color-picker-background:var(--jse-panel-background);--jse-color-picker-border-box-shadow:#cbcbcb 0 0 0 1px}.jse-main.svelte-1tkifqe{width:100%;height:100%;min-width:0;min-height:150px;font-family:var(--jse-font-family);font-size:var(--jse-font-size);line-height:normal;position:relative;display:flex;flex-direction:row}');
}
function tG(e22) {
  var t2, n2, r2 = { readOnly: e22[2], indentation: e22[3], externalContent: e22[0], mainMenuBar: e22[5], navigationBar: e22[6], escapeControlCharacters: e22[8], escapeUnicodeCharacters: e22[9], validator: e22[10], onError: e22[13], onChange: e22[22], onRequestRepair: e22[24], onRenderValue: e22[11], onClassName: e22[12], onFocus: e22[26], onBlur: e22[27], onRenderMenu: e22[20], onSortModal: e22[29], onTransformModal: e22[28] };
  return t2 = new NJ({ props: r2 }), e22[54](t2), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r3) {
    Ma(t2, e23, r3), n2 = true;
  }, p: function(e23, n3) {
    var r3 = {};
    4 & n3[0] && (r3.readOnly = e23[2]), 8 & n3[0] && (r3.indentation = e23[3]), 1 & n3[0] && (r3.externalContent = e23[0]), 32 & n3[0] && (r3.mainMenuBar = e23[5]), 64 & n3[0] && (r3.navigationBar = e23[6]), 256 & n3[0] && (r3.escapeControlCharacters = e23[8]), 512 & n3[0] && (r3.escapeUnicodeCharacters = e23[9]), 1024 & n3[0] && (r3.validator = e23[10]), 8192 & n3[0] && (r3.onError = e23[13]), 2048 & n3[0] && (r3.onRenderValue = e23[11]), 4096 & n3[0] && (r3.onClassName = e23[12]), 1048576 & n3[0] && (r3.onRenderMenu = e23[20]), t2.$set(r3);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(n3) {
    e22[54](null), Ea(t2, n3);
  } };
}
function nG(e22) {
  var t2, n2, r2 = { text: e22[21](e22[0]), readOnly: e22[2], indentation: e22[3], tabSize: e22[4], mainMenuBar: e22[5], statusBar: e22[7], escapeUnicodeCharacters: e22[9], validator: e22[10], onChange: e22[23], onSwitchToTreeMode: e22[25], onError: e22[13], onFocus: e22[26], onBlur: e22[27], onRenderMenu: e22[20], onSortModal: e22[29], onTransformModal: e22[28] };
  return t2 = new fq({ props: r2 }), e22[53](t2), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r3) {
    Ma(t2, e23, r3), n2 = true;
  }, p: function(e23, n3) {
    var r3 = {};
    1 & n3[0] && (r3.text = e23[21](e23[0])), 4 & n3[0] && (r3.readOnly = e23[2]), 8 & n3[0] && (r3.indentation = e23[3]), 16 & n3[0] && (r3.tabSize = e23[4]), 32 & n3[0] && (r3.mainMenuBar = e23[5]), 128 & n3[0] && (r3.statusBar = e23[7]), 512 & n3[0] && (r3.escapeUnicodeCharacters = e23[9]), 1024 & n3[0] && (r3.validator = e23[10]), 8192 & n3[0] && (r3.onError = e23[13]), 1048576 & n3[0] && (r3.onRenderMenu = e23[20]), t2.$set(r3);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(n3) {
    e22[53](null), Ea(t2, n3);
  } };
}
function rG(e22) {
  var t2, n2, r2, i2, o2 = [nG, tG], a2 = [];
  function s2(e23, t3) {
    return e23[1] === ix.text || e23[1] === "code" ? 0 : 1;
  }
  return t2 = s2(e22), n2 = a2[t2] = o2[t2](e22), { c: function() {
    n2.c(), r2 = wo();
  }, m: function(e23, n3) {
    a2[t2].m(e23, n3), vo(e23, r2, n3), i2 = true;
  }, p: function(e23, i3) {
    var u2 = t2;
    (t2 = s2(e23)) === u2 ? a2[t2].p(e23, i3) : (ma(), ba(a2[u2], 1, 1, function() {
      a2[u2] = null;
    }), ga(), (n2 = a2[t2]) ? n2.p(e23, i3) : (n2 = a2[t2] = o2[t2](e23)).c(), ya(n2, 1), n2.m(r2.parentNode, r2));
  }, i: function(e23) {
    i2 || (ya(n2), i2 = true);
  }, o: function(e23) {
    ba(n2), i2 = false;
  }, d: function(e23) {
    a2[t2].d(e23), e23 && po(r2);
  } };
}
function iG(e22) {
  var t2, n2, r2 = e22[14], i2 = rG(e22);
  return { c: function() {
    t2 = go("div"), i2.c(), So(t2, "class", "jse-main svelte-1tkifqe"), To(t2, "jse-focus", e22[15]);
  }, m: function(r3, o2) {
    vo(r3, t2, o2), i2.m(t2, null), e22[55](t2), n2 = true;
  }, p: function(e23, n3) {
    16384 & n3[0] && Ki(r2, r2 = e23[14]) ? (ma(), ba(i2, 1, 1, Bi), ga(), (i2 = rG(e23)).c(), ya(i2, 1), i2.m(t2, null)) : i2.p(e23, n3), 32768 & n3[0] && To(t2, "jse-focus", e23[15]);
  }, i: function(e23) {
    n2 || (ya(i2), n2 = true);
  }, o: function(e23) {
    ba(i2), n2 = false;
  }, d: function(n3) {
    n3 && po(t2), i2.d(n3), e22[55](null);
  } };
}
function oG(e22) {
  var t2, n2, r2, i2, o2;
  function a2(t3) {
    e22[52](t3);
  }
  var s2 = {};
  return e22[19] !== void 0 && (s2.open = e22[19]), t2 = new XK({ props: s2 }), Xo.push(function() {
    return Oa(t2, "open", a2);
  }), i2 = new Yx({ props: { $$slots: { default: [iG] }, $$scope: { ctx: e22 } } }), { c: function() {
    Aa(t2.$$.fragment), r2 = ko(), Aa(i2.$$.fragment);
  }, m: function(e23, n3) {
    Ma(t2, e23, n3), vo(e23, r2, n3), Ma(i2, e23, n3), o2 = true;
  }, p: function(e23, r3) {
    var o3 = {};
    !n2 && 524288 & r3[0] && (n2 = true, o3.open = e23[19], sa(function() {
      return n2 = false;
    })), t2.$set(o3);
    var a3 = {};
    1572863 & r3[0] | 536870912 & r3[1] && (a3.$$scope = { dirty: r3, ctx: e23 }), i2.$set(a3);
  }, i: function(e23) {
    o2 || (ya(t2.$$.fragment, e23), ya(i2.$$.fragment, e23), o2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), ba(i2.$$.fragment, e23), o2 = false;
  }, d: function(e23) {
    Ea(t2, e23), e23 && po(r2), Ea(i2, e23);
  } };
}
function aG(e22) {
  var t2, n2;
  return t2 = new Qa({ props: { $$slots: { default: [oG] }, $$scope: { ctx: e22 } } }), { c: function() {
    Aa(t2.$$.fragment);
  }, m: function(e23, r2) {
    Ma(t2, e23, r2), n2 = true;
  }, p: function(e23, n3) {
    var r2 = {};
    2097151 & n3[0] | 536870912 & n3[1] && (r2.$$scope = { dirty: n3, ctx: e23 }), t2.$set(r2);
  }, i: function(e23) {
    n2 || (ya(t2.$$.fragment, e23), n2 = true);
  }, o: function(e23) {
    ba(t2.$$.fragment, e23), n2 = false;
  }, d: function(e23) {
    Ea(t2, e23);
  } };
}
function sG(e22) {
  this.$set(e22);
}
function uG() {
  this.$destroy();
}
function cG(e22, t2, n2) {
  var r2, i2, o2, a2, s2, u2, c2 = Ia("jsoneditor:Main"), l2 = t2.content, f2 = l2 === void 0 ? { text: "" } : l2, h2 = t2.readOnly, d2 = h2 !== void 0 && h2, v2 = t2.indentation, p2 = v2 === void 0 ? 2 : v2, m2 = t2.tabSize, g2 = m2 === void 0 ? 4 : m2, y2 = t2.mode, b2 = y2 === void 0 ? ix.tree : y2, k2 = t2.mainMenuBar, w2 = k2 === void 0 || k2, x2 = t2.navigationBar, j2 = x2 === void 0 || x2, S2 = t2.statusBar, C2 = S2 === void 0 || S2, _2 = t2.escapeControlCharacters, $2 = _2 !== void 0 && _2, O2 = t2.escapeUnicodeCharacters, A2 = O2 !== void 0 && O2, M2 = t2.validator, E2 = M2 === void 0 ? null : M2, P2 = t2.queryLanguages, N2 = P2 === void 0 ? [TJ] : P2, T2 = t2.queryLanguageId, I2 = T2 === void 0 ? N2[0].id : T2, R2 = t2.onChangeQueryLanguage, D2 = R2 === void 0 ? Vu : R2, z2 = t2.onChange, L2 = z2 === void 0 ? null : z2, B2 = t2.onRenderValue, q2 = B2 === void 0 ? sU : B2, F2 = t2.onClassName, V2 = F2 === void 0 ? function() {
  } : F2, H2 = t2.onRenderMenu, W2 = H2 === void 0 ? Vu : H2, J2 = t2.onChangeMode, U2 = J2 === void 0 ? Vu : J2, K2 = t2.onError, G2 = K2 === void 0 ? function(e23) {
    console.error(e23), alert(e23.toString());
  } : K2, Q2 = t2.onFocus, Y2 = Q2 === void 0 ? Vu : Q2, Z2 = t2.onBlur, X2 = Z2 === void 0 ? Vu : Z2, ee2 = ss(), te2 = false;
  function ne2() {
    a2 ? a2.focus() : o2 && o2.focus();
  }
  function re2(e23, t3, r3) {
    n2(0, f2 = e23), L2 && L2(e23, t3, r3);
  }
  function ie2() {
    return (ie2 = yi(mi().mark(function e23() {
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              return n2(1, b2 = ix.text), e24.next = 3, oa();
            case 3:
              U2(ix.text);
            case 4:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function oe2() {
    return (oe2 = yi(mi().mark(function e23() {
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              return n2(1, b2 = ix.tree), e24.next = 3, oa();
            case 3:
              U2(ix.tree);
            case 4:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  function ae2(e23) {
    return se2.apply(this, arguments);
  }
  function se2() {
    return (se2 = yi(mi().mark(function e23(t3) {
      return mi().wrap(function(e24) {
        for (; ; )
          switch (e24.prev = e24.next) {
            case 0:
              if (b2 !== t3) {
                e24.next = 2;
                break;
              }
              return e24.abrupt("return");
            case 2:
              return n2(1, b2 = t3), e24.next = 5, oa();
            case 5:
              ne2(), U2(t3);
            case 7:
            case "end":
              return e24.stop();
          }
      }, e23);
    }))).apply(this, arguments);
  }
  var ue2 = { separator: true };
  function ce2(e23) {
    c2("handleChangeQueryLanguage", e23), n2(30, I2 = e23), D2(e23);
  }
  return e22.$$set = function(e23) {
    "content" in e23 && n2(0, f2 = e23.content), "readOnly" in e23 && n2(2, d2 = e23.readOnly), "indentation" in e23 && n2(3, p2 = e23.indentation), "tabSize" in e23 && n2(4, g2 = e23.tabSize), "mode" in e23 && n2(1, b2 = e23.mode), "mainMenuBar" in e23 && n2(5, w2 = e23.mainMenuBar), "navigationBar" in e23 && n2(6, j2 = e23.navigationBar), "statusBar" in e23 && n2(7, C2 = e23.statusBar), "escapeControlCharacters" in e23 && n2(8, $2 = e23.escapeControlCharacters), "escapeUnicodeCharacters" in e23 && n2(9, A2 = e23.escapeUnicodeCharacters), "validator" in e23 && n2(10, E2 = e23.validator), "queryLanguages" in e23 && n2(31, N2 = e23.queryLanguages), "queryLanguageId" in e23 && n2(30, I2 = e23.queryLanguageId), "onChangeQueryLanguage" in e23 && n2(32, D2 = e23.onChangeQueryLanguage), "onChange" in e23 && n2(33, L2 = e23.onChange), "onRenderValue" in e23 && n2(11, q2 = e23.onRenderValue), "onClassName" in e23 && n2(12, V2 = e23.onClassName), "onRenderMenu" in e23 && n2(34, W2 = e23.onRenderMenu), "onChangeMode" in e23 && n2(35, U2 = e23.onChangeMode), "onError" in e23 && n2(13, G2 = e23.onError), "onFocus" in e23 && n2(36, Y2 = e23.onFocus), "onBlur" in e23 && n2(37, X2 = e23.onBlur);
  }, e22.$$.update = function() {
    if (1 & e22.$$.dirty[0]) {
      var t3 = ex(f2);
      t3 && console.error("Error: " + t3);
    }
    2 & e22.$$.dirty[0] && n2(51, u2 = [{ text: "text", title: "Switch to text mode (current mode: ".concat(b2, ")"), className: "jse-group-button jse-first" + (b2 === ix.text || b2 === "code" ? " jse-selected" : ""), onClick: function() {
      return ae2(ix.text);
    } }, { text: "tree", title: "Switch to tree mode (current mode: ".concat(b2, ")"), className: "jse-group-button jse-last" + (b2 === ix.tree ? " jse-selected" : ""), onClick: function() {
      return ae2(ix.tree);
    } }]), 1048584 & e22.$$.dirty[1] && n2(20, r2 = function(e23, t4) {
      var n3, r3 = (n3 = t4[0]) && n3.space === true && Object.keys(n3).length === 1 ? u2.concat(t4) : u2.concat(ue2, t4);
      return W2(e23, r3) || r3;
    }), 2 & e22.$$.dirty[0] && (c2("mode changed to", b2), b2 === "code" && console.warn('Deprecation warning: "code" mode is renamed to "text". Please use mode="text" instead.'));
  }, [f2, b2, d2, p2, g2, w2, j2, C2, $2, A2, E2, q2, V2, G2, ee2, te2, i2, o2, a2, s2, r2, function(e23) {
    return tx(e23) ? e23.text : JSON.stringify(e23.json, null, p2);
  }, re2, function(e23, t3) {
    re2({ text: e23, json: void 0 }, { text: t3, json: void 0 }, null);
  }, function() {
    return ie2.apply(this, arguments);
  }, function() {
    return oe2.apply(this, arguments);
  }, function() {
    n2(15, te2 = true), Y2 && Y2();
  }, function() {
    n2(15, te2 = false), X2 && X2();
  }, function(e23) {
    var t3 = e23.id, n3 = e23.json, r3 = e23.selectedPath, i3 = e23.onTransform, o3 = e23.onClose;
    d2 || s2(HK, { id: t3, json: n3, selectedPath: r3, escapeControlCharacters: $2, escapeUnicodeCharacters: A2, queryLanguages: N2, queryLanguageId: I2, onChangeQueryLanguage: ce2, onRenderValue: q2, onClassName: V2, onTransform: i3 }, es, { onClose: o3 });
  }, function(e23) {
    var t3 = e23.id, n3 = e23.json, r3 = e23.selectedPath, i3 = e23.onSort, o3 = e23.onClose;
    d2 || s2(YK, { id: t3, json: n3, selectedPath: r3, onSort: i3 }, Xa, { onClose: o3 });
  }, I2, N2, D2, L2, W2, U2, Y2, X2, function() {
    return f2;
  }, function(e23) {
    c2("set");
    var t3 = ex(e23);
    if (t3)
      throw new Error(t3);
    n2(14, ee2 = ss()), n2(0, f2 = e23);
  }, function(e23) {
    c2("update");
    var t3 = ex(e23);
    if (t3)
      throw new Error(t3);
    n2(0, f2 = e23);
  }, function(e23) {
    if (tx(f2))
      try {
        n2(0, f2 = { json: JSON.parse(f2.text), text: void 0 });
      } catch (e24) {
        throw new Error("Cannot apply patch: current document contains invalid JSON");
      }
    return o2 ? o2.patch(e23) : a2 ? a2.patch(e23) : void 0;
  }, function(e23) {
    if (o2)
      return o2.expand(e23);
    throw new Error('Method expand is not available in mode "'.concat(b2, '"'));
  }, function(e23) {
    if (a2)
      a2.openTransformModal(e23);
    else {
      if (!o2)
        throw new Error('Method transform is not available in mode "'.concat(b2, '"'));
      o2.openTransformModal(e23);
    }
  }, function() {
    return o2 ? o2.acceptAutoRepair() : f2;
  }, function(e23) {
    if (o2)
      return o2.scrollTo(e23);
    throw new Error('Method scrollTo is not available in mode "'.concat(b2, '"'));
  }, function(e23) {
    if (o2)
      return o2.findElement(e23);
    throw new Error('Method findElement is not available in mode "'.concat(b2, '"'));
  }, ne2, function() {
    a2 && a2.refresh();
  }, sG, uG, u2, function(e23) {
    n2(19, s2 = e23);
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(18, a2 = e23);
    });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(17, o2 = e23);
    });
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(16, i2 = e23);
    });
  }];
}
var lG = function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, cG, aG, Ki, { content: 0, readOnly: 2, indentation: 3, tabSize: 4, mode: 1, mainMenuBar: 5, navigationBar: 6, statusBar: 7, escapeControlCharacters: 8, escapeUnicodeCharacters: 9, validator: 10, queryLanguages: 31, queryLanguageId: 30, onChangeQueryLanguage: 32, onChange: 33, onRenderValue: 11, onClassName: 12, onRenderMenu: 34, onChangeMode: 35, onError: 13, onFocus: 36, onBlur: 37, get: 38, set: 39, update: 40, patch: 41, expand: 42, transform: 43, acceptAutoRepair: 44, scrollTo: 45, findElement: 46, focus: 47, refresh: 48, updateProps: 49, destroy: 50 }, eG, [-1, -1]), r2;
  }
  return zi(n2, [{ key: "get", get: function() {
    return this.$$.ctx[38];
  } }, { key: "set", get: function() {
    return this.$$.ctx[39];
  } }, { key: "update", get: function() {
    return this.$$.ctx[40];
  } }, { key: "patch", get: function() {
    return this.$$.ctx[41];
  } }, { key: "expand", get: function() {
    return this.$$.ctx[42];
  } }, { key: "transform", get: function() {
    return this.$$.ctx[43];
  } }, { key: "acceptAutoRepair", get: function() {
    return this.$$.ctx[44];
  } }, { key: "scrollTo", get: function() {
    return this.$$.ctx[45];
  } }, { key: "findElement", get: function() {
    return this.$$.ctx[46];
  } }, { key: "focus", get: function() {
    return this.$$.ctx[47];
  } }, { key: "refresh", get: function() {
    return this.$$.ctx[48];
  } }, { key: "updateProps", get: function() {
    return sG;
  } }, { key: "destroy", get: function() {
    return uG;
  } }]), n2;
}();
function fG(e22) {
  co(e22, "svelte-rc6e9m", ".jse-value.jse-string.svelte-rc6e9m{color:var(--jse-value-color-string)}.jse-value.jse-object.svelte-rc6e9m,.jse-value.jse-array.svelte-rc6e9m{min-width:16px;color:var(--jse-delimiter-color)}.jse-value.jse-number.svelte-rc6e9m{color:var(--jse-value-color-number)}.jse-value.jse-boolean.svelte-rc6e9m{color:var(--jse-value-color-boolean)}.jse-value.jse-null.svelte-rc6e9m{color:var(--jse-value-color-null)}.jse-value.jse-invalid.svelte-rc6e9m{color:var(--jse-text-color)}.jse-value.jse-url.svelte-rc6e9m{color:var(--jse-value-color-url);text-decoration:underline}.jse-enum-value.svelte-rc6e9m{background:var(--jse-hover-background-color);border:none;padding:0;font-family:inherit;font-size:inherit;cursor:pointer;outline:none}.jse-enum-value.jse-selected.svelte-rc6e9m{background:var(--jse-selection-background-color);color:inherit}.jse-enum-value.jse-value.svelte-rc6e9m:focus{color:var(--jse-text-color)}.jse-json-node.jse-selected .jse-enum-value.svelte-rc6e9m{background:transparent}");
}
function hG(e22, t2, n2) {
  var r2 = e22.slice();
  return r2[12] = t2[n2], r2;
}
function dG(e22) {
  var t2, n2, r2, i2 = e22[12].text + "";
  return { c: function() {
    t2 = go("option"), n2 = bo(i2), t2.__value = r2 = e22[12].value, t2.value = t2.__value;
  }, m: function(e23, r3) {
    vo(e23, t2, r3), uo(t2, n2);
  }, p: function(e23, o2) {
    2 & o2 && i2 !== (i2 = e23[12].text + "") && Ao(n2, i2), 2 & o2 && r2 !== (r2 = e23[12].value) && (t2.__value = r2, t2.value = t2.__value);
  }, d: function(e23) {
    e23 && po(t2);
  } };
}
function vG(e22) {
  for (var t2, n2, r2, i2, o2 = e22[1], a2 = [], s2 = 0; s2 < o2.length; s2 += 1)
    a2[s2] = dG(hG(e22, o2, s2));
  return { c: function() {
    t2 = go("select");
    for (var r3 = 0; r3 < a2.length; r3 += 1)
      a2[r3].c();
    So(t2, "class", n2 = eo("jse-enum-value ".concat(UJ(e22[3]))) + " svelte-rc6e9m"), e22[3] === void 0 && aa(function() {
      return e22[9].call(t2);
    }), To(t2, "jse-selected", e22[0]);
  }, m: function(n3, o3) {
    vo(n3, t2, o3);
    for (var s3 = 0; s3 < a2.length; s3 += 1)
      a2[s3].m(t2, null);
    Po(t2, e22[3]), e22[10](t2), r2 || (i2 = [xo(t2, "change", e22[9]), xo(t2, "change", e22[4]), xo(t2, "mousedown", pG)], r2 = true);
  }, p: function(e23, r3) {
    var i3 = xi(r3, 1)[0];
    if (2 & i3) {
      var s3;
      for (o2 = e23[1], s3 = 0; s3 < o2.length; s3 += 1) {
        var u2 = hG(e23, o2, s3);
        a2[s3] ? a2[s3].p(u2, i3) : (a2[s3] = dG(u2), a2[s3].c(), a2[s3].m(t2, null));
      }
      for (; s3 < a2.length; s3 += 1)
        a2[s3].d(1);
      a2.length = o2.length;
    }
    8 & i3 && n2 !== (n2 = eo("jse-enum-value ".concat(UJ(e23[3]))) + " svelte-rc6e9m") && So(t2, "class", n2), 8 & i3 && Po(t2, e23[3]), 9 & i3 && To(t2, "jse-selected", e23[0]);
  }, i: Bi, o: Bi, d: function(n3) {
    n3 && po(t2), mo(a2, n3), e22[10](null), r2 = false, Wi(i2);
  } };
}
function pG(e22) {
  e22.stopPropagation();
}
function mG(e22, t2, n2) {
  var r2, i2 = t2.path, o2 = t2.value, a2 = t2.readOnly, s2 = t2.isSelected, u2 = t2.onPatch, c2 = t2.options, l2 = o2;
  return e22.$$set = function(e23) {
    "path" in e23 && n2(5, i2 = e23.path), "value" in e23 && n2(6, o2 = e23.value), "readOnly" in e23 && n2(7, a2 = e23.readOnly), "isSelected" in e23 && n2(0, s2 = e23.isSelected), "onPatch" in e23 && n2(8, u2 = e23.onPatch), "options" in e23 && n2(1, c2 = e23.options);
  }, e22.$$.update = function() {
    64 & e22.$$.dirty && n2(3, l2 = o2), 1 & e22.$$.dirty && function(e23) {
      e23 && r2 && r2.focus();
    }(s2);
  }, [s2, c2, r2, l2, function(e23) {
    e23.stopPropagation(), a2 || u2([{ op: "replace", path: cs.exports.compileJSONPointer(i2), value: l2 }]);
  }, i2, o2, a2, u2, function() {
    var e23, t3;
    t3 = (e23 = this).querySelector(":checked") || e23.options[0], l2 = t3 && t3.__value, n2(3, l2), n2(6, o2);
  }, function(e23) {
    Xo[e23 ? "unshift" : "push"](function() {
      n2(2, r2 = e23), n2(1, c2);
    });
  }];
}
(function(e22) {
  ji(n2, Ta);
  var t2 = Ci(n2);
  function n2(e23) {
    var r2;
    return Ri(this, n2), Na($i(r2 = t2.call(this)), e23, mG, vG, Ki, { path: 5, value: 6, readOnly: 7, isSelected: 0, onPatch: 8, options: 1 }, fG), r2;
  }
  return zi(n2);
})();
function xG(e22) {
  throw new Error('Could not dynamically require "' + e22 + '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.');
}
us(function e21(t2, n2, r2) {
  function i2(a3, s2) {
    if (!n2[a3]) {
      if (!t2[a3]) {
        if (!s2 && xG)
          return xG(a3);
        if (o2)
          return o2(a3, true);
        var u2 = new Error("Cannot find module '" + a3 + "'");
        throw u2.code = "MODULE_NOT_FOUND", u2;
      }
      var c2 = n2[a3] = { exports: {} };
      t2[a3][0].call(c2.exports, function(e22) {
        return i2(t2[a3][1][e22] || e22);
      }, c2, c2.exports, e21, t2, n2, r2);
    }
    return n2[a3].exports;
  }
  for (var o2 = xG, a2 = 0; a2 < r2.length; a2++)
    i2(r2[a2]);
  return i2;
}({ 1: [function(n2, r2, i2) {
  Object.defineProperty(i2, "__esModule", { value: true }), i2.regexpCode = i2.getEsmExportName = i2.getProperty = i2.safeStringify = i2.stringify = i2.strConcat = i2.addCodeArg = i2.str = i2._ = i2.nil = i2._Code = i2.Name = i2.IDENTIFIER = i2._CodeOrName = void 0;
  var o2 = zi(function e22() {
    Ri(this, e22);
  });
  i2._CodeOrName = o2, i2.IDENTIFIER = /^[a-z$_][a-z$_0-9]*$/i;
  var a2 = function(e22) {
    ji(n3, e22);
    var t2 = Ci(n3);
    function n3(e23) {
      var r3;
      if (Ri(this, n3), r3 = t2.call(this), !i2.IDENTIFIER.test(e23))
        throw new Error("CodeGen: name must be a valid identifier");
      return r3.str = e23, _i(r3);
    }
    return zi(n3, [{ key: "toString", value: function() {
      return this.str;
    } }, { key: "emptyStr", value: function() {
      return false;
    } }, { key: "names", get: function() {
      return Pi({}, this.str, 1);
    } }]), n3;
  }(o2);
  i2.Name = a2;
  var s2 = function(e22) {
    ji(n3, e22);
    var t2 = Ci(n3);
    function n3(e23) {
      var r3;
      return Ri(this, n3), (r3 = t2.call(this))._items = typeof e23 == "string" ? [e23] : e23, r3;
    }
    return zi(n3, [{ key: "toString", value: function() {
      return this.str;
    } }, { key: "emptyStr", value: function() {
      if (this._items.length > 1)
        return false;
      var e23 = this._items[0];
      return e23 === "" || e23 === '""';
    } }, { key: "str", get: function() {
      var e23;
      return (e23 = this._str) !== null && e23 !== void 0 ? e23 : this._str = this._items.reduce(function(e24, t3) {
        return "".concat(e24).concat(t3);
      }, "");
    } }, { key: "names", get: function() {
      var e23;
      return (e23 = this._names) !== null && e23 !== void 0 ? e23 : this._names = this._items.reduce(function(e24, t3) {
        return t3 instanceof a2 && (e24[t3.str] = (e24[t3.str] || 0) + 1), e24;
      }, {});
    } }]), n3;
  }(o2);
  function u2(e22) {
    for (var t2 = [e22[0]], n3 = 0, r3 = arguments.length, i3 = new Array(r3 > 1 ? r3 - 1 : 0), o3 = 1; o3 < r3; o3++)
      i3[o3 - 1] = arguments[o3];
    for (; n3 < i3.length; )
      f2(t2, i3[n3]), t2.push(e22[++n3]);
    return new s2(t2);
  }
  i2._Code = s2, i2.nil = new s2(""), i2._ = u2;
  var c2 = new s2("+");
  function l2(e22) {
    for (var t2 = [d2(e22[0])], n3 = 0, r3 = arguments.length, i3 = new Array(r3 > 1 ? r3 - 1 : 0), o3 = 1; o3 < r3; o3++)
      i3[o3 - 1] = arguments[o3];
    for (; n3 < i3.length; )
      t2.push(c2), f2(t2, i3[n3]), t2.push(c2, d2(e22[++n3]));
    return function(e23) {
      for (var t3 = 1; t3 < e23.length - 1; ) {
        if (e23[t3] === c2) {
          var n4 = h2(e23[t3 - 1], e23[t3 + 1]);
          if (n4 !== void 0) {
            e23.splice(t3 - 1, 3, n4);
            continue;
          }
          e23[t3++] = "+";
        }
        t3++;
      }
    }(t2), new s2(t2);
  }
  function f2(e22, t2) {
    var n3;
    t2 instanceof s2 ? e22.push.apply(e22, Ni(t2._items)) : e22.push(t2 instanceof a2 ? t2 : typeof (n3 = t2) == "number" || typeof n3 == "boolean" || n3 === null ? n3 : d2(Array.isArray(n3) ? n3.join(",") : n3));
  }
  function h2(e22, t2) {
    if (t2 === '""')
      return e22;
    if (e22 === '""')
      return t2;
    if (typeof e22 == "string") {
      if (t2 instanceof a2 || e22[e22.length - 1] !== '"')
        return;
      return typeof t2 != "string" ? "".concat(e22.slice(0, -1)).concat(t2, '"') : t2[0] === '"' ? e22.slice(0, -1) + t2.slice(1) : void 0;
    }
    return typeof t2 != "string" || t2[0] !== '"' || e22 instanceof a2 ? void 0 : '"'.concat(e22).concat(t2.slice(1));
  }
  function d2(e22) {
    return JSON.stringify(e22).replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
  }
  i2.str = l2, i2.addCodeArg = f2, i2.strConcat = function(t2, n3) {
    return n3.emptyStr() ? t2 : t2.emptyStr() ? n3 : l2(e || (e = pi(["", "", ""])), t2, n3);
  }, i2.stringify = function(e22) {
    return new s2(d2(e22));
  }, i2.safeStringify = d2, i2.getProperty = function(e22) {
    return typeof e22 == "string" && i2.IDENTIFIER.test(e22) ? new s2(".".concat(e22)) : u2(t || (t = pi(["[", "]"])), e22);
  }, i2.getEsmExportName = function(e22) {
    if (typeof e22 == "string" && i2.IDENTIFIER.test(e22))
      return new s2("".concat(e22));
    throw new Error("CodeGen: invalid export name: ".concat(e22, ", use explicit $id name mapping"));
  }, i2.regexpCode = function(e22) {
    return new s2(e22.toString());
  };
}, {}], 2: [function(e22, t2, u2) {
  Object.defineProperty(u2, "__esModule", { value: true }), u2.or = u2.and = u2.not = u2.CodeGen = u2.operators = u2.varKinds = u2.ValueScopeName = u2.ValueScope = u2.Scope = u2.Name = u2.regexpCode = u2.stringify = u2.getProperty = u2.nil = u2.strConcat = u2.str = u2._ = void 0;
  var c2 = e22("./code"), l2 = e22("./scope"), f2 = e22("./code");
  Object.defineProperty(u2, "_", { enumerable: true, get: function() {
    return f2._;
  } }), Object.defineProperty(u2, "str", { enumerable: true, get: function() {
    return f2.str;
  } }), Object.defineProperty(u2, "strConcat", { enumerable: true, get: function() {
    return f2.strConcat;
  } }), Object.defineProperty(u2, "nil", { enumerable: true, get: function() {
    return f2.nil;
  } }), Object.defineProperty(u2, "getProperty", { enumerable: true, get: function() {
    return f2.getProperty;
  } }), Object.defineProperty(u2, "stringify", { enumerable: true, get: function() {
    return f2.stringify;
  } }), Object.defineProperty(u2, "regexpCode", { enumerable: true, get: function() {
    return f2.regexpCode;
  } }), Object.defineProperty(u2, "Name", { enumerable: true, get: function() {
    return f2.Name;
  } });
  var h2 = e22("./scope");
  Object.defineProperty(u2, "Scope", { enumerable: true, get: function() {
    return h2.Scope;
  } }), Object.defineProperty(u2, "ValueScope", { enumerable: true, get: function() {
    return h2.ValueScope;
  } }), Object.defineProperty(u2, "ValueScopeName", { enumerable: true, get: function() {
    return h2.ValueScopeName;
  } }), Object.defineProperty(u2, "varKinds", { enumerable: true, get: function() {
    return h2.varKinds;
  } }), u2.operators = { GT: new c2._Code(">"), GTE: new c2._Code(">="), LT: new c2._Code("<"), LTE: new c2._Code("<="), EQ: new c2._Code("==="), NEQ: new c2._Code("!=="), NOT: new c2._Code("!"), OR: new c2._Code("||"), AND: new c2._Code("&&"), ADD: new c2._Code("+") };
  var d2 = function() {
    function e23() {
      Ri(this, e23);
    }
    return zi(e23, [{ key: "optimizeNodes", value: function() {
      return this;
    } }, { key: "optimizeNames", value: function(e24, t3) {
      return this;
    } }]), e23;
  }(), v2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24, r2, i2) {
      var o2;
      return Ri(this, n2), (o2 = t3.call(this)).varKind = e24, o2.name = r2, o2.rhs = i2, o2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = e24.es5, n3 = e24._n;
      return "".concat(t4 ? l2.varKinds.var : this.varKind, " ").concat(this.name).concat(this.rhs === void 0 ? "" : " = ".concat(this.rhs), ";") + n3;
    } }, { key: "optimizeNames", value: function(e24, t4) {
      if (e24[this.name.str])
        return this.rhs && (this.rhs = D2(this.rhs, e24, t4)), this;
    } }, { key: "names", get: function() {
      return this.rhs instanceof c2._CodeOrName ? this.rhs.names : {};
    } }]), n2;
  }(d2), p2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24, r2, i2) {
      var o2;
      return Ri(this, n2), (o2 = t3.call(this)).lhs = e24, o2.rhs = r2, o2.sideEffects = i2, o2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = e24._n;
      return "".concat(this.lhs, " = ").concat(this.rhs, ";") + t4;
    } }, { key: "optimizeNames", value: function(e24, t4) {
      if (!(this.lhs instanceof c2.Name) || e24[this.lhs.str] || this.sideEffects)
        return this.rhs = D2(this.rhs, e24, t4), this;
    } }, { key: "names", get: function() {
      return R2(this.lhs instanceof c2.Name ? {} : Ei({}, this.lhs.names), this.rhs);
    } }]), n2;
  }(d2), m2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24, r2, i2, o2) {
      var a2;
      return Ri(this, n2), (a2 = t3.call(this, e24, i2, o2)).op = r2, a2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = e24._n;
      return "".concat(this.lhs, " ").concat(this.op, "= ").concat(this.rhs, ";") + t4;
    } }]), n2;
  }(p2), g2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24) {
      var r2;
      return Ri(this, n2), (r2 = t3.call(this)).label = e24, r2.names = {}, r2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = e24._n;
      return "".concat(this.label, ":") + t4;
    } }]), n2;
  }(d2), y2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24) {
      var r2;
      return Ri(this, n2), (r2 = t3.call(this)).label = e24, r2.names = {}, r2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = e24._n;
      return "break".concat(this.label ? " ".concat(this.label) : "", ";") + t4;
    } }]), n2;
  }(d2), b2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24) {
      var r2;
      return Ri(this, n2), (r2 = t3.call(this)).error = e24, r2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = e24._n;
      return "throw ".concat(this.error, ";") + t4;
    } }, { key: "names", get: function() {
      return this.error.names;
    } }]), n2;
  }(d2), k2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24) {
      var r2;
      return Ri(this, n2), (r2 = t3.call(this)).code = e24, r2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = e24._n;
      return "".concat(this.code, ";") + t4;
    } }, { key: "optimizeNodes", value: function() {
      return "".concat(this.code) ? this : void 0;
    } }, { key: "optimizeNames", value: function(e24, t4) {
      return this.code = D2(this.code, e24, t4), this;
    } }, { key: "names", get: function() {
      return this.code instanceof c2._CodeOrName ? this.code.names : {};
    } }]), n2;
  }(d2), w2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2() {
      var e24, r2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
      return Ri(this, n2), (e24 = t3.call(this)).nodes = r2, e24;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      return this.nodes.reduce(function(t4, n3) {
        return t4 + n3.render(e24);
      }, "");
    } }, { key: "optimizeNodes", value: function() {
      for (var e24 = this.nodes, t4 = e24.length; t4--; ) {
        var n3 = e24[t4].optimizeNodes();
        Array.isArray(n3) ? e24.splice.apply(e24, [t4, 1].concat(Ni(n3))) : n3 ? e24[t4] = n3 : e24.splice(t4, 1);
      }
      return e24.length > 0 ? this : void 0;
    } }, { key: "optimizeNames", value: function(e24, t4) {
      for (var n3 = this.nodes, r2 = n3.length; r2--; ) {
        var i2 = n3[r2];
        i2.optimizeNames(e24, t4) || (z2(e24, i2.names), n3.splice(r2, 1));
      }
      return n3.length > 0 ? this : void 0;
    } }, { key: "names", get: function() {
      return this.nodes.reduce(function(e24, t4) {
        return I2(e24, t4.names);
      }, {});
    } }]), n2;
  }(d2), x2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2() {
      return Ri(this, n2), t3.apply(this, arguments);
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      return "{" + e24._n + ki(Ai(n2.prototype), "render", this).call(this, e24) + "}" + e24._n;
    } }]), n2;
  }(w2), j2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2() {
      return Ri(this, n2), t3.apply(this, arguments);
    }
    return zi(n2);
  }(w2), S2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2() {
      return Ri(this, n2), t3.apply(this, arguments);
    }
    return zi(n2);
  }(x2);
  S2.kind = "else";
  var C2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24, r2) {
      var i2;
      return Ri(this, n2), (i2 = t3.call(this, r2)).condition = e24, i2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = "if(".concat(this.condition, ")") + ki(Ai(n2.prototype), "render", this).call(this, e24);
      return this.else && (t4 += "else " + this.else.render(e24)), t4;
    } }, { key: "optimizeNodes", value: function() {
      ki(Ai(n2.prototype), "optimizeNodes", this).call(this);
      var e24 = this.condition;
      if (e24 === true)
        return this.nodes;
      var t4 = this.else;
      if (t4) {
        var r2 = t4.optimizeNodes();
        t4 = this.else = Array.isArray(r2) ? new S2(r2) : r2;
      }
      return t4 ? e24 === false ? t4 instanceof n2 ? t4 : t4.nodes : this.nodes.length ? this : new n2(L2(e24), t4 instanceof n2 ? [t4] : t4.nodes) : e24 !== false && this.nodes.length ? this : void 0;
    } }, { key: "optimizeNames", value: function(e24, t4) {
      var r2;
      if (this.else = (r2 = this.else) === null || r2 === void 0 ? void 0 : r2.optimizeNames(e24, t4), ki(Ai(n2.prototype), "optimizeNames", this).call(this, e24, t4) || this.else)
        return this.condition = D2(this.condition, e24, t4), this;
    } }, { key: "names", get: function() {
      var e24 = ki(Ai(n2.prototype), "names", this);
      return R2(e24, this.condition), this.else && I2(e24, this.else.names), e24;
    } }]), n2;
  }(x2);
  C2.kind = "if";
  var _2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2() {
      return Ri(this, n2), t3.apply(this, arguments);
    }
    return zi(n2);
  }(x2);
  _2.kind = "for";
  var $2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24) {
      var r2;
      return Ri(this, n2), (r2 = t3.call(this)).iteration = e24, r2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      return "for(".concat(this.iteration, ")") + ki(Ai(n2.prototype), "render", this).call(this, e24);
    } }, { key: "optimizeNames", value: function(e24, t4) {
      if (ki(Ai(n2.prototype), "optimizeNames", this).call(this, e24, t4))
        return this.iteration = D2(this.iteration, e24, t4), this;
    } }, { key: "names", get: function() {
      return I2(ki(Ai(n2.prototype), "names", this), this.iteration.names);
    } }]), n2;
  }(_2), O2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24, r2, i2, o2) {
      var a2;
      return Ri(this, n2), (a2 = t3.call(this)).varKind = e24, a2.name = r2, a2.from = i2, a2.to = o2, a2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = e24.es5 ? l2.varKinds.var : this.varKind, r2 = this.name, i2 = this.from, o2 = this.to;
      return "for(".concat(t4, " ").concat(r2, "=").concat(i2, "; ").concat(r2, "<").concat(o2, "; ").concat(r2, "++)") + ki(Ai(n2.prototype), "render", this).call(this, e24);
    } }, { key: "names", get: function() {
      var e24 = R2(ki(Ai(n2.prototype), "names", this), this.from);
      return R2(e24, this.to);
    } }]), n2;
  }(_2), A2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24, r2, i2, o2) {
      var a2;
      return Ri(this, n2), (a2 = t3.call(this)).loop = e24, a2.varKind = r2, a2.name = i2, a2.iterable = o2, a2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      return "for(".concat(this.varKind, " ").concat(this.name, " ").concat(this.loop, " ").concat(this.iterable, ")") + ki(Ai(n2.prototype), "render", this).call(this, e24);
    } }, { key: "optimizeNames", value: function(e24, t4) {
      if (ki(Ai(n2.prototype), "optimizeNames", this).call(this, e24, t4))
        return this.iterable = D2(this.iterable, e24, t4), this;
    } }, { key: "names", get: function() {
      return I2(ki(Ai(n2.prototype), "names", this), this.iterable.names);
    } }]), n2;
  }(_2), M2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24, r2, i2) {
      var o2;
      return Ri(this, n2), (o2 = t3.call(this)).name = e24, o2.args = r2, o2.async = i2, o2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      return "".concat(this.async ? "async " : "", "function ").concat(this.name, "(").concat(this.args, ")") + ki(Ai(n2.prototype), "render", this).call(this, e24);
    } }]), n2;
  }(x2);
  M2.kind = "func";
  var E2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2() {
      return Ri(this, n2), t3.apply(this, arguments);
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      return "return " + ki(Ai(n2.prototype), "render", this).call(this, e24);
    } }]), n2;
  }(w2);
  E2.kind = "return";
  var P2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2() {
      return Ri(this, n2), t3.apply(this, arguments);
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      var t4 = "try" + ki(Ai(n2.prototype), "render", this).call(this, e24);
      return this.catch && (t4 += this.catch.render(e24)), this.finally && (t4 += this.finally.render(e24)), t4;
    } }, { key: "optimizeNodes", value: function() {
      var e24, t4;
      return ki(Ai(n2.prototype), "optimizeNodes", this).call(this), (e24 = this.catch) === null || e24 === void 0 || e24.optimizeNodes(), (t4 = this.finally) === null || t4 === void 0 || t4.optimizeNodes(), this;
    } }, { key: "optimizeNames", value: function(e24, t4) {
      var r2, i2;
      return ki(Ai(n2.prototype), "optimizeNames", this).call(this, e24, t4), (r2 = this.catch) === null || r2 === void 0 || r2.optimizeNames(e24, t4), (i2 = this.finally) === null || i2 === void 0 || i2.optimizeNames(e24, t4), this;
    } }, { key: "names", get: function() {
      var e24 = ki(Ai(n2.prototype), "names", this);
      return this.catch && I2(e24, this.catch.names), this.finally && I2(e24, this.finally.names), e24;
    } }]), n2;
  }(x2), N2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2(e24) {
      var r2;
      return Ri(this, n2), (r2 = t3.call(this)).error = e24, r2;
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      return "catch(".concat(this.error, ")") + ki(Ai(n2.prototype), "render", this).call(this, e24);
    } }]), n2;
  }(x2);
  N2.kind = "catch";
  var T2 = function(e23) {
    ji(n2, e23);
    var t3 = Ci(n2);
    function n2() {
      return Ri(this, n2), t3.apply(this, arguments);
    }
    return zi(n2, [{ key: "render", value: function(e24) {
      return "finally" + ki(Ai(n2.prototype), "render", this).call(this, e24);
    } }]), n2;
  }(x2);
  function I2(e23, t3) {
    for (var n2 in t3)
      e23[n2] = (e23[n2] || 0) + (t3[n2] || 0);
    return e23;
  }
  function R2(e23, t3) {
    return t3 instanceof c2._CodeOrName ? I2(e23, t3.names) : e23;
  }
  function D2(e23, t3, n2) {
    return e23 instanceof c2.Name ? i2(e23) : (r2 = e23) instanceof c2._Code && r2._items.some(function(e24) {
      return e24 instanceof c2.Name && t3[e24.str] === 1 && n2[e24.str] !== void 0;
    }) ? new c2._Code(e23._items.reduce(function(e24, t4) {
      return t4 instanceof c2.Name && (t4 = i2(t4)), t4 instanceof c2._Code ? e24.push.apply(e24, Ni(t4._items)) : e24.push(t4), e24;
    }, [])) : e23;
    var r2;
    function i2(e24) {
      var r3 = n2[e24.str];
      return r3 === void 0 || t3[e24.str] !== 1 ? e24 : (delete t3[e24.str], r3);
    }
  }
  function z2(e23, t3) {
    for (var n2 in t3)
      e23[n2] = (e23[n2] || 0) - (t3[n2] || 0);
  }
  function L2(e23) {
    return typeof e23 == "boolean" || typeof e23 == "number" || e23 === null ? !e23 : c2._(n || (n = pi(["!", ""])), V2(e23));
  }
  T2.kind = "finally", u2.CodeGen = function() {
    function e23(t3) {
      var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
      Ri(this, e23), this._values = {}, this._blockStarts = [], this._constants = {}, this.opts = Ei(Ei({}, n2), {}, { _n: n2.lines ? "\n" : "" }), this._extScope = t3, this._scope = new l2.Scope({ parent: t3 }), this._nodes = [new j2()];
    }
    return zi(e23, [{ key: "toString", value: function() {
      return this._root.render(this.opts);
    } }, { key: "name", value: function(e24) {
      return this._scope.name(e24);
    } }, { key: "scopeName", value: function(e24) {
      return this._extScope.name(e24);
    } }, { key: "scopeValue", value: function(e24, t3) {
      var n2 = this._extScope.value(e24, t3);
      return (this._values[n2.prefix] || (this._values[n2.prefix] = /* @__PURE__ */ new Set())).add(n2), n2;
    } }, { key: "getScopeValue", value: function(e24, t3) {
      return this._extScope.getValue(e24, t3);
    } }, { key: "scopeRefs", value: function(e24) {
      return this._extScope.scopeRefs(e24, this._values);
    } }, { key: "scopeCode", value: function() {
      return this._extScope.scopeCode(this._values);
    } }, { key: "_def", value: function(e24, t3, n2, r2) {
      var i2 = this._scope.toName(t3);
      return n2 !== void 0 && r2 && (this._constants[i2.str] = n2), this._leafNode(new v2(e24, i2, n2)), i2;
    } }, { key: "const", value: function(e24, t3, n2) {
      return this._def(l2.varKinds.const, e24, t3, n2);
    } }, { key: "let", value: function(e24, t3, n2) {
      return this._def(l2.varKinds.let, e24, t3, n2);
    } }, { key: "var", value: function(e24, t3, n2) {
      return this._def(l2.varKinds.var, e24, t3, n2);
    } }, { key: "assign", value: function(e24, t3, n2) {
      return this._leafNode(new p2(e24, t3, n2));
    } }, { key: "add", value: function(e24, t3) {
      return this._leafNode(new m2(e24, u2.operators.ADD, t3));
    } }, { key: "code", value: function(e24) {
      return typeof e24 == "function" ? e24() : e24 !== c2.nil && this._leafNode(new k2(e24)), this;
    } }, { key: "object", value: function() {
      for (var e24 = ["{"], t3 = arguments.length, n2 = new Array(t3), r2 = 0; r2 < t3; r2++)
        n2[r2] = arguments[r2];
      for (var i2 = 0, o2 = n2; i2 < o2.length; i2++) {
        var a2 = xi(o2[i2], 2), s2 = a2[0], u3 = a2[1];
        e24.length > 1 && e24.push(","), e24.push(s2), (s2 !== u3 || this.opts.es5) && (e24.push(":"), (0, c2.addCodeArg)(e24, u3));
      }
      return e24.push("}"), new c2._Code(e24);
    } }, { key: "if", value: function(e24, t3, n2) {
      if (this._blockNode(new C2(e24)), t3 && n2)
        this.code(t3).else().code(n2).endIf();
      else if (t3)
        this.code(t3).endIf();
      else if (n2)
        throw new Error('CodeGen: "else" body without "then" body');
      return this;
    } }, { key: "elseIf", value: function(e24) {
      return this._elseNode(new C2(e24));
    } }, { key: "else", value: function() {
      return this._elseNode(new S2());
    } }, { key: "endIf", value: function() {
      return this._endBlockNode(C2, S2);
    } }, { key: "_for", value: function(e24, t3) {
      return this._blockNode(e24), t3 && this.code(t3).endFor(), this;
    } }, { key: "for", value: function(e24, t3) {
      return this._for(new $2(e24), t3);
    } }, { key: "forRange", value: function(e24, t3, n2, r2) {
      var i2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : this.opts.es5 ? l2.varKinds.var : l2.varKinds.let, o2 = this._scope.toName(e24);
      return this._for(new O2(i2, o2, t3, n2), function() {
        return r2(o2);
      });
    } }, { key: "forOf", value: function(e24, t3, n2) {
      var o2 = this, a2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : l2.varKinds.const, s2 = this._scope.toName(e24);
      if (this.opts.es5) {
        var u3 = t3 instanceof c2.Name ? t3 : this.var("_arr", t3);
        return this.forRange("_i", 0, c2._(r || (r = pi(["", ".length"])), u3), function(e25) {
          o2.var(s2, c2._(i || (i = pi(["", "[", "]"])), u3, e25)), n2(s2);
        });
      }
      return this._for(new A2("of", a2, s2, t3), function() {
        return n2(s2);
      });
    } }, { key: "forIn", value: function(e24, t3, n2) {
      var r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : this.opts.es5 ? l2.varKinds.var : l2.varKinds.const;
      if (this.opts.ownProperties)
        return this.forOf(e24, c2._(o || (o = pi(["Object.keys(", ")"])), t3), n2);
      var i2 = this._scope.toName(e24);
      return this._for(new A2("in", r2, i2, t3), function() {
        return n2(i2);
      });
    } }, { key: "endFor", value: function() {
      return this._endBlockNode(_2);
    } }, { key: "label", value: function(e24) {
      return this._leafNode(new g2(e24));
    } }, { key: "break", value: function(e24) {
      return this._leafNode(new y2(e24));
    } }, { key: "return", value: function(e24) {
      var t3 = new E2();
      if (this._blockNode(t3), this.code(e24), t3.nodes.length !== 1)
        throw new Error('CodeGen: "return" should have one node');
      return this._endBlockNode(E2);
    } }, { key: "try", value: function(e24, t3, n2) {
      if (!t3 && !n2)
        throw new Error('CodeGen: "try" without "catch" and "finally"');
      var r2 = new P2();
      if (this._blockNode(r2), this.code(e24), t3) {
        var i2 = this.name("e");
        this._currNode = r2.catch = new N2(i2), t3(i2);
      }
      return n2 && (this._currNode = r2.finally = new T2(), this.code(n2)), this._endBlockNode(N2, T2);
    } }, { key: "throw", value: function(e24) {
      return this._leafNode(new b2(e24));
    } }, { key: "block", value: function(e24, t3) {
      return this._blockStarts.push(this._nodes.length), e24 && this.code(e24).endBlock(t3), this;
    } }, { key: "endBlock", value: function(e24) {
      var t3 = this._blockStarts.pop();
      if (t3 === void 0)
        throw new Error("CodeGen: not in self-balancing block");
      var n2 = this._nodes.length - t3;
      if (n2 < 0 || e24 !== void 0 && n2 !== e24)
        throw new Error("CodeGen: wrong number of nodes: ".concat(n2, " vs ").concat(e24, " expected"));
      return this._nodes.length = t3, this;
    } }, { key: "func", value: function(e24) {
      var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : c2.nil, n2 = arguments.length > 2 ? arguments[2] : void 0, r2 = arguments.length > 3 ? arguments[3] : void 0;
      return this._blockNode(new M2(e24, t3, n2)), r2 && this.code(r2).endFunc(), this;
    } }, { key: "endFunc", value: function() {
      return this._endBlockNode(M2);
    } }, { key: "optimize", value: function() {
      for (var e24 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 1; e24-- > 0; )
        this._root.optimizeNodes(), this._root.optimizeNames(this._root.names, this._constants);
    } }, { key: "_leafNode", value: function(e24) {
      return this._currNode.nodes.push(e24), this;
    } }, { key: "_blockNode", value: function(e24) {
      this._currNode.nodes.push(e24), this._nodes.push(e24);
    } }, { key: "_endBlockNode", value: function(e24, t3) {
      var n2 = this._currNode;
      if (n2 instanceof e24 || t3 && n2 instanceof t3)
        return this._nodes.pop(), this;
      throw new Error('CodeGen: not in block "'.concat(t3 ? "".concat(e24.kind, "/").concat(t3.kind) : e24.kind, '"'));
    } }, { key: "_elseNode", value: function(e24) {
      var t3 = this._currNode;
      if (!(t3 instanceof C2))
        throw new Error('CodeGen: "else" without "if"');
      return this._currNode = t3.else = e24, this;
    } }, { key: "_root", get: function() {
      return this._nodes[0];
    } }, { key: "_currNode", get: function() {
      var e24 = this._nodes;
      return e24[e24.length - 1];
    }, set: function(e24) {
      var t3 = this._nodes;
      t3[t3.length - 1] = e24;
    } }]), e23;
  }(), u2.not = L2;
  var B2 = F2(u2.operators.AND);
  u2.and = function() {
    for (var e23 = arguments.length, t3 = new Array(e23), n2 = 0; n2 < e23; n2++)
      t3[n2] = arguments[n2];
    return t3.reduce(B2);
  };
  var q2 = F2(u2.operators.OR);
  function F2(e23) {
    return function(t3, n2) {
      return t3 === c2.nil ? n2 : n2 === c2.nil ? t3 : c2._(a || (a = pi(["", " ", " ", ""])), V2(t3), e23, V2(n2));
    };
  }
  function V2(e23) {
    return e23 instanceof c2.Name ? e23 : c2._(s || (s = pi(["(", ")"])), e23);
  }
  u2.or = function() {
    for (var e23 = arguments.length, t3 = new Array(e23), n2 = 0; n2 < e23; n2++)
      t3[n2] = arguments[n2];
    return t3.reduce(q2);
  };
}, { "./code": 1, "./scope": 3 }], 3: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.ValueScope = n2.ValueScopeName = n2.Scope = n2.varKinds = n2.UsedValueState = void 0;
  var r2, i2 = e22("./code"), o2 = function(e23) {
    ji(n3, di(Error));
    var t3 = Ci(n3);
    function n3(e24) {
      var r3;
      return Ri(this, n3), (r3 = t3.call(this, 'CodeGen: "code" for '.concat(e24, " not defined"))).value = e24.value, r3;
    }
    return zi(n3);
  }();
  !function(e23) {
    e23[e23.Started = 0] = "Started", e23[e23.Completed = 1] = "Completed";
  }(r2 = n2.UsedValueState || (n2.UsedValueState = {})), n2.varKinds = { const: new i2.Name("const"), let: new i2.Name("let"), var: new i2.Name("var") };
  var a2 = function() {
    function e23() {
      var t3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, n3 = t3.prefixes, r3 = t3.parent;
      Ri(this, e23), this._names = {}, this._prefixes = n3, this._parent = r3;
    }
    return zi(e23, [{ key: "toName", value: function(e24) {
      return e24 instanceof i2.Name ? e24 : this.name(e24);
    } }, { key: "name", value: function(e24) {
      return new i2.Name(this._newName(e24));
    } }, { key: "_newName", value: function(e24) {
      return "".concat(e24).concat((this._names[e24] || this._nameGroup(e24)).index++);
    } }, { key: "_nameGroup", value: function(e24) {
      var t3, n3;
      if (((n3 = (t3 = this._parent) === null || t3 === void 0 ? void 0 : t3._prefixes) === null || n3 === void 0 ? void 0 : n3.has(e24)) || this._prefixes && !this._prefixes.has(e24))
        throw new Error('CodeGen: prefix "'.concat(e24, '" is not allowed in this scope'));
      return this._names[e24] = { prefix: e24, index: 0 };
    } }]), e23;
  }();
  n2.Scope = a2;
  var s2 = function(e23) {
    ji(n3, e23);
    var t3 = Ci(n3);
    function n3(e24, r3) {
      var i3;
      return Ri(this, n3), (i3 = t3.call(this, r3)).prefix = e24, i3;
    }
    return zi(n3, [{ key: "setValue", value: function(e24, t4) {
      var n4 = t4.property, r3 = t4.itemIndex;
      this.value = e24, this.scopePath = i2._(u || (u = pi([".", "[", "]"])), new i2.Name(n4), r3);
    } }]), n3;
  }(i2.Name);
  n2.ValueScopeName = s2;
  var d2 = i2._(c || (c = pi(["\n"], ["\\n"])));
  n2.ValueScope = function(e23) {
    ji(a3, e23);
    var t3 = Ci(a3);
    function a3(e24) {
      var n3;
      return Ri(this, a3), (n3 = t3.call(this, e24))._values = {}, n3._scope = e24.scope, n3.opts = Ei(Ei({}, e24), {}, { _n: e24.lines ? d2 : i2.nil }), n3;
    }
    return zi(a3, [{ key: "get", value: function() {
      return this._scope;
    } }, { key: "name", value: function(e24) {
      return new s2(e24, this._newName(e24));
    } }, { key: "value", value: function(e24, t4) {
      var n3;
      if (t4.ref === void 0)
        throw new Error("CodeGen: ref must be passed in value");
      var r3 = this.toName(e24), i3 = r3.prefix, o3 = (n3 = t4.key) !== null && n3 !== void 0 ? n3 : t4.ref, a4 = this._values[i3];
      if (a4) {
        var s3 = a4.get(o3);
        if (s3)
          return s3;
      } else
        a4 = this._values[i3] = /* @__PURE__ */ new Map();
      a4.set(o3, r3);
      var u2 = this._scope[i3] || (this._scope[i3] = []), c2 = u2.length;
      return u2[c2] = t4.ref, r3.setValue(t4, { property: i3, itemIndex: c2 }), r3;
    } }, { key: "getValue", value: function(e24, t4) {
      var n3 = this._values[e24];
      if (n3)
        return n3.get(t4);
    } }, { key: "scopeRefs", value: function(e24) {
      var t4 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this._values;
      return this._reduceValues(t4, function(t5) {
        if (t5.scopePath === void 0)
          throw new Error('CodeGen: name "'.concat(t5, '" has no value'));
        return i2._(l || (l = pi(["", "", ""])), e24, t5.scopePath);
      });
    } }, { key: "scopeCode", value: function() {
      var e24 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this._values, t4 = arguments.length > 1 ? arguments[1] : void 0, n3 = arguments.length > 2 ? arguments[2] : void 0;
      return this._reduceValues(e24, function(e25) {
        if (e25.value === void 0)
          throw new Error('CodeGen: name "'.concat(e25, '" has no value'));
        return e25.value.code;
      }, t4, n3);
    } }, { key: "_reduceValues", value: function(e24, t4) {
      var a4 = this, s3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, u2 = arguments.length > 3 ? arguments[3] : void 0, c2 = i2.nil, l2 = function(l3) {
        var d4 = e24[l3];
        if (!d4)
          return "continue";
        var v2 = s3[l3] = s3[l3] || /* @__PURE__ */ new Map();
        d4.forEach(function(e25) {
          if (!v2.has(e25)) {
            v2.set(e25, r2.Started);
            var s4 = t4(e25);
            if (s4)
              c2 = i2._(f || (f = pi(["", "", " ", " = ", ";", ""])), c2, a4.opts.es5 ? n2.varKinds.var : n2.varKinds.const, e25, s4, a4.opts._n);
            else {
              if (!(s4 = u2 == null ? void 0 : u2(e25)))
                throw new o2(e25);
              c2 = i2._(h || (h = pi(["", "", "", ""])), c2, s4, a4.opts._n);
            }
            v2.set(e25, r2.Completed);
          }
        });
      };
      for (var d3 in e24)
        l2(d3);
      return c2;
    } }]), a3;
  }(a2);
}, { "./code": 1 }], 4: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.extendErrors = n2.resetErrorsCount = n2.reportExtraError = n2.reportError = n2.keyword$DataError = n2.keywordError = void 0;
  var r2 = e22("./codegen"), i2 = e22("./util"), o2 = e22("./names");
  function a2(e23, t3) {
    var n3 = e23.const("err", t3);
    e23.if(r2._(d || (d = pi(["", " === null"])), o2.default.vErrors), function() {
      return e23.assign(o2.default.vErrors, r2._(v || (v = pi(["[", "]"])), n3));
    }, r2._(p || (p = pi(["", ".push(", ")"])), o2.default.vErrors, n3)), e23.code(r2._(m || (m = pi(["", "++"])), o2.default.errors));
  }
  function s2(e23, t3) {
    var n3 = e23.gen, i3 = e23.validateName;
    e23.schemaEnv.$async ? n3.throw(r2._(g || (g = pi(["new ", "(", ")"])), e23.ValidationError, t3)) : (n3.assign(r2._(y || (y = pi(["", ".errors"])), i3), t3), n3.return(false));
  }
  n2.keywordError = { message: function(e23) {
    var t3 = e23.keyword;
    return r2.str(b || (b = pi(['must pass "', '" keyword validation'])), t3);
  } }, n2.keyword$DataError = { message: function(e23) {
    var t3 = e23.keyword, n3 = e23.schemaType;
    return n3 ? r2.str(k || (k = pi(['"', '" keyword must be ', " ($data)"])), t3, n3) : r2.str(w || (w = pi(['"', '" keyword is invalid ($data)'])), t3);
  } }, n2.reportError = function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : n2.keywordError, i3 = arguments.length > 2 ? arguments[2] : void 0, o3 = arguments.length > 3 ? arguments[3] : void 0, u3 = e23.it, l3 = u3.gen, f3 = u3.compositeRule, h2 = u3.allErrors, d2 = c2(e23, t3, i3);
    (o3 != null ? o3 : f3 || h2) ? a2(l3, d2) : s2(u3, r2._(x || (x = pi(["[", "]"])), d2));
  }, n2.reportExtraError = function(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : n2.keywordError, r3 = arguments.length > 2 ? arguments[2] : void 0, i3 = e23.it, u3 = i3.gen, l3 = i3.compositeRule, f3 = i3.allErrors;
    a2(u3, c2(e23, t3, r3)), l3 || f3 || s2(i3, o2.default.vErrors);
  }, n2.resetErrorsCount = function(e23, t3) {
    e23.assign(o2.default.errors, t3), e23.if(r2._(j || (j = pi(["", " !== null"])), o2.default.vErrors), function() {
      return e23.if(t3, function() {
        return e23.assign(r2._(S || (S = pi(["", ".length"])), o2.default.vErrors), t3);
      }, function() {
        return e23.assign(o2.default.vErrors, null);
      });
    });
  }, n2.extendErrors = function(e23) {
    var t3 = e23.gen, n3 = e23.keyword, i3 = e23.schemaValue, a3 = e23.data, s3 = e23.errsCount, u3 = e23.it;
    if (s3 === void 0)
      throw new Error("ajv implementation error");
    var c3 = t3.name("err");
    t3.forRange("i", s3, o2.default.errors, function(e24) {
      t3.const(c3, r2._(C || (C = pi(["", "[", "]"])), o2.default.vErrors, e24)), t3.if(r2._(_ || (_ = pi(["", ".instancePath === undefined"])), c3), function() {
        return t3.assign(r2._($ || ($ = pi(["", ".instancePath"])), c3), (0, r2.strConcat)(o2.default.instancePath, u3.errorPath));
      }), t3.assign(r2._(O || (O = pi(["", ".schemaPath"])), c3), r2.str(A || (A = pi(["", "/", ""])), u3.errSchemaPath, n3)), u3.opts.verbose && (t3.assign(r2._(M || (M = pi(["", ".schema"])), c3), i3), t3.assign(r2._(E || (E = pi(["", ".data"])), c3), a3));
    });
  };
  var u2 = { keyword: new r2.Name("keyword"), schemaPath: new r2.Name("schemaPath"), params: new r2.Name("params"), propertyName: new r2.Name("propertyName"), message: new r2.Name("message"), schema: new r2.Name("schema"), parentSchema: new r2.Name("parentSchema") };
  function c2(e23, t3, n3) {
    return e23.it.createErrors === false ? r2._(P || (P = pi(["{}"]))) : function(e24, t4) {
      var n4 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, i3 = e24.gen, a3 = [l2(e24.it, n4), f2(e24, n4)];
      return function(e25, t5, n5) {
        var i4 = t5.params, a4 = t5.message, s3 = e25.keyword, c3 = e25.data, l3 = e25.schemaValue, f3 = e25.it, h2 = f3.opts, d2 = f3.propertyName, v2 = f3.topSchemaRef, p2 = f3.schemaPath;
        n5.push([u2.keyword, s3], [u2.params, typeof i4 == "function" ? i4(e25) : i4 || r2._(N || (N = pi(["{}"])))]), h2.messages && n5.push([u2.message, typeof a4 == "function" ? a4(e25) : a4]), h2.verbose && n5.push([u2.schema, l3], [u2.parentSchema, r2._(T || (T = pi(["", "", ""])), v2, p2)], [o2.default.data, c3]), d2 && n5.push([u2.propertyName, d2]);
      }(e24, t4, a3), i3.object.apply(i3, a3);
    }(e23, t3, n3);
  }
  function l2(e23, t3) {
    var n3 = e23.errorPath, a3 = t3.instancePath, s3 = a3 ? r2.str(I || (I = pi(["", "", ""])), n3, (0, i2.getErrorPath)(a3, i2.Type.Str)) : n3;
    return [o2.default.instancePath, (0, r2.strConcat)(o2.default.instancePath, s3)];
  }
  function f2(e23, t3) {
    var n3 = e23.keyword, o3 = e23.it.errSchemaPath, a3 = t3.schemaPath, s3 = t3.parentSchema ? o3 : r2.str(R || (R = pi(["", "/", ""])), o3, n3);
    return a3 && (s3 = r2.str(D || (D = pi(["", "", ""])), s3, (0, i2.getErrorPath)(a3, i2.Type.Str))), [u2.schemaPath, s3];
  }
}, { "./codegen": 2, "./names": 6, "./util": 10 }], 5: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.resolveSchema = n2.getCompilingSchema = n2.resolveRef = n2.compileSchema = n2.SchemaEnv = void 0;
  var r2 = e22("./codegen"), i2 = e22("../runtime/validation_error"), o2 = e22("./names"), a2 = e22("./resolve"), s2 = e22("./util"), u2 = e22("./validate"), c2 = zi(function e23(t3) {
    var n3, r3;
    Ri(this, e23), this.refs = {}, this.dynamicAnchors = {}, Li(t3.schema) == "object" && (r3 = t3.schema), this.schema = t3.schema, this.schemaId = t3.schemaId, this.root = t3.root || this, this.baseId = (n3 = t3.baseId) !== null && n3 !== void 0 ? n3 : (0, a2.normalizeId)(r3 == null ? void 0 : r3[t3.schemaId || "$id"]), this.schemaPath = t3.schemaPath, this.localRefs = t3.localRefs, this.meta = t3.meta, this.$async = r3 == null ? void 0 : r3.$async, this.refs = {};
  });
  function l2(e23) {
    var t3 = h2.call(this, e23);
    if (t3)
      return t3;
    var n3, s3 = (0, a2.getFullPath)(this.opts.uriResolver, e23.root.baseId), c3 = this.opts.code, l3 = c3.es5, f3 = c3.lines, d3 = this.opts.ownProperties, v3 = new r2.CodeGen(this.scope, { es5: l3, lines: f3, ownProperties: d3 });
    e23.$async && (n3 = v3.scopeValue("Error", { ref: i2.default, code: r2._(z || (z = pi(['require("ajv/dist/runtime/validation_error").default']))) }));
    var p3 = v3.scopeName("validate");
    e23.validateName = p3;
    var m3, g2 = { gen: v3, allErrors: this.opts.allErrors, data: o2.default.data, parentData: o2.default.parentData, parentDataProperty: o2.default.parentDataProperty, dataNames: [o2.default.data], dataPathArr: [r2.nil], dataLevel: 0, dataTypes: [], definedProperties: /* @__PURE__ */ new Set(), topSchemaRef: v3.scopeValue("schema", this.opts.code.source === true ? { ref: e23.schema, code: (0, r2.stringify)(e23.schema) } : { ref: e23.schema }), validateName: p3, ValidationError: n3, schema: e23.schema, schemaEnv: e23, rootId: s3, baseId: e23.baseId || s3, schemaPath: r2.nil, errSchemaPath: e23.schemaPath || (this.opts.jtd ? "" : "#"), errorPath: r2._(L || (L = pi(['""']))), opts: this.opts, self: this };
    try {
      this._compilations.add(e23), (0, u2.validateFunctionCode)(g2), v3.optimize(this.opts.code.optimize);
      var y2 = v3.toString();
      m3 = "".concat(v3.scopeRefs(o2.default.scope), "return ").concat(y2), this.opts.code.process && (m3 = this.opts.code.process(m3, e23));
      var b2 = new Function("".concat(o2.default.self), "".concat(o2.default.scope), m3)(this, this.scope.get());
      if (this.scope.value(p3, { ref: b2 }), b2.errors = null, b2.schema = e23.schema, b2.schemaEnv = e23, e23.$async && (b2.$async = true), this.opts.code.source === true && (b2.source = { validateName: p3, validateCode: y2, scopeValues: v3._values }), this.opts.unevaluated) {
        var k2 = g2.props, w2 = g2.items;
        b2.evaluated = { props: k2 instanceof r2.Name ? void 0 : k2, items: w2 instanceof r2.Name ? void 0 : w2, dynamicProps: k2 instanceof r2.Name, dynamicItems: w2 instanceof r2.Name }, b2.source && (b2.source.evaluated = (0, r2.stringify)(b2.evaluated));
      }
      return e23.validate = b2, e23;
    } catch (t4) {
      throw delete e23.validate, delete e23.validateName, m3 && this.logger.error("Error compiling schema, function code:", m3), t4;
    } finally {
      this._compilations.delete(e23);
    }
  }
  function f2(e23) {
    return (0, a2.inlineRef)(e23.schema, this.opts.inlineRefs) ? e23.schema : e23.validate ? e23 : l2.call(this, e23);
  }
  function h2(e23) {
    var t3, n3, r3, i3 = bi(this._compilations);
    try {
      for (i3.s(); !(t3 = i3.n()).done; ) {
        var o3 = t3.value;
        if ((n3 = o3).schema === (r3 = e23).schema && n3.root === r3.root && n3.baseId === r3.baseId)
          return o3;
      }
    } catch (e24) {
      i3.e(e24);
    } finally {
      i3.f();
    }
  }
  function d2(e23, t3) {
    for (var n3; typeof (n3 = this.refs[t3]) == "string"; )
      t3 = n3;
    return n3 || this.schemas[t3] || v2.call(this, e23, t3);
  }
  function v2(e23, t3) {
    var n3 = this.opts.uriResolver.parse(t3), r3 = (0, a2._getFullPath)(this.opts.uriResolver, n3), i3 = (0, a2.getFullPath)(this.opts.uriResolver, e23.baseId, void 0);
    if (Object.keys(e23.schema).length > 0 && r3 === i3)
      return m2.call(this, n3, e23);
    var o3 = (0, a2.normalizeId)(r3), s3 = this.refs[o3] || this.schemas[o3];
    if (typeof s3 == "string") {
      var u3 = v2.call(this, e23, s3);
      if (Li(u3 == null ? void 0 : u3.schema) != "object")
        return;
      return m2.call(this, n3, u3);
    }
    if (Li(s3 == null ? void 0 : s3.schema) == "object") {
      if (s3.validate || l2.call(this, s3), o3 === (0, a2.normalizeId)(t3)) {
        var f3 = s3.schema, h3 = this.opts.schemaId, d3 = f3[h3];
        return d3 && (i3 = (0, a2.resolveUrl)(this.opts.uriResolver, i3, d3)), new c2({ schema: f3, schemaId: h3, root: e23, baseId: i3 });
      }
      return m2.call(this, n3, s3);
    }
  }
  n2.SchemaEnv = c2, n2.compileSchema = l2, n2.resolveRef = function(e23, t3, n3) {
    var r3;
    n3 = (0, a2.resolveUrl)(this.opts.uriResolver, t3, n3);
    var i3 = e23.refs[n3];
    if (i3)
      return i3;
    var o3 = d2.call(this, e23, n3);
    if (o3 === void 0) {
      var s3 = (r3 = e23.localRefs) === null || r3 === void 0 ? void 0 : r3[n3], u3 = this.opts.schemaId;
      s3 && (o3 = new c2({ schema: s3, schemaId: u3, root: e23, baseId: t3 }));
    }
    return o3 !== void 0 ? e23.refs[n3] = f2.call(this, o3) : void 0;
  }, n2.getCompilingSchema = h2, n2.resolveSchema = v2;
  var p2 = /* @__PURE__ */ new Set(["properties", "patternProperties", "enum", "dependencies", "definitions"]);
  function m2(e23, t3) {
    var n3, r3 = t3.baseId, i3 = t3.schema, o3 = t3.root;
    if (((n3 = e23.fragment) === null || n3 === void 0 ? void 0 : n3[0]) === "/") {
      var u3, l3, f3 = bi(e23.fragment.slice(1).split("/"));
      try {
        for (f3.s(); !(u3 = f3.n()).done; ) {
          var h3 = u3.value;
          if (typeof i3 == "boolean")
            return;
          var d3 = i3[(0, s2.unescapeFragment)(h3)];
          if (d3 === void 0)
            return;
          var m3 = Li(i3 = d3) == "object" && i3[this.opts.schemaId];
          !p2.has(h3) && m3 && (r3 = (0, a2.resolveUrl)(this.opts.uriResolver, r3, m3));
        }
      } catch (e24) {
        f3.e(e24);
      } finally {
        f3.f();
      }
      if (typeof i3 != "boolean" && i3.$ref && !(0, s2.schemaHasRulesButRef)(i3, this.RULES)) {
        var g2 = (0, a2.resolveUrl)(this.opts.uriResolver, r3, i3.$ref);
        l3 = v2.call(this, o3, g2);
      }
      var y2 = this.opts.schemaId;
      return (l3 = l3 || new c2({ schema: i3, schemaId: y2, root: o3, baseId: r3 })).schema !== l3.root.schema ? l3 : void 0;
    }
  }
}, { "../runtime/validation_error": 24, "./codegen": 2, "./names": 6, "./resolve": 8, "./util": 10, "./validate": 15 }], 6: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("./codegen"), i2 = { data: new r2.Name("data"), valCxt: new r2.Name("valCxt"), instancePath: new r2.Name("instancePath"), parentData: new r2.Name("parentData"), parentDataProperty: new r2.Name("parentDataProperty"), rootData: new r2.Name("rootData"), dynamicAnchors: new r2.Name("dynamicAnchors"), vErrors: new r2.Name("vErrors"), errors: new r2.Name("errors"), this: new r2.Name("this"), self: new r2.Name("self"), scope: new r2.Name("scope"), json: new r2.Name("json"), jsonPos: new r2.Name("jsonPos"), jsonLen: new r2.Name("jsonLen"), jsonPart: new r2.Name("jsonPart") };
  n2.default = i2;
}, { "./codegen": 2 }], 7: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("./resolve"), i2 = function(e23) {
    ji(n3, di(Error));
    var t3 = Ci(n3);
    function n3(e24, i3, o2, a2) {
      var s2;
      return Ri(this, n3), (s2 = t3.call(this, a2 || "can't resolve reference ".concat(o2, " from id ").concat(i3))).missingRef = (0, r2.resolveUrl)(e24, i3, o2), s2.missingSchema = (0, r2.normalizeId)((0, r2.getFullPath)(e24, s2.missingRef)), s2;
    }
    return zi(n3);
  }();
  n2.default = i2;
}, { "./resolve": 8 }], 8: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.getSchemaRefs = n2.resolveUrl = n2.normalizeId = n2._getFullPath = n2.getFullPath = n2.inlineRef = void 0;
  var r2 = e22("./util"), i2 = e22("fast-deep-equal"), o2 = e22("json-schema-traverse"), a2 = /* @__PURE__ */ new Set(["type", "format", "pattern", "maxLength", "minLength", "maxProperties", "minProperties", "maxItems", "minItems", "maximum", "minimum", "uniqueItems", "multipleOf", "required", "enum", "const"]);
  n2.inlineRef = function(e23) {
    var t3 = !(arguments.length > 1 && arguments[1] !== void 0) || arguments[1];
    return typeof e23 == "boolean" || (t3 === true ? !u2(e23) : !!t3 && c2(e23) <= t3);
  };
  var s2 = /* @__PURE__ */ new Set(["$ref", "$recursiveRef", "$recursiveAnchor", "$dynamicRef", "$dynamicAnchor"]);
  function u2(e23) {
    for (var t3 in e23) {
      if (s2.has(t3))
        return true;
      var n3 = e23[t3];
      if (Array.isArray(n3) && n3.some(u2))
        return true;
      if (Li(n3) == "object" && u2(n3))
        return true;
    }
    return false;
  }
  function c2(e23) {
    var t3 = 0;
    for (var n3 in e23) {
      if (n3 === "$ref")
        return 1 / 0;
      if (t3++, !a2.has(n3) && (Li(e23[n3]) == "object" && (0, r2.eachItem)(e23[n3], function(e24) {
        return t3 += c2(e24);
      }), 1 / 0 === t3))
        return 1 / 0;
    }
    return t3;
  }
  function l2(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "";
    (arguments.length > 2 ? arguments[2] : void 0) !== false && (t3 = d2(t3));
    var n3 = e23.parse(t3);
    return f2(e23, n3);
  }
  function f2(e23, t3) {
    return e23.serialize(t3).split("#")[0] + "#";
  }
  n2.getFullPath = l2, n2._getFullPath = f2;
  var h2 = /#\/?$/;
  function d2(e23) {
    return e23 ? e23.replace(h2, "") : "";
  }
  n2.normalizeId = d2, n2.resolveUrl = function(e23, t3, n3) {
    return n3 = d2(n3), e23.resolve(t3, n3);
  };
  var v2 = /^[a-z_][-a-z0-9._]*$/i;
  n2.getSchemaRefs = function(e23, t3) {
    var n3 = this;
    if (typeof e23 == "boolean")
      return {};
    var r3 = this.opts, a3 = r3.schemaId, s3 = r3.uriResolver, u3 = d2(e23[a3] || t3), c3 = { "": u3 }, f3 = l2(s3, u3, false), h3 = {}, p2 = /* @__PURE__ */ new Set();
    return o2(e23, { allKeys: true }, function(e24, t4, r4, i3) {
      if (i3 !== void 0) {
        var o3 = f3 + t4, s4 = c3[i3];
        typeof e24[a3] == "string" && (s4 = u4.call(n3, e24[a3])), l3.call(n3, e24.$anchor), l3.call(n3, e24.$dynamicAnchor), c3[t4] = s4;
      }
      function u4(t5) {
        if (t5 = d2(s4 ? (0, this.opts.uriResolver.resolve)(s4, t5) : t5), p2.has(t5))
          throw g2(t5);
        p2.add(t5);
        var n4 = this.refs[t5];
        return typeof n4 == "string" && (n4 = this.refs[n4]), Li(n4) == "object" ? m2(e24, n4.schema, t5) : t5 !== d2(o3) && (t5[0] === "#" ? (m2(e24, h3[t5], t5), h3[t5] = e24) : this.refs[t5] = o3), t5;
      }
      function l3(e25) {
        if (typeof e25 == "string") {
          if (!v2.test(e25))
            throw new Error('invalid anchor "'.concat(e25, '"'));
          u4.call(this, "#".concat(e25));
        }
      }
    }), h3;
    function m2(e24, t4, n4) {
      if (t4 !== void 0 && !i2(e24, t4))
        throw g2(n4);
    }
    function g2(e24) {
      return new Error('reference "'.concat(e24, '" resolves to more than one schema'));
    }
  };
}, { "./util": 10, "fast-deep-equal": 63, "json-schema-traverse": 64 }], 9: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.getRules = n2.isJSONType = void 0;
  var r2 = /* @__PURE__ */ new Set(["string", "number", "integer", "boolean", "null", "object", "array"]);
  n2.isJSONType = function(e23) {
    return typeof e23 == "string" && r2.has(e23);
  }, n2.getRules = function() {
    var e23 = { number: { type: "number", rules: [] }, string: { type: "string", rules: [] }, array: { type: "array", rules: [] }, object: { type: "object", rules: [] } };
    return { types: Ei(Ei({}, e23), {}, { integer: true, boolean: true, null: true }), rules: [{ rules: [] }, e23.number, e23.string, e23.array, e23.object], post: { rules: [] }, all: {}, keywords: {} };
  };
}, {}], 10: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.checkStrictMode = n2.getErrorPath = n2.Type = n2.useFunc = n2.setEvaluated = n2.evaluatedPropsToName = n2.mergeEvaluated = n2.eachItem = n2.unescapeJsonPointer = n2.escapeJsonPointer = n2.escapeFragment = n2.unescapeFragment = n2.schemaRefOrVal = n2.schemaHasRulesButRef = n2.schemaHasRules = n2.checkUnknownRules = n2.alwaysValidSchema = n2.toHash = void 0;
  var r2 = e22("./codegen"), i2 = e22("./codegen/code");
  function o2(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23.schema, n3 = e23.opts, r3 = e23.self;
    if (n3.strictSchema && typeof t3 != "boolean") {
      var i3 = r3.RULES.keywords;
      for (var o3 in t3)
        i3[o3] || v2(e23, 'unknown keyword: "'.concat(o3, '"'));
    }
  }
  function a2(e23, t3) {
    if (typeof e23 == "boolean")
      return !e23;
    for (var n3 in e23)
      if (t3[n3])
        return true;
    return false;
  }
  function s2(e23) {
    return typeof e23 == "number" ? "".concat(e23) : e23.replace(/~/g, "~0").replace(/\//g, "~1");
  }
  function u2(e23) {
    return e23.replace(/~1/g, "/").replace(/~0/g, "~");
  }
  function c2(e23) {
    var t3 = e23.mergeNames, n3 = e23.mergeToName, i3 = e23.mergeValues, o3 = e23.resultToName;
    return function(e24, a3, s3, u3) {
      var c3 = s3 === void 0 ? a3 : s3 instanceof r2.Name ? (a3 instanceof r2.Name ? t3(e24, a3, s3) : n3(e24, a3, s3), s3) : a3 instanceof r2.Name ? (n3(e24, s3, a3), a3) : i3(a3, s3);
      return u3 !== r2.Name || c3 instanceof r2.Name ? c3 : o3(e24, c3);
    };
  }
  function l2(e23, t3) {
    if (t3 === true)
      return e23.var("props", true);
    var n3 = e23.var("props", r2._(B || (B = pi(["{}"]))));
    return t3 !== void 0 && f2(e23, n3, t3), n3;
  }
  function f2(e23, t3, n3) {
    Object.keys(n3).forEach(function(n4) {
      return e23.assign(r2._(q || (q = pi(["", "", ""])), t3, (0, r2.getProperty)(n4)), true);
    });
  }
  n2.toHash = function(e23) {
    var t3, n3 = {}, r3 = bi(e23);
    try {
      for (r3.s(); !(t3 = r3.n()).done; )
        n3[t3.value] = true;
    } catch (e24) {
      r3.e(e24);
    } finally {
      r3.f();
    }
    return n3;
  }, n2.alwaysValidSchema = function(e23, t3) {
    return typeof t3 == "boolean" ? t3 : Object.keys(t3).length === 0 || (o2(e23, t3), !a2(t3, e23.self.RULES.all));
  }, n2.checkUnknownRules = o2, n2.schemaHasRules = a2, n2.schemaHasRulesButRef = function(e23, t3) {
    if (typeof e23 == "boolean")
      return !e23;
    for (var n3 in e23)
      if (n3 !== "$ref" && t3.all[n3])
        return true;
    return false;
  }, n2.schemaRefOrVal = function(e23, t3, n3, i3) {
    var o3 = e23.topSchemaRef, a3 = e23.schemaPath;
    if (!i3) {
      if (typeof t3 == "number" || typeof t3 == "boolean")
        return t3;
      if (typeof t3 == "string")
        return r2._(F || (F = pi(["", ""])), t3);
    }
    return r2._(V || (V = pi(["", "", "", ""])), o3, a3, (0, r2.getProperty)(n3));
  }, n2.unescapeFragment = function(e23) {
    return u2(decodeURIComponent(e23));
  }, n2.escapeFragment = function(e23) {
    return encodeURIComponent(s2(e23));
  }, n2.escapeJsonPointer = s2, n2.unescapeJsonPointer = u2, n2.eachItem = function(e23, t3) {
    if (Array.isArray(e23)) {
      var n3, r3 = bi(e23);
      try {
        for (r3.s(); !(n3 = r3.n()).done; )
          t3(n3.value);
      } catch (e24) {
        r3.e(e24);
      } finally {
        r3.f();
      }
    } else
      t3(e23);
  }, n2.mergeEvaluated = { props: c2({ mergeNames: function(e23, t3, n3) {
    return e23.if(r2._(H || (H = pi(["", " !== true && ", " !== undefined"])), n3, t3), function() {
      e23.if(r2._(W || (W = pi(["", " === true"])), t3), function() {
        return e23.assign(n3, true);
      }, function() {
        return e23.assign(n3, r2._(J || (J = pi(["", " || {}"])), n3)).code(r2._(U || (U = pi(["Object.assign(", ", ", ")"])), n3, t3));
      });
    });
  }, mergeToName: function(e23, t3, n3) {
    return e23.if(r2._(K || (K = pi(["", " !== true"])), n3), function() {
      t3 === true ? e23.assign(n3, true) : (e23.assign(n3, r2._(G || (G = pi(["", " || {}"])), n3)), f2(e23, n3, t3));
    });
  }, mergeValues: function(e23, t3) {
    return e23 === true || Ei(Ei({}, e23), t3);
  }, resultToName: l2 }), items: c2({ mergeNames: function(e23, t3, n3) {
    return e23.if(r2._(Q || (Q = pi(["", " !== true && ", " !== undefined"])), n3, t3), function() {
      return e23.assign(n3, r2._(Y || (Y = pi(["", " === true ? true : ", " > ", " ? ", " : ", ""])), t3, n3, t3, n3, t3));
    });
  }, mergeToName: function(e23, t3, n3) {
    return e23.if(r2._(Z || (Z = pi(["", " !== true"])), n3), function() {
      return e23.assign(n3, t3 === true || r2._(X || (X = pi(["", " > ", " ? ", " : ", ""])), n3, t3, n3, t3));
    });
  }, mergeValues: function(e23, t3) {
    return e23 === true || Math.max(e23, t3);
  }, resultToName: function(e23, t3) {
    return e23.var("items", t3);
  } }) }, n2.evaluatedPropsToName = l2, n2.setEvaluated = f2;
  var h2, d2 = {};
  function v2(e23, t3) {
    var n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : e23.opts.strictSchema;
    if (n3) {
      if (t3 = "strict mode: ".concat(t3), n3 === true)
        throw new Error(t3);
      e23.self.logger.warn(t3);
    }
  }
  n2.useFunc = function(e23, t3) {
    return e23.scopeValue("func", { ref: t3, code: d2[t3.code] || (d2[t3.code] = new i2._Code(t3.code)) });
  }, function(e23) {
    e23[e23.Num = 0] = "Num", e23[e23.Str = 1] = "Str";
  }(h2 = n2.Type || (n2.Type = {})), n2.getErrorPath = function(e23, t3, n3) {
    if (e23 instanceof r2.Name) {
      var i3 = t3 === h2.Num;
      return n3 ? i3 ? r2._(ee || (ee = pi(['"[" + ', ' + "]"'])), e23) : r2._(te || (te = pi([`"['" + `, ` + "']"`])), e23) : i3 ? r2._(ne || (ne = pi(['"/" + ', ""])), e23) : r2._(re || (re = pi(['"/" + ', '.replace(/~/g, "~0").replace(/\\//g, "~1")'], ['"/" + ', '.replace(/~/g, "~0").replace(/\\\\//g, "~1")'])), e23);
    }
    return n3 ? (0, r2.getProperty)(e23).toString() : "/" + s2(e23);
  }, n2.checkStrictMode = v2;
}, { "./codegen": 2, "./codegen/code": 1 }], 11: [function(e22, t2, n2) {
  function r2(e23, t3) {
    return t3.rules.some(function(t4) {
      return i2(e23, t4);
    });
  }
  function i2(e23, t3) {
    var n3;
    return e23[t3.keyword] !== void 0 || ((n3 = t3.definition.implements) === null || n3 === void 0 ? void 0 : n3.some(function(t4) {
      return e23[t4] !== void 0;
    }));
  }
  Object.defineProperty(n2, "__esModule", { value: true }), n2.shouldUseRule = n2.shouldUseGroup = n2.schemaHasRulesForType = void 0, n2.schemaHasRulesForType = function(e23, t3) {
    var n3 = e23.schema, i3 = e23.self.RULES.types[t3];
    return i3 && i3 !== true && r2(n3, i3);
  }, n2.shouldUseGroup = r2, n2.shouldUseRule = i2;
}, {}], 12: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.boolOrEmptySchema = n2.topBoolOrEmptySchema = void 0;
  var r2 = e22("../errors"), i2 = e22("../codegen"), o2 = e22("../names"), a2 = { message: "boolean schema is false" };
  function s2(e23, t3) {
    var n3 = e23.gen, i3 = e23.data;
    (0, r2.reportError)({ gen: n3, keyword: "false schema", data: i3, schema: false, schemaCode: false, schemaValue: false, params: {}, it: e23 }, a2, void 0, t3);
  }
  n2.topBoolOrEmptySchema = function(e23) {
    var t3 = e23.gen, n3 = e23.schema, r3 = e23.validateName;
    n3 === false ? s2(e23, false) : Li(n3) == "object" && n3.$async === true ? t3.return(o2.default.data) : (t3.assign(i2._(ie || (ie = pi(["", ".errors"])), r3), null), t3.return(true));
  }, n2.boolOrEmptySchema = function(e23, t3) {
    var n3 = e23.gen;
    e23.schema === false ? (n3.var(t3, false), s2(e23)) : n3.var(t3, true);
  };
}, { "../codegen": 2, "../errors": 4, "../names": 6 }], 13: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.reportTypeError = n2.checkDataTypes = n2.checkDataType = n2.coerceAndCheckDataType = n2.getJSONTypes = n2.getSchemaTypes = n2.DataType = void 0;
  var r2, i2 = e22("../rules"), o2 = e22("./applicability"), a2 = e22("../errors"), s2 = e22("../codegen"), u2 = e22("../util");
  function c2(e23) {
    var t3 = Array.isArray(e23) ? e23 : e23 ? [e23] : [];
    if (t3.every(i2.isJSONType))
      return t3;
    throw new Error("type must be JSONType or JSONType[]: " + t3.join(","));
  }
  !function(e23) {
    e23[e23.Correct = 0] = "Correct", e23[e23.Wrong = 1] = "Wrong";
  }(r2 = n2.DataType || (n2.DataType = {})), n2.getSchemaTypes = function(e23) {
    var t3 = c2(e23.type);
    if (t3.includes("null")) {
      if (e23.nullable === false)
        throw new Error("type: null contradicts nullable: false");
    } else {
      if (!t3.length && e23.nullable !== void 0)
        throw new Error('"nullable" cannot be used without "type"');
      e23.nullable === true && t3.push("null");
    }
    return t3;
  }, n2.getJSONTypes = c2, n2.coerceAndCheckDataType = function(e23, t3) {
    var n3 = e23.gen, i3 = e23.data, a3 = e23.opts, u3 = function(e24, t4) {
      return t4 ? e24.filter(function(e25) {
        return l2.has(e25) || t4 === "array" && e25 === "array";
      }) : [];
    }(t3, a3.coerceTypes), c3 = t3.length > 0 && !(u3.length === 0 && t3.length === 1 && (0, o2.schemaHasRulesForType)(e23, t3[0]));
    if (c3) {
      var f3 = h2(t3, i3, a3.strictNumbers, r2.Wrong);
      n3.if(f3, function() {
        u3.length ? function(e24, t4, n4) {
          var r3 = e24.gen, i4 = e24.data, o3 = e24.opts, a4 = r3.let("dataType", s2._(oe || (oe = pi(["typeof ", ""])), i4)), u4 = r3.let("coerced", s2._(ae || (ae = pi(["undefined"]))));
          o3.coerceTypes === "array" && r3.if(s2._(se || (se = pi(["", " == 'object' && Array.isArray(", ") && ", ".length == 1"])), a4, i4, i4), function() {
            return r3.assign(i4, s2._(ue || (ue = pi(["", "[0]"])), i4)).assign(a4, s2._(ce || (ce = pi(["typeof ", ""])), i4)).if(h2(t4, i4, o3.strictNumbers), function() {
              return r3.assign(u4, i4);
            });
          }), r3.if(s2._(le || (le = pi(["", " !== undefined"])), u4));
          var c4, f4 = bi(n4);
          try {
            for (f4.s(); !(c4 = f4.n()).done; ) {
              var d3 = c4.value;
              (l2.has(d3) || d3 === "array" && o3.coerceTypes === "array") && p2(d3);
            }
          } catch (e25) {
            f4.e(e25);
          } finally {
            f4.f();
          }
          function p2(e25) {
            switch (e25) {
              case "string":
                return void r3.elseIf(s2._(fe || (fe = pi(["", ' == "number" || ', ' == "boolean"'])), a4, a4)).assign(u4, s2._(he || (he = pi(['"" + ', ""])), i4)).elseIf(s2._(de || (de = pi(["", " === null"])), i4)).assign(u4, s2._(ve || (ve = pi(['""']))));
              case "number":
                return void r3.elseIf(s2._(pe || (pe = pi(["", ' == "boolean" || ', " === null\n	              || (", ' == "string" && ', " && ", " == +", ")"])), a4, i4, a4, i4, i4, i4)).assign(u4, s2._(me || (me = pi(["+", ""])), i4));
              case "integer":
                return void r3.elseIf(s2._(ge || (ge = pi(["", ' === "boolean" || ', " === null\n	              || (", ' === "string" && ', " && ", " == +", " && !(", " % 1))"])), a4, i4, a4, i4, i4, i4, i4)).assign(u4, s2._(ye || (ye = pi(["+", ""])), i4));
              case "boolean":
                return void r3.elseIf(s2._(be || (be = pi(["", ' === "false" || ', " === 0 || ", " === null"])), i4, i4, i4)).assign(u4, false).elseIf(s2._(ke || (ke = pi(["", ' === "true" || ', " === 1"])), i4, i4)).assign(u4, true);
              case "null":
                return r3.elseIf(s2._(we || (we = pi(["", ' === "" || ', " === 0 || ", " === false"])), i4, i4, i4)), void r3.assign(u4, null);
              case "array":
                r3.elseIf(s2._(xe || (xe = pi(["", ' === "string" || ', ' === "number"\n	              || ', ' === "boolean" || ', " === null"])), a4, a4, a4, i4)).assign(u4, s2._(je || (je = pi(["[", "]"])), i4));
            }
          }
          r3.else(), v2(e24), r3.endIf(), r3.if(s2._(Se || (Se = pi(["", " !== undefined"])), u4), function() {
            r3.assign(i4, u4), function(e25, t5) {
              var n5 = e25.gen, r4 = e25.parentData, i5 = e25.parentDataProperty;
              n5.if(s2._(Ce || (Ce = pi(["", " !== undefined"])), r4), function() {
                return n5.assign(s2._(_e || (_e = pi(["", "[", "]"])), r4, i5), t5);
              });
            }(e24, u4);
          });
        }(e23, t3, u3) : v2(e23);
      });
    }
    return c3;
  };
  var l2 = /* @__PURE__ */ new Set(["string", "number", "integer", "boolean", "null"]);
  function f2(e23, t3, n3) {
    var i3, o3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : r2.Correct, a3 = o3 === r2.Correct ? s2.operators.EQ : s2.operators.NEQ;
    switch (e23) {
      case "null":
        return s2._($e || ($e = pi(["", " ", " null"])), t3, a3);
      case "array":
        i3 = s2._(Oe || (Oe = pi(["Array.isArray(", ")"])), t3);
        break;
      case "object":
        i3 = s2._(Ae || (Ae = pi(["", " && typeof ", ' == "object" && !Array.isArray(', ")"])), t3, t3, t3);
        break;
      case "integer":
        i3 = u3(s2._(Me || (Me = pi(["!(", " % 1) && !isNaN(", ")"])), t3, t3));
        break;
      case "number":
        i3 = u3();
        break;
      default:
        return s2._(Ee || (Ee = pi(["typeof ", " ", " ", ""])), t3, a3, e23);
    }
    return o3 === r2.Correct ? i3 : (0, s2.not)(i3);
    function u3() {
      var e24 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : s2.nil;
      return (0, s2.and)(s2._(Pe || (Pe = pi(["typeof ", ' == "number"'])), t3), e24, n3 ? s2._(Ne || (Ne = pi(["isFinite(", ")"])), t3) : s2.nil);
    }
  }
  function h2(e23, t3, n3, r3) {
    if (e23.length === 1)
      return f2(e23[0], t3, n3, r3);
    var i3, o3 = (0, u2.toHash)(e23);
    if (o3.array && o3.object) {
      var a3 = s2._(Te || (Te = pi(["typeof ", ' != "object"'])), t3);
      i3 = o3.null ? a3 : s2._(Ie || (Ie = pi(["!", " || ", ""])), t3, a3), delete o3.null, delete o3.array, delete o3.object;
    } else
      i3 = s2.nil;
    for (var c3 in o3.number && delete o3.integer, o3)
      i3 = (0, s2.and)(i3, f2(c3, t3, n3, r3));
    return i3;
  }
  n2.checkDataType = f2, n2.checkDataTypes = h2;
  var d2 = { message: function(e23) {
    var t3 = e23.schema;
    return "must be ".concat(t3);
  }, params: function(e23) {
    var t3 = e23.schema, n3 = e23.schemaValue;
    return typeof t3 == "string" ? s2._(Re || (Re = pi(["{type: ", "}"])), t3) : s2._(De || (De = pi(["{type: ", "}"])), n3);
  } };
  function v2(e23) {
    var t3 = function(e24) {
      var t4 = e24.gen, n3 = e24.data, r3 = e24.schema, i3 = (0, u2.schemaRefOrVal)(e24, r3, "type");
      return { gen: t4, keyword: "type", data: n3, schema: r3.type, schemaCode: i3, schemaValue: i3, parentSchema: r3, params: {}, it: e24 };
    }(e23);
    (0, a2.reportError)(t3, d2);
  }
  n2.reportTypeError = v2;
}, { "../codegen": 2, "../errors": 4, "../rules": 9, "../util": 10, "./applicability": 11 }], 14: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.assignDefaults = void 0;
  var r2 = e22("../codegen"), i2 = e22("../util");
  function o2(e23, t3, n3) {
    var o3 = e23.gen, a2 = e23.compositeRule, s2 = e23.data, u2 = e23.opts;
    if (n3 !== void 0) {
      var c2 = r2._(ze || (ze = pi(["", "", ""])), s2, (0, r2.getProperty)(t3));
      if (a2)
        (0, i2.checkStrictMode)(e23, "default is ignored for: ".concat(c2));
      else {
        var l2 = r2._(Le || (Le = pi(["", " === undefined"])), c2);
        u2.useDefaults === "empty" && (l2 = r2._(Be || (Be = pi(["", " || ", " === null || ", ' === ""'])), l2, c2, c2)), o3.if(l2, r2._(qe || (qe = pi(["", " = ", ""])), c2, (0, r2.stringify)(n3)));
      }
    }
  }
  n2.assignDefaults = function(e23, t3) {
    var n3 = e23.schema, r3 = n3.properties, i3 = n3.items;
    if (t3 === "object" && r3)
      for (var a2 in r3)
        o2(e23, a2, r3[a2].default);
    else
      t3 === "array" && Array.isArray(i3) && i3.forEach(function(t4, n4) {
        return o2(e23, n4, t4.default);
      });
  };
}, { "../codegen": 2, "../util": 10 }], 15: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.getData = n2.KeywordCxt = n2.validateFunctionCode = void 0;
  var r2 = e22("./boolSchema"), i2 = e22("./dataType"), o2 = e22("./applicability"), a2 = e22("./dataType"), s2 = e22("./defaults"), u2 = e22("./keyword"), c2 = e22("./subschema"), l2 = e22("../codegen"), f2 = e22("../names"), h2 = e22("../resolve"), d2 = e22("../util"), v2 = e22("../errors");
  function p2(e23, t3) {
    var n3 = e23.gen, r3 = e23.validateName, i3 = e23.schema, o3 = e23.schemaEnv, a3 = e23.opts;
    a3.code.es5 ? n3.func(r3, l2._(Fe || (Fe = pi(["", ", ", ""])), f2.default.data, f2.default.valCxt), o3.$async, function() {
      n3.code(l2._(Ve || (Ve = pi(['"use strict"; ', ""])), m2(i3, a3))), function(e24, t4) {
        e24.if(f2.default.valCxt, function() {
          e24.var(f2.default.instancePath, l2._(He || (He = pi(["", ".", ""])), f2.default.valCxt, f2.default.instancePath)), e24.var(f2.default.parentData, l2._(We || (We = pi(["", ".", ""])), f2.default.valCxt, f2.default.parentData)), e24.var(f2.default.parentDataProperty, l2._(Je || (Je = pi(["", ".", ""])), f2.default.valCxt, f2.default.parentDataProperty)), e24.var(f2.default.rootData, l2._(Ue || (Ue = pi(["", ".", ""])), f2.default.valCxt, f2.default.rootData)), t4.dynamicRef && e24.var(f2.default.dynamicAnchors, l2._(Ke || (Ke = pi(["", ".", ""])), f2.default.valCxt, f2.default.dynamicAnchors));
        }, function() {
          e24.var(f2.default.instancePath, l2._(Ge || (Ge = pi(['""'])))), e24.var(f2.default.parentData, l2._(Qe || (Qe = pi(["undefined"])))), e24.var(f2.default.parentDataProperty, l2._(Ye || (Ye = pi(["undefined"])))), e24.var(f2.default.rootData, f2.default.data), t4.dynamicRef && e24.var(f2.default.dynamicAnchors, l2._(Ze || (Ze = pi(["{}"]))));
        });
      }(n3, a3), n3.code(t3);
    }) : n3.func(r3, l2._(Xe || (Xe = pi(["", ", ", ""])), f2.default.data, function(e24) {
      return l2._(et || (et = pi(["{", '="", ', ", ", ", ", "=", "", "}={}"])), f2.default.instancePath, f2.default.parentData, f2.default.parentDataProperty, f2.default.rootData, f2.default.data, e24.dynamicRef ? l2._(tt || (tt = pi([", ", "={}"])), f2.default.dynamicAnchors) : l2.nil);
    }(a3)), o3.$async, function() {
      return n3.code(m2(i3, a3)).code(t3);
    });
  }
  function m2(e23, t3) {
    var n3 = Li(e23) == "object" && e23[t3.schemaId];
    return n3 && (t3.code.source || t3.code.process) ? l2._(nt || (nt = pi(["/*# sourceURL=", " */"])), n3) : l2.nil;
  }
  function g2(e23, t3) {
    b2(e23) && (k2(e23), y2(e23)) ? function(e24, t4) {
      var n3 = e24.schema, r3 = e24.gen;
      e24.opts.$comment && n3.$comment && x2(e24), function(e25) {
        var t5 = e25.schema[e25.opts.schemaId];
        t5 && (e25.baseId = (0, h2.resolveUrl)(e25.opts.uriResolver, e25.baseId, t5));
      }(e24), function(e25) {
        if (e25.schema.$async && !e25.schemaEnv.$async)
          throw new Error("async schema in sync schema");
      }(e24);
      var i3 = r3.const("_errs", f2.default.errors);
      w2(e24, i3), r3.var(t4, l2._(rt || (rt = pi(["", " === ", ""])), i3, f2.default.errors));
    }(e23, t3) : (0, r2.boolOrEmptySchema)(e23, t3);
  }
  function y2(e23) {
    var t3 = e23.schema, n3 = e23.self;
    if (typeof t3 == "boolean")
      return !t3;
    for (var r3 in t3)
      if (n3.RULES.all[r3])
        return true;
    return false;
  }
  function b2(e23) {
    return typeof e23.schema != "boolean";
  }
  function k2(e23) {
    (0, d2.checkUnknownRules)(e23), function(e24) {
      var t3 = e24.schema, n3 = e24.errSchemaPath, r3 = e24.opts, i3 = e24.self;
      t3.$ref && r3.ignoreKeywordsWithRef && (0, d2.schemaHasRulesButRef)(t3, i3.RULES) && i3.logger.warn('$ref: keywords ignored in schema at path "'.concat(n3, '"'));
    }(e23);
  }
  function w2(e23, t3) {
    if (e23.opts.jtd)
      return j2(e23, [], false, t3);
    var n3 = (0, i2.getSchemaTypes)(e23.schema);
    j2(e23, n3, !(0, i2.coerceAndCheckDataType)(e23, n3), t3);
  }
  function x2(e23) {
    var t3 = e23.gen, n3 = e23.schemaEnv, r3 = e23.schema, i3 = e23.errSchemaPath, o3 = e23.opts, a3 = r3.$comment;
    if (o3.$comment === true)
      t3.code(l2._(it || (it = pi(["", ".logger.log(", ")"])), f2.default.self, a3));
    else if (typeof o3.$comment == "function") {
      var s3 = l2.str(ot || (ot = pi(["", "/$comment"])), i3), u3 = t3.scopeValue("root", { ref: n3.root });
      t3.code(l2._(at || (at = pi(["", ".opts.$comment(", ", ", ", ", ".schema)"])), f2.default.self, a3, s3, u3));
    }
  }
  function j2(e23, t3, n3, r3) {
    var i3 = e23.gen, s3 = e23.schema, u3 = e23.data, c3 = e23.allErrors, h3 = e23.opts, v3 = e23.self.RULES;
    function p3(d3) {
      (0, o2.shouldUseGroup)(s3, d3) && (d3.type ? (i3.if((0, a2.checkDataType)(d3.type, u3, h3.strictNumbers)), S2(e23, d3), t3.length === 1 && t3[0] === d3.type && n3 && (i3.else(), (0, a2.reportTypeError)(e23)), i3.endIf()) : S2(e23, d3), c3 || i3.if(l2._(st || (st = pi(["", " === ", ""])), f2.default.errors, r3 || 0)));
    }
    !s3.$ref || !h3.ignoreKeywordsWithRef && (0, d2.schemaHasRulesButRef)(s3, v3) ? (h3.jtd || function(e24, t4) {
      !e24.schemaEnv.meta && e24.opts.strictTypes && (function(e25, t5) {
        t5.length && (e25.dataTypes.length ? (t5.forEach(function(t6) {
          _2(e25.dataTypes, t6) || $2(e25, 'type "'.concat(t6, '" not allowed by context "').concat(e25.dataTypes.join(","), '"'));
        }), e25.dataTypes = e25.dataTypes.filter(function(e26) {
          return _2(t5, e26);
        })) : e25.dataTypes = t5);
      }(e24, t4), e24.opts.allowUnionTypes || function(e25, t5) {
        t5.length > 1 && (t5.length !== 2 || !t5.includes("null")) && $2(e25, "use allowUnionTypes to allow union type keyword");
      }(e24, t4), function(e25, t5) {
        var n4 = e25.self.RULES.all;
        for (var r4 in n4) {
          var i4 = n4[r4];
          if (Li(i4) == "object" && (0, o2.shouldUseRule)(e25.schema, i4)) {
            var a3 = i4.definition.type;
            a3.length && !a3.some(function(e26) {
              return C2(t5, e26);
            }) && $2(e25, 'missing type "'.concat(a3.join(","), '" for keyword "').concat(r4, '"'));
          }
        }
      }(e24, e24.dataTypes));
    }(e23, t3), i3.block(function() {
      var e24, t4 = bi(v3.rules);
      try {
        for (t4.s(); !(e24 = t4.n()).done; )
          p3(e24.value);
      } catch (e25) {
        t4.e(e25);
      } finally {
        t4.f();
      }
      p3(v3.post);
    })) : i3.block(function() {
      return A2(e23, "$ref", v3.all.$ref.definition);
    });
  }
  function S2(e23, t3) {
    var n3 = e23.gen, r3 = e23.schema;
    e23.opts.useDefaults && (0, s2.assignDefaults)(e23, t3.type), n3.block(function() {
      var n4, i3 = bi(t3.rules);
      try {
        for (i3.s(); !(n4 = i3.n()).done; ) {
          var a3 = n4.value;
          (0, o2.shouldUseRule)(r3, a3) && A2(e23, a3.keyword, a3.definition, t3.type);
        }
      } catch (e24) {
        i3.e(e24);
      } finally {
        i3.f();
      }
    });
  }
  function C2(e23, t3) {
    return e23.includes(t3) || t3 === "number" && e23.includes("integer");
  }
  function _2(e23, t3) {
    return e23.includes(t3) || t3 === "integer" && e23.includes("number");
  }
  function $2(e23, t3) {
    (0, d2.checkStrictMode)(e23, t3 += ' at "'.concat(e23.schemaEnv.baseId + e23.errSchemaPath, '" (strictTypes)'), e23.opts.strictTypes);
  }
  n2.validateFunctionCode = function(e23) {
    b2(e23) && (k2(e23), y2(e23)) ? function(e24) {
      var t3 = e24.schema, n3 = e24.opts, r3 = e24.gen;
      p2(e24, function() {
        n3.$comment && t3.$comment && x2(e24), function(e25) {
          var t4 = e25.schema, n4 = e25.opts;
          t4.default !== void 0 && n4.useDefaults && n4.strictSchema && (0, d2.checkStrictMode)(e25, "default is ignored in the schema root");
        }(e24), r3.let(f2.default.vErrors, null), r3.let(f2.default.errors, 0), n3.unevaluated && function(e25) {
          var t4 = e25.gen, n4 = e25.validateName;
          e25.evaluated = t4.const("evaluated", l2._(ut || (ut = pi(["", ".evaluated"])), n4)), t4.if(l2._(ct || (ct = pi(["", ".dynamicProps"])), e25.evaluated), function() {
            return t4.assign(l2._(lt || (lt = pi(["", ".props"])), e25.evaluated), l2._(ft || (ft = pi(["undefined"]))));
          }), t4.if(l2._(ht || (ht = pi(["", ".dynamicItems"])), e25.evaluated), function() {
            return t4.assign(l2._(dt || (dt = pi(["", ".items"])), e25.evaluated), l2._(vt || (vt = pi(["undefined"]))));
          });
        }(e24), w2(e24), function(e25) {
          var t4 = e25.gen, n4 = e25.schemaEnv, r4 = e25.validateName, i3 = e25.ValidationError, o3 = e25.opts;
          n4.$async ? t4.if(l2._(pt || (pt = pi(["", " === 0"])), f2.default.errors), function() {
            return t4.return(f2.default.data);
          }, function() {
            return t4.throw(l2._(mt || (mt = pi(["new ", "(", ")"])), i3, f2.default.vErrors));
          }) : (t4.assign(l2._(gt || (gt = pi(["", ".errors"])), r4), f2.default.vErrors), o3.unevaluated && function(e26) {
            var t5 = e26.gen, n5 = e26.evaluated, r5 = e26.props, i4 = e26.items;
            r5 instanceof l2.Name && t5.assign(l2._(yt || (yt = pi(["", ".props"])), n5), r5), i4 instanceof l2.Name && t5.assign(l2._(bt || (bt = pi(["", ".items"])), n5), i4);
          }(e25), t4.return(l2._(kt || (kt = pi(["", " === 0"])), f2.default.errors)));
        }(e24);
      });
    }(e23) : p2(e23, function() {
      return (0, r2.topBoolOrEmptySchema)(e23);
    });
  };
  var O2 = function() {
    function e23(t3, n3, r3) {
      if (Ri(this, e23), (0, u2.validateKeywordUsage)(t3, n3, r3), this.gen = t3.gen, this.allErrors = t3.allErrors, this.keyword = r3, this.data = t3.data, this.schema = t3.schema[r3], this.$data = n3.$data && t3.opts.$data && this.schema && this.schema.$data, this.schemaValue = (0, d2.schemaRefOrVal)(t3, this.schema, r3, this.$data), this.schemaType = n3.schemaType, this.parentSchema = t3.schema, this.params = {}, this.it = t3, this.def = n3, this.$data)
        this.schemaCode = t3.gen.const("vSchema", P2(this.$data, t3));
      else if (this.schemaCode = this.schemaValue, !(0, u2.validSchemaType)(this.schema, n3.schemaType, n3.allowUndefined))
        throw new Error("".concat(r3, " value must be ").concat(JSON.stringify(n3.schemaType)));
      ("code" in n3 ? n3.trackErrors : n3.errors !== false) && (this.errsCount = t3.gen.const("_errs", f2.default.errors));
    }
    return zi(e23, [{ key: "result", value: function(e24, t3, n3) {
      this.failResult((0, l2.not)(e24), t3, n3);
    } }, { key: "failResult", value: function(e24, t3, n3) {
      this.gen.if(e24), n3 ? n3() : this.error(), t3 ? (this.gen.else(), t3(), this.allErrors && this.gen.endIf()) : this.allErrors ? this.gen.endIf() : this.gen.else();
    } }, { key: "pass", value: function(e24, t3) {
      this.failResult((0, l2.not)(e24), void 0, t3);
    } }, { key: "fail", value: function(e24) {
      if (e24 === void 0)
        return this.error(), void (this.allErrors || this.gen.if(false));
      this.gen.if(e24), this.error(), this.allErrors ? this.gen.endIf() : this.gen.else();
    } }, { key: "fail$data", value: function(e24) {
      if (!this.$data)
        return this.fail(e24);
      var t3 = this.schemaCode;
      this.fail(l2._(wt || (wt = pi(["", " !== undefined && (", ")"])), t3, (0, l2.or)(this.invalid$data(), e24)));
    } }, { key: "error", value: function(e24, t3, n3) {
      if (t3)
        return this.setParams(t3), this._error(e24, n3), void this.setParams({});
      this._error(e24, n3);
    } }, { key: "_error", value: function(e24, t3) {
      (e24 ? v2.reportExtraError : v2.reportError)(this, this.def.error, t3);
    } }, { key: "$dataError", value: function() {
      (0, v2.reportError)(this, this.def.$dataError || v2.keyword$DataError);
    } }, { key: "reset", value: function() {
      if (this.errsCount === void 0)
        throw new Error('add "trackErrors" to keyword definition');
      (0, v2.resetErrorsCount)(this.gen, this.errsCount);
    } }, { key: "ok", value: function(e24) {
      this.allErrors || this.gen.if(e24);
    } }, { key: "setParams", value: function(e24, t3) {
      t3 ? Object.assign(this.params, e24) : this.params = e24;
    } }, { key: "block$data", value: function(e24, t3) {
      var n3 = this, r3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : l2.nil;
      this.gen.block(function() {
        n3.check$data(e24, r3), t3();
      });
    } }, { key: "check$data", value: function() {
      var e24 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : l2.nil, t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : l2.nil;
      if (this.$data) {
        var n3 = this.gen, r3 = this.schemaCode, i3 = this.schemaType, o3 = this.def;
        n3.if((0, l2.or)(l2._(xt || (xt = pi(["", " === undefined"])), r3), t3)), e24 !== l2.nil && n3.assign(e24, true), (i3.length || o3.validateSchema) && (n3.elseIf(this.invalid$data()), this.$dataError(), e24 !== l2.nil && n3.assign(e24, false)), n3.else();
      }
    } }, { key: "invalid$data", value: function() {
      var e24 = this.gen, t3 = this.schemaCode, n3 = this.schemaType, r3 = this.def, i3 = this.it;
      return (0, l2.or)(function() {
        if (n3.length) {
          if (!(t3 instanceof l2.Name))
            throw new Error("ajv implementation error");
          var e25 = Array.isArray(n3) ? n3 : [n3];
          return l2._(jt || (jt = pi(["", ""])), (0, a2.checkDataTypes)(e25, t3, i3.opts.strictNumbers, a2.DataType.Wrong));
        }
        return l2.nil;
      }(), function() {
        if (r3.validateSchema) {
          var n4 = e24.scopeValue("validate$data", { ref: r3.validateSchema });
          return l2._(St || (St = pi(["!", "(", ")"])), n4, t3);
        }
        return l2.nil;
      }());
    } }, { key: "subschema", value: function(e24, t3) {
      var n3 = (0, c2.getSubschema)(this.it, e24);
      (0, c2.extendSubschemaData)(n3, this.it, e24), (0, c2.extendSubschemaMode)(n3, e24);
      var r3 = Ei(Ei(Ei({}, this.it), n3), {}, { items: void 0, props: void 0 });
      return g2(r3, t3), r3;
    } }, { key: "mergeEvaluated", value: function(e24, t3) {
      var n3 = this.it, r3 = this.gen;
      n3.opts.unevaluated && (n3.props !== true && e24.props !== void 0 && (n3.props = d2.mergeEvaluated.props(r3, e24.props, n3.props, t3)), n3.items !== true && e24.items !== void 0 && (n3.items = d2.mergeEvaluated.items(r3, e24.items, n3.items, t3)));
    } }, { key: "mergeValidEvaluated", value: function(e24, t3) {
      var n3 = this, r3 = this.it, i3 = this.gen;
      if (r3.opts.unevaluated && (r3.props !== true || r3.items !== true))
        return i3.if(t3, function() {
          return n3.mergeEvaluated(e24, l2.Name);
        }), true;
    } }]), e23;
  }();
  function A2(e23, t3, n3, r3) {
    var i3 = new O2(e23, n3, t3);
    "code" in n3 ? n3.code(i3, r3) : i3.$data && n3.validate ? (0, u2.funcKeywordCode)(i3, n3) : "macro" in n3 ? (0, u2.macroKeywordCode)(i3, n3) : (n3.compile || n3.validate) && (0, u2.funcKeywordCode)(i3, n3);
  }
  n2.KeywordCxt = O2;
  var M2 = /^\/(?:[^~]|~0|~1)*$/, E2 = /^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;
  function P2(e23, t3) {
    var n3, r3, i3 = t3.dataLevel, o3 = t3.dataNames, a3 = t3.dataPathArr;
    if (e23 === "")
      return f2.default.rootData;
    if (e23[0] === "/") {
      if (!M2.test(e23))
        throw new Error("Invalid JSON-pointer: ".concat(e23));
      n3 = e23, r3 = f2.default.rootData;
    } else {
      var s3 = E2.exec(e23);
      if (!s3)
        throw new Error("Invalid JSON-pointer: ".concat(e23));
      var u3 = +s3[1];
      if ((n3 = s3[2]) === "#") {
        if (u3 >= i3)
          throw new Error(m3("property/index", u3));
        return a3[i3 - u3];
      }
      if (u3 > i3)
        throw new Error(m3("data", u3));
      if (r3 = o3[i3 - u3], !n3)
        return r3;
    }
    var c3, h3 = r3, v3 = bi(n3.split("/"));
    try {
      for (v3.s(); !(c3 = v3.n()).done; ) {
        var p3 = c3.value;
        p3 && (r3 = l2._(Ct || (Ct = pi(["", "", ""])), r3, (0, l2.getProperty)((0, d2.unescapeJsonPointer)(p3))), h3 = l2._(_t || (_t = pi(["", " && ", ""])), h3, r3));
      }
    } catch (e24) {
      v3.e(e24);
    } finally {
      v3.f();
    }
    return h3;
    function m3(e24, t4) {
      return "Cannot access ".concat(e24, " ").concat(t4, " levels up, current level is ").concat(i3);
    }
  }
  n2.getData = P2;
}, { "../codegen": 2, "../errors": 4, "../names": 6, "../resolve": 8, "../util": 10, "./applicability": 11, "./boolSchema": 12, "./dataType": 13, "./defaults": 14, "./keyword": 16, "./subschema": 17 }], 16: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.validateKeywordUsage = n2.validSchemaType = n2.funcKeywordCode = n2.macroKeywordCode = void 0;
  var r2 = e22("../codegen"), i2 = e22("../names"), o2 = e22("../../vocabularies/code"), a2 = e22("../errors");
  function s2(e23) {
    var t3 = e23.gen, n3 = e23.data, i3 = e23.it;
    t3.if(i3.parentData, function() {
      return t3.assign(n3, r2._($t || ($t = pi(["", "[", "]"])), i3.parentData, i3.parentDataProperty));
    });
  }
  function u2(e23, t3, n3) {
    if (n3 === void 0)
      throw new Error('keyword "'.concat(t3, '" failed to compile'));
    return e23.scopeValue("keyword", typeof n3 == "function" ? { ref: n3 } : { ref: n3, code: (0, r2.stringify)(n3) });
  }
  n2.macroKeywordCode = function(e23, t3) {
    var n3 = e23.gen, i3 = e23.keyword, o3 = e23.schema, a3 = e23.parentSchema, s3 = e23.it, c2 = t3.macro.call(s3.self, o3, a3, s3), l2 = u2(n3, i3, c2);
    s3.opts.validateSchema !== false && s3.self.validateSchema(c2, true);
    var f2 = n3.name("valid");
    e23.subschema({ schema: c2, schemaPath: r2.nil, errSchemaPath: "".concat(s3.errSchemaPath, "/").concat(i3), topSchemaRef: l2, compositeRule: true }, f2), e23.pass(f2, function() {
      return e23.error(true);
    });
  }, n2.funcKeywordCode = function(e23, t3) {
    var n3, c2 = e23.gen, l2 = e23.keyword, f2 = e23.schema, h2 = e23.parentSchema, d2 = e23.$data, v2 = e23.it;
    !function(e24, t4) {
      var n4 = e24.schemaEnv;
      if (t4.async && !n4.$async)
        throw new Error("async keyword in sync schema");
    }(v2, t3);
    var p2 = !d2 && t3.compile ? t3.compile.call(v2.self, f2, h2, v2) : t3.validate, m2 = u2(c2, l2, p2), g2 = c2.let("valid");
    function y2() {
      var n4 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : t3.async ? r2._(Ot || (Ot = pi(["await "]))) : r2.nil;
      c2.assign(g2, r2._(At || (At = pi(["", "", ""])), n4, (0, o2.callValidateCode)(e23, m2, v2.opts.passContext ? i2.default.this : i2.default.self, !("compile" in t3 && !d2 || t3.schema === false))), t3.modifying);
    }
    function b2(e24) {
      var n4;
      c2.if((0, r2.not)((n4 = t3.valid) !== null && n4 !== void 0 ? n4 : g2), e24);
    }
    e23.block$data(g2, function() {
      if (t3.errors === false)
        y2(), t3.modifying && s2(e23), b2(function() {
          return e23.error();
        });
      else {
        var n4 = t3.async ? function() {
          var e24 = c2.let("ruleErrs", null);
          return c2.try(function() {
            return y2(r2._(Mt || (Mt = pi(["await "]))));
          }, function(t4) {
            return c2.assign(g2, false).if(r2._(Et || (Et = pi(["", " instanceof ", ""])), t4, v2.ValidationError), function() {
              return c2.assign(e24, r2._(Pt || (Pt = pi(["", ".errors"])), t4));
            }, function() {
              return c2.throw(t4);
            });
          }), e24;
        }() : function() {
          var e24 = r2._(Nt || (Nt = pi(["", ".errors"])), m2);
          return c2.assign(e24, null), y2(r2.nil), e24;
        }();
        t3.modifying && s2(e23), b2(function() {
          return function(e24, t4) {
            var n5 = e24.gen;
            n5.if(r2._(Tt || (Tt = pi(["Array.isArray(", ")"])), t4), function() {
              n5.assign(i2.default.vErrors, r2._(It || (It = pi(["", " === null ? ", " : ", ".concat(", ")"])), i2.default.vErrors, t4, i2.default.vErrors, t4)).assign(i2.default.errors, r2._(Rt || (Rt = pi(["", ".length"])), i2.default.vErrors)), (0, a2.extendErrors)(e24);
            }, function() {
              return e24.error();
            });
          }(e23, n4);
        });
      }
    }), e23.ok((n3 = t3.valid) !== null && n3 !== void 0 ? n3 : g2);
  }, n2.validSchemaType = function(e23, t3) {
    var n3 = arguments.length > 2 && arguments[2] !== void 0 && arguments[2];
    return !t3.length || t3.some(function(t4) {
      return t4 === "array" ? Array.isArray(e23) : t4 === "object" ? e23 && Li(e23) == "object" && !Array.isArray(e23) : Li(e23) == t4 || n3 && e23 === void 0;
    });
  }, n2.validateKeywordUsage = function(e23, t3, n3) {
    var r3 = e23.schema, i3 = e23.opts, o3 = e23.self, a3 = e23.errSchemaPath;
    if (Array.isArray(t3.keyword) ? !t3.keyword.includes(n3) : t3.keyword !== n3)
      throw new Error("ajv implementation error");
    var s3 = t3.dependencies;
    if (s3 == null ? void 0 : s3.some(function(e24) {
      return !Object.prototype.hasOwnProperty.call(r3, e24);
    }))
      throw new Error("parent schema must have dependencies of ".concat(n3, ": ").concat(s3.join(",")));
    if (t3.validateSchema && !t3.validateSchema(r3[n3])) {
      var u3 = 'keyword "'.concat(n3, '" value is invalid at path "').concat(a3, '": ') + o3.errorsText(t3.validateSchema.errors);
      if (i3.validateSchema !== "log")
        throw new Error(u3);
      o3.logger.error(u3);
    }
  };
}, { "../../vocabularies/code": 42, "../codegen": 2, "../errors": 4, "../names": 6 }], 17: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.extendSubschemaMode = n2.extendSubschemaData = n2.getSubschema = void 0;
  var r2 = e22("../codegen"), i2 = e22("../util");
  n2.getSubschema = function(e23, t3) {
    var n3 = t3.keyword, o2 = t3.schemaProp, a2 = t3.schema, s2 = t3.schemaPath, u2 = t3.errSchemaPath, c2 = t3.topSchemaRef;
    if (n3 !== void 0 && a2 !== void 0)
      throw new Error('both "keyword" and "schema" passed, only one allowed');
    if (n3 !== void 0) {
      var l2 = e23.schema[n3];
      return o2 === void 0 ? { schema: l2, schemaPath: r2._(Dt || (Dt = pi(["", "", ""])), e23.schemaPath, (0, r2.getProperty)(n3)), errSchemaPath: "".concat(e23.errSchemaPath, "/").concat(n3) } : { schema: l2[o2], schemaPath: r2._(zt || (zt = pi(["", "", "", ""])), e23.schemaPath, (0, r2.getProperty)(n3), (0, r2.getProperty)(o2)), errSchemaPath: "".concat(e23.errSchemaPath, "/").concat(n3, "/").concat((0, i2.escapeFragment)(o2)) };
    }
    if (a2 !== void 0) {
      if (s2 === void 0 || u2 === void 0 || c2 === void 0)
        throw new Error('"schemaPath", "errSchemaPath" and "topSchemaRef" are required with "schema"');
      return { schema: a2, schemaPath: s2, topSchemaRef: c2, errSchemaPath: u2 };
    }
    throw new Error('either "keyword" or "schema" must be passed');
  }, n2.extendSubschemaData = function(e23, t3, n3) {
    var o2 = n3.dataProp, a2 = n3.dataPropType, s2 = n3.data, u2 = n3.dataTypes, c2 = n3.propertyName;
    if (s2 !== void 0 && o2 !== void 0)
      throw new Error('both "data" and "dataProp" passed, only one allowed');
    var l2 = t3.gen;
    if (o2 !== void 0) {
      var f2 = t3.errorPath, h2 = t3.dataPathArr, d2 = t3.opts;
      v2(l2.let("data", r2._(Lt || (Lt = pi(["", "", ""])), t3.data, (0, r2.getProperty)(o2)), true)), e23.errorPath = r2.str(Bt || (Bt = pi(["", "", ""])), f2, (0, i2.getErrorPath)(o2, a2, d2.jsPropertySyntax)), e23.parentDataProperty = r2._(qt || (qt = pi(["", ""])), o2), e23.dataPathArr = [].concat(Ni(h2), [e23.parentDataProperty]);
    }
    function v2(n4) {
      e23.data = n4, e23.dataLevel = t3.dataLevel + 1, e23.dataTypes = [], t3.definedProperties = /* @__PURE__ */ new Set(), e23.parentData = t3.data, e23.dataNames = [].concat(Ni(t3.dataNames), [n4]);
    }
    s2 !== void 0 && (v2(s2 instanceof r2.Name ? s2 : l2.let("data", s2, true)), c2 !== void 0 && (e23.propertyName = c2)), u2 && (e23.dataTypes = u2);
  }, n2.extendSubschemaMode = function(e23, t3) {
    var n3 = t3.jtdDiscriminator, r3 = t3.jtdMetadata, i3 = t3.compositeRule, o2 = t3.createErrors, a2 = t3.allErrors;
    i3 !== void 0 && (e23.compositeRule = i3), o2 !== void 0 && (e23.createErrors = o2), a2 !== void 0 && (e23.allErrors = a2), e23.jtdDiscriminator = n3, e23.jtdMetadata = r3;
  };
}, { "../codegen": 2, "../util": 10 }], 18: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.CodeGen = n2.Name = n2.nil = n2.stringify = n2.str = n2._ = n2.KeywordCxt = void 0;
  var r2 = e22("./compile/validate");
  Object.defineProperty(n2, "KeywordCxt", { enumerable: true, get: function() {
    return r2.KeywordCxt;
  } });
  var i2 = e22("./compile/codegen");
  Object.defineProperty(n2, "_", { enumerable: true, get: function() {
    return i2._;
  } }), Object.defineProperty(n2, "str", { enumerable: true, get: function() {
    return i2.str;
  } }), Object.defineProperty(n2, "stringify", { enumerable: true, get: function() {
    return i2.stringify;
  } }), Object.defineProperty(n2, "nil", { enumerable: true, get: function() {
    return i2.nil;
  } }), Object.defineProperty(n2, "Name", { enumerable: true, get: function() {
    return i2.Name;
  } }), Object.defineProperty(n2, "CodeGen", { enumerable: true, get: function() {
    return i2.CodeGen;
  } });
  var o2 = e22("./runtime/validation_error"), a2 = e22("./compile/ref_error"), s2 = e22("./compile/rules"), u2 = e22("./compile"), c2 = e22("./compile/codegen"), l2 = e22("./compile/resolve"), f2 = e22("./compile/validate/dataType"), h2 = e22("./compile/util"), d2 = e22("./refs/data.json"), v2 = e22("./runtime/uri"), p2 = function(e23, t3) {
    return new RegExp(e23, t3);
  };
  p2.code = "new RegExp";
  var m2 = ["removeAdditional", "useDefaults", "coerceTypes"], g2 = /* @__PURE__ */ new Set(["validate", "serialize", "parse", "wrapper", "root", "schema", "keyword", "pattern", "formats", "validate$data", "func", "obj", "Error"]), y2 = { errorDataPath: "", format: "`validateFormats: false` can be used instead.", nullable: '"nullable" keyword is supported by default.', jsonPointers: "Deprecated jsPropertySyntax can be used instead.", extendRefs: "Deprecated ignoreKeywordsWithRef can be used instead.", missingRefs: "Pass empty schema with $id that should be ignored to ajv.addSchema.", processCode: "Use option `code: {process: (code, schemaEnv: object) => string}`", sourceCode: "Use option `code: {source: true}`", strictDefaults: "It is default now, see option `strict`.", strictKeywords: "It is default now, see option `strict`.", uniqueItems: '"uniqueItems" keyword is always validated.', unknownFormats: "Disable strict mode or pass `true` to `ajv.addFormat` (or `formats` option).", cache: "Map is used as cache, schema object as key.", serialize: "Map is used as cache, schema object as key.", ajvErrors: "It is default now." }, b2 = { ignoreKeywordsWithRef: "", jsPropertySyntax: "", unicode: '"minLength"/"maxLength" account for unicode characters by default.' };
  function k2(e23) {
    var t3, n3, r3, i3, o3, a3, s3, u3, c3, l3, f3, h3, d3, m3, g3, y3, b3, k3, w3, x3, j3, S3, C3, _3, $3, O3 = e23.strict, A3 = (t3 = e23.code) === null || t3 === void 0 ? void 0 : t3.optimize, M3 = A3 === true || A3 === void 0 ? 1 : A3 || 0, E3 = (r3 = (n3 = e23.code) === null || n3 === void 0 ? void 0 : n3.regExp) !== null && r3 !== void 0 ? r3 : p2, P3 = (i3 = e23.uriResolver) !== null && i3 !== void 0 ? i3 : v2.default;
    return { strictSchema: (a3 = (o3 = e23.strictSchema) !== null && o3 !== void 0 ? o3 : O3) === null || a3 === void 0 || a3, strictNumbers: (u3 = (s3 = e23.strictNumbers) !== null && s3 !== void 0 ? s3 : O3) === null || u3 === void 0 || u3, strictTypes: (l3 = (c3 = e23.strictTypes) !== null && c3 !== void 0 ? c3 : O3) !== null && l3 !== void 0 ? l3 : "log", strictTuples: (h3 = (f3 = e23.strictTuples) !== null && f3 !== void 0 ? f3 : O3) !== null && h3 !== void 0 ? h3 : "log", strictRequired: (m3 = (d3 = e23.strictRequired) !== null && d3 !== void 0 ? d3 : O3) !== null && m3 !== void 0 && m3, code: e23.code ? Ei(Ei({}, e23.code), {}, { optimize: M3, regExp: E3 }) : { optimize: M3, regExp: E3 }, loopRequired: (g3 = e23.loopRequired) !== null && g3 !== void 0 ? g3 : 200, loopEnum: (y3 = e23.loopEnum) !== null && y3 !== void 0 ? y3 : 200, meta: (b3 = e23.meta) === null || b3 === void 0 || b3, messages: (k3 = e23.messages) === null || k3 === void 0 || k3, inlineRefs: (w3 = e23.inlineRefs) === null || w3 === void 0 || w3, schemaId: (x3 = e23.schemaId) !== null && x3 !== void 0 ? x3 : "$id", addUsedSchema: (j3 = e23.addUsedSchema) === null || j3 === void 0 || j3, validateSchema: (S3 = e23.validateSchema) === null || S3 === void 0 || S3, validateFormats: (C3 = e23.validateFormats) === null || C3 === void 0 || C3, unicodeRegExp: (_3 = e23.unicodeRegExp) === null || _3 === void 0 || _3, int32range: ($3 = e23.int32range) === null || $3 === void 0 || $3, uriResolver: P3 };
  }
  var w2 = function() {
    function e23() {
      var t3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      Ri(this, e23), this.schemas = {}, this.refs = {}, this.formats = {}, this._compilations = /* @__PURE__ */ new Set(), this._loading = {}, this._cache = /* @__PURE__ */ new Map(), t3 = this.opts = Ei(Ei({}, t3), k2(t3));
      var n3 = this.opts.code, r3 = n3.es5, i3 = n3.lines;
      this.scope = new c2.ValueScope({ scope: {}, prefixes: g2, es5: r3, lines: i3 }), this.logger = function(e24) {
        if (e24 === false)
          return O2;
        if (e24 === void 0)
          return console;
        if (e24.log && e24.warn && e24.error)
          return e24;
        throw new Error("logger must implement log, warn and error methods");
      }(t3.logger);
      var o3 = t3.validateFormats;
      t3.validateFormats = false, this.RULES = (0, s2.getRules)(), x2.call(this, y2, t3, "NOT SUPPORTED"), x2.call(this, b2, t3, "DEPRECATED", "warn"), this._metaOpts = $2.call(this), t3.formats && C2.call(this), this._addVocabularies(), this._addDefaultMetaSchema(), t3.keywords && _2.call(this, t3.keywords), Li(t3.meta) == "object" && this.addMetaSchema(t3.meta), S2.call(this), t3.validateFormats = o3;
    }
    return zi(e23, [{ key: "_addVocabularies", value: function() {
      this.addKeyword("$async");
    } }, { key: "_addDefaultMetaSchema", value: function() {
      var e24 = this.opts, t3 = e24.$data, n3 = e24.meta, r3 = e24.schemaId, i3 = d2;
      r3 === "id" && ((i3 = Ei({}, d2)).id = i3.$id, delete i3.$id), n3 && t3 && this.addMetaSchema(i3, i3[r3], false);
    } }, { key: "defaultMeta", value: function() {
      var e24 = this.opts, t3 = e24.meta, n3 = e24.schemaId;
      return this.opts.defaultMeta = Li(t3) == "object" ? t3[n3] || t3 : void 0;
    } }, { key: "validate", value: function(e24, t3) {
      var n3;
      if (typeof e24 == "string") {
        if (!(n3 = this.getSchema(e24)))
          throw new Error('no schema with key or ref "'.concat(e24, '"'));
      } else
        n3 = this.compile(e24);
      var r3 = n3(t3);
      return "$async" in n3 || (this.errors = n3.errors), r3;
    } }, { key: "compile", value: function(e24, t3) {
      var n3 = this._addSchema(e24, t3);
      return n3.validate || this._compileSchemaEnv(n3);
    } }, { key: "compileAsync", value: function(e24, t3) {
      if (typeof this.opts.loadSchema != "function")
        throw new Error("options.loadSchema should be a function");
      var n3 = this.opts.loadSchema;
      return r3.call(this, e24, t3);
      function r3(e25, t4) {
        return i3.apply(this, arguments);
      }
      function i3() {
        return (i3 = yi(mi().mark(function e25(t4, n4) {
          var r4;
          return mi().wrap(function(e26) {
            for (; ; )
              switch (e26.prev = e26.next) {
                case 0:
                  return e26.next = 2, o3.call(this, t4.$schema);
                case 2:
                  return r4 = this._addSchema(t4, n4), e26.abrupt("return", r4.validate || u3.call(this, r4));
                case 4:
                case "end":
                  return e26.stop();
              }
          }, e25, this);
        }))).apply(this, arguments);
      }
      function o3(e25) {
        return s3.apply(this, arguments);
      }
      function s3() {
        return (s3 = yi(mi().mark(function e25(t4) {
          return mi().wrap(function(e26) {
            for (; ; )
              switch (e26.prev = e26.next) {
                case 0:
                  if (e26.t0 = t4 && !this.getSchema(t4), !e26.t0) {
                    e26.next = 4;
                    break;
                  }
                  return e26.next = 4, r3.call(this, { $ref: t4 }, true);
                case 4:
                case "end":
                  return e26.stop();
              }
          }, e25, this);
        }))).apply(this, arguments);
      }
      function u3(e25) {
        return c3.apply(this, arguments);
      }
      function c3() {
        return (c3 = yi(mi().mark(function e25(t4) {
          return mi().wrap(function(e26) {
            for (; ; )
              switch (e26.prev = e26.next) {
                case 0:
                  return e26.prev = 0, e26.abrupt("return", this._compileSchemaEnv(t4));
                case 4:
                  if (e26.prev = 4, e26.t0 = e26.catch(0), e26.t0 instanceof a2.default) {
                    e26.next = 8;
                    break;
                  }
                  throw e26.t0;
                case 8:
                  return l3.call(this, e26.t0), e26.next = 11, f3.call(this, e26.t0.missingSchema);
                case 11:
                  return e26.abrupt("return", u3.call(this, t4));
                case 12:
                case "end":
                  return e26.stop();
              }
          }, e25, this, [[0, 4]]);
        }))).apply(this, arguments);
      }
      function l3(e25) {
        var t4 = e25.missingSchema, n4 = e25.missingRef;
        if (this.refs[t4])
          throw new Error("AnySchema ".concat(t4, " is loaded but ").concat(n4, " cannot be resolved"));
      }
      function f3(e25) {
        return h3.apply(this, arguments);
      }
      function h3() {
        return (h3 = yi(mi().mark(function e25(n4) {
          var r4;
          return mi().wrap(function(e26) {
            for (; ; )
              switch (e26.prev = e26.next) {
                case 0:
                  return e26.next = 2, d3.call(this, n4);
                case 2:
                  if (r4 = e26.sent, e26.t0 = this.refs[n4], e26.t0) {
                    e26.next = 7;
                    break;
                  }
                  return e26.next = 7, o3.call(this, r4.$schema);
                case 7:
                  this.refs[n4] || this.addSchema(r4, n4, t3);
                case 8:
                case "end":
                  return e26.stop();
              }
          }, e25, this);
        }))).apply(this, arguments);
      }
      function d3(e25) {
        return v3.apply(this, arguments);
      }
      function v3() {
        return (v3 = yi(mi().mark(function e25(t4) {
          var r4;
          return mi().wrap(function(e26) {
            for (; ; )
              switch (e26.prev = e26.next) {
                case 0:
                  if (!(r4 = this._loading[t4])) {
                    e26.next = 3;
                    break;
                  }
                  return e26.abrupt("return", r4);
                case 3:
                  return e26.prev = 3, e26.next = 6, this._loading[t4] = n3(t4);
                case 6:
                  return e26.abrupt("return", e26.sent);
                case 7:
                  return e26.prev = 7, delete this._loading[t4], e26.finish(7);
                case 10:
                case "end":
                  return e26.stop();
              }
          }, e25, this, [[3, , 7, 10]]);
        }))).apply(this, arguments);
      }
    } }, { key: "addSchema", value: function(e24, t3, n3) {
      var r3, i3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : this.opts.validateSchema;
      if (Array.isArray(e24)) {
        var o3, a3 = bi(e24);
        try {
          for (a3.s(); !(o3 = a3.n()).done; ) {
            var s3 = o3.value;
            this.addSchema(s3, void 0, n3, i3);
          }
        } catch (e25) {
          a3.e(e25);
        } finally {
          a3.f();
        }
        return this;
      }
      if (Li(e24) == "object") {
        var u3 = this.opts.schemaId;
        if ((r3 = e24[u3]) !== void 0 && typeof r3 != "string")
          throw new Error("schema ".concat(u3, " must be string"));
      }
      return t3 = (0, l2.normalizeId)(t3 || r3), this._checkUnique(t3), this.schemas[t3] = this._addSchema(e24, n3, t3, i3, true), this;
    } }, { key: "addMetaSchema", value: function(e24, t3) {
      var n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : this.opts.validateSchema;
      return this.addSchema(e24, t3, true, n3), this;
    } }, { key: "validateSchema", value: function(e24, t3) {
      if (typeof e24 == "boolean")
        return true;
      var n3;
      if ((n3 = e24.$schema) !== void 0 && typeof n3 != "string")
        throw new Error("$schema must be a string");
      if (!(n3 = n3 || this.opts.defaultMeta || this.defaultMeta()))
        return this.logger.warn("meta-schema not available"), this.errors = null, true;
      var r3 = this.validate(n3, e24);
      if (!r3 && t3) {
        var i3 = "schema is invalid: " + this.errorsText();
        if (this.opts.validateSchema !== "log")
          throw new Error(i3);
        this.logger.error(i3);
      }
      return r3;
    } }, { key: "getSchema", value: function(e24) {
      for (var t3; typeof (t3 = j2.call(this, e24)) == "string"; )
        e24 = t3;
      if (t3 === void 0) {
        var n3 = this.opts.schemaId, r3 = new u2.SchemaEnv({ schema: {}, schemaId: n3 });
        if (!(t3 = u2.resolveSchema.call(this, r3, e24)))
          return;
        this.refs[e24] = t3;
      }
      return t3.validate || this._compileSchemaEnv(t3);
    } }, { key: "removeSchema", value: function(e24) {
      if (e24 instanceof RegExp)
        return this._removeAllSchemas(this.schemas, e24), this._removeAllSchemas(this.refs, e24), this;
      switch (Li(e24)) {
        case "undefined":
          return this._removeAllSchemas(this.schemas), this._removeAllSchemas(this.refs), this._cache.clear(), this;
        case "string":
          var t3 = j2.call(this, e24);
          return Li(t3) == "object" && this._cache.delete(t3.schema), delete this.schemas[e24], delete this.refs[e24], this;
        case "object":
          this._cache.delete(e24);
          var n3 = e24[this.opts.schemaId];
          return n3 && (n3 = (0, l2.normalizeId)(n3), delete this.schemas[n3], delete this.refs[n3]), this;
        default:
          throw new Error("ajv.removeSchema: invalid parameter");
      }
    } }, { key: "addVocabulary", value: function(e24) {
      var t3, n3 = bi(e24);
      try {
        for (n3.s(); !(t3 = n3.n()).done; ) {
          var r3 = t3.value;
          this.addKeyword(r3);
        }
      } catch (e25) {
        n3.e(e25);
      } finally {
        n3.f();
      }
      return this;
    } }, { key: "addKeyword", value: function(e24, t3) {
      var n3, r3 = this;
      if (typeof e24 == "string")
        n3 = e24, Li(t3) == "object" && (this.logger.warn("these parameters are deprecated, see docs for addKeyword"), t3.keyword = n3);
      else {
        if (Li(e24) != "object" || t3 !== void 0)
          throw new Error("invalid addKeywords parameters");
        if (n3 = (t3 = e24).keyword, Array.isArray(n3) && !n3.length)
          throw new Error("addKeywords: keyword must be string or non-empty array");
      }
      if (M2.call(this, n3, t3), !t3)
        return (0, h2.eachItem)(n3, function(e25) {
          return E2.call(r3, e25);
        }), this;
      N2.call(this, t3);
      var i3 = Ei(Ei({}, t3), {}, { type: (0, f2.getJSONTypes)(t3.type), schemaType: (0, f2.getJSONTypes)(t3.schemaType) });
      return (0, h2.eachItem)(n3, i3.type.length === 0 ? function(e25) {
        return E2.call(r3, e25, i3);
      } : function(e25) {
        return i3.type.forEach(function(t4) {
          return E2.call(r3, e25, i3, t4);
        });
      }), this;
    } }, { key: "getKeyword", value: function(e24) {
      var t3 = this.RULES.all[e24];
      return Li(t3) == "object" ? t3.definition : !!t3;
    } }, { key: "removeKeyword", value: function(e24) {
      var t3 = this.RULES;
      delete t3.keywords[e24], delete t3.all[e24];
      var n3, r3 = bi(t3.rules);
      try {
        for (r3.s(); !(n3 = r3.n()).done; ) {
          var i3 = n3.value, o3 = i3.rules.findIndex(function(t4) {
            return t4.keyword === e24;
          });
          o3 >= 0 && i3.rules.splice(o3, 1);
        }
      } catch (e25) {
        r3.e(e25);
      } finally {
        r3.f();
      }
      return this;
    } }, { key: "addFormat", value: function(e24, t3) {
      return typeof t3 == "string" && (t3 = new RegExp(t3)), this.formats[e24] = t3, this;
    } }, { key: "errorsText", value: function() {
      var e24 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.errors, t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n3 = t3.separator, r3 = n3 === void 0 ? ", " : n3, i3 = t3.dataVar, o3 = i3 === void 0 ? "data" : i3;
      return e24 && e24.length !== 0 ? e24.map(function(e25) {
        return "".concat(o3).concat(e25.instancePath, " ").concat(e25.message);
      }).reduce(function(e25, t4) {
        return e25 + r3 + t4;
      }) : "No errors";
    } }, { key: "$dataMetaSchema", value: function(e24, t3) {
      var n3 = this.RULES.all;
      e24 = JSON.parse(JSON.stringify(e24));
      var r3, i3 = bi(t3);
      try {
        for (i3.s(); !(r3 = i3.n()).done; ) {
          var o3, a3 = r3.value.split("/").slice(1), s3 = e24, u3 = bi(a3);
          try {
            for (u3.s(); !(o3 = u3.n()).done; )
              s3 = s3[o3.value];
          } catch (e25) {
            u3.e(e25);
          } finally {
            u3.f();
          }
          for (var c3 in n3) {
            var l3 = n3[c3];
            if (Li(l3) == "object") {
              var f3 = l3.definition.$data, h3 = s3[c3];
              f3 && h3 && (s3[c3] = I2(h3));
            }
          }
        }
      } catch (e25) {
        i3.e(e25);
      } finally {
        i3.f();
      }
      return e24;
    } }, { key: "_removeAllSchemas", value: function(e24, t3) {
      for (var n3 in e24) {
        var r3 = e24[n3];
        t3 && !t3.test(n3) || (typeof r3 == "string" ? delete e24[n3] : r3 && !r3.meta && (this._cache.delete(r3.schema), delete e24[n3]));
      }
    } }, { key: "_addSchema", value: function(e24, t3, n3) {
      var r3, i3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : this.opts.validateSchema, o3 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : this.opts.addUsedSchema, a3 = this.opts.schemaId;
      if (Li(e24) == "object")
        r3 = e24[a3];
      else {
        if (this.opts.jtd)
          throw new Error("schema must be object");
        if (typeof e24 != "boolean")
          throw new Error("schema must be object or boolean");
      }
      var s3 = this._cache.get(e24);
      if (s3 !== void 0)
        return s3;
      n3 = (0, l2.normalizeId)(r3 || n3);
      var c3 = l2.getSchemaRefs.call(this, e24, n3);
      return s3 = new u2.SchemaEnv({ schema: e24, schemaId: a3, meta: t3, baseId: n3, localRefs: c3 }), this._cache.set(s3.schema, s3), o3 && !n3.startsWith("#") && (n3 && this._checkUnique(n3), this.refs[n3] = s3), i3 && this.validateSchema(e24, true), s3;
    } }, { key: "_checkUnique", value: function(e24) {
      if (this.schemas[e24] || this.refs[e24])
        throw new Error('schema with key or id "'.concat(e24, '" already exists'));
    } }, { key: "_compileSchemaEnv", value: function(e24) {
      if (e24.meta ? this._compileMetaSchema(e24) : u2.compileSchema.call(this, e24), !e24.validate)
        throw new Error("ajv implementation error");
      return e24.validate;
    } }, { key: "_compileMetaSchema", value: function(e24) {
      var t3 = this.opts;
      this.opts = this._metaOpts;
      try {
        u2.compileSchema.call(this, e24);
      } finally {
        this.opts = t3;
      }
    } }]), e23;
  }();
  function x2(e23, t3, n3) {
    var r3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : "error";
    for (var i3 in e23) {
      var o3 = i3;
      o3 in t3 && this.logger[r3]("".concat(n3, ": option ").concat(i3, ". ").concat(e23[o3]));
    }
  }
  function j2(e23) {
    return e23 = (0, l2.normalizeId)(e23), this.schemas[e23] || this.refs[e23];
  }
  function S2() {
    var e23 = this.opts.schemas;
    if (e23)
      if (Array.isArray(e23))
        this.addSchema(e23);
      else
        for (var t3 in e23)
          this.addSchema(e23[t3], t3);
  }
  function C2() {
    for (var e23 in this.opts.formats) {
      var t3 = this.opts.formats[e23];
      t3 && this.addFormat(e23, t3);
    }
  }
  function _2(e23) {
    if (Array.isArray(e23))
      this.addVocabulary(e23);
    else
      for (var t3 in this.logger.warn("keywords option as map is deprecated, pass array"), e23) {
        var n3 = e23[t3];
        n3.keyword || (n3.keyword = t3), this.addKeyword(n3);
      }
  }
  function $2() {
    var e23, t3 = Ei({}, this.opts), n3 = bi(m2);
    try {
      for (n3.s(); !(e23 = n3.n()).done; )
        delete t3[e23.value];
    } catch (e24) {
      n3.e(e24);
    } finally {
      n3.f();
    }
    return t3;
  }
  n2.default = w2, w2.ValidationError = o2.default, w2.MissingRefError = a2.default;
  var O2 = { log: function() {
  }, warn: function() {
  }, error: function() {
  } }, A2 = /^[a-z_$][a-z0-9_$:-]*$/i;
  function M2(e23, t3) {
    var n3 = this.RULES;
    if ((0, h2.eachItem)(e23, function(e24) {
      if (n3.keywords[e24])
        throw new Error("Keyword ".concat(e24, " is already defined"));
      if (!A2.test(e24))
        throw new Error("Keyword ".concat(e24, " has invalid name"));
    }), t3 && t3.$data && !("code" in t3) && !("validate" in t3))
      throw new Error('$data keyword must have "code" or "validate" function');
  }
  function E2(e23, t3, n3) {
    var r3, i3 = this, o3 = t3 == null ? void 0 : t3.post;
    if (n3 && o3)
      throw new Error('keyword with "post" flag cannot have "type"');
    var a3 = this.RULES, s3 = o3 ? a3.post : a3.rules.find(function(e24) {
      return e24.type === n3;
    });
    if (s3 || (s3 = { type: n3, rules: [] }, a3.rules.push(s3)), a3.keywords[e23] = true, t3) {
      var u3 = { keyword: e23, definition: Ei(Ei({}, t3), {}, { type: (0, f2.getJSONTypes)(t3.type), schemaType: (0, f2.getJSONTypes)(t3.schemaType) }) };
      t3.before ? P2.call(this, s3, u3, t3.before) : s3.rules.push(u3), a3.all[e23] = u3, (r3 = t3.implements) === null || r3 === void 0 || r3.forEach(function(e24) {
        return i3.addKeyword(e24);
      });
    }
  }
  function P2(e23, t3, n3) {
    var r3 = e23.rules.findIndex(function(e24) {
      return e24.keyword === n3;
    });
    r3 >= 0 ? e23.rules.splice(r3, 0, t3) : (e23.rules.push(t3), this.logger.warn("rule ".concat(n3, " is not defined")));
  }
  function N2(e23) {
    var t3 = e23.metaSchema;
    t3 !== void 0 && (e23.$data && this.opts.$data && (t3 = I2(t3)), e23.validateSchema = this.compile(t3, true));
  }
  var T2 = { $ref: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#" };
  function I2(e23) {
    return { anyOf: [e23, T2] };
  }
}, { "./compile": 5, "./compile/codegen": 2, "./compile/ref_error": 7, "./compile/resolve": 8, "./compile/rules": 9, "./compile/util": 10, "./compile/validate": 15, "./compile/validate/dataType": 13, "./refs/data.json": 19, "./runtime/uri": 23, "./runtime/validation_error": 24 }], 19: [function(e22, t2, n2) {
  t2.exports = { $id: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#", description: "Meta-schema for $data reference (JSON AnySchema extension proposal)", type: "object", required: ["$data"], properties: { $data: { type: "string", anyOf: [{ format: "relative-json-pointer" }, { format: "json-pointer" }] } }, additionalProperties: false };
}, {}], 20: [function(e22, t2, n2) {
  t2.exports = { $schema: "http://json-schema.org/draft-07/schema#", $id: "http://json-schema.org/draft-07/schema#", title: "Core schema meta-schema", definitions: { schemaArray: { type: "array", minItems: 1, items: { $ref: "#" } }, nonNegativeInteger: { type: "integer", minimum: 0 }, nonNegativeIntegerDefault0: { allOf: [{ $ref: "#/definitions/nonNegativeInteger" }, { default: 0 }] }, simpleTypes: { enum: ["array", "boolean", "integer", "null", "number", "object", "string"] }, stringArray: { type: "array", items: { type: "string" }, uniqueItems: true, default: [] } }, type: ["object", "boolean"], properties: { $id: { type: "string", format: "uri-reference" }, $schema: { type: "string", format: "uri" }, $ref: { type: "string", format: "uri-reference" }, $comment: { type: "string" }, title: { type: "string" }, description: { type: "string" }, default: true, readOnly: { type: "boolean", default: false }, examples: { type: "array", items: true }, multipleOf: { type: "number", exclusiveMinimum: 0 }, maximum: { type: "number" }, exclusiveMaximum: { type: "number" }, minimum: { type: "number" }, exclusiveMinimum: { type: "number" }, maxLength: { $ref: "#/definitions/nonNegativeInteger" }, minLength: { $ref: "#/definitions/nonNegativeIntegerDefault0" }, pattern: { type: "string", format: "regex" }, additionalItems: { $ref: "#" }, items: { anyOf: [{ $ref: "#" }, { $ref: "#/definitions/schemaArray" }], default: true }, maxItems: { $ref: "#/definitions/nonNegativeInteger" }, minItems: { $ref: "#/definitions/nonNegativeIntegerDefault0" }, uniqueItems: { type: "boolean", default: false }, contains: { $ref: "#" }, maxProperties: { $ref: "#/definitions/nonNegativeInteger" }, minProperties: { $ref: "#/definitions/nonNegativeIntegerDefault0" }, required: { $ref: "#/definitions/stringArray" }, additionalProperties: { $ref: "#" }, definitions: { type: "object", additionalProperties: { $ref: "#" }, default: {} }, properties: { type: "object", additionalProperties: { $ref: "#" }, default: {} }, patternProperties: { type: "object", additionalProperties: { $ref: "#" }, propertyNames: { format: "regex" }, default: {} }, dependencies: { type: "object", additionalProperties: { anyOf: [{ $ref: "#" }, { $ref: "#/definitions/stringArray" }] } }, propertyNames: { $ref: "#" }, const: true, enum: { type: "array", items: true, minItems: 1, uniqueItems: true }, type: { anyOf: [{ $ref: "#/definitions/simpleTypes" }, { type: "array", items: { $ref: "#/definitions/simpleTypes" }, minItems: 1, uniqueItems: true }] }, format: { type: "string" }, contentMediaType: { type: "string" }, contentEncoding: { type: "string" }, if: { $ref: "#" }, then: { $ref: "#" }, else: { $ref: "#" }, allOf: { $ref: "#/definitions/schemaArray" }, anyOf: { $ref: "#/definitions/schemaArray" }, oneOf: { $ref: "#/definitions/schemaArray" }, not: { $ref: "#" } }, default: true };
}, {}], 21: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("fast-deep-equal");
  r2.code = 'require("ajv/dist/runtime/equal").default', n2.default = r2;
}, { "fast-deep-equal": 63 }], 22: [function(e22, t2, n2) {
  function r2(e23) {
    for (var t3, n3 = e23.length, r3 = 0, i2 = 0; i2 < n3; )
      r3++, (t3 = e23.charCodeAt(i2++)) >= 55296 && t3 <= 56319 && i2 < n3 && (64512 & (t3 = e23.charCodeAt(i2))) == 56320 && i2++;
    return r3;
  }
  Object.defineProperty(n2, "__esModule", { value: true }), n2.default = r2, r2.code = 'require("ajv/dist/runtime/ucs2length").default';
}, {}], 23: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("uri-js");
  r2.code = 'require("ajv/dist/runtime/uri").default', n2.default = r2;
}, { "uri-js": 65 }], 24: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = function(e23) {
    ji(n3, di(Error));
    var t3 = Ci(n3);
    function n3(e24) {
      var r3;
      return Ri(this, n3), (r3 = t3.call(this, "validation failed")).errors = e24, r3.ajv = r3.validation = true, r3;
    }
    return zi(n3);
  }();
  n2.default = r2;
}, {}], 25: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.validateAdditionalItems = void 0;
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util"), o2 = { keyword: "additionalItems", type: "array", schemaType: ["boolean", "object"], before: "uniqueItems", error: { message: function(e23) {
    var t3 = e23.params.len;
    return r2.str(Ft || (Ft = pi(["must NOT have more than ", " items"])), t3);
  }, params: function(e23) {
    var t3 = e23.params.len;
    return r2._(Vt || (Vt = pi(["{limit: ", "}"])), t3);
  } }, code: function(e23) {
    var t3 = e23.parentSchema, n3 = e23.it, r3 = t3.items;
    Array.isArray(r3) ? a2(e23, r3) : (0, i2.checkStrictMode)(n3, '"additionalItems" is ignored when "items" is not an array of schemas');
  } };
  function a2(e23, t3) {
    var n3 = e23.gen, o3 = e23.schema, a3 = e23.data, s2 = e23.keyword, u2 = e23.it;
    u2.items = true;
    var c2 = n3.const("len", r2._(Ht || (Ht = pi(["", ".length"])), a3));
    if (o3 === false)
      e23.setParams({ len: t3.length }), e23.pass(r2._(Wt || (Wt = pi(["", " <= ", ""])), c2, t3.length));
    else if (Li(o3) == "object" && !(0, i2.alwaysValidSchema)(u2, o3)) {
      var l2 = n3.var("valid", r2._(Jt || (Jt = pi(["", " <= ", ""])), c2, t3.length));
      n3.if((0, r2.not)(l2), function() {
        return function(o4) {
          n3.forRange("i", t3.length, c2, function(t4) {
            e23.subschema({ keyword: s2, dataProp: t4, dataPropType: i2.Type.Num }, o4), u2.allErrors || n3.if((0, r2.not)(o4), function() {
              return n3.break();
            });
          });
        }(l2);
      }), e23.ok(l2);
    }
  }
  n2.validateAdditionalItems = a2, n2.default = o2;
}, { "../../compile/codegen": 2, "../../compile/util": 10 }], 26: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../code"), i2 = e22("../../compile/codegen"), o2 = e22("../../compile/names"), a2 = e22("../../compile/util");
  n2.default = { keyword: "additionalProperties", type: ["object"], schemaType: ["boolean", "object"], allowUndefined: true, trackErrors: true, error: { message: "must NOT have additional properties", params: function(e23) {
    var t3 = e23.params;
    return i2._(Ut || (Ut = pi(["{additionalProperty: ", "}"])), t3.additionalProperty);
  } }, code: function(e23) {
    var t3 = e23.gen, n3 = e23.schema, s2 = e23.parentSchema, u2 = e23.data, c2 = e23.errsCount, l2 = e23.it;
    if (!c2)
      throw new Error("ajv implementation error");
    var f2 = l2.allErrors, h2 = l2.opts;
    if (l2.props = true, h2.removeAdditional === "all" || !(0, a2.alwaysValidSchema)(l2, n3)) {
      var d2 = (0, r2.allSchemaProperties)(s2.properties), v2 = (0, r2.allSchemaProperties)(s2.patternProperties);
      t3.forIn("key", u2, function(n4) {
        d2.length || v2.length ? t3.if(function(n5) {
          var o3;
          if (d2.length > 8) {
            var u3 = (0, a2.schemaRefOrVal)(l2, s2.properties, "properties");
            o3 = (0, r2.isOwnProperty)(t3, u3, n5);
          } else
            o3 = d2.length ? i2.or.apply(void 0, Ni(d2.map(function(e24) {
              return i2._(Gt || (Gt = pi(["", " === ", ""])), n5, e24);
            }))) : i2.nil;
          return v2.length && (o3 = i2.or.apply(void 0, [o3].concat(Ni(v2.map(function(t4) {
            return i2._(Qt || (Qt = pi(["", ".test(", ")"])), (0, r2.usePattern)(e23, t4), n5);
          }))))), (0, i2.not)(o3);
        }(n4), function() {
          return m2(n4);
        }) : m2(n4);
      }), e23.ok(i2._(Yt || (Yt = pi(["", " === ", ""])), c2, o2.default.errors));
    }
    function p2(e24) {
      t3.code(i2._(Kt || (Kt = pi(["delete ", "[", "]"])), u2, e24));
    }
    function m2(r3) {
      if (h2.removeAdditional === "all" || h2.removeAdditional && n3 === false)
        p2(r3);
      else {
        if (n3 === false)
          return e23.setParams({ additionalProperty: r3 }), e23.error(), void (f2 || t3.break());
        if (Li(n3) == "object" && !(0, a2.alwaysValidSchema)(l2, n3)) {
          var o3 = t3.name("valid");
          h2.removeAdditional === "failing" ? (g2(r3, o3, false), t3.if((0, i2.not)(o3), function() {
            e23.reset(), p2(r3);
          })) : (g2(r3, o3), f2 || t3.if((0, i2.not)(o3), function() {
            return t3.break();
          }));
        }
      }
    }
    function g2(t4, n4, r3) {
      var i3 = { keyword: "additionalProperties", dataProp: t4, dataPropType: a2.Type.Str };
      r3 === false && Object.assign(i3, { compositeRule: true, createErrors: false, allErrors: false }), e23.subschema(i3, n4);
    }
  } };
}, { "../../compile/codegen": 2, "../../compile/names": 6, "../../compile/util": 10, "../code": 42 }], 27: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/util");
  n2.default = { keyword: "allOf", schemaType: "array", code: function(e23) {
    var t3 = e23.gen, n3 = e23.schema, i2 = e23.it;
    if (!Array.isArray(n3))
      throw new Error("ajv implementation error");
    var o2 = t3.name("valid");
    n3.forEach(function(t4, n4) {
      if (!(0, r2.alwaysValidSchema)(i2, t4)) {
        var a2 = e23.subschema({ keyword: "allOf", schemaProp: n4 }, o2);
        e23.ok(o2), e23.mergeEvaluated(a2);
      }
    });
  } };
}, { "../../compile/util": 10 }], 28: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../code");
  n2.default = { keyword: "anyOf", schemaType: "array", trackErrors: true, code: r2.validateUnion, error: { message: "must match a schema in anyOf" } };
}, { "../code": 42 }], 29: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util");
  n2.default = { keyword: "contains", type: "array", schemaType: ["object", "boolean"], before: "uniqueItems", trackErrors: true, error: { message: function(e23) {
    var t3 = e23.params, n3 = t3.min, i3 = t3.max;
    return i3 === void 0 ? r2.str(Zt || (Zt = pi(["must contain at least ", " valid item(s)"])), n3) : r2.str(Xt || (Xt = pi(["must contain at least ", " and no more than ", " valid item(s)"])), n3, i3);
  }, params: function(e23) {
    var t3 = e23.params, n3 = t3.min, i3 = t3.max;
    return i3 === void 0 ? r2._(en || (en = pi(["{minContains: ", "}"])), n3) : r2._(tn || (tn = pi(["{minContains: ", ", maxContains: ", "}"])), n3, i3);
  } }, code: function(e23) {
    var t3, n3, o2 = e23.gen, a2 = e23.schema, s2 = e23.parentSchema, u2 = e23.data, c2 = e23.it, l2 = s2.minContains, f2 = s2.maxContains;
    c2.opts.next ? (t3 = l2 === void 0 ? 1 : l2, n3 = f2) : t3 = 1;
    var h2 = o2.const("len", r2._(nn || (nn = pi(["", ".length"])), u2));
    if (e23.setParams({ min: t3, max: n3 }), n3 !== void 0 || t3 !== 0) {
      if (n3 !== void 0 && t3 > n3)
        return (0, i2.checkStrictMode)(c2, '"minContains" > "maxContains" is always invalid'), void e23.fail();
      if ((0, i2.alwaysValidSchema)(c2, a2)) {
        var d2 = r2._(rn || (rn = pi(["", " >= ", ""])), h2, t3);
        return n3 !== void 0 && (d2 = r2._(on || (on = pi(["", " && ", " <= ", ""])), d2, h2, n3)), void e23.pass(d2);
      }
      c2.items = true;
      var v2 = o2.name("valid");
      n3 === void 0 && t3 === 1 ? m2(v2, function() {
        return o2.if(v2, function() {
          return o2.break();
        });
      }) : t3 === 0 ? (o2.let(v2, true), n3 !== void 0 && o2.if(r2._(ln || (ln = pi(["", ".length > 0"])), u2), p2)) : (o2.let(v2, false), p2()), e23.result(v2, function() {
        return e23.reset();
      });
    } else
      (0, i2.checkStrictMode)(c2, '"minContains" == 0 without "maxContains": "contains" keyword ignored');
    function p2() {
      var e24 = o2.name("_valid"), i3 = o2.let("count", 0);
      m2(e24, function() {
        return o2.if(e24, function() {
          return function(e25) {
            o2.code(r2._(an || (an = pi(["", "++"])), e25)), n3 === void 0 ? o2.if(r2._(sn || (sn = pi(["", " >= ", ""])), e25, t3), function() {
              return o2.assign(v2, true).break();
            }) : (o2.if(r2._(un || (un = pi(["", " > ", ""])), e25, n3), function() {
              return o2.assign(v2, false).break();
            }), t3 === 1 ? o2.assign(v2, true) : o2.if(r2._(cn || (cn = pi(["", " >= ", ""])), e25, t3), function() {
              return o2.assign(v2, true);
            }));
          }(i3);
        });
      });
    }
    function m2(t4, n4) {
      o2.forRange("i", 0, h2, function(r3) {
        e23.subschema({ keyword: "contains", dataProp: r3, dataPropType: i2.Type.Num, compositeRule: true }, t4), n4();
      });
    }
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10 }], 30: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.validateSchemaDeps = n2.validatePropertyDeps = n2.error = void 0;
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util"), o2 = e22("../code");
  n2.error = { message: function(e23) {
    var t3 = e23.params, n3 = t3.property, i3 = t3.depsCount, o3 = t3.deps;
    return r2.str(fn || (fn = pi(["must have ", " ", " when property ", " is present"])), i3 === 1 ? "property" : "properties", o3, n3);
  }, params: function(e23) {
    var t3 = e23.params, n3 = t3.property, i3 = t3.depsCount, o3 = t3.deps, a3 = t3.missingProperty;
    return r2._(hn || (hn = pi(["{property: ", ",\n	    missingProperty: ", ",\n	    depsCount: ", ",\n	    deps: ", "}"])), n3, a3, i3, o3);
  } };
  var a2 = { keyword: "dependencies", type: "object", schemaType: "object", error: n2.error, code: function(e23) {
    var t3 = xi(function(e24) {
      var t4 = e24.schema, n4 = {}, r4 = {};
      for (var i3 in t4)
        i3 !== "__proto__" && ((Array.isArray(t4[i3]) ? n4 : r4)[i3] = t4[i3]);
      return [n4, r4];
    }(e23), 2), n3 = t3[0], r3 = t3[1];
    s2(e23, n3), u2(e23, r3);
  } };
  function s2(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23.schema, n3 = e23.gen, i3 = e23.data, a3 = e23.it;
    if (Object.keys(t3).length !== 0) {
      var s3 = n3.let("missing"), u3 = function(u4) {
        var c3 = t3[u4];
        if (c3.length === 0)
          return "continue";
        var l2 = (0, o2.propertyInData)(n3, i3, u4, a3.opts.ownProperties);
        e23.setParams({ property: u4, depsCount: c3.length, deps: c3.join(", ") }), a3.allErrors ? n3.if(l2, function() {
          var t4, n4 = bi(c3);
          try {
            for (n4.s(); !(t4 = n4.n()).done; ) {
              var r3 = t4.value;
              (0, o2.checkReportMissingProp)(e23, r3);
            }
          } catch (e24) {
            n4.e(e24);
          } finally {
            n4.f();
          }
        }) : (n3.if(r2._(dn || (dn = pi(["", " && (", ")"])), l2, (0, o2.checkMissingProp)(e23, c3, s3))), (0, o2.reportMissingProp)(e23, s3), n3.else());
      };
      for (var c2 in t3)
        u3(c2);
    }
  }
  function u2(e23) {
    var t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : e23.schema, n3 = e23.gen, r3 = e23.data, a3 = e23.keyword, s3 = e23.it, u3 = n3.name("valid"), c2 = function(c3) {
      (0, i2.alwaysValidSchema)(s3, t3[c3]) || (n3.if((0, o2.propertyInData)(n3, r3, c3, s3.opts.ownProperties), function() {
        var t4 = e23.subschema({ keyword: a3, schemaProp: c3 }, u3);
        e23.mergeValidEvaluated(t4, u3);
      }, function() {
        return n3.var(u3, true);
      }), e23.ok(u3));
    };
    for (var l2 in t3)
      c2(l2);
  }
  n2.validatePropertyDeps = s2, n2.validateSchemaDeps = u2, n2.default = a2;
}, { "../../compile/codegen": 2, "../../compile/util": 10, "../code": 42 }], 31: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util");
  function o2(e23, t3) {
    var n3 = e23.schema[t3];
    return n3 !== void 0 && !(0, i2.alwaysValidSchema)(e23, n3);
  }
  n2.default = { keyword: "if", schemaType: ["object", "boolean"], trackErrors: true, error: { message: function(e23) {
    var t3 = e23.params;
    return r2.str(vn || (vn = pi(['must match "', '" schema'])), t3.ifClause);
  }, params: function(e23) {
    var t3 = e23.params;
    return r2._(pn || (pn = pi(["{failingKeyword: ", "}"])), t3.ifClause);
  } }, code: function(e23) {
    var t3 = e23.gen, n3 = e23.parentSchema, a2 = e23.it;
    n3.then === void 0 && n3.else === void 0 && (0, i2.checkStrictMode)(a2, '"if" without "then" and "else" is ignored');
    var s2 = o2(a2, "then"), u2 = o2(a2, "else");
    if (s2 || u2) {
      var c2 = t3.let("valid", true), l2 = t3.name("_valid");
      if (function() {
        var t4 = e23.subschema({ keyword: "if", compositeRule: true, createErrors: false, allErrors: false }, l2);
        e23.mergeEvaluated(t4);
      }(), e23.reset(), s2 && u2) {
        var f2 = t3.let("ifClause");
        e23.setParams({ ifClause: f2 }), t3.if(l2, h2("then", f2), h2("else", f2));
      } else
        s2 ? t3.if(l2, h2("then")) : t3.if((0, r2.not)(l2), h2("else"));
      e23.pass(c2, function() {
        return e23.error(true);
      });
    }
    function h2(n4, i3) {
      return function() {
        var o3 = e23.subschema({ keyword: n4 }, l2);
        t3.assign(c2, l2), e23.mergeValidEvaluated(o3, c2), i3 ? t3.assign(i3, r2._(mn || (mn = pi(["", ""])), n4)) : e23.setParams({ ifClause: n4 });
      };
    }
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10 }], 32: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("./additionalItems"), i2 = e22("./prefixItems"), o2 = e22("./items"), a2 = e22("./items2020"), s2 = e22("./contains"), u2 = e22("./dependencies"), c2 = e22("./propertyNames"), l2 = e22("./additionalProperties"), f2 = e22("./properties"), h2 = e22("./patternProperties"), d2 = e22("./not"), v2 = e22("./anyOf"), p2 = e22("./oneOf"), m2 = e22("./allOf"), g2 = e22("./if"), y2 = e22("./thenElse");
  n2.default = function() {
    var e23 = arguments.length > 0 && arguments[0] !== void 0 && arguments[0], t3 = [d2.default, v2.default, p2.default, m2.default, g2.default, y2.default, c2.default, l2.default, u2.default, f2.default, h2.default];
    return e23 ? t3.push(i2.default, a2.default) : t3.push(r2.default, o2.default), t3.push(s2.default), t3;
  };
}, { "./additionalItems": 25, "./additionalProperties": 26, "./allOf": 27, "./anyOf": 28, "./contains": 29, "./dependencies": 30, "./if": 31, "./items": 33, "./items2020": 34, "./not": 35, "./oneOf": 36, "./patternProperties": 37, "./prefixItems": 38, "./properties": 39, "./propertyNames": 40, "./thenElse": 41 }], 33: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.validateTuple = void 0;
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util"), o2 = e22("../code"), a2 = { keyword: "items", type: "array", schemaType: ["object", "array", "boolean"], before: "uniqueItems", code: function(e23) {
    var t3 = e23.schema, n3 = e23.it;
    if (Array.isArray(t3))
      return s2(e23, "additionalItems", t3);
    n3.items = true, (0, i2.alwaysValidSchema)(n3, t3) || e23.ok((0, o2.validateArray)(e23));
  } };
  function s2(e23, t3) {
    var n3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : e23.schema, o3 = e23.gen, a3 = e23.parentSchema, s3 = e23.data, u2 = e23.keyword, c2 = e23.it;
    !function(e24) {
      var r3 = c2.opts, o4 = c2.errSchemaPath, a4 = n3.length, s4 = a4 === e24.minItems && (a4 === e24.maxItems || e24[t3] === false);
      r3.strictTuples && !s4 && (0, i2.checkStrictMode)(c2, '"'.concat(u2, '" is ').concat(a4, "-tuple, but minItems or maxItems/").concat(t3, ' are not specified or different at path "').concat(o4, '"'), r3.strictTuples);
    }(a3), c2.opts.unevaluated && n3.length && c2.items !== true && (c2.items = i2.mergeEvaluated.items(o3, n3.length, c2.items));
    var l2 = o3.name("valid"), f2 = o3.const("len", r2._(gn || (gn = pi(["", ".length"])), s3));
    n3.forEach(function(t4, n4) {
      (0, i2.alwaysValidSchema)(c2, t4) || (o3.if(r2._(yn || (yn = pi(["", " > ", ""])), f2, n4), function() {
        return e23.subschema({ keyword: u2, schemaProp: n4, dataProp: n4 }, l2);
      }), e23.ok(l2));
    });
  }
  n2.validateTuple = s2, n2.default = a2;
}, { "../../compile/codegen": 2, "../../compile/util": 10, "../code": 42 }], 34: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util"), o2 = e22("../code"), a2 = e22("./additionalItems");
  n2.default = { keyword: "items", type: "array", schemaType: ["object", "boolean"], before: "uniqueItems", error: { message: function(e23) {
    var t3 = e23.params.len;
    return r2.str(bn || (bn = pi(["must NOT have more than ", " items"])), t3);
  }, params: function(e23) {
    var t3 = e23.params.len;
    return r2._(kn || (kn = pi(["{limit: ", "}"])), t3);
  } }, code: function(e23) {
    var t3 = e23.schema, n3 = e23.parentSchema, r3 = e23.it, s2 = n3.prefixItems;
    r3.items = true, (0, i2.alwaysValidSchema)(r3, t3) || (s2 ? (0, a2.validateAdditionalItems)(e23, s2) : e23.ok((0, o2.validateArray)(e23)));
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10, "../code": 42, "./additionalItems": 25 }], 35: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/util");
  n2.default = { keyword: "not", schemaType: ["object", "boolean"], trackErrors: true, code: function(e23) {
    var t3 = e23.gen, n3 = e23.schema, i2 = e23.it;
    if ((0, r2.alwaysValidSchema)(i2, n3))
      e23.fail();
    else {
      var o2 = t3.name("valid");
      e23.subschema({ keyword: "not", compositeRule: true, createErrors: false, allErrors: false }, o2), e23.failResult(o2, function() {
        return e23.reset();
      }, function() {
        return e23.error();
      });
    }
  }, error: { message: "must NOT be valid" } };
}, { "../../compile/util": 10 }], 36: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util");
  n2.default = { keyword: "oneOf", schemaType: "array", trackErrors: true, error: { message: "must match exactly one schema in oneOf", params: function(e23) {
    var t3 = e23.params;
    return r2._(wn || (wn = pi(["{passingSchemas: ", "}"])), t3.passing);
  } }, code: function(e23) {
    var t3 = e23.gen, n3 = e23.schema, o2 = e23.parentSchema, a2 = e23.it;
    if (!Array.isArray(n3))
      throw new Error("ajv implementation error");
    if (!a2.opts.discriminator || !o2.discriminator) {
      var s2 = n3, u2 = t3.let("valid", false), c2 = t3.let("passing", null), l2 = t3.name("_valid");
      e23.setParams({ passing: c2 }), t3.block(function() {
        s2.forEach(function(n4, o3) {
          var s3;
          (0, i2.alwaysValidSchema)(a2, n4) ? t3.var(l2, true) : s3 = e23.subschema({ keyword: "oneOf", schemaProp: o3, compositeRule: true }, l2), o3 > 0 && t3.if(r2._(xn || (xn = pi(["", " && ", ""])), l2, u2)).assign(u2, false).assign(c2, r2._(jn || (jn = pi(["[", ", ", "]"])), c2, o3)).else(), t3.if(l2, function() {
            t3.assign(u2, true), t3.assign(c2, o3), s3 && e23.mergeEvaluated(s3, r2.Name);
          });
        });
      }), e23.result(u2, function() {
        return e23.reset();
      }, function() {
        return e23.error(true);
      });
    }
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10 }], 37: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../code"), i2 = e22("../../compile/codegen"), o2 = e22("../../compile/util"), a2 = e22("../../compile/util");
  n2.default = { keyword: "patternProperties", type: "object", schemaType: "object", code: function(e23) {
    var t3 = e23.gen, n3 = e23.schema, s2 = e23.data, u2 = e23.parentSchema, c2 = e23.it, l2 = c2.opts, f2 = (0, r2.allSchemaProperties)(n3), h2 = f2.filter(function(e24) {
      return (0, o2.alwaysValidSchema)(c2, n3[e24]);
    });
    if (f2.length !== 0 && (h2.length !== f2.length || c2.opts.unevaluated && c2.props !== true)) {
      var d2 = l2.strictSchema && !l2.allowMatchingProperties && u2.properties, v2 = t3.name("valid");
      c2.props === true || c2.props instanceof i2.Name || (c2.props = (0, a2.evaluatedPropsToName)(t3, c2.props));
      var p2 = c2.props;
      !function() {
        var e24, n4 = bi(f2);
        try {
          for (n4.s(); !(e24 = n4.n()).done; ) {
            var r3 = e24.value;
            d2 && m2(r3), c2.allErrors ? g2(r3) : (t3.var(v2, true), g2(r3), t3.if(v2));
          }
        } catch (e25) {
          n4.e(e25);
        } finally {
          n4.f();
        }
      }();
    }
    function m2(e24) {
      for (var t4 in d2)
        new RegExp(e24).test(t4) && (0, o2.checkStrictMode)(c2, "property ".concat(t4, " matches pattern ").concat(e24, " (use allowMatchingProperties)"));
    }
    function g2(n4) {
      t3.forIn("key", s2, function(o3) {
        t3.if(i2._(Sn || (Sn = pi(["", ".test(", ")"])), (0, r2.usePattern)(e23, n4), o3), function() {
          var r3 = h2.includes(n4);
          r3 || e23.subschema({ keyword: "patternProperties", schemaProp: n4, dataProp: o3, dataPropType: a2.Type.Str }, v2), c2.opts.unevaluated && p2 !== true ? t3.assign(i2._(Cn || (Cn = pi(["", "[", "]"])), p2, o3), true) : r3 || c2.allErrors || t3.if((0, i2.not)(v2), function() {
            return t3.break();
          });
        });
      });
    }
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10, "../code": 42 }], 38: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("./items");
  n2.default = { keyword: "prefixItems", type: "array", schemaType: ["array"], before: "uniqueItems", code: function(e23) {
    return (0, r2.validateTuple)(e23, "items");
  } };
}, { "./items": 33 }], 39: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/validate"), i2 = e22("../code"), o2 = e22("../../compile/util"), a2 = e22("./additionalProperties");
  n2.default = { keyword: "properties", type: "object", schemaType: "object", code: function(e23) {
    var t3 = e23.gen, n3 = e23.schema, s2 = e23.parentSchema, u2 = e23.data, c2 = e23.it;
    c2.opts.removeAdditional === "all" && s2.additionalProperties === void 0 && a2.default.code(new r2.KeywordCxt(c2, a2.default, "additionalProperties"));
    var l2, f2 = (0, i2.allSchemaProperties)(n3), h2 = bi(f2);
    try {
      for (h2.s(); !(l2 = h2.n()).done; ) {
        var d2 = l2.value;
        c2.definedProperties.add(d2);
      }
    } catch (e24) {
      h2.e(e24);
    } finally {
      h2.f();
    }
    c2.opts.unevaluated && f2.length && c2.props !== true && (c2.props = o2.mergeEvaluated.props(t3, (0, o2.toHash)(f2), c2.props));
    var v2 = f2.filter(function(e24) {
      return !(0, o2.alwaysValidSchema)(c2, n3[e24]);
    });
    if (v2.length !== 0) {
      var p2, m2 = t3.name("valid"), g2 = bi(v2);
      try {
        for (g2.s(); !(p2 = g2.n()).done; ) {
          var y2 = p2.value;
          b2(y2) ? k2(y2) : (t3.if((0, i2.propertyInData)(t3, u2, y2, c2.opts.ownProperties)), k2(y2), c2.allErrors || t3.else().var(m2, true), t3.endIf()), e23.it.definedProperties.add(y2), e23.ok(m2);
        }
      } catch (e24) {
        g2.e(e24);
      } finally {
        g2.f();
      }
    }
    function b2(e24) {
      return c2.opts.useDefaults && !c2.compositeRule && n3[e24].default !== void 0;
    }
    function k2(t4) {
      e23.subschema({ keyword: "properties", schemaProp: t4, dataProp: t4 }, m2);
    }
  } };
}, { "../../compile/util": 10, "../../compile/validate": 15, "../code": 42, "./additionalProperties": 26 }], 40: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util");
  n2.default = { keyword: "propertyNames", type: "object", schemaType: ["object", "boolean"], error: { message: "property name must be valid", params: function(e23) {
    var t3 = e23.params;
    return r2._(_n || (_n = pi(["{propertyName: ", "}"])), t3.propertyName);
  } }, code: function(e23) {
    var t3 = e23.gen, n3 = e23.schema, o2 = e23.data, a2 = e23.it;
    if (!(0, i2.alwaysValidSchema)(a2, n3)) {
      var s2 = t3.name("valid");
      t3.forIn("key", o2, function(n4) {
        e23.setParams({ propertyName: n4 }), e23.subschema({ keyword: "propertyNames", data: n4, dataTypes: ["string"], propertyName: n4, compositeRule: true }, s2), t3.if((0, r2.not)(s2), function() {
          e23.error(true), a2.allErrors || t3.break();
        });
      }), e23.ok(s2);
    }
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10 }], 41: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/util");
  n2.default = { keyword: ["then", "else"], schemaType: ["object", "boolean"], code: function(e23) {
    var t3 = e23.keyword, n3 = e23.parentSchema, i2 = e23.it;
    n3.if === void 0 && (0, r2.checkStrictMode)(i2, '"'.concat(t3, '" without "if" is ignored'));
  } };
}, { "../../compile/util": 10 }], 42: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.validateUnion = n2.validateArray = n2.usePattern = n2.callValidateCode = n2.schemaProperties = n2.allSchemaProperties = n2.noPropertyInData = n2.propertyInData = n2.isOwnProperty = n2.hasPropFunc = n2.reportMissingProp = n2.checkMissingProp = n2.checkReportMissingProp = void 0;
  var r2 = e22("../compile/codegen"), i2 = e22("../compile/util"), o2 = e22("../compile/names"), a2 = e22("../compile/util");
  function s2(e23) {
    return e23.scopeValue("func", { ref: Object.prototype.hasOwnProperty, code: r2._($n || ($n = pi(["Object.prototype.hasOwnProperty"]))) });
  }
  function u2(e23, t3, n3) {
    return r2._(On || (On = pi(["", ".call(", ", ", ")"])), s2(e23), t3, n3);
  }
  function c2(e23, t3, n3, i3) {
    var o3 = r2._(An || (An = pi(["", "", " === undefined"])), t3, (0, r2.getProperty)(n3));
    return i3 ? (0, r2.or)(o3, (0, r2.not)(u2(e23, t3, n3))) : o3;
  }
  function l2(e23) {
    return e23 ? Object.keys(e23).filter(function(e24) {
      return e24 !== "__proto__";
    }) : [];
  }
  n2.checkReportMissingProp = function(e23, t3) {
    var n3 = e23.gen, i3 = e23.data, o3 = e23.it;
    n3.if(c2(n3, i3, t3, o3.opts.ownProperties), function() {
      e23.setParams({ missingProperty: r2._(Mn || (Mn = pi(["", ""])), t3) }, true), e23.error();
    });
  }, n2.checkMissingProp = function(e23, t3, n3) {
    var i3 = e23.gen, o3 = e23.data, a3 = e23.it.opts;
    return r2.or.apply(void 0, Ni(t3.map(function(e24) {
      return (0, r2.and)(c2(i3, o3, e24, a3.ownProperties), r2._(En || (En = pi(["", " = ", ""])), n3, e24));
    })));
  }, n2.reportMissingProp = function(e23, t3) {
    e23.setParams({ missingProperty: t3 }, true), e23.error();
  }, n2.hasPropFunc = s2, n2.isOwnProperty = u2, n2.propertyInData = function(e23, t3, n3, i3) {
    var o3 = r2._(Pn || (Pn = pi(["", "", " !== undefined"])), t3, (0, r2.getProperty)(n3));
    return i3 ? r2._(Nn || (Nn = pi(["", " && ", ""])), o3, u2(e23, t3, n3)) : o3;
  }, n2.noPropertyInData = c2, n2.allSchemaProperties = l2, n2.schemaProperties = function(e23, t3) {
    return l2(t3).filter(function(n3) {
      return !(0, i2.alwaysValidSchema)(e23, t3[n3]);
    });
  }, n2.callValidateCode = function(e23, t3, n3, i3) {
    var a3 = e23.schemaCode, s3 = e23.data, u3 = e23.it, c3 = u3.gen, l3 = u3.topSchemaRef, f3 = u3.schemaPath, h2 = u3.errorPath, d2 = e23.it, v2 = i3 ? r2._(Tn || (Tn = pi(["", ", ", ", ", "", ""])), a3, s3, l3, f3) : s3, p2 = [[o2.default.instancePath, (0, r2.strConcat)(o2.default.instancePath, h2)], [o2.default.parentData, d2.parentData], [o2.default.parentDataProperty, d2.parentDataProperty], [o2.default.rootData, o2.default.rootData]];
    d2.opts.dynamicRef && p2.push([o2.default.dynamicAnchors, o2.default.dynamicAnchors]);
    var m2 = r2._(In || (In = pi(["", ", ", ""])), v2, c3.object.apply(c3, p2));
    return n3 !== r2.nil ? r2._(Rn || (Rn = pi(["", ".call(", ", ", ")"])), t3, n3, m2) : r2._(Dn || (Dn = pi(["", "(", ")"])), t3, m2);
  };
  var f2 = r2._(zn || (zn = pi(["new RegExp"])));
  n2.usePattern = function(e23, t3) {
    var n3 = e23.gen, i3 = e23.it.opts, o3 = i3.unicodeRegExp ? "u" : "", s3 = i3.code.regExp, u3 = s3(t3, o3);
    return n3.scopeValue("pattern", { key: u3.toString(), ref: u3, code: r2._(Ln || (Ln = pi(["", "(", ", ", ")"])), s3.code === "new RegExp" ? f2 : (0, a2.useFunc)(n3, s3), t3, o3) });
  }, n2.validateArray = function(e23) {
    var t3 = e23.gen, n3 = e23.data, o3 = e23.keyword, a3 = e23.it, s3 = t3.name("valid");
    if (a3.allErrors) {
      var u3 = t3.let("valid", true);
      return c3(function() {
        return t3.assign(u3, false);
      }), u3;
    }
    return t3.var(s3, true), c3(function() {
      return t3.break();
    }), s3;
    function c3(a4) {
      var u4 = t3.const("len", r2._(Bn || (Bn = pi(["", ".length"])), n3));
      t3.forRange("i", 0, u4, function(n4) {
        e23.subschema({ keyword: o3, dataProp: n4, dataPropType: i2.Type.Num }, s3), t3.if((0, r2.not)(s3), a4);
      });
    }
  }, n2.validateUnion = function(e23) {
    var t3 = e23.gen, n3 = e23.schema, o3 = e23.keyword, a3 = e23.it;
    if (!Array.isArray(n3))
      throw new Error("ajv implementation error");
    if (!n3.some(function(e24) {
      return (0, i2.alwaysValidSchema)(a3, e24);
    }) || a3.opts.unevaluated) {
      var s3 = t3.let("valid", false), u3 = t3.name("_valid");
      t3.block(function() {
        return n3.forEach(function(n4, i3) {
          var a4 = e23.subschema({ keyword: o3, schemaProp: i3, compositeRule: true }, u3);
          t3.assign(s3, r2._(qn || (qn = pi(["", " || ", ""])), s3, u3)), e23.mergeValidEvaluated(a4, u3) || t3.if((0, r2.not)(s3));
        });
      }), e23.result(s3, function() {
        return e23.reset();
      }, function() {
        return e23.error(true);
      });
    }
  };
}, { "../compile/codegen": 2, "../compile/names": 6, "../compile/util": 10 }], 43: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.default = { keyword: "id", code: function() {
    throw new Error('NOT SUPPORTED: keyword "id", use "$id" for schema ID');
  } };
}, {}], 44: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("./id"), i2 = e22("./ref");
  n2.default = ["$schema", "$id", "$defs", "$vocabulary", { keyword: "$comment" }, "definitions", r2.default, i2.default];
}, { "./id": 43, "./ref": 45 }], 45: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.callRef = n2.getValidate = void 0;
  var r2 = e22("../../compile/ref_error"), i2 = e22("../code"), o2 = e22("../../compile/codegen"), a2 = e22("../../compile/names"), s2 = e22("../../compile"), u2 = e22("../../compile/util"), c2 = { keyword: "$ref", schemaType: "string", code: function(e23) {
    var t3 = e23.gen, n3 = e23.schema, i3 = e23.it, a3 = i3.baseId, u3 = i3.schemaEnv, c3 = i3.validateName, h2 = i3.opts, d2 = i3.self, v2 = u3.root;
    if ((n3 === "#" || n3 === "#/") && a3 === v2.baseId)
      return function() {
        if (u3 === v2)
          return f2(e23, c3, u3, u3.$async);
        var n4 = t3.scopeValue("root", { ref: v2 });
        return f2(e23, o2._(Fn || (Fn = pi(["", ".validate"])), n4), v2, v2.$async);
      }();
    var p2 = s2.resolveRef.call(d2, v2, a3, n3);
    if (p2 === void 0)
      throw new r2.default(i3.opts.uriResolver, a3, n3);
    return p2 instanceof s2.SchemaEnv ? function(t4) {
      var n4 = l2(e23, t4);
      f2(e23, n4, t4, t4.$async);
    }(p2) : function(r3) {
      var i4 = t3.scopeValue("schema", h2.code.source === true ? { ref: r3, code: (0, o2.stringify)(r3) } : { ref: r3 }), a4 = t3.name("valid"), s3 = e23.subschema({ schema: r3, dataTypes: [], schemaPath: o2.nil, topSchemaRef: i4, errSchemaPath: n3 }, a4);
      e23.mergeEvaluated(s3), e23.ok(a4);
    }(p2);
  } };
  function l2(e23, t3) {
    var n3 = e23.gen;
    return t3.validate ? n3.scopeValue("validate", { ref: t3.validate }) : o2._(Vn || (Vn = pi(["", ".validate"])), n3.scopeValue("wrapper", { ref: t3 }));
  }
  function f2(e23, t3, n3, r3) {
    var s3 = e23.gen, c3 = e23.it, l3 = c3.allErrors, f3 = c3.schemaEnv, h2 = c3.opts.passContext ? a2.default.this : o2.nil;
    function d2(e24) {
      var t4 = o2._(Hn || (Hn = pi(["", ".errors"])), e24);
      s3.assign(a2.default.vErrors, o2._(Wn || (Wn = pi(["", " === null ? ", " : ", ".concat(", ")"])), a2.default.vErrors, t4, a2.default.vErrors, t4)), s3.assign(a2.default.errors, o2._(Jn || (Jn = pi(["", ".length"])), a2.default.vErrors));
    }
    function v2(e24) {
      var t4;
      if (c3.opts.unevaluated) {
        var r4 = (t4 = n3 == null ? void 0 : n3.validate) === null || t4 === void 0 ? void 0 : t4.evaluated;
        if (c3.props !== true)
          if (r4 && !r4.dynamicProps)
            r4.props !== void 0 && (c3.props = u2.mergeEvaluated.props(s3, r4.props, c3.props));
          else {
            var i3 = s3.var("props", o2._(Un || (Un = pi(["", ".evaluated.props"])), e24));
            c3.props = u2.mergeEvaluated.props(s3, i3, c3.props, o2.Name);
          }
        if (c3.items !== true)
          if (r4 && !r4.dynamicItems)
            r4.items !== void 0 && (c3.items = u2.mergeEvaluated.items(s3, r4.items, c3.items));
          else {
            var a3 = s3.var("items", o2._(Kn || (Kn = pi(["", ".evaluated.items"])), e24));
            c3.items = u2.mergeEvaluated.items(s3, a3, c3.items, o2.Name);
          }
      }
    }
    r3 ? function() {
      if (!f3.$async)
        throw new Error("async schema referenced by sync schema");
      var n4 = s3.let("valid");
      s3.try(function() {
        s3.code(o2._(Gn || (Gn = pi(["await ", ""])), (0, i2.callValidateCode)(e23, t3, h2))), v2(t3), l3 || s3.assign(n4, true);
      }, function(e24) {
        s3.if(o2._(Qn || (Qn = pi(["!(", " instanceof ", ")"])), e24, c3.ValidationError), function() {
          return s3.throw(e24);
        }), d2(e24), l3 || s3.assign(n4, false);
      }), e23.ok(n4);
    }() : e23.result((0, i2.callValidateCode)(e23, t3, h2), function() {
      return v2(t3);
    }, function() {
      return d2(t3);
    });
  }
  n2.getValidate = l2, n2.callRef = f2, n2.default = c2;
}, { "../../compile": 5, "../../compile/codegen": 2, "../../compile/names": 6, "../../compile/ref_error": 7, "../../compile/util": 10, "../code": 42 }], 46: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = e22("../discriminator/types"), o2 = e22("../../compile"), a2 = e22("../../compile/util");
  n2.default = { keyword: "discriminator", type: "object", schemaType: "object", error: { message: function(e23) {
    var t3 = e23.params, n3 = t3.discrError, r3 = t3.tagName;
    return n3 === i2.DiscrError.Tag ? 'tag "'.concat(r3, '" must be string') : 'value of tag "'.concat(r3, '" must be in oneOf');
  }, params: function(e23) {
    var t3 = e23.params, n3 = t3.discrError, i3 = t3.tag, o3 = t3.tagName;
    return r2._(Yn || (Yn = pi(["{error: ", ", tag: ", ", tagValue: ", "}"])), n3, o3, i3);
  } }, code: function(e23) {
    var t3 = e23.gen, n3 = e23.data, s2 = e23.schema, u2 = e23.parentSchema, c2 = e23.it, l2 = u2.oneOf;
    if (!c2.opts.discriminator)
      throw new Error("discriminator: requires discriminator option");
    var f2 = s2.propertyName;
    if (typeof f2 != "string")
      throw new Error("discriminator: requires propertyName");
    if (s2.mapping)
      throw new Error("discriminator: mapping is not supported");
    if (!l2)
      throw new Error("discriminator: requires oneOf keyword");
    var h2 = t3.let("valid", false), d2 = t3.const("tag", r2._(Zn || (Zn = pi(["", "", ""])), n3, (0, r2.getProperty)(f2)));
    function v2(n4) {
      var i3 = t3.name("valid"), o3 = e23.subschema({ keyword: "oneOf", schemaProp: n4 }, i3);
      return e23.mergeEvaluated(o3, r2.Name), i3;
    }
    t3.if(r2._(Xn || (Xn = pi(["typeof ", ' == "string"'])), d2), function() {
      return function() {
        var n4 = function() {
          for (var e24, t4 = {}, n5 = d3(u2), r3 = true, i3 = 0; i3 < l2.length; i3++) {
            var s4 = l2[i3];
            (s4 == null ? void 0 : s4.$ref) && !(0, a2.schemaHasRulesButRef)(s4, c2.self.RULES) && (s4 = o2.resolveRef.call(c2.self, c2.schemaEnv.root, c2.baseId, s4 == null ? void 0 : s4.$ref)) instanceof o2.SchemaEnv && (s4 = s4.schema);
            var h3 = (e24 = s4 == null ? void 0 : s4.properties) === null || e24 === void 0 ? void 0 : e24[f2];
            if (Li(h3) != "object")
              throw new Error('discriminator: oneOf subschemas (or referenced schemas) must have "properties/'.concat(f2, '"'));
            r3 = r3 && (n5 || d3(s4)), v3(h3, i3);
          }
          if (!r3)
            throw new Error('discriminator: "'.concat(f2, '" must be required'));
          return t4;
          function d3(e25) {
            var t5 = e25.required;
            return Array.isArray(t5) && t5.includes(f2);
          }
          function v3(e25, t5) {
            if (e25.const)
              p2(e25.const, t5);
            else {
              if (!e25.enum)
                throw new Error('discriminator: "properties/'.concat(f2, '" must have "const" or "enum"'));
              var n6, r4 = bi(e25.enum);
              try {
                for (r4.s(); !(n6 = r4.n()).done; )
                  p2(n6.value, t5);
              } catch (e26) {
                r4.e(e26);
              } finally {
                r4.f();
              }
            }
          }
          function p2(e25, n6) {
            if (typeof e25 != "string" || e25 in t4)
              throw new Error('discriminator: "'.concat(f2, '" values must be unique strings'));
            t4[e25] = n6;
          }
        }();
        for (var s3 in t3.if(false), n4)
          t3.elseIf(r2._(er || (er = pi(["", " === ", ""])), d2, s3)), t3.assign(h2, v2(n4[s3]));
        t3.else(), e23.error(false, { discrError: i2.DiscrError.Mapping, tag: d2, tagName: f2 }), t3.endIf();
      }();
    }, function() {
      return e23.error(false, { discrError: i2.DiscrError.Tag, tag: d2, tagName: f2 });
    }), e23.ok(h2);
  } };
}, { "../../compile": 5, "../../compile/codegen": 2, "../../compile/util": 10, "../discriminator/types": 47 }], 47: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.DiscrError = void 0, function(e23) {
    e23.Tag = "tag", e23.Mapping = "mapping";
  }(n2.DiscrError || (n2.DiscrError = {}));
}, {}], 48: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("./core"), i2 = e22("./validation"), o2 = e22("./applicator"), a2 = e22("./format"), s2 = e22("./metadata"), u2 = [r2.default, i2.default, (0, o2.default)(), a2.default, s2.metadataVocabulary, s2.contentVocabulary];
  n2.default = u2;
}, { "./applicator": 32, "./core": 44, "./format": 50, "./metadata": 51, "./validation": 54 }], 49: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen");
  n2.default = { keyword: "format", type: ["number", "string"], schemaType: "string", $data: true, error: { message: function(e23) {
    var t3 = e23.schemaCode;
    return r2.str(tr || (tr = pi(['must match format "', '"'])), t3);
  }, params: function(e23) {
    var t3 = e23.schemaCode;
    return r2._(nr || (nr = pi(["{format: ", "}"])), t3);
  } }, code: function(e23, t3) {
    var n3 = e23.gen, i2 = e23.data, o2 = e23.$data, a2 = e23.schema, s2 = e23.schemaCode, u2 = e23.it, c2 = u2.opts, l2 = u2.errSchemaPath, f2 = u2.schemaEnv, h2 = u2.self;
    c2.validateFormats && (o2 ? function() {
      var o3 = n3.scopeValue("formats", { ref: h2.formats, code: c2.code.formats }), a3 = n3.const("fDef", r2._(rr || (rr = pi(["", "[", "]"])), o3, s2)), u3 = n3.let("fType"), l3 = n3.let("format");
      n3.if(r2._(ir || (ir = pi(["typeof ", ' == "object" && !(', " instanceof RegExp)"])), a3, a3), function() {
        return n3.assign(u3, r2._(or || (or = pi(["", '.type || "string"'])), a3)).assign(l3, r2._(ar || (ar = pi(["", ".validate"])), a3));
      }, function() {
        return n3.assign(u3, r2._(sr || (sr = pi(['"string"'])))).assign(l3, a3);
      }), e23.fail$data((0, r2.or)(c2.strictSchema === false ? r2.nil : r2._(ur || (ur = pi(["", " && !", ""])), s2, l3), function() {
        var e24 = f2.$async ? r2._(cr || (cr = pi(["(", ".async ? await ", "(", ") : ", "(", "))"])), a3, l3, i2, l3, i2) : r2._(lr || (lr = pi(["", "(", ")"])), l3, i2), n4 = r2._(fr || (fr = pi(["(typeof ", ' == "function" ? ', " : ", ".test(", "))"])), l3, e24, l3, i2);
        return r2._(hr || (hr = pi(["", " && ", " !== true && ", " === ", " && !", ""])), l3, l3, u3, t3, n4);
      }()));
    }() : function() {
      var o3 = h2.formats[a2];
      if (o3) {
        if (o3 !== true) {
          var s3 = xi(function(e24) {
            var t4 = e24 instanceof RegExp ? (0, r2.regexpCode)(e24) : c2.code.formats ? r2._(dr || (dr = pi(["", "", ""])), c2.code.formats, (0, r2.getProperty)(a2)) : void 0, i3 = n3.scopeValue("formats", { key: a2, ref: e24, code: t4 });
            return Li(e24) != "object" || e24 instanceof RegExp ? ["string", e24, i3] : [e24.type || "string", e24.validate, r2._(vr || (vr = pi(["", ".validate"])), i3)];
          }(o3), 3), u3 = s3[0], d2 = s3[1], v2 = s3[2];
          u3 === t3 && e23.pass(function() {
            if (Li(o3) == "object" && !(o3 instanceof RegExp) && o3.async) {
              if (!f2.$async)
                throw new Error("async format in sync schema");
              return r2._(pr || (pr = pi(["await ", "(", ")"])), v2, i2);
            }
            return typeof d2 == "function" ? r2._(mr || (mr = pi(["", "(", ")"])), v2, i2) : r2._(gr || (gr = pi(["", ".test(", ")"])), v2, i2);
          }());
        }
      } else
        !function() {
          if (c2.strictSchema !== false)
            throw new Error(e24());
          function e24() {
            return 'unknown format "'.concat(a2, '" ignored in schema at path "').concat(l2, '"');
          }
          h2.logger.warn(e24());
        }();
    }());
  } };
}, { "../../compile/codegen": 2 }], 50: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("./format");
  n2.default = [r2.default];
}, { "./format": 49 }], 51: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.contentVocabulary = n2.metadataVocabulary = void 0, n2.metadataVocabulary = ["title", "description", "default", "deprecated", "readOnly", "writeOnly", "examples"], n2.contentVocabulary = ["contentMediaType", "contentEncoding", "contentSchema"];
}, {}], 52: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util"), o2 = e22("../../runtime/equal");
  n2.default = { keyword: "const", $data: true, error: { message: "must be equal to constant", params: function(e23) {
    var t3 = e23.schemaCode;
    return r2._(yr || (yr = pi(["{allowedValue: ", "}"])), t3);
  } }, code: function(e23) {
    var t3 = e23.gen, n3 = e23.data, a2 = e23.$data, s2 = e23.schemaCode, u2 = e23.schema;
    a2 || u2 && Li(u2) == "object" ? e23.fail$data(r2._(br || (br = pi(["!", "(", ", ", ")"])), (0, i2.useFunc)(t3, o2.default), n3, s2)) : e23.fail(r2._(kr || (kr = pi(["", " !== ", ""])), u2, n3));
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10, "../../runtime/equal": 21 }], 53: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util"), o2 = e22("../../runtime/equal");
  n2.default = { keyword: "enum", schemaType: "array", $data: true, error: { message: "must be equal to one of the allowed values", params: function(e23) {
    var t3 = e23.schemaCode;
    return r2._(wr || (wr = pi(["{allowedValues: ", "}"])), t3);
  } }, code: function(e23) {
    var t3, n3 = e23.gen, a2 = e23.data, s2 = e23.$data, u2 = e23.schema, c2 = e23.schemaCode, l2 = e23.it;
    if (!s2 && u2.length === 0)
      throw new Error("enum must have non-empty array");
    var f2, h2 = function() {
      return t3 != null ? t3 : t3 = (0, i2.useFunc)(n3, o2.default);
    };
    if (u2.length >= l2.opts.loopEnum || s2)
      f2 = n3.let("valid"), e23.block$data(f2, function() {
        n3.assign(f2, false), n3.forOf("v", c2, function(e24) {
          return n3.if(r2._(xr || (xr = pi(["", "(", ", ", ")"])), h2(), a2, e24), function() {
            return n3.assign(f2, true).break();
          });
        });
      });
    else {
      if (!Array.isArray(u2))
        throw new Error("ajv implementation error");
      var d2 = n3.const("vSchema", c2);
      f2 = r2.or.apply(void 0, Ni(u2.map(function(e24, t4) {
        return function(e25, t5) {
          var n4 = u2[t5];
          return Li(n4) == "object" && n4 !== null ? r2._(jr || (jr = pi(["", "(", ", ", "[", "])"])), h2(), a2, e25, t5) : r2._(Sr || (Sr = pi(["", " === ", ""])), a2, n4);
        }(d2, t4);
      })));
    }
    e23.pass(f2);
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10, "../../runtime/equal": 21 }], 54: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("./limitNumber"), i2 = e22("./multipleOf"), o2 = e22("./limitLength"), a2 = e22("./pattern"), s2 = e22("./limitProperties"), u2 = e22("./required"), c2 = e22("./limitItems"), l2 = e22("./uniqueItems"), f2 = e22("./const"), h2 = e22("./enum");
  n2.default = [r2.default, i2.default, o2.default, a2.default, s2.default, u2.default, c2.default, l2.default, { keyword: "type", schemaType: ["string", "array"] }, { keyword: "nullable", schemaType: "boolean" }, f2.default, h2.default];
}, { "./const": 52, "./enum": 53, "./limitItems": 55, "./limitLength": 56, "./limitNumber": 57, "./limitProperties": 58, "./multipleOf": 59, "./pattern": 60, "./required": 61, "./uniqueItems": 62 }], 55: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen");
  n2.default = { keyword: ["maxItems", "minItems"], type: "array", schemaType: "number", $data: true, error: { message: function(e23) {
    var t3 = e23.keyword, n3 = e23.schemaCode;
    return r2.str(Cr || (Cr = pi(["must NOT have ", " than ", " items"])), t3 === "maxItems" ? "more" : "fewer", n3);
  }, params: function(e23) {
    var t3 = e23.schemaCode;
    return r2._(_r || (_r = pi(["{limit: ", "}"])), t3);
  } }, code: function(e23) {
    var t3 = e23.keyword, n3 = e23.data, i2 = e23.schemaCode;
    e23.fail$data(r2._($r || ($r = pi(["", ".length ", " ", ""])), n3, t3 === "maxItems" ? r2.operators.GT : r2.operators.LT, i2));
  } };
}, { "../../compile/codegen": 2 }], 56: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = e22("../../compile/util"), o2 = e22("../../runtime/ucs2length");
  n2.default = { keyword: ["maxLength", "minLength"], type: "string", schemaType: "number", $data: true, error: { message: function(e23) {
    var t3 = e23.keyword, n3 = e23.schemaCode;
    return r2.str(Or || (Or = pi(["must NOT have ", " than ", " characters"])), t3 === "maxLength" ? "more" : "fewer", n3);
  }, params: function(e23) {
    var t3 = e23.schemaCode;
    return r2._(Ar || (Ar = pi(["{limit: ", "}"])), t3);
  } }, code: function(e23) {
    var t3 = e23.keyword, n3 = e23.data, a2 = e23.schemaCode, s2 = e23.it, u2 = t3 === "maxLength" ? r2.operators.GT : r2.operators.LT, c2 = s2.opts.unicode === false ? r2._(Mr || (Mr = pi(["", ".length"])), n3) : r2._(Er || (Er = pi(["", "(", ")"])), (0, i2.useFunc)(e23.gen, o2.default), n3);
    e23.fail$data(r2._(Pr || (Pr = pi(["", " ", " ", ""])), c2, u2, a2));
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10, "../../runtime/ucs2length": 22 }], 57: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen"), i2 = r2.operators, o2 = { maximum: { okStr: "<=", ok: i2.LTE, fail: i2.GT }, minimum: { okStr: ">=", ok: i2.GTE, fail: i2.LT }, exclusiveMaximum: { okStr: "<", ok: i2.LT, fail: i2.GTE }, exclusiveMinimum: { okStr: ">", ok: i2.GT, fail: i2.LTE } }, a2 = { message: function(e23) {
    var t3 = e23.keyword, n3 = e23.schemaCode;
    return r2.str(Nr || (Nr = pi(["must be ", " ", ""])), o2[t3].okStr, n3);
  }, params: function(e23) {
    var t3 = e23.keyword, n3 = e23.schemaCode;
    return r2._(Tr || (Tr = pi(["{comparison: ", ", limit: ", "}"])), o2[t3].okStr, n3);
  } }, s2 = { keyword: Object.keys(o2), type: "number", schemaType: "number", $data: true, error: a2, code: function(e23) {
    var t3 = e23.keyword, n3 = e23.data, i3 = e23.schemaCode;
    e23.fail$data(r2._(Ir || (Ir = pi(["", " ", " ", " || isNaN(", ")"])), n3, o2[t3].fail, i3, n3));
  } };
  n2.default = s2;
}, { "../../compile/codegen": 2 }], 58: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen");
  n2.default = { keyword: ["maxProperties", "minProperties"], type: "object", schemaType: "number", $data: true, error: { message: function(e23) {
    var t3 = e23.keyword, n3 = e23.schemaCode;
    return r2.str(Rr || (Rr = pi(["must NOT have ", " than ", " properties"])), t3 === "maxProperties" ? "more" : "fewer", n3);
  }, params: function(e23) {
    var t3 = e23.schemaCode;
    return r2._(Dr || (Dr = pi(["{limit: ", "}"])), t3);
  } }, code: function(e23) {
    var t3 = e23.keyword, n3 = e23.data, i2 = e23.schemaCode;
    e23.fail$data(r2._(zr || (zr = pi(["Object.keys(", ").length ", " ", ""])), n3, t3 === "maxProperties" ? r2.operators.GT : r2.operators.LT, i2));
  } };
}, { "../../compile/codegen": 2 }], 59: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/codegen");
  n2.default = { keyword: "multipleOf", type: "number", schemaType: "number", $data: true, error: { message: function(e23) {
    var t3 = e23.schemaCode;
    return r2.str(Lr || (Lr = pi(["must be multiple of ", ""])), t3);
  }, params: function(e23) {
    var t3 = e23.schemaCode;
    return r2._(Br || (Br = pi(["{multipleOf: ", "}"])), t3);
  } }, code: function(e23) {
    var t3 = e23.gen, n3 = e23.data, i2 = e23.schemaCode, o2 = e23.it.opts.multipleOfPrecision, a2 = t3.let("res"), s2 = o2 ? r2._(qr || (qr = pi(["Math.abs(Math.round(", ") - ", ") > 1e-", ""])), a2, a2, o2) : r2._(Fr || (Fr = pi(["", " !== parseInt(", ")"])), a2, a2);
    e23.fail$data(r2._(Vr || (Vr = pi(["(", " === 0 || (", " = ", "/", ", ", "))"])), i2, a2, n3, i2, s2));
  } };
}, { "../../compile/codegen": 2 }], 60: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../code"), i2 = e22("../../compile/codegen");
  n2.default = { keyword: "pattern", type: "string", schemaType: "string", $data: true, error: { message: function(e23) {
    var t3 = e23.schemaCode;
    return i2.str(Hr || (Hr = pi(['must match pattern "', '"'])), t3);
  }, params: function(e23) {
    var t3 = e23.schemaCode;
    return i2._(Wr || (Wr = pi(["{pattern: ", "}"])), t3);
  } }, code: function(e23) {
    var t3 = e23.data, n3 = e23.$data, o2 = e23.schema, a2 = e23.schemaCode, s2 = e23.it, u2 = n3 ? i2._(Jr || (Jr = pi(["(new RegExp(", ", ", "))"])), a2, s2.opts.unicodeRegExp ? "u" : "") : (0, r2.usePattern)(e23, o2);
    e23.fail$data(i2._(Ur || (Ur = pi(["!", ".test(", ")"])), u2, t3));
  } };
}, { "../../compile/codegen": 2, "../code": 42 }], 61: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../code"), i2 = e22("../../compile/codegen"), o2 = e22("../../compile/util");
  n2.default = { keyword: "required", type: "object", schemaType: "array", $data: true, error: { message: function(e23) {
    var t3 = e23.params.missingProperty;
    return i2.str(Kr || (Kr = pi(["must have required property '", "'"])), t3);
  }, params: function(e23) {
    var t3 = e23.params.missingProperty;
    return i2._(Gr || (Gr = pi(["{missingProperty: ", "}"])), t3);
  } }, code: function(e23) {
    var t3 = e23.gen, n3 = e23.schema, a2 = e23.schemaCode, s2 = e23.data, u2 = e23.$data, c2 = e23.it, l2 = c2.opts;
    if (u2 || n3.length !== 0) {
      var f2 = n3.length >= l2.loopRequired;
      if (c2.allErrors ? function() {
        if (f2 || u2)
          e23.block$data(i2.nil, g2);
        else {
          var t4, o3 = bi(n3);
          try {
            for (o3.s(); !(t4 = o3.n()).done; ) {
              var a3 = t4.value;
              (0, r2.checkReportMissingProp)(e23, a3);
            }
          } catch (e24) {
            o3.e(e24);
          } finally {
            o3.f();
          }
        }
      }() : function() {
        var o3 = t3.let("missing");
        if (f2 || u2) {
          var c3 = t3.let("valid", true);
          e23.block$data(c3, function() {
            return function(n4, o4) {
              e23.setParams({ missingProperty: n4 }), t3.forOf(n4, a2, function() {
                t3.assign(o4, (0, r2.propertyInData)(t3, s2, n4, l2.ownProperties)), t3.if((0, i2.not)(o4), function() {
                  e23.error(), t3.break();
                });
              }, i2.nil);
            }(o3, c3);
          }), e23.ok(c3);
        } else
          t3.if((0, r2.checkMissingProp)(e23, n3, o3)), (0, r2.reportMissingProp)(e23, o3), t3.else();
      }(), l2.strictRequired) {
        var h2, d2 = e23.parentSchema.properties, v2 = e23.it.definedProperties, p2 = bi(n3);
        try {
          for (p2.s(); !(h2 = p2.n()).done; ) {
            var m2 = h2.value;
            (d2 == null ? void 0 : d2[m2]) !== void 0 || v2.has(m2) || (0, o2.checkStrictMode)(c2, 'required property "'.concat(m2, '" is not defined at "').concat(c2.schemaEnv.baseId + c2.errSchemaPath, '" (strictRequired)'), c2.opts.strictRequired);
          }
        } catch (e24) {
          p2.e(e24);
        } finally {
          p2.f();
        }
      }
    }
    function g2() {
      t3.forOf("prop", a2, function(n4) {
        e23.setParams({ missingProperty: n4 }), t3.if((0, r2.noPropertyInData)(t3, s2, n4, l2.ownProperties), function() {
          return e23.error();
        });
      });
    }
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10, "../code": 42 }], 62: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true });
  var r2 = e22("../../compile/validate/dataType"), i2 = e22("../../compile/codegen"), o2 = e22("../../compile/util"), a2 = e22("../../runtime/equal");
  n2.default = { keyword: "uniqueItems", type: "array", schemaType: "boolean", $data: true, error: { message: function(e23) {
    var t3 = e23.params, n3 = t3.i, r3 = t3.j;
    return i2.str(Qr || (Qr = pi(["must NOT have duplicate items (items ## ", " and ", " are identical)"])), r3, n3);
  }, params: function(e23) {
    var t3 = e23.params, n3 = t3.i, r3 = t3.j;
    return i2._(Yr || (Yr = pi(["{i: ", ", j: ", "}"])), n3, r3);
  } }, code: function(e23) {
    var t3 = e23.gen, n3 = e23.data, s2 = e23.$data, u2 = e23.schema, c2 = e23.parentSchema, l2 = e23.schemaCode, f2 = e23.it;
    if (s2 || u2) {
      var h2 = t3.let("valid"), d2 = c2.items ? (0, r2.getSchemaTypes)(c2.items) : [];
      e23.block$data(h2, function() {
        var r3 = t3.let("i", i2._(li || (li = pi(["", ".length"])), n3)), o3 = t3.let("j");
        e23.setParams({ i: r3, j: o3 }), t3.assign(h2, true), t3.if(i2._(fi || (fi = pi(["", " > 1"])), r3), function() {
          return (d2.length > 0 && !d2.some(function(e24) {
            return e24 === "object" || e24 === "array";
          }) ? v2 : p2)(r3, o3);
        });
      }, i2._(hi || (hi = pi(["", " === false"])), l2)), e23.ok(h2);
    }
    function v2(o3, a3) {
      var s3 = t3.name("item"), u3 = (0, r2.checkDataTypes)(d2, s3, f2.opts.strictNumbers, r2.DataType.Wrong), c3 = t3.const("indices", i2._(Zr || (Zr = pi(["{}"]))));
      t3.for(i2._(Xr || (Xr = pi([";", "--;"])), o3), function() {
        t3.let(s3, i2._(ei || (ei = pi(["", "[", "]"])), n3, o3)), t3.if(u3, i2._(ti || (ti = pi(["continue"])))), d2.length > 1 && t3.if(i2._(ni || (ni = pi(["typeof ", ' == "string"'])), s3), i2._(ri || (ri = pi(["", ' += "_"'])), s3)), t3.if(i2._(ii || (ii = pi(["typeof ", "[", '] == "number"'])), c3, s3), function() {
          t3.assign(a3, i2._(oi || (oi = pi(["", "[", "]"])), c3, s3)), e23.error(), t3.assign(h2, false).break();
        }).code(i2._(ai || (ai = pi(["", "[", "] = ", ""])), c3, s3, o3));
      });
    }
    function p2(r3, s3) {
      var u3 = (0, o2.useFunc)(t3, a2.default), c3 = t3.name("outer");
      t3.label(c3).for(i2._(si || (si = pi([";", "--;"])), r3), function() {
        return t3.for(i2._(ui || (ui = pi(["", " = ", "; ", "--;"])), s3, r3, s3), function() {
          return t3.if(i2._(ci || (ci = pi(["", "(", "[", "], ", "[", "])"])), u3, n3, r3, n3, s3), function() {
            e23.error(), t3.assign(h2, false).break(c3);
          });
        });
      });
    }
  } };
}, { "../../compile/codegen": 2, "../../compile/util": 10, "../../compile/validate/dataType": 13, "../../runtime/equal": 21 }], 63: [function(e22, t2, n2) {
  t2.exports = function e23(t3, n3) {
    if (t3 === n3)
      return true;
    if (t3 && n3 && Li(t3) == "object" && Li(n3) == "object") {
      if (t3.constructor !== n3.constructor)
        return false;
      var r2, i2, o2;
      if (Array.isArray(t3)) {
        if ((r2 = t3.length) != n3.length)
          return false;
        for (i2 = r2; i2-- != 0; )
          if (!e23(t3[i2], n3[i2]))
            return false;
        return true;
      }
      if (t3.constructor === RegExp)
        return t3.source === n3.source && t3.flags === n3.flags;
      if (t3.valueOf !== Object.prototype.valueOf)
        return t3.valueOf() === n3.valueOf();
      if (t3.toString !== Object.prototype.toString)
        return t3.toString() === n3.toString();
      if ((r2 = (o2 = Object.keys(t3)).length) !== Object.keys(n3).length)
        return false;
      for (i2 = r2; i2-- != 0; )
        if (!Object.prototype.hasOwnProperty.call(n3, o2[i2]))
          return false;
      for (i2 = r2; i2-- != 0; ) {
        var a2 = o2[i2];
        if (!e23(t3[a2], n3[a2]))
          return false;
      }
      return true;
    }
    return t3 != t3 && n3 != n3;
  };
}, {}], 64: [function(e22, t2, n2) {
  var r2 = t2.exports = function(e23, t3, n3) {
    typeof t3 == "function" && (n3 = t3, t3 = {}), i2(t3, typeof (n3 = t3.cb || n3) == "function" ? n3 : n3.pre || function() {
    }, n3.post || function() {
    }, e23, "", e23);
  };
  function i2(e23, t3, n3, o2, a2, s2, u2, c2, l2, f2) {
    if (o2 && Li(o2) == "object" && !Array.isArray(o2)) {
      for (var h2 in t3(o2, a2, s2, u2, c2, l2, f2), o2) {
        var d2 = o2[h2];
        if (Array.isArray(d2)) {
          if (h2 in r2.arrayKeywords)
            for (var v2 = 0; v2 < d2.length; v2++)
              i2(e23, t3, n3, d2[v2], a2 + "/" + h2 + "/" + v2, s2, a2, h2, o2, v2);
        } else if (h2 in r2.propsKeywords) {
          if (d2 && Li(d2) == "object")
            for (var p2 in d2)
              i2(e23, t3, n3, d2[p2], a2 + "/" + h2 + "/" + p2.replace(/~/g, "~0").replace(/\//g, "~1"), s2, a2, h2, o2, p2);
        } else
          (h2 in r2.keywords || e23.allKeys && !(h2 in r2.skipKeywords)) && i2(e23, t3, n3, d2, a2 + "/" + h2, s2, a2, h2, o2);
      }
      n3(o2, a2, s2, u2, c2, l2, f2);
    }
  }
  r2.keywords = { additionalItems: true, items: true, contains: true, additionalProperties: true, propertyNames: true, not: true, if: true, then: true, else: true }, r2.arrayKeywords = { items: true, allOf: true, anyOf: true, oneOf: true }, r2.propsKeywords = { $defs: true, definitions: true, properties: true, patternProperties: true, dependencies: true }, r2.skipKeywords = { default: true, enum: true, const: true, required: true, maximum: true, minimum: true, exclusiveMaximum: true, exclusiveMinimum: true, multipleOf: true, maxLength: true, minLength: true, pattern: true, format: true, maxItems: true, minItems: true, uniqueItems: true, maxProperties: true, minProperties: true };
}, {}], 65: [function(e22, t2, n2) {
  /** @license URI.js v4.4.1 (c) 2011 Gary Court. License: http://github.com/garycourt/uri-js */
  !function(e23, r2) {
    r2(Li(n2) == "object" && t2 !== void 0 ? n2 : e23.URI = e23.URI || {});
  }(this, function(e23) {
    function t3() {
      for (var e24 = arguments.length, t4 = Array(e24), n4 = 0; n4 < e24; n4++)
        t4[n4] = arguments[n4];
      if (t4.length > 1) {
        t4[0] = t4[0].slice(0, -1);
        for (var r3 = t4.length - 1, i3 = 1; i3 < r3; ++i3)
          t4[i3] = t4[i3].slice(1, -1);
        return t4[r3] = t4[r3].slice(1), t4.join("");
      }
      return t4[0];
    }
    function n3(e24) {
      return "(?:" + e24 + ")";
    }
    function r2(e24) {
      return e24 === void 0 ? "undefined" : e24 === null ? "null" : Object.prototype.toString.call(e24).split(" ").pop().split("]").shift().toLowerCase();
    }
    function i2(e24) {
      return e24.toUpperCase();
    }
    function o2(e24) {
      var r3 = "[A-Za-z]", i3 = "[0-9]", o3 = t3(i3, "[A-Fa-f]"), a3 = n3(n3("%[EFef]" + o3 + "%" + o3 + o3 + "%" + o3 + o3) + "|" + n3("%[89A-Fa-f]" + o3 + "%" + o3 + o3) + "|" + n3("%" + o3 + o3)), s3 = "[\\!\\$\\&\\'\\(\\)\\*\\+\\,\\;\\=]", u3 = t3("[\\:\\/\\?\\#\\[\\]\\@]", s3), c3 = e24 ? "[\\uE000-\\uF8FF]" : "[]", l3 = t3(r3, i3, "[\\-\\.\\_\\~]", e24 ? "[\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]" : "[]");
      n3(r3 + t3(r3, i3, "[\\+\\-\\.]") + "*"), n3(n3(a3 + "|" + t3(l3, s3, "[\\:]")) + "*");
      var f3 = n3(n3("25[0-5]") + "|" + n3("2[0-4][0-9]") + "|" + n3("1[0-9][0-9]") + "|" + n3("0?[1-9][0-9]") + "|0?0?" + i3), h3 = n3(f3 + "\\." + f3 + "\\." + f3 + "\\." + f3), d3 = n3(o3 + "{1,4}"), v3 = n3(n3(d3 + "\\:" + d3) + "|" + h3), p3 = n3(n3(d3 + "\\:") + "{6}" + v3), m3 = n3("\\:\\:" + n3(d3 + "\\:") + "{5}" + v3), g3 = n3(n3(d3) + "?\\:\\:" + n3(d3 + "\\:") + "{4}" + v3), y3 = n3(n3(n3(d3 + "\\:") + "{0,1}" + d3) + "?\\:\\:" + n3(d3 + "\\:") + "{3}" + v3), b3 = n3(n3(n3(d3 + "\\:") + "{0,2}" + d3) + "?\\:\\:" + n3(d3 + "\\:") + "{2}" + v3), k3 = n3(n3(n3(d3 + "\\:") + "{0,3}" + d3) + "?\\:\\:" + d3 + "\\:" + v3), w3 = n3(n3(n3(d3 + "\\:") + "{0,4}" + d3) + "?\\:\\:" + v3), x3 = n3(n3(n3(d3 + "\\:") + "{0,5}" + d3) + "?\\:\\:" + d3), j3 = n3(n3(n3(d3 + "\\:") + "{0,6}" + d3) + "?\\:\\:"), S3 = n3([p3, m3, g3, y3, b3, k3, w3, x3, j3].join("|")), C3 = n3(n3(l3 + "|" + a3) + "+");
      n3("[vV]" + o3 + "+\\." + t3(l3, s3, "[\\:]") + "+"), n3(n3(a3 + "|" + t3(l3, s3)) + "*");
      var _3 = n3(a3 + "|" + t3(l3, s3, "[\\:\\@]"));
      return n3(n3(a3 + "|" + t3(l3, s3, "[\\@]")) + "+"), n3(n3(_3 + "|" + t3("[\\/\\?]", c3)) + "*"), { NOT_SCHEME: new RegExp(t3("[^]", r3, i3, "[\\+\\-\\.]"), "g"), NOT_USERINFO: new RegExp(t3("[^\\%\\:]", l3, s3), "g"), NOT_HOST: new RegExp(t3("[^\\%\\[\\]\\:]", l3, s3), "g"), NOT_PATH: new RegExp(t3("[^\\%\\/\\:\\@]", l3, s3), "g"), NOT_PATH_NOSCHEME: new RegExp(t3("[^\\%\\/\\@]", l3, s3), "g"), NOT_QUERY: new RegExp(t3("[^\\%]", l3, s3, "[\\:\\@\\/\\?]", c3), "g"), NOT_FRAGMENT: new RegExp(t3("[^\\%]", l3, s3, "[\\:\\@\\/\\?]"), "g"), ESCAPE: new RegExp(t3("[^]", l3, s3), "g"), UNRESERVED: new RegExp(l3, "g"), OTHER_CHARS: new RegExp(t3("[^\\%]", l3, u3), "g"), PCT_ENCODED: new RegExp(a3, "g"), IPV4ADDRESS: new RegExp("^(" + h3 + ")$"), IPV6ADDRESS: new RegExp("^\\[?(" + S3 + ")" + n3(n3("\\%25|\\%(?!" + o3 + "{2})") + "(" + C3 + ")") + "?\\]?$") };
    }
    var a2 = o2(false), s2 = o2(true), u2 = function(e24, t4) {
      if (Array.isArray(e24))
        return e24;
      if (Symbol.iterator in Object(e24))
        return function(e25, t5) {
          var n4 = [], r3 = true, i3 = false, o3 = void 0;
          try {
            for (var a3, s3 = e25[Symbol.iterator](); !(r3 = (a3 = s3.next()).done) && (n4.push(a3.value), !t5 || n4.length !== t5); r3 = true)
              ;
          } catch (e26) {
            i3 = true, o3 = e26;
          } finally {
            try {
              !r3 && s3.return && s3.return();
            } finally {
              if (i3)
                throw o3;
            }
          }
          return n4;
        }(e24, t4);
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }, c2 = 2147483647, l2 = 36, f2 = /^xn--/, h2 = /[^\0-\x7E]/, d2 = /[\x2E\u3002\uFF0E\uFF61]/g, v2 = { overflow: "Overflow: input needs wider integers to process", "not-basic": "Illegal input >= 0x80 (not a basic code point)", "invalid-input": "Invalid input" }, p2 = Math.floor, m2 = String.fromCharCode;
    function g2(e24) {
      throw new RangeError(v2[e24]);
    }
    function y2(e24, t4) {
      var n4 = e24.split("@"), r3 = "";
      n4.length > 1 && (r3 = n4[0] + "@", e24 = n4[1]);
      var i3 = function(e25, t5) {
        for (var n5 = [], r4 = e25.length; r4--; )
          n5[r4] = t5(e25[r4]);
        return n5;
      }((e24 = e24.replace(d2, ".")).split("."), t4).join(".");
      return r3 + i3;
    }
    function b2(e24) {
      for (var t4 = [], n4 = 0, r3 = e24.length; n4 < r3; ) {
        var i3 = e24.charCodeAt(n4++);
        if (i3 >= 55296 && i3 <= 56319 && n4 < r3) {
          var o3 = e24.charCodeAt(n4++);
          (64512 & o3) == 56320 ? t4.push(((1023 & i3) << 10) + (1023 & o3) + 65536) : (t4.push(i3), n4--);
        } else
          t4.push(i3);
      }
      return t4;
    }
    var k2 = function(e24, t4) {
      return e24 + 22 + 75 * (e24 < 26) - ((t4 != 0) << 5);
    }, w2 = function(e24, t4, n4) {
      var r3 = 0;
      for (e24 = n4 ? p2(e24 / 700) : e24 >> 1, e24 += p2(e24 / t4); e24 > 455; r3 += l2)
        e24 = p2(e24 / 35);
      return p2(r3 + 36 * e24 / (e24 + 38));
    }, x2 = function(e24) {
      var t4, n4 = [], r3 = e24.length, i3 = 0, o3 = 128, a3 = 72, s3 = e24.lastIndexOf("-");
      s3 < 0 && (s3 = 0);
      for (var u3 = 0; u3 < s3; ++u3)
        e24.charCodeAt(u3) >= 128 && g2("not-basic"), n4.push(e24.charCodeAt(u3));
      for (var f3 = s3 > 0 ? s3 + 1 : 0; f3 < r3; ) {
        for (var h3 = i3, d3 = 1, v3 = l2; ; v3 += l2) {
          f3 >= r3 && g2("invalid-input");
          var m3 = (t4 = e24.charCodeAt(f3++)) - 48 < 10 ? t4 - 22 : t4 - 65 < 26 ? t4 - 65 : t4 - 97 < 26 ? t4 - 97 : l2;
          (m3 >= l2 || m3 > p2((c2 - i3) / d3)) && g2("overflow"), i3 += m3 * d3;
          var y3 = v3 <= a3 ? 1 : v3 >= a3 + 26 ? 26 : v3 - a3;
          if (m3 < y3)
            break;
          var b3 = l2 - y3;
          d3 > p2(c2 / b3) && g2("overflow"), d3 *= b3;
        }
        var k3 = n4.length + 1;
        a3 = w2(i3 - h3, k3, h3 == 0), p2(i3 / k3) > c2 - o3 && g2("overflow"), o3 += p2(i3 / k3), i3 %= k3, n4.splice(i3++, 0, o3);
      }
      return String.fromCodePoint.apply(String, n4);
    }, j2 = function(e24) {
      var t4 = [], n4 = (e24 = b2(e24)).length, r3 = 128, i3 = 0, o3 = 72, a3 = true, s3 = false, u3 = void 0;
      try {
        for (var f3, h3 = e24[Symbol.iterator](); !(a3 = (f3 = h3.next()).done); a3 = true) {
          var d3 = f3.value;
          d3 < 128 && t4.push(m2(d3));
        }
      } catch (e25) {
        s3 = true, u3 = e25;
      } finally {
        try {
          !a3 && h3.return && h3.return();
        } finally {
          if (s3)
            throw u3;
        }
      }
      var v3 = t4.length, y3 = v3;
      for (v3 && t4.push("-"); y3 < n4; ) {
        var x3 = c2, j3 = true, S3 = false, C3 = void 0;
        try {
          for (var _3, $3 = e24[Symbol.iterator](); !(j3 = (_3 = $3.next()).done); j3 = true) {
            var O3 = _3.value;
            O3 >= r3 && O3 < x3 && (x3 = O3);
          }
        } catch (e25) {
          S3 = true, C3 = e25;
        } finally {
          try {
            !j3 && $3.return && $3.return();
          } finally {
            if (S3)
              throw C3;
          }
        }
        var A3 = y3 + 1;
        x3 - r3 > p2((c2 - i3) / A3) && g2("overflow"), i3 += (x3 - r3) * A3, r3 = x3;
        var M3 = true, E3 = false, P3 = void 0;
        try {
          for (var N3, T3 = e24[Symbol.iterator](); !(M3 = (N3 = T3.next()).done); M3 = true) {
            var I3 = N3.value;
            if (I3 < r3 && ++i3 > c2 && g2("overflow"), I3 == r3) {
              for (var R3 = i3, D3 = l2; ; D3 += l2) {
                var z3 = D3 <= o3 ? 1 : D3 >= o3 + 26 ? 26 : D3 - o3;
                if (R3 < z3)
                  break;
                var L3 = R3 - z3, B3 = l2 - z3;
                t4.push(m2(k2(z3 + L3 % B3, 0))), R3 = p2(L3 / B3);
              }
              t4.push(m2(k2(R3, 0))), o3 = w2(i3, A3, y3 == v3), i3 = 0, ++y3;
            }
          }
        } catch (e25) {
          E3 = true, P3 = e25;
        } finally {
          try {
            !M3 && T3.return && T3.return();
          } finally {
            if (E3)
              throw P3;
          }
        }
        ++i3, ++r3;
      }
      return t4.join("");
    }, S2 = function(e24) {
      return y2(e24, function(e25) {
        return h2.test(e25) ? "xn--" + j2(e25) : e25;
      });
    }, C2 = function(e24) {
      return y2(e24, function(e25) {
        return f2.test(e25) ? x2(e25.slice(4).toLowerCase()) : e25;
      });
    }, _2 = {};
    function $2(e24) {
      var t4 = e24.charCodeAt(0);
      return t4 < 16 ? "%0" + t4.toString(16).toUpperCase() : t4 < 128 ? "%" + t4.toString(16).toUpperCase() : t4 < 2048 ? "%" + (t4 >> 6 | 192).toString(16).toUpperCase() + "%" + (63 & t4 | 128).toString(16).toUpperCase() : "%" + (t4 >> 12 | 224).toString(16).toUpperCase() + "%" + (t4 >> 6 & 63 | 128).toString(16).toUpperCase() + "%" + (63 & t4 | 128).toString(16).toUpperCase();
    }
    function O2(e24) {
      for (var t4 = "", n4 = 0, r3 = e24.length; n4 < r3; ) {
        var i3 = parseInt(e24.substr(n4 + 1, 2), 16);
        if (i3 < 128)
          t4 += String.fromCharCode(i3), n4 += 3;
        else if (i3 >= 194 && i3 < 224) {
          if (r3 - n4 >= 6) {
            var o3 = parseInt(e24.substr(n4 + 4, 2), 16);
            t4 += String.fromCharCode((31 & i3) << 6 | 63 & o3);
          } else
            t4 += e24.substr(n4, 6);
          n4 += 6;
        } else if (i3 >= 224) {
          if (r3 - n4 >= 9) {
            var a3 = parseInt(e24.substr(n4 + 4, 2), 16), s3 = parseInt(e24.substr(n4 + 7, 2), 16);
            t4 += String.fromCharCode((15 & i3) << 12 | (63 & a3) << 6 | 63 & s3);
          } else
            t4 += e24.substr(n4, 9);
          n4 += 9;
        } else
          t4 += e24.substr(n4, 3), n4 += 3;
      }
      return t4;
    }
    function A2(e24, t4) {
      function n4(e25) {
        var n5 = O2(e25);
        return n5.match(t4.UNRESERVED) ? n5 : e25;
      }
      return e24.scheme && (e24.scheme = String(e24.scheme).replace(t4.PCT_ENCODED, n4).toLowerCase().replace(t4.NOT_SCHEME, "")), e24.userinfo !== void 0 && (e24.userinfo = String(e24.userinfo).replace(t4.PCT_ENCODED, n4).replace(t4.NOT_USERINFO, $2).replace(t4.PCT_ENCODED, i2)), e24.host !== void 0 && (e24.host = String(e24.host).replace(t4.PCT_ENCODED, n4).toLowerCase().replace(t4.NOT_HOST, $2).replace(t4.PCT_ENCODED, i2)), e24.path !== void 0 && (e24.path = String(e24.path).replace(t4.PCT_ENCODED, n4).replace(e24.scheme ? t4.NOT_PATH : t4.NOT_PATH_NOSCHEME, $2).replace(t4.PCT_ENCODED, i2)), e24.query !== void 0 && (e24.query = String(e24.query).replace(t4.PCT_ENCODED, n4).replace(t4.NOT_QUERY, $2).replace(t4.PCT_ENCODED, i2)), e24.fragment !== void 0 && (e24.fragment = String(e24.fragment).replace(t4.PCT_ENCODED, n4).replace(t4.NOT_FRAGMENT, $2).replace(t4.PCT_ENCODED, i2)), e24;
    }
    function M2(e24) {
      return e24.replace(/^0*(.*)/, "$1") || "0";
    }
    function E2(e24, t4) {
      var n4 = e24.match(t4.IPV4ADDRESS) || [], r3 = u2(n4, 2)[1];
      return r3 ? r3.split(".").map(M2).join(".") : e24;
    }
    function P2(e24, t4) {
      var n4 = e24.match(t4.IPV6ADDRESS) || [], r3 = u2(n4, 3), i3 = r3[1], o3 = r3[2];
      if (i3) {
        for (var a3 = i3.toLowerCase().split("::").reverse(), s3 = u2(a3, 2), c3 = s3[0], l3 = s3[1], f3 = l3 ? l3.split(":").map(M2) : [], h3 = c3.split(":").map(M2), d3 = t4.IPV4ADDRESS.test(h3[h3.length - 1]), v3 = d3 ? 7 : 8, p3 = h3.length - v3, m3 = Array(v3), g3 = 0; g3 < v3; ++g3)
          m3[g3] = f3[g3] || h3[p3 + g3] || "";
        d3 && (m3[v3 - 1] = E2(m3[v3 - 1], t4));
        var y3 = m3.reduce(function(e25, t5, n5) {
          if (!t5 || t5 === "0") {
            var r4 = e25[e25.length - 1];
            r4 && r4.index + r4.length === n5 ? r4.length++ : e25.push({ index: n5, length: 1 });
          }
          return e25;
        }, []).sort(function(e25, t5) {
          return t5.length - e25.length;
        })[0], b3 = void 0;
        if (y3 && y3.length > 1) {
          var k3 = m3.slice(0, y3.index), w3 = m3.slice(y3.index + y3.length);
          b3 = k3.join(":") + "::" + w3.join(":");
        } else
          b3 = m3.join(":");
        return o3 && (b3 += "%" + o3), b3;
      }
      return e24;
    }
    var N2 = /^(?:([^:\/?#]+):)?(?:\/\/((?:([^\/?#@]*)@)?(\[[^\/?#\]]+\]|[^\/?#:]*)(?:\:(\d*))?))?([^?#]*)(?:\?([^#]*))?(?:#((?:.|\n|\r)*))?/i, T2 = "".match(/(){0}/)[1] === void 0;
    function I2(e24) {
      var t4 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n4 = {}, r3 = t4.iri !== false ? s2 : a2;
      t4.reference === "suffix" && (e24 = (t4.scheme ? t4.scheme + ":" : "") + "//" + e24);
      var i3 = e24.match(N2);
      if (i3) {
        T2 ? (n4.scheme = i3[1], n4.userinfo = i3[3], n4.host = i3[4], n4.port = parseInt(i3[5], 10), n4.path = i3[6] || "", n4.query = i3[7], n4.fragment = i3[8], isNaN(n4.port) && (n4.port = i3[5])) : (n4.scheme = i3[1] || void 0, n4.userinfo = e24.indexOf("@") !== -1 ? i3[3] : void 0, n4.host = e24.indexOf("//") !== -1 ? i3[4] : void 0, n4.port = parseInt(i3[5], 10), n4.path = i3[6] || "", n4.query = e24.indexOf("?") !== -1 ? i3[7] : void 0, n4.fragment = e24.indexOf("#") !== -1 ? i3[8] : void 0, isNaN(n4.port) && (n4.port = e24.match(/\/\/(?:.|\n)*\:(?:\/|\?|\#|$)/) ? i3[4] : void 0)), n4.host && (n4.host = P2(E2(n4.host, r3), r3)), n4.reference = n4.scheme !== void 0 || n4.userinfo !== void 0 || n4.host !== void 0 || n4.port !== void 0 || n4.path || n4.query !== void 0 ? n4.scheme === void 0 ? "relative" : n4.fragment === void 0 ? "absolute" : "uri" : "same-document", t4.reference && t4.reference !== "suffix" && t4.reference !== n4.reference && (n4.error = n4.error || "URI is not a " + t4.reference + " reference.");
        var o3 = _2[(t4.scheme || n4.scheme || "").toLowerCase()];
        if (t4.unicodeSupport || o3 && o3.unicodeSupport)
          A2(n4, r3);
        else {
          if (n4.host && (t4.domainHost || o3 && o3.domainHost))
            try {
              n4.host = S2(n4.host.replace(r3.PCT_ENCODED, O2).toLowerCase());
            } catch (e25) {
              n4.error = n4.error || "Host's domain name can not be converted to ASCII via punycode: " + e25;
            }
          A2(n4, a2);
        }
        o3 && o3.parse && o3.parse(n4, t4);
      } else
        n4.error = n4.error || "URI can not be parsed.";
      return n4;
    }
    function R2(e24, t4) {
      var n4 = t4.iri !== false ? s2 : a2, r3 = [];
      return e24.userinfo !== void 0 && (r3.push(e24.userinfo), r3.push("@")), e24.host !== void 0 && r3.push(P2(E2(String(e24.host), n4), n4).replace(n4.IPV6ADDRESS, function(e25, t5, n5) {
        return "[" + t5 + (n5 ? "%25" + n5 : "") + "]";
      })), typeof e24.port != "number" && typeof e24.port != "string" || (r3.push(":"), r3.push(String(e24.port))), r3.length ? r3.join("") : void 0;
    }
    var D2 = /^\.\.?\//, z2 = /^\/\.(\/|$)/, L2 = /^\/\.\.(\/|$)/, B2 = /^\/?(?:.|\n)*?(?=\/|$)/;
    function q2(e24) {
      for (var t4 = []; e24.length; )
        if (e24.match(D2))
          e24 = e24.replace(D2, "");
        else if (e24.match(z2))
          e24 = e24.replace(z2, "/");
        else if (e24.match(L2))
          e24 = e24.replace(L2, "/"), t4.pop();
        else if (e24 === "." || e24 === "..")
          e24 = "";
        else {
          var n4 = e24.match(B2);
          if (!n4)
            throw new Error("Unexpected dot segment condition");
          var r3 = n4[0];
          e24 = e24.slice(r3.length), t4.push(r3);
        }
      return t4.join("");
    }
    function F2(e24) {
      var t4 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n4 = t4.iri ? s2 : a2, r3 = [], i3 = _2[(t4.scheme || e24.scheme || "").toLowerCase()];
      if (i3 && i3.serialize && i3.serialize(e24, t4), e24.host) {
        if (n4.IPV6ADDRESS.test(e24.host))
          ;
        else if (t4.domainHost || i3 && i3.domainHost)
          try {
            e24.host = t4.iri ? C2(e24.host) : S2(e24.host.replace(n4.PCT_ENCODED, O2).toLowerCase());
          } catch (n5) {
            e24.error = e24.error || "Host's domain name can not be converted to " + (t4.iri ? "Unicode" : "ASCII") + " via punycode: " + n5;
          }
      }
      A2(e24, n4), t4.reference !== "suffix" && e24.scheme && (r3.push(e24.scheme), r3.push(":"));
      var o3 = R2(e24, t4);
      if (o3 !== void 0 && (t4.reference !== "suffix" && r3.push("//"), r3.push(o3), e24.path && e24.path.charAt(0) !== "/" && r3.push("/")), e24.path !== void 0) {
        var u3 = e24.path;
        t4.absolutePath || i3 && i3.absolutePath || (u3 = q2(u3)), o3 === void 0 && (u3 = u3.replace(/^\/\//, "/%2F")), r3.push(u3);
      }
      return e24.query !== void 0 && (r3.push("?"), r3.push(e24.query)), e24.fragment !== void 0 && (r3.push("#"), r3.push(e24.fragment)), r3.join("");
    }
    function V2(e24, t4) {
      var n4 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, r3 = {};
      return arguments[3] || (e24 = I2(F2(e24, n4), n4), t4 = I2(F2(t4, n4), n4)), !(n4 = n4 || {}).tolerant && t4.scheme ? (r3.scheme = t4.scheme, r3.userinfo = t4.userinfo, r3.host = t4.host, r3.port = t4.port, r3.path = q2(t4.path || ""), r3.query = t4.query) : (t4.userinfo !== void 0 || t4.host !== void 0 || t4.port !== void 0 ? (r3.userinfo = t4.userinfo, r3.host = t4.host, r3.port = t4.port, r3.path = q2(t4.path || ""), r3.query = t4.query) : (t4.path ? (t4.path.charAt(0) === "/" ? r3.path = q2(t4.path) : (r3.path = e24.userinfo === void 0 && e24.host === void 0 && e24.port === void 0 || e24.path ? e24.path ? e24.path.slice(0, e24.path.lastIndexOf("/") + 1) + t4.path : t4.path : "/" + t4.path, r3.path = q2(r3.path)), r3.query = t4.query) : (r3.path = e24.path, r3.query = t4.query !== void 0 ? t4.query : e24.query), r3.userinfo = e24.userinfo, r3.host = e24.host, r3.port = e24.port), r3.scheme = e24.scheme), r3.fragment = t4.fragment, r3;
    }
    function H2(e24, t4) {
      return e24 && e24.toString().replace(t4 && t4.iri ? s2.PCT_ENCODED : a2.PCT_ENCODED, O2);
    }
    var W2 = { scheme: "http", domainHost: true, parse: function(e24, t4) {
      return e24.host || (e24.error = e24.error || "HTTP URIs must have a host."), e24;
    }, serialize: function(e24, t4) {
      var n4 = String(e24.scheme).toLowerCase() === "https";
      return e24.port !== (n4 ? 443 : 80) && e24.port !== "" || (e24.port = void 0), e24.path || (e24.path = "/"), e24;
    } }, J2 = { scheme: "https", domainHost: W2.domainHost, parse: W2.parse, serialize: W2.serialize };
    function U2(e24) {
      return typeof e24.secure == "boolean" ? e24.secure : String(e24.scheme).toLowerCase() === "wss";
    }
    var K2 = { scheme: "ws", domainHost: true, parse: function(e24, t4) {
      var n4 = e24;
      return n4.secure = U2(n4), n4.resourceName = (n4.path || "/") + (n4.query ? "?" + n4.query : ""), n4.path = void 0, n4.query = void 0, n4;
    }, serialize: function(e24, t4) {
      if (e24.port !== (U2(e24) ? 443 : 80) && e24.port !== "" || (e24.port = void 0), typeof e24.secure == "boolean" && (e24.scheme = e24.secure ? "wss" : "ws", e24.secure = void 0), e24.resourceName) {
        var n4 = e24.resourceName.split("?"), r3 = u2(n4, 2), i3 = r3[0], o3 = r3[1];
        e24.path = i3 && i3 !== "/" ? i3 : void 0, e24.query = o3, e24.resourceName = void 0;
      }
      return e24.fragment = void 0, e24;
    } }, G2 = { scheme: "wss", domainHost: K2.domainHost, parse: K2.parse, serialize: K2.serialize }, Q2 = {}, Y2 = "[A-Za-z0-9\\-\\.\\_\\~\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]", Z2 = "[0-9A-Fa-f]", X2 = n3(n3("%[EFef][0-9A-Fa-f]%" + Z2 + Z2 + "%" + Z2 + Z2) + "|" + n3("%[89A-Fa-f][0-9A-Fa-f]%" + Z2 + Z2) + "|" + n3("%" + Z2 + Z2)), ee2 = t3("[\\!\\$\\%\\'\\(\\)\\*\\+\\,\\-\\.0-9\\<\\>A-Z\\x5E-\\x7E]", '[\\"\\\\]'), te2 = new RegExp(Y2, "g"), ne2 = new RegExp(X2, "g"), re2 = new RegExp(t3("[^]", "[A-Za-z0-9\\!\\$\\%\\'\\*\\+\\-\\^\\_\\`\\{\\|\\}\\~]", "[\\.]", '[\\"]', ee2), "g"), ie2 = new RegExp(t3("[^]", Y2, "[\\!\\$\\'\\(\\)\\*\\+\\,\\;\\:\\@]"), "g"), oe2 = ie2;
    function ae2(e24) {
      var t4 = O2(e24);
      return t4.match(te2) ? t4 : e24;
    }
    var se2 = { scheme: "mailto", parse: function(e24, t4) {
      var n4 = e24, r3 = n4.to = n4.path ? n4.path.split(",") : [];
      if (n4.path = void 0, n4.query) {
        for (var i3 = false, o3 = {}, a3 = n4.query.split("&"), s3 = 0, u3 = a3.length; s3 < u3; ++s3) {
          var c3 = a3[s3].split("=");
          switch (c3[0]) {
            case "to":
              for (var l3 = c3[1].split(","), f3 = 0, h3 = l3.length; f3 < h3; ++f3)
                r3.push(l3[f3]);
              break;
            case "subject":
              n4.subject = H2(c3[1], t4);
              break;
            case "body":
              n4.body = H2(c3[1], t4);
              break;
            default:
              i3 = true, o3[H2(c3[0], t4)] = H2(c3[1], t4);
          }
        }
        i3 && (n4.headers = o3);
      }
      n4.query = void 0;
      for (var d3 = 0, v3 = r3.length; d3 < v3; ++d3) {
        var p3 = r3[d3].split("@");
        if (p3[0] = H2(p3[0]), t4.unicodeSupport)
          p3[1] = H2(p3[1], t4).toLowerCase();
        else
          try {
            p3[1] = S2(H2(p3[1], t4).toLowerCase());
          } catch (e25) {
            n4.error = n4.error || "Email address's domain name can not be converted to ASCII via punycode: " + e25;
          }
        r3[d3] = p3.join("@");
      }
      return n4;
    }, serialize: function(e24, t4) {
      var n4, r3 = e24, o3 = (n4 = e24.to) != null ? n4 instanceof Array ? n4 : typeof n4.length != "number" || n4.split || n4.setInterval || n4.call ? [n4] : Array.prototype.slice.call(n4) : [];
      if (o3) {
        for (var a3 = 0, s3 = o3.length; a3 < s3; ++a3) {
          var u3 = String(o3[a3]), c3 = u3.lastIndexOf("@"), l3 = u3.slice(0, c3).replace(ne2, ae2).replace(ne2, i2).replace(re2, $2), f3 = u3.slice(c3 + 1);
          try {
            f3 = t4.iri ? C2(f3) : S2(H2(f3, t4).toLowerCase());
          } catch (e25) {
            r3.error = r3.error || "Email address's domain name can not be converted to " + (t4.iri ? "Unicode" : "ASCII") + " via punycode: " + e25;
          }
          o3[a3] = l3 + "@" + f3;
        }
        r3.path = o3.join(",");
      }
      var h3 = e24.headers = e24.headers || {};
      e24.subject && (h3.subject = e24.subject), e24.body && (h3.body = e24.body);
      var d3 = [];
      for (var v3 in h3)
        h3[v3] !== Q2[v3] && d3.push(v3.replace(ne2, ae2).replace(ne2, i2).replace(ie2, $2) + "=" + h3[v3].replace(ne2, ae2).replace(ne2, i2).replace(oe2, $2));
      return d3.length && (r3.query = d3.join("&")), r3;
    } }, ue2 = /^([^\:]+)\:(.*)/, ce2 = { scheme: "urn", parse: function(e24, t4) {
      var n4 = e24.path && e24.path.match(ue2), r3 = e24;
      if (n4) {
        var i3 = t4.scheme || r3.scheme || "urn", o3 = n4[1].toLowerCase(), a3 = n4[2], s3 = _2[i3 + ":" + (t4.nid || o3)];
        r3.nid = o3, r3.nss = a3, r3.path = void 0, s3 && (r3 = s3.parse(r3, t4));
      } else
        r3.error = r3.error || "URN can not be parsed.";
      return r3;
    }, serialize: function(e24, t4) {
      var n4 = e24.nid, r3 = _2[(t4.scheme || e24.scheme || "urn") + ":" + (t4.nid || n4)];
      r3 && (e24 = r3.serialize(e24, t4));
      var i3 = e24;
      return i3.path = (n4 || t4.nid) + ":" + e24.nss, i3;
    } }, le2 = /^[0-9A-Fa-f]{8}(?:\-[0-9A-Fa-f]{4}){3}\-[0-9A-Fa-f]{12}$/, fe2 = { scheme: "urn:uuid", parse: function(e24, t4) {
      var n4 = e24;
      return n4.uuid = n4.nss, n4.nss = void 0, t4.tolerant || n4.uuid && n4.uuid.match(le2) || (n4.error = n4.error || "UUID is not valid."), n4;
    }, serialize: function(e24, t4) {
      var n4 = e24;
      return n4.nss = (e24.uuid || "").toLowerCase(), n4;
    } };
    _2[W2.scheme] = W2, _2[J2.scheme] = J2, _2[K2.scheme] = K2, _2[G2.scheme] = G2, _2[se2.scheme] = se2, _2[ce2.scheme] = ce2, _2[fe2.scheme] = fe2, e23.SCHEMES = _2, e23.pctEncChar = $2, e23.pctDecChars = O2, e23.parse = I2, e23.removeDotSegments = q2, e23.serialize = F2, e23.resolveComponents = V2, e23.resolve = function(e24, t4, n4) {
      var r3 = function(e25, t5) {
        var n5 = { scheme: "null" };
        if (t5)
          for (var r4 in t5)
            n5[r4] = t5[r4];
        return n5;
      }(0, n4);
      return F2(V2(I2(e24, r3), I2(t4, r3), r3, true), r3);
    }, e23.normalize = function(e24, t4) {
      return typeof e24 == "string" ? e24 = F2(I2(e24, t4), t4) : r2(e24) === "object" && (e24 = I2(F2(e24, t4), t4)), e24;
    }, e23.equal = function(e24, t4, n4) {
      return typeof e24 == "string" ? e24 = F2(I2(e24, n4), n4) : r2(e24) === "object" && (e24 = F2(e24, n4)), typeof t4 == "string" ? t4 = F2(I2(t4, n4), n4) : r2(t4) === "object" && (t4 = F2(t4, n4)), e24 === t4;
    }, e23.escapeComponent = function(e24, t4) {
      return e24 && e24.toString().replace(t4 && t4.iri ? s2.ESCAPE : a2.ESCAPE, $2);
    }, e23.unescapeComponent = H2, Object.defineProperty(e23, "__esModule", { value: true });
  });
}, {}], ajv: [function(e22, t2, n2) {
  Object.defineProperty(n2, "__esModule", { value: true }), n2.CodeGen = n2.Name = n2.nil = n2.stringify = n2.str = n2._ = n2.KeywordCxt = void 0;
  var r2 = e22("./core"), i2 = e22("./vocabularies/draft7"), o2 = e22("./vocabularies/discriminator"), a2 = e22("./refs/json-schema-draft-07.json"), s2 = ["/properties"], u2 = "http://json-schema.org/draft-07/schema", c2 = function(e23) {
    ji(n3, e23);
    var t3 = Ci(n3);
    function n3() {
      return Ri(this, n3), t3.apply(this, arguments);
    }
    return zi(n3, [{ key: "_addVocabularies", value: function() {
      var e24 = this;
      ki(Ai(n3.prototype), "_addVocabularies", this).call(this), i2.default.forEach(function(t4) {
        return e24.addVocabulary(t4);
      }), this.opts.discriminator && this.addKeyword(o2.default);
    } }, { key: "_addDefaultMetaSchema", value: function() {
      if (ki(Ai(n3.prototype), "_addDefaultMetaSchema", this).call(this), this.opts.meta) {
        var e24 = this.opts.$data ? this.$dataMetaSchema(a2, s2) : a2;
        this.addMetaSchema(e24, u2, false), this.refs["http://json-schema.org/schema"] = u2;
      }
    } }, { key: "defaultMeta", value: function() {
      return this.opts.defaultMeta = ki(Ai(n3.prototype), "defaultMeta", this).call(this) || (this.getSchema(u2) ? u2 : void 0);
    } }]), n3;
  }(r2.default);
  t2.exports = n2 = c2, Object.defineProperty(n2, "__esModule", { value: true }), n2.default = c2;
  var l2 = e22("./compile/validate");
  Object.defineProperty(n2, "KeywordCxt", { enumerable: true, get: function() {
    return l2.KeywordCxt;
  } });
  var f2 = e22("./compile/codegen");
  Object.defineProperty(n2, "_", { enumerable: true, get: function() {
    return f2._;
  } }), Object.defineProperty(n2, "str", { enumerable: true, get: function() {
    return f2.str;
  } }), Object.defineProperty(n2, "stringify", { enumerable: true, get: function() {
    return f2.stringify;
  } }), Object.defineProperty(n2, "nil", { enumerable: true, get: function() {
    return f2.nil;
  } }), Object.defineProperty(n2, "Name", { enumerable: true, get: function() {
    return f2.Name;
  } }), Object.defineProperty(n2, "CodeGen", { enumerable: true, get: function() {
    return f2.CodeGen;
  } });
}, { "./compile/codegen": 2, "./compile/validate": 15, "./core": 18, "./refs/json-schema-draft-07.json": 20, "./vocabularies/discriminator": 46, "./vocabularies/draft7": 48 }] }, {}, [])("ajv"));
var AG = {};
!function(e22) {
  function t2(e23) {
    return e23 !== null && Object.prototype.toString.call(e23) === "[object Array]";
  }
  function n2(e23) {
    return e23 !== null && Object.prototype.toString.call(e23) === "[object Object]";
  }
  function r2(e23, i3) {
    if (e23 === i3)
      return true;
    if (Object.prototype.toString.call(e23) !== Object.prototype.toString.call(i3))
      return false;
    if (t2(e23) === true) {
      if (e23.length !== i3.length)
        return false;
      for (var o3 = 0; o3 < e23.length; o3++)
        if (r2(e23[o3], i3[o3]) === false)
          return false;
      return true;
    }
    if (n2(e23) === true) {
      var a3 = {};
      for (var s3 in e23)
        if (hasOwnProperty.call(e23, s3)) {
          if (r2(e23[s3], i3[s3]) === false)
            return false;
          a3[s3] = true;
        }
      for (var u3 in i3)
        if (hasOwnProperty.call(i3, u3) && a3[u3] !== true)
          return false;
      return true;
    }
    return false;
  }
  function i2(e23) {
    if (e23 === "" || e23 === false || e23 === null)
      return true;
    if (t2(e23) && e23.length === 0)
      return true;
    if (n2(e23)) {
      for (var r3 in e23)
        if (e23.hasOwnProperty(r3))
          return false;
      return true;
    }
    return false;
  }
  var o2;
  o2 = typeof String.prototype.trimLeft == "function" ? function(e23) {
    return e23.trimLeft();
  } : function(e23) {
    return e23.match(/^\s*(.*)/)[1];
  };
  var a2 = 0, s2 = 2, u2 = { 0: "number", 1: "any", 2: "string", 3: "array", 4: "object", 5: "boolean", 6: "expression", 7: "null", 8: "Array<number>", 9: "Array<string>" }, c2 = "EOF", l2 = "UnquotedIdentifier", f2 = "QuotedIdentifier", h2 = "Rbracket", d2 = "Rparen", v2 = "Comma", p2 = "Colon", m2 = "Rbrace", g2 = "Number", y2 = "Current", b2 = "Expref", k2 = "Pipe", w2 = "Or", x2 = "And", j2 = "EQ", S2 = "GT", C2 = "LT", _2 = "GTE", $2 = "LTE", O2 = "NE", A2 = "Flatten", M2 = "Star", E2 = "Filter", P2 = "Dot", N2 = "Not", T2 = "Lbrace", I2 = "Lbracket", R2 = "Lparen", D2 = "Literal", z2 = { ".": P2, "*": M2, ",": v2, ":": p2, "{": T2, "}": m2, "]": h2, "(": R2, ")": d2, "@": y2 }, L2 = { "<": true, ">": true, "=": true, "!": true }, B2 = { " ": true, "	": true, "\n": true };
  function q2(e23) {
    return e23 >= "0" && e23 <= "9" || e23 === "-";
  }
  function F2() {
  }
  F2.prototype = { tokenize: function(e23) {
    var t3, n3, r3, i3, o3 = [];
    for (this._current = 0; this._current < e23.length; )
      if ((i3 = e23[this._current]) >= "a" && i3 <= "z" || i3 >= "A" && i3 <= "Z" || i3 === "_")
        t3 = this._current, n3 = this._consumeUnquotedIdentifier(e23), o3.push({ type: l2, value: n3, start: t3 });
      else if (z2[e23[this._current]] !== void 0)
        o3.push({ type: z2[e23[this._current]], value: e23[this._current], start: this._current }), this._current++;
      else if (q2(e23[this._current]))
        r3 = this._consumeNumber(e23), o3.push(r3);
      else if (e23[this._current] === "[")
        r3 = this._consumeLBracket(e23), o3.push(r3);
      else if (e23[this._current] === '"')
        t3 = this._current, n3 = this._consumeQuotedIdentifier(e23), o3.push({ type: f2, value: n3, start: t3 });
      else if (e23[this._current] === "'")
        t3 = this._current, n3 = this._consumeRawStringLiteral(e23), o3.push({ type: D2, value: n3, start: t3 });
      else if (e23[this._current] === "`") {
        t3 = this._current;
        var a3 = this._consumeLiteral(e23);
        o3.push({ type: D2, value: a3, start: t3 });
      } else if (L2[e23[this._current]] !== void 0)
        o3.push(this._consumeOperator(e23));
      else if (B2[e23[this._current]] !== void 0)
        this._current++;
      else if (e23[this._current] === "&")
        t3 = this._current, this._current++, e23[this._current] === "&" ? (this._current++, o3.push({ type: x2, value: "&&", start: t3 })) : o3.push({ type: b2, value: "&", start: t3 });
      else {
        if (e23[this._current] !== "|") {
          var s3 = new Error("Unknown character:" + e23[this._current]);
          throw s3.name = "LexerError", s3;
        }
        t3 = this._current, this._current++, e23[this._current] === "|" ? (this._current++, o3.push({ type: w2, value: "||", start: t3 })) : o3.push({ type: k2, value: "|", start: t3 });
      }
    return o3;
  }, _consumeUnquotedIdentifier: function(e23) {
    var t3, n3 = this._current;
    for (this._current++; this._current < e23.length && ((t3 = e23[this._current]) >= "a" && t3 <= "z" || t3 >= "A" && t3 <= "Z" || t3 >= "0" && t3 <= "9" || t3 === "_"); )
      this._current++;
    return e23.slice(n3, this._current);
  }, _consumeQuotedIdentifier: function(e23) {
    var t3 = this._current;
    this._current++;
    for (var n3 = e23.length; e23[this._current] !== '"' && this._current < n3; ) {
      var r3 = this._current;
      e23[r3] !== "\\" || e23[r3 + 1] !== "\\" && e23[r3 + 1] !== '"' ? r3++ : r3 += 2, this._current = r3;
    }
    return this._current++, JSON.parse(e23.slice(t3, this._current));
  }, _consumeRawStringLiteral: function(e23) {
    var t3 = this._current;
    this._current++;
    for (var n3 = e23.length; e23[this._current] !== "'" && this._current < n3; ) {
      var r3 = this._current;
      e23[r3] !== "\\" || e23[r3 + 1] !== "\\" && e23[r3 + 1] !== "'" ? r3++ : r3 += 2, this._current = r3;
    }
    return this._current++, e23.slice(t3 + 1, this._current - 1).replace("\\'", "'");
  }, _consumeNumber: function(e23) {
    var t3 = this._current;
    this._current++;
    for (var n3 = e23.length; q2(e23[this._current]) && this._current < n3; )
      this._current++;
    var r3 = parseInt(e23.slice(t3, this._current));
    return { type: g2, value: r3, start: t3 };
  }, _consumeLBracket: function(e23) {
    var t3 = this._current;
    return this._current++, e23[this._current] === "?" ? (this._current++, { type: E2, value: "[?", start: t3 }) : e23[this._current] === "]" ? (this._current++, { type: A2, value: "[]", start: t3 }) : { type: I2, value: "[", start: t3 };
  }, _consumeOperator: function(e23) {
    var t3 = this._current, n3 = e23[t3];
    return this._current++, n3 === "!" ? e23[this._current] === "=" ? (this._current++, { type: O2, value: "!=", start: t3 }) : { type: N2, value: "!", start: t3 } : n3 === "<" ? e23[this._current] === "=" ? (this._current++, { type: $2, value: "<=", start: t3 }) : { type: C2, value: "<", start: t3 } : n3 === ">" ? e23[this._current] === "=" ? (this._current++, { type: _2, value: ">=", start: t3 }) : { type: S2, value: ">", start: t3 } : n3 === "=" && e23[this._current] === "=" ? (this._current++, { type: j2, value: "==", start: t3 }) : void 0;
  }, _consumeLiteral: function(e23) {
    this._current++;
    for (var t3, n3 = this._current, r3 = e23.length; e23[this._current] !== "`" && this._current < r3; ) {
      var i3 = this._current;
      e23[i3] !== "\\" || e23[i3 + 1] !== "\\" && e23[i3 + 1] !== "`" ? i3++ : i3 += 2, this._current = i3;
    }
    var a3 = o2(e23.slice(n3, this._current));
    return a3 = a3.replace("\\`", "`"), t3 = this._looksLikeJSON(a3) ? JSON.parse(a3) : JSON.parse('"' + a3 + '"'), this._current++, t3;
  }, _looksLikeJSON: function(e23) {
    if (e23 === "")
      return false;
    if ('[{"'.indexOf(e23[0]) >= 0)
      return true;
    if (["true", "false", "null"].indexOf(e23) >= 0)
      return true;
    if (!("-0123456789".indexOf(e23[0]) >= 0))
      return false;
    try {
      return JSON.parse(e23), true;
    } catch (e24) {
      return false;
    }
  } };
  var V2 = {};
  function H2() {
  }
  function W2(e23) {
    this.runtime = e23;
  }
  function J2(e23) {
    this._interpreter = e23, this.functionTable = { abs: { _func: this._functionAbs, _signature: [{ types: [a2] }] }, avg: { _func: this._functionAvg, _signature: [{ types: [8] }] }, ceil: { _func: this._functionCeil, _signature: [{ types: [a2] }] }, contains: { _func: this._functionContains, _signature: [{ types: [s2, 3] }, { types: [1] }] }, ends_with: { _func: this._functionEndsWith, _signature: [{ types: [s2] }, { types: [s2] }] }, floor: { _func: this._functionFloor, _signature: [{ types: [a2] }] }, length: { _func: this._functionLength, _signature: [{ types: [s2, 3, 4] }] }, map: { _func: this._functionMap, _signature: [{ types: [6] }, { types: [3] }] }, max: { _func: this._functionMax, _signature: [{ types: [8, 9] }] }, merge: { _func: this._functionMerge, _signature: [{ types: [4], variadic: true }] }, max_by: { _func: this._functionMaxBy, _signature: [{ types: [3] }, { types: [6] }] }, sum: { _func: this._functionSum, _signature: [{ types: [8] }] }, starts_with: { _func: this._functionStartsWith, _signature: [{ types: [s2] }, { types: [s2] }] }, min: { _func: this._functionMin, _signature: [{ types: [8, 9] }] }, min_by: { _func: this._functionMinBy, _signature: [{ types: [3] }, { types: [6] }] }, type: { _func: this._functionType, _signature: [{ types: [1] }] }, keys: { _func: this._functionKeys, _signature: [{ types: [4] }] }, values: { _func: this._functionValues, _signature: [{ types: [4] }] }, sort: { _func: this._functionSort, _signature: [{ types: [9, 8] }] }, sort_by: { _func: this._functionSortBy, _signature: [{ types: [3] }, { types: [6] }] }, join: { _func: this._functionJoin, _signature: [{ types: [s2] }, { types: [9] }] }, reverse: { _func: this._functionReverse, _signature: [{ types: [s2, 3] }] }, to_array: { _func: this._functionToArray, _signature: [{ types: [1] }] }, to_string: { _func: this._functionToString, _signature: [{ types: [1] }] }, to_number: { _func: this._functionToNumber, _signature: [{ types: [1] }] }, not_null: { _func: this._functionNotNull, _signature: [{ types: [1], variadic: true }] } };
  }
  V2.EOF = 0, V2.UnquotedIdentifier = 0, V2.QuotedIdentifier = 0, V2.Rbracket = 0, V2.Rparen = 0, V2.Comma = 0, V2.Rbrace = 0, V2.Number = 0, V2.Current = 0, V2.Expref = 0, V2.Pipe = 1, V2.Or = 2, V2.And = 3, V2.EQ = 5, V2.GT = 5, V2.LT = 5, V2.GTE = 5, V2.LTE = 5, V2.NE = 5, V2.Flatten = 9, V2.Star = 20, V2.Filter = 21, V2.Dot = 40, V2.Not = 45, V2.Lbrace = 50, V2.Lbracket = 55, V2.Lparen = 60, H2.prototype = { parse: function(e23) {
    this._loadTokens(e23), this.index = 0;
    var t3 = this.expression(0);
    if (this._lookahead(0) !== c2) {
      var n3 = this._lookaheadToken(0), r3 = new Error("Unexpected token type: " + n3.type + ", value: " + n3.value);
      throw r3.name = "ParserError", r3;
    }
    return t3;
  }, _loadTokens: function(e23) {
    var t3 = new F2().tokenize(e23);
    t3.push({ type: c2, value: "", start: e23.length }), this.tokens = t3;
  }, expression: function(e23) {
    var t3 = this._lookaheadToken(0);
    this._advance();
    for (var n3 = this.nud(t3), r3 = this._lookahead(0); e23 < V2[r3]; )
      this._advance(), n3 = this.led(r3, n3), r3 = this._lookahead(0);
    return n3;
  }, _lookahead: function(e23) {
    return this.tokens[this.index + e23].type;
  }, _lookaheadToken: function(e23) {
    return this.tokens[this.index + e23];
  }, _advance: function() {
    this.index++;
  }, nud: function(e23) {
    var t3, n3;
    switch (e23.type) {
      case D2:
        return { type: "Literal", value: e23.value };
      case l2:
        return { type: "Field", name: e23.value };
      case f2:
        var r3 = { type: "Field", name: e23.value };
        if (this._lookahead(0) === R2)
          throw new Error("Quoted identifier not allowed for function names.");
        return r3;
      case N2:
        return { type: "NotExpression", children: [t3 = this.expression(V2.Not)] };
      case M2:
        return t3 = null, { type: "ValueProjection", children: [{ type: "Identity" }, t3 = this._lookahead(0) === h2 ? { type: "Identity" } : this._parseProjectionRHS(V2.Star)] };
      case E2:
        return this.led(e23.type, { type: "Identity" });
      case T2:
        return this._parseMultiselectHash();
      case A2:
        return { type: "Projection", children: [{ type: A2, children: [{ type: "Identity" }] }, t3 = this._parseProjectionRHS(V2.Flatten)] };
      case I2:
        return this._lookahead(0) === g2 || this._lookahead(0) === p2 ? (t3 = this._parseIndexExpression(), this._projectIfSlice({ type: "Identity" }, t3)) : this._lookahead(0) === M2 && this._lookahead(1) === h2 ? (this._advance(), this._advance(), { type: "Projection", children: [{ type: "Identity" }, t3 = this._parseProjectionRHS(V2.Star)] }) : this._parseMultiselectList();
      case y2:
        return { type: y2 };
      case b2:
        return { type: "ExpressionReference", children: [n3 = this.expression(V2.Expref)] };
      case R2:
        for (var i3 = []; this._lookahead(0) !== d2; )
          this._lookahead(0) === y2 ? (n3 = { type: y2 }, this._advance()) : n3 = this.expression(0), i3.push(n3);
        return this._match(d2), i3[0];
      default:
        this._errorToken(e23);
    }
  }, led: function(e23, t3) {
    var n3;
    switch (e23) {
      case P2:
        var r3 = V2.Dot;
        return this._lookahead(0) !== M2 ? { type: "Subexpression", children: [t3, n3 = this._parseDotRHS(r3)] } : (this._advance(), { type: "ValueProjection", children: [t3, n3 = this._parseProjectionRHS(r3)] });
      case k2:
        return n3 = this.expression(V2.Pipe), { type: k2, children: [t3, n3] };
      case w2:
        return { type: "OrExpression", children: [t3, n3 = this.expression(V2.Or)] };
      case x2:
        return { type: "AndExpression", children: [t3, n3 = this.expression(V2.And)] };
      case R2:
        for (var i3, o3 = t3.name, a3 = []; this._lookahead(0) !== d2; )
          this._lookahead(0) === y2 ? (i3 = { type: y2 }, this._advance()) : i3 = this.expression(0), this._lookahead(0) === v2 && this._match(v2), a3.push(i3);
        return this._match(d2), { type: "Function", name: o3, children: a3 };
      case E2:
        var s3 = this.expression(0);
        return this._match(h2), { type: "FilterProjection", children: [t3, n3 = this._lookahead(0) === A2 ? { type: "Identity" } : this._parseProjectionRHS(V2.Filter), s3] };
      case A2:
        return { type: "Projection", children: [{ type: A2, children: [t3] }, this._parseProjectionRHS(V2.Flatten)] };
      case j2:
      case O2:
      case S2:
      case _2:
      case C2:
      case $2:
        return this._parseComparator(t3, e23);
      case I2:
        var u3 = this._lookaheadToken(0);
        return u3.type === g2 || u3.type === p2 ? (n3 = this._parseIndexExpression(), this._projectIfSlice(t3, n3)) : (this._match(M2), this._match(h2), { type: "Projection", children: [t3, n3 = this._parseProjectionRHS(V2.Star)] });
      default:
        this._errorToken(this._lookaheadToken(0));
    }
  }, _match: function(e23) {
    if (this._lookahead(0) !== e23) {
      var t3 = this._lookaheadToken(0), n3 = new Error("Expected " + e23 + ", got: " + t3.type);
      throw n3.name = "ParserError", n3;
    }
    this._advance();
  }, _errorToken: function(e23) {
    var t3 = new Error("Invalid token (" + e23.type + '): "' + e23.value + '"');
    throw t3.name = "ParserError", t3;
  }, _parseIndexExpression: function() {
    if (this._lookahead(0) === p2 || this._lookahead(1) === p2)
      return this._parseSliceExpression();
    var e23 = { type: "Index", value: this._lookaheadToken(0).value };
    return this._advance(), this._match(h2), e23;
  }, _projectIfSlice: function(e23, t3) {
    var n3 = { type: "IndexExpression", children: [e23, t3] };
    return t3.type === "Slice" ? { type: "Projection", children: [n3, this._parseProjectionRHS(V2.Star)] } : n3;
  }, _parseSliceExpression: function() {
    for (var e23 = [null, null, null], t3 = 0, n3 = this._lookahead(0); n3 !== h2 && t3 < 3; ) {
      if (n3 === p2)
        t3++, this._advance();
      else {
        if (n3 !== g2) {
          var r3 = this._lookahead(0), i3 = new Error("Syntax error, unexpected token: " + r3.value + "(" + r3.type + ")");
          throw i3.name = "Parsererror", i3;
        }
        e23[t3] = this._lookaheadToken(0).value, this._advance();
      }
      n3 = this._lookahead(0);
    }
    return this._match(h2), { type: "Slice", children: e23 };
  }, _parseComparator: function(e23, t3) {
    return { type: "Comparator", name: t3, children: [e23, this.expression(V2[t3])] };
  }, _parseDotRHS: function(e23) {
    var t3 = this._lookahead(0);
    return [l2, f2, M2].indexOf(t3) >= 0 ? this.expression(e23) : t3 === I2 ? (this._match(I2), this._parseMultiselectList()) : t3 === T2 ? (this._match(T2), this._parseMultiselectHash()) : void 0;
  }, _parseProjectionRHS: function(e23) {
    var t3;
    if (V2[this._lookahead(0)] < 10)
      t3 = { type: "Identity" };
    else if (this._lookahead(0) === I2)
      t3 = this.expression(e23);
    else if (this._lookahead(0) === E2)
      t3 = this.expression(e23);
    else {
      if (this._lookahead(0) !== P2) {
        var n3 = this._lookaheadToken(0), r3 = new Error("Sytanx error, unexpected token: " + n3.value + "(" + n3.type + ")");
        throw r3.name = "ParserError", r3;
      }
      this._match(P2), t3 = this._parseDotRHS(e23);
    }
    return t3;
  }, _parseMultiselectList: function() {
    for (var e23 = []; this._lookahead(0) !== h2; ) {
      var t3 = this.expression(0);
      if (e23.push(t3), this._lookahead(0) === v2 && (this._match(v2), this._lookahead(0) === h2))
        throw new Error("Unexpected token Rbracket");
    }
    return this._match(h2), { type: "MultiSelectList", children: e23 };
  }, _parseMultiselectHash: function() {
    for (var e23, t3, n3, r3 = [], i3 = [l2, f2]; ; ) {
      if (e23 = this._lookaheadToken(0), i3.indexOf(e23.type) < 0)
        throw new Error("Expecting an identifier token, got: " + e23.type);
      if (t3 = e23.value, this._advance(), this._match(p2), n3 = { type: "KeyValuePair", name: t3, value: this.expression(0) }, r3.push(n3), this._lookahead(0) === v2)
        this._match(v2);
      else if (this._lookahead(0) === m2) {
        this._match(m2);
        break;
      }
    }
    return { type: "MultiSelectHash", children: r3 };
  } }, W2.prototype = { search: function(e23, t3) {
    return this.visit(e23, t3);
  }, visit: function(e23, o3) {
    var a3, s3, u3, c3, l3, f3, h3, d3, v3;
    switch (e23.type) {
      case "Field":
        return o3 !== null && n2(o3) ? (f3 = o3[e23.name]) === void 0 ? null : f3 : null;
      case "Subexpression":
        for (u3 = this.visit(e23.children[0], o3), v3 = 1; v3 < e23.children.length; v3++)
          if ((u3 = this.visit(e23.children[1], u3)) === null)
            return null;
        return u3;
      case "IndexExpression":
        return h3 = this.visit(e23.children[0], o3), this.visit(e23.children[1], h3);
      case "Index":
        if (!t2(o3))
          return null;
        var p3 = e23.value;
        return p3 < 0 && (p3 = o3.length + p3), (u3 = o3[p3]) === void 0 && (u3 = null), u3;
      case "Slice":
        if (!t2(o3))
          return null;
        var m3 = e23.children.slice(0), g3 = this.computeSliceParams(o3.length, m3), w3 = g3[0], x3 = g3[1], M3 = g3[2];
        if (u3 = [], M3 > 0)
          for (v3 = w3; v3 < x3; v3 += M3)
            u3.push(o3[v3]);
        else
          for (v3 = w3; v3 > x3; v3 += M3)
            u3.push(o3[v3]);
        return u3;
      case "Projection":
        var E3 = this.visit(e23.children[0], o3);
        if (!t2(E3))
          return null;
        for (d3 = [], v3 = 0; v3 < E3.length; v3++)
          (s3 = this.visit(e23.children[1], E3[v3])) !== null && d3.push(s3);
        return d3;
      case "ValueProjection":
        if (!n2(E3 = this.visit(e23.children[0], o3)))
          return null;
        d3 = [];
        var P3 = function(e24) {
          for (var t3 = Object.keys(e24), n3 = [], r3 = 0; r3 < t3.length; r3++)
            n3.push(e24[t3[r3]]);
          return n3;
        }(E3);
        for (v3 = 0; v3 < P3.length; v3++)
          (s3 = this.visit(e23.children[1], P3[v3])) !== null && d3.push(s3);
        return d3;
      case "FilterProjection":
        if (!t2(E3 = this.visit(e23.children[0], o3)))
          return null;
        var N3 = [], T3 = [];
        for (v3 = 0; v3 < E3.length; v3++)
          i2(a3 = this.visit(e23.children[2], E3[v3])) || N3.push(E3[v3]);
        for (var I3 = 0; I3 < N3.length; I3++)
          (s3 = this.visit(e23.children[1], N3[I3])) !== null && T3.push(s3);
        return T3;
      case "Comparator":
        switch (c3 = this.visit(e23.children[0], o3), l3 = this.visit(e23.children[1], o3), e23.name) {
          case j2:
            u3 = r2(c3, l3);
            break;
          case O2:
            u3 = !r2(c3, l3);
            break;
          case S2:
            u3 = c3 > l3;
            break;
          case _2:
            u3 = c3 >= l3;
            break;
          case C2:
            u3 = c3 < l3;
            break;
          case $2:
            u3 = c3 <= l3;
            break;
          default:
            throw new Error("Unknown comparator: " + e23.name);
        }
        return u3;
      case A2:
        var R3 = this.visit(e23.children[0], o3);
        if (!t2(R3))
          return null;
        var D3 = [];
        for (v3 = 0; v3 < R3.length; v3++)
          t2(s3 = R3[v3]) ? D3.push.apply(D3, s3) : D3.push(s3);
        return D3;
      case "Identity":
        return o3;
      case "MultiSelectList":
        if (o3 === null)
          return null;
        for (d3 = [], v3 = 0; v3 < e23.children.length; v3++)
          d3.push(this.visit(e23.children[v3], o3));
        return d3;
      case "MultiSelectHash":
        if (o3 === null)
          return null;
        var z3;
        for (d3 = {}, v3 = 0; v3 < e23.children.length; v3++)
          d3[(z3 = e23.children[v3]).name] = this.visit(z3.value, o3);
        return d3;
      case "OrExpression":
        return i2(a3 = this.visit(e23.children[0], o3)) && (a3 = this.visit(e23.children[1], o3)), a3;
      case "AndExpression":
        return i2(c3 = this.visit(e23.children[0], o3)) === true ? c3 : this.visit(e23.children[1], o3);
      case "NotExpression":
        return i2(c3 = this.visit(e23.children[0], o3));
      case "Literal":
        return e23.value;
      case k2:
        return h3 = this.visit(e23.children[0], o3), this.visit(e23.children[1], h3);
      case y2:
        return o3;
      case "Function":
        var L3 = [];
        for (v3 = 0; v3 < e23.children.length; v3++)
          L3.push(this.visit(e23.children[v3], o3));
        return this.runtime.callFunction(e23.name, L3);
      case "ExpressionReference":
        var B3 = e23.children[0];
        return B3.jmespathType = b2, B3;
      default:
        throw new Error("Unknown node type: " + e23.type);
    }
  }, computeSliceParams: function(e23, t3) {
    var n3 = t3[0], r3 = t3[1], i3 = t3[2], o3 = [null, null, null];
    if (i3 === null)
      i3 = 1;
    else if (i3 === 0) {
      var a3 = new Error("Invalid slice, step cannot be 0");
      throw a3.name = "RuntimeError", a3;
    }
    var s3 = i3 < 0;
    return n3 = n3 === null ? s3 ? e23 - 1 : 0 : this.capSliceRange(e23, n3, i3), r3 = r3 === null ? s3 ? -1 : e23 : this.capSliceRange(e23, r3, i3), o3[0] = n3, o3[1] = r3, o3[2] = i3, o3;
  }, capSliceRange: function(e23, t3, n3) {
    return t3 < 0 ? (t3 += e23) < 0 && (t3 = n3 < 0 ? -1 : 0) : t3 >= e23 && (t3 = n3 < 0 ? e23 - 1 : e23), t3;
  } }, J2.prototype = { callFunction: function(e23, t3) {
    var n3 = this.functionTable[e23];
    if (n3 === void 0)
      throw new Error("Unknown function: " + e23 + "()");
    return this._validateArgs(e23, t3, n3._signature), n3._func.call(this, t3);
  }, _validateArgs: function(e23, t3, n3) {
    var r3, i3, o3, a3;
    if (n3[n3.length - 1].variadic) {
      if (t3.length < n3.length)
        throw r3 = n3.length === 1 ? " argument" : " arguments", new Error("ArgumentError: " + e23 + "() takes at least" + n3.length + r3 + " but received " + t3.length);
    } else if (t3.length !== n3.length)
      throw r3 = n3.length === 1 ? " argument" : " arguments", new Error("ArgumentError: " + e23 + "() takes " + n3.length + r3 + " but received " + t3.length);
    for (var s3 = 0; s3 < n3.length; s3++) {
      a3 = false, i3 = n3[s3].types, o3 = this._getTypeName(t3[s3]);
      for (var c3 = 0; c3 < i3.length; c3++)
        if (this._typeMatches(o3, i3[c3], t3[s3])) {
          a3 = true;
          break;
        }
      if (!a3) {
        var l3 = i3.map(function(e24) {
          return u2[e24];
        }).join(",");
        throw new Error("TypeError: " + e23 + "() expected argument " + (s3 + 1) + " to be type " + l3 + " but received type " + u2[o3] + " instead.");
      }
    }
  }, _typeMatches: function(e23, t3, n3) {
    if (t3 === 1)
      return true;
    if (t3 !== 9 && t3 !== 8 && t3 !== 3)
      return e23 === t3;
    if (t3 === 3)
      return e23 === 3;
    if (e23 === 3) {
      var r3;
      t3 === 8 ? r3 = a2 : t3 === 9 && (r3 = s2);
      for (var i3 = 0; i3 < n3.length; i3++)
        if (!this._typeMatches(this._getTypeName(n3[i3]), r3, n3[i3]))
          return false;
      return true;
    }
  }, _getTypeName: function(e23) {
    switch (Object.prototype.toString.call(e23)) {
      case "[object String]":
        return s2;
      case "[object Number]":
        return a2;
      case "[object Array]":
        return 3;
      case "[object Boolean]":
        return 5;
      case "[object Null]":
        return 7;
      case "[object Object]":
        return e23.jmespathType === b2 ? 6 : 4;
    }
  }, _functionStartsWith: function(e23) {
    return e23[0].lastIndexOf(e23[1]) === 0;
  }, _functionEndsWith: function(e23) {
    var t3 = e23[0], n3 = e23[1];
    return t3.indexOf(n3, t3.length - n3.length) !== -1;
  }, _functionReverse: function(e23) {
    if (this._getTypeName(e23[0]) === s2) {
      for (var t3 = e23[0], n3 = "", r3 = t3.length - 1; r3 >= 0; r3--)
        n3 += t3[r3];
      return n3;
    }
    var i3 = e23[0].slice(0);
    return i3.reverse(), i3;
  }, _functionAbs: function(e23) {
    return Math.abs(e23[0]);
  }, _functionCeil: function(e23) {
    return Math.ceil(e23[0]);
  }, _functionAvg: function(e23) {
    for (var t3 = 0, n3 = e23[0], r3 = 0; r3 < n3.length; r3++)
      t3 += n3[r3];
    return t3 / n3.length;
  }, _functionContains: function(e23) {
    return e23[0].indexOf(e23[1]) >= 0;
  }, _functionFloor: function(e23) {
    return Math.floor(e23[0]);
  }, _functionLength: function(e23) {
    return n2(e23[0]) ? Object.keys(e23[0]).length : e23[0].length;
  }, _functionMap: function(e23) {
    for (var t3 = [], n3 = this._interpreter, r3 = e23[0], i3 = e23[1], o3 = 0; o3 < i3.length; o3++)
      t3.push(n3.visit(r3, i3[o3]));
    return t3;
  }, _functionMerge: function(e23) {
    for (var t3 = {}, n3 = 0; n3 < e23.length; n3++) {
      var r3 = e23[n3];
      for (var i3 in r3)
        t3[i3] = r3[i3];
    }
    return t3;
  }, _functionMax: function(e23) {
    if (e23[0].length > 0) {
      if (this._getTypeName(e23[0][0]) === a2)
        return Math.max.apply(Math, e23[0]);
      for (var t3 = e23[0], n3 = t3[0], r3 = 1; r3 < t3.length; r3++)
        n3.localeCompare(t3[r3]) < 0 && (n3 = t3[r3]);
      return n3;
    }
    return null;
  }, _functionMin: function(e23) {
    if (e23[0].length > 0) {
      if (this._getTypeName(e23[0][0]) === a2)
        return Math.min.apply(Math, e23[0]);
      for (var t3 = e23[0], n3 = t3[0], r3 = 1; r3 < t3.length; r3++)
        t3[r3].localeCompare(n3) < 0 && (n3 = t3[r3]);
      return n3;
    }
    return null;
  }, _functionSum: function(e23) {
    for (var t3 = 0, n3 = e23[0], r3 = 0; r3 < n3.length; r3++)
      t3 += n3[r3];
    return t3;
  }, _functionType: function(e23) {
    switch (this._getTypeName(e23[0])) {
      case a2:
        return "number";
      case s2:
        return "string";
      case 3:
        return "array";
      case 4:
        return "object";
      case 5:
        return "boolean";
      case 6:
        return "expref";
      case 7:
        return "null";
    }
  }, _functionKeys: function(e23) {
    return Object.keys(e23[0]);
  }, _functionValues: function(e23) {
    for (var t3 = e23[0], n3 = Object.keys(t3), r3 = [], i3 = 0; i3 < n3.length; i3++)
      r3.push(t3[n3[i3]]);
    return r3;
  }, _functionJoin: function(e23) {
    var t3 = e23[0];
    return e23[1].join(t3);
  }, _functionToArray: function(e23) {
    return this._getTypeName(e23[0]) === 3 ? e23[0] : [e23[0]];
  }, _functionToString: function(e23) {
    return this._getTypeName(e23[0]) === s2 ? e23[0] : JSON.stringify(e23[0]);
  }, _functionToNumber: function(e23) {
    var t3, n3 = this._getTypeName(e23[0]);
    return n3 === a2 ? e23[0] : n3 !== s2 || (t3 = +e23[0], isNaN(t3)) ? null : t3;
  }, _functionNotNull: function(e23) {
    for (var t3 = 0; t3 < e23.length; t3++)
      if (this._getTypeName(e23[t3]) !== 7)
        return e23[t3];
    return null;
  }, _functionSort: function(e23) {
    var t3 = e23[0].slice(0);
    return t3.sort(), t3;
  }, _functionSortBy: function(e23) {
    var t3 = e23[0].slice(0);
    if (t3.length === 0)
      return t3;
    var n3 = this._interpreter, r3 = e23[1], i3 = this._getTypeName(n3.visit(r3, t3[0]));
    if ([a2, s2].indexOf(i3) < 0)
      throw new Error("TypeError");
    for (var o3 = this, u3 = [], c3 = 0; c3 < t3.length; c3++)
      u3.push([c3, t3[c3]]);
    u3.sort(function(e24, t4) {
      var a3 = n3.visit(r3, e24[1]), s3 = n3.visit(r3, t4[1]);
      if (o3._getTypeName(a3) !== i3)
        throw new Error("TypeError: expected " + i3 + ", received " + o3._getTypeName(a3));
      if (o3._getTypeName(s3) !== i3)
        throw new Error("TypeError: expected " + i3 + ", received " + o3._getTypeName(s3));
      return a3 > s3 ? 1 : a3 < s3 ? -1 : e24[0] - t4[0];
    });
    for (var l3 = 0; l3 < u3.length; l3++)
      t3[l3] = u3[l3][1];
    return t3;
  }, _functionMaxBy: function(e23) {
    for (var t3, n3, r3 = e23[1], i3 = e23[0], o3 = this.createKeyFunction(r3, [a2, s2]), u3 = -1 / 0, c3 = 0; c3 < i3.length; c3++)
      (n3 = o3(i3[c3])) > u3 && (u3 = n3, t3 = i3[c3]);
    return t3;
  }, _functionMinBy: function(e23) {
    for (var t3, n3, r3 = e23[1], i3 = e23[0], o3 = this.createKeyFunction(r3, [a2, s2]), u3 = 1 / 0, c3 = 0; c3 < i3.length; c3++)
      (n3 = o3(i3[c3])) < u3 && (u3 = n3, t3 = i3[c3]);
    return t3;
  }, createKeyFunction: function(e23, t3) {
    var n3 = this, r3 = this._interpreter;
    return function(i3) {
      var o3 = r3.visit(e23, i3);
      if (t3.indexOf(n3._getTypeName(o3)) < 0) {
        var a3 = "TypeError: expected one of " + t3 + ", received " + n3._getTypeName(o3);
        throw new Error(a3);
      }
      return o3;
    };
  } }, e22.tokenize = function(e23) {
    return new F2().tokenize(e23);
  }, e22.compile = function(e23) {
    return new H2().parse(e23);
  }, e22.search = function(e23, t3) {
    var n3 = new H2(), r3 = new J2(), i3 = new W2(r3);
    r3._interpreter = i3;
    var o3 = n3.parse(t3);
    return i3.search(o3, e23);
  }, e22.strictDeepEqual = r2;
}(AG);
/*!
* vanilla-picker v2.12.1
* https://vanilla-picker.js.org
*
* Copyright 2017-2021 Andreas Borgen (https://github.com/Sphinxxxx), Adam Brooks (https://github.com/dissimulate)
* Released under the ISC license.
*/
var PG = function(e22, t2) {
  if (!(e22 instanceof t2))
    throw new TypeError("Cannot call a class as a function");
}, NG = function() {
  function e22(e23, t2) {
    for (var n2 = 0; n2 < t2.length; n2++) {
      var r2 = t2[n2];
      r2.enumerable = r2.enumerable || false, r2.configurable = true, "value" in r2 && (r2.writable = true), Object.defineProperty(e23, r2.key, r2);
    }
  }
  return function(t2, n2, r2) {
    return n2 && e22(t2.prototype, n2), r2 && e22(t2, r2), t2;
  };
}(), TG = function(e22, t2) {
  if (Array.isArray(e22))
    return e22;
  if (Symbol.iterator in Object(e22))
    return function(e23, t3) {
      var n2 = [], r2 = true, i2 = false, o2 = void 0;
      try {
        for (var a2, s2 = e23[Symbol.iterator](); !(r2 = (a2 = s2.next()).done) && (n2.push(a2.value), !t3 || n2.length !== t3); r2 = true)
          ;
      } catch (e24) {
        i2 = true, o2 = e24;
      } finally {
        try {
          !r2 && s2.return && s2.return();
        } finally {
          if (i2)
            throw o2;
        }
      }
      return n2;
    }(e22, t2);
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
};
String.prototype.startsWith = String.prototype.startsWith || function(e22) {
  return this.indexOf(e22) === 0;
}, String.prototype.padStart = String.prototype.padStart || function(e22, t2) {
  for (var n2 = this; n2.length < e22; )
    n2 = t2 + n2;
  return n2;
};
var IG = { cb: "0f8ff", tqw: "aebd7", q: "-ffff", qmrn: "7fffd4", zr: "0ffff", bg: "5f5dc", bsq: "e4c4", bck: "---", nch: "ebcd", b: "--ff", bvt: "8a2be2", brwn: "a52a2a", brw: "deb887", ctb: "5f9ea0", hrt: "7fff-", chcT: "d2691e", cr: "7f50", rnw: "6495ed", crns: "8dc", crms: "dc143c", cn: "-ffff", Db: "--8b", Dcn: "-8b8b", Dgnr: "b8860b", Dgr: "a9a9a9", Dgrn: "-64-", Dkhk: "bdb76b", Dmgn: "8b-8b", Dvgr: "556b2f", Drng: "8c-", Drch: "9932cc", Dr: "8b--", Dsmn: "e9967a", Dsgr: "8fbc8f", DsTb: "483d8b", DsTg: "2f4f4f", Dtrq: "-ced1", Dvt: "94-d3", ppnk: "1493", pskb: "-bfff", mgr: "696969", grb: "1e90ff", rbrc: "b22222", rwht: "af0", stg: "228b22", chs: "-ff", gnsb: "dcdcdc", st: "8f8ff", g: "d7-", gnr: "daa520", gr: "808080", grn: "-8-0", grnw: "adff2f", hnw: "0fff0", htpn: "69b4", nnr: "cd5c5c", ng: "4b-82", vr: "0", khk: "0e68c", vnr: "e6e6fa", nrb: "0f5", wngr: "7cfc-", mnch: "acd", Lb: "add8e6", Lcr: "08080", Lcn: "e0ffff", Lgnr: "afad2", Lgr: "d3d3d3", Lgrn: "90ee90", Lpnk: "b6c1", Lsmn: "a07a", Lsgr: "20b2aa", Lskb: "87cefa", LsTg: "778899", Lstb: "b0c4de", Lw: "e0", m: "-ff-", mgrn: "32cd32", nn: "af0e6", mgnt: "-ff", mrn: "8--0", mqm: "66cdaa", mmb: "--cd", mmrc: "ba55d3", mmpr: "9370db", msg: "3cb371", mmsT: "7b68ee", "": "-fa9a", mtr: "48d1cc", mmvt: "c71585", mnLb: "191970", ntc: "5fffa", mstr: "e4e1", mccs: "e4b5", vjw: "dead", nv: "--80", c: "df5e6", v: "808-0", vrb: "6b8e23", rng: "a5-", rngr: "45-", rch: "da70d6", pgnr: "eee8aa", pgrn: "98fb98", ptrq: "afeeee", pvtr: "db7093", ppwh: "efd5", pchp: "dab9", pr: "cd853f", pnk: "c0cb", pm: "dda0dd", pwrb: "b0e0e6", prp: "8-080", cc: "663399", r: "--", sbr: "bc8f8f", rb: "4169e1", sbrw: "8b4513", smn: "a8072", nbr: "4a460", sgrn: "2e8b57", ssh: "5ee", snn: "a0522d", svr: "c0c0c0", skb: "87ceeb", sTb: "6a5acd", sTgr: "708090", snw: "afa", n: "-ff7f", stb: "4682b4", tn: "d2b48c", t: "-8080", thst: "d8bfd8", tmT: "6347", trqs: "40e0d0", vt: "ee82ee", whT: "5deb3", wht: "", hts: "5f5f5", w: "-", wgrn: "9acd32" };
function RG(e22) {
  var t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, n2 = t2 > 0 ? e22.toFixed(t2).replace(/0+$/, "").replace(/\.$/, "") : e22.toString();
  return n2 || "0";
}
var DG = function() {
  function e22(t2, n2, r2, i2) {
    PG(this, e22);
    var o2 = this;
    if (t2 === void 0)
      ;
    else if (Array.isArray(t2))
      this.rgba = t2;
    else if (r2 === void 0) {
      var a2 = t2 && "" + t2;
      a2 && function(t3) {
        if (t3.startsWith("hsl")) {
          var n3 = t3.match(/([\-\d\.e]+)/g).map(Number), r3 = TG(n3, 4), i3 = r3[0], a3 = r3[1], s2 = r3[2], u2 = r3[3];
          u2 === void 0 && (u2 = 1), i3 /= 360, a3 /= 100, s2 /= 100, o2.hsla = [i3, a3, s2, u2];
        } else if (t3.startsWith("rgb")) {
          var c2 = t3.match(/([\-\d\.e]+)/g).map(Number), l2 = TG(c2, 4), f2 = l2[0], h2 = l2[1], d2 = l2[2], v2 = l2[3];
          v2 === void 0 && (v2 = 1), o2.rgba = [f2, h2, d2, v2];
        } else
          t3.startsWith("#") ? o2.rgba = e22.hexToRgb(t3) : o2.rgba = e22.nameToRgb(t3) || e22.hexToRgb(t3);
      }(a2.toLowerCase());
    } else
      this.rgba = [t2, n2, r2, i2 === void 0 ? 1 : i2];
  }
  return NG(e22, [{ key: "printRGB", value: function(e23) {
    var t2 = (e23 ? this.rgba : this.rgba.slice(0, 3)).map(function(e24, t3) {
      return RG(e24, t3 === 3 ? 3 : 0);
    });
    return e23 ? "rgba(" + t2 + ")" : "rgb(" + t2 + ")";
  } }, { key: "printHSL", value: function(e23) {
    var t2 = [360, 100, 100, 1], n2 = ["", "%", "%", ""], r2 = (e23 ? this.hsla : this.hsla.slice(0, 3)).map(function(e24, r3) {
      return RG(e24 * t2[r3], r3 === 3 ? 3 : 1) + n2[r3];
    });
    return e23 ? "hsla(" + r2 + ")" : "hsl(" + r2 + ")";
  } }, { key: "printHex", value: function(e23) {
    var t2 = this.hex;
    return e23 ? t2 : t2.substring(0, 7);
  } }, { key: "rgba", get: function() {
    if (this._rgba)
      return this._rgba;
    if (!this._hsla)
      throw new Error("No color is set");
    return this._rgba = e22.hslToRgb(this._hsla);
  }, set: function(e23) {
    e23.length === 3 && (e23[3] = 1), this._rgba = e23, this._hsla = null;
  } }, { key: "rgbString", get: function() {
    return this.printRGB();
  } }, { key: "rgbaString", get: function() {
    return this.printRGB(true);
  } }, { key: "hsla", get: function() {
    if (this._hsla)
      return this._hsla;
    if (!this._rgba)
      throw new Error("No color is set");
    return this._hsla = e22.rgbToHsl(this._rgba);
  }, set: function(e23) {
    e23.length === 3 && (e23[3] = 1), this._hsla = e23, this._rgba = null;
  } }, { key: "hslString", get: function() {
    return this.printHSL();
  } }, { key: "hslaString", get: function() {
    return this.printHSL(true);
  } }, { key: "hex", get: function() {
    return "#" + this.rgba.map(function(e23, t2) {
      return t2 < 3 ? e23.toString(16) : Math.round(255 * e23).toString(16);
    }).map(function(e23) {
      return e23.padStart(2, "0");
    }).join("");
  }, set: function(t2) {
    this.rgba = e22.hexToRgb(t2);
  } }], [{ key: "hexToRgb", value: function(e23) {
    var t2 = (e23.startsWith("#") ? e23.slice(1) : e23).replace(/^(\w{3})$/, "$1F").replace(/^(\w)(\w)(\w)(\w)$/, "$1$1$2$2$3$3$4$4").replace(/^(\w{6})$/, "$1FF");
    if (!t2.match(/^([0-9a-fA-F]{8})$/))
      throw new Error("Unknown hex color; " + e23);
    var n2 = t2.match(/^(\w\w)(\w\w)(\w\w)(\w\w)$/).slice(1).map(function(e24) {
      return parseInt(e24, 16);
    });
    return n2[3] = n2[3] / 255, n2;
  } }, { key: "nameToRgb", value: function(t2) {
    var n2 = t2.toLowerCase().replace("at", "T").replace(/[aeiouyldf]/g, "").replace("ght", "L").replace("rk", "D").slice(-5, 4), r2 = IG[n2];
    return r2 === void 0 ? r2 : e22.hexToRgb(r2.replace(/\-/g, "00").padStart(6, "f"));
  } }, { key: "rgbToHsl", value: function(e23) {
    var t2 = TG(e23, 4), n2 = t2[0], r2 = t2[1], i2 = t2[2], o2 = t2[3];
    n2 /= 255, r2 /= 255, i2 /= 255;
    var a2 = Math.max(n2, r2, i2), s2 = Math.min(n2, r2, i2), u2 = void 0, c2 = void 0, l2 = (a2 + s2) / 2;
    if (a2 === s2)
      u2 = c2 = 0;
    else {
      var f2 = a2 - s2;
      switch (c2 = l2 > 0.5 ? f2 / (2 - a2 - s2) : f2 / (a2 + s2), a2) {
        case n2:
          u2 = (r2 - i2) / f2 + (r2 < i2 ? 6 : 0);
          break;
        case r2:
          u2 = (i2 - n2) / f2 + 2;
          break;
        case i2:
          u2 = (n2 - r2) / f2 + 4;
      }
      u2 /= 6;
    }
    return [u2, c2, l2, o2];
  } }, { key: "hslToRgb", value: function(e23) {
    var t2 = TG(e23, 4), n2 = t2[0], r2 = t2[1], i2 = t2[2], o2 = t2[3], a2 = void 0, s2 = void 0, u2 = void 0;
    if (r2 === 0)
      a2 = s2 = u2 = i2;
    else {
      var c2 = function(e24, t3, n3) {
        return n3 < 0 && (n3 += 1), n3 > 1 && (n3 -= 1), n3 < 1 / 6 ? e24 + 6 * (t3 - e24) * n3 : n3 < 0.5 ? t3 : n3 < 2 / 3 ? e24 + (t3 - e24) * (2 / 3 - n3) * 6 : e24;
      }, l2 = i2 < 0.5 ? i2 * (1 + r2) : i2 + r2 - i2 * r2, f2 = 2 * i2 - l2;
      a2 = c2(f2, l2, n2 + 1 / 3), s2 = c2(f2, l2, n2), u2 = c2(f2, l2, n2 - 1 / 3);
    }
    var h2 = [255 * a2, 255 * s2, 255 * u2].map(Math.round);
    return h2[3] = o2, h2;
  } }]), e22;
}(), zG = function() {
  function e22() {
    PG(this, e22), this._events = [];
  }
  return NG(e22, [{ key: "add", value: function(e23, t2, n2) {
    e23.addEventListener(t2, n2, false), this._events.push({ target: e23, type: t2, handler: n2 });
  } }, { key: "remove", value: function(t2, n2, r2) {
    this._events = this._events.filter(function(i2) {
      var o2 = true;
      return t2 && t2 !== i2.target && (o2 = false), n2 && n2 !== i2.type && (o2 = false), r2 && r2 !== i2.handler && (o2 = false), o2 && e22._doRemove(i2.target, i2.type, i2.handler), !o2;
    });
  } }, { key: "destroy", value: function() {
    this._events.forEach(function(t2) {
      return e22._doRemove(t2.target, t2.type, t2.handler);
    }), this._events = [];
  } }], [{ key: "_doRemove", value: function(e23, t2, n2) {
    e23.removeEventListener(t2, n2, false);
  } }]), e22;
}();
function LG(e22, t2, n2) {
  var r2 = false;
  function i2(e23, t3, n3) {
    return Math.max(t3, Math.min(e23, n3));
  }
  function o2(e23, o3, a3) {
    if (a3 && (r2 = true), r2) {
      e23.preventDefault();
      var s3 = t2.getBoundingClientRect(), u2 = s3.width, c2 = s3.height, l2 = o3.clientX, f2 = o3.clientY, h2 = i2(l2 - s3.left, 0, u2), d2 = i2(f2 - s3.top, 0, c2);
      n2(h2 / u2, d2 / c2);
    }
  }
  function a2(e23, t3) {
    (e23.buttons === void 0 ? e23.which : e23.buttons) === 1 ? o2(e23, e23, t3) : r2 = false;
  }
  function s2(e23, t3) {
    e23.touches.length === 1 ? o2(e23, e23.touches[0], t3) : r2 = false;
  }
  e22.add(t2, "mousedown", function(e23) {
    a2(e23, true);
  }), e22.add(t2, "touchstart", function(e23) {
    s2(e23, true);
  }), e22.add(window, "mousemove", a2), e22.add(t2, "touchmove", s2), e22.add(window, "mouseup", function(e23) {
    r2 = false;
  }), e22.add(t2, "touchend", function(e23) {
    r2 = false;
  }), e22.add(t2, "touchcancel", function(e23) {
    r2 = false;
  });
}
function BG(e22, t2) {
  return (t2 || document).querySelector(e22);
}
function qG(e22) {
  e22.preventDefault(), e22.stopPropagation();
}
function FG(e22, t2, n2, r2, i2) {
  e22.add(t2, "keydown", function(e23) {
    n2.indexOf(e23.key) >= 0 && (i2 && qG(e23), r2(e23));
  });
}
var VG = function() {
  function e22(t2) {
    PG(this, e22), this.settings = { popup: "right", layout: "default", alpha: true, editor: true, editorFormat: "hex", cancelButton: false, defaultColor: "#0cf" }, this._events = new zG(), this.onChange = null, this.onDone = null, this.onOpen = null, this.onClose = null, this.setOptions(t2);
  }
  return NG(e22, [{ key: "setOptions", value: function(e23) {
    var t2 = this;
    if (e23) {
      var n2 = this.settings;
      if (e23 instanceof HTMLElement)
        n2.parent = e23;
      else {
        n2.parent && e23.parent && n2.parent !== e23.parent && (this._events.remove(n2.parent), this._popupInited = false), function(e24, t3, n3) {
          for (var r3 in e24)
            n3 && n3.indexOf(r3) >= 0 || (t3[r3] = e24[r3]);
        }(e23, n2), e23.onChange && (this.onChange = e23.onChange), e23.onDone && (this.onDone = e23.onDone), e23.onOpen && (this.onOpen = e23.onOpen), e23.onClose && (this.onClose = e23.onClose);
        var r2 = e23.color || e23.colour;
        r2 && this._setColor(r2);
      }
      var i2 = n2.parent;
      if (i2 && n2.popup && !this._popupInited) {
        var o2 = function(e24) {
          return t2.openHandler(e24);
        };
        this._events.add(i2, "click", o2), FG(this._events, i2, [" ", "Spacebar", "Enter"], o2), this._popupInited = true;
      } else
        e23.parent && !n2.popup && this.show();
    }
  } }, { key: "openHandler", value: function(e23) {
    if (this.show()) {
      e23 && e23.preventDefault(), this.settings.parent.style.pointerEvents = "none";
      var t2 = e23 && e23.type === "keydown" ? this._domEdit : this.domElement;
      setTimeout(function() {
        return t2.focus();
      }, 100), this.onOpen && this.onOpen(this.colour);
    }
  } }, { key: "closeHandler", value: function(e23) {
    var t2 = e23 && e23.type, n2 = false;
    if (e23)
      if (t2 === "mousedown" || t2 === "focusin") {
        var r2 = (this.__containedEvent || 0) + 100;
        e23.timeStamp > r2 && (n2 = true);
      } else
        qG(e23), n2 = true;
    else
      n2 = true;
    n2 && this.hide() && (this.settings.parent.style.pointerEvents = "", t2 !== "mousedown" && this.settings.parent.focus(), this.onClose && this.onClose(this.colour));
  } }, { key: "movePopup", value: function(e23, t2) {
    this.closeHandler(), this.setOptions(e23), t2 && this.openHandler();
  } }, { key: "setColor", value: function(e23, t2) {
    this._setColor(e23, { silent: t2 });
  } }, { key: "_setColor", value: function(e23, t2) {
    if (typeof e23 == "string" && (e23 = e23.trim()), e23) {
      t2 = t2 || {};
      var n2 = void 0;
      try {
        n2 = new DG(e23);
      } catch (e24) {
        if (t2.failSilently)
          return;
        throw e24;
      }
      if (!this.settings.alpha) {
        var r2 = n2.hsla;
        r2[3] = 1, n2.hsla = r2;
      }
      this.colour = this.color = n2, this._setHSLA(null, null, null, null, t2);
    }
  } }, { key: "setColour", value: function(e23, t2) {
    this.setColor(e23, t2);
  } }, { key: "show", value: function() {
    if (!this.settings.parent)
      return false;
    if (this.domElement) {
      var e23 = this._toggleDOM(true);
      return this._setPosition(), e23;
    }
    var t2, n2, r2 = this.settings.template || '<div class="picker_wrapper" tabindex="-1"><div class="picker_arrow"></div><div class="picker_hue picker_slider"><div class="picker_selector"></div></div><div class="picker_sl"><div class="picker_selector"></div></div><div class="picker_alpha picker_slider"><div class="picker_selector"></div></div><div class="picker_editor"><input aria-label="Type a color name or hex value"/></div><div class="picker_sample"></div><div class="picker_done"><button>Ok</button></div><div class="picker_cancel"><button>Cancel</button></div></div>', i2 = (t2 = r2, (n2 = document.createElement("div")).innerHTML = t2, n2.firstElementChild);
    return this.domElement = i2, this._domH = BG(".picker_hue", i2), this._domSL = BG(".picker_sl", i2), this._domA = BG(".picker_alpha", i2), this._domEdit = BG(".picker_editor input", i2), this._domSample = BG(".picker_sample", i2), this._domOkay = BG(".picker_done button", i2), this._domCancel = BG(".picker_cancel button", i2), i2.classList.add("layout_" + this.settings.layout), this.settings.alpha || i2.classList.add("no_alpha"), this.settings.editor || i2.classList.add("no_editor"), this.settings.cancelButton || i2.classList.add("no_cancel"), this._ifPopup(function() {
      return i2.classList.add("popup");
    }), this._setPosition(), this.colour ? this._updateUI() : this._setColor(this.settings.defaultColor), this._bindEvents(), true;
  } }, { key: "hide", value: function() {
    return this._toggleDOM(false);
  } }, { key: "destroy", value: function() {
    this._events.destroy(), this.domElement && this.settings.parent.removeChild(this.domElement);
  } }, { key: "_bindEvents", value: function() {
    var e23 = this, t2 = this, n2 = this.domElement, r2 = this._events;
    function i2(e24, t3, n3) {
      r2.add(e24, t3, n3);
    }
    i2(n2, "click", function(e24) {
      return e24.preventDefault();
    }), LG(r2, this._domH, function(e24, n3) {
      return t2._setHSLA(e24);
    }), LG(r2, this._domSL, function(e24, n3) {
      return t2._setHSLA(null, e24, 1 - n3);
    }), this.settings.alpha && LG(r2, this._domA, function(e24, n3) {
      return t2._setHSLA(null, null, null, 1 - n3);
    });
    var o2 = this._domEdit;
    i2(o2, "input", function(e24) {
      t2._setColor(this.value, { fromEditor: true, failSilently: true });
    }), i2(o2, "focus", function(e24) {
      var t3 = this;
      t3.selectionStart === t3.selectionEnd && t3.select();
    }), this._ifPopup(function() {
      var t3 = function(t4) {
        return e23.closeHandler(t4);
      };
      i2(window, "mousedown", t3), i2(window, "focusin", t3), FG(r2, n2, ["Esc", "Escape"], t3);
      var o3 = function(t4) {
        e23.__containedEvent = t4.timeStamp;
      };
      i2(n2, "mousedown", o3), i2(n2, "focusin", o3), i2(e23._domCancel, "click", t3);
    });
    var a2 = function(t3) {
      e23._ifPopup(function() {
        return e23.closeHandler(t3);
      }), e23.onDone && e23.onDone(e23.colour);
    };
    i2(this._domOkay, "click", a2), FG(r2, n2, ["Enter"], a2);
  } }, { key: "_setPosition", value: function() {
    var e23 = this.settings.parent, t2 = this.domElement;
    e23 !== t2.parentNode && e23.appendChild(t2), this._ifPopup(function(n2) {
      getComputedStyle(e23).position === "static" && (e23.style.position = "relative");
      var r2 = n2 === true ? "popup_right" : "popup_" + n2;
      ["popup_top", "popup_bottom", "popup_left", "popup_right"].forEach(function(e24) {
        e24 === r2 ? t2.classList.add(e24) : t2.classList.remove(e24);
      }), t2.classList.add(r2);
    });
  } }, { key: "_setHSLA", value: function(e23, t2, n2, r2, i2) {
    i2 = i2 || {};
    var o2 = this.colour, a2 = o2.hsla;
    [e23, t2, n2, r2].forEach(function(e24, t3) {
      (e24 || e24 === 0) && (a2[t3] = e24);
    }), o2.hsla = a2, this._updateUI(i2), this.onChange && !i2.silent && this.onChange(o2);
  } }, { key: "_updateUI", value: function(e23) {
    if (this.domElement) {
      e23 = e23 || {};
      var t2 = this.colour, n2 = t2.hsla, r2 = "hsl(" + 360 * n2[0] + ", 100%, 50%)", i2 = t2.hslString, o2 = t2.hslaString, a2 = this._domH, s2 = this._domSL, u2 = this._domA, c2 = BG(".picker_selector", a2), l2 = BG(".picker_selector", s2), f2 = BG(".picker_selector", u2);
      y2(0, c2, n2[0]), this._domSL.style.backgroundColor = this._domH.style.color = r2, y2(0, l2, n2[1]), b2(0, l2, 1 - n2[2]), s2.style.color = i2, b2(0, f2, 1 - n2[3]);
      var h2 = i2, d2 = h2.replace("hsl", "hsla").replace(")", ", 0)"), v2 = "linear-gradient(" + [h2, d2] + ")";
      if (this._domA.style.background = v2 + ", linear-gradient(45deg, lightgrey 25%, transparent 25%, transparent 75%, lightgrey 75%) 0 0 / 2em 2em,\n                   linear-gradient(45deg, lightgrey 25%,       white 25%,       white 75%, lightgrey 75%) 1em 1em / 2em 2em", !e23.fromEditor) {
        var p2 = this.settings.editorFormat, m2 = this.settings.alpha, g2 = void 0;
        switch (p2) {
          case "rgb":
            g2 = t2.printRGB(m2);
            break;
          case "hsl":
            g2 = t2.printHSL(m2);
            break;
          default:
            g2 = t2.printHex(m2);
        }
        this._domEdit.value = g2;
      }
      this._domSample.style.color = o2;
    }
    function y2(e24, t3, n3) {
      t3.style.left = 100 * n3 + "%";
    }
    function b2(e24, t3, n3) {
      t3.style.top = 100 * n3 + "%";
    }
  } }, { key: "_ifPopup", value: function(e23, t2) {
    this.settings.parent && this.settings.popup ? e23 && e23(this.settings.popup) : t2 && t2();
  } }, { key: "_toggleDOM", value: function(e23) {
    var t2 = this.domElement;
    if (!t2)
      return false;
    var n2 = e23 ? "" : "none", r2 = t2.style.display !== n2;
    return r2 && (t2.style.display = n2), r2;
  } }]), e22;
}(), HG = document.createElement("style");
HG.textContent = '.picker_wrapper.no_alpha .picker_alpha{display:none}.picker_wrapper.no_editor .picker_editor{position:absolute;z-index:-1;opacity:0}.picker_wrapper.no_cancel .picker_cancel{display:none}.layout_default.picker_wrapper{display:flex;flex-flow:row wrap;justify-content:space-between;align-items:stretch;font-size:10px;width:25em;padding:.5em}.layout_default.picker_wrapper input,.layout_default.picker_wrapper button{font-size:1rem}.layout_default.picker_wrapper>*{margin:.5em}.layout_default.picker_wrapper::before{content:"";display:block;width:100%;height:0;order:1}.layout_default .picker_slider,.layout_default .picker_selector{padding:1em}.layout_default .picker_hue{width:100%}.layout_default .picker_sl{flex:1 1 auto}.layout_default .picker_sl::before{content:"";display:block;padding-bottom:100%}.layout_default .picker_editor{order:1;width:6.5rem}.layout_default .picker_editor input{width:100%;height:100%}.layout_default .picker_sample{order:1;flex:1 1 auto}.layout_default .picker_done,.layout_default .picker_cancel{order:1}.picker_wrapper{box-sizing:border-box;background:#f2f2f2;box-shadow:0 0 0 1px silver;cursor:default;font-family:sans-serif;color:#444;pointer-events:auto}.picker_wrapper:focus{outline:none}.picker_wrapper button,.picker_wrapper input{box-sizing:border-box;border:none;box-shadow:0 0 0 1px silver;outline:none}.picker_wrapper button:focus,.picker_wrapper button:active,.picker_wrapper input:focus,.picker_wrapper input:active{box-shadow:0 0 2px 1px #1e90ff}.picker_wrapper button{padding:.4em .6em;cursor:pointer;background-color:#f5f5f5;background-image:linear-gradient(0deg, gainsboro, transparent)}.picker_wrapper button:active{background-image:linear-gradient(0deg, transparent, gainsboro)}.picker_wrapper button:hover{background-color:#fff}.picker_selector{position:absolute;z-index:1;display:block;-webkit-transform:translate(-50%, -50%);transform:translate(-50%, -50%);border:2px solid #fff;border-radius:100%;box-shadow:0 0 3px 1px #67b9ff;background:currentColor;cursor:pointer}.picker_slider .picker_selector{border-radius:2px}.picker_hue{position:relative;background-image:linear-gradient(90deg, red, yellow, lime, cyan, blue, magenta, red);box-shadow:0 0 0 1px silver}.picker_sl{position:relative;box-shadow:0 0 0 1px silver;background-image:linear-gradient(180deg, white, rgba(255, 255, 255, 0) 50%),linear-gradient(0deg, black, rgba(0, 0, 0, 0) 50%),linear-gradient(90deg, #808080, rgba(128, 128, 128, 0))}.picker_alpha,.picker_sample{position:relative;background:linear-gradient(45deg, lightgrey 25%, transparent 25%, transparent 75%, lightgrey 75%) 0 0/2em 2em,linear-gradient(45deg, lightgrey 25%, white 25%, white 75%, lightgrey 75%) 1em 1em/2em 2em;box-shadow:0 0 0 1px silver}.picker_alpha .picker_selector,.picker_sample .picker_selector{background:none}.picker_editor input{font-family:monospace;padding:.2em .4em}.picker_sample::before{content:"";position:absolute;display:block;width:100%;height:100%;background:currentColor}.picker_arrow{position:absolute;z-index:-1}.picker_wrapper.popup{position:absolute;z-index:2;margin:1.5em}.picker_wrapper.popup,.picker_wrapper.popup .picker_arrow::before,.picker_wrapper.popup .picker_arrow::after{background:#f2f2f2;box-shadow:0 0 10px 1px rgba(0,0,0,.4)}.picker_wrapper.popup .picker_arrow{width:3em;height:3em;margin:0}.picker_wrapper.popup .picker_arrow::before,.picker_wrapper.popup .picker_arrow::after{content:"";display:block;position:absolute;top:0;left:0;z-index:-99}.picker_wrapper.popup .picker_arrow::before{width:100%;height:100%;-webkit-transform:skew(45deg);transform:skew(45deg);-webkit-transform-origin:0 100%;transform-origin:0 100%}.picker_wrapper.popup .picker_arrow::after{width:150%;height:150%;box-shadow:none}.popup.popup_top{bottom:100%;left:0}.popup.popup_top .picker_arrow{bottom:0;left:0;-webkit-transform:rotate(-90deg);transform:rotate(-90deg)}.popup.popup_bottom{top:100%;left:0}.popup.popup_bottom .picker_arrow{top:0;left:0;-webkit-transform:rotate(90deg) scale(1, -1);transform:rotate(90deg) scale(1, -1)}.popup.popup_left{top:0;right:100%}.popup.popup_left .picker_arrow{top:0;right:0;-webkit-transform:scale(-1, 1);transform:scale(-1, 1)}.popup.popup_right{top:0;left:100%}.popup.popup_right .picker_arrow{top:0;left:0}', document.documentElement.firstElementChild.appendChild(HG), VG.StyleElement = HG;
var WG = Object.freeze({ __proto__: null, default: VG });
cs.exports.compileJSONPointer;
cs.exports.compileJSONPointerProp;
cs.exports.deleteIn;
cs.exports.existsIn;
cs.exports.getIn;
cs.exports.immutableJSONPatch;
cs.exports.insertAt;
cs.exports.parseFrom;
cs.exports.parseJSONPointer;
cs.exports.parsePath;
cs.exports.revertJSONPatch;
cs.exports.setIn;
cs.exports.updateIn;
var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
var freeGlobal$1 = freeGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal$1 || freeSelf || Function("return this")();
var root$1 = root;
var Symbol$1 = root$1.Symbol;
var Symbol$2 = Symbol$1;
var objectProto$c = Object.prototype;
var hasOwnProperty$a = objectProto$c.hasOwnProperty;
var nativeObjectToString$1 = objectProto$c.toString;
var symToStringTag$1 = Symbol$2 ? Symbol$2.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty$a.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e22) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var objectProto$b = Object.prototype;
var nativeObjectToString = objectProto$b.toString;
function objectToString(value) {
  return nativeObjectToString.call(value);
}
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var symbolTag$2 = "[object Symbol]";
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag$2;
}
var isArray = Array.isArray;
var isArray$1 = isArray;
var reWhitespace = /\s/;
function trimmedEndIndex(string) {
  var index = string.length;
  while (index-- && reWhitespace.test(string.charAt(index))) {
  }
  return index;
}
var reTrimStart = /^\s+/;
function baseTrim(string) {
  return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, "") : string;
}
function isObject(value) {
  var type = typeof value;
  return value != null && (type == "object" || type == "function");
}
var NAN = 0 / 0;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
function toNumber(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = baseTrim(value);
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var asyncTag = "[object AsyncFunction]", funcTag$2 = "[object Function]", genTag$1 = "[object GeneratorFunction]", proxyTag = "[object Proxy]";
function isFunction(value) {
  if (!isObject(value)) {
    return false;
  }
  var tag = baseGetTag(value);
  return tag == funcTag$2 || tag == genTag$1 || tag == asyncTag || tag == proxyTag;
}
var coreJsData = root$1["__core-js_shared__"];
var coreJsData$1 = coreJsData;
var maskSrcKey = function() {
  var uid = /[^.]+$/.exec(coreJsData$1 && coreJsData$1.keys && coreJsData$1.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
function isMasked(func) {
  return !!maskSrcKey && maskSrcKey in func;
}
var funcProto$1 = Function.prototype;
var funcToString$1 = funcProto$1.toString;
function toSource(func) {
  if (func != null) {
    try {
      return funcToString$1.call(func);
    } catch (e22) {
    }
    try {
      return func + "";
    } catch (e22) {
    }
  }
  return "";
}
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var funcProto = Function.prototype, objectProto$a = Object.prototype;
var funcToString = funcProto.toString;
var hasOwnProperty$9 = objectProto$a.hasOwnProperty;
var reIsNative = RegExp("^" + funcToString.call(hasOwnProperty$9).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}
function getValue(object, key) {
  return object == null ? void 0 : object[key];
}
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : void 0;
}
var WeakMap$1 = getNative(root$1, "WeakMap");
var WeakMap$2 = WeakMap$1;
var objectCreate = Object.create;
var baseCreate = function() {
  function object() {
  }
  return function(proto) {
    if (!isObject(proto)) {
      return {};
    }
    if (objectCreate) {
      return objectCreate(proto);
    }
    object.prototype = proto;
    var result = new object();
    object.prototype = void 0;
    return result;
  };
}();
var baseCreate$1 = baseCreate;
function copyArray(source, array) {
  var index = -1, length = source.length;
  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}
var defineProperty = function() {
  try {
    var func = getNative(Object, "defineProperty");
    func({}, "", {});
    return func;
  } catch (e22) {
  }
}();
var defineProperty$1 = defineProperty;
function arrayEach(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}
var MAX_SAFE_INTEGER$1 = 9007199254740991;
var reIsUint = /^(?:0|[1-9]\d*)$/;
function isIndex(value, length) {
  var type = typeof value;
  length = length == null ? MAX_SAFE_INTEGER$1 : length;
  return !!length && (type == "number" || type != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
}
function baseAssignValue(object, key, value) {
  if (key == "__proto__" && defineProperty$1) {
    defineProperty$1(object, key, {
      "configurable": true,
      "enumerable": true,
      "value": value,
      "writable": true
    });
  } else {
    object[key] = value;
  }
}
function eq(value, other) {
  return value === other || value !== value && other !== other;
}
var objectProto$9 = Object.prototype;
var hasOwnProperty$8 = objectProto$9.hasOwnProperty;
function assignValue(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty$8.call(object, key) && eq(objValue, value)) || value === void 0 && !(key in object)) {
    baseAssignValue(object, key, value);
  }
}
function copyObject(source, props, object, customizer) {
  var isNew = !object;
  object || (object = {});
  var index = -1, length = props.length;
  while (++index < length) {
    var key = props[index];
    var newValue = customizer ? customizer(object[key], source[key], key, object, source) : void 0;
    if (newValue === void 0) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue(object, key, newValue);
    } else {
      assignValue(object, key, newValue);
    }
  }
  return object;
}
var MAX_SAFE_INTEGER = 9007199254740991;
function isLength(value) {
  return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}
var objectProto$8 = Object.prototype;
function isPrototype(value) {
  var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto$8;
  return value === proto;
}
function baseTimes(n2, iteratee) {
  var index = -1, result = Array(n2);
  while (++index < n2) {
    result[index] = iteratee(index);
  }
  return result;
}
var argsTag$2 = "[object Arguments]";
function baseIsArguments(value) {
  return isObjectLike(value) && baseGetTag(value) == argsTag$2;
}
var objectProto$7 = Object.prototype;
var hasOwnProperty$7 = objectProto$7.hasOwnProperty;
var propertyIsEnumerable$1 = objectProto$7.propertyIsEnumerable;
var isArguments = baseIsArguments(function() {
  return arguments;
}()) ? baseIsArguments : function(value) {
  return isObjectLike(value) && hasOwnProperty$7.call(value, "callee") && !propertyIsEnumerable$1.call(value, "callee");
};
var isArguments$1 = isArguments;
function stubFalse() {
  return false;
}
var freeExports$2 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule$2 = freeExports$2 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports$2 = freeModule$2 && freeModule$2.exports === freeExports$2;
var Buffer$1 = moduleExports$2 ? root$1.Buffer : void 0;
var nativeIsBuffer = Buffer$1 ? Buffer$1.isBuffer : void 0;
var isBuffer = nativeIsBuffer || stubFalse;
var isBuffer$1 = isBuffer;
var argsTag$1 = "[object Arguments]", arrayTag$1 = "[object Array]", boolTag$2 = "[object Boolean]", dateTag$2 = "[object Date]", errorTag$1 = "[object Error]", funcTag$1 = "[object Function]", mapTag$4 = "[object Map]", numberTag$2 = "[object Number]", objectTag$2 = "[object Object]", regexpTag$2 = "[object RegExp]", setTag$4 = "[object Set]", stringTag$2 = "[object String]", weakMapTag$2 = "[object WeakMap]";
var arrayBufferTag$2 = "[object ArrayBuffer]", dataViewTag$3 = "[object DataView]", float32Tag$2 = "[object Float32Array]", float64Tag$2 = "[object Float64Array]", int8Tag$2 = "[object Int8Array]", int16Tag$2 = "[object Int16Array]", int32Tag$2 = "[object Int32Array]", uint8Tag$2 = "[object Uint8Array]", uint8ClampedTag$2 = "[object Uint8ClampedArray]", uint16Tag$2 = "[object Uint16Array]", uint32Tag$2 = "[object Uint32Array]";
var typedArrayTags = {};
typedArrayTags[float32Tag$2] = typedArrayTags[float64Tag$2] = typedArrayTags[int8Tag$2] = typedArrayTags[int16Tag$2] = typedArrayTags[int32Tag$2] = typedArrayTags[uint8Tag$2] = typedArrayTags[uint8ClampedTag$2] = typedArrayTags[uint16Tag$2] = typedArrayTags[uint32Tag$2] = true;
typedArrayTags[argsTag$1] = typedArrayTags[arrayTag$1] = typedArrayTags[arrayBufferTag$2] = typedArrayTags[boolTag$2] = typedArrayTags[dataViewTag$3] = typedArrayTags[dateTag$2] = typedArrayTags[errorTag$1] = typedArrayTags[funcTag$1] = typedArrayTags[mapTag$4] = typedArrayTags[numberTag$2] = typedArrayTags[objectTag$2] = typedArrayTags[regexpTag$2] = typedArrayTags[setTag$4] = typedArrayTags[stringTag$2] = typedArrayTags[weakMapTag$2] = false;
function baseIsTypedArray(value) {
  return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
}
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}
var freeExports$1 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule$1 = freeExports$1 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports$1 = freeModule$1 && freeModule$1.exports === freeExports$1;
var freeProcess = moduleExports$1 && freeGlobal$1.process;
var nodeUtil = function() {
  try {
    var types = freeModule$1 && freeModule$1.require && freeModule$1.require("util").types;
    if (types) {
      return types;
    }
    return freeProcess && freeProcess.binding && freeProcess.binding("util");
  } catch (e22) {
  }
}();
var nodeUtil$1 = nodeUtil;
var nodeIsTypedArray = nodeUtil$1 && nodeUtil$1.isTypedArray;
var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
var isTypedArray$1 = isTypedArray;
var objectProto$6 = Object.prototype;
var hasOwnProperty$6 = objectProto$6.hasOwnProperty;
function arrayLikeKeys(value, inherited) {
  var isArr = isArray$1(value), isArg = !isArr && isArguments$1(value), isBuff = !isArr && !isArg && isBuffer$1(value), isType = !isArr && !isArg && !isBuff && isTypedArray$1(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes(value.length, String) : [], length = result.length;
  for (var key in value) {
    if ((inherited || hasOwnProperty$6.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex(key, length)))) {
      result.push(key);
    }
  }
  return result;
}
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}
var nativeKeys = overArg(Object.keys, Object);
var nativeKeys$1 = nativeKeys;
var objectProto$5 = Object.prototype;
var hasOwnProperty$5 = objectProto$5.hasOwnProperty;
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys$1(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty$5.call(object, key) && key != "constructor") {
      result.push(key);
    }
  }
  return result;
}
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}
function nativeKeysIn(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}
var objectProto$4 = Object.prototype;
var hasOwnProperty$4 = objectProto$4.hasOwnProperty;
function baseKeysIn(object) {
  if (!isObject(object)) {
    return nativeKeysIn(object);
  }
  var isProto = isPrototype(object), result = [];
  for (var key in object) {
    if (!(key == "constructor" && (isProto || !hasOwnProperty$4.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}
function keysIn(object) {
  return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
}
var nativeCreate = getNative(Object, "create");
var nativeCreate$1 = nativeCreate;
function hashClear() {
  this.__data__ = nativeCreate$1 ? nativeCreate$1(null) : {};
  this.size = 0;
}
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}
var HASH_UNDEFINED$1 = "__lodash_hash_undefined__";
var objectProto$3 = Object.prototype;
var hasOwnProperty$3 = objectProto$3.hasOwnProperty;
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate$1) {
    var result = data[key];
    return result === HASH_UNDEFINED$1 ? void 0 : result;
  }
  return hasOwnProperty$3.call(data, key) ? data[key] : void 0;
}
var objectProto$2 = Object.prototype;
var hasOwnProperty$2 = objectProto$2.hasOwnProperty;
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate$1 ? data[key] !== void 0 : hasOwnProperty$2.call(data, key);
}
var HASH_UNDEFINED = "__lodash_hash_undefined__";
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = nativeCreate$1 && value === void 0 ? HASH_UNDEFINED : value;
  return this;
}
function Hash(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
Hash.prototype.clear = hashClear;
Hash.prototype["delete"] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}
var arrayProto = Array.prototype;
var splice = arrayProto.splice;
function listCacheDelete(key) {
  var data = this.__data__, index = assocIndexOf(data, key);
  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}
function listCacheGet(key) {
  var data = this.__data__, index = assocIndexOf(data, key);
  return index < 0 ? void 0 : data[index][1];
}
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}
function listCacheSet(key, value) {
  var data = this.__data__, index = assocIndexOf(data, key);
  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}
function ListCache(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
ListCache.prototype.clear = listCacheClear;
ListCache.prototype["delete"] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;
var Map$1 = getNative(root$1, "Map");
var Map$2 = Map$1;
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    "hash": new Hash(),
    "map": new (Map$2 || ListCache)(),
    "string": new Hash()
  };
}
function isKeyable(value) {
  var type = typeof value;
  return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
}
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
}
function mapCacheDelete(key) {
  var result = getMapData(this, key)["delete"](key);
  this.size -= result ? 1 : 0;
  return result;
}
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}
function mapCacheSet(key, value) {
  var data = getMapData(this, key), size = data.size;
  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}
function MapCache(entries) {
  var index = -1, length = entries == null ? 0 : entries.length;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype["delete"] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;
function arrayPush(array, values) {
  var index = -1, length = values.length, offset = array.length;
  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}
var getPrototype = overArg(Object.getPrototypeOf, Object);
var getPrototype$1 = getPrototype;
function stackClear() {
  this.__data__ = new ListCache();
  this.size = 0;
}
function stackDelete(key) {
  var data = this.__data__, result = data["delete"](key);
  this.size = data.size;
  return result;
}
function stackGet(key) {
  return this.__data__.get(key);
}
function stackHas(key) {
  return this.__data__.has(key);
}
var LARGE_ARRAY_SIZE = 200;
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache) {
    var pairs = data.__data__;
    if (!Map$2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}
function Stack(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}
Stack.prototype.clear = stackClear;
Stack.prototype["delete"] = stackDelete;
Stack.prototype.get = stackGet;
Stack.prototype.has = stackHas;
Stack.prototype.set = stackSet;
function baseAssign(object, source) {
  return object && copyObject(source, keys(source), object);
}
function baseAssignIn(object, source) {
  return object && copyObject(source, keysIn(source), object);
}
var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module;
var moduleExports = freeModule && freeModule.exports === freeExports;
var Buffer = moduleExports ? root$1.Buffer : void 0, allocUnsafe = Buffer ? Buffer.allocUnsafe : void 0;
function cloneBuffer(buffer, isDeep) {
  if (isDeep) {
    return buffer.slice();
  }
  var length = buffer.length, result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
  buffer.copy(result);
  return result;
}
function arrayFilter(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}
function stubArray() {
  return [];
}
var objectProto$1 = Object.prototype;
var propertyIsEnumerable = objectProto$1.propertyIsEnumerable;
var nativeGetSymbols$1 = Object.getOwnPropertySymbols;
var getSymbols = !nativeGetSymbols$1 ? stubArray : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols$1(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};
var getSymbols$1 = getSymbols;
function copySymbols(source, object) {
  return copyObject(source, getSymbols$1(source), object);
}
var nativeGetSymbols = Object.getOwnPropertySymbols;
var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
  var result = [];
  while (object) {
    arrayPush(result, getSymbols$1(object));
    object = getPrototype$1(object);
  }
  return result;
};
var getSymbolsIn$1 = getSymbolsIn;
function copySymbolsIn(source, object) {
  return copyObject(source, getSymbolsIn$1(source), object);
}
function baseGetAllKeys(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray$1(object) ? result : arrayPush(result, symbolsFunc(object));
}
function getAllKeys(object) {
  return baseGetAllKeys(object, keys, getSymbols$1);
}
function getAllKeysIn(object) {
  return baseGetAllKeys(object, keysIn, getSymbolsIn$1);
}
var DataView = getNative(root$1, "DataView");
var DataView$1 = DataView;
var Promise$1 = getNative(root$1, "Promise");
var Promise$2 = Promise$1;
var Set$1 = getNative(root$1, "Set");
var Set$2 = Set$1;
var mapTag$3 = "[object Map]", objectTag$1 = "[object Object]", promiseTag = "[object Promise]", setTag$3 = "[object Set]", weakMapTag$1 = "[object WeakMap]";
var dataViewTag$2 = "[object DataView]";
var dataViewCtorString = toSource(DataView$1), mapCtorString = toSource(Map$2), promiseCtorString = toSource(Promise$2), setCtorString = toSource(Set$2), weakMapCtorString = toSource(WeakMap$2);
var getTag = baseGetTag;
if (DataView$1 && getTag(new DataView$1(new ArrayBuffer(1))) != dataViewTag$2 || Map$2 && getTag(new Map$2()) != mapTag$3 || Promise$2 && getTag(Promise$2.resolve()) != promiseTag || Set$2 && getTag(new Set$2()) != setTag$3 || WeakMap$2 && getTag(new WeakMap$2()) != weakMapTag$1) {
  getTag = function(value) {
    var result = baseGetTag(value), Ctor = result == objectTag$1 ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : "";
    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString:
          return dataViewTag$2;
        case mapCtorString:
          return mapTag$3;
        case promiseCtorString:
          return promiseTag;
        case setCtorString:
          return setTag$3;
        case weakMapCtorString:
          return weakMapTag$1;
      }
    }
    return result;
  };
}
var getTag$1 = getTag;
var objectProto = Object.prototype;
var hasOwnProperty$1 = objectProto.hasOwnProperty;
function initCloneArray(array) {
  var length = array.length, result = new array.constructor(length);
  if (length && typeof array[0] == "string" && hasOwnProperty$1.call(array, "index")) {
    result.index = array.index;
    result.input = array.input;
  }
  return result;
}
var Uint8Array$1 = root$1.Uint8Array;
var Uint8Array$2 = Uint8Array$1;
function cloneArrayBuffer(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array$2(result).set(new Uint8Array$2(arrayBuffer));
  return result;
}
function cloneDataView(dataView, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
  return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
}
var reFlags = /\w*$/;
function cloneRegExp(regexp) {
  var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
  result.lastIndex = regexp.lastIndex;
  return result;
}
var symbolProto = Symbol$2 ? Symbol$2.prototype : void 0, symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;
function cloneSymbol(symbol) {
  return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
}
function cloneTypedArray(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}
var boolTag$1 = "[object Boolean]", dateTag$1 = "[object Date]", mapTag$2 = "[object Map]", numberTag$1 = "[object Number]", regexpTag$1 = "[object RegExp]", setTag$2 = "[object Set]", stringTag$1 = "[object String]", symbolTag$1 = "[object Symbol]";
var arrayBufferTag$1 = "[object ArrayBuffer]", dataViewTag$1 = "[object DataView]", float32Tag$1 = "[object Float32Array]", float64Tag$1 = "[object Float64Array]", int8Tag$1 = "[object Int8Array]", int16Tag$1 = "[object Int16Array]", int32Tag$1 = "[object Int32Array]", uint8Tag$1 = "[object Uint8Array]", uint8ClampedTag$1 = "[object Uint8ClampedArray]", uint16Tag$1 = "[object Uint16Array]", uint32Tag$1 = "[object Uint32Array]";
function initCloneByTag(object, tag, isDeep) {
  var Ctor = object.constructor;
  switch (tag) {
    case arrayBufferTag$1:
      return cloneArrayBuffer(object);
    case boolTag$1:
    case dateTag$1:
      return new Ctor(+object);
    case dataViewTag$1:
      return cloneDataView(object, isDeep);
    case float32Tag$1:
    case float64Tag$1:
    case int8Tag$1:
    case int16Tag$1:
    case int32Tag$1:
    case uint8Tag$1:
    case uint8ClampedTag$1:
    case uint16Tag$1:
    case uint32Tag$1:
      return cloneTypedArray(object, isDeep);
    case mapTag$2:
      return new Ctor();
    case numberTag$1:
    case stringTag$1:
      return new Ctor(object);
    case regexpTag$1:
      return cloneRegExp(object);
    case setTag$2:
      return new Ctor();
    case symbolTag$1:
      return cloneSymbol(object);
  }
}
function initCloneObject(object) {
  return typeof object.constructor == "function" && !isPrototype(object) ? baseCreate$1(getPrototype$1(object)) : {};
}
var mapTag$1 = "[object Map]";
function baseIsMap(value) {
  return isObjectLike(value) && getTag$1(value) == mapTag$1;
}
var nodeIsMap = nodeUtil$1 && nodeUtil$1.isMap;
var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
var isMap$1 = isMap;
var setTag$1 = "[object Set]";
function baseIsSet(value) {
  return isObjectLike(value) && getTag$1(value) == setTag$1;
}
var nodeIsSet = nodeUtil$1 && nodeUtil$1.isSet;
var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
var isSet$1 = isSet;
var CLONE_DEEP_FLAG$1 = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG$1 = 4;
var argsTag = "[object Arguments]", arrayTag = "[object Array]", boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", objectTag = "[object Object]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", weakMapTag = "[object WeakMap]";
var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
var cloneableTags = {};
cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
function baseClone(value, bitmask, customizer, key, object, stack) {
  var result, isDeep = bitmask & CLONE_DEEP_FLAG$1, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG$1;
  if (customizer) {
    result = object ? customizer(value, key, object, stack) : customizer(value);
  }
  if (result !== void 0) {
    return result;
  }
  if (!isObject(value)) {
    return value;
  }
  var isArr = isArray$1(value);
  if (isArr) {
    result = initCloneArray(value);
    if (!isDeep) {
      return copyArray(value, result);
    }
  } else {
    var tag = getTag$1(value), isFunc = tag == funcTag || tag == genTag;
    if (isBuffer$1(value)) {
      return cloneBuffer(value, isDeep);
    }
    if (tag == objectTag || tag == argsTag || isFunc && !object) {
      result = isFlat || isFunc ? {} : initCloneObject(value);
      if (!isDeep) {
        return isFlat ? copySymbolsIn(value, baseAssignIn(result, value)) : copySymbols(value, baseAssign(result, value));
      }
    } else {
      if (!cloneableTags[tag]) {
        return object ? value : {};
      }
      result = initCloneByTag(value, tag, isDeep);
    }
  }
  stack || (stack = new Stack());
  var stacked = stack.get(value);
  if (stacked) {
    return stacked;
  }
  stack.set(value, result);
  if (isSet$1(value)) {
    value.forEach(function(subValue) {
      result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
    });
  } else if (isMap$1(value)) {
    value.forEach(function(subValue, key2) {
      result.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
    });
  }
  var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys;
  var props = isArr ? void 0 : keysFunc(value);
  arrayEach(props || value, function(subValue, key2) {
    if (props) {
      key2 = subValue;
      subValue = value[key2];
    }
    assignValue(result, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
  });
  return result;
}
var CLONE_DEEP_FLAG = 1, CLONE_SYMBOLS_FLAG = 4;
function cloneDeep(value) {
  return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
}
var now = function() {
  return root$1.Date.now();
};
var now$1 = now;
var FUNC_ERROR_TEXT = "Expected a function";
var nativeMax = Math.max, nativeMin = Math.min;
function debounce(func, wait, options) {
  var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject(options)) {
    leading = !!options.leading;
    maxing = "maxWait" in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = "trailing" in options ? !!options.trailing : trailing;
  }
  function invokeFunc(time) {
    var args = lastArgs, thisArg = lastThis;
    lastArgs = lastThis = void 0;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }
  function leadingEdge(time) {
    lastInvokeTime = time;
    timerId = setTimeout(timerExpired, wait);
    return leading ? invokeFunc(time) : result;
  }
  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
    return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
  }
  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
    return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
  }
  function timerExpired() {
    var time = now$1();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    timerId = setTimeout(timerExpired, remainingWait(time));
  }
  function trailingEdge(time) {
    timerId = void 0;
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = void 0;
    return result;
  }
  function cancel() {
    if (timerId !== void 0) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = void 0;
  }
  function flush() {
    return timerId === void 0 ? result : trailingEdge(now$1());
  }
  function debounced() {
    var time = now$1(), isInvoking = shouldInvoke(time);
    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;
    if (isInvoking) {
      if (timerId === void 0) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        clearTimeout(timerId);
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === void 0) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}
const valuePropName = isVue3 ? "modelValue" : "value";
var Component = defineComponent({
  name: "JsonEditorVue",
  props: [valuePropName],
  setup(props, { attrs, emit }) {
    const currentInstance = getCurrentInstance();
    const syncingValue = ref(false);
    const eventName = isVue3 ? "update:modelValue" : "input";
    const jsonEditor = ref();
    const valueKey = ref("json");
    const initialValue = cloneDeep(props[valuePropName]);
    const syncValue = debounce((updatedContent) => {
      syncingValue.value = true;
      emit(eventName, updatedContent[valueKey.value]);
    }, 100);
    const modeToValueKey = (mode) => mode ? { "text": "text", "tree": "json" }[mode] : valueKey.value;
    const SvelteJsoneditorProps = computed(() => {
      return conclude([attrs, globalAttrs, {
        onChange: syncValue,
        onChangeMode(mode) {
          valueKey.value = modeToValueKey(mode);
        }
      }], {
        camelCase: false,
        mergeFunction: (globalFunction, defaultFunction) => (...args) => {
          globalFunction(...args);
          defaultFunction(...args);
        },
        ...initialValue !== void 0 && {
          default: ({ mode }) => {
            valueKey.value = modeToValueKey(mode);
            return {
              content: {
                [valueKey.value]: initialValue
              }
            };
          },
          defaultIsDynamic: true
        }
      });
    });
    watch(() => props[valuePropName], (n2, o2) => {
      if (syncingValue.value) {
        syncingValue.value = false;
        return;
      }
      jsonEditor.value.set(n2 === void 0 ? { text: "" } : {
        [valueKey.value]: typeof n2 !== "string" && valueKey.value === "text" ? JSON.stringify(n2) : n2
      });
    }, {
      deep: true
    });
    watch(SvelteJsoneditorProps, (n2) => {
      valueKey.value = modeToValueKey(n2.mode);
      delete n2.content;
      jsonEditor.value.updateProps(n2);
    }, {
      deep: true
    });
    onMounted(() => {
      jsonEditor.value = new lG({
        target: currentInstance.proxy.$refs.jsonEditorRef,
        props: SvelteJsoneditorProps.value
      });
    });
    onUnmounted(() => {
      jsonEditor.value.destroy();
    });
    return () => h$1("div", {
      ref: "jsonEditorRef"
    });
  }
});
let globalProps = {}, globalAttrs = {}, globalListeners = {}, globalHooks = {};
Component.install = (app, options = {}) => {
  if (!Component.name) {
    throw Error(`Name is required for a global component.`);
  } else if (Component.install.installed) {
    console.warn(`${Component.name} has been registered.`);
    return;
  }
  const { props, attrs, listeners, hooks } = useGlobalConfig(options, Component.props);
  globalProps = props;
  globalAttrs = attrs;
  globalListeners = listeners;
  globalHooks = hooks;
  app.component(Component.name, Component);
  Component.install.installed = true;
};
export { Component as default, globalAttrs, globalHooks, globalListeners, globalProps };
